(() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
  var __require = (x3) => {
    if (typeof require !== "undefined")
      return require(x3);
    throw new Error('Dynamic require of "' + x3 + '" is not supported');
  };
  var __esm = (fn, res) => function __init() {
    return fn && (res = (0, fn[Object.keys(fn)[0]])(fn = 0)), res;
  };
  var __commonJS = (cb, mod2) => function __require2() {
    return mod2 || (0, cb[Object.keys(cb)[0]])((mod2 = { exports: {} }).exports, mod2), mod2.exports;
  };
  var __export = (target, all2) => {
    __markAsModule(target);
    for (var name106 in all2)
      __defProp(target, name106, { get: all2[name106], enumerable: true });
  };
  var __reExport = (target, module, desc) => {
    if (module && typeof module === "object" || typeof module === "function") {
      for (let key of __getOwnPropNames(module))
        if (!__hasOwnProp.call(target, key) && key !== "default")
          __defProp(target, key, { get: () => module[key], enumerable: !(desc = __getOwnPropDesc(module, key)) || desc.enumerable });
    }
    return target;
  };
  var __toModule = (module) => {
    return __reExport(__markAsModule(__defProp(module != null ? __create(__getProtoOf(module)) : {}, "default", module && module.__esModule && "default" in module ? { get: () => module.default, enumerable: true } : { value: module, enumerable: true })), module);
  };

  // src/model/extensions.js
  var pointsToExtensions, PriorityNormal, PriorityFirst, PriorityLast, Extensions;
  var init_extensions = __esm({
    "src/model/extensions.js"() {
      pointsToExtensions = {};
      PriorityNormal = 0;
      PriorityFirst = -1;
      PriorityLast = 1;
      Extensions = class {
        static add(extensionPoint, extension, priority) {
          let extensions = pointsToExtensions[extensionPoint];
          if (!extensions) {
            extensions = [];
            pointsToExtensions[extensionPoint] = extensions;
          }
          if (priority === void 0) {
            priority = PriorityNormal;
          }
          extensions.push({
            extension,
            priority
          });
          extensions.needsSort = true;
        }
        static remove(extensionPoint, filter3) {
          let extensions = pointsToExtensions[extensionPoint];
          if (extensions) {
            let length = extensions.length, i3;
            for (i3 = length - 1; i3 >= 0; i3--) {
              if (filter3(extensions[i3].extension)) {
                extensions.splice(i3, 1);
              }
            }
          }
        }
        static hasExtensions(extensionPoint) {
          let extensions = pointsToExtensions[extensionPoint];
          return extensions ? extensions.length > 0 : false;
        }
        static processExtensions(extensionPoint, block, returnFirst) {
          let extensions = pointsToExtensions[extensionPoint], length = extensions ? extensions.length : 0, i3;
          if (extensions && extensions.needsSort) {
            extensions.sort((a3, b2) => {
              return a3.priority - b2.priority;
            });
            extensions.needsSort = false;
          }
          for (i3 = 0; i3 < length; i3++) {
            let eachResult = block(extensions[i3].extension);
            if (eachResult !== void 0 && returnFirst) {
              return eachResult;
            }
          }
        }
        static processExtensionsAsync(extensionPoint, block, returnFirst) {
          let extensions = pointsToExtensions[extensionPoint], length = extensions ? extensions.length : 0, i3;
          if (extensions && extensions.needsSort) {
            extensions.sort((a3, b2) => {
              return a3.priority - b2.priority;
            });
            extensions.needsSort = false;
          }
          const promises = [];
          for (i3 = 0; i3 < length; i3++) {
            let eachResult = block(extensions[i3].extension);
            if (eachResult !== void 0) {
              if (eachResult.then) {
                promises.push(eachResult);
              }
            }
          }
          return Promise.all(promises).then((resolutions) => {
            const resolutionsWithResults = resolutions.filter((resolution) => {
              if (Array.isArray(resolution))
                return resolution.length > 0;
              return !!resolution;
            });
            if (returnFirst) {
              return resolutionsWithResults[0];
            }
            return resolutionsWithResults;
          });
        }
        static addCommand(extension, priority) {
          this.add("com.foldingtext.editor.commands", extension, priority);
        }
        static addInit(extension, priority) {
          this.add("com.foldingtext.editor.init", extension, priority);
        }
        static addMode(extension, priority) {
          this.add("com.foldingtext.editor.mode", extension, priority);
        }
        static addState(extension, priority) {
          this.add("com.foldingtext.editor.state", extension, priority);
        }
        static addSelectionDidChange(extension, priority) {
          this.add("com.foldingtext.editor.selectionDidChange", extension, priority);
        }
        static addNodePathDidChange(extension, priority) {
          this.add("com.foldingtext.editor.nodePathDidChange", extension, priority);
        }
        static addRenderNodeElementStyles(extension, priority) {
          this.add("com.foldingtext.editor.renderNodeElementStyles", extension, priority);
        }
        static addTreeChanged(extension, priority) {
          this.add("com.foldingtext.editor.treeChange", extension, priority);
        }
        static addRenderNode(extension, priority) {
          this.add("com.foldingtext.editor.renderNode", extension, priority);
        }
        static addSnippet(extension, priority) {
          this.add("com.foldingtext.editor.snippets", extension, priority);
        }
        static addClockTick(extension, priority) {
          this.add("com.foldingtext.editor.clockTick", extension, priority);
        }
      };
      Extensions.PriorityNormal = PriorityNormal;
      Extensions.PriorityFirst = PriorityFirst;
      Extensions.PriorityLast = PriorityLast;
    }
  });

  // src/util/objectutils.js
  function hasOwnProperty(obj, key) {
    return Object.prototype.hasOwnProperty.call(obj, key);
  }
  function arrayOfValues(object) {
    let a3 = [];
    for (let key in object) {
      if (hasOwnProperty(object, key)) {
        a3.push(object[key]);
      }
    }
    return a3;
  }
  function arrayOfKeys(object) {
    let a3 = [];
    for (let key in object) {
      if (hasOwnProperty(object, key)) {
        a3.push(key);
      }
    }
    return a3;
  }
  function shallowClone(object) {
    if (!object) {
      return null;
    }
    let copy2 = {}, attr;
    for (attr in object) {
      if (hasOwnProperty(object, attr)) {
        copy2[attr] = object[attr];
      }
    }
    return copy2;
  }
  function shallowEquals(a3, b2) {
    if (a3 === b2) {
      return true;
    }
    if (!a3 || !b2) {
      return false;
    }
    let aCount = 0;
    let key;
    for (key in a3) {
      if (hasOwnProperty(a3, key)) {
        if (a3[key] !== b2[key]) {
          return false;
        }
        aCount++;
      }
    }
    let bCount = 0;
    for (key in b2) {
      if (hasOwnProperty(b2, key)) {
        bCount++;
      }
    }
    return aCount === bCount;
  }
  var init_objectutils = __esm({
    "src/util/objectutils.js"() {
    }
  });

  // node_modules/@plaincontext/codemirror/lib/codemirror.js
  var require_codemirror = __commonJS({
    "node_modules/@plaincontext/codemirror/lib/codemirror.js"(exports, module) {
      (function(global2, factory2) {
        typeof exports === "object" && typeof module !== "undefined" ? module.exports = factory2() : typeof define === "function" && define.amd ? define(factory2) : (global2 = global2 || self, global2.CodeMirror = factory2());
      })(exports, function() {
        "use strict";
        var userAgent = navigator.userAgent;
        var platform = navigator.platform;
        var gecko = /gecko\/\d/i.test(userAgent);
        var ie_upto10 = /MSIE \d/.test(userAgent);
        var ie_11up = /Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(userAgent);
        var edge = /Edge\/(\d+)/.exec(userAgent);
        var ie = ie_upto10 || ie_11up || edge;
        var ie_version = ie && (ie_upto10 ? document.documentMode || 6 : +(edge || ie_11up)[1]);
        var webkit = !edge && /WebKit\//.test(userAgent);
        var qtwebkit = webkit && /Qt\/\d+\.\d+/.test(userAgent);
        var chrome = !edge && /Chrome\//.test(userAgent);
        var presto = /Opera\//.test(userAgent);
        var safari = /Apple Computer/.test(navigator.vendor);
        var mac_geMountainLion = /Mac OS X 1\d\D([8-9]|\d\d)\D/.test(userAgent);
        var phantom = /PhantomJS/.test(userAgent);
        var ios = !edge && /AppleWebKit/.test(userAgent) && /Mobile\/\w+/.test(userAgent);
        var android = /Android/.test(userAgent);
        var mobile = ios || android || /webOS|BlackBerry|Opera Mini|Opera Mobi|IEMobile/i.test(userAgent);
        var mac = ios || /Mac/.test(platform);
        var chromeOS = /\bCrOS\b/.test(userAgent);
        var windows = /win/i.test(platform);
        var presto_version = presto && userAgent.match(/Version\/(\d*\.\d*)/);
        if (presto_version) {
          presto_version = Number(presto_version[1]);
        }
        if (presto_version && presto_version >= 15) {
          presto = false;
          webkit = true;
        }
        var flipCtrlCmd = mac && (qtwebkit || presto && (presto_version == null || presto_version < 12.11));
        var captureRightClick = gecko || ie && ie_version >= 9;
        function classTest(cls) {
          return new RegExp("(^|\\s)" + cls + "(?:$|\\s)\\s*");
        }
        var rmClass = function(node, cls) {
          var current = node.className;
          var match = classTest(cls).exec(current);
          if (match) {
            var after = current.slice(match.index + match[0].length);
            node.className = current.slice(0, match.index) + (after ? match[1] + after : "");
          }
        };
        function removeChildren(e5) {
          for (var count = e5.childNodes.length; count > 0; --count) {
            e5.removeChild(e5.firstChild);
          }
          return e5;
        }
        function removeChildrenAndAdd(parent, e5) {
          return removeChildren(parent).appendChild(e5);
        }
        function elt(tag, content, className, style) {
          var e5 = document.createElement(tag);
          if (className) {
            e5.className = className;
          }
          if (style) {
            e5.style.cssText = style;
          }
          if (typeof content == "string") {
            e5.appendChild(document.createTextNode(content));
          } else if (content) {
            for (var i4 = 0; i4 < content.length; ++i4) {
              e5.appendChild(content[i4]);
            }
          }
          return e5;
        }
        function eltP(tag, content, className, style) {
          var e5 = elt(tag, content, className, style);
          e5.setAttribute("role", "presentation");
          return e5;
        }
        var range2;
        if (document.createRange) {
          range2 = function(node, start2, end, endNode) {
            var r3 = document.createRange();
            r3.setEnd(endNode || node, end);
            r3.setStart(node, start2);
            return r3;
          };
        } else {
          range2 = function(node, start2, end) {
            var r3 = document.body.createTextRange();
            try {
              r3.moveToElementText(node.parentNode);
            } catch (e5) {
              return r3;
            }
            r3.collapse(true);
            r3.moveEnd("character", end);
            r3.moveStart("character", start2);
            return r3;
          };
        }
        function contains3(parent, child) {
          if (child.nodeType == 3) {
            child = child.parentNode;
          }
          if (parent.contains) {
            return parent.contains(child);
          }
          do {
            if (child.nodeType == 11) {
              child = child.host;
            }
            if (child == parent) {
              return true;
            }
          } while (child = child.parentNode);
        }
        function activeElt() {
          var activeElement;
          try {
            activeElement = document.activeElement;
          } catch (e5) {
            activeElement = document.body || null;
          }
          while (activeElement && activeElement.shadowRoot && activeElement.shadowRoot.activeElement) {
            activeElement = activeElement.shadowRoot.activeElement;
          }
          return activeElement;
        }
        function addClass2(node, cls) {
          var current = node.className;
          if (!classTest(cls).test(current)) {
            node.className += (current ? " " : "") + cls;
          }
        }
        function joinClasses(a3, b2) {
          var as = a3.split(" ");
          for (var i4 = 0; i4 < as.length; i4++) {
            if (as[i4] && !classTest(as[i4]).test(b2)) {
              b2 += " " + as[i4];
            }
          }
          return b2;
        }
        var selectInput = function(node) {
          node.select();
        };
        if (ios) {
          selectInput = function(node) {
            node.selectionStart = 0;
            node.selectionEnd = node.value.length;
          };
        } else if (ie) {
          selectInput = function(node) {
            try {
              node.select();
            } catch (_e) {
            }
          };
        }
        function bind(f3) {
          var args = Array.prototype.slice.call(arguments, 1);
          return function() {
            return f3.apply(null, args);
          };
        }
        function copyObj(obj, target, overwrite) {
          if (!target) {
            target = {};
          }
          for (var prop2 in obj) {
            if (obj.hasOwnProperty(prop2) && (overwrite !== false || !target.hasOwnProperty(prop2))) {
              target[prop2] = obj[prop2];
            }
          }
          return target;
        }
        function countColumn(string2, end, tabSize, startIndex, startValue) {
          if (end == null) {
            end = string2.search(/[^\s\u00a0]/);
            if (end == -1) {
              end = string2.length;
            }
          }
          for (var i4 = startIndex || 0, n3 = startValue || 0; ; ) {
            var nextTab = string2.indexOf("	", i4);
            if (nextTab < 0 || nextTab >= end) {
              return n3 + (end - i4);
            }
            n3 += nextTab - i4;
            n3 += tabSize - n3 % tabSize;
            i4 = nextTab + 1;
          }
        }
        var Delayed = function() {
          this.id = null;
          this.f = null;
          this.time = 0;
          this.handler = bind(this.onTimeout, this);
        };
        Delayed.prototype.onTimeout = function(self2) {
          self2.id = 0;
          if (self2.time <= +new Date()) {
            self2.f();
          } else {
            setTimeout(self2.handler, self2.time - +new Date());
          }
        };
        Delayed.prototype.set = function(ms, f3) {
          this.f = f3;
          var time = +new Date() + ms;
          if (!this.id || time < this.time) {
            clearTimeout(this.id);
            this.id = setTimeout(this.handler, ms);
            this.time = time;
          }
        };
        function indexOf(array, elt2) {
          for (var i4 = 0; i4 < array.length; ++i4) {
            if (array[i4] == elt2) {
              return i4;
            }
          }
          return -1;
        }
        var scrollerGap = 50;
        var Pass = { toString: function() {
          return "CodeMirror.Pass";
        } };
        var sel_dontScroll = { scroll: false }, sel_mouse = { origin: "*mouse" }, sel_move = { origin: "+move" };
        function findColumn(string2, goal, tabSize) {
          for (var pos = 0, col = 0; ; ) {
            var nextTab = string2.indexOf("	", pos);
            if (nextTab == -1) {
              nextTab = string2.length;
            }
            var skipped = nextTab - pos;
            if (nextTab == string2.length || col + skipped >= goal) {
              return pos + Math.min(skipped, goal - col);
            }
            col += nextTab - pos;
            col += tabSize - col % tabSize;
            pos = nextTab + 1;
            if (col >= goal) {
              return pos;
            }
          }
        }
        var spaceStrs = [""];
        function spaceStr(n3) {
          while (spaceStrs.length <= n3) {
            spaceStrs.push(lst(spaceStrs) + " ");
          }
          return spaceStrs[n3];
        }
        function lst(arr) {
          return arr[arr.length - 1];
        }
        function map3(array, f3) {
          var out = [];
          for (var i4 = 0; i4 < array.length; i4++) {
            out[i4] = f3(array[i4], i4);
          }
          return out;
        }
        function insertSorted(array, value, score) {
          var pos = 0, priority = score(value);
          while (pos < array.length && score(array[pos]) <= priority) {
            pos++;
          }
          array.splice(pos, 0, value);
        }
        function nothing() {
        }
        function createObj(base, props) {
          var inst;
          if (Object.create) {
            inst = Object.create(base);
          } else {
            nothing.prototype = base;
            inst = new nothing();
          }
          if (props) {
            copyObj(props, inst);
          }
          return inst;
        }
        var nonASCIISingleCaseWordChar2 = /[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;
        function isWordCharBasic(ch) {
          return /\w/.test(ch) || ch > "\x80" && (ch.toUpperCase() != ch.toLowerCase() || nonASCIISingleCaseWordChar2.test(ch));
        }
        function isWordChar2(ch, helper) {
          if (!helper) {
            return isWordCharBasic(ch);
          }
          if (helper.source.indexOf("\\w") > -1 && isWordCharBasic(ch)) {
            return true;
          }
          return helper.test(ch);
        }
        function isEmpty(obj) {
          for (var n3 in obj) {
            if (obj.hasOwnProperty(n3) && obj[n3]) {
              return false;
            }
          }
          return true;
        }
        var extendingChars = /[\u0300-\u036f\u0483-\u0489\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u065e\u0670\u06d6-\u06dc\u06de-\u06e4\u06e7\u06e8\u06ea-\u06ed\u0711\u0730-\u074a\u07a6-\u07b0\u07eb-\u07f3\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0900-\u0902\u093c\u0941-\u0948\u094d\u0951-\u0955\u0962\u0963\u0981\u09bc\u09be\u09c1-\u09c4\u09cd\u09d7\u09e2\u09e3\u0a01\u0a02\u0a3c\u0a41\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a70\u0a71\u0a75\u0a81\u0a82\u0abc\u0ac1-\u0ac5\u0ac7\u0ac8\u0acd\u0ae2\u0ae3\u0b01\u0b3c\u0b3e\u0b3f\u0b41-\u0b44\u0b4d\u0b56\u0b57\u0b62\u0b63\u0b82\u0bbe\u0bc0\u0bcd\u0bd7\u0c3e-\u0c40\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0cbc\u0cbf\u0cc2\u0cc6\u0ccc\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0d3e\u0d41-\u0d44\u0d4d\u0d57\u0d62\u0d63\u0dca\u0dcf\u0dd2-\u0dd4\u0dd6\u0ddf\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0eb1\u0eb4-\u0eb9\u0ebb\u0ebc\u0ec8-\u0ecd\u0f18\u0f19\u0f35\u0f37\u0f39\u0f71-\u0f7e\u0f80-\u0f84\u0f86\u0f87\u0f90-\u0f97\u0f99-\u0fbc\u0fc6\u102d-\u1030\u1032-\u1037\u1039\u103a\u103d\u103e\u1058\u1059\u105e-\u1060\u1071-\u1074\u1082\u1085\u1086\u108d\u109d\u135f\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17b7-\u17bd\u17c6\u17c9-\u17d3\u17dd\u180b-\u180d\u18a9\u1920-\u1922\u1927\u1928\u1932\u1939-\u193b\u1a17\u1a18\u1a56\u1a58-\u1a5e\u1a60\u1a62\u1a65-\u1a6c\u1a73-\u1a7c\u1a7f\u1b00-\u1b03\u1b34\u1b36-\u1b3a\u1b3c\u1b42\u1b6b-\u1b73\u1b80\u1b81\u1ba2-\u1ba5\u1ba8\u1ba9\u1c2c-\u1c33\u1c36\u1c37\u1cd0-\u1cd2\u1cd4-\u1ce0\u1ce2-\u1ce8\u1ced\u1dc0-\u1de6\u1dfd-\u1dff\u200c\u200d\u20d0-\u20f0\u2cef-\u2cf1\u2de0-\u2dff\u302a-\u302f\u3099\u309a\ua66f-\ua672\ua67c\ua67d\ua6f0\ua6f1\ua802\ua806\ua80b\ua825\ua826\ua8c4\ua8e0-\ua8f1\ua926-\ua92d\ua947-\ua951\ua980-\ua982\ua9b3\ua9b6-\ua9b9\ua9bc\uaa29-\uaa2e\uaa31\uaa32\uaa35\uaa36\uaa43\uaa4c\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uabe5\uabe8\uabed\udc00-\udfff\ufb1e\ufe00-\ufe0f\ufe20-\ufe26\uff9e\uff9f]/;
        function isExtendingChar(ch) {
          return ch.charCodeAt(0) >= 768 && extendingChars.test(ch);
        }
        function skipExtendingChars(str, pos, dir) {
          while ((dir < 0 ? pos > 0 : pos < str.length) && isExtendingChar(str.charAt(pos))) {
            pos += dir;
          }
          return pos;
        }
        function findFirst(pred, from, to) {
          var dir = from > to ? -1 : 1;
          for (; ; ) {
            if (from == to) {
              return from;
            }
            var midF = (from + to) / 2, mid = dir < 0 ? Math.ceil(midF) : Math.floor(midF);
            if (mid == from) {
              return pred(mid) ? from : to;
            }
            if (pred(mid)) {
              to = mid;
            } else {
              from = mid + dir;
            }
          }
        }
        function iterateBidiSections(order, from, to, f3) {
          if (!order) {
            return f3(from, to, "ltr", 0);
          }
          var found = false;
          for (var i4 = 0; i4 < order.length; ++i4) {
            var part = order[i4];
            if (part.from < to && part.to > from || from == to && part.to == from) {
              f3(Math.max(part.from, from), Math.min(part.to, to), part.level == 1 ? "rtl" : "ltr", i4);
              found = true;
            }
          }
          if (!found) {
            f3(from, to, "ltr");
          }
        }
        var bidiOther = null;
        function getBidiPartAt(order, ch, sticky) {
          var found;
          bidiOther = null;
          for (var i4 = 0; i4 < order.length; ++i4) {
            var cur = order[i4];
            if (cur.from < ch && cur.to > ch) {
              return i4;
            }
            if (cur.to == ch) {
              if (cur.from != cur.to && sticky == "before") {
                found = i4;
              } else {
                bidiOther = i4;
              }
            }
            if (cur.from == ch) {
              if (cur.from != cur.to && sticky != "before") {
                found = i4;
              } else {
                bidiOther = i4;
              }
            }
          }
          return found != null ? found : bidiOther;
        }
        var bidiOrdering = function() {
          var lowTypes = "bbbbbbbbbtstwsbbbbbbbbbbbbbbssstwNN%%%NNNNNN,N,N1111111111NNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNbbbbbbsbbbbbbbbbbbbbbbbbbbbbbbbbb,N%%%%NNNNLNNNNN%%11NLNNN1LNNNNNLLLLLLLLLLLLLLLLLLLLLLLNLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLN";
          var arabicTypes = "nnnnnnNNr%%r,rNNmmmmmmmmmmmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmmmmmmmmnnnnnnnnnn%nnrrrmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmnNmmmmmmrrmmNmmmmrr1111111111";
          function charType(code) {
            if (code <= 247) {
              return lowTypes.charAt(code);
            } else if (1424 <= code && code <= 1524) {
              return "R";
            } else if (1536 <= code && code <= 1785) {
              return arabicTypes.charAt(code - 1536);
            } else if (1774 <= code && code <= 2220) {
              return "r";
            } else if (8192 <= code && code <= 8203) {
              return "w";
            } else if (code == 8204) {
              return "b";
            } else {
              return "L";
            }
          }
          var bidiRE = /[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac]/;
          var isNeutral = /[stwN]/, isStrong = /[LRr]/, countsAsLeft = /[Lb1n]/, countsAsNum = /[1n]/;
          function BidiSpan(level, from, to) {
            this.level = level;
            this.from = from;
            this.to = to;
          }
          return function(str, direction) {
            var outerType = direction == "ltr" ? "L" : "R";
            if (str.length == 0 || direction == "ltr" && !bidiRE.test(str)) {
              return false;
            }
            var len = str.length, types = [];
            for (var i4 = 0; i4 < len; ++i4) {
              types.push(charType(str.charCodeAt(i4)));
            }
            for (var i$12 = 0, prev = outerType; i$12 < len; ++i$12) {
              var type = types[i$12];
              if (type == "m") {
                types[i$12] = prev;
              } else {
                prev = type;
              }
            }
            for (var i$22 = 0, cur = outerType; i$22 < len; ++i$22) {
              var type$1 = types[i$22];
              if (type$1 == "1" && cur == "r") {
                types[i$22] = "n";
              } else if (isStrong.test(type$1)) {
                cur = type$1;
                if (type$1 == "r") {
                  types[i$22] = "R";
                }
              }
            }
            for (var i$3 = 1, prev$1 = types[0]; i$3 < len - 1; ++i$3) {
              var type$2 = types[i$3];
              if (type$2 == "+" && prev$1 == "1" && types[i$3 + 1] == "1") {
                types[i$3] = "1";
              } else if (type$2 == "," && prev$1 == types[i$3 + 1] && (prev$1 == "1" || prev$1 == "n")) {
                types[i$3] = prev$1;
              }
              prev$1 = type$2;
            }
            for (var i$4 = 0; i$4 < len; ++i$4) {
              var type$3 = types[i$4];
              if (type$3 == ",") {
                types[i$4] = "N";
              } else if (type$3 == "%") {
                var end = void 0;
                for (end = i$4 + 1; end < len && types[end] == "%"; ++end) {
                }
                var replace3 = i$4 && types[i$4 - 1] == "!" || end < len && types[end] == "1" ? "1" : "N";
                for (var j3 = i$4; j3 < end; ++j3) {
                  types[j3] = replace3;
                }
                i$4 = end - 1;
              }
            }
            for (var i$5 = 0, cur$1 = outerType; i$5 < len; ++i$5) {
              var type$4 = types[i$5];
              if (cur$1 == "L" && type$4 == "1") {
                types[i$5] = "L";
              } else if (isStrong.test(type$4)) {
                cur$1 = type$4;
              }
            }
            for (var i$6 = 0; i$6 < len; ++i$6) {
              if (isNeutral.test(types[i$6])) {
                var end$1 = void 0;
                for (end$1 = i$6 + 1; end$1 < len && isNeutral.test(types[end$1]); ++end$1) {
                }
                var before = (i$6 ? types[i$6 - 1] : outerType) == "L";
                var after = (end$1 < len ? types[end$1] : outerType) == "L";
                var replace$1 = before == after ? before ? "L" : "R" : outerType;
                for (var j$1 = i$6; j$1 < end$1; ++j$1) {
                  types[j$1] = replace$1;
                }
                i$6 = end$1 - 1;
              }
            }
            var order = [], m3;
            for (var i$7 = 0; i$7 < len; ) {
              if (countsAsLeft.test(types[i$7])) {
                var start2 = i$7;
                for (++i$7; i$7 < len && countsAsLeft.test(types[i$7]); ++i$7) {
                }
                order.push(new BidiSpan(0, start2, i$7));
              } else {
                var pos = i$7, at = order.length, isRTL = direction == "rtl" ? 1 : 0;
                for (++i$7; i$7 < len && types[i$7] != "L"; ++i$7) {
                }
                for (var j$2 = pos; j$2 < i$7; ) {
                  if (countsAsNum.test(types[j$2])) {
                    if (pos < j$2) {
                      order.splice(at, 0, new BidiSpan(1, pos, j$2));
                      at += isRTL;
                    }
                    var nstart = j$2;
                    for (++j$2; j$2 < i$7 && countsAsNum.test(types[j$2]); ++j$2) {
                    }
                    order.splice(at, 0, new BidiSpan(2, nstart, j$2));
                    at += isRTL;
                    pos = j$2;
                  } else {
                    ++j$2;
                  }
                }
                if (pos < i$7) {
                  order.splice(at, 0, new BidiSpan(1, pos, i$7));
                }
              }
            }
            if (direction == "ltr") {
              if (order[0].level == 1 && (m3 = str.match(/^\s+/))) {
                order[0].from = m3[0].length;
                order.unshift(new BidiSpan(0, 0, m3[0].length));
              }
              if (lst(order).level == 1 && (m3 = str.match(/\s+$/))) {
                lst(order).to -= m3[0].length;
                order.push(new BidiSpan(0, len - m3[0].length, len));
              }
            }
            return direction == "rtl" ? order.reverse() : order;
          };
        }();
        function getOrder(line, direction) {
          var order = line.order;
          if (order == null) {
            order = line.order = bidiOrdering(line.text, direction);
          }
          return order;
        }
        var noHandlers = [];
        var on = function(emitter2, type, f3) {
          if (emitter2.addEventListener) {
            emitter2.addEventListener(type, f3, false);
          } else if (emitter2.attachEvent) {
            emitter2.attachEvent("on" + type, f3);
          } else {
            var map4 = emitter2._handlers || (emitter2._handlers = {});
            map4[type] = (map4[type] || noHandlers).concat(f3);
          }
        };
        function getHandlers(emitter2, type) {
          return emitter2._handlers && emitter2._handlers[type] || noHandlers;
        }
        function off(emitter2, type, f3) {
          if (emitter2.removeEventListener) {
            emitter2.removeEventListener(type, f3, false);
          } else if (emitter2.detachEvent) {
            emitter2.detachEvent("on" + type, f3);
          } else {
            var map4 = emitter2._handlers, arr = map4 && map4[type];
            if (arr) {
              var index2 = indexOf(arr, f3);
              if (index2 > -1) {
                map4[type] = arr.slice(0, index2).concat(arr.slice(index2 + 1));
              }
            }
          }
        }
        function signal(emitter2, type) {
          var handlers = getHandlers(emitter2, type);
          if (!handlers.length) {
            return;
          }
          var args = Array.prototype.slice.call(arguments, 2);
          for (var i4 = 0; i4 < handlers.length; ++i4) {
            handlers[i4].apply(null, args);
          }
        }
        function signalDOMEvent(cm, e5, override) {
          if (typeof e5 == "string") {
            e5 = { type: e5, preventDefault: function() {
              this.defaultPrevented = true;
            } };
          }
          signal(cm, override || e5.type, cm, e5);
          return e_defaultPrevented(e5) || e5.codemirrorIgnore;
        }
        function signalCursorActivity(cm) {
          var arr = cm._handlers && cm._handlers.cursorActivity;
          if (!arr) {
            return;
          }
          var set = cm.curOp.cursorActivityHandlers || (cm.curOp.cursorActivityHandlers = []);
          for (var i4 = 0; i4 < arr.length; ++i4) {
            if (indexOf(set, arr[i4]) == -1) {
              set.push(arr[i4]);
            }
          }
        }
        function hasHandler(emitter2, type) {
          return getHandlers(emitter2, type).length > 0;
        }
        function eventMixin(ctor) {
          ctor.prototype.on = function(type, f3) {
            on(this, type, f3);
          };
          ctor.prototype.off = function(type, f3) {
            off(this, type, f3);
          };
        }
        function e_preventDefault(e5) {
          if (e5.preventDefault) {
            e5.preventDefault();
          } else {
            e5.returnValue = false;
          }
        }
        function e_stopPropagation(e5) {
          if (e5.stopPropagation) {
            e5.stopPropagation();
          } else {
            e5.cancelBubble = true;
          }
        }
        function e_defaultPrevented(e5) {
          return e5.defaultPrevented != null ? e5.defaultPrevented : e5.returnValue == false;
        }
        function e_stop(e5) {
          e_preventDefault(e5);
          e_stopPropagation(e5);
        }
        function e_target(e5) {
          return e5.target || e5.srcElement;
        }
        function e_button(e5) {
          var b2 = e5.which;
          if (b2 == null) {
            if (e5.button & 1) {
              b2 = 1;
            } else if (e5.button & 2) {
              b2 = 3;
            } else if (e5.button & 4) {
              b2 = 2;
            }
          }
          if (mac && e5.ctrlKey && b2 == 1) {
            b2 = 3;
          }
          return b2;
        }
        var dragAndDrop = function() {
          if (ie && ie_version < 9) {
            return false;
          }
          var div = elt("div");
          return "draggable" in div || "dragDrop" in div;
        }();
        var zwspSupported;
        function zeroWidthElement(measure) {
          if (zwspSupported == null) {
            var test = elt("span", "\u200B");
            removeChildrenAndAdd(measure, elt("span", [test, document.createTextNode("x")]));
            if (measure.firstChild.offsetHeight != 0) {
              zwspSupported = test.offsetWidth <= 1 && test.offsetHeight > 2 && !(ie && ie_version < 8);
            }
          }
          var node = zwspSupported ? elt("span", "\u200B") : elt("span", "\xA0", null, "display: inline-block; width: 1px; margin-right: -1px");
          node.setAttribute("cm-text", "");
          return node;
        }
        var badBidiRects;
        function hasBadBidiRects(measure) {
          if (badBidiRects != null) {
            return badBidiRects;
          }
          var txt = removeChildrenAndAdd(measure, document.createTextNode("A\u062EA"));
          var r0 = range2(txt, 0, 1).getBoundingClientRect();
          var r1 = range2(txt, 1, 2).getBoundingClientRect();
          removeChildren(measure);
          if (!r0 || r0.left == r0.right) {
            return false;
          }
          return badBidiRects = r1.right - r0.right < 3;
        }
        var splitLinesAuto = "\n\nb".split(/\n/).length != 3 ? function(string2) {
          var pos = 0, result = [], l3 = string2.length;
          while (pos <= l3) {
            var nl = string2.indexOf("\n", pos);
            if (nl == -1) {
              nl = string2.length;
            }
            var line = string2.slice(pos, string2.charAt(nl - 1) == "\r" ? nl - 1 : nl);
            var rt = line.indexOf("\r");
            if (rt != -1) {
              result.push(line.slice(0, rt));
              pos += rt + 1;
            } else {
              result.push(line);
              pos = nl + 1;
            }
          }
          return result;
        } : function(string2) {
          return string2.split(/\r\n?|\n/);
        };
        var hasSelection = window.getSelection ? function(te) {
          try {
            return te.selectionStart != te.selectionEnd;
          } catch (e5) {
            return false;
          }
        } : function(te) {
          var range3;
          try {
            range3 = te.ownerDocument.selection.createRange();
          } catch (e5) {
          }
          if (!range3 || range3.parentElement() != te) {
            return false;
          }
          return range3.compareEndPoints("StartToEnd", range3) != 0;
        };
        var hasCopyEvent = function() {
          var e5 = elt("div");
          if ("oncopy" in e5) {
            return true;
          }
          e5.setAttribute("oncopy", "return;");
          return typeof e5.oncopy == "function";
        }();
        var badZoomedRects = null;
        function hasBadZoomedRects(measure) {
          if (badZoomedRects != null) {
            return badZoomedRects;
          }
          var node = removeChildrenAndAdd(measure, elt("span", "x"));
          var normal = node.getBoundingClientRect();
          var fromRange = range2(node, 0, 1).getBoundingClientRect();
          return badZoomedRects = Math.abs(normal.left - fromRange.left) > 1;
        }
        var modes = {}, mimeModes = {};
        function defineMode(name106, mode2) {
          if (arguments.length > 2) {
            mode2.dependencies = Array.prototype.slice.call(arguments, 2);
          }
          modes[name106] = mode2;
        }
        function defineMIME(mime, spec) {
          mimeModes[mime] = spec;
        }
        function resolveMode(spec) {
          if (typeof spec == "string" && mimeModes.hasOwnProperty(spec)) {
            spec = mimeModes[spec];
          } else if (spec && typeof spec.name == "string" && mimeModes.hasOwnProperty(spec.name)) {
            var found = mimeModes[spec.name];
            if (typeof found == "string") {
              found = { name: found };
            }
            spec = createObj(found, spec);
            spec.name = found.name;
          } else if (typeof spec == "string" && /^[\w\-]+\/[\w\-]+\+xml$/.test(spec)) {
            return resolveMode("application/xml");
          } else if (typeof spec == "string" && /^[\w\-]+\/[\w\-]+\+json$/.test(spec)) {
            return resolveMode("application/json");
          }
          if (typeof spec == "string") {
            return { name: spec };
          } else {
            return spec || { name: "null" };
          }
        }
        function getMode2(options, spec) {
          spec = resolveMode(spec);
          var mfactory = modes[spec.name];
          if (!mfactory) {
            return getMode2(options, "text/plain");
          }
          var modeObj = mfactory(options, spec);
          if (modeExtensions.hasOwnProperty(spec.name)) {
            var exts = modeExtensions[spec.name];
            for (var prop2 in exts) {
              if (!exts.hasOwnProperty(prop2)) {
                continue;
              }
              if (modeObj.hasOwnProperty(prop2)) {
                modeObj["_" + prop2] = modeObj[prop2];
              }
              modeObj[prop2] = exts[prop2];
            }
          }
          modeObj.name = spec.name;
          if (spec.helperType) {
            modeObj.helperType = spec.helperType;
          }
          if (spec.modeProps) {
            for (var prop$1 in spec.modeProps) {
              modeObj[prop$1] = spec.modeProps[prop$1];
            }
          }
          return modeObj;
        }
        var modeExtensions = {};
        function extendMode(mode2, properties2) {
          var exts = modeExtensions.hasOwnProperty(mode2) ? modeExtensions[mode2] : modeExtensions[mode2] = {};
          copyObj(properties2, exts);
        }
        function copyState2(mode2, state) {
          if (state === true) {
            return state;
          }
          if (mode2.copyState) {
            return mode2.copyState(state);
          }
          var nstate = {};
          for (var n3 in state) {
            var val = state[n3];
            if (val instanceof Array) {
              val = val.concat([]);
            }
            nstate[n3] = val;
          }
          return nstate;
        }
        function innerMode(mode2, state) {
          var info;
          while (mode2.innerMode) {
            info = mode2.innerMode(state);
            if (!info || info.mode == mode2) {
              break;
            }
            state = info.state;
            mode2 = info.mode;
          }
          return info || { mode: mode2, state };
        }
        function startState(mode2, a1, a22) {
          return mode2.startState ? mode2.startState(a1, a22) : true;
        }
        var StringStream2 = function(string2, tabSize, lineOracle) {
          this.pos = this.start = 0;
          this.string = string2;
          this.tabSize = tabSize || 8;
          this.lastColumnPos = this.lastColumnValue = 0;
          this.lineStart = 0;
          this.lineOracle = lineOracle;
        };
        StringStream2.prototype.eol = function() {
          return this.pos >= this.string.length;
        };
        StringStream2.prototype.sol = function() {
          return this.pos == this.lineStart;
        };
        StringStream2.prototype.peek = function() {
          return this.string.charAt(this.pos) || void 0;
        };
        StringStream2.prototype.next = function() {
          if (this.pos < this.string.length) {
            return this.string.charAt(this.pos++);
          }
        };
        StringStream2.prototype.eat = function(match) {
          var ch = this.string.charAt(this.pos);
          var ok5;
          if (typeof match == "string") {
            ok5 = ch == match;
          } else {
            ok5 = ch && (match.test ? match.test(ch) : match(ch));
          }
          if (ok5) {
            ++this.pos;
            return ch;
          }
        };
        StringStream2.prototype.eatWhile = function(match) {
          var start2 = this.pos;
          while (this.eat(match)) {
          }
          return this.pos > start2;
        };
        StringStream2.prototype.eatSpace = function() {
          var start2 = this.pos;
          while (/[\s\u00a0]/.test(this.string.charAt(this.pos))) {
            ++this.pos;
          }
          return this.pos > start2;
        };
        StringStream2.prototype.skipToEnd = function() {
          this.pos = this.string.length;
        };
        StringStream2.prototype.skipTo = function(ch) {
          var found = this.string.indexOf(ch, this.pos);
          if (found > -1) {
            this.pos = found;
            return true;
          }
        };
        StringStream2.prototype.backUp = function(n3) {
          this.pos -= n3;
        };
        StringStream2.prototype.column = function() {
          if (this.lastColumnPos < this.start) {
            this.lastColumnValue = countColumn(this.string, this.start, this.tabSize, this.lastColumnPos, this.lastColumnValue);
            this.lastColumnPos = this.start;
          }
          return this.lastColumnValue - (this.lineStart ? countColumn(this.string, this.lineStart, this.tabSize) : 0);
        };
        StringStream2.prototype.indentation = function() {
          return countColumn(this.string, null, this.tabSize) - (this.lineStart ? countColumn(this.string, this.lineStart, this.tabSize) : 0);
        };
        StringStream2.prototype.match = function(pattern, consume, caseInsensitive) {
          if (typeof pattern == "string") {
            var cased = function(str) {
              return caseInsensitive ? str.toLowerCase() : str;
            };
            var substr = this.string.substr(this.pos, pattern.length);
            if (cased(substr) == cased(pattern)) {
              if (consume !== false) {
                this.pos += pattern.length;
              }
              return true;
            }
          } else {
            var match = this.string.slice(this.pos).match(pattern);
            if (match && match.index > 0) {
              return null;
            }
            if (match && consume !== false) {
              this.pos += match[0].length;
            }
            return match;
          }
        };
        StringStream2.prototype.current = function() {
          return this.string.slice(this.start, this.pos);
        };
        StringStream2.prototype.hideFirstChars = function(n3, inner) {
          this.lineStart += n3;
          try {
            return inner();
          } finally {
            this.lineStart -= n3;
          }
        };
        StringStream2.prototype.lookAhead = function(n3) {
          var oracle = this.lineOracle;
          return oracle && oracle.lookAhead(n3);
        };
        StringStream2.prototype.baseToken = function() {
          var oracle = this.lineOracle;
          return oracle && oracle.baseToken(this.pos);
        };
        function getLine(doc, n3) {
          n3 -= doc.first;
          if (n3 < 0 || n3 >= doc.size) {
            throw new Error("There is no line " + (n3 + doc.first) + " in the document.");
          }
          var chunk = doc;
          while (!chunk.lines) {
            for (var i4 = 0; ; ++i4) {
              var child = chunk.children[i4], sz = child.chunkSize();
              if (n3 < sz) {
                chunk = child;
                break;
              }
              n3 -= sz;
            }
          }
          return chunk.lines[n3];
        }
        function getBetween(doc, start2, end) {
          var out = [], n3 = start2.line;
          doc.iter(start2.line, end.line + 1, function(line) {
            var text = line.text;
            if (n3 == end.line) {
              text = text.slice(0, end.ch);
            }
            if (n3 == start2.line) {
              text = text.slice(start2.ch);
            }
            out.push(text);
            ++n3;
          });
          return out;
        }
        function getLines(doc, from, to) {
          var out = [];
          doc.iter(from, to, function(line) {
            out.push(line.text);
          });
          return out;
        }
        function updateLineHeight(line, height) {
          var diff = height - line.height;
          if (diff) {
            for (var n3 = line; n3; n3 = n3.parent) {
              n3.height += diff;
            }
          }
        }
        function lineNo(line) {
          if (line.parent == null) {
            return null;
          }
          var cur = line.parent, no = indexOf(cur.lines, line);
          for (var chunk = cur.parent; chunk; cur = chunk, chunk = chunk.parent) {
            for (var i4 = 0; ; ++i4) {
              if (chunk.children[i4] == cur) {
                break;
              }
              no += chunk.children[i4].chunkSize();
            }
          }
          return no + cur.first;
        }
        function lineAtHeight(chunk, h2) {
          var n3 = chunk.first;
          outer:
            do {
              for (var i$12 = 0; i$12 < chunk.children.length; ++i$12) {
                var child = chunk.children[i$12], ch = child.height;
                if (h2 < ch) {
                  chunk = child;
                  continue outer;
                }
                h2 -= ch;
                n3 += child.chunkSize();
              }
              return n3;
            } while (!chunk.lines);
          var i4 = 0;
          for (; i4 < chunk.lines.length; ++i4) {
            var line = chunk.lines[i4], lh = line.height;
            if (h2 < lh) {
              break;
            }
            h2 -= lh;
          }
          return n3 + i4;
        }
        function isLine(doc, l3) {
          return l3 >= doc.first && l3 < doc.first + doc.size;
        }
        function lineNumberFor(options, i4) {
          return String(options.lineNumberFormatter(i4 + options.firstLineNumber));
        }
        function Pos(line, ch, sticky) {
          if (sticky === void 0)
            sticky = null;
          if (!(this instanceof Pos)) {
            return new Pos(line, ch, sticky);
          }
          this.line = line;
          this.ch = ch;
          this.sticky = sticky;
        }
        function cmp(a3, b2) {
          return a3.line - b2.line || a3.ch - b2.ch;
        }
        function equalCursorPos(a3, b2) {
          return a3.sticky == b2.sticky && cmp(a3, b2) == 0;
        }
        function copyPos(x3) {
          return Pos(x3.line, x3.ch);
        }
        function maxPos(a3, b2) {
          return cmp(a3, b2) < 0 ? b2 : a3;
        }
        function minPos(a3, b2) {
          return cmp(a3, b2) < 0 ? a3 : b2;
        }
        function clipLine(doc, n3) {
          return Math.max(doc.first, Math.min(n3, doc.first + doc.size - 1));
        }
        function clipPos(doc, pos) {
          if (pos.line < doc.first) {
            return Pos(doc.first, 0);
          }
          var last = doc.first + doc.size - 1;
          if (pos.line > last) {
            return Pos(last, getLine(doc, last).text.length);
          }
          return clipToLen(pos, getLine(doc, pos.line).text.length);
        }
        function clipToLen(pos, linelen) {
          var ch = pos.ch;
          if (ch == null || ch > linelen) {
            return Pos(pos.line, linelen);
          } else if (ch < 0) {
            return Pos(pos.line, 0);
          } else {
            return pos;
          }
        }
        function clipPosArray(doc, array) {
          var out = [];
          for (var i4 = 0; i4 < array.length; i4++) {
            out[i4] = clipPos(doc, array[i4]);
          }
          return out;
        }
        var SavedContext = function(state, lookAhead) {
          this.state = state;
          this.lookAhead = lookAhead;
        };
        var Context = function(doc, state, line, lookAhead) {
          this.state = state;
          this.doc = doc;
          this.line = line;
          this.maxLookAhead = lookAhead || 0;
          this.baseTokens = null;
          this.baseTokenPos = 1;
        };
        Context.prototype.lookAhead = function(n3) {
          var line = this.doc.getLine(this.line + n3);
          if (line != null && n3 > this.maxLookAhead) {
            this.maxLookAhead = n3;
          }
          return line;
        };
        Context.prototype.baseToken = function(n3) {
          if (!this.baseTokens) {
            return null;
          }
          while (this.baseTokens[this.baseTokenPos] <= n3) {
            this.baseTokenPos += 2;
          }
          var type = this.baseTokens[this.baseTokenPos + 1];
          return {
            type: type && type.replace(/( |^)overlay .*/, ""),
            size: this.baseTokens[this.baseTokenPos] - n3
          };
        };
        Context.prototype.nextLine = function() {
          this.line++;
          if (this.maxLookAhead > 0) {
            this.maxLookAhead--;
          }
        };
        Context.fromSaved = function(doc, saved, line) {
          if (saved instanceof SavedContext) {
            return new Context(doc, copyState2(doc.mode, saved.state), line, saved.lookAhead);
          } else {
            return new Context(doc, copyState2(doc.mode, saved), line);
          }
        };
        Context.prototype.save = function(copy2) {
          var state = copy2 !== false ? copyState2(this.doc.mode, this.state) : this.state;
          return this.maxLookAhead > 0 ? new SavedContext(state, this.maxLookAhead) : state;
        };
        function highlightLine(cm, line, context, forceToEnd) {
          var st = [cm.state.modeGen], lineClasses = {};
          var externalMode = cm.getOption("externalMode");
          if (externalMode) {
            var externalStyles = externalMode(cm, line);
            st = st.concat(externalStyles);
          } else {
            runMode2(cm, line.text, cm.doc.mode, context, function(end, style) {
              return st.push(end, style);
            }, lineClasses, forceToEnd);
          }
          var state = context.state;
          var loop = function(o4) {
            context.baseTokens = st;
            var overlay = cm.state.overlays[o4], i4 = 1, at = 0;
            context.state = true;
            runMode2(cm, line.text, overlay.mode, context, function(end, style) {
              var start2 = i4;
              while (at < end) {
                var i_end = st[i4];
                if (i_end > end) {
                  st.splice(i4, 1, end, st[i4 + 1], i_end);
                }
                i4 += 2;
                at = Math.min(end, i_end);
              }
              if (!style) {
                return;
              }
              if (overlay.opaque) {
                st.splice(start2, i4 - start2, end, "overlay " + style);
                i4 = start2 + 2;
              } else {
                for (; start2 < i4; start2 += 2) {
                  var cur = st[start2 + 1];
                  st[start2 + 1] = (cur ? cur + " " : "") + "overlay " + style;
                }
              }
            }, lineClasses);
            context.state = state;
            context.baseTokens = null;
            context.baseTokenPos = 1;
          };
          for (var o3 = 0; o3 < cm.state.overlays.length; ++o3)
            loop(o3);
          return { styles: st, classes: lineClasses.bgClass || lineClasses.textClass ? lineClasses : null };
        }
        function getLineStyles(cm, line, updateFrontier) {
          if (!line.styles || line.styles[0] != cm.state.modeGen) {
            var context = getContextBefore(cm, lineNo(line));
            var resetState = line.text.length > cm.options.maxHighlightLength && copyState2(cm.doc.mode, context.state);
            var result = highlightLine(cm, line, context);
            if (resetState) {
              context.state = resetState;
            }
            line.stateAfter = context.save(!resetState);
            line.styles = result.styles;
            if (result.classes) {
              line.styleClasses = result.classes;
            } else if (line.styleClasses) {
              line.styleClasses = null;
            }
            if (updateFrontier === cm.doc.highlightFrontier) {
              cm.doc.modeFrontier = Math.max(cm.doc.modeFrontier, ++cm.doc.highlightFrontier);
            }
          }
          return line.styles;
        }
        function getContextBefore(cm, n3, precise) {
          var doc = cm.doc, display = cm.display;
          if (!doc.mode.startState) {
            return new Context(doc, true, n3);
          }
          var start2 = findStartLine(cm, n3, precise);
          var saved = start2 > doc.first && getLine(doc, start2 - 1).stateAfter;
          var context = saved ? Context.fromSaved(doc, saved, start2) : new Context(doc, startState(doc.mode), start2);
          doc.iter(start2, n3, function(line) {
            processLine(cm, line.text, context);
            var pos = context.line;
            line.stateAfter = pos == n3 - 1 || pos % 5 == 0 || pos >= display.viewFrom && pos < display.viewTo ? context.save() : null;
            context.nextLine();
          });
          if (precise) {
            doc.modeFrontier = context.line;
          }
          return context;
        }
        function processLine(cm, text, context, startAt) {
          var mode2 = cm.doc.mode;
          var stream = new StringStream2(text, cm.options.tabSize, context);
          stream.start = stream.pos = startAt || 0;
          if (text == "") {
            callBlankLine(mode2, context.state);
          }
          while (!stream.eol()) {
            readToken(mode2, stream, context.state);
            stream.start = stream.pos;
          }
        }
        function callBlankLine(mode2, state) {
          if (mode2.blankLine) {
            return mode2.blankLine(state);
          }
          if (!mode2.innerMode) {
            return;
          }
          var inner = innerMode(mode2, state);
          if (inner.mode.blankLine) {
            return inner.mode.blankLine(inner.state);
          }
        }
        function readToken(mode2, stream, state, inner) {
          for (var i4 = 0; i4 < 10; i4++) {
            if (inner) {
              inner[0] = innerMode(mode2, state).mode;
            }
            var style = mode2.token(stream, state);
            if (stream.pos > stream.start) {
              return style;
            }
          }
          throw new Error("Mode " + mode2.name + " failed to advance stream.");
        }
        var Token = function(stream, type, state) {
          this.start = stream.start;
          this.end = stream.pos;
          this.string = stream.current();
          this.type = type || null;
          this.state = state;
        };
        function takeToken(cm, pos, precise, asArray) {
          var doc = cm.doc, mode2 = doc.mode, style;
          pos = clipPos(doc, pos);
          var line = getLine(doc, pos.line), context = getContextBefore(cm, pos.line, precise);
          var stream = new StringStream2(line.text, cm.options.tabSize, context), tokens;
          if (asArray) {
            tokens = [];
          }
          while ((asArray || stream.pos < pos.ch) && !stream.eol()) {
            stream.start = stream.pos;
            style = readToken(mode2, stream, context.state);
            if (asArray) {
              tokens.push(new Token(stream, style, copyState2(doc.mode, context.state)));
            }
          }
          return asArray ? tokens : new Token(stream, style, context.state);
        }
        function extractLineClasses(type, output) {
          if (type) {
            for (; ; ) {
              var lineClass = type.match(/(?:^|\s+)line-(background-)?(\S+)/);
              if (!lineClass) {
                break;
              }
              type = type.slice(0, lineClass.index) + type.slice(lineClass.index + lineClass[0].length);
              var prop2 = lineClass[1] ? "bgClass" : "textClass";
              if (output[prop2] == null) {
                output[prop2] = lineClass[2];
              } else if (!new RegExp("(?:^|s)" + lineClass[2] + "(?:$|s)").test(output[prop2])) {
                output[prop2] += " " + lineClass[2];
              }
            }
          }
          return type;
        }
        function runMode2(cm, text, mode2, context, f3, lineClasses, forceToEnd) {
          var flattenSpans = mode2.flattenSpans;
          if (flattenSpans == null) {
            flattenSpans = cm.options.flattenSpans;
          }
          var curStart = 0, curStyle = null;
          var stream = new StringStream2(text, cm.options.tabSize, context), style;
          var inner = cm.options.addModeClass && [null];
          if (text == "") {
            extractLineClasses(callBlankLine(mode2, context.state), lineClasses);
          }
          while (!stream.eol()) {
            if (stream.pos > cm.options.maxHighlightLength) {
              flattenSpans = false;
              if (forceToEnd) {
                processLine(cm, text, context, stream.pos);
              }
              stream.pos = text.length;
              style = null;
            } else {
              style = extractLineClasses(readToken(mode2, stream, context.state, inner), lineClasses);
            }
            if (inner) {
              var mName = inner[0].name;
              if (mName) {
                style = "m-" + (style ? mName + " " + style : mName);
              }
            }
            if (!flattenSpans || curStyle != style) {
              while (curStart < stream.start) {
                curStart = Math.min(stream.start, curStart + 5e3);
                f3(curStart, curStyle);
              }
              curStyle = style;
            }
            stream.start = stream.pos;
          }
          while (curStart < stream.pos) {
            var pos = Math.min(stream.pos, curStart + 5e3);
            f3(pos, curStyle);
            curStart = pos;
          }
        }
        function findStartLine(cm, n3, precise) {
          var minindent, minline, doc = cm.doc;
          var lim = precise ? -1 : n3 - (cm.doc.mode.innerMode ? 1e3 : 100);
          for (var search = n3; search > lim; --search) {
            if (search <= doc.first) {
              return doc.first;
            }
            var line = getLine(doc, search - 1), after = line.stateAfter;
            if (after && (!precise || search + (after instanceof SavedContext ? after.lookAhead : 0) <= doc.modeFrontier)) {
              return search;
            }
            var indented = countColumn(line.text, null, cm.options.tabSize);
            if (minline == null || minindent > indented) {
              minline = search - 1;
              minindent = indented;
            }
          }
          return minline;
        }
        function retreatFrontier(doc, n3) {
          doc.modeFrontier = Math.min(doc.modeFrontier, n3);
          if (doc.highlightFrontier < n3 - 10) {
            return;
          }
          var start2 = doc.first;
          for (var line = n3 - 1; line > start2; line--) {
            var saved = getLine(doc, line).stateAfter;
            if (saved && (!(saved instanceof SavedContext) || line + saved.lookAhead < n3)) {
              start2 = line + 1;
              break;
            }
          }
          doc.highlightFrontier = Math.min(doc.highlightFrontier, start2);
        }
        var sawReadOnlySpans = false, sawCollapsedSpans = false;
        function seeReadOnlySpans() {
          sawReadOnlySpans = true;
        }
        function seeCollapsedSpans() {
          sawCollapsedSpans = true;
        }
        function MarkedSpan(marker, from, to) {
          this.marker = marker;
          this.from = from;
          this.to = to;
        }
        function getMarkedSpanFor(spans, marker) {
          if (spans) {
            for (var i4 = 0; i4 < spans.length; ++i4) {
              var span = spans[i4];
              if (span.marker == marker) {
                return span;
              }
            }
          }
        }
        function removeMarkedSpan(spans, span) {
          var r3;
          for (var i4 = 0; i4 < spans.length; ++i4) {
            if (spans[i4] != span) {
              (r3 || (r3 = [])).push(spans[i4]);
            }
          }
          return r3;
        }
        function addMarkedSpan(line, span) {
          line.markedSpans = line.markedSpans ? line.markedSpans.concat([span]) : [span];
          span.marker.attachLine(line);
        }
        function markedSpansBefore(old, startCh, isInsert) {
          var nw;
          if (old) {
            for (var i4 = 0; i4 < old.length; ++i4) {
              var span = old[i4], marker = span.marker;
              var startsBefore = span.from == null || (marker.inclusiveLeft ? span.from <= startCh : span.from < startCh);
              if (startsBefore || span.from == startCh && marker.type == "bookmark" && (!isInsert || !span.marker.insertLeft)) {
                var endsAfter = span.to == null || (marker.inclusiveRight ? span.to >= startCh : span.to > startCh);
                (nw || (nw = [])).push(new MarkedSpan(marker, span.from, endsAfter ? null : span.to));
              }
            }
          }
          return nw;
        }
        function markedSpansAfter(old, endCh, isInsert) {
          var nw;
          if (old) {
            for (var i4 = 0; i4 < old.length; ++i4) {
              var span = old[i4], marker = span.marker;
              var endsAfter = span.to == null || (marker.inclusiveRight ? span.to >= endCh : span.to > endCh);
              if (endsAfter || span.from == endCh && marker.type == "bookmark" && (!isInsert || span.marker.insertLeft)) {
                var startsBefore = span.from == null || (marker.inclusiveLeft ? span.from <= endCh : span.from < endCh);
                (nw || (nw = [])).push(new MarkedSpan(marker, startsBefore ? null : span.from - endCh, span.to == null ? null : span.to - endCh));
              }
            }
          }
          return nw;
        }
        function stretchSpansOverChange(doc, change) {
          if (change.full) {
            return null;
          }
          var oldFirst = isLine(doc, change.from.line) && getLine(doc, change.from.line).markedSpans;
          var oldLast = isLine(doc, change.to.line) && getLine(doc, change.to.line).markedSpans;
          if (!oldFirst && !oldLast) {
            return null;
          }
          var startCh = change.from.ch, endCh = change.to.ch, isInsert = cmp(change.from, change.to) == 0;
          var first = markedSpansBefore(oldFirst, startCh, isInsert);
          var last = markedSpansAfter(oldLast, endCh, isInsert);
          var sameLine = change.text.length == 1, offset = lst(change.text).length + (sameLine ? startCh : 0);
          if (first) {
            for (var i4 = 0; i4 < first.length; ++i4) {
              var span = first[i4];
              if (span.to == null) {
                var found = getMarkedSpanFor(last, span.marker);
                if (!found) {
                  span.to = startCh;
                } else if (sameLine) {
                  span.to = found.to == null ? null : found.to + offset;
                }
              }
            }
          }
          if (last) {
            for (var i$12 = 0; i$12 < last.length; ++i$12) {
              var span$1 = last[i$12];
              if (span$1.to != null) {
                span$1.to += offset;
              }
              if (span$1.from == null) {
                var found$1 = getMarkedSpanFor(first, span$1.marker);
                if (!found$1) {
                  span$1.from = offset;
                  if (sameLine) {
                    (first || (first = [])).push(span$1);
                  }
                }
              } else {
                span$1.from += offset;
                if (sameLine) {
                  (first || (first = [])).push(span$1);
                }
              }
            }
          }
          if (first) {
            first = clearEmptySpans(first);
          }
          if (last && last != first) {
            last = clearEmptySpans(last);
          }
          var newMarkers = [first];
          if (!sameLine) {
            var gap = change.text.length - 2, gapMarkers;
            if (gap > 0 && first) {
              for (var i$22 = 0; i$22 < first.length; ++i$22) {
                if (first[i$22].to == null) {
                  (gapMarkers || (gapMarkers = [])).push(new MarkedSpan(first[i$22].marker, null, null));
                }
              }
            }
            for (var i$3 = 0; i$3 < gap; ++i$3) {
              newMarkers.push(gapMarkers);
            }
            newMarkers.push(last);
          }
          return newMarkers;
        }
        function clearEmptySpans(spans) {
          for (var i4 = 0; i4 < spans.length; ++i4) {
            var span = spans[i4];
            if (span.from != null && span.from == span.to && span.marker.clearWhenEmpty !== false) {
              spans.splice(i4--, 1);
            }
          }
          if (!spans.length) {
            return null;
          }
          return spans;
        }
        function removeReadOnlyRanges(doc, from, to) {
          var markers = null;
          doc.iter(from.line, to.line + 1, function(line) {
            if (line.markedSpans) {
              for (var i5 = 0; i5 < line.markedSpans.length; ++i5) {
                var mark = line.markedSpans[i5].marker;
                if (mark.readOnly && (!markers || indexOf(markers, mark) == -1)) {
                  (markers || (markers = [])).push(mark);
                }
              }
            }
          });
          if (!markers) {
            return null;
          }
          var parts = [{ from, to }];
          for (var i4 = 0; i4 < markers.length; ++i4) {
            var mk = markers[i4], m3 = mk.find(0);
            for (var j3 = 0; j3 < parts.length; ++j3) {
              var p3 = parts[j3];
              if (cmp(p3.to, m3.from) < 0 || cmp(p3.from, m3.to) > 0) {
                continue;
              }
              var newParts = [j3, 1], dfrom = cmp(p3.from, m3.from), dto = cmp(p3.to, m3.to);
              if (dfrom < 0 || !mk.inclusiveLeft && !dfrom) {
                newParts.push({ from: p3.from, to: m3.from });
              }
              if (dto > 0 || !mk.inclusiveRight && !dto) {
                newParts.push({ from: m3.to, to: p3.to });
              }
              parts.splice.apply(parts, newParts);
              j3 += newParts.length - 3;
            }
          }
          return parts;
        }
        function detachMarkedSpans(line) {
          var spans = line.markedSpans;
          if (!spans) {
            return;
          }
          for (var i4 = 0; i4 < spans.length; ++i4) {
            spans[i4].marker.detachLine(line);
          }
          line.markedSpans = null;
        }
        function attachMarkedSpans(line, spans) {
          if (!spans) {
            return;
          }
          for (var i4 = 0; i4 < spans.length; ++i4) {
            spans[i4].marker.attachLine(line);
          }
          line.markedSpans = spans;
        }
        function extraLeft(marker) {
          return marker.inclusiveLeft ? -1 : 0;
        }
        function extraRight(marker) {
          return marker.inclusiveRight ? 1 : 0;
        }
        function compareCollapsedMarkers(a3, b2) {
          var lenDiff = a3.lines.length - b2.lines.length;
          if (lenDiff != 0) {
            return lenDiff;
          }
          var aPos = a3.find(), bPos = b2.find();
          var fromCmp = cmp(aPos.from, bPos.from) || extraLeft(a3) - extraLeft(b2);
          if (fromCmp) {
            return -fromCmp;
          }
          var toCmp = cmp(aPos.to, bPos.to) || extraRight(a3) - extraRight(b2);
          if (toCmp) {
            return toCmp;
          }
          return b2.id - a3.id;
        }
        function collapsedSpanAtSide(line, start2) {
          var sps = sawCollapsedSpans && line.markedSpans, found;
          if (sps) {
            for (var sp = void 0, i4 = 0; i4 < sps.length; ++i4) {
              sp = sps[i4];
              if (sp.marker.collapsed && (start2 ? sp.from : sp.to) == null && (!found || compareCollapsedMarkers(found, sp.marker) < 0)) {
                found = sp.marker;
              }
            }
          }
          return found;
        }
        function collapsedSpanAtStart(line) {
          return collapsedSpanAtSide(line, true);
        }
        function collapsedSpanAtEnd(line) {
          return collapsedSpanAtSide(line, false);
        }
        function collapsedSpanAround(line, ch) {
          var sps = sawCollapsedSpans && line.markedSpans, found;
          if (sps) {
            for (var i4 = 0; i4 < sps.length; ++i4) {
              var sp = sps[i4];
              if (sp.marker.collapsed && (sp.from == null || sp.from < ch) && (sp.to == null || sp.to > ch) && (!found || compareCollapsedMarkers(found, sp.marker) < 0)) {
                found = sp.marker;
              }
            }
          }
          return found;
        }
        function conflictingCollapsedRange(doc, lineNo2, from, to, marker) {
          var line = getLine(doc, lineNo2);
          var sps = sawCollapsedSpans && line.markedSpans;
          if (sps) {
            for (var i4 = 0; i4 < sps.length; ++i4) {
              var sp = sps[i4];
              if (!sp.marker.collapsed) {
                continue;
              }
              var found = sp.marker.find(0);
              var fromCmp = cmp(found.from, from) || extraLeft(sp.marker) - extraLeft(marker);
              var toCmp = cmp(found.to, to) || extraRight(sp.marker) - extraRight(marker);
              if (fromCmp >= 0 && toCmp <= 0 || fromCmp <= 0 && toCmp >= 0) {
                continue;
              }
              if (fromCmp <= 0 && (sp.marker.inclusiveRight && marker.inclusiveLeft ? cmp(found.to, from) >= 0 : cmp(found.to, from) > 0) || fromCmp >= 0 && (sp.marker.inclusiveRight && marker.inclusiveLeft ? cmp(found.from, to) <= 0 : cmp(found.from, to) < 0)) {
                return true;
              }
            }
          }
        }
        function visualLine(line) {
          var merged;
          while (merged = collapsedSpanAtStart(line)) {
            line = merged.find(-1, true).line;
          }
          return line;
        }
        function visualLineEnd(line) {
          var merged;
          while (merged = collapsedSpanAtEnd(line)) {
            line = merged.find(1, true).line;
          }
          return line;
        }
        function visualLineContinued(line) {
          var merged, lines;
          while (merged = collapsedSpanAtEnd(line)) {
            line = merged.find(1, true).line;
            (lines || (lines = [])).push(line);
          }
          return lines;
        }
        function visualLineNo(doc, lineN) {
          var line = getLine(doc, lineN), vis = visualLine(line);
          if (line == vis) {
            return lineN;
          }
          return lineNo(vis);
        }
        function visualLineEndNo(doc, lineN) {
          if (lineN > doc.lastLine()) {
            return lineN;
          }
          var line = getLine(doc, lineN), merged;
          if (!lineIsHidden(doc, line)) {
            return lineN;
          }
          while (merged = collapsedSpanAtEnd(line)) {
            line = merged.find(1, true).line;
          }
          return lineNo(line) + 1;
        }
        function lineIsHidden(doc, line) {
          var sps = sawCollapsedSpans && line.markedSpans;
          if (sps) {
            for (var sp = void 0, i4 = 0; i4 < sps.length; ++i4) {
              sp = sps[i4];
              if (!sp.marker.collapsed) {
                continue;
              }
              if (sp.from == null) {
                return true;
              }
              if (sp.marker.widgetNode) {
                continue;
              }
              if (sp.from == 0 && sp.marker.inclusiveLeft && lineIsHiddenInner(doc, line, sp)) {
                return true;
              }
            }
          }
        }
        function lineIsHiddenInner(doc, line, span) {
          if (span.to == null) {
            var end = span.marker.find(1, true);
            return lineIsHiddenInner(doc, end.line, getMarkedSpanFor(end.line.markedSpans, span.marker));
          }
          if (span.marker.inclusiveRight && span.to == line.text.length) {
            return true;
          }
          for (var sp = void 0, i4 = 0; i4 < line.markedSpans.length; ++i4) {
            sp = line.markedSpans[i4];
            if (sp.marker.collapsed && !sp.marker.widgetNode && sp.from == span.to && (sp.to == null || sp.to != span.from) && (sp.marker.inclusiveLeft || span.marker.inclusiveRight) && lineIsHiddenInner(doc, line, sp)) {
              return true;
            }
          }
        }
        function heightAtLine(lineObj) {
          lineObj = visualLine(lineObj);
          var h2 = 0, chunk = lineObj.parent;
          for (var i4 = 0; i4 < chunk.lines.length; ++i4) {
            var line = chunk.lines[i4];
            if (line == lineObj) {
              break;
            } else {
              h2 += line.height;
            }
          }
          for (var p3 = chunk.parent; p3; chunk = p3, p3 = chunk.parent) {
            for (var i$12 = 0; i$12 < p3.children.length; ++i$12) {
              var cur = p3.children[i$12];
              if (cur == chunk) {
                break;
              } else {
                h2 += cur.height;
              }
            }
          }
          return h2;
        }
        function lineLength(line) {
          if (line.height == 0) {
            return 0;
          }
          var len = line.text.length, merged, cur = line;
          while (merged = collapsedSpanAtStart(cur)) {
            var found = merged.find(0, true);
            cur = found.from.line;
            len += found.from.ch - found.to.ch;
          }
          cur = line;
          while (merged = collapsedSpanAtEnd(cur)) {
            var found$1 = merged.find(0, true);
            len -= cur.text.length - found$1.from.ch;
            cur = found$1.to.line;
            len += cur.text.length - found$1.to.ch;
          }
          return len;
        }
        function findMaxLine(cm) {
          var d4 = cm.display, doc = cm.doc;
          d4.maxLine = getLine(doc, doc.first);
          d4.maxLineLength = lineLength(d4.maxLine);
          d4.maxLineChanged = true;
          doc.iter(function(line) {
            var len = lineLength(line);
            if (len > d4.maxLineLength) {
              d4.maxLineLength = len;
              d4.maxLine = line;
            }
          });
        }
        var Line = function(text, markedSpans, estimateHeight2) {
          this.text = text;
          attachMarkedSpans(this, markedSpans);
          this.height = estimateHeight2 ? estimateHeight2(this) : 1;
        };
        Line.prototype.lineNo = function() {
          return lineNo(this);
        };
        eventMixin(Line);
        function updateLine(line, text, markedSpans, estimateHeight2) {
          line.text = text;
          if (line.stateAfter) {
            line.stateAfter = null;
          }
          if (line.styles) {
            line.styles = null;
          }
          if (line.order != null) {
            line.order = null;
          }
          detachMarkedSpans(line);
          attachMarkedSpans(line, markedSpans);
          var estHeight = estimateHeight2 ? estimateHeight2(line) : 1;
          if (estHeight != line.height) {
            updateLineHeight(line, estHeight);
          }
        }
        function cleanUpLine(line) {
          line.parent = null;
          detachMarkedSpans(line);
        }
        var styleToClassCache = {}, styleToClassCacheWithMode = {};
        function interpretTokenStyle(style, options) {
          if (!style || /^\s*$/.test(style)) {
            return null;
          }
          var cache = options.addModeClass ? styleToClassCacheWithMode : styleToClassCache;
          return cache[style] || (cache[style] = style.replace(/\S+/g, "cm-$&"));
        }
        function buildLineContent(cm, lineView) {
          var content = eltP("span", null, null, webkit ? "padding-right: .1px" : null);
          var builder = {
            pre: eltP("pre", [content], "CodeMirror-line"),
            content,
            col: 0,
            pos: 0,
            cm,
            trailingSpace: false,
            splitSpaces: cm.getOption("lineWrapping")
          };
          lineView.measure = {};
          for (var i4 = 0; i4 <= (lineView.rest ? lineView.rest.length : 0); i4++) {
            var line = i4 ? lineView.rest[i4 - 1] : lineView.line, order = void 0;
            builder.pos = 0;
            builder.addToken = buildToken;
            if (hasBadBidiRects(cm.display.measure) && (order = getOrder(line, cm.doc.direction))) {
              builder.addToken = buildTokenBadBidi(builder.addToken, order);
            }
            builder.map = [];
            var allowFrontierUpdate = lineView != cm.display.externalMeasured && lineNo(line);
            insertLineContent(line, builder, getLineStyles(cm, line, allowFrontierUpdate));
            if (line.styleClasses) {
              if (line.styleClasses.bgClass) {
                builder.bgClass = joinClasses(line.styleClasses.bgClass, builder.bgClass || "");
              }
              if (line.styleClasses.textClass) {
                builder.textClass = joinClasses(line.styleClasses.textClass, builder.textClass || "");
              }
            }
            if (builder.map.length == 0) {
              builder.map.push(0, 0, builder.content.appendChild(zeroWidthElement(cm.display.measure)));
            }
            if (i4 == 0) {
              lineView.measure.map = builder.map;
              lineView.measure.cache = {};
            } else {
              (lineView.measure.maps || (lineView.measure.maps = [])).push(builder.map);
              (lineView.measure.caches || (lineView.measure.caches = [])).push({});
            }
          }
          if (webkit) {
            var last = builder.content.lastChild;
            if (/\bcm-tab\b/.test(last.className) || last.querySelector && last.querySelector(".cm-tab")) {
              builder.content.className = "cm-tab-wrap-hack";
            }
          }
          signal(cm, "renderLine", cm, lineView.line, builder.pre, builder, lineView.measure);
          if (builder.pre.className) {
            builder.textClass = joinClasses(builder.pre.className, builder.textClass || "");
          }
          return builder;
        }
        function defaultSpecialCharPlaceholder(ch) {
          var token = elt("span", "\u2022", "cm-invalidchar");
          token.title = "\\u" + ch.charCodeAt(0).toString(16);
          token.setAttribute("aria-label", token.title);
          return token;
        }
        function buildToken(builder, text, style, startStyle, endStyle, css, attributes) {
          if (!text) {
            return;
          }
          var displayText = builder.splitSpaces ? splitSpaces(text, builder.trailingSpace) : text;
          var special = builder.cm.state.specialChars, mustWrap = false;
          var content;
          if (!special.test(text)) {
            builder.col += text.length;
            content = document.createTextNode(displayText);
            builder.map.push(builder.pos, builder.pos + text.length, content);
            if (ie && ie_version < 9) {
              mustWrap = true;
            }
            builder.pos += text.length;
          } else {
            content = document.createDocumentFragment();
            var pos = 0;
            while (true) {
              special.lastIndex = pos;
              var m3 = special.exec(text);
              var skipped = m3 ? m3.index - pos : text.length - pos;
              if (skipped) {
                var txt = document.createTextNode(displayText.slice(pos, pos + skipped));
                if (ie && ie_version < 9) {
                  content.appendChild(elt("span", [txt]));
                } else {
                  content.appendChild(txt);
                }
                builder.map.push(builder.pos, builder.pos + skipped, txt);
                builder.col += skipped;
                builder.pos += skipped;
              }
              if (!m3) {
                break;
              }
              pos += skipped + 1;
              var txt$1 = void 0;
              if (m3[0] == "	") {
                var tabSize = builder.cm.options.tabSize, tabWidth = tabSize - builder.col % tabSize;
                txt$1 = content.appendChild(elt("span", spaceStr(tabWidth), "cm-tab"));
                txt$1.setAttribute("role", "presentation");
                txt$1.setAttribute("cm-text", "	");
                builder.col += tabWidth;
              } else if (m3[0] == "\r" || m3[0] == "\n") {
                txt$1 = content.appendChild(elt("span", m3[0] == "\r" ? "\u240D" : "\u2424", "cm-invalidchar"));
                txt$1.setAttribute("cm-text", m3[0]);
                builder.col += 1;
              } else {
                txt$1 = builder.cm.options.specialCharPlaceholder(m3[0]);
                txt$1.setAttribute("cm-text", m3[0]);
                if (ie && ie_version < 9) {
                  content.appendChild(elt("span", [txt$1]));
                } else {
                  content.appendChild(txt$1);
                }
                builder.col += 1;
              }
              builder.map.push(builder.pos, builder.pos + 1, txt$1);
              builder.pos++;
            }
          }
          builder.trailingSpace = displayText.charCodeAt(text.length - 1) == 32;
          if (style || startStyle || endStyle || mustWrap || css) {
            var fullStyle = style || "";
            if (startStyle) {
              fullStyle += startStyle;
            }
            if (endStyle) {
              fullStyle += endStyle;
            }
            var token = elt("span", [content], fullStyle, css);
            if (attributes) {
              for (var attr in attributes) {
                if (attributes.hasOwnProperty(attr) && attr != "style" && attr != "class") {
                  token.setAttribute(attr, attributes[attr]);
                }
              }
            }
            return builder.content.appendChild(token);
          }
          builder.content.appendChild(content);
        }
        function splitSpaces(text, trailingBefore) {
          if (text.length > 1 && !/  /.test(text)) {
            return text;
          }
          var spaceBefore = trailingBefore, result = "";
          for (var i4 = 0; i4 < text.length; i4++) {
            var ch = text.charAt(i4);
            if (ch == " " && spaceBefore && (i4 == text.length - 1 || text.charCodeAt(i4 + 1) == 32)) {
              ch = "\xA0";
            }
            result += ch;
            spaceBefore = ch == " ";
          }
          return result;
        }
        function buildTokenBadBidi(inner, order) {
          return function(builder, text, style, startStyle, endStyle, css, attributes) {
            style = style ? style + " cm-force-border" : "cm-force-border";
            var start2 = builder.pos, end = start2 + text.length;
            for (; ; ) {
              var part = void 0;
              for (var i4 = 0; i4 < order.length; i4++) {
                part = order[i4];
                if (part.to > start2 && part.from <= start2) {
                  break;
                }
              }
              if (part.to >= end) {
                return inner(builder, text, style, startStyle, endStyle, css, attributes);
              }
              inner(builder, text.slice(0, part.to - start2), style, startStyle, null, css, attributes);
              startStyle = null;
              text = text.slice(part.to - start2);
              start2 = part.to;
            }
          };
        }
        function buildCollapsedSpan(builder, size2, marker, ignoreWidget) {
          var widget = !ignoreWidget && marker.widgetNode;
          if (widget) {
            builder.map.push(builder.pos, builder.pos + size2, widget);
          }
          if (!ignoreWidget && builder.cm.display.input.needsContentAttribute) {
            if (!widget) {
              widget = builder.content.appendChild(document.createElement("span"));
            }
            widget.setAttribute("cm-marker", marker.id);
          }
          if (widget) {
            builder.cm.display.input.setUneditable(widget);
            builder.content.appendChild(widget);
          }
          builder.pos += size2;
          builder.trailingSpace = false;
        }
        function insertLineContent(line, builder, styles) {
          var spans = line.markedSpans, allText = line.text, at = 0;
          if (!spans) {
            for (var i$12 = 1; i$12 < styles.length; i$12 += 2) {
              builder.addToken(builder, allText.slice(at, at = styles[i$12]), interpretTokenStyle(styles[i$12 + 1], builder.cm.options));
            }
            return;
          }
          var len = allText.length, pos = 0, i4 = 1, text = "", style, css;
          var nextChange = 0, spanStyle, spanEndStyle, spanStartStyle, collapsed, attributes;
          for (; ; ) {
            if (nextChange == pos) {
              spanStyle = spanEndStyle = spanStartStyle = css = "";
              attributes = null;
              collapsed = null;
              nextChange = Infinity;
              var foundBookmarks = [], endStyles = void 0;
              for (var j3 = 0; j3 < spans.length; ++j3) {
                var sp = spans[j3], m3 = sp.marker;
                if (m3.type == "bookmark" && sp.from == pos && m3.widgetNode) {
                  foundBookmarks.push(m3);
                } else if (sp.from <= pos && (sp.to == null || sp.to > pos || m3.collapsed && sp.to == pos && sp.from == pos)) {
                  if (sp.to != null && sp.to != pos && nextChange > sp.to) {
                    nextChange = sp.to;
                    spanEndStyle = "";
                  }
                  if (m3.className) {
                    spanStyle += " " + m3.className;
                  }
                  if (m3.css) {
                    css = (css ? css + ";" : "") + m3.css;
                  }
                  if (m3.startStyle && sp.from == pos) {
                    spanStartStyle += " " + m3.startStyle;
                  }
                  if (m3.endStyle && sp.to == nextChange) {
                    (endStyles || (endStyles = [])).push(m3.endStyle, sp.to);
                  }
                  if (m3.title) {
                    (attributes || (attributes = {})).title = m3.title;
                  }
                  if (m3.attributes) {
                    for (var attr in m3.attributes) {
                      (attributes || (attributes = {}))[attr] = m3.attributes[attr];
                    }
                  }
                  if (m3.collapsed && (!collapsed || compareCollapsedMarkers(collapsed.marker, m3) < 0)) {
                    collapsed = sp;
                  }
                } else if (sp.from > pos && nextChange > sp.from) {
                  nextChange = sp.from;
                }
              }
              if (endStyles) {
                for (var j$1 = 0; j$1 < endStyles.length; j$1 += 2) {
                  if (endStyles[j$1 + 1] == nextChange) {
                    spanEndStyle += " " + endStyles[j$1];
                  }
                }
              }
              if (!collapsed || collapsed.from == pos) {
                for (var j$2 = 0; j$2 < foundBookmarks.length; ++j$2) {
                  buildCollapsedSpan(builder, 0, foundBookmarks[j$2]);
                }
              }
              if (collapsed && (collapsed.from || 0) == pos) {
                buildCollapsedSpan(builder, (collapsed.to == null ? len + 1 : collapsed.to) - pos, collapsed.marker, collapsed.from == null);
                if (collapsed.to == null) {
                  return;
                }
                if (collapsed.to == pos) {
                  collapsed = false;
                }
              }
            }
            if (pos >= len) {
              break;
            }
            var upto = Math.min(len, nextChange);
            while (true) {
              if (text) {
                var end = pos + text.length;
                if (!collapsed) {
                  var tokenText = end > upto ? text.slice(0, upto - pos) : text;
                  builder.addToken(builder, tokenText, style ? style + spanStyle : spanStyle, spanStartStyle, pos + tokenText.length == nextChange ? spanEndStyle : "", css, attributes);
                }
                if (end >= upto) {
                  text = text.slice(upto - pos);
                  pos = upto;
                  break;
                }
                pos = end;
                spanStartStyle = "";
              }
              text = allText.slice(at, at = styles[i4++]);
              style = interpretTokenStyle(styles[i4++], builder.cm.options);
            }
          }
        }
        function LineView(doc, line, lineN) {
          this.line = line;
          this.rest = visualLineContinued(line);
          this.size = this.rest ? lineNo(lst(this.rest)) - lineN + 1 : 1;
          this.node = this.text = null;
          this.hidden = lineIsHidden(doc, line);
        }
        function buildViewArray(cm, from, to) {
          var array = [], nextPos;
          for (var pos = from; pos < to; pos = nextPos) {
            var view = new LineView(cm.doc, getLine(cm.doc, pos), pos);
            nextPos = pos + view.size;
            array.push(view);
          }
          return array;
        }
        var operationGroup = null;
        function pushOperation(op) {
          if (operationGroup) {
            operationGroup.ops.push(op);
          } else {
            op.ownsGroup = operationGroup = {
              ops: [op],
              delayedCallbacks: []
            };
          }
        }
        function fireCallbacksForOps(group) {
          var callbacks = group.delayedCallbacks, i4 = 0;
          do {
            for (; i4 < callbacks.length; i4++) {
              callbacks[i4].call(null);
            }
            for (var j3 = 0; j3 < group.ops.length; j3++) {
              var op = group.ops[j3];
              if (op.cursorActivityHandlers) {
                while (op.cursorActivityCalled < op.cursorActivityHandlers.length) {
                  op.cursorActivityHandlers[op.cursorActivityCalled++].call(null, op.cm);
                }
              }
            }
          } while (i4 < callbacks.length);
        }
        function finishOperation(op, endCb) {
          var group = op.ownsGroup;
          if (!group) {
            return;
          }
          try {
            fireCallbacksForOps(group);
          } finally {
            operationGroup = null;
            endCb(group);
          }
        }
        var orphanDelayedCallbacks = null;
        function signalLater(emitter2, type) {
          var arr = getHandlers(emitter2, type);
          if (!arr.length) {
            return;
          }
          var args = Array.prototype.slice.call(arguments, 2), list;
          if (operationGroup) {
            list = operationGroup.delayedCallbacks;
          } else if (orphanDelayedCallbacks) {
            list = orphanDelayedCallbacks;
          } else {
            list = orphanDelayedCallbacks = [];
            setTimeout(fireOrphanDelayed, 0);
          }
          var loop = function(i5) {
            list.push(function() {
              return arr[i5].apply(null, args);
            });
          };
          for (var i4 = 0; i4 < arr.length; ++i4)
            loop(i4);
        }
        function fireOrphanDelayed() {
          var delayed = orphanDelayedCallbacks;
          orphanDelayedCallbacks = null;
          for (var i4 = 0; i4 < delayed.length; ++i4) {
            delayed[i4]();
          }
        }
        function updateLineForChanges(cm, lineView, lineN, dims) {
          for (var j3 = 0; j3 < lineView.changes.length; j3++) {
            var type = lineView.changes[j3];
            if (type == "text") {
              updateLineText(cm, lineView);
            } else if (type == "gutter") {
              updateLineGutter(cm, lineView, lineN, dims);
            } else if (type == "class") {
              updateLineClasses(cm, lineView);
            } else if (type == "widget") {
              updateLineWidgets(cm, lineView, dims);
            }
          }
          lineView.changes = null;
        }
        function ensureLineWrapped(lineView) {
          if (lineView.node == lineView.text) {
            lineView.node = elt("div", null, null, "position: relative");
            if (lineView.text.parentNode) {
              lineView.text.parentNode.replaceChild(lineView.node, lineView.text);
            }
            lineView.node.appendChild(lineView.text);
            if (ie && ie_version < 8) {
              lineView.node.style.zIndex = 2;
            }
          }
          return lineView.node;
        }
        function updateLineBackground(cm, lineView) {
          var cls = lineView.bgClass ? lineView.bgClass + " " + (lineView.line.bgClass || "") : lineView.line.bgClass;
          if (cls) {
            cls += " CodeMirror-linebackground";
          }
          if (lineView.background) {
            if (cls) {
              lineView.background.className = cls;
            } else {
              lineView.background.parentNode.removeChild(lineView.background);
              lineView.background = null;
            }
          } else if (cls) {
            var wrap = ensureLineWrapped(lineView);
            lineView.background = wrap.insertBefore(elt("div", null, cls), wrap.firstChild);
            cm.display.input.setUneditable(lineView.background);
          }
        }
        function getLineContent(cm, lineView) {
          var ext = cm.display.externalMeasured;
          if (ext && ext.line == lineView.line) {
            cm.display.externalMeasured = null;
            lineView.measure = ext.measure;
            return ext.built;
          }
          return buildLineContent(cm, lineView);
        }
        function updateLineText(cm, lineView) {
          var cls = lineView.text.className;
          var built = getLineContent(cm, lineView);
          if (lineView.text == lineView.node) {
            lineView.node = built.pre;
          }
          lineView.text.parentNode.replaceChild(built.pre, lineView.text);
          lineView.text = built.pre;
          if (built.wrapClass != lineView.wrapClass || built.bgClass != lineView.bgClass || built.textClass != lineView.textClass) {
            lineView.wrapClass = built.wrapClass;
            lineView.bgClass = built.bgClass;
            lineView.textClass = built.textClass;
            updateLineClasses(cm, lineView);
          } else if (cls) {
            lineView.text.className = cls;
          }
        }
        function updateLineClasses(cm, lineView) {
          updateLineBackground(cm, lineView);
          var wrapClass2 = lineView.wrapClass ? lineView.wrapClass + " " + (lineView.line.wrapClass || "") : lineView.line.wrapClass;
          if (wrapClass2) {
            ensureLineWrapped(lineView).className = wrapClass2;
          } else if (lineView.node != lineView.text) {
            lineView.node.className = "";
          }
          var textClass2 = lineView.textClass ? lineView.textClass + " " + (lineView.line.textClass || "") : lineView.line.textClass;
          lineView.text.className = textClass2 || "";
        }
        function updateLineGutter(cm, lineView, lineN, dims) {
          if (lineView.gutter) {
            lineView.node.removeChild(lineView.gutter);
            lineView.gutter = null;
          }
          if (lineView.gutterBackground) {
            lineView.node.removeChild(lineView.gutterBackground);
            lineView.gutterBackground = null;
          }
          if (lineView.line.gutterClass) {
            var wrap = ensureLineWrapped(lineView);
            lineView.gutterBackground = elt("div", null, "CodeMirror-gutter-background " + lineView.line.gutterClass, "left: " + (cm.options.fixedGutter ? dims.fixedPos : -dims.gutterTotalWidth) + "px; width: " + dims.gutterTotalWidth + "px");
            cm.display.input.setUneditable(lineView.gutterBackground);
            wrap.insertBefore(lineView.gutterBackground, lineView.text);
          }
          var markers = lineView.line.gutterMarkers;
          if (cm.options.lineNumbers || markers) {
            var wrap$1 = ensureLineWrapped(lineView);
            var gutterWrap = lineView.gutter = elt("div", null, "CodeMirror-gutter-wrapper", "left: " + (cm.options.fixedGutter ? dims.fixedPos : -dims.gutterTotalWidth) + "px");
            cm.display.input.setUneditable(gutterWrap);
            wrap$1.insertBefore(gutterWrap, lineView.text);
            if (lineView.line.gutterClass) {
              gutterWrap.className += " " + lineView.line.gutterClass;
            }
            if (cm.options.lineNumbers && (!markers || !markers["CodeMirror-linenumbers"])) {
              lineView.lineNumber = gutterWrap.appendChild(elt("div", lineNumberFor(cm.options, lineN), "CodeMirror-linenumber CodeMirror-gutter-elt", "left: " + dims.gutterLeft["CodeMirror-linenumbers"] + "px; width: " + cm.display.lineNumInnerWidth + "px"));
            }
            if (markers) {
              for (var k3 = 0; k3 < cm.display.gutterSpecs.length; ++k3) {
                var id = cm.display.gutterSpecs[k3].className, found = markers.hasOwnProperty(id) && markers[id];
                if (found) {
                  gutterWrap.appendChild(elt("div", [found], "CodeMirror-gutter-elt", "left: " + dims.gutterLeft[id] + "px; width: " + dims.gutterWidth[id] + "px"));
                }
              }
            }
          }
        }
        function updateLineWidgets(cm, lineView, dims) {
          if (lineView.alignable) {
            lineView.alignable = null;
          }
          var isWidget = classTest("CodeMirror-linewidget");
          for (var node = lineView.node.firstChild, next = void 0; node; node = next) {
            next = node.nextSibling;
            if (isWidget.test(node.className)) {
              lineView.node.removeChild(node);
            }
          }
          insertLineWidgets(cm, lineView, dims);
        }
        function buildLineElement(cm, lineView, lineN, dims) {
          var built = getLineContent(cm, lineView);
          lineView.text = lineView.node = built.pre;
          if (built.wrapClass) {
            lineView.wrapClass = built.wrapClass;
          }
          if (built.bgClass) {
            lineView.bgClass = built.bgClass;
          }
          if (built.textClass) {
            lineView.textClass = built.textClass;
          }
          updateLineClasses(cm, lineView);
          updateLineGutter(cm, lineView, lineN, dims);
          insertLineWidgets(cm, lineView, dims);
          return lineView.node;
        }
        function insertLineWidgets(cm, lineView, dims) {
          insertLineWidgetsFor(cm, lineView.line, lineView, dims, true, false);
          if (lineView.rest) {
            for (var i4 = 0; i4 < lineView.rest.length; i4++) {
              insertLineWidgetsFor(cm, lineView.rest[i4], lineView, dims, false, true);
            }
          }
        }
        function insertLineWidgetsFor(cm, line, lineView, dims, allowAbove, isHidden) {
          if (!line.widgets) {
            return;
          }
          var wrap = ensureLineWrapped(lineView);
          for (var i4 = 0, ws = line.widgets; i4 < ws.length; ++i4) {
            var widget = ws[i4];
            if (isHidden && !widget.showIfHidden) {
              continue;
            }
            var node = elt("div", [widget.node], "CodeMirror-linewidget" + (widget.className ? " " + widget.className : ""));
            if (!widget.handleMouseEvents) {
              node.setAttribute("cm-ignore-events", "true");
            }
            positionLineWidget(cm, widget, node, lineView, dims);
            cm.display.input.setUneditable(node);
            if (allowAbove && widget.above) {
              wrap.insertBefore(node, lineView.gutter || lineView.text);
            } else if (widget.overlay) {
              wrap.insertBefore(node, lineView.text);
            } else {
              wrap.appendChild(node);
            }
            signalLater(widget, "redraw");
          }
        }
        function positionLineWidget(cm, widget, node, lineView, dims) {
          if (widget.noHScroll) {
            (lineView.alignable || (lineView.alignable = [])).push(node);
            var width = dims.wrapperWidth;
            node.style.left = dims.fixedPos + "px";
            if (!widget.coverGutter) {
              width -= dims.gutterTotalWidth;
              node.style.paddingLeft = dims.gutterTotalWidth + "px";
            }
            node.style.width = width + "px";
          }
          if (widget.coverGutter) {
            node.style.zIndex = 5;
            node.style.position = "relative";
            if (!widget.noHScroll) {
              node.style.marginLeft = -dims.gutterTotalWidth + "px";
            }
          }
          if (widget.overlay) {
            node.style.position = "absolute";
          }
          if (widget.positionWidget && cm.display.positionLineWidgets) {
            cm.display.positionLineWidgets.push({
              widget,
              node
            });
          }
        }
        function widgetHeight(widget) {
          if (widget.height != null) {
            return widget.height;
          }
          if (widget.overlay) {
            return widget.height = 0;
          }
          var cm = widget.doc.cm;
          if (!cm) {
            return 0;
          }
          if (!contains3(document.body, widget.node)) {
            var parentStyle = "position: relative;";
            if (widget.coverGutter) {
              parentStyle += "margin-left: -" + cm.display.gutters.offsetWidth + "px;";
            }
            if (widget.noHScroll) {
              parentStyle += "width: " + cm.display.wrapper.clientWidth + "px;";
            }
            removeChildrenAndAdd(cm.display.measure, elt("div", [widget.node], null, parentStyle));
          }
          return widget.height = widget.node.parentNode.offsetHeight;
        }
        function eventInWidget(display, e5) {
          for (var n3 = e_target(e5); n3 != display.wrapper; n3 = n3.parentNode) {
            if (!n3 || n3.nodeType == 1 && n3.getAttribute("cm-ignore-events") == "true" || n3.parentNode == display.sizer && n3 != display.mover) {
              return true;
            }
          }
        }
        function spaceWidth(display) {
          if (display.cachedSpaceWidth != null) {
            return display.cachedSpaceWidth;
          }
          var anchor = elt("span", "          ");
          var pre = elt("pre", [anchor], "CodeMirror-line-like");
          removeChildrenAndAdd(display.measure, pre);
          var rect = anchor.getBoundingClientRect(), width = (rect.right - rect.left) / 10;
          if (width > 2) {
            display.cachedSpaceWidth = width;
          }
          return width || 10;
        }
        function paddingTop(display) {
          return display.lineSpace.offsetTop;
        }
        function paddingVert(display) {
          return display.mover.offsetHeight - display.lineSpace.offsetHeight;
        }
        function paddingH(display) {
          if (display.cachedPaddingH) {
            return display.cachedPaddingH;
          }
          var e5 = removeChildrenAndAdd(display.measure, elt("pre", "x", "CodeMirror-line-like"));
          var style = window.getComputedStyle ? window.getComputedStyle(e5) : e5.currentStyle;
          var data = { left: parseInt(style.paddingLeft), right: parseInt(style.paddingRight) };
          if (!isNaN(data.left) && !isNaN(data.right)) {
            display.cachedPaddingH = data;
          }
          return data;
        }
        function scrollGap(cm) {
          return scrollerGap - cm.display.nativeBarWidth;
        }
        function displayWidth(cm) {
          return cm.display.scroller.clientWidth - scrollGap(cm) - cm.display.barWidth;
        }
        function displayHeight(cm) {
          return cm.display.scroller.clientHeight - scrollGap(cm) - cm.display.barHeight;
        }
        function ensureLineHeights(cm, lineView, rect) {
          var wrapping = cm.options.lineWrapping;
          var curWidth = wrapping && displayWidth(cm);
          if (!lineView.measure.heights || wrapping && lineView.measure.width != curWidth) {
            var heights = lineView.measure.heights = [];
            if (wrapping) {
              lineView.measure.width = curWidth;
              var rects = lineView.text.firstChild.getClientRects();
              for (var i4 = 0; i4 < rects.length - 1; i4++) {
                var cur = rects[i4], next = rects[i4 + 1];
                if (Math.abs(cur.bottom - next.bottom) > 2) {
                  heights.push((cur.bottom + next.top) / 2 - rect.top);
                }
              }
            }
            heights.push(rect.bottom - rect.top);
          }
        }
        function mapFromLineView(lineView, line, lineN) {
          if (lineView.line == line) {
            return { map: lineView.measure.map, cache: lineView.measure.cache };
          }
          for (var i4 = 0; i4 < lineView.rest.length; i4++) {
            if (lineView.rest[i4] == line) {
              return { map: lineView.measure.maps[i4], cache: lineView.measure.caches[i4] };
            }
          }
          for (var i$12 = 0; i$12 < lineView.rest.length; i$12++) {
            if (lineNo(lineView.rest[i$12]) > lineN) {
              return { map: lineView.measure.maps[i$12], cache: lineView.measure.caches[i$12], before: true };
            }
          }
        }
        function updateExternalMeasurement(cm, line) {
          line = visualLine(line);
          var lineN = lineNo(line);
          var view = cm.display.externalMeasured = new LineView(cm.doc, line, lineN);
          view.lineN = lineN;
          var built = view.built = buildLineContent(cm, view);
          view.text = built.pre;
          removeChildrenAndAdd(cm.display.lineMeasure, built.pre);
          return view;
        }
        function measureChar(cm, line, ch, bias) {
          return measureCharPrepared(cm, prepareMeasureForLine(cm, line), ch, bias);
        }
        function findViewForLine(cm, lineN) {
          if (lineN >= cm.display.viewFrom && lineN < cm.display.viewTo) {
            return cm.display.view[findViewIndex(cm, lineN)];
          }
          var ext = cm.display.externalMeasured;
          if (ext && lineN >= ext.lineN && lineN < ext.lineN + ext.size) {
            return ext;
          }
        }
        function prepareMeasureForLine(cm, line) {
          var lineN = lineNo(line);
          var view = findViewForLine(cm, lineN);
          if (view && !view.text) {
            view = null;
          } else if (view && view.changes) {
            updateLineForChanges(cm, view, lineN, getDimensions(cm));
            cm.curOp.forceUpdate = true;
          }
          if (!view) {
            view = updateExternalMeasurement(cm, line);
          }
          var info = mapFromLineView(view, line, lineN);
          return {
            line,
            view,
            rect: null,
            map: info.map,
            cache: info.cache,
            before: info.before,
            hasHeights: false
          };
        }
        function measureCharPrepared(cm, prepared, ch, bias, varHeight) {
          if (prepared.before) {
            ch = -1;
          }
          var key = ch + (bias || ""), found;
          if (prepared.cache.hasOwnProperty(key)) {
            found = prepared.cache[key];
          } else {
            if (!prepared.rect) {
              prepared.rect = prepared.view.text.getBoundingClientRect();
            }
            if (!prepared.hasHeights) {
              ensureLineHeights(cm, prepared.view, prepared.rect);
              prepared.hasHeights = true;
            }
            found = measureCharInner(cm, prepared, ch, bias);
            if (!found.bogus) {
              prepared.cache[key] = found;
            }
          }
          return {
            left: found.left,
            right: found.right,
            top: varHeight ? found.rtop : found.top,
            bottom: varHeight ? found.rbottom : found.bottom
          };
        }
        var nullRect = { left: 0, right: 0, top: 0, bottom: 0 };
        function nodeAndOffsetInLineMap(map4, ch, bias) {
          var node, start2, end, collapse, mStart, mEnd;
          for (var i4 = 0; i4 < map4.length; i4 += 3) {
            mStart = map4[i4];
            mEnd = map4[i4 + 1];
            if (ch < mStart) {
              start2 = 0;
              end = 1;
              collapse = "left";
            } else if (ch < mEnd) {
              start2 = ch - mStart;
              end = start2 + 1;
            } else if (i4 == map4.length - 3 || ch == mEnd && map4[i4 + 3] > ch) {
              end = mEnd - mStart;
              start2 = end - 1;
              if (ch >= mEnd) {
                collapse = "right";
              }
            }
            if (start2 != null) {
              node = map4[i4 + 2];
              if (mStart == mEnd && bias == (node.insertLeft ? "left" : "right")) {
                collapse = bias;
              }
              if (bias == "left" && start2 == 0) {
                while (i4 && map4[i4 - 2] == map4[i4 - 3] && map4[i4 - 1].insertLeft) {
                  node = map4[(i4 -= 3) + 2];
                  collapse = "left";
                }
              }
              if (bias == "right" && start2 == mEnd - mStart) {
                while (i4 < map4.length - 3 && map4[i4 + 3] == map4[i4 + 4] && !map4[i4 + 5].insertLeft) {
                  node = map4[(i4 += 3) + 2];
                  collapse = "right";
                }
              }
              break;
            }
          }
          return { node, start: start2, end, collapse, coverStart: mStart, coverEnd: mEnd };
        }
        function getUsefulRect(rects, bias) {
          var rect = nullRect;
          if (bias == "left") {
            for (var i4 = 0; i4 < rects.length; i4++) {
              if ((rect = rects[i4]).left != rect.right) {
                break;
              }
            }
          } else {
            for (var i$12 = rects.length - 1; i$12 >= 0; i$12--) {
              if ((rect = rects[i$12]).left != rect.right) {
                break;
              }
            }
          }
          return rect;
        }
        function measureCharInner(cm, prepared, ch, bias) {
          var place = nodeAndOffsetInLineMap(prepared.map, ch, bias);
          var node = place.node, start2 = place.start, end = place.end, collapse = place.collapse;
          var rect;
          if (node.nodeType == 3) {
            for (var i$12 = 0; i$12 < 4; i$12++) {
              while (start2 && isExtendingChar(prepared.line.text.charAt(place.coverStart + start2))) {
                --start2;
              }
              while (place.coverStart + end < place.coverEnd && isExtendingChar(prepared.line.text.charAt(place.coverStart + end))) {
                ++end;
              }
              if (ie && ie_version < 9 && start2 == 0 && end == place.coverEnd - place.coverStart) {
                rect = node.parentNode.getBoundingClientRect();
              } else {
                rect = getUsefulRect(range2(node, start2, end).getClientRects(), bias);
                if (rect.width === 0) {
                  var rects = range2(node, start2, end).getClientRects();
                  if (rects.length) {
                    rect = rects[bias == "right" ? rects.length - 1 : 0];
                  } else {
                    rect = nullRect;
                  }
                }
              }
              if (rect.left || rect.right || start2 == 0) {
                break;
              }
              end = start2;
              start2 = start2 - 1;
              collapse = "right";
            }
            if (ie && ie_version < 11) {
              rect = maybeUpdateRectForZooming(cm.display.measure, rect);
            }
          } else {
            if (start2 > 0) {
              collapse = bias = "right";
            }
            var rects$1;
            if (cm.options.lineWrapping && (rects$1 = node.getClientRects()).length > 1) {
              rect = rects$1[bias == "right" ? rects$1.length - 1 : 0];
            } else {
              rect = node.getBoundingClientRect();
            }
          }
          if (ie && ie_version < 9 && !start2 && (!rect || !rect.left && !rect.right)) {
            var rSpan = node.parentNode.getClientRects()[0];
            if (rSpan) {
              rect = { left: rSpan.left, right: rSpan.left + charWidth(cm.display), top: rSpan.top, bottom: rSpan.bottom };
            } else {
              rect = nullRect;
            }
          }
          var rtop = rect.top - prepared.rect.top, rbot = rect.bottom - prepared.rect.top;
          var mid = (rtop + rbot) / 2;
          var heights = prepared.view.measure.heights;
          var i4 = 0;
          for (; i4 < heights.length - 1; i4++) {
            if (mid < heights[i4]) {
              break;
            }
          }
          var top = i4 ? heights[i4 - 1] : 0, bot = heights[i4];
          var result = {
            left: (collapse == "right" ? rect.right : rect.left) - prepared.rect.left,
            right: (collapse == "left" ? rect.left : rect.right) - prepared.rect.left,
            top,
            bottom: bot
          };
          if (!rect.left && !rect.right) {
            result.bogus = true;
          }
          if (!cm.options.singleCursorHeightPerLine) {
            result.rtop = rtop;
            result.rbottom = rbot;
          }
          var left = prepared.view.text.offsetLeft;
          if (left) {
            result.left += left;
            result.right += left;
          }
          return result;
        }
        function maybeUpdateRectForZooming(measure, rect) {
          if (!window.screen || screen.logicalXDPI == null || screen.logicalXDPI == screen.deviceXDPI || !hasBadZoomedRects(measure)) {
            return rect;
          }
          var scaleX = screen.logicalXDPI / screen.deviceXDPI;
          var scaleY = screen.logicalYDPI / screen.deviceYDPI;
          return {
            left: rect.left * scaleX,
            right: rect.right * scaleX,
            top: rect.top * scaleY,
            bottom: rect.bottom * scaleY
          };
        }
        function clearLineMeasurementCacheFor(lineView) {
          if (lineView.measure) {
            lineView.measure.cache = {};
            lineView.measure.heights = null;
            if (lineView.rest) {
              for (var i4 = 0; i4 < lineView.rest.length; i4++) {
                lineView.measure.caches[i4] = {};
              }
            }
          }
        }
        function clearLineMeasurementCache(cm) {
          cm.display.externalMeasure = null;
          removeChildren(cm.display.lineMeasure);
          for (var i4 = 0; i4 < cm.display.view.length; i4++) {
            clearLineMeasurementCacheFor(cm.display.view[i4]);
          }
        }
        function clearCaches(cm) {
          clearLineMeasurementCache(cm);
          cm.display.cachedCharWidth = cm.display.cachedSpaceWidth = cm.display.cachedTextHeight = cm.display.cachedPaddingH = null;
          if (!cm.options.lineWrapping) {
            cm.display.maxLineChanged = true;
          }
          cm.display.lineNumChars = null;
        }
        function pageScrollX() {
          if (chrome && android) {
            return -(document.body.getBoundingClientRect().left - parseInt(getComputedStyle(document.body).marginLeft));
          }
          return window.pageXOffset || (document.documentElement || document.body).scrollLeft;
        }
        function pageScrollY() {
          if (chrome && android) {
            return -(document.body.getBoundingClientRect().top - parseInt(getComputedStyle(document.body).marginTop));
          }
          return window.pageYOffset || (document.documentElement || document.body).scrollTop;
        }
        function widgetTopHeight(lineObj) {
          var height = 0;
          if (lineObj.widgets) {
            for (var i4 = 0; i4 < lineObj.widgets.length; ++i4) {
              if (lineObj.widgets[i4].above) {
                height += widgetHeight(lineObj.widgets[i4]);
              }
            }
          }
          return height;
        }
        function intoCoordSystem(cm, lineObj, rect, context, includeWidgets) {
          if (!includeWidgets) {
            var height = widgetTopHeight(lineObj);
            rect.top += height;
            rect.bottom += height;
          }
          if (context == "line") {
            return rect;
          }
          if (!context) {
            context = "local";
          }
          var yOff = heightAtLine(lineObj);
          if (context == "local") {
            yOff += paddingTop(cm.display);
          } else {
            yOff -= cm.display.viewOffset;
          }
          if (context == "page" || context == "window") {
            var lOff = cm.display.lineSpace.getBoundingClientRect();
            yOff += lOff.top + (context == "window" ? 0 : pageScrollY());
            var xOff = lOff.left + (context == "window" ? 0 : pageScrollX());
            rect.left += xOff;
            rect.right += xOff;
          }
          rect.top += yOff;
          rect.bottom += yOff;
          return rect;
        }
        function fromCoordSystem(cm, coords, context) {
          if (context == "div") {
            return coords;
          }
          var left = coords.left, top = coords.top;
          if (context == "page") {
            left -= pageScrollX();
            top -= pageScrollY();
          } else if (context == "local" || !context) {
            var localBox = cm.display.sizer.getBoundingClientRect();
            left += localBox.left;
            top += localBox.top;
          }
          var lineSpaceBox = cm.display.lineSpace.getBoundingClientRect();
          return { left: left - lineSpaceBox.left, top: top - lineSpaceBox.top };
        }
        function charCoords(cm, pos, context, lineObj, bias) {
          if (!lineObj) {
            lineObj = getLine(cm.doc, pos.line);
          }
          return intoCoordSystem(cm, lineObj, measureChar(cm, lineObj, pos.ch, bias), context);
        }
        function cursorCoords(cm, pos, context, lineObj, preparedMeasure, varHeight) {
          lineObj = lineObj || getLine(cm.doc, pos.line);
          if (!preparedMeasure) {
            preparedMeasure = prepareMeasureForLine(cm, lineObj);
          }
          function get(ch2, right) {
            var m3 = measureCharPrepared(cm, preparedMeasure, ch2, right ? "right" : "left", varHeight);
            if (right) {
              m3.left = m3.right;
            } else {
              m3.right = m3.left;
            }
            return intoCoordSystem(cm, lineObj, m3, context);
          }
          var order = getOrder(lineObj, cm.doc.direction), ch = pos.ch, sticky = pos.sticky;
          if (ch >= lineObj.text.length) {
            ch = lineObj.text.length;
            sticky = "before";
          } else if (ch <= 0) {
            ch = 0;
            sticky = "after";
          }
          if (!order) {
            return get(sticky == "before" ? ch - 1 : ch, sticky == "before");
          }
          function getBidi(ch2, partPos2, invert) {
            var part = order[partPos2], right = part.level == 1;
            return get(invert ? ch2 - 1 : ch2, right != invert);
          }
          var partPos = getBidiPartAt(order, ch, sticky);
          var other = bidiOther;
          var val = getBidi(ch, partPos, sticky == "before");
          if (other != null) {
            val.other = getBidi(ch, other, sticky != "before");
          }
          return val;
        }
        function estimateCoords(cm, pos) {
          var left = 0;
          pos = clipPos(cm.doc, pos);
          if (!cm.options.lineWrapping) {
            left = charWidth(cm.display) * pos.ch;
          }
          var lineObj = getLine(cm.doc, pos.line);
          var top = heightAtLine(lineObj) + paddingTop(cm.display);
          return { left, right: left, top, bottom: top + lineObj.height };
        }
        function PosWithInfo(line, ch, sticky, outside, xRel) {
          var pos = Pos(line, ch, sticky);
          pos.xRel = xRel;
          if (outside) {
            pos.outside = outside;
          }
          return pos;
        }
        function coordsChar(cm, x3, y2) {
          var doc = cm.doc;
          y2 += cm.display.viewOffset;
          if (y2 < 0) {
            return PosWithInfo(doc.first, 0, null, -1, -1);
          }
          var lineN = lineAtHeight(doc, y2), last = doc.first + doc.size - 1;
          if (lineN > last) {
            return PosWithInfo(doc.first + doc.size - 1, getLine(doc, last).text.length, null, 1, 1);
          }
          if (x3 < 0) {
            x3 = 0;
          }
          var lineObj = getLine(doc, lineN);
          for (; ; ) {
            var found = coordsCharInner(cm, lineObj, lineN, x3, y2);
            var collapsed = collapsedSpanAround(lineObj, found.ch + (found.xRel > 0 || found.outside > 0 ? 1 : 0));
            if (!collapsed) {
              return found;
            }
            var rangeEnd = collapsed.find(1);
            if (rangeEnd.line == lineN) {
              return rangeEnd;
            }
            lineObj = getLine(doc, lineN = rangeEnd.line);
          }
        }
        function wrappedLineExtent(cm, lineObj, preparedMeasure, y2) {
          y2 -= widgetTopHeight(lineObj);
          var end = lineObj.text.length;
          var begin = findFirst(function(ch) {
            return measureCharPrepared(cm, preparedMeasure, ch - 1).bottom <= y2;
          }, end, 0);
          end = findFirst(function(ch) {
            return measureCharPrepared(cm, preparedMeasure, ch).top > y2;
          }, begin, end);
          return { begin, end };
        }
        function wrappedLineExtentChar(cm, lineObj, preparedMeasure, target) {
          if (!preparedMeasure) {
            preparedMeasure = prepareMeasureForLine(cm, lineObj);
          }
          var targetTop = intoCoordSystem(cm, lineObj, measureCharPrepared(cm, preparedMeasure, target), "line").top;
          return wrappedLineExtent(cm, lineObj, preparedMeasure, targetTop);
        }
        function boxIsAfter(box, x3, y2, left) {
          return box.bottom <= y2 ? false : box.top > y2 ? true : (left ? box.left : box.right) > x3;
        }
        function coordsCharInner(cm, lineObj, lineNo2, x3, y2) {
          y2 -= heightAtLine(lineObj);
          var preparedMeasure = prepareMeasureForLine(cm, lineObj);
          var widgetHeight2 = widgetTopHeight(lineObj);
          var begin = 0, end = lineObj.text.length, ltr = true;
          var order = getOrder(lineObj, cm.doc.direction);
          if (order) {
            var part = (cm.options.lineWrapping ? coordsBidiPartWrapped : coordsBidiPart)(cm, lineObj, lineNo2, preparedMeasure, order, x3, y2);
            ltr = part.level != 1;
            begin = ltr ? part.from : part.to - 1;
            end = ltr ? part.to : part.from - 1;
          }
          var chAround = null, boxAround = null;
          var ch = findFirst(function(ch2) {
            var box = measureCharPrepared(cm, preparedMeasure, ch2);
            box.top += widgetHeight2;
            box.bottom += widgetHeight2;
            if (!boxIsAfter(box, x3, y2, false)) {
              return false;
            }
            if (box.top <= y2 && box.left <= x3) {
              chAround = ch2;
              boxAround = box;
            }
            return true;
          }, begin, end);
          var baseX, sticky, outside = false;
          if (boxAround) {
            var atLeft = x3 - boxAround.left < boxAround.right - x3, atStart = atLeft == ltr;
            ch = chAround + (atStart ? 0 : 1);
            sticky = atStart ? "after" : "before";
            baseX = atLeft ? boxAround.left : boxAround.right;
          } else {
            if (!ltr && (ch == end || ch == begin)) {
              ch++;
            }
            sticky = ch == 0 ? "after" : ch == lineObj.text.length ? "before" : measureCharPrepared(cm, preparedMeasure, ch - (ltr ? 1 : 0)).bottom + widgetHeight2 <= y2 == ltr ? "after" : "before";
            var coords = cursorCoords(cm, Pos(lineNo2, ch, sticky), "line", lineObj, preparedMeasure);
            baseX = coords.left;
            outside = y2 < coords.top ? -1 : y2 >= coords.bottom ? 1 : 0;
          }
          ch = skipExtendingChars(lineObj.text, ch, 1);
          return PosWithInfo(lineNo2, ch, sticky, outside, x3 - baseX);
        }
        function coordsBidiPart(cm, lineObj, lineNo2, preparedMeasure, order, x3, y2) {
          var index2 = findFirst(function(i4) {
            var part2 = order[i4], ltr2 = part2.level != 1;
            return boxIsAfter(cursorCoords(cm, Pos(lineNo2, ltr2 ? part2.to : part2.from, ltr2 ? "before" : "after"), "line", lineObj, preparedMeasure), x3, y2, true);
          }, 0, order.length - 1);
          var part = order[index2];
          if (index2 > 0) {
            var ltr = part.level != 1;
            var start2 = cursorCoords(cm, Pos(lineNo2, ltr ? part.from : part.to, ltr ? "after" : "before"), "line", lineObj, preparedMeasure);
            if (boxIsAfter(start2, x3, y2, true) && start2.top > y2) {
              part = order[index2 - 1];
            }
          }
          return part;
        }
        function coordsBidiPartWrapped(cm, lineObj, _lineNo, preparedMeasure, order, x3, y2) {
          var ref = wrappedLineExtent(cm, lineObj, preparedMeasure, y2);
          var begin = ref.begin;
          var end = ref.end;
          if (/\s/.test(lineObj.text.charAt(end - 1))) {
            end--;
          }
          var part = null, closestDist = null;
          for (var i4 = 0; i4 < order.length; i4++) {
            var p3 = order[i4];
            if (p3.from >= end || p3.to <= begin) {
              continue;
            }
            var ltr = p3.level != 1;
            var endX = measureCharPrepared(cm, preparedMeasure, ltr ? Math.min(end, p3.to) - 1 : Math.max(begin, p3.from)).right;
            var dist = endX < x3 ? x3 - endX + 1e9 : endX - x3;
            if (!part || closestDist > dist) {
              part = p3;
              closestDist = dist;
            }
          }
          if (!part) {
            part = order[order.length - 1];
          }
          if (part.from < begin) {
            part = { from: begin, to: part.to, level: part.level };
          }
          if (part.to > end) {
            part = { from: part.from, to: end, level: part.level };
          }
          return part;
        }
        var measureText;
        function textHeight$1(display) {
          if (display.cachedTextHeight != null) {
            return display.cachedTextHeight;
          }
          if (measureText == null) {
            measureText = elt("pre", null, "CodeMirror-line-like");
            for (var i4 = 0; i4 < 49; ++i4) {
              measureText.appendChild(document.createTextNode("x"));
              measureText.appendChild(elt("br"));
            }
            measureText.appendChild(document.createTextNode("x"));
          }
          removeChildrenAndAdd(display.measure, measureText);
          var height = measureText.offsetHeight / 50;
          if (height > 3) {
            display.cachedTextHeight = height;
          }
          removeChildren(display.measure);
          return height || 1;
        }
        function charWidth(display) {
          if (display.cachedCharWidth != null) {
            return display.cachedCharWidth;
          }
          var anchor = elt("span", "xxxxxxxxxx");
          var pre = elt("pre", [anchor]);
          removeChildrenAndAdd(display.measure, pre);
          var rect = anchor.getBoundingClientRect(), width = (rect.right - rect.left) / 10;
          if (width > 2) {
            display.cachedCharWidth = width;
          }
          return width || 10;
        }
        function getDimensions(cm) {
          var d4 = cm.display, left = {}, width = {};
          var gutterLeft = d4.gutters.clientLeft;
          for (var n3 = d4.gutters.firstChild, i4 = 0; n3; n3 = n3.nextSibling, ++i4) {
            var id = cm.display.gutterSpecs[i4].className;
            left[id] = n3.offsetLeft + n3.clientLeft + gutterLeft;
            width[id] = n3.clientWidth;
          }
          return {
            fixedPos: compensateForHScroll(d4),
            gutterTotalWidth: d4.gutters.offsetWidth,
            gutterLeft: left,
            gutterWidth: width,
            wrapperWidth: d4.wrapper.clientWidth
          };
        }
        function compensateForHScroll(display) {
          return display.scroller.getBoundingClientRect().left - display.sizer.getBoundingClientRect().left;
        }
        function estimateHeight(cm) {
          var th = textHeight$1(cm.display), wrapping = cm.options.lineWrapping;
          var perLine = wrapping && Math.max(5, cm.display.scroller.clientWidth / charWidth(cm.display) - 3);
          return function(line) {
            if (lineIsHidden(cm.doc, line)) {
              return 0;
            }
            var widgetsHeight = 0;
            if (line.widgets) {
              for (var i4 = 0; i4 < line.widgets.length; i4++) {
                if (line.widgets[i4].height) {
                  widgetsHeight += line.widgets[i4].height;
                }
              }
            }
            if (wrapping) {
              return widgetsHeight + (Math.ceil(line.text.length / perLine) || 1) * th;
            } else {
              return widgetsHeight + th;
            }
          };
        }
        function estimateLineHeights(cm) {
          var doc = cm.doc, est = estimateHeight(cm);
          doc.iter(function(line) {
            var estHeight = est(line);
            if (estHeight != line.height) {
              updateLineHeight(line, estHeight);
            }
          });
        }
        function posFromMouse(cm, e5, liberal, forRect) {
          var display = cm.display;
          if (!liberal && e_target(e5).getAttribute("cm-not-content") == "true") {
            return null;
          }
          var x3, y2, space = display.lineSpace.getBoundingClientRect();
          try {
            x3 = e5.clientX - space.left;
            y2 = e5.clientY - space.top;
          } catch (e6) {
            return null;
          }
          var coords = coordsChar(cm, x3, y2), line;
          if (forRect && coords.xRel > 0 && (line = getLine(cm.doc, coords.line).text).length == coords.ch) {
            var colDiff = countColumn(line, line.length, cm.options.tabSize) - line.length;
            coords = Pos(coords.line, Math.max(0, Math.round((x3 - paddingH(cm.display).left) / charWidth(cm.display)) - colDiff));
          }
          return coords;
        }
        function findViewIndex(cm, n3) {
          if (n3 >= cm.display.viewTo) {
            return null;
          }
          n3 -= cm.display.viewFrom;
          if (n3 < 0) {
            return null;
          }
          var view = cm.display.view;
          for (var i4 = 0; i4 < view.length; i4++) {
            n3 -= view[i4].size;
            if (n3 < 0) {
              return i4;
            }
          }
        }
        function regChange(cm, from, to, lendiff) {
          if (from == null) {
            from = cm.doc.first;
          }
          if (to == null) {
            to = cm.doc.first + cm.doc.size;
          }
          if (!lendiff) {
            lendiff = 0;
          }
          var display = cm.display;
          if (lendiff && to < display.viewTo && (display.updateLineNumbers == null || display.updateLineNumbers > from)) {
            display.updateLineNumbers = from;
          }
          cm.curOp.viewChanged = true;
          if (from >= display.viewTo) {
            if (sawCollapsedSpans && visualLineNo(cm.doc, from) < display.viewTo) {
              resetView(cm);
            }
          } else if (to <= display.viewFrom) {
            if (sawCollapsedSpans && visualLineEndNo(cm.doc, to + lendiff) > display.viewFrom) {
              resetView(cm);
            } else {
              display.viewFrom += lendiff;
              display.viewTo += lendiff;
            }
          } else if (from <= display.viewFrom && to >= display.viewTo) {
            resetView(cm);
          } else if (from <= display.viewFrom) {
            var cut2 = viewCuttingPoint(cm, to, to + lendiff, 1);
            if (cut2) {
              display.view = display.view.slice(cut2.index);
              display.viewFrom = cut2.lineN;
              display.viewTo += lendiff;
            } else {
              resetView(cm);
            }
          } else if (to >= display.viewTo) {
            var cut$1 = viewCuttingPoint(cm, from, from, -1);
            if (cut$1) {
              display.view = display.view.slice(0, cut$1.index);
              display.viewTo = cut$1.lineN;
            } else {
              resetView(cm);
            }
          } else {
            var cutTop = viewCuttingPoint(cm, from, from, -1);
            var cutBot = viewCuttingPoint(cm, to, to + lendiff, 1);
            if (cutTop && cutBot) {
              display.view = display.view.slice(0, cutTop.index).concat(buildViewArray(cm, cutTop.lineN, cutBot.lineN)).concat(display.view.slice(cutBot.index));
              display.viewTo += lendiff;
            } else {
              resetView(cm);
            }
          }
          var ext = display.externalMeasured;
          if (ext) {
            if (to < ext.lineN) {
              ext.lineN += lendiff;
            } else if (from < ext.lineN + ext.size) {
              display.externalMeasured = null;
            }
          }
        }
        function regLineChange(cm, line, type) {
          cm.curOp.viewChanged = true;
          var display = cm.display, ext = cm.display.externalMeasured;
          if (ext && line >= ext.lineN && line < ext.lineN + ext.size) {
            display.externalMeasured = null;
          }
          if (line < display.viewFrom || line >= display.viewTo) {
            return;
          }
          var lineView = display.view[findViewIndex(cm, line)];
          if (lineView.node == null) {
            return;
          }
          var arr = lineView.changes || (lineView.changes = []);
          if (indexOf(arr, type) == -1) {
            arr.push(type);
          }
        }
        function resetView(cm) {
          cm.display.viewFrom = cm.display.viewTo = cm.doc.first;
          cm.display.view = [];
          cm.display.viewOffset = 0;
        }
        function viewCuttingPoint(cm, oldN, newN, dir) {
          var index2 = findViewIndex(cm, oldN), diff, view = cm.display.view;
          if (!sawCollapsedSpans || newN == cm.doc.first + cm.doc.size) {
            return { index: index2, lineN: newN };
          }
          var n3 = cm.display.viewFrom;
          for (var i4 = 0; i4 < index2; i4++) {
            n3 += view[i4].size;
          }
          if (n3 != oldN) {
            if (dir > 0) {
              if (index2 == view.length - 1) {
                return null;
              }
              diff = n3 + view[index2].size - oldN;
              index2++;
            } else {
              diff = n3 - oldN;
            }
            oldN += diff;
            newN += diff;
          }
          while (visualLineNo(cm.doc, newN) != newN) {
            if (index2 == (dir < 0 ? 0 : view.length - 1)) {
              return null;
            }
            newN += dir * view[index2 - (dir < 0 ? 1 : 0)].size;
            index2 += dir;
          }
          return { index: index2, lineN: newN };
        }
        function adjustView(cm, from, to) {
          var display = cm.display, view = display.view;
          if (view.length == 0 || from >= display.viewTo || to <= display.viewFrom) {
            display.view = buildViewArray(cm, from, to);
            display.viewFrom = from;
          } else {
            if (display.viewFrom > from) {
              display.view = buildViewArray(cm, from, display.viewFrom).concat(display.view);
            } else if (display.viewFrom < from) {
              display.view = display.view.slice(findViewIndex(cm, from));
            }
            display.viewFrom = from;
            if (display.viewTo < to) {
              display.view = display.view.concat(buildViewArray(cm, display.viewTo, to));
            } else if (display.viewTo > to) {
              display.view = display.view.slice(0, findViewIndex(cm, to));
            }
          }
          display.viewTo = to;
        }
        function countDirtyView(cm) {
          var view = cm.display.view, dirty = 0;
          for (var i4 = 0; i4 < view.length; i4++) {
            var lineView = view[i4];
            if (!lineView.hidden && (!lineView.node || lineView.changes)) {
              ++dirty;
            }
          }
          return dirty;
        }
        function updateSelection(cm) {
          cm.display.input.showSelection(cm.display.input.prepareSelection());
        }
        function prepareSelection(cm, primary) {
          if (primary === void 0)
            primary = true;
          var doc = cm.doc, result = {};
          var curFragment = result.cursors = document.createDocumentFragment();
          var selFragment = result.selection = document.createDocumentFragment();
          for (var i4 = 0; i4 < doc.sel.ranges.length; i4++) {
            if (!primary && i4 == doc.sel.primIndex) {
              continue;
            }
            var range3 = doc.sel.ranges[i4];
            if (range3.from().line >= cm.display.viewTo || range3.to().line < cm.display.viewFrom) {
              continue;
            }
            var collapsed = range3.empty();
            if (collapsed || cm.options.showCursorWhenSelecting) {
              drawSelectionCursor(cm, range3.head, curFragment);
            }
            if (!collapsed) {
              drawSelectionRange(cm, range3, selFragment);
            }
          }
          return result;
        }
        function drawSelectionCursor(cm, head, output) {
          var pos = cursorCoords(cm, head, "div", null, null, !cm.options.singleCursorHeightPerLine);
          var cursor = output.appendChild(elt("div", "\xA0", "CodeMirror-cursor"));
          cursor.style.left = pos.left + "px";
          cursor.style.top = pos.top + "px";
          cursor.style.height = Math.max(0, pos.bottom - pos.top) * cm.options.cursorHeight + "px";
          if (pos.other) {
            var otherCursor = output.appendChild(elt("div", "\xA0", "CodeMirror-cursor CodeMirror-secondarycursor"));
            otherCursor.style.display = "";
            otherCursor.style.left = pos.other.left + "px";
            otherCursor.style.top = pos.other.top + "px";
            otherCursor.style.height = (pos.other.bottom - pos.other.top) * 0.85 + "px";
          }
        }
        function cmpCoords(a3, b2) {
          return a3.top - b2.top || a3.left - b2.left;
        }
        function drawSelectionRange(cm, range3, output) {
          var display = cm.display, doc = cm.doc;
          var fragment = document.createDocumentFragment();
          var padding = paddingH(cm.display), leftSide = padding.left;
          var rightSide = Math.max(display.sizerWidth, displayWidth(cm) - display.sizer.offsetLeft) - padding.right;
          var docLTR = doc.direction == "ltr";
          function add2(left, top, width, bottom) {
            if (top < 0) {
              top = 0;
            }
            top = Math.round(top);
            bottom = Math.round(bottom);
            fragment.appendChild(elt("div", null, "CodeMirror-selected", "position: absolute; left: " + left + "px;\n                             top: " + top + "px; width: " + (width == null ? rightSide - left : width) + "px;\n                             height: " + (bottom - top) + "px"));
          }
          function drawForLine(line, fromArg2, toArg2) {
            var lineObj = getLine(doc, line);
            var lineLen = lineObj.text.length;
            var start2, end;
            function coords(ch, bias) {
              return charCoords(cm, Pos(line, ch), "div", lineObj, bias);
            }
            function wrapX(pos, dir, side) {
              var extent = wrappedLineExtentChar(cm, lineObj, null, pos);
              var prop2 = dir == "ltr" == (side == "after") ? "left" : "right";
              var ch = side == "after" ? extent.begin : extent.end - (/\s/.test(lineObj.text.charAt(extent.end - 1)) ? 2 : 1);
              return coords(ch, prop2)[prop2];
            }
            var order = getOrder(lineObj, doc.direction);
            iterateBidiSections(order, fromArg2 || 0, toArg2 == null ? lineLen : toArg2, function(from, to, dir, i4) {
              var ltr = dir == "ltr";
              var fromPos = coords(from, ltr ? "left" : "right");
              var toPos = coords(to - 1, ltr ? "right" : "left");
              var openStart = fromArg2 == null && from == 0, openEnd = toArg2 == null && to == lineLen;
              var first = i4 == 0, last = !order || i4 == order.length - 1;
              if (toPos.top - fromPos.top <= 3) {
                var openLeft = (docLTR ? openStart : openEnd) && first;
                var openRight = (docLTR ? openEnd : openStart) && last;
                var left = openLeft ? leftSide : (ltr ? fromPos : toPos).left;
                var right = openRight ? rightSide : (ltr ? toPos : fromPos).right;
                add2(left, fromPos.top, right - left, fromPos.bottom);
              } else {
                var topLeft, topRight, botLeft, botRight;
                if (ltr) {
                  topLeft = docLTR && openStart && first ? leftSide : fromPos.left;
                  topRight = docLTR ? rightSide : wrapX(from, dir, "before");
                  botLeft = docLTR ? leftSide : wrapX(to, dir, "after");
                  botRight = docLTR && openEnd && last ? rightSide : toPos.right;
                } else {
                  topLeft = !docLTR ? leftSide : wrapX(from, dir, "before");
                  topRight = !docLTR && openStart && first ? rightSide : fromPos.right;
                  botLeft = !docLTR && openEnd && last ? leftSide : toPos.left;
                  botRight = !docLTR ? rightSide : wrapX(to, dir, "after");
                }
                add2(topLeft, fromPos.top, topRight - topLeft, fromPos.bottom);
                if (fromPos.bottom < toPos.top) {
                  add2(leftSide, fromPos.bottom, null, toPos.top);
                }
                add2(botLeft, toPos.top, botRight - botLeft, toPos.bottom);
              }
              if (!start2 || cmpCoords(fromPos, start2) < 0) {
                start2 = fromPos;
              }
              if (cmpCoords(toPos, start2) < 0) {
                start2 = toPos;
              }
              if (!end || cmpCoords(fromPos, end) < 0) {
                end = fromPos;
              }
              if (cmpCoords(toPos, end) < 0) {
                end = toPos;
              }
            });
            return { start: start2, end };
          }
          var sFrom = range3.from(), sTo = range3.to();
          if (sFrom.line == sTo.line) {
            drawForLine(sFrom.line, sFrom.ch, sTo.ch);
          } else {
            var fromLine = getLine(doc, sFrom.line), toLine = getLine(doc, sTo.line);
            var singleVLine = visualLine(fromLine) == visualLine(toLine);
            var leftEnd = drawForLine(sFrom.line, sFrom.ch, singleVLine ? fromLine.text.length + 1 : null).end;
            var fromArg = singleVLine ? 0 : null;
            var toArg = sTo.ch;
            var rightStart;
            if (fromArg === null && toArg === 0) {
              rightStart = charCoords(cm, Pos(sTo.line, sTo.ch), "div");
            } else {
              rightStart = drawForLine(sTo.line, singleVLine ? 0 : null, sTo.ch).start;
              if (singleVLine) {
                if (leftEnd.top < rightStart.top - 2) {
                  add2(leftEnd.right, leftEnd.top, null, leftEnd.bottom);
                  add2(leftSide, rightStart.top, rightStart.left, rightStart.bottom);
                } else {
                  add2(leftEnd.right, leftEnd.top, rightStart.left - leftEnd.right, leftEnd.bottom);
                }
              }
            }
            if (leftEnd.bottom < rightStart.top) {
              add2(leftSide, leftEnd.bottom, null, rightStart.top);
            }
          }
          output.appendChild(fragment);
        }
        function restartBlink(cm) {
          if (!cm.state.focused) {
            return;
          }
          var display = cm.display;
          clearInterval(display.blinker);
          var on2 = true;
          display.cursorDiv.style.visibility = "";
          if (cm.options.cursorBlinkRate > 0) {
            display.blinker = setInterval(function() {
              return display.cursorDiv.style.visibility = (on2 = !on2) ? "" : "hidden";
            }, cm.options.cursorBlinkRate);
          } else if (cm.options.cursorBlinkRate < 0) {
            display.cursorDiv.style.visibility = "hidden";
          }
        }
        function ensureFocus(cm) {
          if (!cm.state.focused) {
            cm.display.input.focus();
            onFocus(cm);
          }
        }
        function delayBlurEvent(cm) {
          cm.state.delayingBlurEvent = true;
          setTimeout(function() {
            if (cm.state.delayingBlurEvent) {
              cm.state.delayingBlurEvent = false;
              onBlur(cm);
            }
          }, 100);
        }
        function onFocus(cm, e5) {
          if (cm.state.delayingBlurEvent) {
            cm.state.delayingBlurEvent = false;
          }
          if (cm.options.readOnly == "nocursor") {
            return;
          }
          if (!cm.state.focused) {
            signal(cm, "focus", cm, e5);
            cm.state.focused = true;
            addClass2(cm.display.wrapper, "CodeMirror-focused");
            if (!cm.curOp && cm.display.selForContextMenu != cm.doc.sel) {
              cm.display.input.reset();
              if (webkit) {
                setTimeout(function() {
                  return cm.display.input.reset(true);
                }, 20);
              }
            }
            cm.display.input.receivedFocus();
          }
          restartBlink(cm);
        }
        function onBlur(cm, e5) {
          if (cm.state.delayingBlurEvent) {
            return;
          }
          if (cm.state.focused) {
            signal(cm, "blur", cm, e5);
            cm.state.focused = false;
            rmClass(cm.display.wrapper, "CodeMirror-focused");
          }
          clearInterval(cm.display.blinker);
          setTimeout(function() {
            if (!cm.state.focused) {
              cm.display.shift = false;
            }
          }, 150);
        }
        function updateHeightInViewport(cm, view, height) {
          var display = cm.display;
          var diff = view.line.height - height;
          if (height < 2) {
            height = textHeight(display);
          }
          if (diff > 5e-3 || diff < -5e-3) {
            updateLineHeight(view.line, height);
            updateWidgetHeight(view.line);
            if (view.rest) {
              for (var j3 = 0; j3 < view.rest.length; j3++) {
                updateWidgetHeight(view.rest[j3]);
              }
            }
          }
        }
        function updateHeightsInViewport(cm) {
          var display = cm.display;
          var prevBottom = display.lineDiv.offsetTop;
          var prev;
          for (var i4 = 0; i4 < display.view.length; i4++) {
            var cur = display.view[i4];
            var width = 0;
            if (cur.hidden) {
              continue;
            }
            var offsetTop = cur.node.offsetTop;
            var offsetHeight = cur.node.offsetHeight;
            var offsetBottom = offsetTop + offsetHeight;
            var gap = offsetTop - prevBottom;
            if (gap) {
              updateHeightInViewport(cm, prev, prev.line.height + gap);
            }
            updateHeightInViewport(cm, cur, offsetHeight);
            prevBottom = offsetBottom;
            prev = cur;
            if (width > cm.display.sizerWidth) {
              var chWidth = Math.ceil(width / charWidth(cm.display));
              if (chWidth > cm.display.maxLineLength) {
                cm.display.maxLineLength = chWidth;
                cm.display.maxLine = cur.line;
                cm.display.maxLineChanged = true;
              }
            }
          }
        }
        function updateWidgetHeight(line) {
          if (line.widgets) {
            for (var i4 = 0; i4 < line.widgets.length; ++i4) {
              var each = line.widgets[i4];
              if (each.overlay) {
                each.height = 0;
              } else {
                each.height = each.node.offsetHeight;
              }
            }
          }
        }
        function visibleLines(display, doc, viewport) {
          var top = viewport && viewport.top != null ? Math.max(0, viewport.top) : display.scroller.scrollTop;
          top = Math.floor(top - paddingTop(display));
          var bottom = viewport && viewport.bottom != null ? viewport.bottom : top + display.wrapper.clientHeight;
          var from = lineAtHeight(doc, top), to = lineAtHeight(doc, bottom);
          if (viewport && viewport.ensure) {
            var ensureFrom = viewport.ensure.from.line, ensureTo = viewport.ensure.to.line;
            if (ensureFrom < from) {
              from = ensureFrom;
              to = lineAtHeight(doc, heightAtLine(getLine(doc, ensureFrom)) + display.wrapper.clientHeight);
            } else if (Math.min(ensureTo, doc.lastLine()) >= to) {
              from = lineAtHeight(doc, heightAtLine(getLine(doc, ensureTo)) - display.wrapper.clientHeight);
              to = ensureTo;
            }
          }
          return { from, to: Math.max(to, from + 1) };
        }
        function maybeScrollWindow(cm, rect) {
          if (signalDOMEvent(cm, "scrollCursorIntoView")) {
            return;
          }
          var display = cm.display, box = display.sizer.getBoundingClientRect(), doScroll = null;
          if (rect.top + box.top < 0) {
            doScroll = true;
          } else if (rect.bottom + box.top > (window.innerHeight || document.documentElement.clientHeight)) {
            doScroll = false;
          }
          if (doScroll != null && !phantom) {
            var scrollNode = elt("div", "\u200B", null, "position: absolute;\n                         top: " + (rect.top - display.viewOffset - paddingTop(cm.display)) + "px;\n                         height: " + (rect.bottom - rect.top + scrollGap(cm) + display.barHeight) + "px;\n                         left: " + rect.left + "px; width: " + Math.max(2, rect.right - rect.left) + "px;");
            cm.display.lineSpace.appendChild(scrollNode);
            scrollNode.scrollIntoView(doScroll);
            cm.display.lineSpace.removeChild(scrollNode);
          }
        }
        function scrollPosIntoView(cm, pos, end, topMargin, bottomMargin) {
          if (topMargin == null) {
            topMargin = 0;
          }
          if (bottomMargin == null) {
            bottomMargin = 0;
          }
          var rect;
          if (!cm.options.lineWrapping && pos == end) {
            pos = pos.ch ? Pos(pos.line, pos.sticky == "before" ? pos.ch - 1 : pos.ch, "after") : pos;
            end = pos.sticky == "before" ? Pos(pos.line, pos.ch + 1, "before") : pos;
          }
          for (var limit = 0; limit < 5; limit++) {
            var changed = false;
            var coords = cursorCoords(cm, pos);
            var endCoords = !end || end == pos ? coords : cursorCoords(cm, end);
            rect = {
              left: Math.min(coords.left, endCoords.left),
              top: Math.min(coords.top, endCoords.top) - topMargin,
              right: Math.max(coords.left, endCoords.left),
              bottom: Math.max(coords.bottom, endCoords.bottom) + bottomMargin
            };
            var scrollPos = calculateScrollPos(cm, rect);
            var startTop = cm.doc.scrollTop, startLeft = cm.doc.scrollLeft;
            if (scrollPos.scrollTop != null) {
              updateScrollTop(cm, scrollPos.scrollTop);
              if (Math.abs(cm.doc.scrollTop - startTop) > 1) {
                changed = true;
              }
            }
            if (scrollPos.scrollLeft != null) {
              setScrollLeft(cm, scrollPos.scrollLeft);
              if (Math.abs(cm.doc.scrollLeft - startLeft) > 1) {
                changed = true;
              }
            }
            if (!changed) {
              break;
            }
          }
          return rect;
        }
        function scrollIntoView(cm, rect) {
          var scrollPos = calculateScrollPos(cm, rect);
          if (scrollPos.scrollTop != null) {
            updateScrollTop(cm, scrollPos.scrollTop);
          }
          if (scrollPos.scrollLeft != null) {
            setScrollLeft(cm, scrollPos.scrollLeft);
          }
        }
        function calculateScrollPos(cm, rect) {
          var display = cm.display, snapMargin = textHeight$1(cm.display);
          if (rect.top < 0) {
            rect.top = 0;
          }
          var screentop = cm.curOp && cm.curOp.scrollTop != null ? cm.curOp.scrollTop : display.scroller.scrollTop;
          var screen2 = displayHeight(cm), result = {};
          if (rect.bottom - rect.top > screen2) {
            rect.bottom = rect.top + screen2;
          }
          var docBottom = cm.doc.height + paddingVert(display);
          var atTop = rect.top < snapMargin, atBottom = rect.bottom > docBottom - snapMargin;
          if (rect.top < screentop) {
            result.scrollTop = atTop ? 0 : rect.top;
          } else if (rect.bottom > screentop + screen2) {
            var newTop = Math.min(rect.top, (atBottom ? docBottom : rect.bottom) - screen2);
            if (newTop != screentop) {
              result.scrollTop = newTop;
            }
          }
          var screenleft = cm.curOp && cm.curOp.scrollLeft != null ? cm.curOp.scrollLeft : display.scroller.scrollLeft;
          var screenw = displayWidth(cm) - (cm.options.fixedGutter ? display.gutters.offsetWidth : 0);
          var tooWide = rect.right - rect.left > screenw;
          if (tooWide) {
            rect.right = rect.left + screenw;
          }
          if (rect.left < 10) {
            result.scrollLeft = 0;
          } else if (rect.left < screenleft) {
            result.scrollLeft = Math.max(0, rect.left - (tooWide ? 0 : 10));
          } else if (rect.right > screenw + screenleft - 3) {
            result.scrollLeft = rect.right + (tooWide ? 0 : 10) - screenw;
          }
          return result;
        }
        function addToScrollTop(cm, top) {
          if (top == null) {
            return;
          }
          resolveScrollToPos(cm);
          cm.curOp.scrollTop = (cm.curOp.scrollTop == null ? cm.doc.scrollTop : cm.curOp.scrollTop) + top;
        }
        function ensureCursorVisible(cm) {
          resolveScrollToPos(cm);
          var cur = cm.getCursor();
          cm.curOp.scrollToPos = { from: cur, to: cur, margin: cm.options.cursorScrollMargin };
        }
        function scrollToCoords(cm, x3, y2) {
          if (x3 != null || y2 != null) {
            resolveScrollToPos(cm);
          }
          if (x3 != null) {
            cm.curOp.scrollLeft = x3;
          }
          if (y2 != null) {
            cm.curOp.scrollTop = y2;
          }
        }
        function scrollToRange(cm, range3) {
          resolveScrollToPos(cm);
          cm.curOp.scrollToPos = range3;
        }
        function resolveScrollToPos(cm) {
          var range3 = cm.curOp.scrollToPos;
          if (range3) {
            cm.curOp.scrollToPos = null;
            var from = estimateCoords(cm, range3.from), to = estimateCoords(cm, range3.to);
            scrollToCoordsRange(cm, from, to, range3.topMargin, range3.bottomMargin);
          }
        }
        function scrollToCoordsRange(cm, from, to, topMargin, bottomMargin) {
          var sPos = calculateScrollPos(cm, {
            left: Math.min(from.left, to.left),
            top: Math.min(from.top, to.top) - topMargin,
            right: Math.max(from.right, to.right),
            bottom: Math.max(from.bottom, to.bottom) + bottomMargin
          });
          scrollToCoords(cm, sPos.scrollLeft, sPos.scrollTop);
        }
        function updateScrollTop(cm, val) {
          if (Math.abs(cm.doc.scrollTop - val) < 2) {
            return;
          }
          if (!gecko) {
            updateDisplaySimple(cm, { top: val });
          }
          setScrollTop(cm, val, true);
          if (gecko) {
            updateDisplaySimple(cm);
          }
          startWorker(cm, 100);
        }
        function setScrollTop(cm, val, forceScroll) {
          val = Math.max(0, Math.min(cm.display.scroller.scrollHeight - cm.display.scroller.clientHeight, val));
          if (cm.display.scroller.scrollTop == val && !forceScroll) {
            return;
          }
          cm.doc.scrollTop = val;
          cm.display.scrollbars.setScrollTop(val);
          if (cm.display.scroller.scrollTop != val) {
            cm.display.scroller.scrollTop = val;
          }
        }
        function setScrollLeft(cm, val, isScroller, forceScroll) {
          val = Math.max(0, Math.min(val, cm.display.scroller.scrollWidth - cm.display.scroller.clientWidth));
          if ((isScroller ? val == cm.doc.scrollLeft : Math.abs(cm.doc.scrollLeft - val) < 2) && !forceScroll) {
            return;
          }
          cm.doc.scrollLeft = val;
          alignHorizontally(cm);
          if (cm.display.scroller.scrollLeft != val) {
            cm.display.scroller.scrollLeft = val;
          }
          cm.display.scrollbars.setScrollLeft(val);
        }
        function measureForScrollbars(cm) {
          var d4 = cm.display, gutterW = d4.gutters.offsetWidth;
          var docH = Math.round(cm.doc.height + paddingVert(cm.display));
          return {
            clientHeight: d4.scroller.clientHeight,
            viewHeight: d4.wrapper.clientHeight,
            scrollWidth: d4.scroller.scrollWidth,
            clientWidth: d4.scroller.clientWidth,
            viewWidth: d4.wrapper.clientWidth,
            barLeft: cm.options.fixedGutter ? gutterW : 0,
            docHeight: docH,
            scrollHeight: docH + scrollGap(cm) + d4.barHeight,
            nativeBarWidth: d4.nativeBarWidth,
            gutterWidth: gutterW
          };
        }
        var NativeScrollbars = function(place, scroll, cm) {
          this.cm = cm;
          var vert = this.vert = elt("div", [elt("div", null, null, "min-width: 1px")], "CodeMirror-vscrollbar");
          var horiz = this.horiz = elt("div", [elt("div", null, null, "height: 100%; min-height: 1px")], "CodeMirror-hscrollbar");
          vert.tabIndex = horiz.tabIndex = -1;
          place(vert);
          place(horiz);
          on(vert, "scroll", function() {
            if (vert.clientHeight) {
              scroll(vert.scrollTop, "vertical");
            }
          });
          on(horiz, "scroll", function() {
            if (horiz.clientWidth) {
              scroll(horiz.scrollLeft, "horizontal");
            }
          });
          this.checkedZeroWidth = false;
          if (ie && ie_version < 8) {
            this.horiz.style.minHeight = this.vert.style.minWidth = "18px";
          }
        };
        NativeScrollbars.prototype.update = function(measure) {
          var needsH = measure.scrollWidth > measure.clientWidth + 1;
          var needsV = measure.scrollHeight > measure.clientHeight + 1;
          var sWidth = measure.nativeBarWidth;
          if (needsV) {
            this.vert.style.display = "block";
            this.vert.style.bottom = needsH ? sWidth + "px" : "0";
            var totalHeight = measure.viewHeight - (needsH ? sWidth : 0);
            this.vert.firstChild.style.height = Math.max(0, measure.scrollHeight - measure.clientHeight + totalHeight) + "px";
          } else {
            this.vert.style.display = "";
            this.vert.firstChild.style.height = "0";
          }
          if (needsH) {
            this.horiz.style.display = "block";
            this.horiz.style.right = needsV ? sWidth + "px" : "0";
            this.horiz.style.left = measure.barLeft + "px";
            var totalWidth = measure.viewWidth - measure.barLeft - (needsV ? sWidth : 0);
            this.horiz.firstChild.style.width = Math.max(0, measure.scrollWidth - measure.clientWidth + totalWidth) + "px";
          } else {
            this.horiz.style.display = "";
            this.horiz.firstChild.style.width = "0";
          }
          if (!this.checkedZeroWidth && measure.clientHeight > 0) {
            if (sWidth == 0) {
              this.zeroWidthHack();
            }
            this.checkedZeroWidth = true;
          }
          return { right: needsV ? sWidth : 0, bottom: needsH ? sWidth : 0 };
        };
        NativeScrollbars.prototype.setScrollLeft = function(pos) {
          if (this.horiz.scrollLeft != pos) {
            this.horiz.scrollLeft = pos;
          }
          if (this.disableHoriz) {
            this.enableZeroWidthBar(this.horiz, this.disableHoriz, "horiz");
          }
        };
        NativeScrollbars.prototype.setScrollTop = function(pos) {
          if (this.vert.scrollTop != pos) {
            this.vert.scrollTop = pos;
          }
          if (this.disableVert) {
            this.enableZeroWidthBar(this.vert, this.disableVert, "vert");
          }
        };
        NativeScrollbars.prototype.zeroWidthHack = function() {
          var w3 = mac && !mac_geMountainLion ? "12px" : "18px";
          this.horiz.style.height = this.vert.style.width = w3;
          this.horiz.style.pointerEvents = this.vert.style.pointerEvents = "none";
          this.disableHoriz = new Delayed();
          this.disableVert = new Delayed();
        };
        NativeScrollbars.prototype.enableZeroWidthBar = function(bar, delay, type) {
          bar.style.pointerEvents = "auto";
          function maybeDisable() {
            var box = bar.getBoundingClientRect();
            var elt2 = type == "vert" ? document.elementFromPoint(box.right - 1, (box.top + box.bottom) / 2) : document.elementFromPoint((box.right + box.left) / 2, box.bottom - 1);
            if (elt2 != bar) {
              bar.style.pointerEvents = "none";
            } else {
              delay.set(1e3, maybeDisable);
            }
          }
          delay.set(1e3, maybeDisable);
        };
        NativeScrollbars.prototype.clear = function() {
          var parent = this.horiz.parentNode;
          parent.removeChild(this.horiz);
          parent.removeChild(this.vert);
        };
        var NullScrollbars = function() {
        };
        NullScrollbars.prototype.update = function() {
          return { bottom: 0, right: 0 };
        };
        NullScrollbars.prototype.setScrollLeft = function() {
        };
        NullScrollbars.prototype.setScrollTop = function() {
        };
        NullScrollbars.prototype.clear = function() {
        };
        function updateScrollbars(cm, measure) {
          if (!measure) {
            measure = measureForScrollbars(cm);
          }
          var startWidth = cm.display.barWidth, startHeight = cm.display.barHeight;
          updateScrollbarsInner(cm, measure);
          for (var i4 = 0; i4 < 4 && startWidth != cm.display.barWidth || startHeight != cm.display.barHeight; i4++) {
            if (startWidth != cm.display.barWidth && cm.options.lineWrapping) {
              updateHeightsInViewport(cm);
            }
            updateScrollbarsInner(cm, measureForScrollbars(cm));
            startWidth = cm.display.barWidth;
            startHeight = cm.display.barHeight;
          }
        }
        function updateScrollbarsInner(cm, measure) {
          var d4 = cm.display;
          var sizes = d4.scrollbars.update(measure);
          d4.sizer.style.paddingRight = (d4.barWidth = sizes.right) + "px";
          d4.sizer.style.paddingBottom = (d4.barHeight = sizes.bottom) + "px";
          d4.heightForcer.style.borderBottom = sizes.bottom + "px solid transparent";
          if (sizes.right && sizes.bottom) {
            d4.scrollbarFiller.style.display = "block";
            d4.scrollbarFiller.style.height = sizes.bottom + "px";
            d4.scrollbarFiller.style.width = sizes.right + "px";
          } else {
            d4.scrollbarFiller.style.display = "";
          }
          if (sizes.bottom && cm.options.coverGutterNextToScrollbar && cm.options.fixedGutter) {
            d4.gutterFiller.style.display = "block";
            d4.gutterFiller.style.height = sizes.bottom + "px";
            d4.gutterFiller.style.width = measure.gutterWidth + "px";
          } else {
            d4.gutterFiller.style.display = "";
          }
        }
        var scrollbarModel = { "native": NativeScrollbars, "null": NullScrollbars };
        function initScrollbars(cm) {
          if (cm.display.scrollbars) {
            cm.display.scrollbars.clear();
            if (cm.display.scrollbars.addClass) {
              rmClass(cm.display.wrapper, cm.display.scrollbars.addClass);
            }
          }
          cm.display.scrollbars = new scrollbarModel[cm.options.scrollbarStyle](function(node) {
            cm.display.wrapper.insertBefore(node, cm.display.scrollbarFiller);
            on(node, "mousedown", function() {
              if (cm.state.focused) {
                setTimeout(function() {
                  return cm.display.input.focus();
                }, 0);
              }
            });
            node.setAttribute("cm-not-content", "true");
          }, function(pos, axis) {
            if (axis == "horizontal") {
              setScrollLeft(cm, pos);
            } else {
              updateScrollTop(cm, pos);
            }
          }, cm);
          if (cm.display.scrollbars.addClass) {
            addClass2(cm.display.wrapper, cm.display.scrollbars.addClass);
          }
        }
        var nextOpId = 0;
        function startOperation(cm) {
          cm.curOp = {
            cm,
            viewChanged: false,
            startHeight: cm.doc.height,
            forceUpdate: false,
            updateInput: 0,
            typing: false,
            changeObjs: null,
            cursorActivityHandlers: null,
            cursorActivityCalled: 0,
            selectionChanged: false,
            updateMaxLine: false,
            scrollLeft: null,
            scrollTop: null,
            scrollToPos: null,
            focus: false,
            id: ++nextOpId
          };
          pushOperation(cm.curOp);
        }
        function endOperation(cm) {
          signal(cm, "willEndOperation", cm);
          var op = cm.curOp;
          if (op) {
            finishOperation(op, function(group) {
              for (var i4 = 0; i4 < group.ops.length; i4++) {
                group.ops[i4].cm.curOp = null;
              }
              endOperations(group);
            });
          }
        }
        function endOperations(group) {
          var ops = group.ops;
          for (var i4 = 0; i4 < ops.length; i4++) {
            endOperation_R1(ops[i4]);
          }
          for (var i$12 = 0; i$12 < ops.length; i$12++) {
            endOperation_W1(ops[i$12]);
          }
          for (var i$22 = 0; i$22 < ops.length; i$22++) {
            endOperation_R2(ops[i$22]);
          }
          for (var i$3 = 0; i$3 < ops.length; i$3++) {
            endOperation_W2(ops[i$3]);
          }
          for (var i$4 = 0; i$4 < ops.length; i$4++) {
            endOperation_finish(ops[i$4]);
          }
        }
        function endOperation_R1(op) {
          var cm = op.cm, display = cm.display;
          maybeClipScrollbars(cm);
          if (op.updateMaxLine) {
            findMaxLine(cm);
          }
          op.mustUpdate = op.viewChanged || op.forceUpdate || op.scrollTop != null || op.scrollToPos && (op.scrollToPos.from.line < display.viewFrom || op.scrollToPos.to.line >= display.viewTo) || display.maxLineChanged && cm.options.lineWrapping;
          op.update = op.mustUpdate && new DisplayUpdate(cm, op.mustUpdate && { top: op.scrollTop, ensure: op.scrollToPos }, op.forceUpdate);
        }
        function endOperation_W1(op) {
          op.updatedDisplay = op.mustUpdate && updateDisplayIfNeeded(op.cm, op.update);
        }
        function endOperation_R2(op) {
          var cm = op.cm, display = cm.display;
          if (op.updatedDisplay) {
            updateHeightsInViewport(cm);
          }
          op.barMeasure = measureForScrollbars(cm);
          if (display.maxLineChanged && !cm.options.lineWrapping) {
            op.adjustWidthTo = measureChar(cm, display.maxLine, display.maxLine.text.length).left + 3;
            cm.display.sizerWidth = op.adjustWidthTo;
            op.barMeasure.scrollWidth = Math.max(display.scroller.clientWidth, display.sizer.offsetLeft + op.adjustWidthTo + scrollGap(cm) + cm.display.barWidth);
            op.maxScrollLeft = Math.max(0, display.sizer.offsetLeft + op.adjustWidthTo - displayWidth(cm));
          }
          if (op.updatedDisplay || op.selectionChanged) {
            op.preparedSelection = display.input.prepareSelection();
          }
        }
        function endOperation_W2(op) {
          var cm = op.cm;
          if (op.adjustWidthTo != null) {
            cm.display.sizer.style.minWidth = op.adjustWidthTo + "px";
            if (op.maxScrollLeft < cm.doc.scrollLeft) {
              setScrollLeft(cm, Math.min(cm.display.scroller.scrollLeft, op.maxScrollLeft), true);
            }
            cm.display.maxLineChanged = false;
          }
          var takeFocus = op.focus && op.focus == activeElt();
          if (op.preparedSelection) {
            cm.display.input.showSelection(op.preparedSelection, takeFocus);
          }
          if (op.updatedDisplay || op.startHeight != cm.doc.height) {
            updateScrollbars(cm, op.barMeasure);
          }
          if (op.updatedDisplay) {
            setDocumentHeight(cm, op.barMeasure);
          }
          if (op.selectionChanged) {
            restartBlink(cm);
          }
          if (cm.state.focused && op.updateInput) {
            cm.display.input.reset(op.typing);
          }
          if (takeFocus) {
            ensureFocus(op.cm);
          }
        }
        function endOperation_finish(op) {
          var cm = op.cm, display = cm.display, doc = cm.doc;
          if (op.updatedDisplay) {
            postUpdateDisplay(cm, op.update);
          }
          if (display.wheelStartX != null && (op.scrollTop != null || op.scrollLeft != null || op.scrollToPos)) {
            display.wheelStartX = display.wheelStartY = null;
          }
          if (op.scrollTop != null) {
            setScrollTop(cm, op.scrollTop, op.forceScroll);
          }
          if (op.scrollLeft != null) {
            setScrollLeft(cm, op.scrollLeft, true, true);
          }
          if (op.scrollToPos) {
            var rect = scrollPosIntoView(cm, clipPos(doc, op.scrollToPos.from), clipPos(doc, op.scrollToPos.to), op.scrollToPos.topMargin, op.scrollToPos.bottomMargin);
            maybeScrollWindow(cm, rect);
          }
          var hidden = op.maybeHiddenMarkers, unhidden = op.maybeUnhiddenMarkers;
          if (hidden) {
            for (var i4 = 0; i4 < hidden.length; ++i4) {
              if (!hidden[i4].lines.length) {
                signal(hidden[i4], "hide");
              }
            }
          }
          if (unhidden) {
            for (var i$12 = 0; i$12 < unhidden.length; ++i$12) {
              if (unhidden[i$12].lines.length) {
                signal(unhidden[i$12], "unhide");
              }
            }
          }
          if (display.wrapper.offsetHeight) {
            doc.scrollTop = cm.display.scroller.scrollTop;
          }
          if (op.changeObjs) {
            signal(cm, "changes", cm, op.changeObjs);
          }
          if (op.update) {
            op.update.finish();
          }
        }
        function runInOp(cm, f3) {
          if (cm.curOp) {
            return f3();
          }
          startOperation(cm);
          try {
            return f3();
          } finally {
            endOperation(cm);
          }
        }
        function operation(cm, f3) {
          return function() {
            if (cm.curOp) {
              return f3.apply(cm, arguments);
            }
            startOperation(cm);
            try {
              return f3.apply(cm, arguments);
            } finally {
              endOperation(cm);
            }
          };
        }
        function methodOp(f3) {
          return function() {
            if (this.curOp) {
              return f3.apply(this, arguments);
            }
            startOperation(this);
            try {
              return f3.apply(this, arguments);
            } finally {
              endOperation(this);
            }
          };
        }
        function docMethodOp(f3) {
          return function() {
            var cm = this.cm;
            if (!cm || cm.curOp) {
              return f3.apply(this, arguments);
            }
            startOperation(cm);
            try {
              return f3.apply(this, arguments);
            } finally {
              endOperation(cm);
            }
          };
        }
        function startWorker(cm, time) {
          if (cm.doc.highlightFrontier < cm.display.viewTo) {
            cm.state.highlight.set(time, bind(highlightWorker, cm));
          }
        }
        function highlightWorker(cm) {
          var doc = cm.doc;
          if (doc.highlightFrontier >= cm.display.viewTo) {
            return;
          }
          var end = +new Date() + cm.options.workTime;
          var context = getContextBefore(cm, doc.highlightFrontier);
          var changedLines = [];
          doc.iter(context.line, Math.min(doc.first + doc.size, cm.display.viewTo + 500), function(line) {
            if (context.line >= cm.display.viewFrom) {
              var oldStyles = line.styles;
              var resetState = line.text.length > cm.options.maxHighlightLength ? copyState2(doc.mode, context.state) : null;
              var highlighted = highlightLine(cm, line, context, true);
              if (resetState) {
                context.state = resetState;
              }
              line.styles = highlighted.styles;
              var oldCls = line.styleClasses, newCls = highlighted.classes;
              if (newCls) {
                line.styleClasses = newCls;
              } else if (oldCls) {
                line.styleClasses = null;
              }
              var ischange = !oldStyles || oldStyles.length != line.styles.length || oldCls != newCls && (!oldCls || !newCls || oldCls.bgClass != newCls.bgClass || oldCls.textClass != newCls.textClass);
              for (var i4 = 0; !ischange && i4 < oldStyles.length; ++i4) {
                ischange = oldStyles[i4] != line.styles[i4];
              }
              if (ischange) {
                changedLines.push(context.line);
              }
              line.stateAfter = context.save();
              context.nextLine();
            } else {
              if (line.text.length <= cm.options.maxHighlightLength) {
                processLine(cm, line.text, context);
              }
              line.stateAfter = context.line % 5 == 0 ? context.save() : null;
              context.nextLine();
            }
            if (+new Date() > end) {
              startWorker(cm, cm.options.workDelay);
              return true;
            }
          });
          doc.highlightFrontier = context.line;
          doc.modeFrontier = Math.max(doc.modeFrontier, context.line);
          if (changedLines.length) {
            runInOp(cm, function() {
              for (var i4 = 0; i4 < changedLines.length; i4++) {
                regLineChange(cm, changedLines[i4], "text");
              }
            });
          }
        }
        var DisplayUpdate = function(cm, viewport, force) {
          var display = cm.display;
          this.viewport = viewport;
          this.visible = visibleLines(display, cm.doc, viewport);
          this.positionLineWidgets = display.positionLineWidgets = [];
          this.editorIsHidden = !display.wrapper.offsetWidth;
          this.wrapperHeight = display.wrapper.clientHeight;
          this.wrapperWidth = display.wrapper.clientWidth;
          this.oldDisplayWidth = displayWidth(cm);
          this.force = force;
          this.dims = getDimensions(cm);
          this.events = [];
        };
        DisplayUpdate.prototype.signal = function(emitter2, type) {
          if (hasHandler(emitter2, type)) {
            this.events.push(arguments);
          }
        };
        DisplayUpdate.prototype.finish = function() {
          for (var i4 = 0; i4 < this.events.length; i4++) {
            signal.apply(null, this.events[i4]);
          }
        };
        function maybeClipScrollbars(cm) {
          var display = cm.display;
          if (!display.scrollbarsClipped && display.scroller.offsetWidth) {
            display.nativeBarWidth = display.scroller.offsetWidth - display.scroller.clientWidth;
            display.heightForcer.style.height = scrollGap(cm) + "px";
            display.sizer.style.marginBottom = -display.nativeBarWidth + "px";
            display.sizer.style.borderRightWidth = scrollGap(cm) + "px";
            display.scrollbarsClipped = true;
          }
        }
        function selectionSnapshot(cm) {
          if (cm.hasFocus()) {
            return null;
          }
          var active = activeElt();
          if (!active || !contains3(cm.display.lineDiv, active)) {
            return null;
          }
          var result = { activeElt: active };
          if (window.getSelection) {
            var sel = window.getSelection();
            if (sel.anchorNode && sel.extend && contains3(cm.display.lineDiv, sel.anchorNode)) {
              result.anchorNode = sel.anchorNode;
              result.anchorOffset = sel.anchorOffset;
              result.focusNode = sel.focusNode;
              result.focusOffset = sel.focusOffset;
            }
          }
          return result;
        }
        function restoreSelection(snapshot) {
          if (!snapshot || !snapshot.activeElt || snapshot.activeElt == activeElt()) {
            return;
          }
          snapshot.activeElt.focus();
          if (!/^(INPUT|TEXTAREA)$/.test(snapshot.activeElt.nodeName) && snapshot.anchorNode && contains3(document.body, snapshot.anchorNode) && contains3(document.body, snapshot.focusNode)) {
            var sel = window.getSelection(), range3 = document.createRange();
            range3.setEnd(snapshot.anchorNode, snapshot.anchorOffset);
            range3.collapse(false);
            sel.removeAllRanges();
            sel.addRange(range3);
            sel.extend(snapshot.focusNode, snapshot.focusOffset);
          }
        }
        function updateDisplayIfNeeded(cm, update) {
          var display = cm.display, doc = cm.doc;
          if (update.editorIsHidden) {
            resetView(cm);
            return false;
          }
          if (!update.force && update.visible.from >= display.viewFrom && update.visible.to <= display.viewTo && (display.updateLineNumbers == null || display.updateLineNumbers >= display.viewTo) && display.renderedView == display.view && countDirtyView(cm) == 0) {
            return false;
          }
          if (maybeUpdateLineNumberWidth(cm)) {
            resetView(cm);
            update.dims = getDimensions(cm);
          }
          var end = doc.first + doc.size;
          var from = Math.max(update.visible.from - cm.options.viewportMargin, doc.first);
          var to = Math.min(end, update.visible.to + cm.options.viewportMargin);
          if (display.viewFrom < from && from - display.viewFrom < 20) {
            from = Math.max(doc.first, display.viewFrom);
          }
          if (display.viewTo > to && display.viewTo - to < 20) {
            to = Math.min(end, display.viewTo);
          }
          if (sawCollapsedSpans) {
            from = visualLineNo(cm.doc, from);
            to = visualLineEndNo(cm.doc, to);
          }
          var different = from != display.viewFrom || to != display.viewTo || display.lastWrapHeight != update.wrapperHeight || display.lastWrapWidth != update.wrapperWidth;
          adjustView(cm, from, to);
          display.viewOffset = heightAtLine(getLine(cm.doc, display.viewFrom));
          cm.display.mover.style.top = display.viewOffset + "px";
          var toUpdate = countDirtyView(cm);
          if (!different && toUpdate == 0 && !update.force && display.renderedView == display.view && (display.updateLineNumbers == null || display.updateLineNumbers >= display.viewTo)) {
            return false;
          }
          var selSnapshot = selectionSnapshot(cm);
          if (toUpdate > 4) {
            display.lineDiv.style.display = "none";
          }
          patchDisplay(cm, display.updateLineNumbers, update.dims);
          if (toUpdate > 4) {
            display.lineDiv.style.display = "";
          }
          display.renderedView = display.view;
          restoreSelection(selSnapshot);
          removeChildren(display.cursorDiv);
          removeChildren(display.selectionDiv);
          display.gutters.style.height = display.sizer.style.minHeight = 0;
          if (different) {
            display.lastWrapHeight = update.wrapperHeight;
            display.lastWrapWidth = update.wrapperWidth;
            startWorker(cm, 400);
          }
          var positionedWidgets = [], widgetWrapper;
          var positionLineWidgets = display.positionLineWidgets || [];
          for (var i4 = 0; i4 < positionLineWidgets.length; i4++) {
            widgetWrapper = positionLineWidgets[i4].widget.node.parentNode;
            positionedWidgets.push({
              widgetWrapper,
              position: positionLineWidgets[i4].widget.positionWidget(widgetWrapper.offsetWidth, widgetWrapper.offsetHeight)
            });
          }
          for (var i4 = 0; i4 < positionedWidgets.length; i4++) {
            var position = positionedWidgets[i4].position;
            widgetWrapper = positionedWidgets[i4].widgetWrapper;
            if (position.top) {
              widgetWrapper.style.top = position.top;
            }
            if (position.bottom) {
              widgetWrapper.style.bottom = position.bottom;
            }
            if (position.left) {
              widgetWrapper.style.left = position.left;
            }
            if (position.right) {
              widgetWrapper.style.right = position.right;
            }
            if (position.marginLeft) {
              widgetWrapper.style.marginLeft = position.marginLeft;
            }
            if (position.marginRight) {
              widgetWrapper.style.marginRight = position.marginRight;
            }
          }
          display.positionLineWidgets = null;
          display.updateLineNumbers = null;
          return true;
        }
        function postUpdateDisplay(cm, update) {
          var viewport = update.viewport;
          for (var first = true; ; first = false) {
            if (!first || !cm.options.lineWrapping || update.oldDisplayWidth == displayWidth(cm)) {
              if (viewport && viewport.top != null) {
                viewport = { top: Math.min(cm.doc.height + paddingVert(cm.display) - displayHeight(cm), viewport.top) };
              }
              update.visible = visibleLines(cm.display, cm.doc, viewport);
              if (update.visible.from >= cm.display.viewFrom && update.visible.to <= cm.display.viewTo) {
                break;
              }
            } else if (first) {
              update.visible = visibleLines(cm.display, cm.doc, viewport);
            }
            if (!updateDisplayIfNeeded(cm, update)) {
              break;
            }
            updateHeightsInViewport(cm);
            var barMeasure = measureForScrollbars(cm);
            updateSelection(cm);
            updateScrollbars(cm, barMeasure);
            setDocumentHeight(cm, barMeasure);
            update.force = false;
          }
          update.signal(cm, "update", cm);
          if (cm.display.viewFrom != cm.display.reportedViewFrom || cm.display.viewTo != cm.display.reportedViewTo) {
            update.signal(cm, "viewportChange", cm, cm.display.viewFrom, cm.display.viewTo);
            cm.display.reportedViewFrom = cm.display.viewFrom;
            cm.display.reportedViewTo = cm.display.viewTo;
          }
        }
        function updateDisplaySimple(cm, viewport) {
          var update = new DisplayUpdate(cm, viewport);
          if (updateDisplayIfNeeded(cm, update)) {
            updateHeightsInViewport(cm);
            postUpdateDisplay(cm, update);
            var barMeasure = measureForScrollbars(cm);
            updateSelection(cm);
            updateScrollbars(cm, barMeasure);
            setDocumentHeight(cm, barMeasure);
            update.finish();
          }
        }
        function patchDisplay(cm, updateNumbersFrom, dims) {
          var display = cm.display, lineNumbers = cm.options.lineNumbers;
          var container = display.lineDiv, cur = container.firstChild;
          function rm(node2) {
            var next = node2.nextSibling;
            if (webkit && mac && cm.display.currentWheelTarget == node2) {
              node2.style.display = "none";
            } else {
              node2.parentNode.removeChild(node2);
            }
            return next;
          }
          var view = display.view, lineN = display.viewFrom;
          for (var i4 = 0; i4 < view.length; i4++) {
            var lineView = view[i4];
            if (lineView.hidden)
              ;
            else if (!lineView.node || lineView.node.parentNode != container) {
              var node = buildLineElement(cm, lineView, lineN, dims);
              container.insertBefore(node, cur);
            } else {
              while (cur != lineView.node) {
                cur = rm(cur);
              }
              var updateNumber = lineNumbers && updateNumbersFrom != null && updateNumbersFrom <= lineN && lineView.lineNumber;
              if (lineView.changes) {
                if (indexOf(lineView.changes, "gutter") > -1) {
                  updateNumber = false;
                }
                updateLineForChanges(cm, lineView, lineN, dims);
              }
              if (updateNumber) {
                removeChildren(lineView.lineNumber);
                lineView.lineNumber.appendChild(document.createTextNode(lineNumberFor(cm.options, lineN)));
              }
              cur = lineView.node.nextSibling;
            }
            lineN += lineView.size;
          }
          while (cur) {
            cur = rm(cur);
          }
        }
        function updateGutterSpace(display) {
          var width = display.gutters.offsetWidth;
          display.sizer.style.marginLeft = width + "px";
        }
        function setDocumentHeight(cm, measure) {
          cm.display.sizer.style.minHeight = measure.docHeight + "px";
          cm.display.heightForcer.style.top = measure.docHeight + "px";
          cm.display.gutters.style.height = measure.docHeight + cm.display.barHeight + scrollGap(cm) + "px";
        }
        function alignHorizontally(cm) {
          var display = cm.display, view = display.view;
          if (!display.alignWidgets && (!display.gutters.firstChild || !cm.options.fixedGutter)) {
            return;
          }
          var comp = compensateForHScroll(display) - display.scroller.scrollLeft + cm.doc.scrollLeft;
          var gutterW = display.gutters.offsetWidth, left = comp + "px";
          for (var i4 = 0; i4 < view.length; i4++) {
            if (!view[i4].hidden) {
              if (cm.options.fixedGutter) {
                if (view[i4].gutter) {
                  view[i4].gutter.style.left = left;
                }
                if (view[i4].gutterBackground) {
                  view[i4].gutterBackground.style.left = left;
                }
              }
              var align = view[i4].alignable;
              if (align) {
                for (var j3 = 0; j3 < align.length; j3++) {
                  align[j3].style.left = left;
                }
              }
            }
          }
          if (cm.options.fixedGutter) {
            display.gutters.style.left = comp + gutterW + "px";
          }
        }
        function maybeUpdateLineNumberWidth(cm) {
          if (!cm.options.lineNumbers) {
            return false;
          }
          var doc = cm.doc, last = lineNumberFor(cm.options, doc.first + doc.size - 1), display = cm.display;
          if (last.length != display.lineNumChars) {
            var test = display.measure.appendChild(elt("div", [elt("div", last)], "CodeMirror-linenumber CodeMirror-gutter-elt"));
            var innerW = test.firstChild.offsetWidth, padding = test.offsetWidth - innerW;
            display.lineGutter.style.width = "";
            display.lineNumInnerWidth = Math.max(innerW, display.lineGutter.offsetWidth - padding) + 1;
            display.lineNumWidth = display.lineNumInnerWidth + padding;
            display.lineNumChars = display.lineNumInnerWidth ? last.length : -1;
            display.lineGutter.style.width = display.lineNumWidth + "px";
            updateGutterSpace(cm.display);
            return true;
          }
          return false;
        }
        function getGutters(gutters, lineNumbers) {
          var result = [], sawLineNumbers = false;
          for (var i4 = 0; i4 < gutters.length; i4++) {
            var name106 = gutters[i4], style = null;
            if (typeof name106 != "string") {
              style = name106.style;
              name106 = name106.className;
            }
            if (name106 == "CodeMirror-linenumbers") {
              if (!lineNumbers) {
                continue;
              } else {
                sawLineNumbers = true;
              }
            }
            result.push({ className: name106, style });
          }
          if (lineNumbers && !sawLineNumbers) {
            result.push({ className: "CodeMirror-linenumbers", style: null });
          }
          return result;
        }
        function renderGutters(display) {
          var gutters = display.gutters, specs = display.gutterSpecs;
          removeChildren(gutters);
          display.lineGutter = null;
          for (var i4 = 0; i4 < specs.length; ++i4) {
            var ref = specs[i4];
            var className = ref.className;
            var style = ref.style;
            var gElt = gutters.appendChild(elt("div", null, "CodeMirror-gutter " + className));
            if (style) {
              gElt.style.cssText = style;
            }
            if (className == "CodeMirror-linenumbers") {
              display.lineGutter = gElt;
              gElt.style.width = (display.lineNumWidth || 1) + "px";
            }
          }
          gutters.style.display = specs.length ? "" : "none";
          updateGutterSpace(display);
        }
        function updateGutters(cm) {
          renderGutters(cm.display);
          regChange(cm);
          alignHorizontally(cm);
        }
        function Display(place, doc, input, options) {
          var d4 = this;
          this.input = input;
          d4.scrollbarFiller = elt("div", null, "CodeMirror-scrollbar-filler");
          d4.scrollbarFiller.setAttribute("cm-not-content", "true");
          d4.gutterFiller = elt("div", null, "CodeMirror-gutter-filler");
          d4.gutterFiller.setAttribute("cm-not-content", "true");
          d4.lineDiv = eltP("div", null, "CodeMirror-code");
          d4.selectionDiv = elt("div", null, null, "position: relative; z-index: 1");
          d4.cursorDiv = elt("div", null, "CodeMirror-cursors");
          d4.measure = elt("div", null, "CodeMirror-measure");
          d4.lineMeasure = elt("div", null, "CodeMirror-measure");
          d4.lineSpace = eltP("div", [d4.measure, d4.lineMeasure, d4.selectionDiv, d4.cursorDiv, d4.lineDiv], null, "position: relative; outline: none");
          var lines = eltP("div", [d4.lineSpace], "CodeMirror-lines");
          d4.mover = elt("div", [lines], null, "position: relative");
          d4.sizer = elt("div", [d4.mover], "CodeMirror-sizer");
          d4.sizerWidth = null;
          d4.heightForcer = elt("div", null, null, "position: absolute; height: " + scrollerGap + "px; width: 1px;");
          d4.gutters = elt("div", null, "CodeMirror-gutters");
          d4.lineGutter = null;
          d4.scroller = elt("div", [d4.sizer, d4.heightForcer, d4.gutters], "CodeMirror-scroll");
          d4.scroller.setAttribute("tabIndex", "-1");
          d4.wrapper = elt("div", [d4.scrollbarFiller, d4.gutterFiller, d4.scroller], "CodeMirror");
          if (ie && ie_version < 8) {
            d4.gutters.style.zIndex = -1;
            d4.scroller.style.paddingRight = 0;
          }
          if (!webkit && !(gecko && mobile)) {
            d4.scroller.draggable = true;
          }
          if (place) {
            if (place.appendChild) {
              place.appendChild(d4.wrapper);
            } else {
              place(d4.wrapper);
            }
          }
          d4.viewFrom = d4.viewTo = doc.first;
          d4.reportedViewFrom = d4.reportedViewTo = doc.first;
          d4.view = [];
          d4.renderedView = null;
          d4.externalMeasured = null;
          d4.viewOffset = 0;
          d4.lastWrapHeight = d4.lastWrapWidth = 0;
          d4.updateLineNumbers = null;
          d4.nativeBarWidth = d4.barHeight = d4.barWidth = 0;
          d4.scrollbarsClipped = false;
          d4.lineNumWidth = d4.lineNumInnerWidth = d4.lineNumChars = null;
          d4.alignWidgets = false;
          d4.cachedCharWidth = d4.cachedSpaceWidth = d4.cachedTextHeight = d4.cachedPaddingH = null;
          d4.maxLine = null;
          d4.maxLineLength = 0;
          d4.maxLineChanged = false;
          d4.wheelDX = d4.wheelDY = d4.wheelStartX = d4.wheelStartY = null;
          d4.shift = false;
          d4.selForContextMenu = null;
          d4.activeTouch = null;
          d4.gutterSpecs = getGutters(options.gutters, options.lineNumbers);
          renderGutters(d4);
          input.init(d4);
        }
        var wheelSamples = 0, wheelPixelsPerUnit = null;
        if (ie) {
          wheelPixelsPerUnit = -0.53;
        } else if (gecko) {
          wheelPixelsPerUnit = 15;
        } else if (chrome) {
          wheelPixelsPerUnit = -0.7;
        } else if (safari) {
          wheelPixelsPerUnit = -1 / 3;
        }
        function wheelEventDelta(e5) {
          var dx = e5.wheelDeltaX, dy = e5.wheelDeltaY;
          if (dx == null && e5.detail && e5.axis == e5.HORIZONTAL_AXIS) {
            dx = e5.detail;
          }
          if (dy == null && e5.detail && e5.axis == e5.VERTICAL_AXIS) {
            dy = e5.detail;
          } else if (dy == null) {
            dy = e5.wheelDelta;
          }
          return { x: dx, y: dy };
        }
        function wheelEventPixels(e5) {
          var delta = wheelEventDelta(e5);
          delta.x *= wheelPixelsPerUnit;
          delta.y *= wheelPixelsPerUnit;
          return delta;
        }
        function onScrollWheel(cm, e5) {
          var delta = wheelEventDelta(e5), dx = delta.x, dy = delta.y;
          var display = cm.display, scroll = display.scroller;
          var canScrollX = scroll.scrollWidth > scroll.clientWidth;
          var canScrollY = scroll.scrollHeight > scroll.clientHeight;
          if (!(dx && canScrollX || dy && canScrollY)) {
            return;
          }
          if (dy && mac && webkit) {
            outer:
              for (var cur = e5.target, view = display.view; cur != scroll; cur = cur.parentNode) {
                for (var i4 = 0; i4 < view.length; i4++) {
                  if (view[i4].node == cur) {
                    cm.display.currentWheelTarget = cur;
                    break outer;
                  }
                }
              }
          }
          if (dx && !gecko && !presto && wheelPixelsPerUnit != null) {
            if (dy && canScrollY) {
              updateScrollTop(cm, Math.max(0, scroll.scrollTop + dy * wheelPixelsPerUnit));
            }
            setScrollLeft(cm, Math.max(0, scroll.scrollLeft + dx * wheelPixelsPerUnit));
            if (!dy || dy && canScrollY) {
              e_preventDefault(e5);
            }
            display.wheelStartX = null;
            return;
          }
          if (dy && wheelPixelsPerUnit != null) {
            var pixels = dy * wheelPixelsPerUnit;
            var top = cm.doc.scrollTop, bot = top + display.wrapper.clientHeight;
            if (pixels < 0) {
              top = Math.max(0, top + pixels - 50);
            } else {
              bot = Math.min(cm.doc.height, bot + pixels + 50);
            }
            updateDisplaySimple(cm, { top, bottom: bot });
          }
          if (wheelSamples < 20) {
            if (display.wheelStartX == null) {
              display.wheelStartX = scroll.scrollLeft;
              display.wheelStartY = scroll.scrollTop;
              display.wheelDX = dx;
              display.wheelDY = dy;
              setTimeout(function() {
                if (display.wheelStartX == null) {
                  return;
                }
                var movedX = scroll.scrollLeft - display.wheelStartX;
                var movedY = scroll.scrollTop - display.wheelStartY;
                var sample = movedY && display.wheelDY && movedY / display.wheelDY || movedX && display.wheelDX && movedX / display.wheelDX;
                display.wheelStartX = display.wheelStartY = null;
                if (!sample) {
                  return;
                }
                wheelPixelsPerUnit = (wheelPixelsPerUnit * wheelSamples + sample) / (wheelSamples + 1);
                ++wheelSamples;
              }, 200);
            } else {
              display.wheelDX += dx;
              display.wheelDY += dy;
            }
          }
        }
        var Selection4 = function(ranges, primIndex) {
          this.ranges = ranges;
          this.primIndex = primIndex;
        };
        Selection4.prototype.primary = function() {
          return this.ranges[this.primIndex];
        };
        Selection4.prototype.equals = function(other) {
          if (other == this) {
            return true;
          }
          if (other.primIndex != this.primIndex || other.ranges.length != this.ranges.length) {
            return false;
          }
          for (var i4 = 0; i4 < this.ranges.length; i4++) {
            var here = this.ranges[i4], there = other.ranges[i4];
            if (!equalCursorPos(here.anchor, there.anchor) || !equalCursorPos(here.head, there.head)) {
              return false;
            }
          }
          return true;
        };
        Selection4.prototype.deepCopy = function() {
          var out = [];
          for (var i4 = 0; i4 < this.ranges.length; i4++) {
            out[i4] = new Range3(copyPos(this.ranges[i4].anchor), copyPos(this.ranges[i4].head));
          }
          return new Selection4(out, this.primIndex);
        };
        Selection4.prototype.somethingSelected = function() {
          for (var i4 = 0; i4 < this.ranges.length; i4++) {
            if (!this.ranges[i4].empty()) {
              return true;
            }
          }
          return false;
        };
        Selection4.prototype.contains = function(pos, end) {
          if (!end) {
            end = pos;
          }
          for (var i4 = 0; i4 < this.ranges.length; i4++) {
            var range3 = this.ranges[i4];
            if (cmp(end, range3.from()) >= 0 && cmp(pos, range3.to()) <= 0) {
              return i4;
            }
          }
          return -1;
        };
        var Range3 = function(anchor, head) {
          this.anchor = anchor;
          this.head = head;
        };
        Range3.prototype.from = function() {
          return minPos(this.anchor, this.head);
        };
        Range3.prototype.to = function() {
          return maxPos(this.anchor, this.head);
        };
        Range3.prototype.empty = function() {
          return this.head.line == this.anchor.line && this.head.ch == this.anchor.ch;
        };
        function normalizeSelection(cm, ranges, primIndex) {
          var mayTouch = cm && cm.options.selectionsMayTouch;
          var prim = ranges[primIndex];
          ranges.sort(function(a3, b2) {
            return cmp(a3.from(), b2.from());
          });
          primIndex = indexOf(ranges, prim);
          for (var i4 = 1; i4 < ranges.length; i4++) {
            var cur = ranges[i4], prev = ranges[i4 - 1];
            var diff = cmp(prev.to(), cur.from());
            if (mayTouch && !cur.empty() ? diff > 0 : diff >= 0) {
              var from = minPos(prev.from(), cur.from()), to = maxPos(prev.to(), cur.to());
              var inv = prev.empty() ? cur.from() == cur.head : prev.from() == prev.head;
              if (i4 <= primIndex) {
                --primIndex;
              }
              ranges.splice(--i4, 2, new Range3(inv ? to : from, inv ? from : to));
            }
          }
          return new Selection4(ranges, primIndex);
        }
        function simpleSelection(anchor, head) {
          return new Selection4([new Range3(anchor, head || anchor)], 0);
        }
        function changeEnd(change) {
          if (!change.text) {
            return change.to;
          }
          return Pos(change.from.line + change.text.length - 1, lst(change.text).length + (change.text.length == 1 ? change.from.ch : 0));
        }
        function adjustForChange(pos, change) {
          if (cmp(pos, change.from) < 0) {
            return pos;
          }
          if (cmp(pos, change.to) <= 0) {
            return changeEnd(change);
          }
          var line = pos.line + change.text.length - (change.to.line - change.from.line) - 1, ch = pos.ch;
          if (pos.line == change.to.line) {
            ch += changeEnd(change).ch - change.to.ch;
          }
          return Pos(line, ch);
        }
        function computeSelAfterChange(doc, change) {
          var out = [];
          for (var i4 = 0; i4 < doc.sel.ranges.length; i4++) {
            var range3 = doc.sel.ranges[i4];
            out.push(new Range3(adjustForChange(range3.anchor, change), adjustForChange(range3.head, change)));
          }
          return normalizeSelection(doc.cm, out, doc.sel.primIndex);
        }
        function offsetPos(pos, old, nw) {
          if (pos.line == old.line) {
            return Pos(nw.line, pos.ch - old.ch + nw.ch);
          } else {
            return Pos(nw.line + (pos.line - old.line), pos.ch);
          }
        }
        function computeReplacedSel(doc, changes, hint) {
          var out = [];
          var oldPrev = Pos(doc.first, 0), newPrev = oldPrev;
          for (var i4 = 0; i4 < changes.length; i4++) {
            var change = changes[i4];
            var from = offsetPos(change.from, oldPrev, newPrev);
            var to = offsetPos(changeEnd(change), oldPrev, newPrev);
            oldPrev = change.to;
            newPrev = to;
            if (hint == "around") {
              var range3 = doc.sel.ranges[i4], inv = cmp(range3.head, range3.anchor) < 0;
              out[i4] = new Range3(inv ? to : from, inv ? from : to);
            } else {
              out[i4] = new Range3(from, from);
            }
          }
          return new Selection4(out, doc.sel.primIndex);
        }
        function loadMode(cm) {
          cm.doc.mode = getMode2(cm.options, cm.doc.modeOption);
          resetModeState(cm);
        }
        function resetModeState(cm) {
          cm.doc.iter(function(line) {
            if (line.stateAfter) {
              line.stateAfter = null;
            }
            if (line.styles) {
              line.styles = null;
            }
          });
          cm.doc.modeFrontier = cm.doc.highlightFrontier = cm.doc.first;
          startWorker(cm, 100);
          cm.state.modeGen++;
          if (cm.curOp) {
            regChange(cm);
          }
        }
        function isWholeLineUpdate(doc, change) {
          return change.from.ch == 0 && change.to.ch == 0 && lst(change.text) == "" && (!doc.cm || doc.cm.options.wholeLineUpdateBefore);
        }
        function updateDoc(doc, change, markedSpans, estimateHeight2) {
          function spansFor(n3) {
            return markedSpans ? markedSpans[n3] : null;
          }
          function update(line, text2, spans) {
            updateLine(line, text2, spans, estimateHeight2);
            signalLater(line, "change", line, change);
          }
          function linesFor(start2, end) {
            var result = [];
            for (var i4 = start2; i4 < end; ++i4) {
              result.push(new Line(text[i4], spansFor(i4), estimateHeight2));
            }
            return result;
          }
          var from = change.from, to = change.to, text = change.text;
          var firstLine = getLine(doc, from.line), lastLine = getLine(doc, to.line);
          var lastText = lst(text), lastSpans = spansFor(text.length - 1), nlines = to.line - from.line;
          if (change.full) {
            doc.insert(0, linesFor(0, text.length));
            doc.remove(text.length, doc.size - text.length);
          } else if (isWholeLineUpdate(doc, change)) {
            var added = linesFor(0, text.length - 1);
            update(lastLine, lastLine.text, lastSpans);
            if (nlines) {
              doc.remove(from.line, nlines);
            }
            if (added.length) {
              doc.insert(from.line, added);
            }
          } else if (firstLine == lastLine) {
            if (text.length == 1) {
              update(firstLine, firstLine.text.slice(0, from.ch) + lastText + firstLine.text.slice(to.ch), lastSpans);
            } else {
              var added$1 = linesFor(1, text.length - 1);
              added$1.push(new Line(lastText + firstLine.text.slice(to.ch), lastSpans, estimateHeight2));
              update(firstLine, firstLine.text.slice(0, from.ch) + text[0], spansFor(0));
              doc.insert(from.line + 1, added$1);
            }
          } else if (text.length == 1) {
            update(firstLine, firstLine.text.slice(0, from.ch) + text[0] + lastLine.text.slice(to.ch), spansFor(0));
            doc.remove(from.line + 1, nlines);
          } else {
            update(firstLine, firstLine.text.slice(0, from.ch) + text[0], spansFor(0));
            update(lastLine, lastText + lastLine.text.slice(to.ch), lastSpans);
            var added$2 = linesFor(1, text.length - 1);
            if (nlines > 1) {
              doc.remove(from.line + 1, nlines - 1);
            }
            doc.insert(from.line + 1, added$2);
          }
          signalLater(doc, "change", doc, change);
        }
        function linkedDocs(doc, f3, sharedHistOnly) {
          function propagate(doc2, skip, sharedHist) {
            if (doc2.linked) {
              for (var i4 = 0; i4 < doc2.linked.length; ++i4) {
                var rel = doc2.linked[i4];
                if (rel.doc == skip) {
                  continue;
                }
                var shared = sharedHist && rel.sharedHist;
                if (sharedHistOnly && !shared) {
                  continue;
                }
                f3(rel.doc, shared);
                propagate(rel.doc, doc2, shared);
              }
            }
          }
          propagate(doc, null, true);
        }
        function attachDoc(cm, doc) {
          if (doc.cm) {
            throw new Error("This document is already in use.");
          }
          cm.doc = doc;
          doc.cm = cm;
          estimateLineHeights(cm);
          loadMode(cm);
          setDirectionClass(cm);
          if (!cm.options.lineWrapping) {
            findMaxLine(cm);
          }
          cm.options.mode = doc.modeOption;
          regChange(cm);
        }
        function setDirectionClass(cm) {
          (cm.doc.direction == "rtl" ? addClass2 : rmClass)(cm.display.lineDiv, "CodeMirror-rtl");
        }
        function directionChanged(cm) {
          runInOp(cm, function() {
            setDirectionClass(cm);
            regChange(cm);
          });
        }
        function History(startGen) {
          this.done = [];
          this.undone = [];
          this.undoDepth = Infinity;
          this.lastModTime = this.lastSelTime = 0;
          this.lastOp = this.lastSelOp = null;
          this.lastOrigin = this.lastSelOrigin = null;
          this.generation = this.maxGeneration = startGen || 1;
        }
        function historyChangeFromChange(doc, change) {
          var histChange = { from: copyPos(change.from), to: changeEnd(change), text: getBetween(doc, change.from, change.to) };
          attachLocalSpans(doc, histChange, change.from.line, change.to.line + 1);
          linkedDocs(doc, function(doc2) {
            return attachLocalSpans(doc2, histChange, change.from.line, change.to.line + 1);
          }, true);
          return histChange;
        }
        function clearSelectionEvents(array) {
          while (array.length) {
            var last = lst(array);
            if (last.ranges) {
              array.pop();
            } else {
              break;
            }
          }
        }
        function lastChangeEvent(hist, force) {
          if (force) {
            clearSelectionEvents(hist.done);
            return lst(hist.done);
          } else if (hist.done.length && !lst(hist.done).ranges) {
            return lst(hist.done);
          } else if (hist.done.length > 1 && !hist.done[hist.done.length - 2].ranges) {
            hist.done.pop();
            return lst(hist.done);
          }
        }
        function addChangeToHistory(doc, change, selAfter, opId) {
          var hist = doc.history;
          hist.undone.length = 0;
          var time = +new Date(), cur;
          var last;
          if ((hist.lastOp == opId || hist.lastOrigin == change.origin && change.origin && (change.origin.charAt(0) == "+" && hist.lastModTime > time - (doc.cm ? doc.cm.options.historyEventDelay : 500) || change.origin.charAt(0) == "*")) && (cur = lastChangeEvent(hist, hist.lastOp == opId))) {
            last = lst(cur.changes);
            if (cmp(change.from, change.to) == 0 && cmp(change.from, last.to) == 0) {
              last.to = changeEnd(change);
            } else {
              cur.changes.push(historyChangeFromChange(doc, change));
            }
          } else {
            var before = lst(hist.done);
            if (!before || !before.ranges) {
              pushSelectionToHistory(doc.sel, hist.done);
            }
            cur = {
              changes: [historyChangeFromChange(doc, change)],
              generation: hist.generation
            };
            hist.done.push(cur);
            while (hist.done.length > hist.undoDepth) {
              hist.done.shift();
              if (!hist.done[0].ranges) {
                hist.done.shift();
              }
            }
          }
          hist.done.push(selAfter);
          hist.generation = ++hist.maxGeneration;
          hist.lastModTime = hist.lastSelTime = time;
          hist.lastOp = hist.lastSelOp = opId;
          hist.lastOrigin = hist.lastSelOrigin = change.origin;
          if (!last) {
            signal(doc, "historyAdded");
          }
        }
        function selectionEventCanBeMerged(doc, origin, prev, sel) {
          var ch = origin.charAt(0);
          return ch == "*" || ch == "+" && prev.ranges.length == sel.ranges.length && prev.somethingSelected() == sel.somethingSelected() && new Date() - doc.history.lastSelTime <= (doc.cm ? doc.cm.options.historyEventDelay : 500);
        }
        function addSelectionToHistory(doc, sel, opId, options) {
          var hist = doc.history, origin = options && options.origin;
          if (opId == hist.lastSelOp || origin && hist.lastSelOrigin == origin && (hist.lastModTime == hist.lastSelTime && hist.lastOrigin == origin || selectionEventCanBeMerged(doc, origin, lst(hist.done), sel))) {
            hist.done[hist.done.length - 1] = sel;
          } else {
            pushSelectionToHistory(sel, hist.done);
          }
          hist.lastSelTime = +new Date();
          hist.lastSelOrigin = origin;
          hist.lastSelOp = opId;
          if (options && options.clearRedo !== false) {
            clearSelectionEvents(hist.undone);
          }
        }
        function pushSelectionToHistory(sel, dest) {
          var top = lst(dest);
          if (!(top && top.ranges && top.equals(sel))) {
            dest.push(sel);
          }
        }
        function attachLocalSpans(doc, change, from, to) {
          var existing = change["spans_" + doc.id], n3 = 0;
          doc.iter(Math.max(doc.first, from), Math.min(doc.first + doc.size, to), function(line) {
            if (line.markedSpans) {
              (existing || (existing = change["spans_" + doc.id] = {}))[n3] = line.markedSpans;
            }
            ++n3;
          });
        }
        function removeClearedSpans(spans) {
          if (!spans) {
            return null;
          }
          var out;
          for (var i4 = 0; i4 < spans.length; ++i4) {
            if (spans[i4].marker.explicitlyCleared) {
              if (!out) {
                out = spans.slice(0, i4);
              }
            } else if (out) {
              out.push(spans[i4]);
            }
          }
          return !out ? spans : out.length ? out : null;
        }
        function getOldSpans(doc, change) {
          var found = change["spans_" + doc.id];
          if (!found) {
            return null;
          }
          var nw = [];
          for (var i4 = 0; i4 < change.text.length; ++i4) {
            nw.push(removeClearedSpans(found[i4]));
          }
          return nw;
        }
        function mergeOldSpans(doc, change) {
          var old = getOldSpans(doc, change);
          var stretched = stretchSpansOverChange(doc, change);
          if (!old) {
            return stretched;
          }
          if (!stretched) {
            return old;
          }
          for (var i4 = 0; i4 < old.length; ++i4) {
            var oldCur = old[i4], stretchCur = stretched[i4];
            if (oldCur && stretchCur) {
              spans:
                for (var j3 = 0; j3 < stretchCur.length; ++j3) {
                  var span = stretchCur[j3];
                  for (var k3 = 0; k3 < oldCur.length; ++k3) {
                    if (oldCur[k3].marker == span.marker) {
                      continue spans;
                    }
                  }
                  oldCur.push(span);
                }
            } else if (stretchCur) {
              old[i4] = stretchCur;
            }
          }
          return old;
        }
        function copyHistoryArray(events, newGroup, instantiateSel) {
          var copy2 = [];
          for (var i4 = 0; i4 < events.length; ++i4) {
            var event2 = events[i4];
            if (event2.ranges) {
              copy2.push(instantiateSel ? Selection4.prototype.deepCopy.call(event2) : event2);
              continue;
            }
            var changes = event2.changes, newChanges = [];
            copy2.push({ changes: newChanges });
            for (var j3 = 0; j3 < changes.length; ++j3) {
              var change = changes[j3], m3 = void 0;
              newChanges.push({ from: change.from, to: change.to, text: change.text });
              if (newGroup) {
                for (var prop2 in change) {
                  if (m3 = prop2.match(/^spans_(\d+)$/)) {
                    if (indexOf(newGroup, Number(m3[1])) > -1) {
                      lst(newChanges)[prop2] = change[prop2];
                      delete change[prop2];
                    }
                  }
                }
              }
            }
          }
          return copy2;
        }
        function extendRange(range3, head, other, extend2) {
          if (extend2) {
            var anchor = range3.anchor;
            if (other) {
              var posBefore = cmp(head, anchor) < 0;
              if (posBefore != cmp(other, anchor) < 0) {
                anchor = head;
                head = other;
              } else if (posBefore != cmp(head, other) < 0) {
                head = other;
              }
            }
            return new Range3(anchor, head);
          } else {
            return new Range3(other || head, head);
          }
        }
        function extendSelection(doc, head, other, options, extend2) {
          if (extend2 == null) {
            extend2 = doc.cm && (doc.cm.display.shift || doc.extend);
          }
          setSelection(doc, new Selection4([extendRange(doc.sel.primary(), head, other, extend2)], 0), options);
        }
        function extendSelections(doc, heads, options) {
          var out = [];
          var extend2 = doc.cm && (doc.cm.display.shift || doc.extend);
          for (var i4 = 0; i4 < doc.sel.ranges.length; i4++) {
            out[i4] = extendRange(doc.sel.ranges[i4], heads[i4], null, extend2);
          }
          var newSel = normalizeSelection(doc.cm, out, doc.sel.primIndex);
          setSelection(doc, newSel, options);
        }
        function replaceOneSelection(doc, i4, range3, options) {
          var ranges = doc.sel.ranges.slice(0);
          ranges[i4] = range3;
          setSelection(doc, normalizeSelection(doc.cm, ranges, doc.sel.primIndex), options);
        }
        function setSimpleSelection(doc, anchor, head, options) {
          setSelection(doc, simpleSelection(anchor, head), options);
        }
        function filterSelectionChange(doc, sel, options) {
          var obj = {
            ranges: sel.ranges,
            update: function(ranges) {
              this.ranges = [];
              for (var i4 = 0; i4 < ranges.length; i4++) {
                this.ranges[i4] = new Range3(clipPos(doc, ranges[i4].anchor), clipPos(doc, ranges[i4].head));
              }
            },
            origin: options && options.origin
          };
          signal(doc, "beforeSelectionChange", doc, obj);
          if (doc.cm) {
            signal(doc.cm, "beforeSelectionChange", doc.cm, obj);
          }
          if (obj.ranges != sel.ranges) {
            return normalizeSelection(doc.cm, obj.ranges, obj.ranges.length - 1);
          } else {
            return sel;
          }
        }
        function setSelectionReplaceHistory(doc, sel, options) {
          var done = doc.history.done, last = lst(done);
          if (last && last.ranges) {
            done[done.length - 1] = sel;
            setSelectionNoUndo(doc, sel, options);
          } else {
            setSelection(doc, sel, options);
          }
        }
        function setSelection(doc, sel, options) {
          setSelectionNoUndo(doc, sel, options);
          addSelectionToHistory(doc, doc.sel, doc.cm ? doc.cm.curOp.id : NaN, options);
        }
        function setSelectionNoUndo(doc, sel, options) {
          if (hasHandler(doc, "beforeSelectionChange") || doc.cm && hasHandler(doc.cm, "beforeSelectionChange")) {
            sel = filterSelectionChange(doc, sel, options);
          }
          var bias = options && options.bias || (cmp(sel.primary().head, doc.sel.primary().head) < 0 ? -1 : 1);
          setSelectionInner(doc, skipAtomicInSelection(doc, sel, bias, true));
          if (!(options && options.scroll === false) && doc.cm) {
            ensureCursorVisible(doc.cm);
          }
        }
        function setSelectionInner(doc, sel) {
          if (sel.equals(doc.sel)) {
            return;
          }
          doc.sel = sel;
          if (doc.cm) {
            doc.cm.curOp.updateInput = 1;
            doc.cm.curOp.selectionChanged = true;
            signalCursorActivity(doc.cm);
          }
          signalLater(doc, "cursorActivity", doc);
        }
        function reCheckSelection(doc) {
          setSelectionInner(doc, skipAtomicInSelection(doc, doc.sel, null, false));
        }
        function skipAtomicInSelection(doc, sel, bias, mayClear) {
          var out;
          for (var i4 = 0; i4 < sel.ranges.length; i4++) {
            var range3 = sel.ranges[i4];
            var old = sel.ranges.length == doc.sel.ranges.length && doc.sel.ranges[i4];
            var newAnchor = skipAtomic(doc, range3.anchor, old && old.anchor, bias, mayClear);
            var newHead = skipAtomic(doc, range3.head, old && old.head, bias, mayClear);
            if (out || newAnchor != range3.anchor || newHead != range3.head) {
              if (!out) {
                out = sel.ranges.slice(0, i4);
              }
              out[i4] = new Range3(newAnchor, newHead);
            }
          }
          return out ? normalizeSelection(doc.cm, out, sel.primIndex) : sel;
        }
        function skipAtomicInner(doc, pos, oldPos, dir, mayClear) {
          var line = getLine(doc, pos.line);
          if (line.markedSpans) {
            for (var i4 = 0; i4 < line.markedSpans.length; ++i4) {
              var sp = line.markedSpans[i4], m3 = sp.marker;
              var preventCursorLeft = "selectLeft" in m3 ? !m3.selectLeft : m3.inclusiveLeft;
              var preventCursorRight = "selectRight" in m3 ? !m3.selectRight : m3.inclusiveRight;
              if ((sp.from == null || (preventCursorLeft ? sp.from <= pos.ch : sp.from < pos.ch)) && (sp.to == null || (preventCursorRight ? sp.to >= pos.ch : sp.to > pos.ch))) {
                if (mayClear) {
                  signal(m3, "beforeCursorEnter");
                  if (m3.explicitlyCleared) {
                    if (!line.markedSpans) {
                      break;
                    } else {
                      --i4;
                      continue;
                    }
                  }
                }
                if (!m3.atomic) {
                  continue;
                }
                if (oldPos) {
                  var near = m3.find(dir < 0 ? 1 : -1), diff = void 0;
                  if (dir < 0 ? preventCursorRight : preventCursorLeft) {
                    near = movePos(doc, near, -dir, near && near.line == pos.line ? line : null);
                  }
                  if (near && near.line == pos.line && (diff = cmp(near, oldPos)) && (dir < 0 ? diff < 0 : diff > 0)) {
                    return skipAtomicInner(doc, near, pos, dir, mayClear);
                  }
                }
                var far = m3.find(dir < 0 ? -1 : 1);
                if (dir < 0 ? preventCursorLeft : preventCursorRight) {
                  far = movePos(doc, far, dir, far.line == pos.line ? line : null);
                }
                return far ? skipAtomicInner(doc, far, pos, dir, mayClear) : null;
              }
            }
          }
          return pos;
        }
        function skipAtomic(doc, pos, oldPos, bias, mayClear) {
          var dir = bias || 1;
          var found = skipAtomicInner(doc, pos, oldPos, dir, mayClear) || !mayClear && skipAtomicInner(doc, pos, oldPos, dir, true) || skipAtomicInner(doc, pos, oldPos, -dir, mayClear) || !mayClear && skipAtomicInner(doc, pos, oldPos, -dir, true);
          if (!found) {
            doc.cantEdit = true;
            return Pos(doc.first, 0);
          }
          return found;
        }
        function movePos(doc, pos, dir, line) {
          if (dir < 0 && pos.ch == 0) {
            if (pos.line > doc.first) {
              return clipPos(doc, Pos(pos.line - 1));
            } else {
              return null;
            }
          } else if (dir > 0 && pos.ch == (line || getLine(doc, pos.line)).text.length) {
            if (pos.line < doc.first + doc.size - 1) {
              return Pos(pos.line + 1, 0);
            } else {
              return null;
            }
          } else {
            return new Pos(pos.line, pos.ch + dir);
          }
        }
        function selectAll(cm) {
          cm.setSelection(Pos(cm.firstLine(), 0), Pos(cm.lastLine()), sel_dontScroll);
        }
        function filterChange(doc, change, update) {
          var obj = {
            canceled: false,
            from: change.from,
            to: change.to,
            text: change.text,
            origin: change.origin,
            cancel: function() {
              return obj.canceled = true;
            }
          };
          if (update) {
            obj.update = function(from, to, text, origin) {
              if (from) {
                obj.from = clipPos(doc, from);
              }
              if (to) {
                obj.to = clipPos(doc, to);
              }
              if (text) {
                obj.text = text;
              }
              if (origin !== void 0) {
                obj.origin = origin;
              }
            };
          }
          signal(doc, "beforeChange", doc, obj);
          if (doc.cm) {
            signal(doc.cm, "beforeChange", doc.cm, obj);
          }
          if (obj.canceled) {
            if (doc.cm) {
              doc.cm.curOp.updateInput = 2;
            }
            return null;
          }
          return { from: obj.from, to: obj.to, text: obj.text, origin: obj.origin };
        }
        function makeChange(doc, change, ignoreReadOnly) {
          if (doc.cm) {
            if (!doc.cm.curOp) {
              return operation(doc.cm, makeChange)(doc, change, ignoreReadOnly);
            }
            if (doc.cm.state.suppressEdits) {
              return;
            }
          }
          if (hasHandler(doc, "beforeChange") || doc.cm && hasHandler(doc.cm, "beforeChange")) {
            change = filterChange(doc, change, true);
            if (!change) {
              return;
            }
          }
          var split = sawReadOnlySpans && !ignoreReadOnly && removeReadOnlyRanges(doc, change.from, change.to);
          if (split) {
            for (var i4 = split.length - 1; i4 >= 0; --i4) {
              makeChangeInner(doc, { from: split[i4].from, to: split[i4].to, text: i4 ? [""] : change.text, origin: change.origin });
            }
          } else {
            makeChangeInner(doc, change);
          }
        }
        function makeChangeInner(doc, change) {
          if (change.text.length == 1 && change.text[0] == "" && cmp(change.from, change.to) == 0) {
            return;
          }
          var selAfter = computeSelAfterChange(doc, change);
          addChangeToHistory(doc, change, selAfter, doc.cm ? doc.cm.curOp.id : NaN);
          makeChangeSingleDoc(doc, change, selAfter, stretchSpansOverChange(doc, change));
          var rebased = [];
          linkedDocs(doc, function(doc2, sharedHist) {
            if (!sharedHist && indexOf(rebased, doc2.history) == -1) {
              rebaseHist(doc2.history, change);
              rebased.push(doc2.history);
            }
            makeChangeSingleDoc(doc2, change, null, stretchSpansOverChange(doc2, change));
          });
        }
        function makeChangeFromHistory(doc, type, allowSelectionOnly) {
          var suppress = doc.cm && doc.cm.state.suppressEdits;
          if (suppress && !allowSelectionOnly) {
            return;
          }
          var hist = doc.history, event2, selAfter = doc.sel;
          var source = type == "undo" ? hist.done : hist.undone, dest = type == "undo" ? hist.undone : hist.done;
          var i4 = 0;
          for (; i4 < source.length; i4++) {
            event2 = source[i4];
            if (allowSelectionOnly ? event2.ranges && !event2.equals(doc.sel) : !event2.ranges) {
              break;
            }
          }
          if (i4 == source.length) {
            return;
          }
          hist.lastOrigin = hist.lastSelOrigin = null;
          for (; ; ) {
            event2 = source.pop();
            if (event2.ranges) {
              pushSelectionToHistory(event2, dest);
              if (allowSelectionOnly && !event2.equals(doc.sel)) {
                setSelection(doc, event2, { clearRedo: false });
                return;
              }
              selAfter = event2;
            } else if (suppress) {
              source.push(event2);
              return;
            } else {
              break;
            }
          }
          var antiChanges = [];
          pushSelectionToHistory(selAfter, dest);
          dest.push({ changes: antiChanges, generation: hist.generation });
          hist.generation = event2.generation || ++hist.maxGeneration;
          var filter3 = hasHandler(doc, "beforeChange") || doc.cm && hasHandler(doc.cm, "beforeChange");
          var loop = function(i5) {
            var change = event2.changes[i5];
            change.origin = type;
            if (filter3 && !filterChange(doc, change, false)) {
              source.length = 0;
              return {};
            }
            antiChanges.push(historyChangeFromChange(doc, change));
            var after = i5 ? computeSelAfterChange(doc, change) : lst(source);
            makeChangeSingleDoc(doc, change, after, mergeOldSpans(doc, change));
            if (!i5 && doc.cm) {
              doc.cm.scrollIntoView({ from: change.from, to: changeEnd(change) });
            }
            var rebased = [];
            linkedDocs(doc, function(doc2, sharedHist) {
              if (!sharedHist && indexOf(rebased, doc2.history) == -1) {
                rebaseHist(doc2.history, change);
                rebased.push(doc2.history);
              }
              makeChangeSingleDoc(doc2, change, null, mergeOldSpans(doc2, change));
            });
          };
          for (var i$12 = event2.changes.length - 1; i$12 >= 0; --i$12) {
            var returned = loop(i$12);
            if (returned)
              return returned.v;
          }
        }
        function shiftDoc(doc, distance) {
          if (distance == 0) {
            return;
          }
          doc.first += distance;
          doc.sel = new Selection4(map3(doc.sel.ranges, function(range3) {
            return new Range3(Pos(range3.anchor.line + distance, range3.anchor.ch), Pos(range3.head.line + distance, range3.head.ch));
          }), doc.sel.primIndex);
          if (doc.cm) {
            regChange(doc.cm, doc.first, doc.first - distance, distance);
            for (var d4 = doc.cm.display, l3 = d4.viewFrom; l3 < d4.viewTo; l3++) {
              regLineChange(doc.cm, l3, "gutter");
            }
          }
        }
        function makeChangeSingleDoc(doc, change, selAfter, spans) {
          if (doc.cm && !doc.cm.curOp) {
            return operation(doc.cm, makeChangeSingleDoc)(doc, change, selAfter, spans);
          }
          if (change.to.line < doc.first) {
            shiftDoc(doc, change.text.length - 1 - (change.to.line - change.from.line));
            return;
          }
          if (change.from.line > doc.lastLine()) {
            return;
          }
          if (change.from.line < doc.first) {
            var shift = change.text.length - 1 - (doc.first - change.from.line);
            shiftDoc(doc, shift);
            change = {
              from: Pos(doc.first, 0),
              to: Pos(change.to.line + shift, change.to.ch),
              text: [lst(change.text)],
              origin: change.origin
            };
          }
          var last = doc.lastLine();
          if (change.to.line > last) {
            change = {
              from: change.from,
              to: Pos(last, getLine(doc, last).text.length),
              text: [change.text[0]],
              origin: change.origin
            };
          }
          change.removed = getBetween(doc, change.from, change.to);
          if (!selAfter) {
            selAfter = computeSelAfterChange(doc, change);
          }
          if (doc.cm) {
            makeChangeSingleDocInEditor(doc.cm, change, spans);
          } else {
            updateDoc(doc, change, spans);
          }
          setSelectionNoUndo(doc, selAfter, sel_dontScroll);
          if (doc.cm && hasHandler(doc.cm, "justChanged")) {
            signal(doc.cm, "justChanged", doc.cm, change);
          }
          if (doc.cantEdit && skipAtomic(doc, Pos(doc.firstLine(), 0))) {
            doc.cantEdit = false;
          }
        }
        function makeChangeSingleDocInEditor(cm, change, spans) {
          var doc = cm.doc, display = cm.display, from = change.from, to = change.to;
          var recomputeMaxLength = false, checkWidthStart = from.line;
          if (!cm.options.lineWrapping) {
            checkWidthStart = lineNo(visualLine(getLine(doc, from.line)));
            doc.iter(checkWidthStart, to.line + 1, function(line) {
              if (line == display.maxLine) {
                recomputeMaxLength = true;
                return true;
              }
            });
          }
          if (doc.sel.contains(change.from, change.to) > -1) {
            signalCursorActivity(cm);
          }
          updateDoc(doc, change, spans, estimateHeight(cm));
          if (!cm.options.lineWrapping) {
            doc.iter(checkWidthStart, from.line + change.text.length, function(line) {
              var len = lineLength(line);
              if (len > display.maxLineLength) {
                display.maxLine = line;
                display.maxLineLength = len;
                display.maxLineChanged = true;
                recomputeMaxLength = false;
              }
            });
            if (recomputeMaxLength) {
              cm.curOp.updateMaxLine = true;
            }
          }
          retreatFrontier(doc, from.line);
          startWorker(cm, 400);
          var lendiff = change.text.length - (to.line - from.line) - 1;
          if (change.full) {
            regChange(cm);
          } else if (from.line == to.line && change.text.length == 1 && !isWholeLineUpdate(cm.doc, change)) {
            regLineChange(cm, from.line, "text");
          } else {
            regChange(cm, from.line, to.line + 1, lendiff);
          }
          var changesHandler = hasHandler(cm, "changes"), changeHandler = hasHandler(cm, "change");
          if (changeHandler || changesHandler) {
            var obj = {
              from,
              to,
              text: change.text,
              removed: change.removed,
              origin: change.origin
            };
            if (changeHandler) {
              signalLater(cm, "change", cm, obj);
            }
            if (changesHandler) {
              (cm.curOp.changeObjs || (cm.curOp.changeObjs = [])).push(obj);
            }
          }
          cm.display.selForContextMenu = null;
        }
        function replaceRange(doc, code, from, to, origin) {
          var assign;
          if (!to) {
            to = from;
          }
          if (cmp(to, from) < 0) {
            assign = [to, from], from = assign[0], to = assign[1];
          }
          if (typeof code == "string") {
            code = doc.splitLines(code);
          }
          makeChange(doc, { from, to, text: code, origin });
        }
        function rebaseHistSelSingle(pos, from, to, diff) {
          if (to < pos.line) {
            pos.line += diff;
          } else if (from < pos.line) {
            pos.line = from;
            pos.ch = 0;
          }
        }
        function rebaseHistArray(array, from, to, diff) {
          for (var i4 = 0; i4 < array.length; ++i4) {
            var sub = array[i4], ok5 = true;
            if (sub.ranges) {
              if (!sub.copied) {
                sub = array[i4] = sub.deepCopy();
                sub.copied = true;
              }
              for (var j3 = 0; j3 < sub.ranges.length; j3++) {
                rebaseHistSelSingle(sub.ranges[j3].anchor, from, to, diff);
                rebaseHistSelSingle(sub.ranges[j3].head, from, to, diff);
              }
              continue;
            }
            for (var j$1 = 0; j$1 < sub.changes.length; ++j$1) {
              var cur = sub.changes[j$1];
              if (to < cur.from.line) {
                cur.from = Pos(cur.from.line + diff, cur.from.ch);
                cur.to = Pos(cur.to.line + diff, cur.to.ch);
              } else if (from <= cur.to.line) {
                ok5 = false;
                break;
              }
            }
            if (!ok5) {
              array.splice(0, i4 + 1);
              i4 = 0;
            }
          }
        }
        function rebaseHist(hist, change) {
          var from = change.from.line, to = change.to.line, diff = change.text.length - (to - from) - 1;
          rebaseHistArray(hist.done, from, to, diff);
          rebaseHistArray(hist.undone, from, to, diff);
        }
        function changeLine(doc, handle, changeType, op) {
          var no = handle, line = handle;
          if (typeof handle == "number") {
            line = getLine(doc, clipLine(doc, handle));
          } else {
            no = lineNo(handle);
          }
          if (no == null) {
            return null;
          }
          if (op(line, no) && doc.cm) {
            regLineChange(doc.cm, no, changeType);
          }
          return line;
        }
        function LeafChunk(lines) {
          this.lines = lines;
          this.parent = null;
          var height = 0;
          for (var i4 = 0; i4 < lines.length; ++i4) {
            lines[i4].parent = this;
            height += lines[i4].height;
          }
          this.height = height;
        }
        LeafChunk.prototype = {
          chunkSize: function() {
            return this.lines.length;
          },
          removeInner: function(at, n3) {
            for (var i4 = at, e5 = at + n3; i4 < e5; ++i4) {
              var line = this.lines[i4];
              this.height -= line.height;
              cleanUpLine(line);
              signalLater(line, "delete");
            }
            this.lines.splice(at, n3);
          },
          collapse: function(lines) {
            lines.push.apply(lines, this.lines);
          },
          insertInner: function(at, lines, height) {
            this.height += height;
            this.lines = this.lines.slice(0, at).concat(lines).concat(this.lines.slice(at));
            for (var i4 = 0; i4 < lines.length; ++i4) {
              lines[i4].parent = this;
            }
          },
          iterN: function(at, n3, op) {
            for (var e5 = at + n3; at < e5; ++at) {
              if (op(this.lines[at])) {
                return true;
              }
            }
          }
        };
        function BranchChunk(children) {
          this.children = children;
          var size2 = 0, height = 0;
          for (var i4 = 0; i4 < children.length; ++i4) {
            var ch = children[i4];
            size2 += ch.chunkSize();
            height += ch.height;
            ch.parent = this;
          }
          this.size = size2;
          this.height = height;
          this.parent = null;
        }
        BranchChunk.prototype = {
          chunkSize: function() {
            return this.size;
          },
          removeInner: function(at, n3) {
            this.size -= n3;
            for (var i4 = 0; i4 < this.children.length; ++i4) {
              var child = this.children[i4], sz = child.chunkSize();
              if (at < sz) {
                var rm = Math.min(n3, sz - at), oldHeight = child.height;
                child.removeInner(at, rm);
                this.height -= oldHeight - child.height;
                if (sz == rm) {
                  this.children.splice(i4--, 1);
                  child.parent = null;
                }
                if ((n3 -= rm) == 0) {
                  break;
                }
                at = 0;
              } else {
                at -= sz;
              }
            }
            if (this.size - n3 < 25 && (this.children.length > 1 || !(this.children[0] instanceof LeafChunk))) {
              var lines = [];
              this.collapse(lines);
              this.children = [new LeafChunk(lines)];
              this.children[0].parent = this;
            }
          },
          collapse: function(lines) {
            for (var i4 = 0; i4 < this.children.length; ++i4) {
              this.children[i4].collapse(lines);
            }
          },
          insertInner: function(at, lines, height) {
            this.size += lines.length;
            this.height += height;
            for (var i4 = 0; i4 < this.children.length; ++i4) {
              var child = this.children[i4], sz = child.chunkSize();
              if (at <= sz) {
                child.insertInner(at, lines, height);
                if (child.lines && child.lines.length > 50) {
                  var remaining = child.lines.length % 25 + 25;
                  for (var pos = remaining; pos < child.lines.length; ) {
                    var leaf = new LeafChunk(child.lines.slice(pos, pos += 25));
                    child.height -= leaf.height;
                    this.children.splice(++i4, 0, leaf);
                    leaf.parent = this;
                  }
                  child.lines = child.lines.slice(0, remaining);
                  this.maybeSpill();
                }
                break;
              }
              at -= sz;
            }
          },
          maybeSpill: function() {
            if (this.children.length <= 10) {
              return;
            }
            var me = this;
            do {
              var spilled = me.children.splice(me.children.length - 5, 5);
              var sibling = new BranchChunk(spilled);
              if (!me.parent) {
                var copy2 = new BranchChunk(me.children);
                copy2.parent = me;
                me.children = [copy2, sibling];
                me = copy2;
              } else {
                me.size -= sibling.size;
                me.height -= sibling.height;
                var myIndex = indexOf(me.parent.children, me);
                me.parent.children.splice(myIndex + 1, 0, sibling);
              }
              sibling.parent = me.parent;
            } while (me.children.length > 10);
            me.parent.maybeSpill();
          },
          iterN: function(at, n3, op) {
            for (var i4 = 0; i4 < this.children.length; ++i4) {
              var child = this.children[i4], sz = child.chunkSize();
              if (at < sz) {
                var used = Math.min(n3, sz - at);
                if (child.iterN(at, used, op)) {
                  return true;
                }
                if ((n3 -= used) == 0) {
                  break;
                }
                at = 0;
              } else {
                at -= sz;
              }
            }
          }
        };
        var LineWidget = function(doc, node, options) {
          if (options) {
            for (var opt in options) {
              if (options.hasOwnProperty(opt)) {
                this[opt] = options[opt];
              }
            }
          }
          this.doc = doc;
          this.node = node;
        };
        LineWidget.prototype.clear = function() {
          var cm = this.doc.cm, ws = this.line.widgets, line = this.line, no = lineNo(line);
          if (no == null || !ws) {
            return;
          }
          for (var i4 = 0; i4 < ws.length; ++i4) {
            if (ws[i4] == this) {
              ws.splice(i4--, 1);
            }
          }
          if (!ws.length) {
            line.widgets = null;
          }
          var height = widgetHeight(this);
          updateLineHeight(line, Math.max(0, line.height - height));
          if (cm) {
            runInOp(cm, function() {
              adjustScrollWhenAboveVisible(cm, line, -height);
              regLineChange(cm, no, "widget");
            });
            signalLater(cm, "lineWidgetCleared", cm, this, no);
          }
        };
        LineWidget.prototype.changed = function() {
          var this$1 = this;
          var oldH = this.height, cm = this.doc.cm, line = this.line;
          this.height = null;
          var diff = widgetHeight(this) - oldH;
          if (!diff) {
            return;
          }
          if (!lineIsHidden(this.doc, line)) {
            updateLineHeight(line, line.height + diff);
          }
          if (cm) {
            runInOp(cm, function() {
              cm.curOp.forceUpdate = true;
              adjustScrollWhenAboveVisible(cm, line, diff);
              signalLater(cm, "lineWidgetChanged", cm, this$1, lineNo(line));
            });
          }
        };
        eventMixin(LineWidget);
        function adjustScrollWhenAboveVisible(cm, line, diff) {
          if (heightAtLine(line) < (cm.curOp && cm.curOp.scrollTop || cm.doc.scrollTop)) {
            addToScrollTop(cm, diff);
          }
        }
        function addLineWidget(doc, handle, node, options) {
          var widget = new LineWidget(doc, node, options);
          var cm = doc.cm;
          if (cm && widget.noHScroll) {
            cm.display.alignWidgets = true;
          }
          changeLine(doc, handle, "widget", function(line) {
            var widgets = line.widgets || (line.widgets = []);
            if (widget.insertAt == null) {
              widgets.push(widget);
            } else {
              widgets.splice(Math.min(widgets.length - 1, Math.max(0, widget.insertAt)), 0, widget);
            }
            widget.line = line;
            if (cm && !lineIsHidden(doc, line)) {
              var aboveVisible = heightAtLine(line) < doc.scrollTop;
              updateLineHeight(line, line.height + widgetHeight(widget));
              if (aboveVisible) {
                addToScrollTop(cm, widget.height);
              }
              cm.curOp.forceUpdate = true;
            }
            return true;
          });
          if (cm) {
            signalLater(cm, "lineWidgetAdded", cm, widget, typeof handle == "number" ? handle : lineNo(handle));
          }
          return widget;
        }
        var nextMarkerId = 0;
        var TextMarker = function(doc, type) {
          this.lines = [];
          this.type = type;
          this.doc = doc;
          this.id = ++nextMarkerId;
        };
        TextMarker.prototype.clear = function() {
          if (this.explicitlyCleared) {
            return;
          }
          var cm = this.doc.cm, withOp = cm && !cm.curOp;
          if (withOp) {
            startOperation(cm);
          }
          if (hasHandler(this, "clear")) {
            var found = this.find();
            if (found) {
              signalLater(this, "clear", found.from, found.to);
            }
          }
          var min2 = null, max2 = null;
          for (var i4 = 0; i4 < this.lines.length; ++i4) {
            var line = this.lines[i4];
            var span = getMarkedSpanFor(line.markedSpans, this);
            if (cm && !this.collapsed) {
              regLineChange(cm, lineNo(line), "text");
            } else if (cm) {
              if (span.to != null) {
                max2 = lineNo(line);
              }
              if (span.from != null) {
                min2 = lineNo(line);
              }
            }
            line.markedSpans = removeMarkedSpan(line.markedSpans, span);
            if (span.from == null && this.collapsed && !lineIsHidden(this.doc, line) && cm) {
              updateLineHeight(line, textHeight$1(cm.display));
            }
          }
          if (cm && this.collapsed && !cm.options.lineWrapping) {
            for (var i$12 = 0; i$12 < this.lines.length; ++i$12) {
              var visual = visualLine(this.lines[i$12]), len = lineLength(visual);
              if (len > cm.display.maxLineLength) {
                cm.display.maxLine = visual;
                cm.display.maxLineLength = len;
                cm.display.maxLineChanged = true;
              }
            }
          }
          if (min2 != null && cm && this.collapsed) {
            regChange(cm, min2, max2 + 1);
          }
          this.lines.length = 0;
          this.explicitlyCleared = true;
          if (this.atomic && this.doc.cantEdit) {
            this.doc.cantEdit = false;
            if (cm) {
              reCheckSelection(cm.doc);
            }
          }
          if (cm) {
            signalLater(cm, "markerCleared", cm, this, min2, max2);
          }
          if (withOp) {
            endOperation(cm);
          }
          if (this.parent) {
            this.parent.clear();
          }
        };
        TextMarker.prototype.find = function(side, lineObj) {
          if (side == null && this.type == "bookmark") {
            side = 1;
          }
          var from, to;
          for (var i4 = 0; i4 < this.lines.length; ++i4) {
            var line = this.lines[i4];
            var span = getMarkedSpanFor(line.markedSpans, this);
            if (span.from != null) {
              from = Pos(lineObj ? line : lineNo(line), span.from);
              if (side == -1) {
                return from;
              }
            }
            if (span.to != null) {
              to = Pos(lineObj ? line : lineNo(line), span.to);
              if (side == 1) {
                return to;
              }
            }
          }
          return from && { from, to };
        };
        TextMarker.prototype.changed = function() {
          var this$1 = this;
          var pos = this.find(-1, true), widget = this, cm = this.doc.cm;
          if (!pos || !cm) {
            return;
          }
          runInOp(cm, function() {
            var line = pos.line, lineN = lineNo(pos.line);
            var view = findViewForLine(cm, lineN);
            if (view) {
              clearLineMeasurementCacheFor(view);
              cm.curOp.selectionChanged = cm.curOp.forceUpdate = true;
            }
            cm.curOp.updateMaxLine = true;
            if (!lineIsHidden(widget.doc, line) && widget.height != null) {
              var oldHeight = widget.height;
              widget.height = null;
              var dHeight = widgetHeight(widget) - oldHeight;
              if (dHeight) {
                updateLineHeight(line, line.height + dHeight);
              }
            }
            signalLater(cm, "markerChanged", cm, this$1);
          });
        };
        TextMarker.prototype.attachLine = function(line) {
          if (!this.lines.length && this.doc.cm) {
            var op = this.doc.cm.curOp;
            if (!op.maybeHiddenMarkers || indexOf(op.maybeHiddenMarkers, this) == -1) {
              (op.maybeUnhiddenMarkers || (op.maybeUnhiddenMarkers = [])).push(this);
            }
          }
          this.lines.push(line);
        };
        TextMarker.prototype.detachLine = function(line) {
          this.lines.splice(indexOf(this.lines, line), 1);
          if (!this.lines.length && this.doc.cm) {
            var op = this.doc.cm.curOp;
            (op.maybeHiddenMarkers || (op.maybeHiddenMarkers = [])).push(this);
          }
        };
        eventMixin(TextMarker);
        function markText(doc, from, to, options, type) {
          if (options && options.shared) {
            return markTextShared(doc, from, to, options, type);
          }
          if (doc.cm && !doc.cm.curOp) {
            return operation(doc.cm, markText)(doc, from, to, options, type);
          }
          var marker = new TextMarker(doc, type), diff = cmp(from, to);
          if (options) {
            copyObj(options, marker, false);
          }
          if (diff > 0 || diff == 0 && marker.clearWhenEmpty !== false) {
            return marker;
          }
          if (marker.replacedWith) {
            marker.collapsed = true;
            marker.widgetNode = eltP("span", [marker.replacedWith], "CodeMirror-widget");
            if (!options.handleMouseEvents) {
              marker.widgetNode.setAttribute("cm-ignore-events", "true");
            }
            if (options.insertLeft) {
              marker.widgetNode.insertLeft = true;
            }
          }
          if (marker.collapsed) {
            if (conflictingCollapsedRange(doc, from.line, from, to, marker) || from.line != to.line && conflictingCollapsedRange(doc, to.line, from, to, marker)) {
              throw new Error("Inserting collapsed marker partially overlapping an existing one");
            }
            seeCollapsedSpans();
          }
          if (marker.addToHistory) {
            addChangeToHistory(doc, { from, to, origin: "markText" }, doc.sel, NaN);
          }
          var curLine = from.line, cm = doc.cm, updateMaxLine;
          doc.iter(curLine, to.line + 1, function(line) {
            if (cm && marker.collapsed && !cm.options.lineWrapping && visualLine(line) == cm.display.maxLine) {
              updateMaxLine = true;
            }
            if (marker.collapsed && curLine != from.line) {
              updateLineHeight(line, 0);
            }
            addMarkedSpan(line, new MarkedSpan(marker, curLine == from.line ? from.ch : null, curLine == to.line ? to.ch : null));
            ++curLine;
          });
          if (marker.collapsed) {
            doc.iter(from.line, to.line + 1, function(line) {
              if (lineIsHidden(doc, line)) {
                updateLineHeight(line, 0);
              }
            });
          }
          if (marker.clearOnEnter) {
            on(marker, "beforeCursorEnter", function() {
              return marker.clear();
            });
          }
          if (marker.readOnly) {
            seeReadOnlySpans();
            if (doc.history.done.length || doc.history.undone.length) {
              doc.clearHistory();
            }
          }
          if (marker.collapsed) {
            marker.id = ++nextMarkerId;
            marker.atomic = true;
          }
          if (cm) {
            if (updateMaxLine) {
              cm.curOp.updateMaxLine = true;
            }
            if (marker.collapsed) {
              regChange(cm, from.line, to.line + 1);
            } else if (marker.className || marker.startStyle || marker.endStyle || marker.css || marker.attributes || marker.title) {
              for (var i4 = from.line; i4 <= to.line; i4++) {
                regLineChange(cm, i4, "text");
              }
            }
            if (marker.atomic) {
              reCheckSelection(cm.doc);
            }
            signalLater(cm, "markerAdded", cm, marker);
          }
          return marker;
        }
        var SharedTextMarker = function(markers, primary) {
          this.markers = markers;
          this.primary = primary;
          for (var i4 = 0; i4 < markers.length; ++i4) {
            markers[i4].parent = this;
          }
        };
        SharedTextMarker.prototype.clear = function() {
          if (this.explicitlyCleared) {
            return;
          }
          this.explicitlyCleared = true;
          for (var i4 = 0; i4 < this.markers.length; ++i4) {
            this.markers[i4].clear();
          }
          signalLater(this, "clear");
        };
        SharedTextMarker.prototype.find = function(side, lineObj) {
          return this.primary.find(side, lineObj);
        };
        eventMixin(SharedTextMarker);
        function markTextShared(doc, from, to, options, type) {
          options = copyObj(options);
          options.shared = false;
          var markers = [markText(doc, from, to, options, type)], primary = markers[0];
          var widget = options.widgetNode;
          linkedDocs(doc, function(doc2) {
            if (widget) {
              options.widgetNode = widget.cloneNode(true);
            }
            markers.push(markText(doc2, clipPos(doc2, from), clipPos(doc2, to), options, type));
            for (var i4 = 0; i4 < doc2.linked.length; ++i4) {
              if (doc2.linked[i4].isParent) {
                return;
              }
            }
            primary = lst(markers);
          });
          return new SharedTextMarker(markers, primary);
        }
        function findSharedMarkers(doc) {
          return doc.findMarks(Pos(doc.first, 0), doc.clipPos(Pos(doc.lastLine())), function(m3) {
            return m3.parent;
          });
        }
        function copySharedMarkers(doc, markers) {
          for (var i4 = 0; i4 < markers.length; i4++) {
            var marker = markers[i4], pos = marker.find();
            var mFrom = doc.clipPos(pos.from), mTo = doc.clipPos(pos.to);
            if (cmp(mFrom, mTo)) {
              var subMark = markText(doc, mFrom, mTo, marker.primary, marker.primary.type);
              marker.markers.push(subMark);
              subMark.parent = marker;
            }
          }
        }
        function detachSharedMarkers(markers) {
          var loop = function(i5) {
            var marker = markers[i5], linked = [marker.primary.doc];
            linkedDocs(marker.primary.doc, function(d4) {
              return linked.push(d4);
            });
            for (var j3 = 0; j3 < marker.markers.length; j3++) {
              var subMarker = marker.markers[j3];
              if (indexOf(linked, subMarker.doc) == -1) {
                subMarker.parent = null;
                marker.markers.splice(j3--, 1);
              }
            }
          };
          for (var i4 = 0; i4 < markers.length; i4++)
            loop(i4);
        }
        var nextDocId = 0;
        var Doc = function(text, mode2, firstLine, lineSep, direction) {
          if (!(this instanceof Doc)) {
            return new Doc(text, mode2, firstLine, lineSep, direction);
          }
          if (firstLine == null) {
            firstLine = 0;
          }
          BranchChunk.call(this, [new LeafChunk([new Line("", null)])]);
          this.first = firstLine;
          this.scrollTop = this.scrollLeft = 0;
          this.cantEdit = false;
          this.cleanGeneration = 1;
          this.modeFrontier = this.highlightFrontier = firstLine;
          var start2 = Pos(firstLine, 0);
          this.sel = simpleSelection(start2);
          this.history = new History(null);
          this.id = ++nextDocId;
          this.modeOption = mode2;
          this.lineSep = lineSep;
          this.direction = direction == "rtl" ? "rtl" : "ltr";
          this.extend = false;
          if (typeof text == "string") {
            text = this.splitLines(text);
          }
          updateDoc(this, { from: start2, to: start2, text });
          setSelection(this, simpleSelection(start2), sel_dontScroll);
        };
        Doc.prototype = createObj(BranchChunk.prototype, {
          constructor: Doc,
          iter: function(from, to, op) {
            if (op) {
              this.iterN(from - this.first, to - from, op);
            } else {
              this.iterN(this.first, this.first + this.size, from);
            }
          },
          insert: function(at, lines) {
            var height = 0;
            for (var i4 = 0; i4 < lines.length; ++i4) {
              height += lines[i4].height;
            }
            this.insertInner(at - this.first, lines, height);
          },
          remove: function(at, n3) {
            this.removeInner(at - this.first, n3);
          },
          getValue: function(lineSep) {
            var lines = getLines(this, this.first, this.first + this.size);
            if (lineSep === false) {
              return lines;
            }
            return lines.join(lineSep || this.lineSeparator());
          },
          setValue: docMethodOp(function(code) {
            var top = Pos(this.first, 0), last = this.first + this.size - 1;
            makeChange(this, {
              from: top,
              to: Pos(last, getLine(this, last).text.length),
              text: this.splitLines(code),
              origin: "setValue",
              full: true
            }, true);
            if (this.cm) {
              scrollToCoords(this.cm, 0, 0);
            }
            setSelection(this, simpleSelection(top), sel_dontScroll);
          }),
          replaceRange: function(code, from, to, origin) {
            from = clipPos(this, from);
            to = to ? clipPos(this, to) : from;
            replaceRange(this, code, from, to, origin);
          },
          getRange: function(from, to, lineSep) {
            var lines = getBetween(this, clipPos(this, from), clipPos(this, to));
            if (lineSep === false) {
              return lines;
            }
            return lines.join(lineSep || this.lineSeparator());
          },
          getLine: function(line) {
            var l3 = this.getLineHandle(line);
            return l3 && l3.text;
          },
          getLineHandle: function(line) {
            if (isLine(this, line)) {
              return getLine(this, line);
            }
          },
          getLineNumber: function(line) {
            return lineNo(line);
          },
          getLineHandleVisualStart: function(line) {
            if (typeof line == "number") {
              line = getLine(this, line);
            }
            return visualLine(line);
          },
          lineCount: function() {
            return this.size;
          },
          firstLine: function() {
            return this.first;
          },
          lastLine: function() {
            return this.first + this.size - 1;
          },
          clipPos: function(pos) {
            return clipPos(this, pos);
          },
          getCursor: function(start2) {
            var range3 = this.sel.primary(), pos;
            if (start2 == null || start2 == "head") {
              pos = range3.head;
            } else if (start2 == "anchor") {
              pos = range3.anchor;
            } else if (start2 == "end" || start2 == "to" || start2 === false) {
              pos = range3.to();
            } else {
              pos = range3.from();
            }
            return pos;
          },
          listSelections: function() {
            return this.sel.ranges;
          },
          somethingSelected: function() {
            return this.sel.somethingSelected();
          },
          setCursor: docMethodOp(function(line, ch, options) {
            setSimpleSelection(this, clipPos(this, typeof line == "number" ? Pos(line, ch || 0) : line), null, options);
          }),
          setSelection: docMethodOp(function(anchor, head, options) {
            setSimpleSelection(this, clipPos(this, anchor), clipPos(this, head || anchor), options);
          }),
          extendSelection: docMethodOp(function(head, other, options) {
            extendSelection(this, clipPos(this, head), other && clipPos(this, other), options);
          }),
          extendSelections: docMethodOp(function(heads, options) {
            extendSelections(this, clipPosArray(this, heads), options);
          }),
          extendSelectionsBy: docMethodOp(function(f3, options) {
            var heads = map3(this.sel.ranges, f3);
            extendSelections(this, clipPosArray(this, heads), options);
          }),
          setSelections: docMethodOp(function(ranges, primary, options) {
            if (!ranges.length) {
              return;
            }
            var out = [];
            for (var i4 = 0; i4 < ranges.length; i4++) {
              out[i4] = new Range3(clipPos(this, ranges[i4].anchor), clipPos(this, ranges[i4].head));
            }
            if (primary == null) {
              primary = Math.min(ranges.length - 1, this.sel.primIndex);
            }
            setSelection(this, normalizeSelection(this.cm, out, primary), options);
          }),
          addSelection: docMethodOp(function(anchor, head, options) {
            var ranges = this.sel.ranges.slice(0);
            ranges.push(new Range3(clipPos(this, anchor), clipPos(this, head || anchor)));
            setSelection(this, normalizeSelection(this.cm, ranges, ranges.length - 1), options);
          }),
          getSelection: function(lineSep) {
            var ranges = this.sel.ranges, lines;
            for (var i4 = 0; i4 < ranges.length; i4++) {
              var sel = getBetween(this, ranges[i4].from(), ranges[i4].to());
              lines = lines ? lines.concat(sel) : sel;
            }
            if (lineSep === false) {
              return lines;
            } else {
              return lines.join(lineSep || this.lineSeparator());
            }
          },
          getSelections: function(lineSep) {
            var parts = [], ranges = this.sel.ranges;
            for (var i4 = 0; i4 < ranges.length; i4++) {
              var sel = getBetween(this, ranges[i4].from(), ranges[i4].to());
              if (lineSep !== false) {
                sel = sel.join(lineSep || this.lineSeparator());
              }
              parts[i4] = sel;
            }
            return parts;
          },
          replaceSelection: function(code, collapse, origin) {
            var dup = [];
            for (var i4 = 0; i4 < this.sel.ranges.length; i4++) {
              dup[i4] = code;
            }
            this.replaceSelections(dup, collapse, origin || "+input");
          },
          replaceSelections: docMethodOp(function(code, collapse, origin) {
            var changes = [], sel = this.sel;
            for (var i4 = 0; i4 < sel.ranges.length; i4++) {
              var range3 = sel.ranges[i4];
              changes[i4] = { from: range3.from(), to: range3.to(), text: this.splitLines(code[i4]), origin };
            }
            var newSel = collapse && collapse != "end" && computeReplacedSel(this, changes, collapse);
            for (var i$12 = changes.length - 1; i$12 >= 0; i$12--) {
              makeChange(this, changes[i$12]);
            }
            if (newSel) {
              setSelectionReplaceHistory(this, newSel);
            } else if (this.cm) {
              ensureCursorVisible(this.cm);
            }
          }),
          undo: docMethodOp(function() {
            makeChangeFromHistory(this, "undo");
          }),
          redo: docMethodOp(function() {
            makeChangeFromHistory(this, "redo");
          }),
          undoSelection: docMethodOp(function() {
            makeChangeFromHistory(this, "undo", true);
          }),
          redoSelection: docMethodOp(function() {
            makeChangeFromHistory(this, "redo", true);
          }),
          setExtending: function(val) {
            this.extend = val;
          },
          getExtending: function() {
            return this.extend;
          },
          historySize: function() {
            var hist = this.history, done = 0, undone = 0;
            for (var i4 = 0; i4 < hist.done.length; i4++) {
              if (!hist.done[i4].ranges) {
                ++done;
              }
            }
            for (var i$12 = 0; i$12 < hist.undone.length; i$12++) {
              if (!hist.undone[i$12].ranges) {
                ++undone;
              }
            }
            return { undo: done, redo: undone };
          },
          clearHistory: function() {
            var this$1 = this;
            this.history = new History(this.history.maxGeneration);
            linkedDocs(this, function(doc) {
              return doc.history = this$1.history;
            }, true);
          },
          markClean: function() {
            this.cleanGeneration = this.changeGeneration(true);
          },
          changeGeneration: function(forceSplit) {
            if (forceSplit) {
              this.history.lastOp = this.history.lastSelOp = this.history.lastOrigin = null;
            }
            return this.history.generation;
          },
          isClean: function(gen) {
            return this.history.generation == (gen || this.cleanGeneration);
          },
          getHistory: function() {
            return {
              done: copyHistoryArray(this.history.done),
              undone: copyHistoryArray(this.history.undone)
            };
          },
          setHistory: function(histData) {
            var hist = this.history = new History(this.history.maxGeneration);
            hist.done = copyHistoryArray(histData.done.slice(0), null, true);
            hist.undone = copyHistoryArray(histData.undone.slice(0), null, true);
          },
          setGutterMarker: docMethodOp(function(line, gutterID, value) {
            return changeLine(this, line, "gutter", function(line2) {
              var markers = line2.gutterMarkers || (line2.gutterMarkers = {});
              markers[gutterID] = value;
              if (!value && isEmpty(markers)) {
                line2.gutterMarkers = null;
              }
              return true;
            });
          }),
          clearGutter: docMethodOp(function(gutterID) {
            var this$1 = this;
            this.iter(function(line) {
              if (line.gutterMarkers && line.gutterMarkers[gutterID]) {
                changeLine(this$1, line, "gutter", function() {
                  line.gutterMarkers[gutterID] = null;
                  if (isEmpty(line.gutterMarkers)) {
                    line.gutterMarkers = null;
                  }
                  return true;
                });
              }
            });
          }),
          lineInfo: function(line) {
            var n3;
            if (typeof line == "number") {
              if (!isLine(this, line)) {
                return null;
              }
              n3 = line;
              line = getLine(this, line);
              if (!line) {
                return null;
              }
            } else {
              n3 = lineNo(line);
              if (n3 == null) {
                return null;
              }
            }
            return {
              line: n3,
              handle: line,
              text: line.text,
              gutterMarkers: line.gutterMarkers,
              textClass: line.textClass,
              bgClass: line.bgClass,
              wrapClass: line.wrapClass,
              widgets: line.widgets
            };
          },
          addLineClass: docMethodOp(function(handle, where, cls) {
            return changeLine(this, handle, where == "gutter" ? "gutter" : "class", function(line) {
              var prop2 = where == "text" ? "textClass" : where == "background" ? "bgClass" : where == "gutter" ? "gutterClass" : "wrapClass";
              if (!line[prop2]) {
                line[prop2] = cls;
              } else if (classTest(cls).test(line[prop2])) {
                return false;
              } else {
                line[prop2] += " " + cls;
              }
              return true;
            });
          }),
          removeLineClass: docMethodOp(function(handle, where, cls) {
            return changeLine(this, handle, where == "gutter" ? "gutter" : "class", function(line) {
              var prop2 = where == "text" ? "textClass" : where == "background" ? "bgClass" : where == "gutter" ? "gutterClass" : "wrapClass";
              var cur = line[prop2];
              if (!cur) {
                return false;
              } else if (cls == null) {
                line[prop2] = null;
              } else {
                var found = cur.match(classTest(cls));
                if (!found) {
                  return false;
                }
                var end = found.index + found[0].length;
                line[prop2] = cur.slice(0, found.index) + (!found.index || end == cur.length ? "" : " ") + cur.slice(end) || null;
              }
              return true;
            });
          }),
          addLineWidget: docMethodOp(function(handle, node, options) {
            return addLineWidget(this, handle, node, options);
          }),
          removeLineWidget: function(widget) {
            widget.clear();
          },
          markText: function(from, to, options) {
            return markText(this, clipPos(this, from), clipPos(this, to), options, options && options.type || "range");
          },
          setBookmark: function(pos, options) {
            var realOpts = {
              replacedWith: options && (options.nodeType == null ? options.widget : options),
              insertLeft: options && options.insertLeft,
              clearWhenEmpty: false,
              shared: options && options.shared,
              handleMouseEvents: options && options.handleMouseEvents
            };
            pos = clipPos(this, pos);
            return markText(this, pos, pos, realOpts, "bookmark");
          },
          findMarksAt: function(pos) {
            pos = clipPos(this, pos);
            var markers = [], spans = getLine(this, pos.line).markedSpans;
            if (spans) {
              for (var i4 = 0; i4 < spans.length; ++i4) {
                var span = spans[i4];
                if ((span.from == null || span.from <= pos.ch) && (span.to == null || span.to >= pos.ch)) {
                  markers.push(span.marker.parent || span.marker);
                }
              }
            }
            return markers;
          },
          findMarks: function(from, to, filter3) {
            from = clipPos(this, from);
            to = clipPos(this, to);
            var found = [], lineNo2 = from.line;
            this.iter(from.line, to.line + 1, function(line) {
              var spans = line.markedSpans;
              if (spans) {
                for (var i4 = 0; i4 < spans.length; i4++) {
                  var span = spans[i4];
                  if (!(span.to != null && lineNo2 == from.line && from.ch >= span.to || span.from == null && lineNo2 != from.line || span.from != null && lineNo2 == to.line && span.from >= to.ch) && (!filter3 || filter3(span.marker))) {
                    found.push(span.marker.parent || span.marker);
                  }
                }
              }
              ++lineNo2;
            });
            return found;
          },
          findMarksInRange: function(from, to) {
            if (!to) {
              to = from;
            }
            from = clipPos(this, from);
            to = clipPos(this, to);
            var markers = [], lineNum = from.line;
            this.iter(from.line, to.line + 1, function(line) {
              var spans = line.markedSpans;
              if (spans) {
                for (var i4 = 0; i4 < spans.length; ++i4) {
                  var span = spans[i4];
                  var fromOverlap = false;
                  var toOverlap = false;
                  if (to.line === lineNum) {
                    fromOverlap = span.from == null || span.from <= to.ch;
                  } else {
                    fromOverlap = true;
                  }
                  if (from.line === lineNum) {
                    toOverlap = span.to == null || span.to >= from.ch;
                  } else {
                    toOverlap = true;
                  }
                  if (fromOverlap && toOverlap) {
                    var marker = span.marker.parent || span.marker;
                    if (markers.indexOf(marker) === -1) {
                      markers.push(marker);
                    }
                  }
                }
              }
              lineNum++;
            });
            return markers;
          },
          getAllMarks: function() {
            var markers = [];
            this.iter(function(line) {
              var sps = line.markedSpans;
              if (sps) {
                for (var i4 = 0; i4 < sps.length; ++i4) {
                  if (sps[i4].from != null) {
                    markers.push(sps[i4].marker);
                  }
                }
              }
            });
            return markers;
          },
          posFromIndex: function(off2) {
            var ch, lineNo2 = this.first, sepSize = this.lineSeparator().length;
            this.iter(function(line) {
              var sz = line.text.length + sepSize;
              if (sz > off2) {
                ch = off2;
                return true;
              }
              off2 -= sz;
              ++lineNo2;
            });
            return clipPos(this, Pos(lineNo2, ch));
          },
          indexFromPos: function(coords) {
            coords = clipPos(this, coords);
            var index2 = coords.ch;
            if (coords.line < this.first || coords.ch < 0) {
              return 0;
            }
            var sepSize = this.lineSeparator().length;
            this.iter(this.first, coords.line, function(line) {
              index2 += line.text.length + sepSize;
            });
            return index2;
          },
          copy: function(copyHistory) {
            var doc = new Doc(getLines(this, this.first, this.first + this.size), this.modeOption, this.first, this.lineSep, this.direction);
            doc.scrollTop = this.scrollTop;
            doc.scrollLeft = this.scrollLeft;
            doc.sel = this.sel;
            doc.extend = false;
            if (copyHistory) {
              doc.history.undoDepth = this.history.undoDepth;
              doc.setHistory(this.getHistory());
            }
            return doc;
          },
          linkedDoc: function(options) {
            if (!options) {
              options = {};
            }
            var from = this.first, to = this.first + this.size;
            if (options.from != null && options.from > from) {
              from = options.from;
            }
            if (options.to != null && options.to < to) {
              to = options.to;
            }
            var copy2 = new Doc(getLines(this, from, to), options.mode || this.modeOption, from, this.lineSep, this.direction);
            if (options.sharedHist) {
              copy2.history = this.history;
            }
            (this.linked || (this.linked = [])).push({ doc: copy2, sharedHist: options.sharedHist });
            copy2.linked = [{ doc: this, isParent: true, sharedHist: options.sharedHist }];
            copySharedMarkers(copy2, findSharedMarkers(this));
            return copy2;
          },
          unlinkDoc: function(other) {
            if (other instanceof CodeMirror5) {
              other = other.doc;
            }
            if (this.linked) {
              for (var i4 = 0; i4 < this.linked.length; ++i4) {
                var link = this.linked[i4];
                if (link.doc != other) {
                  continue;
                }
                this.linked.splice(i4, 1);
                other.unlinkDoc(this);
                detachSharedMarkers(findSharedMarkers(this));
                break;
              }
            }
            if (other.history == this.history) {
              var splitIds = [other.id];
              linkedDocs(other, function(doc) {
                return splitIds.push(doc.id);
              }, true);
              other.history = new History(null);
              other.history.done = copyHistoryArray(this.history.done, splitIds);
              other.history.undone = copyHistoryArray(this.history.undone, splitIds);
            }
          },
          iterLinkedDocs: function(f3) {
            linkedDocs(this, f3);
          },
          getMode: function() {
            return this.mode;
          },
          getEditor: function() {
            return this.cm;
          },
          splitLines: function(str) {
            if (this.lineSep) {
              return str.split(this.lineSep);
            }
            return splitLinesAuto(str);
          },
          lineSeparator: function() {
            return this.lineSep || "\n";
          },
          setDirection: docMethodOp(function(dir) {
            if (dir != "rtl") {
              dir = "ltr";
            }
            if (dir == this.direction) {
              return;
            }
            this.direction = dir;
            this.iter(function(line) {
              return line.order = null;
            });
            if (this.cm) {
              directionChanged(this.cm);
            }
          })
        });
        Doc.prototype.eachLine = Doc.prototype.iter;
        var lastDrop = 0;
        function onDrop(e5) {
          var cm = this;
          clearDragCursor(cm);
          if (signalDOMEvent(cm, e5) || eventInWidget(cm.display, e5)) {
            return;
          }
          e_preventDefault(e5);
          if (ie) {
            lastDrop = +new Date();
          }
          var pos = posFromMouse(cm, e5, true), files = e5.dataTransfer.files;
          if (!pos || cm.isReadOnly()) {
            return;
          }
          var textForDropEvent = cm.options.textforDropEvent ? cm.options.textForDropEvent(e5) : null;
          if (textForDropEvent === null && files && files.length && window.FileReader && window.File) {
            var n3 = files.length, text = Array(n3), read = 0;
            var markAsReadAndPasteIfAllFilesAreRead = function() {
              if (++read == n3) {
                operation(cm, function() {
                  pos = clipPos(cm.doc, pos);
                  var change = {
                    from: pos,
                    to: pos,
                    text: cm.doc.splitLines(text.filter(function(t3) {
                      return t3 != null;
                    }).join(cm.doc.lineSeparator())),
                    origin: "+paste"
                  };
                  makeChange(cm.doc, change);
                  setSelectionReplaceHistory(cm.doc, simpleSelection(clipPos(cm.doc, pos), clipPos(cm.doc, changeEnd(change))));
                })();
              }
            };
            var readTextFromFile = function(file, i5) {
              if (cm.options.allowDropFileTypes && indexOf(cm.options.allowDropFileTypes, file.type) == -1) {
                markAsReadAndPasteIfAllFilesAreRead();
                return;
              }
              var reader = new FileReader();
              reader.onerror = function() {
                return markAsReadAndPasteIfAllFilesAreRead();
              };
              reader.onload = function() {
                var content = reader.result;
                if (/[\x00-\x08\x0e-\x1f]{2}/.test(content)) {
                  markAsReadAndPasteIfAllFilesAreRead();
                  return;
                }
                text[i5] = content;
                markAsReadAndPasteIfAllFilesAreRead();
              };
              reader.readAsText(file);
            };
            for (var i4 = 0; i4 < files.length; i4++) {
              readTextFromFile(files[i4], i4);
            }
          } else {
            if (cm.state.draggingText && cm.doc.sel.contains(pos) > -1) {
              cm.state.draggingText(e5);
              setTimeout(function() {
                return cm.display.input.focus();
              }, 20);
              return;
            }
            try {
              var text$1 = textForDropEvent ? textForDropEvent : e5.dataTransfer.getData("Text");
              if (text$1) {
                var selected;
                if (cm.state.draggingText && !cm.state.draggingText.copy) {
                  selected = cm.listSelections();
                }
                setSelectionNoUndo(cm.doc, simpleSelection(pos, pos));
                if (!textForDropEvent) {
                  if (selected) {
                    for (var i$12 = 0; i$12 < selected.length; ++i$12) {
                      replaceRange(cm.doc, "", selected[i$12].anchor, selected[i$12].head, "drag");
                    }
                  }
                }
                cm.replaceSelection(text$1, "around", "+paste");
                cm.display.input.focus();
              }
            } catch (e6) {
            }
          }
        }
        function onDragStart(cm, e5) {
          if (ie && (!cm.state.draggingText || +new Date() - lastDrop < 100)) {
            e_stop(e5);
            return;
          }
          if (signalDOMEvent(cm, e5) || eventInWidget(cm.display, e5)) {
            return;
          }
          e5.dataTransfer.setData("Text", cm.getSelection());
          e5.dataTransfer.effectAllowed = "copyMove";
          if (e5.dataTransfer.setDragImage && !safari) {
            var img = elt("img", null, null, "position: fixed; left: 0; top: 0;");
            img.src = "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==";
            if (presto) {
              img.width = img.height = 1;
              cm.display.wrapper.appendChild(img);
              img._top = img.offsetTop;
            }
            e5.dataTransfer.setDragImage(img, 0, 0);
            if (presto) {
              img.parentNode.removeChild(img);
            }
          }
        }
        function onDragOver(cm, e5) {
          var pos = posFromMouse(cm, e5);
          if (!pos) {
            return;
          }
          var frag = document.createDocumentFragment();
          drawSelectionCursor(cm, pos, frag);
          if (!cm.display.dragCursor) {
            cm.display.dragCursor = elt("div", null, "CodeMirror-cursors CodeMirror-dragcursors");
            cm.display.lineSpace.insertBefore(cm.display.dragCursor, cm.display.cursorDiv);
          }
          removeChildrenAndAdd(cm.display.dragCursor, frag);
        }
        function clearDragCursor(cm) {
          if (cm.display.dragCursor) {
            cm.display.lineSpace.removeChild(cm.display.dragCursor);
            cm.display.dragCursor = null;
          }
        }
        function forEachCodeMirror(f3) {
          if (!document.getElementsByClassName) {
            return;
          }
          var byClass = document.getElementsByClassName("CodeMirror"), editors = [];
          for (var i4 = 0; i4 < byClass.length; i4++) {
            var cm = byClass[i4].CodeMirror;
            if (cm) {
              editors.push(cm);
            }
          }
          if (editors.length) {
            editors[0].operation(function() {
              for (var i5 = 0; i5 < editors.length; i5++) {
                f3(editors[i5]);
              }
            });
          }
        }
        var globalsRegistered = false;
        function ensureGlobalHandlers() {
          if (globalsRegistered) {
            return;
          }
          registerGlobalHandlers();
          globalsRegistered = true;
        }
        function registerGlobalHandlers() {
          var resizeTimer;
          on(window, "resize", function() {
            if (resizeTimer == null) {
              resizeTimer = setTimeout(function() {
                resizeTimer = null;
                forEachCodeMirror(onResize);
              }, 100);
            }
          });
          on(window, "blur", function() {
            return forEachCodeMirror(onBlur);
          });
        }
        function onResize(cm) {
          var d4 = cm.display;
          d4.cachedCharWidth = d4.cachedTextHeight = d4.cachedPaddingH = null;
          d4.scrollbarsClipped = false;
          cm.setSize();
        }
        var keyNames = {
          3: "Pause",
          8: "Backspace",
          9: "Tab",
          13: "Enter",
          16: "Shift",
          17: "Ctrl",
          18: "Alt",
          19: "Pause",
          20: "CapsLock",
          27: "Esc",
          32: "Space",
          33: "PageUp",
          34: "PageDown",
          35: "End",
          36: "Home",
          37: "Left",
          38: "Up",
          39: "Right",
          40: "Down",
          44: "PrintScrn",
          45: "Insert",
          46: "Delete",
          59: ";",
          61: "=",
          91: "Mod",
          92: "Mod",
          93: "Mod",
          106: "*",
          107: "=",
          109: "-",
          110: ".",
          111: "/",
          145: "ScrollLock",
          173: "-",
          186: ";",
          187: "=",
          188: ",",
          189: "-",
          190: ".",
          191: "/",
          192: "`",
          219: "[",
          220: "\\",
          221: "]",
          222: "'",
          63232: "Up",
          63233: "Down",
          63234: "Left",
          63235: "Right",
          63272: "Delete",
          63273: "Home",
          63275: "End",
          63276: "PageUp",
          63277: "PageDown",
          63302: "Insert"
        };
        for (var i3 = 0; i3 < 10; i3++) {
          keyNames[i3 + 48] = keyNames[i3 + 96] = String(i3);
        }
        for (var i$1 = 65; i$1 <= 90; i$1++) {
          keyNames[i$1] = String.fromCharCode(i$1);
        }
        for (var i$2 = 1; i$2 <= 12; i$2++) {
          keyNames[i$2 + 111] = keyNames[i$2 + 63235] = "F" + i$2;
        }
        var keyMap = {};
        keyMap.basic = {
          "Left": "goCharLeft",
          "Right": "goCharRight",
          "Up": "goLineUp",
          "Down": "goLineDown",
          "End": "goLineEnd",
          "Home": "goLineStartSmart",
          "PageUp": "goPageUp",
          "PageDown": "goPageDown",
          "Delete": "delCharAfter",
          "Backspace": "delCharBefore",
          "Shift-Backspace": "delCharBefore",
          "Tab": "defaultTab",
          "Shift-Tab": "indentAuto",
          "Enter": "newlineAndIndent",
          "Insert": "toggleOverwrite",
          "Esc": "singleSelection"
        };
        keyMap.pcDefault = {
          "Ctrl-A": "selectAll",
          "Ctrl-D": "deleteLine",
          "Ctrl-Z": "undo",
          "Shift-Ctrl-Z": "redo",
          "Ctrl-Y": "redo",
          "Ctrl-Home": "goDocStart",
          "Ctrl-End": "goDocEnd",
          "Ctrl-Up": "goLineUp",
          "Ctrl-Down": "goLineDown",
          "Ctrl-Left": "goGroupLeft",
          "Ctrl-Right": "goGroupRight",
          "Alt-Left": "goLineStart",
          "Alt-Right": "goLineEnd",
          "Ctrl-Backspace": "delGroupBefore",
          "Ctrl-Delete": "delGroupAfter",
          "Ctrl-S": "save",
          "Ctrl-F": "find",
          "Ctrl-G": "findNext",
          "Shift-Ctrl-G": "findPrev",
          "Shift-Ctrl-F": "replace",
          "Shift-Ctrl-R": "replaceAll",
          "Ctrl-[": "indentLess",
          "Ctrl-]": "indentMore",
          "Ctrl-U": "undoSelection",
          "Shift-Ctrl-U": "redoSelection",
          "Alt-U": "redoSelection",
          "fallthrough": "basic"
        };
        keyMap.emacsy = {
          "Ctrl-F": "goCharRight",
          "Ctrl-B": "goCharLeft",
          "Ctrl-P": "goLineUp",
          "Ctrl-N": "goLineDown",
          "Alt-F": "goWordRight",
          "Alt-B": "goWordLeft",
          "Ctrl-A": "goLineStart",
          "Ctrl-E": "goLineEnd",
          "Ctrl-V": "goPageDown",
          "Shift-Ctrl-V": "goPageUp",
          "Ctrl-D": "delCharAfter",
          "Ctrl-H": "delCharBefore",
          "Alt-D": "delWordAfter",
          "Alt-Backspace": "delWordBefore",
          "Ctrl-K": "killLine",
          "Ctrl-T": "transposeChars",
          "Ctrl-O": "openLine"
        };
        keyMap.macDefault = {
          "Cmd-A": "selectAll",
          "Cmd-D": "deleteLine",
          "Cmd-Z": "undo",
          "Shift-Cmd-Z": "redo",
          "Cmd-Y": "redo",
          "Cmd-Home": "goDocStart",
          "Cmd-Up": "goDocStart",
          "Cmd-End": "goDocEnd",
          "Cmd-Down": "goDocEnd",
          "Alt-Left": "goGroupLeft",
          "Alt-Right": "goGroupRight",
          "Cmd-Left": "goLineLeft",
          "Cmd-Right": "goLineRight",
          "Alt-Backspace": "delGroupBefore",
          "Ctrl-Alt-Backspace": "delGroupAfter",
          "Alt-Delete": "delGroupAfter",
          "Cmd-S": "save",
          "Cmd-F": "find",
          "Cmd-G": "findNext",
          "Shift-Cmd-G": "findPrev",
          "Cmd-Alt-F": "replace",
          "Shift-Cmd-Alt-F": "replaceAll",
          "Cmd-[": "indentLess",
          "Cmd-]": "indentMore",
          "Cmd-Backspace": "delWrappedLineLeft",
          "Cmd-Delete": "delWrappedLineRight",
          "Cmd-U": "undoSelection",
          "Shift-Cmd-U": "redoSelection",
          "Ctrl-Up": "goDocStart",
          "Ctrl-Down": "goDocEnd",
          "fallthrough": ["basic", "emacsy"]
        };
        keyMap["default"] = mac ? keyMap.macDefault : keyMap.pcDefault;
        function normalizeKeyName(name106) {
          var parts = name106.split(/-(?!$)/);
          name106 = parts[parts.length - 1];
          var alt, ctrl, shift, cmd;
          for (var i4 = 0; i4 < parts.length - 1; i4++) {
            var mod2 = parts[i4];
            if (/^(cmd|meta|m)$/i.test(mod2)) {
              cmd = true;
            } else if (/^a(lt)?$/i.test(mod2)) {
              alt = true;
            } else if (/^(c|ctrl|control)$/i.test(mod2)) {
              ctrl = true;
            } else if (/^s(hift)?$/i.test(mod2)) {
              shift = true;
            } else {
              throw new Error("Unrecognized modifier name: " + mod2);
            }
          }
          if (alt) {
            name106 = "Alt-" + name106;
          }
          if (ctrl) {
            name106 = "Ctrl-" + name106;
          }
          if (cmd) {
            name106 = "Cmd-" + name106;
          }
          if (shift) {
            name106 = "Shift-" + name106;
          }
          return name106;
        }
        function normalizeKeyMap(keymap) {
          var copy2 = {};
          for (var keyname in keymap) {
            if (keymap.hasOwnProperty(keyname)) {
              var value = keymap[keyname];
              if (/^(name|fallthrough|(de|at)tach)$/.test(keyname)) {
                continue;
              }
              if (value == "...") {
                delete keymap[keyname];
                continue;
              }
              var keys = map3(keyname.split(" "), normalizeKeyName);
              for (var i4 = 0; i4 < keys.length; i4++) {
                var val = void 0, name106 = void 0;
                if (i4 == keys.length - 1) {
                  name106 = keys.join(" ");
                  val = value;
                } else {
                  name106 = keys.slice(0, i4 + 1).join(" ");
                  val = "...";
                }
                var prev = copy2[name106];
                if (!prev) {
                  copy2[name106] = val;
                } else if (prev != val) {
                  throw new Error("Inconsistent bindings for " + name106);
                }
              }
              delete keymap[keyname];
            }
          }
          for (var prop2 in copy2) {
            keymap[prop2] = copy2[prop2];
          }
          return keymap;
        }
        function lookupKey(key, map4, handle, context) {
          map4 = getKeyMap(map4);
          var found = map4.call ? map4.call(key, context) : map4[key];
          if (found === false) {
            return "nothing";
          }
          if (found === "...") {
            return "multi";
          }
          if (found != null && handle(found)) {
            return "handled";
          }
          if (map4.fallthrough) {
            if (Object.prototype.toString.call(map4.fallthrough) != "[object Array]") {
              return lookupKey(key, map4.fallthrough, handle, context);
            }
            for (var i4 = 0; i4 < map4.fallthrough.length; i4++) {
              var result = lookupKey(key, map4.fallthrough[i4], handle, context);
              if (result) {
                return result;
              }
            }
          }
        }
        function isModifierKey(value) {
          var name106 = typeof value == "string" ? value : keyNames[value.keyCode];
          return name106 == "Ctrl" || name106 == "Alt" || name106 == "Shift" || name106 == "Mod";
        }
        function addModifierNames(name106, event2, noShift) {
          var base = name106;
          if (event2.altKey && base != "Alt") {
            name106 = "Alt-" + name106;
          }
          if ((flipCtrlCmd ? event2.metaKey : event2.ctrlKey) && base != "Ctrl") {
            name106 = "Ctrl-" + name106;
          }
          if ((flipCtrlCmd ? event2.ctrlKey : event2.metaKey) && base != "Cmd") {
            name106 = "Cmd-" + name106;
          }
          if (!noShift && event2.shiftKey && base != "Shift") {
            name106 = "Shift-" + name106;
          }
          return name106;
        }
        function keyName(event2, noShift) {
          if (presto && event2.keyCode == 34 && event2["char"]) {
            return false;
          }
          var name106 = keyNames[event2.keyCode];
          if (name106 == null || event2.altGraphKey) {
            return false;
          }
          if (event2.keyCode == 3 && event2.code) {
            name106 = event2.code;
          }
          return addModifierNames(name106, event2, noShift);
        }
        function getKeyMap(val) {
          return typeof val == "string" ? keyMap[val] : val;
        }
        function deleteNearSelection(cm, compute) {
          var ranges = cm.doc.sel.ranges, kill = [];
          for (var i4 = 0; i4 < ranges.length; i4++) {
            var toKill = compute(ranges[i4]);
            while (kill.length && cmp(toKill.from, lst(kill).to) <= 0) {
              var replaced = kill.pop();
              if (cmp(replaced.from, toKill.from) < 0) {
                toKill.from = replaced.from;
                break;
              }
            }
            kill.push(toKill);
          }
          runInOp(cm, function() {
            for (var i5 = kill.length - 1; i5 >= 0; i5--) {
              replaceRange(cm.doc, "", kill[i5].from, kill[i5].to, "+delete");
            }
            ensureCursorVisible(cm);
          });
        }
        function moveCharLogically(line, ch, dir) {
          var target = skipExtendingChars(line.text, ch + dir, dir);
          return target < 0 || target > line.text.length ? null : target;
        }
        function moveLogically(line, start2, dir) {
          var ch = moveCharLogically(line, start2.ch, dir);
          return ch == null ? null : new Pos(start2.line, ch, dir < 0 ? "after" : "before");
        }
        function endOfLine(visually, cm, lineObj, lineNo2, dir) {
          if (visually) {
            if (cm.doc.direction == "rtl") {
              dir = -dir;
            }
            var order = getOrder(lineObj, cm.doc.direction);
            if (order) {
              var part = dir < 0 ? lst(order) : order[0];
              var moveInStorageOrder = dir < 0 == (part.level == 1);
              var sticky = moveInStorageOrder ? "after" : "before";
              var ch;
              if (part.level > 0 || cm.doc.direction == "rtl") {
                var prep = prepareMeasureForLine(cm, lineObj);
                ch = dir < 0 ? lineObj.text.length - 1 : 0;
                var targetTop = measureCharPrepared(cm, prep, ch).top;
                ch = findFirst(function(ch2) {
                  return measureCharPrepared(cm, prep, ch2).top == targetTop;
                }, dir < 0 == (part.level == 1) ? part.from : part.to - 1, ch);
                if (sticky == "before") {
                  ch = moveCharLogically(lineObj, ch, 1);
                }
              } else {
                ch = dir < 0 ? part.to : part.from;
              }
              return new Pos(lineNo2, ch, sticky);
            }
          }
          return new Pos(lineNo2, dir < 0 ? lineObj.text.length : 0, dir < 0 ? "before" : "after");
        }
        function moveVisually(cm, line, start2, dir) {
          var bidi = getOrder(line, cm.doc.direction);
          if (!bidi) {
            return moveLogically(line, start2, dir);
          }
          if (start2.ch >= line.text.length) {
            start2.ch = line.text.length;
            start2.sticky = "before";
          } else if (start2.ch <= 0) {
            start2.ch = 0;
            start2.sticky = "after";
          }
          var partPos = getBidiPartAt(bidi, start2.ch, start2.sticky), part = bidi[partPos];
          if (cm.doc.direction == "ltr" && part.level % 2 == 0 && (dir > 0 ? part.to > start2.ch : part.from < start2.ch)) {
            return moveLogically(line, start2, dir);
          }
          var mv = function(pos, dir2) {
            return moveCharLogically(line, pos instanceof Pos ? pos.ch : pos, dir2);
          };
          var prep;
          var getWrappedLineExtent = function(ch2) {
            if (!cm.options.lineWrapping) {
              return { begin: 0, end: line.text.length };
            }
            prep = prep || prepareMeasureForLine(cm, line);
            return wrappedLineExtentChar(cm, line, prep, ch2);
          };
          var wrappedLineExtent2 = getWrappedLineExtent(start2.sticky == "before" ? mv(start2, -1) : start2.ch);
          if (cm.doc.direction == "rtl" || part.level == 1) {
            var moveInStorageOrder = part.level == 1 == dir < 0;
            var ch = mv(start2, moveInStorageOrder ? 1 : -1);
            if (ch != null && (!moveInStorageOrder ? ch >= part.from && ch >= wrappedLineExtent2.begin : ch <= part.to && ch <= wrappedLineExtent2.end)) {
              var sticky = moveInStorageOrder ? "before" : "after";
              return new Pos(start2.line, ch, sticky);
            }
          }
          var searchInVisualLine = function(partPos2, dir2, wrappedLineExtent3) {
            var getRes = function(ch3, moveInStorageOrder3) {
              return moveInStorageOrder3 ? new Pos(start2.line, mv(ch3, 1), "before") : new Pos(start2.line, ch3, "after");
            };
            for (; partPos2 >= 0 && partPos2 < bidi.length; partPos2 += dir2) {
              var part2 = bidi[partPos2];
              var moveInStorageOrder2 = dir2 > 0 == (part2.level != 1);
              var ch2 = moveInStorageOrder2 ? wrappedLineExtent3.begin : mv(wrappedLineExtent3.end, -1);
              if (part2.from <= ch2 && ch2 < part2.to) {
                return getRes(ch2, moveInStorageOrder2);
              }
              ch2 = moveInStorageOrder2 ? part2.from : mv(part2.to, -1);
              if (wrappedLineExtent3.begin <= ch2 && ch2 < wrappedLineExtent3.end) {
                return getRes(ch2, moveInStorageOrder2);
              }
            }
          };
          var res = searchInVisualLine(partPos + dir, dir, wrappedLineExtent2);
          if (res) {
            return res;
          }
          var nextCh = dir > 0 ? wrappedLineExtent2.end : mv(wrappedLineExtent2.begin, -1);
          if (nextCh != null && !(dir > 0 && nextCh == line.text.length)) {
            res = searchInVisualLine(dir > 0 ? 0 : bidi.length - 1, dir, getWrappedLineExtent(nextCh));
            if (res) {
              return res;
            }
          }
          return null;
        }
        var commands = {
          selectAll,
          singleSelection: function(cm) {
            return cm.setSelection(cm.getCursor("anchor"), cm.getCursor("head"), sel_dontScroll);
          },
          killLine: function(cm) {
            return deleteNearSelection(cm, function(range3) {
              if (range3.empty()) {
                var len = getLine(cm.doc, range3.head.line).text.length;
                if (range3.head.ch == len && range3.head.line < cm.lastLine()) {
                  return { from: range3.head, to: Pos(range3.head.line + 1, 0) };
                } else {
                  return { from: range3.head, to: Pos(range3.head.line, len) };
                }
              } else {
                return { from: range3.from(), to: range3.to() };
              }
            });
          },
          deleteLine: function(cm) {
            return deleteNearSelection(cm, function(range3) {
              return {
                from: Pos(range3.from().line, 0),
                to: clipPos(cm.doc, Pos(range3.to().line + 1, 0))
              };
            });
          },
          delLineLeft: function(cm) {
            return deleteNearSelection(cm, function(range3) {
              return {
                from: Pos(range3.from().line, 0),
                to: range3.from()
              };
            });
          },
          delWrappedLineLeft: function(cm) {
            return deleteNearSelection(cm, function(range3) {
              var top = cm.charCoords(range3.head, "div").top + 5;
              var leftPos = cm.coordsChar({ left: 0, top }, "div");
              return { from: leftPos, to: range3.from() };
            });
          },
          delWrappedLineRight: function(cm) {
            return deleteNearSelection(cm, function(range3) {
              var top = cm.charCoords(range3.head, "div").top + 5;
              var rightPos = cm.coordsChar({ left: cm.display.lineDiv.offsetWidth + 100, top }, "div");
              return { from: range3.from(), to: rightPos };
            });
          },
          undo: function(cm) {
            return cm.undo();
          },
          redo: function(cm) {
            return cm.redo();
          },
          undoSelection: function(cm) {
            return cm.undoSelection();
          },
          redoSelection: function(cm) {
            return cm.redoSelection();
          },
          goDocStart: function(cm) {
            return cm.extendSelection(Pos(cm.firstLine(), 0));
          },
          goDocEnd: function(cm) {
            return cm.extendSelection(Pos(cm.lastLine()));
          },
          goLineStart: function(cm) {
            return cm.extendSelectionsBy(function(range3) {
              return lineStart(cm, range3.head.line);
            }, { origin: "+move", bias: 1 });
          },
          goLineStartSmart: function(cm) {
            return cm.extendSelectionsBy(function(range3) {
              return lineStartSmart(cm, range3.head);
            }, { origin: "+move", bias: 1 });
          },
          goLineEnd: function(cm) {
            return cm.extendSelectionsBy(function(range3) {
              return lineEnd(cm, range3.head.line);
            }, { origin: "+move", bias: -1 });
          },
          goLineRight: function(cm) {
            return cm.extendSelectionsBy(function(range3) {
              var top = cm.cursorCoords(range3.head, "div").top + 5;
              return cm.coordsChar({ left: cm.display.lineDiv.offsetWidth + 100, top }, "div");
            }, sel_move);
          },
          goLineLeft: function(cm) {
            return cm.extendSelectionsBy(function(range3) {
              var top = cm.cursorCoords(range3.head, "div").top + 5;
              return cm.coordsChar({ left: 0, top }, "div");
            }, sel_move);
          },
          goLineLeftSmart: function(cm) {
            return cm.extendSelectionsBy(function(range3) {
              var top = cm.cursorCoords(range3.head, "div").top + 5;
              var pos = cm.coordsChar({ left: 0, top }, "div");
              if (pos.ch < cm.getLine(pos.line).search(/\S/)) {
                return lineStartSmart(cm, range3.head);
              }
              return pos;
            }, sel_move);
          },
          goLineUp: function(cm) {
            return cm.moveV(-1, "line");
          },
          goLineDown: function(cm) {
            return cm.moveV(1, "line");
          },
          goPageUp: function(cm) {
            return cm.moveV(-1, "page");
          },
          goPageDown: function(cm) {
            return cm.moveV(1, "page");
          },
          goCharLeft: function(cm) {
            return cm.moveH(-1, "char");
          },
          goCharRight: function(cm) {
            return cm.moveH(1, "char");
          },
          goColumnLeft: function(cm) {
            return cm.moveH(-1, "column");
          },
          goColumnRight: function(cm) {
            return cm.moveH(1, "column");
          },
          goWordLeft: function(cm) {
            return cm.moveH(-1, "word");
          },
          goGroupRight: function(cm) {
            return cm.moveH(1, "group");
          },
          goGroupLeft: function(cm) {
            return cm.moveH(-1, "group");
          },
          goWordRight: function(cm) {
            return cm.moveH(1, "word");
          },
          delCharBefore: function(cm) {
            return cm.deleteH(-1, "char");
          },
          delCharAfter: function(cm) {
            return cm.deleteH(1, "char");
          },
          delWordBefore: function(cm) {
            return cm.deleteH(-1, "word");
          },
          delWordAfter: function(cm) {
            return cm.deleteH(1, "word");
          },
          delGroupBefore: function(cm) {
            return cm.deleteH(-1, "group");
          },
          delGroupAfter: function(cm) {
            return cm.deleteH(1, "group");
          },
          indentAuto: function(cm) {
            return cm.indentSelection("smart");
          },
          indentMore: function(cm) {
            return cm.indentSelection("add");
          },
          indentLess: function(cm) {
            return cm.indentSelection("subtract");
          },
          insertTab: function(cm) {
            return cm.replaceSelection("	");
          },
          insertSoftTab: function(cm) {
            var spaces = [], ranges = cm.listSelections(), tabSize = cm.options.tabSize;
            for (var i4 = 0; i4 < ranges.length; i4++) {
              var pos = ranges[i4].from();
              var col = countColumn(cm.getLine(pos.line), pos.ch, tabSize);
              spaces.push(spaceStr(tabSize - col % tabSize));
            }
            cm.replaceSelections(spaces);
          },
          defaultTab: function(cm) {
            if (cm.somethingSelected()) {
              cm.indentSelection("add");
            } else {
              cm.execCommand("insertTab");
            }
          },
          transposeChars: function(cm) {
            return runInOp(cm, function() {
              var ranges = cm.listSelections(), newSel = [];
              for (var i4 = 0; i4 < ranges.length; i4++) {
                if (!ranges[i4].empty()) {
                  continue;
                }
                var cur = ranges[i4].head, line = getLine(cm.doc, cur.line).text;
                if (line) {
                  if (cur.ch == line.length) {
                    cur = new Pos(cur.line, cur.ch - 1);
                  }
                  if (cur.ch > 0) {
                    cur = new Pos(cur.line, cur.ch + 1);
                    cm.replaceRange(line.charAt(cur.ch - 1) + line.charAt(cur.ch - 2), Pos(cur.line, cur.ch - 2), cur, "+transpose");
                  } else if (cur.line > cm.doc.first) {
                    var prev = getLine(cm.doc, cur.line - 1).text;
                    if (prev) {
                      cur = new Pos(cur.line, 1);
                      cm.replaceRange(line.charAt(0) + cm.doc.lineSeparator() + prev.charAt(prev.length - 1), Pos(cur.line - 1, prev.length - 1), cur, "+transpose");
                    }
                  }
                }
                newSel.push(new Range3(cur, cur));
              }
              cm.setSelections(newSel);
            });
          },
          newlineAndIndent: function(cm) {
            return runInOp(cm, function() {
              var sels = cm.listSelections();
              for (var i4 = sels.length - 1; i4 >= 0; i4--) {
                cm.replaceRange(cm.doc.lineSeparator(), sels[i4].anchor, sels[i4].head, "+input");
              }
              sels = cm.listSelections();
              for (var i$12 = 0; i$12 < sels.length; i$12++) {
                cm.indentLine(sels[i$12].from().line, null, true);
              }
              ensureCursorVisible(cm);
            });
          },
          openLine: function(cm) {
            return cm.replaceSelection("\n", "start");
          },
          toggleOverwrite: function(cm) {
            return cm.toggleOverwrite();
          }
        };
        function lineStart(cm, lineN) {
          var line = getLine(cm.doc, lineN);
          var visual = visualLine(line);
          if (visual != line) {
            lineN = lineNo(visual);
          }
          return endOfLine(true, cm, visual, lineN, 1);
        }
        function lineEnd(cm, lineN) {
          var line = getLine(cm.doc, lineN);
          var visual = visualLineEnd(line);
          if (visual != line) {
            lineN = lineNo(visual);
          }
          return endOfLine(true, cm, line, lineN, -1);
        }
        function lineStartSmart(cm, pos) {
          var start2 = lineStart(cm, pos.line);
          var line = getLine(cm.doc, start2.line);
          var order = getOrder(line, cm.doc.direction);
          if (!order || order[0].level == 0) {
            var firstNonWS = Math.max(start2.ch, line.text.search(/\S/));
            var inWS = pos.line == start2.line && pos.ch <= firstNonWS && pos.ch;
            return Pos(start2.line, inWS ? 0 : firstNonWS, start2.sticky);
          }
          return start2;
        }
        function doHandleBinding(cm, bound, dropShift) {
          if (typeof bound == "string") {
            bound = commands[bound];
            if (!bound) {
              return false;
            }
          }
          cm.display.input.ensurePolled();
          var prevShift = cm.display.shift, done = false;
          try {
            if (cm.isReadOnly()) {
              cm.state.suppressEdits = true;
            }
            if (dropShift) {
              cm.display.shift = false;
            }
            done = bound(cm) != Pass;
          } finally {
            cm.display.shift = prevShift;
            cm.state.suppressEdits = false;
          }
          return done;
        }
        function lookupKeyForEditor(cm, name106, handle) {
          for (var i4 = 0; i4 < cm.state.keyMaps.length; i4++) {
            var result = lookupKey(name106, cm.state.keyMaps[i4], handle, cm);
            if (result) {
              return result;
            }
          }
          return cm.options.extraKeys && lookupKey(name106, cm.options.extraKeys, handle, cm) || lookupKey(name106, cm.options.keyMap, handle, cm);
        }
        var stopSeq = new Delayed();
        function dispatchKey(cm, name106, e5, handle) {
          var seq = cm.state.keySeq;
          if (seq) {
            if (isModifierKey(name106)) {
              return "handled";
            }
            if (/\'$/.test(name106)) {
              cm.state.keySeq = null;
            } else {
              stopSeq.set(50, function() {
                if (cm.state.keySeq == seq) {
                  cm.state.keySeq = null;
                  cm.display.input.reset();
                }
              });
            }
            if (dispatchKeyInner(cm, seq + " " + name106, e5, handle)) {
              return true;
            }
          }
          return dispatchKeyInner(cm, name106, e5, handle);
        }
        function dispatchKeyInner(cm, name106, e5, handle) {
          var result = lookupKeyForEditor(cm, name106, handle);
          if (result == "multi") {
            cm.state.keySeq = name106;
          }
          if (result == "handled") {
            signalLater(cm, "keyHandled", cm, name106, e5);
          }
          if (result == "handled" || result == "multi") {
            e_preventDefault(e5);
            restartBlink(cm);
          }
          return !!result;
        }
        function handleKeyBinding(cm, e5) {
          var name106 = keyName(e5, true);
          if (!name106) {
            return false;
          }
          if (e5.shiftKey && !cm.state.keySeq) {
            return dispatchKey(cm, "Shift-" + name106, e5, function(b2) {
              return doHandleBinding(cm, b2, true);
            }) || dispatchKey(cm, name106, e5, function(b2) {
              if (typeof b2 == "string" ? /^go[A-Z]/.test(b2) : b2.motion) {
                return doHandleBinding(cm, b2);
              }
            });
          } else {
            return dispatchKey(cm, name106, e5, function(b2) {
              return doHandleBinding(cm, b2);
            });
          }
        }
        function handleCharBinding(cm, e5, ch) {
          return dispatchKey(cm, "'" + ch + "'", e5, function(b2) {
            return doHandleBinding(cm, b2, true);
          });
        }
        var lastStoppedKey = null;
        function onKeyDown(e5) {
          var cm = this;
          if (e5.target && e5.target != cm.display.input.getField()) {
            return;
          }
          cm.curOp.focus = activeElt();
          if (signalDOMEvent(cm, e5)) {
            return;
          }
          if (ie && ie_version < 11 && e5.keyCode == 27) {
            e5.returnValue = false;
          }
          var code = e5.keyCode;
          cm.display.shift = code == 16 || e5.shiftKey;
          var handled = handleKeyBinding(cm, e5);
          if (presto) {
            lastStoppedKey = handled ? code : null;
            if (!handled && code == 88 && !hasCopyEvent && (mac ? e5.metaKey : e5.ctrlKey)) {
              cm.replaceSelection("", null, "cut");
            }
          }
          if (gecko && !mac && !handled && code == 46 && e5.shiftKey && !e5.ctrlKey && document.execCommand) {
            document.execCommand("cut");
          }
          if (code == 18 && !/\bCodeMirror-crosshair\b/.test(cm.display.lineDiv.className)) {
            showCrossHair(cm);
          }
        }
        function showCrossHair(cm) {
          var lineDiv = cm.display.lineDiv;
          addClass2(lineDiv, "CodeMirror-crosshair");
          function up(e5) {
            if (e5.keyCode == 18 || !e5.altKey) {
              rmClass(lineDiv, "CodeMirror-crosshair");
              off(document, "keyup", up);
              off(document, "mouseover", up);
            }
          }
          on(document, "keyup", up);
          on(document, "mouseover", up);
        }
        function onKeyUp(e5) {
          if (e5.keyCode == 16) {
            this.doc.sel.shift = false;
          }
          signalDOMEvent(this, e5);
        }
        function onKeyPress(e5) {
          var cm = this;
          if (e5.target && e5.target != cm.display.input.getField()) {
            return;
          }
          if (eventInWidget(cm.display, e5) || signalDOMEvent(cm, e5) || e5.ctrlKey && !e5.altKey || mac && e5.metaKey) {
            return;
          }
          var keyCode = e5.keyCode, charCode = e5.charCode;
          if (presto && keyCode == lastStoppedKey) {
            lastStoppedKey = null;
            e_preventDefault(e5);
            return;
          }
          if (presto && (!e5.which || e5.which < 10) && handleKeyBinding(cm, e5)) {
            return;
          }
          var ch = String.fromCharCode(charCode == null ? keyCode : charCode);
          if (ch == "\b") {
            return;
          }
          if (handleCharBinding(cm, e5, ch)) {
            return;
          }
          cm.display.input.onKeyPress(e5);
        }
        var DOUBLECLICK_DELAY = 400;
        var PastClick = function(time, pos, button) {
          this.time = time;
          this.pos = pos;
          this.button = button;
        };
        PastClick.prototype.compare = function(time, pos, button) {
          return this.time + DOUBLECLICK_DELAY > time && cmp(pos, this.pos) == 0 && button == this.button;
        };
        var lastClick, lastDoubleClick;
        function clickRepeat(pos, button) {
          var now = +new Date();
          if (lastDoubleClick && lastDoubleClick.compare(now, pos, button)) {
            lastClick = lastDoubleClick = null;
            return "triple";
          } else if (lastClick && lastClick.compare(now, pos, button)) {
            lastDoubleClick = new PastClick(now, pos, button);
            lastClick = null;
            return "double";
          } else {
            lastClick = new PastClick(now, pos, button);
            lastDoubleClick = null;
            return "single";
          }
        }
        function onMouseDown(e5) {
          var cm = this, display = cm.display;
          if (signalDOMEvent(cm, e5) || display.activeTouch && display.input.supportsTouch()) {
            return;
          }
          display.input.ensurePolled();
          display.shift = e5.shiftKey;
          if (eventInWidget(display, e5)) {
            if (!webkit) {
              display.scroller.draggable = false;
              setTimeout(function() {
                return display.scroller.draggable = true;
              }, 100);
            }
            return;
          }
          if (clickInGutter(cm, e5)) {
            return;
          }
          var pos = posFromMouse(cm, e5), button = e_button(e5), repeat = pos ? clickRepeat(pos, button) : "single";
          window.focus();
          if (button == 1 && cm.state.selectingText) {
            cm.state.selectingText(e5);
          }
          if (pos && handleMappedButton(cm, button, pos, repeat, e5)) {
            return;
          }
          if (button == 1) {
            if (pos) {
              leftButtonDown(cm, pos, repeat, e5);
            } else if (e_target(e5) == display.scroller) {
              e_preventDefault(e5);
            }
          } else if (button == 2) {
            if (pos) {
              extendSelection(cm.doc, pos);
            }
            setTimeout(function() {
              return display.input.focus();
            }, 20);
          } else if (button == 3) {
            if (captureRightClick) {
              cm.display.input.onContextMenu(e5);
            } else {
              delayBlurEvent(cm);
            }
          }
        }
        function handleMappedButton(cm, button, pos, repeat, event2) {
          var name106 = "Click";
          if (repeat == "double") {
            name106 = "Double" + name106;
          } else if (repeat == "triple") {
            name106 = "Triple" + name106;
          }
          name106 = (button == 1 ? "Left" : button == 2 ? "Middle" : "Right") + name106;
          return dispatchKey(cm, addModifierNames(name106, event2), event2, function(bound) {
            if (typeof bound == "string") {
              bound = commands[bound];
            }
            if (!bound) {
              return false;
            }
            var done = false;
            try {
              if (cm.isReadOnly()) {
                cm.state.suppressEdits = true;
              }
              done = bound(cm, pos) != Pass;
            } finally {
              cm.state.suppressEdits = false;
            }
            return done;
          });
        }
        function configureMouse(cm, repeat, event2) {
          var option = cm.getOption("configureMouse");
          var value = option ? option(cm, repeat, event2) : {};
          if (value.unit == null) {
            var rect = chromeOS ? event2.shiftKey && event2.metaKey : event2.altKey;
            value.unit = rect ? "rectangle" : repeat == "single" ? "char" : repeat == "double" ? "word" : "line";
          }
          if (value.extend == null || cm.doc.extend) {
            value.extend = cm.doc.extend || event2.shiftKey;
          }
          if (value.addNew == null) {
            value.addNew = mac ? event2.metaKey : event2.ctrlKey;
          }
          if (value.moveOnDrag == null) {
            value.moveOnDrag = !(mac ? event2.altKey : event2.ctrlKey);
          }
          return value;
        }
        function leftButtonDown(cm, pos, repeat, event2) {
          if (ie) {
            setTimeout(bind(ensureFocus, cm), 0);
          } else {
            cm.curOp.focus = activeElt();
          }
          var behavior = configureMouse(cm, repeat, event2);
          var sel = cm.doc.sel, contained;
          if (cm.options.dragDrop && dragAndDrop && !cm.isReadOnly() && repeat == "single" && (contained = sel.contains(pos)) > -1 && (cmp((contained = sel.ranges[contained]).from(), pos) < 0 || pos.xRel > 0) && (cmp(contained.to(), pos) > 0 || pos.xRel < 0)) {
            leftButtonStartDrag(cm, event2, pos, behavior);
          } else {
            leftButtonSelect(cm, event2, pos, behavior);
          }
        }
        function leftButtonStartDrag(cm, event2, pos, behavior) {
          var display = cm.display, moved = false;
          var dragEnd = operation(cm, function(e5) {
            if (webkit) {
              display.scroller.draggable = false;
            }
            cm.state.draggingText = false;
            off(display.wrapper.ownerDocument, "mouseup", dragEnd);
            off(display.wrapper.ownerDocument, "mousemove", mouseMove);
            off(display.scroller, "dragstart", dragStart);
            off(display.scroller, "drop", dragEnd);
            if (!moved) {
              e_preventDefault(e5);
              if (!behavior.addNew) {
                extendSelection(cm.doc, pos, null, null, behavior.extend);
              }
              if (webkit && !safari || ie && ie_version == 9) {
                setTimeout(function() {
                  display.wrapper.ownerDocument.body.focus({ preventScroll: true });
                  display.input.focus();
                }, 20);
              } else {
                display.input.focus();
              }
            }
          });
          var mouseMove = function(e22) {
            moved = moved || Math.abs(event2.clientX - e22.clientX) + Math.abs(event2.clientY - e22.clientY) >= 10;
          };
          var dragStart = function() {
            return moved = true;
          };
          if (webkit) {
            display.scroller.draggable = true;
          }
          cm.state.draggingText = dragEnd;
          dragEnd.copy = !behavior.moveOnDrag;
          if (display.scroller.dragDrop) {
            display.scroller.dragDrop();
          }
          on(display.wrapper.ownerDocument, "mouseup", dragEnd);
          on(display.wrapper.ownerDocument, "mousemove", mouseMove);
          on(display.scroller, "dragstart", dragStart);
          on(display.scroller, "drop", dragEnd);
          delayBlurEvent(cm);
          setTimeout(function() {
            return display.input.focus();
          }, 20);
        }
        function rangeForUnit(cm, pos, unit) {
          if (unit == "char") {
            return new Range3(pos, pos);
          }
          if (unit == "word") {
            return cm.findWordAt(pos);
          }
          if (unit == "line") {
            return new Range3(Pos(pos.line, 0), clipPos(cm.doc, Pos(pos.line + 1, 0)));
          }
          var result = unit(cm, pos);
          return new Range3(result.from, result.to);
        }
        function leftButtonSelect(cm, event2, start2, behavior) {
          var display = cm.display, doc = cm.doc;
          e_preventDefault(event2);
          var ourRange, ourIndex, startSel = doc.sel, ranges = startSel.ranges;
          if (behavior.addNew && !behavior.extend) {
            ourIndex = doc.sel.contains(start2);
            if (ourIndex > -1) {
              ourRange = ranges[ourIndex];
            } else {
              ourRange = new Range3(start2, start2);
            }
          } else {
            ourRange = doc.sel.primary();
            ourIndex = doc.sel.primIndex;
          }
          if (behavior.unit == "rectangle") {
            if (!behavior.addNew) {
              ourRange = new Range3(start2, start2);
            }
            start2 = posFromMouse(cm, event2, true, true);
            ourIndex = -1;
          } else {
            var range3 = rangeForUnit(cm, start2, behavior.unit);
            if (behavior.extend) {
              ourRange = extendRange(ourRange, range3.anchor, range3.head, behavior.extend);
            } else {
              ourRange = range3;
            }
          }
          if (!behavior.addNew) {
            ourIndex = 0;
            setSelection(doc, new Selection4([ourRange], 0), sel_mouse);
            startSel = doc.sel;
          } else if (ourIndex == -1) {
            ourIndex = ranges.length;
            setSelection(doc, normalizeSelection(cm, ranges.concat([ourRange]), ourIndex), { scroll: false, origin: "*mouse" });
          } else if (ranges.length > 1 && ranges[ourIndex].empty() && behavior.unit == "char" && !behavior.extend) {
            setSelection(doc, normalizeSelection(cm, ranges.slice(0, ourIndex).concat(ranges.slice(ourIndex + 1)), 0), { scroll: false, origin: "*mouse" });
            startSel = doc.sel;
          } else {
            replaceOneSelection(doc, ourIndex, ourRange, sel_mouse);
          }
          var lastPos = start2;
          function extendTo(pos) {
            if (cmp(lastPos, pos) == 0) {
              return;
            }
            lastPos = pos;
            if (behavior.unit == "rectangle") {
              var ranges2 = [], tabSize = cm.options.tabSize;
              var startCol = countColumn(getLine(doc, start2.line).text, start2.ch, tabSize);
              var posCol = countColumn(getLine(doc, pos.line).text, pos.ch, tabSize);
              var left = Math.min(startCol, posCol), right = Math.max(startCol, posCol);
              for (var line = Math.min(start2.line, pos.line), end = Math.min(cm.lastLine(), Math.max(start2.line, pos.line)); line <= end; line++) {
                var text = getLine(doc, line).text, leftPos = findColumn(text, left, tabSize);
                if (left == right) {
                  ranges2.push(new Range3(Pos(line, leftPos), Pos(line, leftPos)));
                } else if (text.length > leftPos) {
                  ranges2.push(new Range3(Pos(line, leftPos), Pos(line, findColumn(text, right, tabSize))));
                }
              }
              if (!ranges2.length) {
                ranges2.push(new Range3(start2, start2));
              }
              setSelection(doc, normalizeSelection(cm, startSel.ranges.slice(0, ourIndex).concat(ranges2), ourIndex), { origin: "*mouse", scroll: false });
              cm.scrollIntoView(pos);
            } else {
              var oldRange = ourRange;
              var range4 = rangeForUnit(cm, pos, behavior.unit);
              var anchor = oldRange.anchor, head;
              if (cmp(range4.anchor, anchor) > 0) {
                head = range4.head;
                anchor = minPos(oldRange.from(), range4.anchor);
              } else {
                head = range4.anchor;
                anchor = maxPos(oldRange.to(), range4.head);
              }
              var ranges$1 = startSel.ranges.slice(0);
              ranges$1[ourIndex] = bidiSimplify(cm, new Range3(clipPos(doc, anchor), head));
              setSelection(doc, normalizeSelection(cm, ranges$1, ourIndex), sel_mouse);
            }
          }
          var editorSize = display.wrapper.getBoundingClientRect();
          var counter = 0;
          function extend2(e5) {
            var curCount = ++counter;
            var cur = posFromMouse(cm, e5, true, behavior.unit == "rectangle");
            if (!cur) {
              return;
            }
            if (cmp(cur, lastPos) != 0) {
              cm.curOp.focus = activeElt();
              extendTo(cur);
              var visible = visibleLines(display, doc);
              if (cur.line >= visible.to || cur.line < visible.from) {
                setTimeout(operation(cm, function() {
                  if (counter == curCount) {
                    extend2(e5);
                  }
                }), 150);
              }
            } else {
              var outside = e5.clientY < editorSize.top ? -20 : e5.clientY > editorSize.bottom ? 20 : 0;
              if (outside) {
                setTimeout(operation(cm, function() {
                  if (counter != curCount) {
                    return;
                  }
                  display.scroller.scrollTop += outside;
                  extend2(e5);
                }), 50);
              }
            }
          }
          function done(e5) {
            cm.state.selectingText = false;
            counter = Infinity;
            if (e5) {
              e_preventDefault(e5);
              display.input.focus();
            }
            off(display.wrapper.ownerDocument, "mousemove", move);
            off(display.wrapper.ownerDocument, "mouseup", up);
            doc.history.lastSelOrigin = null;
          }
          var move = operation(cm, function(e5) {
            if (e5.buttons === 0 || !e_button(e5)) {
              done(e5);
            } else {
              extend2(e5);
            }
          });
          var up = operation(cm, done);
          cm.state.selectingText = up;
          on(display.wrapper.ownerDocument, "mousemove", move);
          on(display.wrapper.ownerDocument, "mouseup", up);
        }
        function bidiSimplify(cm, range3) {
          var anchor = range3.anchor;
          var head = range3.head;
          var anchorLine = getLine(cm.doc, anchor.line);
          if (cmp(anchor, head) == 0 && anchor.sticky == head.sticky) {
            return range3;
          }
          var order = getOrder(anchorLine);
          if (!order) {
            return range3;
          }
          var index2 = getBidiPartAt(order, anchor.ch, anchor.sticky), part = order[index2];
          if (part.from != anchor.ch && part.to != anchor.ch) {
            return range3;
          }
          var boundary = index2 + (part.from == anchor.ch == (part.level != 1) ? 0 : 1);
          if (boundary == 0 || boundary == order.length) {
            return range3;
          }
          var leftSide;
          if (head.line != anchor.line) {
            leftSide = (head.line - anchor.line) * (cm.doc.direction == "ltr" ? 1 : -1) > 0;
          } else {
            var headIndex = getBidiPartAt(order, head.ch, head.sticky);
            var dir = headIndex - index2 || (head.ch - anchor.ch) * (part.level == 1 ? -1 : 1);
            if (headIndex == boundary - 1 || headIndex == boundary) {
              leftSide = dir < 0;
            } else {
              leftSide = dir > 0;
            }
          }
          var usePart = order[boundary + (leftSide ? -1 : 0)];
          var from = leftSide == (usePart.level == 1);
          var ch = from ? usePart.from : usePart.to, sticky = from ? "after" : "before";
          return anchor.ch == ch && anchor.sticky == sticky ? range3 : new Range3(new Pos(anchor.line, ch, sticky), head);
        }
        function gutterEvent(cm, e5, type, prevent) {
          var mX, mY;
          if (e5.touches) {
            mX = e5.touches[0].clientX;
            mY = e5.touches[0].clientY;
          } else {
            try {
              mX = e5.clientX;
              mY = e5.clientY;
            } catch (e6) {
              return false;
            }
          }
          if (mX >= Math.floor(cm.display.gutters.getBoundingClientRect().right)) {
            return false;
          }
          if (prevent) {
            e_preventDefault(e5);
          }
          var display = cm.display;
          var lineBox = display.lineDiv.getBoundingClientRect();
          if (mY > lineBox.bottom || !hasHandler(cm, type)) {
            return e_defaultPrevented(e5);
          }
          mY -= lineBox.top - display.viewOffset;
          for (var i4 = 0; i4 < cm.display.gutterSpecs.length; ++i4) {
            var g3 = display.gutters.childNodes[i4];
            if (g3 && g3.getBoundingClientRect().right >= mX) {
              var line = lineAtHeight(cm.doc, mY);
              var gutter = cm.display.gutterSpecs[i4];
              signal(cm, type, cm, line, gutter.className, e5);
              return e_defaultPrevented(e5);
            }
          }
        }
        function clickInGutter(cm, e5) {
          return gutterEvent(cm, e5, "gutterClick", true);
        }
        function onContextMenu(cm, e5) {
          if (eventInWidget(cm.display, e5) || contextMenuInGutter(cm, e5)) {
            return;
          }
          if (signalDOMEvent(cm, e5, "contextmenu")) {
            return;
          }
          if (!captureRightClick) {
            cm.display.input.onContextMenu(e5);
          }
        }
        function contextMenuInGutter(cm, e5) {
          if (!hasHandler(cm, "gutterContextMenu")) {
            return false;
          }
          return gutterEvent(cm, e5, "gutterContextMenu", false);
        }
        function themeChanged(cm) {
          cm.display.wrapper.className = cm.display.wrapper.className.replace(/\s*cm-s-\S+/g, "") + cm.options.theme.replace(/(^|\s)\s*/g, " cm-s-");
          clearCaches(cm);
        }
        var Init = { toString: function() {
          return "CodeMirror.Init";
        } };
        var defaults = {};
        var optionHandlers = {};
        function defineOptions(CodeMirror6) {
          var optionHandlers2 = CodeMirror6.optionHandlers;
          function option(name106, deflt, handle, notOnInit) {
            CodeMirror6.defaults[name106] = deflt;
            if (handle) {
              optionHandlers2[name106] = notOnInit ? function(cm, val, old) {
                if (old != Init) {
                  handle(cm, val, old);
                }
              } : handle;
            }
          }
          CodeMirror6.defineOption = option;
          CodeMirror6.Init = Init;
          option("value", "", function(cm, val) {
            return cm.setValue(val);
          }, true);
          option("mode", null, function(cm, val) {
            cm.doc.modeOption = val;
            loadMode(cm);
          }, true);
          option("indentUnit", 2, loadMode, true);
          option("indentWithTabs", false);
          option("smartIndent", true);
          option("tabSize", 4, function(cm) {
            resetModeState(cm);
            clearCaches(cm);
            regChange(cm);
          }, true);
          option("lineSeparator", null, function(cm, val) {
            cm.doc.lineSep = val;
            if (!val) {
              return;
            }
            var newBreaks = [], lineNo2 = cm.doc.first;
            cm.doc.iter(function(line) {
              for (var pos = 0; ; ) {
                var found = line.text.indexOf(val, pos);
                if (found == -1) {
                  break;
                }
                pos = found + val.length;
                newBreaks.push(Pos(lineNo2, found));
              }
              lineNo2++;
            });
            for (var i4 = newBreaks.length - 1; i4 >= 0; i4--) {
              replaceRange(cm.doc, val, newBreaks[i4], Pos(newBreaks[i4].line, newBreaks[i4].ch + val.length));
            }
          });
          option("specialChars", /[\u0000-\u001f\u007f-\u009f\u00ad\u061c\u200b-\u200f\u2028\u2029\ufeff\ufff9-\ufffc]/g, function(cm, val, old) {
            cm.state.specialChars = new RegExp(val.source + (val.test("	") ? "" : "|	"), "g");
            if (old != Init) {
              cm.refresh();
            }
          });
          option("specialCharPlaceholder", defaultSpecialCharPlaceholder, function(cm) {
            return cm.refresh();
          }, true);
          option("electricChars", true);
          option("inputStyle", mobile ? "contenteditable" : "textarea", function() {
            throw new Error("inputStyle can not (yet) be changed in a running editor");
          }, true);
          option("spellcheck", false, function(cm, val) {
            return cm.getInputField().spellcheck = val;
          }, true);
          option("autocorrect", false, function(cm, val) {
            return cm.getInputField().autocorrect = val;
          }, true);
          option("autocapitalize", false, function(cm, val) {
            return cm.getInputField().autocapitalize = val;
          }, true);
          option("rtlMoveVisually", !windows);
          option("wholeLineUpdateBefore", true);
          option("theme", "default", function(cm) {
            themeChanged(cm);
            updateGutters(cm);
          }, true);
          option("keyMap", "default", function(cm, val, old) {
            var next = getKeyMap(val);
            var prev = old != Init && getKeyMap(old);
            if (prev && prev.detach) {
              prev.detach(cm, next);
            }
            if (next.attach) {
              next.attach(cm, prev || null);
            }
          });
          option("extraKeys", null);
          option("configureMouse", null);
          option("lineWrapping", false, wrappingChanged, true);
          option("gutters", [], function(cm, val) {
            cm.display.gutterSpecs = getGutters(val, cm.options.lineNumbers);
            updateGutters(cm);
          }, true);
          option("fixedGutter", true, function(cm, val) {
            cm.display.gutters.style.left = val ? compensateForHScroll(cm.display) + "px" : "0";
            cm.refresh();
          }, true);
          option("coverGutterNextToScrollbar", false, function(cm) {
            return updateScrollbars(cm);
          }, true);
          option("scrollbarStyle", "native", function(cm) {
            initScrollbars(cm);
            updateScrollbars(cm);
            cm.display.scrollbars.setScrollTop(cm.doc.scrollTop);
            cm.display.scrollbars.setScrollLeft(cm.doc.scrollLeft);
          }, true);
          option("lineNumbers", false, function(cm, val) {
            cm.display.gutterSpecs = getGutters(cm.options.gutters, val);
            updateGutters(cm);
          }, true);
          option("firstLineNumber", 1, updateGutters, true);
          option("lineNumberFormatter", function(integer) {
            return integer;
          }, updateGutters, true);
          option("showCursorWhenSelecting", false, updateSelection, true);
          option("resetSelectionOnContextMenu", true);
          option("lineWiseCopyCut", true);
          option("pasteLinesPerSelection", true);
          option("selectionsMayTouch", false);
          option("readOnly", false, function(cm, val) {
            if (val == "nocursor") {
              onBlur(cm);
              cm.display.input.blur();
            }
            cm.display.input.readOnlyChanged(val);
          });
          option("screenReaderLabel", null, function(cm, val) {
            val = val === "" ? null : val;
            cm.display.input.screenReaderLabelChanged(val);
          });
          option("disableInput", false, function(cm, val) {
            if (!val) {
              cm.display.input.reset();
            }
          }, true);
          option("dragDrop", true, dragDropChanged);
          option("allowDropFileTypes", null);
          option("cursorBlinkRate", 530);
          option("cursorScrollMargin", 0);
          option("cursorHeight", 1, updateSelection, true);
          option("singleCursorHeightPerLine", true, updateSelection, true);
          option("workTime", 100);
          option("workDelay", 100);
          option("flattenSpans", true, resetModeState, true);
          option("addModeClass", false, resetModeState, true);
          option("pollInterval", 100);
          option("undoDepth", 200, function(cm, val) {
            return cm.doc.history.undoDepth = val;
          });
          option("historyEventDelay", 1250);
          option("viewportMargin", 10, function(cm) {
            return cm.refresh();
          }, true);
          option("maxHighlightLength", 1e4, resetModeState, true);
          option("moveInputWithCursor", true, function(cm, val) {
            if (!val) {
              cm.display.input.resetPosition();
            }
          });
          option("tabindex", null, function(cm, val) {
            return cm.display.input.getField().tabIndex = val || "";
          });
          option("autofocus", null);
          option("direction", "ltr", function(cm, val) {
            return cm.doc.setDirection(val);
          }, true);
          option("phrases", null);
        }
        function dragDropChanged(cm, value, old) {
          var wasOn = old && old != Init;
          if (!value != !wasOn) {
            var funcs = cm.display.dragFunctions;
            var toggle = value ? on : off;
            toggle(cm.display.scroller, "dragstart", funcs.start);
            toggle(cm.display.scroller, "dragenter", funcs.enter);
            toggle(cm.display.scroller, "dragover", funcs.over);
            toggle(cm.display.scroller, "dragleave", funcs.leave);
            toggle(cm.display.scroller, "drop", funcs.drop);
          }
        }
        function wrappingChanged(cm) {
          if (cm.options.lineWrapping) {
            addClass2(cm.display.wrapper, "CodeMirror-wrap");
            cm.display.sizer.style.minWidth = "";
            cm.display.sizerWidth = null;
          } else {
            rmClass(cm.display.wrapper, "CodeMirror-wrap");
            findMaxLine(cm);
          }
          estimateLineHeights(cm);
          regChange(cm);
          clearCaches(cm);
          setTimeout(function() {
            return updateScrollbars(cm);
          }, 100);
        }
        function CodeMirror5(place, options) {
          var this$1 = this;
          if (!(this instanceof CodeMirror5)) {
            return new CodeMirror5(place, options);
          }
          this.options = options = options ? copyObj(options) : {};
          copyObj(defaults, options, false);
          var doc = options.value;
          if (typeof doc == "string") {
            doc = new Doc(doc, options.mode, null, options.lineSeparator, options.direction);
          } else if (options.mode) {
            doc.modeOption = options.mode;
          }
          this.doc = doc;
          var input = new CodeMirror5.inputStyles[options.inputStyle](this);
          var display = this.display = new Display(place, doc, input, options);
          display.wrapper.CodeMirror = this;
          themeChanged(this);
          if (options.lineWrapping) {
            this.display.wrapper.className += " CodeMirror-wrap";
          }
          initScrollbars(this);
          this.state = {
            keyMaps: [],
            overlays: [],
            modeGen: 0,
            overwrite: false,
            delayingBlurEvent: false,
            focused: false,
            suppressEdits: false,
            pasteIncoming: -1,
            cutIncoming: -1,
            selectingText: false,
            draggingText: false,
            highlight: new Delayed(),
            keySeq: null,
            specialChars: null
          };
          if (options.autofocus && !mobile) {
            display.input.focus();
          }
          if (ie && ie_version < 11) {
            setTimeout(function() {
              return this$1.display.input.reset(true);
            }, 20);
          }
          registerEventHandlers(this);
          ensureGlobalHandlers();
          startOperation(this);
          this.curOp.forceUpdate = true;
          attachDoc(this, doc);
          if (options.autofocus && !mobile || this.hasFocus()) {
            setTimeout(bind(onFocus, this), 20);
          } else {
            onBlur(this);
          }
          for (var opt in optionHandlers) {
            if (optionHandlers.hasOwnProperty(opt)) {
              optionHandlers[opt](this, options[opt], Init);
            }
          }
          maybeUpdateLineNumberWidth(this);
          if (options.finishInit) {
            options.finishInit(this);
          }
          for (var i4 = 0; i4 < initHooks.length; ++i4) {
            initHooks[i4](this);
          }
          endOperation(this);
          if (webkit && options.lineWrapping && getComputedStyle(display.lineDiv).textRendering == "optimizelegibility") {
            display.lineDiv.style.textRendering = "auto";
          }
        }
        CodeMirror5.defaults = defaults;
        CodeMirror5.optionHandlers = optionHandlers;
        CodeMirror5.mobile = mobile;
        CodeMirror5.mac = mac;
        CodeMirror5.windows = windows;
        function registerEventHandlers(cm) {
          var d4 = cm.display;
          on(d4.scroller, "mousedown", operation(cm, onMouseDown));
          if (ie && ie_version < 11) {
            on(d4.scroller, "dblclick", operation(cm, function(e5) {
              if (signalDOMEvent(cm, e5)) {
                return;
              }
              var pos = posFromMouse(cm, e5);
              if (!pos || clickInGutter(cm, e5) || eventInWidget(cm.display, e5)) {
                return;
              }
              e_preventDefault(e5);
              var word = cm.findWordAt(pos);
              extendSelection(cm.doc, word.anchor, word.head);
            }));
          } else {
            on(d4.scroller, "dblclick", function(e5) {
              return signalDOMEvent(cm, e5) || e_preventDefault(e5);
            });
          }
          on(d4.scroller, "contextmenu", function(e5) {
            return onContextMenu(cm, e5);
          });
          on(d4.input.getField(), "contextmenu", function(e5) {
            if (!d4.scroller.contains(e5.target)) {
              onContextMenu(cm, e5);
            }
          });
          var touchFinished, prevTouch = { end: 0 };
          function finishTouch() {
            if (d4.activeTouch) {
              touchFinished = setTimeout(function() {
                return d4.activeTouch = null;
              }, 1e3);
              prevTouch = d4.activeTouch;
              prevTouch.end = +new Date();
            }
          }
          function isMouseLikeTouchEvent(e5) {
            if (e5.touches.length != 1) {
              return false;
            }
            var touch = e5.touches[0];
            return touch.radiusX <= 1 && touch.radiusY <= 1;
          }
          function farAway(touch, other) {
            if (other.left == null) {
              return true;
            }
            var dx = other.left - touch.left, dy = other.top - touch.top;
            return dx * dx + dy * dy > 20 * 20;
          }
          on(d4.scroller, "touchstart", function(e5) {
            if (!signalDOMEvent(cm, e5) && !isMouseLikeTouchEvent(e5) && !clickInGutter(cm, e5)) {
              d4.input.ensurePolled();
              clearTimeout(touchFinished);
              var now = +new Date();
              d4.activeTouch = {
                start: now,
                moved: false,
                prev: now - prevTouch.end <= 300 ? prevTouch : null
              };
              if (e5.touches.length == 1) {
                d4.activeTouch.left = e5.touches[0].pageX;
                d4.activeTouch.top = e5.touches[0].pageY;
              }
            }
          });
          on(d4.scroller, "touchmove", function() {
            if (d4.activeTouch) {
              d4.activeTouch.moved = true;
            }
          });
          on(d4.scroller, "touchend", function(e5) {
            var touch = d4.activeTouch;
            if (touch && !eventInWidget(d4, e5) && touch.left != null && !touch.moved && new Date() - touch.start < 300) {
              var pos = cm.coordsChar(d4.activeTouch, "page"), range3;
              if (!touch.prev || farAway(touch, touch.prev)) {
                range3 = new Range3(pos, pos);
              } else if (!touch.prev.prev || farAway(touch, touch.prev.prev)) {
                range3 = cm.findWordAt(pos);
              } else {
                range3 = new Range3(Pos(pos.line, 0), clipPos(cm.doc, Pos(pos.line + 1, 0)));
              }
              cm.setSelection(range3.anchor, range3.head);
              cm.focus();
              e_preventDefault(e5);
            }
            finishTouch();
          });
          on(d4.scroller, "touchcancel", finishTouch);
          on(d4.scroller, "scroll", function() {
            if (d4.scroller.clientHeight) {
              updateScrollTop(cm, d4.scroller.scrollTop);
              setScrollLeft(cm, d4.scroller.scrollLeft, true);
              signal(cm, "scroll", cm);
            }
          });
          on(d4.scroller, "mousewheel", function(e5) {
            return onScrollWheel(cm, e5);
          });
          on(d4.scroller, "DOMMouseScroll", function(e5) {
            return onScrollWheel(cm, e5);
          });
          on(d4.wrapper, "scroll", function() {
            return d4.wrapper.scrollTop = d4.wrapper.scrollLeft = 0;
          });
          d4.dragFunctions = {
            enter: function(e5) {
              if (!signalDOMEvent(cm, e5)) {
                e_stop(e5);
              }
            },
            over: function(e5) {
              if (!signalDOMEvent(cm, e5)) {
                onDragOver(cm, e5);
                e_stop(e5);
              }
            },
            start: function(e5) {
              return onDragStart(cm, e5);
            },
            drop: operation(cm, onDrop),
            leave: function(e5) {
              if (!signalDOMEvent(cm, e5)) {
                clearDragCursor(cm);
              }
            }
          };
          var inp = d4.input.getField();
          on(inp, "keyup", function(e5) {
            return onKeyUp.call(cm, e5);
          });
          on(inp, "keydown", operation(cm, onKeyDown));
          on(inp, "keypress", operation(cm, onKeyPress));
          on(inp, "focus", function(e5) {
            return onFocus(cm, e5);
          });
          on(inp, "blur", function(e5) {
            return onBlur(cm, e5);
          });
        }
        var initHooks = [];
        CodeMirror5.defineInitHook = function(f3) {
          return initHooks.push(f3);
        };
        function indentLine(cm, n3, how, aggressive) {
          var doc = cm.doc, state;
          if (how == null) {
            how = "add";
          }
          if (how == "smart") {
            if (!doc.mode.indent) {
              how = "prev";
            } else {
              state = getContextBefore(cm, n3).state;
            }
          }
          var tabSize = cm.options.tabSize;
          var line = getLine(doc, n3), curSpace = countColumn(line.text, null, tabSize);
          if (line.stateAfter) {
            line.stateAfter = null;
          }
          var curSpaceString = line.text.match(/^\s*/)[0], indentation;
          if (!aggressive && !/\S/.test(line.text)) {
            indentation = 0;
            how = "not";
          } else if (how == "smart") {
            indentation = doc.mode.indent(state, line.text.slice(curSpaceString.length), line.text);
            if (indentation == Pass || indentation > 150) {
              if (!aggressive) {
                return;
              }
              how = "prev";
            }
          }
          if (how == "prev") {
            if (n3 > doc.first) {
              indentation = countColumn(getLine(doc, n3 - 1).text, null, tabSize);
            } else {
              indentation = 0;
            }
          } else if (how == "add") {
            indentation = curSpace + cm.options.indentUnit;
          } else if (how == "subtract") {
            indentation = curSpace - cm.options.indentUnit;
          } else if (typeof how == "number") {
            indentation = curSpace + how;
          }
          indentation = Math.max(0, indentation);
          var indentString = "", pos = 0;
          if (cm.options.indentWithTabs) {
            for (var i4 = Math.floor(indentation / tabSize); i4; --i4) {
              pos += tabSize;
              indentString += "	";
            }
          }
          if (pos < indentation) {
            indentString += spaceStr(indentation - pos);
          }
          if (indentString != curSpaceString) {
            replaceRange(doc, indentString, Pos(n3, 0), Pos(n3, curSpaceString.length), "+input");
            line.stateAfter = null;
            return true;
          } else {
            for (var i$12 = 0; i$12 < doc.sel.ranges.length; i$12++) {
              var range3 = doc.sel.ranges[i$12];
              if (range3.head.line == n3 && range3.head.ch < curSpaceString.length) {
                var pos$1 = Pos(n3, curSpaceString.length);
                replaceOneSelection(doc, i$12, new Range3(pos$1, pos$1));
                break;
              }
            }
          }
        }
        var lastCopied = null;
        function setLastCopied(newLastCopied) {
          lastCopied = newLastCopied;
        }
        function applyTextInput(cm, inserted, deleted, sel, origin) {
          var doc = cm.doc;
          cm.display.shift = false;
          if (!sel) {
            sel = doc.sel;
          }
          var recent = +new Date() - 200;
          var paste2 = origin == "paste" || cm.state.pasteIncoming > recent;
          var textLines = splitLinesAuto(inserted), multiPaste = null;
          if (paste2 && sel.ranges.length > 1) {
            if (lastCopied && lastCopied.text.join("\n") == inserted) {
              if (sel.ranges.length % lastCopied.text.length == 0) {
                multiPaste = [];
                for (var i4 = 0; i4 < lastCopied.text.length; i4++) {
                  multiPaste.push(doc.splitLines(lastCopied.text[i4]));
                }
              }
            } else if (textLines.length == sel.ranges.length && cm.options.pasteLinesPerSelection) {
              multiPaste = map3(textLines, function(l3) {
                return [l3];
              });
            }
          }
          var updateInput = cm.curOp.updateInput;
          for (var i$12 = sel.ranges.length - 1; i$12 >= 0; i$12--) {
            var range3 = sel.ranges[i$12];
            var from = range3.from(), to = range3.to();
            if (range3.empty()) {
              if (deleted && deleted > 0) {
                from = Pos(from.line, from.ch - deleted);
              } else if (cm.state.overwrite && !paste2) {
                to = Pos(to.line, Math.min(getLine(doc, to.line).text.length, to.ch + lst(textLines).length));
              } else if (paste2 && lastCopied && lastCopied.lineWise && lastCopied.text.join("\n") == inserted) {
                from = to = Pos(from.line, 0);
              }
            }
            var changeEvent = {
              from,
              to,
              text: multiPaste ? multiPaste[i$12 % multiPaste.length] : textLines,
              origin: origin || (paste2 ? "paste" : cm.state.cutIncoming > recent ? "cut" : "+input")
            };
            makeChange(cm.doc, changeEvent);
            signalLater(cm, "inputRead", cm, changeEvent);
          }
          if (inserted && !paste2) {
            triggerElectric(cm, inserted);
          }
          ensureCursorVisible(cm);
          if (cm.curOp.updateInput < 2) {
            cm.curOp.updateInput = updateInput;
          }
          cm.curOp.typing = true;
          cm.state.pasteIncoming = cm.state.cutIncoming = -1;
        }
        function handlePaste(e5, cm) {
          var pasted = e5.clipboardData && e5.clipboardData.getData("Text");
          if (pasted) {
            e5.preventDefault();
            if (!cm.isReadOnly() && !cm.options.disableInput) {
              runInOp(cm, function() {
                return applyTextInput(cm, pasted, 0, null, "paste");
              });
            }
            return true;
          }
        }
        function triggerElectric(cm, inserted) {
          if (!cm.options.electricChars || !cm.options.smartIndent) {
            return;
          }
          var sel = cm.doc.sel;
          for (var i4 = sel.ranges.length - 1; i4 >= 0; i4--) {
            var range3 = sel.ranges[i4];
            if (range3.head.ch > 100 || i4 && sel.ranges[i4 - 1].head.line == range3.head.line) {
              continue;
            }
            var mode2 = cm.getModeAt(range3.head);
            var indented = false;
            if (mode2.electricChars) {
              for (var j3 = 0; j3 < mode2.electricChars.length; j3++) {
                if (inserted.indexOf(mode2.electricChars.charAt(j3)) > -1) {
                  indented = indentLine(cm, range3.head.line, "smart");
                  break;
                }
              }
            } else if (mode2.electricInput) {
              if (mode2.electricInput.test(getLine(cm.doc, range3.head.line).text.slice(0, range3.head.ch))) {
                indented = indentLine(cm, range3.head.line, "smart");
              }
            }
            if (indented) {
              signalLater(cm, "electricInput", cm, range3.head.line);
            }
          }
        }
        function copyableRanges(cm) {
          var text = [], ranges = [];
          for (var i4 = 0; i4 < cm.doc.sel.ranges.length; i4++) {
            var line = cm.doc.sel.ranges[i4].head.line;
            var lineRange = { anchor: Pos(line, 0), head: Pos(line + 1, 0) };
            ranges.push(lineRange);
            text.push(cm.getRange(lineRange.anchor, lineRange.head));
          }
          return { text, ranges };
        }
        function disableBrowserMagic(field, spellcheck, autocorrect, autocapitalize) {
          field.setAttribute("autocorrect", autocorrect ? "" : "off");
          field.setAttribute("autocapitalize", autocapitalize ? "" : "off");
          field.setAttribute("spellcheck", !!spellcheck);
        }
        function hiddenTextarea() {
          var te = elt("textarea", null, null, "position: absolute; bottom: -1em; padding: 0; width: 1px; height: 1em; outline: none");
          var div = elt("div", [te], null, "overflow: hidden; position: relative; width: 3px; height: 0px;");
          if (webkit) {
            te.style.width = "1000px";
          } else {
            te.setAttribute("wrap", "off");
          }
          if (ios) {
            te.style.border = "1px solid black";
          }
          disableBrowserMagic(te);
          return div;
        }
        function addEditorMethods(CodeMirror6) {
          var optionHandlers2 = CodeMirror6.optionHandlers;
          var helpers = CodeMirror6.helpers = {};
          CodeMirror6.prototype = {
            constructor: CodeMirror6,
            focus: function() {
              window.focus();
              this.display.input.focus();
            },
            setOption: function(option, value) {
              var options = this.options, old = options[option];
              if (options[option] == value && option != "mode") {
                return;
              }
              options[option] = value;
              if (optionHandlers2.hasOwnProperty(option)) {
                operation(this, optionHandlers2[option])(this, value, old);
              }
              signal(this, "optionChange", this, option);
            },
            getOption: function(option) {
              return this.options[option];
            },
            getDoc: function() {
              return this.doc;
            },
            addKeyMap: function(map4, bottom) {
              this.state.keyMaps[bottom ? "push" : "unshift"](getKeyMap(map4));
            },
            removeKeyMap: function(map4) {
              var maps = this.state.keyMaps;
              for (var i4 = 0; i4 < maps.length; ++i4) {
                if (maps[i4] == map4 || maps[i4].name == map4) {
                  maps.splice(i4, 1);
                  return true;
                }
              }
            },
            addOverlay: methodOp(function(spec, options) {
              var mode2 = spec.token ? spec : CodeMirror6.getMode(this.options, spec);
              if (mode2.startState) {
                throw new Error("Overlays may not be stateful.");
              }
              insertSorted(this.state.overlays, {
                mode: mode2,
                modeSpec: spec,
                opaque: options && options.opaque,
                priority: options && options.priority || 0
              }, function(overlay) {
                return overlay.priority;
              });
              this.state.modeGen++;
              regChange(this);
            }),
            removeOverlay: methodOp(function(spec) {
              var overlays = this.state.overlays;
              for (var i4 = 0; i4 < overlays.length; ++i4) {
                var cur = overlays[i4].modeSpec;
                if (cur == spec || typeof spec == "string" && cur.name == spec) {
                  overlays.splice(i4, 1);
                  this.state.modeGen++;
                  regChange(this);
                  return;
                }
              }
            }),
            indentLine: methodOp(function(n3, dir, aggressive) {
              if (typeof dir != "string" && typeof dir != "number") {
                if (dir == null) {
                  dir = this.options.smartIndent ? "smart" : "prev";
                } else {
                  dir = dir ? "add" : "subtract";
                }
              }
              if (isLine(this.doc, n3)) {
                indentLine(this, n3, dir, aggressive);
              }
            }),
            indentSelection: methodOp(function(how) {
              var ranges = this.doc.sel.ranges, end = -1;
              for (var i4 = 0; i4 < ranges.length; i4++) {
                var range3 = ranges[i4];
                if (!range3.empty()) {
                  var from = range3.from(), to = range3.to();
                  var start2 = Math.max(end, from.line);
                  end = Math.min(this.lastLine(), to.line - (to.ch ? 0 : 1)) + 1;
                  for (var j3 = start2; j3 < end; ++j3) {
                    indentLine(this, j3, how);
                  }
                  var newRanges = this.doc.sel.ranges;
                  if (from.ch == 0 && ranges.length == newRanges.length && newRanges[i4].from().ch > 0) {
                    replaceOneSelection(this.doc, i4, new Range3(from, newRanges[i4].to()), sel_dontScroll);
                  }
                } else if (range3.head.line > end) {
                  indentLine(this, range3.head.line, how, true);
                  end = range3.head.line;
                  if (i4 == this.doc.sel.primIndex) {
                    ensureCursorVisible(this);
                  }
                }
              }
            }),
            getTokenAt: function(pos, precise) {
              return takeToken(this, pos, precise);
            },
            getLineTokens: function(line, precise) {
              return takeToken(this, Pos(line), precise, true);
            },
            getTokenTypeAt: function(pos) {
              pos = clipPos(this.doc, pos);
              var styles = getLineStyles(this, getLine(this.doc, pos.line));
              var before = 0, after = (styles.length - 1) / 2, ch = pos.ch;
              var type;
              if (ch == 0) {
                type = styles[2];
              } else {
                for (; ; ) {
                  var mid = before + after >> 1;
                  if ((mid ? styles[mid * 2 - 1] : 0) >= ch) {
                    after = mid;
                  } else if (styles[mid * 2 + 1] < ch) {
                    before = mid + 1;
                  } else {
                    type = styles[mid * 2 + 2];
                    break;
                  }
                }
              }
              var cut2 = type ? type.indexOf("overlay ") : -1;
              return cut2 < 0 ? type : cut2 == 0 ? null : type.slice(0, cut2 - 1);
            },
            getModeAt: function(pos) {
              var mode2 = this.doc.mode;
              if (!mode2.innerMode) {
                return mode2;
              }
              return CodeMirror6.innerMode(mode2, this.getTokenAt(pos).state).mode;
            },
            getHelper: function(pos, type) {
              return this.getHelpers(pos, type)[0];
            },
            getHelpers: function(pos, type) {
              var found = [];
              if (!helpers.hasOwnProperty(type)) {
                return found;
              }
              var help2 = helpers[type], mode2 = this.getModeAt(pos);
              if (typeof mode2[type] == "string") {
                if (help2[mode2[type]]) {
                  found.push(help2[mode2[type]]);
                }
              } else if (mode2[type]) {
                for (var i4 = 0; i4 < mode2[type].length; i4++) {
                  var val = help2[mode2[type][i4]];
                  if (val) {
                    found.push(val);
                  }
                }
              } else if (mode2.helperType && help2[mode2.helperType]) {
                found.push(help2[mode2.helperType]);
              } else if (help2[mode2.name]) {
                found.push(help2[mode2.name]);
              }
              for (var i$12 = 0; i$12 < help2._global.length; i$12++) {
                var cur = help2._global[i$12];
                if (cur.pred(mode2, this) && indexOf(found, cur.val) == -1) {
                  found.push(cur.val);
                }
              }
              return found;
            },
            getStateAfter: function(line, precise) {
              var doc = this.doc;
              line = clipLine(doc, line == null ? doc.first + doc.size - 1 : line);
              return getContextBefore(this, line + 1, precise).state;
            },
            cursorCoords: function(start2, mode2) {
              var pos, range3 = this.doc.sel.primary();
              if (start2 == null) {
                pos = range3.head;
              } else if (typeof start2 == "object") {
                pos = clipPos(this.doc, start2);
              } else {
                pos = start2 ? range3.from() : range3.to();
              }
              return cursorCoords(this, pos, mode2 || "page");
            },
            charCoords: function(pos, mode2) {
              return charCoords(this, clipPos(this.doc, pos), mode2 || "page");
            },
            coordsChar: function(coords, mode2) {
              coords = fromCoordSystem(this, coords, mode2 || "page");
              return coordsChar(this, coords.left, coords.top);
            },
            lineAtHeight: function(height, mode2) {
              height = fromCoordSystem(this, { top: height, left: 0 }, mode2 || "page").top;
              return lineAtHeight(this.doc, height + this.display.viewOffset);
            },
            heightAtLine: function(line, mode2, includeWidgets) {
              var end = false, lineObj;
              if (typeof line == "number") {
                var last = this.doc.first + this.doc.size - 1;
                if (line < this.doc.first) {
                  line = this.doc.first;
                } else if (line > last) {
                  line = last;
                  end = true;
                }
                lineObj = getLine(this.doc, line);
              } else {
                lineObj = line;
              }
              return intoCoordSystem(this, lineObj, { top: 0, left: 0 }, mode2 || "page", includeWidgets || end).top + (end ? this.doc.height - heightAtLine(lineObj) : 0);
            },
            defaultTextHeight: function() {
              return textHeight$1(this.display);
            },
            defaultCharWidth: function() {
              return charWidth(this.display);
            },
            defaultSpaceWidth: function() {
              return spaceWidth(this.display);
            },
            getViewport: function() {
              return { from: this.display.viewFrom, to: this.display.viewTo };
            },
            addWidget: function(pos, node, scroll, vert, horiz) {
              var display = this.display;
              pos = cursorCoords(this, clipPos(this.doc, pos));
              var top = pos.bottom, left = pos.left;
              node.style.position = "absolute";
              node.setAttribute("cm-ignore-events", "true");
              this.display.input.setUneditable(node);
              display.sizer.appendChild(node);
              if (vert == "over") {
                top = pos.top;
              } else if (vert == "above" || vert == "near") {
                var vspace = Math.max(display.wrapper.clientHeight, this.doc.height), hspace = Math.max(display.sizer.clientWidth, display.lineSpace.clientWidth);
                if ((vert == "above" || pos.bottom + node.offsetHeight > vspace) && pos.top > node.offsetHeight) {
                  top = pos.top - node.offsetHeight;
                } else if (pos.bottom + node.offsetHeight <= vspace) {
                  top = pos.bottom;
                }
                if (left + node.offsetWidth > hspace) {
                  left = hspace - node.offsetWidth;
                }
              }
              node.style.top = top + "px";
              node.style.left = node.style.right = "";
              if (horiz == "right") {
                left = display.sizer.clientWidth - node.offsetWidth;
                node.style.right = "0px";
              } else {
                if (horiz == "left") {
                  left = 0;
                } else if (horiz == "middle") {
                  left = (display.sizer.clientWidth - node.offsetWidth) / 2;
                }
                node.style.left = left + "px";
              }
              if (scroll) {
                scrollIntoView(this, { left, top, right: left + node.offsetWidth, bottom: top + node.offsetHeight });
              }
            },
            triggerOnKeyDown: methodOp(onKeyDown),
            triggerOnKeyPress: methodOp(onKeyPress),
            triggerOnKeyUp: onKeyUp,
            triggerOnMouseDown: methodOp(onMouseDown),
            execCommand: function(cmd) {
              if (commands.hasOwnProperty(cmd)) {
                return commands[cmd].call(null, this);
              }
            },
            triggerElectric: methodOp(function(text) {
              triggerElectric(this, text);
            }),
            findPosH: function(from, amount, unit, visually) {
              var dir = 1;
              if (amount < 0) {
                dir = -1;
                amount = -amount;
              }
              var cur = clipPos(this.doc, from);
              for (var i4 = 0; i4 < amount; ++i4) {
                cur = findPosH(this.doc, cur, dir, unit, visually);
                if (cur.hitSide) {
                  break;
                }
              }
              return cur;
            },
            moveH: methodOp(function(dir, unit) {
              var this$1 = this;
              this.extendSelectionsBy(function(range3) {
                if (this$1.display.shift || this$1.doc.extend || range3.empty()) {
                  return findPosH(this$1.doc, range3.head, dir, unit, this$1.options.rtlMoveVisually);
                } else {
                  return dir < 0 ? range3.from() : range3.to();
                }
              }, sel_move);
            }),
            deleteH: methodOp(function(dir, unit) {
              var sel = this.doc.sel, doc = this.doc;
              if (sel.somethingSelected()) {
                doc.replaceSelection("", null, "+delete");
              } else {
                deleteNearSelection(this, function(range3) {
                  var other = findPosH(doc, range3.head, dir, unit, false);
                  return dir < 0 ? { from: other, to: range3.head } : { from: range3.head, to: other };
                });
              }
            }),
            findPosV: function(from, amount, unit, goalColumn) {
              var dir = 1, x3 = goalColumn;
              if (amount < 0) {
                dir = -1;
                amount = -amount;
              }
              var cur = clipPos(this.doc, from);
              for (var i4 = 0; i4 < amount; ++i4) {
                var coords = cursorCoords(this, cur, "div");
                if (x3 == null) {
                  x3 = coords.left;
                } else {
                  coords.left = x3;
                }
                cur = findPosV(this, coords, dir, unit);
                if (cur.hitSide) {
                  break;
                }
              }
              return cur;
            },
            moveV: methodOp(function(dir, unit) {
              var this$1 = this;
              var doc = this.doc, goals = [];
              var collapse = !this.display.shift && !doc.extend && doc.sel.somethingSelected();
              doc.extendSelectionsBy(function(range3) {
                if (collapse) {
                  return dir < 0 ? range3.from() : range3.to();
                }
                var headPos = cursorCoords(this$1, range3.head, "div");
                if (range3.goalColumn != null) {
                  headPos.left = range3.goalColumn;
                }
                goals.push(headPos.left);
                var pos = findPosV(this$1, headPos, dir, unit);
                if (unit == "page" && range3 == doc.sel.primary()) {
                  addToScrollTop(this$1, charCoords(this$1, pos, "div").top - headPos.top);
                }
                return pos;
              }, sel_move);
              if (goals.length) {
                for (var i4 = 0; i4 < doc.sel.ranges.length; i4++) {
                  doc.sel.ranges[i4].goalColumn = goals[i4];
                }
              }
            }),
            findWordAt: function(pos) {
              var doc = this.doc, line = getLine(doc, pos.line).text;
              var start2 = pos.ch, end = pos.ch;
              if (line) {
                var helper = this.getHelper(pos, "wordChars");
                if ((pos.sticky == "before" || end == line.length) && start2) {
                  --start2;
                } else {
                  ++end;
                }
                var startChar = line.charAt(start2);
                var check = isWordChar2(startChar, helper) ? function(ch) {
                  return isWordChar2(ch, helper);
                } : /\s/.test(startChar) ? function(ch) {
                  return /\s/.test(ch);
                } : function(ch) {
                  return !/\s/.test(ch) && !isWordChar2(ch);
                };
                while (start2 > 0 && check(line.charAt(start2 - 1))) {
                  --start2;
                }
                while (end < line.length && check(line.charAt(end))) {
                  ++end;
                }
              }
              return new Range3(Pos(pos.line, start2), Pos(pos.line, end));
            },
            toggleOverwrite: function(value) {
              if (value != null && value == this.state.overwrite) {
                return;
              }
              if (this.state.overwrite = !this.state.overwrite) {
                addClass2(this.display.cursorDiv, "CodeMirror-overwrite");
              } else {
                rmClass(this.display.cursorDiv, "CodeMirror-overwrite");
              }
              signal(this, "overwriteToggle", this, this.state.overwrite);
            },
            hasFocus: function() {
              return this.display.input.getField() == activeElt();
            },
            isReadOnly: function() {
              return !!(this.options.readOnly || this.doc.cantEdit);
            },
            scrollTo: methodOp(function(x3, y2) {
              scrollToCoords(this, x3, y2);
            }),
            getScrollInfo: function() {
              var scroller = this.display.scroller;
              return {
                left: scroller.scrollLeft,
                top: scroller.scrollTop,
                height: scroller.scrollHeight - scrollGap(this) - this.display.barHeight,
                width: scroller.scrollWidth - scrollGap(this) - this.display.barWidth,
                clientHeight: displayHeight(this),
                clientWidth: displayWidth(this)
              };
            },
            scrollIntoView: methodOp(function(range3, topMargin, bottomMargin) {
              if (range3 == null) {
                range3 = { from: this.doc.sel.primary().head, to: null };
                if (topMargin == null) {
                  topMargin = this.options.cursorScrollMargin;
                }
              } else if (typeof range3 == "number") {
                range3 = { from: Pos(range3, 0), to: null };
              } else if (range3.from == null) {
                range3 = { from: range3, to: null };
              }
              if (!range3.to) {
                range3.to = range3.from;
              }
              range3.topMargin = topMargin || 0;
              range3.bottomMargin = bottomMargin === void 0 ? range3.topMargin : bottomMargin;
              if (range3.from.line != null) {
                scrollToRange(this, range3);
              } else {
                scrollToCoordsRange(this, range3.from, range3.to, range3.topMargin, range3.bottomMargin);
              }
            }),
            setSize: methodOp(function(width, height) {
              var this$1 = this;
              var interpret = function(val) {
                return typeof val == "number" || /^\d+$/.test(String(val)) ? val + "px" : val;
              };
              if (width != null) {
                this.display.wrapper.style.width = interpret(width);
              }
              if (height != null) {
                this.display.wrapper.style.height = interpret(height);
              }
              if (this.options.lineWrapping) {
                clearLineMeasurementCache(this);
              }
              var lineNo2 = this.display.viewFrom;
              this.doc.iter(lineNo2, this.display.viewTo, function(line) {
                if (line.widgets) {
                  for (var i4 = 0; i4 < line.widgets.length; i4++) {
                    if (line.widgets[i4].noHScroll) {
                      regLineChange(this$1, lineNo2, "widget");
                      break;
                    }
                  }
                }
                ++lineNo2;
              });
              this.curOp.forceUpdate = true;
              signal(this, "refresh", this);
            }),
            operation: function(f3) {
              return runInOp(this, f3);
            },
            startOperation: function() {
              return startOperation(this);
            },
            endOperation: function() {
              return endOperation(this);
            },
            refresh: methodOp(function() {
              var oldHeight = this.display.cachedTextHeight;
              regChange(this);
              this.curOp.forceUpdate = true;
              clearCaches(this);
              scrollToCoords(this, this.doc.scrollLeft, this.doc.scrollTop);
              updateGutterSpace(this.display);
              if (oldHeight == null || Math.abs(oldHeight - textHeight$1(this.display)) > 0.5 || this.options.lineWrapping) {
                estimateLineHeights(this);
              }
              signal(this, "refresh", this);
            }),
            regLineChange: function(line, type) {
              regLineChange(this, line, type);
            },
            lineHandleIsHidden: function(lineHandle) {
              return lineIsHidden(this, lineHandle);
            },
            swapDoc: methodOp(function(doc) {
              var old = this.doc;
              old.cm = null;
              if (this.state.selectingText) {
                this.state.selectingText();
              }
              attachDoc(this, doc);
              clearCaches(this);
              this.display.input.reset();
              scrollToCoords(this, doc.scrollLeft, doc.scrollTop);
              this.curOp.forceScroll = true;
              signalLater(this, "swapDoc", this, old);
              return old;
            }),
            phrase: function(phraseText) {
              var phrases = this.options.phrases;
              return phrases && Object.prototype.hasOwnProperty.call(phrases, phraseText) ? phrases[phraseText] : phraseText;
            },
            getInputField: function() {
              return this.display.input.getField();
            },
            getWrapperElement: function() {
              return this.display.wrapper;
            },
            getScrollerElement: function() {
              return this.display.scroller;
            },
            getGutterElement: function() {
              return this.display.gutters;
            }
          };
          eventMixin(CodeMirror6);
          CodeMirror6.registerHelper = function(type, name106, value) {
            if (!helpers.hasOwnProperty(type)) {
              helpers[type] = CodeMirror6[type] = { _global: [] };
            }
            helpers[type][name106] = value;
          };
          CodeMirror6.registerGlobalHelper = function(type, name106, predicate, value) {
            CodeMirror6.registerHelper(type, name106, value);
            helpers[type]._global.push({ pred: predicate, val: value });
          };
        }
        function findPosH(doc, pos, dir, unit, visually) {
          var oldPos = pos;
          var origDir = dir;
          var lineObj = getLine(doc, pos.line);
          var lineDir = visually && doc.direction == "rtl" ? -dir : dir;
          function findNextLine() {
            var l3 = pos.line + lineDir;
            if (l3 < doc.first || l3 >= doc.first + doc.size) {
              return false;
            }
            pos = new Pos(l3, pos.ch, pos.sticky);
            return lineObj = getLine(doc, l3);
          }
          function moveOnce(boundToLine) {
            var next;
            if (visually) {
              next = moveVisually(doc.cm, lineObj, pos, dir);
            } else {
              next = moveLogically(lineObj, pos, dir);
            }
            if (next == null) {
              if (!boundToLine && findNextLine()) {
                pos = endOfLine(visually, doc.cm, lineObj, pos.line, lineDir);
              } else {
                return false;
              }
            } else {
              pos = next;
            }
            return true;
          }
          if (unit == "char") {
            moveOnce();
          } else if (unit == "column") {
            moveOnce(true);
          } else if (unit == "word" || unit == "group") {
            var sawType = null, group = unit == "group";
            var helper = doc.cm && doc.cm.getHelper(pos, "wordChars");
            for (var first = true; ; first = false) {
              if (dir < 0 && !moveOnce(!first)) {
                break;
              }
              var cur = lineObj.text.charAt(pos.ch) || "\n";
              var type = isWordChar2(cur, helper) ? "w" : group && cur == "\n" ? "n" : !group || /\s/.test(cur) ? null : "p";
              if (group && !first && !type) {
                type = "s";
              }
              if (sawType && sawType != type) {
                if (dir < 0) {
                  dir = 1;
                  moveOnce();
                  pos.sticky = "after";
                }
                break;
              }
              if (type) {
                sawType = type;
              }
              if (dir > 0 && !moveOnce(!first)) {
                break;
              }
            }
          }
          var result = skipAtomic(doc, pos, oldPos, origDir, true);
          if (equalCursorPos(oldPos, result)) {
            result.hitSide = true;
          }
          return result;
        }
        function findPosV(cm, pos, dir, unit) {
          var doc = cm.doc, x3 = pos.left, y2;
          if (unit == "page") {
            var pageSize = Math.min(cm.display.wrapper.clientHeight, window.innerHeight || document.documentElement.clientHeight);
            var moveAmount = Math.max(pageSize - 0.5 * textHeight$1(cm.display), 3);
            y2 = (dir > 0 ? pos.bottom : pos.top) + dir * moveAmount;
          } else if (unit == "line") {
            y2 = dir > 0 ? pos.bottom + 3 : pos.top - 3;
          }
          var target;
          for (; ; ) {
            target = coordsChar(cm, x3, y2);
            if (!target.outside) {
              break;
            }
            if (dir < 0 ? y2 <= 0 : y2 >= doc.height) {
              target.hitSide = true;
              break;
            }
            y2 += dir * 5;
          }
          return target;
        }
        var ContentEditableInput = function(cm) {
          this.cm = cm;
          this.lastAnchorNode = this.lastAnchorOffset = this.lastFocusNode = this.lastFocusOffset = null;
          this.polling = new Delayed();
          this.composing = null;
          this.gracePeriod = false;
          this.readDOMTimeout = null;
        };
        ContentEditableInput.prototype.init = function(display) {
          var this$1 = this;
          var input = this, cm = input.cm;
          var div = input.div = display.lineDiv;
          disableBrowserMagic(div, cm.options.spellcheck, cm.options.autocorrect, cm.options.autocapitalize);
          function belongsToInput(e5) {
            for (var t3 = e5.target; t3; t3 = t3.parentNode) {
              if (t3 == div) {
                return true;
              }
              if (/\bCodeMirror-(?:line)?widget\b/.test(t3.className)) {
                break;
              }
            }
            return false;
          }
          on(div, "paste", function(e5) {
            if (!belongsToInput(e5) || signalDOMEvent(cm, e5) || handlePaste(e5, cm)) {
              return;
            }
            if (ie_version <= 11) {
              setTimeout(operation(cm, function() {
                return this$1.updateFromDOM();
              }), 20);
            }
          });
          on(div, "compositionstart", function(e5) {
            this$1.composing = { data: e5.data, done: false };
          });
          on(div, "compositionupdate", function(e5) {
            if (!this$1.composing) {
              this$1.composing = { data: e5.data, done: false };
            }
          });
          on(div, "compositionend", function(e5) {
            if (this$1.composing) {
              if (e5.data != this$1.composing.data) {
                this$1.readFromDOMSoon();
              }
              this$1.composing.done = true;
            }
          });
          on(div, "touchstart", function() {
            return input.forceCompositionEnd();
          });
          on(div, "input", function() {
            if (!this$1.composing) {
              this$1.readFromDOMSoon();
            }
          });
          function onCopyCut(e5) {
            if (!belongsToInput(e5) || signalDOMEvent(cm, e5)) {
              return;
            }
            if (cm.somethingSelected()) {
              setLastCopied({ lineWise: false, text: cm.getSelections() });
              if (e5.type == "cut") {
                cm.replaceSelection("", null, "cut");
              }
            } else if (!cm.options.lineWiseCopyCut) {
              return;
            } else {
              var ranges = copyableRanges(cm);
              setLastCopied({ lineWise: true, text: ranges.text });
              if (e5.type == "cut") {
                cm.operation(function() {
                  cm.setSelections(ranges.ranges, 0, sel_dontScroll);
                  cm.replaceSelection("", null, "cut");
                });
              }
            }
            if (e5.clipboardData) {
              e5.clipboardData.clearData();
              var content = lastCopied.text.join("\n");
              e5.clipboardData.setData("Text", content);
              if (e5.clipboardData.getData("Text") == content) {
                e5.preventDefault();
                return;
              }
            }
            var kludge = hiddenTextarea(), te = kludge.firstChild;
            cm.display.lineSpace.insertBefore(kludge, cm.display.lineSpace.firstChild);
            te.value = lastCopied.text.join("\n");
            var hadFocus = document.activeElement;
            selectInput(te);
            setTimeout(function() {
              cm.display.lineSpace.removeChild(kludge);
              hadFocus.focus();
              if (hadFocus == div) {
                input.showPrimarySelection();
              }
            }, 50);
          }
          on(div, "copy", onCopyCut);
          on(div, "cut", onCopyCut);
        };
        ContentEditableInput.prototype.screenReaderLabelChanged = function(label) {
          if (label) {
            this.div.setAttribute("aria-label", label);
          } else {
            this.div.removeAttribute("aria-label");
          }
        };
        ContentEditableInput.prototype.prepareSelection = function() {
          var result = prepareSelection(this.cm, false);
          result.focus = document.activeElement == this.div;
          return result;
        };
        ContentEditableInput.prototype.showSelection = function(info, takeFocus) {
          if (!info || !this.cm.display.view.length) {
            return;
          }
          if (info.focus || takeFocus) {
            this.showPrimarySelection();
          }
          this.showMultipleSelections(info);
        };
        ContentEditableInput.prototype.getSelection = function() {
          return this.cm.display.wrapper.ownerDocument.getSelection();
        };
        ContentEditableInput.prototype.showPrimarySelection = function() {
          var sel = this.getSelection(), cm = this.cm, prim = cm.doc.sel.primary();
          var from = prim.from(), to = prim.to();
          if (cm.display.viewTo == cm.display.viewFrom || from.line >= cm.display.viewTo || to.line < cm.display.viewFrom) {
            sel.removeAllRanges();
            return;
          }
          var curAnchor = domToPos(cm, sel.anchorNode, sel.anchorOffset);
          var curFocus = domToPos(cm, sel.focusNode, sel.focusOffset);
          if (curAnchor && !curAnchor.bad && curFocus && !curFocus.bad && cmp(minPos(curAnchor, curFocus), from) == 0 && cmp(maxPos(curAnchor, curFocus), to) == 0) {
            return;
          }
          var view = cm.display.view;
          var start2 = from.line >= cm.display.viewFrom && posToDOM(cm, from) || { node: view[0].measure.map[2], offset: 0 };
          var end = to.line < cm.display.viewTo && posToDOM(cm, to);
          if (!end) {
            var measure = view[view.length - 1].measure;
            var map4 = measure.maps ? measure.maps[measure.maps.length - 1] : measure.map;
            end = { node: map4[map4.length - 1], offset: map4[map4.length - 2] - map4[map4.length - 3] };
          }
          if (!start2 || !end) {
            sel.removeAllRanges();
            return;
          }
          var old = sel.rangeCount && sel.getRangeAt(0), rng;
          try {
            rng = range2(start2.node, start2.offset, end.offset, end.node);
          } catch (e5) {
          }
          if (rng) {
            if (!gecko && cm.state.focused) {
              sel.collapse(start2.node, start2.offset);
              if (!rng.collapsed) {
                sel.removeAllRanges();
                sel.addRange(rng);
              }
            } else {
              sel.removeAllRanges();
              sel.addRange(rng);
            }
            if (old && sel.anchorNode == null) {
              sel.addRange(old);
            } else if (gecko) {
              this.startGracePeriod();
            }
          }
          this.rememberSelection();
        };
        ContentEditableInput.prototype.startGracePeriod = function() {
          var this$1 = this;
          clearTimeout(this.gracePeriod);
          this.gracePeriod = setTimeout(function() {
            this$1.gracePeriod = false;
            if (this$1.selectionChanged()) {
              this$1.cm.operation(function() {
                return this$1.cm.curOp.selectionChanged = true;
              });
            }
          }, 20);
        };
        ContentEditableInput.prototype.showMultipleSelections = function(info) {
          removeChildrenAndAdd(this.cm.display.cursorDiv, info.cursors);
          removeChildrenAndAdd(this.cm.display.selectionDiv, info.selection);
        };
        ContentEditableInput.prototype.rememberSelection = function() {
          var sel = this.getSelection();
          this.lastAnchorNode = sel.anchorNode;
          this.lastAnchorOffset = sel.anchorOffset;
          this.lastFocusNode = sel.focusNode;
          this.lastFocusOffset = sel.focusOffset;
        };
        ContentEditableInput.prototype.selectionInEditor = function() {
          var sel = this.getSelection();
          if (!sel.rangeCount) {
            return false;
          }
          var node = sel.getRangeAt(0).commonAncestorContainer;
          return contains3(this.div, node);
        };
        ContentEditableInput.prototype.focus = function() {
          if (this.cm.options.readOnly != "nocursor") {
            if (!this.selectionInEditor() || document.activeElement != this.div) {
              this.showSelection(this.prepareSelection(), true);
            }
            this.div.focus();
          }
        };
        ContentEditableInput.prototype.blur = function() {
          this.div.blur();
        };
        ContentEditableInput.prototype.getField = function() {
          return this.div;
        };
        ContentEditableInput.prototype.supportsTouch = function() {
          return true;
        };
        ContentEditableInput.prototype.receivedFocus = function() {
          var input = this;
          if (this.selectionInEditor()) {
            this.pollSelection();
          } else {
            runInOp(this.cm, function() {
              return input.cm.curOp.selectionChanged = true;
            });
          }
          function poll() {
            if (input.cm.state.focused) {
              input.pollSelection();
              input.polling.set(input.cm.options.pollInterval, poll);
            }
          }
          this.polling.set(this.cm.options.pollInterval, poll);
        };
        ContentEditableInput.prototype.selectionChanged = function() {
          var sel = this.getSelection();
          return sel.anchorNode != this.lastAnchorNode || sel.anchorOffset != this.lastAnchorOffset || sel.focusNode != this.lastFocusNode || sel.focusOffset != this.lastFocusOffset;
        };
        ContentEditableInput.prototype.pollSelection = function() {
          if (this.readDOMTimeout != null || this.gracePeriod || !this.selectionChanged()) {
            return;
          }
          var sel = this.getSelection(), cm = this.cm;
          if (android && chrome && this.cm.display.gutterSpecs.length && isInGutter(sel.anchorNode)) {
            this.cm.triggerOnKeyDown({ type: "keydown", keyCode: 8, preventDefault: Math.abs });
            this.blur();
            this.focus();
            return;
          }
          if (this.composing) {
            return;
          }
          this.rememberSelection();
          var anchor = domToPos(cm, sel.anchorNode, sel.anchorOffset);
          var head = domToPos(cm, sel.focusNode, sel.focusOffset);
          if (anchor && head) {
            runInOp(cm, function() {
              setSelection(cm.doc, simpleSelection(anchor, head), sel_dontScroll);
              if (anchor.bad || head.bad) {
                cm.curOp.selectionChanged = true;
              }
            });
          }
        };
        ContentEditableInput.prototype.pollContent = function() {
          if (this.readDOMTimeout != null) {
            clearTimeout(this.readDOMTimeout);
            this.readDOMTimeout = null;
          }
          var cm = this.cm, display = cm.display, sel = cm.doc.sel.primary();
          var from = sel.from(), to = sel.to();
          if (from.ch == 0 && from.line > cm.firstLine()) {
            from = Pos(from.line - 1, getLine(cm.doc, from.line - 1).length);
          }
          if (to.ch == getLine(cm.doc, to.line).text.length && to.line < cm.lastLine()) {
            to = Pos(to.line + 1, 0);
          }
          if (from.line < display.viewFrom || to.line > display.viewTo - 1) {
            return false;
          }
          var fromIndex, fromLine, fromNode;
          if (from.line == display.viewFrom || (fromIndex = findViewIndex(cm, from.line)) == 0) {
            fromLine = lineNo(display.view[0].line);
            fromNode = display.view[0].node;
          } else {
            fromLine = lineNo(display.view[fromIndex].line);
            fromNode = display.view[fromIndex - 1].node.nextSibling;
          }
          var toIndex = findViewIndex(cm, to.line);
          var toLine, toNode;
          if (toIndex == display.view.length - 1) {
            toLine = display.viewTo - 1;
            toNode = display.lineDiv.lastChild;
          } else {
            toLine = lineNo(display.view[toIndex + 1].line) - 1;
            toNode = display.view[toIndex + 1].node.previousSibling;
          }
          if (!fromNode) {
            return false;
          }
          var newText = cm.doc.splitLines(domTextBetween(cm, fromNode, toNode, fromLine, toLine));
          var oldText = getBetween(cm.doc, Pos(fromLine, 0), Pos(toLine, getLine(cm.doc, toLine).text.length));
          while (newText.length > 1 && oldText.length > 1) {
            if (lst(newText) == lst(oldText)) {
              newText.pop();
              oldText.pop();
              toLine--;
            } else if (newText[0] == oldText[0]) {
              newText.shift();
              oldText.shift();
              fromLine++;
            } else {
              break;
            }
          }
          var cutFront = 0, cutEnd = 0;
          var newTop = newText[0], oldTop = oldText[0], maxCutFront = Math.min(newTop.length, oldTop.length);
          while (cutFront < maxCutFront && newTop.charCodeAt(cutFront) == oldTop.charCodeAt(cutFront)) {
            ++cutFront;
          }
          var newBot = lst(newText), oldBot = lst(oldText);
          var maxCutEnd = Math.min(newBot.length - (newText.length == 1 ? cutFront : 0), oldBot.length - (oldText.length == 1 ? cutFront : 0));
          while (cutEnd < maxCutEnd && newBot.charCodeAt(newBot.length - cutEnd - 1) == oldBot.charCodeAt(oldBot.length - cutEnd - 1)) {
            ++cutEnd;
          }
          if (newText.length == 1 && oldText.length == 1 && fromLine == from.line) {
            while (cutFront && cutFront > from.ch && newBot.charCodeAt(newBot.length - cutEnd - 1) == oldBot.charCodeAt(oldBot.length - cutEnd - 1)) {
              cutFront--;
              cutEnd++;
            }
          }
          newText[newText.length - 1] = newBot.slice(0, newBot.length - cutEnd).replace(/^\u200b+/, "");
          newText[0] = newText[0].slice(cutFront).replace(/\u200b+$/, "");
          var chFrom = Pos(fromLine, cutFront);
          var chTo = Pos(toLine, oldText.length ? lst(oldText).length - cutEnd : 0);
          if (newText.length > 1 || newText[0] || cmp(chFrom, chTo)) {
            replaceRange(cm.doc, newText, chFrom, chTo, "+input");
            return true;
          }
        };
        ContentEditableInput.prototype.ensurePolled = function() {
          this.forceCompositionEnd();
        };
        ContentEditableInput.prototype.reset = function() {
          this.forceCompositionEnd();
        };
        ContentEditableInput.prototype.forceCompositionEnd = function() {
          if (!this.composing) {
            return;
          }
          clearTimeout(this.readDOMTimeout);
          this.composing = null;
          this.updateFromDOM();
          this.div.blur();
          this.div.focus();
        };
        ContentEditableInput.prototype.readFromDOMSoon = function() {
          var this$1 = this;
          if (this.readDOMTimeout != null) {
            return;
          }
          this.readDOMTimeout = setTimeout(function() {
            this$1.readDOMTimeout = null;
            if (this$1.composing) {
              if (this$1.composing.done) {
                this$1.composing = null;
              } else {
                return;
              }
            }
            this$1.updateFromDOM();
          }, 80);
        };
        ContentEditableInput.prototype.updateFromDOM = function() {
          var this$1 = this;
          if (this.cm.isReadOnly() || !this.pollContent()) {
            runInOp(this.cm, function() {
              return regChange(this$1.cm);
            });
          }
        };
        ContentEditableInput.prototype.setUneditable = function(node) {
          node.contentEditable = "false";
        };
        ContentEditableInput.prototype.onKeyPress = function(e5) {
          if (e5.charCode == 0 || this.composing) {
            return;
          }
          e5.preventDefault();
          if (!this.cm.isReadOnly()) {
            operation(this.cm, applyTextInput)(this.cm, String.fromCharCode(e5.charCode == null ? e5.keyCode : e5.charCode), 0);
          }
        };
        ContentEditableInput.prototype.readOnlyChanged = function(val) {
          this.div.contentEditable = String(val != "nocursor");
        };
        ContentEditableInput.prototype.onContextMenu = function() {
        };
        ContentEditableInput.prototype.resetPosition = function() {
        };
        ContentEditableInput.prototype.needsContentAttribute = true;
        function posToDOM(cm, pos) {
          var view = findViewForLine(cm, pos.line);
          if (!view || view.hidden) {
            return null;
          }
          var line = getLine(cm.doc, pos.line);
          var info = mapFromLineView(view, line, pos.line);
          var order = getOrder(line, cm.doc.direction), side = "left";
          if (order) {
            var partPos = getBidiPartAt(order, pos.ch);
            side = partPos % 2 ? "right" : "left";
          }
          var result = nodeAndOffsetInLineMap(info.map, pos.ch, side);
          result.offset = result.collapse == "right" ? result.end : result.start;
          return result;
        }
        function isInGutter(node) {
          for (var scan = node; scan; scan = scan.parentNode) {
            if (/CodeMirror-gutter-wrapper/.test(scan.className)) {
              return true;
            }
          }
          return false;
        }
        function badPos(pos, bad) {
          if (bad) {
            pos.bad = true;
          }
          return pos;
        }
        function domTextBetween(cm, from, to, fromLine, toLine) {
          var text = "", closing = false, lineSep = cm.doc.lineSeparator(), extraLinebreak = false;
          function recognizeMarker(id) {
            return function(marker) {
              return marker.id == id;
            };
          }
          function close() {
            if (closing) {
              text += lineSep;
              if (extraLinebreak) {
                text += lineSep;
              }
              closing = extraLinebreak = false;
            }
          }
          function addText(str) {
            if (str) {
              close();
              text += str;
            }
          }
          function walk(node) {
            if (node.nodeType == 1) {
              var cmText = node.getAttribute("cm-text");
              if (cmText) {
                addText(cmText);
                return;
              }
              var markerID = node.getAttribute("cm-marker"), range3;
              if (markerID) {
                var found = cm.findMarks(Pos(fromLine, 0), Pos(toLine + 1, 0), recognizeMarker(+markerID));
                if (found.length && (range3 = found[0].find(0))) {
                  addText(getBetween(cm.doc, range3.from, range3.to).join(lineSep));
                }
                return;
              }
              if (node.getAttribute("contenteditable") == "false") {
                return;
              }
              var isBlock = /^(pre|div|p|li|table|br)$/i.test(node.nodeName);
              if (!/^br$/i.test(node.nodeName) && node.textContent.length == 0) {
                return;
              }
              if (isBlock) {
                close();
              }
              for (var i4 = 0; i4 < node.childNodes.length; i4++) {
                walk(node.childNodes[i4]);
              }
              if (/^(pre|p)$/i.test(node.nodeName)) {
                extraLinebreak = true;
              }
              if (isBlock) {
                closing = true;
              }
            } else if (node.nodeType == 3) {
              addText(node.nodeValue.replace(/\u200b/g, "").replace(/\u00a0/g, " "));
            }
          }
          for (; ; ) {
            walk(from);
            if (from == to) {
              break;
            }
            from = from.nextSibling;
            extraLinebreak = false;
          }
          return text;
        }
        function domToPos(cm, node, offset) {
          var lineNode;
          if (node == cm.display.lineDiv) {
            lineNode = cm.display.lineDiv.childNodes[offset];
            if (!lineNode) {
              return badPos(cm.clipPos(Pos(cm.display.viewTo - 1)), true);
            }
            node = null;
            offset = 0;
          } else {
            for (lineNode = node; ; lineNode = lineNode.parentNode) {
              if (!lineNode || lineNode == cm.display.lineDiv) {
                return null;
              }
              if (lineNode.parentNode && lineNode.parentNode == cm.display.lineDiv) {
                break;
              }
            }
          }
          for (var i4 = 0; i4 < cm.display.view.length; i4++) {
            var lineView = cm.display.view[i4];
            if (lineView.node == lineNode) {
              return locateNodeInLineView(lineView, node, offset);
            }
          }
        }
        function locateNodeInLineView(lineView, node, offset) {
          var wrapper = lineView.text.firstChild, bad = false;
          if (!node || !contains3(wrapper, node)) {
            return badPos(Pos(lineNo(lineView.line), 0), true);
          }
          if (node == wrapper) {
            bad = true;
            node = wrapper.childNodes[offset];
            offset = 0;
            if (!node) {
              var line = lineView.rest ? lst(lineView.rest) : lineView.line;
              return badPos(Pos(lineNo(line), line.text.length), bad);
            }
          }
          var textNode = node.nodeType == 3 ? node : null, topNode = node;
          if (!textNode && node.childNodes.length == 1 && node.firstChild.nodeType == 3) {
            textNode = node.firstChild;
            if (offset) {
              offset = textNode.nodeValue.length;
            }
          }
          while (topNode.parentNode != wrapper) {
            topNode = topNode.parentNode;
          }
          var measure = lineView.measure, maps = measure.maps;
          function find(textNode2, topNode2, offset2) {
            for (var i4 = -1; i4 < (maps ? maps.length : 0); i4++) {
              var map4 = i4 < 0 ? measure.map : maps[i4];
              for (var j3 = 0; j3 < map4.length; j3 += 3) {
                var curNode = map4[j3 + 2];
                if (curNode == textNode2 || curNode == topNode2) {
                  var line2 = lineNo(i4 < 0 ? lineView.line : lineView.rest[i4]);
                  var ch = map4[j3] + offset2;
                  if (offset2 < 0 || curNode != textNode2) {
                    ch = map4[j3 + (offset2 ? 1 : 0)];
                  }
                  return Pos(line2, ch);
                }
              }
            }
          }
          var found = find(textNode, topNode, offset);
          if (found) {
            return badPos(found, bad);
          }
          for (var after = topNode.nextSibling, dist = textNode ? textNode.nodeValue.length - offset : 0; after; after = after.nextSibling) {
            found = find(after, after.firstChild, 0);
            if (found) {
              return badPos(Pos(found.line, found.ch - dist), bad);
            } else {
              dist += after.textContent.length;
            }
          }
          for (var before = topNode.previousSibling, dist$1 = offset; before; before = before.previousSibling) {
            found = find(before, before.firstChild, -1);
            if (found) {
              return badPos(Pos(found.line, found.ch + dist$1), bad);
            } else {
              dist$1 += before.textContent.length;
            }
          }
        }
        var TextareaInput = function(cm) {
          this.cm = cm;
          this.prevInput = "";
          this.pollingFast = false;
          this.polling = new Delayed();
          this.hasSelection = false;
          this.composing = null;
        };
        TextareaInput.prototype.init = function(display) {
          var this$1 = this;
          var input = this, cm = this.cm;
          this.createField(display);
          var te = this.textarea;
          display.wrapper.insertBefore(this.wrapper, display.wrapper.firstChild);
          if (ios) {
            te.style.width = "0px";
          }
          on(te, "input", function() {
            if (ie && ie_version >= 9 && this$1.hasSelection) {
              this$1.hasSelection = null;
            }
            input.poll();
          });
          on(te, "paste", function(e5) {
            if (signalDOMEvent(cm, e5) || eventInWidget(cm.display, e5)) {
              return;
            }
            if (handlePaste(e5, cm)) {
              return true;
            }
            cm.state.pasteIncoming = +new Date();
            input.fastPoll();
          });
          function prepareCopyCut(e5) {
            if (signalDOMEvent(cm, e5) || eventInWidget(d, e5)) {
              return;
            }
            if (cm.somethingSelected()) {
              setLastCopied({ lineWise: false, text: cm.getSelections() });
            } else if (!cm.options.lineWiseCopyCut) {
              return;
            } else {
              var ranges = copyableRanges(cm);
              setLastCopied({ lineWise: true, text: ranges.text });
              if (e5.type == "cut") {
                cm.setSelections(ranges.ranges, null, sel_dontScroll);
              } else {
                input.prevInput = "";
                te.value = ranges.text.join("\n");
                selectInput(te);
              }
            }
            if (e5.type == "cut") {
              cm.state.cutIncoming = +new Date();
            }
          }
          on(te, "cut", prepareCopyCut);
          on(te, "copy", prepareCopyCut);
          on(display.scroller, "paste", function(e5) {
            if (signalDOMEvent(cm, e5) || eventInWidget(display, e5)) {
              return;
            }
            if (!te.dispatchEvent) {
              cm.state.pasteIncoming = +new Date();
              input.focus();
              return;
            }
            var event2 = new Event("paste");
            event2.clipboardData = e5.clipboardData;
            te.dispatchEvent(event2);
          });
          on(display.lineSpace, "selectstart", function(e5) {
            if (!eventInWidget(display, e5)) {
              e_preventDefault(e5);
            }
          });
          on(te, "compositionstart", function() {
            cm.options.moveInputWithCursor = true;
            var start2 = cm.getCursor("from");
            if (input.composing) {
              input.composing.range.clear();
            }
            input.composing = {
              start: start2,
              range: cm.markText(start2, cm.getCursor("to"), { className: "CodeMirror-composing" })
            };
          });
          on(te, "compositionend", function() {
            if (input.composing) {
              input.poll();
              input.composing.range.clear();
              input.composing = null;
              cm.options.moveInputWithCursor = false;
            }
          });
        };
        TextareaInput.prototype.createField = function(_display) {
          this.wrapper = hiddenTextarea();
          this.textarea = this.wrapper.firstChild;
        };
        TextareaInput.prototype.screenReaderLabelChanged = function(label) {
          if (label) {
            this.textarea.setAttribute("aria-label", label);
          } else {
            this.textarea.removeAttribute("aria-label");
          }
        };
        TextareaInput.prototype.prepareSelection = function() {
          var cm = this.cm, display = cm.display, doc = cm.doc;
          var result = prepareSelection(cm);
          if (cm.options.moveInputWithCursor) {
            var headPos = cursorCoords(cm, doc.sel.primary().head, "div");
            var wrapOff = display.wrapper.getBoundingClientRect(), lineOff = display.lineDiv.getBoundingClientRect();
            result.teTop = Math.max(0, Math.min(display.wrapper.clientHeight - 10, headPos.top + lineOff.top - wrapOff.top));
            result.teLeft = Math.max(0, Math.min(display.wrapper.clientWidth - 10, headPos.left + lineOff.left - wrapOff.left));
          }
          return result;
        };
        TextareaInput.prototype.showSelection = function(drawn) {
          var cm = this.cm, display = cm.display;
          removeChildrenAndAdd(display.cursorDiv, drawn.cursors);
          removeChildrenAndAdd(display.selectionDiv, drawn.selection);
          if (drawn.teTop != null) {
            this.wrapper.style.top = drawn.teTop + "px";
            this.wrapper.style.left = drawn.teLeft + "px";
          }
        };
        TextareaInput.prototype.reset = function(typing) {
          if (this.contextMenuPending || this.composing) {
            return;
          }
          var cm = this.cm;
          if (cm.somethingSelected()) {
            this.prevInput = "";
            var content = cm.getSelection();
            this.textarea.value = content;
            if (cm.state.focused) {
              selectInput(this.textarea);
            }
            if (ie && ie_version >= 9) {
              this.hasSelection = content;
            }
          } else if (!typing) {
            this.prevInput = this.textarea.value = "";
            if (ie && ie_version >= 9) {
              this.hasSelection = null;
            }
          }
        };
        TextareaInput.prototype.getField = function() {
          return this.textarea;
        };
        TextareaInput.prototype.supportsTouch = function() {
          return false;
        };
        TextareaInput.prototype.focus = function() {
          if (this.cm.options.readOnly != "nocursor" && (!mobile || activeElt() != this.textarea)) {
            try {
              this.textarea.focus();
            } catch (e5) {
            }
          }
        };
        TextareaInput.prototype.blur = function() {
          this.textarea.blur();
        };
        TextareaInput.prototype.resetPosition = function() {
          this.wrapper.style.top = this.wrapper.style.left = 0;
        };
        TextareaInput.prototype.receivedFocus = function() {
          this.slowPoll();
        };
        TextareaInput.prototype.slowPoll = function() {
          var this$1 = this;
          if (this.pollingFast) {
            return;
          }
          this.polling.set(this.cm.options.pollInterval, function() {
            this$1.poll();
            if (this$1.cm.state.focused) {
              this$1.slowPoll();
            }
          });
        };
        TextareaInput.prototype.fastPoll = function() {
          var missed = false, input = this;
          input.pollingFast = true;
          function p3() {
            var changed = input.poll();
            if (!changed && !missed) {
              missed = true;
              input.polling.set(60, p3);
            } else {
              input.pollingFast = false;
              input.slowPoll();
            }
          }
          input.polling.set(20, p3);
        };
        TextareaInput.prototype.poll = function() {
          var this$1 = this;
          var cm = this.cm, input = this.textarea, prevInput = this.prevInput;
          if (this.contextMenuPending || !cm.state.focused || hasSelection(input) && !prevInput && !this.composing || cm.isReadOnly() || cm.options.disableInput || cm.state.keySeq) {
            return false;
          }
          var text = input.value;
          if (text == prevInput && !cm.somethingSelected()) {
            return false;
          }
          if (ie && ie_version >= 9 && this.hasSelection === text || mac && /[\uf700-\uf7ff]/.test(text)) {
            cm.display.input.reset();
            return false;
          }
          if (cm.doc.sel == cm.display.selForContextMenu) {
            var first = text.charCodeAt(0);
            if (first == 8203 && !prevInput) {
              prevInput = "\u200B";
            }
            if (first == 8666) {
              this.reset();
              return this.cm.execCommand("undo");
            }
          }
          var same = 0, l3 = Math.min(prevInput.length, text.length);
          while (same < l3 && prevInput.charCodeAt(same) == text.charCodeAt(same)) {
            ++same;
          }
          runInOp(cm, function() {
            applyTextInput(cm, text.slice(same), prevInput.length - same, null, this$1.composing ? "*compose" : null);
            if (text.length > 1e3 || text.indexOf("\n") > -1) {
              input.value = this$1.prevInput = "";
            } else {
              this$1.prevInput = text;
            }
            if (this$1.composing) {
              this$1.composing.range.clear();
              this$1.composing.range = cm.markText(this$1.composing.start, cm.getCursor("to"), { className: "CodeMirror-composing" });
            }
          });
          return true;
        };
        TextareaInput.prototype.ensurePolled = function() {
          if (this.pollingFast && this.poll()) {
            this.pollingFast = false;
          }
        };
        TextareaInput.prototype.onKeyPress = function() {
          if (ie && ie_version >= 9) {
            this.hasSelection = null;
          }
          this.fastPoll();
        };
        TextareaInput.prototype.onContextMenu = function(e5) {
          var input = this, cm = input.cm, display = cm.display, te = input.textarea;
          if (input.contextMenuPending) {
            input.contextMenuPending();
          }
          var pos = posFromMouse(cm, e5), scrollPos = display.scroller.scrollTop;
          if (!pos || presto) {
            return;
          }
          var reset = cm.options.resetSelectionOnContextMenu;
          if (reset && (!cm.doc.somethingSelected() || cm.doc.sel.contains(pos) == -1)) {
            operation(cm, setSelection)(cm.doc, simpleSelection(pos), sel_dontScroll);
          }
          var oldCSS = te.style.cssText, oldWrapperCSS = input.wrapper.style.cssText;
          var wrapperBox = input.wrapper.offsetParent.getBoundingClientRect();
          input.wrapper.style.cssText = "position: static";
          te.style.cssText = "position: absolute; width: 30px; height: 30px;\n      top: " + (e5.clientY - wrapperBox.top - 5) + "px; left: " + (e5.clientX - wrapperBox.left - 5) + "px;\n      z-index: 1000; background: " + (ie ? "rgba(255, 255, 255, .05)" : "transparent") + ";\n      outline: none; border-width: 0; outline: none; overflow: hidden; opacity: .05; filter: alpha(opacity=5);";
          var oldScrollY;
          if (webkit) {
            oldScrollY = window.scrollY;
          }
          display.input.focus();
          if (webkit) {
            window.scrollTo(null, oldScrollY);
          }
          display.input.reset();
          if (!cm.somethingSelected()) {
            te.value = input.prevInput = " ";
          }
          input.contextMenuPending = rehide;
          display.selForContextMenu = cm.doc.sel;
          clearTimeout(display.detectingSelectAll);
          function prepareSelectAllHack() {
            if (te.selectionStart != null) {
              var selected = cm.somethingSelected();
              var extval = "\u200B" + (selected ? te.value : "");
              te.value = "\u21DA";
              te.value = extval;
              input.prevInput = selected ? "" : "\u200B";
              te.selectionStart = 1;
              te.selectionEnd = extval.length;
              display.selForContextMenu = cm.doc.sel;
            }
          }
          function rehide() {
            if (input.contextMenuPending != rehide) {
              return;
            }
            input.contextMenuPending = false;
            input.wrapper.style.cssText = oldWrapperCSS;
            te.style.cssText = oldCSS;
            if (ie && ie_version < 9) {
              display.scrollbars.setScrollTop(display.scroller.scrollTop = scrollPos);
            }
            if (te.selectionStart != null) {
              if (!ie || ie && ie_version < 9) {
                prepareSelectAllHack();
              }
              var i4 = 0, poll = function() {
                if (display.selForContextMenu == cm.doc.sel && te.selectionStart == 0 && te.selectionEnd > 0 && input.prevInput == "\u200B") {
                  operation(cm, selectAll)(cm);
                } else if (i4++ < 10) {
                  display.detectingSelectAll = setTimeout(poll, 500);
                } else {
                  display.selForContextMenu = null;
                  display.input.reset();
                }
              };
              display.detectingSelectAll = setTimeout(poll, 200);
            }
          }
          if (ie && ie_version >= 9) {
            prepareSelectAllHack();
          }
          if (captureRightClick) {
            e_stop(e5);
            var mouseup = function() {
              off(window, "mouseup", mouseup);
              setTimeout(rehide, 20);
            };
            on(window, "mouseup", mouseup);
          } else {
            setTimeout(rehide, 50);
          }
        };
        TextareaInput.prototype.readOnlyChanged = function(val) {
          if (!val) {
            this.reset();
          }
          this.textarea.disabled = val == "nocursor";
        };
        TextareaInput.prototype.setUneditable = function() {
        };
        TextareaInput.prototype.needsContentAttribute = false;
        function fromTextArea(textarea, options) {
          options = options ? copyObj(options) : {};
          options.value = textarea.value;
          if (!options.tabindex && textarea.tabIndex) {
            options.tabindex = textarea.tabIndex;
          }
          if (!options.placeholder && textarea.placeholder) {
            options.placeholder = textarea.placeholder;
          }
          if (options.autofocus == null) {
            var hasFocus = activeElt();
            options.autofocus = hasFocus == textarea || textarea.getAttribute("autofocus") != null && hasFocus == document.body;
          }
          function save() {
            textarea.value = cm.getValue();
          }
          var realSubmit;
          if (textarea.form) {
            on(textarea.form, "submit", save);
            if (!options.leaveSubmitMethodAlone) {
              var form = textarea.form;
              realSubmit = form.submit;
              try {
                var wrappedSubmit = form.submit = function() {
                  save();
                  form.submit = realSubmit;
                  form.submit();
                  form.submit = wrappedSubmit;
                };
              } catch (e5) {
              }
            }
          }
          options.finishInit = function(cm2) {
            cm2.save = save;
            cm2.getTextArea = function() {
              return textarea;
            };
            cm2.toTextArea = function() {
              cm2.toTextArea = isNaN;
              save();
              textarea.parentNode.removeChild(cm2.getWrapperElement());
              textarea.style.display = "";
              if (textarea.form) {
                off(textarea.form, "submit", save);
                if (!options.leaveSubmitMethodAlone && typeof textarea.form.submit == "function") {
                  textarea.form.submit = realSubmit;
                }
              }
            };
          };
          textarea.style.display = "none";
          var cm = CodeMirror5(function(node) {
            return textarea.parentNode.insertBefore(node, textarea.nextSibling);
          }, options);
          return cm;
        }
        function addLegacyProps(CodeMirror6) {
          CodeMirror6.off = off;
          CodeMirror6.on = on;
          CodeMirror6.wheelEventPixels = wheelEventPixels;
          CodeMirror6.Doc = Doc;
          CodeMirror6.splitLines = splitLinesAuto;
          CodeMirror6.countColumn = countColumn;
          CodeMirror6.findColumn = findColumn;
          CodeMirror6.isWordChar = isWordCharBasic;
          CodeMirror6.Pass = Pass;
          CodeMirror6.signal = signal;
          CodeMirror6.Line = Line;
          CodeMirror6.changeEnd = changeEnd;
          CodeMirror6.scrollbarModel = scrollbarModel;
          CodeMirror6.Pos = Pos;
          CodeMirror6.cmpPos = cmp;
          CodeMirror6.modes = modes;
          CodeMirror6.mimeModes = mimeModes;
          CodeMirror6.resolveMode = resolveMode;
          CodeMirror6.getMode = getMode2;
          CodeMirror6.modeExtensions = modeExtensions;
          CodeMirror6.extendMode = extendMode;
          CodeMirror6.copyState = copyState2;
          CodeMirror6.startState = startState;
          CodeMirror6.innerMode = innerMode;
          CodeMirror6.commands = commands;
          CodeMirror6.keyMap = keyMap;
          CodeMirror6.keyName = keyName;
          CodeMirror6.isModifierKey = isModifierKey;
          CodeMirror6.lookupKey = lookupKey;
          CodeMirror6.normalizeKeyMap = normalizeKeyMap;
          CodeMirror6.StringStream = StringStream2;
          CodeMirror6.SharedTextMarker = SharedTextMarker;
          CodeMirror6.TextMarker = TextMarker;
          CodeMirror6.LineWidget = LineWidget;
          CodeMirror6.e_preventDefault = e_preventDefault;
          CodeMirror6.e_stopPropagation = e_stopPropagation;
          CodeMirror6.e_stop = e_stop;
          CodeMirror6.addClass = addClass2;
          CodeMirror6.contains = contains3;
          CodeMirror6.rmClass = rmClass;
          CodeMirror6.keyNames = keyNames;
        }
        defineOptions(CodeMirror5);
        addEditorMethods(CodeMirror5);
        var dontDelegate = "iter insert remove copy getEditor constructor".split(" ");
        for (var prop in Doc.prototype) {
          if (Doc.prototype.hasOwnProperty(prop) && indexOf(dontDelegate, prop) < 0) {
            CodeMirror5.prototype[prop] = function(method) {
              return function() {
                return method.apply(this.doc, arguments);
              };
            }(Doc.prototype[prop]);
          }
        }
        eventMixin(Doc);
        CodeMirror5.inputStyles = { "textarea": TextareaInput, "contenteditable": ContentEditableInput };
        CodeMirror5.defineMode = function(name106) {
          if (!CodeMirror5.defaults.mode && name106 != "null") {
            CodeMirror5.defaults.mode = name106;
          }
          defineMode.apply(this, arguments);
        };
        CodeMirror5.defineMIME = defineMIME;
        CodeMirror5.defineMode("null", function() {
          return { token: function(stream) {
            return stream.skipToEnd();
          } };
        });
        CodeMirror5.defineMIME("text/plain", "null");
        CodeMirror5.defineExtension = function(name106, func) {
          CodeMirror5.prototype[name106] = func;
        };
        CodeMirror5.defineDocExtension = function(name106, func) {
          Doc.prototype[name106] = func;
        };
        CodeMirror5.fromTextArea = fromTextArea;
        addLegacyProps(CodeMirror5);
        CodeMirror5.version = "5.53.2";
        return CodeMirror5;
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/xml/xml.js
  var require_xml = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/xml/xml.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var htmlConfig = {
          autoSelfClosers: {
            "area": true,
            "base": true,
            "br": true,
            "col": true,
            "command": true,
            "embed": true,
            "frame": true,
            "hr": true,
            "img": true,
            "input": true,
            "keygen": true,
            "link": true,
            "meta": true,
            "param": true,
            "source": true,
            "track": true,
            "wbr": true,
            "menuitem": true
          },
          implicitlyClosed: {
            "dd": true,
            "li": true,
            "optgroup": true,
            "option": true,
            "p": true,
            "rp": true,
            "rt": true,
            "tbody": true,
            "td": true,
            "tfoot": true,
            "th": true,
            "tr": true
          },
          contextGrabbers: {
            "dd": { "dd": true, "dt": true },
            "dt": { "dd": true, "dt": true },
            "li": { "li": true },
            "option": { "option": true, "optgroup": true },
            "optgroup": { "optgroup": true },
            "p": {
              "address": true,
              "article": true,
              "aside": true,
              "blockquote": true,
              "dir": true,
              "div": true,
              "dl": true,
              "fieldset": true,
              "footer": true,
              "form": true,
              "h1": true,
              "h2": true,
              "h3": true,
              "h4": true,
              "h5": true,
              "h6": true,
              "header": true,
              "hgroup": true,
              "hr": true,
              "menu": true,
              "nav": true,
              "ol": true,
              "p": true,
              "pre": true,
              "section": true,
              "table": true,
              "ul": true
            },
            "rp": { "rp": true, "rt": true },
            "rt": { "rp": true, "rt": true },
            "tbody": { "tbody": true, "tfoot": true },
            "td": { "td": true, "th": true },
            "tfoot": { "tbody": true },
            "th": { "td": true, "th": true },
            "thead": { "tbody": true, "tfoot": true },
            "tr": { "tr": true }
          },
          doNotIndent: { "pre": true },
          allowUnquoted: true,
          allowMissing: true,
          caseFold: true
        };
        var xmlConfig = {
          autoSelfClosers: {},
          implicitlyClosed: {},
          contextGrabbers: {},
          doNotIndent: {},
          allowUnquoted: false,
          allowMissing: false,
          allowMissingTagName: false,
          caseFold: false
        };
        CodeMirror5.defineMode("xml", function(editorConf, config_) {
          var indentUnit = editorConf.indentUnit;
          var config3 = {};
          var defaults = config_.htmlMode ? htmlConfig : xmlConfig;
          for (var prop in defaults)
            config3[prop] = defaults[prop];
          for (var prop in config_)
            config3[prop] = config_[prop];
          var type, setStyle2;
          function inText(stream, state) {
            function chain2(parser2) {
              state.tokenize = parser2;
              return parser2(stream, state);
            }
            var ch = stream.next();
            if (ch == "<") {
              if (stream.eat("!")) {
                if (stream.eat("[")) {
                  if (stream.match("CDATA["))
                    return chain2(inBlock("atom", "]]>"));
                  else
                    return null;
                } else if (stream.match("--")) {
                  return chain2(inBlock("comment", "-->"));
                } else if (stream.match("DOCTYPE", true, true)) {
                  stream.eatWhile(/[\w\._\-]/);
                  return chain2(doctype(1));
                } else {
                  return null;
                }
              } else if (stream.eat("?")) {
                stream.eatWhile(/[\w\._\-]/);
                state.tokenize = inBlock("meta", "?>");
                return "meta";
              } else {
                type = stream.eat("/") ? "closeTag" : "openTag";
                state.tokenize = inTag;
                return "tag bracket";
              }
            } else if (ch == "&") {
              var ok5;
              if (stream.eat("#")) {
                if (stream.eat("x")) {
                  ok5 = stream.eatWhile(/[a-fA-F\d]/) && stream.eat(";");
                } else {
                  ok5 = stream.eatWhile(/[\d]/) && stream.eat(";");
                }
              } else {
                ok5 = stream.eatWhile(/[\w\.\-:]/) && stream.eat(";");
              }
              return ok5 ? "atom" : "error";
            } else {
              stream.eatWhile(/[^&<]/);
              return null;
            }
          }
          inText.isInText = true;
          function inTag(stream, state) {
            var ch = stream.next();
            if (ch == ">" || ch == "/" && stream.eat(">")) {
              state.tokenize = inText;
              type = ch == ">" ? "endTag" : "selfcloseTag";
              return "tag bracket";
            } else if (ch == "=") {
              type = "equals";
              return null;
            } else if (ch == "<") {
              state.tokenize = inText;
              state.state = baseState;
              state.tagName = state.tagStart = null;
              var next = state.tokenize(stream, state);
              return next ? next + " tag error" : "tag error";
            } else if (/[\'\"]/.test(ch)) {
              state.tokenize = inAttribute(ch);
              state.stringStartCol = stream.column();
              return state.tokenize(stream, state);
            } else {
              stream.match(/^[^\s\u00a0=<>\"\']*[^\s\u00a0=<>\"\'\/]/);
              return "word";
            }
          }
          function inAttribute(quote) {
            var closure = function(stream, state) {
              while (!stream.eol()) {
                if (stream.next() == quote) {
                  state.tokenize = inTag;
                  break;
                }
              }
              return "string";
            };
            closure.isInAttribute = true;
            return closure;
          }
          function inBlock(style, terminator) {
            return function(stream, state) {
              while (!stream.eol()) {
                if (stream.match(terminator)) {
                  state.tokenize = inText;
                  break;
                }
                stream.next();
              }
              return style;
            };
          }
          function doctype(depth) {
            return function(stream, state) {
              var ch;
              while ((ch = stream.next()) != null) {
                if (ch == "<") {
                  state.tokenize = doctype(depth + 1);
                  return state.tokenize(stream, state);
                } else if (ch == ">") {
                  if (depth == 1) {
                    state.tokenize = inText;
                    break;
                  } else {
                    state.tokenize = doctype(depth - 1);
                    return state.tokenize(stream, state);
                  }
                }
              }
              return "meta";
            };
          }
          function Context(state, tagName, startOfLine) {
            this.prev = state.context;
            this.tagName = tagName;
            this.indent = state.indented;
            this.startOfLine = startOfLine;
            if (config3.doNotIndent.hasOwnProperty(tagName) || state.context && state.context.noIndent)
              this.noIndent = true;
          }
          function popContext(state) {
            if (state.context)
              state.context = state.context.prev;
          }
          function maybePopContext(state, nextTagName) {
            var parentTagName;
            while (true) {
              if (!state.context) {
                return;
              }
              parentTagName = state.context.tagName;
              if (!config3.contextGrabbers.hasOwnProperty(parentTagName) || !config3.contextGrabbers[parentTagName].hasOwnProperty(nextTagName)) {
                return;
              }
              popContext(state);
            }
          }
          function baseState(type2, stream, state) {
            if (type2 == "openTag") {
              state.tagStart = stream.column();
              return tagNameState;
            } else if (type2 == "closeTag") {
              return closeTagNameState;
            } else {
              return baseState;
            }
          }
          function tagNameState(type2, stream, state) {
            if (type2 == "word") {
              state.tagName = stream.current();
              setStyle2 = "tag";
              return attrState;
            } else if (config3.allowMissingTagName && type2 == "endTag") {
              setStyle2 = "tag bracket";
              return attrState(type2, stream, state);
            } else {
              setStyle2 = "error";
              return tagNameState;
            }
          }
          function closeTagNameState(type2, stream, state) {
            if (type2 == "word") {
              var tagName = stream.current();
              if (state.context && state.context.tagName != tagName && config3.implicitlyClosed.hasOwnProperty(state.context.tagName))
                popContext(state);
              if (state.context && state.context.tagName == tagName || config3.matchClosing === false) {
                setStyle2 = "tag";
                return closeState;
              } else {
                setStyle2 = "tag error";
                return closeStateErr;
              }
            } else if (config3.allowMissingTagName && type2 == "endTag") {
              setStyle2 = "tag bracket";
              return closeState(type2, stream, state);
            } else {
              setStyle2 = "error";
              return closeStateErr;
            }
          }
          function closeState(type2, _stream, state) {
            if (type2 != "endTag") {
              setStyle2 = "error";
              return closeState;
            }
            popContext(state);
            return baseState;
          }
          function closeStateErr(type2, stream, state) {
            setStyle2 = "error";
            return closeState(type2, stream, state);
          }
          function attrState(type2, _stream, state) {
            if (type2 == "word") {
              setStyle2 = "attribute";
              return attrEqState;
            } else if (type2 == "endTag" || type2 == "selfcloseTag") {
              var tagName = state.tagName, tagStart = state.tagStart;
              state.tagName = state.tagStart = null;
              if (type2 == "selfcloseTag" || config3.autoSelfClosers.hasOwnProperty(tagName)) {
                maybePopContext(state, tagName);
              } else {
                maybePopContext(state, tagName);
                state.context = new Context(state, tagName, tagStart == state.indented);
              }
              return baseState;
            }
            setStyle2 = "error";
            return attrState;
          }
          function attrEqState(type2, stream, state) {
            if (type2 == "equals")
              return attrValueState;
            if (!config3.allowMissing)
              setStyle2 = "error";
            return attrState(type2, stream, state);
          }
          function attrValueState(type2, stream, state) {
            if (type2 == "string")
              return attrContinuedState;
            if (type2 == "word" && config3.allowUnquoted) {
              setStyle2 = "string";
              return attrState;
            }
            setStyle2 = "error";
            return attrState(type2, stream, state);
          }
          function attrContinuedState(type2, stream, state) {
            if (type2 == "string")
              return attrContinuedState;
            return attrState(type2, stream, state);
          }
          return {
            startState: function(baseIndent) {
              var state = {
                tokenize: inText,
                state: baseState,
                indented: baseIndent || 0,
                tagName: null,
                tagStart: null,
                context: null
              };
              if (baseIndent != null)
                state.baseIndent = baseIndent;
              return state;
            },
            token: function(stream, state) {
              if (!state.tagName && stream.sol())
                state.indented = stream.indentation();
              if (stream.eatSpace())
                return null;
              type = null;
              var style = state.tokenize(stream, state);
              if ((style || type) && style != "comment") {
                setStyle2 = null;
                state.state = state.state(type || style, stream, state);
                if (setStyle2)
                  style = setStyle2 == "error" ? style + " error" : setStyle2;
              }
              return style;
            },
            indent: function(state, textAfter, fullLine) {
              var context = state.context;
              if (state.tokenize.isInAttribute) {
                if (state.tagStart == state.indented)
                  return state.stringStartCol + 1;
                else
                  return state.indented + indentUnit;
              }
              if (context && context.noIndent)
                return CodeMirror5.Pass;
              if (state.tokenize != inTag && state.tokenize != inText)
                return fullLine ? fullLine.match(/^(\s*)/)[0].length : 0;
              if (state.tagName) {
                if (config3.multilineTagIndentPastTag !== false)
                  return state.tagStart + state.tagName.length + 2;
                else
                  return state.tagStart + indentUnit * (config3.multilineTagIndentFactor || 1);
              }
              if (config3.alignCDATA && /<!\[CDATA\[/.test(textAfter))
                return 0;
              var tagAfter = textAfter && /^<(\/)?([\w_:\.-]*)/.exec(textAfter);
              if (tagAfter && tagAfter[1]) {
                while (context) {
                  if (context.tagName == tagAfter[2]) {
                    context = context.prev;
                    break;
                  } else if (config3.implicitlyClosed.hasOwnProperty(context.tagName)) {
                    context = context.prev;
                  } else {
                    break;
                  }
                }
              } else if (tagAfter) {
                while (context) {
                  var grabbers = config3.contextGrabbers[context.tagName];
                  if (grabbers && grabbers.hasOwnProperty(tagAfter[2]))
                    context = context.prev;
                  else
                    break;
                }
              }
              while (context && context.prev && !context.startOfLine)
                context = context.prev;
              if (context)
                return context.indent + indentUnit;
              else
                return state.baseIndent || 0;
            },
            electricInput: /<\/[\s\w:]+>$/,
            blockCommentStart: "<!--",
            blockCommentEnd: "-->",
            configuration: config3.htmlMode ? "html" : "xml",
            helperType: config3.htmlMode ? "html" : "xml",
            skipAttribute: function(state) {
              if (state.state == attrValueState)
                state.state = attrState;
            },
            xmlCurrentTag: function(state) {
              return state.tagName ? { name: state.tagName, close: state.type == "closeTag" } : null;
            },
            xmlCurrentContext: function(state) {
              var context = [];
              for (var cx = state.context; cx; cx = cx.prev)
                if (cx.tagName)
                  context.push(cx.tagName);
              return context.reverse();
            }
          };
        });
        CodeMirror5.defineMIME("text/xml", "xml");
        CodeMirror5.defineMIME("application/xml", "xml");
        if (!CodeMirror5.mimeModes.hasOwnProperty("text/html"))
          CodeMirror5.defineMIME("text/html", { name: "xml", htmlMode: true });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/javascript/javascript.js
  var require_javascript = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/javascript/javascript.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("javascript", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit;
          var statementIndent = parserConfig.statementIndent;
          var jsonldMode = parserConfig.jsonld;
          var jsonMode = parserConfig.json || jsonldMode;
          var isTS = parserConfig.typescript;
          var wordRE = parserConfig.wordCharacters || /[\w$\xa1-\uffff]/;
          var keywords2 = function() {
            function kw(type2) {
              return { type: type2, style: "keyword" };
            }
            var A2 = kw("keyword a"), B = kw("keyword b"), C2 = kw("keyword c"), D = kw("keyword d");
            var operator = kw("operator"), atom = { type: "atom", style: "atom" };
            return {
              "if": kw("if"),
              "while": A2,
              "with": A2,
              "else": B,
              "do": B,
              "try": B,
              "finally": B,
              "return": D,
              "break": D,
              "continue": D,
              "new": kw("new"),
              "delete": C2,
              "void": C2,
              "throw": C2,
              "debugger": kw("debugger"),
              "var": kw("var"),
              "const": kw("var"),
              "let": kw("var"),
              "function": kw("function"),
              "catch": kw("catch"),
              "for": kw("for"),
              "switch": kw("switch"),
              "case": kw("case"),
              "default": kw("default"),
              "in": operator,
              "typeof": operator,
              "instanceof": operator,
              "true": atom,
              "false": atom,
              "null": atom,
              "undefined": atom,
              "NaN": atom,
              "Infinity": atom,
              "this": kw("this"),
              "class": kw("class"),
              "super": kw("atom"),
              "yield": C2,
              "export": kw("export"),
              "import": kw("import"),
              "extends": C2,
              "await": C2
            };
          }();
          var isOperatorChar = /[+\-*&%=<>!?|~^@]/;
          var isJsonldKeyword = /^@(context|id|value|language|type|container|list|set|reverse|index|base|vocab|graph)"/;
          function readRegexp(stream) {
            var escaped = false, next, inSet = false;
            while ((next = stream.next()) != null) {
              if (!escaped) {
                if (next == "/" && !inSet)
                  return;
                if (next == "[")
                  inSet = true;
                else if (inSet && next == "]")
                  inSet = false;
              }
              escaped = !escaped && next == "\\";
            }
          }
          var type, content;
          function ret(tp, style, cont2) {
            type = tp;
            content = cont2;
            return style;
          }
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            } else if (ch == "." && stream.match(/^\d[\d_]*(?:[eE][+\-]?[\d_]+)?/)) {
              return ret("number", "number");
            } else if (ch == "." && stream.match("..")) {
              return ret("spread", "meta");
            } else if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              return ret(ch);
            } else if (ch == "=" && stream.eat(">")) {
              return ret("=>", "operator");
            } else if (ch == "0" && stream.match(/^(?:x[\dA-Fa-f_]+|o[0-7_]+|b[01_]+)n?/)) {
              return ret("number", "number");
            } else if (/\d/.test(ch)) {
              stream.match(/^[\d_]*(?:n|(?:\.[\d_]*)?(?:[eE][+\-]?[\d_]+)?)?/);
              return ret("number", "number");
            } else if (ch == "/") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              } else if (stream.eat("/")) {
                stream.skipToEnd();
                return ret("comment", "comment");
              } else if (expressionAllowed(stream, state, 1)) {
                readRegexp(stream);
                stream.match(/^\b(([gimyus])(?![gimyus]*\2))+\b/);
                return ret("regexp", "string-2");
              } else {
                stream.eat("=");
                return ret("operator", "operator", stream.current());
              }
            } else if (ch == "`") {
              state.tokenize = tokenQuasi;
              return tokenQuasi(stream, state);
            } else if (ch == "#" && stream.peek() == "!") {
              stream.skipToEnd();
              return ret("meta", "meta");
            } else if (ch == "#" && stream.eatWhile(wordRE)) {
              return ret("variable", "property");
            } else if (ch == "<" && stream.match("!--") || ch == "-" && stream.match("->")) {
              stream.skipToEnd();
              return ret("comment", "comment");
            } else if (isOperatorChar.test(ch)) {
              if (ch != ">" || !state.lexical || state.lexical.type != ">") {
                if (stream.eat("=")) {
                  if (ch == "!" || ch == "=")
                    stream.eat("=");
                } else if (/[<>*+\-]/.test(ch)) {
                  stream.eat(ch);
                  if (ch == ">")
                    stream.eat(ch);
                }
              }
              if (ch == "?" && stream.eat("."))
                return ret(".");
              return ret("operator", "operator", stream.current());
            } else if (wordRE.test(ch)) {
              stream.eatWhile(wordRE);
              var word = stream.current();
              if (state.lastType != ".") {
                if (keywords2.propertyIsEnumerable(word)) {
                  var kw = keywords2[word];
                  return ret(kw.type, kw.style, word);
                }
                if (word == "async" && stream.match(/^(\s|\/\*.*?\*\/)*[\[\(\w]/, false))
                  return ret("async", "keyword", word);
              }
              return ret("variable", "variable", word);
            }
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next;
              if (jsonldMode && stream.peek() == "@" && stream.match(isJsonldKeyword)) {
                state.tokenize = tokenBase;
                return ret("jsonld-keyword", "meta");
              }
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped)
                  break;
                escaped = !escaped && next == "\\";
              }
              if (!escaped)
                state.tokenize = tokenBase;
              return ret("string", "string");
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return ret("comment", "comment");
          }
          function tokenQuasi(stream, state) {
            var escaped = false, next;
            while ((next = stream.next()) != null) {
              if (!escaped && (next == "`" || next == "$" && stream.eat("{"))) {
                state.tokenize = tokenBase;
                break;
              }
              escaped = !escaped && next == "\\";
            }
            return ret("quasi", "string-2", stream.current());
          }
          var brackets = "([{}])";
          function findFatArrow(stream, state) {
            if (state.fatArrowAt)
              state.fatArrowAt = null;
            var arrow = stream.string.indexOf("=>", stream.start);
            if (arrow < 0)
              return;
            if (isTS) {
              var m3 = /:\s*(?:\w+(?:<[^>]*>|\[\])?|\{[^}]*\})\s*$/.exec(stream.string.slice(stream.start, arrow));
              if (m3)
                arrow = m3.index;
            }
            var depth = 0, sawSomething = false;
            for (var pos = arrow - 1; pos >= 0; --pos) {
              var ch = stream.string.charAt(pos);
              var bracket = brackets.indexOf(ch);
              if (bracket >= 0 && bracket < 3) {
                if (!depth) {
                  ++pos;
                  break;
                }
                if (--depth == 0) {
                  if (ch == "(")
                    sawSomething = true;
                  break;
                }
              } else if (bracket >= 3 && bracket < 6) {
                ++depth;
              } else if (wordRE.test(ch)) {
                sawSomething = true;
              } else if (/["'\/`]/.test(ch)) {
                for (; ; --pos) {
                  if (pos == 0)
                    return;
                  var next = stream.string.charAt(pos - 1);
                  if (next == ch && stream.string.charAt(pos - 2) != "\\") {
                    pos--;
                    break;
                  }
                }
              } else if (sawSomething && !depth) {
                ++pos;
                break;
              }
            }
            if (sawSomething && !depth)
              state.fatArrowAt = pos;
          }
          var atomicTypes = { "atom": true, "number": true, "variable": true, "string": true, "regexp": true, "this": true, "jsonld-keyword": true };
          function JSLexical(indented, column, type2, align, prev, info) {
            this.indented = indented;
            this.column = column;
            this.type = type2;
            this.prev = prev;
            this.info = info;
            if (align != null)
              this.align = align;
          }
          function inScope(state, varname) {
            for (var v3 = state.localVars; v3; v3 = v3.next)
              if (v3.name == varname)
                return true;
            for (var cx2 = state.context; cx2; cx2 = cx2.prev) {
              for (var v3 = cx2.vars; v3; v3 = v3.next)
                if (v3.name == varname)
                  return true;
            }
          }
          function parseJS(state, style, type2, content2, stream) {
            var cc = state.cc;
            cx.state = state;
            cx.stream = stream;
            cx.marked = null, cx.cc = cc;
            cx.style = style;
            if (!state.lexical.hasOwnProperty("align"))
              state.lexical.align = true;
            while (true) {
              var combinator = cc.length ? cc.pop() : jsonMode ? expression : statement;
              if (combinator(type2, content2)) {
                while (cc.length && cc[cc.length - 1].lex)
                  cc.pop()();
                if (cx.marked)
                  return cx.marked;
                if (type2 == "variable" && inScope(state, content2))
                  return "variable-2";
                return style;
              }
            }
          }
          var cx = { state: null, column: null, marked: null, cc: null };
          function pass() {
            for (var i3 = arguments.length - 1; i3 >= 0; i3--)
              cx.cc.push(arguments[i3]);
          }
          function cont() {
            pass.apply(null, arguments);
            return true;
          }
          function inList(name106, list) {
            for (var v3 = list; v3; v3 = v3.next)
              if (v3.name == name106)
                return true;
            return false;
          }
          function register(varname) {
            var state = cx.state;
            cx.marked = "def";
            if (state.context) {
              if (state.lexical.info == "var" && state.context && state.context.block) {
                var newContext = registerVarScoped(varname, state.context);
                if (newContext != null) {
                  state.context = newContext;
                  return;
                }
              } else if (!inList(varname, state.localVars)) {
                state.localVars = new Var(varname, state.localVars);
                return;
              }
            }
            if (parserConfig.globalVars && !inList(varname, state.globalVars))
              state.globalVars = new Var(varname, state.globalVars);
          }
          function registerVarScoped(varname, context) {
            if (!context) {
              return null;
            } else if (context.block) {
              var inner = registerVarScoped(varname, context.prev);
              if (!inner)
                return null;
              if (inner == context.prev)
                return context;
              return new Context(inner, context.vars, true);
            } else if (inList(varname, context.vars)) {
              return context;
            } else {
              return new Context(context.prev, new Var(varname, context.vars), false);
            }
          }
          function isModifier(name106) {
            return name106 == "public" || name106 == "private" || name106 == "protected" || name106 == "abstract" || name106 == "readonly";
          }
          function Context(prev, vars, block2) {
            this.prev = prev;
            this.vars = vars;
            this.block = block2;
          }
          function Var(name106, next) {
            this.name = name106;
            this.next = next;
          }
          var defaultVars = new Var("this", new Var("arguments", null));
          function pushcontext() {
            cx.state.context = new Context(cx.state.context, cx.state.localVars, false);
            cx.state.localVars = defaultVars;
          }
          function pushblockcontext() {
            cx.state.context = new Context(cx.state.context, cx.state.localVars, true);
            cx.state.localVars = null;
          }
          function popcontext() {
            cx.state.localVars = cx.state.context.vars;
            cx.state.context = cx.state.context.prev;
          }
          popcontext.lex = true;
          function pushlex(type2, info) {
            var result = function() {
              var state = cx.state, indent = state.indented;
              if (state.lexical.type == "stat")
                indent = state.lexical.indented;
              else
                for (var outer = state.lexical; outer && outer.type == ")" && outer.align; outer = outer.prev)
                  indent = outer.indented;
              state.lexical = new JSLexical(indent, cx.stream.column(), type2, null, state.lexical, info);
            };
            result.lex = true;
            return result;
          }
          function poplex() {
            var state = cx.state;
            if (state.lexical.prev) {
              if (state.lexical.type == ")")
                state.indented = state.lexical.indented;
              state.lexical = state.lexical.prev;
            }
          }
          poplex.lex = true;
          function expect(wanted) {
            function exp2(type2) {
              if (type2 == wanted)
                return cont();
              else if (wanted == ";" || type2 == "}" || type2 == ")" || type2 == "]")
                return pass();
              else
                return cont(exp2);
            }
            ;
            return exp2;
          }
          function statement(type2, value) {
            if (type2 == "var")
              return cont(pushlex("vardef", value), vardef, expect(";"), poplex);
            if (type2 == "keyword a")
              return cont(pushlex("form"), parenExpr, statement, poplex);
            if (type2 == "keyword b")
              return cont(pushlex("form"), statement, poplex);
            if (type2 == "keyword d")
              return cx.stream.match(/^\s*$/, false) ? cont() : cont(pushlex("stat"), maybeexpression, expect(";"), poplex);
            if (type2 == "debugger")
              return cont(expect(";"));
            if (type2 == "{")
              return cont(pushlex("}"), pushblockcontext, block, poplex, popcontext);
            if (type2 == ";")
              return cont();
            if (type2 == "if") {
              if (cx.state.lexical.info == "else" && cx.state.cc[cx.state.cc.length - 1] == poplex)
                cx.state.cc.pop()();
              return cont(pushlex("form"), parenExpr, statement, poplex, maybeelse);
            }
            if (type2 == "function")
              return cont(functiondef);
            if (type2 == "for")
              return cont(pushlex("form"), forspec, statement, poplex);
            if (type2 == "class" || isTS && value == "interface") {
              cx.marked = "keyword";
              return cont(pushlex("form", type2 == "class" ? type2 : value), className, poplex);
            }
            if (type2 == "variable") {
              if (isTS && value == "declare") {
                cx.marked = "keyword";
                return cont(statement);
              } else if (isTS && (value == "module" || value == "enum" || value == "type") && cx.stream.match(/^\s*\w/, false)) {
                cx.marked = "keyword";
                if (value == "enum")
                  return cont(enumdef);
                else if (value == "type")
                  return cont(typename, expect("operator"), typeexpr, expect(";"));
                else
                  return cont(pushlex("form"), pattern, expect("{"), pushlex("}"), block, poplex, poplex);
              } else if (isTS && value == "namespace") {
                cx.marked = "keyword";
                return cont(pushlex("form"), expression, statement, poplex);
              } else if (isTS && value == "abstract") {
                cx.marked = "keyword";
                return cont(statement);
              } else {
                return cont(pushlex("stat"), maybelabel);
              }
            }
            if (type2 == "switch")
              return cont(pushlex("form"), parenExpr, expect("{"), pushlex("}", "switch"), pushblockcontext, block, poplex, poplex, popcontext);
            if (type2 == "case")
              return cont(expression, expect(":"));
            if (type2 == "default")
              return cont(expect(":"));
            if (type2 == "catch")
              return cont(pushlex("form"), pushcontext, maybeCatchBinding, statement, poplex, popcontext);
            if (type2 == "export")
              return cont(pushlex("stat"), afterExport, poplex);
            if (type2 == "import")
              return cont(pushlex("stat"), afterImport, poplex);
            if (type2 == "async")
              return cont(statement);
            if (value == "@")
              return cont(expression, statement);
            return pass(pushlex("stat"), expression, expect(";"), poplex);
          }
          function maybeCatchBinding(type2) {
            if (type2 == "(")
              return cont(funarg, expect(")"));
          }
          function expression(type2, value) {
            return expressionInner(type2, value, false);
          }
          function expressionNoComma(type2, value) {
            return expressionInner(type2, value, true);
          }
          function parenExpr(type2) {
            if (type2 != "(")
              return pass();
            return cont(pushlex(")"), maybeexpression, expect(")"), poplex);
          }
          function expressionInner(type2, value, noComma) {
            if (cx.state.fatArrowAt == cx.stream.start) {
              var body = noComma ? arrowBodyNoComma : arrowBody;
              if (type2 == "(")
                return cont(pushcontext, pushlex(")"), commasep(funarg, ")"), poplex, expect("=>"), body, popcontext);
              else if (type2 == "variable")
                return pass(pushcontext, pattern, expect("=>"), body, popcontext);
            }
            var maybeop = noComma ? maybeoperatorNoComma : maybeoperatorComma;
            if (atomicTypes.hasOwnProperty(type2))
              return cont(maybeop);
            if (type2 == "function")
              return cont(functiondef, maybeop);
            if (type2 == "class" || isTS && value == "interface") {
              cx.marked = "keyword";
              return cont(pushlex("form"), classExpression, poplex);
            }
            if (type2 == "keyword c" || type2 == "async")
              return cont(noComma ? expressionNoComma : expression);
            if (type2 == "(")
              return cont(pushlex(")"), maybeexpression, expect(")"), poplex, maybeop);
            if (type2 == "operator" || type2 == "spread")
              return cont(noComma ? expressionNoComma : expression);
            if (type2 == "[")
              return cont(pushlex("]"), arrayLiteral, poplex, maybeop);
            if (type2 == "{")
              return contCommasep(objprop, "}", null, maybeop);
            if (type2 == "quasi")
              return pass(quasi, maybeop);
            if (type2 == "new")
              return cont(maybeTarget(noComma));
            if (type2 == "import")
              return cont(expression);
            return cont();
          }
          function maybeexpression(type2) {
            if (type2.match(/[;\}\)\],]/))
              return pass();
            return pass(expression);
          }
          function maybeoperatorComma(type2, value) {
            if (type2 == ",")
              return cont(maybeexpression);
            return maybeoperatorNoComma(type2, value, false);
          }
          function maybeoperatorNoComma(type2, value, noComma) {
            var me = noComma == false ? maybeoperatorComma : maybeoperatorNoComma;
            var expr = noComma == false ? expression : expressionNoComma;
            if (type2 == "=>")
              return cont(pushcontext, noComma ? arrowBodyNoComma : arrowBody, popcontext);
            if (type2 == "operator") {
              if (/\+\+|--/.test(value) || isTS && value == "!")
                return cont(me);
              if (isTS && value == "<" && cx.stream.match(/^([^>]|<.*?>)*>\s*\(/, false))
                return cont(pushlex(">"), commasep(typeexpr, ">"), poplex, me);
              if (value == "?")
                return cont(expression, expect(":"), expr);
              return cont(expr);
            }
            if (type2 == "quasi") {
              return pass(quasi, me);
            }
            if (type2 == ";")
              return;
            if (type2 == "(")
              return contCommasep(expressionNoComma, ")", "call", me);
            if (type2 == ".")
              return cont(property, me);
            if (type2 == "[")
              return cont(pushlex("]"), maybeexpression, expect("]"), poplex, me);
            if (isTS && value == "as") {
              cx.marked = "keyword";
              return cont(typeexpr, me);
            }
            if (type2 == "regexp") {
              cx.state.lastType = cx.marked = "operator";
              cx.stream.backUp(cx.stream.pos - cx.stream.start - 1);
              return cont(expr);
            }
          }
          function quasi(type2, value) {
            if (type2 != "quasi")
              return pass();
            if (value.slice(value.length - 2) != "${")
              return cont(quasi);
            return cont(expression, continueQuasi);
          }
          function continueQuasi(type2) {
            if (type2 == "}") {
              cx.marked = "string-2";
              cx.state.tokenize = tokenQuasi;
              return cont(quasi);
            }
          }
          function arrowBody(type2) {
            findFatArrow(cx.stream, cx.state);
            return pass(type2 == "{" ? statement : expression);
          }
          function arrowBodyNoComma(type2) {
            findFatArrow(cx.stream, cx.state);
            return pass(type2 == "{" ? statement : expressionNoComma);
          }
          function maybeTarget(noComma) {
            return function(type2) {
              if (type2 == ".")
                return cont(noComma ? targetNoComma : target);
              else if (type2 == "variable" && isTS)
                return cont(maybeTypeArgs, noComma ? maybeoperatorNoComma : maybeoperatorComma);
              else
                return pass(noComma ? expressionNoComma : expression);
            };
          }
          function target(_2, value) {
            if (value == "target") {
              cx.marked = "keyword";
              return cont(maybeoperatorComma);
            }
          }
          function targetNoComma(_2, value) {
            if (value == "target") {
              cx.marked = "keyword";
              return cont(maybeoperatorNoComma);
            }
          }
          function maybelabel(type2) {
            if (type2 == ":")
              return cont(poplex, statement);
            return pass(maybeoperatorComma, expect(";"), poplex);
          }
          function property(type2) {
            if (type2 == "variable") {
              cx.marked = "property";
              return cont();
            }
          }
          function objprop(type2, value) {
            if (type2 == "async") {
              cx.marked = "property";
              return cont(objprop);
            } else if (type2 == "variable" || cx.style == "keyword") {
              cx.marked = "property";
              if (value == "get" || value == "set")
                return cont(getterSetter);
              var m3;
              if (isTS && cx.state.fatArrowAt == cx.stream.start && (m3 = cx.stream.match(/^\s*:\s*/, false)))
                cx.state.fatArrowAt = cx.stream.pos + m3[0].length;
              return cont(afterprop);
            } else if (type2 == "number" || type2 == "string") {
              cx.marked = jsonldMode ? "property" : cx.style + " property";
              return cont(afterprop);
            } else if (type2 == "jsonld-keyword") {
              return cont(afterprop);
            } else if (isTS && isModifier(value)) {
              cx.marked = "keyword";
              return cont(objprop);
            } else if (type2 == "[") {
              return cont(expression, maybetype, expect("]"), afterprop);
            } else if (type2 == "spread") {
              return cont(expressionNoComma, afterprop);
            } else if (value == "*") {
              cx.marked = "keyword";
              return cont(objprop);
            } else if (type2 == ":") {
              return pass(afterprop);
            }
          }
          function getterSetter(type2) {
            if (type2 != "variable")
              return pass(afterprop);
            cx.marked = "property";
            return cont(functiondef);
          }
          function afterprop(type2) {
            if (type2 == ":")
              return cont(expressionNoComma);
            if (type2 == "(")
              return pass(functiondef);
          }
          function commasep(what, end, sep) {
            function proceed(type2, value) {
              if (sep ? sep.indexOf(type2) > -1 : type2 == ",") {
                var lex = cx.state.lexical;
                if (lex.info == "call")
                  lex.pos = (lex.pos || 0) + 1;
                return cont(function(type3, value2) {
                  if (type3 == end || value2 == end)
                    return pass();
                  return pass(what);
                }, proceed);
              }
              if (type2 == end || value == end)
                return cont();
              if (sep && sep.indexOf(";") > -1)
                return pass(what);
              return cont(expect(end));
            }
            return function(type2, value) {
              if (type2 == end || value == end)
                return cont();
              return pass(what, proceed);
            };
          }
          function contCommasep(what, end, info) {
            for (var i3 = 3; i3 < arguments.length; i3++)
              cx.cc.push(arguments[i3]);
            return cont(pushlex(end, info), commasep(what, end), poplex);
          }
          function block(type2) {
            if (type2 == "}")
              return cont();
            return pass(statement, block);
          }
          function maybetype(type2, value) {
            if (isTS) {
              if (type2 == ":")
                return cont(typeexpr);
              if (value == "?")
                return cont(maybetype);
            }
          }
          function maybetypeOrIn(type2, value) {
            if (isTS && (type2 == ":" || value == "in"))
              return cont(typeexpr);
          }
          function mayberettype(type2) {
            if (isTS && type2 == ":") {
              if (cx.stream.match(/^\s*\w+\s+is\b/, false))
                return cont(expression, isKW, typeexpr);
              else
                return cont(typeexpr);
            }
          }
          function isKW(_2, value) {
            if (value == "is") {
              cx.marked = "keyword";
              return cont();
            }
          }
          function typeexpr(type2, value) {
            if (value == "keyof" || value == "typeof" || value == "infer") {
              cx.marked = "keyword";
              return cont(value == "typeof" ? expressionNoComma : typeexpr);
            }
            if (type2 == "variable" || value == "void") {
              cx.marked = "type";
              return cont(afterType);
            }
            if (value == "|" || value == "&")
              return cont(typeexpr);
            if (type2 == "string" || type2 == "number" || type2 == "atom")
              return cont(afterType);
            if (type2 == "[")
              return cont(pushlex("]"), commasep(typeexpr, "]", ","), poplex, afterType);
            if (type2 == "{")
              return cont(pushlex("}"), commasep(typeprop, "}", ",;"), poplex, afterType);
            if (type2 == "(")
              return cont(commasep(typearg, ")"), maybeReturnType, afterType);
            if (type2 == "<")
              return cont(commasep(typeexpr, ">"), typeexpr);
          }
          function maybeReturnType(type2) {
            if (type2 == "=>")
              return cont(typeexpr);
          }
          function typeprop(type2, value) {
            if (type2 == "variable" || cx.style == "keyword") {
              cx.marked = "property";
              return cont(typeprop);
            } else if (value == "?" || type2 == "number" || type2 == "string") {
              return cont(typeprop);
            } else if (type2 == ":") {
              return cont(typeexpr);
            } else if (type2 == "[") {
              return cont(expect("variable"), maybetypeOrIn, expect("]"), typeprop);
            } else if (type2 == "(") {
              return pass(functiondecl, typeprop);
            }
          }
          function typearg(type2, value) {
            if (type2 == "variable" && cx.stream.match(/^\s*[?:]/, false) || value == "?")
              return cont(typearg);
            if (type2 == ":")
              return cont(typeexpr);
            if (type2 == "spread")
              return cont(typearg);
            return pass(typeexpr);
          }
          function afterType(type2, value) {
            if (value == "<")
              return cont(pushlex(">"), commasep(typeexpr, ">"), poplex, afterType);
            if (value == "|" || type2 == "." || value == "&")
              return cont(typeexpr);
            if (type2 == "[")
              return cont(typeexpr, expect("]"), afterType);
            if (value == "extends" || value == "implements") {
              cx.marked = "keyword";
              return cont(typeexpr);
            }
            if (value == "?")
              return cont(typeexpr, expect(":"), typeexpr);
          }
          function maybeTypeArgs(_2, value) {
            if (value == "<")
              return cont(pushlex(">"), commasep(typeexpr, ">"), poplex, afterType);
          }
          function typeparam() {
            return pass(typeexpr, maybeTypeDefault);
          }
          function maybeTypeDefault(_2, value) {
            if (value == "=")
              return cont(typeexpr);
          }
          function vardef(_2, value) {
            if (value == "enum") {
              cx.marked = "keyword";
              return cont(enumdef);
            }
            return pass(pattern, maybetype, maybeAssign, vardefCont);
          }
          function pattern(type2, value) {
            if (isTS && isModifier(value)) {
              cx.marked = "keyword";
              return cont(pattern);
            }
            if (type2 == "variable") {
              register(value);
              return cont();
            }
            if (type2 == "spread")
              return cont(pattern);
            if (type2 == "[")
              return contCommasep(eltpattern, "]");
            if (type2 == "{")
              return contCommasep(proppattern, "}");
          }
          function proppattern(type2, value) {
            if (type2 == "variable" && !cx.stream.match(/^\s*:/, false)) {
              register(value);
              return cont(maybeAssign);
            }
            if (type2 == "variable")
              cx.marked = "property";
            if (type2 == "spread")
              return cont(pattern);
            if (type2 == "}")
              return pass();
            if (type2 == "[")
              return cont(expression, expect("]"), expect(":"), proppattern);
            return cont(expect(":"), pattern, maybeAssign);
          }
          function eltpattern() {
            return pass(pattern, maybeAssign);
          }
          function maybeAssign(_type, value) {
            if (value == "=")
              return cont(expressionNoComma);
          }
          function vardefCont(type2) {
            if (type2 == ",")
              return cont(vardef);
          }
          function maybeelse(type2, value) {
            if (type2 == "keyword b" && value == "else")
              return cont(pushlex("form", "else"), statement, poplex);
          }
          function forspec(type2, value) {
            if (value == "await")
              return cont(forspec);
            if (type2 == "(")
              return cont(pushlex(")"), forspec1, poplex);
          }
          function forspec1(type2) {
            if (type2 == "var")
              return cont(vardef, forspec2);
            if (type2 == "variable")
              return cont(forspec2);
            return pass(forspec2);
          }
          function forspec2(type2, value) {
            if (type2 == ")")
              return cont();
            if (type2 == ";")
              return cont(forspec2);
            if (value == "in" || value == "of") {
              cx.marked = "keyword";
              return cont(expression, forspec2);
            }
            return pass(expression, forspec2);
          }
          function functiondef(type2, value) {
            if (value == "*") {
              cx.marked = "keyword";
              return cont(functiondef);
            }
            if (type2 == "variable") {
              register(value);
              return cont(functiondef);
            }
            if (type2 == "(")
              return cont(pushcontext, pushlex(")"), commasep(funarg, ")"), poplex, mayberettype, statement, popcontext);
            if (isTS && value == "<")
              return cont(pushlex(">"), commasep(typeparam, ">"), poplex, functiondef);
          }
          function functiondecl(type2, value) {
            if (value == "*") {
              cx.marked = "keyword";
              return cont(functiondecl);
            }
            if (type2 == "variable") {
              register(value);
              return cont(functiondecl);
            }
            if (type2 == "(")
              return cont(pushcontext, pushlex(")"), commasep(funarg, ")"), poplex, mayberettype, popcontext);
            if (isTS && value == "<")
              return cont(pushlex(">"), commasep(typeparam, ">"), poplex, functiondecl);
          }
          function typename(type2, value) {
            if (type2 == "keyword" || type2 == "variable") {
              cx.marked = "type";
              return cont(typename);
            } else if (value == "<") {
              return cont(pushlex(">"), commasep(typeparam, ">"), poplex);
            }
          }
          function funarg(type2, value) {
            if (value == "@")
              cont(expression, funarg);
            if (type2 == "spread")
              return cont(funarg);
            if (isTS && isModifier(value)) {
              cx.marked = "keyword";
              return cont(funarg);
            }
            if (isTS && type2 == "this")
              return cont(maybetype, maybeAssign);
            return pass(pattern, maybetype, maybeAssign);
          }
          function classExpression(type2, value) {
            if (type2 == "variable")
              return className(type2, value);
            return classNameAfter(type2, value);
          }
          function className(type2, value) {
            if (type2 == "variable") {
              register(value);
              return cont(classNameAfter);
            }
          }
          function classNameAfter(type2, value) {
            if (value == "<")
              return cont(pushlex(">"), commasep(typeparam, ">"), poplex, classNameAfter);
            if (value == "extends" || value == "implements" || isTS && type2 == ",") {
              if (value == "implements")
                cx.marked = "keyword";
              return cont(isTS ? typeexpr : expression, classNameAfter);
            }
            if (type2 == "{")
              return cont(pushlex("}"), classBody, poplex);
          }
          function classBody(type2, value) {
            if (type2 == "async" || type2 == "variable" && (value == "static" || value == "get" || value == "set" || isTS && isModifier(value)) && cx.stream.match(/^\s+[\w$\xa1-\uffff]/, false)) {
              cx.marked = "keyword";
              return cont(classBody);
            }
            if (type2 == "variable" || cx.style == "keyword") {
              cx.marked = "property";
              return cont(classfield, classBody);
            }
            if (type2 == "number" || type2 == "string")
              return cont(classfield, classBody);
            if (type2 == "[")
              return cont(expression, maybetype, expect("]"), classfield, classBody);
            if (value == "*") {
              cx.marked = "keyword";
              return cont(classBody);
            }
            if (isTS && type2 == "(")
              return pass(functiondecl, classBody);
            if (type2 == ";" || type2 == ",")
              return cont(classBody);
            if (type2 == "}")
              return cont();
            if (value == "@")
              return cont(expression, classBody);
          }
          function classfield(type2, value) {
            if (value == "?")
              return cont(classfield);
            if (type2 == ":")
              return cont(typeexpr, maybeAssign);
            if (value == "=")
              return cont(expressionNoComma);
            var context = cx.state.lexical.prev, isInterface = context && context.info == "interface";
            return pass(isInterface ? functiondecl : functiondef);
          }
          function afterExport(type2, value) {
            if (value == "*") {
              cx.marked = "keyword";
              return cont(maybeFrom, expect(";"));
            }
            if (value == "default") {
              cx.marked = "keyword";
              return cont(expression, expect(";"));
            }
            if (type2 == "{")
              return cont(commasep(exportField, "}"), maybeFrom, expect(";"));
            return pass(statement);
          }
          function exportField(type2, value) {
            if (value == "as") {
              cx.marked = "keyword";
              return cont(expect("variable"));
            }
            if (type2 == "variable")
              return pass(expressionNoComma, exportField);
          }
          function afterImport(type2) {
            if (type2 == "string")
              return cont();
            if (type2 == "(")
              return pass(expression);
            return pass(importSpec, maybeMoreImports, maybeFrom);
          }
          function importSpec(type2, value) {
            if (type2 == "{")
              return contCommasep(importSpec, "}");
            if (type2 == "variable")
              register(value);
            if (value == "*")
              cx.marked = "keyword";
            return cont(maybeAs);
          }
          function maybeMoreImports(type2) {
            if (type2 == ",")
              return cont(importSpec, maybeMoreImports);
          }
          function maybeAs(_type, value) {
            if (value == "as") {
              cx.marked = "keyword";
              return cont(importSpec);
            }
          }
          function maybeFrom(_type, value) {
            if (value == "from") {
              cx.marked = "keyword";
              return cont(expression);
            }
          }
          function arrayLiteral(type2) {
            if (type2 == "]")
              return cont();
            return pass(commasep(expressionNoComma, "]"));
          }
          function enumdef() {
            return pass(pushlex("form"), pattern, expect("{"), pushlex("}"), commasep(enummember, "}"), poplex, poplex);
          }
          function enummember() {
            return pass(pattern, maybeAssign);
          }
          function isContinuedStatement(state, textAfter) {
            return state.lastType == "operator" || state.lastType == "," || isOperatorChar.test(textAfter.charAt(0)) || /[,.]/.test(textAfter.charAt(0));
          }
          function expressionAllowed(stream, state, backUp) {
            return state.tokenize == tokenBase && /^(?:operator|sof|keyword [bcd]|case|new|export|default|spread|[\[{}\(,;:]|=>)$/.test(state.lastType) || state.lastType == "quasi" && /\{\s*$/.test(stream.string.slice(0, stream.pos - (backUp || 0)));
          }
          return {
            startState: function(basecolumn) {
              var state = {
                tokenize: tokenBase,
                lastType: "sof",
                cc: [],
                lexical: new JSLexical((basecolumn || 0) - indentUnit, 0, "block", false),
                localVars: parserConfig.localVars,
                context: parserConfig.localVars && new Context(null, null, false),
                indented: basecolumn || 0
              };
              if (parserConfig.globalVars && typeof parserConfig.globalVars == "object")
                state.globalVars = parserConfig.globalVars;
              return state;
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (!state.lexical.hasOwnProperty("align"))
                  state.lexical.align = false;
                state.indented = stream.indentation();
                findFatArrow(stream, state);
              }
              if (state.tokenize != tokenComment && stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              if (type == "comment")
                return style;
              state.lastType = type == "operator" && (content == "++" || content == "--") ? "incdec" : type;
              return parseJS(state, style, type, content, stream);
            },
            indent: function(state, textAfter) {
              if (state.tokenize == tokenComment)
                return CodeMirror5.Pass;
              if (state.tokenize != tokenBase)
                return 0;
              var firstChar = textAfter && textAfter.charAt(0), lexical = state.lexical, top;
              if (!/^\s*else\b/.test(textAfter))
                for (var i3 = state.cc.length - 1; i3 >= 0; --i3) {
                  var c3 = state.cc[i3];
                  if (c3 == poplex)
                    lexical = lexical.prev;
                  else if (c3 != maybeelse)
                    break;
                }
              while ((lexical.type == "stat" || lexical.type == "form") && (firstChar == "}" || (top = state.cc[state.cc.length - 1]) && (top == maybeoperatorComma || top == maybeoperatorNoComma) && !/^[,\.=+\-*:?[\(]/.test(textAfter)))
                lexical = lexical.prev;
              if (statementIndent && lexical.type == ")" && lexical.prev.type == "stat")
                lexical = lexical.prev;
              var type2 = lexical.type, closing = firstChar == type2;
              if (type2 == "vardef")
                return lexical.indented + (state.lastType == "operator" || state.lastType == "," ? lexical.info.length + 1 : 0);
              else if (type2 == "form" && firstChar == "{")
                return lexical.indented;
              else if (type2 == "form")
                return lexical.indented + indentUnit;
              else if (type2 == "stat")
                return lexical.indented + (isContinuedStatement(state, textAfter) ? statementIndent || indentUnit : 0);
              else if (lexical.info == "switch" && !closing && parserConfig.doubleIndentSwitch != false)
                return lexical.indented + (/^(?:case|default)\b/.test(textAfter) ? indentUnit : 2 * indentUnit);
              else if (lexical.align)
                return lexical.column + (closing ? 0 : 1);
              else
                return lexical.indented + (closing ? 0 : indentUnit);
            },
            electricInput: /^\s*(?:case .*?:|default:|\{|\})$/,
            blockCommentStart: jsonMode ? null : "/*",
            blockCommentEnd: jsonMode ? null : "*/",
            blockCommentContinue: jsonMode ? null : " * ",
            lineComment: jsonMode ? null : "//",
            fold: "brace",
            closeBrackets: "()[]{}''\"\"``",
            helperType: jsonMode ? "json" : "javascript",
            jsonldMode,
            jsonMode,
            expressionAllowed,
            skipExpression: function(state) {
              var top = state.cc[state.cc.length - 1];
              if (top == expression || top == expressionNoComma)
                state.cc.pop();
            }
          };
        });
        CodeMirror5.registerHelper("wordChars", "javascript", /[\w$]/);
        CodeMirror5.defineMIME("text/javascript", "javascript");
        CodeMirror5.defineMIME("text/ecmascript", "javascript");
        CodeMirror5.defineMIME("application/javascript", "javascript");
        CodeMirror5.defineMIME("application/x-javascript", "javascript");
        CodeMirror5.defineMIME("application/ecmascript", "javascript");
        CodeMirror5.defineMIME("application/json", { name: "javascript", json: true });
        CodeMirror5.defineMIME("application/x-json", { name: "javascript", json: true });
        CodeMirror5.defineMIME("application/ld+json", { name: "javascript", jsonld: true });
        CodeMirror5.defineMIME("text/typescript", { name: "javascript", typescript: true });
        CodeMirror5.defineMIME("application/typescript", { name: "javascript", typescript: true });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/css/css.js
  var require_css = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/css/css.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("css", function(config3, parserConfig) {
          var inline = parserConfig.inline;
          if (!parserConfig.propertyKeywords)
            parserConfig = CodeMirror5.resolveMode("text/css");
          var indentUnit = config3.indentUnit, tokenHooks = parserConfig.tokenHooks, documentTypes2 = parserConfig.documentTypes || {}, mediaTypes2 = parserConfig.mediaTypes || {}, mediaFeatures2 = parserConfig.mediaFeatures || {}, mediaValueKeywords2 = parserConfig.mediaValueKeywords || {}, propertyKeywords2 = parserConfig.propertyKeywords || {}, nonStandardPropertyKeywords2 = parserConfig.nonStandardPropertyKeywords || {}, fontProperties2 = parserConfig.fontProperties || {}, counterDescriptors2 = parserConfig.counterDescriptors || {}, colorKeywords2 = parserConfig.colorKeywords || {}, valueKeywords2 = parserConfig.valueKeywords || {}, allowNested = parserConfig.allowNested, lineComment = parserConfig.lineComment, supportsAtComponent = parserConfig.supportsAtComponent === true;
          var type, override;
          function ret(style, tp) {
            type = tp;
            return style;
          }
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (tokenHooks[ch]) {
              var result = tokenHooks[ch](stream, state);
              if (result !== false)
                return result;
            }
            if (ch == "@") {
              stream.eatWhile(/[\w\\\-]/);
              return ret("def", stream.current());
            } else if (ch == "=" || (ch == "~" || ch == "|") && stream.eat("=")) {
              return ret(null, "compare");
            } else if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            } else if (ch == "#") {
              stream.eatWhile(/[\w\\\-]/);
              return ret("atom", "hash");
            } else if (ch == "!") {
              stream.match(/^\s*\w*/);
              return ret("keyword", "important");
            } else if (/\d/.test(ch) || ch == "." && stream.eat(/\d/)) {
              stream.eatWhile(/[\w.%]/);
              return ret("number", "unit");
            } else if (ch === "-") {
              if (/[\d.]/.test(stream.peek())) {
                stream.eatWhile(/[\w.%]/);
                return ret("number", "unit");
              } else if (stream.match(/^-[\w\\\-]*/)) {
                stream.eatWhile(/[\w\\\-]/);
                if (stream.match(/^\s*:/, false))
                  return ret("variable-2", "variable-definition");
                return ret("variable-2", "variable");
              } else if (stream.match(/^\w+-/)) {
                return ret("meta", "meta");
              }
            } else if (/[,+>*\/]/.test(ch)) {
              return ret(null, "select-op");
            } else if (ch == "." && stream.match(/^-?[_a-z][_a-z0-9-]*/i)) {
              return ret("qualifier", "qualifier");
            } else if (/[:;{}\[\]\(\)]/.test(ch)) {
              return ret(null, ch);
            } else if (stream.match(/[\w-.]+(?=\()/)) {
              if (/^(url(-prefix)?|domain|regexp)$/.test(stream.current().toLowerCase())) {
                state.tokenize = tokenParenthesized;
              }
              return ret("variable callee", "variable");
            } else if (/[\w\\\-]/.test(ch)) {
              stream.eatWhile(/[\w\\\-]/);
              return ret("property", "word");
            } else {
              return ret(null, null);
            }
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped) {
                  if (quote == ")")
                    stream.backUp(1);
                  break;
                }
                escaped = !escaped && ch == "\\";
              }
              if (ch == quote || !escaped && quote != ")")
                state.tokenize = null;
              return ret("string", "string");
            };
          }
          function tokenParenthesized(stream, state) {
            stream.next();
            if (!stream.match(/\s*[\"\')]/, false))
              state.tokenize = tokenString(")");
            else
              state.tokenize = null;
            return ret(null, "(");
          }
          function Context(type2, indent, prev) {
            this.type = type2;
            this.indent = indent;
            this.prev = prev;
          }
          function pushContext(state, stream, type2, indent) {
            state.context = new Context(type2, stream.indentation() + (indent === false ? 0 : indentUnit), state.context);
            return type2;
          }
          function popContext(state) {
            if (state.context.prev)
              state.context = state.context.prev;
            return state.context.type;
          }
          function pass(type2, stream, state) {
            return states[state.context.type](type2, stream, state);
          }
          function popAndPass(type2, stream, state, n3) {
            for (var i3 = n3 || 1; i3 > 0; i3--)
              state.context = state.context.prev;
            return pass(type2, stream, state);
          }
          function wordAsValue(stream) {
            var word = stream.current().toLowerCase();
            if (valueKeywords2.hasOwnProperty(word))
              override = "atom";
            else if (colorKeywords2.hasOwnProperty(word))
              override = "keyword";
            else
              override = "variable";
          }
          var states = {};
          states.top = function(type2, stream, state) {
            if (type2 == "{") {
              return pushContext(state, stream, "block");
            } else if (type2 == "}" && state.context.prev) {
              return popContext(state);
            } else if (supportsAtComponent && /@component/i.test(type2)) {
              return pushContext(state, stream, "atComponentBlock");
            } else if (/^@(-moz-)?document$/i.test(type2)) {
              return pushContext(state, stream, "documentTypes");
            } else if (/^@(media|supports|(-moz-)?document|import)$/i.test(type2)) {
              return pushContext(state, stream, "atBlock");
            } else if (/^@(font-face|counter-style)/i.test(type2)) {
              state.stateArg = type2;
              return "restricted_atBlock_before";
            } else if (/^@(-(moz|ms|o|webkit)-)?keyframes$/i.test(type2)) {
              return "keyframes";
            } else if (type2 && type2.charAt(0) == "@") {
              return pushContext(state, stream, "at");
            } else if (type2 == "hash") {
              override = "builtin";
            } else if (type2 == "word") {
              override = "tag";
            } else if (type2 == "variable-definition") {
              return "maybeprop";
            } else if (type2 == "interpolation") {
              return pushContext(state, stream, "interpolation");
            } else if (type2 == ":") {
              return "pseudo";
            } else if (allowNested && type2 == "(") {
              return pushContext(state, stream, "parens");
            }
            return state.context.type;
          };
          states.block = function(type2, stream, state) {
            if (type2 == "word") {
              var word = stream.current().toLowerCase();
              if (propertyKeywords2.hasOwnProperty(word)) {
                override = "property";
                return "maybeprop";
              } else if (nonStandardPropertyKeywords2.hasOwnProperty(word)) {
                override = "string-2";
                return "maybeprop";
              } else if (allowNested) {
                override = stream.match(/^\s*:(?:\s|$)/, false) ? "property" : "tag";
                return "block";
              } else {
                override += " error";
                return "maybeprop";
              }
            } else if (type2 == "meta") {
              return "block";
            } else if (!allowNested && (type2 == "hash" || type2 == "qualifier")) {
              override = "error";
              return "block";
            } else {
              return states.top(type2, stream, state);
            }
          };
          states.maybeprop = function(type2, stream, state) {
            if (type2 == ":")
              return pushContext(state, stream, "prop");
            return pass(type2, stream, state);
          };
          states.prop = function(type2, stream, state) {
            if (type2 == ";")
              return popContext(state);
            if (type2 == "{" && allowNested)
              return pushContext(state, stream, "propBlock");
            if (type2 == "}" || type2 == "{")
              return popAndPass(type2, stream, state);
            if (type2 == "(")
              return pushContext(state, stream, "parens");
            if (type2 == "hash" && !/^#([0-9a-fA-f]{3,4}|[0-9a-fA-f]{6}|[0-9a-fA-f]{8})$/.test(stream.current())) {
              override += " error";
            } else if (type2 == "word") {
              wordAsValue(stream);
            } else if (type2 == "interpolation") {
              return pushContext(state, stream, "interpolation");
            }
            return "prop";
          };
          states.propBlock = function(type2, _stream, state) {
            if (type2 == "}")
              return popContext(state);
            if (type2 == "word") {
              override = "property";
              return "maybeprop";
            }
            return state.context.type;
          };
          states.parens = function(type2, stream, state) {
            if (type2 == "{" || type2 == "}")
              return popAndPass(type2, stream, state);
            if (type2 == ")")
              return popContext(state);
            if (type2 == "(")
              return pushContext(state, stream, "parens");
            if (type2 == "interpolation")
              return pushContext(state, stream, "interpolation");
            if (type2 == "word")
              wordAsValue(stream);
            return "parens";
          };
          states.pseudo = function(type2, stream, state) {
            if (type2 == "meta")
              return "pseudo";
            if (type2 == "word") {
              override = "variable-3";
              return state.context.type;
            }
            return pass(type2, stream, state);
          };
          states.documentTypes = function(type2, stream, state) {
            if (type2 == "word" && documentTypes2.hasOwnProperty(stream.current())) {
              override = "tag";
              return state.context.type;
            } else {
              return states.atBlock(type2, stream, state);
            }
          };
          states.atBlock = function(type2, stream, state) {
            if (type2 == "(")
              return pushContext(state, stream, "atBlock_parens");
            if (type2 == "}" || type2 == ";")
              return popAndPass(type2, stream, state);
            if (type2 == "{")
              return popContext(state) && pushContext(state, stream, allowNested ? "block" : "top");
            if (type2 == "interpolation")
              return pushContext(state, stream, "interpolation");
            if (type2 == "word") {
              var word = stream.current().toLowerCase();
              if (word == "only" || word == "not" || word == "and" || word == "or")
                override = "keyword";
              else if (mediaTypes2.hasOwnProperty(word))
                override = "attribute";
              else if (mediaFeatures2.hasOwnProperty(word))
                override = "property";
              else if (mediaValueKeywords2.hasOwnProperty(word))
                override = "keyword";
              else if (propertyKeywords2.hasOwnProperty(word))
                override = "property";
              else if (nonStandardPropertyKeywords2.hasOwnProperty(word))
                override = "string-2";
              else if (valueKeywords2.hasOwnProperty(word))
                override = "atom";
              else if (colorKeywords2.hasOwnProperty(word))
                override = "keyword";
              else
                override = "error";
            }
            return state.context.type;
          };
          states.atComponentBlock = function(type2, stream, state) {
            if (type2 == "}")
              return popAndPass(type2, stream, state);
            if (type2 == "{")
              return popContext(state) && pushContext(state, stream, allowNested ? "block" : "top", false);
            if (type2 == "word")
              override = "error";
            return state.context.type;
          };
          states.atBlock_parens = function(type2, stream, state) {
            if (type2 == ")")
              return popContext(state);
            if (type2 == "{" || type2 == "}")
              return popAndPass(type2, stream, state, 2);
            return states.atBlock(type2, stream, state);
          };
          states.restricted_atBlock_before = function(type2, stream, state) {
            if (type2 == "{")
              return pushContext(state, stream, "restricted_atBlock");
            if (type2 == "word" && state.stateArg == "@counter-style") {
              override = "variable";
              return "restricted_atBlock_before";
            }
            return pass(type2, stream, state);
          };
          states.restricted_atBlock = function(type2, stream, state) {
            if (type2 == "}") {
              state.stateArg = null;
              return popContext(state);
            }
            if (type2 == "word") {
              if (state.stateArg == "@font-face" && !fontProperties2.hasOwnProperty(stream.current().toLowerCase()) || state.stateArg == "@counter-style" && !counterDescriptors2.hasOwnProperty(stream.current().toLowerCase()))
                override = "error";
              else
                override = "property";
              return "maybeprop";
            }
            return "restricted_atBlock";
          };
          states.keyframes = function(type2, stream, state) {
            if (type2 == "word") {
              override = "variable";
              return "keyframes";
            }
            if (type2 == "{")
              return pushContext(state, stream, "top");
            return pass(type2, stream, state);
          };
          states.at = function(type2, stream, state) {
            if (type2 == ";")
              return popContext(state);
            if (type2 == "{" || type2 == "}")
              return popAndPass(type2, stream, state);
            if (type2 == "word")
              override = "tag";
            else if (type2 == "hash")
              override = "builtin";
            return "at";
          };
          states.interpolation = function(type2, stream, state) {
            if (type2 == "}")
              return popContext(state);
            if (type2 == "{" || type2 == ";")
              return popAndPass(type2, stream, state);
            if (type2 == "word")
              override = "variable";
            else if (type2 != "variable" && type2 != "(" && type2 != ")")
              override = "error";
            return "interpolation";
          };
          return {
            startState: function(base) {
              return {
                tokenize: null,
                state: inline ? "block" : "top",
                stateArg: null,
                context: new Context(inline ? "block" : "top", base || 0, null)
              };
            },
            token: function(stream, state) {
              if (!state.tokenize && stream.eatSpace())
                return null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style && typeof style == "object") {
                type = style[1];
                style = style[0];
              }
              override = style;
              if (type != "comment")
                state.state = states[state.state](type, stream, state);
              return override;
            },
            indent: function(state, textAfter) {
              var cx = state.context, ch = textAfter && textAfter.charAt(0);
              var indent = cx.indent;
              if (cx.type == "prop" && (ch == "}" || ch == ")"))
                cx = cx.prev;
              if (cx.prev) {
                if (ch == "}" && (cx.type == "block" || cx.type == "top" || cx.type == "interpolation" || cx.type == "restricted_atBlock")) {
                  cx = cx.prev;
                  indent = cx.indent;
                } else if (ch == ")" && (cx.type == "parens" || cx.type == "atBlock_parens") || ch == "{" && (cx.type == "at" || cx.type == "atBlock")) {
                  indent = Math.max(0, cx.indent - indentUnit);
                }
              }
              return indent;
            },
            electricChars: "}",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            blockCommentContinue: " * ",
            lineComment,
            fold: "brace"
          };
        });
        function keySet(array) {
          var keys = {};
          for (var i3 = 0; i3 < array.length; ++i3) {
            keys[array[i3].toLowerCase()] = true;
          }
          return keys;
        }
        var documentTypes_ = [
          "domain",
          "regexp",
          "url",
          "url-prefix"
        ], documentTypes = keySet(documentTypes_);
        var mediaTypes_ = [
          "all",
          "aural",
          "braille",
          "handheld",
          "print",
          "projection",
          "screen",
          "tty",
          "tv",
          "embossed"
        ], mediaTypes = keySet(mediaTypes_);
        var mediaFeatures_ = [
          "width",
          "min-width",
          "max-width",
          "height",
          "min-height",
          "max-height",
          "device-width",
          "min-device-width",
          "max-device-width",
          "device-height",
          "min-device-height",
          "max-device-height",
          "aspect-ratio",
          "min-aspect-ratio",
          "max-aspect-ratio",
          "device-aspect-ratio",
          "min-device-aspect-ratio",
          "max-device-aspect-ratio",
          "color",
          "min-color",
          "max-color",
          "color-index",
          "min-color-index",
          "max-color-index",
          "monochrome",
          "min-monochrome",
          "max-monochrome",
          "resolution",
          "min-resolution",
          "max-resolution",
          "scan",
          "grid",
          "orientation",
          "device-pixel-ratio",
          "min-device-pixel-ratio",
          "max-device-pixel-ratio",
          "pointer",
          "any-pointer",
          "hover",
          "any-hover"
        ], mediaFeatures = keySet(mediaFeatures_);
        var mediaValueKeywords_ = [
          "landscape",
          "portrait",
          "none",
          "coarse",
          "fine",
          "on-demand",
          "hover",
          "interlace",
          "progressive"
        ], mediaValueKeywords = keySet(mediaValueKeywords_);
        var propertyKeywords_ = [
          "align-content",
          "align-items",
          "align-self",
          "alignment-adjust",
          "alignment-baseline",
          "anchor-point",
          "animation",
          "animation-delay",
          "animation-direction",
          "animation-duration",
          "animation-fill-mode",
          "animation-iteration-count",
          "animation-name",
          "animation-play-state",
          "animation-timing-function",
          "appearance",
          "azimuth",
          "backdrop-filter",
          "backface-visibility",
          "background",
          "background-attachment",
          "background-blend-mode",
          "background-clip",
          "background-color",
          "background-image",
          "background-origin",
          "background-position",
          "background-position-x",
          "background-position-y",
          "background-repeat",
          "background-size",
          "baseline-shift",
          "binding",
          "bleed",
          "block-size",
          "bookmark-label",
          "bookmark-level",
          "bookmark-state",
          "bookmark-target",
          "border",
          "border-bottom",
          "border-bottom-color",
          "border-bottom-left-radius",
          "border-bottom-right-radius",
          "border-bottom-style",
          "border-bottom-width",
          "border-collapse",
          "border-color",
          "border-image",
          "border-image-outset",
          "border-image-repeat",
          "border-image-slice",
          "border-image-source",
          "border-image-width",
          "border-left",
          "border-left-color",
          "border-left-style",
          "border-left-width",
          "border-radius",
          "border-right",
          "border-right-color",
          "border-right-style",
          "border-right-width",
          "border-spacing",
          "border-style",
          "border-top",
          "border-top-color",
          "border-top-left-radius",
          "border-top-right-radius",
          "border-top-style",
          "border-top-width",
          "border-width",
          "bottom",
          "box-decoration-break",
          "box-shadow",
          "box-sizing",
          "break-after",
          "break-before",
          "break-inside",
          "caption-side",
          "caret-color",
          "clear",
          "clip",
          "color",
          "color-profile",
          "column-count",
          "column-fill",
          "column-gap",
          "column-rule",
          "column-rule-color",
          "column-rule-style",
          "column-rule-width",
          "column-span",
          "column-width",
          "columns",
          "contain",
          "content",
          "counter-increment",
          "counter-reset",
          "crop",
          "cue",
          "cue-after",
          "cue-before",
          "cursor",
          "direction",
          "display",
          "dominant-baseline",
          "drop-initial-after-adjust",
          "drop-initial-after-align",
          "drop-initial-before-adjust",
          "drop-initial-before-align",
          "drop-initial-size",
          "drop-initial-value",
          "elevation",
          "empty-cells",
          "fit",
          "fit-position",
          "flex",
          "flex-basis",
          "flex-direction",
          "flex-flow",
          "flex-grow",
          "flex-shrink",
          "flex-wrap",
          "float",
          "float-offset",
          "flow-from",
          "flow-into",
          "font",
          "font-family",
          "font-feature-settings",
          "font-kerning",
          "font-language-override",
          "font-optical-sizing",
          "font-size",
          "font-size-adjust",
          "font-stretch",
          "font-style",
          "font-synthesis",
          "font-variant",
          "font-variant-alternates",
          "font-variant-caps",
          "font-variant-east-asian",
          "font-variant-ligatures",
          "font-variant-numeric",
          "font-variant-position",
          "font-variation-settings",
          "font-weight",
          "gap",
          "grid",
          "grid-area",
          "grid-auto-columns",
          "grid-auto-flow",
          "grid-auto-rows",
          "grid-column",
          "grid-column-end",
          "grid-column-gap",
          "grid-column-start",
          "grid-gap",
          "grid-row",
          "grid-row-end",
          "grid-row-gap",
          "grid-row-start",
          "grid-template",
          "grid-template-areas",
          "grid-template-columns",
          "grid-template-rows",
          "hanging-punctuation",
          "height",
          "hyphens",
          "icon",
          "image-orientation",
          "image-rendering",
          "image-resolution",
          "inline-box-align",
          "inset",
          "inset-block",
          "inset-block-end",
          "inset-block-start",
          "inset-inline",
          "inset-inline-end",
          "inset-inline-start",
          "isolation",
          "justify-content",
          "justify-items",
          "justify-self",
          "left",
          "letter-spacing",
          "line-break",
          "line-height",
          "line-height-step",
          "line-stacking",
          "line-stacking-ruby",
          "line-stacking-shift",
          "line-stacking-strategy",
          "list-style",
          "list-style-image",
          "list-style-position",
          "list-style-type",
          "margin",
          "margin-bottom",
          "margin-left",
          "margin-right",
          "margin-top",
          "marks",
          "marquee-direction",
          "marquee-loop",
          "marquee-play-count",
          "marquee-speed",
          "marquee-style",
          "max-block-size",
          "max-height",
          "max-inline-size",
          "max-width",
          "min-block-size",
          "min-height",
          "min-inline-size",
          "min-width",
          "mix-blend-mode",
          "move-to",
          "nav-down",
          "nav-index",
          "nav-left",
          "nav-right",
          "nav-up",
          "object-fit",
          "object-position",
          "offset",
          "offset-anchor",
          "offset-distance",
          "offset-path",
          "offset-position",
          "offset-rotate",
          "opacity",
          "order",
          "orphans",
          "outline",
          "outline-color",
          "outline-offset",
          "outline-style",
          "outline-width",
          "overflow",
          "overflow-style",
          "overflow-wrap",
          "overflow-x",
          "overflow-y",
          "padding",
          "padding-bottom",
          "padding-left",
          "padding-right",
          "padding-top",
          "page",
          "page-break-after",
          "page-break-before",
          "page-break-inside",
          "page-policy",
          "pause",
          "pause-after",
          "pause-before",
          "perspective",
          "perspective-origin",
          "pitch",
          "pitch-range",
          "place-content",
          "place-items",
          "place-self",
          "play-during",
          "position",
          "presentation-level",
          "punctuation-trim",
          "quotes",
          "region-break-after",
          "region-break-before",
          "region-break-inside",
          "region-fragment",
          "rendering-intent",
          "resize",
          "rest",
          "rest-after",
          "rest-before",
          "richness",
          "right",
          "rotate",
          "rotation",
          "rotation-point",
          "row-gap",
          "ruby-align",
          "ruby-overhang",
          "ruby-position",
          "ruby-span",
          "scale",
          "scroll-behavior",
          "scroll-margin",
          "scroll-margin-block",
          "scroll-margin-block-end",
          "scroll-margin-block-start",
          "scroll-margin-bottom",
          "scroll-margin-inline",
          "scroll-margin-inline-end",
          "scroll-margin-inline-start",
          "scroll-margin-left",
          "scroll-margin-right",
          "scroll-margin-top",
          "scroll-padding",
          "scroll-padding-block",
          "scroll-padding-block-end",
          "scroll-padding-block-start",
          "scroll-padding-bottom",
          "scroll-padding-inline",
          "scroll-padding-inline-end",
          "scroll-padding-inline-start",
          "scroll-padding-left",
          "scroll-padding-right",
          "scroll-padding-top",
          "scroll-snap-align",
          "scroll-snap-type",
          "shape-image-threshold",
          "shape-inside",
          "shape-margin",
          "shape-outside",
          "size",
          "speak",
          "speak-as",
          "speak-header",
          "speak-numeral",
          "speak-punctuation",
          "speech-rate",
          "stress",
          "string-set",
          "tab-size",
          "table-layout",
          "target",
          "target-name",
          "target-new",
          "target-position",
          "text-align",
          "text-align-last",
          "text-combine-upright",
          "text-decoration",
          "text-decoration-color",
          "text-decoration-line",
          "text-decoration-skip",
          "text-decoration-skip-ink",
          "text-decoration-style",
          "text-emphasis",
          "text-emphasis-color",
          "text-emphasis-position",
          "text-emphasis-style",
          "text-height",
          "text-indent",
          "text-justify",
          "text-orientation",
          "text-outline",
          "text-overflow",
          "text-rendering",
          "text-shadow",
          "text-size-adjust",
          "text-space-collapse",
          "text-transform",
          "text-underline-position",
          "text-wrap",
          "top",
          "transform",
          "transform-origin",
          "transform-style",
          "transition",
          "transition-delay",
          "transition-duration",
          "transition-property",
          "transition-timing-function",
          "translate",
          "unicode-bidi",
          "user-select",
          "vertical-align",
          "visibility",
          "voice-balance",
          "voice-duration",
          "voice-family",
          "voice-pitch",
          "voice-range",
          "voice-rate",
          "voice-stress",
          "voice-volume",
          "volume",
          "white-space",
          "widows",
          "width",
          "will-change",
          "word-break",
          "word-spacing",
          "word-wrap",
          "writing-mode",
          "z-index",
          "clip-path",
          "clip-rule",
          "mask",
          "enable-background",
          "filter",
          "flood-color",
          "flood-opacity",
          "lighting-color",
          "stop-color",
          "stop-opacity",
          "pointer-events",
          "color-interpolation",
          "color-interpolation-filters",
          "color-rendering",
          "fill",
          "fill-opacity",
          "fill-rule",
          "image-rendering",
          "marker",
          "marker-end",
          "marker-mid",
          "marker-start",
          "shape-rendering",
          "stroke",
          "stroke-dasharray",
          "stroke-dashoffset",
          "stroke-linecap",
          "stroke-linejoin",
          "stroke-miterlimit",
          "stroke-opacity",
          "stroke-width",
          "text-rendering",
          "baseline-shift",
          "dominant-baseline",
          "glyph-orientation-horizontal",
          "glyph-orientation-vertical",
          "text-anchor",
          "writing-mode"
        ], propertyKeywords = keySet(propertyKeywords_);
        var nonStandardPropertyKeywords_ = [
          "border-block",
          "border-block-color",
          "border-block-end",
          "border-block-end-color",
          "border-block-end-style",
          "border-block-end-width",
          "border-block-start",
          "border-block-start-color",
          "border-block-start-style",
          "border-block-start-width",
          "border-block-style",
          "border-block-width",
          "border-inline",
          "border-inline-color",
          "border-inline-end",
          "border-inline-end-color",
          "border-inline-end-style",
          "border-inline-end-width",
          "border-inline-start",
          "border-inline-start-color",
          "border-inline-start-style",
          "border-inline-start-width",
          "border-inline-style",
          "border-inline-width",
          "margin-block",
          "margin-block-end",
          "margin-block-start",
          "margin-inline",
          "margin-inline-end",
          "margin-inline-start",
          "padding-block",
          "padding-block-end",
          "padding-block-start",
          "padding-inline",
          "padding-inline-end",
          "padding-inline-start",
          "scroll-snap-stop",
          "scrollbar-3d-light-color",
          "scrollbar-arrow-color",
          "scrollbar-base-color",
          "scrollbar-dark-shadow-color",
          "scrollbar-face-color",
          "scrollbar-highlight-color",
          "scrollbar-shadow-color",
          "scrollbar-track-color",
          "searchfield-cancel-button",
          "searchfield-decoration",
          "searchfield-results-button",
          "searchfield-results-decoration",
          "shape-inside",
          "zoom"
        ], nonStandardPropertyKeywords = keySet(nonStandardPropertyKeywords_);
        var fontProperties_ = [
          "font-display",
          "font-family",
          "src",
          "unicode-range",
          "font-variant",
          "font-feature-settings",
          "font-stretch",
          "font-weight",
          "font-style"
        ], fontProperties = keySet(fontProperties_);
        var counterDescriptors_ = [
          "additive-symbols",
          "fallback",
          "negative",
          "pad",
          "prefix",
          "range",
          "speak-as",
          "suffix",
          "symbols",
          "system"
        ], counterDescriptors = keySet(counterDescriptors_);
        var colorKeywords_ = [
          "aliceblue",
          "antiquewhite",
          "aqua",
          "aquamarine",
          "azure",
          "beige",
          "bisque",
          "black",
          "blanchedalmond",
          "blue",
          "blueviolet",
          "brown",
          "burlywood",
          "cadetblue",
          "chartreuse",
          "chocolate",
          "coral",
          "cornflowerblue",
          "cornsilk",
          "crimson",
          "cyan",
          "darkblue",
          "darkcyan",
          "darkgoldenrod",
          "darkgray",
          "darkgreen",
          "darkkhaki",
          "darkmagenta",
          "darkolivegreen",
          "darkorange",
          "darkorchid",
          "darkred",
          "darksalmon",
          "darkseagreen",
          "darkslateblue",
          "darkslategray",
          "darkturquoise",
          "darkviolet",
          "deeppink",
          "deepskyblue",
          "dimgray",
          "dodgerblue",
          "firebrick",
          "floralwhite",
          "forestgreen",
          "fuchsia",
          "gainsboro",
          "ghostwhite",
          "gold",
          "goldenrod",
          "gray",
          "grey",
          "green",
          "greenyellow",
          "honeydew",
          "hotpink",
          "indianred",
          "indigo",
          "ivory",
          "khaki",
          "lavender",
          "lavenderblush",
          "lawngreen",
          "lemonchiffon",
          "lightblue",
          "lightcoral",
          "lightcyan",
          "lightgoldenrodyellow",
          "lightgray",
          "lightgreen",
          "lightpink",
          "lightsalmon",
          "lightseagreen",
          "lightskyblue",
          "lightslategray",
          "lightsteelblue",
          "lightyellow",
          "lime",
          "limegreen",
          "linen",
          "magenta",
          "maroon",
          "mediumaquamarine",
          "mediumblue",
          "mediumorchid",
          "mediumpurple",
          "mediumseagreen",
          "mediumslateblue",
          "mediumspringgreen",
          "mediumturquoise",
          "mediumvioletred",
          "midnightblue",
          "mintcream",
          "mistyrose",
          "moccasin",
          "navajowhite",
          "navy",
          "oldlace",
          "olive",
          "olivedrab",
          "orange",
          "orangered",
          "orchid",
          "palegoldenrod",
          "palegreen",
          "paleturquoise",
          "palevioletred",
          "papayawhip",
          "peachpuff",
          "peru",
          "pink",
          "plum",
          "powderblue",
          "purple",
          "rebeccapurple",
          "red",
          "rosybrown",
          "royalblue",
          "saddlebrown",
          "salmon",
          "sandybrown",
          "seagreen",
          "seashell",
          "sienna",
          "silver",
          "skyblue",
          "slateblue",
          "slategray",
          "snow",
          "springgreen",
          "steelblue",
          "tan",
          "teal",
          "thistle",
          "tomato",
          "turquoise",
          "violet",
          "wheat",
          "white",
          "whitesmoke",
          "yellow",
          "yellowgreen"
        ], colorKeywords = keySet(colorKeywords_);
        var valueKeywords_ = [
          "above",
          "absolute",
          "activeborder",
          "additive",
          "activecaption",
          "afar",
          "after-white-space",
          "ahead",
          "alias",
          "all",
          "all-scroll",
          "alphabetic",
          "alternate",
          "always",
          "amharic",
          "amharic-abegede",
          "antialiased",
          "appworkspace",
          "arabic-indic",
          "armenian",
          "asterisks",
          "attr",
          "auto",
          "auto-flow",
          "avoid",
          "avoid-column",
          "avoid-page",
          "avoid-region",
          "background",
          "backwards",
          "baseline",
          "below",
          "bidi-override",
          "binary",
          "bengali",
          "blink",
          "block",
          "block-axis",
          "bold",
          "bolder",
          "border",
          "border-box",
          "both",
          "bottom",
          "break",
          "break-all",
          "break-word",
          "bullets",
          "button",
          "button-bevel",
          "buttonface",
          "buttonhighlight",
          "buttonshadow",
          "buttontext",
          "calc",
          "cambodian",
          "capitalize",
          "caps-lock-indicator",
          "caption",
          "captiontext",
          "caret",
          "cell",
          "center",
          "checkbox",
          "circle",
          "cjk-decimal",
          "cjk-earthly-branch",
          "cjk-heavenly-stem",
          "cjk-ideographic",
          "clear",
          "clip",
          "close-quote",
          "col-resize",
          "collapse",
          "color",
          "color-burn",
          "color-dodge",
          "column",
          "column-reverse",
          "compact",
          "condensed",
          "contain",
          "content",
          "contents",
          "content-box",
          "context-menu",
          "continuous",
          "copy",
          "counter",
          "counters",
          "cover",
          "crop",
          "cross",
          "crosshair",
          "currentcolor",
          "cursive",
          "cyclic",
          "darken",
          "dashed",
          "decimal",
          "decimal-leading-zero",
          "default",
          "default-button",
          "dense",
          "destination-atop",
          "destination-in",
          "destination-out",
          "destination-over",
          "devanagari",
          "difference",
          "disc",
          "discard",
          "disclosure-closed",
          "disclosure-open",
          "document",
          "dot-dash",
          "dot-dot-dash",
          "dotted",
          "double",
          "down",
          "e-resize",
          "ease",
          "ease-in",
          "ease-in-out",
          "ease-out",
          "element",
          "ellipse",
          "ellipsis",
          "embed",
          "end",
          "ethiopic",
          "ethiopic-abegede",
          "ethiopic-abegede-am-et",
          "ethiopic-abegede-gez",
          "ethiopic-abegede-ti-er",
          "ethiopic-abegede-ti-et",
          "ethiopic-halehame-aa-er",
          "ethiopic-halehame-aa-et",
          "ethiopic-halehame-am-et",
          "ethiopic-halehame-gez",
          "ethiopic-halehame-om-et",
          "ethiopic-halehame-sid-et",
          "ethiopic-halehame-so-et",
          "ethiopic-halehame-ti-er",
          "ethiopic-halehame-ti-et",
          "ethiopic-halehame-tig",
          "ethiopic-numeric",
          "ew-resize",
          "exclusion",
          "expanded",
          "extends",
          "extra-condensed",
          "extra-expanded",
          "fantasy",
          "fast",
          "fill",
          "fixed",
          "flat",
          "flex",
          "flex-end",
          "flex-start",
          "footnotes",
          "forwards",
          "from",
          "geometricPrecision",
          "georgian",
          "graytext",
          "grid",
          "groove",
          "gujarati",
          "gurmukhi",
          "hand",
          "hangul",
          "hangul-consonant",
          "hard-light",
          "hebrew",
          "help",
          "hidden",
          "hide",
          "higher",
          "highlight",
          "highlighttext",
          "hiragana",
          "hiragana-iroha",
          "horizontal",
          "hsl",
          "hsla",
          "hue",
          "icon",
          "ignore",
          "inactiveborder",
          "inactivecaption",
          "inactivecaptiontext",
          "infinite",
          "infobackground",
          "infotext",
          "inherit",
          "initial",
          "inline",
          "inline-axis",
          "inline-block",
          "inline-flex",
          "inline-grid",
          "inline-table",
          "inset",
          "inside",
          "intrinsic",
          "invert",
          "italic",
          "japanese-formal",
          "japanese-informal",
          "justify",
          "kannada",
          "katakana",
          "katakana-iroha",
          "keep-all",
          "khmer",
          "korean-hangul-formal",
          "korean-hanja-formal",
          "korean-hanja-informal",
          "landscape",
          "lao",
          "large",
          "larger",
          "left",
          "level",
          "lighter",
          "lighten",
          "line-through",
          "linear",
          "linear-gradient",
          "lines",
          "list-item",
          "listbox",
          "listitem",
          "local",
          "logical",
          "loud",
          "lower",
          "lower-alpha",
          "lower-armenian",
          "lower-greek",
          "lower-hexadecimal",
          "lower-latin",
          "lower-norwegian",
          "lower-roman",
          "lowercase",
          "ltr",
          "luminosity",
          "malayalam",
          "match",
          "matrix",
          "matrix3d",
          "media-controls-background",
          "media-current-time-display",
          "media-fullscreen-button",
          "media-mute-button",
          "media-play-button",
          "media-return-to-realtime-button",
          "media-rewind-button",
          "media-seek-back-button",
          "media-seek-forward-button",
          "media-slider",
          "media-sliderthumb",
          "media-time-remaining-display",
          "media-volume-slider",
          "media-volume-slider-container",
          "media-volume-sliderthumb",
          "medium",
          "menu",
          "menulist",
          "menulist-button",
          "menulist-text",
          "menulist-textfield",
          "menutext",
          "message-box",
          "middle",
          "min-intrinsic",
          "mix",
          "mongolian",
          "monospace",
          "move",
          "multiple",
          "multiply",
          "myanmar",
          "n-resize",
          "narrower",
          "ne-resize",
          "nesw-resize",
          "no-close-quote",
          "no-drop",
          "no-open-quote",
          "no-repeat",
          "none",
          "normal",
          "not-allowed",
          "nowrap",
          "ns-resize",
          "numbers",
          "numeric",
          "nw-resize",
          "nwse-resize",
          "oblique",
          "octal",
          "opacity",
          "open-quote",
          "optimizeLegibility",
          "optimizeSpeed",
          "oriya",
          "oromo",
          "outset",
          "outside",
          "outside-shape",
          "overlay",
          "overline",
          "padding",
          "padding-box",
          "painted",
          "page",
          "paused",
          "persian",
          "perspective",
          "plus-darker",
          "plus-lighter",
          "pointer",
          "polygon",
          "portrait",
          "pre",
          "pre-line",
          "pre-wrap",
          "preserve-3d",
          "progress",
          "push-button",
          "radial-gradient",
          "radio",
          "read-only",
          "read-write",
          "read-write-plaintext-only",
          "rectangle",
          "region",
          "relative",
          "repeat",
          "repeating-linear-gradient",
          "repeating-radial-gradient",
          "repeat-x",
          "repeat-y",
          "reset",
          "reverse",
          "rgb",
          "rgba",
          "ridge",
          "right",
          "rotate",
          "rotate3d",
          "rotateX",
          "rotateY",
          "rotateZ",
          "round",
          "row",
          "row-resize",
          "row-reverse",
          "rtl",
          "run-in",
          "running",
          "s-resize",
          "sans-serif",
          "saturation",
          "scale",
          "scale3d",
          "scaleX",
          "scaleY",
          "scaleZ",
          "screen",
          "scroll",
          "scrollbar",
          "scroll-position",
          "se-resize",
          "searchfield",
          "searchfield-cancel-button",
          "searchfield-decoration",
          "searchfield-results-button",
          "searchfield-results-decoration",
          "self-start",
          "self-end",
          "semi-condensed",
          "semi-expanded",
          "separate",
          "serif",
          "show",
          "sidama",
          "simp-chinese-formal",
          "simp-chinese-informal",
          "single",
          "skew",
          "skewX",
          "skewY",
          "skip-white-space",
          "slide",
          "slider-horizontal",
          "slider-vertical",
          "sliderthumb-horizontal",
          "sliderthumb-vertical",
          "slow",
          "small",
          "small-caps",
          "small-caption",
          "smaller",
          "soft-light",
          "solid",
          "somali",
          "source-atop",
          "source-in",
          "source-out",
          "source-over",
          "space",
          "space-around",
          "space-between",
          "space-evenly",
          "spell-out",
          "square",
          "square-button",
          "start",
          "static",
          "status-bar",
          "stretch",
          "stroke",
          "sub",
          "subpixel-antialiased",
          "super",
          "sw-resize",
          "symbolic",
          "symbols",
          "system-ui",
          "table",
          "table-caption",
          "table-cell",
          "table-column",
          "table-column-group",
          "table-footer-group",
          "table-header-group",
          "table-row",
          "table-row-group",
          "tamil",
          "telugu",
          "text",
          "text-bottom",
          "text-top",
          "textarea",
          "textfield",
          "thai",
          "thick",
          "thin",
          "threeddarkshadow",
          "threedface",
          "threedhighlight",
          "threedlightshadow",
          "threedshadow",
          "tibetan",
          "tigre",
          "tigrinya-er",
          "tigrinya-er-abegede",
          "tigrinya-et",
          "tigrinya-et-abegede",
          "to",
          "top",
          "trad-chinese-formal",
          "trad-chinese-informal",
          "transform",
          "translate",
          "translate3d",
          "translateX",
          "translateY",
          "translateZ",
          "transparent",
          "ultra-condensed",
          "ultra-expanded",
          "underline",
          "unset",
          "up",
          "upper-alpha",
          "upper-armenian",
          "upper-greek",
          "upper-hexadecimal",
          "upper-latin",
          "upper-norwegian",
          "upper-roman",
          "uppercase",
          "urdu",
          "url",
          "var",
          "vertical",
          "vertical-text",
          "visible",
          "visibleFill",
          "visiblePainted",
          "visibleStroke",
          "visual",
          "w-resize",
          "wait",
          "wave",
          "wider",
          "window",
          "windowframe",
          "windowtext",
          "words",
          "wrap",
          "wrap-reverse",
          "x-large",
          "x-small",
          "xor",
          "xx-large",
          "xx-small"
        ], valueKeywords = keySet(valueKeywords_);
        var allWords = documentTypes_.concat(mediaTypes_).concat(mediaFeatures_).concat(mediaValueKeywords_).concat(propertyKeywords_).concat(nonStandardPropertyKeywords_).concat(colorKeywords_).concat(valueKeywords_);
        CodeMirror5.registerHelper("hintWords", "css", allWords);
        function tokenCComment(stream, state) {
          var maybeEnd = false, ch;
          while ((ch = stream.next()) != null) {
            if (maybeEnd && ch == "/") {
              state.tokenize = null;
              break;
            }
            maybeEnd = ch == "*";
          }
          return ["comment", "comment"];
        }
        CodeMirror5.defineMIME("text/css", {
          documentTypes,
          mediaTypes,
          mediaFeatures,
          mediaValueKeywords,
          propertyKeywords,
          nonStandardPropertyKeywords,
          fontProperties,
          counterDescriptors,
          colorKeywords,
          valueKeywords,
          tokenHooks: {
            "/": function(stream, state) {
              if (!stream.eat("*"))
                return false;
              state.tokenize = tokenCComment;
              return tokenCComment(stream, state);
            }
          },
          name: "css"
        });
        CodeMirror5.defineMIME("text/x-scss", {
          mediaTypes,
          mediaFeatures,
          mediaValueKeywords,
          propertyKeywords,
          nonStandardPropertyKeywords,
          colorKeywords,
          valueKeywords,
          fontProperties,
          allowNested: true,
          lineComment: "//",
          tokenHooks: {
            "/": function(stream, state) {
              if (stream.eat("/")) {
                stream.skipToEnd();
                return ["comment", "comment"];
              } else if (stream.eat("*")) {
                state.tokenize = tokenCComment;
                return tokenCComment(stream, state);
              } else {
                return ["operator", "operator"];
              }
            },
            ":": function(stream) {
              if (stream.match(/\s*\{/, false))
                return [null, null];
              return false;
            },
            "$": function(stream) {
              stream.match(/^[\w-]+/);
              if (stream.match(/^\s*:/, false))
                return ["variable-2", "variable-definition"];
              return ["variable-2", "variable"];
            },
            "#": function(stream) {
              if (!stream.eat("{"))
                return false;
              return [null, "interpolation"];
            }
          },
          name: "css",
          helperType: "scss"
        });
        CodeMirror5.defineMIME("text/x-less", {
          mediaTypes,
          mediaFeatures,
          mediaValueKeywords,
          propertyKeywords,
          nonStandardPropertyKeywords,
          colorKeywords,
          valueKeywords,
          fontProperties,
          allowNested: true,
          lineComment: "//",
          tokenHooks: {
            "/": function(stream, state) {
              if (stream.eat("/")) {
                stream.skipToEnd();
                return ["comment", "comment"];
              } else if (stream.eat("*")) {
                state.tokenize = tokenCComment;
                return tokenCComment(stream, state);
              } else {
                return ["operator", "operator"];
              }
            },
            "@": function(stream) {
              if (stream.eat("{"))
                return [null, "interpolation"];
              if (stream.match(/^(charset|document|font-face|import|(-(moz|ms|o|webkit)-)?keyframes|media|namespace|page|supports)\b/i, false))
                return false;
              stream.eatWhile(/[\w\\\-]/);
              if (stream.match(/^\s*:/, false))
                return ["variable-2", "variable-definition"];
              return ["variable-2", "variable"];
            },
            "&": function() {
              return ["atom", "atom"];
            }
          },
          name: "css",
          helperType: "less"
        });
        CodeMirror5.defineMIME("text/x-gss", {
          documentTypes,
          mediaTypes,
          mediaFeatures,
          propertyKeywords,
          nonStandardPropertyKeywords,
          fontProperties,
          counterDescriptors,
          colorKeywords,
          valueKeywords,
          supportsAtComponent: true,
          tokenHooks: {
            "/": function(stream, state) {
              if (!stream.eat("*"))
                return false;
              state.tokenize = tokenCComment;
              return tokenCComment(stream, state);
            }
          },
          name: "css",
          helperType: "gss"
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/htmlmixed/htmlmixed.js
  var require_htmlmixed = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/htmlmixed/htmlmixed.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_xml(), require_javascript(), require_css());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../xml/xml", "../javascript/javascript", "../css/css"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var defaultTags = {
          script: [
            ["lang", /(javascript|babel)/i, "javascript"],
            ["type", /^(?:text|application)\/(?:x-)?(?:java|ecma)script$|^module$|^$/i, "javascript"],
            ["type", /./, "text/plain"],
            [null, null, "javascript"]
          ],
          style: [
            ["lang", /^css$/i, "css"],
            ["type", /^(text\/)?(x-)?(stylesheet|css)$/i, "css"],
            ["type", /./, "text/plain"],
            [null, null, "css"]
          ]
        };
        function maybeBackup(stream, pat, style) {
          var cur = stream.current(), close = cur.search(pat);
          if (close > -1) {
            stream.backUp(cur.length - close);
          } else if (cur.match(/<\/?$/)) {
            stream.backUp(cur.length);
            if (!stream.match(pat, false))
              stream.match(cur);
          }
          return style;
        }
        var attrRegexpCache = {};
        function getAttrRegexp(attr) {
          var regexp = attrRegexpCache[attr];
          if (regexp)
            return regexp;
          return attrRegexpCache[attr] = new RegExp("\\s+" + attr + `\\s*=\\s*('|")?([^'"]+)('|")?\\s*`);
        }
        function getAttrValue(text, attr) {
          var match = text.match(getAttrRegexp(attr));
          return match ? /^\s*(.*?)\s*$/.exec(match[2])[1] : "";
        }
        function getTagRegexp(tagName, anchored) {
          return new RegExp((anchored ? "^" : "") + "</s*" + tagName + "s*>", "i");
        }
        function addTags(from, to) {
          for (var tag in from) {
            var dest = to[tag] || (to[tag] = []);
            var source = from[tag];
            for (var i3 = source.length - 1; i3 >= 0; i3--)
              dest.unshift(source[i3]);
          }
        }
        function findMatchingMode(tagInfo, tagText) {
          for (var i3 = 0; i3 < tagInfo.length; i3++) {
            var spec = tagInfo[i3];
            if (!spec[0] || spec[1].test(getAttrValue(tagText, spec[0])))
              return spec[2];
          }
        }
        CodeMirror5.defineMode("htmlmixed", function(config3, parserConfig) {
          var htmlMode = CodeMirror5.getMode(config3, {
            name: "xml",
            htmlMode: true,
            multilineTagIndentFactor: parserConfig.multilineTagIndentFactor,
            multilineTagIndentPastTag: parserConfig.multilineTagIndentPastTag
          });
          var tags = {};
          var configTags = parserConfig && parserConfig.tags, configScript = parserConfig && parserConfig.scriptTypes;
          addTags(defaultTags, tags);
          if (configTags)
            addTags(configTags, tags);
          if (configScript)
            for (var i3 = configScript.length - 1; i3 >= 0; i3--)
              tags.script.unshift(["type", configScript[i3].matches, configScript[i3].mode]);
          function html(stream, state) {
            var style = htmlMode.token(stream, state.htmlState), tag = /\btag\b/.test(style), tagName;
            if (tag && !/[<>\s\/]/.test(stream.current()) && (tagName = state.htmlState.tagName && state.htmlState.tagName.toLowerCase()) && tags.hasOwnProperty(tagName)) {
              state.inTag = tagName + " ";
            } else if (state.inTag && tag && />$/.test(stream.current())) {
              var inTag = /^([\S]+) (.*)/.exec(state.inTag);
              state.inTag = null;
              var modeSpec = stream.current() == ">" && findMatchingMode(tags[inTag[1]], inTag[2]);
              var mode2 = CodeMirror5.getMode(config3, modeSpec);
              var endTagA = getTagRegexp(inTag[1], true), endTag = getTagRegexp(inTag[1], false);
              state.token = function(stream2, state2) {
                if (stream2.match(endTagA, false)) {
                  state2.token = html;
                  state2.localState = state2.localMode = null;
                  return null;
                }
                return maybeBackup(stream2, endTag, state2.localMode.token(stream2, state2.localState));
              };
              state.localMode = mode2;
              state.localState = CodeMirror5.startState(mode2, htmlMode.indent(state.htmlState, "", ""));
            } else if (state.inTag) {
              state.inTag += stream.current();
              if (stream.eol())
                state.inTag += " ";
            }
            return style;
          }
          ;
          return {
            startState: function() {
              var state = CodeMirror5.startState(htmlMode);
              return { token: html, inTag: null, localMode: null, localState: null, htmlState: state };
            },
            copyState: function(state) {
              var local;
              if (state.localState) {
                local = CodeMirror5.copyState(state.localMode, state.localState);
              }
              return {
                token: state.token,
                inTag: state.inTag,
                localMode: state.localMode,
                localState: local,
                htmlState: CodeMirror5.copyState(htmlMode, state.htmlState)
              };
            },
            token: function(stream, state) {
              return state.token(stream, state);
            },
            indent: function(state, textAfter, line) {
              if (!state.localMode || /^\s*<\//.test(textAfter))
                return htmlMode.indent(state.htmlState, textAfter, line);
              else if (state.localMode.indent)
                return state.localMode.indent(state.localState, textAfter, line);
              else
                return CodeMirror5.Pass;
            },
            innerMode: function(state) {
              return { state: state.localState || state.htmlState, mode: state.localMode || htmlMode };
            }
          };
        }, "xml", "javascript", "css");
        CodeMirror5.defineMIME("text/html", "htmlmixed");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/apl/apl.js
  var require_apl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/apl/apl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("apl", function() {
          var builtInOps = {
            ".": "innerProduct",
            "\\": "scan",
            "/": "reduce",
            "\u233F": "reduce1Axis",
            "\u2340": "scan1Axis",
            "\xA8": "each",
            "\u2363": "power"
          };
          var builtInFuncs = {
            "+": ["conjugate", "add"],
            "\u2212": ["negate", "subtract"],
            "\xD7": ["signOf", "multiply"],
            "\xF7": ["reciprocal", "divide"],
            "\u2308": ["ceiling", "greaterOf"],
            "\u230A": ["floor", "lesserOf"],
            "\u2223": ["absolute", "residue"],
            "\u2373": ["indexGenerate", "indexOf"],
            "?": ["roll", "deal"],
            "\u22C6": ["exponentiate", "toThePowerOf"],
            "\u235F": ["naturalLog", "logToTheBase"],
            "\u25CB": ["piTimes", "circularFuncs"],
            "!": ["factorial", "binomial"],
            "\u2339": ["matrixInverse", "matrixDivide"],
            "<": [null, "lessThan"],
            "\u2264": [null, "lessThanOrEqual"],
            "=": [null, "equals"],
            ">": [null, "greaterThan"],
            "\u2265": [null, "greaterThanOrEqual"],
            "\u2260": [null, "notEqual"],
            "\u2261": ["depth", "match"],
            "\u2262": [null, "notMatch"],
            "\u2208": ["enlist", "membership"],
            "\u2377": [null, "find"],
            "\u222A": ["unique", "union"],
            "\u2229": [null, "intersection"],
            "\u223C": ["not", "without"],
            "\u2228": [null, "or"],
            "\u2227": [null, "and"],
            "\u2371": [null, "nor"],
            "\u2372": [null, "nand"],
            "\u2374": ["shapeOf", "reshape"],
            ",": ["ravel", "catenate"],
            "\u236A": [null, "firstAxisCatenate"],
            "\u233D": ["reverse", "rotate"],
            "\u2296": ["axis1Reverse", "axis1Rotate"],
            "\u2349": ["transpose", null],
            "\u2191": ["first", "take"],
            "\u2193": [null, "drop"],
            "\u2282": ["enclose", "partitionWithAxis"],
            "\u2283": ["diclose", "pick"],
            "\u2337": [null, "index"],
            "\u234B": ["gradeUp", null],
            "\u2352": ["gradeDown", null],
            "\u22A4": ["encode", null],
            "\u22A5": ["decode", null],
            "\u2355": ["format", "formatByExample"],
            "\u234E": ["execute", null],
            "\u22A3": ["stop", "left"],
            "\u22A2": ["pass", "right"]
          };
          var isOperator = /[\.\/⌿⍀¨⍣]/;
          var isNiladic = /⍬/;
          var isFunction2 = /[\+−×÷⌈⌊∣⍳\?⋆⍟○!⌹<≤=>≥≠≡≢∈⍷∪∩∼∨∧⍱⍲⍴,⍪⌽⊖⍉↑↓⊂⊃⌷⍋⍒⊤⊥⍕⍎⊣⊢]/;
          var isArrow = /←/;
          var isComment = /[⍝#].*$/;
          var stringEater = function(type) {
            var prev;
            prev = false;
            return function(c3) {
              prev = c3;
              if (c3 === type) {
                return prev === "\\";
              }
              return true;
            };
          };
          return {
            startState: function() {
              return {
                prev: false,
                func: false,
                op: false,
                string: false,
                escape: false
              };
            },
            token: function(stream, state) {
              var ch, funcName;
              if (stream.eatSpace()) {
                return null;
              }
              ch = stream.next();
              if (ch === '"' || ch === "'") {
                stream.eatWhile(stringEater(ch));
                stream.next();
                state.prev = true;
                return "string";
              }
              if (/[\[{\(]/.test(ch)) {
                state.prev = false;
                return null;
              }
              if (/[\]}\)]/.test(ch)) {
                state.prev = true;
                return null;
              }
              if (isNiladic.test(ch)) {
                state.prev = false;
                return "niladic";
              }
              if (/[¯\d]/.test(ch)) {
                if (state.func) {
                  state.func = false;
                  state.prev = false;
                } else {
                  state.prev = true;
                }
                stream.eatWhile(/[\w\.]/);
                return "number";
              }
              if (isOperator.test(ch)) {
                return "operator apl-" + builtInOps[ch];
              }
              if (isArrow.test(ch)) {
                return "apl-arrow";
              }
              if (isFunction2.test(ch)) {
                funcName = "apl-";
                if (builtInFuncs[ch] != null) {
                  if (state.prev) {
                    funcName += builtInFuncs[ch][1];
                  } else {
                    funcName += builtInFuncs[ch][0];
                  }
                }
                state.func = true;
                state.prev = false;
                return "function " + funcName;
              }
              if (isComment.test(ch)) {
                stream.skipToEnd();
                return "comment";
              }
              if (ch === "\u2218" && stream.peek() === ".") {
                stream.next();
                return "function jot-dot";
              }
              stream.eatWhile(/[\w\$_]/);
              state.prev = true;
              return "keyword";
            }
          };
        });
        CodeMirror5.defineMIME("text/apl", "apl");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/asciiarmor/asciiarmor.js
  var require_asciiarmor = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/asciiarmor/asciiarmor.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function errorIfNotEmpty(stream) {
          var nonWS = stream.match(/^\s*\S/);
          stream.skipToEnd();
          return nonWS ? "error" : null;
        }
        CodeMirror5.defineMode("asciiarmor", function() {
          return {
            token: function(stream, state) {
              var m3;
              if (state.state == "top") {
                if (stream.sol() && (m3 = stream.match(/^-----BEGIN (.*)?-----\s*$/))) {
                  state.state = "headers";
                  state.type = m3[1];
                  return "tag";
                }
                return errorIfNotEmpty(stream);
              } else if (state.state == "headers") {
                if (stream.sol() && stream.match(/^\w+:/)) {
                  state.state = "header";
                  return "atom";
                } else {
                  var result = errorIfNotEmpty(stream);
                  if (result)
                    state.state = "body";
                  return result;
                }
              } else if (state.state == "header") {
                stream.skipToEnd();
                state.state = "headers";
                return "string";
              } else if (state.state == "body") {
                if (stream.sol() && (m3 = stream.match(/^-----END (.*)?-----\s*$/))) {
                  if (m3[1] != state.type)
                    return "error";
                  state.state = "end";
                  return "tag";
                } else {
                  if (stream.eatWhile(/[A-Za-z0-9+\/=]/)) {
                    return null;
                  } else {
                    stream.next();
                    return "error";
                  }
                }
              } else if (state.state == "end") {
                return errorIfNotEmpty(stream);
              }
            },
            blankLine: function(state) {
              if (state.state == "headers")
                state.state = "body";
            },
            startState: function() {
              return { state: "top", type: null };
            }
          };
        });
        CodeMirror5.defineMIME("application/pgp", "asciiarmor");
        CodeMirror5.defineMIME("application/pgp-encrypted", "asciiarmor");
        CodeMirror5.defineMIME("application/pgp-keys", "asciiarmor");
        CodeMirror5.defineMIME("application/pgp-signature", "asciiarmor");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/asn.1/asn.1.js
  var require_asn_1 = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/asn.1/asn.1.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("asn.1", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit, keywords2 = parserConfig.keywords || {}, cmipVerbs = parserConfig.cmipVerbs || {}, compareTypes = parserConfig.compareTypes || {}, status = parserConfig.status || {}, tags = parserConfig.tags || {}, storage = parserConfig.storage || {}, modifier = parserConfig.modifier || {}, accessTypes = parserConfig.accessTypes || {}, multiLineStrings = parserConfig.multiLineStrings, indentStatements = parserConfig.indentStatements !== false;
          var isOperatorChar = /[\|\^]/;
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[\[\]\(\){}:=,;]/.test(ch)) {
              curPunc = ch;
              return "punctuation";
            }
            if (ch == "-") {
              if (stream.eat("-")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\-]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur))
              return "keyword";
            if (cmipVerbs.propertyIsEnumerable(cur))
              return "variable cmipVerbs";
            if (compareTypes.propertyIsEnumerable(cur))
              return "atom compareTypes";
            if (status.propertyIsEnumerable(cur))
              return "comment status";
            if (tags.propertyIsEnumerable(cur))
              return "variable-3 tags";
            if (storage.propertyIsEnumerable(cur))
              return "builtin storage";
            if (modifier.propertyIsEnumerable(cur))
              return "string-2 modifier";
            if (accessTypes.propertyIsEnumerable(cur))
              return "atom accessTypes";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  var afterNext = stream.peek();
                  if (afterNext) {
                    afterNext = afterNext.toLowerCase();
                    if (afterNext == "b" || afterNext == "h" || afterNext == "o")
                      stream.next();
                  }
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = null;
              return "string";
            };
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            var indent = state.indented;
            if (state.context && state.context.type == "statement")
              indent = state.context.indented;
            return state.context = new Context(indent, col, type, null, state.context);
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if ((curPunc == ";" || curPunc == ":" || curPunc == ",") && ctx.type == "statement") {
                popContext(state);
              } else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if (indentStatements && ((ctx.type == "}" || ctx.type == "top") && curPunc != ";" || ctx.type == "statement" && curPunc == "newstatement"))
                pushContext(state, stream.column(), "statement");
              state.startOfLine = false;
              return style;
            },
            electricChars: "{}",
            lineComment: "--",
            fold: "brace"
          };
        });
        function words(str) {
          var obj = {}, words2 = str.split(" ");
          for (var i3 = 0; i3 < words2.length; ++i3)
            obj[words2[i3]] = true;
          return obj;
        }
        CodeMirror5.defineMIME("text/x-ttcn-asn", {
          name: "asn.1",
          keywords: words("DEFINITIONS OBJECTS IF DERIVED INFORMATION ACTION REPLY ANY NAMED CHARACTERIZED BEHAVIOUR REGISTERED WITH AS IDENTIFIED CONSTRAINED BY PRESENT BEGIN IMPORTS FROM UNITS SYNTAX MIN-ACCESS MAX-ACCESS MINACCESS MAXACCESS REVISION STATUS DESCRIPTION SEQUENCE SET COMPONENTS OF CHOICE DistinguishedName ENUMERATED SIZE MODULE END INDEX AUGMENTS EXTENSIBILITY IMPLIED EXPORTS"),
          cmipVerbs: words("ACTIONS ADD GET NOTIFICATIONS REPLACE REMOVE"),
          compareTypes: words("OPTIONAL DEFAULT MANAGED MODULE-TYPE MODULE_IDENTITY MODULE-COMPLIANCE OBJECT-TYPE OBJECT-IDENTITY OBJECT-COMPLIANCE MODE CONFIRMED CONDITIONAL SUBORDINATE SUPERIOR CLASS TRUE FALSE NULL TEXTUAL-CONVENTION"),
          status: words("current deprecated mandatory obsolete"),
          tags: words("APPLICATION AUTOMATIC EXPLICIT IMPLICIT PRIVATE TAGS UNIVERSAL"),
          storage: words("BOOLEAN INTEGER OBJECT IDENTIFIER BIT OCTET STRING UTCTime InterfaceIndex IANAifType CMIP-Attribute REAL PACKAGE PACKAGES IpAddress PhysAddress NetworkAddress BITS BMPString TimeStamp TimeTicks TruthValue RowStatus DisplayString GeneralString GraphicString IA5String NumericString PrintableString SnmpAdminAtring TeletexString UTF8String VideotexString VisibleString StringStore ISO646String T61String UniversalString Unsigned32 Integer32 Gauge Gauge32 Counter Counter32 Counter64"),
          modifier: words("ATTRIBUTE ATTRIBUTES MANDATORY-GROUP MANDATORY-GROUPS GROUP GROUPS ELEMENTS EQUALITY ORDERING SUBSTRINGS DEFINED"),
          accessTypes: words("not-accessible accessible-for-notify read-only read-create read-write"),
          multiLineStrings: true
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/asterisk/asterisk.js
  var require_asterisk = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/asterisk/asterisk.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("asterisk", function() {
          var atoms = ["exten", "same", "include", "ignorepat", "switch"], dpcmd = ["#include", "#exec"], apps = [
            "addqueuemember",
            "adsiprog",
            "aelsub",
            "agentlogin",
            "agentmonitoroutgoing",
            "agi",
            "alarmreceiver",
            "amd",
            "answer",
            "authenticate",
            "background",
            "backgrounddetect",
            "bridge",
            "busy",
            "callcompletioncancel",
            "callcompletionrequest",
            "celgenuserevent",
            "changemonitor",
            "chanisavail",
            "channelredirect",
            "chanspy",
            "clearhash",
            "confbridge",
            "congestion",
            "continuewhile",
            "controlplayback",
            "dahdiacceptr2call",
            "dahdibarge",
            "dahdiras",
            "dahdiscan",
            "dahdisendcallreroutingfacility",
            "dahdisendkeypadfacility",
            "datetime",
            "dbdel",
            "dbdeltree",
            "deadagi",
            "dial",
            "dictate",
            "directory",
            "disa",
            "dumpchan",
            "eagi",
            "echo",
            "endwhile",
            "exec",
            "execif",
            "execiftime",
            "exitwhile",
            "extenspy",
            "externalivr",
            "festival",
            "flash",
            "followme",
            "forkcdr",
            "getcpeid",
            "gosub",
            "gosubif",
            "goto",
            "gotoif",
            "gotoiftime",
            "hangup",
            "iax2provision",
            "ices",
            "importvar",
            "incomplete",
            "ivrdemo",
            "jabberjoin",
            "jabberleave",
            "jabbersend",
            "jabbersendgroup",
            "jabberstatus",
            "jack",
            "log",
            "macro",
            "macroexclusive",
            "macroexit",
            "macroif",
            "mailboxexists",
            "meetme",
            "meetmeadmin",
            "meetmechanneladmin",
            "meetmecount",
            "milliwatt",
            "minivmaccmess",
            "minivmdelete",
            "minivmgreet",
            "minivmmwi",
            "minivmnotify",
            "minivmrecord",
            "mixmonitor",
            "monitor",
            "morsecode",
            "mp3player",
            "mset",
            "musiconhold",
            "nbscat",
            "nocdr",
            "noop",
            "odbc",
            "odbc",
            "odbcfinish",
            "originate",
            "ospauth",
            "ospfinish",
            "osplookup",
            "ospnext",
            "page",
            "park",
            "parkandannounce",
            "parkedcall",
            "pausemonitor",
            "pausequeuemember",
            "pickup",
            "pickupchan",
            "playback",
            "playtones",
            "privacymanager",
            "proceeding",
            "progress",
            "queue",
            "queuelog",
            "raiseexception",
            "read",
            "readexten",
            "readfile",
            "receivefax",
            "receivefax",
            "receivefax",
            "record",
            "removequeuemember",
            "resetcdr",
            "retrydial",
            "return",
            "ringing",
            "sayalpha",
            "saycountedadj",
            "saycountednoun",
            "saycountpl",
            "saydigits",
            "saynumber",
            "sayphonetic",
            "sayunixtime",
            "senddtmf",
            "sendfax",
            "sendfax",
            "sendfax",
            "sendimage",
            "sendtext",
            "sendurl",
            "set",
            "setamaflags",
            "setcallerpres",
            "setmusiconhold",
            "sipaddheader",
            "sipdtmfmode",
            "sipremoveheader",
            "skel",
            "slastation",
            "slatrunk",
            "sms",
            "softhangup",
            "speechactivategrammar",
            "speechbackground",
            "speechcreate",
            "speechdeactivategrammar",
            "speechdestroy",
            "speechloadgrammar",
            "speechprocessingsound",
            "speechstart",
            "speechunloadgrammar",
            "stackpop",
            "startmusiconhold",
            "stopmixmonitor",
            "stopmonitor",
            "stopmusiconhold",
            "stopplaytones",
            "system",
            "testclient",
            "testserver",
            "transfer",
            "tryexec",
            "trysystem",
            "unpausemonitor",
            "unpausequeuemember",
            "userevent",
            "verbose",
            "vmauthenticate",
            "vmsayname",
            "voicemail",
            "voicemailmain",
            "wait",
            "waitexten",
            "waitfornoise",
            "waitforring",
            "waitforsilence",
            "waitmusiconhold",
            "waituntil",
            "while",
            "zapateller"
          ];
          function basicToken(stream, state) {
            var cur = "";
            var ch = stream.next();
            if (state.blockComment) {
              if (ch == "-" && stream.match("-;", true)) {
                state.blockComment = false;
              } else if (stream.skipTo("--;")) {
                stream.next();
                stream.next();
                stream.next();
                state.blockComment = false;
              } else {
                stream.skipToEnd();
              }
              return "comment";
            }
            if (ch == ";") {
              if (stream.match("--", true)) {
                if (!stream.match("-", false)) {
                  state.blockComment = true;
                  return "comment";
                }
              }
              stream.skipToEnd();
              return "comment";
            }
            if (ch == "[") {
              stream.skipTo("]");
              stream.eat("]");
              return "header";
            }
            if (ch == '"') {
              stream.skipTo('"');
              return "string";
            }
            if (ch == "'") {
              stream.skipTo("'");
              return "string-2";
            }
            if (ch == "#") {
              stream.eatWhile(/\w/);
              cur = stream.current();
              if (dpcmd.indexOf(cur) !== -1) {
                stream.skipToEnd();
                return "strong";
              }
            }
            if (ch == "$") {
              var ch1 = stream.peek();
              if (ch1 == "{") {
                stream.skipTo("}");
                stream.eat("}");
                return "variable-3";
              }
            }
            stream.eatWhile(/\w/);
            cur = stream.current();
            if (atoms.indexOf(cur) !== -1) {
              state.extenStart = true;
              switch (cur) {
                case "same":
                  state.extenSame = true;
                  break;
                case "include":
                case "switch":
                case "ignorepat":
                  state.extenInclude = true;
                  break;
                default:
                  break;
              }
              return "atom";
            }
          }
          return {
            startState: function() {
              return {
                blockComment: false,
                extenStart: false,
                extenSame: false,
                extenInclude: false,
                extenExten: false,
                extenPriority: false,
                extenApplication: false
              };
            },
            token: function(stream, state) {
              var cur = "";
              if (stream.eatSpace())
                return null;
              if (state.extenStart) {
                stream.eatWhile(/[^\s]/);
                cur = stream.current();
                if (/^=>?$/.test(cur)) {
                  state.extenExten = true;
                  state.extenStart = false;
                  return "strong";
                } else {
                  state.extenStart = false;
                  stream.skipToEnd();
                  return "error";
                }
              } else if (state.extenExten) {
                state.extenExten = false;
                state.extenPriority = true;
                stream.eatWhile(/[^,]/);
                if (state.extenInclude) {
                  stream.skipToEnd();
                  state.extenPriority = false;
                  state.extenInclude = false;
                }
                if (state.extenSame) {
                  state.extenPriority = false;
                  state.extenSame = false;
                  state.extenApplication = true;
                }
                return "tag";
              } else if (state.extenPriority) {
                state.extenPriority = false;
                state.extenApplication = true;
                stream.next();
                if (state.extenSame)
                  return null;
                stream.eatWhile(/[^,]/);
                return "number";
              } else if (state.extenApplication) {
                stream.eatWhile(/,/);
                cur = stream.current();
                if (cur === ",")
                  return null;
                stream.eatWhile(/\w/);
                cur = stream.current().toLowerCase();
                state.extenApplication = false;
                if (apps.indexOf(cur) !== -1) {
                  return "def strong";
                }
              } else {
                return basicToken(stream, state);
              }
              return null;
            },
            blockCommentStart: ";--",
            blockCommentEnd: "--;",
            lineComment: ";"
          };
        });
        CodeMirror5.defineMIME("text/x-asterisk", "asterisk");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/brainfuck/brainfuck.js
  var require_brainfuck = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/brainfuck/brainfuck.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var reserve = "><+-.,[]".split("");
        CodeMirror5.defineMode("brainfuck", function() {
          return {
            startState: function() {
              return {
                commentLine: false,
                left: 0,
                right: 0,
                commentLoop: false
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              if (stream.sol()) {
                state.commentLine = false;
              }
              var ch = stream.next().toString();
              if (reserve.indexOf(ch) !== -1) {
                if (state.commentLine === true) {
                  if (stream.eol()) {
                    state.commentLine = false;
                  }
                  return "comment";
                }
                if (ch === "]" || ch === "[") {
                  if (ch === "[") {
                    state.left++;
                  } else {
                    state.right++;
                  }
                  return "bracket";
                } else if (ch === "+" || ch === "-") {
                  return "keyword";
                } else if (ch === "<" || ch === ">") {
                  return "atom";
                } else if (ch === "." || ch === ",") {
                  return "def";
                }
              } else {
                state.commentLine = true;
                if (stream.eol()) {
                  state.commentLine = false;
                }
                return "comment";
              }
              if (stream.eol()) {
                state.commentLine = false;
              }
            }
          };
        });
        CodeMirror5.defineMIME("text/x-brainfuck", "brainfuck");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/clike/clike.js
  var require_clike = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/clike/clike.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function Context(indented, column, type, info, align, prev) {
          this.indented = indented;
          this.column = column;
          this.type = type;
          this.info = info;
          this.align = align;
          this.prev = prev;
        }
        function pushContext(state, col, type, info) {
          var indent = state.indented;
          if (state.context && state.context.type == "statement" && type != "statement")
            indent = state.context.indented;
          return state.context = new Context(indent, col, type, info, null, state.context);
        }
        function popContext(state) {
          var t3 = state.context.type;
          if (t3 == ")" || t3 == "]" || t3 == "}")
            state.indented = state.context.indented;
          return state.context = state.context.prev;
        }
        function typeBefore(stream, state, pos) {
          if (state.prevToken == "variable" || state.prevToken == "type")
            return true;
          if (/\S(?:[^- ]>|[*\]])\s*$|\*$/.test(stream.string.slice(0, pos)))
            return true;
          if (state.typeAtEndOfLine && stream.column() == stream.indentation())
            return true;
        }
        function isTopScope(context) {
          for (; ; ) {
            if (!context || context.type == "top")
              return true;
            if (context.type == "}" && context.prev.info != "namespace")
              return false;
            context = context.prev;
          }
        }
        CodeMirror5.defineMode("clike", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit, statementIndentUnit = parserConfig.statementIndentUnit || indentUnit, dontAlignCalls = parserConfig.dontAlignCalls, keywords2 = parserConfig.keywords || {}, types = parserConfig.types || {}, builtin = parserConfig.builtin || {}, blockKeywords = parserConfig.blockKeywords || {}, defKeywords = parserConfig.defKeywords || {}, atoms = parserConfig.atoms || {}, hooks = parserConfig.hooks || {}, multiLineStrings = parserConfig.multiLineStrings, indentStatements = parserConfig.indentStatements !== false, indentSwitch = parserConfig.indentSwitch !== false, namespaceSeparator = parserConfig.namespaceSeparator, isPunctuationChar = parserConfig.isPunctuationChar || /[\[\]{}\(\),;\:\.]/, numberStart = parserConfig.numberStart || /[\d\.]/, number2 = parserConfig.number || /^(?:0x[a-f\d]+|0b[01]+|(?:\d+\.?\d*|\.\d+)(?:e[-+]?\d+)?)(u|ll?|l|f)?/i, isOperatorChar = parserConfig.isOperatorChar || /[+\-*&%=<>!?|\/]/, isIdentifierChar = parserConfig.isIdentifierChar || /[\w\$_\xa1-\uffff]/, isReservedIdentifier = parserConfig.isReservedIdentifier || false;
          var curPunc, isDefKeyword;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (hooks[ch]) {
              var result = hooks[ch](stream, state);
              if (result !== false)
                return result;
            }
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (isPunctuationChar.test(ch)) {
              curPunc = ch;
              return null;
            }
            if (numberStart.test(ch)) {
              stream.backUp(1);
              if (stream.match(number2))
                return "number";
              stream.next();
            }
            if (ch == "/") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              while (!stream.match(/^\/[\/*]/, false) && stream.eat(isOperatorChar)) {
              }
              return "operator";
            }
            stream.eatWhile(isIdentifierChar);
            if (namespaceSeparator)
              while (stream.match(namespaceSeparator))
                stream.eatWhile(isIdentifierChar);
            var cur = stream.current();
            if (contains3(keywords2, cur)) {
              if (contains3(blockKeywords, cur))
                curPunc = "newstatement";
              if (contains3(defKeywords, cur))
                isDefKeyword = true;
              return "keyword";
            }
            if (contains3(types, cur))
              return "type";
            if (contains3(builtin, cur) || isReservedIdentifier && isReservedIdentifier(cur)) {
              if (contains3(blockKeywords, cur))
                curPunc = "newstatement";
              return "builtin";
            }
            if (contains3(atoms, cur))
              return "atom";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = null;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = null;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function maybeEOL(stream, state) {
            if (parserConfig.typeFirstDefinitions && stream.eol() && isTopScope(state.context))
              state.typeAtEndOfLine = typeBefore(stream, state, stream.pos);
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", null, false),
                indented: 0,
                startOfLine: true,
                prevToken: null
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace()) {
                maybeEOL(stream, state);
                return null;
              }
              curPunc = isDefKeyword = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment" || style == "meta")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if (curPunc == ";" || curPunc == ":" || curPunc == "," && stream.match(/^\s*(?:\/\/.*)?$/, false))
                while (state.context.type == "statement")
                  popContext(state);
              else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if (indentStatements && ((ctx.type == "}" || ctx.type == "top") && curPunc != ";" || ctx.type == "statement" && curPunc == "newstatement")) {
                pushContext(state, stream.column(), "statement", stream.current());
              }
              if (style == "variable" && (state.prevToken == "def" || parserConfig.typeFirstDefinitions && typeBefore(stream, state, stream.start) && isTopScope(state.context) && stream.match(/^\s*\(/, false)))
                style = "def";
              if (hooks.token) {
                var result = hooks.token(stream, state, style);
                if (result !== void 0)
                  style = result;
              }
              if (style == "def" && parserConfig.styleDefs === false)
                style = "variable";
              state.startOfLine = false;
              state.prevToken = isDefKeyword ? "def" : style || curPunc;
              maybeEOL(stream, state);
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase && state.tokenize != null || state.typeAtEndOfLine)
                return CodeMirror5.Pass;
              var ctx = state.context, firstChar = textAfter && textAfter.charAt(0);
              var closing = firstChar == ctx.type;
              if (ctx.type == "statement" && firstChar == "}")
                ctx = ctx.prev;
              if (parserConfig.dontIndentStatements)
                while (ctx.type == "statement" && parserConfig.dontIndentStatements.test(ctx.info))
                  ctx = ctx.prev;
              if (hooks.indent) {
                var hook = hooks.indent(state, ctx, textAfter, indentUnit);
                if (typeof hook == "number")
                  return hook;
              }
              var switchBlock = ctx.prev && ctx.prev.info == "switch";
              if (parserConfig.allmanIndentation && /[{(]/.test(firstChar)) {
                while (ctx.type != "top" && ctx.type != "}")
                  ctx = ctx.prev;
                return ctx.indented;
              }
              if (ctx.type == "statement")
                return ctx.indented + (firstChar == "{" ? 0 : statementIndentUnit);
              if (ctx.align && (!dontAlignCalls || ctx.type != ")"))
                return ctx.column + (closing ? 0 : 1);
              if (ctx.type == ")" && !closing)
                return ctx.indented + statementIndentUnit;
              return ctx.indented + (closing ? 0 : indentUnit) + (!closing && switchBlock && !/^(?:case|default)\b/.test(textAfter) ? indentUnit : 0);
            },
            electricInput: indentSwitch ? /^\s*(?:case .*?:|default:|\{\}?|\})$/ : /^\s*[{}]$/,
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            blockCommentContinue: " * ",
            lineComment: "//",
            fold: "brace"
          };
        });
        function words(str) {
          var obj = {}, words2 = str.split(" ");
          for (var i3 = 0; i3 < words2.length; ++i3)
            obj[words2[i3]] = true;
          return obj;
        }
        function contains3(words2, word) {
          if (typeof words2 === "function") {
            return words2(word);
          } else {
            return words2.propertyIsEnumerable(word);
          }
        }
        var cKeywords = "auto if break case register continue return default do sizeof static else struct switch extern typedef union for goto while enum const volatile inline restrict asm fortran";
        var cppKeywords = "alignas alignof and and_eq audit axiom bitand bitor catch class compl concept constexpr const_cast decltype delete dynamic_cast explicit export final friend import module mutable namespace new noexcept not not_eq operator or or_eq override private protected public reinterpret_cast requires static_assert static_cast template this thread_local throw try typeid typename using virtual xor xor_eq";
        var objCKeywords = "bycopy byref in inout oneway out self super atomic nonatomic retain copy readwrite readonly strong weak assign typeof nullable nonnull null_resettable _cmd @interface @implementation @end @protocol @encode @property @synthesize @dynamic @class @public @package @private @protected @required @optional @try @catch @finally @import @selector @encode @defs @synchronized @autoreleasepool @compatibility_alias @available";
        var objCBuiltins = "FOUNDATION_EXPORT FOUNDATION_EXTERN NS_INLINE NS_FORMAT_FUNCTION  NS_RETURNS_RETAINEDNS_ERROR_ENUM NS_RETURNS_NOT_RETAINED NS_RETURNS_INNER_POINTER NS_DESIGNATED_INITIALIZER NS_ENUM NS_OPTIONS NS_REQUIRES_NIL_TERMINATION NS_ASSUME_NONNULL_BEGIN NS_ASSUME_NONNULL_END NS_SWIFT_NAME NS_REFINED_FOR_SWIFT";
        var basicCTypes = words("int long char short double float unsigned signed void bool");
        var basicObjCTypes = words("SEL instancetype id Class Protocol BOOL");
        function cTypes(identifier) {
          return contains3(basicCTypes, identifier) || /.+_t$/.test(identifier);
        }
        function objCTypes(identifier) {
          return cTypes(identifier) || contains3(basicObjCTypes, identifier);
        }
        var cBlockKeywords = "case do else for if switch while struct enum union";
        var cDefKeywords = "struct enum union";
        function cppHook(stream, state) {
          if (!state.startOfLine)
            return false;
          for (var ch, next = null; ch = stream.peek(); ) {
            if (ch == "\\" && stream.match(/^.$/)) {
              next = cppHook;
              break;
            } else if (ch == "/" && stream.match(/^\/[\/\*]/, false)) {
              break;
            }
            stream.next();
          }
          state.tokenize = next;
          return "meta";
        }
        function pointerHook(_stream, state) {
          if (state.prevToken == "type")
            return "type";
          return false;
        }
        function cIsReservedIdentifier(token) {
          if (!token || token.length < 2)
            return false;
          if (token[0] != "_")
            return false;
          return token[1] == "_" || token[1] !== token[1].toLowerCase();
        }
        function cpp14Literal(stream) {
          stream.eatWhile(/[\w\.']/);
          return "number";
        }
        function cpp11StringHook(stream, state) {
          stream.backUp(1);
          if (stream.match(/(R|u8R|uR|UR|LR)/)) {
            var match = stream.match(/"([^\s\\()]{0,16})\(/);
            if (!match) {
              return false;
            }
            state.cpp11RawStringDelim = match[1];
            state.tokenize = tokenRawString;
            return tokenRawString(stream, state);
          }
          if (stream.match(/(u8|u|U|L)/)) {
            if (stream.match(/["']/, false)) {
              return "string";
            }
            return false;
          }
          stream.next();
          return false;
        }
        function cppLooksLikeConstructor(word) {
          var lastTwo = /(\w+)::~?(\w+)$/.exec(word);
          return lastTwo && lastTwo[1] == lastTwo[2];
        }
        function tokenAtString(stream, state) {
          var next;
          while ((next = stream.next()) != null) {
            if (next == '"' && !stream.eat('"')) {
              state.tokenize = null;
              break;
            }
          }
          return "string";
        }
        function tokenRawString(stream, state) {
          var delim = state.cpp11RawStringDelim.replace(/[^\w\s]/g, "\\$&");
          var match = stream.match(new RegExp(".*?\\)" + delim + '"'));
          if (match)
            state.tokenize = null;
          else
            stream.skipToEnd();
          return "string";
        }
        function def(mimes, mode2) {
          if (typeof mimes == "string")
            mimes = [mimes];
          var words2 = [];
          function add2(obj) {
            if (obj) {
              for (var prop in obj)
                if (obj.hasOwnProperty(prop))
                  words2.push(prop);
            }
          }
          add2(mode2.keywords);
          add2(mode2.types);
          add2(mode2.builtin);
          add2(mode2.atoms);
          if (words2.length) {
            mode2.helperType = mimes[0];
            CodeMirror5.registerHelper("hintWords", mimes[0], words2);
          }
          for (var i3 = 0; i3 < mimes.length; ++i3)
            CodeMirror5.defineMIME(mimes[i3], mode2);
        }
        def(["text/x-csrc", "text/x-c", "text/x-chdr"], {
          name: "clike",
          keywords: words(cKeywords),
          types: cTypes,
          blockKeywords: words(cBlockKeywords),
          defKeywords: words(cDefKeywords),
          typeFirstDefinitions: true,
          atoms: words("NULL true false"),
          isReservedIdentifier: cIsReservedIdentifier,
          hooks: {
            "#": cppHook,
            "*": pointerHook
          },
          modeProps: { fold: ["brace", "include"] }
        });
        def(["text/x-c++src", "text/x-c++hdr"], {
          name: "clike",
          keywords: words(cKeywords + " " + cppKeywords),
          types: cTypes,
          blockKeywords: words(cBlockKeywords + " class try catch"),
          defKeywords: words(cDefKeywords + " class namespace"),
          typeFirstDefinitions: true,
          atoms: words("true false NULL nullptr"),
          dontIndentStatements: /^template$/,
          isIdentifierChar: /[\w\$_~\xa1-\uffff]/,
          isReservedIdentifier: cIsReservedIdentifier,
          hooks: {
            "#": cppHook,
            "*": pointerHook,
            "u": cpp11StringHook,
            "U": cpp11StringHook,
            "L": cpp11StringHook,
            "R": cpp11StringHook,
            "0": cpp14Literal,
            "1": cpp14Literal,
            "2": cpp14Literal,
            "3": cpp14Literal,
            "4": cpp14Literal,
            "5": cpp14Literal,
            "6": cpp14Literal,
            "7": cpp14Literal,
            "8": cpp14Literal,
            "9": cpp14Literal,
            token: function(stream, state, style) {
              if (style == "variable" && stream.peek() == "(" && (state.prevToken == ";" || state.prevToken == null || state.prevToken == "}") && cppLooksLikeConstructor(stream.current()))
                return "def";
            }
          },
          namespaceSeparator: "::",
          modeProps: { fold: ["brace", "include"] }
        });
        def("text/x-java", {
          name: "clike",
          keywords: words("abstract assert break case catch class const continue default do else enum extends final finally for goto if implements import instanceof interface native new package private protected public return static strictfp super switch synchronized this throw throws transient try volatile while @interface"),
          types: words("byte short int long float double boolean char void Boolean Byte Character Double Float Integer Long Number Object Short String StringBuffer StringBuilder Void"),
          blockKeywords: words("catch class do else finally for if switch try while"),
          defKeywords: words("class interface enum @interface"),
          typeFirstDefinitions: true,
          atoms: words("true false null"),
          number: /^(?:0x[a-f\d_]+|0b[01_]+|(?:[\d_]+\.?\d*|\.\d+)(?:e[-+]?[\d_]+)?)(u|ll?|l|f)?/i,
          hooks: {
            "@": function(stream) {
              if (stream.match("interface", false))
                return false;
              stream.eatWhile(/[\w\$_]/);
              return "meta";
            }
          },
          modeProps: { fold: ["brace", "import"] }
        });
        def("text/x-csharp", {
          name: "clike",
          keywords: words("abstract as async await base break case catch checked class const continue default delegate do else enum event explicit extern finally fixed for foreach goto if implicit in interface internal is lock namespace new operator out override params private protected public readonly ref return sealed sizeof stackalloc static struct switch this throw try typeof unchecked unsafe using virtual void volatile while add alias ascending descending dynamic from get global group into join let orderby partial remove select set value var yield"),
          types: words("Action Boolean Byte Char DateTime DateTimeOffset Decimal Double Func Guid Int16 Int32 Int64 Object SByte Single String Task TimeSpan UInt16 UInt32 UInt64 bool byte char decimal double short int long object sbyte float string ushort uint ulong"),
          blockKeywords: words("catch class do else finally for foreach if struct switch try while"),
          defKeywords: words("class interface namespace struct var"),
          typeFirstDefinitions: true,
          atoms: words("true false null"),
          hooks: {
            "@": function(stream, state) {
              if (stream.eat('"')) {
                state.tokenize = tokenAtString;
                return tokenAtString(stream, state);
              }
              stream.eatWhile(/[\w\$_]/);
              return "meta";
            }
          }
        });
        function tokenTripleString(stream, state) {
          var escaped = false;
          while (!stream.eol()) {
            if (!escaped && stream.match('"""')) {
              state.tokenize = null;
              break;
            }
            escaped = stream.next() == "\\" && !escaped;
          }
          return "string";
        }
        function tokenNestedComment(depth) {
          return function(stream, state) {
            var ch;
            while (ch = stream.next()) {
              if (ch == "*" && stream.eat("/")) {
                if (depth == 1) {
                  state.tokenize = null;
                  break;
                } else {
                  state.tokenize = tokenNestedComment(depth - 1);
                  return state.tokenize(stream, state);
                }
              } else if (ch == "/" && stream.eat("*")) {
                state.tokenize = tokenNestedComment(depth + 1);
                return state.tokenize(stream, state);
              }
            }
            return "comment";
          };
        }
        def("text/x-scala", {
          name: "clike",
          keywords: words("abstract case catch class def do else extends final finally for forSome if implicit import lazy match new null object override package private protected return sealed super this throw trait try type val var while with yield _ assert assume require print println printf readLine readBoolean readByte readShort readChar readInt readLong readFloat readDouble"),
          types: words("AnyVal App Application Array BufferedIterator BigDecimal BigInt Char Console Either Enumeration Equiv Error Exception Fractional Function IndexedSeq Int Integral Iterable Iterator List Map Numeric Nil NotNull Option Ordered Ordering PartialFunction PartialOrdering Product Proxy Range Responder Seq Serializable Set Specializable Stream StringBuilder StringContext Symbol Throwable Traversable TraversableOnce Tuple Unit Vector Boolean Byte Character CharSequence Class ClassLoader Cloneable Comparable Compiler Double Exception Float Integer Long Math Number Object Package Pair Process Runtime Runnable SecurityManager Short StackTraceElement StrictMath String StringBuffer System Thread ThreadGroup ThreadLocal Throwable Triple Void"),
          multiLineStrings: true,
          blockKeywords: words("catch class enum do else finally for forSome if match switch try while"),
          defKeywords: words("class enum def object package trait type val var"),
          atoms: words("true false null"),
          indentStatements: false,
          indentSwitch: false,
          isOperatorChar: /[+\-*&%=<>!?|\/#:@]/,
          hooks: {
            "@": function(stream) {
              stream.eatWhile(/[\w\$_]/);
              return "meta";
            },
            '"': function(stream, state) {
              if (!stream.match('""'))
                return false;
              state.tokenize = tokenTripleString;
              return state.tokenize(stream, state);
            },
            "'": function(stream) {
              stream.eatWhile(/[\w\$_\xa1-\uffff]/);
              return "atom";
            },
            "=": function(stream, state) {
              var cx = state.context;
              if (cx.type == "}" && cx.align && stream.eat(">")) {
                state.context = new Context(cx.indented, cx.column, cx.type, cx.info, null, cx.prev);
                return "operator";
              } else {
                return false;
              }
            },
            "/": function(stream, state) {
              if (!stream.eat("*"))
                return false;
              state.tokenize = tokenNestedComment(1);
              return state.tokenize(stream, state);
            }
          },
          modeProps: { closeBrackets: { pairs: '()[]{}""', triples: '"' } }
        });
        function tokenKotlinString(tripleString) {
          return function(stream, state) {
            var escaped = false, next, end = false;
            while (!stream.eol()) {
              if (!tripleString && !escaped && stream.match('"')) {
                end = true;
                break;
              }
              if (tripleString && stream.match('"""')) {
                end = true;
                break;
              }
              next = stream.next();
              if (!escaped && next == "$" && stream.match("{"))
                stream.skipTo("}");
              escaped = !escaped && next == "\\" && !tripleString;
            }
            if (end || !tripleString)
              state.tokenize = null;
            return "string";
          };
        }
        def("text/x-kotlin", {
          name: "clike",
          keywords: words("package as typealias class interface this super val operator var fun for is in This throw return annotation break continue object if else while do try when !in !is as? file import where by get set abstract enum open inner override private public internal protected catch finally out final vararg reified dynamic companion constructor init sealed field property receiver param sparam lateinit data inline noinline tailrec external annotation crossinline const operator infix suspend actual expect setparam"),
          types: words("Boolean Byte Character CharSequence Class ClassLoader Cloneable Comparable Compiler Double Exception Float Integer Long Math Number Object Package Pair Process Runtime Runnable SecurityManager Short StackTraceElement StrictMath String StringBuffer System Thread ThreadGroup ThreadLocal Throwable Triple Void Annotation Any BooleanArray ByteArray Char CharArray DeprecationLevel DoubleArray Enum FloatArray Function Int IntArray Lazy LazyThreadSafetyMode LongArray Nothing ShortArray Unit"),
          intendSwitch: false,
          indentStatements: false,
          multiLineStrings: true,
          number: /^(?:0x[a-f\d_]+|0b[01_]+|(?:[\d_]+(\.\d+)?|\.\d+)(?:e[-+]?[\d_]+)?)(u|ll?|l|f)?/i,
          blockKeywords: words("catch class do else finally for if where try while enum"),
          defKeywords: words("class val var object interface fun"),
          atoms: words("true false null this"),
          hooks: {
            "@": function(stream) {
              stream.eatWhile(/[\w\$_]/);
              return "meta";
            },
            "*": function(_stream, state) {
              return state.prevToken == "." ? "variable" : "operator";
            },
            '"': function(stream, state) {
              state.tokenize = tokenKotlinString(stream.match('""'));
              return state.tokenize(stream, state);
            },
            "/": function(stream, state) {
              if (!stream.eat("*"))
                return false;
              state.tokenize = tokenNestedComment(1);
              return state.tokenize(stream, state);
            },
            indent: function(state, ctx, textAfter, indentUnit) {
              var firstChar = textAfter && textAfter.charAt(0);
              if ((state.prevToken == "}" || state.prevToken == ")") && textAfter == "")
                return state.indented;
              if (state.prevToken == "operator" && textAfter != "}" && state.context.type != "}" || state.prevToken == "variable" && firstChar == "." || (state.prevToken == "}" || state.prevToken == ")") && firstChar == ".")
                return indentUnit * 2 + ctx.indented;
              if (ctx.align && ctx.type == "}")
                return ctx.indented + (state.context.type == (textAfter || "").charAt(0) ? 0 : indentUnit);
            }
          },
          modeProps: { closeBrackets: { triples: '"' } }
        });
        def(["x-shader/x-vertex", "x-shader/x-fragment"], {
          name: "clike",
          keywords: words("sampler1D sampler2D sampler3D samplerCube sampler1DShadow sampler2DShadow const attribute uniform varying break continue discard return for while do if else struct in out inout"),
          types: words("float int bool void vec2 vec3 vec4 ivec2 ivec3 ivec4 bvec2 bvec3 bvec4 mat2 mat3 mat4"),
          blockKeywords: words("for while do if else struct"),
          builtin: words("radians degrees sin cos tan asin acos atan pow exp log exp2 sqrt inversesqrt abs sign floor ceil fract mod min max clamp mix step smoothstep length distance dot cross normalize ftransform faceforward reflect refract matrixCompMult lessThan lessThanEqual greaterThan greaterThanEqual equal notEqual any all not texture1D texture1DProj texture1DLod texture1DProjLod texture2D texture2DProj texture2DLod texture2DProjLod texture3D texture3DProj texture3DLod texture3DProjLod textureCube textureCubeLod shadow1D shadow2D shadow1DProj shadow2DProj shadow1DLod shadow2DLod shadow1DProjLod shadow2DProjLod dFdx dFdy fwidth noise1 noise2 noise3 noise4"),
          atoms: words("true false gl_FragColor gl_SecondaryColor gl_Normal gl_Vertex gl_MultiTexCoord0 gl_MultiTexCoord1 gl_MultiTexCoord2 gl_MultiTexCoord3 gl_MultiTexCoord4 gl_MultiTexCoord5 gl_MultiTexCoord6 gl_MultiTexCoord7 gl_FogCoord gl_PointCoord gl_Position gl_PointSize gl_ClipVertex gl_FrontColor gl_BackColor gl_FrontSecondaryColor gl_BackSecondaryColor gl_TexCoord gl_FogFragCoord gl_FragCoord gl_FrontFacing gl_FragData gl_FragDepth gl_ModelViewMatrix gl_ProjectionMatrix gl_ModelViewProjectionMatrix gl_TextureMatrix gl_NormalMatrix gl_ModelViewMatrixInverse gl_ProjectionMatrixInverse gl_ModelViewProjectionMatrixInverse gl_TexureMatrixTranspose gl_ModelViewMatrixInverseTranspose gl_ProjectionMatrixInverseTranspose gl_ModelViewProjectionMatrixInverseTranspose gl_TextureMatrixInverseTranspose gl_NormalScale gl_DepthRange gl_ClipPlane gl_Point gl_FrontMaterial gl_BackMaterial gl_LightSource gl_LightModel gl_FrontLightModelProduct gl_BackLightModelProduct gl_TextureColor gl_EyePlaneS gl_EyePlaneT gl_EyePlaneR gl_EyePlaneQ gl_FogParameters gl_MaxLights gl_MaxClipPlanes gl_MaxTextureUnits gl_MaxTextureCoords gl_MaxVertexAttribs gl_MaxVertexUniformComponents gl_MaxVaryingFloats gl_MaxVertexTextureImageUnits gl_MaxTextureImageUnits gl_MaxFragmentUniformComponents gl_MaxCombineTextureImageUnits gl_MaxDrawBuffers"),
          indentSwitch: false,
          hooks: { "#": cppHook },
          modeProps: { fold: ["brace", "include"] }
        });
        def("text/x-nesc", {
          name: "clike",
          keywords: words(cKeywords + " as atomic async call command component components configuration event generic implementation includes interface module new norace nx_struct nx_union post provides signal task uses abstract extends"),
          types: cTypes,
          blockKeywords: words(cBlockKeywords),
          atoms: words("null true false"),
          hooks: { "#": cppHook },
          modeProps: { fold: ["brace", "include"] }
        });
        def("text/x-objectivec", {
          name: "clike",
          keywords: words(cKeywords + " " + objCKeywords),
          types: objCTypes,
          builtin: words(objCBuiltins),
          blockKeywords: words(cBlockKeywords + " @synthesize @try @catch @finally @autoreleasepool @synchronized"),
          defKeywords: words(cDefKeywords + " @interface @implementation @protocol @class"),
          dontIndentStatements: /^@.*$/,
          typeFirstDefinitions: true,
          atoms: words("YES NO NULL Nil nil true false nullptr"),
          isReservedIdentifier: cIsReservedIdentifier,
          hooks: {
            "#": cppHook,
            "*": pointerHook
          },
          modeProps: { fold: ["brace", "include"] }
        });
        def("text/x-objectivec++", {
          name: "clike",
          keywords: words(cKeywords + " " + objCKeywords + " " + cppKeywords),
          types: objCTypes,
          builtin: words(objCBuiltins),
          blockKeywords: words(cBlockKeywords + " @synthesize @try @catch @finally @autoreleasepool @synchronized class try catch"),
          defKeywords: words(cDefKeywords + " @interface @implementation @protocol @class class namespace"),
          dontIndentStatements: /^@.*$|^template$/,
          typeFirstDefinitions: true,
          atoms: words("YES NO NULL Nil nil true false nullptr"),
          isReservedIdentifier: cIsReservedIdentifier,
          hooks: {
            "#": cppHook,
            "*": pointerHook,
            "u": cpp11StringHook,
            "U": cpp11StringHook,
            "L": cpp11StringHook,
            "R": cpp11StringHook,
            "0": cpp14Literal,
            "1": cpp14Literal,
            "2": cpp14Literal,
            "3": cpp14Literal,
            "4": cpp14Literal,
            "5": cpp14Literal,
            "6": cpp14Literal,
            "7": cpp14Literal,
            "8": cpp14Literal,
            "9": cpp14Literal,
            token: function(stream, state, style) {
              if (style == "variable" && stream.peek() == "(" && (state.prevToken == ";" || state.prevToken == null || state.prevToken == "}") && cppLooksLikeConstructor(stream.current()))
                return "def";
            }
          },
          namespaceSeparator: "::",
          modeProps: { fold: ["brace", "include"] }
        });
        def("text/x-squirrel", {
          name: "clike",
          keywords: words("base break clone continue const default delete enum extends function in class foreach local resume return this throw typeof yield constructor instanceof static"),
          types: cTypes,
          blockKeywords: words("case catch class else for foreach if switch try while"),
          defKeywords: words("function local class"),
          typeFirstDefinitions: true,
          atoms: words("true false null"),
          hooks: { "#": cppHook },
          modeProps: { fold: ["brace", "include"] }
        });
        var stringTokenizer = null;
        function tokenCeylonString(type) {
          return function(stream, state) {
            var escaped = false, next, end = false;
            while (!stream.eol()) {
              if (!escaped && stream.match('"') && (type == "single" || stream.match('""'))) {
                end = true;
                break;
              }
              if (!escaped && stream.match("``")) {
                stringTokenizer = tokenCeylonString(type);
                end = true;
                break;
              }
              next = stream.next();
              escaped = type == "single" && !escaped && next == "\\";
            }
            if (end)
              state.tokenize = null;
            return "string";
          };
        }
        def("text/x-ceylon", {
          name: "clike",
          keywords: words("abstracts alias assembly assert assign break case catch class continue dynamic else exists extends finally for function given if import in interface is let module new nonempty object of out outer package return satisfies super switch then this throw try value void while"),
          types: function(word) {
            var first = word.charAt(0);
            return first === first.toUpperCase() && first !== first.toLowerCase();
          },
          blockKeywords: words("case catch class dynamic else finally for function if interface module new object switch try while"),
          defKeywords: words("class dynamic function interface module object package value"),
          builtin: words("abstract actual aliased annotation by default deprecated doc final formal late license native optional sealed see serializable shared suppressWarnings tagged throws variable"),
          isPunctuationChar: /[\[\]{}\(\),;\:\.`]/,
          isOperatorChar: /[+\-*&%=<>!?|^~:\/]/,
          numberStart: /[\d#$]/,
          number: /^(?:#[\da-fA-F_]+|\$[01_]+|[\d_]+[kMGTPmunpf]?|[\d_]+\.[\d_]+(?:[eE][-+]?\d+|[kMGTPmunpf]|)|)/i,
          multiLineStrings: true,
          typeFirstDefinitions: true,
          atoms: words("true false null larger smaller equal empty finished"),
          indentSwitch: false,
          styleDefs: false,
          hooks: {
            "@": function(stream) {
              stream.eatWhile(/[\w\$_]/);
              return "meta";
            },
            '"': function(stream, state) {
              state.tokenize = tokenCeylonString(stream.match('""') ? "triple" : "single");
              return state.tokenize(stream, state);
            },
            "`": function(stream, state) {
              if (!stringTokenizer || !stream.match("`"))
                return false;
              state.tokenize = stringTokenizer;
              stringTokenizer = null;
              return state.tokenize(stream, state);
            },
            "'": function(stream) {
              stream.eatWhile(/[\w\$_\xa1-\uffff]/);
              return "atom";
            },
            token: function(_stream, state, style) {
              if ((style == "variable" || style == "type") && state.prevToken == ".") {
                return "variable-2";
              }
            }
          },
          modeProps: {
            fold: ["brace", "import"],
            closeBrackets: { triples: '"' }
          }
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/clojure/clojure.js
  var require_clojure = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/clojure/clojure.js"(exports, module) {
      (function(mod2) {
        if (typeof exports === "object" && typeof module === "object")
          mod2(require_codemirror());
        else if (typeof define === "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("clojure", function(options) {
          var atoms = ["false", "nil", "true"];
          var specialForms = [
            ".",
            "catch",
            "def",
            "do",
            "if",
            "monitor-enter",
            "monitor-exit",
            "new",
            "quote",
            "recur",
            "set!",
            "throw",
            "try",
            "var"
          ];
          var coreSymbols = [
            "*",
            "*'",
            "*1",
            "*2",
            "*3",
            "*agent*",
            "*allow-unresolved-vars*",
            "*assert*",
            "*clojure-version*",
            "*command-line-args*",
            "*compile-files*",
            "*compile-path*",
            "*compiler-options*",
            "*data-readers*",
            "*default-data-reader-fn*",
            "*e",
            "*err*",
            "*file*",
            "*flush-on-newline*",
            "*fn-loader*",
            "*in*",
            "*math-context*",
            "*ns*",
            "*out*",
            "*print-dup*",
            "*print-length*",
            "*print-level*",
            "*print-meta*",
            "*print-namespace-maps*",
            "*print-readably*",
            "*read-eval*",
            "*reader-resolver*",
            "*source-path*",
            "*suppress-read*",
            "*unchecked-math*",
            "*use-context-classloader*",
            "*verbose-defrecords*",
            "*warn-on-reflection*",
            "+",
            "+'",
            "-",
            "-'",
            "->",
            "->>",
            "->ArrayChunk",
            "->Eduction",
            "->Vec",
            "->VecNode",
            "->VecSeq",
            "-cache-protocol-fn",
            "-reset-methods",
            "..",
            "/",
            "<",
            "<=",
            "=",
            "==",
            ">",
            ">=",
            "EMPTY-NODE",
            "Inst",
            "StackTraceElement->vec",
            "Throwable->map",
            "accessor",
            "aclone",
            "add-classpath",
            "add-watch",
            "agent",
            "agent-error",
            "agent-errors",
            "aget",
            "alength",
            "alias",
            "all-ns",
            "alter",
            "alter-meta!",
            "alter-var-root",
            "amap",
            "ancestors",
            "and",
            "any?",
            "apply",
            "areduce",
            "array-map",
            "as->",
            "aset",
            "aset-boolean",
            "aset-byte",
            "aset-char",
            "aset-double",
            "aset-float",
            "aset-int",
            "aset-long",
            "aset-short",
            "assert",
            "assoc",
            "assoc!",
            "assoc-in",
            "associative?",
            "atom",
            "await",
            "await-for",
            "await1",
            "bases",
            "bean",
            "bigdec",
            "bigint",
            "biginteger",
            "binding",
            "bit-and",
            "bit-and-not",
            "bit-clear",
            "bit-flip",
            "bit-not",
            "bit-or",
            "bit-set",
            "bit-shift-left",
            "bit-shift-right",
            "bit-test",
            "bit-xor",
            "boolean",
            "boolean-array",
            "boolean?",
            "booleans",
            "bound-fn",
            "bound-fn*",
            "bound?",
            "bounded-count",
            "butlast",
            "byte",
            "byte-array",
            "bytes",
            "bytes?",
            "case",
            "cast",
            "cat",
            "char",
            "char-array",
            "char-escape-string",
            "char-name-string",
            "char?",
            "chars",
            "chunk",
            "chunk-append",
            "chunk-buffer",
            "chunk-cons",
            "chunk-first",
            "chunk-next",
            "chunk-rest",
            "chunked-seq?",
            "class",
            "class?",
            "clear-agent-errors",
            "clojure-version",
            "coll?",
            "comment",
            "commute",
            "comp",
            "comparator",
            "compare",
            "compare-and-set!",
            "compile",
            "complement",
            "completing",
            "concat",
            "cond",
            "cond->",
            "cond->>",
            "condp",
            "conj",
            "conj!",
            "cons",
            "constantly",
            "construct-proxy",
            "contains?",
            "count",
            "counted?",
            "create-ns",
            "create-struct",
            "cycle",
            "dec",
            "dec'",
            "decimal?",
            "declare",
            "dedupe",
            "default-data-readers",
            "definline",
            "definterface",
            "defmacro",
            "defmethod",
            "defmulti",
            "defn",
            "defn-",
            "defonce",
            "defprotocol",
            "defrecord",
            "defstruct",
            "deftype",
            "delay",
            "delay?",
            "deliver",
            "denominator",
            "deref",
            "derive",
            "descendants",
            "destructure",
            "disj",
            "disj!",
            "dissoc",
            "dissoc!",
            "distinct",
            "distinct?",
            "doall",
            "dorun",
            "doseq",
            "dosync",
            "dotimes",
            "doto",
            "double",
            "double-array",
            "double?",
            "doubles",
            "drop",
            "drop-last",
            "drop-while",
            "eduction",
            "empty",
            "empty?",
            "ensure",
            "ensure-reduced",
            "enumeration-seq",
            "error-handler",
            "error-mode",
            "eval",
            "even?",
            "every-pred",
            "every?",
            "ex-data",
            "ex-info",
            "extend",
            "extend-protocol",
            "extend-type",
            "extenders",
            "extends?",
            "false?",
            "ffirst",
            "file-seq",
            "filter",
            "filterv",
            "find",
            "find-keyword",
            "find-ns",
            "find-protocol-impl",
            "find-protocol-method",
            "find-var",
            "first",
            "flatten",
            "float",
            "float-array",
            "float?",
            "floats",
            "flush",
            "fn",
            "fn?",
            "fnext",
            "fnil",
            "for",
            "force",
            "format",
            "frequencies",
            "future",
            "future-call",
            "future-cancel",
            "future-cancelled?",
            "future-done?",
            "future?",
            "gen-class",
            "gen-interface",
            "gensym",
            "get",
            "get-in",
            "get-method",
            "get-proxy-class",
            "get-thread-bindings",
            "get-validator",
            "group-by",
            "halt-when",
            "hash",
            "hash-combine",
            "hash-map",
            "hash-ordered-coll",
            "hash-set",
            "hash-unordered-coll",
            "ident?",
            "identical?",
            "identity",
            "if-let",
            "if-not",
            "if-some",
            "ifn?",
            "import",
            "in-ns",
            "inc",
            "inc'",
            "indexed?",
            "init-proxy",
            "inst-ms",
            "inst-ms*",
            "inst?",
            "instance?",
            "int",
            "int-array",
            "int?",
            "integer?",
            "interleave",
            "intern",
            "interpose",
            "into",
            "into-array",
            "ints",
            "io!",
            "isa?",
            "iterate",
            "iterator-seq",
            "juxt",
            "keep",
            "keep-indexed",
            "key",
            "keys",
            "keyword",
            "keyword?",
            "last",
            "lazy-cat",
            "lazy-seq",
            "let",
            "letfn",
            "line-seq",
            "list",
            "list*",
            "list?",
            "load",
            "load-file",
            "load-reader",
            "load-string",
            "loaded-libs",
            "locking",
            "long",
            "long-array",
            "longs",
            "loop",
            "macroexpand",
            "macroexpand-1",
            "make-array",
            "make-hierarchy",
            "map",
            "map-entry?",
            "map-indexed",
            "map?",
            "mapcat",
            "mapv",
            "max",
            "max-key",
            "memfn",
            "memoize",
            "merge",
            "merge-with",
            "meta",
            "method-sig",
            "methods",
            "min",
            "min-key",
            "mix-collection-hash",
            "mod",
            "munge",
            "name",
            "namespace",
            "namespace-munge",
            "nat-int?",
            "neg-int?",
            "neg?",
            "newline",
            "next",
            "nfirst",
            "nil?",
            "nnext",
            "not",
            "not-any?",
            "not-empty",
            "not-every?",
            "not=",
            "ns",
            "ns-aliases",
            "ns-imports",
            "ns-interns",
            "ns-map",
            "ns-name",
            "ns-publics",
            "ns-refers",
            "ns-resolve",
            "ns-unalias",
            "ns-unmap",
            "nth",
            "nthnext",
            "nthrest",
            "num",
            "number?",
            "numerator",
            "object-array",
            "odd?",
            "or",
            "parents",
            "partial",
            "partition",
            "partition-all",
            "partition-by",
            "pcalls",
            "peek",
            "persistent!",
            "pmap",
            "pop",
            "pop!",
            "pop-thread-bindings",
            "pos-int?",
            "pos?",
            "pr",
            "pr-str",
            "prefer-method",
            "prefers",
            "primitives-classnames",
            "print",
            "print-ctor",
            "print-dup",
            "print-method",
            "print-simple",
            "print-str",
            "printf",
            "println",
            "println-str",
            "prn",
            "prn-str",
            "promise",
            "proxy",
            "proxy-call-with-super",
            "proxy-mappings",
            "proxy-name",
            "proxy-super",
            "push-thread-bindings",
            "pvalues",
            "qualified-ident?",
            "qualified-keyword?",
            "qualified-symbol?",
            "quot",
            "rand",
            "rand-int",
            "rand-nth",
            "random-sample",
            "range",
            "ratio?",
            "rational?",
            "rationalize",
            "re-find",
            "re-groups",
            "re-matcher",
            "re-matches",
            "re-pattern",
            "re-seq",
            "read",
            "read-line",
            "read-string",
            "reader-conditional",
            "reader-conditional?",
            "realized?",
            "record?",
            "reduce",
            "reduce-kv",
            "reduced",
            "reduced?",
            "reductions",
            "ref",
            "ref-history-count",
            "ref-max-history",
            "ref-min-history",
            "ref-set",
            "refer",
            "refer-clojure",
            "reify",
            "release-pending-sends",
            "rem",
            "remove",
            "remove-all-methods",
            "remove-method",
            "remove-ns",
            "remove-watch",
            "repeat",
            "repeatedly",
            "replace",
            "replicate",
            "require",
            "reset!",
            "reset-meta!",
            "reset-vals!",
            "resolve",
            "rest",
            "restart-agent",
            "resultset-seq",
            "reverse",
            "reversible?",
            "rseq",
            "rsubseq",
            "run!",
            "satisfies?",
            "second",
            "select-keys",
            "send",
            "send-off",
            "send-via",
            "seq",
            "seq?",
            "seqable?",
            "seque",
            "sequence",
            "sequential?",
            "set",
            "set-agent-send-executor!",
            "set-agent-send-off-executor!",
            "set-error-handler!",
            "set-error-mode!",
            "set-validator!",
            "set?",
            "short",
            "short-array",
            "shorts",
            "shuffle",
            "shutdown-agents",
            "simple-ident?",
            "simple-keyword?",
            "simple-symbol?",
            "slurp",
            "some",
            "some->",
            "some->>",
            "some-fn",
            "some?",
            "sort",
            "sort-by",
            "sorted-map",
            "sorted-map-by",
            "sorted-set",
            "sorted-set-by",
            "sorted?",
            "special-symbol?",
            "spit",
            "split-at",
            "split-with",
            "str",
            "string?",
            "struct",
            "struct-map",
            "subs",
            "subseq",
            "subvec",
            "supers",
            "swap!",
            "swap-vals!",
            "symbol",
            "symbol?",
            "sync",
            "tagged-literal",
            "tagged-literal?",
            "take",
            "take-last",
            "take-nth",
            "take-while",
            "test",
            "the-ns",
            "thread-bound?",
            "time",
            "to-array",
            "to-array-2d",
            "trampoline",
            "transduce",
            "transient",
            "tree-seq",
            "true?",
            "type",
            "unchecked-add",
            "unchecked-add-int",
            "unchecked-byte",
            "unchecked-char",
            "unchecked-dec",
            "unchecked-dec-int",
            "unchecked-divide-int",
            "unchecked-double",
            "unchecked-float",
            "unchecked-inc",
            "unchecked-inc-int",
            "unchecked-int",
            "unchecked-long",
            "unchecked-multiply",
            "unchecked-multiply-int",
            "unchecked-negate",
            "unchecked-negate-int",
            "unchecked-remainder-int",
            "unchecked-short",
            "unchecked-subtract",
            "unchecked-subtract-int",
            "underive",
            "unquote",
            "unquote-splicing",
            "unreduced",
            "unsigned-bit-shift-right",
            "update",
            "update-in",
            "update-proxy",
            "uri?",
            "use",
            "uuid?",
            "val",
            "vals",
            "var-get",
            "var-set",
            "var?",
            "vary-meta",
            "vec",
            "vector",
            "vector-of",
            "vector?",
            "volatile!",
            "volatile?",
            "vreset!",
            "vswap!",
            "when",
            "when-first",
            "when-let",
            "when-not",
            "when-some",
            "while",
            "with-bindings",
            "with-bindings*",
            "with-in-str",
            "with-loading-context",
            "with-local-vars",
            "with-meta",
            "with-open",
            "with-out-str",
            "with-precision",
            "with-redefs",
            "with-redefs-fn",
            "xml-seq",
            "zero?",
            "zipmap"
          ];
          var haveBodyParameter = [
            "->",
            "->>",
            "as->",
            "binding",
            "bound-fn",
            "case",
            "catch",
            "comment",
            "cond",
            "cond->",
            "cond->>",
            "condp",
            "def",
            "definterface",
            "defmethod",
            "defn",
            "defmacro",
            "defprotocol",
            "defrecord",
            "defstruct",
            "deftype",
            "do",
            "doseq",
            "dotimes",
            "doto",
            "extend",
            "extend-protocol",
            "extend-type",
            "fn",
            "for",
            "future",
            "if",
            "if-let",
            "if-not",
            "if-some",
            "let",
            "letfn",
            "locking",
            "loop",
            "ns",
            "proxy",
            "reify",
            "struct-map",
            "some->",
            "some->>",
            "try",
            "when",
            "when-first",
            "when-let",
            "when-not",
            "when-some",
            "while",
            "with-bindings",
            "with-bindings*",
            "with-in-str",
            "with-loading-context",
            "with-local-vars",
            "with-meta",
            "with-open",
            "with-out-str",
            "with-precision",
            "with-redefs",
            "with-redefs-fn"
          ];
          CodeMirror5.registerHelper("hintWords", "clojure", [].concat(atoms, specialForms, coreSymbols));
          var atom = createLookupMap(atoms);
          var specialForm = createLookupMap(specialForms);
          var coreSymbol = createLookupMap(coreSymbols);
          var hasBodyParameter = createLookupMap(haveBodyParameter);
          var delimiter = /^(?:[\\\[\]\s"(),;@^`{}~]|$)/;
          var numberLiteral = /^(?:[+\-]?\d+(?:(?:N|(?:[eE][+\-]?\d+))|(?:\.?\d*(?:M|(?:[eE][+\-]?\d+))?)|\/\d+|[xX][0-9a-fA-F]+|r[0-9a-zA-Z]+)?(?=[\\\[\]\s"#'(),;@^`{}~]|$))/;
          var characterLiteral = /^(?:\\(?:backspace|formfeed|newline|return|space|tab|o[0-7]{3}|u[0-9A-Fa-f]{4}|x[0-9A-Fa-f]{4}|.)?(?=[\\\[\]\s"(),;@^`{}~]|$))/;
          var qualifiedSymbol = /^(?:(?:[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*(?:\.[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*)*\/)?(?:\/|[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*)*(?=[\\\[\]\s"(),;@^`{}~]|$))/;
          function base(stream, state) {
            if (stream.eatSpace() || stream.eat(","))
              return ["space", null];
            if (stream.match(numberLiteral))
              return [null, "number"];
            if (stream.match(characterLiteral))
              return [null, "string-2"];
            if (stream.eat(/^"/))
              return (state.tokenize = inString)(stream, state);
            if (stream.eat(/^[(\[{]/))
              return ["open", "bracket"];
            if (stream.eat(/^[)\]}]/))
              return ["close", "bracket"];
            if (stream.eat(/^;/)) {
              stream.skipToEnd();
              return ["space", "comment"];
            }
            if (stream.eat(/^[#'@^`~]/))
              return [null, "meta"];
            var matches = stream.match(qualifiedSymbol);
            var symbol = matches && matches[0];
            if (!symbol) {
              stream.next();
              stream.eatWhile(function(c3) {
                return !is(c3, delimiter);
              });
              return [null, "error"];
            }
            if (symbol === "comment" && state.lastToken === "(")
              return (state.tokenize = inComment)(stream, state);
            if (is(symbol, atom) || symbol.charAt(0) === ":")
              return ["symbol", "atom"];
            if (is(symbol, specialForm) || is(symbol, coreSymbol))
              return ["symbol", "keyword"];
            if (state.lastToken === "(")
              return ["symbol", "builtin"];
            return ["symbol", "variable"];
          }
          function inString(stream, state) {
            var escaped = false, next;
            while (next = stream.next()) {
              if (next === '"' && !escaped) {
                state.tokenize = base;
                break;
              }
              escaped = !escaped && next === "\\";
            }
            return [null, "string"];
          }
          function inComment(stream, state) {
            var parenthesisCount = 1;
            var next;
            while (next = stream.next()) {
              if (next === ")")
                parenthesisCount--;
              if (next === "(")
                parenthesisCount++;
              if (parenthesisCount === 0) {
                stream.backUp(1);
                state.tokenize = base;
                break;
              }
            }
            return ["space", "comment"];
          }
          function createLookupMap(words) {
            var obj = {};
            for (var i3 = 0; i3 < words.length; ++i3)
              obj[words[i3]] = true;
            return obj;
          }
          function is(value, test) {
            if (test instanceof RegExp)
              return test.test(value);
            if (test instanceof Object)
              return test.propertyIsEnumerable(value);
          }
          return {
            startState: function() {
              return {
                ctx: { prev: null, start: 0, indentTo: 0 },
                lastToken: null,
                tokenize: base
              };
            },
            token: function(stream, state) {
              if (stream.sol() && typeof state.ctx.indentTo !== "number")
                state.ctx.indentTo = state.ctx.start + 1;
              var typeStylePair = state.tokenize(stream, state);
              var type = typeStylePair[0];
              var style = typeStylePair[1];
              var current = stream.current();
              if (type !== "space") {
                if (state.lastToken === "(" && state.ctx.indentTo === null) {
                  if (type === "symbol" && is(current, hasBodyParameter))
                    state.ctx.indentTo = state.ctx.start + options.indentUnit;
                  else
                    state.ctx.indentTo = "next";
                } else if (state.ctx.indentTo === "next") {
                  state.ctx.indentTo = stream.column();
                }
                state.lastToken = current;
              }
              if (type === "open")
                state.ctx = { prev: state.ctx, start: stream.column(), indentTo: null };
              else if (type === "close")
                state.ctx = state.ctx.prev || state.ctx;
              return style;
            },
            indent: function(state) {
              var i3 = state.ctx.indentTo;
              return typeof i3 === "number" ? i3 : state.ctx.start + 1;
            },
            closeBrackets: { pairs: '()[]{}""' },
            lineComment: ";;"
          };
        });
        CodeMirror5.defineMIME("text/x-clojure", "clojure");
        CodeMirror5.defineMIME("text/x-clojurescript", "clojure");
        CodeMirror5.defineMIME("application/edn", "clojure");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/cmake/cmake.js
  var require_cmake = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/cmake/cmake.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("cmake", function() {
          var variable_regex = /({)?[a-zA-Z0-9_]+(})?/;
          function tokenString(stream, state) {
            var current, prev, found_var = false;
            while (!stream.eol() && (current = stream.next()) != state.pending) {
              if (current === "$" && prev != "\\" && state.pending == '"') {
                found_var = true;
                break;
              }
              prev = current;
            }
            if (found_var) {
              stream.backUp(1);
            }
            if (current == state.pending) {
              state.continueString = false;
            } else {
              state.continueString = true;
            }
            return "string";
          }
          function tokenize(stream, state) {
            var ch = stream.next();
            if (ch === "$") {
              if (stream.match(variable_regex)) {
                return "variable-2";
              }
              return "variable";
            }
            if (state.continueString) {
              stream.backUp(1);
              return tokenString(stream, state);
            }
            if (stream.match(/(\s+)?\w+\(/) || stream.match(/(\s+)?\w+\ \(/)) {
              stream.backUp(1);
              return "def";
            }
            if (ch == "#") {
              stream.skipToEnd();
              return "comment";
            }
            if (ch == "'" || ch == '"') {
              state.pending = ch;
              return tokenString(stream, state);
            }
            if (ch == "(" || ch == ")") {
              return "bracket";
            }
            if (ch.match(/[0-9]/)) {
              return "number";
            }
            stream.eatWhile(/[\w-]/);
            return null;
          }
          return {
            startState: function() {
              var state = {};
              state.inDefinition = false;
              state.inInclude = false;
              state.continueString = false;
              state.pending = false;
              return state;
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return tokenize(stream, state);
            }
          };
        });
        CodeMirror5.defineMIME("text/x-cmake", "cmake");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/cobol/cobol.js
  var require_cobol = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/cobol/cobol.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("cobol", function() {
          var BUILTIN = "builtin", COMMENT = "comment", STRING = "string", ATOM = "atom", NUMBER = "number", KEYWORD = "keyword", MODTAG = "header", COBOLLINENUM = "def", PERIOD = "link";
          function makeKeywords(str) {
            var obj = {}, words = str.split(" ");
            for (var i3 = 0; i3 < words.length; ++i3)
              obj[words[i3]] = true;
            return obj;
          }
          var atoms = makeKeywords("TRUE FALSE ZEROES ZEROS ZERO SPACES SPACE LOW-VALUE LOW-VALUES ");
          var keywords2 = makeKeywords("ACCEPT ACCESS ACQUIRE ADD ADDRESS ADVANCING AFTER ALIAS ALL ALPHABET ALPHABETIC ALPHABETIC-LOWER ALPHABETIC-UPPER ALPHANUMERIC ALPHANUMERIC-EDITED ALSO ALTER ALTERNATE AND ANY ARE AREA AREAS ARITHMETIC ASCENDING ASSIGN AT ATTRIBUTE AUTHOR AUTO AUTO-SKIP AUTOMATIC B-AND B-EXOR B-LESS B-NOT B-OR BACKGROUND-COLOR BACKGROUND-COLOUR BEEP BEFORE BELL BINARY BIT BITS BLANK BLINK BLOCK BOOLEAN BOTTOM BY CALL CANCEL CD CF CH CHARACTER CHARACTERS CLASS CLOCK-UNITS CLOSE COBOL CODE CODE-SET COL COLLATING COLUMN COMMA COMMIT COMMITMENT COMMON COMMUNICATION COMP COMP-0 COMP-1 COMP-2 COMP-3 COMP-4 COMP-5 COMP-6 COMP-7 COMP-8 COMP-9 COMPUTATIONAL COMPUTATIONAL-0 COMPUTATIONAL-1 COMPUTATIONAL-2 COMPUTATIONAL-3 COMPUTATIONAL-4 COMPUTATIONAL-5 COMPUTATIONAL-6 COMPUTATIONAL-7 COMPUTATIONAL-8 COMPUTATIONAL-9 COMPUTE CONFIGURATION CONNECT CONSOLE CONTAINED CONTAINS CONTENT CONTINUE CONTROL CONTROL-AREA CONTROLS CONVERTING COPY CORR CORRESPONDING COUNT CRT CRT-UNDER CURRENCY CURRENT CURSOR DATA DATE DATE-COMPILED DATE-WRITTEN DAY DAY-OF-WEEK DB DB-ACCESS-CONTROL-KEY DB-DATA-NAME DB-EXCEPTION DB-FORMAT-NAME DB-RECORD-NAME DB-SET-NAME DB-STATUS DBCS DBCS-EDITED DE DEBUG-CONTENTS DEBUG-ITEM DEBUG-LINE DEBUG-NAME DEBUG-SUB-1 DEBUG-SUB-2 DEBUG-SUB-3 DEBUGGING DECIMAL-POINT DECLARATIVES DEFAULT DELETE DELIMITED DELIMITER DEPENDING DESCENDING DESCRIBED DESTINATION DETAIL DISABLE DISCONNECT DISPLAY DISPLAY-1 DISPLAY-2 DISPLAY-3 DISPLAY-4 DISPLAY-5 DISPLAY-6 DISPLAY-7 DISPLAY-8 DISPLAY-9 DIVIDE DIVISION DOWN DROP DUPLICATE DUPLICATES DYNAMIC EBCDIC EGI EJECT ELSE EMI EMPTY EMPTY-CHECK ENABLE END END. END-ACCEPT END-ACCEPT. END-ADD END-CALL END-COMPUTE END-DELETE END-DISPLAY END-DIVIDE END-EVALUATE END-IF END-INVOKE END-MULTIPLY END-OF-PAGE END-PERFORM END-READ END-RECEIVE END-RETURN END-REWRITE END-SEARCH END-START END-STRING END-SUBTRACT END-UNSTRING END-WRITE END-XML ENTER ENTRY ENVIRONMENT EOP EQUAL EQUALS ERASE ERROR ESI EVALUATE EVERY EXCEEDS EXCEPTION EXCLUSIVE EXIT EXTEND EXTERNAL EXTERNALLY-DESCRIBED-KEY FD FETCH FILE FILE-CONTROL FILE-STREAM FILES FILLER FINAL FIND FINISH FIRST FOOTING FOR FOREGROUND-COLOR FOREGROUND-COLOUR FORMAT FREE FROM FULL FUNCTION GENERATE GET GIVING GLOBAL GO GOBACK GREATER GROUP HEADING HIGH-VALUE HIGH-VALUES HIGHLIGHT I-O I-O-CONTROL ID IDENTIFICATION IF IN INDEX INDEX-1 INDEX-2 INDEX-3 INDEX-4 INDEX-5 INDEX-6 INDEX-7 INDEX-8 INDEX-9 INDEXED INDIC INDICATE INDICATOR INDICATORS INITIAL INITIALIZE INITIATE INPUT INPUT-OUTPUT INSPECT INSTALLATION INTO INVALID INVOKE IS JUST JUSTIFIED KANJI KEEP KEY LABEL LAST LD LEADING LEFT LEFT-JUSTIFY LENGTH LENGTH-CHECK LESS LIBRARY LIKE LIMIT LIMITS LINAGE LINAGE-COUNTER LINE LINE-COUNTER LINES LINKAGE LOCAL-STORAGE LOCALE LOCALLY LOCK MEMBER MEMORY MERGE MESSAGE METACLASS MODE MODIFIED MODIFY MODULES MOVE MULTIPLE MULTIPLY NATIONAL NATIVE NEGATIVE NEXT NO NO-ECHO NONE NOT NULL NULL-KEY-MAP NULL-MAP NULLS NUMBER NUMERIC NUMERIC-EDITED OBJECT OBJECT-COMPUTER OCCURS OF OFF OMITTED ON ONLY OPEN OPTIONAL OR ORDER ORGANIZATION OTHER OUTPUT OVERFLOW OWNER PACKED-DECIMAL PADDING PAGE PAGE-COUNTER PARSE PERFORM PF PH PIC PICTURE PLUS POINTER POSITION POSITIVE PREFIX PRESENT PRINTING PRIOR PROCEDURE PROCEDURE-POINTER PROCEDURES PROCEED PROCESS PROCESSING PROGRAM PROGRAM-ID PROMPT PROTECTED PURGE QUEUE QUOTE QUOTES RANDOM RD READ READY REALM RECEIVE RECONNECT RECORD RECORD-NAME RECORDS RECURSIVE REDEFINES REEL REFERENCE REFERENCE-MONITOR REFERENCES RELATION RELATIVE RELEASE REMAINDER REMOVAL RENAMES REPEATED REPLACE REPLACING REPORT REPORTING REPORTS REPOSITORY REQUIRED RERUN RESERVE RESET RETAINING RETRIEVAL RETURN RETURN-CODE RETURNING REVERSE-VIDEO REVERSED REWIND REWRITE RF RH RIGHT RIGHT-JUSTIFY ROLLBACK ROLLING ROUNDED RUN SAME SCREEN SD SEARCH SECTION SECURE SECURITY SEGMENT SEGMENT-LIMIT SELECT SEND SENTENCE SEPARATE SEQUENCE SEQUENTIAL SET SHARED SIGN SIZE SKIP1 SKIP2 SKIP3 SORT SORT-MERGE SORT-RETURN SOURCE SOURCE-COMPUTER SPACE-FILL SPECIAL-NAMES STANDARD STANDARD-1 STANDARD-2 START STARTING STATUS STOP STORE STRING SUB-QUEUE-1 SUB-QUEUE-2 SUB-QUEUE-3 SUB-SCHEMA SUBFILE SUBSTITUTE SUBTRACT SUM SUPPRESS SYMBOLIC SYNC SYNCHRONIZED SYSIN SYSOUT TABLE TALLYING TAPE TENANT TERMINAL TERMINATE TEST TEXT THAN THEN THROUGH THRU TIME TIMES TITLE TO TOP TRAILING TRAILING-SIGN TRANSACTION TYPE TYPEDEF UNDERLINE UNEQUAL UNIT UNSTRING UNTIL UP UPDATE UPON USAGE USAGE-MODE USE USING VALID VALIDATE VALUE VALUES VARYING VLR WAIT WHEN WHEN-COMPILED WITH WITHIN WORDS WORKING-STORAGE WRITE XML XML-CODE XML-EVENT XML-NTEXT XML-TEXT ZERO ZERO-FILL ");
          var builtins = makeKeywords("- * ** / + < <= = > >= ");
          var tests = {
            digit: /\d/,
            digit_or_colon: /[\d:]/,
            hex: /[0-9a-f]/i,
            sign: /[+-]/,
            exponent: /e/i,
            keyword_char: /[^\s\(\[\;\)\]]/,
            symbol: /[\w*+\-]/
          };
          function isNumber2(ch, stream) {
            if (ch === "0" && stream.eat(/x/i)) {
              stream.eatWhile(tests.hex);
              return true;
            }
            if ((ch == "+" || ch == "-") && tests.digit.test(stream.peek())) {
              stream.eat(tests.sign);
              ch = stream.next();
            }
            if (tests.digit.test(ch)) {
              stream.eat(ch);
              stream.eatWhile(tests.digit);
              if (stream.peek() == ".") {
                stream.eat(".");
                stream.eatWhile(tests.digit);
              }
              if (stream.eat(tests.exponent)) {
                stream.eat(tests.sign);
                stream.eatWhile(tests.digit);
              }
              return true;
            }
            return false;
          }
          return {
            startState: function() {
              return {
                indentStack: null,
                indentation: 0,
                mode: false
              };
            },
            token: function(stream, state) {
              if (state.indentStack == null && stream.sol()) {
                state.indentation = 6;
              }
              if (stream.eatSpace()) {
                return null;
              }
              var returnType = null;
              switch (state.mode) {
                case "string":
                  var next = false;
                  while ((next = stream.next()) != null) {
                    if (next == '"' || next == "'") {
                      state.mode = false;
                      break;
                    }
                  }
                  returnType = STRING;
                  break;
                default:
                  var ch = stream.next();
                  var col = stream.column();
                  if (col >= 0 && col <= 5) {
                    returnType = COBOLLINENUM;
                  } else if (col >= 72 && col <= 79) {
                    stream.skipToEnd();
                    returnType = MODTAG;
                  } else if (ch == "*" && col == 6) {
                    stream.skipToEnd();
                    returnType = COMMENT;
                  } else if (ch == '"' || ch == "'") {
                    state.mode = "string";
                    returnType = STRING;
                  } else if (ch == "'" && !tests.digit_or_colon.test(stream.peek())) {
                    returnType = ATOM;
                  } else if (ch == ".") {
                    returnType = PERIOD;
                  } else if (isNumber2(ch, stream)) {
                    returnType = NUMBER;
                  } else {
                    if (stream.current().match(tests.symbol)) {
                      while (col < 71) {
                        if (stream.eat(tests.symbol) === void 0) {
                          break;
                        } else {
                          col++;
                        }
                      }
                    }
                    if (keywords2 && keywords2.propertyIsEnumerable(stream.current().toUpperCase())) {
                      returnType = KEYWORD;
                    } else if (builtins && builtins.propertyIsEnumerable(stream.current().toUpperCase())) {
                      returnType = BUILTIN;
                    } else if (atoms && atoms.propertyIsEnumerable(stream.current().toUpperCase())) {
                      returnType = ATOM;
                    } else
                      returnType = null;
                  }
              }
              return returnType;
            },
            indent: function(state) {
              if (state.indentStack == null)
                return state.indentation;
              return state.indentStack.indent;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-cobol", "cobol");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/coffeescript/coffeescript.js
  var require_coffeescript = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/coffeescript/coffeescript.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("coffeescript", function(conf, parserConf) {
          var ERRORCLASS = "error";
          function wordRegexp(words) {
            return new RegExp("^((" + words.join(")|(") + "))\\b");
          }
          var operators = /^(?:->|=>|\+[+=]?|-[\-=]?|\*[\*=]?|\/[\/=]?|[=!]=|<[><]?=?|>>?=?|%=?|&=?|\|=?|\^=?|\~|!|\?|(or|and|\|\||&&|\?)=)/;
          var delimiters = /^(?:[()\[\]{},:`=;]|\.\.?\.?)/;
          var identifiers = /^[_A-Za-z$][_A-Za-z$0-9]*/;
          var atProp = /^@[_A-Za-z$][_A-Za-z$0-9]*/;
          var wordOperators = wordRegexp([
            "and",
            "or",
            "not",
            "is",
            "isnt",
            "in",
            "instanceof",
            "typeof"
          ]);
          var indentKeywords = [
            "for",
            "while",
            "loop",
            "if",
            "unless",
            "else",
            "switch",
            "try",
            "catch",
            "finally",
            "class"
          ];
          var commonKeywords = [
            "break",
            "by",
            "continue",
            "debugger",
            "delete",
            "do",
            "in",
            "of",
            "new",
            "return",
            "then",
            "this",
            "@",
            "throw",
            "when",
            "until",
            "extends"
          ];
          var keywords2 = wordRegexp(indentKeywords.concat(commonKeywords));
          indentKeywords = wordRegexp(indentKeywords);
          var stringPrefixes = /^('{3}|\"{3}|['\"])/;
          var regexPrefixes = /^(\/{3}|\/)/;
          var commonConstants = ["Infinity", "NaN", "undefined", "null", "true", "false", "on", "off", "yes", "no"];
          var constants = wordRegexp(commonConstants);
          function tokenBase(stream, state) {
            if (stream.sol()) {
              if (state.scope.align === null)
                state.scope.align = false;
              var scopeOffset = state.scope.offset;
              if (stream.eatSpace()) {
                var lineOffset = stream.indentation();
                if (lineOffset > scopeOffset && state.scope.type == "coffee") {
                  return "indent";
                } else if (lineOffset < scopeOffset) {
                  return "dedent";
                }
                return null;
              } else {
                if (scopeOffset > 0) {
                  dedent(stream, state);
                }
              }
            }
            if (stream.eatSpace()) {
              return null;
            }
            var ch = stream.peek();
            if (stream.match("####")) {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match("###")) {
              state.tokenize = longComment;
              return state.tokenize(stream, state);
            }
            if (ch === "#") {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match(/^-?[0-9\.]/, false)) {
              var floatLiteral = false;
              if (stream.match(/^-?\d*\.\d+(e[\+\-]?\d+)?/i)) {
                floatLiteral = true;
              }
              if (stream.match(/^-?\d+\.\d*/)) {
                floatLiteral = true;
              }
              if (stream.match(/^-?\.\d+/)) {
                floatLiteral = true;
              }
              if (floatLiteral) {
                if (stream.peek() == ".") {
                  stream.backUp(1);
                }
                return "number";
              }
              var intLiteral = false;
              if (stream.match(/^-?0x[0-9a-f]+/i)) {
                intLiteral = true;
              }
              if (stream.match(/^-?[1-9]\d*(e[\+\-]?\d+)?/)) {
                intLiteral = true;
              }
              if (stream.match(/^-?0(?![\dx])/i)) {
                intLiteral = true;
              }
              if (intLiteral) {
                return "number";
              }
            }
            if (stream.match(stringPrefixes)) {
              state.tokenize = tokenFactory(stream.current(), false, "string");
              return state.tokenize(stream, state);
            }
            if (stream.match(regexPrefixes)) {
              if (stream.current() != "/" || stream.match(/^.*\//, false)) {
                state.tokenize = tokenFactory(stream.current(), true, "string-2");
                return state.tokenize(stream, state);
              } else {
                stream.backUp(1);
              }
            }
            if (stream.match(operators) || stream.match(wordOperators)) {
              return "operator";
            }
            if (stream.match(delimiters)) {
              return "punctuation";
            }
            if (stream.match(constants)) {
              return "atom";
            }
            if (stream.match(atProp) || state.prop && stream.match(identifiers)) {
              return "property";
            }
            if (stream.match(keywords2)) {
              return "keyword";
            }
            if (stream.match(identifiers)) {
              return "variable";
            }
            stream.next();
            return ERRORCLASS;
          }
          function tokenFactory(delimiter, singleline, outclass) {
            return function(stream, state) {
              while (!stream.eol()) {
                stream.eatWhile(/[^'"\/\\]/);
                if (stream.eat("\\")) {
                  stream.next();
                  if (singleline && stream.eol()) {
                    return outclass;
                  }
                } else if (stream.match(delimiter)) {
                  state.tokenize = tokenBase;
                  return outclass;
                } else {
                  stream.eat(/['"\/]/);
                }
              }
              if (singleline) {
                if (parserConf.singleLineStringErrors) {
                  outclass = ERRORCLASS;
                } else {
                  state.tokenize = tokenBase;
                }
              }
              return outclass;
            };
          }
          function longComment(stream, state) {
            while (!stream.eol()) {
              stream.eatWhile(/[^#]/);
              if (stream.match("###")) {
                state.tokenize = tokenBase;
                break;
              }
              stream.eatWhile("#");
            }
            return "comment";
          }
          function indent(stream, state, type) {
            type = type || "coffee";
            var offset = 0, align = false, alignOffset = null;
            for (var scope = state.scope; scope; scope = scope.prev) {
              if (scope.type === "coffee" || scope.type == "}") {
                offset = scope.offset + conf.indentUnit;
                break;
              }
            }
            if (type !== "coffee") {
              align = null;
              alignOffset = stream.column() + stream.current().length;
            } else if (state.scope.align) {
              state.scope.align = false;
            }
            state.scope = {
              offset,
              type,
              prev: state.scope,
              align,
              alignOffset
            };
          }
          function dedent(stream, state) {
            if (!state.scope.prev)
              return;
            if (state.scope.type === "coffee") {
              var _indent = stream.indentation();
              var matched = false;
              for (var scope = state.scope; scope; scope = scope.prev) {
                if (_indent === scope.offset) {
                  matched = true;
                  break;
                }
              }
              if (!matched) {
                return true;
              }
              while (state.scope.prev && state.scope.offset !== _indent) {
                state.scope = state.scope.prev;
              }
              return false;
            } else {
              state.scope = state.scope.prev;
              return false;
            }
          }
          function tokenLexer(stream, state) {
            var style = state.tokenize(stream, state);
            var current = stream.current();
            if (current === "return") {
              state.dedent = true;
            }
            if ((current === "->" || current === "=>") && stream.eol() || style === "indent") {
              indent(stream, state);
            }
            var delimiter_index = "[({".indexOf(current);
            if (delimiter_index !== -1) {
              indent(stream, state, "])}".slice(delimiter_index, delimiter_index + 1));
            }
            if (indentKeywords.exec(current)) {
              indent(stream, state);
            }
            if (current == "then") {
              dedent(stream, state);
            }
            if (style === "dedent") {
              if (dedent(stream, state)) {
                return ERRORCLASS;
              }
            }
            delimiter_index = "])}".indexOf(current);
            if (delimiter_index !== -1) {
              while (state.scope.type == "coffee" && state.scope.prev)
                state.scope = state.scope.prev;
              if (state.scope.type == current)
                state.scope = state.scope.prev;
            }
            if (state.dedent && stream.eol()) {
              if (state.scope.type == "coffee" && state.scope.prev)
                state.scope = state.scope.prev;
              state.dedent = false;
            }
            return style;
          }
          var external = {
            startState: function(basecolumn) {
              return {
                tokenize: tokenBase,
                scope: { offset: basecolumn || 0, type: "coffee", prev: null, align: false },
                prop: false,
                dedent: 0
              };
            },
            token: function(stream, state) {
              var fillAlign = state.scope.align === null && state.scope;
              if (fillAlign && stream.sol())
                fillAlign.align = false;
              var style = tokenLexer(stream, state);
              if (style && style != "comment") {
                if (fillAlign)
                  fillAlign.align = true;
                state.prop = style == "punctuation" && stream.current() == ".";
              }
              return style;
            },
            indent: function(state, text) {
              if (state.tokenize != tokenBase)
                return 0;
              var scope = state.scope;
              var closer = text && "])}".indexOf(text.charAt(0)) > -1;
              if (closer)
                while (scope.type == "coffee" && scope.prev)
                  scope = scope.prev;
              var closes = closer && scope.type === text.charAt(0);
              if (scope.align)
                return scope.alignOffset - (closes ? 1 : 0);
              else
                return (closes ? scope.prev : scope).offset;
            },
            lineComment: "#",
            fold: "indent"
          };
          return external;
        });
        CodeMirror5.defineMIME("application/vnd.coffeescript", "coffeescript");
        CodeMirror5.defineMIME("text/x-coffeescript", "coffeescript");
        CodeMirror5.defineMIME("text/coffeescript", "coffeescript");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/commonlisp/commonlisp.js
  var require_commonlisp = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/commonlisp/commonlisp.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("commonlisp", function(config3) {
          var specialForm = /^(block|let*|return-from|catch|load-time-value|setq|eval-when|locally|symbol-macrolet|flet|macrolet|tagbody|function|multiple-value-call|the|go|multiple-value-prog1|throw|if|progn|unwind-protect|labels|progv|let|quote)$/;
          var assumeBody = /^with|^def|^do|^prog|case$|^cond$|bind$|when$|unless$/;
          var numLiteral = /^(?:[+\-]?(?:\d+|\d*\.\d+)(?:[efd][+\-]?\d+)?|[+\-]?\d+(?:\/[+\-]?\d+)?|#b[+\-]?[01]+|#o[+\-]?[0-7]+|#x[+\-]?[\da-f]+)/;
          var symbol = /[^\s'`,@()\[\]";]/;
          var type;
          function readSym(stream) {
            var ch;
            while (ch = stream.next()) {
              if (ch == "\\")
                stream.next();
              else if (!symbol.test(ch)) {
                stream.backUp(1);
                break;
              }
            }
            return stream.current();
          }
          function base(stream, state) {
            if (stream.eatSpace()) {
              type = "ws";
              return null;
            }
            if (stream.match(numLiteral))
              return "number";
            var ch = stream.next();
            if (ch == "\\")
              ch = stream.next();
            if (ch == '"')
              return (state.tokenize = inString)(stream, state);
            else if (ch == "(") {
              type = "open";
              return "bracket";
            } else if (ch == ")" || ch == "]") {
              type = "close";
              return "bracket";
            } else if (ch == ";") {
              stream.skipToEnd();
              type = "ws";
              return "comment";
            } else if (/['`,@]/.test(ch))
              return null;
            else if (ch == "|") {
              if (stream.skipTo("|")) {
                stream.next();
                return "symbol";
              } else {
                stream.skipToEnd();
                return "error";
              }
            } else if (ch == "#") {
              var ch = stream.next();
              if (ch == "(") {
                type = "open";
                return "bracket";
              } else if (/[+\-=\.']/.test(ch))
                return null;
              else if (/\d/.test(ch) && stream.match(/^\d*#/))
                return null;
              else if (ch == "|")
                return (state.tokenize = inComment)(stream, state);
              else if (ch == ":") {
                readSym(stream);
                return "meta";
              } else if (ch == "\\") {
                stream.next();
                readSym(stream);
                return "string-2";
              } else
                return "error";
            } else {
              var name106 = readSym(stream);
              if (name106 == ".")
                return null;
              type = "symbol";
              if (name106 == "nil" || name106 == "t" || name106.charAt(0) == ":")
                return "atom";
              if (state.lastType == "open" && (specialForm.test(name106) || assumeBody.test(name106)))
                return "keyword";
              if (name106.charAt(0) == "&")
                return "variable-2";
              return "variable";
            }
          }
          function inString(stream, state) {
            var escaped = false, next;
            while (next = stream.next()) {
              if (next == '"' && !escaped) {
                state.tokenize = base;
                break;
              }
              escaped = !escaped && next == "\\";
            }
            return "string";
          }
          function inComment(stream, state) {
            var next, last;
            while (next = stream.next()) {
              if (next == "#" && last == "|") {
                state.tokenize = base;
                break;
              }
              last = next;
            }
            type = "ws";
            return "comment";
          }
          return {
            startState: function() {
              return { ctx: { prev: null, start: 0, indentTo: 0 }, lastType: null, tokenize: base };
            },
            token: function(stream, state) {
              if (stream.sol() && typeof state.ctx.indentTo != "number")
                state.ctx.indentTo = state.ctx.start + 1;
              type = null;
              var style = state.tokenize(stream, state);
              if (type != "ws") {
                if (state.ctx.indentTo == null) {
                  if (type == "symbol" && assumeBody.test(stream.current()))
                    state.ctx.indentTo = state.ctx.start + config3.indentUnit;
                  else
                    state.ctx.indentTo = "next";
                } else if (state.ctx.indentTo == "next") {
                  state.ctx.indentTo = stream.column();
                }
                state.lastType = type;
              }
              if (type == "open")
                state.ctx = { prev: state.ctx, start: stream.column(), indentTo: null };
              else if (type == "close")
                state.ctx = state.ctx.prev || state.ctx;
              return style;
            },
            indent: function(state, _textAfter) {
              var i3 = state.ctx.indentTo;
              return typeof i3 == "number" ? i3 : state.ctx.start + 1;
            },
            closeBrackets: { pairs: '()[]{}""' },
            lineComment: ";;",
            blockCommentStart: "#|",
            blockCommentEnd: "|#"
          };
        });
        CodeMirror5.defineMIME("text/x-common-lisp", "commonlisp");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/crystal/crystal.js
  var require_crystal = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/crystal/crystal.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("crystal", function(config3) {
          function wordRegExp(words, end) {
            return new RegExp((end ? "" : "^") + "(?:" + words.join("|") + ")" + (end ? "$" : "\\b"));
          }
          function chain2(tokenize, stream, state) {
            state.tokenize.push(tokenize);
            return tokenize(stream, state);
          }
          var operators = /^(?:[-+/%|&^]|\*\*?|[<>]{2})/;
          var conditionalOperators = /^(?:[=!]~|===|<=>|[<>=!]=?|[|&]{2}|~)/;
          var indexingOperators = /^(?:\[\][?=]?)/;
          var anotherOperators = /^(?:\.(?:\.{2})?|->|[?:])/;
          var idents = /^[a-z_\u009F-\uFFFF][a-zA-Z0-9_\u009F-\uFFFF]*/;
          var types = /^[A-Z_\u009F-\uFFFF][a-zA-Z0-9_\u009F-\uFFFF]*/;
          var keywords2 = wordRegExp([
            "abstract",
            "alias",
            "as",
            "asm",
            "begin",
            "break",
            "case",
            "class",
            "def",
            "do",
            "else",
            "elsif",
            "end",
            "ensure",
            "enum",
            "extend",
            "for",
            "fun",
            "if",
            "include",
            "instance_sizeof",
            "lib",
            "macro",
            "module",
            "next",
            "of",
            "out",
            "pointerof",
            "private",
            "protected",
            "rescue",
            "return",
            "require",
            "select",
            "sizeof",
            "struct",
            "super",
            "then",
            "type",
            "typeof",
            "uninitialized",
            "union",
            "unless",
            "until",
            "when",
            "while",
            "with",
            "yield",
            "__DIR__",
            "__END_LINE__",
            "__FILE__",
            "__LINE__"
          ]);
          var atomWords = wordRegExp(["true", "false", "nil", "self"]);
          var indentKeywordsArray = [
            "def",
            "fun",
            "macro",
            "class",
            "module",
            "struct",
            "lib",
            "enum",
            "union",
            "do",
            "for"
          ];
          var indentKeywords = wordRegExp(indentKeywordsArray);
          var indentExpressionKeywordsArray = ["if", "unless", "case", "while", "until", "begin", "then"];
          var indentExpressionKeywords = wordRegExp(indentExpressionKeywordsArray);
          var dedentKeywordsArray = ["end", "else", "elsif", "rescue", "ensure"];
          var dedentKeywords = wordRegExp(dedentKeywordsArray);
          var dedentPunctualsArray = ["\\)", "\\}", "\\]"];
          var dedentPunctuals = new RegExp("^(?:" + dedentPunctualsArray.join("|") + ")$");
          var nextTokenizer = {
            "def": tokenFollowIdent,
            "fun": tokenFollowIdent,
            "macro": tokenMacroDef,
            "class": tokenFollowType,
            "module": tokenFollowType,
            "struct": tokenFollowType,
            "lib": tokenFollowType,
            "enum": tokenFollowType,
            "union": tokenFollowType
          };
          var matching = { "[": "]", "{": "}", "(": ")", "<": ">" };
          function tokenBase(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            if (state.lastToken != "\\" && stream.match("{%", false)) {
              return chain2(tokenMacro("%", "%"), stream, state);
            }
            if (state.lastToken != "\\" && stream.match("{{", false)) {
              return chain2(tokenMacro("{", "}"), stream, state);
            }
            if (stream.peek() == "#") {
              stream.skipToEnd();
              return "comment";
            }
            var matched;
            if (stream.match(idents)) {
              stream.eat(/[?!]/);
              matched = stream.current();
              if (stream.eat(":")) {
                return "atom";
              } else if (state.lastToken == ".") {
                return "property";
              } else if (keywords2.test(matched)) {
                if (indentKeywords.test(matched)) {
                  if (!(matched == "fun" && state.blocks.indexOf("lib") >= 0) && !(matched == "def" && state.lastToken == "abstract")) {
                    state.blocks.push(matched);
                    state.currentIndent += 1;
                  }
                } else if ((state.lastStyle == "operator" || !state.lastStyle) && indentExpressionKeywords.test(matched)) {
                  state.blocks.push(matched);
                  state.currentIndent += 1;
                } else if (matched == "end") {
                  state.blocks.pop();
                  state.currentIndent -= 1;
                }
                if (nextTokenizer.hasOwnProperty(matched)) {
                  state.tokenize.push(nextTokenizer[matched]);
                }
                return "keyword";
              } else if (atomWords.test(matched)) {
                return "atom";
              }
              return "variable";
            }
            if (stream.eat("@")) {
              if (stream.peek() == "[") {
                return chain2(tokenNest("[", "]", "meta"), stream, state);
              }
              stream.eat("@");
              stream.match(idents) || stream.match(types);
              return "variable-2";
            }
            if (stream.match(types)) {
              return "tag";
            }
            if (stream.eat(":")) {
              if (stream.eat('"')) {
                return chain2(tokenQuote('"', "atom", false), stream, state);
              } else if (stream.match(idents) || stream.match(types) || stream.match(operators) || stream.match(conditionalOperators) || stream.match(indexingOperators)) {
                return "atom";
              }
              stream.eat(":");
              return "operator";
            }
            if (stream.eat('"')) {
              return chain2(tokenQuote('"', "string", true), stream, state);
            }
            if (stream.peek() == "%") {
              var style = "string";
              var embed = true;
              var delim;
              if (stream.match("%r")) {
                style = "string-2";
                delim = stream.next();
              } else if (stream.match("%w")) {
                embed = false;
                delim = stream.next();
              } else if (stream.match("%q")) {
                embed = false;
                delim = stream.next();
              } else {
                if (delim = stream.match(/^%([^\w\s=])/)) {
                  delim = delim[1];
                } else if (stream.match(/^%[a-zA-Z0-9_\u009F-\uFFFF]*/)) {
                  return "meta";
                } else {
                  return "operator";
                }
              }
              if (matching.hasOwnProperty(delim)) {
                delim = matching[delim];
              }
              return chain2(tokenQuote(delim, style, embed), stream, state);
            }
            if (matched = stream.match(/^<<-('?)([A-Z]\w*)\1/)) {
              return chain2(tokenHereDoc(matched[2], !matched[1]), stream, state);
            }
            if (stream.eat("'")) {
              stream.match(/^(?:[^']|\\(?:[befnrtv0'"]|[0-7]{3}|u(?:[0-9a-fA-F]{4}|\{[0-9a-fA-F]{1,6}\})))/);
              stream.eat("'");
              return "atom";
            }
            if (stream.eat("0")) {
              if (stream.eat("x")) {
                stream.match(/^[0-9a-fA-F]+/);
              } else if (stream.eat("o")) {
                stream.match(/^[0-7]+/);
              } else if (stream.eat("b")) {
                stream.match(/^[01]+/);
              }
              return "number";
            }
            if (stream.eat(/^\d/)) {
              stream.match(/^\d*(?:\.\d+)?(?:[eE][+-]?\d+)?/);
              return "number";
            }
            if (stream.match(operators)) {
              stream.eat("=");
              return "operator";
            }
            if (stream.match(conditionalOperators) || stream.match(anotherOperators)) {
              return "operator";
            }
            if (matched = stream.match(/[({[]/, false)) {
              matched = matched[0];
              return chain2(tokenNest(matched, matching[matched], null), stream, state);
            }
            if (stream.eat("\\")) {
              stream.next();
              return "meta";
            }
            stream.next();
            return null;
          }
          function tokenNest(begin, end, style, started) {
            return function(stream, state) {
              if (!started && stream.match(begin)) {
                state.tokenize[state.tokenize.length - 1] = tokenNest(begin, end, style, true);
                state.currentIndent += 1;
                return style;
              }
              var nextStyle = tokenBase(stream, state);
              if (stream.current() === end) {
                state.tokenize.pop();
                state.currentIndent -= 1;
                nextStyle = style;
              }
              return nextStyle;
            };
          }
          function tokenMacro(begin, end, started) {
            return function(stream, state) {
              if (!started && stream.match("{" + begin)) {
                state.currentIndent += 1;
                state.tokenize[state.tokenize.length - 1] = tokenMacro(begin, end, true);
                return "meta";
              }
              if (stream.match(end + "}")) {
                state.currentIndent -= 1;
                state.tokenize.pop();
                return "meta";
              }
              return tokenBase(stream, state);
            };
          }
          function tokenMacroDef(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            var matched;
            if (matched = stream.match(idents)) {
              if (matched == "def") {
                return "keyword";
              }
              stream.eat(/[?!]/);
            }
            state.tokenize.pop();
            return "def";
          }
          function tokenFollowIdent(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            if (stream.match(idents)) {
              stream.eat(/[!?]/);
            } else {
              stream.match(operators) || stream.match(conditionalOperators) || stream.match(indexingOperators);
            }
            state.tokenize.pop();
            return "def";
          }
          function tokenFollowType(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            stream.match(types);
            state.tokenize.pop();
            return "def";
          }
          function tokenQuote(end, style, embed) {
            return function(stream, state) {
              var escaped = false;
              while (stream.peek()) {
                if (!escaped) {
                  if (stream.match("{%", false)) {
                    state.tokenize.push(tokenMacro("%", "%"));
                    return style;
                  }
                  if (stream.match("{{", false)) {
                    state.tokenize.push(tokenMacro("{", "}"));
                    return style;
                  }
                  if (embed && stream.match("#{", false)) {
                    state.tokenize.push(tokenNest("#{", "}", "meta"));
                    return style;
                  }
                  var ch = stream.next();
                  if (ch == end) {
                    state.tokenize.pop();
                    return style;
                  }
                  escaped = embed && ch == "\\";
                } else {
                  stream.next();
                  escaped = false;
                }
              }
              return style;
            };
          }
          function tokenHereDoc(phrase, embed) {
            return function(stream, state) {
              if (stream.sol()) {
                stream.eatSpace();
                if (stream.match(phrase)) {
                  state.tokenize.pop();
                  return "string";
                }
              }
              var escaped = false;
              while (stream.peek()) {
                if (!escaped) {
                  if (stream.match("{%", false)) {
                    state.tokenize.push(tokenMacro("%", "%"));
                    return "string";
                  }
                  if (stream.match("{{", false)) {
                    state.tokenize.push(tokenMacro("{", "}"));
                    return "string";
                  }
                  if (embed && stream.match("#{", false)) {
                    state.tokenize.push(tokenNest("#{", "}", "meta"));
                    return "string";
                  }
                  escaped = embed && stream.next() == "\\";
                } else {
                  stream.next();
                  escaped = false;
                }
              }
              return "string";
            };
          }
          return {
            startState: function() {
              return {
                tokenize: [tokenBase],
                currentIndent: 0,
                lastToken: null,
                lastStyle: null,
                blocks: []
              };
            },
            token: function(stream, state) {
              var style = state.tokenize[state.tokenize.length - 1](stream, state);
              var token = stream.current();
              if (style && style != "comment") {
                state.lastToken = token;
                state.lastStyle = style;
              }
              return style;
            },
            indent: function(state, textAfter) {
              textAfter = textAfter.replace(/^\s*(?:\{%)?\s*|\s*(?:%\})?\s*$/g, "");
              if (dedentKeywords.test(textAfter) || dedentPunctuals.test(textAfter)) {
                return config3.indentUnit * (state.currentIndent - 1);
              }
              return config3.indentUnit * state.currentIndent;
            },
            fold: "indent",
            electricInput: wordRegExp(dedentPunctualsArray.concat(dedentKeywordsArray), true),
            lineComment: "#"
          };
        });
        CodeMirror5.defineMIME("text/x-crystal", "crystal");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/cypher/cypher.js
  var require_cypher = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/cypher/cypher.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var wordRegexp = function(words) {
          return new RegExp("^(?:" + words.join("|") + ")$", "i");
        };
        CodeMirror5.defineMode("cypher", function(config3) {
          var tokenBase = function(stream) {
            var ch = stream.next();
            if (ch === '"') {
              stream.match(/.*?"/);
              return "string";
            }
            if (ch === "'") {
              stream.match(/.*?'/);
              return "string";
            }
            if (/[{}\(\),\.;\[\]]/.test(ch)) {
              curPunc = ch;
              return "node";
            } else if (ch === "/" && stream.eat("/")) {
              stream.skipToEnd();
              return "comment";
            } else if (operatorChars.test(ch)) {
              stream.eatWhile(operatorChars);
              return null;
            } else {
              stream.eatWhile(/[_\w\d]/);
              if (stream.eat(":")) {
                stream.eatWhile(/[\w\d_\-]/);
                return "atom";
              }
              var word = stream.current();
              if (funcs.test(word))
                return "builtin";
              if (preds.test(word))
                return "def";
              if (keywords2.test(word) || systemKeywords.test(word))
                return "keyword";
              return "variable";
            }
          };
          var pushContext = function(state, type, col) {
            return state.context = {
              prev: state.context,
              indent: state.indent,
              col,
              type
            };
          };
          var popContext = function(state) {
            state.indent = state.context.indent;
            return state.context = state.context.prev;
          };
          var indentUnit = config3.indentUnit;
          var curPunc;
          var funcs = wordRegexp(["abs", "acos", "allShortestPaths", "asin", "atan", "atan2", "avg", "ceil", "coalesce", "collect", "cos", "cot", "count", "degrees", "e", "endnode", "exp", "extract", "filter", "floor", "haversin", "head", "id", "keys", "labels", "last", "left", "length", "log", "log10", "lower", "ltrim", "max", "min", "node", "nodes", "percentileCont", "percentileDisc", "pi", "radians", "rand", "range", "reduce", "rel", "relationship", "relationships", "replace", "reverse", "right", "round", "rtrim", "shortestPath", "sign", "sin", "size", "split", "sqrt", "startnode", "stdev", "stdevp", "str", "substring", "sum", "tail", "tan", "timestamp", "toFloat", "toInt", "toString", "trim", "type", "upper"]);
          var preds = wordRegexp(["all", "and", "any", "contains", "exists", "has", "in", "none", "not", "or", "single", "xor"]);
          var keywords2 = wordRegexp(["as", "asc", "ascending", "assert", "by", "case", "commit", "constraint", "create", "csv", "cypher", "delete", "desc", "descending", "detach", "distinct", "drop", "else", "end", "ends", "explain", "false", "fieldterminator", "foreach", "from", "headers", "in", "index", "is", "join", "limit", "load", "match", "merge", "null", "on", "optional", "order", "periodic", "profile", "remove", "return", "scan", "set", "skip", "start", "starts", "then", "true", "union", "unique", "unwind", "using", "when", "where", "with", "call", "yield"]);
          var systemKeywords = wordRegexp(["access", "active", "assign", "all", "alter", "as", "catalog", "change", "copy", "create", "constraint", "constraints", "current", "database", "databases", "dbms", "default", "deny", "drop", "element", "elements", "exists", "from", "grant", "graph", "graphs", "if", "index", "indexes", "label", "labels", "management", "match", "name", "names", "new", "node", "nodes", "not", "of", "on", "or", "password", "populated", "privileges", "property", "read", "relationship", "relationships", "remove", "replace", "required", "revoke", "role", "roles", "set", "show", "start", "status", "stop", "suspended", "to", "traverse", "type", "types", "user", "users", "with", "write"]);
          var operatorChars = /[*+\-<>=&|~%^]/;
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                context: null,
                indent: 0,
                col: 0
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (state.context && state.context.align == null) {
                  state.context.align = false;
                }
                state.indent = stream.indentation();
              }
              if (stream.eatSpace()) {
                return null;
              }
              var style = state.tokenize(stream, state);
              if (style !== "comment" && state.context && state.context.align == null && state.context.type !== "pattern") {
                state.context.align = true;
              }
              if (curPunc === "(") {
                pushContext(state, ")", stream.column());
              } else if (curPunc === "[") {
                pushContext(state, "]", stream.column());
              } else if (curPunc === "{") {
                pushContext(state, "}", stream.column());
              } else if (/[\]\}\)]/.test(curPunc)) {
                while (state.context && state.context.type === "pattern") {
                  popContext(state);
                }
                if (state.context && curPunc === state.context.type) {
                  popContext(state);
                }
              } else if (curPunc === "." && state.context && state.context.type === "pattern") {
                popContext(state);
              } else if (/atom|string|variable/.test(style) && state.context) {
                if (/[\}\]]/.test(state.context.type)) {
                  pushContext(state, "pattern", stream.column());
                } else if (state.context.type === "pattern" && !state.context.align) {
                  state.context.align = true;
                  state.context.col = stream.column();
                }
              }
              return style;
            },
            indent: function(state, textAfter) {
              var firstChar = textAfter && textAfter.charAt(0);
              var context = state.context;
              if (/[\]\}]/.test(firstChar)) {
                while (context && context.type === "pattern") {
                  context = context.prev;
                }
              }
              var closing = context && firstChar === context.type;
              if (!context)
                return 0;
              if (context.type === "keywords")
                return CodeMirror5.commands.newlineAndIndent;
              if (context.align)
                return context.col + (closing ? 0 : 1);
              return context.indent + (closing ? 0 : indentUnit);
            }
          };
        });
        CodeMirror5.modeExtensions["cypher"] = {
          autoFormatLineBreaks: function(text) {
            var i3, lines, reProcessedPortion;
            var lines = text.split("\n");
            var reProcessedPortion = /\s+\b(return|where|order by|match|with|skip|limit|create|delete|set)\b\s/g;
            for (var i3 = 0; i3 < lines.length; i3++)
              lines[i3] = lines[i3].replace(reProcessedPortion, " \n$1 ").trim();
            return lines.join("\n");
          }
        };
        CodeMirror5.defineMIME("application/x-cypher-query", "cypher");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/d/d.js
  var require_d = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/d/d.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("d", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit, statementIndentUnit = parserConfig.statementIndentUnit || indentUnit, keywords2 = parserConfig.keywords || {}, builtin = parserConfig.builtin || {}, blockKeywords2 = parserConfig.blockKeywords || {}, atoms = parserConfig.atoms || {}, hooks = parserConfig.hooks || {}, multiLineStrings = parserConfig.multiLineStrings;
          var isOperatorChar = /[+\-*&%=<>!?|\/]/;
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (hooks[ch]) {
              var result = hooks[ch](stream, state);
              if (result !== false)
                return result;
            }
            if (ch == '"' || ch == "'" || ch == "`") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              curPunc = ch;
              return null;
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            }
            if (ch == "/") {
              if (stream.eat("+")) {
                state.tokenize = tokenNestedComment;
                return tokenNestedComment(stream, state);
              }
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_\xa1-\uffff]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur)) {
              if (blockKeywords2.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "keyword";
            }
            if (builtin.propertyIsEnumerable(cur)) {
              if (blockKeywords2.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "builtin";
            }
            if (atoms.propertyIsEnumerable(cur))
              return "atom";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = null;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = null;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function tokenNestedComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = null;
                break;
              }
              maybeEnd = ch == "+";
            }
            return "comment";
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            var indent = state.indented;
            if (state.context && state.context.type == "statement")
              indent = state.context.indented;
            return state.context = new Context(indent, col, type, null, state.context);
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment" || style == "meta")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if ((curPunc == ";" || curPunc == ":" || curPunc == ",") && ctx.type == "statement")
                popContext(state);
              else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if ((ctx.type == "}" || ctx.type == "top") && curPunc != ";" || ctx.type == "statement" && curPunc == "newstatement")
                pushContext(state, stream.column(), "statement");
              state.startOfLine = false;
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase && state.tokenize != null)
                return CodeMirror5.Pass;
              var ctx = state.context, firstChar = textAfter && textAfter.charAt(0);
              if (ctx.type == "statement" && firstChar == "}")
                ctx = ctx.prev;
              var closing = firstChar == ctx.type;
              if (ctx.type == "statement")
                return ctx.indented + (firstChar == "{" ? 0 : statementIndentUnit);
              else if (ctx.align)
                return ctx.column + (closing ? 0 : 1);
              else
                return ctx.indented + (closing ? 0 : indentUnit);
            },
            electricChars: "{}",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            blockCommentContinue: " * ",
            lineComment: "//",
            fold: "brace"
          };
        });
        function words(str) {
          var obj = {}, words2 = str.split(" ");
          for (var i3 = 0; i3 < words2.length; ++i3)
            obj[words2[i3]] = true;
          return obj;
        }
        var blockKeywords = "body catch class do else enum for foreach foreach_reverse if in interface mixin out scope struct switch try union unittest version while with";
        CodeMirror5.defineMIME("text/x-d", {
          name: "d",
          keywords: words("abstract alias align asm assert auto break case cast cdouble cent cfloat const continue debug default delegate delete deprecated export extern final finally function goto immutable import inout invariant is lazy macro module new nothrow override package pragma private protected public pure ref return shared short static super synchronized template this throw typedef typeid typeof volatile __FILE__ __LINE__ __gshared __traits __vector __parameters " + blockKeywords),
          blockKeywords: words(blockKeywords),
          builtin: words("bool byte char creal dchar double float idouble ifloat int ireal long real short ubyte ucent uint ulong ushort wchar wstring void size_t sizediff_t"),
          atoms: words("exit failure success true false null"),
          hooks: {
            "@": function(stream, _state) {
              stream.eatWhile(/[\w\$_]/);
              return "meta";
            }
          }
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/dart/dart.js
  var require_dart = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/dart/dart.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_clike());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../clike/clike"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var keywords2 = "this super static final const abstract class extends external factory implements mixin get native set typedef with enum throw rethrow assert break case continue default in return new deferred async await covariant try catch finally do else for if switch while import library export part of show hide is as extension on yield".split(" ");
        var blockKeywords = "try catch finally do else for if switch while".split(" ");
        var atoms = "true false null".split(" ");
        var builtins = "void bool num int double dynamic var String".split(" ");
        function set(words) {
          var obj = {};
          for (var i3 = 0; i3 < words.length; ++i3)
            obj[words[i3]] = true;
          return obj;
        }
        function pushInterpolationStack(state) {
          (state.interpolationStack || (state.interpolationStack = [])).push(state.tokenize);
        }
        function popInterpolationStack(state) {
          return (state.interpolationStack || (state.interpolationStack = [])).pop();
        }
        function sizeInterpolationStack(state) {
          return state.interpolationStack ? state.interpolationStack.length : 0;
        }
        CodeMirror5.defineMIME("application/dart", {
          name: "clike",
          keywords: set(keywords2),
          blockKeywords: set(blockKeywords),
          builtin: set(builtins),
          atoms: set(atoms),
          hooks: {
            "@": function(stream) {
              stream.eatWhile(/[\w\$_\.]/);
              return "meta";
            },
            "'": function(stream, state) {
              return tokenString("'", stream, state, false);
            },
            '"': function(stream, state) {
              return tokenString('"', stream, state, false);
            },
            "r": function(stream, state) {
              var peek = stream.peek();
              if (peek == "'" || peek == '"') {
                return tokenString(stream.next(), stream, state, true);
              }
              return false;
            },
            "}": function(_stream, state) {
              if (sizeInterpolationStack(state) > 0) {
                state.tokenize = popInterpolationStack(state);
                return null;
              }
              return false;
            },
            "/": function(stream, state) {
              if (!stream.eat("*"))
                return false;
              state.tokenize = tokenNestedComment(1);
              return state.tokenize(stream, state);
            },
            token: function(stream, _2, style) {
              if (style == "variable") {
                var isUpper = RegExp("^[_$]*[A-Z][a-zA-Z0-9_$]*$", "g");
                if (isUpper.test(stream.current())) {
                  return "variable-2";
                }
              }
            }
          }
        });
        function tokenString(quote, stream, state, raw) {
          var tripleQuoted = false;
          if (stream.eat(quote)) {
            if (stream.eat(quote))
              tripleQuoted = true;
            else
              return "string";
          }
          function tokenStringHelper(stream2, state2) {
            var escaped = false;
            while (!stream2.eol()) {
              if (!raw && !escaped && stream2.peek() == "$") {
                pushInterpolationStack(state2);
                state2.tokenize = tokenInterpolation;
                return "string";
              }
              var next = stream2.next();
              if (next == quote && !escaped && (!tripleQuoted || stream2.match(quote + quote))) {
                state2.tokenize = null;
                break;
              }
              escaped = !raw && !escaped && next == "\\";
            }
            return "string";
          }
          state.tokenize = tokenStringHelper;
          return tokenStringHelper(stream, state);
        }
        function tokenInterpolation(stream, state) {
          stream.eat("$");
          if (stream.eat("{")) {
            state.tokenize = null;
          } else {
            state.tokenize = tokenInterpolationIdentifier;
          }
          return null;
        }
        function tokenInterpolationIdentifier(stream, state) {
          stream.eatWhile(/[\w_]/);
          state.tokenize = popInterpolationStack(state);
          return "variable";
        }
        function tokenNestedComment(depth) {
          return function(stream, state) {
            var ch;
            while (ch = stream.next()) {
              if (ch == "*" && stream.eat("/")) {
                if (depth == 1) {
                  state.tokenize = null;
                  break;
                } else {
                  state.tokenize = tokenNestedComment(depth - 1);
                  return state.tokenize(stream, state);
                }
              } else if (ch == "/" && stream.eat("*")) {
                state.tokenize = tokenNestedComment(depth + 1);
                return state.tokenize(stream, state);
              }
            }
            return "comment";
          };
        }
        CodeMirror5.registerHelper("hintWords", "application/dart", keywords2.concat(atoms).concat(builtins));
        CodeMirror5.defineMode("dart", function(conf) {
          return CodeMirror5.getMode(conf, "application/dart");
        }, "clike");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/diff/diff.js
  var require_diff = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/diff/diff.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("diff", function() {
          var TOKEN_NAMES = {
            "+": "positive",
            "-": "negative",
            "@": "meta"
          };
          return {
            token: function(stream) {
              var tw_pos = stream.string.search(/[\t ]+?$/);
              if (!stream.sol() || tw_pos === 0) {
                stream.skipToEnd();
                return ("error " + (TOKEN_NAMES[stream.string.charAt(0)] || "")).replace(/ $/, "");
              }
              var token_name = TOKEN_NAMES[stream.peek()] || stream.skipToEnd();
              if (tw_pos === -1) {
                stream.skipToEnd();
              } else {
                stream.pos = tw_pos;
              }
              return token_name;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-diff", "diff");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/mode/overlay.js
  var require_overlay = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/mode/overlay.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.overlayMode = function(base, overlay, combine) {
          return {
            startState: function() {
              return {
                base: CodeMirror5.startState(base),
                overlay: CodeMirror5.startState(overlay),
                basePos: 0,
                baseCur: null,
                overlayPos: 0,
                overlayCur: null,
                streamSeen: null
              };
            },
            copyState: function(state) {
              return {
                base: CodeMirror5.copyState(base, state.base),
                overlay: CodeMirror5.copyState(overlay, state.overlay),
                basePos: state.basePos,
                baseCur: null,
                overlayPos: state.overlayPos,
                overlayCur: null
              };
            },
            token: function(stream, state) {
              if (stream != state.streamSeen || Math.min(state.basePos, state.overlayPos) < stream.start) {
                state.streamSeen = stream;
                state.basePos = state.overlayPos = stream.start;
              }
              if (stream.start == state.basePos) {
                state.baseCur = base.token(stream, state.base);
                state.basePos = stream.pos;
              }
              if (stream.start == state.overlayPos) {
                stream.pos = stream.start;
                state.overlayCur = overlay.token(stream, state.overlay);
                state.overlayPos = stream.pos;
              }
              stream.pos = Math.min(state.basePos, state.overlayPos);
              if (state.overlayCur == null)
                return state.baseCur;
              else if (state.baseCur != null && state.overlay.combineTokens || combine && state.overlay.combineTokens == null)
                return state.baseCur + " " + state.overlayCur;
              else
                return state.overlayCur;
            },
            indent: base.indent && function(state, textAfter, line) {
              return base.indent(state.base, textAfter, line);
            },
            electricChars: base.electricChars,
            innerMode: function(state) {
              return { state: state.base, mode: base };
            },
            blankLine: function(state) {
              var baseToken, overlayToken;
              if (base.blankLine)
                baseToken = base.blankLine(state.base);
              if (overlay.blankLine)
                overlayToken = overlay.blankLine(state.overlay);
              return overlayToken == null ? baseToken : combine && baseToken != null ? baseToken + " " + overlayToken : overlayToken;
            }
          };
        };
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/django/django.js
  var require_django = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/django/django.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_htmlmixed(), require_overlay());
        else if (typeof define == "function" && define.amd)
          define([
            "../../lib/codemirror",
            "../htmlmixed/htmlmixed",
            "../../addon/mode/overlay"
          ], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("django:inner", function() {
          var keywords2 = [
            "block",
            "endblock",
            "for",
            "endfor",
            "true",
            "false",
            "filter",
            "endfilter",
            "loop",
            "none",
            "self",
            "super",
            "if",
            "elif",
            "endif",
            "as",
            "else",
            "import",
            "with",
            "endwith",
            "without",
            "context",
            "ifequal",
            "endifequal",
            "ifnotequal",
            "endifnotequal",
            "extends",
            "include",
            "load",
            "comment",
            "endcomment",
            "empty",
            "url",
            "static",
            "trans",
            "blocktrans",
            "endblocktrans",
            "now",
            "regroup",
            "lorem",
            "ifchanged",
            "endifchanged",
            "firstof",
            "debug",
            "cycle",
            "csrf_token",
            "autoescape",
            "endautoescape",
            "spaceless",
            "endspaceless",
            "ssi",
            "templatetag",
            "verbatim",
            "endverbatim",
            "widthratio"
          ], filters = [
            "add",
            "addslashes",
            "capfirst",
            "center",
            "cut",
            "date",
            "default",
            "default_if_none",
            "dictsort",
            "dictsortreversed",
            "divisibleby",
            "escape",
            "escapejs",
            "filesizeformat",
            "first",
            "floatformat",
            "force_escape",
            "get_digit",
            "iriencode",
            "join",
            "last",
            "length",
            "length_is",
            "linebreaks",
            "linebreaksbr",
            "linenumbers",
            "ljust",
            "lower",
            "make_list",
            "phone2numeric",
            "pluralize",
            "pprint",
            "random",
            "removetags",
            "rjust",
            "safe",
            "safeseq",
            "slice",
            "slugify",
            "stringformat",
            "striptags",
            "time",
            "timesince",
            "timeuntil",
            "title",
            "truncatechars",
            "truncatechars_html",
            "truncatewords",
            "truncatewords_html",
            "unordered_list",
            "upper",
            "urlencode",
            "urlize",
            "urlizetrunc",
            "wordcount",
            "wordwrap",
            "yesno"
          ], operators = ["==", "!=", "<", ">", "<=", ">="], wordOperators = ["in", "not", "or", "and"];
          keywords2 = new RegExp("^\\b(" + keywords2.join("|") + ")\\b");
          filters = new RegExp("^\\b(" + filters.join("|") + ")\\b");
          operators = new RegExp("^\\b(" + operators.join("|") + ")\\b");
          wordOperators = new RegExp("^\\b(" + wordOperators.join("|") + ")\\b");
          function tokenBase(stream, state) {
            if (stream.match("{{")) {
              state.tokenize = inVariable;
              return "tag";
            } else if (stream.match("{%")) {
              state.tokenize = inTag;
              return "tag";
            } else if (stream.match("{#")) {
              state.tokenize = inComment;
              return "comment";
            }
            while (stream.next() != null && !stream.match(/\{[{%#]/, false)) {
            }
            return null;
          }
          function inString(delimiter, previousTokenizer) {
            return function(stream, state) {
              if (!state.escapeNext && stream.eat(delimiter)) {
                state.tokenize = previousTokenizer;
              } else {
                if (state.escapeNext) {
                  state.escapeNext = false;
                }
                var ch = stream.next();
                if (ch == "\\") {
                  state.escapeNext = true;
                }
              }
              return "string";
            };
          }
          function inVariable(stream, state) {
            if (state.waitDot) {
              state.waitDot = false;
              if (stream.peek() != ".") {
                return "null";
              }
              if (stream.match(/\.\W+/)) {
                return "error";
              } else if (stream.eat(".")) {
                state.waitProperty = true;
                return "null";
              } else {
                throw Error("Unexpected error while waiting for property.");
              }
            }
            if (state.waitPipe) {
              state.waitPipe = false;
              if (stream.peek() != "|") {
                return "null";
              }
              if (stream.match(/\.\W+/)) {
                return "error";
              } else if (stream.eat("|")) {
                state.waitFilter = true;
                return "null";
              } else {
                throw Error("Unexpected error while waiting for filter.");
              }
            }
            if (state.waitProperty) {
              state.waitProperty = false;
              if (stream.match(/\b(\w+)\b/)) {
                state.waitDot = true;
                state.waitPipe = true;
                return "property";
              }
            }
            if (state.waitFilter) {
              state.waitFilter = false;
              if (stream.match(filters)) {
                return "variable-2";
              }
            }
            if (stream.eatSpace()) {
              state.waitProperty = false;
              return "null";
            }
            if (stream.match(/\b\d+(\.\d+)?\b/)) {
              return "number";
            }
            if (stream.match("'")) {
              state.tokenize = inString("'", state.tokenize);
              return "string";
            } else if (stream.match('"')) {
              state.tokenize = inString('"', state.tokenize);
              return "string";
            }
            if (stream.match(/\b(\w+)\b/) && !state.foundVariable) {
              state.waitDot = true;
              state.waitPipe = true;
              return "variable";
            }
            if (stream.match("}}")) {
              state.waitProperty = null;
              state.waitFilter = null;
              state.waitDot = null;
              state.waitPipe = null;
              state.tokenize = tokenBase;
              return "tag";
            }
            stream.next();
            return "null";
          }
          function inTag(stream, state) {
            if (state.waitDot) {
              state.waitDot = false;
              if (stream.peek() != ".") {
                return "null";
              }
              if (stream.match(/\.\W+/)) {
                return "error";
              } else if (stream.eat(".")) {
                state.waitProperty = true;
                return "null";
              } else {
                throw Error("Unexpected error while waiting for property.");
              }
            }
            if (state.waitPipe) {
              state.waitPipe = false;
              if (stream.peek() != "|") {
                return "null";
              }
              if (stream.match(/\.\W+/)) {
                return "error";
              } else if (stream.eat("|")) {
                state.waitFilter = true;
                return "null";
              } else {
                throw Error("Unexpected error while waiting for filter.");
              }
            }
            if (state.waitProperty) {
              state.waitProperty = false;
              if (stream.match(/\b(\w+)\b/)) {
                state.waitDot = true;
                state.waitPipe = true;
                return "property";
              }
            }
            if (state.waitFilter) {
              state.waitFilter = false;
              if (stream.match(filters)) {
                return "variable-2";
              }
            }
            if (stream.eatSpace()) {
              state.waitProperty = false;
              return "null";
            }
            if (stream.match(/\b\d+(\.\d+)?\b/)) {
              return "number";
            }
            if (stream.match("'")) {
              state.tokenize = inString("'", state.tokenize);
              return "string";
            } else if (stream.match('"')) {
              state.tokenize = inString('"', state.tokenize);
              return "string";
            }
            if (stream.match(operators)) {
              return "operator";
            }
            if (stream.match(wordOperators)) {
              return "keyword";
            }
            var keywordMatch = stream.match(keywords2);
            if (keywordMatch) {
              if (keywordMatch[0] == "comment") {
                state.blockCommentTag = true;
              }
              return "keyword";
            }
            if (stream.match(/\b(\w+)\b/)) {
              state.waitDot = true;
              state.waitPipe = true;
              return "variable";
            }
            if (stream.match("%}")) {
              state.waitProperty = null;
              state.waitFilter = null;
              state.waitDot = null;
              state.waitPipe = null;
              if (state.blockCommentTag) {
                state.blockCommentTag = false;
                state.tokenize = inBlockComment;
              } else {
                state.tokenize = tokenBase;
              }
              return "tag";
            }
            stream.next();
            return "null";
          }
          function inComment(stream, state) {
            if (stream.match(/^.*?#\}/))
              state.tokenize = tokenBase;
            else
              stream.skipToEnd();
            return "comment";
          }
          function inBlockComment(stream, state) {
            if (stream.match(/\{%\s*endcomment\s*%\}/, false)) {
              state.tokenize = inTag;
              stream.match("{%");
              return "tag";
            } else {
              stream.next();
              return "comment";
            }
          }
          return {
            startState: function() {
              return { tokenize: tokenBase };
            },
            token: function(stream, state) {
              return state.tokenize(stream, state);
            },
            blockCommentStart: "{% comment %}",
            blockCommentEnd: "{% endcomment %}"
          };
        });
        CodeMirror5.defineMode("django", function(config3) {
          var htmlBase = CodeMirror5.getMode(config3, "text/html");
          var djangoInner = CodeMirror5.getMode(config3, "django:inner");
          return CodeMirror5.overlayMode(htmlBase, djangoInner);
        });
        CodeMirror5.defineMIME("text/x-django", "django");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/mode/simple.js
  var require_simple = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/mode/simple.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineSimpleMode = function(name106, states) {
          CodeMirror5.defineMode(name106, function(config3) {
            return CodeMirror5.simpleMode(config3, states);
          });
        };
        CodeMirror5.simpleMode = function(config3, states) {
          ensureState(states, "start");
          var states_ = {}, meta = states.meta || {}, hasIndentation = false;
          for (var state in states)
            if (state != meta && states.hasOwnProperty(state)) {
              var list = states_[state] = [], orig = states[state];
              for (var i3 = 0; i3 < orig.length; i3++) {
                var data = orig[i3];
                list.push(new Rule(data, states));
                if (data.indent || data.dedent)
                  hasIndentation = true;
              }
            }
          var mode2 = {
            startState: function() {
              return {
                state: "start",
                pending: null,
                local: null,
                localState: null,
                indent: hasIndentation ? [] : null
              };
            },
            copyState: function(state2) {
              var s3 = {
                state: state2.state,
                pending: state2.pending,
                local: state2.local,
                localState: null,
                indent: state2.indent && state2.indent.slice(0)
              };
              if (state2.localState)
                s3.localState = CodeMirror5.copyState(state2.local.mode, state2.localState);
              if (state2.stack)
                s3.stack = state2.stack.slice(0);
              for (var pers = state2.persistentStates; pers; pers = pers.next)
                s3.persistentStates = {
                  mode: pers.mode,
                  spec: pers.spec,
                  state: pers.state == state2.localState ? s3.localState : CodeMirror5.copyState(pers.mode, pers.state),
                  next: s3.persistentStates
                };
              return s3;
            },
            token: tokenFunction(states_, config3),
            innerMode: function(state2) {
              return state2.local && { mode: state2.local.mode, state: state2.localState };
            },
            indent: indentFunction(states_, meta)
          };
          if (meta) {
            for (var prop in meta)
              if (meta.hasOwnProperty(prop))
                mode2[prop] = meta[prop];
          }
          return mode2;
        };
        function ensureState(states, name106) {
          if (!states.hasOwnProperty(name106))
            throw new Error("Undefined state " + name106 + " in simple mode");
        }
        function toRegex(val, caret) {
          if (!val)
            return /(?:)/;
          var flags = "";
          if (val instanceof RegExp) {
            if (val.ignoreCase)
              flags = "i";
            val = val.source;
          } else {
            val = String(val);
          }
          return new RegExp((caret === false ? "" : "^") + "(?:" + val + ")", flags);
        }
        function asToken(val) {
          if (!val)
            return null;
          if (val.apply)
            return val;
          if (typeof val == "string")
            return val.replace(/\./g, " ");
          var result = [];
          for (var i3 = 0; i3 < val.length; i3++)
            result.push(val[i3] && val[i3].replace(/\./g, " "));
          return result;
        }
        function Rule(data, states) {
          if (data.next || data.push)
            ensureState(states, data.next || data.push);
          this.regex = toRegex(data.regex);
          this.token = asToken(data.token);
          this.data = data;
        }
        function tokenFunction(states, config3) {
          return function(stream, state) {
            if (state.pending) {
              var pend = state.pending.shift();
              if (state.pending.length == 0)
                state.pending = null;
              stream.pos += pend.text.length;
              return pend.token;
            }
            if (state.local) {
              if (state.local.end && stream.match(state.local.end)) {
                var tok = state.local.endToken || null;
                state.local = state.localState = null;
                return tok;
              } else {
                var tok = state.local.mode.token(stream, state.localState), m3;
                if (state.local.endScan && (m3 = state.local.endScan.exec(stream.current())))
                  stream.pos = stream.start + m3.index;
                return tok;
              }
            }
            var curState = states[state.state];
            for (var i3 = 0; i3 < curState.length; i3++) {
              var rule = curState[i3];
              var matches = (!rule.data.sol || stream.sol()) && stream.match(rule.regex);
              if (matches) {
                if (rule.data.next) {
                  state.state = rule.data.next;
                } else if (rule.data.push) {
                  (state.stack || (state.stack = [])).push(state.state);
                  state.state = rule.data.push;
                } else if (rule.data.pop && state.stack && state.stack.length) {
                  state.state = state.stack.pop();
                }
                if (rule.data.mode)
                  enterLocalMode(config3, state, rule.data.mode, rule.token);
                if (rule.data.indent)
                  state.indent.push(stream.indentation() + config3.indentUnit);
                if (rule.data.dedent)
                  state.indent.pop();
                var token = rule.token;
                if (token && token.apply)
                  token = token(matches);
                if (matches.length > 2 && rule.token && typeof rule.token != "string") {
                  state.pending = [];
                  for (var j3 = 2; j3 < matches.length; j3++)
                    if (matches[j3])
                      state.pending.push({ text: matches[j3], token: rule.token[j3 - 1] });
                  stream.backUp(matches[0].length - (matches[1] ? matches[1].length : 0));
                  return token[0];
                } else if (token && token.join) {
                  return token[0];
                } else {
                  return token;
                }
              }
            }
            stream.next();
            return null;
          };
        }
        function cmp(a3, b2) {
          if (a3 === b2)
            return true;
          if (!a3 || typeof a3 != "object" || !b2 || typeof b2 != "object")
            return false;
          var props = 0;
          for (var prop in a3)
            if (a3.hasOwnProperty(prop)) {
              if (!b2.hasOwnProperty(prop) || !cmp(a3[prop], b2[prop]))
                return false;
              props++;
            }
          for (var prop in b2)
            if (b2.hasOwnProperty(prop))
              props--;
          return props == 0;
        }
        function enterLocalMode(config3, state, spec, token) {
          var pers;
          if (spec.persistent) {
            for (var p3 = state.persistentStates; p3 && !pers; p3 = p3.next)
              if (spec.spec ? cmp(spec.spec, p3.spec) : spec.mode == p3.mode)
                pers = p3;
          }
          var mode2 = pers ? pers.mode : spec.mode || CodeMirror5.getMode(config3, spec.spec);
          var lState = pers ? pers.state : CodeMirror5.startState(mode2);
          if (spec.persistent && !pers)
            state.persistentStates = { mode: mode2, spec: spec.spec, state: lState, next: state.persistentStates };
          state.localState = lState;
          state.local = {
            mode: mode2,
            end: spec.end && toRegex(spec.end),
            endScan: spec.end && spec.forceEnd !== false && toRegex(spec.end, false),
            endToken: token && token.join ? token[token.length - 1] : token
          };
        }
        function indexOf(val, arr) {
          for (var i3 = 0; i3 < arr.length; i3++)
            if (arr[i3] === val)
              return true;
        }
        function indentFunction(states, meta) {
          return function(state, textAfter, line) {
            if (state.local && state.local.mode.indent)
              return state.local.mode.indent(state.localState, textAfter, line);
            if (state.indent == null || state.local || meta.dontIndentStates && indexOf(state.state, meta.dontIndentStates) > -1)
              return CodeMirror5.Pass;
            var pos = state.indent.length - 1, rules = states[state.state];
            scan:
              for (; ; ) {
                for (var i3 = 0; i3 < rules.length; i3++) {
                  var rule = rules[i3];
                  if (rule.data.dedent && rule.data.dedentIfLineStart !== false) {
                    var m3 = rule.regex.exec(textAfter);
                    if (m3 && m3[0]) {
                      pos--;
                      if (rule.next || rule.push)
                        rules = states[rule.next || rule.push];
                      textAfter = textAfter.slice(m3[0].length);
                      continue scan;
                    }
                  }
                }
                break;
              }
            return pos < 0 ? 0 : state.indent[pos];
          };
        }
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/dockerfile/dockerfile.js
  var require_dockerfile = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/dockerfile/dockerfile.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_simple());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../../addon/mode/simple"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var from = "from";
        var fromRegex = new RegExp("^(\\s*)\\b(" + from + ")\\b", "i");
        var shells = ["run", "cmd", "entrypoint", "shell"];
        var shellsAsArrayRegex = new RegExp("^(\\s*)(" + shells.join("|") + ")(\\s+\\[)", "i");
        var expose = "expose";
        var exposeRegex = new RegExp("^(\\s*)(" + expose + ")(\\s+)", "i");
        var others = [
          "arg",
          "from",
          "maintainer",
          "label",
          "env",
          "add",
          "copy",
          "volume",
          "user",
          "workdir",
          "onbuild",
          "stopsignal",
          "healthcheck",
          "shell"
        ];
        var instructions = [from, expose].concat(shells).concat(others), instructionRegex = "(" + instructions.join("|") + ")", instructionOnlyLine = new RegExp("^(\\s*)" + instructionRegex + "(\\s*)(#.*)?$", "i"), instructionWithArguments = new RegExp("^(\\s*)" + instructionRegex + "(\\s+)", "i");
        CodeMirror5.defineSimpleMode("dockerfile", {
          start: [
            {
              regex: /^\s*#.*$/,
              sol: true,
              token: "comment"
            },
            {
              regex: fromRegex,
              token: [null, "keyword"],
              sol: true,
              next: "from"
            },
            {
              regex: instructionOnlyLine,
              token: [null, "keyword", null, "error"],
              sol: true
            },
            {
              regex: shellsAsArrayRegex,
              token: [null, "keyword", null],
              sol: true,
              next: "array"
            },
            {
              regex: exposeRegex,
              token: [null, "keyword", null],
              sol: true,
              next: "expose"
            },
            {
              regex: instructionWithArguments,
              token: [null, "keyword", null],
              sol: true,
              next: "arguments"
            },
            {
              regex: /./,
              token: null
            }
          ],
          from: [
            {
              regex: /\s*$/,
              token: null,
              next: "start"
            },
            {
              regex: /(\s*)(#.*)$/,
              token: [null, "error"],
              next: "start"
            },
            {
              regex: /(\s*\S+\s+)(as)/i,
              token: [null, "keyword"],
              next: "start"
            },
            {
              token: null,
              next: "start"
            }
          ],
          single: [
            {
              regex: /(?:[^\\']|\\.)/,
              token: "string"
            },
            {
              regex: /'/,
              token: "string",
              pop: true
            }
          ],
          double: [
            {
              regex: /(?:[^\\"]|\\.)/,
              token: "string"
            },
            {
              regex: /"/,
              token: "string",
              pop: true
            }
          ],
          array: [
            {
              regex: /\]/,
              token: null,
              next: "start"
            },
            {
              regex: /"(?:[^\\"]|\\.)*"?/,
              token: "string"
            }
          ],
          expose: [
            {
              regex: /\d+$/,
              token: "number",
              next: "start"
            },
            {
              regex: /[^\d]+$/,
              token: null,
              next: "start"
            },
            {
              regex: /\d+/,
              token: "number"
            },
            {
              regex: /[^\d]+/,
              token: null
            },
            {
              token: null,
              next: "start"
            }
          ],
          arguments: [
            {
              regex: /^\s*#.*$/,
              sol: true,
              token: "comment"
            },
            {
              regex: /"(?:[^\\"]|\\.)*"?$/,
              token: "string",
              next: "start"
            },
            {
              regex: /"/,
              token: "string",
              push: "double"
            },
            {
              regex: /'(?:[^\\']|\\.)*'?$/,
              token: "string",
              next: "start"
            },
            {
              regex: /'/,
              token: "string",
              push: "single"
            },
            {
              regex: /[^#"']+[\\`]$/,
              token: null
            },
            {
              regex: /[^#"']+$/,
              token: null,
              next: "start"
            },
            {
              regex: /[^#"']+/,
              token: null
            },
            {
              token: null,
              next: "start"
            }
          ],
          meta: {
            lineComment: "#"
          }
        });
        CodeMirror5.defineMIME("text/x-dockerfile", "dockerfile");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/dtd/dtd.js
  var require_dtd = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/dtd/dtd.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("dtd", function(config3) {
          var indentUnit = config3.indentUnit, type;
          function ret(style, tp) {
            type = tp;
            return style;
          }
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == "<" && stream.eat("!")) {
              if (stream.eatWhile(/[\-]/)) {
                state.tokenize = tokenSGMLComment;
                return tokenSGMLComment(stream, state);
              } else if (stream.eatWhile(/[\w]/))
                return ret("keyword", "doindent");
            } else if (ch == "<" && stream.eat("?")) {
              state.tokenize = inBlock("meta", "?>");
              return ret("meta", ch);
            } else if (ch == "#" && stream.eatWhile(/[\w]/))
              return ret("atom", "tag");
            else if (ch == "|")
              return ret("keyword", "seperator");
            else if (ch.match(/[\(\)\[\]\-\.,\+\?>]/))
              return ret(null, ch);
            else if (ch.match(/[\[\]]/))
              return ret("rule", ch);
            else if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            } else if (stream.eatWhile(/[a-zA-Z\?\+\d]/)) {
              var sc = stream.current();
              if (sc.substr(sc.length - 1, sc.length).match(/\?|\+/) !== null)
                stream.backUp(1);
              return ret("tag", "tag");
            } else if (ch == "%" || ch == "*")
              return ret("number", "number");
            else {
              stream.eatWhile(/[\w\\\-_%.{,]/);
              return ret(null, null);
            }
          }
          function tokenSGMLComment(stream, state) {
            var dashes = 0, ch;
            while ((ch = stream.next()) != null) {
              if (dashes >= 2 && ch == ">") {
                state.tokenize = tokenBase;
                break;
              }
              dashes = ch == "-" ? dashes + 1 : 0;
            }
            return ret("comment", "comment");
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped) {
                  state.tokenize = tokenBase;
                  break;
                }
                escaped = !escaped && ch == "\\";
              }
              return ret("string", "tag");
            };
          }
          function inBlock(style, terminator) {
            return function(stream, state) {
              while (!stream.eol()) {
                if (stream.match(terminator)) {
                  state.tokenize = tokenBase;
                  break;
                }
                stream.next();
              }
              return style;
            };
          }
          return {
            startState: function(base) {
              return {
                tokenize: tokenBase,
                baseIndent: base || 0,
                stack: []
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              var context = state.stack[state.stack.length - 1];
              if (stream.current() == "[" || type === "doindent" || type == "[")
                state.stack.push("rule");
              else if (type === "endtag")
                state.stack[state.stack.length - 1] = "endtag";
              else if (stream.current() == "]" || type == "]" || type == ">" && context == "rule")
                state.stack.pop();
              else if (type == "[")
                state.stack.push("[");
              return style;
            },
            indent: function(state, textAfter) {
              var n3 = state.stack.length;
              if (textAfter.match(/\]\s+|\]/))
                n3 = n3 - 1;
              else if (textAfter.substr(textAfter.length - 1, textAfter.length) === ">") {
                if (textAfter.substr(0, 1) === "<") {
                } else if (type == "doindent" && textAfter.length > 1) {
                } else if (type == "doindent")
                  n3--;
                else if (type == ">" && textAfter.length > 1) {
                } else if (type == "tag" && textAfter !== ">") {
                } else if (type == "tag" && state.stack[state.stack.length - 1] == "rule")
                  n3--;
                else if (type == "tag")
                  n3++;
                else if (textAfter === ">" && state.stack[state.stack.length - 1] == "rule" && type === ">")
                  n3--;
                else if (textAfter === ">" && state.stack[state.stack.length - 1] == "rule") {
                } else if (textAfter.substr(0, 1) !== "<" && textAfter.substr(0, 1) === ">")
                  n3 = n3 - 1;
                else if (textAfter === ">") {
                } else
                  n3 = n3 - 1;
                if (type == null || type == "]")
                  n3--;
              }
              return state.baseIndent + n3 * indentUnit;
            },
            electricChars: "]>"
          };
        });
        CodeMirror5.defineMIME("application/xml-dtd", "dtd");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/dylan/dylan.js
  var require_dylan = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/dylan/dylan.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function forEach3(arr, f3) {
          for (var i3 = 0; i3 < arr.length; i3++)
            f3(arr[i3], i3);
        }
        function some(arr, f3) {
          for (var i3 = 0; i3 < arr.length; i3++)
            if (f3(arr[i3], i3))
              return true;
          return false;
        }
        CodeMirror5.defineMode("dylan", function(_config) {
          var words = {
            unnamedDefinition: ["interface"],
            namedDefinition: [
              "module",
              "library",
              "macro",
              "C-struct",
              "C-union",
              "C-function",
              "C-callable-wrapper"
            ],
            typeParameterizedDefinition: ["class", "C-subtype", "C-mapped-subtype"],
            otherParameterizedDefinition: [
              "method",
              "function",
              "C-variable",
              "C-address"
            ],
            constantSimpleDefinition: ["constant"],
            variableSimpleDefinition: ["variable"],
            otherSimpleDefinition: [
              "generic",
              "domain",
              "C-pointer-type",
              "table"
            ],
            statement: [
              "if",
              "block",
              "begin",
              "method",
              "case",
              "for",
              "select",
              "when",
              "unless",
              "until",
              "while",
              "iterate",
              "profiling",
              "dynamic-bind"
            ],
            separator: [
              "finally",
              "exception",
              "cleanup",
              "else",
              "elseif",
              "afterwards"
            ],
            other: [
              "above",
              "below",
              "by",
              "from",
              "handler",
              "in",
              "instance",
              "let",
              "local",
              "otherwise",
              "slot",
              "subclass",
              "then",
              "to",
              "keyed-by",
              "virtual"
            ],
            signalingCalls: [
              "signal",
              "error",
              "cerror",
              "break",
              "check-type",
              "abort"
            ]
          };
          words["otherDefinition"] = words["unnamedDefinition"].concat(words["namedDefinition"]).concat(words["otherParameterizedDefinition"]);
          words["definition"] = words["typeParameterizedDefinition"].concat(words["otherDefinition"]);
          words["parameterizedDefinition"] = words["typeParameterizedDefinition"].concat(words["otherParameterizedDefinition"]);
          words["simpleDefinition"] = words["constantSimpleDefinition"].concat(words["variableSimpleDefinition"]).concat(words["otherSimpleDefinition"]);
          words["keyword"] = words["statement"].concat(words["separator"]).concat(words["other"]);
          var symbolPattern = "[-_a-zA-Z?!*@<>$%]+";
          var symbol = new RegExp("^" + symbolPattern);
          var patterns = {
            symbolKeyword: symbolPattern + ":",
            symbolClass: "<" + symbolPattern + ">",
            symbolGlobal: "\\*" + symbolPattern + "\\*",
            symbolConstant: "\\$" + symbolPattern
          };
          var patternStyles = {
            symbolKeyword: "atom",
            symbolClass: "tag",
            symbolGlobal: "variable-2",
            symbolConstant: "variable-3"
          };
          for (var patternName in patterns)
            if (patterns.hasOwnProperty(patternName))
              patterns[patternName] = new RegExp("^" + patterns[patternName]);
          patterns["keyword"] = [/^with(?:out)?-[-_a-zA-Z?!*@<>$%]+/];
          var styles = {};
          styles["keyword"] = "keyword";
          styles["definition"] = "def";
          styles["simpleDefinition"] = "def";
          styles["signalingCalls"] = "builtin";
          var wordLookup = {};
          var styleLookup = {};
          forEach3([
            "keyword",
            "definition",
            "simpleDefinition",
            "signalingCalls"
          ], function(type) {
            forEach3(words[type], function(word) {
              wordLookup[word] = type;
              styleLookup[word] = styles[type];
            });
          });
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function tokenBase(stream, state) {
            var ch = stream.peek();
            if (ch == "'" || ch == '"') {
              stream.next();
              return chain2(stream, state, tokenString(ch, "string"));
            } else if (ch == "/") {
              stream.next();
              if (stream.eat("*")) {
                return chain2(stream, state, tokenComment);
              } else if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
              stream.backUp(1);
            } else if (/[+\-\d\.]/.test(ch)) {
              if (stream.match(/^[+-]?[0-9]*\.[0-9]*([esdx][+-]?[0-9]+)?/i) || stream.match(/^[+-]?[0-9]+([esdx][+-]?[0-9]+)/i) || stream.match(/^[+-]?\d+/)) {
                return "number";
              }
            } else if (ch == "#") {
              stream.next();
              ch = stream.peek();
              if (ch == '"') {
                stream.next();
                return chain2(stream, state, tokenString('"', "string"));
              } else if (ch == "b") {
                stream.next();
                stream.eatWhile(/[01]/);
                return "number";
              } else if (ch == "x") {
                stream.next();
                stream.eatWhile(/[\da-f]/i);
                return "number";
              } else if (ch == "o") {
                stream.next();
                stream.eatWhile(/[0-7]/);
                return "number";
              } else if (ch == "#") {
                stream.next();
                return "punctuation";
              } else if (ch == "[" || ch == "(") {
                stream.next();
                return "bracket";
              } else if (stream.match(/f|t|all-keys|include|key|next|rest/i)) {
                return "atom";
              } else {
                stream.eatWhile(/[-a-zA-Z]/);
                return "error";
              }
            } else if (ch == "~") {
              stream.next();
              ch = stream.peek();
              if (ch == "=") {
                stream.next();
                ch = stream.peek();
                if (ch == "=") {
                  stream.next();
                  return "operator";
                }
                return "operator";
              }
              return "operator";
            } else if (ch == ":") {
              stream.next();
              ch = stream.peek();
              if (ch == "=") {
                stream.next();
                return "operator";
              } else if (ch == ":") {
                stream.next();
                return "punctuation";
              }
            } else if ("[](){}".indexOf(ch) != -1) {
              stream.next();
              return "bracket";
            } else if (".,".indexOf(ch) != -1) {
              stream.next();
              return "punctuation";
            } else if (stream.match("end")) {
              return "keyword";
            }
            for (var name106 in patterns) {
              if (patterns.hasOwnProperty(name106)) {
                var pattern = patterns[name106];
                if (pattern instanceof Array && some(pattern, function(p3) {
                  return stream.match(p3);
                }) || stream.match(pattern))
                  return patternStyles[name106];
              }
            }
            if (/[+\-*\/^=<>&|]/.test(ch)) {
              stream.next();
              return "operator";
            }
            if (stream.match("define")) {
              return "def";
            } else {
              stream.eatWhile(/[\w\-]/);
              if (wordLookup.hasOwnProperty(stream.current())) {
                return styleLookup[stream.current()];
              } else if (stream.current().match(symbol)) {
                return "variable";
              } else {
                stream.next();
                return "variable-2";
              }
            }
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, maybeNested = false, nestedCount = 0, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                if (nestedCount > 0) {
                  nestedCount--;
                } else {
                  state.tokenize = tokenBase;
                  break;
                }
              } else if (ch == "*" && maybeNested) {
                nestedCount++;
              }
              maybeEnd = ch == "*";
              maybeNested = ch == "/";
            }
            return "comment";
          }
          function tokenString(quote, style) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !escaped) {
                state.tokenize = tokenBase;
              }
              return style;
            };
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                currentIndent: 0
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              return style;
            },
            blockCommentStart: "/*",
            blockCommentEnd: "*/"
          };
        });
        CodeMirror5.defineMIME("text/x-dylan", "dylan");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/ebnf/ebnf.js
  var require_ebnf = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/ebnf/ebnf.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("ebnf", function(config3) {
          var commentType = { slash: 0, parenthesis: 1 };
          var stateType = { comment: 0, _string: 1, characterClass: 2 };
          var bracesMode = null;
          if (config3.bracesMode)
            bracesMode = CodeMirror5.getMode(config3, config3.bracesMode);
          return {
            startState: function() {
              return {
                stringType: null,
                commentType: null,
                braced: 0,
                lhs: true,
                localState: null,
                stack: [],
                inDefinition: false
              };
            },
            token: function(stream, state) {
              if (!stream)
                return;
              if (state.stack.length === 0) {
                if (stream.peek() == '"' || stream.peek() == "'") {
                  state.stringType = stream.peek();
                  stream.next();
                  state.stack.unshift(stateType._string);
                } else if (stream.match(/^\/\*/)) {
                  state.stack.unshift(stateType.comment);
                  state.commentType = commentType.slash;
                } else if (stream.match(/^\(\*/)) {
                  state.stack.unshift(stateType.comment);
                  state.commentType = commentType.parenthesis;
                }
              }
              switch (state.stack[0]) {
                case stateType._string:
                  while (state.stack[0] === stateType._string && !stream.eol()) {
                    if (stream.peek() === state.stringType) {
                      stream.next();
                      state.stack.shift();
                    } else if (stream.peek() === "\\") {
                      stream.next();
                      stream.next();
                    } else {
                      stream.match(/^.[^\\\"\']*/);
                    }
                  }
                  return state.lhs ? "property string" : "string";
                case stateType.comment:
                  while (state.stack[0] === stateType.comment && !stream.eol()) {
                    if (state.commentType === commentType.slash && stream.match(/\*\//)) {
                      state.stack.shift();
                      state.commentType = null;
                    } else if (state.commentType === commentType.parenthesis && stream.match(/\*\)/)) {
                      state.stack.shift();
                      state.commentType = null;
                    } else {
                      stream.match(/^.[^\*]*/);
                    }
                  }
                  return "comment";
                case stateType.characterClass:
                  while (state.stack[0] === stateType.characterClass && !stream.eol()) {
                    if (!(stream.match(/^[^\]\\]+/) || stream.match(/^\\./))) {
                      state.stack.shift();
                    }
                  }
                  return "operator";
              }
              var peek = stream.peek();
              if (bracesMode !== null && (state.braced || peek === "{")) {
                if (state.localState === null)
                  state.localState = CodeMirror5.startState(bracesMode);
                var token = bracesMode.token(stream, state.localState), text = stream.current();
                if (!token) {
                  for (var i3 = 0; i3 < text.length; i3++) {
                    if (text[i3] === "{") {
                      if (state.braced === 0) {
                        token = "matchingbracket";
                      }
                      state.braced++;
                    } else if (text[i3] === "}") {
                      state.braced--;
                      if (state.braced === 0) {
                        token = "matchingbracket";
                      }
                    }
                  }
                }
                return token;
              }
              switch (peek) {
                case "[":
                  stream.next();
                  state.stack.unshift(stateType.characterClass);
                  return "bracket";
                case ":":
                case "|":
                case ";":
                  stream.next();
                  return "operator";
                case "%":
                  if (stream.match("%%")) {
                    return "header";
                  } else if (stream.match(/[%][A-Za-z]+/)) {
                    return "keyword";
                  } else if (stream.match(/[%][}]/)) {
                    return "matchingbracket";
                  }
                  break;
                case "/":
                  if (stream.match(/[\/][A-Za-z]+/)) {
                    return "keyword";
                  }
                case "\\":
                  if (stream.match(/[\][a-z]+/)) {
                    return "string-2";
                  }
                case ".":
                  if (stream.match(".")) {
                    return "atom";
                  }
                case "*":
                case "-":
                case "+":
                case "^":
                  if (stream.match(peek)) {
                    return "atom";
                  }
                case "$":
                  if (stream.match("$$")) {
                    return "builtin";
                  } else if (stream.match(/[$][0-9]+/)) {
                    return "variable-3";
                  }
                case "<":
                  if (stream.match(/<<[a-zA-Z_]+>>/)) {
                    return "builtin";
                  }
              }
              if (stream.match(/^\/\//)) {
                stream.skipToEnd();
                return "comment";
              } else if (stream.match(/return/)) {
                return "operator";
              } else if (stream.match(/^[a-zA-Z_][a-zA-Z0-9_]*/)) {
                if (stream.match(/(?=[\(.])/)) {
                  return "variable";
                } else if (stream.match(/(?=[\s\n]*[:=])/)) {
                  return "def";
                }
                return "variable-2";
              } else if (["[", "]", "(", ")"].indexOf(stream.peek()) != -1) {
                stream.next();
                return "bracket";
              } else if (!stream.eatSpace()) {
                stream.next();
              }
              return null;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-ebnf", "ebnf");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/ecl/ecl.js
  var require_ecl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/ecl/ecl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("ecl", function(config3) {
          function words(str) {
            var obj = {}, words2 = str.split(" ");
            for (var i3 = 0; i3 < words2.length; ++i3)
              obj[words2[i3]] = true;
            return obj;
          }
          function metaHook(stream, state) {
            if (!state.startOfLine)
              return false;
            stream.skipToEnd();
            return "meta";
          }
          var indentUnit = config3.indentUnit;
          var keyword = words("abs acos allnodes ascii asin asstring atan atan2 ave case choose choosen choosesets clustersize combine correlation cos cosh count covariance cron dataset dedup define denormalize distribute distributed distribution ebcdic enth error evaluate event eventextra eventname exists exp failcode failmessage fetch fromunicode getisvalid global graph group hash hash32 hash64 hashcrc hashmd5 having if index intformat isvalid iterate join keyunicode length library limit ln local log loop map matched matchlength matchposition matchtext matchunicode max merge mergejoin min nolocal nonempty normalize parse pipe power preload process project pull random range rank ranked realformat recordof regexfind regexreplace regroup rejected rollup round roundup row rowdiff sample set sin sinh sizeof soapcall sort sorted sqrt stepped stored sum table tan tanh thisnode topn tounicode transfer trim truncate typeof ungroup unicodeorder variance which workunit xmldecode xmlencode xmltext xmlunicode");
          var variable = words("apply assert build buildindex evaluate fail keydiff keypatch loadxml nothor notify output parallel sequential soapcall wait");
          var variable_2 = words("__compressed__ all and any as atmost before beginc++ best between case const counter csv descend encrypt end endc++ endmacro except exclusive expire export extend false few first flat from full function group header heading hole ifblock import in interface joined keep keyed last left limit load local locale lookup macro many maxcount maxlength min skew module named nocase noroot noscan nosort not of only opt or outer overwrite packed partition penalty physicallength pipe quote record relationship repeat return right scan self separator service shared skew skip sql store terminator thor threshold token transform trim true type unicodeorder unsorted validate virtual whole wild within xml xpath");
          var variable_3 = words("ascii big_endian boolean data decimal ebcdic integer pattern qstring real record rule set of string token udecimal unicode unsigned varstring varunicode");
          var builtin = words("checkpoint deprecated failcode failmessage failure global independent onwarning persist priority recovery stored success wait when");
          var blockKeywords = words("catch class do else finally for if switch try while");
          var atoms = words("true false null");
          var hooks = { "#": metaHook };
          var isOperatorChar = /[+\-*&%=<>!?|\/]/;
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (hooks[ch]) {
              var result = hooks[ch](stream, state);
              if (result !== false)
                return result;
            }
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              curPunc = ch;
              return null;
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            }
            if (ch == "/") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_]/);
            var cur = stream.current().toLowerCase();
            if (keyword.propertyIsEnumerable(cur)) {
              if (blockKeywords.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "keyword";
            } else if (variable.propertyIsEnumerable(cur)) {
              if (blockKeywords.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "variable";
            } else if (variable_2.propertyIsEnumerable(cur)) {
              if (blockKeywords.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "variable-2";
            } else if (variable_3.propertyIsEnumerable(cur)) {
              if (blockKeywords.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "variable-3";
            } else if (builtin.propertyIsEnumerable(cur)) {
              if (blockKeywords.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "builtin";
            } else {
              var i3 = cur.length - 1;
              while (i3 >= 0 && (!isNaN(cur[i3]) || cur[i3] == "_"))
                --i3;
              if (i3 > 0) {
                var cur2 = cur.substr(0, i3 + 1);
                if (variable_3.propertyIsEnumerable(cur2)) {
                  if (blockKeywords.propertyIsEnumerable(cur2))
                    curPunc = "newstatement";
                  return "variable-3";
                }
              }
            }
            if (atoms.propertyIsEnumerable(cur))
              return "atom";
            return null;
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !escaped)
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            return state.context = new Context(state.indented, col, type, null, state.context);
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment" || style == "meta")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if ((curPunc == ";" || curPunc == ":") && ctx.type == "statement")
                popContext(state);
              else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if (ctx.type == "}" || ctx.type == "top" || ctx.type == "statement" && curPunc == "newstatement")
                pushContext(state, stream.column(), "statement");
              state.startOfLine = false;
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase && state.tokenize != null)
                return 0;
              var ctx = state.context, firstChar = textAfter && textAfter.charAt(0);
              if (ctx.type == "statement" && firstChar == "}")
                ctx = ctx.prev;
              var closing = firstChar == ctx.type;
              if (ctx.type == "statement")
                return ctx.indented + (firstChar == "{" ? 0 : indentUnit);
              else if (ctx.align)
                return ctx.column + (closing ? 0 : 1);
              else
                return ctx.indented + (closing ? 0 : indentUnit);
            },
            electricChars: "{}"
          };
        });
        CodeMirror5.defineMIME("text/x-ecl", "ecl");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/eiffel/eiffel.js
  var require_eiffel = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/eiffel/eiffel.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("eiffel", function() {
          function wordObj(words) {
            var o3 = {};
            for (var i3 = 0, e5 = words.length; i3 < e5; ++i3)
              o3[words[i3]] = true;
            return o3;
          }
          var keywords2 = wordObj([
            "note",
            "across",
            "when",
            "variant",
            "until",
            "unique",
            "undefine",
            "then",
            "strip",
            "select",
            "retry",
            "rescue",
            "require",
            "rename",
            "reference",
            "redefine",
            "prefix",
            "once",
            "old",
            "obsolete",
            "loop",
            "local",
            "like",
            "is",
            "inspect",
            "infix",
            "include",
            "if",
            "frozen",
            "from",
            "external",
            "export",
            "ensure",
            "end",
            "elseif",
            "else",
            "do",
            "creation",
            "create",
            "check",
            "alias",
            "agent",
            "separate",
            "invariant",
            "inherit",
            "indexing",
            "feature",
            "expanded",
            "deferred",
            "class",
            "Void",
            "True",
            "Result",
            "Precursor",
            "False",
            "Current",
            "create",
            "attached",
            "detachable",
            "as",
            "and",
            "implies",
            "not",
            "or"
          ]);
          var operators = wordObj([":=", "and then", "and", "or", "<<", ">>"]);
          function chain2(newtok, stream, state) {
            state.tokenize.push(newtok);
            return newtok(stream, state);
          }
          function tokenBase(stream, state) {
            if (stream.eatSpace())
              return null;
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              return chain2(readQuoted(ch, "string"), stream, state);
            } else if (ch == "-" && stream.eat("-")) {
              stream.skipToEnd();
              return "comment";
            } else if (ch == ":" && stream.eat("=")) {
              return "operator";
            } else if (/[0-9]/.test(ch)) {
              stream.eatWhile(/[xXbBCc0-9\.]/);
              stream.eat(/[\?\!]/);
              return "ident";
            } else if (/[a-zA-Z_0-9]/.test(ch)) {
              stream.eatWhile(/[a-zA-Z_0-9]/);
              stream.eat(/[\?\!]/);
              return "ident";
            } else if (/[=+\-\/*^%<>~]/.test(ch)) {
              stream.eatWhile(/[=+\-\/*^%<>~]/);
              return "operator";
            } else {
              return null;
            }
          }
          function readQuoted(quote, style, unescaped) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && (unescaped || !escaped)) {
                  state.tokenize.pop();
                  break;
                }
                escaped = !escaped && ch == "%";
              }
              return style;
            };
          }
          return {
            startState: function() {
              return { tokenize: [tokenBase] };
            },
            token: function(stream, state) {
              var style = state.tokenize[state.tokenize.length - 1](stream, state);
              if (style == "ident") {
                var word = stream.current();
                style = keywords2.propertyIsEnumerable(stream.current()) ? "keyword" : operators.propertyIsEnumerable(stream.current()) ? "operator" : /^[A-Z][A-Z_0-9]*$/g.test(word) ? "tag" : /^0[bB][0-1]+$/g.test(word) ? "number" : /^0[cC][0-7]+$/g.test(word) ? "number" : /^0[xX][a-fA-F0-9]+$/g.test(word) ? "number" : /^([0-9]+\.[0-9]*)|([0-9]*\.[0-9]+)$/g.test(word) ? "number" : /^[0-9]+$/g.test(word) ? "number" : "variable";
              }
              return style;
            },
            lineComment: "--"
          };
        });
        CodeMirror5.defineMIME("text/x-eiffel", "eiffel");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/elm/elm.js
  var require_elm = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/elm/elm.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("elm", function() {
          function switchState(source, setState, f3) {
            setState(f3);
            return f3(source, setState);
          }
          var lowerRE = /[a-z]/;
          var upperRE = /[A-Z]/;
          var innerRE = /[a-zA-Z0-9_]/;
          var digitRE = /[0-9]/;
          var hexRE = /[0-9A-Fa-f]/;
          var symbolRE = /[-&*+.\\/<>=?^|:]/;
          var specialRE = /[(),[\]{}]/;
          var spacesRE = /[ \v\f]/;
          function normal() {
            return function(source, setState) {
              if (source.eatWhile(spacesRE)) {
                return null;
              }
              var char = source.next();
              if (specialRE.test(char)) {
                return char === "{" && source.eat("-") ? switchState(source, setState, chompMultiComment(1)) : char === "[" && source.match("glsl|") ? switchState(source, setState, chompGlsl) : "builtin";
              }
              if (char === "'") {
                return switchState(source, setState, chompChar);
              }
              if (char === '"') {
                return source.eat('"') ? source.eat('"') ? switchState(source, setState, chompMultiString) : "string" : switchState(source, setState, chompSingleString);
              }
              if (upperRE.test(char)) {
                source.eatWhile(innerRE);
                return "variable-2";
              }
              if (lowerRE.test(char)) {
                var isDef = source.pos === 1;
                source.eatWhile(innerRE);
                return isDef ? "def" : "variable";
              }
              if (digitRE.test(char)) {
                if (char === "0") {
                  if (source.eat(/[xX]/)) {
                    source.eatWhile(hexRE);
                    return "number";
                  }
                } else {
                  source.eatWhile(digitRE);
                }
                if (source.eat(".")) {
                  source.eatWhile(digitRE);
                }
                if (source.eat(/[eE]/)) {
                  source.eat(/[-+]/);
                  source.eatWhile(digitRE);
                }
                return "number";
              }
              if (symbolRE.test(char)) {
                if (char === "-" && source.eat("-")) {
                  source.skipToEnd();
                  return "comment";
                }
                source.eatWhile(symbolRE);
                return "keyword";
              }
              if (char === "_") {
                return "keyword";
              }
              return "error";
            };
          }
          function chompMultiComment(nest) {
            if (nest == 0) {
              return normal();
            }
            return function(source, setState) {
              while (!source.eol()) {
                var char = source.next();
                if (char == "{" && source.eat("-")) {
                  ++nest;
                } else if (char == "-" && source.eat("}")) {
                  --nest;
                  if (nest === 0) {
                    setState(normal());
                    return "comment";
                  }
                }
              }
              setState(chompMultiComment(nest));
              return "comment";
            };
          }
          function chompMultiString(source, setState) {
            while (!source.eol()) {
              var char = source.next();
              if (char === '"' && source.eat('"') && source.eat('"')) {
                setState(normal());
                return "string";
              }
            }
            return "string";
          }
          function chompSingleString(source, setState) {
            while (source.skipTo('\\"')) {
              source.next();
              source.next();
            }
            if (source.skipTo('"')) {
              source.next();
              setState(normal());
              return "string";
            }
            source.skipToEnd();
            setState(normal());
            return "error";
          }
          function chompChar(source, setState) {
            while (source.skipTo("\\'")) {
              source.next();
              source.next();
            }
            if (source.skipTo("'")) {
              source.next();
              setState(normal());
              return "string";
            }
            source.skipToEnd();
            setState(normal());
            return "error";
          }
          function chompGlsl(source, setState) {
            while (!source.eol()) {
              var char = source.next();
              if (char === "|" && source.eat("]")) {
                setState(normal());
                return "string";
              }
            }
            return "string";
          }
          var wellKnownWords = {
            case: 1,
            of: 1,
            as: 1,
            if: 1,
            then: 1,
            else: 1,
            let: 1,
            in: 1,
            type: 1,
            alias: 1,
            module: 1,
            where: 1,
            import: 1,
            exposing: 1,
            port: 1
          };
          return {
            startState: function() {
              return { f: normal() };
            },
            copyState: function(s3) {
              return { f: s3.f };
            },
            token: function(stream, state) {
              var type = state.f(stream, function(s3) {
                state.f = s3;
              });
              var word = stream.current();
              return wellKnownWords.hasOwnProperty(word) ? "keyword" : type;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-elm", "elm");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/erlang/erlang.js
  var require_erlang = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/erlang/erlang.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMIME("text/x-erlang", "erlang");
        CodeMirror5.defineMode("erlang", function(cmCfg) {
          "use strict";
          var typeWords = [
            "-type",
            "-spec",
            "-export_type",
            "-opaque"
          ];
          var keywordWords = [
            "after",
            "begin",
            "catch",
            "case",
            "cond",
            "end",
            "fun",
            "if",
            "let",
            "of",
            "query",
            "receive",
            "try",
            "when"
          ];
          var separatorRE = /[\->,;]/;
          var separatorWords = [
            "->",
            ";",
            ","
          ];
          var operatorAtomWords = [
            "and",
            "andalso",
            "band",
            "bnot",
            "bor",
            "bsl",
            "bsr",
            "bxor",
            "div",
            "not",
            "or",
            "orelse",
            "rem",
            "xor"
          ];
          var operatorSymbolRE = /[\+\-\*\/<>=\|:!]/;
          var operatorSymbolWords = [
            "=",
            "+",
            "-",
            "*",
            "/",
            ">",
            ">=",
            "<",
            "=<",
            "=:=",
            "==",
            "=/=",
            "/=",
            "||",
            "<-",
            "!"
          ];
          var openParenRE = /[<\(\[\{]/;
          var openParenWords = [
            "<<",
            "(",
            "[",
            "{"
          ];
          var closeParenRE = /[>\)\]\}]/;
          var closeParenWords = [
            "}",
            "]",
            ")",
            ">>"
          ];
          var guardWords = [
            "is_atom",
            "is_binary",
            "is_bitstring",
            "is_boolean",
            "is_float",
            "is_function",
            "is_integer",
            "is_list",
            "is_number",
            "is_pid",
            "is_port",
            "is_record",
            "is_reference",
            "is_tuple",
            "atom",
            "binary",
            "bitstring",
            "boolean",
            "function",
            "integer",
            "list",
            "number",
            "pid",
            "port",
            "record",
            "reference",
            "tuple"
          ];
          var bifWords = [
            "abs",
            "adler32",
            "adler32_combine",
            "alive",
            "apply",
            "atom_to_binary",
            "atom_to_list",
            "binary_to_atom",
            "binary_to_existing_atom",
            "binary_to_list",
            "binary_to_term",
            "bit_size",
            "bitstring_to_list",
            "byte_size",
            "check_process_code",
            "contact_binary",
            "crc32",
            "crc32_combine",
            "date",
            "decode_packet",
            "delete_module",
            "disconnect_node",
            "element",
            "erase",
            "exit",
            "float",
            "float_to_list",
            "garbage_collect",
            "get",
            "get_keys",
            "group_leader",
            "halt",
            "hd",
            "integer_to_list",
            "internal_bif",
            "iolist_size",
            "iolist_to_binary",
            "is_alive",
            "is_atom",
            "is_binary",
            "is_bitstring",
            "is_boolean",
            "is_float",
            "is_function",
            "is_integer",
            "is_list",
            "is_number",
            "is_pid",
            "is_port",
            "is_process_alive",
            "is_record",
            "is_reference",
            "is_tuple",
            "length",
            "link",
            "list_to_atom",
            "list_to_binary",
            "list_to_bitstring",
            "list_to_existing_atom",
            "list_to_float",
            "list_to_integer",
            "list_to_pid",
            "list_to_tuple",
            "load_module",
            "make_ref",
            "module_loaded",
            "monitor_node",
            "node",
            "node_link",
            "node_unlink",
            "nodes",
            "notalive",
            "now",
            "open_port",
            "pid_to_list",
            "port_close",
            "port_command",
            "port_connect",
            "port_control",
            "pre_loaded",
            "process_flag",
            "process_info",
            "processes",
            "purge_module",
            "put",
            "register",
            "registered",
            "round",
            "self",
            "setelement",
            "size",
            "spawn",
            "spawn_link",
            "spawn_monitor",
            "spawn_opt",
            "split_binary",
            "statistics",
            "term_to_binary",
            "time",
            "throw",
            "tl",
            "trunc",
            "tuple_size",
            "tuple_to_list",
            "unlink",
            "unregister",
            "whereis"
          ];
          var anumRE = /[\w@Ø-ÞÀ-Öß-öø-ÿ]/;
          var escapesRE = /[0-7]{1,3}|[bdefnrstv\\"']|\^[a-zA-Z]|x[0-9a-zA-Z]{2}|x{[0-9a-zA-Z]+}/;
          function tokenizer(stream, state) {
            if (state.in_string) {
              state.in_string = !doubleQuote(stream);
              return rval(state, stream, "string");
            }
            if (state.in_atom) {
              state.in_atom = !singleQuote(stream);
              return rval(state, stream, "atom");
            }
            if (stream.eatSpace()) {
              return rval(state, stream, "whitespace");
            }
            if (!peekToken(state) && stream.match(/-\s*[a-zß-öø-ÿ][\wØ-ÞÀ-Öß-öø-ÿ]*/)) {
              if (is_member(stream.current(), typeWords)) {
                return rval(state, stream, "type");
              } else {
                return rval(state, stream, "attribute");
              }
            }
            var ch = stream.next();
            if (ch == "%") {
              stream.skipToEnd();
              return rval(state, stream, "comment");
            }
            if (ch == ":") {
              return rval(state, stream, "colon");
            }
            if (ch == "?") {
              stream.eatSpace();
              stream.eatWhile(anumRE);
              return rval(state, stream, "macro");
            }
            if (ch == "#") {
              stream.eatSpace();
              stream.eatWhile(anumRE);
              return rval(state, stream, "record");
            }
            if (ch == "$") {
              if (stream.next() == "\\" && !stream.match(escapesRE)) {
                return rval(state, stream, "error");
              }
              return rval(state, stream, "number");
            }
            if (ch == ".") {
              return rval(state, stream, "dot");
            }
            if (ch == "'") {
              if (!(state.in_atom = !singleQuote(stream))) {
                if (stream.match(/\s*\/\s*[0-9]/, false)) {
                  stream.match(/\s*\/\s*[0-9]/, true);
                  return rval(state, stream, "fun");
                }
                if (stream.match(/\s*\(/, false) || stream.match(/\s*:/, false)) {
                  return rval(state, stream, "function");
                }
              }
              return rval(state, stream, "atom");
            }
            if (ch == '"') {
              state.in_string = !doubleQuote(stream);
              return rval(state, stream, "string");
            }
            if (/[A-Z_Ø-ÞÀ-Ö]/.test(ch)) {
              stream.eatWhile(anumRE);
              return rval(state, stream, "variable");
            }
            if (/[a-z_ß-öø-ÿ]/.test(ch)) {
              stream.eatWhile(anumRE);
              if (stream.match(/\s*\/\s*[0-9]/, false)) {
                stream.match(/\s*\/\s*[0-9]/, true);
                return rval(state, stream, "fun");
              }
              var w3 = stream.current();
              if (is_member(w3, keywordWords)) {
                return rval(state, stream, "keyword");
              } else if (is_member(w3, operatorAtomWords)) {
                return rval(state, stream, "operator");
              } else if (stream.match(/\s*\(/, false)) {
                if (is_member(w3, bifWords) && (peekToken(state).token != ":" || peekToken(state, 2).token == "erlang")) {
                  return rval(state, stream, "builtin");
                } else if (is_member(w3, guardWords)) {
                  return rval(state, stream, "guard");
                } else {
                  return rval(state, stream, "function");
                }
              } else if (lookahead(stream) == ":") {
                if (w3 == "erlang") {
                  return rval(state, stream, "builtin");
                } else {
                  return rval(state, stream, "function");
                }
              } else if (is_member(w3, ["true", "false"])) {
                return rval(state, stream, "boolean");
              } else {
                return rval(state, stream, "atom");
              }
            }
            var digitRE = /[0-9]/;
            var radixRE = /[0-9a-zA-Z]/;
            if (digitRE.test(ch)) {
              stream.eatWhile(digitRE);
              if (stream.eat("#")) {
                if (!stream.eatWhile(radixRE)) {
                  stream.backUp(1);
                }
              } else if (stream.eat(".")) {
                if (!stream.eatWhile(digitRE)) {
                  stream.backUp(1);
                } else {
                  if (stream.eat(/[eE]/)) {
                    if (stream.eat(/[-+]/)) {
                      if (!stream.eatWhile(digitRE)) {
                        stream.backUp(2);
                      }
                    } else {
                      if (!stream.eatWhile(digitRE)) {
                        stream.backUp(1);
                      }
                    }
                  }
                }
              }
              return rval(state, stream, "number");
            }
            if (nongreedy(stream, openParenRE, openParenWords)) {
              return rval(state, stream, "open_paren");
            }
            if (nongreedy(stream, closeParenRE, closeParenWords)) {
              return rval(state, stream, "close_paren");
            }
            if (greedy(stream, separatorRE, separatorWords)) {
              return rval(state, stream, "separator");
            }
            if (greedy(stream, operatorSymbolRE, operatorSymbolWords)) {
              return rval(state, stream, "operator");
            }
            return rval(state, stream, null);
          }
          function nongreedy(stream, re, words) {
            if (stream.current().length == 1 && re.test(stream.current())) {
              stream.backUp(1);
              while (re.test(stream.peek())) {
                stream.next();
                if (is_member(stream.current(), words)) {
                  return true;
                }
              }
              stream.backUp(stream.current().length - 1);
            }
            return false;
          }
          function greedy(stream, re, words) {
            if (stream.current().length == 1 && re.test(stream.current())) {
              while (re.test(stream.peek())) {
                stream.next();
              }
              while (0 < stream.current().length) {
                if (is_member(stream.current(), words)) {
                  return true;
                } else {
                  stream.backUp(1);
                }
              }
              stream.next();
            }
            return false;
          }
          function doubleQuote(stream) {
            return quote(stream, '"', "\\");
          }
          function singleQuote(stream) {
            return quote(stream, "'", "\\");
          }
          function quote(stream, quoteChar, escapeChar) {
            while (!stream.eol()) {
              var ch = stream.next();
              if (ch == quoteChar) {
                return true;
              } else if (ch == escapeChar) {
                stream.next();
              }
            }
            return false;
          }
          function lookahead(stream) {
            var m3 = stream.match(/([\n\s]+|%[^\n]*\n)*(.)/, false);
            return m3 ? m3.pop() : "";
          }
          function is_member(element3, list) {
            return -1 < list.indexOf(element3);
          }
          function rval(state, stream, type) {
            pushToken(state, realToken(type, stream));
            switch (type) {
              case "atom":
                return "atom";
              case "attribute":
                return "attribute";
              case "boolean":
                return "atom";
              case "builtin":
                return "builtin";
              case "close_paren":
                return null;
              case "colon":
                return null;
              case "comment":
                return "comment";
              case "dot":
                return null;
              case "error":
                return "error";
              case "fun":
                return "meta";
              case "function":
                return "tag";
              case "guard":
                return "property";
              case "keyword":
                return "keyword";
              case "macro":
                return "variable-2";
              case "number":
                return "number";
              case "open_paren":
                return null;
              case "operator":
                return "operator";
              case "record":
                return "bracket";
              case "separator":
                return null;
              case "string":
                return "string";
              case "type":
                return "def";
              case "variable":
                return "variable";
              default:
                return null;
            }
          }
          function aToken(tok, col, ind, typ) {
            return {
              token: tok,
              column: col,
              indent: ind,
              type: typ
            };
          }
          function realToken(type, stream) {
            return aToken(stream.current(), stream.column(), stream.indentation(), type);
          }
          function fakeToken(type) {
            return aToken(type, 0, 0, type);
          }
          function peekToken(state, depth) {
            var len = state.tokenStack.length;
            var dep = depth ? depth : 1;
            if (len < dep) {
              return false;
            } else {
              return state.tokenStack[len - dep];
            }
          }
          function pushToken(state, token) {
            if (!(token.type == "comment" || token.type == "whitespace")) {
              state.tokenStack = maybe_drop_pre(state.tokenStack, token);
              state.tokenStack = maybe_drop_post(state.tokenStack);
            }
          }
          function maybe_drop_pre(s3, token) {
            var last = s3.length - 1;
            if (0 < last && s3[last].type === "record" && token.type === "dot") {
              s3.pop();
            } else if (0 < last && s3[last].type === "group") {
              s3.pop();
              s3.push(token);
            } else {
              s3.push(token);
            }
            return s3;
          }
          function maybe_drop_post(s3) {
            if (!s3.length)
              return s3;
            var last = s3.length - 1;
            if (s3[last].type === "dot") {
              return [];
            }
            if (last > 1 && s3[last].type === "fun" && s3[last - 1].token === "fun") {
              return s3.slice(0, last - 1);
            }
            switch (s3[last].token) {
              case "}":
                return d4(s3, { g: ["{"] });
              case "]":
                return d4(s3, { i: ["["] });
              case ")":
                return d4(s3, { i: ["("] });
              case ">>":
                return d4(s3, { i: ["<<"] });
              case "end":
                return d4(s3, { i: ["begin", "case", "fun", "if", "receive", "try"] });
              case ",":
                return d4(s3, { e: [
                  "begin",
                  "try",
                  "when",
                  "->",
                  ",",
                  "(",
                  "[",
                  "{",
                  "<<"
                ] });
              case "->":
                return d4(s3, {
                  r: ["when"],
                  m: ["try", "if", "case", "receive"]
                });
              case ";":
                return d4(s3, { E: ["case", "fun", "if", "receive", "try", "when"] });
              case "catch":
                return d4(s3, { e: ["try"] });
              case "of":
                return d4(s3, { e: ["case"] });
              case "after":
                return d4(s3, { e: ["receive", "try"] });
              default:
                return s3;
            }
          }
          function d4(stack, tt) {
            for (var type in tt) {
              var len = stack.length - 1;
              var tokens = tt[type];
              for (var i3 = len - 1; -1 < i3; i3--) {
                if (is_member(stack[i3].token, tokens)) {
                  var ss = stack.slice(0, i3);
                  switch (type) {
                    case "m":
                      return ss.concat(stack[i3]).concat(stack[len]);
                    case "r":
                      return ss.concat(stack[len]);
                    case "i":
                      return ss;
                    case "g":
                      return ss.concat(fakeToken("group"));
                    case "E":
                      return ss.concat(stack[i3]);
                    case "e":
                      return ss.concat(stack[i3]);
                  }
                }
              }
            }
            return type == "E" ? [] : stack;
          }
          function indenter(state, textAfter) {
            var t3;
            var unit = cmCfg.indentUnit;
            var wordAfter = wordafter(textAfter);
            var currT = peekToken(state, 1);
            var prevT = peekToken(state, 2);
            if (state.in_string || state.in_atom) {
              return CodeMirror5.Pass;
            } else if (!prevT) {
              return 0;
            } else if (currT.token == "when") {
              return currT.column + unit;
            } else if (wordAfter === "when" && prevT.type === "function") {
              return prevT.indent + unit;
            } else if (wordAfter === "(" && currT.token === "fun") {
              return currT.column + 3;
            } else if (wordAfter === "catch" && (t3 = getToken(state, ["try"]))) {
              return t3.column;
            } else if (is_member(wordAfter, ["end", "after", "of"])) {
              t3 = getToken(state, ["begin", "case", "fun", "if", "receive", "try"]);
              return t3 ? t3.column : CodeMirror5.Pass;
            } else if (is_member(wordAfter, closeParenWords)) {
              t3 = getToken(state, openParenWords);
              return t3 ? t3.column : CodeMirror5.Pass;
            } else if (is_member(currT.token, [",", "|", "||"]) || is_member(wordAfter, [",", "|", "||"])) {
              t3 = postcommaToken(state);
              return t3 ? t3.column + t3.token.length : unit;
            } else if (currT.token == "->") {
              if (is_member(prevT.token, ["receive", "case", "if", "try"])) {
                return prevT.column + unit + unit;
              } else {
                return prevT.column + unit;
              }
            } else if (is_member(currT.token, openParenWords)) {
              return currT.column + currT.token.length;
            } else {
              t3 = defaultToken(state);
              return truthy(t3) ? t3.column + unit : 0;
            }
          }
          function wordafter(str) {
            var m3 = str.match(/,|[a-z]+|\}|\]|\)|>>|\|+|\(/);
            return truthy(m3) && m3.index === 0 ? m3[0] : "";
          }
          function postcommaToken(state) {
            var objs = state.tokenStack.slice(0, -1);
            var i3 = getTokenIndex(objs, "type", ["open_paren"]);
            return truthy(objs[i3]) ? objs[i3] : false;
          }
          function defaultToken(state) {
            var objs = state.tokenStack;
            var stop2 = getTokenIndex(objs, "type", ["open_paren", "separator", "keyword"]);
            var oper = getTokenIndex(objs, "type", ["operator"]);
            if (truthy(stop2) && truthy(oper) && stop2 < oper) {
              return objs[stop2 + 1];
            } else if (truthy(stop2)) {
              return objs[stop2];
            } else {
              return false;
            }
          }
          function getToken(state, tokens) {
            var objs = state.tokenStack;
            var i3 = getTokenIndex(objs, "token", tokens);
            return truthy(objs[i3]) ? objs[i3] : false;
          }
          function getTokenIndex(objs, propname, propvals) {
            for (var i3 = objs.length - 1; -1 < i3; i3--) {
              if (is_member(objs[i3][propname], propvals)) {
                return i3;
              }
            }
            return false;
          }
          function truthy(x3) {
            return x3 !== false && x3 != null;
          }
          return {
            startState: function() {
              return {
                tokenStack: [],
                in_string: false,
                in_atom: false
              };
            },
            token: function(stream, state) {
              return tokenizer(stream, state);
            },
            indent: function(state, textAfter) {
              return indenter(state, textAfter);
            },
            lineComment: "%"
          };
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/factor/factor.js
  var require_factor = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/factor/factor.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_simple());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../../addon/mode/simple"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineSimpleMode("factor", {
          start: [
            { regex: /#?!.*/, token: "comment" },
            { regex: /"""/, token: "string", next: "string3" },
            { regex: /(STRING:)(\s)/, token: ["keyword", null], next: "string2" },
            { regex: /\S*?"/, token: "string", next: "string" },
            { regex: /(?:0x[\d,a-f]+)|(?:0o[0-7]+)|(?:0b[0,1]+)|(?:\-?\d+.?\d*)(?=\s)/, token: "number" },
            { regex: /((?:GENERIC)|\:?\:)(\s+)(\S+)(\s+)(\()/, token: ["keyword", null, "def", null, "bracket"], next: "stack" },
            { regex: /(M\:)(\s+)(\S+)(\s+)(\S+)/, token: ["keyword", null, "def", null, "tag"] },
            { regex: /USING\:/, token: "keyword", next: "vocabulary" },
            { regex: /(USE\:|IN\:)(\s+)(\S+)(?=\s|$)/, token: ["keyword", null, "tag"] },
            { regex: /(\S+\:)(\s+)(\S+)(?=\s|$)/, token: ["keyword", null, "def"] },
            { regex: /(?:;|\\|t|f|if|loop|while|until|do|PRIVATE>|<PRIVATE|\.|\S*\[|\]|\S*\{|\})(?=\s|$)/, token: "keyword" },
            { regex: /\S+[\)>\.\*\?]+(?=\s|$)/, token: "builtin" },
            { regex: /[\)><]+\S+(?=\s|$)/, token: "builtin" },
            { regex: /(?:[\+\-\=\/\*<>])(?=\s|$)/, token: "keyword" },
            { regex: /\S+/, token: "variable" },
            { regex: /\s+|./, token: null }
          ],
          vocabulary: [
            { regex: /;/, token: "keyword", next: "start" },
            { regex: /\S+/, token: "tag" },
            { regex: /\s+|./, token: null }
          ],
          string: [
            { regex: /(?:[^\\]|\\.)*?"/, token: "string", next: "start" },
            { regex: /.*/, token: "string" }
          ],
          string2: [
            { regex: /^;/, token: "keyword", next: "start" },
            { regex: /.*/, token: "string" }
          ],
          string3: [
            { regex: /(?:[^\\]|\\.)*?"""/, token: "string", next: "start" },
            { regex: /.*/, token: "string" }
          ],
          stack: [
            { regex: /\)/, token: "bracket", next: "start" },
            { regex: /--/, token: "bracket" },
            { regex: /\S+/, token: "meta" },
            { regex: /\s+|./, token: null }
          ],
          meta: {
            dontIndentStates: ["start", "vocabulary", "string", "string3", "stack"],
            lineComment: ["!", "#!"]
          }
        });
        CodeMirror5.defineMIME("text/x-factor", "factor");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/fcl/fcl.js
  var require_fcl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/fcl/fcl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("fcl", function(config3) {
          var indentUnit = config3.indentUnit;
          var keywords2 = {
            "term": true,
            "method": true,
            "accu": true,
            "rule": true,
            "then": true,
            "is": true,
            "and": true,
            "or": true,
            "if": true,
            "default": true
          };
          var start_blocks = {
            "var_input": true,
            "var_output": true,
            "fuzzify": true,
            "defuzzify": true,
            "function_block": true,
            "ruleblock": true
          };
          var end_blocks = {
            "end_ruleblock": true,
            "end_defuzzify": true,
            "end_function_block": true,
            "end_fuzzify": true,
            "end_var": true
          };
          var atoms = {
            "true": true,
            "false": true,
            "nan": true,
            "real": true,
            "min": true,
            "max": true,
            "cog": true,
            "cogs": true
          };
          var isOperatorChar = /[+\-*&^%:=<>!|\/]/;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (/[\d\.]/.test(ch)) {
              if (ch == ".") {
                stream.match(/^[0-9]+([eE][\-+]?[0-9]+)?/);
              } else if (ch == "0") {
                stream.match(/^[xX][0-9a-fA-F]+/) || stream.match(/^0[0-7]+/);
              } else {
                stream.match(/^[0-9]*\.?[0-9]*([eE][\-+]?[0-9]+)?/);
              }
              return "number";
            }
            if (ch == "/" || ch == "(") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_\xa1-\uffff]/);
            var cur = stream.current().toLowerCase();
            if (keywords2.propertyIsEnumerable(cur) || start_blocks.propertyIsEnumerable(cur) || end_blocks.propertyIsEnumerable(cur)) {
              return "keyword";
            }
            if (atoms.propertyIsEnumerable(cur))
              return "atom";
            return "variable";
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if ((ch == "/" || ch == ")") && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            return state.context = new Context(state.indented, col, type, null, state.context);
          }
          function popContext(state) {
            if (!state.context.prev)
              return;
            var t3 = state.context.type;
            if (t3 == "end_block")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              var cur = stream.current().toLowerCase();
              if (start_blocks.propertyIsEnumerable(cur))
                pushContext(state, stream.column(), "end_block");
              else if (end_blocks.propertyIsEnumerable(cur))
                popContext(state);
              state.startOfLine = false;
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase && state.tokenize != null)
                return 0;
              var ctx = state.context;
              var closing = end_blocks.propertyIsEnumerable(textAfter);
              if (ctx.align)
                return ctx.column + (closing ? 0 : 1);
              else
                return ctx.indented + (closing ? 0 : indentUnit);
            },
            electricChars: "ryk",
            fold: "brace",
            blockCommentStart: "(*",
            blockCommentEnd: "*)",
            lineComment: "//"
          };
        });
        CodeMirror5.defineMIME("text/x-fcl", "fcl");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/forth/forth.js
  var require_forth = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/forth/forth.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function toWordList(words) {
          var ret = [];
          words.split(" ").forEach(function(e5) {
            ret.push({ name: e5 });
          });
          return ret;
        }
        var coreWordList = toWordList("INVERT AND OR XOR 2* 2/ LSHIFT RSHIFT 0= = 0< < > U< MIN MAX 2DROP 2DUP 2OVER 2SWAP ?DUP DEPTH DROP DUP OVER ROT SWAP >R R> R@ + - 1+ 1- ABS NEGATE S>D * M* UM* FM/MOD SM/REM UM/MOD */ */MOD / /MOD MOD HERE , @ ! CELL+ CELLS C, C@ C! CHARS 2@ 2! ALIGN ALIGNED +! ALLOT CHAR [CHAR] [ ] BL FIND EXECUTE IMMEDIATE COUNT LITERAL STATE ; DOES> >BODY EVALUATE SOURCE >IN <# # #S #> HOLD SIGN BASE >NUMBER HEX DECIMAL FILL MOVE . CR EMIT SPACE SPACES TYPE U. .R U.R ACCEPT TRUE FALSE <> U> 0<> 0> NIP TUCK ROLL PICK 2>R 2R@ 2R> WITHIN UNUSED MARKER I J TO COMPILE, [COMPILE] SAVE-INPUT RESTORE-INPUT PAD ERASE 2LITERAL DNEGATE D- D+ D0< D0= D2* D2/ D< D= DMAX DMIN D>S DABS M+ M*/ D. D.R 2ROT DU< CATCH THROW FREE RESIZE ALLOCATE CS-PICK CS-ROLL GET-CURRENT SET-CURRENT FORTH-WORDLIST GET-ORDER SET-ORDER PREVIOUS SEARCH-WORDLIST WORDLIST FIND ALSO ONLY FORTH DEFINITIONS ORDER -TRAILING /STRING SEARCH COMPARE CMOVE CMOVE> BLANK SLITERAL");
        var immediateWordList = toWordList("IF ELSE THEN BEGIN WHILE REPEAT UNTIL RECURSE [IF] [ELSE] [THEN] ?DO DO LOOP +LOOP UNLOOP LEAVE EXIT AGAIN CASE OF ENDOF ENDCASE");
        CodeMirror5.defineMode("forth", function() {
          function searchWordList(wordList, word) {
            var i3;
            for (i3 = wordList.length - 1; i3 >= 0; i3--) {
              if (wordList[i3].name === word.toUpperCase()) {
                return wordList[i3];
              }
            }
            return void 0;
          }
          return {
            startState: function() {
              return {
                state: "",
                base: 10,
                coreWordList,
                immediateWordList,
                wordList: []
              };
            },
            token: function(stream, stt) {
              var mat;
              if (stream.eatSpace()) {
                return null;
              }
              if (stt.state === "") {
                if (stream.match(/^(\]|:NONAME)(\s|$)/i)) {
                  stt.state = " compilation";
                  return "builtin compilation";
                }
                mat = stream.match(/^(\:)\s+(\S+)(\s|$)+/);
                if (mat) {
                  stt.wordList.push({ name: mat[2].toUpperCase() });
                  stt.state = " compilation";
                  return "def" + stt.state;
                }
                mat = stream.match(/^(VARIABLE|2VARIABLE|CONSTANT|2CONSTANT|CREATE|POSTPONE|VALUE|WORD)\s+(\S+)(\s|$)+/i);
                if (mat) {
                  stt.wordList.push({ name: mat[2].toUpperCase() });
                  return "def" + stt.state;
                }
                mat = stream.match(/^(\'|\[\'\])\s+(\S+)(\s|$)+/);
                if (mat) {
                  return "builtin" + stt.state;
                }
              } else {
                if (stream.match(/^(\;|\[)(\s)/)) {
                  stt.state = "";
                  stream.backUp(1);
                  return "builtin compilation";
                }
                if (stream.match(/^(\;|\[)($)/)) {
                  stt.state = "";
                  return "builtin compilation";
                }
                if (stream.match(/^(POSTPONE)\s+\S+(\s|$)+/)) {
                  return "builtin";
                }
              }
              mat = stream.match(/^(\S+)(\s+|$)/);
              if (mat) {
                if (searchWordList(stt.wordList, mat[1]) !== void 0) {
                  return "variable" + stt.state;
                }
                if (mat[1] === "\\") {
                  stream.skipToEnd();
                  return "comment" + stt.state;
                }
                if (searchWordList(stt.coreWordList, mat[1]) !== void 0) {
                  return "builtin" + stt.state;
                }
                if (searchWordList(stt.immediateWordList, mat[1]) !== void 0) {
                  return "keyword" + stt.state;
                }
                if (mat[1] === "(") {
                  stream.eatWhile(function(s3) {
                    return s3 !== ")";
                  });
                  stream.eat(")");
                  return "comment" + stt.state;
                }
                if (mat[1] === ".(") {
                  stream.eatWhile(function(s3) {
                    return s3 !== ")";
                  });
                  stream.eat(")");
                  return "string" + stt.state;
                }
                if (mat[1] === 'S"' || mat[1] === '."' || mat[1] === 'C"') {
                  stream.eatWhile(function(s3) {
                    return s3 !== '"';
                  });
                  stream.eat('"');
                  return "string" + stt.state;
                }
                if (mat[1] - 68719476735) {
                  return "number" + stt.state;
                }
                return "atom" + stt.state;
              }
            }
          };
        });
        CodeMirror5.defineMIME("text/x-forth", "forth");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/fortran/fortran.js
  var require_fortran = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/fortran/fortran.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("fortran", function() {
          function words(array) {
            var keys = {};
            for (var i3 = 0; i3 < array.length; ++i3) {
              keys[array[i3]] = true;
            }
            return keys;
          }
          var keywords2 = words([
            "abstract",
            "accept",
            "allocatable",
            "allocate",
            "array",
            "assign",
            "asynchronous",
            "backspace",
            "bind",
            "block",
            "byte",
            "call",
            "case",
            "class",
            "close",
            "common",
            "contains",
            "continue",
            "cycle",
            "data",
            "deallocate",
            "decode",
            "deferred",
            "dimension",
            "do",
            "elemental",
            "else",
            "encode",
            "end",
            "endif",
            "entry",
            "enumerator",
            "equivalence",
            "exit",
            "external",
            "extrinsic",
            "final",
            "forall",
            "format",
            "function",
            "generic",
            "go",
            "goto",
            "if",
            "implicit",
            "import",
            "include",
            "inquire",
            "intent",
            "interface",
            "intrinsic",
            "module",
            "namelist",
            "non_intrinsic",
            "non_overridable",
            "none",
            "nopass",
            "nullify",
            "open",
            "optional",
            "options",
            "parameter",
            "pass",
            "pause",
            "pointer",
            "print",
            "private",
            "program",
            "protected",
            "public",
            "pure",
            "read",
            "recursive",
            "result",
            "return",
            "rewind",
            "save",
            "select",
            "sequence",
            "stop",
            "subroutine",
            "target",
            "then",
            "to",
            "type",
            "use",
            "value",
            "volatile",
            "where",
            "while",
            "write"
          ]);
          var builtins = words([
            "abort",
            "abs",
            "access",
            "achar",
            "acos",
            "adjustl",
            "adjustr",
            "aimag",
            "aint",
            "alarm",
            "all",
            "allocated",
            "alog",
            "amax",
            "amin",
            "amod",
            "and",
            "anint",
            "any",
            "asin",
            "associated",
            "atan",
            "besj",
            "besjn",
            "besy",
            "besyn",
            "bit_size",
            "btest",
            "cabs",
            "ccos",
            "ceiling",
            "cexp",
            "char",
            "chdir",
            "chmod",
            "clog",
            "cmplx",
            "command_argument_count",
            "complex",
            "conjg",
            "cos",
            "cosh",
            "count",
            "cpu_time",
            "cshift",
            "csin",
            "csqrt",
            "ctime",
            "c_funloc",
            "c_loc",
            "c_associated",
            "c_null_ptr",
            "c_null_funptr",
            "c_f_pointer",
            "c_null_char",
            "c_alert",
            "c_backspace",
            "c_form_feed",
            "c_new_line",
            "c_carriage_return",
            "c_horizontal_tab",
            "c_vertical_tab",
            "dabs",
            "dacos",
            "dasin",
            "datan",
            "date_and_time",
            "dbesj",
            "dbesj",
            "dbesjn",
            "dbesy",
            "dbesy",
            "dbesyn",
            "dble",
            "dcos",
            "dcosh",
            "ddim",
            "derf",
            "derfc",
            "dexp",
            "digits",
            "dim",
            "dint",
            "dlog",
            "dlog",
            "dmax",
            "dmin",
            "dmod",
            "dnint",
            "dot_product",
            "dprod",
            "dsign",
            "dsinh",
            "dsin",
            "dsqrt",
            "dtanh",
            "dtan",
            "dtime",
            "eoshift",
            "epsilon",
            "erf",
            "erfc",
            "etime",
            "exit",
            "exp",
            "exponent",
            "extends_type_of",
            "fdate",
            "fget",
            "fgetc",
            "float",
            "floor",
            "flush",
            "fnum",
            "fputc",
            "fput",
            "fraction",
            "fseek",
            "fstat",
            "ftell",
            "gerror",
            "getarg",
            "get_command",
            "get_command_argument",
            "get_environment_variable",
            "getcwd",
            "getenv",
            "getgid",
            "getlog",
            "getpid",
            "getuid",
            "gmtime",
            "hostnm",
            "huge",
            "iabs",
            "iachar",
            "iand",
            "iargc",
            "ibclr",
            "ibits",
            "ibset",
            "ichar",
            "idate",
            "idim",
            "idint",
            "idnint",
            "ieor",
            "ierrno",
            "ifix",
            "imag",
            "imagpart",
            "index",
            "int",
            "ior",
            "irand",
            "isatty",
            "ishft",
            "ishftc",
            "isign",
            "iso_c_binding",
            "is_iostat_end",
            "is_iostat_eor",
            "itime",
            "kill",
            "kind",
            "lbound",
            "len",
            "len_trim",
            "lge",
            "lgt",
            "link",
            "lle",
            "llt",
            "lnblnk",
            "loc",
            "log",
            "logical",
            "long",
            "lshift",
            "lstat",
            "ltime",
            "matmul",
            "max",
            "maxexponent",
            "maxloc",
            "maxval",
            "mclock",
            "merge",
            "move_alloc",
            "min",
            "minexponent",
            "minloc",
            "minval",
            "mod",
            "modulo",
            "mvbits",
            "nearest",
            "new_line",
            "nint",
            "not",
            "or",
            "pack",
            "perror",
            "precision",
            "present",
            "product",
            "radix",
            "rand",
            "random_number",
            "random_seed",
            "range",
            "real",
            "realpart",
            "rename",
            "repeat",
            "reshape",
            "rrspacing",
            "rshift",
            "same_type_as",
            "scale",
            "scan",
            "second",
            "selected_int_kind",
            "selected_real_kind",
            "set_exponent",
            "shape",
            "short",
            "sign",
            "signal",
            "sinh",
            "sin",
            "sleep",
            "sngl",
            "spacing",
            "spread",
            "sqrt",
            "srand",
            "stat",
            "sum",
            "symlnk",
            "system",
            "system_clock",
            "tan",
            "tanh",
            "time",
            "tiny",
            "transfer",
            "transpose",
            "trim",
            "ttynam",
            "ubound",
            "umask",
            "unlink",
            "unpack",
            "verify",
            "xor",
            "zabs",
            "zcos",
            "zexp",
            "zlog",
            "zsin",
            "zsqrt"
          ]);
          var dataTypes = words([
            "c_bool",
            "c_char",
            "c_double",
            "c_double_complex",
            "c_float",
            "c_float_complex",
            "c_funptr",
            "c_int",
            "c_int16_t",
            "c_int32_t",
            "c_int64_t",
            "c_int8_t",
            "c_int_fast16_t",
            "c_int_fast32_t",
            "c_int_fast64_t",
            "c_int_fast8_t",
            "c_int_least16_t",
            "c_int_least32_t",
            "c_int_least64_t",
            "c_int_least8_t",
            "c_intmax_t",
            "c_intptr_t",
            "c_long",
            "c_long_double",
            "c_long_double_complex",
            "c_long_long",
            "c_ptr",
            "c_short",
            "c_signed_char",
            "c_size_t",
            "character",
            "complex",
            "double",
            "integer",
            "logical",
            "real"
          ]);
          var isOperatorChar = /[+\-*&=<>\/\:]/;
          var litOperator = new RegExp("(.and.|.or.|.eq.|.lt.|.le.|.gt.|.ge.|.ne.|.not.|.eqv.|.neqv.)", "i");
          function tokenBase(stream, state) {
            if (stream.match(litOperator)) {
              return "operator";
            }
            var ch = stream.next();
            if (ch == "!") {
              stream.skipToEnd();
              return "comment";
            }
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[\[\]\(\),]/.test(ch)) {
              return null;
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_]/);
            var word = stream.current().toLowerCase();
            if (keywords2.hasOwnProperty(word)) {
              return "keyword";
            }
            if (builtins.hasOwnProperty(word) || dataTypes.hasOwnProperty(word)) {
              return "builtin";
            }
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !escaped)
                state.tokenize = null;
              return "string";
            };
          }
          return {
            startState: function() {
              return { tokenize: null };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment" || style == "meta")
                return style;
              return style;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-fortran", "fortran");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/meta.js
  var require_meta = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/meta.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.modeInfo = [
          { name: "APL", mime: "text/apl", mode: "apl", ext: ["dyalog", "apl"] },
          { name: "PGP", mimes: ["application/pgp", "application/pgp-encrypted", "application/pgp-keys", "application/pgp-signature"], mode: "asciiarmor", ext: ["asc", "pgp", "sig"] },
          { name: "ASN.1", mime: "text/x-ttcn-asn", mode: "asn.1", ext: ["asn", "asn1"] },
          { name: "Asterisk", mime: "text/x-asterisk", mode: "asterisk", file: /^extensions\.conf$/i },
          { name: "Brainfuck", mime: "text/x-brainfuck", mode: "brainfuck", ext: ["b", "bf"] },
          { name: "C", mime: "text/x-csrc", mode: "clike", ext: ["c", "h", "ino"] },
          { name: "C++", mime: "text/x-c++src", mode: "clike", ext: ["cpp", "c++", "cc", "cxx", "hpp", "h++", "hh", "hxx"], alias: ["cpp"] },
          { name: "Cobol", mime: "text/x-cobol", mode: "cobol", ext: ["cob", "cpy"] },
          { name: "C#", mime: "text/x-csharp", mode: "clike", ext: ["cs"], alias: ["csharp", "cs"] },
          { name: "Clojure", mime: "text/x-clojure", mode: "clojure", ext: ["clj", "cljc", "cljx"] },
          { name: "ClojureScript", mime: "text/x-clojurescript", mode: "clojure", ext: ["cljs"] },
          { name: "Closure Stylesheets (GSS)", mime: "text/x-gss", mode: "css", ext: ["gss"] },
          { name: "CMake", mime: "text/x-cmake", mode: "cmake", ext: ["cmake", "cmake.in"], file: /^CMakeLists.txt$/ },
          { name: "CoffeeScript", mimes: ["application/vnd.coffeescript", "text/coffeescript", "text/x-coffeescript"], mode: "coffeescript", ext: ["coffee"], alias: ["coffee", "coffee-script"] },
          { name: "Common Lisp", mime: "text/x-common-lisp", mode: "commonlisp", ext: ["cl", "lisp", "el"], alias: ["lisp"] },
          { name: "Cypher", mime: "application/x-cypher-query", mode: "cypher", ext: ["cyp", "cypher"] },
          { name: "Cython", mime: "text/x-cython", mode: "python", ext: ["pyx", "pxd", "pxi"] },
          { name: "Crystal", mime: "text/x-crystal", mode: "crystal", ext: ["cr"] },
          { name: "CSS", mime: "text/css", mode: "css", ext: ["css"] },
          { name: "CQL", mime: "text/x-cassandra", mode: "sql", ext: ["cql"] },
          { name: "D", mime: "text/x-d", mode: "d", ext: ["d"] },
          { name: "Dart", mimes: ["application/dart", "text/x-dart"], mode: "dart", ext: ["dart"] },
          { name: "diff", mime: "text/x-diff", mode: "diff", ext: ["diff", "patch"] },
          { name: "Django", mime: "text/x-django", mode: "django" },
          { name: "Dockerfile", mime: "text/x-dockerfile", mode: "dockerfile", file: /^Dockerfile$/ },
          { name: "DTD", mime: "application/xml-dtd", mode: "dtd", ext: ["dtd"] },
          { name: "Dylan", mime: "text/x-dylan", mode: "dylan", ext: ["dylan", "dyl", "intr"] },
          { name: "EBNF", mime: "text/x-ebnf", mode: "ebnf" },
          { name: "ECL", mime: "text/x-ecl", mode: "ecl", ext: ["ecl"] },
          { name: "edn", mime: "application/edn", mode: "clojure", ext: ["edn"] },
          { name: "Eiffel", mime: "text/x-eiffel", mode: "eiffel", ext: ["e"] },
          { name: "Elm", mime: "text/x-elm", mode: "elm", ext: ["elm"] },
          { name: "Embedded Javascript", mime: "application/x-ejs", mode: "htmlembedded", ext: ["ejs"] },
          { name: "Embedded Ruby", mime: "application/x-erb", mode: "htmlembedded", ext: ["erb"] },
          { name: "Erlang", mime: "text/x-erlang", mode: "erlang", ext: ["erl"] },
          { name: "Esper", mime: "text/x-esper", mode: "sql" },
          { name: "Factor", mime: "text/x-factor", mode: "factor", ext: ["factor"] },
          { name: "FCL", mime: "text/x-fcl", mode: "fcl" },
          { name: "Forth", mime: "text/x-forth", mode: "forth", ext: ["forth", "fth", "4th"] },
          { name: "Fortran", mime: "text/x-fortran", mode: "fortran", ext: ["f", "for", "f77", "f90", "f95"] },
          { name: "F#", mime: "text/x-fsharp", mode: "mllike", ext: ["fs"], alias: ["fsharp"] },
          { name: "Gas", mime: "text/x-gas", mode: "gas", ext: ["s"] },
          { name: "Gherkin", mime: "text/x-feature", mode: "gherkin", ext: ["feature"] },
          { name: "GitHub Flavored Markdown", mime: "text/x-gfm", mode: "gfm", file: /^(readme|contributing|history).md$/i },
          { name: "Go", mime: "text/x-go", mode: "go", ext: ["go"] },
          { name: "Groovy", mime: "text/x-groovy", mode: "groovy", ext: ["groovy", "gradle"], file: /^Jenkinsfile$/ },
          { name: "HAML", mime: "text/x-haml", mode: "haml", ext: ["haml"] },
          { name: "Haskell", mime: "text/x-haskell", mode: "haskell", ext: ["hs"] },
          { name: "Haskell (Literate)", mime: "text/x-literate-haskell", mode: "haskell-literate", ext: ["lhs"] },
          { name: "Haxe", mime: "text/x-haxe", mode: "haxe", ext: ["hx"] },
          { name: "HXML", mime: "text/x-hxml", mode: "haxe", ext: ["hxml"] },
          { name: "ASP.NET", mime: "application/x-aspx", mode: "htmlembedded", ext: ["aspx"], alias: ["asp", "aspx"] },
          { name: "HTML", mime: "text/html", mode: "htmlmixed", ext: ["html", "htm", "handlebars", "hbs"], alias: ["xhtml"] },
          { name: "HTTP", mime: "message/http", mode: "http" },
          { name: "IDL", mime: "text/x-idl", mode: "idl", ext: ["pro"] },
          { name: "Pug", mime: "text/x-pug", mode: "pug", ext: ["jade", "pug"], alias: ["jade"] },
          { name: "Java", mime: "text/x-java", mode: "clike", ext: ["java"] },
          { name: "Java Server Pages", mime: "application/x-jsp", mode: "htmlembedded", ext: ["jsp"], alias: ["jsp"] },
          {
            name: "JavaScript",
            mimes: ["text/javascript", "text/ecmascript", "application/javascript", "application/x-javascript", "application/ecmascript"],
            mode: "javascript",
            ext: ["js"],
            alias: ["ecmascript", "js", "node"]
          },
          { name: "JSON", mimes: ["application/json", "application/x-json"], mode: "javascript", ext: ["json", "map"], alias: ["json5"] },
          { name: "JSON-LD", mime: "application/ld+json", mode: "javascript", ext: ["jsonld"], alias: ["jsonld"] },
          { name: "JSX", mime: "text/jsx", mode: "jsx", ext: ["jsx"] },
          { name: "Jinja2", mime: "text/jinja2", mode: "jinja2", ext: ["j2", "jinja", "jinja2"] },
          { name: "Julia", mime: "text/x-julia", mode: "julia", ext: ["jl"] },
          { name: "Kotlin", mime: "text/x-kotlin", mode: "clike", ext: ["kt"] },
          { name: "LESS", mime: "text/x-less", mode: "css", ext: ["less"] },
          { name: "LiveScript", mime: "text/x-livescript", mode: "livescript", ext: ["ls"], alias: ["ls"] },
          { name: "Lua", mime: "text/x-lua", mode: "lua", ext: ["lua"] },
          { name: "Markdown", mime: "text/x-markdown", mode: "markdown", ext: ["markdown", "md", "mkd"] },
          { name: "mIRC", mime: "text/mirc", mode: "mirc" },
          { name: "MariaDB SQL", mime: "text/x-mariadb", mode: "sql" },
          { name: "Mathematica", mime: "text/x-mathematica", mode: "mathematica", ext: ["m", "nb", "wl", "wls"] },
          { name: "Modelica", mime: "text/x-modelica", mode: "modelica", ext: ["mo"] },
          { name: "MUMPS", mime: "text/x-mumps", mode: "mumps", ext: ["mps"] },
          { name: "MS SQL", mime: "text/x-mssql", mode: "sql" },
          { name: "mbox", mime: "application/mbox", mode: "mbox", ext: ["mbox"] },
          { name: "MySQL", mime: "text/x-mysql", mode: "sql" },
          { name: "Nginx", mime: "text/x-nginx-conf", mode: "nginx", file: /nginx.*\.conf$/i },
          { name: "NSIS", mime: "text/x-nsis", mode: "nsis", ext: ["nsh", "nsi"] },
          {
            name: "NTriples",
            mimes: ["application/n-triples", "application/n-quads", "text/n-triples"],
            mode: "ntriples",
            ext: ["nt", "nq"]
          },
          { name: "Objective-C", mime: "text/x-objectivec", mode: "clike", ext: ["m"], alias: ["objective-c", "objc"] },
          { name: "Objective-C++", mime: "text/x-objectivec++", mode: "clike", ext: ["mm"], alias: ["objective-c++", "objc++"] },
          { name: "OCaml", mime: "text/x-ocaml", mode: "mllike", ext: ["ml", "mli", "mll", "mly"] },
          { name: "Octave", mime: "text/x-octave", mode: "octave", ext: ["m"] },
          { name: "Oz", mime: "text/x-oz", mode: "oz", ext: ["oz"] },
          { name: "Pascal", mime: "text/x-pascal", mode: "pascal", ext: ["p", "pas"] },
          { name: "PEG.js", mime: "null", mode: "pegjs", ext: ["jsonld"] },
          { name: "Perl", mime: "text/x-perl", mode: "perl", ext: ["pl", "pm"] },
          { name: "PHP", mimes: ["text/x-php", "application/x-httpd-php", "application/x-httpd-php-open"], mode: "php", ext: ["php", "php3", "php4", "php5", "php7", "phtml"] },
          { name: "Pig", mime: "text/x-pig", mode: "pig", ext: ["pig"] },
          { name: "Plain Text", mime: "text/plain", mode: "null", ext: ["txt", "text", "conf", "def", "list", "log"] },
          { name: "PLSQL", mime: "text/x-plsql", mode: "sql", ext: ["pls"] },
          { name: "PostgreSQL", mime: "text/x-pgsql", mode: "sql" },
          { name: "PowerShell", mime: "application/x-powershell", mode: "powershell", ext: ["ps1", "psd1", "psm1"] },
          { name: "Properties files", mime: "text/x-properties", mode: "properties", ext: ["properties", "ini", "in"], alias: ["ini", "properties"] },
          { name: "ProtoBuf", mime: "text/x-protobuf", mode: "protobuf", ext: ["proto"] },
          { name: "Python", mime: "text/x-python", mode: "python", ext: ["BUILD", "bzl", "py", "pyw"], file: /^(BUCK|BUILD)$/ },
          { name: "Puppet", mime: "text/x-puppet", mode: "puppet", ext: ["pp"] },
          { name: "Q", mime: "text/x-q", mode: "q", ext: ["q"] },
          { name: "R", mime: "text/x-rsrc", mode: "r", ext: ["r", "R"], alias: ["rscript"] },
          { name: "reStructuredText", mime: "text/x-rst", mode: "rst", ext: ["rst"], alias: ["rst"] },
          { name: "RPM Changes", mime: "text/x-rpm-changes", mode: "rpm" },
          { name: "RPM Spec", mime: "text/x-rpm-spec", mode: "rpm", ext: ["spec"] },
          { name: "Ruby", mime: "text/x-ruby", mode: "ruby", ext: ["rb"], alias: ["jruby", "macruby", "rake", "rb", "rbx"] },
          { name: "Rust", mime: "text/x-rustsrc", mode: "rust", ext: ["rs"] },
          { name: "SAS", mime: "text/x-sas", mode: "sas", ext: ["sas"] },
          { name: "Sass", mime: "text/x-sass", mode: "sass", ext: ["sass"] },
          { name: "Scala", mime: "text/x-scala", mode: "clike", ext: ["scala"] },
          { name: "Scheme", mime: "text/x-scheme", mode: "scheme", ext: ["scm", "ss"] },
          { name: "SCSS", mime: "text/x-scss", mode: "css", ext: ["scss"] },
          { name: "Shell", mimes: ["text/x-sh", "application/x-sh"], mode: "shell", ext: ["sh", "ksh", "bash"], alias: ["bash", "sh", "zsh"], file: /^PKGBUILD$/ },
          { name: "Sieve", mime: "application/sieve", mode: "sieve", ext: ["siv", "sieve"] },
          { name: "Slim", mimes: ["text/x-slim", "application/x-slim"], mode: "slim", ext: ["slim"] },
          { name: "Smalltalk", mime: "text/x-stsrc", mode: "smalltalk", ext: ["st"] },
          { name: "Smarty", mime: "text/x-smarty", mode: "smarty", ext: ["tpl"] },
          { name: "Solr", mime: "text/x-solr", mode: "solr" },
          { name: "SML", mime: "text/x-sml", mode: "mllike", ext: ["sml", "sig", "fun", "smackspec"] },
          { name: "Soy", mime: "text/x-soy", mode: "soy", ext: ["soy"], alias: ["closure template"] },
          { name: "SPARQL", mime: "application/sparql-query", mode: "sparql", ext: ["rq", "sparql"], alias: ["sparul"] },
          { name: "Spreadsheet", mime: "text/x-spreadsheet", mode: "spreadsheet", alias: ["excel", "formula"] },
          { name: "SQL", mime: "text/x-sql", mode: "sql", ext: ["sql"] },
          { name: "SQLite", mime: "text/x-sqlite", mode: "sql" },
          { name: "Squirrel", mime: "text/x-squirrel", mode: "clike", ext: ["nut"] },
          { name: "Stylus", mime: "text/x-styl", mode: "stylus", ext: ["styl"] },
          { name: "Swift", mime: "text/x-swift", mode: "swift", ext: ["swift"] },
          { name: "sTeX", mime: "text/x-stex", mode: "stex" },
          { name: "LaTeX", mime: "text/x-latex", mode: "stex", ext: ["text", "ltx", "tex"], alias: ["tex"] },
          { name: "SystemVerilog", mime: "text/x-systemverilog", mode: "verilog", ext: ["v", "sv", "svh"] },
          { name: "Tcl", mime: "text/x-tcl", mode: "tcl", ext: ["tcl"] },
          { name: "Textile", mime: "text/x-textile", mode: "textile", ext: ["textile"] },
          { name: "TiddlyWiki ", mime: "text/x-tiddlywiki", mode: "tiddlywiki" },
          { name: "Tiki wiki", mime: "text/tiki", mode: "tiki" },
          { name: "TOML", mime: "text/x-toml", mode: "toml", ext: ["toml"] },
          { name: "Tornado", mime: "text/x-tornado", mode: "tornado" },
          { name: "troff", mime: "text/troff", mode: "troff", ext: ["1", "2", "3", "4", "5", "6", "7", "8", "9"] },
          { name: "TTCN", mime: "text/x-ttcn", mode: "ttcn", ext: ["ttcn", "ttcn3", "ttcnpp"] },
          { name: "TTCN_CFG", mime: "text/x-ttcn-cfg", mode: "ttcn-cfg", ext: ["cfg"] },
          { name: "Turtle", mime: "text/turtle", mode: "turtle", ext: ["ttl"] },
          { name: "TypeScript", mime: "application/typescript", mode: "javascript", ext: ["ts"], alias: ["ts"] },
          { name: "TypeScript-JSX", mime: "text/typescript-jsx", mode: "jsx", ext: ["tsx"], alias: ["tsx"] },
          { name: "Twig", mime: "text/x-twig", mode: "twig" },
          { name: "Web IDL", mime: "text/x-webidl", mode: "webidl", ext: ["webidl"] },
          { name: "VB.NET", mime: "text/x-vb", mode: "vb", ext: ["vb"] },
          { name: "VBScript", mime: "text/vbscript", mode: "vbscript", ext: ["vbs"] },
          { name: "Velocity", mime: "text/velocity", mode: "velocity", ext: ["vtl"] },
          { name: "Verilog", mime: "text/x-verilog", mode: "verilog", ext: ["v"] },
          { name: "VHDL", mime: "text/x-vhdl", mode: "vhdl", ext: ["vhd", "vhdl"] },
          { name: "Vue.js Component", mimes: ["script/x-vue", "text/x-vue"], mode: "vue", ext: ["vue"] },
          { name: "XML", mimes: ["application/xml", "text/xml"], mode: "xml", ext: ["xml", "xsl", "xsd", "svg"], alias: ["rss", "wsdl", "xsd"] },
          { name: "XQuery", mime: "application/xquery", mode: "xquery", ext: ["xy", "xquery"] },
          { name: "Yacas", mime: "text/x-yacas", mode: "yacas", ext: ["ys"] },
          { name: "YAML", mimes: ["text/x-yaml", "text/yaml"], mode: "yaml", ext: ["yaml", "yml"], alias: ["yml"] },
          { name: "Z80", mime: "text/x-z80", mode: "z80", ext: ["z80"] },
          { name: "mscgen", mime: "text/x-mscgen", mode: "mscgen", ext: ["mscgen", "mscin", "msc"] },
          { name: "xu", mime: "text/x-xu", mode: "mscgen", ext: ["xu"] },
          { name: "msgenny", mime: "text/x-msgenny", mode: "mscgen", ext: ["msgenny"] }
        ];
        for (var i3 = 0; i3 < CodeMirror5.modeInfo.length; i3++) {
          var info = CodeMirror5.modeInfo[i3];
          if (info.mimes)
            info.mime = info.mimes[0];
        }
        CodeMirror5.findModeByMIME = function(mime) {
          mime = mime.toLowerCase();
          for (var i4 = 0; i4 < CodeMirror5.modeInfo.length; i4++) {
            var info2 = CodeMirror5.modeInfo[i4];
            if (info2.mime == mime)
              return info2;
            if (info2.mimes) {
              for (var j3 = 0; j3 < info2.mimes.length; j3++)
                if (info2.mimes[j3] == mime)
                  return info2;
            }
          }
          if (/\+xml$/.test(mime))
            return CodeMirror5.findModeByMIME("application/xml");
          if (/\+json$/.test(mime))
            return CodeMirror5.findModeByMIME("application/json");
        };
        CodeMirror5.findModeByExtension = function(ext) {
          ext = ext.toLowerCase();
          for (var i4 = 0; i4 < CodeMirror5.modeInfo.length; i4++) {
            var info2 = CodeMirror5.modeInfo[i4];
            if (info2.ext) {
              for (var j3 = 0; j3 < info2.ext.length; j3++)
                if (info2.ext[j3] == ext)
                  return info2;
            }
          }
        };
        CodeMirror5.findModeByFileName = function(filename) {
          for (var i4 = 0; i4 < CodeMirror5.modeInfo.length; i4++) {
            var info2 = CodeMirror5.modeInfo[i4];
            if (info2.file && info2.file.test(filename))
              return info2;
          }
          var dot = filename.lastIndexOf(".");
          var ext = dot > -1 && filename.substring(dot + 1, filename.length);
          if (ext)
            return CodeMirror5.findModeByExtension(ext);
        };
        CodeMirror5.findModeByName = function(name106) {
          name106 = name106.toLowerCase();
          for (var i4 = 0; i4 < CodeMirror5.modeInfo.length; i4++) {
            var info2 = CodeMirror5.modeInfo[i4];
            if (info2.name.toLowerCase() == name106)
              return info2;
            if (info2.alias) {
              for (var j3 = 0; j3 < info2.alias.length; j3++)
                if (info2.alias[j3].toLowerCase() == name106)
                  return info2;
            }
          }
        };
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/markdown/markdown.js
  var require_markdown = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/markdown/markdown.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_xml(), require_meta());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../xml/xml", "../meta"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("markdown", function(cmCfg, modeCfg) {
          var htmlMode = CodeMirror5.getMode(cmCfg, "text/html");
          var htmlModeMissing = htmlMode.name == "null";
          function getMode2(name106) {
            if (CodeMirror5.findModeByName) {
              var found = CodeMirror5.findModeByName(name106);
              if (found)
                name106 = found.mime || found.mimes[0];
            }
            var mode3 = CodeMirror5.getMode(cmCfg, name106);
            return mode3.name == "null" ? null : mode3;
          }
          if (modeCfg.highlightFormatting === void 0)
            modeCfg.highlightFormatting = false;
          if (modeCfg.maxBlockquoteDepth === void 0)
            modeCfg.maxBlockquoteDepth = 0;
          if (modeCfg.taskLists === void 0)
            modeCfg.taskLists = false;
          if (modeCfg.strikethrough === void 0)
            modeCfg.strikethrough = false;
          if (modeCfg.emoji === void 0)
            modeCfg.emoji = false;
          if (modeCfg.fencedCodeBlockHighlighting === void 0)
            modeCfg.fencedCodeBlockHighlighting = true;
          if (modeCfg.xml === void 0)
            modeCfg.xml = true;
          if (modeCfg.tokenTypeOverrides === void 0)
            modeCfg.tokenTypeOverrides = {};
          var tokenTypes = {
            header: "header",
            code: "comment",
            quote: "quote",
            list1: "variable-2",
            list2: "variable-3",
            list3: "keyword",
            hr: "hr",
            image: "image",
            imageAltText: "image-alt-text",
            imageMarker: "image-marker",
            formatting: "formatting",
            linkInline: "link",
            linkEmail: "link",
            linkText: "link",
            linkHref: "string",
            em: "em",
            strong: "strong",
            strikethrough: "strikethrough",
            emoji: "builtin"
          };
          for (var tokenType in tokenTypes) {
            if (tokenTypes.hasOwnProperty(tokenType) && modeCfg.tokenTypeOverrides[tokenType]) {
              tokenTypes[tokenType] = modeCfg.tokenTypeOverrides[tokenType];
            }
          }
          var hrRE = /^([*\-_])(?:\s*\1){2,}\s*$/, listRE = /^(?:[*\-+]|^[0-9]+([.)]))\s+/, taskListRE = /^\[(x| )\](?=\s)/i, atxHeaderRE = modeCfg.allowAtxHeaderWithoutSpace ? /^(#+)/ : /^(#+)(?: |$)/, setextHeaderRE = /^ {0,3}(?:\={1,}|-{2,})\s*$/, textRE = /^[^#!\[\]*_\\<>` "'(~:]+/, fencedCodeRE = /^(~~~+|```+)[ \t]*([\w+#-]*)[^\n`]*$/, linkDefRE = /^\s*\[[^\]]+?\]:.*$/, punctuation = /[!"#$%&'()*+,\-.\/:;<=>?@\[\\\]^_`{|}~\xA1\xA7\xAB\xB6\xB7\xBB\xBF\u037E\u0387\u055A-\u055F\u0589\u058A\u05BE\u05C0\u05C3\u05C6\u05F3\u05F4\u0609\u060A\u060C\u060D\u061B\u061E\u061F\u066A-\u066D\u06D4\u0700-\u070D\u07F7-\u07F9\u0830-\u083E\u085E\u0964\u0965\u0970\u0AF0\u0DF4\u0E4F\u0E5A\u0E5B\u0F04-\u0F12\u0F14\u0F3A-\u0F3D\u0F85\u0FD0-\u0FD4\u0FD9\u0FDA\u104A-\u104F\u10FB\u1360-\u1368\u1400\u166D\u166E\u169B\u169C\u16EB-\u16ED\u1735\u1736\u17D4-\u17D6\u17D8-\u17DA\u1800-\u180A\u1944\u1945\u1A1E\u1A1F\u1AA0-\u1AA6\u1AA8-\u1AAD\u1B5A-\u1B60\u1BFC-\u1BFF\u1C3B-\u1C3F\u1C7E\u1C7F\u1CC0-\u1CC7\u1CD3\u2010-\u2027\u2030-\u2043\u2045-\u2051\u2053-\u205E\u207D\u207E\u208D\u208E\u2308-\u230B\u2329\u232A\u2768-\u2775\u27C5\u27C6\u27E6-\u27EF\u2983-\u2998\u29D8-\u29DB\u29FC\u29FD\u2CF9-\u2CFC\u2CFE\u2CFF\u2D70\u2E00-\u2E2E\u2E30-\u2E42\u3001-\u3003\u3008-\u3011\u3014-\u301F\u3030\u303D\u30A0\u30FB\uA4FE\uA4FF\uA60D-\uA60F\uA673\uA67E\uA6F2-\uA6F7\uA874-\uA877\uA8CE\uA8CF\uA8F8-\uA8FA\uA8FC\uA92E\uA92F\uA95F\uA9C1-\uA9CD\uA9DE\uA9DF\uAA5C-\uAA5F\uAADE\uAADF\uAAF0\uAAF1\uABEB\uFD3E\uFD3F\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE61\uFE63\uFE68\uFE6A\uFE6B\uFF01-\uFF03\uFF05-\uFF0A\uFF0C-\uFF0F\uFF1A\uFF1B\uFF1F\uFF20\uFF3B-\uFF3D\uFF3F\uFF5B\uFF5D\uFF5F-\uFF65]|\uD800[\uDD00-\uDD02\uDF9F\uDFD0]|\uD801\uDD6F|\uD802[\uDC57\uDD1F\uDD3F\uDE50-\uDE58\uDE7F\uDEF0-\uDEF6\uDF39-\uDF3F\uDF99-\uDF9C]|\uD804[\uDC47-\uDC4D\uDCBB\uDCBC\uDCBE-\uDCC1\uDD40-\uDD43\uDD74\uDD75\uDDC5-\uDDC9\uDDCD\uDDDB\uDDDD-\uDDDF\uDE38-\uDE3D\uDEA9]|\uD805[\uDCC6\uDDC1-\uDDD7\uDE41-\uDE43\uDF3C-\uDF3E]|\uD809[\uDC70-\uDC74]|\uD81A[\uDE6E\uDE6F\uDEF5\uDF37-\uDF3B\uDF44]|\uD82F\uDC9F|\uD836[\uDE87-\uDE8B]/, expandedTab = "    ";
          function switchInline(stream, state, f3) {
            state.f = state.inline = f3;
            return f3(stream, state);
          }
          function switchBlock(stream, state, f3) {
            state.f = state.block = f3;
            return f3(stream, state);
          }
          function lineIsEmpty(line) {
            return !line || !/\S/.test(line.string);
          }
          function blankLine(state) {
            state.linkTitle = false;
            state.linkHref = false;
            state.linkText = false;
            state.em = false;
            state.strong = false;
            state.strikethrough = false;
            state.quote = 0;
            state.indentedCode = false;
            if (state.f == htmlBlock) {
              var exit = htmlModeMissing;
              if (!exit) {
                var inner = CodeMirror5.innerMode(htmlMode, state.htmlState);
                exit = inner.mode.name == "xml" && inner.state.tagStart === null && (!inner.state.context && inner.state.tokenize.isInText);
              }
              if (exit) {
                state.f = inlineNormal;
                state.block = blockNormal;
                state.htmlState = null;
              }
            }
            state.trailingSpace = 0;
            state.trailingSpaceNewLine = false;
            state.prevLine = state.thisLine;
            state.thisLine = { stream: null };
            return null;
          }
          function blockNormal(stream, state) {
            var firstTokenOnLine = stream.column() === state.indentation;
            var prevLineLineIsEmpty = lineIsEmpty(state.prevLine.stream);
            var prevLineIsIndentedCode = state.indentedCode;
            var prevLineIsHr = state.prevLine.hr;
            var prevLineIsList = state.list !== false;
            var maxNonCodeIndentation = (state.listStack[state.listStack.length - 1] || 0) + 3;
            state.indentedCode = false;
            var lineIndentation = state.indentation;
            if (state.indentationDiff === null) {
              state.indentationDiff = state.indentation;
              if (prevLineIsList) {
                state.list = null;
                while (lineIndentation < state.listStack[state.listStack.length - 1]) {
                  state.listStack.pop();
                  if (state.listStack.length) {
                    state.indentation = state.listStack[state.listStack.length - 1];
                  } else {
                    state.list = false;
                  }
                }
                if (state.list !== false) {
                  state.indentationDiff = lineIndentation - state.listStack[state.listStack.length - 1];
                }
              }
            }
            var allowsInlineContinuation = !prevLineLineIsEmpty && !prevLineIsHr && !state.prevLine.header && (!prevLineIsList || !prevLineIsIndentedCode) && !state.prevLine.fencedCodeEnd;
            var isHr = (state.list === false || prevLineIsHr || prevLineLineIsEmpty) && state.indentation <= maxNonCodeIndentation && stream.match(hrRE);
            var match = null;
            if (state.indentationDiff >= 4 && (prevLineIsIndentedCode || state.prevLine.fencedCodeEnd || state.prevLine.header || prevLineLineIsEmpty)) {
              stream.skipToEnd();
              state.indentedCode = true;
              return tokenTypes.code;
            } else if (stream.eatSpace()) {
              return null;
            } else if (firstTokenOnLine && state.indentation <= maxNonCodeIndentation && (match = stream.match(atxHeaderRE)) && match[1].length <= 6) {
              state.quote = 0;
              state.header = match[1].length;
              state.thisLine.header = true;
              if (modeCfg.highlightFormatting)
                state.formatting = "header";
              state.f = state.inline;
              return getType(state);
            } else if (state.indentation <= maxNonCodeIndentation && stream.eat(">")) {
              state.quote = firstTokenOnLine ? 1 : state.quote + 1;
              if (modeCfg.highlightFormatting)
                state.formatting = "quote";
              stream.eatSpace();
              return getType(state);
            } else if (!isHr && !state.setext && firstTokenOnLine && state.indentation <= maxNonCodeIndentation && (match = stream.match(listRE))) {
              var listType = match[1] ? "ol" : "ul";
              state.indentation = lineIndentation + stream.current().length;
              state.list = true;
              state.quote = 0;
              state.listStack.push(state.indentation);
              state.em = false;
              state.strong = false;
              state.code = false;
              state.strikethrough = false;
              if (modeCfg.taskLists && stream.match(taskListRE, false)) {
                state.taskList = true;
              }
              state.f = state.inline;
              if (modeCfg.highlightFormatting)
                state.formatting = ["list", "list-" + listType];
              return getType(state);
            } else if (firstTokenOnLine && state.indentation <= maxNonCodeIndentation && (match = stream.match(fencedCodeRE, true))) {
              state.quote = 0;
              state.fencedEndRE = new RegExp(match[1] + "+ *$");
              state.localMode = modeCfg.fencedCodeBlockHighlighting && getMode2(match[2]);
              if (state.localMode)
                state.localState = CodeMirror5.startState(state.localMode);
              state.f = state.block = local;
              if (modeCfg.highlightFormatting)
                state.formatting = "code-block";
              state.code = -1;
              return getType(state);
            } else if (state.setext || (!allowsInlineContinuation || !prevLineIsList) && !state.quote && state.list === false && !state.code && !isHr && !linkDefRE.test(stream.string) && (match = stream.lookAhead(1)) && (match = match.match(setextHeaderRE))) {
              if (!state.setext) {
                state.header = match[0].charAt(0) == "=" ? 1 : 2;
                state.setext = state.header;
              } else {
                state.header = state.setext;
                state.setext = 0;
                stream.skipToEnd();
                if (modeCfg.highlightFormatting)
                  state.formatting = "header";
              }
              state.thisLine.header = true;
              state.f = state.inline;
              return getType(state);
            } else if (isHr) {
              stream.skipToEnd();
              state.hr = true;
              state.thisLine.hr = true;
              return tokenTypes.hr;
            } else if (stream.peek() === "[") {
              return switchInline(stream, state, footnoteLink);
            }
            return switchInline(stream, state, state.inline);
          }
          function htmlBlock(stream, state) {
            var style = htmlMode.token(stream, state.htmlState);
            if (!htmlModeMissing) {
              var inner = CodeMirror5.innerMode(htmlMode, state.htmlState);
              if (inner.mode.name == "xml" && inner.state.tagStart === null && (!inner.state.context && inner.state.tokenize.isInText) || state.md_inside && stream.current().indexOf(">") > -1) {
                state.f = inlineNormal;
                state.block = blockNormal;
                state.htmlState = null;
              }
            }
            return style;
          }
          function local(stream, state) {
            var currListInd = state.listStack[state.listStack.length - 1] || 0;
            var hasExitedList = state.indentation < currListInd;
            var maxFencedEndInd = currListInd + 3;
            if (state.fencedEndRE && state.indentation <= maxFencedEndInd && (hasExitedList || stream.match(state.fencedEndRE))) {
              if (modeCfg.highlightFormatting)
                state.formatting = "code-block";
              var returnType;
              if (!hasExitedList)
                returnType = getType(state);
              state.localMode = state.localState = null;
              state.block = blockNormal;
              state.f = inlineNormal;
              state.fencedEndRE = null;
              state.code = 0;
              state.thisLine.fencedCodeEnd = true;
              if (hasExitedList)
                return switchBlock(stream, state, state.block);
              return returnType;
            } else if (state.localMode) {
              return state.localMode.token(stream, state.localState);
            } else {
              stream.skipToEnd();
              return tokenTypes.code;
            }
          }
          function getType(state) {
            var styles = [];
            if (state.formatting) {
              styles.push(tokenTypes.formatting);
              if (typeof state.formatting === "string")
                state.formatting = [state.formatting];
              for (var i3 = 0; i3 < state.formatting.length; i3++) {
                styles.push(tokenTypes.formatting + "-" + state.formatting[i3]);
                if (state.formatting[i3] === "header") {
                  styles.push(tokenTypes.formatting + "-" + state.formatting[i3] + "-" + state.header);
                }
                if (state.formatting[i3] === "quote") {
                  if (!modeCfg.maxBlockquoteDepth || modeCfg.maxBlockquoteDepth >= state.quote) {
                    styles.push(tokenTypes.formatting + "-" + state.formatting[i3] + "-" + state.quote);
                  } else {
                    styles.push("error");
                  }
                }
              }
            }
            if (state.taskOpen) {
              styles.push("meta");
              return styles.length ? styles.join(" ") : null;
            }
            if (state.taskClosed) {
              styles.push("property");
              return styles.length ? styles.join(" ") : null;
            }
            if (state.linkHref) {
              styles.push(tokenTypes.linkHref, "url");
            } else {
              if (state.strong) {
                styles.push(tokenTypes.strong);
              }
              if (state.em) {
                styles.push(tokenTypes.em);
              }
              if (state.strikethrough) {
                styles.push(tokenTypes.strikethrough);
              }
              if (state.emoji) {
                styles.push(tokenTypes.emoji);
              }
              if (state.linkText) {
                styles.push(tokenTypes.linkText);
              }
              if (state.code) {
                styles.push(tokenTypes.code);
              }
              if (state.image) {
                styles.push(tokenTypes.image);
              }
              if (state.imageAltText) {
                styles.push(tokenTypes.imageAltText, "link");
              }
              if (state.imageMarker) {
                styles.push(tokenTypes.imageMarker);
              }
            }
            if (state.header) {
              styles.push(tokenTypes.header, tokenTypes.header + "-" + state.header);
            }
            if (state.quote) {
              styles.push(tokenTypes.quote);
              if (!modeCfg.maxBlockquoteDepth || modeCfg.maxBlockquoteDepth >= state.quote) {
                styles.push(tokenTypes.quote + "-" + state.quote);
              } else {
                styles.push(tokenTypes.quote + "-" + modeCfg.maxBlockquoteDepth);
              }
            }
            if (state.list !== false) {
              var listMod = (state.listStack.length - 1) % 3;
              if (!listMod) {
                styles.push(tokenTypes.list1);
              } else if (listMod === 1) {
                styles.push(tokenTypes.list2);
              } else {
                styles.push(tokenTypes.list3);
              }
            }
            if (state.trailingSpaceNewLine) {
              styles.push("trailing-space-new-line");
            } else if (state.trailingSpace) {
              styles.push("trailing-space-" + (state.trailingSpace % 2 ? "a" : "b"));
            }
            return styles.length ? styles.join(" ") : null;
          }
          function handleText(stream, state) {
            if (stream.match(textRE, true)) {
              return getType(state);
            }
            return void 0;
          }
          function inlineNormal(stream, state) {
            var style = state.text(stream, state);
            if (typeof style !== "undefined")
              return style;
            if (state.list) {
              state.list = null;
              return getType(state);
            }
            if (state.taskList) {
              var taskOpen = stream.match(taskListRE, true)[1] === " ";
              if (taskOpen)
                state.taskOpen = true;
              else
                state.taskClosed = true;
              if (modeCfg.highlightFormatting)
                state.formatting = "task";
              state.taskList = false;
              return getType(state);
            }
            state.taskOpen = false;
            state.taskClosed = false;
            if (state.header && stream.match(/^#+$/, true)) {
              if (modeCfg.highlightFormatting)
                state.formatting = "header";
              return getType(state);
            }
            var ch = stream.next();
            if (state.linkTitle) {
              state.linkTitle = false;
              var matchCh = ch;
              if (ch === "(") {
                matchCh = ")";
              }
              matchCh = (matchCh + "").replace(/([.?*+^\[\]\\(){}|-])/g, "\\$1");
              var regex = "^\\s*(?:[^" + matchCh + "\\\\]+|\\\\\\\\|\\\\.)" + matchCh;
              if (stream.match(new RegExp(regex), true)) {
                return tokenTypes.linkHref;
              }
            }
            if (ch === "`") {
              var previousFormatting = state.formatting;
              if (modeCfg.highlightFormatting)
                state.formatting = "code";
              stream.eatWhile("`");
              var count = stream.current().length;
              if (state.code == 0 && (!state.quote || count == 1)) {
                state.code = count;
                return getType(state);
              } else if (count == state.code) {
                var t3 = getType(state);
                state.code = 0;
                return t3;
              } else {
                state.formatting = previousFormatting;
                return getType(state);
              }
            } else if (state.code) {
              return getType(state);
            }
            if (ch === "\\") {
              stream.next();
              if (modeCfg.highlightFormatting) {
                var type = getType(state);
                var formattingEscape = tokenTypes.formatting + "-escape";
                return type ? type + " " + formattingEscape : formattingEscape;
              }
            }
            if (ch === "!" && stream.match(/\[[^\]]*\] ?(?:\(|\[)/, false)) {
              state.imageMarker = true;
              state.image = true;
              if (modeCfg.highlightFormatting)
                state.formatting = "image";
              return getType(state);
            }
            if (ch === "[" && state.imageMarker && stream.match(/[^\]]*\](\(.*?\)| ?\[.*?\])/, false)) {
              state.imageMarker = false;
              state.imageAltText = true;
              if (modeCfg.highlightFormatting)
                state.formatting = "image";
              return getType(state);
            }
            if (ch === "]" && state.imageAltText) {
              if (modeCfg.highlightFormatting)
                state.formatting = "image";
              var type = getType(state);
              state.imageAltText = false;
              state.image = false;
              state.inline = state.f = linkHref;
              return type;
            }
            if (ch === "[" && !state.image) {
              if (state.linkText && stream.match(/^.*?\]/))
                return getType(state);
              state.linkText = true;
              if (modeCfg.highlightFormatting)
                state.formatting = "link";
              return getType(state);
            }
            if (ch === "]" && state.linkText) {
              if (modeCfg.highlightFormatting)
                state.formatting = "link";
              var type = getType(state);
              state.linkText = false;
              state.inline = state.f = stream.match(/\(.*?\)| ?\[.*?\]/, false) ? linkHref : inlineNormal;
              return type;
            }
            if (ch === "<" && stream.match(/^(https?|ftps?):\/\/(?:[^\\>]|\\.)+>/, false)) {
              state.f = state.inline = linkInline;
              if (modeCfg.highlightFormatting)
                state.formatting = "link";
              var type = getType(state);
              if (type) {
                type += " ";
              } else {
                type = "";
              }
              return type + tokenTypes.linkInline;
            }
            if (ch === "<" && stream.match(/^[^> \\]+@(?:[^\\>]|\\.)+>/, false)) {
              state.f = state.inline = linkInline;
              if (modeCfg.highlightFormatting)
                state.formatting = "link";
              var type = getType(state);
              if (type) {
                type += " ";
              } else {
                type = "";
              }
              return type + tokenTypes.linkEmail;
            }
            if (modeCfg.xml && ch === "<" && stream.match(/^(!--|\?|!\[CDATA\[|[a-z][a-z0-9-]*(?:\s+[a-z_:.\-]+(?:\s*=\s*[^>]+)?)*\s*(?:>|$))/i, false)) {
              var end = stream.string.indexOf(">", stream.pos);
              if (end != -1) {
                var atts = stream.string.substring(stream.start, end);
                if (/markdown\s*=\s*('|"){0,1}1('|"){0,1}/.test(atts))
                  state.md_inside = true;
              }
              stream.backUp(1);
              state.htmlState = CodeMirror5.startState(htmlMode);
              return switchBlock(stream, state, htmlBlock);
            }
            if (modeCfg.xml && ch === "<" && stream.match(/^\/\w*?>/)) {
              state.md_inside = false;
              return "tag";
            } else if (ch === "*" || ch === "_") {
              var len = 1, before = stream.pos == 1 ? " " : stream.string.charAt(stream.pos - 2);
              while (len < 3 && stream.eat(ch))
                len++;
              var after = stream.peek() || " ";
              var leftFlanking = !/\s/.test(after) && (!punctuation.test(after) || /\s/.test(before) || punctuation.test(before));
              var rightFlanking = !/\s/.test(before) && (!punctuation.test(before) || /\s/.test(after) || punctuation.test(after));
              var setEm = null, setStrong = null;
              if (len % 2) {
                if (!state.em && leftFlanking && (ch === "*" || !rightFlanking || punctuation.test(before)))
                  setEm = true;
                else if (state.em == ch && rightFlanking && (ch === "*" || !leftFlanking || punctuation.test(after)))
                  setEm = false;
              }
              if (len > 1) {
                if (!state.strong && leftFlanking && (ch === "*" || !rightFlanking || punctuation.test(before)))
                  setStrong = true;
                else if (state.strong == ch && rightFlanking && (ch === "*" || !leftFlanking || punctuation.test(after)))
                  setStrong = false;
              }
              if (setStrong != null || setEm != null) {
                if (modeCfg.highlightFormatting)
                  state.formatting = setEm == null ? "strong" : setStrong == null ? "em" : "strong em";
                if (setEm === true)
                  state.em = ch;
                if (setStrong === true)
                  state.strong = ch;
                var t3 = getType(state);
                if (setEm === false)
                  state.em = false;
                if (setStrong === false)
                  state.strong = false;
                return t3;
              }
            } else if (ch === " ") {
              if (stream.eat("*") || stream.eat("_")) {
                if (stream.peek() === " ") {
                  return getType(state);
                } else {
                  stream.backUp(1);
                }
              }
            }
            if (modeCfg.strikethrough) {
              if (ch === "~" && stream.eatWhile(ch)) {
                if (state.strikethrough) {
                  if (modeCfg.highlightFormatting)
                    state.formatting = "strikethrough";
                  var t3 = getType(state);
                  state.strikethrough = false;
                  return t3;
                } else if (stream.match(/^[^\s]/, false)) {
                  state.strikethrough = true;
                  if (modeCfg.highlightFormatting)
                    state.formatting = "strikethrough";
                  return getType(state);
                }
              } else if (ch === " ") {
                if (stream.match(/^~~/, true)) {
                  if (stream.peek() === " ") {
                    return getType(state);
                  } else {
                    stream.backUp(2);
                  }
                }
              }
            }
            if (modeCfg.emoji && ch === ":" && stream.match(/^(?:[a-z_\d+][a-z_\d+-]*|\-[a-z_\d+][a-z_\d+-]*):/)) {
              state.emoji = true;
              if (modeCfg.highlightFormatting)
                state.formatting = "emoji";
              var retType = getType(state);
              state.emoji = false;
              return retType;
            }
            if (ch === " ") {
              if (stream.match(/^ +$/, false)) {
                state.trailingSpace++;
              } else if (state.trailingSpace) {
                state.trailingSpaceNewLine = true;
              }
            }
            return getType(state);
          }
          function linkInline(stream, state) {
            var ch = stream.next();
            if (ch === ">") {
              state.f = state.inline = inlineNormal;
              if (modeCfg.highlightFormatting)
                state.formatting = "link";
              var type = getType(state);
              if (type) {
                type += " ";
              } else {
                type = "";
              }
              return type + tokenTypes.linkInline;
            }
            stream.match(/^[^>]+/, true);
            return tokenTypes.linkInline;
          }
          function linkHref(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            var ch = stream.next();
            if (ch === "(" || ch === "[") {
              state.f = state.inline = getLinkHrefInside(ch === "(" ? ")" : "]");
              if (modeCfg.highlightFormatting)
                state.formatting = "link-string";
              state.linkHref = true;
              return getType(state);
            }
            return "error";
          }
          var linkRE = {
            ")": /^(?:[^\\\(\)]|\\.|\((?:[^\\\(\)]|\\.)*\))*?(?=\))/,
            "]": /^(?:[^\\\[\]]|\\.|\[(?:[^\\\[\]]|\\.)*\])*?(?=\])/
          };
          function getLinkHrefInside(endChar) {
            return function(stream, state) {
              var ch = stream.next();
              if (ch === endChar) {
                state.f = state.inline = inlineNormal;
                if (modeCfg.highlightFormatting)
                  state.formatting = "link-string";
                var returnState = getType(state);
                state.linkHref = false;
                return returnState;
              }
              stream.match(linkRE[endChar]);
              state.linkHref = true;
              return getType(state);
            };
          }
          function footnoteLink(stream, state) {
            if (stream.match(/^([^\]\\]|\\.)*\]:/, false)) {
              state.f = footnoteLinkInside;
              stream.next();
              if (modeCfg.highlightFormatting)
                state.formatting = "link";
              state.linkText = true;
              return getType(state);
            }
            return switchInline(stream, state, inlineNormal);
          }
          function footnoteLinkInside(stream, state) {
            if (stream.match(/^\]:/, true)) {
              state.f = state.inline = footnoteUrl;
              if (modeCfg.highlightFormatting)
                state.formatting = "link";
              var returnType = getType(state);
              state.linkText = false;
              return returnType;
            }
            stream.match(/^([^\]\\]|\\.)+/, true);
            return tokenTypes.linkText;
          }
          function footnoteUrl(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            stream.match(/^[^\s]+/, true);
            if (stream.peek() === void 0) {
              state.linkTitle = true;
            } else {
              stream.match(/^(?:\s+(?:"(?:[^"\\]|\\\\|\\.)+"|'(?:[^'\\]|\\\\|\\.)+'|\((?:[^)\\]|\\\\|\\.)+\)))?/, true);
            }
            state.f = state.inline = inlineNormal;
            return tokenTypes.linkHref + " url";
          }
          var mode2 = {
            startState: function() {
              return {
                f: blockNormal,
                prevLine: { stream: null },
                thisLine: { stream: null },
                block: blockNormal,
                htmlState: null,
                indentation: 0,
                inline: inlineNormal,
                text: handleText,
                formatting: false,
                linkText: false,
                linkHref: false,
                linkTitle: false,
                code: 0,
                em: false,
                strong: false,
                header: 0,
                setext: 0,
                hr: false,
                taskList: false,
                list: false,
                listStack: [],
                quote: 0,
                trailingSpace: 0,
                trailingSpaceNewLine: false,
                strikethrough: false,
                emoji: false,
                fencedEndRE: null
              };
            },
            copyState: function(s3) {
              return {
                f: s3.f,
                prevLine: s3.prevLine,
                thisLine: s3.thisLine,
                block: s3.block,
                htmlState: s3.htmlState && CodeMirror5.copyState(htmlMode, s3.htmlState),
                indentation: s3.indentation,
                localMode: s3.localMode,
                localState: s3.localMode ? CodeMirror5.copyState(s3.localMode, s3.localState) : null,
                inline: s3.inline,
                text: s3.text,
                formatting: false,
                linkText: s3.linkText,
                linkTitle: s3.linkTitle,
                linkHref: s3.linkHref,
                code: s3.code,
                em: s3.em,
                strong: s3.strong,
                strikethrough: s3.strikethrough,
                emoji: s3.emoji,
                header: s3.header,
                setext: s3.setext,
                hr: s3.hr,
                taskList: s3.taskList,
                list: s3.list,
                listStack: s3.listStack.slice(0),
                quote: s3.quote,
                indentedCode: s3.indentedCode,
                trailingSpace: s3.trailingSpace,
                trailingSpaceNewLine: s3.trailingSpaceNewLine,
                md_inside: s3.md_inside,
                fencedEndRE: s3.fencedEndRE
              };
            },
            token: function(stream, state) {
              state.formatting = false;
              if (stream != state.thisLine.stream) {
                state.header = 0;
                state.hr = false;
                if (stream.match(/^\s*$/, true)) {
                  blankLine(state);
                  return null;
                }
                state.prevLine = state.thisLine;
                state.thisLine = { stream };
                state.taskList = false;
                state.trailingSpace = 0;
                state.trailingSpaceNewLine = false;
                if (!state.localState) {
                  state.f = state.block;
                  if (state.f != htmlBlock) {
                    var indentation = stream.match(/^\s*/, true)[0].replace(/\t/g, expandedTab).length;
                    state.indentation = indentation;
                    state.indentationDiff = null;
                    if (indentation > 0)
                      return null;
                  }
                }
              }
              return state.f(stream, state);
            },
            innerMode: function(state) {
              if (state.block == htmlBlock)
                return { state: state.htmlState, mode: htmlMode };
              if (state.localState)
                return { state: state.localState, mode: state.localMode };
              return { state, mode: mode2 };
            },
            indent: function(state, textAfter, line) {
              if (state.block == htmlBlock && htmlMode.indent)
                return htmlMode.indent(state.htmlState, textAfter, line);
              if (state.localState && state.localMode.indent)
                return state.localMode.indent(state.localState, textAfter, line);
              return CodeMirror5.Pass;
            },
            blankLine,
            getType,
            blockCommentStart: "<!--",
            blockCommentEnd: "-->",
            closeBrackets: "()[]{}''\"\"``",
            fold: "markdown"
          };
          return mode2;
        }, "xml");
        CodeMirror5.defineMIME("text/markdown", "markdown");
        CodeMirror5.defineMIME("text/x-markdown", "markdown");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/gfm/gfm.js
  var require_gfm = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/gfm/gfm.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_markdown(), require_overlay());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../markdown/markdown", "../../addon/mode/overlay"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var urlRE = /^((?:(?:aaas?|about|acap|adiumxtra|af[ps]|aim|apt|attachment|aw|beshare|bitcoin|bolo|callto|cap|chrome(?:-extension)?|cid|coap|com-eventbrite-attendee|content|crid|cvs|data|dav|dict|dlna-(?:playcontainer|playsingle)|dns|doi|dtn|dvb|ed2k|facetime|feed|file|finger|fish|ftp|geo|gg|git|gizmoproject|go|gopher|gtalk|h323|hcp|https?|iax|icap|icon|im|imap|info|ipn|ipp|irc[6s]?|iris(?:\.beep|\.lwz|\.xpc|\.xpcs)?|itms|jar|javascript|jms|keyparc|lastfm|ldaps?|magnet|mailto|maps|market|message|mid|mms|ms-help|msnim|msrps?|mtqp|mumble|mupdate|mvn|news|nfs|nih?|nntp|notes|oid|opaquelocktoken|palm|paparazzi|platform|pop|pres|proxy|psyc|query|res(?:ource)?|rmi|rsync|rtmp|rtsp|secondlife|service|session|sftp|sgn|shttp|sieve|sips?|skype|sm[bs]|snmp|soap\.beeps?|soldat|spotify|ssh|steam|svn|tag|teamspeak|tel(?:net)?|tftp|things|thismessage|tip|tn3270|tv|udp|unreal|urn|ut2004|vemmi|ventrilo|view-source|webcal|wss?|wtai|wyciwyg|xcon(?:-userid)?|xfire|xmlrpc\.beeps?|xmpp|xri|ymsgr|z39\.50[rs]?):(?:\/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]|\([^\s()<>]*\))+(?:\([^\s()<>]*\)|[^\s`*!()\[\]{};:'".,<>?«»“”‘’]))/i;
        CodeMirror5.defineMode("gfm", function(config3, modeConfig) {
          var codeDepth = 0;
          function blankLine(state) {
            state.code = false;
            return null;
          }
          var gfmOverlay = {
            startState: function() {
              return {
                code: false,
                codeBlock: false,
                ateSpace: false
              };
            },
            copyState: function(s3) {
              return {
                code: s3.code,
                codeBlock: s3.codeBlock,
                ateSpace: s3.ateSpace
              };
            },
            token: function(stream, state) {
              state.combineTokens = null;
              if (state.codeBlock) {
                if (stream.match(/^```+/)) {
                  state.codeBlock = false;
                  return null;
                }
                stream.skipToEnd();
                return null;
              }
              if (stream.sol()) {
                state.code = false;
              }
              if (stream.sol() && stream.match(/^```+/)) {
                stream.skipToEnd();
                state.codeBlock = true;
                return null;
              }
              if (stream.peek() === "`") {
                stream.next();
                var before = stream.pos;
                stream.eatWhile("`");
                var difference = 1 + stream.pos - before;
                if (!state.code) {
                  codeDepth = difference;
                  state.code = true;
                } else {
                  if (difference === codeDepth) {
                    state.code = false;
                  }
                }
                return null;
              } else if (state.code) {
                stream.next();
                return null;
              }
              if (stream.eatSpace()) {
                state.ateSpace = true;
                return null;
              }
              if (stream.sol() || state.ateSpace) {
                state.ateSpace = false;
                if (modeConfig.gitHubSpice !== false) {
                  if (stream.match(/^(?:[a-zA-Z0-9\-_]+\/)?(?:[a-zA-Z0-9\-_]+@)?(?=.{0,6}\d)(?:[a-f0-9]{7,40}\b)/)) {
                    state.combineTokens = true;
                    return "link";
                  } else if (stream.match(/^(?:[a-zA-Z0-9\-_]+\/)?(?:[a-zA-Z0-9\-_]+)?#[0-9]+\b/)) {
                    state.combineTokens = true;
                    return "link";
                  }
                }
              }
              if (stream.match(urlRE) && stream.string.slice(stream.start - 2, stream.start) != "](" && (stream.start == 0 || /\W/.test(stream.string.charAt(stream.start - 1)))) {
                state.combineTokens = true;
                return "link";
              }
              stream.next();
              return null;
            },
            blankLine
          };
          var markdownConfig = {
            taskLists: true,
            strikethrough: true,
            emoji: true
          };
          for (var attr in modeConfig) {
            markdownConfig[attr] = modeConfig[attr];
          }
          markdownConfig.name = "markdown";
          return CodeMirror5.overlayMode(CodeMirror5.getMode(config3, markdownConfig), gfmOverlay);
        }, "markdown");
        CodeMirror5.defineMIME("text/x-gfm", "gfm");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/gherkin/gherkin.js
  var require_gherkin = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/gherkin/gherkin.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("gherkin", function() {
          return {
            startState: function() {
              return {
                lineNumber: 0,
                tableHeaderLine: false,
                allowFeature: true,
                allowBackground: false,
                allowScenario: false,
                allowSteps: false,
                allowPlaceholders: false,
                allowMultilineArgument: false,
                inMultilineString: false,
                inMultilineTable: false,
                inKeywordLine: false
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                state.lineNumber++;
                state.inKeywordLine = false;
                if (state.inMultilineTable) {
                  state.tableHeaderLine = false;
                  if (!stream.match(/\s*\|/, false)) {
                    state.allowMultilineArgument = false;
                    state.inMultilineTable = false;
                  }
                }
              }
              stream.eatSpace();
              if (state.allowMultilineArgument) {
                if (state.inMultilineString) {
                  if (stream.match('"""')) {
                    state.inMultilineString = false;
                    state.allowMultilineArgument = false;
                  } else {
                    stream.match(/.*/);
                  }
                  return "string";
                }
                if (state.inMultilineTable) {
                  if (stream.match(/\|\s*/)) {
                    return "bracket";
                  } else {
                    stream.match(/[^\|]*/);
                    return state.tableHeaderLine ? "header" : "string";
                  }
                }
                if (stream.match('"""')) {
                  state.inMultilineString = true;
                  return "string";
                } else if (stream.match("|")) {
                  state.inMultilineTable = true;
                  state.tableHeaderLine = true;
                  return "bracket";
                }
              }
              if (stream.match(/#.*/)) {
                return "comment";
              } else if (!state.inKeywordLine && stream.match(/@\S+/)) {
                return "tag";
              } else if (!state.inKeywordLine && state.allowFeature && stream.match(/(機能|功能|フィーチャ|기능|โครงหลัก|ความสามารถ|ความต้องการทางธุรกิจ|ಹೆಚ್ಚಳ|గుణము|ਮੁਹਾਂਦਰਾ|ਨਕਸ਼ ਨੁਹਾਰ|ਖਾਸੀਅਤ|रूप लेख|وِیژگی|خاصية|תכונה|Функціонал|Функция|Функционалност|Функционал|Үзенчәлеклелек|Свойство|Особина|Мөмкинлек|Могућност|Λειτουργία|Δυνατότητα|Właściwość|Vlastnosť|Trajto|Tính năng|Savybė|Pretty much|Požiadavka|Požadavek|Potrzeba biznesowa|Özellik|Osobina|Ominaisuus|Omadus|OH HAI|Mogućnost|Mogucnost|Jellemző|Hwæt|Hwaet|Funzionalità|Funktionalitéit|Funktionalität|Funkcja|Funkcionalnost|Funkcionalitāte|Funkcia|Fungsi|Functionaliteit|Funcționalitate|Funcţionalitate|Functionalitate|Funcionalitat|Funcionalidade|Fonctionnalité|Fitur|Fīča|Feature|Eiginleiki|Egenskap|Egenskab|Característica|Caracteristica|Business Need|Aspekt|Arwedd|Ahoy matey!|Ability):/)) {
                state.allowScenario = true;
                state.allowBackground = true;
                state.allowPlaceholders = false;
                state.allowSteps = false;
                state.allowMultilineArgument = false;
                state.inKeywordLine = true;
                return "keyword";
              } else if (!state.inKeywordLine && state.allowBackground && stream.match(/(背景|배경|แนวคิด|ಹಿನ್ನೆಲೆ|నేపథ్యం|ਪਿਛੋਕੜ|पृष्ठभूमि|زمینه|الخلفية|רקע|Тарих|Предыстория|Предистория|Позадина|Передумова|Основа|Контекст|Кереш|Υπόβαθρο|Założenia|Yo\-ho\-ho|Tausta|Taust|Situācija|Rerefons|Pozadina|Pozadie|Pozadí|Osnova|Latar Belakang|Kontext|Konteksts|Kontekstas|Kontekst|Háttér|Hannergrond|Grundlage|Geçmiş|Fundo|Fono|First off|Dis is what went down|Dasar|Contexto|Contexte|Context|Contesto|Cenário de Fundo|Cenario de Fundo|Cefndir|Bối cảnh|Bakgrunnur|Bakgrunn|Bakgrund|Baggrund|Background|B4|Antecedents|Antecedentes|Ær|Aer|Achtergrond):/)) {
                state.allowPlaceholders = false;
                state.allowSteps = true;
                state.allowBackground = false;
                state.allowMultilineArgument = false;
                state.inKeywordLine = true;
                return "keyword";
              } else if (!state.inKeywordLine && state.allowScenario && stream.match(/(場景大綱|场景大纲|劇本大綱|剧本大纲|テンプレ|シナリオテンプレート|シナリオテンプレ|シナリオアウトライン|시나리오 개요|สรุปเหตุการณ์|โครงสร้างของเหตุการณ์|ವಿವರಣೆ|కథనం|ਪਟਕਥਾ ਰੂਪ ਰੇਖਾ|ਪਟਕਥਾ ਢਾਂਚਾ|परिदृश्य रूपरेखा|سيناريو مخطط|الگوی سناریو|תבנית תרחיש|Сценарийның төзелеше|Сценарий структураси|Структура сценарію|Структура сценария|Структура сценарија|Скица|Рамка на сценарий|Концепт|Περιγραφή Σεναρίου|Wharrimean is|Template Situai|Template Senario|Template Keadaan|Tapausaihio|Szenariogrundriss|Szablon scenariusza|Swa hwær swa|Swa hwaer swa|Struktura scenarija|Structură scenariu|Structura scenariu|Skica|Skenario konsep|Shiver me timbers|Senaryo taslağı|Schema dello scenario|Scenariomall|Scenariomal|Scenario Template|Scenario Outline|Scenario Amlinellol|Scenārijs pēc parauga|Scenarijaus šablonas|Reckon it's like|Raamstsenaarium|Plang vum Szenario|Plan du Scénario|Plan du scénario|Osnova scénáře|Osnova Scenára|Náčrt Scenáru|Náčrt Scénáře|Náčrt Scenára|MISHUN SRSLY|Menggariskan Senario|Lýsing Dæma|Lýsing Atburðarásar|Konturo de la scenaro|Koncept|Khung tình huống|Khung kịch bản|Forgatókönyv vázlat|Esquema do Cenário|Esquema do Cenario|Esquema del escenario|Esquema de l'escenari|Esbozo do escenario|Delineação do Cenário|Delineacao do Cenario|All y'all|Abstrakt Scenario|Abstract Scenario):/)) {
                state.allowPlaceholders = true;
                state.allowSteps = true;
                state.allowMultilineArgument = false;
                state.inKeywordLine = true;
                return "keyword";
              } else if (state.allowScenario && stream.match(/(例子|例|サンプル|예|ชุดของเหตุการณ์|ชุดของตัวอย่าง|ಉದಾಹರಣೆಗಳು|ఉదాహరణలు|ਉਦਾਹਰਨਾਂ|उदाहरण|نمونه ها|امثلة|דוגמאות|Үрнәкләр|Сценарији|Примеры|Примери|Приклади|Мисоллар|Мисаллар|Σενάρια|Παραδείγματα|You'll wanna|Voorbeelden|Variantai|Tapaukset|Se þe|Se the|Se ðe|Scenarios|Scenariji|Scenarijai|Przykłady|Primjeri|Primeri|Příklady|Príklady|Piemēri|Példák|Pavyzdžiai|Paraugs|Örnekler|Juhtumid|Exemplos|Exemples|Exemple|Exempel|EXAMPLZ|Examples|Esempi|Enghreifftiau|Ekzemploj|Eksempler|Ejemplos|Dữ liệu|Dead men tell no tales|Dæmi|Contoh|Cenários|Cenarios|Beispiller|Beispiele|Atburðarásir):/)) {
                state.allowPlaceholders = false;
                state.allowSteps = true;
                state.allowBackground = false;
                state.allowMultilineArgument = true;
                return "keyword";
              } else if (!state.inKeywordLine && state.allowScenario && stream.match(/(場景|场景|劇本|剧本|シナリオ|시나리오|เหตุการณ์|ಕಥಾಸಾರಾಂಶ|సన్నివేశం|ਪਟਕਥਾ|परिदृश्य|سيناريو|سناریو|תרחיש|Сценарій|Сценарио|Сценарий|Пример|Σενάριο|Tình huống|The thing of it is|Tapaus|Szenario|Swa|Stsenaarium|Skenario|Situai|Senaryo|Senario|Scenaro|Scenariusz|Scenariu|Scénario|Scenario|Scenarijus|Scenārijs|Scenarij|Scenarie|Scénář|Scenár|Primer|MISHUN|Kịch bản|Keadaan|Heave to|Forgatókönyv|Escenario|Escenari|Cenário|Cenario|Awww, look mate|Atburðarás):/)) {
                state.allowPlaceholders = false;
                state.allowSteps = true;
                state.allowBackground = false;
                state.allowMultilineArgument = false;
                state.inKeywordLine = true;
                return "keyword";
              } else if (!state.inKeywordLine && state.allowSteps && stream.match(/(那麼|那么|而且|當|当|并且|同時|同时|前提|假设|假設|假定|假如|但是|但し|並且|もし|ならば|ただし|しかし|かつ|하지만|조건|먼저|만일|만약|단|그리고|그러면|และ |เมื่อ |แต่ |ดังนั้น |กำหนดให้ |ಸ್ಥಿತಿಯನ್ನು |ಮತ್ತು |ನೀಡಿದ |ನಂತರ |ಆದರೆ |మరియు |చెప్పబడినది |కాని |ఈ పరిస్థితిలో |అప్పుడు |ਪਰ |ਤਦ |ਜੇਕਰ |ਜਿਵੇਂ ਕਿ |ਜਦੋਂ |ਅਤੇ |यदि |परन्तु |पर |तब |तदा |तथा |जब |चूंकि |किन्तु |कदा |और |अगर |و |هنگامی |متى |لكن |عندما |ثم |بفرض |با فرض |اما |اذاً |آنگاه |כאשר |וגם |בהינתן |אזי |אז |אבל |Якщо |Һәм |Унда |Тоді |Тогда |То |Также |Та |Пусть |Припустимо, що |Припустимо |Онда |Но |Нехай |Нәтиҗәдә |Лекин |Ләкин |Коли |Когда |Когато |Када |Кад |К тому же |І |И |Задато |Задати |Задате |Если |Допустим |Дано |Дадено |Вә |Ва |Бирок |Әмма |Әйтик |Әгәр |Аммо |Али |Але |Агар |А також |А |Τότε |Όταν |Και |Δεδομένου |Αλλά |Þurh |Þegar |Þa þe |Þá |Þa |Zatati |Zakładając |Zadato |Zadate |Zadano |Zadani |Zadan |Za předpokladu |Za predpokladu |Youse know when youse got |Youse know like when |Yna |Yeah nah |Y'know |Y |Wun |Wtedy |When y'all |When |Wenn |WEN |wann |Ve |Và |Und |Un |ugeholl |Too right |Thurh |Thì |Then y'all |Then |Tha the |Tha |Tetapi |Tapi |Tak |Tada |Tad |Stel |Soit |Siis |Și |Şi |Si |Sed |Se |Så |Quando |Quand |Quan |Pryd |Potom |Pokud |Pokiaľ |Però |Pero |Pak |Oraz |Onda |Ond |Oletetaan |Og |Och |O zaman |Niin |Nhưng |När |Når |Mutta |Men |Mas |Maka |Majd |Mając |Mais |Maar |mä |Ma |Lorsque |Lorsqu'|Logo |Let go and haul |Kun |Kuid |Kui |Kiedy |Khi |Ketika |Kemudian |Keď |Když |Kaj |Kai |Kada |Kad |Jeżeli |Jeśli |Ja |It's just unbelievable |Ir |I CAN HAZ |I |Ha |Givun |Givet |Given y'all |Given |Gitt |Gegeven |Gegeben seien |Gegeben sei |Gdy |Gangway! |Fakat |Étant donnés |Etant donnés |Étant données |Etant données |Étant donnée |Etant donnée |Étant donné |Etant donné |Et |És |Entonces |Entón |Então |Entao |En |Eğer ki |Ef |Eeldades |E |Ðurh |Duota |Dun |Donitaĵo |Donat |Donada |Do |Diyelim ki |Diberi |Dengan |Den youse gotta |DEN |De |Dato |Dați fiind |Daţi fiind |Dati fiind |Dati |Date fiind |Date |Data |Dat fiind |Dar |Dann |dann |Dan |Dados |Dado |Dadas |Dada |Ða ðe |Ða |Cuando |Cho |Cando |Când |Cand |Cal |But y'all |But at the end of the day I reckon |BUT |But |Buh |Blimey! |Biết |Bet |Bagi |Aye |awer |Avast! |Atunci |Atesa |Atès |Apabila |Anrhegedig a |Angenommen |And y'all |And |AN |An |an |Amikor |Amennyiben |Ama |Als |Alors |Allora |Ali |Aleshores |Ale |Akkor |Ak |Adott |Ac |Aber |A zároveň |A tiež |A taktiež |A také |A |a |7 |\* )/)) {
                state.inStep = true;
                state.allowPlaceholders = true;
                state.allowMultilineArgument = true;
                state.inKeywordLine = true;
                return "keyword";
              } else if (stream.match(/"[^"]*"?/)) {
                return "string";
              } else if (state.allowPlaceholders && stream.match(/<[^>]*>?/)) {
                return "variable";
              } else {
                stream.next();
                stream.eatWhile(/[^@"<#]/);
                return null;
              }
            }
          };
        });
        CodeMirror5.defineMIME("text/x-feature", "gherkin");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/go/go.js
  var require_go = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/go/go.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("go", function(config3) {
          var indentUnit = config3.indentUnit;
          var keywords2 = {
            "break": true,
            "case": true,
            "chan": true,
            "const": true,
            "continue": true,
            "default": true,
            "defer": true,
            "else": true,
            "fallthrough": true,
            "for": true,
            "func": true,
            "go": true,
            "goto": true,
            "if": true,
            "import": true,
            "interface": true,
            "map": true,
            "package": true,
            "range": true,
            "return": true,
            "select": true,
            "struct": true,
            "switch": true,
            "type": true,
            "var": true,
            "bool": true,
            "byte": true,
            "complex64": true,
            "complex128": true,
            "float32": true,
            "float64": true,
            "int8": true,
            "int16": true,
            "int32": true,
            "int64": true,
            "string": true,
            "uint8": true,
            "uint16": true,
            "uint32": true,
            "uint64": true,
            "int": true,
            "uint": true,
            "uintptr": true,
            "error": true,
            "rune": true
          };
          var atoms = {
            "true": true,
            "false": true,
            "iota": true,
            "nil": true,
            "append": true,
            "cap": true,
            "close": true,
            "complex": true,
            "copy": true,
            "delete": true,
            "imag": true,
            "len": true,
            "make": true,
            "new": true,
            "panic": true,
            "print": true,
            "println": true,
            "real": true,
            "recover": true
          };
          var isOperatorChar = /[+\-*&^%:=<>!|\/]/;
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'" || ch == "`") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[\d\.]/.test(ch)) {
              if (ch == ".") {
                stream.match(/^[0-9]+([eE][\-+]?[0-9]+)?/);
              } else if (ch == "0") {
                stream.match(/^[xX][0-9a-fA-F]+/) || stream.match(/^0[0-7]+/);
              } else {
                stream.match(/^[0-9]*\.?[0-9]*([eE][\-+]?[0-9]+)?/);
              }
              return "number";
            }
            if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              curPunc = ch;
              return null;
            }
            if (ch == "/") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_\xa1-\uffff]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur)) {
              if (cur == "case" || cur == "default")
                curPunc = "case";
              return "keyword";
            }
            if (atoms.propertyIsEnumerable(cur))
              return "atom";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && quote != "`" && next == "\\";
              }
              if (end || !(escaped || quote == "`"))
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            return state.context = new Context(state.indented, col, type, null, state.context);
          }
          function popContext(state) {
            if (!state.context.prev)
              return;
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
                if (ctx.type == "case")
                  ctx.type = "}";
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "case")
                ctx.type = "case";
              else if (curPunc == "}" && ctx.type == "}")
                popContext(state);
              else if (curPunc == ctx.type)
                popContext(state);
              state.startOfLine = false;
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase && state.tokenize != null)
                return CodeMirror5.Pass;
              var ctx = state.context, firstChar = textAfter && textAfter.charAt(0);
              if (ctx.type == "case" && /^(?:case|default)\b/.test(textAfter)) {
                state.context.type = "}";
                return ctx.indented;
              }
              var closing = firstChar == ctx.type;
              if (ctx.align)
                return ctx.column + (closing ? 0 : 1);
              else
                return ctx.indented + (closing ? 0 : indentUnit);
            },
            electricChars: "{}):",
            closeBrackets: "()[]{}''\"\"``",
            fold: "brace",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//"
          };
        });
        CodeMirror5.defineMIME("text/x-go", "go");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/groovy/groovy.js
  var require_groovy = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/groovy/groovy.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("groovy", function(config3) {
          function words(str) {
            var obj = {}, words2 = str.split(" ");
            for (var i3 = 0; i3 < words2.length; ++i3)
              obj[words2[i3]] = true;
            return obj;
          }
          var keywords2 = words("abstract as assert boolean break byte case catch char class const continue def default do double else enum extends final finally float for goto if implements import in instanceof int interface long native new package private protected public return short static strictfp super switch synchronized threadsafe throw throws trait transient try void volatile while");
          var blockKeywords = words("catch class def do else enum finally for if interface switch trait try while");
          var standaloneKeywords = words("return break continue");
          var atoms = words("null true false this");
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              return startString(ch, stream, state);
            }
            if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              curPunc = ch;
              return null;
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              if (stream.eat(/eE/)) {
                stream.eat(/\+\-/);
                stream.eatWhile(/\d/);
              }
              return "number";
            }
            if (ch == "/") {
              if (stream.eat("*")) {
                state.tokenize.push(tokenComment);
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
              if (expectExpression(state.lastToken, false)) {
                return startString(ch, stream, state);
              }
            }
            if (ch == "-" && stream.eat(">")) {
              curPunc = "->";
              return null;
            }
            if (/[+\-*&%=<>!?|\/~]/.test(ch)) {
              stream.eatWhile(/[+\-*&%=<>|~]/);
              return "operator";
            }
            stream.eatWhile(/[\w\$_]/);
            if (ch == "@") {
              stream.eatWhile(/[\w\$_\.]/);
              return "meta";
            }
            if (state.lastToken == ".")
              return "property";
            if (stream.eat(":")) {
              curPunc = "proplabel";
              return "property";
            }
            var cur = stream.current();
            if (atoms.propertyIsEnumerable(cur)) {
              return "atom";
            }
            if (keywords2.propertyIsEnumerable(cur)) {
              if (blockKeywords.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              else if (standaloneKeywords.propertyIsEnumerable(cur))
                curPunc = "standalone";
              return "keyword";
            }
            return "variable";
          }
          tokenBase.isBase = true;
          function startString(quote, stream, state) {
            var tripleQuoted = false;
            if (quote != "/" && stream.eat(quote)) {
              if (stream.eat(quote))
                tripleQuoted = true;
              else
                return "string";
            }
            function t3(stream2, state2) {
              var escaped = false, next, end = !tripleQuoted;
              while ((next = stream2.next()) != null) {
                if (next == quote && !escaped) {
                  if (!tripleQuoted) {
                    break;
                  }
                  if (stream2.match(quote + quote)) {
                    end = true;
                    break;
                  }
                }
                if (quote == '"' && next == "$" && !escaped && stream2.eat("{")) {
                  state2.tokenize.push(tokenBaseUntilBrace());
                  return "string";
                }
                escaped = !escaped && next == "\\";
              }
              if (end)
                state2.tokenize.pop();
              return "string";
            }
            state.tokenize.push(t3);
            return t3(stream, state);
          }
          function tokenBaseUntilBrace() {
            var depth = 1;
            function t3(stream, state) {
              if (stream.peek() == "}") {
                depth--;
                if (depth == 0) {
                  state.tokenize.pop();
                  return state.tokenize[state.tokenize.length - 1](stream, state);
                }
              } else if (stream.peek() == "{") {
                depth++;
              }
              return tokenBase(stream, state);
            }
            t3.isBase = true;
            return t3;
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize.pop();
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function expectExpression(last, newline) {
            return !last || last == "operator" || last == "->" || /[\.\[\{\(,;:]/.test(last) || last == "newstatement" || last == "keyword" || last == "proplabel" || last == "standalone" && !newline;
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            return state.context = new Context(state.indented, col, type, null, state.context);
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: [tokenBase],
                context: new Context((basecolumn || 0) - config3.indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true,
                lastToken: null
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
                if (ctx.type == "statement" && !expectExpression(state.lastToken, true)) {
                  popContext(state);
                  ctx = state.context;
                }
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = state.tokenize[state.tokenize.length - 1](stream, state);
              if (style == "comment")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if ((curPunc == ";" || curPunc == ":") && ctx.type == "statement")
                popContext(state);
              else if (curPunc == "->" && ctx.type == "statement" && ctx.prev.type == "}") {
                popContext(state);
                state.context.align = false;
              } else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if (ctx.type == "}" || ctx.type == "top" || ctx.type == "statement" && curPunc == "newstatement")
                pushContext(state, stream.column(), "statement");
              state.startOfLine = false;
              state.lastToken = curPunc || style;
              return style;
            },
            indent: function(state, textAfter) {
              if (!state.tokenize[state.tokenize.length - 1].isBase)
                return CodeMirror5.Pass;
              var firstChar = textAfter && textAfter.charAt(0), ctx = state.context;
              if (ctx.type == "statement" && !expectExpression(state.lastToken, true))
                ctx = ctx.prev;
              var closing = firstChar == ctx.type;
              if (ctx.type == "statement")
                return ctx.indented + (firstChar == "{" ? 0 : config3.indentUnit);
              else if (ctx.align)
                return ctx.column + (closing ? 0 : 1);
              else
                return ctx.indented + (closing ? 0 : config3.indentUnit);
            },
            electricChars: "{}",
            closeBrackets: { triples: `'"` },
            fold: "brace",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//"
          };
        });
        CodeMirror5.defineMIME("text/x-groovy", "groovy");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/ruby/ruby.js
  var require_ruby = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/ruby/ruby.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("ruby", function(config3) {
          function wordObj(words) {
            var o3 = {};
            for (var i3 = 0, e5 = words.length; i3 < e5; ++i3)
              o3[words[i3]] = true;
            return o3;
          }
          var keywords2 = wordObj([
            "alias",
            "and",
            "BEGIN",
            "begin",
            "break",
            "case",
            "class",
            "def",
            "defined?",
            "do",
            "else",
            "elsif",
            "END",
            "end",
            "ensure",
            "false",
            "for",
            "if",
            "in",
            "module",
            "next",
            "not",
            "or",
            "redo",
            "rescue",
            "retry",
            "return",
            "self",
            "super",
            "then",
            "true",
            "undef",
            "unless",
            "until",
            "when",
            "while",
            "yield",
            "nil",
            "raise",
            "throw",
            "catch",
            "fail",
            "loop",
            "callcc",
            "caller",
            "lambda",
            "proc",
            "public",
            "protected",
            "private",
            "require",
            "load",
            "require_relative",
            "extend",
            "autoload",
            "__END__",
            "__FILE__",
            "__LINE__",
            "__dir__"
          ]);
          var indentWords = wordObj([
            "def",
            "class",
            "case",
            "for",
            "while",
            "until",
            "module",
            "then",
            "catch",
            "loop",
            "proc",
            "begin"
          ]);
          var dedentWords = wordObj(["end", "until"]);
          var opening = { "[": "]", "{": "}", "(": ")" };
          var closing = { "]": "[", "}": "{", ")": "(" };
          var curPunc;
          function chain2(newtok, stream, state) {
            state.tokenize.push(newtok);
            return newtok(stream, state);
          }
          function tokenBase(stream, state) {
            if (stream.sol() && stream.match("=begin") && stream.eol()) {
              state.tokenize.push(readBlockComment);
              return "comment";
            }
            if (stream.eatSpace())
              return null;
            var ch = stream.next(), m3;
            if (ch == "`" || ch == "'" || ch == '"') {
              return chain2(readQuoted(ch, "string", ch == '"' || ch == "`"), stream, state);
            } else if (ch == "/") {
              if (regexpAhead(stream))
                return chain2(readQuoted(ch, "string-2", true), stream, state);
              else
                return "operator";
            } else if (ch == "%") {
              var style = "string", embed = true;
              if (stream.eat("s"))
                style = "atom";
              else if (stream.eat(/[WQ]/))
                style = "string";
              else if (stream.eat(/[r]/))
                style = "string-2";
              else if (stream.eat(/[wxq]/)) {
                style = "string";
                embed = false;
              }
              var delim = stream.eat(/[^\w\s=]/);
              if (!delim)
                return "operator";
              if (opening.propertyIsEnumerable(delim))
                delim = opening[delim];
              return chain2(readQuoted(delim, style, embed, true), stream, state);
            } else if (ch == "#") {
              stream.skipToEnd();
              return "comment";
            } else if (ch == "<" && (m3 = stream.match(/^<([-~])[\`\"\']?([a-zA-Z_?]\w*)[\`\"\']?(?:;|$)/))) {
              return chain2(readHereDoc(m3[2], m3[1]), stream, state);
            } else if (ch == "0") {
              if (stream.eat("x"))
                stream.eatWhile(/[\da-fA-F]/);
              else if (stream.eat("b"))
                stream.eatWhile(/[01]/);
              else
                stream.eatWhile(/[0-7]/);
              return "number";
            } else if (/\d/.test(ch)) {
              stream.match(/^[\d_]*(?:\.[\d_]+)?(?:[eE][+\-]?[\d_]+)?/);
              return "number";
            } else if (ch == "?") {
              while (stream.match(/^\\[CM]-/)) {
              }
              if (stream.eat("\\"))
                stream.eatWhile(/\w/);
              else
                stream.next();
              return "string";
            } else if (ch == ":") {
              if (stream.eat("'"))
                return chain2(readQuoted("'", "atom", false), stream, state);
              if (stream.eat('"'))
                return chain2(readQuoted('"', "atom", true), stream, state);
              if (stream.eat(/[\<\>]/)) {
                stream.eat(/[\<\>]/);
                return "atom";
              }
              if (stream.eat(/[\+\-\*\/\&\|\:\!]/)) {
                return "atom";
              }
              if (stream.eat(/[a-zA-Z$@_\xa1-\uffff]/)) {
                stream.eatWhile(/[\w$\xa1-\uffff]/);
                stream.eat(/[\?\!\=]/);
                return "atom";
              }
              return "operator";
            } else if (ch == "@" && stream.match(/^@?[a-zA-Z_\xa1-\uffff]/)) {
              stream.eat("@");
              stream.eatWhile(/[\w\xa1-\uffff]/);
              return "variable-2";
            } else if (ch == "$") {
              if (stream.eat(/[a-zA-Z_]/)) {
                stream.eatWhile(/[\w]/);
              } else if (stream.eat(/\d/)) {
                stream.eat(/\d/);
              } else {
                stream.next();
              }
              return "variable-3";
            } else if (/[a-zA-Z_\xa1-\uffff]/.test(ch)) {
              stream.eatWhile(/[\w\xa1-\uffff]/);
              stream.eat(/[\?\!]/);
              if (stream.eat(":"))
                return "atom";
              return "ident";
            } else if (ch == "|" && (state.varList || state.lastTok == "{" || state.lastTok == "do")) {
              curPunc = "|";
              return null;
            } else if (/[\(\)\[\]{}\\;]/.test(ch)) {
              curPunc = ch;
              return null;
            } else if (ch == "-" && stream.eat(">")) {
              return "arrow";
            } else if (/[=+\-\/*:\.^%<>~|]/.test(ch)) {
              var more = stream.eatWhile(/[=+\-\/*:\.^%<>~|]/);
              if (ch == "." && !more)
                curPunc = ".";
              return "operator";
            } else {
              return null;
            }
          }
          function regexpAhead(stream) {
            var start2 = stream.pos, depth = 0, next, found = false, escaped = false;
            while ((next = stream.next()) != null) {
              if (!escaped) {
                if ("[{(".indexOf(next) > -1) {
                  depth++;
                } else if ("]})".indexOf(next) > -1) {
                  depth--;
                  if (depth < 0)
                    break;
                } else if (next == "/" && depth == 0) {
                  found = true;
                  break;
                }
                escaped = next == "\\";
              } else {
                escaped = false;
              }
            }
            stream.backUp(stream.pos - start2);
            return found;
          }
          function tokenBaseUntilBrace(depth) {
            if (!depth)
              depth = 1;
            return function(stream, state) {
              if (stream.peek() == "}") {
                if (depth == 1) {
                  state.tokenize.pop();
                  return state.tokenize[state.tokenize.length - 1](stream, state);
                } else {
                  state.tokenize[state.tokenize.length - 1] = tokenBaseUntilBrace(depth - 1);
                }
              } else if (stream.peek() == "{") {
                state.tokenize[state.tokenize.length - 1] = tokenBaseUntilBrace(depth + 1);
              }
              return tokenBase(stream, state);
            };
          }
          function tokenBaseOnce() {
            var alreadyCalled = false;
            return function(stream, state) {
              if (alreadyCalled) {
                state.tokenize.pop();
                return state.tokenize[state.tokenize.length - 1](stream, state);
              }
              alreadyCalled = true;
              return tokenBase(stream, state);
            };
          }
          function readQuoted(quote, style, embed, unescaped) {
            return function(stream, state) {
              var escaped = false, ch;
              if (state.context.type === "read-quoted-paused") {
                state.context = state.context.prev;
                stream.eat("}");
              }
              while ((ch = stream.next()) != null) {
                if (ch == quote && (unescaped || !escaped)) {
                  state.tokenize.pop();
                  break;
                }
                if (embed && ch == "#" && !escaped) {
                  if (stream.eat("{")) {
                    if (quote == "}") {
                      state.context = { prev: state.context, type: "read-quoted-paused" };
                    }
                    state.tokenize.push(tokenBaseUntilBrace());
                    break;
                  } else if (/[@\$]/.test(stream.peek())) {
                    state.tokenize.push(tokenBaseOnce());
                    break;
                  }
                }
                escaped = !escaped && ch == "\\";
              }
              return style;
            };
          }
          function readHereDoc(phrase, mayIndent) {
            return function(stream, state) {
              if (mayIndent)
                stream.eatSpace();
              if (stream.match(phrase))
                state.tokenize.pop();
              else
                stream.skipToEnd();
              return "string";
            };
          }
          function readBlockComment(stream, state) {
            if (stream.sol() && stream.match("=end") && stream.eol())
              state.tokenize.pop();
            stream.skipToEnd();
            return "comment";
          }
          return {
            startState: function() {
              return {
                tokenize: [tokenBase],
                indented: 0,
                context: { type: "top", indented: -config3.indentUnit },
                continuedLine: false,
                lastTok: null,
                varList: false
              };
            },
            token: function(stream, state) {
              curPunc = null;
              if (stream.sol())
                state.indented = stream.indentation();
              var style = state.tokenize[state.tokenize.length - 1](stream, state), kwtype;
              var thisTok = curPunc;
              if (style == "ident") {
                var word = stream.current();
                style = state.lastTok == "." ? "property" : keywords2.propertyIsEnumerable(stream.current()) ? "keyword" : /^[A-Z]/.test(word) ? "tag" : state.lastTok == "def" || state.lastTok == "class" || state.varList ? "def" : "variable";
                if (style == "keyword") {
                  thisTok = word;
                  if (indentWords.propertyIsEnumerable(word))
                    kwtype = "indent";
                  else if (dedentWords.propertyIsEnumerable(word))
                    kwtype = "dedent";
                  else if ((word == "if" || word == "unless") && stream.column() == stream.indentation())
                    kwtype = "indent";
                  else if (word == "do" && state.context.indented < state.indented)
                    kwtype = "indent";
                }
              }
              if (curPunc || style && style != "comment")
                state.lastTok = thisTok;
              if (curPunc == "|")
                state.varList = !state.varList;
              if (kwtype == "indent" || /[\(\[\{]/.test(curPunc))
                state.context = { prev: state.context, type: curPunc || style, indented: state.indented };
              else if ((kwtype == "dedent" || /[\)\]\}]/.test(curPunc)) && state.context.prev)
                state.context = state.context.prev;
              if (stream.eol())
                state.continuedLine = curPunc == "\\" || style == "operator";
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize[state.tokenize.length - 1] != tokenBase)
                return CodeMirror5.Pass;
              var firstChar = textAfter && textAfter.charAt(0);
              var ct = state.context;
              var closed = ct.type == closing[firstChar] || ct.type == "keyword" && /^(?:end|until|else|elsif|when|rescue)\b/.test(textAfter);
              return ct.indented + (closed ? 0 : config3.indentUnit) + (state.continuedLine ? config3.indentUnit : 0);
            },
            electricInput: /^\s*(?:end|rescue|elsif|else|\})$/,
            lineComment: "#",
            fold: "indent"
          };
        });
        CodeMirror5.defineMIME("text/x-ruby", "ruby");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/haml/haml.js
  var require_haml = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/haml/haml.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_htmlmixed(), require_ruby());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../htmlmixed/htmlmixed", "../ruby/ruby"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("haml", function(config3) {
          var htmlMode = CodeMirror5.getMode(config3, { name: "htmlmixed" });
          var rubyMode = CodeMirror5.getMode(config3, "ruby");
          function rubyInQuote(endQuote) {
            return function(stream, state) {
              var ch = stream.peek();
              if (ch == endQuote && state.rubyState.tokenize.length == 1) {
                stream.next();
                state.tokenize = html;
                return "closeAttributeTag";
              } else {
                return ruby(stream, state);
              }
            };
          }
          function ruby(stream, state) {
            if (stream.match("-#")) {
              stream.skipToEnd();
              return "comment";
            }
            return rubyMode.token(stream, state.rubyState);
          }
          function html(stream, state) {
            var ch = stream.peek();
            if (state.previousToken.style == "comment") {
              if (state.indented > state.previousToken.indented) {
                stream.skipToEnd();
                return "commentLine";
              }
            }
            if (state.startOfLine) {
              if (ch == "!" && stream.match("!!")) {
                stream.skipToEnd();
                return "tag";
              } else if (stream.match(/^%[\w:#\.]+=/)) {
                state.tokenize = ruby;
                return "hamlTag";
              } else if (stream.match(/^%[\w:]+/)) {
                return "hamlTag";
              } else if (ch == "/") {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (state.startOfLine || state.previousToken.style == "hamlTag") {
              if (ch == "#" || ch == ".") {
                stream.match(/[\w-#\.]*/);
                return "hamlAttribute";
              }
            }
            if (state.startOfLine && !stream.match("-->", false) && (ch == "=" || ch == "-")) {
              state.tokenize = ruby;
              return state.tokenize(stream, state);
            }
            if (state.previousToken.style == "hamlTag" || state.previousToken.style == "closeAttributeTag" || state.previousToken.style == "hamlAttribute") {
              if (ch == "(") {
                state.tokenize = rubyInQuote(")");
                return state.tokenize(stream, state);
              } else if (ch == "{") {
                if (!stream.match(/^\{%.*/)) {
                  state.tokenize = rubyInQuote("}");
                  return state.tokenize(stream, state);
                }
              }
            }
            return htmlMode.token(stream, state.htmlState);
          }
          return {
            startState: function() {
              var htmlState = CodeMirror5.startState(htmlMode);
              var rubyState = CodeMirror5.startState(rubyMode);
              return {
                htmlState,
                rubyState,
                indented: 0,
                previousToken: { style: null, indented: 0 },
                tokenize: html
              };
            },
            copyState: function(state) {
              return {
                htmlState: CodeMirror5.copyState(htmlMode, state.htmlState),
                rubyState: CodeMirror5.copyState(rubyMode, state.rubyState),
                indented: state.indented,
                previousToken: state.previousToken,
                tokenize: state.tokenize
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              state.startOfLine = false;
              if (style && style != "commentLine") {
                state.previousToken = { style, indented: state.indented };
              }
              if (stream.eol() && state.tokenize == ruby) {
                stream.backUp(1);
                var ch = stream.peek();
                stream.next();
                if (ch && ch != ",") {
                  state.tokenize = html;
                }
              }
              if (style == "hamlTag") {
                style = "tag";
              } else if (style == "commentLine") {
                style = "comment";
              } else if (style == "hamlAttribute") {
                style = "attribute";
              } else if (style == "closeAttributeTag") {
                style = null;
              }
              return style;
            }
          };
        }, "htmlmixed", "ruby");
        CodeMirror5.defineMIME("text/x-haml", "haml");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/mode/multiplex.js
  var require_multiplex = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/mode/multiplex.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.multiplexingMode = function(outer) {
          var others = Array.prototype.slice.call(arguments, 1);
          function indexOf(string2, pattern, from, returnEnd) {
            if (typeof pattern == "string") {
              var found = string2.indexOf(pattern, from);
              return returnEnd && found > -1 ? found + pattern.length : found;
            }
            var m3 = pattern.exec(from ? string2.slice(from) : string2);
            return m3 ? m3.index + from + (returnEnd ? m3[0].length : 0) : -1;
          }
          return {
            startState: function() {
              return {
                outer: CodeMirror5.startState(outer),
                innerActive: null,
                inner: null
              };
            },
            copyState: function(state) {
              return {
                outer: CodeMirror5.copyState(outer, state.outer),
                innerActive: state.innerActive,
                inner: state.innerActive && CodeMirror5.copyState(state.innerActive.mode, state.inner)
              };
            },
            token: function(stream, state) {
              if (!state.innerActive) {
                var cutOff = Infinity, oldContent = stream.string;
                for (var i3 = 0; i3 < others.length; ++i3) {
                  var other = others[i3];
                  var found = indexOf(oldContent, other.open, stream.pos);
                  if (found == stream.pos) {
                    if (!other.parseDelimiters)
                      stream.match(other.open);
                    state.innerActive = other;
                    var outerIndent = 0;
                    if (outer.indent) {
                      var possibleOuterIndent = outer.indent(state.outer, "", "");
                      if (possibleOuterIndent !== CodeMirror5.Pass)
                        outerIndent = possibleOuterIndent;
                    }
                    state.inner = CodeMirror5.startState(other.mode, outerIndent);
                    return other.delimStyle && other.delimStyle + " " + other.delimStyle + "-open";
                  } else if (found != -1 && found < cutOff) {
                    cutOff = found;
                  }
                }
                if (cutOff != Infinity)
                  stream.string = oldContent.slice(0, cutOff);
                var outerToken = outer.token(stream, state.outer);
                if (cutOff != Infinity)
                  stream.string = oldContent;
                return outerToken;
              } else {
                var curInner = state.innerActive, oldContent = stream.string;
                if (!curInner.close && stream.sol()) {
                  state.innerActive = state.inner = null;
                  return this.token(stream, state);
                }
                var found = curInner.close ? indexOf(oldContent, curInner.close, stream.pos, curInner.parseDelimiters) : -1;
                if (found == stream.pos && !curInner.parseDelimiters) {
                  stream.match(curInner.close);
                  state.innerActive = state.inner = null;
                  return curInner.delimStyle && curInner.delimStyle + " " + curInner.delimStyle + "-close";
                }
                if (found > -1)
                  stream.string = oldContent.slice(0, found);
                var innerToken = curInner.mode.token(stream, state.inner);
                if (found > -1)
                  stream.string = oldContent;
                if (found == stream.pos && curInner.parseDelimiters)
                  state.innerActive = state.inner = null;
                if (curInner.innerStyle) {
                  if (innerToken)
                    innerToken = innerToken + " " + curInner.innerStyle;
                  else
                    innerToken = curInner.innerStyle;
                }
                return innerToken;
              }
            },
            indent: function(state, textAfter, line) {
              var mode2 = state.innerActive ? state.innerActive.mode : outer;
              if (!mode2.indent)
                return CodeMirror5.Pass;
              return mode2.indent(state.innerActive ? state.inner : state.outer, textAfter, line);
            },
            blankLine: function(state) {
              var mode2 = state.innerActive ? state.innerActive.mode : outer;
              if (mode2.blankLine) {
                mode2.blankLine(state.innerActive ? state.inner : state.outer);
              }
              if (!state.innerActive) {
                for (var i3 = 0; i3 < others.length; ++i3) {
                  var other = others[i3];
                  if (other.open === "\n") {
                    state.innerActive = other;
                    state.inner = CodeMirror5.startState(other.mode, mode2.indent ? mode2.indent(state.outer, "", "") : 0);
                  }
                }
              } else if (state.innerActive.close === "\n") {
                state.innerActive = state.inner = null;
              }
            },
            electricChars: outer.electricChars,
            innerMode: function(state) {
              return state.inner ? { state: state.inner, mode: state.innerActive.mode } : { state: state.outer, mode: outer };
            }
          };
        };
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/handlebars/handlebars.js
  var require_handlebars = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/handlebars/handlebars.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_simple(), require_multiplex());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../../addon/mode/simple", "../../addon/mode/multiplex"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineSimpleMode("handlebars-tags", {
          start: [
            { regex: /\{\{\{/, push: "handlebars_raw", token: "tag" },
            { regex: /\{\{!--/, push: "dash_comment", token: "comment" },
            { regex: /\{\{!/, push: "comment", token: "comment" },
            { regex: /\{\{/, push: "handlebars", token: "tag" }
          ],
          handlebars_raw: [
            { regex: /\}\}\}/, pop: true, token: "tag" }
          ],
          handlebars: [
            { regex: /\}\}/, pop: true, token: "tag" },
            { regex: /"(?:[^\\"]|\\.)*"?/, token: "string" },
            { regex: /'(?:[^\\']|\\.)*'?/, token: "string" },
            { regex: />|[#\/]([A-Za-z_]\w*)/, token: "keyword" },
            { regex: /(?:else|this)\b/, token: "keyword" },
            { regex: /\d+/i, token: "number" },
            { regex: /=|~|@|true|false/, token: "atom" },
            { regex: /(?:\.\.\/)*(?:[A-Za-z_][\w\.]*)+/, token: "variable-2" }
          ],
          dash_comment: [
            { regex: /--\}\}/, pop: true, token: "comment" },
            { regex: /./, token: "comment" }
          ],
          comment: [
            { regex: /\}\}/, pop: true, token: "comment" },
            { regex: /./, token: "comment" }
          ],
          meta: {
            blockCommentStart: "{{--",
            blockCommentEnd: "--}}"
          }
        });
        CodeMirror5.defineMode("handlebars", function(config3, parserConfig) {
          var handlebars = CodeMirror5.getMode(config3, "handlebars-tags");
          if (!parserConfig || !parserConfig.base)
            return handlebars;
          return CodeMirror5.multiplexingMode(CodeMirror5.getMode(config3, parserConfig.base), { open: "{{", close: /\}\}\}?/, mode: handlebars, parseDelimiters: true });
        });
        CodeMirror5.defineMIME("text/x-handlebars-template", "handlebars");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/haskell/haskell.js
  var require_haskell = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/haskell/haskell.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("haskell", function(_config, modeConfig) {
          function switchState(source, setState, f3) {
            setState(f3);
            return f3(source, setState);
          }
          var smallRE = /[a-z_]/;
          var largeRE = /[A-Z]/;
          var digitRE = /\d/;
          var hexitRE = /[0-9A-Fa-f]/;
          var octitRE = /[0-7]/;
          var idRE = /[a-z_A-Z0-9'\xa1-\uffff]/;
          var symbolRE = /[-!#$%&*+.\/<=>?@\\^|~:]/;
          var specialRE = /[(),;[\]`{}]/;
          var whiteCharRE = /[ \t\v\f]/;
          function normal(source, setState) {
            if (source.eatWhile(whiteCharRE)) {
              return null;
            }
            var ch = source.next();
            if (specialRE.test(ch)) {
              if (ch == "{" && source.eat("-")) {
                var t3 = "comment";
                if (source.eat("#")) {
                  t3 = "meta";
                }
                return switchState(source, setState, ncomment(t3, 1));
              }
              return null;
            }
            if (ch == "'") {
              if (source.eat("\\")) {
                source.next();
              } else {
                source.next();
              }
              if (source.eat("'")) {
                return "string";
              }
              return "string error";
            }
            if (ch == '"') {
              return switchState(source, setState, stringLiteral);
            }
            if (largeRE.test(ch)) {
              source.eatWhile(idRE);
              if (source.eat(".")) {
                return "qualifier";
              }
              return "variable-2";
            }
            if (smallRE.test(ch)) {
              source.eatWhile(idRE);
              return "variable";
            }
            if (digitRE.test(ch)) {
              if (ch == "0") {
                if (source.eat(/[xX]/)) {
                  source.eatWhile(hexitRE);
                  return "integer";
                }
                if (source.eat(/[oO]/)) {
                  source.eatWhile(octitRE);
                  return "number";
                }
              }
              source.eatWhile(digitRE);
              var t3 = "number";
              if (source.match(/^\.\d+/)) {
                t3 = "number";
              }
              if (source.eat(/[eE]/)) {
                t3 = "number";
                source.eat(/[-+]/);
                source.eatWhile(digitRE);
              }
              return t3;
            }
            if (ch == "." && source.eat("."))
              return "keyword";
            if (symbolRE.test(ch)) {
              if (ch == "-" && source.eat(/-/)) {
                source.eatWhile(/-/);
                if (!source.eat(symbolRE)) {
                  source.skipToEnd();
                  return "comment";
                }
              }
              var t3 = "variable";
              if (ch == ":") {
                t3 = "variable-2";
              }
              source.eatWhile(symbolRE);
              return t3;
            }
            return "error";
          }
          function ncomment(type, nest) {
            if (nest == 0) {
              return normal;
            }
            return function(source, setState) {
              var currNest = nest;
              while (!source.eol()) {
                var ch = source.next();
                if (ch == "{" && source.eat("-")) {
                  ++currNest;
                } else if (ch == "-" && source.eat("}")) {
                  --currNest;
                  if (currNest == 0) {
                    setState(normal);
                    return type;
                  }
                }
              }
              setState(ncomment(type, currNest));
              return type;
            };
          }
          function stringLiteral(source, setState) {
            while (!source.eol()) {
              var ch = source.next();
              if (ch == '"') {
                setState(normal);
                return "string";
              }
              if (ch == "\\") {
                if (source.eol() || source.eat(whiteCharRE)) {
                  setState(stringGap);
                  return "string";
                }
                if (source.eat("&")) {
                } else {
                  source.next();
                }
              }
            }
            setState(normal);
            return "string error";
          }
          function stringGap(source, setState) {
            if (source.eat("\\")) {
              return switchState(source, setState, stringLiteral);
            }
            source.next();
            setState(normal);
            return "error";
          }
          var wellKnownWords = function() {
            var wkw = {};
            function setType(t3) {
              return function() {
                for (var i3 = 0; i3 < arguments.length; i3++)
                  wkw[arguments[i3]] = t3;
              };
            }
            setType("keyword")("case", "class", "data", "default", "deriving", "do", "else", "foreign", "if", "import", "in", "infix", "infixl", "infixr", "instance", "let", "module", "newtype", "of", "then", "type", "where", "_");
            setType("keyword")("..", ":", "::", "=", "\\", "<-", "->", "@", "~", "=>");
            setType("builtin")("!!", "$!", "$", "&&", "+", "++", "-", ".", "/", "/=", "<", "<*", "<=", "<$>", "<*>", "=<<", "==", ">", ">=", ">>", ">>=", "^", "^^", "||", "*", "*>", "**");
            setType("builtin")("Applicative", "Bool", "Bounded", "Char", "Double", "EQ", "Either", "Enum", "Eq", "False", "FilePath", "Float", "Floating", "Fractional", "Functor", "GT", "IO", "IOError", "Int", "Integer", "Integral", "Just", "LT", "Left", "Maybe", "Monad", "Nothing", "Num", "Ord", "Ordering", "Rational", "Read", "ReadS", "Real", "RealFloat", "RealFrac", "Right", "Show", "ShowS", "String", "True");
            setType("builtin")("abs", "acos", "acosh", "all", "and", "any", "appendFile", "asTypeOf", "asin", "asinh", "atan", "atan2", "atanh", "break", "catch", "ceiling", "compare", "concat", "concatMap", "const", "cos", "cosh", "curry", "cycle", "decodeFloat", "div", "divMod", "drop", "dropWhile", "either", "elem", "encodeFloat", "enumFrom", "enumFromThen", "enumFromThenTo", "enumFromTo", "error", "even", "exp", "exponent", "fail", "filter", "flip", "floatDigits", "floatRadix", "floatRange", "floor", "fmap", "foldl", "foldl1", "foldr", "foldr1", "fromEnum", "fromInteger", "fromIntegral", "fromRational", "fst", "gcd", "getChar", "getContents", "getLine", "head", "id", "init", "interact", "ioError", "isDenormalized", "isIEEE", "isInfinite", "isNaN", "isNegativeZero", "iterate", "last", "lcm", "length", "lex", "lines", "log", "logBase", "lookup", "map", "mapM", "mapM_", "max", "maxBound", "maximum", "maybe", "min", "minBound", "minimum", "mod", "negate", "not", "notElem", "null", "odd", "or", "otherwise", "pi", "pred", "print", "product", "properFraction", "pure", "putChar", "putStr", "putStrLn", "quot", "quotRem", "read", "readFile", "readIO", "readList", "readLn", "readParen", "reads", "readsPrec", "realToFrac", "recip", "rem", "repeat", "replicate", "return", "reverse", "round", "scaleFloat", "scanl", "scanl1", "scanr", "scanr1", "seq", "sequence", "sequence_", "show", "showChar", "showList", "showParen", "showString", "shows", "showsPrec", "significand", "signum", "sin", "sinh", "snd", "span", "splitAt", "sqrt", "subtract", "succ", "sum", "tail", "take", "takeWhile", "tan", "tanh", "toEnum", "toInteger", "toRational", "truncate", "uncurry", "undefined", "unlines", "until", "unwords", "unzip", "unzip3", "userError", "words", "writeFile", "zip", "zip3", "zipWith", "zipWith3");
            var override = modeConfig.overrideKeywords;
            if (override) {
              for (var word in override)
                if (override.hasOwnProperty(word))
                  wkw[word] = override[word];
            }
            return wkw;
          }();
          return {
            startState: function() {
              return { f: normal };
            },
            copyState: function(s3) {
              return { f: s3.f };
            },
            token: function(stream, state) {
              var t3 = state.f(stream, function(s3) {
                state.f = s3;
              });
              var w3 = stream.current();
              return wellKnownWords.hasOwnProperty(w3) ? wellKnownWords[w3] : t3;
            },
            blockCommentStart: "{-",
            blockCommentEnd: "-}",
            lineComment: "--"
          };
        });
        CodeMirror5.defineMIME("text/x-haskell", "haskell");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/haskell-literate/haskell-literate.js
  var require_haskell_literate = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/haskell-literate/haskell-literate.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_haskell());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../haskell/haskell"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("haskell-literate", function(config3, parserConfig) {
          var baseMode = CodeMirror5.getMode(config3, parserConfig && parserConfig.base || "haskell");
          return {
            startState: function() {
              return {
                inCode: false,
                baseState: CodeMirror5.startState(baseMode)
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (state.inCode = stream.eat(">"))
                  return "meta";
              }
              if (state.inCode) {
                return baseMode.token(stream, state.baseState);
              } else {
                stream.skipToEnd();
                return "comment";
              }
            },
            innerMode: function(state) {
              return state.inCode ? { state: state.baseState, mode: baseMode } : null;
            }
          };
        }, "haskell");
        CodeMirror5.defineMIME("text/x-literate-haskell", "haskell-literate");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/haxe/haxe.js
  var require_haxe = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/haxe/haxe.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("haxe", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit;
          function kw(type2) {
            return { type: type2, style: "keyword" };
          }
          var A2 = kw("keyword a"), B = kw("keyword b"), C2 = kw("keyword c");
          var operator = kw("operator"), atom = { type: "atom", style: "atom" }, attribute = { type: "attribute", style: "attribute" };
          var type = kw("typedef");
          var keywords2 = {
            "if": A2,
            "while": A2,
            "else": B,
            "do": B,
            "try": B,
            "return": C2,
            "break": C2,
            "continue": C2,
            "new": C2,
            "throw": C2,
            "var": kw("var"),
            "inline": attribute,
            "static": attribute,
            "using": kw("import"),
            "public": attribute,
            "private": attribute,
            "cast": kw("cast"),
            "import": kw("import"),
            "macro": kw("macro"),
            "function": kw("function"),
            "catch": kw("catch"),
            "untyped": kw("untyped"),
            "callback": kw("cb"),
            "for": kw("for"),
            "switch": kw("switch"),
            "case": kw("case"),
            "default": kw("default"),
            "in": operator,
            "never": kw("property_access"),
            "trace": kw("trace"),
            "class": type,
            "abstract": type,
            "enum": type,
            "interface": type,
            "typedef": type,
            "extends": type,
            "implements": type,
            "dynamic": type,
            "true": atom,
            "false": atom,
            "null": atom
          };
          var isOperatorChar = /[+\-*&%=<>!?|]/;
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function toUnescaped(stream, end) {
            var escaped = false, next;
            while ((next = stream.next()) != null) {
              if (next == end && !escaped)
                return true;
              escaped = !escaped && next == "\\";
            }
          }
          var type, content;
          function ret(tp, style, cont2) {
            type = tp;
            content = cont2;
            return style;
          }
          function haxeTokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              return chain2(stream, state, haxeTokenString(ch));
            } else if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              return ret(ch);
            } else if (ch == "0" && stream.eat(/x/i)) {
              stream.eatWhile(/[\da-f]/i);
              return ret("number", "number");
            } else if (/\d/.test(ch) || ch == "-" && stream.eat(/\d/)) {
              stream.match(/^\d*(?:\.\d*(?!\.))?(?:[eE][+\-]?\d+)?/);
              return ret("number", "number");
            } else if (state.reAllowed && (ch == "~" && stream.eat(/\//))) {
              toUnescaped(stream, "/");
              stream.eatWhile(/[gimsu]/);
              return ret("regexp", "string-2");
            } else if (ch == "/") {
              if (stream.eat("*")) {
                return chain2(stream, state, haxeTokenComment);
              } else if (stream.eat("/")) {
                stream.skipToEnd();
                return ret("comment", "comment");
              } else {
                stream.eatWhile(isOperatorChar);
                return ret("operator", null, stream.current());
              }
            } else if (ch == "#") {
              stream.skipToEnd();
              return ret("conditional", "meta");
            } else if (ch == "@") {
              stream.eat(/:/);
              stream.eatWhile(/[\w_]/);
              return ret("metadata", "meta");
            } else if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return ret("operator", null, stream.current());
            } else {
              var word;
              if (/[A-Z]/.test(ch)) {
                stream.eatWhile(/[\w_<>]/);
                word = stream.current();
                return ret("type", "variable-3", word);
              } else {
                stream.eatWhile(/[\w_]/);
                var word = stream.current(), known = keywords2.propertyIsEnumerable(word) && keywords2[word];
                return known && state.kwAllowed ? ret(known.type, known.style, word) : ret("variable", "variable", word);
              }
            }
          }
          function haxeTokenString(quote) {
            return function(stream, state) {
              if (toUnescaped(stream, quote))
                state.tokenize = haxeTokenBase;
              return ret("string", "string");
            };
          }
          function haxeTokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = haxeTokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return ret("comment", "comment");
          }
          var atomicTypes = { "atom": true, "number": true, "variable": true, "string": true, "regexp": true };
          function HaxeLexical(indented, column, type2, align, prev, info) {
            this.indented = indented;
            this.column = column;
            this.type = type2;
            this.prev = prev;
            this.info = info;
            if (align != null)
              this.align = align;
          }
          function inScope(state, varname) {
            for (var v3 = state.localVars; v3; v3 = v3.next)
              if (v3.name == varname)
                return true;
          }
          function parseHaxe(state, style, type2, content2, stream) {
            var cc = state.cc;
            cx.state = state;
            cx.stream = stream;
            cx.marked = null, cx.cc = cc;
            if (!state.lexical.hasOwnProperty("align"))
              state.lexical.align = true;
            while (true) {
              var combinator = cc.length ? cc.pop() : statement;
              if (combinator(type2, content2)) {
                while (cc.length && cc[cc.length - 1].lex)
                  cc.pop()();
                if (cx.marked)
                  return cx.marked;
                if (type2 == "variable" && inScope(state, content2))
                  return "variable-2";
                if (type2 == "variable" && imported(state, content2))
                  return "variable-3";
                return style;
              }
            }
          }
          function imported(state, typename) {
            if (/[a-z]/.test(typename.charAt(0)))
              return false;
            var len = state.importedtypes.length;
            for (var i3 = 0; i3 < len; i3++)
              if (state.importedtypes[i3] == typename)
                return true;
          }
          function registerimport(importname) {
            var state = cx.state;
            for (var t3 = state.importedtypes; t3; t3 = t3.next)
              if (t3.name == importname)
                return;
            state.importedtypes = { name: importname, next: state.importedtypes };
          }
          var cx = { state: null, column: null, marked: null, cc: null };
          function pass() {
            for (var i3 = arguments.length - 1; i3 >= 0; i3--)
              cx.cc.push(arguments[i3]);
          }
          function cont() {
            pass.apply(null, arguments);
            return true;
          }
          function inList(name106, list) {
            for (var v3 = list; v3; v3 = v3.next)
              if (v3.name == name106)
                return true;
            return false;
          }
          function register(varname) {
            var state = cx.state;
            if (state.context) {
              cx.marked = "def";
              if (inList(varname, state.localVars))
                return;
              state.localVars = { name: varname, next: state.localVars };
            } else if (state.globalVars) {
              if (inList(varname, state.globalVars))
                return;
              state.globalVars = { name: varname, next: state.globalVars };
            }
          }
          var defaultVars = { name: "this", next: null };
          function pushcontext() {
            if (!cx.state.context)
              cx.state.localVars = defaultVars;
            cx.state.context = { prev: cx.state.context, vars: cx.state.localVars };
          }
          function popcontext() {
            cx.state.localVars = cx.state.context.vars;
            cx.state.context = cx.state.context.prev;
          }
          popcontext.lex = true;
          function pushlex(type2, info) {
            var result = function() {
              var state = cx.state;
              state.lexical = new HaxeLexical(state.indented, cx.stream.column(), type2, null, state.lexical, info);
            };
            result.lex = true;
            return result;
          }
          function poplex() {
            var state = cx.state;
            if (state.lexical.prev) {
              if (state.lexical.type == ")")
                state.indented = state.lexical.indented;
              state.lexical = state.lexical.prev;
            }
          }
          poplex.lex = true;
          function expect(wanted) {
            function f3(type2) {
              if (type2 == wanted)
                return cont();
              else if (wanted == ";")
                return pass();
              else
                return cont(f3);
            }
            return f3;
          }
          function statement(type2) {
            if (type2 == "@")
              return cont(metadef);
            if (type2 == "var")
              return cont(pushlex("vardef"), vardef1, expect(";"), poplex);
            if (type2 == "keyword a")
              return cont(pushlex("form"), expression, statement, poplex);
            if (type2 == "keyword b")
              return cont(pushlex("form"), statement, poplex);
            if (type2 == "{")
              return cont(pushlex("}"), pushcontext, block, poplex, popcontext);
            if (type2 == ";")
              return cont();
            if (type2 == "attribute")
              return cont(maybeattribute);
            if (type2 == "function")
              return cont(functiondef);
            if (type2 == "for")
              return cont(pushlex("form"), expect("("), pushlex(")"), forspec1, expect(")"), poplex, statement, poplex);
            if (type2 == "variable")
              return cont(pushlex("stat"), maybelabel);
            if (type2 == "switch")
              return cont(pushlex("form"), expression, pushlex("}", "switch"), expect("{"), block, poplex, poplex);
            if (type2 == "case")
              return cont(expression, expect(":"));
            if (type2 == "default")
              return cont(expect(":"));
            if (type2 == "catch")
              return cont(pushlex("form"), pushcontext, expect("("), funarg, expect(")"), statement, poplex, popcontext);
            if (type2 == "import")
              return cont(importdef, expect(";"));
            if (type2 == "typedef")
              return cont(typedef);
            return pass(pushlex("stat"), expression, expect(";"), poplex);
          }
          function expression(type2) {
            if (atomicTypes.hasOwnProperty(type2))
              return cont(maybeoperator);
            if (type2 == "type")
              return cont(maybeoperator);
            if (type2 == "function")
              return cont(functiondef);
            if (type2 == "keyword c")
              return cont(maybeexpression);
            if (type2 == "(")
              return cont(pushlex(")"), maybeexpression, expect(")"), poplex, maybeoperator);
            if (type2 == "operator")
              return cont(expression);
            if (type2 == "[")
              return cont(pushlex("]"), commasep(maybeexpression, "]"), poplex, maybeoperator);
            if (type2 == "{")
              return cont(pushlex("}"), commasep(objprop, "}"), poplex, maybeoperator);
            return cont();
          }
          function maybeexpression(type2) {
            if (type2.match(/[;\}\)\],]/))
              return pass();
            return pass(expression);
          }
          function maybeoperator(type2, value) {
            if (type2 == "operator" && /\+\+|--/.test(value))
              return cont(maybeoperator);
            if (type2 == "operator" || type2 == ":")
              return cont(expression);
            if (type2 == ";")
              return;
            if (type2 == "(")
              return cont(pushlex(")"), commasep(expression, ")"), poplex, maybeoperator);
            if (type2 == ".")
              return cont(property, maybeoperator);
            if (type2 == "[")
              return cont(pushlex("]"), expression, expect("]"), poplex, maybeoperator);
          }
          function maybeattribute(type2) {
            if (type2 == "attribute")
              return cont(maybeattribute);
            if (type2 == "function")
              return cont(functiondef);
            if (type2 == "var")
              return cont(vardef1);
          }
          function metadef(type2) {
            if (type2 == ":")
              return cont(metadef);
            if (type2 == "variable")
              return cont(metadef);
            if (type2 == "(")
              return cont(pushlex(")"), commasep(metaargs, ")"), poplex, statement);
          }
          function metaargs(type2) {
            if (type2 == "variable")
              return cont();
          }
          function importdef(type2, value) {
            if (type2 == "variable" && /[A-Z]/.test(value.charAt(0))) {
              registerimport(value);
              return cont();
            } else if (type2 == "variable" || type2 == "property" || type2 == "." || value == "*")
              return cont(importdef);
          }
          function typedef(type2, value) {
            if (type2 == "variable" && /[A-Z]/.test(value.charAt(0))) {
              registerimport(value);
              return cont();
            } else if (type2 == "type" && /[A-Z]/.test(value.charAt(0))) {
              return cont();
            }
          }
          function maybelabel(type2) {
            if (type2 == ":")
              return cont(poplex, statement);
            return pass(maybeoperator, expect(";"), poplex);
          }
          function property(type2) {
            if (type2 == "variable") {
              cx.marked = "property";
              return cont();
            }
          }
          function objprop(type2) {
            if (type2 == "variable")
              cx.marked = "property";
            if (atomicTypes.hasOwnProperty(type2))
              return cont(expect(":"), expression);
          }
          function commasep(what, end) {
            function proceed(type2) {
              if (type2 == ",")
                return cont(what, proceed);
              if (type2 == end)
                return cont();
              return cont(expect(end));
            }
            return function(type2) {
              if (type2 == end)
                return cont();
              else
                return pass(what, proceed);
            };
          }
          function block(type2) {
            if (type2 == "}")
              return cont();
            return pass(statement, block);
          }
          function vardef1(type2, value) {
            if (type2 == "variable") {
              register(value);
              return cont(typeuse, vardef2);
            }
            return cont();
          }
          function vardef2(type2, value) {
            if (value == "=")
              return cont(expression, vardef2);
            if (type2 == ",")
              return cont(vardef1);
          }
          function forspec1(type2, value) {
            if (type2 == "variable") {
              register(value);
              return cont(forin, expression);
            } else {
              return pass();
            }
          }
          function forin(_type, value) {
            if (value == "in")
              return cont();
          }
          function functiondef(type2, value) {
            if (type2 == "variable" || type2 == "type") {
              register(value);
              return cont(functiondef);
            }
            if (value == "new")
              return cont(functiondef);
            if (type2 == "(")
              return cont(pushlex(")"), pushcontext, commasep(funarg, ")"), poplex, typeuse, statement, popcontext);
          }
          function typeuse(type2) {
            if (type2 == ":")
              return cont(typestring);
          }
          function typestring(type2) {
            if (type2 == "type")
              return cont();
            if (type2 == "variable")
              return cont();
            if (type2 == "{")
              return cont(pushlex("}"), commasep(typeprop, "}"), poplex);
          }
          function typeprop(type2) {
            if (type2 == "variable")
              return cont(typeuse);
          }
          function funarg(type2, value) {
            if (type2 == "variable") {
              register(value);
              return cont(typeuse);
            }
          }
          return {
            startState: function(basecolumn) {
              var defaulttypes = ["Int", "Float", "String", "Void", "Std", "Bool", "Dynamic", "Array"];
              var state = {
                tokenize: haxeTokenBase,
                reAllowed: true,
                kwAllowed: true,
                cc: [],
                lexical: new HaxeLexical((basecolumn || 0) - indentUnit, 0, "block", false),
                localVars: parserConfig.localVars,
                importedtypes: defaulttypes,
                context: parserConfig.localVars && { vars: parserConfig.localVars },
                indented: 0
              };
              if (parserConfig.globalVars && typeof parserConfig.globalVars == "object")
                state.globalVars = parserConfig.globalVars;
              return state;
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (!state.lexical.hasOwnProperty("align"))
                  state.lexical.align = false;
                state.indented = stream.indentation();
              }
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              if (type == "comment")
                return style;
              state.reAllowed = !!(type == "operator" || type == "keyword c" || type.match(/^[\[{}\(,;:]$/));
              state.kwAllowed = type != ".";
              return parseHaxe(state, style, type, content, stream);
            },
            indent: function(state, textAfter) {
              if (state.tokenize != haxeTokenBase)
                return 0;
              var firstChar = textAfter && textAfter.charAt(0), lexical = state.lexical;
              if (lexical.type == "stat" && firstChar == "}")
                lexical = lexical.prev;
              var type2 = lexical.type, closing = firstChar == type2;
              if (type2 == "vardef")
                return lexical.indented + 4;
              else if (type2 == "form" && firstChar == "{")
                return lexical.indented;
              else if (type2 == "stat" || type2 == "form")
                return lexical.indented + indentUnit;
              else if (lexical.info == "switch" && !closing)
                return lexical.indented + (/^(?:case|default)\b/.test(textAfter) ? indentUnit : 2 * indentUnit);
              else if (lexical.align)
                return lexical.column + (closing ? 0 : 1);
              else
                return lexical.indented + (closing ? 0 : indentUnit);
            },
            electricChars: "{}",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//"
          };
        });
        CodeMirror5.defineMIME("text/x-haxe", "haxe");
        CodeMirror5.defineMode("hxml", function() {
          return {
            startState: function() {
              return {
                define: false,
                inString: false
              };
            },
            token: function(stream, state) {
              var ch = stream.peek();
              var sol = stream.sol();
              if (ch == "#") {
                stream.skipToEnd();
                return "comment";
              }
              if (sol && ch == "-") {
                var style = "variable-2";
                stream.eat(/-/);
                if (stream.peek() == "-") {
                  stream.eat(/-/);
                  style = "keyword a";
                }
                if (stream.peek() == "D") {
                  stream.eat(/[D]/);
                  style = "keyword c";
                  state.define = true;
                }
                stream.eatWhile(/[A-Z]/i);
                return style;
              }
              var ch = stream.peek();
              if (state.inString == false && ch == "'") {
                state.inString = true;
                stream.next();
              }
              if (state.inString == true) {
                if (stream.skipTo("'")) {
                } else {
                  stream.skipToEnd();
                }
                if (stream.peek() == "'") {
                  stream.next();
                  state.inString = false;
                }
                return "string";
              }
              stream.next();
              return null;
            },
            lineComment: "#"
          };
        });
        CodeMirror5.defineMIME("text/x-hxml", "hxml");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/htmlembedded/htmlembedded.js
  var require_htmlembedded = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/htmlembedded/htmlembedded.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_htmlmixed(), require_multiplex());
        else if (typeof define == "function" && define.amd)
          define([
            "../../lib/codemirror",
            "../htmlmixed/htmlmixed",
            "../../addon/mode/multiplex"
          ], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("htmlembedded", function(config3, parserConfig) {
          var closeComment = parserConfig.closeComment || "--%>";
          return CodeMirror5.multiplexingMode(CodeMirror5.getMode(config3, "htmlmixed"), {
            open: parserConfig.openComment || "<%--",
            close: closeComment,
            delimStyle: "comment",
            mode: { token: function(stream) {
              stream.skipTo(closeComment) || stream.skipToEnd();
              return "comment";
            } }
          }, {
            open: parserConfig.open || parserConfig.scriptStartRegex || "<%",
            close: parserConfig.close || parserConfig.scriptEndRegex || "%>",
            mode: CodeMirror5.getMode(config3, parserConfig.scriptingModeSpec)
          });
        }, "htmlmixed");
        CodeMirror5.defineMIME("application/x-ejs", { name: "htmlembedded", scriptingModeSpec: "javascript" });
        CodeMirror5.defineMIME("application/x-aspx", { name: "htmlembedded", scriptingModeSpec: "text/x-csharp" });
        CodeMirror5.defineMIME("application/x-jsp", { name: "htmlembedded", scriptingModeSpec: "text/x-java" });
        CodeMirror5.defineMIME("application/x-erb", { name: "htmlembedded", scriptingModeSpec: "ruby" });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/idl/idl.js
  var require_idl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/idl/idl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function wordRegexp(words) {
          return new RegExp("^((" + words.join(")|(") + "))\\b", "i");
        }
        ;
        var builtinArray = [
          "a_correlate",
          "abs",
          "acos",
          "adapt_hist_equal",
          "alog",
          "alog2",
          "alog10",
          "amoeba",
          "annotate",
          "app_user_dir",
          "app_user_dir_query",
          "arg_present",
          "array_equal",
          "array_indices",
          "arrow",
          "ascii_template",
          "asin",
          "assoc",
          "atan",
          "axis",
          "axis",
          "bandpass_filter",
          "bandreject_filter",
          "barplot",
          "bar_plot",
          "beseli",
          "beselj",
          "beselk",
          "besely",
          "beta",
          "biginteger",
          "bilinear",
          "bin_date",
          "binary_template",
          "bindgen",
          "binomial",
          "bit_ffs",
          "bit_population",
          "blas_axpy",
          "blk_con",
          "boolarr",
          "boolean",
          "boxplot",
          "box_cursor",
          "breakpoint",
          "broyden",
          "bubbleplot",
          "butterworth",
          "bytarr",
          "byte",
          "byteorder",
          "bytscl",
          "c_correlate",
          "calendar",
          "caldat",
          "call_external",
          "call_function",
          "call_method",
          "call_procedure",
          "canny",
          "catch",
          "cd",
          "cdf",
          "ceil",
          "chebyshev",
          "check_math",
          "chisqr_cvf",
          "chisqr_pdf",
          "choldc",
          "cholsol",
          "cindgen",
          "cir_3pnt",
          "clipboard",
          "close",
          "clust_wts",
          "cluster",
          "cluster_tree",
          "cmyk_convert",
          "code_coverage",
          "color_convert",
          "color_exchange",
          "color_quan",
          "color_range_map",
          "colorbar",
          "colorize_sample",
          "colormap_applicable",
          "colormap_gradient",
          "colormap_rotation",
          "colortable",
          "comfit",
          "command_line_args",
          "common",
          "compile_opt",
          "complex",
          "complexarr",
          "complexround",
          "compute_mesh_normals",
          "cond",
          "congrid",
          "conj",
          "constrained_min",
          "contour",
          "contour",
          "convert_coord",
          "convol",
          "convol_fft",
          "coord2to3",
          "copy_lun",
          "correlate",
          "cos",
          "cosh",
          "cpu",
          "cramer",
          "createboxplotdata",
          "create_cursor",
          "create_struct",
          "create_view",
          "crossp",
          "crvlength",
          "ct_luminance",
          "cti_test",
          "cursor",
          "curvefit",
          "cv_coord",
          "cvttobm",
          "cw_animate",
          "cw_animate_getp",
          "cw_animate_load",
          "cw_animate_run",
          "cw_arcball",
          "cw_bgroup",
          "cw_clr_index",
          "cw_colorsel",
          "cw_defroi",
          "cw_field",
          "cw_filesel",
          "cw_form",
          "cw_fslider",
          "cw_light_editor",
          "cw_light_editor_get",
          "cw_light_editor_set",
          "cw_orient",
          "cw_palette_editor",
          "cw_palette_editor_get",
          "cw_palette_editor_set",
          "cw_pdmenu",
          "cw_rgbslider",
          "cw_tmpl",
          "cw_zoom",
          "db_exists",
          "dblarr",
          "dcindgen",
          "dcomplex",
          "dcomplexarr",
          "define_key",
          "define_msgblk",
          "define_msgblk_from_file",
          "defroi",
          "defsysv",
          "delvar",
          "dendro_plot",
          "dendrogram",
          "deriv",
          "derivsig",
          "determ",
          "device",
          "dfpmin",
          "diag_matrix",
          "dialog_dbconnect",
          "dialog_message",
          "dialog_pickfile",
          "dialog_printersetup",
          "dialog_printjob",
          "dialog_read_image",
          "dialog_write_image",
          "dictionary",
          "digital_filter",
          "dilate",
          "dindgen",
          "dissolve",
          "dist",
          "distance_measure",
          "dlm_load",
          "dlm_register",
          "doc_library",
          "double",
          "draw_roi",
          "edge_dog",
          "efont",
          "eigenql",
          "eigenvec",
          "ellipse",
          "elmhes",
          "emboss",
          "empty",
          "enable_sysrtn",
          "eof",
          "eos",
          "erase",
          "erf",
          "erfc",
          "erfcx",
          "erode",
          "errorplot",
          "errplot",
          "estimator_filter",
          "execute",
          "exit",
          "exp",
          "expand",
          "expand_path",
          "expint",
          "extrac",
          "extract_slice",
          "f_cvf",
          "f_pdf",
          "factorial",
          "fft",
          "file_basename",
          "file_chmod",
          "file_copy",
          "file_delete",
          "file_dirname",
          "file_expand_path",
          "file_gunzip",
          "file_gzip",
          "file_info",
          "file_lines",
          "file_link",
          "file_mkdir",
          "file_move",
          "file_poll_input",
          "file_readlink",
          "file_same",
          "file_search",
          "file_tar",
          "file_test",
          "file_untar",
          "file_unzip",
          "file_which",
          "file_zip",
          "filepath",
          "findgen",
          "finite",
          "fix",
          "flick",
          "float",
          "floor",
          "flow3",
          "fltarr",
          "flush",
          "format_axis_values",
          "forward_function",
          "free_lun",
          "fstat",
          "fulstr",
          "funct",
          "function",
          "fv_test",
          "fx_root",
          "fz_roots",
          "gamma",
          "gamma_ct",
          "gauss_cvf",
          "gauss_pdf",
          "gauss_smooth",
          "gauss2dfit",
          "gaussfit",
          "gaussian_function",
          "gaussint",
          "get_drive_list",
          "get_dxf_objects",
          "get_kbrd",
          "get_login_info",
          "get_lun",
          "get_screen_size",
          "getenv",
          "getwindows",
          "greg2jul",
          "grib",
          "grid_input",
          "grid_tps",
          "grid3",
          "griddata",
          "gs_iter",
          "h_eq_ct",
          "h_eq_int",
          "hanning",
          "hash",
          "hdf",
          "hdf5",
          "heap_free",
          "heap_gc",
          "heap_nosave",
          "heap_refcount",
          "heap_save",
          "help",
          "hilbert",
          "hist_2d",
          "hist_equal",
          "histogram",
          "hls",
          "hough",
          "hqr",
          "hsv",
          "i18n_multibytetoutf8",
          "i18n_multibytetowidechar",
          "i18n_utf8tomultibyte",
          "i18n_widechartomultibyte",
          "ibeta",
          "icontour",
          "iconvertcoord",
          "idelete",
          "identity",
          "idl_base64",
          "idl_container",
          "idl_validname",
          "idlexbr_assistant",
          "idlitsys_createtool",
          "idlunit",
          "iellipse",
          "igamma",
          "igetcurrent",
          "igetdata",
          "igetid",
          "igetproperty",
          "iimage",
          "image",
          "image_cont",
          "image_statistics",
          "image_threshold",
          "imaginary",
          "imap",
          "indgen",
          "int_2d",
          "int_3d",
          "int_tabulated",
          "intarr",
          "interpol",
          "interpolate",
          "interval_volume",
          "invert",
          "ioctl",
          "iopen",
          "ir_filter",
          "iplot",
          "ipolygon",
          "ipolyline",
          "iputdata",
          "iregister",
          "ireset",
          "iresolve",
          "irotate",
          "isa",
          "isave",
          "iscale",
          "isetcurrent",
          "isetproperty",
          "ishft",
          "isocontour",
          "isosurface",
          "isurface",
          "itext",
          "itranslate",
          "ivector",
          "ivolume",
          "izoom",
          "journal",
          "json_parse",
          "json_serialize",
          "jul2greg",
          "julday",
          "keyword_set",
          "krig2d",
          "kurtosis",
          "kw_test",
          "l64indgen",
          "la_choldc",
          "la_cholmprove",
          "la_cholsol",
          "la_determ",
          "la_eigenproblem",
          "la_eigenql",
          "la_eigenvec",
          "la_elmhes",
          "la_gm_linear_model",
          "la_hqr",
          "la_invert",
          "la_least_square_equality",
          "la_least_squares",
          "la_linear_equation",
          "la_ludc",
          "la_lumprove",
          "la_lusol",
          "la_svd",
          "la_tridc",
          "la_trimprove",
          "la_triql",
          "la_trired",
          "la_trisol",
          "label_date",
          "label_region",
          "ladfit",
          "laguerre",
          "lambda",
          "lambdap",
          "lambertw",
          "laplacian",
          "least_squares_filter",
          "leefilt",
          "legend",
          "legendre",
          "linbcg",
          "lindgen",
          "linfit",
          "linkimage",
          "list",
          "ll_arc_distance",
          "lmfit",
          "lmgr",
          "lngamma",
          "lnp_test",
          "loadct",
          "locale_get",
          "logical_and",
          "logical_or",
          "logical_true",
          "lon64arr",
          "lonarr",
          "long",
          "long64",
          "lsode",
          "lu_complex",
          "ludc",
          "lumprove",
          "lusol",
          "m_correlate",
          "machar",
          "make_array",
          "make_dll",
          "make_rt",
          "map",
          "mapcontinents",
          "mapgrid",
          "map_2points",
          "map_continents",
          "map_grid",
          "map_image",
          "map_patch",
          "map_proj_forward",
          "map_proj_image",
          "map_proj_info",
          "map_proj_init",
          "map_proj_inverse",
          "map_set",
          "matrix_multiply",
          "matrix_power",
          "max",
          "md_test",
          "mean",
          "meanabsdev",
          "mean_filter",
          "median",
          "memory",
          "mesh_clip",
          "mesh_decimate",
          "mesh_issolid",
          "mesh_merge",
          "mesh_numtriangles",
          "mesh_obj",
          "mesh_smooth",
          "mesh_surfacearea",
          "mesh_validate",
          "mesh_volume",
          "message",
          "min",
          "min_curve_surf",
          "mk_html_help",
          "modifyct",
          "moment",
          "morph_close",
          "morph_distance",
          "morph_gradient",
          "morph_hitormiss",
          "morph_open",
          "morph_thin",
          "morph_tophat",
          "multi",
          "n_elements",
          "n_params",
          "n_tags",
          "ncdf",
          "newton",
          "noise_hurl",
          "noise_pick",
          "noise_scatter",
          "noise_slur",
          "norm",
          "obj_class",
          "obj_destroy",
          "obj_hasmethod",
          "obj_isa",
          "obj_new",
          "obj_valid",
          "objarr",
          "on_error",
          "on_ioerror",
          "online_help",
          "openr",
          "openu",
          "openw",
          "oplot",
          "oploterr",
          "orderedhash",
          "p_correlate",
          "parse_url",
          "particle_trace",
          "path_cache",
          "path_sep",
          "pcomp",
          "plot",
          "plot3d",
          "plot",
          "plot_3dbox",
          "plot_field",
          "ploterr",
          "plots",
          "polar_contour",
          "polar_surface",
          "polyfill",
          "polyshade",
          "pnt_line",
          "point_lun",
          "polarplot",
          "poly",
          "poly_2d",
          "poly_area",
          "poly_fit",
          "polyfillv",
          "polygon",
          "polyline",
          "polywarp",
          "popd",
          "powell",
          "pref_commit",
          "pref_get",
          "pref_set",
          "prewitt",
          "primes",
          "print",
          "printf",
          "printd",
          "pro",
          "product",
          "profile",
          "profiler",
          "profiles",
          "project_vol",
          "ps_show_fonts",
          "psafm",
          "pseudo",
          "ptr_free",
          "ptr_new",
          "ptr_valid",
          "ptrarr",
          "pushd",
          "qgrid3",
          "qhull",
          "qromb",
          "qromo",
          "qsimp",
          "query_*",
          "query_ascii",
          "query_bmp",
          "query_csv",
          "query_dicom",
          "query_gif",
          "query_image",
          "query_jpeg",
          "query_jpeg2000",
          "query_mrsid",
          "query_pict",
          "query_png",
          "query_ppm",
          "query_srf",
          "query_tiff",
          "query_video",
          "query_wav",
          "r_correlate",
          "r_test",
          "radon",
          "randomn",
          "randomu",
          "ranks",
          "rdpix",
          "read",
          "readf",
          "read_ascii",
          "read_binary",
          "read_bmp",
          "read_csv",
          "read_dicom",
          "read_gif",
          "read_image",
          "read_interfile",
          "read_jpeg",
          "read_jpeg2000",
          "read_mrsid",
          "read_pict",
          "read_png",
          "read_ppm",
          "read_spr",
          "read_srf",
          "read_sylk",
          "read_tiff",
          "read_video",
          "read_wav",
          "read_wave",
          "read_x11_bitmap",
          "read_xwd",
          "reads",
          "readu",
          "real_part",
          "rebin",
          "recall_commands",
          "recon3",
          "reduce_colors",
          "reform",
          "region_grow",
          "register_cursor",
          "regress",
          "replicate",
          "replicate_inplace",
          "resolve_all",
          "resolve_routine",
          "restore",
          "retall",
          "return",
          "reverse",
          "rk4",
          "roberts",
          "rot",
          "rotate",
          "round",
          "routine_filepath",
          "routine_info",
          "rs_test",
          "s_test",
          "save",
          "savgol",
          "scale3",
          "scale3d",
          "scatterplot",
          "scatterplot3d",
          "scope_level",
          "scope_traceback",
          "scope_varfetch",
          "scope_varname",
          "search2d",
          "search3d",
          "sem_create",
          "sem_delete",
          "sem_lock",
          "sem_release",
          "set_plot",
          "set_shading",
          "setenv",
          "sfit",
          "shade_surf",
          "shade_surf_irr",
          "shade_volume",
          "shift",
          "shift_diff",
          "shmdebug",
          "shmmap",
          "shmunmap",
          "shmvar",
          "show3",
          "showfont",
          "signum",
          "simplex",
          "sin",
          "sindgen",
          "sinh",
          "size",
          "skewness",
          "skip_lun",
          "slicer3",
          "slide_image",
          "smooth",
          "sobel",
          "socket",
          "sort",
          "spawn",
          "sph_4pnt",
          "sph_scat",
          "spher_harm",
          "spl_init",
          "spl_interp",
          "spline",
          "spline_p",
          "sprsab",
          "sprsax",
          "sprsin",
          "sprstp",
          "sqrt",
          "standardize",
          "stddev",
          "stop",
          "strarr",
          "strcmp",
          "strcompress",
          "streamline",
          "streamline",
          "stregex",
          "stretch",
          "string",
          "strjoin",
          "strlen",
          "strlowcase",
          "strmatch",
          "strmessage",
          "strmid",
          "strpos",
          "strput",
          "strsplit",
          "strtrim",
          "struct_assign",
          "struct_hide",
          "strupcase",
          "surface",
          "surface",
          "surfr",
          "svdc",
          "svdfit",
          "svsol",
          "swap_endian",
          "swap_endian_inplace",
          "symbol",
          "systime",
          "t_cvf",
          "t_pdf",
          "t3d",
          "tag_names",
          "tan",
          "tanh",
          "tek_color",
          "temporary",
          "terminal_size",
          "tetra_clip",
          "tetra_surface",
          "tetra_volume",
          "text",
          "thin",
          "thread",
          "threed",
          "tic",
          "time_test2",
          "timegen",
          "timer",
          "timestamp",
          "timestamptovalues",
          "tm_test",
          "toc",
          "total",
          "trace",
          "transpose",
          "tri_surf",
          "triangulate",
          "trigrid",
          "triql",
          "trired",
          "trisol",
          "truncate_lun",
          "ts_coef",
          "ts_diff",
          "ts_fcast",
          "ts_smooth",
          "tv",
          "tvcrs",
          "tvlct",
          "tvrd",
          "tvscl",
          "typename",
          "uindgen",
          "uint",
          "uintarr",
          "ul64indgen",
          "ulindgen",
          "ulon64arr",
          "ulonarr",
          "ulong",
          "ulong64",
          "uniq",
          "unsharp_mask",
          "usersym",
          "value_locate",
          "variance",
          "vector",
          "vector_field",
          "vel",
          "velovect",
          "vert_t3d",
          "voigt",
          "volume",
          "voronoi",
          "voxel_proj",
          "wait",
          "warp_tri",
          "watershed",
          "wdelete",
          "wf_draw",
          "where",
          "widget_base",
          "widget_button",
          "widget_combobox",
          "widget_control",
          "widget_displaycontextmenu",
          "widget_draw",
          "widget_droplist",
          "widget_event",
          "widget_info",
          "widget_label",
          "widget_list",
          "widget_propertysheet",
          "widget_slider",
          "widget_tab",
          "widget_table",
          "widget_text",
          "widget_tree",
          "widget_tree_move",
          "widget_window",
          "wiener_filter",
          "window",
          "window",
          "write_bmp",
          "write_csv",
          "write_gif",
          "write_image",
          "write_jpeg",
          "write_jpeg2000",
          "write_nrif",
          "write_pict",
          "write_png",
          "write_ppm",
          "write_spr",
          "write_srf",
          "write_sylk",
          "write_tiff",
          "write_video",
          "write_wav",
          "write_wave",
          "writeu",
          "wset",
          "wshow",
          "wtn",
          "wv_applet",
          "wv_cwt",
          "wv_cw_wavelet",
          "wv_denoise",
          "wv_dwt",
          "wv_fn_coiflet",
          "wv_fn_daubechies",
          "wv_fn_gaussian",
          "wv_fn_haar",
          "wv_fn_morlet",
          "wv_fn_paul",
          "wv_fn_symlet",
          "wv_import_data",
          "wv_import_wavelet",
          "wv_plot3d_wps",
          "wv_plot_multires",
          "wv_pwt",
          "wv_tool_denoise",
          "xbm_edit",
          "xdisplayfile",
          "xdxf",
          "xfont",
          "xinteranimate",
          "xloadct",
          "xmanager",
          "xmng_tmpl",
          "xmtool",
          "xobjview",
          "xobjview_rotate",
          "xobjview_write_image",
          "xpalette",
          "xpcolor",
          "xplot3d",
          "xregistered",
          "xroi",
          "xsq_test",
          "xsurface",
          "xvaredit",
          "xvolume",
          "xvolume_rotate",
          "xvolume_write_image",
          "xyouts",
          "zlib_compress",
          "zlib_uncompress",
          "zoom",
          "zoom_24"
        ];
        var builtins = wordRegexp(builtinArray);
        var keywordArray = [
          "begin",
          "end",
          "endcase",
          "endfor",
          "endwhile",
          "endif",
          "endrep",
          "endforeach",
          "break",
          "case",
          "continue",
          "for",
          "foreach",
          "goto",
          "if",
          "then",
          "else",
          "repeat",
          "until",
          "switch",
          "while",
          "do",
          "pro",
          "function"
        ];
        var keywords2 = wordRegexp(keywordArray);
        CodeMirror5.registerHelper("hintWords", "idl", builtinArray.concat(keywordArray));
        var identifiers = new RegExp("^[_a-z\xA1-\uFFFF][_a-z0-9\xA1-\uFFFF]*", "i");
        var singleOperators = /[+\-*&=<>\/@#~$]/;
        var boolOperators = new RegExp("(and|or|eq|lt|le|gt|ge|ne|not)", "i");
        function tokenBase(stream) {
          if (stream.eatSpace())
            return null;
          if (stream.match(";")) {
            stream.skipToEnd();
            return "comment";
          }
          if (stream.match(/^[0-9\.+-]/, false)) {
            if (stream.match(/^[+-]?0x[0-9a-fA-F]+/))
              return "number";
            if (stream.match(/^[+-]?\d*\.\d+([EeDd][+-]?\d+)?/))
              return "number";
            if (stream.match(/^[+-]?\d+([EeDd][+-]?\d+)?/))
              return "number";
          }
          if (stream.match(/^"([^"]|(""))*"/)) {
            return "string";
          }
          if (stream.match(/^'([^']|(''))*'/)) {
            return "string";
          }
          if (stream.match(keywords2)) {
            return "keyword";
          }
          if (stream.match(builtins)) {
            return "builtin";
          }
          if (stream.match(identifiers)) {
            return "variable";
          }
          if (stream.match(singleOperators) || stream.match(boolOperators)) {
            return "operator";
          }
          stream.next();
          return null;
        }
        ;
        CodeMirror5.defineMode("idl", function() {
          return {
            token: function(stream) {
              return tokenBase(stream);
            }
          };
        });
        CodeMirror5.defineMIME("text/x-idl", "idl");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/jinja2/jinja2.js
  var require_jinja2 = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/jinja2/jinja2.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("jinja2", function() {
          var keywords2 = [
            "and",
            "as",
            "block",
            "endblock",
            "by",
            "cycle",
            "debug",
            "else",
            "elif",
            "extends",
            "filter",
            "endfilter",
            "firstof",
            "for",
            "endfor",
            "if",
            "endif",
            "ifchanged",
            "endifchanged",
            "ifequal",
            "endifequal",
            "ifnotequal",
            "endifnotequal",
            "in",
            "include",
            "load",
            "not",
            "now",
            "or",
            "parsed",
            "regroup",
            "reversed",
            "spaceless",
            "endspaceless",
            "ssi",
            "templatetag",
            "openblock",
            "closeblock",
            "openvariable",
            "closevariable",
            "openbrace",
            "closebrace",
            "opencomment",
            "closecomment",
            "widthratio",
            "url",
            "with",
            "endwith",
            "get_current_language",
            "trans",
            "endtrans",
            "noop",
            "blocktrans",
            "endblocktrans",
            "get_available_languages",
            "get_current_language_bidi",
            "plural"
          ], operator = /^[+\-*&%=<>!?|~^]/, sign3 = /^[:\[\(\{]/, atom = ["true", "false"], number2 = /^(\d[+\-\*\/])?\d+(\.\d+)?/;
          keywords2 = new RegExp("((" + keywords2.join(")|(") + "))\\b");
          atom = new RegExp("((" + atom.join(")|(") + "))\\b");
          function tokenBase(stream, state) {
            var ch = stream.peek();
            if (state.incomment) {
              if (!stream.skipTo("#}")) {
                stream.skipToEnd();
              } else {
                stream.eatWhile(/\#|}/);
                state.incomment = false;
              }
              return "comment";
            } else if (state.intag) {
              if (state.operator) {
                state.operator = false;
                if (stream.match(atom)) {
                  return "atom";
                }
                if (stream.match(number2)) {
                  return "number";
                }
              }
              if (state.sign) {
                state.sign = false;
                if (stream.match(atom)) {
                  return "atom";
                }
                if (stream.match(number2)) {
                  return "number";
                }
              }
              if (state.instring) {
                if (ch == state.instring) {
                  state.instring = false;
                }
                stream.next();
                return "string";
              } else if (ch == "'" || ch == '"') {
                state.instring = ch;
                stream.next();
                return "string";
              } else if (stream.match(state.intag + "}") || stream.eat("-") && stream.match(state.intag + "}")) {
                state.intag = false;
                return "tag";
              } else if (stream.match(operator)) {
                state.operator = true;
                return "operator";
              } else if (stream.match(sign3)) {
                state.sign = true;
              } else {
                if (stream.eat(" ") || stream.sol()) {
                  if (stream.match(keywords2)) {
                    return "keyword";
                  }
                  if (stream.match(atom)) {
                    return "atom";
                  }
                  if (stream.match(number2)) {
                    return "number";
                  }
                  if (stream.sol()) {
                    stream.next();
                  }
                } else {
                  stream.next();
                }
              }
              return "variable";
            } else if (stream.eat("{")) {
              if (stream.eat("#")) {
                state.incomment = true;
                if (!stream.skipTo("#}")) {
                  stream.skipToEnd();
                } else {
                  stream.eatWhile(/\#|}/);
                  state.incomment = false;
                }
                return "comment";
              } else if (ch = stream.eat(/\{|%/)) {
                state.intag = ch;
                if (ch == "{") {
                  state.intag = "}";
                }
                stream.eat("-");
                return "tag";
              }
            }
            stream.next();
          }
          ;
          return {
            startState: function() {
              return { tokenize: tokenBase };
            },
            token: function(stream, state) {
              return state.tokenize(stream, state);
            },
            blockCommentStart: "{#",
            blockCommentEnd: "#}"
          };
        });
        CodeMirror5.defineMIME("text/jinja2", "jinja2");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/jsx/jsx.js
  var require_jsx = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/jsx/jsx.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_xml(), require_javascript());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../xml/xml", "../javascript/javascript"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function Context(state, mode2, depth, prev) {
          this.state = state;
          this.mode = mode2;
          this.depth = depth;
          this.prev = prev;
        }
        function copyContext(context) {
          return new Context(CodeMirror5.copyState(context.mode, context.state), context.mode, context.depth, context.prev && copyContext(context.prev));
        }
        CodeMirror5.defineMode("jsx", function(config3, modeConfig) {
          var xmlMode = CodeMirror5.getMode(config3, { name: "xml", allowMissing: true, multilineTagIndentPastTag: false, allowMissingTagName: true });
          var jsMode = CodeMirror5.getMode(config3, modeConfig && modeConfig.base || "javascript");
          function flatXMLIndent(state) {
            var tagName = state.tagName;
            state.tagName = null;
            var result = xmlMode.indent(state, "", "");
            state.tagName = tagName;
            return result;
          }
          function token(stream, state) {
            if (state.context.mode == xmlMode)
              return xmlToken(stream, state, state.context);
            else
              return jsToken(stream, state, state.context);
          }
          function xmlToken(stream, state, cx) {
            if (cx.depth == 2) {
              if (stream.match(/^.*?\*\//))
                cx.depth = 1;
              else
                stream.skipToEnd();
              return "comment";
            }
            if (stream.peek() == "{") {
              xmlMode.skipAttribute(cx.state);
              var indent = flatXMLIndent(cx.state), xmlContext = cx.state.context;
              if (xmlContext && stream.match(/^[^>]*>\s*$/, false)) {
                while (xmlContext.prev && !xmlContext.startOfLine)
                  xmlContext = xmlContext.prev;
                if (xmlContext.startOfLine)
                  indent -= config3.indentUnit;
                else if (cx.prev.state.lexical)
                  indent = cx.prev.state.lexical.indented;
              } else if (cx.depth == 1) {
                indent += config3.indentUnit;
              }
              state.context = new Context(CodeMirror5.startState(jsMode, indent), jsMode, 0, state.context);
              return null;
            }
            if (cx.depth == 1) {
              if (stream.peek() == "<") {
                xmlMode.skipAttribute(cx.state);
                state.context = new Context(CodeMirror5.startState(xmlMode, flatXMLIndent(cx.state)), xmlMode, 0, state.context);
                return null;
              } else if (stream.match("//")) {
                stream.skipToEnd();
                return "comment";
              } else if (stream.match("/*")) {
                cx.depth = 2;
                return token(stream, state);
              }
            }
            var style = xmlMode.token(stream, cx.state), cur = stream.current(), stop2;
            if (/\btag\b/.test(style)) {
              if (/>$/.test(cur)) {
                if (cx.state.context)
                  cx.depth = 0;
                else
                  state.context = state.context.prev;
              } else if (/^</.test(cur)) {
                cx.depth = 1;
              }
            } else if (!style && (stop2 = cur.indexOf("{")) > -1) {
              stream.backUp(cur.length - stop2);
            }
            return style;
          }
          function jsToken(stream, state, cx) {
            if (stream.peek() == "<" && jsMode.expressionAllowed(stream, cx.state)) {
              jsMode.skipExpression(cx.state);
              state.context = new Context(CodeMirror5.startState(xmlMode, jsMode.indent(cx.state, "", "")), xmlMode, 0, state.context);
              return null;
            }
            var style = jsMode.token(stream, cx.state);
            if (!style && cx.depth != null) {
              var cur = stream.current();
              if (cur == "{") {
                cx.depth++;
              } else if (cur == "}") {
                if (--cx.depth == 0)
                  state.context = state.context.prev;
              }
            }
            return style;
          }
          return {
            startState: function() {
              return { context: new Context(CodeMirror5.startState(jsMode), jsMode) };
            },
            copyState: function(state) {
              return { context: copyContext(state.context) };
            },
            token,
            indent: function(state, textAfter, fullLine) {
              return state.context.mode.indent(state.context.state, textAfter, fullLine);
            },
            innerMode: function(state) {
              return state.context;
            }
          };
        }, "xml", "javascript");
        CodeMirror5.defineMIME("text/jsx", "jsx");
        CodeMirror5.defineMIME("text/typescript-jsx", { name: "jsx", base: { name: "javascript", typescript: true } });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/julia/julia.js
  var require_julia = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/julia/julia.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("julia", function(config3, parserConf) {
          function wordRegexp(words, end) {
            if (typeof end === "undefined") {
              end = "\\b";
            }
            return new RegExp("^((" + words.join(")|(") + "))" + end);
          }
          var octChar = "\\\\[0-7]{1,3}";
          var hexChar = "\\\\x[A-Fa-f0-9]{1,2}";
          var sChar = `\\\\[abefnrtv0%?'"\\\\]`;
          var uChar = "([^\\u0027\\u005C\\uD800-\\uDFFF]|[\\uD800-\\uDFFF][\\uDC00-\\uDFFF])";
          var operators = parserConf.operators || wordRegexp([
            "[<>]:",
            "[<>=]=",
            "<<=?",
            ">>>?=?",
            "=>",
            "->",
            "\\/\\/",
            "[\\\\%*+\\-<>!=\\/^|&\\u00F7\\u22BB]=?",
            "\\?",
            "\\$",
            "~",
            ":",
            "\\u00D7",
            "\\u2208",
            "\\u2209",
            "\\u220B",
            "\\u220C",
            "\\u2218",
            "\\u221A",
            "\\u221B",
            "\\u2229",
            "\\u222A",
            "\\u2260",
            "\\u2264",
            "\\u2265",
            "\\u2286",
            "\\u2288",
            "\\u228A",
            "\\u22C5",
            "\\b(in|isa)\\b(?!.?\\()"
          ], "");
          var delimiters = parserConf.delimiters || /^[;,()[\]{}]/;
          var identifiers = parserConf.identifiers || /^[_A-Za-z\u00A1-\u2217\u2219-\uFFFF][\w\u00A1-\u2217\u2219-\uFFFF]*!*/;
          var chars = wordRegexp([octChar, hexChar, sChar, uChar], "'");
          var openersList = [
            "begin",
            "function",
            "type",
            "struct",
            "immutable",
            "let",
            "macro",
            "for",
            "while",
            "quote",
            "if",
            "else",
            "elseif",
            "try",
            "finally",
            "catch",
            "do"
          ];
          var closersList = ["end", "else", "elseif", "catch", "finally"];
          var keywordsList = [
            "if",
            "else",
            "elseif",
            "while",
            "for",
            "begin",
            "let",
            "end",
            "do",
            "try",
            "catch",
            "finally",
            "return",
            "break",
            "continue",
            "global",
            "local",
            "const",
            "export",
            "import",
            "importall",
            "using",
            "function",
            "where",
            "macro",
            "module",
            "baremodule",
            "struct",
            "type",
            "mutable",
            "immutable",
            "quote",
            "typealias",
            "abstract",
            "primitive",
            "bitstype"
          ];
          var builtinsList = ["true", "false", "nothing", "NaN", "Inf"];
          CodeMirror5.registerHelper("hintWords", "julia", keywordsList.concat(builtinsList));
          var openers = wordRegexp(openersList);
          var closers = wordRegexp(closersList);
          var keywords2 = wordRegexp(keywordsList);
          var builtins = wordRegexp(builtinsList);
          var macro = /^@[_A-Za-z][\w]*/;
          var symbol = /^:[_A-Za-z\u00A1-\uFFFF][\w\u00A1-\uFFFF]*!*/;
          var stringPrefixes = /^(`|([_A-Za-z\u00A1-\uFFFF]*"("")?))/;
          function inArray(state) {
            return state.nestedArrays > 0;
          }
          function inGenerator(state) {
            return state.nestedGenerators > 0;
          }
          function currentScope(state, n3) {
            if (typeof n3 === "undefined") {
              n3 = 0;
            }
            if (state.scopes.length <= n3) {
              return null;
            }
            return state.scopes[state.scopes.length - (n3 + 1)];
          }
          function tokenBase(stream, state) {
            if (stream.match(/^#=/, false)) {
              state.tokenize = tokenComment;
              return state.tokenize(stream, state);
            }
            var leavingExpr = state.leavingExpr;
            if (stream.sol()) {
              leavingExpr = false;
            }
            state.leavingExpr = false;
            if (leavingExpr) {
              if (stream.match(/^'+/)) {
                return "operator";
              }
            }
            if (stream.match(/\.{4,}/)) {
              return "error";
            } else if (stream.match(/\.{1,3}/)) {
              return "operator";
            }
            if (stream.eatSpace()) {
              return null;
            }
            var ch = stream.peek();
            if (ch === "#") {
              stream.skipToEnd();
              return "comment";
            }
            if (ch === "[") {
              state.scopes.push("[");
              state.nestedArrays++;
            }
            if (ch === "(") {
              state.scopes.push("(");
              state.nestedGenerators++;
            }
            if (inArray(state) && ch === "]") {
              while (state.scopes.length && currentScope(state) !== "[") {
                state.scopes.pop();
              }
              state.scopes.pop();
              state.nestedArrays--;
              state.leavingExpr = true;
            }
            if (inGenerator(state) && ch === ")") {
              while (state.scopes.length && currentScope(state) !== "(") {
                state.scopes.pop();
              }
              state.scopes.pop();
              state.nestedGenerators--;
              state.leavingExpr = true;
            }
            if (inArray(state)) {
              if (state.lastToken == "end" && stream.match(/^:/)) {
                return "operator";
              }
              if (stream.match(/^end/)) {
                return "number";
              }
            }
            var match;
            if (match = stream.match(openers, false)) {
              state.scopes.push(match[0]);
            }
            if (stream.match(closers, false)) {
              state.scopes.pop();
            }
            if (stream.match(/^::(?![:\$])/)) {
              state.tokenize = tokenAnnotation;
              return state.tokenize(stream, state);
            }
            if (!leavingExpr && stream.match(symbol) || stream.match(/:([<>]:|<<=?|>>>?=?|->|\/\/|\.{2,3}|[\.\\%*+\-<>!\/^|&]=?|[~\?\$])/)) {
              return "builtin";
            }
            if (stream.match(operators)) {
              return "operator";
            }
            if (stream.match(/^\.?\d/, false)) {
              var imMatcher = RegExp(/^im\b/);
              var numberLiteral = false;
              if (stream.match(/^0x\.[0-9a-f_]+p[\+\-]?[_\d]+/i)) {
                numberLiteral = true;
              }
              if (stream.match(/^0x[0-9a-f_]+/i)) {
                numberLiteral = true;
              }
              if (stream.match(/^0b[01_]+/i)) {
                numberLiteral = true;
              }
              if (stream.match(/^0o[0-7_]+/i)) {
                numberLiteral = true;
              }
              if (stream.match(/^(?:(?:\d[_\d]*)?\.(?!\.)(?:\d[_\d]*)?|\d[_\d]*\.(?!\.)(?:\d[_\d]*))?([Eef][\+\-]?[_\d]+)?/i)) {
                numberLiteral = true;
              }
              if (stream.match(/^\d[_\d]*(e[\+\-]?\d+)?/i)) {
                numberLiteral = true;
              }
              if (numberLiteral) {
                stream.match(imMatcher);
                state.leavingExpr = true;
                return "number";
              }
            }
            if (stream.match(/^'/)) {
              state.tokenize = tokenChar;
              return state.tokenize(stream, state);
            }
            if (stream.match(stringPrefixes)) {
              state.tokenize = tokenStringFactory(stream.current());
              return state.tokenize(stream, state);
            }
            if (stream.match(macro)) {
              return "meta";
            }
            if (stream.match(delimiters)) {
              return null;
            }
            if (stream.match(keywords2)) {
              return "keyword";
            }
            if (stream.match(builtins)) {
              return "builtin";
            }
            var isDefinition = state.isDefinition || state.lastToken == "function" || state.lastToken == "macro" || state.lastToken == "type" || state.lastToken == "struct" || state.lastToken == "immutable";
            if (stream.match(identifiers)) {
              if (isDefinition) {
                if (stream.peek() === ".") {
                  state.isDefinition = true;
                  return "variable";
                }
                state.isDefinition = false;
                return "def";
              }
              if (stream.match(/^({[^}]*})*\(/, false)) {
                state.tokenize = tokenCallOrDef;
                return state.tokenize(stream, state);
              }
              state.leavingExpr = true;
              return "variable";
            }
            stream.next();
            return "error";
          }
          function tokenCallOrDef(stream, state) {
            var match = stream.match(/^(\(\s*)/);
            if (match) {
              if (state.firstParenPos < 0)
                state.firstParenPos = state.scopes.length;
              state.scopes.push("(");
              state.charsAdvanced += match[1].length;
            }
            if (currentScope(state) == "(" && stream.match(/^\)/)) {
              state.scopes.pop();
              state.charsAdvanced += 1;
              if (state.scopes.length <= state.firstParenPos) {
                var isDefinition = stream.match(/^(\s*where\s+[^\s=]+)*\s*?=(?!=)/, false);
                stream.backUp(state.charsAdvanced);
                state.firstParenPos = -1;
                state.charsAdvanced = 0;
                state.tokenize = tokenBase;
                if (isDefinition)
                  return "def";
                return "builtin";
              }
            }
            if (stream.match(/^$/g, false)) {
              stream.backUp(state.charsAdvanced);
              while (state.scopes.length > state.firstParenPos)
                state.scopes.pop();
              state.firstParenPos = -1;
              state.charsAdvanced = 0;
              state.tokenize = tokenBase;
              return "builtin";
            }
            state.charsAdvanced += stream.match(/^([^()]*)/)[1].length;
            return state.tokenize(stream, state);
          }
          function tokenAnnotation(stream, state) {
            stream.match(/.*?(?=,|;|{|}|\(|\)|=|$|\s)/);
            if (stream.match(/^{/)) {
              state.nestedParameters++;
            } else if (stream.match(/^}/) && state.nestedParameters > 0) {
              state.nestedParameters--;
            }
            if (state.nestedParameters > 0) {
              stream.match(/.*?(?={|})/) || stream.next();
            } else if (state.nestedParameters == 0) {
              state.tokenize = tokenBase;
            }
            return "builtin";
          }
          function tokenComment(stream, state) {
            if (stream.match(/^#=/)) {
              state.nestedComments++;
            }
            if (!stream.match(/.*?(?=(#=|=#))/)) {
              stream.skipToEnd();
            }
            if (stream.match(/^=#/)) {
              state.nestedComments--;
              if (state.nestedComments == 0)
                state.tokenize = tokenBase;
            }
            return "comment";
          }
          function tokenChar(stream, state) {
            var isChar = false, match;
            if (stream.match(chars)) {
              isChar = true;
            } else if (match = stream.match(/\\u([a-f0-9]{1,4})(?=')/i)) {
              var value = parseInt(match[1], 16);
              if (value <= 55295 || value >= 57344) {
                isChar = true;
                stream.next();
              }
            } else if (match = stream.match(/\\U([A-Fa-f0-9]{5,8})(?=')/)) {
              var value = parseInt(match[1], 16);
              if (value <= 1114111) {
                isChar = true;
                stream.next();
              }
            }
            if (isChar) {
              state.leavingExpr = true;
              state.tokenize = tokenBase;
              return "string";
            }
            if (!stream.match(/^[^']+(?=')/)) {
              stream.skipToEnd();
            }
            if (stream.match(/^'/)) {
              state.tokenize = tokenBase;
            }
            return "error";
          }
          function tokenStringFactory(delimiter) {
            if (delimiter.substr(-3) === '"""') {
              delimiter = '"""';
            } else if (delimiter.substr(-1) === '"') {
              delimiter = '"';
            }
            function tokenString(stream, state) {
              if (stream.eat("\\")) {
                stream.next();
              } else if (stream.match(delimiter)) {
                state.tokenize = tokenBase;
                state.leavingExpr = true;
                return "string";
              } else {
                stream.eat(/[`"]/);
              }
              stream.eatWhile(/[^\\`"]/);
              return "string";
            }
            return tokenString;
          }
          var external = {
            startState: function() {
              return {
                tokenize: tokenBase,
                scopes: [],
                lastToken: null,
                leavingExpr: false,
                isDefinition: false,
                nestedArrays: 0,
                nestedComments: 0,
                nestedGenerators: 0,
                nestedParameters: 0,
                charsAdvanced: 0,
                firstParenPos: -1
              };
            },
            token: function(stream, state) {
              var style = state.tokenize(stream, state);
              var current = stream.current();
              if (current && style) {
                state.lastToken = current;
              }
              return style;
            },
            indent: function(state, textAfter) {
              var delta = 0;
              if (textAfter === "]" || textAfter === ")" || textAfter === "end" || textAfter === "else" || textAfter === "catch" || textAfter === "elseif" || textAfter === "finally") {
                delta = -1;
              }
              return (state.scopes.length + delta) * config3.indentUnit;
            },
            electricInput: /\b(end|else|catch|finally)\b/,
            blockCommentStart: "#=",
            blockCommentEnd: "=#",
            lineComment: "#",
            closeBrackets: '()[]{}""',
            fold: "indent"
          };
          return external;
        });
        CodeMirror5.defineMIME("text/x-julia", "julia");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/livescript/livescript.js
  var require_livescript = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/livescript/livescript.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("livescript", function() {
          var tokenBase = function(stream, state) {
            var next_rule = state.next || "start";
            if (next_rule) {
              state.next = state.next;
              var nr = Rules[next_rule];
              if (nr.splice) {
                for (var i$ = 0; i$ < nr.length; ++i$) {
                  var r4 = nr[i$];
                  if (r4.regex && stream.match(r4.regex)) {
                    state.next = r4.next || state.next;
                    return r4.token;
                  }
                }
                stream.next();
                return "error";
              }
              if (stream.match(r4 = Rules[next_rule])) {
                if (r4.regex && stream.match(r4.regex)) {
                  state.next = r4.next;
                  return r4.token;
                } else {
                  stream.next();
                  return "error";
                }
              }
            }
            stream.next();
            return "error";
          };
          var external = {
            startState: function() {
              return {
                next: "start",
                lastToken: { style: null, indent: 0, content: "" }
              };
            },
            token: function(stream, state) {
              while (stream.pos == stream.start)
                var style = tokenBase(stream, state);
              state.lastToken = {
                style,
                indent: stream.indentation(),
                content: stream.current()
              };
              return style.replace(/\./g, " ");
            },
            indent: function(state) {
              var indentation = state.lastToken.indent;
              if (state.lastToken.content.match(indenter)) {
                indentation += 2;
              }
              return indentation;
            }
          };
          return external;
        });
        var identifier = "(?![\\d\\s])[$\\w\\xAA-\\uFFDC](?:(?!\\s)[$\\w\\xAA-\\uFFDC]|-[A-Za-z])*";
        var indenter = RegExp("(?:[({[=:]|[-~]>|\\b(?:e(?:lse|xport)|d(?:o|efault)|t(?:ry|hen)|finally|import(?:\\s*all)?|const|var|let|new|catch(?:\\s*" + identifier + ")?))\\s*$");
        var keywordend = "(?![$\\w]|-[A-Za-z]|\\s*:(?![:=]))";
        var stringfill = {
          token: "string",
          regex: ".+"
        };
        var Rules = {
          start: [
            {
              token: "comment.doc",
              regex: "/\\*",
              next: "comment"
            },
            {
              token: "comment",
              regex: "#.*"
            },
            {
              token: "keyword",
              regex: "(?:t(?:h(?:is|row|en)|ry|ypeof!?)|c(?:on(?:tinue|st)|a(?:se|tch)|lass)|i(?:n(?:stanceof)?|mp(?:ort(?:\\s+all)?|lements)|[fs])|d(?:e(?:fault|lete|bugger)|o)|f(?:or(?:\\s+own)?|inally|unction)|s(?:uper|witch)|e(?:lse|x(?:tends|port)|val)|a(?:nd|rguments)|n(?:ew|ot)|un(?:less|til)|w(?:hile|ith)|o[fr]|return|break|let|var|loop)" + keywordend
            },
            {
              token: "constant.language",
              regex: "(?:true|false|yes|no|on|off|null|void|undefined)" + keywordend
            },
            {
              token: "invalid.illegal",
              regex: "(?:p(?:ackage|r(?:ivate|otected)|ublic)|i(?:mplements|nterface)|enum|static|yield)" + keywordend
            },
            {
              token: "language.support.class",
              regex: "(?:R(?:e(?:gExp|ferenceError)|angeError)|S(?:tring|yntaxError)|E(?:rror|valError)|Array|Boolean|Date|Function|Number|Object|TypeError|URIError)" + keywordend
            },
            {
              token: "language.support.function",
              regex: "(?:is(?:NaN|Finite)|parse(?:Int|Float)|Math|JSON|(?:en|de)codeURI(?:Component)?)" + keywordend
            },
            {
              token: "variable.language",
              regex: "(?:t(?:hat|il|o)|f(?:rom|allthrough)|it|by|e)" + keywordend
            },
            {
              token: "identifier",
              regex: identifier + "\\s*:(?![:=])"
            },
            {
              token: "variable",
              regex: identifier
            },
            {
              token: "keyword.operator",
              regex: "(?:\\.{3}|\\s+\\?)"
            },
            {
              token: "keyword.variable",
              regex: "(?:@+|::|\\.\\.)",
              next: "key"
            },
            {
              token: "keyword.operator",
              regex: "\\.\\s*",
              next: "key"
            },
            {
              token: "string",
              regex: "\\\\\\S[^\\s,;)}\\]]*"
            },
            {
              token: "string.doc",
              regex: "'''",
              next: "qdoc"
            },
            {
              token: "string.doc",
              regex: '"""',
              next: "qqdoc"
            },
            {
              token: "string",
              regex: "'",
              next: "qstring"
            },
            {
              token: "string",
              regex: '"',
              next: "qqstring"
            },
            {
              token: "string",
              regex: "`",
              next: "js"
            },
            {
              token: "string",
              regex: "<\\[",
              next: "words"
            },
            {
              token: "string.regex",
              regex: "//",
              next: "heregex"
            },
            {
              token: "string.regex",
              regex: "\\/(?:[^[\\/\\n\\\\]*(?:(?:\\\\.|\\[[^\\]\\n\\\\]*(?:\\\\.[^\\]\\n\\\\]*)*\\])[^[\\/\\n\\\\]*)*)\\/[gimy$]{0,4}",
              next: "key"
            },
            {
              token: "constant.numeric",
              regex: "(?:0x[\\da-fA-F][\\da-fA-F_]*|(?:[2-9]|[12]\\d|3[0-6])r[\\da-zA-Z][\\da-zA-Z_]*|(?:\\d[\\d_]*(?:\\.\\d[\\d_]*)?|\\.\\d[\\d_]*)(?:e[+-]?\\d[\\d_]*)?[\\w$]*)"
            },
            {
              token: "lparen",
              regex: "[({[]"
            },
            {
              token: "rparen",
              regex: "[)}\\]]",
              next: "key"
            },
            {
              token: "keyword.operator",
              regex: "\\S+"
            },
            {
              token: "text",
              regex: "\\s+"
            }
          ],
          heregex: [
            {
              token: "string.regex",
              regex: ".*?//[gimy$?]{0,4}",
              next: "start"
            },
            {
              token: "string.regex",
              regex: "\\s*#{"
            },
            {
              token: "comment.regex",
              regex: "\\s+(?:#.*)?"
            },
            {
              token: "string.regex",
              regex: "\\S+"
            }
          ],
          key: [
            {
              token: "keyword.operator",
              regex: "[.?@!]+"
            },
            {
              token: "identifier",
              regex: identifier,
              next: "start"
            },
            {
              token: "text",
              regex: "",
              next: "start"
            }
          ],
          comment: [
            {
              token: "comment.doc",
              regex: ".*?\\*/",
              next: "start"
            },
            {
              token: "comment.doc",
              regex: ".+"
            }
          ],
          qdoc: [
            {
              token: "string",
              regex: ".*?'''",
              next: "key"
            },
            stringfill
          ],
          qqdoc: [
            {
              token: "string",
              regex: '.*?"""',
              next: "key"
            },
            stringfill
          ],
          qstring: [
            {
              token: "string",
              regex: "[^\\\\']*(?:\\\\.[^\\\\']*)*'",
              next: "key"
            },
            stringfill
          ],
          qqstring: [
            {
              token: "string",
              regex: '[^\\\\"]*(?:\\\\.[^\\\\"]*)*"',
              next: "key"
            },
            stringfill
          ],
          js: [
            {
              token: "string",
              regex: "[^\\\\`]*(?:\\\\.[^\\\\`]*)*`",
              next: "key"
            },
            stringfill
          ],
          words: [
            {
              token: "string",
              regex: ".*?\\]>",
              next: "key"
            },
            stringfill
          ]
        };
        for (var idx in Rules) {
          var r3 = Rules[idx];
          if (r3.splice) {
            for (var i3 = 0, len = r3.length; i3 < len; ++i3) {
              var rr = r3[i3];
              if (typeof rr.regex === "string") {
                Rules[idx][i3].regex = new RegExp("^" + rr.regex);
              }
            }
          } else if (typeof rr.regex === "string") {
            Rules[idx].regex = new RegExp("^" + r3.regex);
          }
        }
        CodeMirror5.defineMIME("text/x-livescript", "livescript");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/lua/lua.js
  var require_lua = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/lua/lua.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("lua", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit;
          function prefixRE(words) {
            return new RegExp("^(?:" + words.join("|") + ")", "i");
          }
          function wordRE(words) {
            return new RegExp("^(?:" + words.join("|") + ")$", "i");
          }
          var specials = wordRE(parserConfig.specials || []);
          var builtins = wordRE([
            "_G",
            "_VERSION",
            "assert",
            "collectgarbage",
            "dofile",
            "error",
            "getfenv",
            "getmetatable",
            "ipairs",
            "load",
            "loadfile",
            "loadstring",
            "module",
            "next",
            "pairs",
            "pcall",
            "print",
            "rawequal",
            "rawget",
            "rawset",
            "require",
            "select",
            "setfenv",
            "setmetatable",
            "tonumber",
            "tostring",
            "type",
            "unpack",
            "xpcall",
            "coroutine.create",
            "coroutine.resume",
            "coroutine.running",
            "coroutine.status",
            "coroutine.wrap",
            "coroutine.yield",
            "debug.debug",
            "debug.getfenv",
            "debug.gethook",
            "debug.getinfo",
            "debug.getlocal",
            "debug.getmetatable",
            "debug.getregistry",
            "debug.getupvalue",
            "debug.setfenv",
            "debug.sethook",
            "debug.setlocal",
            "debug.setmetatable",
            "debug.setupvalue",
            "debug.traceback",
            "close",
            "flush",
            "lines",
            "read",
            "seek",
            "setvbuf",
            "write",
            "io.close",
            "io.flush",
            "io.input",
            "io.lines",
            "io.open",
            "io.output",
            "io.popen",
            "io.read",
            "io.stderr",
            "io.stdin",
            "io.stdout",
            "io.tmpfile",
            "io.type",
            "io.write",
            "math.abs",
            "math.acos",
            "math.asin",
            "math.atan",
            "math.atan2",
            "math.ceil",
            "math.cos",
            "math.cosh",
            "math.deg",
            "math.exp",
            "math.floor",
            "math.fmod",
            "math.frexp",
            "math.huge",
            "math.ldexp",
            "math.log",
            "math.log10",
            "math.max",
            "math.min",
            "math.modf",
            "math.pi",
            "math.pow",
            "math.rad",
            "math.random",
            "math.randomseed",
            "math.sin",
            "math.sinh",
            "math.sqrt",
            "math.tan",
            "math.tanh",
            "os.clock",
            "os.date",
            "os.difftime",
            "os.execute",
            "os.exit",
            "os.getenv",
            "os.remove",
            "os.rename",
            "os.setlocale",
            "os.time",
            "os.tmpname",
            "package.cpath",
            "package.loaded",
            "package.loaders",
            "package.loadlib",
            "package.path",
            "package.preload",
            "package.seeall",
            "string.byte",
            "string.char",
            "string.dump",
            "string.find",
            "string.format",
            "string.gmatch",
            "string.gsub",
            "string.len",
            "string.lower",
            "string.match",
            "string.rep",
            "string.reverse",
            "string.sub",
            "string.upper",
            "table.concat",
            "table.insert",
            "table.maxn",
            "table.remove",
            "table.sort"
          ]);
          var keywords2 = wordRE([
            "and",
            "break",
            "elseif",
            "false",
            "nil",
            "not",
            "or",
            "return",
            "true",
            "function",
            "end",
            "if",
            "then",
            "else",
            "do",
            "while",
            "repeat",
            "until",
            "for",
            "in",
            "local"
          ]);
          var indentTokens = wordRE(["function", "if", "repeat", "do", "\\(", "{"]);
          var dedentTokens = wordRE(["end", "until", "\\)", "}"]);
          var dedentPartial = prefixRE(["end", "until", "\\)", "}", "else", "elseif"]);
          function readBracket(stream) {
            var level = 0;
            while (stream.eat("="))
              ++level;
            stream.eat("[");
            return level;
          }
          function normal(stream, state) {
            var ch = stream.next();
            if (ch == "-" && stream.eat("-")) {
              if (stream.eat("[") && stream.eat("["))
                return (state.cur = bracketed(readBracket(stream), "comment"))(stream, state);
              stream.skipToEnd();
              return "comment";
            }
            if (ch == '"' || ch == "'")
              return (state.cur = string2(ch))(stream, state);
            if (ch == "[" && /[\[=]/.test(stream.peek()))
              return (state.cur = bracketed(readBracket(stream), "string"))(stream, state);
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w.%]/);
              return "number";
            }
            if (/[\w_]/.test(ch)) {
              stream.eatWhile(/[\w\\\-_.]/);
              return "variable";
            }
            return null;
          }
          function bracketed(level, style) {
            return function(stream, state) {
              var curlev = null, ch;
              while ((ch = stream.next()) != null) {
                if (curlev == null) {
                  if (ch == "]")
                    curlev = 0;
                } else if (ch == "=")
                  ++curlev;
                else if (ch == "]" && curlev == level) {
                  state.cur = normal;
                  break;
                } else
                  curlev = null;
              }
              return style;
            };
          }
          function string2(quote) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped)
                  break;
                escaped = !escaped && ch == "\\";
              }
              if (!escaped)
                state.cur = normal;
              return "string";
            };
          }
          return {
            startState: function(basecol) {
              return { basecol: basecol || 0, indentDepth: 0, cur: normal };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = state.cur(stream, state);
              var word = stream.current();
              if (style == "variable") {
                if (keywords2.test(word))
                  style = "keyword";
                else if (builtins.test(word))
                  style = "builtin";
                else if (specials.test(word))
                  style = "variable-2";
              }
              if (style != "comment" && style != "string") {
                if (indentTokens.test(word))
                  ++state.indentDepth;
                else if (dedentTokens.test(word))
                  --state.indentDepth;
              }
              return style;
            },
            indent: function(state, textAfter) {
              var closing = dedentPartial.test(textAfter);
              return state.basecol + indentUnit * (state.indentDepth - (closing ? 1 : 0));
            },
            lineComment: "--",
            blockCommentStart: "--[[",
            blockCommentEnd: "]]"
          };
        });
        CodeMirror5.defineMIME("text/x-lua", "lua");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/mathematica/mathematica.js
  var require_mathematica = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/mathematica/mathematica.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("mathematica", function(_config, _parserConfig) {
          var Identifier = "[a-zA-Z\\$][a-zA-Z0-9\\$]*";
          var pBase = "(?:\\d+)";
          var pFloat = "(?:\\.\\d+|\\d+\\.\\d*|\\d+)";
          var pFloatBase = "(?:\\.\\w+|\\w+\\.\\w*|\\w+)";
          var pPrecision = "(?:`(?:`?" + pFloat + ")?)";
          var reBaseForm = new RegExp("(?:" + pBase + "(?:\\^\\^" + pFloatBase + pPrecision + "?(?:\\*\\^[+-]?\\d+)?))");
          var reFloatForm = new RegExp("(?:" + pFloat + pPrecision + "?(?:\\*\\^[+-]?\\d+)?)");
          var reIdInContext = new RegExp("(?:`?)(?:" + Identifier + ")(?:`(?:" + Identifier + "))*(?:`?)");
          function tokenBase(stream, state) {
            var ch;
            ch = stream.next();
            if (ch === '"') {
              state.tokenize = tokenString;
              return state.tokenize(stream, state);
            }
            if (ch === "(") {
              if (stream.eat("*")) {
                state.commentLevel++;
                state.tokenize = tokenComment;
                return state.tokenize(stream, state);
              }
            }
            stream.backUp(1);
            if (stream.match(reBaseForm, true, false)) {
              return "number";
            }
            if (stream.match(reFloatForm, true, false)) {
              return "number";
            }
            if (stream.match(/(?:In|Out)\[[0-9]*\]/, true, false)) {
              return "atom";
            }
            if (stream.match(/([a-zA-Z\$][a-zA-Z0-9\$]*(?:`[a-zA-Z0-9\$]+)*::usage)/, true, false)) {
              return "meta";
            }
            if (stream.match(/([a-zA-Z\$][a-zA-Z0-9\$]*(?:`[a-zA-Z0-9\$]+)*::[a-zA-Z\$][a-zA-Z0-9\$]*):?/, true, false)) {
              return "string-2";
            }
            if (stream.match(/([a-zA-Z\$][a-zA-Z0-9\$]*\s*:)(?:(?:[a-zA-Z\$][a-zA-Z0-9\$]*)|(?:[^:=>~@\^\&\*\)\[\]'\?,\|])).*/, true, false)) {
              return "variable-2";
            }
            if (stream.match(/[a-zA-Z\$][a-zA-Z0-9\$]*_+[a-zA-Z\$][a-zA-Z0-9\$]*/, true, false)) {
              return "variable-2";
            }
            if (stream.match(/[a-zA-Z\$][a-zA-Z0-9\$]*_+/, true, false)) {
              return "variable-2";
            }
            if (stream.match(/_+[a-zA-Z\$][a-zA-Z0-9\$]*/, true, false)) {
              return "variable-2";
            }
            if (stream.match(/\\\[[a-zA-Z\$][a-zA-Z0-9\$]*\]/, true, false)) {
              return "variable-3";
            }
            if (stream.match(/(?:\[|\]|{|}|\(|\))/, true, false)) {
              return "bracket";
            }
            if (stream.match(/(?:#[a-zA-Z\$][a-zA-Z0-9\$]*|#+[0-9]?)/, true, false)) {
              return "variable-2";
            }
            if (stream.match(reIdInContext, true, false)) {
              return "keyword";
            }
            if (stream.match(/(?:\\|\+|\-|\*|\/|,|;|\.|:|@|~|=|>|<|&|\||_|`|'|\^|\?|!|%)/, true, false)) {
              return "operator";
            }
            stream.next();
            return "error";
          }
          function tokenString(stream, state) {
            var next, end = false, escaped = false;
            while ((next = stream.next()) != null) {
              if (next === '"' && !escaped) {
                end = true;
                break;
              }
              escaped = !escaped && next === "\\";
            }
            if (end && !escaped) {
              state.tokenize = tokenBase;
            }
            return "string";
          }
          ;
          function tokenComment(stream, state) {
            var prev, next;
            while (state.commentLevel > 0 && (next = stream.next()) != null) {
              if (prev === "(" && next === "*")
                state.commentLevel++;
              if (prev === "*" && next === ")")
                state.commentLevel--;
              prev = next;
            }
            if (state.commentLevel <= 0) {
              state.tokenize = tokenBase;
            }
            return "comment";
          }
          return {
            startState: function() {
              return { tokenize: tokenBase, commentLevel: 0 };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return state.tokenize(stream, state);
            },
            blockCommentStart: "(*",
            blockCommentEnd: "*)"
          };
        });
        CodeMirror5.defineMIME("text/x-mathematica", {
          name: "mathematica"
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/mbox/mbox.js
  var require_mbox = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/mbox/mbox.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var rfc2822 = [
          "From",
          "Sender",
          "Reply-To",
          "To",
          "Cc",
          "Bcc",
          "Message-ID",
          "In-Reply-To",
          "References",
          "Resent-From",
          "Resent-Sender",
          "Resent-To",
          "Resent-Cc",
          "Resent-Bcc",
          "Resent-Message-ID",
          "Return-Path",
          "Received"
        ];
        var rfc2822NoEmail = [
          "Date",
          "Subject",
          "Comments",
          "Keywords",
          "Resent-Date"
        ];
        CodeMirror5.registerHelper("hintWords", "mbox", rfc2822.concat(rfc2822NoEmail));
        var whitespace = /^[ \t]/;
        var separator = /^From /;
        var rfc2822Header = new RegExp("^(" + rfc2822.join("|") + "): ");
        var rfc2822HeaderNoEmail = new RegExp("^(" + rfc2822NoEmail.join("|") + "): ");
        var header = /^[^:]+:/;
        var email = /^[^ ]+@[^ ]+/;
        var untilEmail = /^.*?(?=[^ ]+?@[^ ]+)/;
        var bracketedEmail = /^<.*?>/;
        var untilBracketedEmail = /^.*?(?=<.*>)/;
        function styleForHeader(header2) {
          if (header2 === "Subject")
            return "header";
          return "string";
        }
        function readToken(stream, state) {
          if (stream.sol()) {
            state.inSeparator = false;
            if (state.inHeader && stream.match(whitespace)) {
              return null;
            } else {
              state.inHeader = false;
              state.header = null;
            }
            if (stream.match(separator)) {
              state.inHeaders = true;
              state.inSeparator = true;
              return "atom";
            }
            var match;
            var emailPermitted = false;
            if ((match = stream.match(rfc2822HeaderNoEmail)) || (emailPermitted = true) && (match = stream.match(rfc2822Header))) {
              state.inHeaders = true;
              state.inHeader = true;
              state.emailPermitted = emailPermitted;
              state.header = match[1];
              return "atom";
            }
            if (state.inHeaders && (match = stream.match(header))) {
              state.inHeader = true;
              state.emailPermitted = true;
              state.header = match[1];
              return "atom";
            }
            state.inHeaders = false;
            stream.skipToEnd();
            return null;
          }
          if (state.inSeparator) {
            if (stream.match(email))
              return "link";
            if (stream.match(untilEmail))
              return "atom";
            stream.skipToEnd();
            return "atom";
          }
          if (state.inHeader) {
            var style = styleForHeader(state.header);
            if (state.emailPermitted) {
              if (stream.match(bracketedEmail))
                return style + " link";
              if (stream.match(untilBracketedEmail))
                return style;
            }
            stream.skipToEnd();
            return style;
          }
          stream.skipToEnd();
          return null;
        }
        ;
        CodeMirror5.defineMode("mbox", function() {
          return {
            startState: function() {
              return {
                inSeparator: false,
                inHeader: false,
                emailPermitted: false,
                header: null,
                inHeaders: false
              };
            },
            token: readToken,
            blankLine: function(state) {
              state.inHeaders = state.inSeparator = state.inHeader = false;
            }
          };
        });
        CodeMirror5.defineMIME("application/mbox", "mbox");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/mirc/mirc.js
  var require_mirc = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/mirc/mirc.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMIME("text/mirc", "mirc");
        CodeMirror5.defineMode("mirc", function() {
          function parseWords(str) {
            var obj = {}, words = str.split(" ");
            for (var i3 = 0; i3 < words.length; ++i3)
              obj[words[i3]] = true;
            return obj;
          }
          var specials = parseWords("$! $$ $& $? $+ $abook $abs $active $activecid $activewid $address $addtok $agent $agentname $agentstat $agentver $alias $and $anick $ansi2mirc $aop $appactive $appstate $asc $asctime $asin $atan $avoice $away $awaymsg $awaytime $banmask $base $bfind $binoff $biton $bnick $bvar $bytes $calc $cb $cd $ceil $chan $chanmodes $chantypes $chat $chr $cid $clevel $click $cmdbox $cmdline $cnick $color $com $comcall $comchan $comerr $compact $compress $comval $cos $count $cr $crc $creq $crlf $ctime $ctimer $ctrlenter $date $day $daylight $dbuh $dbuw $dccignore $dccport $dde $ddename $debug $decode $decompress $deltok $devent $dialog $did $didreg $didtok $didwm $disk $dlevel $dll $dllcall $dname $dns $duration $ebeeps $editbox $emailaddr $encode $error $eval $event $exist $feof $ferr $fgetc $file $filename $filtered $finddir $finddirn $findfile $findfilen $findtok $fline $floor $fopen $fread $fserve $fulladdress $fulldate $fullname $fullscreen $get $getdir $getdot $gettok $gmt $group $halted $hash $height $hfind $hget $highlight $hnick $hotline $hotlinepos $ial $ialchan $ibl $idle $iel $ifmatch $ignore $iif $iil $inelipse $ini $inmidi $inpaste $inpoly $input $inrect $inroundrect $insong $instok $int $inwave $ip $isalias $isbit $isdde $isdir $isfile $isid $islower $istok $isupper $keychar $keyrpt $keyval $knick $lactive $lactivecid $lactivewid $left $len $level $lf $line $lines $link $lock $lock $locked $log $logstamp $logstampfmt $longfn $longip $lower $ltimer $maddress $mask $matchkey $matchtok $md5 $me $menu $menubar $menucontext $menutype $mid $middir $mircdir $mircexe $mircini $mklogfn $mnick $mode $modefirst $modelast $modespl $mouse $msfile $network $newnick $nick $nofile $nopath $noqt $not $notags $notify $null $numeric $numok $oline $onpoly $opnick $or $ord $os $passivedcc $pic $play $pnick $port $portable $portfree $pos $prefix $prop $protect $puttok $qt $query $rand $r $rawmsg $read $readomo $readn $regex $regml $regsub $regsubex $remove $remtok $replace $replacex $reptok $result $rgb $right $round $scid $scon $script $scriptdir $scriptline $sdir $send $server $serverip $sfile $sha1 $shortfn $show $signal $sin $site $sline $snick $snicks $snotify $sock $sockbr $sockerr $sockname $sorttok $sound $sqrt $ssl $sreq $sslready $status $strip $str $stripped $syle $submenu $switchbar $tan $target $ticks $time $timer $timestamp $timestampfmt $timezone $tip $titlebar $toolbar $treebar $trust $ulevel $ulist $upper $uptime $url $usermode $v1 $v2 $var $vcmd $vcmdstat $vcmdver $version $vnick $vol $wid $width $wildsite $wildtok $window $wrap $xor");
          var keywords2 = parseWords("abook ajinvite alias aline ame amsg anick aop auser autojoin avoice away background ban bcopy beep bread break breplace bset btrunc bunset bwrite channel clear clearall cline clipboard close cnick color comclose comopen comreg continue copy creq ctcpreply ctcps dcc dccserver dde ddeserver debug dec describe dialog did didtok disable disconnect dlevel dline dll dns dqwindow drawcopy drawdot drawfill drawline drawpic drawrect drawreplace drawrot drawsave drawscroll drawtext ebeeps echo editbox emailaddr enable events exit fclose filter findtext finger firewall flash flist flood flush flushini font fopen fseek fsend fserve fullname fwrite ghide gload gmove gopts goto gplay gpoint gqreq groups gshow gsize gstop gtalk gunload hadd halt haltdef hdec hdel help hfree hinc hload hmake hop hsave ial ialclear ialmark identd if ignore iline inc invite iuser join kick linesep links list load loadbuf localinfo log mdi me menubar mkdir mnick mode msg nick noop notice notify omsg onotice part partall pdcc perform play playctrl pop protect pvoice qme qmsg query queryn quit raw reload remini remote remove rename renwin reseterror resetidle return rlevel rline rmdir run ruser save savebuf saveini say scid scon server set showmirc signam sline sockaccept sockclose socklist socklisten sockmark sockopen sockpause sockread sockrename sockudp sockwrite sound speak splay sreq strip switchbar timer timestamp titlebar tnick tokenize toolbar topic tray treebar ulist unload unset unsetall updatenl url uwho var vcadd vcmd vcrem vol while whois window winhelp write writeint if isalnum isalpha isaop isavoice isban ischan ishop isignore isin isincs isletter islower isnotify isnum ison isop isprotect isreg isupper isvoice iswm iswmcs elseif else goto menu nicklist status title icon size option text edit button check radio box scroll list combo link tab item");
          var functions = parseWords("if elseif else and not or eq ne in ni for foreach while switch");
          var isOperatorChar = /[+\-*&%=<>!?^\/\|]/;
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function tokenBase(stream, state) {
            var beforeParams = state.beforeParams;
            state.beforeParams = false;
            var ch = stream.next();
            if (/[\[\]{}\(\),\.]/.test(ch)) {
              if (ch == "(" && beforeParams)
                state.inParams = true;
              else if (ch == ")")
                state.inParams = false;
              return null;
            } else if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            } else if (ch == "\\") {
              stream.eat("\\");
              stream.eat(/./);
              return "number";
            } else if (ch == "/" && stream.eat("*")) {
              return chain2(stream, state, tokenComment);
            } else if (ch == ";" && stream.match(/ *\( *\(/)) {
              return chain2(stream, state, tokenUnparsed);
            } else if (ch == ";" && !state.inParams) {
              stream.skipToEnd();
              return "comment";
            } else if (ch == '"') {
              stream.eat(/"/);
              return "keyword";
            } else if (ch == "$") {
              stream.eatWhile(/[$_a-z0-9A-Z\.:]/);
              if (specials && specials.propertyIsEnumerable(stream.current().toLowerCase())) {
                return "keyword";
              } else {
                state.beforeParams = true;
                return "builtin";
              }
            } else if (ch == "%") {
              stream.eatWhile(/[^,\s()]/);
              state.beforeParams = true;
              return "string";
            } else if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            } else {
              stream.eatWhile(/[\w\$_{}]/);
              var word = stream.current().toLowerCase();
              if (keywords2 && keywords2.propertyIsEnumerable(word))
                return "keyword";
              if (functions && functions.propertyIsEnumerable(word)) {
                state.beforeParams = true;
                return "keyword";
              }
              return null;
            }
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function tokenUnparsed(stream, state) {
            var maybeEnd = 0, ch;
            while (ch = stream.next()) {
              if (ch == ";" && maybeEnd == 2) {
                state.tokenize = tokenBase;
                break;
              }
              if (ch == ")")
                maybeEnd++;
              else if (ch != " ")
                maybeEnd = 0;
            }
            return "meta";
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                beforeParams: false,
                inParams: false
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return state.tokenize(stream, state);
            }
          };
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/mllike/mllike.js
  var require_mllike = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/mllike/mllike.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("mllike", function(_config, parserConfig) {
          var words = {
            "as": "keyword",
            "do": "keyword",
            "else": "keyword",
            "end": "keyword",
            "exception": "keyword",
            "fun": "keyword",
            "functor": "keyword",
            "if": "keyword",
            "in": "keyword",
            "include": "keyword",
            "let": "keyword",
            "of": "keyword",
            "open": "keyword",
            "rec": "keyword",
            "struct": "keyword",
            "then": "keyword",
            "type": "keyword",
            "val": "keyword",
            "while": "keyword",
            "with": "keyword"
          };
          var extraWords = parserConfig.extraWords || {};
          for (var prop in extraWords) {
            if (extraWords.hasOwnProperty(prop)) {
              words[prop] = parserConfig.extraWords[prop];
            }
          }
          var hintWords = [];
          for (var k3 in words) {
            hintWords.push(k3);
          }
          CodeMirror5.registerHelper("hintWords", "mllike", hintWords);
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch === '"') {
              state.tokenize = tokenString;
              return state.tokenize(stream, state);
            }
            if (ch === "{") {
              if (stream.eat("|")) {
                state.longString = true;
                state.tokenize = tokenLongString;
                return state.tokenize(stream, state);
              }
            }
            if (ch === "(") {
              if (stream.eat("*")) {
                state.commentLevel++;
                state.tokenize = tokenComment;
                return state.tokenize(stream, state);
              }
            }
            if (ch === "~" || ch === "?") {
              stream.eatWhile(/\w/);
              return "variable-2";
            }
            if (ch === "`") {
              stream.eatWhile(/\w/);
              return "quote";
            }
            if (ch === "/" && parserConfig.slashComments && stream.eat("/")) {
              stream.skipToEnd();
              return "comment";
            }
            if (/\d/.test(ch)) {
              if (ch === "0" && stream.eat(/[bB]/)) {
                stream.eatWhile(/[01]/);
              }
              if (ch === "0" && stream.eat(/[xX]/)) {
                stream.eatWhile(/[0-9a-fA-F]/);
              }
              if (ch === "0" && stream.eat(/[oO]/)) {
                stream.eatWhile(/[0-7]/);
              } else {
                stream.eatWhile(/[\d_]/);
                if (stream.eat(".")) {
                  stream.eatWhile(/[\d]/);
                }
                if (stream.eat(/[eE]/)) {
                  stream.eatWhile(/[\d\-+]/);
                }
              }
              return "number";
            }
            if (/[+\-*&%=<>!?|@\.~:]/.test(ch)) {
              return "operator";
            }
            if (/[\w\xa1-\uffff]/.test(ch)) {
              stream.eatWhile(/[\w\xa1-\uffff]/);
              var cur = stream.current();
              return words.hasOwnProperty(cur) ? words[cur] : "variable";
            }
            return null;
          }
          function tokenString(stream, state) {
            var next, end = false, escaped = false;
            while ((next = stream.next()) != null) {
              if (next === '"' && !escaped) {
                end = true;
                break;
              }
              escaped = !escaped && next === "\\";
            }
            if (end && !escaped) {
              state.tokenize = tokenBase;
            }
            return "string";
          }
          ;
          function tokenComment(stream, state) {
            var prev, next;
            while (state.commentLevel > 0 && (next = stream.next()) != null) {
              if (prev === "(" && next === "*")
                state.commentLevel++;
              if (prev === "*" && next === ")")
                state.commentLevel--;
              prev = next;
            }
            if (state.commentLevel <= 0) {
              state.tokenize = tokenBase;
            }
            return "comment";
          }
          function tokenLongString(stream, state) {
            var prev, next;
            while (state.longString && (next = stream.next()) != null) {
              if (prev === "|" && next === "}")
                state.longString = false;
              prev = next;
            }
            if (!state.longString) {
              state.tokenize = tokenBase;
            }
            return "string";
          }
          return {
            startState: function() {
              return { tokenize: tokenBase, commentLevel: 0, longString: false };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return state.tokenize(stream, state);
            },
            blockCommentStart: "(*",
            blockCommentEnd: "*)",
            lineComment: parserConfig.slashComments ? "//" : null
          };
        });
        CodeMirror5.defineMIME("text/x-ocaml", {
          name: "mllike",
          extraWords: {
            "and": "keyword",
            "assert": "keyword",
            "begin": "keyword",
            "class": "keyword",
            "constraint": "keyword",
            "done": "keyword",
            "downto": "keyword",
            "external": "keyword",
            "function": "keyword",
            "initializer": "keyword",
            "lazy": "keyword",
            "match": "keyword",
            "method": "keyword",
            "module": "keyword",
            "mutable": "keyword",
            "new": "keyword",
            "nonrec": "keyword",
            "object": "keyword",
            "private": "keyword",
            "sig": "keyword",
            "to": "keyword",
            "try": "keyword",
            "value": "keyword",
            "virtual": "keyword",
            "when": "keyword",
            "raise": "builtin",
            "failwith": "builtin",
            "true": "builtin",
            "false": "builtin",
            "asr": "builtin",
            "land": "builtin",
            "lor": "builtin",
            "lsl": "builtin",
            "lsr": "builtin",
            "lxor": "builtin",
            "mod": "builtin",
            "or": "builtin",
            "raise_notrace": "builtin",
            "trace": "builtin",
            "exit": "builtin",
            "print_string": "builtin",
            "print_endline": "builtin",
            "int": "type",
            "float": "type",
            "bool": "type",
            "char": "type",
            "string": "type",
            "unit": "type",
            "List": "builtin"
          }
        });
        CodeMirror5.defineMIME("text/x-fsharp", {
          name: "mllike",
          extraWords: {
            "abstract": "keyword",
            "assert": "keyword",
            "base": "keyword",
            "begin": "keyword",
            "class": "keyword",
            "default": "keyword",
            "delegate": "keyword",
            "do!": "keyword",
            "done": "keyword",
            "downcast": "keyword",
            "downto": "keyword",
            "elif": "keyword",
            "extern": "keyword",
            "finally": "keyword",
            "for": "keyword",
            "function": "keyword",
            "global": "keyword",
            "inherit": "keyword",
            "inline": "keyword",
            "interface": "keyword",
            "internal": "keyword",
            "lazy": "keyword",
            "let!": "keyword",
            "match": "keyword",
            "member": "keyword",
            "module": "keyword",
            "mutable": "keyword",
            "namespace": "keyword",
            "new": "keyword",
            "null": "keyword",
            "override": "keyword",
            "private": "keyword",
            "public": "keyword",
            "return!": "keyword",
            "return": "keyword",
            "select": "keyword",
            "static": "keyword",
            "to": "keyword",
            "try": "keyword",
            "upcast": "keyword",
            "use!": "keyword",
            "use": "keyword",
            "void": "keyword",
            "when": "keyword",
            "yield!": "keyword",
            "yield": "keyword",
            "atomic": "keyword",
            "break": "keyword",
            "checked": "keyword",
            "component": "keyword",
            "const": "keyword",
            "constraint": "keyword",
            "constructor": "keyword",
            "continue": "keyword",
            "eager": "keyword",
            "event": "keyword",
            "external": "keyword",
            "fixed": "keyword",
            "method": "keyword",
            "mixin": "keyword",
            "object": "keyword",
            "parallel": "keyword",
            "process": "keyword",
            "protected": "keyword",
            "pure": "keyword",
            "sealed": "keyword",
            "tailcall": "keyword",
            "trait": "keyword",
            "virtual": "keyword",
            "volatile": "keyword",
            "List": "builtin",
            "Seq": "builtin",
            "Map": "builtin",
            "Set": "builtin",
            "Option": "builtin",
            "int": "builtin",
            "string": "builtin",
            "not": "builtin",
            "true": "builtin",
            "false": "builtin",
            "raise": "builtin",
            "failwith": "builtin"
          },
          slashComments: true
        });
        CodeMirror5.defineMIME("text/x-sml", {
          name: "mllike",
          extraWords: {
            "abstype": "keyword",
            "and": "keyword",
            "andalso": "keyword",
            "case": "keyword",
            "datatype": "keyword",
            "fn": "keyword",
            "handle": "keyword",
            "infix": "keyword",
            "infixr": "keyword",
            "local": "keyword",
            "nonfix": "keyword",
            "op": "keyword",
            "orelse": "keyword",
            "raise": "keyword",
            "withtype": "keyword",
            "eqtype": "keyword",
            "sharing": "keyword",
            "sig": "keyword",
            "signature": "keyword",
            "structure": "keyword",
            "where": "keyword",
            "true": "keyword",
            "false": "keyword",
            "int": "builtin",
            "real": "builtin",
            "string": "builtin",
            "char": "builtin",
            "bool": "builtin"
          },
          slashComments: true
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/modelica/modelica.js
  var require_modelica = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/modelica/modelica.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("modelica", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit;
          var keywords2 = parserConfig.keywords || {};
          var builtin = parserConfig.builtin || {};
          var atoms = parserConfig.atoms || {};
          var isSingleOperatorChar = /[;=\(:\),{}.*<>+\-\/^\[\]]/;
          var isDoubleOperatorChar = /(:=|<=|>=|==|<>|\.\+|\.\-|\.\*|\.\/|\.\^)/;
          var isDigit = /[0-9]/;
          var isNonDigit = /[_a-zA-Z]/;
          function tokenLineComment(stream, state) {
            stream.skipToEnd();
            state.tokenize = null;
            return "comment";
          }
          function tokenBlockComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (maybeEnd && ch == "/") {
                state.tokenize = null;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function tokenString(stream, state) {
            var escaped = false, ch;
            while ((ch = stream.next()) != null) {
              if (ch == '"' && !escaped) {
                state.tokenize = null;
                state.sol = false;
                break;
              }
              escaped = !escaped && ch == "\\";
            }
            return "string";
          }
          function tokenIdent(stream, state) {
            stream.eatWhile(isDigit);
            while (stream.eat(isDigit) || stream.eat(isNonDigit)) {
            }
            var cur = stream.current();
            if (state.sol && (cur == "package" || cur == "model" || cur == "when" || cur == "connector"))
              state.level++;
            else if (state.sol && cur == "end" && state.level > 0)
              state.level--;
            state.tokenize = null;
            state.sol = false;
            if (keywords2.propertyIsEnumerable(cur))
              return "keyword";
            else if (builtin.propertyIsEnumerable(cur))
              return "builtin";
            else if (atoms.propertyIsEnumerable(cur))
              return "atom";
            else
              return "variable";
          }
          function tokenQIdent(stream, state) {
            while (stream.eat(/[^']/)) {
            }
            state.tokenize = null;
            state.sol = false;
            if (stream.eat("'"))
              return "variable";
            else
              return "error";
          }
          function tokenUnsignedNuber(stream, state) {
            stream.eatWhile(isDigit);
            if (stream.eat(".")) {
              stream.eatWhile(isDigit);
            }
            if (stream.eat("e") || stream.eat("E")) {
              if (!stream.eat("-"))
                stream.eat("+");
              stream.eatWhile(isDigit);
            }
            state.tokenize = null;
            state.sol = false;
            return "number";
          }
          return {
            startState: function() {
              return {
                tokenize: null,
                level: 0,
                sol: true
              };
            },
            token: function(stream, state) {
              if (state.tokenize != null) {
                return state.tokenize(stream, state);
              }
              if (stream.sol()) {
                state.sol = true;
              }
              if (stream.eatSpace()) {
                state.tokenize = null;
                return null;
              }
              var ch = stream.next();
              if (ch == "/" && stream.eat("/")) {
                state.tokenize = tokenLineComment;
              } else if (ch == "/" && stream.eat("*")) {
                state.tokenize = tokenBlockComment;
              } else if (isDoubleOperatorChar.test(ch + stream.peek())) {
                stream.next();
                state.tokenize = null;
                return "operator";
              } else if (isSingleOperatorChar.test(ch)) {
                state.tokenize = null;
                return "operator";
              } else if (isNonDigit.test(ch)) {
                state.tokenize = tokenIdent;
              } else if (ch == "'" && stream.peek() && stream.peek() != "'") {
                state.tokenize = tokenQIdent;
              } else if (ch == '"') {
                state.tokenize = tokenString;
              } else if (isDigit.test(ch)) {
                state.tokenize = tokenUnsignedNuber;
              } else {
                state.tokenize = null;
                return "error";
              }
              return state.tokenize(stream, state);
            },
            indent: function(state, textAfter) {
              if (state.tokenize != null)
                return CodeMirror5.Pass;
              var level = state.level;
              if (/(algorithm)/.test(textAfter))
                level--;
              if (/(equation)/.test(textAfter))
                level--;
              if (/(initial algorithm)/.test(textAfter))
                level--;
              if (/(initial equation)/.test(textAfter))
                level--;
              if (/(end)/.test(textAfter))
                level--;
              if (level > 0)
                return indentUnit * level;
              else
                return 0;
            },
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//"
          };
        });
        function words(str) {
          var obj = {}, words2 = str.split(" ");
          for (var i3 = 0; i3 < words2.length; ++i3)
            obj[words2[i3]] = true;
          return obj;
        }
        var modelicaKeywords = "algorithm and annotation assert block break class connect connector constant constrainedby der discrete each else elseif elsewhen encapsulated end enumeration equation expandable extends external false final flow for function if import impure in initial inner input loop model not operator or outer output package parameter partial protected public pure record redeclare replaceable return stream then true type when while within";
        var modelicaBuiltin = "abs acos actualStream asin atan atan2 cardinality ceil cos cosh delay div edge exp floor getInstanceName homotopy inStream integer log log10 mod pre reinit rem semiLinear sign sin sinh spatialDistribution sqrt tan tanh";
        var modelicaAtoms = "Real Boolean Integer String";
        function def(mimes, mode2) {
          if (typeof mimes == "string")
            mimes = [mimes];
          var words2 = [];
          function add2(obj) {
            if (obj) {
              for (var prop in obj)
                if (obj.hasOwnProperty(prop))
                  words2.push(prop);
            }
          }
          add2(mode2.keywords);
          add2(mode2.builtin);
          add2(mode2.atoms);
          if (words2.length) {
            mode2.helperType = mimes[0];
            CodeMirror5.registerHelper("hintWords", mimes[0], words2);
          }
          for (var i3 = 0; i3 < mimes.length; ++i3)
            CodeMirror5.defineMIME(mimes[i3], mode2);
        }
        def(["text/x-modelica"], {
          name: "modelica",
          keywords: words(modelicaKeywords),
          builtin: words(modelicaBuiltin),
          atoms: words(modelicaAtoms)
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/mscgen/mscgen.js
  var require_mscgen = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/mscgen/mscgen.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var languages = {
          mscgen: {
            "keywords": ["msc"],
            "options": ["hscale", "width", "arcgradient", "wordwraparcs"],
            "constants": ["true", "false", "on", "off"],
            "attributes": ["label", "idurl", "id", "url", "linecolor", "linecolour", "textcolor", "textcolour", "textbgcolor", "textbgcolour", "arclinecolor", "arclinecolour", "arctextcolor", "arctextcolour", "arctextbgcolor", "arctextbgcolour", "arcskip"],
            "brackets": ["\\{", "\\}"],
            "arcsWords": ["note", "abox", "rbox", "box"],
            "arcsOthers": ["\\|\\|\\|", "\\.\\.\\.", "---", "--", "<->", "==", "<<=>>", "<=>", "\\.\\.", "<<>>", "::", "<:>", "->", "=>>", "=>", ">>", ":>", "<-", "<<=", "<=", "<<", "<:", "x-", "-x"],
            "singlecomment": ["//", "#"],
            "operators": ["="]
          },
          xu: {
            "keywords": ["msc", "xu"],
            "options": ["hscale", "width", "arcgradient", "wordwraparcs", "wordwrapentities", "watermark"],
            "constants": ["true", "false", "on", "off", "auto"],
            "attributes": ["label", "idurl", "id", "url", "linecolor", "linecolour", "textcolor", "textcolour", "textbgcolor", "textbgcolour", "arclinecolor", "arclinecolour", "arctextcolor", "arctextcolour", "arctextbgcolor", "arctextbgcolour", "arcskip", "title", "deactivate", "activate", "activation"],
            "brackets": ["\\{", "\\}"],
            "arcsWords": ["note", "abox", "rbox", "box", "alt", "else", "opt", "break", "par", "seq", "strict", "neg", "critical", "ignore", "consider", "assert", "loop", "ref", "exc"],
            "arcsOthers": ["\\|\\|\\|", "\\.\\.\\.", "---", "--", "<->", "==", "<<=>>", "<=>", "\\.\\.", "<<>>", "::", "<:>", "->", "=>>", "=>", ">>", ":>", "<-", "<<=", "<=", "<<", "<:", "x-", "-x"],
            "singlecomment": ["//", "#"],
            "operators": ["="]
          },
          msgenny: {
            "keywords": null,
            "options": ["hscale", "width", "arcgradient", "wordwraparcs", "wordwrapentities", "watermark"],
            "constants": ["true", "false", "on", "off", "auto"],
            "attributes": null,
            "brackets": ["\\{", "\\}"],
            "arcsWords": ["note", "abox", "rbox", "box", "alt", "else", "opt", "break", "par", "seq", "strict", "neg", "critical", "ignore", "consider", "assert", "loop", "ref", "exc"],
            "arcsOthers": ["\\|\\|\\|", "\\.\\.\\.", "---", "--", "<->", "==", "<<=>>", "<=>", "\\.\\.", "<<>>", "::", "<:>", "->", "=>>", "=>", ">>", ":>", "<-", "<<=", "<=", "<<", "<:", "x-", "-x"],
            "singlecomment": ["//", "#"],
            "operators": ["="]
          }
        };
        CodeMirror5.defineMode("mscgen", function(_2, modeConfig) {
          var language = languages[modeConfig && modeConfig.language || "mscgen"];
          return {
            startState: startStateFn,
            copyState: copyStateFn,
            token: produceTokenFunction(language),
            lineComment: "#",
            blockCommentStart: "/*",
            blockCommentEnd: "*/"
          };
        });
        CodeMirror5.defineMIME("text/x-mscgen", "mscgen");
        CodeMirror5.defineMIME("text/x-xu", { name: "mscgen", language: "xu" });
        CodeMirror5.defineMIME("text/x-msgenny", { name: "mscgen", language: "msgenny" });
        function wordRegexpBoundary(pWords) {
          return new RegExp("\\b(" + pWords.join("|") + ")\\b", "i");
        }
        function wordRegexp(pWords) {
          return new RegExp("(" + pWords.join("|") + ")", "i");
        }
        function startStateFn() {
          return {
            inComment: false,
            inString: false,
            inAttributeList: false,
            inScript: false
          };
        }
        function copyStateFn(pState) {
          return {
            inComment: pState.inComment,
            inString: pState.inString,
            inAttributeList: pState.inAttributeList,
            inScript: pState.inScript
          };
        }
        function produceTokenFunction(pConfig) {
          return function(pStream, pState) {
            if (pStream.match(wordRegexp(pConfig.brackets), true, true)) {
              return "bracket";
            }
            if (!pState.inComment) {
              if (pStream.match(/\/\*[^\*\/]*/, true, true)) {
                pState.inComment = true;
                return "comment";
              }
              if (pStream.match(wordRegexp(pConfig.singlecomment), true, true)) {
                pStream.skipToEnd();
                return "comment";
              }
            }
            if (pState.inComment) {
              if (pStream.match(/[^\*\/]*\*\//, true, true))
                pState.inComment = false;
              else
                pStream.skipToEnd();
              return "comment";
            }
            if (!pState.inString && pStream.match(/\"(\\\"|[^\"])*/, true, true)) {
              pState.inString = true;
              return "string";
            }
            if (pState.inString) {
              if (pStream.match(/[^\"]*\"/, true, true))
                pState.inString = false;
              else
                pStream.skipToEnd();
              return "string";
            }
            if (!!pConfig.keywords && pStream.match(wordRegexpBoundary(pConfig.keywords), true, true))
              return "keyword";
            if (pStream.match(wordRegexpBoundary(pConfig.options), true, true))
              return "keyword";
            if (pStream.match(wordRegexpBoundary(pConfig.arcsWords), true, true))
              return "keyword";
            if (pStream.match(wordRegexp(pConfig.arcsOthers), true, true))
              return "keyword";
            if (!!pConfig.operators && pStream.match(wordRegexp(pConfig.operators), true, true))
              return "operator";
            if (!!pConfig.constants && pStream.match(wordRegexp(pConfig.constants), true, true))
              return "variable";
            if (!pConfig.inAttributeList && !!pConfig.attributes && pStream.match(/\[/, true, true)) {
              pConfig.inAttributeList = true;
              return "bracket";
            }
            if (pConfig.inAttributeList) {
              if (pConfig.attributes !== null && pStream.match(wordRegexpBoundary(pConfig.attributes), true, true)) {
                return "attribute";
              }
              if (pStream.match(/]/, true, true)) {
                pConfig.inAttributeList = false;
                return "bracket";
              }
            }
            pStream.next();
            return "base";
          };
        }
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/mumps/mumps.js
  var require_mumps = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/mumps/mumps.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("mumps", function() {
          function wordRegexp(words) {
            return new RegExp("^((" + words.join(")|(") + "))\\b", "i");
          }
          var singleOperators = new RegExp("^[\\+\\-\\*/&#!_?\\\\<>=\\'\\[\\]]");
          var doubleOperators = new RegExp("^(('=)|(<=)|(>=)|('>)|('<)|([[)|(]])|(^$))");
          var singleDelimiters = new RegExp("^[\\.,:]");
          var brackets = new RegExp("[()]");
          var identifiers = new RegExp("^[%A-Za-z][A-Za-z0-9]*");
          var commandKeywords = ["break", "close", "do", "else", "for", "goto", "halt", "hang", "if", "job", "kill", "lock", "merge", "new", "open", "quit", "read", "set", "tcommit", "trollback", "tstart", "use", "view", "write", "xecute", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "q", "r", "s", "tc", "tro", "ts", "u", "v", "w", "x"];
          var intrinsicFuncsWords = ["\\$ascii", "\\$char", "\\$data", "\\$ecode", "\\$estack", "\\$etrap", "\\$extract", "\\$find", "\\$fnumber", "\\$get", "\\$horolog", "\\$io", "\\$increment", "\\$job", "\\$justify", "\\$length", "\\$name", "\\$next", "\\$order", "\\$piece", "\\$qlength", "\\$qsubscript", "\\$query", "\\$quit", "\\$random", "\\$reverse", "\\$select", "\\$stack", "\\$test", "\\$text", "\\$translate", "\\$view", "\\$x", "\\$y", "\\$a", "\\$c", "\\$d", "\\$e", "\\$ec", "\\$es", "\\$et", "\\$f", "\\$fn", "\\$g", "\\$h", "\\$i", "\\$j", "\\$l", "\\$n", "\\$na", "\\$o", "\\$p", "\\$q", "\\$ql", "\\$qs", "\\$r", "\\$re", "\\$s", "\\$st", "\\$t", "\\$tr", "\\$v", "\\$z"];
          var intrinsicFuncs = wordRegexp(intrinsicFuncsWords);
          var command = wordRegexp(commandKeywords);
          function tokenBase(stream, state) {
            if (stream.sol()) {
              state.label = true;
              state.commandMode = 0;
            }
            var ch = stream.peek();
            if (ch == " " || ch == "	") {
              state.label = false;
              if (state.commandMode == 0)
                state.commandMode = 1;
              else if (state.commandMode < 0 || state.commandMode == 2)
                state.commandMode = 0;
            } else if (ch != "." && state.commandMode > 0) {
              if (ch == ":")
                state.commandMode = -1;
              else
                state.commandMode = 2;
            }
            if (ch === "(" || ch === "	")
              state.label = false;
            if (ch === ";") {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match(/^[-+]?\d+(\.\d+)?([eE][-+]?\d+)?/))
              return "number";
            if (ch == '"') {
              if (stream.skipTo('"')) {
                stream.next();
                return "string";
              } else {
                stream.skipToEnd();
                return "error";
              }
            }
            if (stream.match(doubleOperators) || stream.match(singleOperators))
              return "operator";
            if (stream.match(singleDelimiters))
              return null;
            if (brackets.test(ch)) {
              stream.next();
              return "bracket";
            }
            if (state.commandMode > 0 && stream.match(command))
              return "variable-2";
            if (stream.match(intrinsicFuncs))
              return "builtin";
            if (stream.match(identifiers))
              return "variable";
            if (ch === "$" || ch === "^") {
              stream.next();
              return "builtin";
            }
            if (ch === "@") {
              stream.next();
              return "string-2";
            }
            if (/[\w%]/.test(ch)) {
              stream.eatWhile(/[\w%]/);
              return "variable";
            }
            stream.next();
            return "error";
          }
          return {
            startState: function() {
              return {
                label: false,
                commandMode: 0
              };
            },
            token: function(stream, state) {
              var style = tokenBase(stream, state);
              if (state.label)
                return "tag";
              return style;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-mumps", "mumps");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/nginx/nginx.js
  var require_nginx = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/nginx/nginx.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("nginx", function(config3) {
          function words(str) {
            var obj = {}, words2 = str.split(" ");
            for (var i3 = 0; i3 < words2.length; ++i3)
              obj[words2[i3]] = true;
            return obj;
          }
          var keywords2 = words("break return rewrite set accept_mutex accept_mutex_delay access_log add_after_body add_before_body add_header addition_types aio alias allow ancient_browser ancient_browser_value auth_basic auth_basic_user_file auth_http auth_http_header auth_http_timeout autoindex autoindex_exact_size autoindex_localtime charset charset_types client_body_buffer_size client_body_in_file_only client_body_in_single_buffer client_body_temp_path client_body_timeout client_header_buffer_size client_header_timeout client_max_body_size connection_pool_size create_full_put_path daemon dav_access dav_methods debug_connection debug_points default_type degradation degrade deny devpoll_changes devpoll_events directio directio_alignment empty_gif env epoll_events error_log eventport_events expires fastcgi_bind fastcgi_buffer_size fastcgi_buffers fastcgi_busy_buffers_size fastcgi_cache fastcgi_cache_key fastcgi_cache_methods fastcgi_cache_min_uses fastcgi_cache_path fastcgi_cache_use_stale fastcgi_cache_valid fastcgi_catch_stderr fastcgi_connect_timeout fastcgi_hide_header fastcgi_ignore_client_abort fastcgi_ignore_headers fastcgi_index fastcgi_intercept_errors fastcgi_max_temp_file_size fastcgi_next_upstream fastcgi_param fastcgi_pass_header fastcgi_pass_request_body fastcgi_pass_request_headers fastcgi_read_timeout fastcgi_send_lowat fastcgi_send_timeout fastcgi_split_path_info fastcgi_store fastcgi_store_access fastcgi_temp_file_write_size fastcgi_temp_path fastcgi_upstream_fail_timeout fastcgi_upstream_max_fails flv geoip_city geoip_country google_perftools_profiles gzip gzip_buffers gzip_comp_level gzip_disable gzip_hash gzip_http_version gzip_min_length gzip_no_buffer gzip_proxied gzip_static gzip_types gzip_vary gzip_window if_modified_since ignore_invalid_headers image_filter image_filter_buffer image_filter_jpeg_quality image_filter_transparency imap_auth imap_capabilities imap_client_buffer index ip_hash keepalive_requests keepalive_timeout kqueue_changes kqueue_events large_client_header_buffers limit_conn limit_conn_log_level limit_rate limit_rate_after limit_req limit_req_log_level limit_req_zone limit_zone lingering_time lingering_timeout lock_file log_format log_not_found log_subrequest map_hash_bucket_size map_hash_max_size master_process memcached_bind memcached_buffer_size memcached_connect_timeout memcached_next_upstream memcached_read_timeout memcached_send_timeout memcached_upstream_fail_timeout memcached_upstream_max_fails merge_slashes min_delete_depth modern_browser modern_browser_value msie_padding msie_refresh multi_accept open_file_cache open_file_cache_errors open_file_cache_events open_file_cache_min_uses open_file_cache_valid open_log_file_cache output_buffers override_charset perl perl_modules perl_require perl_set pid pop3_auth pop3_capabilities port_in_redirect postpone_gzipping postpone_output protocol proxy proxy_bind proxy_buffer proxy_buffer_size proxy_buffering proxy_buffers proxy_busy_buffers_size proxy_cache proxy_cache_key proxy_cache_methods proxy_cache_min_uses proxy_cache_path proxy_cache_use_stale proxy_cache_valid proxy_connect_timeout proxy_headers_hash_bucket_size proxy_headers_hash_max_size proxy_hide_header proxy_ignore_client_abort proxy_ignore_headers proxy_intercept_errors proxy_max_temp_file_size proxy_method proxy_next_upstream proxy_pass_error_message proxy_pass_header proxy_pass_request_body proxy_pass_request_headers proxy_read_timeout proxy_redirect proxy_send_lowat proxy_send_timeout proxy_set_body proxy_set_header proxy_ssl_session_reuse proxy_store proxy_store_access proxy_temp_file_write_size proxy_temp_path proxy_timeout proxy_upstream_fail_timeout proxy_upstream_max_fails random_index read_ahead real_ip_header recursive_error_pages request_pool_size reset_timedout_connection resolver resolver_timeout rewrite_log rtsig_overflow_events rtsig_overflow_test rtsig_overflow_threshold rtsig_signo satisfy secure_link_secret send_lowat send_timeout sendfile sendfile_max_chunk server_name_in_redirect server_names_hash_bucket_size server_names_hash_max_size server_tokens set_real_ip_from smtp_auth smtp_capabilities smtp_client_buffer smtp_greeting_delay so_keepalive source_charset ssi ssi_ignore_recycled_buffers ssi_min_file_chunk ssi_silent_errors ssi_types ssi_value_length ssl ssl_certificate ssl_certificate_key ssl_ciphers ssl_client_certificate ssl_crl ssl_dhparam ssl_engine ssl_prefer_server_ciphers ssl_protocols ssl_session_cache ssl_session_timeout ssl_verify_client ssl_verify_depth starttls stub_status sub_filter sub_filter_once sub_filter_types tcp_nodelay tcp_nopush thread_stack_size timeout timer_resolution types_hash_bucket_size types_hash_max_size underscores_in_headers uninitialized_variable_warn use user userid userid_domain userid_expires userid_mark userid_name userid_p3p userid_path userid_service valid_referers variables_hash_bucket_size variables_hash_max_size worker_connections worker_cpu_affinity worker_priority worker_processes worker_rlimit_core worker_rlimit_nofile worker_rlimit_sigpending worker_threads working_directory xclient xml_entities xslt_stylesheet xslt_typesdrew@li229-23");
          var keywords_block = words("http mail events server types location upstream charset_map limit_except if geo map");
          var keywords_important = words("include root server server_name listen internal proxy_pass memcached_pass fastcgi_pass try_files");
          var indentUnit = config3.indentUnit, type;
          function ret(style, tp) {
            type = tp;
            return style;
          }
          function tokenBase(stream, state) {
            stream.eatWhile(/[\w\$_]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur)) {
              return "keyword";
            } else if (keywords_block.propertyIsEnumerable(cur)) {
              return "variable-2";
            } else if (keywords_important.propertyIsEnumerable(cur)) {
              return "string-2";
            }
            var ch = stream.next();
            if (ch == "@") {
              stream.eatWhile(/[\w\\\-]/);
              return ret("meta", stream.current());
            } else if (ch == "/" && stream.eat("*")) {
              state.tokenize = tokenCComment;
              return tokenCComment(stream, state);
            } else if (ch == "<" && stream.eat("!")) {
              state.tokenize = tokenSGMLComment;
              return tokenSGMLComment(stream, state);
            } else if (ch == "=")
              ret(null, "compare");
            else if ((ch == "~" || ch == "|") && stream.eat("="))
              return ret(null, "compare");
            else if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            } else if (ch == "#") {
              stream.skipToEnd();
              return ret("comment", "comment");
            } else if (ch == "!") {
              stream.match(/^\s*\w*/);
              return ret("keyword", "important");
            } else if (/\d/.test(ch)) {
              stream.eatWhile(/[\w.%]/);
              return ret("number", "unit");
            } else if (/[,.+>*\/]/.test(ch)) {
              return ret(null, "select-op");
            } else if (/[;{}:\[\]]/.test(ch)) {
              return ret(null, ch);
            } else {
              stream.eatWhile(/[\w\\\-]/);
              return ret("variable", "variable");
            }
          }
          function tokenCComment(stream, state) {
            var maybeEnd = false, ch;
            while ((ch = stream.next()) != null) {
              if (maybeEnd && ch == "/") {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return ret("comment", "comment");
          }
          function tokenSGMLComment(stream, state) {
            var dashes = 0, ch;
            while ((ch = stream.next()) != null) {
              if (dashes >= 2 && ch == ">") {
                state.tokenize = tokenBase;
                break;
              }
              dashes = ch == "-" ? dashes + 1 : 0;
            }
            return ret("comment", "comment");
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped)
                  break;
                escaped = !escaped && ch == "\\";
              }
              if (!escaped)
                state.tokenize = tokenBase;
              return ret("string", "string");
            };
          }
          return {
            startState: function(base) {
              return {
                tokenize: tokenBase,
                baseIndent: base || 0,
                stack: []
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              type = null;
              var style = state.tokenize(stream, state);
              var context = state.stack[state.stack.length - 1];
              if (type == "hash" && context == "rule")
                style = "atom";
              else if (style == "variable") {
                if (context == "rule")
                  style = "number";
                else if (!context || context == "@media{")
                  style = "tag";
              }
              if (context == "rule" && /^[\{\};]$/.test(type))
                state.stack.pop();
              if (type == "{") {
                if (context == "@media")
                  state.stack[state.stack.length - 1] = "@media{";
                else
                  state.stack.push("{");
              } else if (type == "}")
                state.stack.pop();
              else if (type == "@media")
                state.stack.push("@media");
              else if (context == "{" && type != "comment")
                state.stack.push("rule");
              return style;
            },
            indent: function(state, textAfter) {
              var n3 = state.stack.length;
              if (/^\}/.test(textAfter))
                n3 -= state.stack[state.stack.length - 1] == "rule" ? 2 : 1;
              return state.baseIndent + n3 * indentUnit;
            },
            electricChars: "}"
          };
        });
        CodeMirror5.defineMIME("text/x-nginx-conf", "nginx");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/nsis/nsis.js
  var require_nsis = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/nsis/nsis.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_simple());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../../addon/mode/simple"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineSimpleMode("nsis", {
          start: [
            { regex: /(?:[+-]?)(?:0x[\d,a-f]+)|(?:0o[0-7]+)|(?:0b[0,1]+)|(?:\d+.?\d*)/, token: "number" },
            { regex: /"(?:[^\\"]|\\.)*"?/, token: "string" },
            { regex: /'(?:[^\\']|\\.)*'?/, token: "string" },
            { regex: /`(?:[^\\`]|\\.)*`?/, token: "string" },
            { regex: /^\s*(?:\!(include|addincludedir|addplugindir|appendfile|cd|delfile|echo|error|execute|packhdr|pragma|finalize|getdllversion|gettlbversion|system|tempfile|warning|verbose|define|undef|insertmacro|macro|macroend|makensis|searchparse|searchreplace))\b/, token: "keyword" },
            { regex: /^\s*(?:\!(if(?:n?def)?|ifmacron?def|macro))\b/, token: "keyword", indent: true },
            { regex: /^\s*(?:\!(else|endif|macroend))\b/, token: "keyword", dedent: true },
            { regex: /^\s*(?:Abort|AddBrandingImage|AddSize|AllowRootDirInstall|AllowSkipFiles|AutoCloseWindow|BGFont|BGGradient|BrandingText|BringToFront|Call|CallInstDLL|Caption|ChangeUI|CheckBitmap|ClearErrors|CompletedText|ComponentText|CopyFiles|CRCCheck|CreateDirectory|CreateFont|CreateShortCut|Delete|DeleteINISec|DeleteINIStr|DeleteRegKey|DeleteRegValue|DetailPrint|DetailsButtonText|DirText|DirVar|DirVerify|EnableWindow|EnumRegKey|EnumRegValue|Exch|Exec|ExecShell|ExecShellWait|ExecWait|ExpandEnvStrings|File|FileBufSize|FileClose|FileErrorText|FileOpen|FileRead|FileReadByte|FileReadUTF16LE|FileReadWord|FileWriteUTF16LE|FileSeek|FileWrite|FileWriteByte|FileWriteWord|FindClose|FindFirst|FindNext|FindWindow|FlushINI|GetCurInstType|GetCurrentAddress|GetDlgItem|GetDLLVersion|GetDLLVersionLocal|GetErrorLevel|GetFileTime|GetFileTimeLocal|GetFullPathName|GetFunctionAddress|GetInstDirError|GetLabelAddress|GetTempFileName|Goto|HideWindow|Icon|IfAbort|IfErrors|IfFileExists|IfRebootFlag|IfSilent|InitPluginsDir|InstallButtonText|InstallColors|InstallDir|InstallDirRegKey|InstProgressFlags|InstType|InstTypeGetText|InstTypeSetText|Int64Cmp|Int64CmpU|Int64Fmt|IntCmp|IntCmpU|IntFmt|IntOp|IntPtrCmp|IntPtrCmpU|IntPtrOp|IsWindow|LangString|LicenseBkColor|LicenseData|LicenseForceSelection|LicenseLangString|LicenseText|LoadAndSetImage|LoadLanguageFile|LockWindow|LogSet|LogText|ManifestDPIAware|ManifestLongPathAware|ManifestMaxVersionTested|ManifestSupportedOS|MessageBox|MiscButtonText|Name|Nop|OutFile|Page|PageCallbacks|PEAddResource|PEDllCharacteristics|PERemoveResource|PESubsysVer|Pop|Push|Quit|ReadEnvStr|ReadINIStr|ReadRegDWORD|ReadRegStr|Reboot|RegDLL|Rename|RequestExecutionLevel|ReserveFile|Return|RMDir|SearchPath|SectionGetFlags|SectionGetInstTypes|SectionGetSize|SectionGetText|SectionIn|SectionSetFlags|SectionSetInstTypes|SectionSetSize|SectionSetText|SendMessage|SetAutoClose|SetBrandingImage|SetCompress|SetCompressor|SetCompressorDictSize|SetCtlColors|SetCurInstType|SetDatablockOptimize|SetDateSave|SetDetailsPrint|SetDetailsView|SetErrorLevel|SetErrors|SetFileAttributes|SetFont|SetOutPath|SetOverwrite|SetRebootFlag|SetRegView|SetShellVarContext|SetSilent|ShowInstDetails|ShowUninstDetails|ShowWindow|SilentInstall|SilentUnInstall|Sleep|SpaceTexts|StrCmp|StrCmpS|StrCpy|StrLen|SubCaption|Unicode|UninstallButtonText|UninstallCaption|UninstallIcon|UninstallSubCaption|UninstallText|UninstPage|UnRegDLL|Var|VIAddVersionKey|VIFileVersion|VIProductVersion|WindowIcon|WriteINIStr|WriteRegBin|WriteRegDWORD|WriteRegExpandStr|WriteRegMultiStr|WriteRegNone|WriteRegStr|WriteUninstaller|XPStyle)\b/, token: "keyword" },
            { regex: /^\s*(?:Function|PageEx|Section(?:Group)?)\b/, token: "keyword", indent: true },
            { regex: /^\s*(?:(Function|PageEx|Section(?:Group)?)End)\b/, token: "keyword", dedent: true },
            { regex: /\b(?:ARCHIVE|FILE_ATTRIBUTE_ARCHIVE|FILE_ATTRIBUTE_HIDDEN|FILE_ATTRIBUTE_NORMAL|FILE_ATTRIBUTE_OFFLINE|FILE_ATTRIBUTE_READONLY|FILE_ATTRIBUTE_SYSTEM|FILE_ATTRIBUTE_TEMPORARY|HIDDEN|HKCC|HKCR(32|64)?|HKCU(32|64)?|HKDD|HKEY_CLASSES_ROOT|HKEY_CURRENT_CONFIG|HKEY_CURRENT_USER|HKEY_DYN_DATA|HKEY_LOCAL_MACHINE|HKEY_PERFORMANCE_DATA|HKEY_USERS|HKLM(32|64)?|HKPD|HKU|IDABORT|IDCANCEL|IDD_DIR|IDD_INST|IDD_INSTFILES|IDD_LICENSE|IDD_SELCOM|IDD_UNINST|IDD_VERIFY|IDIGNORE|IDNO|IDOK|IDRETRY|IDYES|MB_ABORTRETRYIGNORE|MB_DEFBUTTON1|MB_DEFBUTTON2|MB_DEFBUTTON3|MB_DEFBUTTON4|MB_ICONEXCLAMATION|MB_ICONINFORMATION|MB_ICONQUESTION|MB_ICONSTOP|MB_OK|MB_OKCANCEL|MB_RETRYCANCEL|MB_RIGHT|MB_RTLREADING|MB_SETFOREGROUND|MB_TOPMOST|MB_USERICON|MB_YESNO|MB_YESNOCANCEL|NORMAL|OFFLINE|READONLY|SHCTX|SHELL_CONTEXT|SW_HIDE|SW_SHOWDEFAULT|SW_SHOWMAXIMIZED|SW_SHOWMINIMIZED|SW_SHOWNORMAL|SYSTEM|TEMPORARY)\b/, token: "atom" },
            { regex: /\b(?:admin|all|auto|both|bottom|bzip2|components|current|custom|directory|false|force|hide|highest|ifdiff|ifnewer|instfiles|lastused|leave|left|license|listonly|lzma|nevershow|none|normal|notset|off|on|right|show|silent|silentlog|textonly|top|true|try|un\.components|un\.custom|un\.directory|un\.instfiles|un\.license|uninstConfirm|user|Win10|Win7|Win8|WinVista|zlib)\b/, token: "builtin" },
            { regex: /\$\{(?:And(?:If(?:Not)?|Unless)|Break|Case(?:Else)?|Continue|Default|Do(?:Until|While)?|Else(?:If(?:Not)?|Unless)?|End(?:If|Select|Switch)|Exit(?:Do|For|While)|For(?:Each)?|If(?:Cmd|Not(?:Then)?|Then)?|Loop(?:Until|While)?|Or(?:If(?:Not)?|Unless)|Select|Switch|Unless|While)\}/, token: "variable-2", indent: true },
            { regex: /\$\{(?:BannerTrimPath|DirState|DriveSpace|Get(BaseName|Drives|ExeName|ExePath|FileAttributes|FileExt|FileName|FileVersion|Options|OptionsS|Parameters|Parent|Root|Size|Time)|Locate|RefreshShellIcons)\}/, token: "variable-2", dedent: true },
            { regex: /\$\{(?:Memento(?:Section(?:Done|End|Restore|Save)?|UnselectedSection))\}/, token: "variable-2", dedent: true },
            { regex: /\$\{(?:Config(?:Read|ReadS|Write|WriteS)|File(?:Join|ReadFromEnd|Recode)|Line(?:Find|Read|Sum)|Text(?:Compare|CompareS)|TrimNewLines)\}/, token: "variable-2", dedent: true },
            { regex: /\$\{(?:(?:At(?:Least|Most)|Is)(?:ServicePack|Win(?:7|8|10|95|98|200(?:0|3|8(?:R2)?)|ME|NT4|Vista|XP))|Is(?:NT|Server))\}/, token: "variable", dedent: true },
            { regex: /\$\{(?:StrFilterS?|Version(?:Compare|Convert)|Word(?:AddS?|Find(?:(?:2|3)X)?S?|InsertS?|ReplaceS?))\}/, token: "variable-2", dedent: true },
            { regex: /\$\{(?:RunningX64)\}/, token: "variable", dedent: true },
            { regex: /\$\{(?:Disable|Enable)X64FSRedirection\}/, token: "variable-2", dedent: true },
            { regex: /(#|;).*/, token: "comment" },
            { regex: /\/\*/, token: "comment", next: "comment" },
            { regex: /[-+\/*=<>!]+/, token: "operator" },
            { regex: /\$\w+/, token: "variable" },
            { regex: /\${[\w\.:-]+}/, token: "variable-2" },
            { regex: /\$\([\w\.:-]+\)/, token: "variable-3" }
          ],
          comment: [
            { regex: /.*?\*\//, token: "comment", next: "start" },
            { regex: /.*/, token: "comment" }
          ],
          meta: {
            electricInput: /^\s*((Function|PageEx|Section|Section(Group)?)End|(\!(endif|macroend))|\$\{(End(If|Unless|While)|Loop(Until)|Next)\})$/,
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: ["#", ";"]
          }
        });
        CodeMirror5.defineMIME("text/x-nsis", "nsis");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/ntriples/ntriples.js
  var require_ntriples = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/ntriples/ntriples.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("ntriples", function() {
          var Location = {
            PRE_SUBJECT: 0,
            WRITING_SUB_URI: 1,
            WRITING_BNODE_URI: 2,
            PRE_PRED: 3,
            WRITING_PRED_URI: 4,
            PRE_OBJ: 5,
            WRITING_OBJ_URI: 6,
            WRITING_OBJ_BNODE: 7,
            WRITING_OBJ_LITERAL: 8,
            WRITING_LIT_LANG: 9,
            WRITING_LIT_TYPE: 10,
            POST_OBJ: 11,
            ERROR: 12
          };
          function transitState(currState, c3) {
            var currLocation = currState.location;
            var ret;
            if (currLocation == Location.PRE_SUBJECT && c3 == "<")
              ret = Location.WRITING_SUB_URI;
            else if (currLocation == Location.PRE_SUBJECT && c3 == "_")
              ret = Location.WRITING_BNODE_URI;
            else if (currLocation == Location.PRE_PRED && c3 == "<")
              ret = Location.WRITING_PRED_URI;
            else if (currLocation == Location.PRE_OBJ && c3 == "<")
              ret = Location.WRITING_OBJ_URI;
            else if (currLocation == Location.PRE_OBJ && c3 == "_")
              ret = Location.WRITING_OBJ_BNODE;
            else if (currLocation == Location.PRE_OBJ && c3 == '"')
              ret = Location.WRITING_OBJ_LITERAL;
            else if (currLocation == Location.WRITING_SUB_URI && c3 == ">")
              ret = Location.PRE_PRED;
            else if (currLocation == Location.WRITING_BNODE_URI && c3 == " ")
              ret = Location.PRE_PRED;
            else if (currLocation == Location.WRITING_PRED_URI && c3 == ">")
              ret = Location.PRE_OBJ;
            else if (currLocation == Location.WRITING_OBJ_URI && c3 == ">")
              ret = Location.POST_OBJ;
            else if (currLocation == Location.WRITING_OBJ_BNODE && c3 == " ")
              ret = Location.POST_OBJ;
            else if (currLocation == Location.WRITING_OBJ_LITERAL && c3 == '"')
              ret = Location.POST_OBJ;
            else if (currLocation == Location.WRITING_LIT_LANG && c3 == " ")
              ret = Location.POST_OBJ;
            else if (currLocation == Location.WRITING_LIT_TYPE && c3 == ">")
              ret = Location.POST_OBJ;
            else if (currLocation == Location.WRITING_OBJ_LITERAL && c3 == "@")
              ret = Location.WRITING_LIT_LANG;
            else if (currLocation == Location.WRITING_OBJ_LITERAL && c3 == "^")
              ret = Location.WRITING_LIT_TYPE;
            else if (c3 == " " && (currLocation == Location.PRE_SUBJECT || currLocation == Location.PRE_PRED || currLocation == Location.PRE_OBJ || currLocation == Location.POST_OBJ))
              ret = currLocation;
            else if (currLocation == Location.POST_OBJ && c3 == ".")
              ret = Location.PRE_SUBJECT;
            else
              ret = Location.ERROR;
            currState.location = ret;
          }
          return {
            startState: function() {
              return {
                location: Location.PRE_SUBJECT,
                uris: [],
                anchors: [],
                bnodes: [],
                langs: [],
                types: []
              };
            },
            token: function(stream, state) {
              var ch = stream.next();
              if (ch == "<") {
                transitState(state, ch);
                var parsedURI = "";
                stream.eatWhile(function(c3) {
                  if (c3 != "#" && c3 != ">") {
                    parsedURI += c3;
                    return true;
                  }
                  return false;
                });
                state.uris.push(parsedURI);
                if (stream.match("#", false))
                  return "variable";
                stream.next();
                transitState(state, ">");
                return "variable";
              }
              if (ch == "#") {
                var parsedAnchor = "";
                stream.eatWhile(function(c3) {
                  if (c3 != ">" && c3 != " ") {
                    parsedAnchor += c3;
                    return true;
                  }
                  return false;
                });
                state.anchors.push(parsedAnchor);
                return "variable-2";
              }
              if (ch == ">") {
                transitState(state, ">");
                return "variable";
              }
              if (ch == "_") {
                transitState(state, ch);
                var parsedBNode = "";
                stream.eatWhile(function(c3) {
                  if (c3 != " ") {
                    parsedBNode += c3;
                    return true;
                  }
                  return false;
                });
                state.bnodes.push(parsedBNode);
                stream.next();
                transitState(state, " ");
                return "builtin";
              }
              if (ch == '"') {
                transitState(state, ch);
                stream.eatWhile(function(c3) {
                  return c3 != '"';
                });
                stream.next();
                if (stream.peek() != "@" && stream.peek() != "^") {
                  transitState(state, '"');
                }
                return "string";
              }
              if (ch == "@") {
                transitState(state, "@");
                var parsedLang = "";
                stream.eatWhile(function(c3) {
                  if (c3 != " ") {
                    parsedLang += c3;
                    return true;
                  }
                  return false;
                });
                state.langs.push(parsedLang);
                stream.next();
                transitState(state, " ");
                return "string-2";
              }
              if (ch == "^") {
                stream.next();
                transitState(state, "^");
                var parsedType = "";
                stream.eatWhile(function(c3) {
                  if (c3 != ">") {
                    parsedType += c3;
                    return true;
                  }
                  return false;
                });
                state.types.push(parsedType);
                stream.next();
                transitState(state, ">");
                return "variable";
              }
              if (ch == " ") {
                transitState(state, ch);
              }
              if (ch == ".") {
                transitState(state, ch);
              }
            }
          };
        });
        CodeMirror5.defineMIME("application/n-triples", "ntriples");
        CodeMirror5.defineMIME("application/n-quads", "ntriples");
        CodeMirror5.defineMIME("text/n-triples", "ntriples");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/octave/octave.js
  var require_octave = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/octave/octave.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("octave", function() {
          function wordRegexp(words) {
            return new RegExp("^((" + words.join(")|(") + "))\\b");
          }
          var singleOperators = new RegExp("^[\\+\\-\\*/&|\\^~<>!@'\\\\]");
          var singleDelimiters = new RegExp("^[\\(\\[\\{\\},:=;\\.]");
          var doubleOperators = new RegExp("^((==)|(~=)|(<=)|(>=)|(<<)|(>>)|(\\.[\\+\\-\\*/\\^\\\\]))");
          var doubleDelimiters = new RegExp("^((!=)|(\\+=)|(\\-=)|(\\*=)|(/=)|(&=)|(\\|=)|(\\^=))");
          var tripleDelimiters = new RegExp("^((>>=)|(<<=))");
          var expressionEnd = new RegExp("^[\\]\\)]");
          var identifiers = new RegExp("^[_A-Za-z\xA1-\uFFFF][_A-Za-z0-9\xA1-\uFFFF]*");
          var builtins = wordRegexp([
            "error",
            "eval",
            "function",
            "abs",
            "acos",
            "atan",
            "asin",
            "cos",
            "cosh",
            "exp",
            "log",
            "prod",
            "sum",
            "log10",
            "max",
            "min",
            "sign",
            "sin",
            "sinh",
            "sqrt",
            "tan",
            "reshape",
            "break",
            "zeros",
            "default",
            "margin",
            "round",
            "ones",
            "rand",
            "syn",
            "ceil",
            "floor",
            "size",
            "clear",
            "zeros",
            "eye",
            "mean",
            "std",
            "cov",
            "det",
            "eig",
            "inv",
            "norm",
            "rank",
            "trace",
            "expm",
            "logm",
            "sqrtm",
            "linspace",
            "plot",
            "title",
            "xlabel",
            "ylabel",
            "legend",
            "text",
            "grid",
            "meshgrid",
            "mesh",
            "num2str",
            "fft",
            "ifft",
            "arrayfun",
            "cellfun",
            "input",
            "fliplr",
            "flipud",
            "ismember"
          ]);
          var keywords2 = wordRegexp([
            "return",
            "case",
            "switch",
            "else",
            "elseif",
            "end",
            "endif",
            "endfunction",
            "if",
            "otherwise",
            "do",
            "for",
            "while",
            "try",
            "catch",
            "classdef",
            "properties",
            "events",
            "methods",
            "global",
            "persistent",
            "endfor",
            "endwhile",
            "printf",
            "sprintf",
            "disp",
            "until",
            "continue",
            "pkg"
          ]);
          function tokenTranspose(stream, state) {
            if (!stream.sol() && stream.peek() === "'") {
              stream.next();
              state.tokenize = tokenBase;
              return "operator";
            }
            state.tokenize = tokenBase;
            return tokenBase(stream, state);
          }
          function tokenComment(stream, state) {
            if (stream.match(/^.*%}/)) {
              state.tokenize = tokenBase;
              return "comment";
            }
            ;
            stream.skipToEnd();
            return "comment";
          }
          function tokenBase(stream, state) {
            if (stream.eatSpace())
              return null;
            if (stream.match("%{")) {
              state.tokenize = tokenComment;
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match(/^[%#]/)) {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match(/^[0-9\.+-]/, false)) {
              if (stream.match(/^[+-]?0x[0-9a-fA-F]+[ij]?/)) {
                stream.tokenize = tokenBase;
                return "number";
              }
              ;
              if (stream.match(/^[+-]?\d*\.\d+([EeDd][+-]?\d+)?[ij]?/)) {
                return "number";
              }
              ;
              if (stream.match(/^[+-]?\d+([EeDd][+-]?\d+)?[ij]?/)) {
                return "number";
              }
              ;
            }
            if (stream.match(wordRegexp(["nan", "NaN", "inf", "Inf"]))) {
              return "number";
            }
            ;
            var m3 = stream.match(/^"(?:[^"]|"")*("|$)/) || stream.match(/^'(?:[^']|'')*('|$)/);
            if (m3) {
              return m3[1] ? "string" : "string error";
            }
            if (stream.match(keywords2)) {
              return "keyword";
            }
            ;
            if (stream.match(builtins)) {
              return "builtin";
            }
            ;
            if (stream.match(identifiers)) {
              return "variable";
            }
            ;
            if (stream.match(singleOperators) || stream.match(doubleOperators)) {
              return "operator";
            }
            ;
            if (stream.match(singleDelimiters) || stream.match(doubleDelimiters) || stream.match(tripleDelimiters)) {
              return null;
            }
            ;
            if (stream.match(expressionEnd)) {
              state.tokenize = tokenTranspose;
              return null;
            }
            ;
            stream.next();
            return "error";
          }
          ;
          return {
            startState: function() {
              return {
                tokenize: tokenBase
              };
            },
            token: function(stream, state) {
              var style = state.tokenize(stream, state);
              if (style === "number" || style === "variable") {
                state.tokenize = tokenTranspose;
              }
              return style;
            },
            lineComment: "%",
            fold: "indent"
          };
        });
        CodeMirror5.defineMIME("text/x-octave", "octave");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/oz/oz.js
  var require_oz = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/oz/oz.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("oz", function(conf) {
          function wordRegexp(words) {
            return new RegExp("^((" + words.join(")|(") + "))\\b");
          }
          var singleOperators = /[\^@!\|<>#~\.\*\-\+\\/,=]/;
          var doubleOperators = /(<-)|(:=)|(=<)|(>=)|(<=)|(<:)|(>:)|(=:)|(\\=)|(\\=:)|(!!)|(==)|(::)/;
          var tripleOperators = /(:::)|(\.\.\.)|(=<:)|(>=:)/;
          var middle = [
            "in",
            "then",
            "else",
            "of",
            "elseof",
            "elsecase",
            "elseif",
            "catch",
            "finally",
            "with",
            "require",
            "prepare",
            "import",
            "export",
            "define",
            "do"
          ];
          var end = ["end"];
          var atoms = wordRegexp(["true", "false", "nil", "unit"]);
          var commonKeywords = wordRegexp([
            "andthen",
            "at",
            "attr",
            "declare",
            "feat",
            "from",
            "lex",
            "mod",
            "div",
            "mode",
            "orelse",
            "parser",
            "prod",
            "prop",
            "scanner",
            "self",
            "syn",
            "token"
          ]);
          var openingKeywords = wordRegexp([
            "local",
            "proc",
            "fun",
            "case",
            "class",
            "if",
            "cond",
            "or",
            "dis",
            "choice",
            "not",
            "thread",
            "try",
            "raise",
            "lock",
            "for",
            "suchthat",
            "meth",
            "functor"
          ]);
          var middleKeywords = wordRegexp(middle);
          var endKeywords = wordRegexp(end);
          function tokenBase(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            if (stream.match(/[{}]/)) {
              return "bracket";
            }
            if (stream.match(/(\[])/)) {
              return "keyword";
            }
            if (stream.match(tripleOperators) || stream.match(doubleOperators)) {
              return "operator";
            }
            if (stream.match(atoms)) {
              return "atom";
            }
            var matched = stream.match(openingKeywords);
            if (matched) {
              if (!state.doInCurrentLine)
                state.currentIndent++;
              else
                state.doInCurrentLine = false;
              if (matched[0] == "proc" || matched[0] == "fun")
                state.tokenize = tokenFunProc;
              else if (matched[0] == "class")
                state.tokenize = tokenClass;
              else if (matched[0] == "meth")
                state.tokenize = tokenMeth;
              return "keyword";
            }
            if (stream.match(middleKeywords) || stream.match(commonKeywords)) {
              return "keyword";
            }
            if (stream.match(endKeywords)) {
              state.currentIndent--;
              return "keyword";
            }
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[~\d]/.test(ch)) {
              if (ch == "~") {
                if (!/^[0-9]/.test(stream.peek()))
                  return null;
                else if (stream.next() == "0" && stream.match(/^[xX][0-9a-fA-F]+/) || stream.match(/^[0-9]*(\.[0-9]+)?([eE][~+]?[0-9]+)?/))
                  return "number";
              }
              if (ch == "0" && stream.match(/^[xX][0-9a-fA-F]+/) || stream.match(/^[0-9]*(\.[0-9]+)?([eE][~+]?[0-9]+)?/))
                return "number";
              return null;
            }
            if (ch == "%") {
              stream.skipToEnd();
              return "comment";
            } else if (ch == "/") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
            }
            if (singleOperators.test(ch)) {
              return "operator";
            }
            stream.eatWhile(/\w/);
            return "variable";
          }
          function tokenClass(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            stream.match(/([A-Z][A-Za-z0-9_]*)|(`.+`)/);
            state.tokenize = tokenBase;
            return "variable-3";
          }
          function tokenMeth(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            stream.match(/([a-zA-Z][A-Za-z0-9_]*)|(`.+`)/);
            state.tokenize = tokenBase;
            return "def";
          }
          function tokenFunProc(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            if (!state.hasPassedFirstStage && stream.eat("{")) {
              state.hasPassedFirstStage = true;
              return "bracket";
            } else if (state.hasPassedFirstStage) {
              stream.match(/([A-Z][A-Za-z0-9_]*)|(`.+`)|\$/);
              state.hasPassedFirstStage = false;
              state.tokenize = tokenBase;
              return "def";
            } else {
              state.tokenize = tokenBase;
              return null;
            }
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end2 = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end2 = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end2 || !escaped)
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function buildElectricInputRegEx() {
            var allClosings = middle.concat(end);
            return new RegExp("[\\[\\]]|(" + allClosings.join("|") + ")$");
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                currentIndent: 0,
                doInCurrentLine: false,
                hasPassedFirstStage: false
              };
            },
            token: function(stream, state) {
              if (stream.sol())
                state.doInCurrentLine = 0;
              return state.tokenize(stream, state);
            },
            indent: function(state, textAfter) {
              var trueText = textAfter.replace(/^\s+|\s+$/g, "");
              if (trueText.match(endKeywords) || trueText.match(middleKeywords) || trueText.match(/(\[])/))
                return conf.indentUnit * (state.currentIndent - 1);
              if (state.currentIndent < 0)
                return 0;
              return state.currentIndent * conf.indentUnit;
            },
            fold: "indent",
            electricInput: buildElectricInputRegEx(),
            lineComment: "%",
            blockCommentStart: "/*",
            blockCommentEnd: "*/"
          };
        });
        CodeMirror5.defineMIME("text/x-oz", "oz");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/pascal/pascal.js
  var require_pascal = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/pascal/pascal.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("pascal", function() {
          function words(str) {
            var obj = {}, words2 = str.split(" ");
            for (var i3 = 0; i3 < words2.length; ++i3)
              obj[words2[i3]] = true;
            return obj;
          }
          var keywords2 = words("absolute and array asm begin case const constructor destructor div do downto else end file for function goto if implementation in inherited inline interface label mod nil not object of operator or packed procedure program record reintroduce repeat self set shl shr string then to type unit until uses var while with xor as class dispinterface except exports finalization finally initialization inline is library on out packed property raise resourcestring threadvar try absolute abstract alias assembler bitpacked break cdecl continue cppdecl cvar default deprecated dynamic enumerator experimental export external far far16 forward generic helper implements index interrupt iocheck local message name near nodefault noreturn nostackframe oldfpccall otherwise overload override pascal platform private protected public published read register reintroduce result safecall saveregisters softfloat specialize static stdcall stored strict unaligned unimplemented varargs virtual write");
          var atoms = { "null": true };
          var isOperatorChar = /[+\-*&%=<>!?|\/]/;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == "#" && state.startOfLine) {
              stream.skipToEnd();
              return "meta";
            }
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (ch == "(" && stream.eat("*")) {
              state.tokenize = tokenComment;
              return tokenComment(stream, state);
            }
            if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              return null;
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            }
            if (ch == "/") {
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur))
              return "keyword";
            if (atoms.propertyIsEnumerable(cur))
              return "atom";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !escaped)
                state.tokenize = null;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == ")" && maybeEnd) {
                state.tokenize = null;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          return {
            startState: function() {
              return { tokenize: null };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment" || style == "meta")
                return style;
              return style;
            },
            electricChars: "{}"
          };
        });
        CodeMirror5.defineMIME("text/x-pascal", "pascal");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/perl/perl.js
  var require_perl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/perl/perl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("perl", function() {
          var PERL = {
            "->": 4,
            "++": 4,
            "--": 4,
            "**": 4,
            "=~": 4,
            "!~": 4,
            "*": 4,
            "/": 4,
            "%": 4,
            "x": 4,
            "+": 4,
            "-": 4,
            ".": 4,
            "<<": 4,
            ">>": 4,
            "<": 4,
            ">": 4,
            "<=": 4,
            ">=": 4,
            "lt": 4,
            "gt": 4,
            "le": 4,
            "ge": 4,
            "==": 4,
            "!=": 4,
            "<=>": 4,
            "eq": 4,
            "ne": 4,
            "cmp": 4,
            "~~": 4,
            "&": 4,
            "|": 4,
            "^": 4,
            "&&": 4,
            "||": 4,
            "//": 4,
            "..": 4,
            "...": 4,
            "?": 4,
            ":": 4,
            "=": 4,
            "+=": 4,
            "-=": 4,
            "*=": 4,
            ",": 4,
            "=>": 4,
            "::": 4,
            "not": 4,
            "and": 4,
            "or": 4,
            "xor": 4,
            "BEGIN": [5, 1],
            "END": [5, 1],
            "PRINT": [5, 1],
            "PRINTF": [5, 1],
            "GETC": [5, 1],
            "READ": [5, 1],
            "READLINE": [5, 1],
            "DESTROY": [5, 1],
            "TIE": [5, 1],
            "TIEHANDLE": [5, 1],
            "UNTIE": [5, 1],
            "STDIN": 5,
            "STDIN_TOP": 5,
            "STDOUT": 5,
            "STDOUT_TOP": 5,
            "STDERR": 5,
            "STDERR_TOP": 5,
            "$ARG": 5,
            "$_": 5,
            "@ARG": 5,
            "@_": 5,
            "$LIST_SEPARATOR": 5,
            '$"': 5,
            "$PROCESS_ID": 5,
            "$PID": 5,
            "$$": 5,
            "$REAL_GROUP_ID": 5,
            "$GID": 5,
            "$(": 5,
            "$EFFECTIVE_GROUP_ID": 5,
            "$EGID": 5,
            "$)": 5,
            "$PROGRAM_NAME": 5,
            "$0": 5,
            "$SUBSCRIPT_SEPARATOR": 5,
            "$SUBSEP": 5,
            "$;": 5,
            "$REAL_USER_ID": 5,
            "$UID": 5,
            "$<": 5,
            "$EFFECTIVE_USER_ID": 5,
            "$EUID": 5,
            "$>": 5,
            "$a": 5,
            "$b": 5,
            "$COMPILING": 5,
            "$^C": 5,
            "$DEBUGGING": 5,
            "$^D": 5,
            "${^ENCODING}": 5,
            "$ENV": 5,
            "%ENV": 5,
            "$SYSTEM_FD_MAX": 5,
            "$^F": 5,
            "@F": 5,
            "${^GLOBAL_PHASE}": 5,
            "$^H": 5,
            "%^H": 5,
            "@INC": 5,
            "%INC": 5,
            "$INPLACE_EDIT": 5,
            "$^I": 5,
            "$^M": 5,
            "$OSNAME": 5,
            "$^O": 5,
            "${^OPEN}": 5,
            "$PERLDB": 5,
            "$^P": 5,
            "$SIG": 5,
            "%SIG": 5,
            "$BASETIME": 5,
            "$^T": 5,
            "${^TAINT}": 5,
            "${^UNICODE}": 5,
            "${^UTF8CACHE}": 5,
            "${^UTF8LOCALE}": 5,
            "$PERL_VERSION": 5,
            "$^V": 5,
            "${^WIN32_SLOPPY_STAT}": 5,
            "$EXECUTABLE_NAME": 5,
            "$^X": 5,
            "$1": 5,
            "$MATCH": 5,
            "$&": 5,
            "${^MATCH}": 5,
            "$PREMATCH": 5,
            "$`": 5,
            "${^PREMATCH}": 5,
            "$POSTMATCH": 5,
            "$'": 5,
            "${^POSTMATCH}": 5,
            "$LAST_PAREN_MATCH": 5,
            "$+": 5,
            "$LAST_SUBMATCH_RESULT": 5,
            "$^N": 5,
            "@LAST_MATCH_END": 5,
            "@+": 5,
            "%LAST_PAREN_MATCH": 5,
            "%+": 5,
            "@LAST_MATCH_START": 5,
            "@-": 5,
            "%LAST_MATCH_START": 5,
            "%-": 5,
            "$LAST_REGEXP_CODE_RESULT": 5,
            "$^R": 5,
            "${^RE_DEBUG_FLAGS}": 5,
            "${^RE_TRIE_MAXBUF}": 5,
            "$ARGV": 5,
            "@ARGV": 5,
            "ARGV": 5,
            "ARGVOUT": 5,
            "$OUTPUT_FIELD_SEPARATOR": 5,
            "$OFS": 5,
            "$,": 5,
            "$INPUT_LINE_NUMBER": 5,
            "$NR": 5,
            "$.": 5,
            "$INPUT_RECORD_SEPARATOR": 5,
            "$RS": 5,
            "$/": 5,
            "$OUTPUT_RECORD_SEPARATOR": 5,
            "$ORS": 5,
            "$\\": 5,
            "$OUTPUT_AUTOFLUSH": 5,
            "$|": 5,
            "$ACCUMULATOR": 5,
            "$^A": 5,
            "$FORMAT_FORMFEED": 5,
            "$^L": 5,
            "$FORMAT_PAGE_NUMBER": 5,
            "$%": 5,
            "$FORMAT_LINES_LEFT": 5,
            "$-": 5,
            "$FORMAT_LINE_BREAK_CHARACTERS": 5,
            "$:": 5,
            "$FORMAT_LINES_PER_PAGE": 5,
            "$=": 5,
            "$FORMAT_TOP_NAME": 5,
            "$^": 5,
            "$FORMAT_NAME": 5,
            "$~": 5,
            "${^CHILD_ERROR_NATIVE}": 5,
            "$EXTENDED_OS_ERROR": 5,
            "$^E": 5,
            "$EXCEPTIONS_BEING_CAUGHT": 5,
            "$^S": 5,
            "$WARNING": 5,
            "$^W": 5,
            "${^WARNING_BITS}": 5,
            "$OS_ERROR": 5,
            "$ERRNO": 5,
            "$!": 5,
            "%OS_ERROR": 5,
            "%ERRNO": 5,
            "%!": 5,
            "$CHILD_ERROR": 5,
            "$?": 5,
            "$EVAL_ERROR": 5,
            "$@": 5,
            "$OFMT": 5,
            "$#": 5,
            "$*": 5,
            "$ARRAY_BASE": 5,
            "$[": 5,
            "$OLD_PERL_VERSION": 5,
            "$]": 5,
            "if": [1, 1],
            elsif: [1, 1],
            "else": [1, 1],
            "while": [1, 1],
            unless: [1, 1],
            "for": [1, 1],
            foreach: [1, 1],
            "abs": 1,
            accept: 1,
            alarm: 1,
            "atan2": 1,
            bind: 1,
            binmode: 1,
            bless: 1,
            bootstrap: 1,
            "break": 1,
            caller: 1,
            chdir: 1,
            chmod: 1,
            chomp: 1,
            chop: 1,
            chown: 1,
            chr: 1,
            chroot: 1,
            close: 1,
            closedir: 1,
            connect: 1,
            "continue": [1, 1],
            "cos": 1,
            crypt: 1,
            dbmclose: 1,
            dbmopen: 1,
            "default": 1,
            defined: 1,
            "delete": 1,
            die: 1,
            "do": 1,
            dump: 1,
            each: 1,
            endgrent: 1,
            endhostent: 1,
            endnetent: 1,
            endprotoent: 1,
            endpwent: 1,
            endservent: 1,
            eof: 1,
            "eval": 1,
            "exec": 1,
            exists: 1,
            exit: 1,
            "exp": 1,
            fcntl: 1,
            fileno: 1,
            flock: 1,
            fork: 1,
            format: 1,
            formline: 1,
            getc: 1,
            getgrent: 1,
            getgrgid: 1,
            getgrnam: 1,
            gethostbyaddr: 1,
            gethostbyname: 1,
            gethostent: 1,
            getlogin: 1,
            getnetbyaddr: 1,
            getnetbyname: 1,
            getnetent: 1,
            getpeername: 1,
            getpgrp: 1,
            getppid: 1,
            getpriority: 1,
            getprotobyname: 1,
            getprotobynumber: 1,
            getprotoent: 1,
            getpwent: 1,
            getpwnam: 1,
            getpwuid: 1,
            getservbyname: 1,
            getservbyport: 1,
            getservent: 1,
            getsockname: 1,
            getsockopt: 1,
            given: 1,
            glob: 1,
            gmtime: 1,
            "goto": 1,
            grep: 1,
            hex: 1,
            "import": 1,
            index: 1,
            "int": 1,
            ioctl: 1,
            "join": 1,
            keys: 1,
            kill: 1,
            last: 1,
            lc: 1,
            lcfirst: 1,
            length: 1,
            "link": 1,
            listen: 1,
            local: 2,
            localtime: 1,
            lock: 1,
            "log": 1,
            lstat: 1,
            m: null,
            map: 1,
            mkdir: 1,
            msgctl: 1,
            msgget: 1,
            msgrcv: 1,
            msgsnd: 1,
            my: 2,
            "new": 1,
            next: 1,
            no: 1,
            oct: 1,
            open: 1,
            opendir: 1,
            ord: 1,
            our: 2,
            pack: 1,
            "package": 1,
            pipe: 1,
            pop: 1,
            pos: 1,
            print: 1,
            printf: 1,
            prototype: 1,
            push: 1,
            q: null,
            qq: null,
            qr: null,
            quotemeta: null,
            qw: null,
            qx: null,
            rand: 1,
            read: 1,
            readdir: 1,
            readline: 1,
            readlink: 1,
            readpipe: 1,
            recv: 1,
            redo: 1,
            ref: 1,
            rename: 1,
            require: 1,
            reset: 1,
            "return": 1,
            reverse: 1,
            rewinddir: 1,
            rindex: 1,
            rmdir: 1,
            s: null,
            say: 1,
            scalar: 1,
            seek: 1,
            seekdir: 1,
            select: 1,
            semctl: 1,
            semget: 1,
            semop: 1,
            send: 1,
            setgrent: 1,
            sethostent: 1,
            setnetent: 1,
            setpgrp: 1,
            setpriority: 1,
            setprotoent: 1,
            setpwent: 1,
            setservent: 1,
            setsockopt: 1,
            shift: 1,
            shmctl: 1,
            shmget: 1,
            shmread: 1,
            shmwrite: 1,
            shutdown: 1,
            "sin": 1,
            sleep: 1,
            socket: 1,
            socketpair: 1,
            "sort": 1,
            splice: 1,
            "split": 1,
            sprintf: 1,
            "sqrt": 1,
            srand: 1,
            stat: 1,
            state: 1,
            study: 1,
            "sub": 1,
            "substr": 1,
            symlink: 1,
            syscall: 1,
            sysopen: 1,
            sysread: 1,
            sysseek: 1,
            system: 1,
            syswrite: 1,
            tell: 1,
            telldir: 1,
            tie: 1,
            tied: 1,
            time: 1,
            times: 1,
            tr: null,
            truncate: 1,
            uc: 1,
            ucfirst: 1,
            umask: 1,
            undef: 1,
            unlink: 1,
            unpack: 1,
            unshift: 1,
            untie: 1,
            use: 1,
            utime: 1,
            values: 1,
            vec: 1,
            wait: 1,
            waitpid: 1,
            wantarray: 1,
            warn: 1,
            when: 1,
            write: 1,
            y: null
          };
          var RXstyle = "string-2";
          var RXmodifiers = /[goseximacplud]/;
          function tokenChain(stream, state, chain2, style, tail) {
            state.chain = null;
            state.style = null;
            state.tail = null;
            state.tokenize = function(stream2, state2) {
              var e5 = false, c3, i3 = 0;
              while (c3 = stream2.next()) {
                if (c3 === chain2[i3] && !e5) {
                  if (chain2[++i3] !== void 0) {
                    state2.chain = chain2[i3];
                    state2.style = style;
                    state2.tail = tail;
                  } else if (tail)
                    stream2.eatWhile(tail);
                  state2.tokenize = tokenPerl;
                  return style;
                }
                e5 = !e5 && c3 == "\\";
              }
              return style;
            };
            return state.tokenize(stream, state);
          }
          function tokenSOMETHING(stream, state, string2) {
            state.tokenize = function(stream2, state2) {
              if (stream2.string == string2)
                state2.tokenize = tokenPerl;
              stream2.skipToEnd();
              return "string";
            };
            return state.tokenize(stream, state);
          }
          function tokenPerl(stream, state) {
            if (stream.eatSpace())
              return null;
            if (state.chain)
              return tokenChain(stream, state, state.chain, state.style, state.tail);
            if (stream.match(/^\-?[\d\.]/, false)) {
              if (stream.match(/^(\-?(\d*\.\d+(e[+-]?\d+)?|\d+\.\d*)|0x[\da-fA-F]+|0b[01]+|\d+(e[+-]?\d+)?)/))
                return "number";
            }
            if (stream.match(/^<<(?=\w)/)) {
              stream.eatWhile(/\w/);
              return tokenSOMETHING(stream, state, stream.current().substr(2));
            }
            if (stream.sol() && stream.match(/^\=item(?!\w)/)) {
              return tokenSOMETHING(stream, state, "=cut");
            }
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              if (prefix(stream, 3) == "<<" + ch) {
                var p3 = stream.pos;
                stream.eatWhile(/\w/);
                var n3 = stream.current().substr(1);
                if (n3 && stream.eat(ch))
                  return tokenSOMETHING(stream, state, n3);
                stream.pos = p3;
              }
              return tokenChain(stream, state, [ch], "string");
            }
            if (ch == "q") {
              var c3 = look(stream, -2);
              if (!(c3 && /\w/.test(c3))) {
                c3 = look(stream, 0);
                if (c3 == "x") {
                  c3 = look(stream, 1);
                  if (c3 == "(") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [")"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "[") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["]"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "{") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["}"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "<") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [">"], RXstyle, RXmodifiers);
                  }
                  if (/[\^'"!~\/]/.test(c3)) {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, [stream.eat(c3)], RXstyle, RXmodifiers);
                  }
                } else if (c3 == "q") {
                  c3 = look(stream, 1);
                  if (c3 == "(") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [")"], "string");
                  }
                  if (c3 == "[") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["]"], "string");
                  }
                  if (c3 == "{") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["}"], "string");
                  }
                  if (c3 == "<") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [">"], "string");
                  }
                  if (/[\^'"!~\/]/.test(c3)) {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, [stream.eat(c3)], "string");
                  }
                } else if (c3 == "w") {
                  c3 = look(stream, 1);
                  if (c3 == "(") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [")"], "bracket");
                  }
                  if (c3 == "[") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["]"], "bracket");
                  }
                  if (c3 == "{") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["}"], "bracket");
                  }
                  if (c3 == "<") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [">"], "bracket");
                  }
                  if (/[\^'"!~\/]/.test(c3)) {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, [stream.eat(c3)], "bracket");
                  }
                } else if (c3 == "r") {
                  c3 = look(stream, 1);
                  if (c3 == "(") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [")"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "[") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["]"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "{") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, ["}"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "<") {
                    eatSuffix(stream, 2);
                    return tokenChain(stream, state, [">"], RXstyle, RXmodifiers);
                  }
                  if (/[\^'"!~\/]/.test(c3)) {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, [stream.eat(c3)], RXstyle, RXmodifiers);
                  }
                } else if (/[\^'"!~\/(\[{<]/.test(c3)) {
                  if (c3 == "(") {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, [")"], "string");
                  }
                  if (c3 == "[") {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, ["]"], "string");
                  }
                  if (c3 == "{") {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, ["}"], "string");
                  }
                  if (c3 == "<") {
                    eatSuffix(stream, 1);
                    return tokenChain(stream, state, [">"], "string");
                  }
                  if (/[\^'"!~\/]/.test(c3)) {
                    return tokenChain(stream, state, [stream.eat(c3)], "string");
                  }
                }
              }
            }
            if (ch == "m") {
              var c3 = look(stream, -2);
              if (!(c3 && /\w/.test(c3))) {
                c3 = stream.eat(/[(\[{<\^'"!~\/]/);
                if (c3) {
                  if (/[\^'"!~\/]/.test(c3)) {
                    return tokenChain(stream, state, [c3], RXstyle, RXmodifiers);
                  }
                  if (c3 == "(") {
                    return tokenChain(stream, state, [")"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "[") {
                    return tokenChain(stream, state, ["]"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "{") {
                    return tokenChain(stream, state, ["}"], RXstyle, RXmodifiers);
                  }
                  if (c3 == "<") {
                    return tokenChain(stream, state, [">"], RXstyle, RXmodifiers);
                  }
                }
              }
            }
            if (ch == "s") {
              var c3 = /[\/>\]})\w]/.test(look(stream, -2));
              if (!c3) {
                c3 = stream.eat(/[(\[{<\^'"!~\/]/);
                if (c3) {
                  if (c3 == "[")
                    return tokenChain(stream, state, ["]", "]"], RXstyle, RXmodifiers);
                  if (c3 == "{")
                    return tokenChain(stream, state, ["}", "}"], RXstyle, RXmodifiers);
                  if (c3 == "<")
                    return tokenChain(stream, state, [">", ">"], RXstyle, RXmodifiers);
                  if (c3 == "(")
                    return tokenChain(stream, state, [")", ")"], RXstyle, RXmodifiers);
                  return tokenChain(stream, state, [c3, c3], RXstyle, RXmodifiers);
                }
              }
            }
            if (ch == "y") {
              var c3 = /[\/>\]})\w]/.test(look(stream, -2));
              if (!c3) {
                c3 = stream.eat(/[(\[{<\^'"!~\/]/);
                if (c3) {
                  if (c3 == "[")
                    return tokenChain(stream, state, ["]", "]"], RXstyle, RXmodifiers);
                  if (c3 == "{")
                    return tokenChain(stream, state, ["}", "}"], RXstyle, RXmodifiers);
                  if (c3 == "<")
                    return tokenChain(stream, state, [">", ">"], RXstyle, RXmodifiers);
                  if (c3 == "(")
                    return tokenChain(stream, state, [")", ")"], RXstyle, RXmodifiers);
                  return tokenChain(stream, state, [c3, c3], RXstyle, RXmodifiers);
                }
              }
            }
            if (ch == "t") {
              var c3 = /[\/>\]})\w]/.test(look(stream, -2));
              if (!c3) {
                c3 = stream.eat("r");
                if (c3) {
                  c3 = stream.eat(/[(\[{<\^'"!~\/]/);
                  if (c3) {
                    if (c3 == "[")
                      return tokenChain(stream, state, ["]", "]"], RXstyle, RXmodifiers);
                    if (c3 == "{")
                      return tokenChain(stream, state, ["}", "}"], RXstyle, RXmodifiers);
                    if (c3 == "<")
                      return tokenChain(stream, state, [">", ">"], RXstyle, RXmodifiers);
                    if (c3 == "(")
                      return tokenChain(stream, state, [")", ")"], RXstyle, RXmodifiers);
                    return tokenChain(stream, state, [c3, c3], RXstyle, RXmodifiers);
                  }
                }
              }
            }
            if (ch == "`") {
              return tokenChain(stream, state, [ch], "variable-2");
            }
            if (ch == "/") {
              if (!/~\s*$/.test(prefix(stream)))
                return "operator";
              else
                return tokenChain(stream, state, [ch], RXstyle, RXmodifiers);
            }
            if (ch == "$") {
              var p3 = stream.pos;
              if (stream.eatWhile(/\d/) || stream.eat("{") && stream.eatWhile(/\d/) && stream.eat("}"))
                return "variable-2";
              else
                stream.pos = p3;
            }
            if (/[$@%]/.test(ch)) {
              var p3 = stream.pos;
              if (stream.eat("^") && stream.eat(/[A-Z]/) || !/[@$%&]/.test(look(stream, -2)) && stream.eat(/[=|\\\-#?@;:&`~\^!\[\]*'"$+.,\/<>()]/)) {
                var c3 = stream.current();
                if (PERL[c3])
                  return "variable-2";
              }
              stream.pos = p3;
            }
            if (/[$@%&]/.test(ch)) {
              if (stream.eatWhile(/[\w$\[\]]/) || stream.eat("{") && stream.eatWhile(/[\w$\[\]]/) && stream.eat("}")) {
                var c3 = stream.current();
                if (PERL[c3])
                  return "variable-2";
                else
                  return "variable";
              }
            }
            if (ch == "#") {
              if (look(stream, -2) != "$") {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (/[:+\-\^*$&%@=<>!?|\/~\.]/.test(ch)) {
              var p3 = stream.pos;
              stream.eatWhile(/[:+\-\^*$&%@=<>!?|\/~\.]/);
              if (PERL[stream.current()])
                return "operator";
              else
                stream.pos = p3;
            }
            if (ch == "_") {
              if (stream.pos == 1) {
                if (suffix(stream, 6) == "_END__") {
                  return tokenChain(stream, state, ["\0"], "comment");
                } else if (suffix(stream, 7) == "_DATA__") {
                  return tokenChain(stream, state, ["\0"], "variable-2");
                } else if (suffix(stream, 7) == "_C__") {
                  return tokenChain(stream, state, ["\0"], "string");
                }
              }
            }
            if (/\w/.test(ch)) {
              var p3 = stream.pos;
              if (look(stream, -2) == "{" && (look(stream, 0) == "}" || stream.eatWhile(/\w/) && look(stream, 0) == "}"))
                return "string";
              else
                stream.pos = p3;
            }
            if (/[A-Z]/.test(ch)) {
              var l3 = look(stream, -2);
              var p3 = stream.pos;
              stream.eatWhile(/[A-Z_]/);
              if (/[\da-z]/.test(look(stream, 0))) {
                stream.pos = p3;
              } else {
                var c3 = PERL[stream.current()];
                if (!c3)
                  return "meta";
                if (c3[1])
                  c3 = c3[0];
                if (l3 != ":") {
                  if (c3 == 1)
                    return "keyword";
                  else if (c3 == 2)
                    return "def";
                  else if (c3 == 3)
                    return "atom";
                  else if (c3 == 4)
                    return "operator";
                  else if (c3 == 5)
                    return "variable-2";
                  else
                    return "meta";
                } else
                  return "meta";
              }
            }
            if (/[a-zA-Z_]/.test(ch)) {
              var l3 = look(stream, -2);
              stream.eatWhile(/\w/);
              var c3 = PERL[stream.current()];
              if (!c3)
                return "meta";
              if (c3[1])
                c3 = c3[0];
              if (l3 != ":") {
                if (c3 == 1)
                  return "keyword";
                else if (c3 == 2)
                  return "def";
                else if (c3 == 3)
                  return "atom";
                else if (c3 == 4)
                  return "operator";
                else if (c3 == 5)
                  return "variable-2";
                else
                  return "meta";
              } else
                return "meta";
            }
            return null;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenPerl,
                chain: null,
                style: null,
                tail: null
              };
            },
            token: function(stream, state) {
              return (state.tokenize || tokenPerl)(stream, state);
            },
            lineComment: "#"
          };
        });
        CodeMirror5.registerHelper("wordChars", "perl", /[\w$]/);
        CodeMirror5.defineMIME("text/x-perl", "perl");
        function look(stream, c3) {
          return stream.string.charAt(stream.pos + (c3 || 0));
        }
        function prefix(stream, c3) {
          if (c3) {
            var x3 = stream.pos - c3;
            return stream.string.substr(x3 >= 0 ? x3 : 0, c3);
          } else {
            return stream.string.substr(0, stream.pos - 1);
          }
        }
        function suffix(stream, c3) {
          var y2 = stream.string.length;
          var x3 = y2 - stream.pos + 1;
          return stream.string.substr(stream.pos, c3 && c3 < y2 ? c3 : x3);
        }
        function eatSuffix(stream, c3) {
          var x3 = stream.pos + c3;
          var y2;
          if (x3 <= 0)
            stream.pos = 0;
          else if (x3 >= (y2 = stream.string.length - 1))
            stream.pos = y2;
          else
            stream.pos = x3;
        }
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/php/php.js
  var require_php = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/php/php.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_htmlmixed(), require_clike());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../htmlmixed/htmlmixed", "../clike/clike"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function keywords2(str) {
          var obj = {}, words = str.split(" ");
          for (var i3 = 0; i3 < words.length; ++i3)
            obj[words[i3]] = true;
          return obj;
        }
        function matchSequence(list, end, escapes) {
          if (list.length == 0)
            return phpString(end);
          return function(stream, state) {
            var patterns = list[0];
            for (var i3 = 0; i3 < patterns.length; i3++)
              if (stream.match(patterns[i3][0])) {
                state.tokenize = matchSequence(list.slice(1), end);
                return patterns[i3][1];
              }
            state.tokenize = phpString(end, escapes);
            return "string";
          };
        }
        function phpString(closing, escapes) {
          return function(stream, state) {
            return phpString_(stream, state, closing, escapes);
          };
        }
        function phpString_(stream, state, closing, escapes) {
          if (escapes !== false && stream.match("${", false) || stream.match("{$", false)) {
            state.tokenize = null;
            return "string";
          }
          if (escapes !== false && stream.match(/^\$[a-zA-Z_][a-zA-Z0-9_]*/)) {
            if (stream.match("[", false)) {
              state.tokenize = matchSequence([
                [["[", null]],
                [
                  [/\d[\w\.]*/, "number"],
                  [/\$[a-zA-Z_][a-zA-Z0-9_]*/, "variable-2"],
                  [/[\w\$]+/, "variable"]
                ],
                [["]", null]]
              ], closing, escapes);
            }
            if (stream.match(/\-\>\w/, false)) {
              state.tokenize = matchSequence([
                [["->", null]],
                [[/[\w]+/, "variable"]]
              ], closing, escapes);
            }
            return "variable-2";
          }
          var escaped = false;
          while (!stream.eol() && (escaped || escapes === false || !stream.match("{$", false) && !stream.match(/^(\$[a-zA-Z_][a-zA-Z0-9_]*|\$\{)/, false))) {
            if (!escaped && stream.match(closing)) {
              state.tokenize = null;
              state.tokStack.pop();
              state.tokStack.pop();
              break;
            }
            escaped = stream.next() == "\\" && !escaped;
          }
          return "string";
        }
        var phpKeywords = "abstract and array as break case catch class clone const continue declare default do else elseif enddeclare endfor endforeach endif endswitch endwhile extends final for foreach function global goto if implements interface instanceof namespace new or private protected public static switch throw trait try use var while xor die echo empty exit eval include include_once isset list require require_once return print unset __halt_compiler self static parent yield insteadof finally";
        var phpAtoms = "true false null TRUE FALSE NULL __CLASS__ __DIR__ __FILE__ __LINE__ __METHOD__ __FUNCTION__ __NAMESPACE__ __TRAIT__";
        var phpBuiltin = "func_num_args func_get_arg func_get_args strlen strcmp strncmp strcasecmp strncasecmp each error_reporting define defined trigger_error user_error set_error_handler restore_error_handler get_declared_classes get_loaded_extensions extension_loaded get_extension_funcs debug_backtrace constant bin2hex hex2bin sleep usleep time mktime gmmktime strftime gmstrftime strtotime date gmdate getdate localtime checkdate flush wordwrap htmlspecialchars htmlentities html_entity_decode md5 md5_file crc32 getimagesize image_type_to_mime_type phpinfo phpversion phpcredits strnatcmp strnatcasecmp substr_count strspn strcspn strtok strtoupper strtolower strpos strrpos strrev hebrev hebrevc nl2br basename dirname pathinfo stripslashes stripcslashes strstr stristr strrchr str_shuffle str_word_count strcoll substr substr_replace quotemeta ucfirst ucwords strtr addslashes addcslashes rtrim str_replace str_repeat count_chars chunk_split trim ltrim strip_tags similar_text explode implode setlocale localeconv parse_str str_pad chop strchr sprintf printf vprintf vsprintf sscanf fscanf parse_url urlencode urldecode rawurlencode rawurldecode readlink linkinfo link unlink exec system escapeshellcmd escapeshellarg passthru shell_exec proc_open proc_close rand srand getrandmax mt_rand mt_srand mt_getrandmax base64_decode base64_encode abs ceil floor round is_finite is_nan is_infinite bindec hexdec octdec decbin decoct dechex base_convert number_format fmod ip2long long2ip getenv putenv getopt microtime gettimeofday getrusage uniqid quoted_printable_decode set_time_limit get_cfg_var magic_quotes_runtime set_magic_quotes_runtime get_magic_quotes_gpc get_magic_quotes_runtime import_request_variables error_log serialize unserialize memory_get_usage var_dump var_export debug_zval_dump print_r highlight_file show_source highlight_string ini_get ini_get_all ini_set ini_alter ini_restore get_include_path set_include_path restore_include_path setcookie header headers_sent connection_aborted connection_status ignore_user_abort parse_ini_file is_uploaded_file move_uploaded_file intval floatval doubleval strval gettype settype is_null is_resource is_bool is_long is_float is_int is_integer is_double is_real is_numeric is_string is_array is_object is_scalar ereg ereg_replace eregi eregi_replace split spliti join sql_regcase dl pclose popen readfile rewind rmdir umask fclose feof fgetc fgets fgetss fread fopen fpassthru ftruncate fstat fseek ftell fflush fwrite fputs mkdir rename copy tempnam tmpfile file file_get_contents file_put_contents stream_select stream_context_create stream_context_set_params stream_context_set_option stream_context_get_options stream_filter_prepend stream_filter_append fgetcsv flock get_meta_tags stream_set_write_buffer set_file_buffer set_socket_blocking stream_set_blocking socket_set_blocking stream_get_meta_data stream_register_wrapper stream_wrapper_register stream_set_timeout socket_set_timeout socket_get_status realpath fnmatch fsockopen pfsockopen pack unpack get_browser crypt opendir closedir chdir getcwd rewinddir readdir dir glob fileatime filectime filegroup fileinode filemtime fileowner fileperms filesize filetype file_exists is_writable is_writeable is_readable is_executable is_file is_dir is_link stat lstat chown touch clearstatcache mail ob_start ob_flush ob_clean ob_end_flush ob_end_clean ob_get_flush ob_get_clean ob_get_length ob_get_level ob_get_status ob_get_contents ob_implicit_flush ob_list_handlers ksort krsort natsort natcasesort asort arsort sort rsort usort uasort uksort shuffle array_walk count end prev next reset current key min max in_array array_search extract compact array_fill range array_multisort array_push array_pop array_shift array_unshift array_splice array_slice array_merge array_merge_recursive array_keys array_values array_count_values array_reverse array_reduce array_pad array_flip array_change_key_case array_rand array_unique array_intersect array_intersect_assoc array_diff array_diff_assoc array_sum array_filter array_map array_chunk array_key_exists array_intersect_key array_combine array_column pos sizeof key_exists assert assert_options version_compare ftok str_rot13 aggregate session_name session_module_name session_save_path session_id session_regenerate_id session_decode session_register session_unregister session_is_registered session_encode session_start session_destroy session_unset session_set_save_handler session_cache_limiter session_cache_expire session_set_cookie_params session_get_cookie_params session_write_close preg_match preg_match_all preg_replace preg_replace_callback preg_split preg_quote preg_grep overload ctype_alnum ctype_alpha ctype_cntrl ctype_digit ctype_lower ctype_graph ctype_print ctype_punct ctype_space ctype_upper ctype_xdigit virtual apache_request_headers apache_note apache_lookup_uri apache_child_terminate apache_setenv apache_response_headers apache_get_version getallheaders mysql_connect mysql_pconnect mysql_close mysql_select_db mysql_create_db mysql_drop_db mysql_query mysql_unbuffered_query mysql_db_query mysql_list_dbs mysql_list_tables mysql_list_fields mysql_list_processes mysql_error mysql_errno mysql_affected_rows mysql_insert_id mysql_result mysql_num_rows mysql_num_fields mysql_fetch_row mysql_fetch_array mysql_fetch_assoc mysql_fetch_object mysql_data_seek mysql_fetch_lengths mysql_fetch_field mysql_field_seek mysql_free_result mysql_field_name mysql_field_table mysql_field_len mysql_field_type mysql_field_flags mysql_escape_string mysql_real_escape_string mysql_stat mysql_thread_id mysql_client_encoding mysql_get_client_info mysql_get_host_info mysql_get_proto_info mysql_get_server_info mysql_info mysql mysql_fieldname mysql_fieldtable mysql_fieldlen mysql_fieldtype mysql_fieldflags mysql_selectdb mysql_createdb mysql_dropdb mysql_freeresult mysql_numfields mysql_numrows mysql_listdbs mysql_listtables mysql_listfields mysql_db_name mysql_dbname mysql_tablename mysql_table_name pg_connect pg_pconnect pg_close pg_connection_status pg_connection_busy pg_connection_reset pg_host pg_dbname pg_port pg_tty pg_options pg_ping pg_query pg_send_query pg_cancel_query pg_fetch_result pg_fetch_row pg_fetch_assoc pg_fetch_array pg_fetch_object pg_fetch_all pg_affected_rows pg_get_result pg_result_seek pg_result_status pg_free_result pg_last_oid pg_num_rows pg_num_fields pg_field_name pg_field_num pg_field_size pg_field_type pg_field_prtlen pg_field_is_null pg_get_notify pg_get_pid pg_result_error pg_last_error pg_last_notice pg_put_line pg_end_copy pg_copy_to pg_copy_from pg_trace pg_untrace pg_lo_create pg_lo_unlink pg_lo_open pg_lo_close pg_lo_read pg_lo_write pg_lo_read_all pg_lo_import pg_lo_export pg_lo_seek pg_lo_tell pg_escape_string pg_escape_bytea pg_unescape_bytea pg_client_encoding pg_set_client_encoding pg_meta_data pg_convert pg_insert pg_update pg_delete pg_select pg_exec pg_getlastoid pg_cmdtuples pg_errormessage pg_numrows pg_numfields pg_fieldname pg_fieldsize pg_fieldtype pg_fieldnum pg_fieldprtlen pg_fieldisnull pg_freeresult pg_result pg_loreadall pg_locreate pg_lounlink pg_loopen pg_loclose pg_loread pg_lowrite pg_loimport pg_loexport http_response_code get_declared_traits getimagesizefromstring socket_import_stream stream_set_chunk_size trait_exists header_register_callback class_uses session_status session_register_shutdown echo print global static exit array empty eval isset unset die include require include_once require_once json_decode json_encode json_last_error json_last_error_msg curl_close curl_copy_handle curl_errno curl_error curl_escape curl_exec curl_file_create curl_getinfo curl_init curl_multi_add_handle curl_multi_close curl_multi_exec curl_multi_getcontent curl_multi_info_read curl_multi_init curl_multi_remove_handle curl_multi_select curl_multi_setopt curl_multi_strerror curl_pause curl_reset curl_setopt_array curl_setopt curl_share_close curl_share_init curl_share_setopt curl_strerror curl_unescape curl_version mysqli_affected_rows mysqli_autocommit mysqli_change_user mysqli_character_set_name mysqli_close mysqli_commit mysqli_connect_errno mysqli_connect_error mysqli_connect mysqli_data_seek mysqli_debug mysqli_dump_debug_info mysqli_errno mysqli_error_list mysqli_error mysqli_fetch_all mysqli_fetch_array mysqli_fetch_assoc mysqli_fetch_field_direct mysqli_fetch_field mysqli_fetch_fields mysqli_fetch_lengths mysqli_fetch_object mysqli_fetch_row mysqli_field_count mysqli_field_seek mysqli_field_tell mysqli_free_result mysqli_get_charset mysqli_get_client_info mysqli_get_client_stats mysqli_get_client_version mysqli_get_connection_stats mysqli_get_host_info mysqli_get_proto_info mysqli_get_server_info mysqli_get_server_version mysqli_info mysqli_init mysqli_insert_id mysqli_kill mysqli_more_results mysqli_multi_query mysqli_next_result mysqli_num_fields mysqli_num_rows mysqli_options mysqli_ping mysqli_prepare mysqli_query mysqli_real_connect mysqli_real_escape_string mysqli_real_query mysqli_reap_async_query mysqli_refresh mysqli_rollback mysqli_select_db mysqli_set_charset mysqli_set_local_infile_default mysqli_set_local_infile_handler mysqli_sqlstate mysqli_ssl_set mysqli_stat mysqli_stmt_init mysqli_store_result mysqli_thread_id mysqli_thread_safe mysqli_use_result mysqli_warning_count";
        CodeMirror5.registerHelper("hintWords", "php", [phpKeywords, phpAtoms, phpBuiltin].join(" ").split(" "));
        CodeMirror5.registerHelper("wordChars", "php", /[\w$]/);
        var phpConfig = {
          name: "clike",
          helperType: "php",
          keywords: keywords2(phpKeywords),
          blockKeywords: keywords2("catch do else elseif for foreach if switch try while finally"),
          defKeywords: keywords2("class function interface namespace trait"),
          atoms: keywords2(phpAtoms),
          builtin: keywords2(phpBuiltin),
          multiLineStrings: true,
          hooks: {
            "$": function(stream) {
              stream.eatWhile(/[\w\$_]/);
              return "variable-2";
            },
            "<": function(stream, state) {
              var before;
              if (before = stream.match(/<<\s*/)) {
                var quoted = stream.eat(/['"]/);
                stream.eatWhile(/[\w\.]/);
                var delim = stream.current().slice(before[0].length + (quoted ? 2 : 1));
                if (quoted)
                  stream.eat(quoted);
                if (delim) {
                  (state.tokStack || (state.tokStack = [])).push(delim, 0);
                  state.tokenize = phpString(delim, quoted != "'");
                  return "string";
                }
              }
              return false;
            },
            "#": function(stream) {
              while (!stream.eol() && !stream.match("?>", false))
                stream.next();
              return "comment";
            },
            "/": function(stream) {
              if (stream.eat("/")) {
                while (!stream.eol() && !stream.match("?>", false))
                  stream.next();
                return "comment";
              }
              return false;
            },
            '"': function(_stream, state) {
              (state.tokStack || (state.tokStack = [])).push('"', 0);
              state.tokenize = phpString('"');
              return "string";
            },
            "{": function(_stream, state) {
              if (state.tokStack && state.tokStack.length)
                state.tokStack[state.tokStack.length - 1]++;
              return false;
            },
            "}": function(_stream, state) {
              if (state.tokStack && state.tokStack.length > 0 && !--state.tokStack[state.tokStack.length - 1]) {
                state.tokenize = phpString(state.tokStack[state.tokStack.length - 2]);
              }
              return false;
            }
          }
        };
        CodeMirror5.defineMode("php", function(config3, parserConfig) {
          var htmlMode = CodeMirror5.getMode(config3, parserConfig && parserConfig.htmlMode || "text/html");
          var phpMode = CodeMirror5.getMode(config3, phpConfig);
          function dispatch(stream, state) {
            var isPHP = state.curMode == phpMode;
            if (stream.sol() && state.pending && state.pending != '"' && state.pending != "'")
              state.pending = null;
            if (!isPHP) {
              if (stream.match(/^<\?\w*/)) {
                state.curMode = phpMode;
                if (!state.php)
                  state.php = CodeMirror5.startState(phpMode, htmlMode.indent(state.html, "", ""));
                state.curState = state.php;
                return "meta";
              }
              if (state.pending == '"' || state.pending == "'") {
                while (!stream.eol() && stream.next() != state.pending) {
                }
                var style = "string";
              } else if (state.pending && stream.pos < state.pending.end) {
                stream.pos = state.pending.end;
                var style = state.pending.style;
              } else {
                var style = htmlMode.token(stream, state.curState);
              }
              if (state.pending)
                state.pending = null;
              var cur = stream.current(), openPHP = cur.search(/<\?/), m3;
              if (openPHP != -1) {
                if (style == "string" && (m3 = cur.match(/[\'\"]$/)) && !/\?>/.test(cur))
                  state.pending = m3[0];
                else
                  state.pending = { end: stream.pos, style };
                stream.backUp(cur.length - openPHP);
              }
              return style;
            } else if (isPHP && state.php.tokenize == null && stream.match("?>")) {
              state.curMode = htmlMode;
              state.curState = state.html;
              if (!state.php.context.prev)
                state.php = null;
              return "meta";
            } else {
              return phpMode.token(stream, state.curState);
            }
          }
          return {
            startState: function() {
              var html = CodeMirror5.startState(htmlMode);
              var php = parserConfig.startOpen ? CodeMirror5.startState(phpMode) : null;
              return {
                html,
                php,
                curMode: parserConfig.startOpen ? phpMode : htmlMode,
                curState: parserConfig.startOpen ? php : html,
                pending: null
              };
            },
            copyState: function(state) {
              var html = state.html, htmlNew = CodeMirror5.copyState(htmlMode, html), php = state.php, phpNew = php && CodeMirror5.copyState(phpMode, php), cur;
              if (state.curMode == htmlMode)
                cur = htmlNew;
              else
                cur = phpNew;
              return {
                html: htmlNew,
                php: phpNew,
                curMode: state.curMode,
                curState: cur,
                pending: state.pending
              };
            },
            token: dispatch,
            indent: function(state, textAfter, line) {
              if (state.curMode != phpMode && /^\s*<\//.test(textAfter) || state.curMode == phpMode && /^\?>/.test(textAfter))
                return htmlMode.indent(state.html, textAfter, line);
              return state.curMode.indent(state.curState, textAfter, line);
            },
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//",
            innerMode: function(state) {
              return { state: state.curState, mode: state.curMode };
            }
          };
        }, "htmlmixed", "clike");
        CodeMirror5.defineMIME("application/x-httpd-php", "php");
        CodeMirror5.defineMIME("application/x-httpd-php-open", { name: "php", startOpen: true });
        CodeMirror5.defineMIME("text/x-php", phpConfig);
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/pig/pig.js
  var require_pig = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/pig/pig.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("pig", function(_config, parserConfig) {
          var keywords2 = parserConfig.keywords, builtins = parserConfig.builtins, types = parserConfig.types, multiLineStrings = parserConfig.multiLineStrings;
          var isOperatorChar = /[*+\-%<>=&?:\/!|]/;
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function tokenComment(stream, state) {
            var isEnd = false;
            var ch;
            while (ch = stream.next()) {
              if (ch == "/" && isEnd) {
                state.tokenize = tokenBase;
                break;
              }
              isEnd = ch == "*";
            }
            return "comment";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = tokenBase;
              return "error";
            };
          }
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'")
              return chain2(stream, state, tokenString(ch));
            else if (/[\[\]{}\(\),;\.]/.test(ch))
              return null;
            else if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            } else if (ch == "/") {
              if (stream.eat("*")) {
                return chain2(stream, state, tokenComment);
              } else {
                stream.eatWhile(isOperatorChar);
                return "operator";
              }
            } else if (ch == "-") {
              if (stream.eat("-")) {
                stream.skipToEnd();
                return "comment";
              } else {
                stream.eatWhile(isOperatorChar);
                return "operator";
              }
            } else if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            } else {
              stream.eatWhile(/[\w\$_]/);
              if (keywords2 && keywords2.propertyIsEnumerable(stream.current().toUpperCase())) {
                if (!stream.eat(")") && !stream.eat("."))
                  return "keyword";
              }
              if (builtins && builtins.propertyIsEnumerable(stream.current().toUpperCase()))
                return "variable-2";
              if (types && types.propertyIsEnumerable(stream.current().toUpperCase()))
                return "variable-3";
              return "variable";
            }
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              return style;
            }
          };
        });
        (function() {
          function keywords2(str) {
            var obj = {}, words = str.split(" ");
            for (var i3 = 0; i3 < words.length; ++i3)
              obj[words[i3]] = true;
            return obj;
          }
          var pBuiltins = "ABS ACOS ARITY ASIN ATAN AVG BAGSIZE BINSTORAGE BLOOM BUILDBLOOM CBRT CEIL CONCAT COR COS COSH COUNT COUNT_STAR COV CONSTANTSIZE CUBEDIMENSIONS DIFF DISTINCT DOUBLEABS DOUBLEAVG DOUBLEBASE DOUBLEMAX DOUBLEMIN DOUBLEROUND DOUBLESUM EXP FLOOR FLOATABS FLOATAVG FLOATMAX FLOATMIN FLOATROUND FLOATSUM GENERICINVOKER INDEXOF INTABS INTAVG INTMAX INTMIN INTSUM INVOKEFORDOUBLE INVOKEFORFLOAT INVOKEFORINT INVOKEFORLONG INVOKEFORSTRING INVOKER ISEMPTY JSONLOADER JSONMETADATA JSONSTORAGE LAST_INDEX_OF LCFIRST LOG LOG10 LOWER LONGABS LONGAVG LONGMAX LONGMIN LONGSUM MAX MIN MAPSIZE MONITOREDUDF NONDETERMINISTIC OUTPUTSCHEMA  PIGSTORAGE PIGSTREAMING RANDOM REGEX_EXTRACT REGEX_EXTRACT_ALL REPLACE ROUND SIN SINH SIZE SQRT STRSPLIT SUBSTRING SUM STRINGCONCAT STRINGMAX STRINGMIN STRINGSIZE TAN TANH TOBAG TOKENIZE TOMAP TOP TOTUPLE TRIM TEXTLOADER TUPLESIZE UCFIRST UPPER UTF8STORAGECONVERTER ";
          var pKeywords = "VOID IMPORT RETURNS DEFINE LOAD FILTER FOREACH ORDER CUBE DISTINCT COGROUP JOIN CROSS UNION SPLIT INTO IF OTHERWISE ALL AS BY USING INNER OUTER ONSCHEMA PARALLEL PARTITION GROUP AND OR NOT GENERATE FLATTEN ASC DESC IS STREAM THROUGH STORE MAPREDUCE SHIP CACHE INPUT OUTPUT STDERROR STDIN STDOUT LIMIT SAMPLE LEFT RIGHT FULL EQ GT LT GTE LTE NEQ MATCHES TRUE FALSE DUMP";
          var pTypes = "BOOLEAN INT LONG FLOAT DOUBLE CHARARRAY BYTEARRAY BAG TUPLE MAP ";
          CodeMirror5.defineMIME("text/x-pig", {
            name: "pig",
            builtins: keywords2(pBuiltins),
            keywords: keywords2(pKeywords),
            types: keywords2(pTypes)
          });
          CodeMirror5.registerHelper("hintWords", "pig", (pBuiltins + pTypes + pKeywords).split(" "));
        })();
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/powershell/powershell.js
  var require_powershell = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/powershell/powershell.js"(exports, module) {
      (function(mod2) {
        "use strict";
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(window.CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("powershell", function() {
          function buildRegexp(patterns, options) {
            options = options || {};
            var prefix = options.prefix !== void 0 ? options.prefix : "^";
            var suffix = options.suffix !== void 0 ? options.suffix : "\\b";
            for (var i3 = 0; i3 < patterns.length; i3++) {
              if (patterns[i3] instanceof RegExp) {
                patterns[i3] = patterns[i3].source;
              } else {
                patterns[i3] = patterns[i3].replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&");
              }
            }
            return new RegExp(prefix + "(" + patterns.join("|") + ")" + suffix, "i");
          }
          var notCharacterOrDash = "(?=[^A-Za-z\\d\\-_]|$)";
          var varNames = /[\w\-:]/;
          var keywords2 = buildRegexp([
            /begin|break|catch|continue|data|default|do|dynamicparam/,
            /else|elseif|end|exit|filter|finally|for|foreach|from|function|if|in/,
            /param|process|return|switch|throw|trap|try|until|where|while/
          ], { suffix: notCharacterOrDash });
          var punctuation = /[\[\]{},;`\\\.]|@[({]/;
          var wordOperators = buildRegexp([
            "f",
            /b?not/,
            /[ic]?split/,
            "join",
            /is(not)?/,
            "as",
            /[ic]?(eq|ne|[gl][te])/,
            /[ic]?(not)?(like|match|contains)/,
            /[ic]?replace/,
            /b?(and|or|xor)/
          ], { prefix: "-" });
          var symbolOperators = /[+\-*\/%]=|\+\+|--|\.\.|[+\-*&^%:=!|\/]|<(?!#)|(?!#)>/;
          var operators = buildRegexp([wordOperators, symbolOperators], { suffix: "" });
          var numbers = /^((0x[\da-f]+)|((\d+\.\d+|\d\.|\.\d+|\d+)(e[\+\-]?\d+)?))[ld]?([kmgtp]b)?/i;
          var identifiers = /^[A-Za-z\_][A-Za-z\-\_\d]*\b/;
          var symbolBuiltins = /[A-Z]:|%|\?/i;
          var namedBuiltins = buildRegexp([
            /Add-(Computer|Content|History|Member|PSSnapin|Type)/,
            /Checkpoint-Computer/,
            /Clear-(Content|EventLog|History|Host|Item(Property)?|Variable)/,
            /Compare-Object/,
            /Complete-Transaction/,
            /Connect-PSSession/,
            /ConvertFrom-(Csv|Json|SecureString|StringData)/,
            /Convert-Path/,
            /ConvertTo-(Csv|Html|Json|SecureString|Xml)/,
            /Copy-Item(Property)?/,
            /Debug-Process/,
            /Disable-(ComputerRestore|PSBreakpoint|PSRemoting|PSSessionConfiguration)/,
            /Disconnect-PSSession/,
            /Enable-(ComputerRestore|PSBreakpoint|PSRemoting|PSSessionConfiguration)/,
            /(Enter|Exit)-PSSession/,
            /Export-(Alias|Clixml|Console|Counter|Csv|FormatData|ModuleMember|PSSession)/,
            /ForEach-Object/,
            /Format-(Custom|List|Table|Wide)/,
            new RegExp("Get-(Acl|Alias|AuthenticodeSignature|ChildItem|Command|ComputerRestorePoint|Content|ControlPanelItem|Counter|Credential|Culture|Date|Event|EventLog|EventSubscriber|ExecutionPolicy|FormatData|Help|History|Host|HotFix|Item|ItemProperty|Job|Location|Member|Module|PfxCertificate|Process|PSBreakpoint|PSCallStack|PSDrive|PSProvider|PSSession|PSSessionConfiguration|PSSnapin|Random|Service|TraceSource|Transaction|TypeData|UICulture|Unique|Variable|Verb|WinEvent|WmiObject)"),
            /Group-Object/,
            /Import-(Alias|Clixml|Counter|Csv|LocalizedData|Module|PSSession)/,
            /ImportSystemModules/,
            /Invoke-(Command|Expression|History|Item|RestMethod|WebRequest|WmiMethod)/,
            /Join-Path/,
            /Limit-EventLog/,
            /Measure-(Command|Object)/,
            /Move-Item(Property)?/,
            new RegExp("New-(Alias|Event|EventLog|Item(Property)?|Module|ModuleManifest|Object|PSDrive|PSSession|PSSessionConfigurationFile|PSSessionOption|PSTransportOption|Service|TimeSpan|Variable|WebServiceProxy|WinEvent)"),
            /Out-(Default|File|GridView|Host|Null|Printer|String)/,
            /Pause/,
            /(Pop|Push)-Location/,
            /Read-Host/,
            /Receive-(Job|PSSession)/,
            /Register-(EngineEvent|ObjectEvent|PSSessionConfiguration|WmiEvent)/,
            /Remove-(Computer|Event|EventLog|Item(Property)?|Job|Module|PSBreakpoint|PSDrive|PSSession|PSSnapin|TypeData|Variable|WmiObject)/,
            /Rename-(Computer|Item(Property)?)/,
            /Reset-ComputerMachinePassword/,
            /Resolve-Path/,
            /Restart-(Computer|Service)/,
            /Restore-Computer/,
            /Resume-(Job|Service)/,
            /Save-Help/,
            /Select-(Object|String|Xml)/,
            /Send-MailMessage/,
            new RegExp("Set-(Acl|Alias|AuthenticodeSignature|Content|Date|ExecutionPolicy|Item(Property)?|Location|PSBreakpoint|PSDebug|PSSessionConfiguration|Service|StrictMode|TraceSource|Variable|WmiInstance)"),
            /Show-(Command|ControlPanelItem|EventLog)/,
            /Sort-Object/,
            /Split-Path/,
            /Start-(Job|Process|Service|Sleep|Transaction|Transcript)/,
            /Stop-(Computer|Job|Process|Service|Transcript)/,
            /Suspend-(Job|Service)/,
            /TabExpansion2/,
            /Tee-Object/,
            /Test-(ComputerSecureChannel|Connection|ModuleManifest|Path|PSSessionConfigurationFile)/,
            /Trace-Command/,
            /Unblock-File/,
            /Undo-Transaction/,
            /Unregister-(Event|PSSessionConfiguration)/,
            /Update-(FormatData|Help|List|TypeData)/,
            /Use-Transaction/,
            /Wait-(Event|Job|Process)/,
            /Where-Object/,
            /Write-(Debug|Error|EventLog|Host|Output|Progress|Verbose|Warning)/,
            /cd|help|mkdir|more|oss|prompt/,
            /ac|asnp|cat|cd|chdir|clc|clear|clhy|cli|clp|cls|clv|cnsn|compare|copy|cp|cpi|cpp|cvpa|dbp|del|diff|dir|dnsn|ebp/,
            /echo|epal|epcsv|epsn|erase|etsn|exsn|fc|fl|foreach|ft|fw|gal|gbp|gc|gci|gcm|gcs|gdr|ghy|gi|gjb|gl|gm|gmo|gp|gps/,
            /group|gsn|gsnp|gsv|gu|gv|gwmi|h|history|icm|iex|ihy|ii|ipal|ipcsv|ipmo|ipsn|irm|ise|iwmi|iwr|kill|lp|ls|man|md/,
            /measure|mi|mount|move|mp|mv|nal|ndr|ni|nmo|npssc|nsn|nv|ogv|oh|popd|ps|pushd|pwd|r|rbp|rcjb|rcsn|rd|rdr|ren|ri/,
            /rjb|rm|rmdir|rmo|rni|rnp|rp|rsn|rsnp|rujb|rv|rvpa|rwmi|sajb|sal|saps|sasv|sbp|sc|select|set|shcm|si|sl|sleep|sls/,
            /sort|sp|spjb|spps|spsv|start|sujb|sv|swmi|tee|trcm|type|where|wjb|write/
          ], { prefix: "", suffix: "" });
          var variableBuiltins = buildRegexp([
            /[$?^_]|Args|ConfirmPreference|ConsoleFileName|DebugPreference|Error|ErrorActionPreference|ErrorView|ExecutionContext/,
            /FormatEnumerationLimit|Home|Host|Input|MaximumAliasCount|MaximumDriveCount|MaximumErrorCount|MaximumFunctionCount/,
            /MaximumHistoryCount|MaximumVariableCount|MyInvocation|NestedPromptLevel|OutputEncoding|Pid|Profile|ProgressPreference/,
            /PSBoundParameters|PSCommandPath|PSCulture|PSDefaultParameterValues|PSEmailServer|PSHome|PSScriptRoot|PSSessionApplicationName/,
            /PSSessionConfigurationName|PSSessionOption|PSUICulture|PSVersionTable|Pwd|ShellId|StackTrace|VerbosePreference/,
            /WarningPreference|WhatIfPreference/,
            /Event|EventArgs|EventSubscriber|Sender/,
            /Matches|Ofs|ForEach|LastExitCode|PSCmdlet|PSItem|PSSenderInfo|This/,
            /true|false|null/
          ], { prefix: "\\$", suffix: "" });
          var builtins = buildRegexp([symbolBuiltins, namedBuiltins, variableBuiltins], { suffix: notCharacterOrDash });
          var grammar = {
            keyword: keywords2,
            number: numbers,
            operator: operators,
            builtin: builtins,
            punctuation,
            identifier: identifiers
          };
          function tokenBase(stream, state) {
            var parent = state.returnStack[state.returnStack.length - 1];
            if (parent && parent.shouldReturnFrom(state)) {
              state.tokenize = parent.tokenize;
              state.returnStack.pop();
              return state.tokenize(stream, state);
            }
            if (stream.eatSpace()) {
              return null;
            }
            if (stream.eat("(")) {
              state.bracketNesting += 1;
              return "punctuation";
            }
            if (stream.eat(")")) {
              state.bracketNesting -= 1;
              return "punctuation";
            }
            for (var key in grammar) {
              if (stream.match(grammar[key])) {
                return key;
              }
            }
            var ch = stream.next();
            if (ch === "'") {
              return tokenSingleQuoteString(stream, state);
            }
            if (ch === "$") {
              return tokenVariable(stream, state);
            }
            if (ch === '"') {
              return tokenDoubleQuoteString(stream, state);
            }
            if (ch === "<" && stream.eat("#")) {
              state.tokenize = tokenComment;
              return tokenComment(stream, state);
            }
            if (ch === "#") {
              stream.skipToEnd();
              return "comment";
            }
            if (ch === "@") {
              var quoteMatch = stream.eat(/["']/);
              if (quoteMatch && stream.eol()) {
                state.tokenize = tokenMultiString;
                state.startQuote = quoteMatch[0];
                return tokenMultiString(stream, state);
              } else if (stream.eol()) {
                return "error";
              } else if (stream.peek().match(/[({]/)) {
                return "punctuation";
              } else if (stream.peek().match(varNames)) {
                return tokenVariable(stream, state);
              }
            }
            return "error";
          }
          function tokenSingleQuoteString(stream, state) {
            var ch;
            while ((ch = stream.peek()) != null) {
              stream.next();
              if (ch === "'" && !stream.eat("'")) {
                state.tokenize = tokenBase;
                return "string";
              }
            }
            return "error";
          }
          function tokenDoubleQuoteString(stream, state) {
            var ch;
            while ((ch = stream.peek()) != null) {
              if (ch === "$") {
                state.tokenize = tokenStringInterpolation;
                return "string";
              }
              stream.next();
              if (ch === "`") {
                stream.next();
                continue;
              }
              if (ch === '"' && !stream.eat('"')) {
                state.tokenize = tokenBase;
                return "string";
              }
            }
            return "error";
          }
          function tokenStringInterpolation(stream, state) {
            return tokenInterpolation(stream, state, tokenDoubleQuoteString);
          }
          function tokenMultiStringReturn(stream, state) {
            state.tokenize = tokenMultiString;
            state.startQuote = '"';
            return tokenMultiString(stream, state);
          }
          function tokenHereStringInterpolation(stream, state) {
            return tokenInterpolation(stream, state, tokenMultiStringReturn);
          }
          function tokenInterpolation(stream, state, parentTokenize) {
            if (stream.match("$(")) {
              var savedBracketNesting = state.bracketNesting;
              state.returnStack.push({
                shouldReturnFrom: function(state2) {
                  return state2.bracketNesting === savedBracketNesting;
                },
                tokenize: parentTokenize
              });
              state.tokenize = tokenBase;
              state.bracketNesting += 1;
              return "punctuation";
            } else {
              stream.next();
              state.returnStack.push({
                shouldReturnFrom: function() {
                  return true;
                },
                tokenize: parentTokenize
              });
              state.tokenize = tokenVariable;
              return state.tokenize(stream, state);
            }
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while ((ch = stream.next()) != null) {
              if (maybeEnd && ch == ">") {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch === "#";
            }
            return "comment";
          }
          function tokenVariable(stream, state) {
            var ch = stream.peek();
            if (stream.eat("{")) {
              state.tokenize = tokenVariableWithBraces;
              return tokenVariableWithBraces(stream, state);
            } else if (ch != void 0 && ch.match(varNames)) {
              stream.eatWhile(varNames);
              state.tokenize = tokenBase;
              return "variable-2";
            } else {
              state.tokenize = tokenBase;
              return "error";
            }
          }
          function tokenVariableWithBraces(stream, state) {
            var ch;
            while ((ch = stream.next()) != null) {
              if (ch === "}") {
                state.tokenize = tokenBase;
                break;
              }
            }
            return "variable-2";
          }
          function tokenMultiString(stream, state) {
            var quote = state.startQuote;
            if (stream.sol() && stream.match(new RegExp(quote + "@"))) {
              state.tokenize = tokenBase;
            } else if (quote === '"') {
              while (!stream.eol()) {
                var ch = stream.peek();
                if (ch === "$") {
                  state.tokenize = tokenHereStringInterpolation;
                  return "string";
                }
                stream.next();
                if (ch === "`") {
                  stream.next();
                }
              }
            } else {
              stream.skipToEnd();
            }
            return "string";
          }
          var external = {
            startState: function() {
              return {
                returnStack: [],
                bracketNesting: 0,
                tokenize: tokenBase
              };
            },
            token: function(stream, state) {
              return state.tokenize(stream, state);
            },
            blockCommentStart: "<#",
            blockCommentEnd: "#>",
            lineComment: "#",
            fold: "brace"
          };
          return external;
        });
        CodeMirror5.defineMIME("application/x-powershell", "powershell");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/properties/properties.js
  var require_properties = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/properties/properties.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("properties", function() {
          return {
            token: function(stream, state) {
              var sol = stream.sol() || state.afterSection;
              var eol = stream.eol();
              state.afterSection = false;
              if (sol) {
                if (state.nextMultiline) {
                  state.inMultiline = true;
                  state.nextMultiline = false;
                } else {
                  state.position = "def";
                }
              }
              if (eol && !state.nextMultiline) {
                state.inMultiline = false;
                state.position = "def";
              }
              if (sol) {
                while (stream.eatSpace()) {
                }
              }
              var ch = stream.next();
              if (sol && (ch === "#" || ch === "!" || ch === ";")) {
                state.position = "comment";
                stream.skipToEnd();
                return "comment";
              } else if (sol && ch === "[") {
                state.afterSection = true;
                stream.skipTo("]");
                stream.eat("]");
                return "header";
              } else if (ch === "=" || ch === ":") {
                state.position = "quote";
                return null;
              } else if (ch === "\\" && state.position === "quote") {
                if (stream.eol()) {
                  state.nextMultiline = true;
                }
              }
              return state.position;
            },
            startState: function() {
              return {
                position: "def",
                nextMultiline: false,
                inMultiline: false,
                afterSection: false
              };
            }
          };
        });
        CodeMirror5.defineMIME("text/x-properties", "properties");
        CodeMirror5.defineMIME("text/x-ini", "properties");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/protobuf/protobuf.js
  var require_protobuf = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/protobuf/protobuf.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function wordRegexp(words) {
          return new RegExp("^((" + words.join(")|(") + "))\\b", "i");
        }
        ;
        var keywordArray = [
          "package",
          "message",
          "import",
          "syntax",
          "required",
          "optional",
          "repeated",
          "reserved",
          "default",
          "extensions",
          "packed",
          "bool",
          "bytes",
          "double",
          "enum",
          "float",
          "string",
          "int32",
          "int64",
          "uint32",
          "uint64",
          "sint32",
          "sint64",
          "fixed32",
          "fixed64",
          "sfixed32",
          "sfixed64",
          "option",
          "service",
          "rpc",
          "returns"
        ];
        var keywords2 = wordRegexp(keywordArray);
        CodeMirror5.registerHelper("hintWords", "protobuf", keywordArray);
        var identifiers = new RegExp("^[_A-Za-z\xA1-\uFFFF][_A-Za-z0-9\xA1-\uFFFF]*");
        function tokenBase(stream) {
          if (stream.eatSpace())
            return null;
          if (stream.match("//")) {
            stream.skipToEnd();
            return "comment";
          }
          if (stream.match(/^[0-9\.+-]/, false)) {
            if (stream.match(/^[+-]?0x[0-9a-fA-F]+/))
              return "number";
            if (stream.match(/^[+-]?\d*\.\d+([EeDd][+-]?\d+)?/))
              return "number";
            if (stream.match(/^[+-]?\d+([EeDd][+-]?\d+)?/))
              return "number";
          }
          if (stream.match(/^"([^"]|(""))*"/)) {
            return "string";
          }
          if (stream.match(/^'([^']|(''))*'/)) {
            return "string";
          }
          if (stream.match(keywords2)) {
            return "keyword";
          }
          if (stream.match(identifiers)) {
            return "variable";
          }
          ;
          stream.next();
          return null;
        }
        ;
        CodeMirror5.defineMode("protobuf", function() {
          return {
            token: tokenBase,
            fold: "brace"
          };
        });
        CodeMirror5.defineMIME("text/x-protobuf", "protobuf");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/pug/pug.js
  var require_pug = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/pug/pug.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_javascript(), require_css(), require_htmlmixed());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../javascript/javascript", "../css/css", "../htmlmixed/htmlmixed"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("pug", function(config3) {
          var KEYWORD = "keyword";
          var DOCTYPE = "meta";
          var ID = "builtin";
          var CLASS = "qualifier";
          var ATTRS_NEST = {
            "{": "}",
            "(": ")",
            "[": "]"
          };
          var jsMode = CodeMirror5.getMode(config3, "javascript");
          function State() {
            this.javaScriptLine = false;
            this.javaScriptLineExcludesColon = false;
            this.javaScriptArguments = false;
            this.javaScriptArgumentsDepth = 0;
            this.isInterpolating = false;
            this.interpolationNesting = 0;
            this.jsState = CodeMirror5.startState(jsMode);
            this.restOfLine = "";
            this.isIncludeFiltered = false;
            this.isEach = false;
            this.lastTag = "";
            this.scriptType = "";
            this.isAttrs = false;
            this.attrsNest = [];
            this.inAttributeName = true;
            this.attributeIsType = false;
            this.attrValue = "";
            this.indentOf = Infinity;
            this.indentToken = "";
            this.innerMode = null;
            this.innerState = null;
            this.innerModeForLine = false;
          }
          State.prototype.copy = function() {
            var res = new State();
            res.javaScriptLine = this.javaScriptLine;
            res.javaScriptLineExcludesColon = this.javaScriptLineExcludesColon;
            res.javaScriptArguments = this.javaScriptArguments;
            res.javaScriptArgumentsDepth = this.javaScriptArgumentsDepth;
            res.isInterpolating = this.isInterpolating;
            res.interpolationNesting = this.interpolationNesting;
            res.jsState = CodeMirror5.copyState(jsMode, this.jsState);
            res.innerMode = this.innerMode;
            if (this.innerMode && this.innerState) {
              res.innerState = CodeMirror5.copyState(this.innerMode, this.innerState);
            }
            res.restOfLine = this.restOfLine;
            res.isIncludeFiltered = this.isIncludeFiltered;
            res.isEach = this.isEach;
            res.lastTag = this.lastTag;
            res.scriptType = this.scriptType;
            res.isAttrs = this.isAttrs;
            res.attrsNest = this.attrsNest.slice();
            res.inAttributeName = this.inAttributeName;
            res.attributeIsType = this.attributeIsType;
            res.attrValue = this.attrValue;
            res.indentOf = this.indentOf;
            res.indentToken = this.indentToken;
            res.innerModeForLine = this.innerModeForLine;
            return res;
          };
          function javaScript(stream, state) {
            if (stream.sol()) {
              state.javaScriptLine = false;
              state.javaScriptLineExcludesColon = false;
            }
            if (state.javaScriptLine) {
              if (state.javaScriptLineExcludesColon && stream.peek() === ":") {
                state.javaScriptLine = false;
                state.javaScriptLineExcludesColon = false;
                return;
              }
              var tok = jsMode.token(stream, state.jsState);
              if (stream.eol())
                state.javaScriptLine = false;
              return tok || true;
            }
          }
          function javaScriptArguments(stream, state) {
            if (state.javaScriptArguments) {
              if (state.javaScriptArgumentsDepth === 0 && stream.peek() !== "(") {
                state.javaScriptArguments = false;
                return;
              }
              if (stream.peek() === "(") {
                state.javaScriptArgumentsDepth++;
              } else if (stream.peek() === ")") {
                state.javaScriptArgumentsDepth--;
              }
              if (state.javaScriptArgumentsDepth === 0) {
                state.javaScriptArguments = false;
                return;
              }
              var tok = jsMode.token(stream, state.jsState);
              return tok || true;
            }
          }
          function yieldStatement(stream) {
            if (stream.match(/^yield\b/)) {
              return "keyword";
            }
          }
          function doctype(stream) {
            if (stream.match(/^(?:doctype) *([^\n]+)?/)) {
              return DOCTYPE;
            }
          }
          function interpolation(stream, state) {
            if (stream.match("#{")) {
              state.isInterpolating = true;
              state.interpolationNesting = 0;
              return "punctuation";
            }
          }
          function interpolationContinued(stream, state) {
            if (state.isInterpolating) {
              if (stream.peek() === "}") {
                state.interpolationNesting--;
                if (state.interpolationNesting < 0) {
                  stream.next();
                  state.isInterpolating = false;
                  return "punctuation";
                }
              } else if (stream.peek() === "{") {
                state.interpolationNesting++;
              }
              return jsMode.token(stream, state.jsState) || true;
            }
          }
          function caseStatement(stream, state) {
            if (stream.match(/^case\b/)) {
              state.javaScriptLine = true;
              return KEYWORD;
            }
          }
          function when(stream, state) {
            if (stream.match(/^when\b/)) {
              state.javaScriptLine = true;
              state.javaScriptLineExcludesColon = true;
              return KEYWORD;
            }
          }
          function defaultStatement(stream) {
            if (stream.match(/^default\b/)) {
              return KEYWORD;
            }
          }
          function extendsStatement(stream, state) {
            if (stream.match(/^extends?\b/)) {
              state.restOfLine = "string";
              return KEYWORD;
            }
          }
          function append(stream, state) {
            if (stream.match(/^append\b/)) {
              state.restOfLine = "variable";
              return KEYWORD;
            }
          }
          function prepend(stream, state) {
            if (stream.match(/^prepend\b/)) {
              state.restOfLine = "variable";
              return KEYWORD;
            }
          }
          function block(stream, state) {
            if (stream.match(/^block\b *(?:(prepend|append)\b)?/)) {
              state.restOfLine = "variable";
              return KEYWORD;
            }
          }
          function include(stream, state) {
            if (stream.match(/^include\b/)) {
              state.restOfLine = "string";
              return KEYWORD;
            }
          }
          function includeFiltered(stream, state) {
            if (stream.match(/^include:([a-zA-Z0-9\-]+)/, false) && stream.match("include")) {
              state.isIncludeFiltered = true;
              return KEYWORD;
            }
          }
          function includeFilteredContinued(stream, state) {
            if (state.isIncludeFiltered) {
              var tok = filter3(stream, state);
              state.isIncludeFiltered = false;
              state.restOfLine = "string";
              return tok;
            }
          }
          function mixin2(stream, state) {
            if (stream.match(/^mixin\b/)) {
              state.javaScriptLine = true;
              return KEYWORD;
            }
          }
          function call(stream, state) {
            if (stream.match(/^\+([-\w]+)/)) {
              if (!stream.match(/^\( *[-\w]+ *=/, false)) {
                state.javaScriptArguments = true;
                state.javaScriptArgumentsDepth = 0;
              }
              return "variable";
            }
            if (stream.match(/^\+#{/, false)) {
              stream.next();
              state.mixinCallAfter = true;
              return interpolation(stream, state);
            }
          }
          function callArguments(stream, state) {
            if (state.mixinCallAfter) {
              state.mixinCallAfter = false;
              if (!stream.match(/^\( *[-\w]+ *=/, false)) {
                state.javaScriptArguments = true;
                state.javaScriptArgumentsDepth = 0;
              }
              return true;
            }
          }
          function conditional(stream, state) {
            if (stream.match(/^(if|unless|else if|else)\b/)) {
              state.javaScriptLine = true;
              return KEYWORD;
            }
          }
          function each(stream, state) {
            if (stream.match(/^(- *)?(each|for)\b/)) {
              state.isEach = true;
              return KEYWORD;
            }
          }
          function eachContinued(stream, state) {
            if (state.isEach) {
              if (stream.match(/^ in\b/)) {
                state.javaScriptLine = true;
                state.isEach = false;
                return KEYWORD;
              } else if (stream.sol() || stream.eol()) {
                state.isEach = false;
              } else if (stream.next()) {
                while (!stream.match(/^ in\b/, false) && stream.next())
                  ;
                return "variable";
              }
            }
          }
          function whileStatement(stream, state) {
            if (stream.match(/^while\b/)) {
              state.javaScriptLine = true;
              return KEYWORD;
            }
          }
          function tag(stream, state) {
            var captures;
            if (captures = stream.match(/^(\w(?:[-:\w]*\w)?)\/?/)) {
              state.lastTag = captures[1].toLowerCase();
              if (state.lastTag === "script") {
                state.scriptType = "application/javascript";
              }
              return "tag";
            }
          }
          function filter3(stream, state) {
            if (stream.match(/^:([\w\-]+)/)) {
              var innerMode2;
              if (config3 && config3.innerModes) {
                innerMode2 = config3.innerModes(stream.current().substring(1));
              }
              if (!innerMode2) {
                innerMode2 = stream.current().substring(1);
              }
              if (typeof innerMode2 === "string") {
                innerMode2 = CodeMirror5.getMode(config3, innerMode2);
              }
              setInnerMode(stream, state, innerMode2);
              return "atom";
            }
          }
          function code(stream, state) {
            if (stream.match(/^(!?=|-)/)) {
              state.javaScriptLine = true;
              return "punctuation";
            }
          }
          function id(stream) {
            if (stream.match(/^#([\w-]+)/)) {
              return ID;
            }
          }
          function className(stream) {
            if (stream.match(/^\.([\w-]+)/)) {
              return CLASS;
            }
          }
          function attrs(stream, state) {
            if (stream.peek() == "(") {
              stream.next();
              state.isAttrs = true;
              state.attrsNest = [];
              state.inAttributeName = true;
              state.attrValue = "";
              state.attributeIsType = false;
              return "punctuation";
            }
          }
          function attrsContinued(stream, state) {
            if (state.isAttrs) {
              if (ATTRS_NEST[stream.peek()]) {
                state.attrsNest.push(ATTRS_NEST[stream.peek()]);
              }
              if (state.attrsNest[state.attrsNest.length - 1] === stream.peek()) {
                state.attrsNest.pop();
              } else if (stream.eat(")")) {
                state.isAttrs = false;
                return "punctuation";
              }
              if (state.inAttributeName && stream.match(/^[^=,\)!]+/)) {
                if (stream.peek() === "=" || stream.peek() === "!") {
                  state.inAttributeName = false;
                  state.jsState = CodeMirror5.startState(jsMode);
                  if (state.lastTag === "script" && stream.current().trim().toLowerCase() === "type") {
                    state.attributeIsType = true;
                  } else {
                    state.attributeIsType = false;
                  }
                }
                return "attribute";
              }
              var tok = jsMode.token(stream, state.jsState);
              if (state.attributeIsType && tok === "string") {
                state.scriptType = stream.current().toString();
              }
              if (state.attrsNest.length === 0 && (tok === "string" || tok === "variable" || tok === "keyword")) {
                try {
                  Function("", "var x " + state.attrValue.replace(/,\s*$/, "").replace(/^!/, ""));
                  state.inAttributeName = true;
                  state.attrValue = "";
                  stream.backUp(stream.current().length);
                  return attrsContinued(stream, state);
                } catch (ex) {
                }
              }
              state.attrValue += stream.current();
              return tok || true;
            }
          }
          function attributesBlock(stream, state) {
            if (stream.match(/^&attributes\b/)) {
              state.javaScriptArguments = true;
              state.javaScriptArgumentsDepth = 0;
              return "keyword";
            }
          }
          function indent(stream) {
            if (stream.sol() && stream.eatSpace()) {
              return "indent";
            }
          }
          function comment(stream, state) {
            if (stream.match(/^ *\/\/(-)?([^\n]*)/)) {
              state.indentOf = stream.indentation();
              state.indentToken = "comment";
              return "comment";
            }
          }
          function colon(stream) {
            if (stream.match(/^: */)) {
              return "colon";
            }
          }
          function text(stream, state) {
            if (stream.match(/^(?:\| ?| )([^\n]+)/)) {
              return "string";
            }
            if (stream.match(/^(<[^\n]*)/, false)) {
              setInnerMode(stream, state, "htmlmixed");
              state.innerModeForLine = true;
              return innerMode(stream, state, true);
            }
          }
          function dot(stream, state) {
            if (stream.eat(".")) {
              var innerMode2 = null;
              if (state.lastTag === "script" && state.scriptType.toLowerCase().indexOf("javascript") != -1) {
                innerMode2 = state.scriptType.toLowerCase().replace(/"|'/g, "");
              } else if (state.lastTag === "style") {
                innerMode2 = "css";
              }
              setInnerMode(stream, state, innerMode2);
              return "dot";
            }
          }
          function fail2(stream) {
            stream.next();
            return null;
          }
          function setInnerMode(stream, state, mode2) {
            mode2 = CodeMirror5.mimeModes[mode2] || mode2;
            mode2 = config3.innerModes ? config3.innerModes(mode2) || mode2 : mode2;
            mode2 = CodeMirror5.mimeModes[mode2] || mode2;
            mode2 = CodeMirror5.getMode(config3, mode2);
            state.indentOf = stream.indentation();
            if (mode2 && mode2.name !== "null") {
              state.innerMode = mode2;
            } else {
              state.indentToken = "string";
            }
          }
          function innerMode(stream, state, force) {
            if (stream.indentation() > state.indentOf || state.innerModeForLine && !stream.sol() || force) {
              if (state.innerMode) {
                if (!state.innerState) {
                  state.innerState = state.innerMode.startState ? CodeMirror5.startState(state.innerMode, stream.indentation()) : {};
                }
                return stream.hideFirstChars(state.indentOf + 2, function() {
                  return state.innerMode.token(stream, state.innerState) || true;
                });
              } else {
                stream.skipToEnd();
                return state.indentToken;
              }
            } else if (stream.sol()) {
              state.indentOf = Infinity;
              state.indentToken = null;
              state.innerMode = null;
              state.innerState = null;
            }
          }
          function restOfLine(stream, state) {
            if (stream.sol()) {
              state.restOfLine = "";
            }
            if (state.restOfLine) {
              stream.skipToEnd();
              var tok = state.restOfLine;
              state.restOfLine = "";
              return tok;
            }
          }
          function startState() {
            return new State();
          }
          function copyState2(state) {
            return state.copy();
          }
          function nextToken(stream, state) {
            var tok = innerMode(stream, state) || restOfLine(stream, state) || interpolationContinued(stream, state) || includeFilteredContinued(stream, state) || eachContinued(stream, state) || attrsContinued(stream, state) || javaScript(stream, state) || javaScriptArguments(stream, state) || callArguments(stream, state) || yieldStatement(stream) || doctype(stream) || interpolation(stream, state) || caseStatement(stream, state) || when(stream, state) || defaultStatement(stream) || extendsStatement(stream, state) || append(stream, state) || prepend(stream, state) || block(stream, state) || include(stream, state) || includeFiltered(stream, state) || mixin2(stream, state) || call(stream, state) || conditional(stream, state) || each(stream, state) || whileStatement(stream, state) || tag(stream, state) || filter3(stream, state) || code(stream, state) || id(stream) || className(stream) || attrs(stream, state) || attributesBlock(stream, state) || indent(stream) || text(stream, state) || comment(stream, state) || colon(stream) || dot(stream, state) || fail2(stream);
            return tok === true ? null : tok;
          }
          return {
            startState,
            copyState: copyState2,
            token: nextToken
          };
        }, "javascript", "css", "htmlmixed");
        CodeMirror5.defineMIME("text/x-pug", "pug");
        CodeMirror5.defineMIME("text/x-jade", "pug");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/puppet/puppet.js
  var require_puppet = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/puppet/puppet.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("puppet", function() {
          var words = {};
          var variable_regex = /({)?([a-z][a-z0-9_]*)?((::[a-z][a-z0-9_]*)*::)?[a-zA-Z0-9_]+(})?/;
          function define2(style, string2) {
            var split = string2.split(" ");
            for (var i3 = 0; i3 < split.length; i3++) {
              words[split[i3]] = style;
            }
          }
          define2("keyword", "class define site node include import inherits");
          define2("keyword", "case if else in and elsif default or");
          define2("atom", "false true running present absent file directory undef");
          define2("builtin", "action augeas burst chain computer cron destination dport exec file filebucket group host icmp iniface interface jump k5login limit log_level log_prefix macauthorization mailalias maillist mcx mount nagios_command nagios_contact nagios_contactgroup nagios_host nagios_hostdependency nagios_hostescalation nagios_hostextinfo nagios_hostgroup nagios_service nagios_servicedependency nagios_serviceescalation nagios_serviceextinfo nagios_servicegroup nagios_timeperiod name notify outiface package proto reject resources router schedule scheduled_task selboolean selmodule service source sport ssh_authorized_key sshkey stage state table tidy todest toports tosource user vlan yumrepo zfs zone zpool");
          function tokenString(stream, state) {
            var current, prev, found_var = false;
            while (!stream.eol() && (current = stream.next()) != state.pending) {
              if (current === "$" && prev != "\\" && state.pending == '"') {
                found_var = true;
                break;
              }
              prev = current;
            }
            if (found_var) {
              stream.backUp(1);
            }
            if (current == state.pending) {
              state.continueString = false;
            } else {
              state.continueString = true;
            }
            return "string";
          }
          function tokenize(stream, state) {
            var word = stream.match(/[\w]+/, false);
            var attribute = stream.match(/(\s+)?\w+\s+=>.*/, false);
            var resource = stream.match(/(\s+)?[\w:_]+(\s+)?{/, false);
            var special_resource = stream.match(/(\s+)?[@]{1,2}[\w:_]+(\s+)?{/, false);
            var ch = stream.next();
            if (ch === "$") {
              if (stream.match(variable_regex)) {
                return state.continueString ? "variable-2" : "variable";
              }
              return "error";
            }
            if (state.continueString) {
              stream.backUp(1);
              return tokenString(stream, state);
            }
            if (state.inDefinition) {
              if (stream.match(/(\s+)?[\w:_]+(\s+)?/)) {
                return "def";
              }
              stream.match(/\s+{/);
              state.inDefinition = false;
            }
            if (state.inInclude) {
              stream.match(/(\s+)?\S+(\s+)?/);
              state.inInclude = false;
              return "def";
            }
            if (stream.match(/(\s+)?\w+\(/)) {
              stream.backUp(1);
              return "def";
            }
            if (attribute) {
              stream.match(/(\s+)?\w+/);
              return "tag";
            }
            if (word && words.hasOwnProperty(word)) {
              stream.backUp(1);
              stream.match(/[\w]+/);
              if (stream.match(/\s+\S+\s+{/, false)) {
                state.inDefinition = true;
              }
              if (word == "include") {
                state.inInclude = true;
              }
              return words[word];
            }
            if (/(^|\s+)[A-Z][\w:_]+/.test(word)) {
              stream.backUp(1);
              stream.match(/(^|\s+)[A-Z][\w:_]+/);
              return "def";
            }
            if (resource) {
              stream.match(/(\s+)?[\w:_]+/);
              return "def";
            }
            if (special_resource) {
              stream.match(/(\s+)?[@]{1,2}/);
              return "special";
            }
            if (ch == "#") {
              stream.skipToEnd();
              return "comment";
            }
            if (ch == "'" || ch == '"') {
              state.pending = ch;
              return tokenString(stream, state);
            }
            if (ch == "{" || ch == "}") {
              return "bracket";
            }
            if (ch == "/") {
              stream.match(/.*?\//);
              return "variable-3";
            }
            if (ch.match(/[0-9]/)) {
              stream.eatWhile(/[0-9]+/);
              return "number";
            }
            if (ch == "=") {
              if (stream.peek() == ">") {
                stream.next();
              }
              return "operator";
            }
            stream.eatWhile(/[\w-]/);
            return null;
          }
          return {
            startState: function() {
              var state = {};
              state.inDefinition = false;
              state.inInclude = false;
              state.continueString = false;
              state.pending = false;
              return state;
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return tokenize(stream, state);
            }
          };
        });
        CodeMirror5.defineMIME("text/x-puppet", "puppet");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/python/python.js
  var require_python = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/python/python.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function wordRegexp(words2) {
          return new RegExp("^((" + words2.join(")|(") + "))\\b");
        }
        var wordOperators = wordRegexp(["and", "or", "not", "is"]);
        var commonKeywords = [
          "as",
          "assert",
          "break",
          "class",
          "continue",
          "def",
          "del",
          "elif",
          "else",
          "except",
          "finally",
          "for",
          "from",
          "global",
          "if",
          "import",
          "lambda",
          "pass",
          "raise",
          "return",
          "try",
          "while",
          "with",
          "yield",
          "in"
        ];
        var commonBuiltins = [
          "abs",
          "all",
          "any",
          "bin",
          "bool",
          "bytearray",
          "callable",
          "chr",
          "classmethod",
          "compile",
          "complex",
          "delattr",
          "dict",
          "dir",
          "divmod",
          "enumerate",
          "eval",
          "filter",
          "float",
          "format",
          "frozenset",
          "getattr",
          "globals",
          "hasattr",
          "hash",
          "help",
          "hex",
          "id",
          "input",
          "int",
          "isinstance",
          "issubclass",
          "iter",
          "len",
          "list",
          "locals",
          "map",
          "max",
          "memoryview",
          "min",
          "next",
          "object",
          "oct",
          "open",
          "ord",
          "pow",
          "property",
          "range",
          "repr",
          "reversed",
          "round",
          "set",
          "setattr",
          "slice",
          "sorted",
          "staticmethod",
          "str",
          "sum",
          "super",
          "tuple",
          "type",
          "vars",
          "zip",
          "__import__",
          "NotImplemented",
          "Ellipsis",
          "__debug__"
        ];
        CodeMirror5.registerHelper("hintWords", "python", commonKeywords.concat(commonBuiltins));
        function top(state) {
          return state.scopes[state.scopes.length - 1];
        }
        CodeMirror5.defineMode("python", function(conf, parserConf) {
          var ERRORCLASS = "error";
          var delimiters = parserConf.delimiters || parserConf.singleDelimiters || /^[\(\)\[\]\{\}@,:`=;\.\\]/;
          var operators = [
            parserConf.singleOperators,
            parserConf.doubleOperators,
            parserConf.doubleDelimiters,
            parserConf.tripleDelimiters,
            parserConf.operators || /^([-+*/%\/&|^]=?|[<>=]+|\/\/=?|\*\*=?|!=|[~!@]|\.\.\.)/
          ];
          for (var i3 = 0; i3 < operators.length; i3++)
            if (!operators[i3])
              operators.splice(i3--, 1);
          var hangingIndent = parserConf.hangingIndent || conf.indentUnit;
          var myKeywords = commonKeywords, myBuiltins = commonBuiltins;
          if (parserConf.extra_keywords != void 0)
            myKeywords = myKeywords.concat(parserConf.extra_keywords);
          if (parserConf.extra_builtins != void 0)
            myBuiltins = myBuiltins.concat(parserConf.extra_builtins);
          var py3 = !(parserConf.version && Number(parserConf.version) < 3);
          if (py3) {
            var identifiers = parserConf.identifiers || /^[_A-Za-z\u00A1-\uFFFF][_A-Za-z0-9\u00A1-\uFFFF]*/;
            myKeywords = myKeywords.concat(["nonlocal", "False", "True", "None", "async", "await"]);
            myBuiltins = myBuiltins.concat(["ascii", "bytes", "exec", "print"]);
            var stringPrefixes = new RegExp(`^(([rbuf]|(br)|(fr))?('{3}|"{3}|['"]))`, "i");
          } else {
            var identifiers = parserConf.identifiers || /^[_A-Za-z][_A-Za-z0-9]*/;
            myKeywords = myKeywords.concat(["exec", "print"]);
            myBuiltins = myBuiltins.concat([
              "apply",
              "basestring",
              "buffer",
              "cmp",
              "coerce",
              "execfile",
              "file",
              "intern",
              "long",
              "raw_input",
              "reduce",
              "reload",
              "unichr",
              "unicode",
              "xrange",
              "False",
              "True",
              "None"
            ]);
            var stringPrefixes = new RegExp(`^(([rubf]|(ur)|(br))?('{3}|"{3}|['"]))`, "i");
          }
          var keywords2 = wordRegexp(myKeywords);
          var builtins = wordRegexp(myBuiltins);
          function tokenBase(stream, state) {
            var sol = stream.sol() && state.lastToken != "\\";
            if (sol)
              state.indent = stream.indentation();
            if (sol && top(state).type == "py") {
              var scopeOffset = top(state).offset;
              if (stream.eatSpace()) {
                var lineOffset = stream.indentation();
                if (lineOffset > scopeOffset)
                  pushPyScope(state);
                else if (lineOffset < scopeOffset && dedent(stream, state) && stream.peek() != "#")
                  state.errorToken = true;
                return null;
              } else {
                var style = tokenBaseInner(stream, state);
                if (scopeOffset > 0 && dedent(stream, state))
                  style += " " + ERRORCLASS;
                return style;
              }
            }
            return tokenBaseInner(stream, state);
          }
          function tokenBaseInner(stream, state, inFormat) {
            if (stream.eatSpace())
              return null;
            if (!inFormat && stream.match(/^#.*/))
              return "comment";
            if (stream.match(/^[0-9\.]/, false)) {
              var floatLiteral = false;
              if (stream.match(/^[\d_]*\.\d+(e[\+\-]?\d+)?/i)) {
                floatLiteral = true;
              }
              if (stream.match(/^[\d_]+\.\d*/)) {
                floatLiteral = true;
              }
              if (stream.match(/^\.\d+/)) {
                floatLiteral = true;
              }
              if (floatLiteral) {
                stream.eat(/J/i);
                return "number";
              }
              var intLiteral = false;
              if (stream.match(/^0x[0-9a-f_]+/i))
                intLiteral = true;
              if (stream.match(/^0b[01_]+/i))
                intLiteral = true;
              if (stream.match(/^0o[0-7_]+/i))
                intLiteral = true;
              if (stream.match(/^[1-9][\d_]*(e[\+\-]?[\d_]+)?/)) {
                stream.eat(/J/i);
                intLiteral = true;
              }
              if (stream.match(/^0(?![\dx])/i))
                intLiteral = true;
              if (intLiteral) {
                stream.eat(/L/i);
                return "number";
              }
            }
            if (stream.match(stringPrefixes)) {
              var isFmtString = stream.current().toLowerCase().indexOf("f") !== -1;
              if (!isFmtString) {
                state.tokenize = tokenStringFactory(stream.current(), state.tokenize);
                return state.tokenize(stream, state);
              } else {
                state.tokenize = formatStringFactory(stream.current(), state.tokenize);
                return state.tokenize(stream, state);
              }
            }
            for (var i4 = 0; i4 < operators.length; i4++)
              if (stream.match(operators[i4]))
                return "operator";
            if (stream.match(delimiters))
              return "punctuation";
            if (state.lastToken == "." && stream.match(identifiers))
              return "property";
            if (stream.match(keywords2) || stream.match(wordOperators))
              return "keyword";
            if (stream.match(builtins))
              return "builtin";
            if (stream.match(/^(self|cls)\b/))
              return "variable-2";
            if (stream.match(identifiers)) {
              if (state.lastToken == "def" || state.lastToken == "class")
                return "def";
              return "variable";
            }
            stream.next();
            return inFormat ? null : ERRORCLASS;
          }
          function formatStringFactory(delimiter, tokenOuter) {
            while ("rubf".indexOf(delimiter.charAt(0).toLowerCase()) >= 0)
              delimiter = delimiter.substr(1);
            var singleline = delimiter.length == 1;
            var OUTCLASS = "string";
            function tokenNestedExpr(depth) {
              return function(stream, state) {
                var inner = tokenBaseInner(stream, state, true);
                if (inner == "punctuation") {
                  if (stream.current() == "{") {
                    state.tokenize = tokenNestedExpr(depth + 1);
                  } else if (stream.current() == "}") {
                    if (depth > 1)
                      state.tokenize = tokenNestedExpr(depth - 1);
                    else
                      state.tokenize = tokenString;
                  }
                }
                return inner;
              };
            }
            function tokenString(stream, state) {
              while (!stream.eol()) {
                stream.eatWhile(/[^'"\{\}\\]/);
                if (stream.eat("\\")) {
                  stream.next();
                  if (singleline && stream.eol())
                    return OUTCLASS;
                } else if (stream.match(delimiter)) {
                  state.tokenize = tokenOuter;
                  return OUTCLASS;
                } else if (stream.match("{{")) {
                  return OUTCLASS;
                } else if (stream.match("{", false)) {
                  state.tokenize = tokenNestedExpr(0);
                  if (stream.current())
                    return OUTCLASS;
                  else
                    return state.tokenize(stream, state);
                } else if (stream.match("}}")) {
                  return OUTCLASS;
                } else if (stream.match("}")) {
                  return ERRORCLASS;
                } else {
                  stream.eat(/['"]/);
                }
              }
              if (singleline) {
                if (parserConf.singleLineStringErrors)
                  return ERRORCLASS;
                else
                  state.tokenize = tokenOuter;
              }
              return OUTCLASS;
            }
            tokenString.isString = true;
            return tokenString;
          }
          function tokenStringFactory(delimiter, tokenOuter) {
            while ("rubf".indexOf(delimiter.charAt(0).toLowerCase()) >= 0)
              delimiter = delimiter.substr(1);
            var singleline = delimiter.length == 1;
            var OUTCLASS = "string";
            function tokenString(stream, state) {
              while (!stream.eol()) {
                stream.eatWhile(/[^'"\\]/);
                if (stream.eat("\\")) {
                  stream.next();
                  if (singleline && stream.eol())
                    return OUTCLASS;
                } else if (stream.match(delimiter)) {
                  state.tokenize = tokenOuter;
                  return OUTCLASS;
                } else {
                  stream.eat(/['"]/);
                }
              }
              if (singleline) {
                if (parserConf.singleLineStringErrors)
                  return ERRORCLASS;
                else
                  state.tokenize = tokenOuter;
              }
              return OUTCLASS;
            }
            tokenString.isString = true;
            return tokenString;
          }
          function pushPyScope(state) {
            while (top(state).type != "py")
              state.scopes.pop();
            state.scopes.push({
              offset: top(state).offset + conf.indentUnit,
              type: "py",
              align: null
            });
          }
          function pushBracketScope(stream, state, type) {
            var align = stream.match(/^([\s\[\{\(]|#.*)*$/, false) ? null : stream.column() + 1;
            state.scopes.push({
              offset: state.indent + hangingIndent,
              type,
              align
            });
          }
          function dedent(stream, state) {
            var indented = stream.indentation();
            while (state.scopes.length > 1 && top(state).offset > indented) {
              if (top(state).type != "py")
                return true;
              state.scopes.pop();
            }
            return top(state).offset != indented;
          }
          function tokenLexer(stream, state) {
            if (stream.sol())
              state.beginningOfLine = true;
            var style = state.tokenize(stream, state);
            var current = stream.current();
            if (state.beginningOfLine && current == "@")
              return stream.match(identifiers, false) ? "meta" : py3 ? "operator" : ERRORCLASS;
            if (/\S/.test(current))
              state.beginningOfLine = false;
            if ((style == "variable" || style == "builtin") && state.lastToken == "meta")
              style = "meta";
            if (current == "pass" || current == "return")
              state.dedent += 1;
            if (current == "lambda")
              state.lambda = true;
            if (current == ":" && !state.lambda && top(state).type == "py")
              pushPyScope(state);
            if (current.length == 1 && !/string|comment/.test(style)) {
              var delimiter_index = "[({".indexOf(current);
              if (delimiter_index != -1)
                pushBracketScope(stream, state, "])}".slice(delimiter_index, delimiter_index + 1));
              delimiter_index = "])}".indexOf(current);
              if (delimiter_index != -1) {
                if (top(state).type == current)
                  state.indent = state.scopes.pop().offset - hangingIndent;
                else
                  return ERRORCLASS;
              }
            }
            if (state.dedent > 0 && stream.eol() && top(state).type == "py") {
              if (state.scopes.length > 1)
                state.scopes.pop();
              state.dedent -= 1;
            }
            return style;
          }
          var external = {
            startState: function(basecolumn) {
              return {
                tokenize: tokenBase,
                scopes: [{ offset: basecolumn || 0, type: "py", align: null }],
                indent: basecolumn || 0,
                lastToken: null,
                lambda: false,
                dedent: 0
              };
            },
            token: function(stream, state) {
              var addErr = state.errorToken;
              if (addErr)
                state.errorToken = false;
              var style = tokenLexer(stream, state);
              if (style && style != "comment")
                state.lastToken = style == "keyword" || style == "punctuation" ? stream.current() : style;
              if (style == "punctuation")
                style = null;
              if (stream.eol() && state.lambda)
                state.lambda = false;
              return addErr ? style + " " + ERRORCLASS : style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase)
                return state.tokenize.isString ? CodeMirror5.Pass : 0;
              var scope = top(state), closing = scope.type == textAfter.charAt(0);
              if (scope.align != null)
                return scope.align - (closing ? 1 : 0);
              else
                return scope.offset - (closing ? hangingIndent : 0);
            },
            electricInput: /^\s*[\}\]\)]$/,
            closeBrackets: { triples: `'"` },
            lineComment: "#",
            fold: "indent"
          };
          return external;
        });
        CodeMirror5.defineMIME("text/x-python", "python");
        var words = function(str) {
          return str.split(" ");
        };
        CodeMirror5.defineMIME("text/x-cython", {
          name: "python",
          extra_keywords: words("by cdef cimport cpdef ctypedef enum except extern gil include nogil property public readonly struct union DEF IF ELIF ELSE")
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/q/q.js
  var require_q = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/q/q.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("q", function(config3) {
          var indentUnit = config3.indentUnit, curPunc, keywords2 = buildRE(["abs", "acos", "aj", "aj0", "all", "and", "any", "asc", "asin", "asof", "atan", "attr", "avg", "avgs", "bin", "by", "ceiling", "cols", "cor", "cos", "count", "cov", "cross", "csv", "cut", "delete", "deltas", "desc", "dev", "differ", "distinct", "div", "do", "each", "ej", "enlist", "eval", "except", "exec", "exit", "exp", "fby", "fills", "first", "fkeys", "flip", "floor", "from", "get", "getenv", "group", "gtime", "hclose", "hcount", "hdel", "hopen", "hsym", "iasc", "idesc", "if", "ij", "in", "insert", "inter", "inv", "key", "keys", "last", "like", "list", "lj", "load", "log", "lower", "lsq", "ltime", "ltrim", "mavg", "max", "maxs", "mcount", "md5", "mdev", "med", "meta", "min", "mins", "mmax", "mmin", "mmu", "mod", "msum", "neg", "next", "not", "null", "or", "over", "parse", "peach", "pj", "plist", "prd", "prds", "prev", "prior", "rand", "rank", "ratios", "raze", "read0", "read1", "reciprocal", "reverse", "rload", "rotate", "rsave", "rtrim", "save", "scan", "select", "set", "setenv", "show", "signum", "sin", "sqrt", "ss", "ssr", "string", "sublist", "sum", "sums", "sv", "system", "tables", "tan", "til", "trim", "txf", "type", "uj", "ungroup", "union", "update", "upper", "upsert", "value", "var", "view", "views", "vs", "wavg", "where", "where", "while", "within", "wj", "wj1", "wsum", "xasc", "xbar", "xcol", "xcols", "xdesc", "xexp", "xgroup", "xkey", "xlog", "xprev", "xrank"]), E = /[|/&^!+:\\\-*%$=~#;@><,?_\'\"\[\(\]\)\s{}]/;
          function buildRE(w3) {
            return new RegExp("^(" + w3.join("|") + ")$");
          }
          function tokenBase(stream, state) {
            var sol = stream.sol(), c3 = stream.next();
            curPunc = null;
            if (sol) {
              if (c3 == "/")
                return (state.tokenize = tokenLineComment)(stream, state);
              else if (c3 == "\\") {
                if (stream.eol() || /\s/.test(stream.peek()))
                  return stream.skipToEnd(), /^\\\s*$/.test(stream.current()) ? (state.tokenize = tokenCommentToEOF)(stream) : state.tokenize = tokenBase, "comment";
                else
                  return state.tokenize = tokenBase, "builtin";
              }
            }
            if (/\s/.test(c3))
              return stream.peek() == "/" ? (stream.skipToEnd(), "comment") : "whitespace";
            if (c3 == '"')
              return (state.tokenize = tokenString)(stream, state);
            if (c3 == "`")
              return stream.eatWhile(/[A-Za-z\d_:\/.]/), "symbol";
            if (c3 == "." && /\d/.test(stream.peek()) || /\d/.test(c3)) {
              var t3 = null;
              stream.backUp(1);
              if (stream.match(/^\d{4}\.\d{2}(m|\.\d{2}([DT](\d{2}(:\d{2}(:\d{2}(\.\d{1,9})?)?)?)?)?)/) || stream.match(/^\d+D(\d{2}(:\d{2}(:\d{2}(\.\d{1,9})?)?)?)/) || stream.match(/^\d{2}:\d{2}(:\d{2}(\.\d{1,9})?)?/) || stream.match(/^\d+[ptuv]{1}/))
                t3 = "temporal";
              else if (stream.match(/^0[NwW]{1}/) || stream.match(/^0x[\da-fA-F]*/) || stream.match(/^[01]+[b]{1}/) || stream.match(/^\d+[chijn]{1}/) || stream.match(/-?\d*(\.\d*)?(e[+\-]?\d+)?(e|f)?/))
                t3 = "number";
              return t3 && (!(c3 = stream.peek()) || E.test(c3)) ? t3 : (stream.next(), "error");
            }
            if (/[A-Za-z]|\./.test(c3))
              return stream.eatWhile(/[A-Za-z._\d]/), keywords2.test(stream.current()) ? "keyword" : "variable";
            if (/[|/&^!+:\\\-*%$=~#;@><\.,?_\']/.test(c3))
              return null;
            if (/[{}\(\[\]\)]/.test(c3))
              return null;
            return "error";
          }
          function tokenLineComment(stream, state) {
            return stream.skipToEnd(), /\/\s*$/.test(stream.current()) ? (state.tokenize = tokenBlockComment)(stream, state) : state.tokenize = tokenBase, "comment";
          }
          function tokenBlockComment(stream, state) {
            var f3 = stream.sol() && stream.peek() == "\\";
            stream.skipToEnd();
            if (f3 && /^\\\s*$/.test(stream.current()))
              state.tokenize = tokenBase;
            return "comment";
          }
          function tokenCommentToEOF(stream) {
            return stream.skipToEnd(), "comment";
          }
          function tokenString(stream, state) {
            var escaped = false, next, end = false;
            while (next = stream.next()) {
              if (next == '"' && !escaped) {
                end = true;
                break;
              }
              escaped = !escaped && next == "\\";
            }
            if (end)
              state.tokenize = tokenBase;
            return "string";
          }
          function pushContext(state, type, col) {
            state.context = { prev: state.context, indent: state.indent, col, type };
          }
          function popContext(state) {
            state.indent = state.context.indent;
            state.context = state.context.prev;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                context: null,
                indent: 0,
                col: 0
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (state.context && state.context.align == null)
                  state.context.align = false;
                state.indent = stream.indentation();
              }
              var style = state.tokenize(stream, state);
              if (style != "comment" && state.context && state.context.align == null && state.context.type != "pattern") {
                state.context.align = true;
              }
              if (curPunc == "(")
                pushContext(state, ")", stream.column());
              else if (curPunc == "[")
                pushContext(state, "]", stream.column());
              else if (curPunc == "{")
                pushContext(state, "}", stream.column());
              else if (/[\]\}\)]/.test(curPunc)) {
                while (state.context && state.context.type == "pattern")
                  popContext(state);
                if (state.context && curPunc == state.context.type)
                  popContext(state);
              } else if (curPunc == "." && state.context && state.context.type == "pattern")
                popContext(state);
              else if (/atom|string|variable/.test(style) && state.context) {
                if (/[\}\]]/.test(state.context.type))
                  pushContext(state, "pattern", stream.column());
                else if (state.context.type == "pattern" && !state.context.align) {
                  state.context.align = true;
                  state.context.col = stream.column();
                }
              }
              return style;
            },
            indent: function(state, textAfter) {
              var firstChar = textAfter && textAfter.charAt(0);
              var context = state.context;
              if (/[\]\}]/.test(firstChar))
                while (context && context.type == "pattern")
                  context = context.prev;
              var closing = context && firstChar == context.type;
              if (!context)
                return 0;
              else if (context.type == "pattern")
                return context.col;
              else if (context.align)
                return context.col + (closing ? 0 : 1);
              else
                return context.indent + (closing ? 0 : indentUnit);
            }
          };
        });
        CodeMirror5.defineMIME("text/x-q", "q");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/r/r.js
  var require_r = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/r/r.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.registerHelper("wordChars", "r", /[\w.]/);
        CodeMirror5.defineMode("r", function(config3) {
          function wordObj(words) {
            var res = {};
            for (var i3 = 0; i3 < words.length; ++i3)
              res[words[i3]] = true;
            return res;
          }
          var commonAtoms = ["NULL", "NA", "Inf", "NaN", "NA_integer_", "NA_real_", "NA_complex_", "NA_character_", "TRUE", "FALSE"];
          var commonBuiltins = ["list", "quote", "bquote", "eval", "return", "call", "parse", "deparse"];
          var commonKeywords = ["if", "else", "repeat", "while", "function", "for", "in", "next", "break"];
          var commonBlockKeywords = ["if", "else", "repeat", "while", "function", "for"];
          CodeMirror5.registerHelper("hintWords", "r", commonAtoms.concat(commonBuiltins, commonKeywords));
          var atoms = wordObj(commonAtoms);
          var builtins = wordObj(commonBuiltins);
          var keywords2 = wordObj(commonKeywords);
          var blockkeywords = wordObj(commonBlockKeywords);
          var opChars = /[+\-*\/^<>=!&|~$:]/;
          var curPunc;
          function tokenBase(stream, state) {
            curPunc = null;
            var ch = stream.next();
            if (ch == "#") {
              stream.skipToEnd();
              return "comment";
            } else if (ch == "0" && stream.eat("x")) {
              stream.eatWhile(/[\da-f]/i);
              return "number";
            } else if (ch == "." && stream.eat(/\d/)) {
              stream.match(/\d*(?:e[+\-]?\d+)?/);
              return "number";
            } else if (/\d/.test(ch)) {
              stream.match(/\d*(?:\.\d+)?(?:e[+\-]\d+)?L?/);
              return "number";
            } else if (ch == "'" || ch == '"') {
              state.tokenize = tokenString(ch);
              return "string";
            } else if (ch == "`") {
              stream.match(/[^`]+`/);
              return "variable-3";
            } else if (ch == "." && stream.match(/.[.\d]+/)) {
              return "keyword";
            } else if (/[\w\.]/.test(ch) && ch != "_") {
              stream.eatWhile(/[\w\.]/);
              var word = stream.current();
              if (atoms.propertyIsEnumerable(word))
                return "atom";
              if (keywords2.propertyIsEnumerable(word)) {
                if (blockkeywords.propertyIsEnumerable(word) && !stream.match(/\s*if(\s+|$)/, false))
                  curPunc = "block";
                return "keyword";
              }
              if (builtins.propertyIsEnumerable(word))
                return "builtin";
              return "variable";
            } else if (ch == "%") {
              if (stream.skipTo("%"))
                stream.next();
              return "operator variable-2";
            } else if (ch == "<" && stream.eat("-") || ch == "<" && stream.match("<-") || ch == "-" && stream.match(/>>?/)) {
              return "operator arrow";
            } else if (ch == "=" && state.ctx.argList) {
              return "arg-is";
            } else if (opChars.test(ch)) {
              if (ch == "$")
                return "operator dollar";
              stream.eatWhile(opChars);
              return "operator";
            } else if (/[\(\){}\[\];]/.test(ch)) {
              curPunc = ch;
              if (ch == ";")
                return "semi";
              return null;
            } else {
              return null;
            }
          }
          function tokenString(quote) {
            return function(stream, state) {
              if (stream.eat("\\")) {
                var ch = stream.next();
                if (ch == "x")
                  stream.match(/^[a-f0-9]{2}/i);
                else if ((ch == "u" || ch == "U") && stream.eat("{") && stream.skipTo("}"))
                  stream.next();
                else if (ch == "u")
                  stream.match(/^[a-f0-9]{4}/i);
                else if (ch == "U")
                  stream.match(/^[a-f0-9]{8}/i);
                else if (/[0-7]/.test(ch))
                  stream.match(/^[0-7]{1,2}/);
                return "string-2";
              } else {
                var next;
                while ((next = stream.next()) != null) {
                  if (next == quote) {
                    state.tokenize = tokenBase;
                    break;
                  }
                  if (next == "\\") {
                    stream.backUp(1);
                    break;
                  }
                }
                return "string";
              }
            };
          }
          var ALIGN_YES = 1, ALIGN_NO = 2, BRACELESS = 4;
          function push(state, type, stream) {
            state.ctx = {
              type,
              indent: state.indent,
              flags: 0,
              column: stream.column(),
              prev: state.ctx
            };
          }
          function setFlag(state, flag) {
            var ctx = state.ctx;
            state.ctx = {
              type: ctx.type,
              indent: ctx.indent,
              flags: ctx.flags | flag,
              column: ctx.column,
              prev: ctx.prev
            };
          }
          function pop(state) {
            state.indent = state.ctx.indent;
            state.ctx = state.ctx.prev;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                ctx: {
                  type: "top",
                  indent: -config3.indentUnit,
                  flags: ALIGN_NO
                },
                indent: 0,
                afterIdent: false
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if ((state.ctx.flags & 3) == 0)
                  state.ctx.flags |= ALIGN_NO;
                if (state.ctx.flags & BRACELESS)
                  pop(state);
                state.indent = stream.indentation();
              }
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              if (style != "comment" && (state.ctx.flags & ALIGN_NO) == 0)
                setFlag(state, ALIGN_YES);
              if ((curPunc == ";" || curPunc == "{" || curPunc == "}") && state.ctx.type == "block")
                pop(state);
              if (curPunc == "{")
                push(state, "}", stream);
              else if (curPunc == "(") {
                push(state, ")", stream);
                if (state.afterIdent)
                  state.ctx.argList = true;
              } else if (curPunc == "[")
                push(state, "]", stream);
              else if (curPunc == "block")
                push(state, "block", stream);
              else if (curPunc == state.ctx.type)
                pop(state);
              else if (state.ctx.type == "block" && style != "comment")
                setFlag(state, BRACELESS);
              state.afterIdent = style == "variable" || style == "keyword";
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase)
                return 0;
              var firstChar = textAfter && textAfter.charAt(0), ctx = state.ctx, closing = firstChar == ctx.type;
              if (ctx.flags & BRACELESS)
                ctx = ctx.prev;
              if (ctx.type == "block")
                return ctx.indent + (firstChar == "{" ? 0 : config3.indentUnit);
              else if (ctx.flags & ALIGN_YES)
                return ctx.column + (closing ? 0 : 1);
              else
                return ctx.indent + (closing ? 0 : config3.indentUnit);
            },
            lineComment: "#"
          };
        });
        CodeMirror5.defineMIME("text/x-rsrc", "r");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/rpm/rpm.js
  var require_rpm = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/rpm/rpm.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("rpm-changes", function() {
          var headerSeperator = /^-+$/;
          var headerLine = /^(Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)  ?\d{1,2} \d{2}:\d{2}(:\d{2})? [A-Z]{3,4} \d{4} - /;
          var simpleEmail = /^[\w+.-]+@[\w.-]+/;
          return {
            token: function(stream) {
              if (stream.sol()) {
                if (stream.match(headerSeperator)) {
                  return "tag";
                }
                if (stream.match(headerLine)) {
                  return "tag";
                }
              }
              if (stream.match(simpleEmail)) {
                return "string";
              }
              stream.next();
              return null;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-rpm-changes", "rpm-changes");
        CodeMirror5.defineMode("rpm-spec", function() {
          var arch = /^(i386|i586|i686|x86_64|ppc64le|ppc64|ppc|ia64|s390x|s390|sparc64|sparcv9|sparc|noarch|alphaev6|alpha|hppa|mipsel)/;
          var preamble = /^[a-zA-Z0-9()]+:/;
          var section = /^%(debug_package|package|description|prep|build|install|files|clean|changelog|preinstall|preun|postinstall|postun|pretrans|posttrans|pre|post|triggerin|triggerun|verifyscript|check|triggerpostun|triggerprein|trigger)/;
          var control_flow_complex = /^%(ifnarch|ifarch|if)/;
          var control_flow_simple = /^%(else|endif)/;
          var operators = /^(\!|\?|\<\=|\<|\>\=|\>|\=\=|\&\&|\|\|)/;
          return {
            startState: function() {
              return {
                controlFlow: false,
                macroParameters: false,
                section: false
              };
            },
            token: function(stream, state) {
              var ch = stream.peek();
              if (ch == "#") {
                stream.skipToEnd();
                return "comment";
              }
              if (stream.sol()) {
                if (stream.match(preamble)) {
                  return "header";
                }
                if (stream.match(section)) {
                  return "atom";
                }
              }
              if (stream.match(/^\$\w+/)) {
                return "def";
              }
              if (stream.match(/^\$\{\w+\}/)) {
                return "def";
              }
              if (stream.match(control_flow_simple)) {
                return "keyword";
              }
              if (stream.match(control_flow_complex)) {
                state.controlFlow = true;
                return "keyword";
              }
              if (state.controlFlow) {
                if (stream.match(operators)) {
                  return "operator";
                }
                if (stream.match(/^(\d+)/)) {
                  return "number";
                }
                if (stream.eol()) {
                  state.controlFlow = false;
                }
              }
              if (stream.match(arch)) {
                if (stream.eol()) {
                  state.controlFlow = false;
                }
                return "number";
              }
              if (stream.match(/^%[\w]+/)) {
                if (stream.match(/^\(/)) {
                  state.macroParameters = true;
                }
                return "keyword";
              }
              if (state.macroParameters) {
                if (stream.match(/^\d+/)) {
                  return "number";
                }
                if (stream.match(/^\)/)) {
                  state.macroParameters = false;
                  return "keyword";
                }
              }
              if (stream.match(/^%\{\??[\w \-\:\!]+\}/)) {
                if (stream.eol()) {
                  state.controlFlow = false;
                }
                return "def";
              }
              stream.next();
              return null;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-rpm-spec", "rpm-spec");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/stex/stex.js
  var require_stex = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/stex/stex.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("stex", function(_config, parserConfig) {
          "use strict";
          function pushCommand(state, command) {
            state.cmdState.push(command);
          }
          function peekCommand(state) {
            if (state.cmdState.length > 0) {
              return state.cmdState[state.cmdState.length - 1];
            } else {
              return null;
            }
          }
          function popCommand(state) {
            var plug = state.cmdState.pop();
            if (plug) {
              plug.closeBracket();
            }
          }
          function getMostPowerful(state) {
            var context = state.cmdState;
            for (var i3 = context.length - 1; i3 >= 0; i3--) {
              var plug = context[i3];
              if (plug.name == "DEFAULT") {
                continue;
              }
              return plug;
            }
            return { styleIdentifier: function() {
              return null;
            } };
          }
          function addPluginPattern(pluginName, cmdStyle, styles) {
            return function() {
              this.name = pluginName;
              this.bracketNo = 0;
              this.style = cmdStyle;
              this.styles = styles;
              this.argument = null;
              this.styleIdentifier = function() {
                return this.styles[this.bracketNo - 1] || null;
              };
              this.openBracket = function() {
                this.bracketNo++;
                return "bracket";
              };
              this.closeBracket = function() {
              };
            };
          }
          var plugins = {};
          plugins["importmodule"] = addPluginPattern("importmodule", "tag", ["string", "builtin"]);
          plugins["documentclass"] = addPluginPattern("documentclass", "tag", ["", "atom"]);
          plugins["usepackage"] = addPluginPattern("usepackage", "tag", ["atom"]);
          plugins["begin"] = addPluginPattern("begin", "tag", ["atom"]);
          plugins["end"] = addPluginPattern("end", "tag", ["atom"]);
          plugins["label"] = addPluginPattern("label", "tag", ["atom"]);
          plugins["ref"] = addPluginPattern("ref", "tag", ["atom"]);
          plugins["eqref"] = addPluginPattern("eqref", "tag", ["atom"]);
          plugins["cite"] = addPluginPattern("cite", "tag", ["atom"]);
          plugins["bibitem"] = addPluginPattern("bibitem", "tag", ["atom"]);
          plugins["Bibitem"] = addPluginPattern("Bibitem", "tag", ["atom"]);
          plugins["RBibitem"] = addPluginPattern("RBibitem", "tag", ["atom"]);
          plugins["DEFAULT"] = function() {
            this.name = "DEFAULT";
            this.style = "tag";
            this.styleIdentifier = this.openBracket = this.closeBracket = function() {
            };
          };
          function setState(state, f3) {
            state.f = f3;
          }
          function normal(source, state) {
            var plug;
            if (source.match(/^\\[a-zA-Z@]+/)) {
              var cmdName = source.current().slice(1);
              plug = plugins.hasOwnProperty(cmdName) ? plugins[cmdName] : plugins["DEFAULT"];
              plug = new plug();
              pushCommand(state, plug);
              setState(state, beginParams);
              return plug.style;
            }
            if (source.match(/^\\[$&%#{}_]/)) {
              return "tag";
            }
            if (source.match(/^\\[,;!\/\\]/)) {
              return "tag";
            }
            if (source.match("\\[")) {
              setState(state, function(source2, state2) {
                return inMathMode(source2, state2, "\\]");
              });
              return "keyword";
            }
            if (source.match("\\(")) {
              setState(state, function(source2, state2) {
                return inMathMode(source2, state2, "\\)");
              });
              return "keyword";
            }
            if (source.match("$$")) {
              setState(state, function(source2, state2) {
                return inMathMode(source2, state2, "$$");
              });
              return "keyword";
            }
            if (source.match("$")) {
              setState(state, function(source2, state2) {
                return inMathMode(source2, state2, "$");
              });
              return "keyword";
            }
            var ch = source.next();
            if (ch == "%") {
              source.skipToEnd();
              return "comment";
            } else if (ch == "}" || ch == "]") {
              plug = peekCommand(state);
              if (plug) {
                plug.closeBracket(ch);
                setState(state, beginParams);
              } else {
                return "error";
              }
              return "bracket";
            } else if (ch == "{" || ch == "[") {
              plug = plugins["DEFAULT"];
              plug = new plug();
              pushCommand(state, plug);
              return "bracket";
            } else if (/\d/.test(ch)) {
              source.eatWhile(/[\w.%]/);
              return "atom";
            } else {
              source.eatWhile(/[\w\-_]/);
              plug = getMostPowerful(state);
              if (plug.name == "begin") {
                plug.argument = source.current();
              }
              return plug.styleIdentifier();
            }
          }
          function inMathMode(source, state, endModeSeq) {
            if (source.eatSpace()) {
              return null;
            }
            if (endModeSeq && source.match(endModeSeq)) {
              setState(state, normal);
              return "keyword";
            }
            if (source.match(/^\\[a-zA-Z@]+/)) {
              return "tag";
            }
            if (source.match(/^[a-zA-Z]+/)) {
              return "variable-2";
            }
            if (source.match(/^\\[$&%#{}_]/)) {
              return "tag";
            }
            if (source.match(/^\\[,;!\/]/)) {
              return "tag";
            }
            if (source.match(/^[\^_&]/)) {
              return "tag";
            }
            if (source.match(/^[+\-<>|=,\/@!*:;'"`~#?]/)) {
              return null;
            }
            if (source.match(/^(\d+\.\d*|\d*\.\d+|\d+)/)) {
              return "number";
            }
            var ch = source.next();
            if (ch == "{" || ch == "}" || ch == "[" || ch == "]" || ch == "(" || ch == ")") {
              return "bracket";
            }
            if (ch == "%") {
              source.skipToEnd();
              return "comment";
            }
            return "error";
          }
          function beginParams(source, state) {
            var ch = source.peek(), lastPlug;
            if (ch == "{" || ch == "[") {
              lastPlug = peekCommand(state);
              lastPlug.openBracket(ch);
              source.eat(ch);
              setState(state, normal);
              return "bracket";
            }
            if (/[ \t\r]/.test(ch)) {
              source.eat(ch);
              return null;
            }
            setState(state, normal);
            popCommand(state);
            return normal(source, state);
          }
          return {
            startState: function() {
              var f3 = parserConfig.inMathMode ? function(source, state) {
                return inMathMode(source, state);
              } : normal;
              return {
                cmdState: [],
                f: f3
              };
            },
            copyState: function(s3) {
              return {
                cmdState: s3.cmdState.slice(),
                f: s3.f
              };
            },
            token: function(stream, state) {
              return state.f(stream, state);
            },
            blankLine: function(state) {
              state.f = normal;
              state.cmdState.length = 0;
            },
            lineComment: "%"
          };
        });
        CodeMirror5.defineMIME("text/x-stex", "stex");
        CodeMirror5.defineMIME("text/x-latex", "stex");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/rst/rst.js
  var require_rst = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/rst/rst.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_python(), require_stex(), require_overlay());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../python/python", "../stex/stex", "../../addon/mode/overlay"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("rst", function(config3, options) {
          var rx_strong = /^\*\*[^\*\s](?:[^\*]*[^\*\s])?\*\*/;
          var rx_emphasis = /^\*[^\*\s](?:[^\*]*[^\*\s])?\*/;
          var rx_literal = /^``[^`\s](?:[^`]*[^`\s])``/;
          var rx_number = /^(?:[\d]+(?:[\.,]\d+)*)/;
          var rx_positive = /^(?:\s\+[\d]+(?:[\.,]\d+)*)/;
          var rx_negative = /^(?:\s\-[\d]+(?:[\.,]\d+)*)/;
          var rx_uri_protocol = "[Hh][Tt][Tt][Pp][Ss]?://";
          var rx_uri_domain = "(?:[\\d\\w.-]+)\\.(?:\\w{2,6})";
          var rx_uri_path = "(?:/[\\d\\w\\#\\%\\&\\-\\.\\,\\/\\:\\=\\?\\~]+)*";
          var rx_uri = new RegExp("^" + rx_uri_protocol + rx_uri_domain + rx_uri_path);
          var overlay = {
            token: function(stream) {
              if (stream.match(rx_strong) && stream.match(/\W+|$/, false))
                return "strong";
              if (stream.match(rx_emphasis) && stream.match(/\W+|$/, false))
                return "em";
              if (stream.match(rx_literal) && stream.match(/\W+|$/, false))
                return "string-2";
              if (stream.match(rx_number))
                return "number";
              if (stream.match(rx_positive))
                return "positive";
              if (stream.match(rx_negative))
                return "negative";
              if (stream.match(rx_uri))
                return "link";
              while (stream.next() != null) {
                if (stream.match(rx_strong, false))
                  break;
                if (stream.match(rx_emphasis, false))
                  break;
                if (stream.match(rx_literal, false))
                  break;
                if (stream.match(rx_number, false))
                  break;
                if (stream.match(rx_positive, false))
                  break;
                if (stream.match(rx_negative, false))
                  break;
                if (stream.match(rx_uri, false))
                  break;
              }
              return null;
            }
          };
          var mode2 = CodeMirror5.getMode(config3, options.backdrop || "rst-base");
          return CodeMirror5.overlayMode(mode2, overlay, true);
        }, "python", "stex");
        CodeMirror5.defineMode("rst-base", function(config3) {
          function format5(string2) {
            var args = Array.prototype.slice.call(arguments, 1);
            return string2.replace(/{(\d+)}/g, function(match, n3) {
              return typeof args[n3] != "undefined" ? args[n3] : match;
            });
          }
          var mode_python = CodeMirror5.getMode(config3, "python");
          var mode_stex = CodeMirror5.getMode(config3, "stex");
          var SEPA = "\\s+";
          var TAIL = "(?:\\s*|\\W|$)", rx_TAIL = new RegExp(format5("^{0}", TAIL));
          var NAME = `(?:[^\\W\\d_](?:[\\w!"#$%&'()\\*\\+,\\-\\./:;<=>\\?]*[^\\W_])?)`, rx_NAME = new RegExp(format5("^{0}", NAME));
          var NAME_WWS = `(?:[^\\W\\d_](?:[\\w\\s!"#$%&'()\\*\\+,\\-\\./:;<=>\\?]*[^\\W_])?)`;
          var REF_NAME = format5("(?:{0}|`{1}`)", NAME, NAME_WWS);
          var TEXT1 = "(?:[^\\s\\|](?:[^\\|]*[^\\s\\|])?)";
          var TEXT2 = "(?:[^\\`]+)", rx_TEXT2 = new RegExp(format5("^{0}", TEXT2));
          var rx_section = new RegExp("^([!'#$%&\"()*+,-./:;<=>?@\\[\\\\\\]^_`{|}~])\\1{3,}\\s*$");
          var rx_explicit = new RegExp(format5("^\\.\\.{0}", SEPA));
          var rx_link = new RegExp(format5("^_{0}:{1}|^__:{1}", REF_NAME, TAIL));
          var rx_directive = new RegExp(format5("^{0}::{1}", REF_NAME, TAIL));
          var rx_substitution = new RegExp(format5("^\\|{0}\\|{1}{2}::{3}", TEXT1, SEPA, REF_NAME, TAIL));
          var rx_footnote = new RegExp(format5("^\\[(?:\\d+|#{0}?|\\*)]{1}", REF_NAME, TAIL));
          var rx_citation = new RegExp(format5("^\\[{0}\\]{1}", REF_NAME, TAIL));
          var rx_substitution_ref = new RegExp(format5("^\\|{0}\\|", TEXT1));
          var rx_footnote_ref = new RegExp(format5("^\\[(?:\\d+|#{0}?|\\*)]_", REF_NAME));
          var rx_citation_ref = new RegExp(format5("^\\[{0}\\]_", REF_NAME));
          var rx_link_ref1 = new RegExp(format5("^{0}__?", REF_NAME));
          var rx_link_ref2 = new RegExp(format5("^`{0}`_", TEXT2));
          var rx_role_pre = new RegExp(format5("^:{0}:`{1}`{2}", NAME, TEXT2, TAIL));
          var rx_role_suf = new RegExp(format5("^`{1}`:{0}:{2}", NAME, TEXT2, TAIL));
          var rx_role = new RegExp(format5("^:{0}:{1}", NAME, TAIL));
          var rx_directive_name = new RegExp(format5("^{0}", REF_NAME));
          var rx_directive_tail = new RegExp(format5("^::{0}", TAIL));
          var rx_substitution_text = new RegExp(format5("^\\|{0}\\|", TEXT1));
          var rx_substitution_sepa = new RegExp(format5("^{0}", SEPA));
          var rx_substitution_name = new RegExp(format5("^{0}", REF_NAME));
          var rx_substitution_tail = new RegExp(format5("^::{0}", TAIL));
          var rx_link_head = new RegExp("^_");
          var rx_link_name = new RegExp(format5("^{0}|_", REF_NAME));
          var rx_link_tail = new RegExp(format5("^:{0}", TAIL));
          var rx_verbatim = new RegExp("^::\\s*$");
          var rx_examples = new RegExp("^\\s+(?:>>>|In \\[\\d+\\]:)\\s");
          function to_normal(stream, state) {
            var token = null;
            if (stream.sol() && stream.match(rx_examples, false)) {
              change(state, to_mode, {
                mode: mode_python,
                local: CodeMirror5.startState(mode_python)
              });
            } else if (stream.sol() && stream.match(rx_explicit)) {
              change(state, to_explicit);
              token = "meta";
            } else if (stream.sol() && stream.match(rx_section)) {
              change(state, to_normal);
              token = "header";
            } else if (phase(state) == rx_role_pre || stream.match(rx_role_pre, false)) {
              switch (stage(state)) {
                case 0:
                  change(state, to_normal, context(rx_role_pre, 1));
                  stream.match(/^:/);
                  token = "meta";
                  break;
                case 1:
                  change(state, to_normal, context(rx_role_pre, 2));
                  stream.match(rx_NAME);
                  token = "keyword";
                  if (stream.current().match(/^(?:math|latex)/)) {
                    state.tmp_stex = true;
                  }
                  break;
                case 2:
                  change(state, to_normal, context(rx_role_pre, 3));
                  stream.match(/^:`/);
                  token = "meta";
                  break;
                case 3:
                  if (state.tmp_stex) {
                    state.tmp_stex = void 0;
                    state.tmp = {
                      mode: mode_stex,
                      local: CodeMirror5.startState(mode_stex)
                    };
                  }
                  if (state.tmp) {
                    if (stream.peek() == "`") {
                      change(state, to_normal, context(rx_role_pre, 4));
                      state.tmp = void 0;
                      break;
                    }
                    token = state.tmp.mode.token(stream, state.tmp.local);
                    break;
                  }
                  change(state, to_normal, context(rx_role_pre, 4));
                  stream.match(rx_TEXT2);
                  token = "string";
                  break;
                case 4:
                  change(state, to_normal, context(rx_role_pre, 5));
                  stream.match(/^`/);
                  token = "meta";
                  break;
                case 5:
                  change(state, to_normal, context(rx_role_pre, 6));
                  stream.match(rx_TAIL);
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (phase(state) == rx_role_suf || stream.match(rx_role_suf, false)) {
              switch (stage(state)) {
                case 0:
                  change(state, to_normal, context(rx_role_suf, 1));
                  stream.match(/^`/);
                  token = "meta";
                  break;
                case 1:
                  change(state, to_normal, context(rx_role_suf, 2));
                  stream.match(rx_TEXT2);
                  token = "string";
                  break;
                case 2:
                  change(state, to_normal, context(rx_role_suf, 3));
                  stream.match(/^`:/);
                  token = "meta";
                  break;
                case 3:
                  change(state, to_normal, context(rx_role_suf, 4));
                  stream.match(rx_NAME);
                  token = "keyword";
                  break;
                case 4:
                  change(state, to_normal, context(rx_role_suf, 5));
                  stream.match(/^:/);
                  token = "meta";
                  break;
                case 5:
                  change(state, to_normal, context(rx_role_suf, 6));
                  stream.match(rx_TAIL);
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (phase(state) == rx_role || stream.match(rx_role, false)) {
              switch (stage(state)) {
                case 0:
                  change(state, to_normal, context(rx_role, 1));
                  stream.match(/^:/);
                  token = "meta";
                  break;
                case 1:
                  change(state, to_normal, context(rx_role, 2));
                  stream.match(rx_NAME);
                  token = "keyword";
                  break;
                case 2:
                  change(state, to_normal, context(rx_role, 3));
                  stream.match(/^:/);
                  token = "meta";
                  break;
                case 3:
                  change(state, to_normal, context(rx_role, 4));
                  stream.match(rx_TAIL);
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (phase(state) == rx_substitution_ref || stream.match(rx_substitution_ref, false)) {
              switch (stage(state)) {
                case 0:
                  change(state, to_normal, context(rx_substitution_ref, 1));
                  stream.match(rx_substitution_text);
                  token = "variable-2";
                  break;
                case 1:
                  change(state, to_normal, context(rx_substitution_ref, 2));
                  if (stream.match(/^_?_?/))
                    token = "link";
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (stream.match(rx_footnote_ref)) {
              change(state, to_normal);
              token = "quote";
            } else if (stream.match(rx_citation_ref)) {
              change(state, to_normal);
              token = "quote";
            } else if (stream.match(rx_link_ref1)) {
              change(state, to_normal);
              if (!stream.peek() || stream.peek().match(/^\W$/)) {
                token = "link";
              }
            } else if (phase(state) == rx_link_ref2 || stream.match(rx_link_ref2, false)) {
              switch (stage(state)) {
                case 0:
                  if (!stream.peek() || stream.peek().match(/^\W$/)) {
                    change(state, to_normal, context(rx_link_ref2, 1));
                  } else {
                    stream.match(rx_link_ref2);
                  }
                  break;
                case 1:
                  change(state, to_normal, context(rx_link_ref2, 2));
                  stream.match(/^`/);
                  token = "link";
                  break;
                case 2:
                  change(state, to_normal, context(rx_link_ref2, 3));
                  stream.match(rx_TEXT2);
                  break;
                case 3:
                  change(state, to_normal, context(rx_link_ref2, 4));
                  stream.match(/^`_/);
                  token = "link";
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (stream.match(rx_verbatim)) {
              change(state, to_verbatim);
            } else {
              if (stream.next())
                change(state, to_normal);
            }
            return token;
          }
          function to_explicit(stream, state) {
            var token = null;
            if (phase(state) == rx_substitution || stream.match(rx_substitution, false)) {
              switch (stage(state)) {
                case 0:
                  change(state, to_explicit, context(rx_substitution, 1));
                  stream.match(rx_substitution_text);
                  token = "variable-2";
                  break;
                case 1:
                  change(state, to_explicit, context(rx_substitution, 2));
                  stream.match(rx_substitution_sepa);
                  break;
                case 2:
                  change(state, to_explicit, context(rx_substitution, 3));
                  stream.match(rx_substitution_name);
                  token = "keyword";
                  break;
                case 3:
                  change(state, to_explicit, context(rx_substitution, 4));
                  stream.match(rx_substitution_tail);
                  token = "meta";
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (phase(state) == rx_directive || stream.match(rx_directive, false)) {
              switch (stage(state)) {
                case 0:
                  change(state, to_explicit, context(rx_directive, 1));
                  stream.match(rx_directive_name);
                  token = "keyword";
                  if (stream.current().match(/^(?:math|latex)/))
                    state.tmp_stex = true;
                  else if (stream.current().match(/^python/))
                    state.tmp_py = true;
                  break;
                case 1:
                  change(state, to_explicit, context(rx_directive, 2));
                  stream.match(rx_directive_tail);
                  token = "meta";
                  if (stream.match(/^latex\s*$/) || state.tmp_stex) {
                    state.tmp_stex = void 0;
                    change(state, to_mode, {
                      mode: mode_stex,
                      local: CodeMirror5.startState(mode_stex)
                    });
                  }
                  break;
                case 2:
                  change(state, to_explicit, context(rx_directive, 3));
                  if (stream.match(/^python\s*$/) || state.tmp_py) {
                    state.tmp_py = void 0;
                    change(state, to_mode, {
                      mode: mode_python,
                      local: CodeMirror5.startState(mode_python)
                    });
                  }
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (phase(state) == rx_link || stream.match(rx_link, false)) {
              switch (stage(state)) {
                case 0:
                  change(state, to_explicit, context(rx_link, 1));
                  stream.match(rx_link_head);
                  stream.match(rx_link_name);
                  token = "link";
                  break;
                case 1:
                  change(state, to_explicit, context(rx_link, 2));
                  stream.match(rx_link_tail);
                  token = "meta";
                  break;
                default:
                  change(state, to_normal);
              }
            } else if (stream.match(rx_footnote)) {
              change(state, to_normal);
              token = "quote";
            } else if (stream.match(rx_citation)) {
              change(state, to_normal);
              token = "quote";
            } else {
              stream.eatSpace();
              if (stream.eol()) {
                change(state, to_normal);
              } else {
                stream.skipToEnd();
                change(state, to_comment);
                token = "comment";
              }
            }
            return token;
          }
          function to_comment(stream, state) {
            return as_block(stream, state, "comment");
          }
          function to_verbatim(stream, state) {
            return as_block(stream, state, "meta");
          }
          function as_block(stream, state, token) {
            if (stream.eol() || stream.eatSpace()) {
              stream.skipToEnd();
              return token;
            } else {
              change(state, to_normal);
              return null;
            }
          }
          function to_mode(stream, state) {
            if (state.ctx.mode && state.ctx.local) {
              if (stream.sol()) {
                if (!stream.eatSpace())
                  change(state, to_normal);
                return null;
              }
              return state.ctx.mode.token(stream, state.ctx.local);
            }
            change(state, to_normal);
            return null;
          }
          function context(phase2, stage2, mode2, local) {
            return { phase: phase2, stage: stage2, mode: mode2, local };
          }
          function change(state, tok, ctx) {
            state.tok = tok;
            state.ctx = ctx || {};
          }
          function stage(state) {
            return state.ctx.stage || 0;
          }
          function phase(state) {
            return state.ctx.phase;
          }
          return {
            startState: function() {
              return { tok: to_normal, ctx: context(void 0, 0) };
            },
            copyState: function(state) {
              var ctx = state.ctx, tmp = state.tmp;
              if (ctx.local)
                ctx = { mode: ctx.mode, local: CodeMirror5.copyState(ctx.mode, ctx.local) };
              if (tmp)
                tmp = { mode: tmp.mode, local: CodeMirror5.copyState(tmp.mode, tmp.local) };
              return { tok: state.tok, ctx, tmp };
            },
            innerMode: function(state) {
              return state.tmp ? { state: state.tmp.local, mode: state.tmp.mode } : state.ctx.mode ? { state: state.ctx.local, mode: state.ctx.mode } : null;
            },
            token: function(stream, state) {
              return state.tok(stream, state);
            }
          };
        }, "python", "stex");
        CodeMirror5.defineMIME("text/x-rst", "rst");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/rust/rust.js
  var require_rust = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/rust/rust.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_simple());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../../addon/mode/simple"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineSimpleMode("rust", {
          start: [
            { regex: /b?"/, token: "string", next: "string" },
            { regex: /b?r"/, token: "string", next: "string_raw" },
            { regex: /b?r#+"/, token: "string", next: "string_raw_hash" },
            { regex: /'(?:[^'\\]|\\(?:[nrt0'"]|x[\da-fA-F]{2}|u\{[\da-fA-F]{6}\}))'/, token: "string-2" },
            { regex: /b'(?:[^']|\\(?:['\\nrt0]|x[\da-fA-F]{2}))'/, token: "string-2" },
            {
              regex: /(?:(?:[0-9][0-9_]*)(?:(?:[Ee][+-]?[0-9_]+)|\.[0-9_]+(?:[Ee][+-]?[0-9_]+)?)(?:f32|f64)?)|(?:0(?:b[01_]+|(?:o[0-7_]+)|(?:x[0-9a-fA-F_]+))|(?:[0-9][0-9_]*))(?:u8|u16|u32|u64|i8|i16|i32|i64|isize|usize)?/,
              token: "number"
            },
            { regex: /(let(?:\s+mut)?|fn|enum|mod|struct|type|union)(\s+)([a-zA-Z_][a-zA-Z0-9_]*)/, token: ["keyword", null, "def"] },
            { regex: /(?:abstract|alignof|as|async|await|box|break|continue|const|crate|do|dyn|else|enum|extern|fn|for|final|if|impl|in|loop|macro|match|mod|move|offsetof|override|priv|proc|pub|pure|ref|return|self|sizeof|static|struct|super|trait|type|typeof|union|unsafe|unsized|use|virtual|where|while|yield)\b/, token: "keyword" },
            { regex: /\b(?:Self|isize|usize|char|bool|u8|u16|u32|u64|f16|f32|f64|i8|i16|i32|i64|str|Option)\b/, token: "atom" },
            { regex: /\b(?:true|false|Some|None|Ok|Err)\b/, token: "builtin" },
            {
              regex: /\b(fn)(\s+)([a-zA-Z_][a-zA-Z0-9_]*)/,
              token: ["keyword", null, "def"]
            },
            { regex: /#!?\[.*\]/, token: "meta" },
            { regex: /\/\/.*/, token: "comment" },
            { regex: /\/\*/, token: "comment", next: "comment" },
            { regex: /[-+\/*=<>!]+/, token: "operator" },
            { regex: /[a-zA-Z_]\w*!/, token: "variable-3" },
            { regex: /[a-zA-Z_]\w*/, token: "variable" },
            { regex: /[\{\[\(]/, indent: true },
            { regex: /[\}\]\)]/, dedent: true }
          ],
          string: [
            { regex: /"/, token: "string", next: "start" },
            { regex: /(?:[^\\"]|\\(?:.|$))*/, token: "string" }
          ],
          string_raw: [
            { regex: /"/, token: "string", next: "start" },
            { regex: /[^"]*/, token: "string" }
          ],
          string_raw_hash: [
            { regex: /"#+/, token: "string", next: "start" },
            { regex: /(?:[^"]|"(?!#))*/, token: "string" }
          ],
          comment: [
            { regex: /.*?\*\//, token: "comment", next: "start" },
            { regex: /.*/, token: "comment" }
          ],
          meta: {
            dontIndentStates: ["comment"],
            electricInput: /^\s*\}$/,
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//",
            fold: "brace"
          }
        });
        CodeMirror5.defineMIME("text/x-rustsrc", "rust");
        CodeMirror5.defineMIME("text/rust", "rust");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/sas/sas.js
  var require_sas = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/sas/sas.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("sas", function() {
          var words = {};
          var isDoubleOperatorSym = {
            eq: "operator",
            lt: "operator",
            le: "operator",
            gt: "operator",
            ge: "operator",
            "in": "operator",
            ne: "operator",
            or: "operator"
          };
          var isDoubleOperatorChar = /(<=|>=|!=|<>)/;
          var isSingleOperatorChar = /[=\(:\),{}.*<>+\-\/^\[\]]/;
          function define2(style, string2, context) {
            if (context) {
              var split = string2.split(" ");
              for (var i3 = 0; i3 < split.length; i3++) {
                words[split[i3]] = { style, state: context };
              }
            }
          }
          define2("def", "stack pgm view source debug nesting nolist", ["inDataStep"]);
          define2("def", "if while until for do do; end end; then else cancel", ["inDataStep"]);
          define2("def", "label format _n_ _error_", ["inDataStep"]);
          define2("def", "ALTER BUFNO BUFSIZE CNTLLEV COMPRESS DLDMGACTION ENCRYPT ENCRYPTKEY EXTENDOBSCOUNTER GENMAX GENNUM INDEX LABEL OBSBUF OUTREP PW PWREQ READ REPEMPTY REPLACE REUSE ROLE SORTEDBY SPILL TOBSNO TYPE WRITE FILECLOSE FIRSTOBS IN OBS POINTOBS WHERE WHEREUP IDXNAME IDXWHERE DROP KEEP RENAME", ["inDataStep"]);
          define2("def", "filevar finfo finv fipname fipnamel fipstate first firstobs floor", ["inDataStep"]);
          define2("def", "varfmt varinfmt varlabel varlen varname varnum varray varrayx vartype verify vformat vformatd vformatdx vformatn vformatnx vformatw vformatwx vformatx vinarray vinarrayx vinformat vinformatd vinformatdx vinformatn vinformatnx vinformatw vinformatwx vinformatx vlabel vlabelx vlength vlengthx vname vnamex vnferr vtype vtypex weekday", ["inDataStep"]);
          define2("def", "zipfips zipname zipnamel zipstate", ["inDataStep"]);
          define2("def", "put putc putn", ["inDataStep"]);
          define2("builtin", "data run", ["inDataStep"]);
          define2("def", "data", ["inProc"]);
          define2("def", "%if %end %end; %else %else; %do %do; %then", ["inMacro"]);
          define2("builtin", "proc run; quit; libname filename %macro %mend option options", ["ALL"]);
          define2("def", "footnote title libname ods", ["ALL"]);
          define2("def", "%let %put %global %sysfunc %eval ", ["ALL"]);
          define2("variable", "&sysbuffr &syscc &syscharwidth &syscmd &sysdate &sysdate9 &sysday &sysdevic &sysdmg &sysdsn &sysencoding &sysenv &syserr &syserrortext &sysfilrc &syshostname &sysindex &sysinfo &sysjobid &syslast &syslckrc &syslibrc &syslogapplname &sysmacroname &sysmenv &sysmsg &sysncpu &sysodspath &sysparm &syspbuff &sysprocessid &sysprocessname &sysprocname &sysrc &sysscp &sysscpl &sysscpl &syssite &sysstartid &sysstartname &systcpiphostname &systime &sysuserid &sysver &sysvlong &sysvlong4 &syswarningtext", ["ALL"]);
          define2("def", "source2 nosource2 page pageno pagesize", ["ALL"]);
          define2("def", "_all_ _character_ _cmd_ _freq_ _i_ _infile_ _last_ _msg_ _null_ _numeric_ _temporary_ _type_ abort abs addr adjrsq airy alpha alter altlog altprint and arcos array arsin as atan attrc attrib attrn authserver autoexec awscontrol awsdef awsmenu awsmenumerge awstitle backward band base betainv between blocksize blshift bnot bor brshift bufno bufsize bxor by byerr byline byte calculated call cards cards4 catcache cbufno cdf ceil center cexist change chisq cinv class cleanup close cnonct cntllev coalesce codegen col collate collin column comamid comaux1 comaux2 comdef compbl compound compress config continue convert cos cosh cpuid create cross crosstab css curobs cv daccdb daccdbsl daccsl daccsyd dacctab dairy datalines datalines4 datejul datepart datetime day dbcslang dbcstype dclose ddm delete delimiter depdb depdbsl depsl depsyd deptab dequote descending descript design= device dflang dhms dif digamma dim dinfo display distinct dkricond dkrocond dlm dnum do dopen doptname doptnum dread drop dropnote dsname dsnferr echo else emaildlg emailid emailpw emailserver emailsys encrypt end endsas engine eof eov erf erfc error errorcheck errors exist exp fappend fclose fcol fdelete feedback fetch fetchobs fexist fget file fileclose fileexist filefmt filename fileref  fmterr fmtsearch fnonct fnote font fontalias  fopen foptname foptnum force formatted formchar formdelim formdlim forward fpoint fpos fput fread frewind frlen from fsep fuzz fwrite gaminv gamma getoption getvarc getvarn go goto group gwindow hbar hbound helpenv helploc hms honorappearance hosthelp hostprint hour hpct html hvar ibessel ibr id if index indexc indexw initcmd initstmt inner input inputc inputn inr insert int intck intnx into intrr invaliddata irr is jbessel join juldate keep kentb kurtosis label lag last lbound leave left length levels lgamma lib  library libref line linesize link list log log10 log2 logpdf logpmf logsdf lostcard lowcase lrecl ls macro macrogen maps mautosource max maxdec maxr mdy mean measures median memtype merge merror min minute missing missover mlogic mod mode model modify month mopen mort mprint mrecall msglevel msymtabmax mvarsize myy n nest netpv new news nmiss no nobatch nobs nocaps nocardimage nocenter nocharcode nocmdmac nocol nocum nodate nodbcs nodetails nodmr nodms nodmsbatch nodup nodupkey noduplicates noechoauto noequals noerrorabend noexitwindows nofullstimer noicon noimplmac noint nolist noloadlist nomiss nomlogic nomprint nomrecall nomsgcase nomstored nomultenvappl nonotes nonumber noobs noovp nopad nopercent noprint noprintinit normal norow norsasuser nosetinit  nosplash nosymbolgen note notes notitle notitles notsorted noverbose noxsync noxwait npv null number numkeys nummousekeys nway obs  on open     order ordinal otherwise out outer outp= output over ovp p(1 5 10 25 50 75 90 95 99) pad pad2  paired parm parmcards path pathdll pathname pdf peek peekc pfkey pmf point poisson poke position printer probbeta probbnml probchi probf probgam probhypr probit probnegb probnorm probsig probt procleave prt ps  pw pwreq qtr quote r ranbin rancau ranexp rangam range ranks rannor ranpoi rantbl rantri ranuni read recfm register regr remote remove rename repeat replace resolve retain return reuse reverse rewind right round rsquare rtf rtrace rtraceloc s s2 samploc sasautos sascontrol sasfrscr sasmsg sasmstore sasscript sasuser saving scan sdf second select selection separated seq serror set setcomm setot sign simple sin sinh siteinfo skewness skip sle sls sortedby sortpgm sortseq sortsize soundex  spedis splashlocation split spool sqrt start std stderr stdin stfips stimer stname stnamel stop stopover subgroup subpopn substr sum sumwgt symbol symbolgen symget symput sysget sysin sysleave sysmsg sysparm sysprint sysprintfont sysprod sysrc system t table tables tan tanh tapeclose tbufsize terminal test then timepart tinv  tnonct to today tol tooldef totper transformout translate trantab tranwrd trigamma trim trimn trunc truncover type unformatted uniform union until upcase update user usericon uss validate value var  weight when where while wincharset window work workinit workterm write wsum xsync xwait yearcutoff yes yyq  min max", ["inDataStep", "inProc"]);
          define2("operator", "and not ", ["inDataStep", "inProc"]);
          function tokenize(stream, state) {
            var ch = stream.next();
            if (ch === "/" && stream.eat("*")) {
              state.continueComment = true;
              return "comment";
            } else if (state.continueComment === true) {
              if (ch === "*" && stream.peek() === "/") {
                stream.next();
                state.continueComment = false;
              } else if (stream.skipTo("*")) {
                stream.skipTo("*");
                stream.next();
                if (stream.eat("/"))
                  state.continueComment = false;
              } else {
                stream.skipToEnd();
              }
              return "comment";
            }
            if (ch == "*" && stream.column() == stream.indentation()) {
              stream.skipToEnd();
              return "comment";
            }
            var doubleOperator = ch + stream.peek();
            if ((ch === '"' || ch === "'") && !state.continueString) {
              state.continueString = ch;
              return "string";
            } else if (state.continueString) {
              if (state.continueString == ch) {
                state.continueString = null;
              } else if (stream.skipTo(state.continueString)) {
                stream.next();
                state.continueString = null;
              } else {
                stream.skipToEnd();
              }
              return "string";
            } else if (state.continueString !== null && stream.eol()) {
              stream.skipTo(state.continueString) || stream.skipToEnd();
              return "string";
            } else if (/[\d\.]/.test(ch)) {
              if (ch === ".")
                stream.match(/^[0-9]+([eE][\-+]?[0-9]+)?/);
              else if (ch === "0")
                stream.match(/^[xX][0-9a-fA-F]+/) || stream.match(/^0[0-7]+/);
              else
                stream.match(/^[0-9]*\.?[0-9]*([eE][\-+]?[0-9]+)?/);
              return "number";
            } else if (isDoubleOperatorChar.test(ch + stream.peek())) {
              stream.next();
              return "operator";
            } else if (isDoubleOperatorSym.hasOwnProperty(doubleOperator)) {
              stream.next();
              if (stream.peek() === " ")
                return isDoubleOperatorSym[doubleOperator.toLowerCase()];
            } else if (isSingleOperatorChar.test(ch)) {
              return "operator";
            }
            var word;
            if (stream.match(/[%&;\w]+/, false) != null) {
              word = ch + stream.match(/[%&;\w]+/, true);
              if (/&/.test(word))
                return "variable";
            } else {
              word = ch;
            }
            if (state.nextword) {
              stream.match(/[\w]+/);
              if (stream.peek() === ".")
                stream.skipTo(" ");
              state.nextword = false;
              return "variable-2";
            }
            word = word.toLowerCase();
            if (state.inDataStep) {
              if (word === "run;" || stream.match(/run\s;/)) {
                state.inDataStep = false;
                return "builtin";
              }
              if (word && stream.next() === ".") {
                if (/\w/.test(stream.peek()))
                  return "variable-2";
                else
                  return "variable";
              }
              if (word && words.hasOwnProperty(word) && (words[word].state.indexOf("inDataStep") !== -1 || words[word].state.indexOf("ALL") !== -1)) {
                if (stream.start < stream.pos)
                  stream.backUp(stream.pos - stream.start);
                for (var i3 = 0; i3 < word.length; ++i3)
                  stream.next();
                return words[word].style;
              }
            }
            if (state.inProc) {
              if (word === "run;" || word === "quit;") {
                state.inProc = false;
                return "builtin";
              }
              if (word && words.hasOwnProperty(word) && (words[word].state.indexOf("inProc") !== -1 || words[word].state.indexOf("ALL") !== -1)) {
                stream.match(/[\w]+/);
                return words[word].style;
              }
            }
            if (state.inMacro) {
              if (word === "%mend") {
                if (stream.peek() === ";")
                  stream.next();
                state.inMacro = false;
                return "builtin";
              }
              if (word && words.hasOwnProperty(word) && (words[word].state.indexOf("inMacro") !== -1 || words[word].state.indexOf("ALL") !== -1)) {
                stream.match(/[\w]+/);
                return words[word].style;
              }
              return "atom";
            }
            if (word && words.hasOwnProperty(word)) {
              stream.backUp(1);
              stream.match(/[\w]+/);
              if (word === "data" && /=/.test(stream.peek()) === false) {
                state.inDataStep = true;
                state.nextword = true;
                return "builtin";
              }
              if (word === "proc") {
                state.inProc = true;
                state.nextword = true;
                return "builtin";
              }
              if (word === "%macro") {
                state.inMacro = true;
                state.nextword = true;
                return "builtin";
              }
              if (/title[1-9]/.test(word))
                return "def";
              if (word === "footnote") {
                stream.eat(/[1-9]/);
                return "def";
              }
              if (state.inDataStep === true && words[word].state.indexOf("inDataStep") !== -1)
                return words[word].style;
              if (state.inProc === true && words[word].state.indexOf("inProc") !== -1)
                return words[word].style;
              if (state.inMacro === true && words[word].state.indexOf("inMacro") !== -1)
                return words[word].style;
              if (words[word].state.indexOf("ALL") !== -1)
                return words[word].style;
              return null;
            }
            return null;
          }
          return {
            startState: function() {
              return {
                inDataStep: false,
                inProc: false,
                inMacro: false,
                nextword: false,
                continueString: null,
                continueComment: false
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return tokenize(stream, state);
            },
            blockCommentStart: "/*",
            blockCommentEnd: "*/"
          };
        });
        CodeMirror5.defineMIME("text/x-sas", "sas");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/sass/sass.js
  var require_sass = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/sass/sass.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_css());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../css/css"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("sass", function(config3) {
          var cssMode = CodeMirror5.mimeModes["text/css"];
          var propertyKeywords = cssMode.propertyKeywords || {}, colorKeywords = cssMode.colorKeywords || {}, valueKeywords = cssMode.valueKeywords || {}, fontProperties = cssMode.fontProperties || {};
          function tokenRegexp(words) {
            return new RegExp("^" + words.join("|"));
          }
          var keywords2 = ["true", "false", "null", "auto"];
          var keywordsRegexp = new RegExp("^" + keywords2.join("|"));
          var operators = [
            "\\(",
            "\\)",
            "=",
            ">",
            "<",
            "==",
            ">=",
            "<=",
            "\\+",
            "-",
            "\\!=",
            "/",
            "\\*",
            "%",
            "and",
            "or",
            "not",
            ";",
            "\\{",
            "\\}",
            ":"
          ];
          var opRegexp = tokenRegexp(operators);
          var pseudoElementsRegexp = /^::?[a-zA-Z_][\w\-]*/;
          var word;
          function isEndLine(stream) {
            return !stream.peek() || stream.match(/\s+$/, false);
          }
          function urlTokens(stream, state) {
            var ch = stream.peek();
            if (ch === ")") {
              stream.next();
              state.tokenizer = tokenBase;
              return "operator";
            } else if (ch === "(") {
              stream.next();
              stream.eatSpace();
              return "operator";
            } else if (ch === "'" || ch === '"') {
              state.tokenizer = buildStringTokenizer(stream.next());
              return "string";
            } else {
              state.tokenizer = buildStringTokenizer(")", false);
              return "string";
            }
          }
          function comment(indentation, multiLine) {
            return function(stream, state) {
              if (stream.sol() && stream.indentation() <= indentation) {
                state.tokenizer = tokenBase;
                return tokenBase(stream, state);
              }
              if (multiLine && stream.skipTo("*/")) {
                stream.next();
                stream.next();
                state.tokenizer = tokenBase;
              } else {
                stream.skipToEnd();
              }
              return "comment";
            };
          }
          function buildStringTokenizer(quote, greedy) {
            if (greedy == null) {
              greedy = true;
            }
            function stringTokenizer(stream, state) {
              var nextChar = stream.next();
              var peekChar = stream.peek();
              var previousChar = stream.string.charAt(stream.pos - 2);
              var endingString = nextChar !== "\\" && peekChar === quote || nextChar === quote && previousChar !== "\\";
              if (endingString) {
                if (nextChar !== quote && greedy) {
                  stream.next();
                }
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                state.tokenizer = tokenBase;
                return "string";
              } else if (nextChar === "#" && peekChar === "{") {
                state.tokenizer = buildInterpolationTokenizer(stringTokenizer);
                stream.next();
                return "operator";
              } else {
                return "string";
              }
            }
            return stringTokenizer;
          }
          function buildInterpolationTokenizer(currentTokenizer) {
            return function(stream, state) {
              if (stream.peek() === "}") {
                stream.next();
                state.tokenizer = currentTokenizer;
                return "operator";
              } else {
                return tokenBase(stream, state);
              }
            };
          }
          function indent(state) {
            if (state.indentCount == 0) {
              state.indentCount++;
              var lastScopeOffset = state.scopes[0].offset;
              var currentOffset = lastScopeOffset + config3.indentUnit;
              state.scopes.unshift({ offset: currentOffset });
            }
          }
          function dedent(state) {
            if (state.scopes.length == 1)
              return;
            state.scopes.shift();
          }
          function tokenBase(stream, state) {
            var ch = stream.peek();
            if (stream.match("/*")) {
              state.tokenizer = comment(stream.indentation(), true);
              return state.tokenizer(stream, state);
            }
            if (stream.match("//")) {
              state.tokenizer = comment(stream.indentation(), false);
              return state.tokenizer(stream, state);
            }
            if (stream.match("#{")) {
              state.tokenizer = buildInterpolationTokenizer(tokenBase);
              return "operator";
            }
            if (ch === '"' || ch === "'") {
              stream.next();
              state.tokenizer = buildStringTokenizer(ch);
              return "string";
            }
            if (!state.cursorHalf) {
              if (ch === "-") {
                if (stream.match(/^-\w+-/)) {
                  return "meta";
                }
              }
              if (ch === ".") {
                stream.next();
                if (stream.match(/^[\w-]+/)) {
                  indent(state);
                  return "qualifier";
                } else if (stream.peek() === "#") {
                  indent(state);
                  return "tag";
                }
              }
              if (ch === "#") {
                stream.next();
                if (stream.match(/^[\w-]+/)) {
                  indent(state);
                  return "builtin";
                }
                if (stream.peek() === "#") {
                  indent(state);
                  return "tag";
                }
              }
              if (ch === "$") {
                stream.next();
                stream.eatWhile(/[\w-]/);
                return "variable-2";
              }
              if (stream.match(/^-?[0-9\.]+/))
                return "number";
              if (stream.match(/^(px|em|in)\b/))
                return "unit";
              if (stream.match(keywordsRegexp))
                return "keyword";
              if (stream.match(/^url/) && stream.peek() === "(") {
                state.tokenizer = urlTokens;
                return "atom";
              }
              if (ch === "=") {
                if (stream.match(/^=[\w-]+/)) {
                  indent(state);
                  return "meta";
                }
              }
              if (ch === "+") {
                if (stream.match(/^\+[\w-]+/)) {
                  return "variable-3";
                }
              }
              if (ch === "@") {
                if (stream.match(/@extend/)) {
                  if (!stream.match(/\s*[\w]/))
                    dedent(state);
                }
              }
              if (stream.match(/^@(else if|if|media|else|for|each|while|mixin|function)/)) {
                indent(state);
                return "def";
              }
              if (ch === "@") {
                stream.next();
                stream.eatWhile(/[\w-]/);
                return "def";
              }
              if (stream.eatWhile(/[\w-]/)) {
                if (stream.match(/ *: *[\w-\+\$#!\("']/, false)) {
                  word = stream.current().toLowerCase();
                  var prop = state.prevProp + "-" + word;
                  if (propertyKeywords.hasOwnProperty(prop)) {
                    return "property";
                  } else if (propertyKeywords.hasOwnProperty(word)) {
                    state.prevProp = word;
                    return "property";
                  } else if (fontProperties.hasOwnProperty(word)) {
                    return "property";
                  }
                  return "tag";
                } else if (stream.match(/ *:/, false)) {
                  indent(state);
                  state.cursorHalf = 1;
                  state.prevProp = stream.current().toLowerCase();
                  return "property";
                } else if (stream.match(/ *,/, false)) {
                  return "tag";
                } else {
                  indent(state);
                  return "tag";
                }
              }
              if (ch === ":") {
                if (stream.match(pseudoElementsRegexp)) {
                  return "variable-3";
                }
                stream.next();
                state.cursorHalf = 1;
                return "operator";
              }
            } else {
              if (ch === "#") {
                stream.next();
                if (stream.match(/[0-9a-fA-F]{6}|[0-9a-fA-F]{3}/)) {
                  if (isEndLine(stream)) {
                    state.cursorHalf = 0;
                  }
                  return "number";
                }
              }
              if (stream.match(/^-?[0-9\.]+/)) {
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                return "number";
              }
              if (stream.match(/^(px|em|in)\b/)) {
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                return "unit";
              }
              if (stream.match(keywordsRegexp)) {
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                return "keyword";
              }
              if (stream.match(/^url/) && stream.peek() === "(") {
                state.tokenizer = urlTokens;
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                return "atom";
              }
              if (ch === "$") {
                stream.next();
                stream.eatWhile(/[\w-]/);
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                return "variable-2";
              }
              if (ch === "!") {
                stream.next();
                state.cursorHalf = 0;
                return stream.match(/^[\w]+/) ? "keyword" : "operator";
              }
              if (stream.match(opRegexp)) {
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                return "operator";
              }
              if (stream.eatWhile(/[\w-]/)) {
                if (isEndLine(stream)) {
                  state.cursorHalf = 0;
                }
                word = stream.current().toLowerCase();
                if (valueKeywords.hasOwnProperty(word)) {
                  return "atom";
                } else if (colorKeywords.hasOwnProperty(word)) {
                  return "keyword";
                } else if (propertyKeywords.hasOwnProperty(word)) {
                  state.prevProp = stream.current().toLowerCase();
                  return "property";
                } else {
                  return "tag";
                }
              }
              if (isEndLine(stream)) {
                state.cursorHalf = 0;
                return null;
              }
            }
            if (stream.match(opRegexp))
              return "operator";
            stream.next();
            return null;
          }
          function tokenLexer(stream, state) {
            if (stream.sol())
              state.indentCount = 0;
            var style = state.tokenizer(stream, state);
            var current = stream.current();
            if (current === "@return" || current === "}") {
              dedent(state);
            }
            if (style !== null) {
              var startOfToken = stream.pos - current.length;
              var withCurrentIndent = startOfToken + config3.indentUnit * state.indentCount;
              var newScopes = [];
              for (var i3 = 0; i3 < state.scopes.length; i3++) {
                var scope = state.scopes[i3];
                if (scope.offset <= withCurrentIndent)
                  newScopes.push(scope);
              }
              state.scopes = newScopes;
            }
            return style;
          }
          return {
            startState: function() {
              return {
                tokenizer: tokenBase,
                scopes: [{ offset: 0, type: "sass" }],
                indentCount: 0,
                cursorHalf: 0,
                definedVars: [],
                definedMixins: []
              };
            },
            token: function(stream, state) {
              var style = tokenLexer(stream, state);
              state.lastToken = { style, content: stream.current() };
              return style;
            },
            indent: function(state) {
              return state.scopes[0].offset;
            }
          };
        }, "css");
        CodeMirror5.defineMIME("text/x-sass", "sass");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/scheme/scheme.js
  var require_scheme = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/scheme/scheme.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("scheme", function() {
          var BUILTIN = "builtin", COMMENT = "comment", STRING = "string", ATOM = "atom", NUMBER = "number", BRACKET = "bracket";
          var INDENT_WORD_SKIP = 2;
          function makeKeywords(str) {
            var obj = {}, words = str.split(" ");
            for (var i3 = 0; i3 < words.length; ++i3)
              obj[words[i3]] = true;
            return obj;
          }
          var keywords2 = makeKeywords("\u03BB case-lambda call/cc class define-class exit-handler field import inherit init-field interface let*-values let-values let/ec mixin opt-lambda override protect provide public rename require require-for-syntax syntax syntax-case syntax-error unit/sig unless when with-syntax and begin call-with-current-continuation call-with-input-file call-with-output-file case cond define define-syntax delay do dynamic-wind else for-each if lambda let let* let-syntax letrec letrec-syntax map or syntax-rules abs acos angle append apply asin assoc assq assv atan boolean? caar cadr call-with-input-file call-with-output-file call-with-values car cdddar cddddr cdr ceiling char->integer char-alphabetic? char-ci<=? char-ci<? char-ci=? char-ci>=? char-ci>? char-downcase char-lower-case? char-numeric? char-ready? char-upcase char-upper-case? char-whitespace? char<=? char<? char=? char>=? char>? char? close-input-port close-output-port complex? cons cos current-input-port current-output-port denominator display eof-object? eq? equal? eqv? eval even? exact->inexact exact? exp expt #f floor force gcd imag-part inexact->exact inexact? input-port? integer->char integer? interaction-environment lcm length list list->string list->vector list-ref list-tail list? load log magnitude make-polar make-rectangular make-string make-vector max member memq memv min modulo negative? newline not null-environment null? number->string number? numerator odd? open-input-file open-output-file output-port? pair? peek-char port? positive? procedure? quasiquote quote quotient rational? rationalize read read-char real-part real? remainder reverse round scheme-report-environment set! set-car! set-cdr! sin sqrt string string->list string->number string->symbol string-append string-ci<=? string-ci<? string-ci=? string-ci>=? string-ci>? string-copy string-fill! string-length string-ref string-set! string<=? string<? string=? string>=? string>? string? substring symbol->string symbol? #t tan transcript-off transcript-on truncate values vector vector->list vector-fill! vector-length vector-ref vector-set! with-input-from-file with-output-to-file write write-char zero?");
          var indentKeys = makeKeywords("define let letrec let* lambda");
          function stateStack(indent, type, prev) {
            this.indent = indent;
            this.type = type;
            this.prev = prev;
          }
          function pushStack(state, indent, type) {
            state.indentStack = new stateStack(indent, type, state.indentStack);
          }
          function popStack(state) {
            state.indentStack = state.indentStack.prev;
          }
          var binaryMatcher = new RegExp(/^(?:[-+]i|[-+][01]+#*(?:\/[01]+#*)?i|[-+]?[01]+#*(?:\/[01]+#*)?@[-+]?[01]+#*(?:\/[01]+#*)?|[-+]?[01]+#*(?:\/[01]+#*)?[-+](?:[01]+#*(?:\/[01]+#*)?)?i|[-+]?[01]+#*(?:\/[01]+#*)?)(?=[()\s;"]|$)/i);
          var octalMatcher = new RegExp(/^(?:[-+]i|[-+][0-7]+#*(?:\/[0-7]+#*)?i|[-+]?[0-7]+#*(?:\/[0-7]+#*)?@[-+]?[0-7]+#*(?:\/[0-7]+#*)?|[-+]?[0-7]+#*(?:\/[0-7]+#*)?[-+](?:[0-7]+#*(?:\/[0-7]+#*)?)?i|[-+]?[0-7]+#*(?:\/[0-7]+#*)?)(?=[()\s;"]|$)/i);
          var hexMatcher = new RegExp(/^(?:[-+]i|[-+][\da-f]+#*(?:\/[\da-f]+#*)?i|[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?@[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?|[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?[-+](?:[\da-f]+#*(?:\/[\da-f]+#*)?)?i|[-+]?[\da-f]+#*(?:\/[\da-f]+#*)?)(?=[()\s;"]|$)/i);
          var decimalMatcher = new RegExp(/^(?:[-+]i|[-+](?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)i|[-+]?(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)@[-+]?(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)|[-+]?(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)[-+](?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*)?i|(?:(?:(?:\d+#+\.?#*|\d+\.\d*#*|\.\d+#*|\d+)(?:[esfdl][-+]?\d+)?)|\d+#*\/\d+#*))(?=[()\s;"]|$)/i);
          function isBinaryNumber(stream) {
            return stream.match(binaryMatcher);
          }
          function isOctalNumber(stream) {
            return stream.match(octalMatcher);
          }
          function isDecimalNumber(stream, backup) {
            if (backup === true) {
              stream.backUp(1);
            }
            return stream.match(decimalMatcher);
          }
          function isHexNumber(stream) {
            return stream.match(hexMatcher);
          }
          return {
            startState: function() {
              return {
                indentStack: null,
                indentation: 0,
                mode: false,
                sExprComment: false,
                sExprQuote: false
              };
            },
            token: function(stream, state) {
              if (state.indentStack == null && stream.sol()) {
                state.indentation = stream.indentation();
              }
              if (stream.eatSpace()) {
                return null;
              }
              var returnType = null;
              switch (state.mode) {
                case "string":
                  var next, escaped = false;
                  while ((next = stream.next()) != null) {
                    if (next == '"' && !escaped) {
                      state.mode = false;
                      break;
                    }
                    escaped = !escaped && next == "\\";
                  }
                  returnType = STRING;
                  break;
                case "comment":
                  var next, maybeEnd = false;
                  while ((next = stream.next()) != null) {
                    if (next == "#" && maybeEnd) {
                      state.mode = false;
                      break;
                    }
                    maybeEnd = next == "|";
                  }
                  returnType = COMMENT;
                  break;
                case "s-expr-comment":
                  state.mode = false;
                  if (stream.peek() == "(" || stream.peek() == "[") {
                    state.sExprComment = 0;
                  } else {
                    stream.eatWhile(/[^\s\(\)\[\]]/);
                    returnType = COMMENT;
                    break;
                  }
                default:
                  var ch = stream.next();
                  if (ch == '"') {
                    state.mode = "string";
                    returnType = STRING;
                  } else if (ch == "'") {
                    if (stream.peek() == "(" || stream.peek() == "[") {
                      if (typeof state.sExprQuote != "number") {
                        state.sExprQuote = 0;
                      }
                      returnType = ATOM;
                    } else {
                      stream.eatWhile(/[\w_\-!$%&*+\.\/:<=>?@\^~]/);
                      returnType = ATOM;
                    }
                  } else if (ch == "#") {
                    if (stream.eat("|")) {
                      state.mode = "comment";
                      returnType = COMMENT;
                    } else if (stream.eat(/[tf]/i)) {
                      returnType = ATOM;
                    } else if (stream.eat(";")) {
                      state.mode = "s-expr-comment";
                      returnType = COMMENT;
                    } else {
                      var numTest = null, hasExactness = false, hasRadix = true;
                      if (stream.eat(/[ei]/i)) {
                        hasExactness = true;
                      } else {
                        stream.backUp(1);
                      }
                      if (stream.match(/^#b/i)) {
                        numTest = isBinaryNumber;
                      } else if (stream.match(/^#o/i)) {
                        numTest = isOctalNumber;
                      } else if (stream.match(/^#x/i)) {
                        numTest = isHexNumber;
                      } else if (stream.match(/^#d/i)) {
                        numTest = isDecimalNumber;
                      } else if (stream.match(/^[-+0-9.]/, false)) {
                        hasRadix = false;
                        numTest = isDecimalNumber;
                      } else if (!hasExactness) {
                        stream.eat("#");
                      }
                      if (numTest != null) {
                        if (hasRadix && !hasExactness) {
                          stream.match(/^#[ei]/i);
                        }
                        if (numTest(stream))
                          returnType = NUMBER;
                      }
                    }
                  } else if (/^[-+0-9.]/.test(ch) && isDecimalNumber(stream, true)) {
                    returnType = NUMBER;
                  } else if (ch == ";") {
                    stream.skipToEnd();
                    returnType = COMMENT;
                  } else if (ch == "(" || ch == "[") {
                    var keyWord = "";
                    var indentTemp = stream.column(), letter;
                    while ((letter = stream.eat(/[^\s\(\[\;\)\]]/)) != null) {
                      keyWord += letter;
                    }
                    if (keyWord.length > 0 && indentKeys.propertyIsEnumerable(keyWord)) {
                      pushStack(state, indentTemp + INDENT_WORD_SKIP, ch);
                    } else {
                      stream.eatSpace();
                      if (stream.eol() || stream.peek() == ";") {
                        pushStack(state, indentTemp + 1, ch);
                      } else {
                        pushStack(state, indentTemp + stream.current().length, ch);
                      }
                    }
                    stream.backUp(stream.current().length - 1);
                    if (typeof state.sExprComment == "number")
                      state.sExprComment++;
                    if (typeof state.sExprQuote == "number")
                      state.sExprQuote++;
                    returnType = BRACKET;
                  } else if (ch == ")" || ch == "]") {
                    returnType = BRACKET;
                    if (state.indentStack != null && state.indentStack.type == (ch == ")" ? "(" : "[")) {
                      popStack(state);
                      if (typeof state.sExprComment == "number") {
                        if (--state.sExprComment == 0) {
                          returnType = COMMENT;
                          state.sExprComment = false;
                        }
                      }
                      if (typeof state.sExprQuote == "number") {
                        if (--state.sExprQuote == 0) {
                          returnType = ATOM;
                          state.sExprQuote = false;
                        }
                      }
                    }
                  } else {
                    stream.eatWhile(/[\w_\-!$%&*+\.\/:<=>?@\^~]/);
                    if (keywords2 && keywords2.propertyIsEnumerable(stream.current())) {
                      returnType = BUILTIN;
                    } else
                      returnType = "variable";
                  }
              }
              return typeof state.sExprComment == "number" ? COMMENT : typeof state.sExprQuote == "number" ? ATOM : returnType;
            },
            indent: function(state) {
              if (state.indentStack == null)
                return state.indentation;
              return state.indentStack.indent;
            },
            closeBrackets: { pairs: '()[]{}""' },
            lineComment: ";;"
          };
        });
        CodeMirror5.defineMIME("text/x-scheme", "scheme");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/shell/shell.js
  var require_shell = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/shell/shell.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("shell", function() {
          var words = {};
          function define2(style, dict) {
            for (var i3 = 0; i3 < dict.length; i3++) {
              words[dict[i3]] = style;
            }
          }
          ;
          var commonAtoms = ["true", "false"];
          var commonKeywords = [
            "if",
            "then",
            "do",
            "else",
            "elif",
            "while",
            "until",
            "for",
            "in",
            "esac",
            "fi",
            "fin",
            "fil",
            "done",
            "exit",
            "set",
            "unset",
            "export",
            "function"
          ];
          var commonCommands = [
            "ab",
            "awk",
            "bash",
            "beep",
            "cat",
            "cc",
            "cd",
            "chown",
            "chmod",
            "chroot",
            "clear",
            "cp",
            "curl",
            "cut",
            "diff",
            "echo",
            "find",
            "gawk",
            "gcc",
            "get",
            "git",
            "grep",
            "hg",
            "kill",
            "killall",
            "ln",
            "ls",
            "make",
            "mkdir",
            "openssl",
            "mv",
            "nc",
            "nl",
            "node",
            "npm",
            "ping",
            "ps",
            "restart",
            "rm",
            "rmdir",
            "sed",
            "service",
            "sh",
            "shopt",
            "shred",
            "source",
            "sort",
            "sleep",
            "ssh",
            "start",
            "stop",
            "su",
            "sudo",
            "svn",
            "tee",
            "telnet",
            "top",
            "touch",
            "vi",
            "vim",
            "wall",
            "wc",
            "wget",
            "who",
            "write",
            "yes",
            "zsh"
          ];
          CodeMirror5.registerHelper("hintWords", "shell", commonAtoms.concat(commonKeywords, commonCommands));
          define2("atom", commonAtoms);
          define2("keyword", commonKeywords);
          define2("builtin", commonCommands);
          function tokenBase(stream, state) {
            if (stream.eatSpace())
              return null;
            var sol = stream.sol();
            var ch = stream.next();
            if (ch === "\\") {
              stream.next();
              return null;
            }
            if (ch === "'" || ch === '"' || ch === "`") {
              state.tokens.unshift(tokenString(ch, ch === "`" ? "quote" : "string"));
              return tokenize(stream, state);
            }
            if (ch === "#") {
              if (sol && stream.eat("!")) {
                stream.skipToEnd();
                return "meta";
              }
              stream.skipToEnd();
              return "comment";
            }
            if (ch === "$") {
              state.tokens.unshift(tokenDollar);
              return tokenize(stream, state);
            }
            if (ch === "+" || ch === "=") {
              return "operator";
            }
            if (ch === "-") {
              stream.eat("-");
              stream.eatWhile(/\w/);
              return "attribute";
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/\d/);
              if (stream.eol() || !/\w/.test(stream.peek())) {
                return "number";
              }
            }
            stream.eatWhile(/[\w-]/);
            var cur = stream.current();
            if (stream.peek() === "=" && /\w+/.test(cur))
              return "def";
            return words.hasOwnProperty(cur) ? words[cur] : null;
          }
          function tokenString(quote, style) {
            var close = quote == "(" ? ")" : quote == "{" ? "}" : quote;
            return function(stream, state) {
              var next, escaped = false;
              while ((next = stream.next()) != null) {
                if (next === close && !escaped) {
                  state.tokens.shift();
                  break;
                } else if (next === "$" && !escaped && quote !== "'" && stream.peek() != close) {
                  escaped = true;
                  stream.backUp(1);
                  state.tokens.unshift(tokenDollar);
                  break;
                } else if (!escaped && quote !== close && next === quote) {
                  state.tokens.unshift(tokenString(quote, style));
                  return tokenize(stream, state);
                } else if (!escaped && /['"]/.test(next) && !/['"]/.test(quote)) {
                  state.tokens.unshift(tokenStringStart(next, "string"));
                  stream.backUp(1);
                  break;
                }
                escaped = !escaped && next === "\\";
              }
              return style;
            };
          }
          ;
          function tokenStringStart(quote, style) {
            return function(stream, state) {
              state.tokens[0] = tokenString(quote, style);
              stream.next();
              return tokenize(stream, state);
            };
          }
          var tokenDollar = function(stream, state) {
            if (state.tokens.length > 1)
              stream.eat("$");
            var ch = stream.next();
            if (/['"({]/.test(ch)) {
              state.tokens[0] = tokenString(ch, ch == "(" ? "quote" : ch == "{" ? "def" : "string");
              return tokenize(stream, state);
            }
            if (!/\d/.test(ch))
              stream.eatWhile(/\w/);
            state.tokens.shift();
            return "def";
          };
          function tokenize(stream, state) {
            return (state.tokens[0] || tokenBase)(stream, state);
          }
          ;
          return {
            startState: function() {
              return { tokens: [] };
            },
            token: function(stream, state) {
              return tokenize(stream, state);
            },
            closeBrackets: "()[]{}''\"\"``",
            lineComment: "#",
            fold: "brace"
          };
        });
        CodeMirror5.defineMIME("text/x-sh", "shell");
        CodeMirror5.defineMIME("application/x-sh", "shell");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/sieve/sieve.js
  var require_sieve = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/sieve/sieve.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("sieve", function(config3) {
          function words(str) {
            var obj = {}, words2 = str.split(" ");
            for (var i3 = 0; i3 < words2.length; ++i3)
              obj[words2[i3]] = true;
            return obj;
          }
          var keywords2 = words("if elsif else stop require");
          var atoms = words("true false not");
          var indentUnit = config3.indentUnit;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == "/" && stream.eat("*")) {
              state.tokenize = tokenCComment;
              return tokenCComment(stream, state);
            }
            if (ch === "#") {
              stream.skipToEnd();
              return "comment";
            }
            if (ch == '"') {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (ch == "(") {
              state._indent.push("(");
              state._indent.push("{");
              return null;
            }
            if (ch === "{") {
              state._indent.push("{");
              return null;
            }
            if (ch == ")") {
              state._indent.pop();
              state._indent.pop();
            }
            if (ch === "}") {
              state._indent.pop();
              return null;
            }
            if (ch == ",")
              return null;
            if (ch == ";")
              return null;
            if (/[{}\(\),;]/.test(ch))
              return null;
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\d]/);
              stream.eat(/[KkMmGg]/);
              return "number";
            }
            if (ch == ":") {
              stream.eatWhile(/[a-zA-Z_]/);
              stream.eatWhile(/[a-zA-Z0-9_]/);
              return "operator";
            }
            stream.eatWhile(/\w/);
            var cur = stream.current();
            if (cur == "text" && stream.eat(":")) {
              state.tokenize = tokenMultiLineString;
              return "string";
            }
            if (keywords2.propertyIsEnumerable(cur))
              return "keyword";
            if (atoms.propertyIsEnumerable(cur))
              return "atom";
            return null;
          }
          function tokenMultiLineString(stream, state) {
            state._multiLineString = true;
            if (!stream.sol()) {
              stream.eatSpace();
              if (stream.peek() == "#") {
                stream.skipToEnd();
                return "comment";
              }
              stream.skipToEnd();
              return "string";
            }
            if (stream.next() == "." && stream.eol()) {
              state._multiLineString = false;
              state.tokenize = tokenBase;
            }
            return "string";
          }
          function tokenCComment(stream, state) {
            var maybeEnd = false, ch;
            while ((ch = stream.next()) != null) {
              if (maybeEnd && ch == "/") {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped)
                  break;
                escaped = !escaped && ch == "\\";
              }
              if (!escaped)
                state.tokenize = tokenBase;
              return "string";
            };
          }
          return {
            startState: function(base) {
              return {
                tokenize: tokenBase,
                baseIndent: base || 0,
                _indent: []
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return (state.tokenize || tokenBase)(stream, state);
            },
            indent: function(state, _textAfter) {
              var length = state._indent.length;
              if (_textAfter && _textAfter[0] == "}")
                length--;
              if (length < 0)
                length = 0;
              return length * indentUnit;
            },
            electricChars: "}"
          };
        });
        CodeMirror5.defineMIME("application/sieve", "sieve");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/slim/slim.js
  var require_slim = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/slim/slim.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_htmlmixed(), require_ruby());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../htmlmixed/htmlmixed", "../ruby/ruby"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("slim", function(config3) {
          var htmlMode = CodeMirror5.getMode(config3, { name: "htmlmixed" });
          var rubyMode = CodeMirror5.getMode(config3, "ruby");
          var modes = { html: htmlMode, ruby: rubyMode };
          var embedded = {
            ruby: "ruby",
            javascript: "javascript",
            css: "text/css",
            sass: "text/x-sass",
            scss: "text/x-scss",
            less: "text/x-less",
            styl: "text/x-styl",
            coffee: "coffeescript",
            asciidoc: "text/x-asciidoc",
            markdown: "text/x-markdown",
            textile: "text/x-textile",
            creole: "text/x-creole",
            wiki: "text/x-wiki",
            mediawiki: "text/x-mediawiki",
            rdoc: "text/x-rdoc",
            builder: "text/x-builder",
            nokogiri: "text/x-nokogiri",
            erb: "application/x-erb"
          };
          var embeddedRegexp = function(map3) {
            var arr = [];
            for (var key in map3)
              arr.push(key);
            return new RegExp("^(" + arr.join("|") + "):");
          }(embedded);
          var styleMap = {
            "commentLine": "comment",
            "slimSwitch": "operator special",
            "slimTag": "tag",
            "slimId": "attribute def",
            "slimClass": "attribute qualifier",
            "slimAttribute": "attribute",
            "slimSubmode": "keyword special",
            "closeAttributeTag": null,
            "slimDoctype": null,
            "lineContinuation": null
          };
          var closing = {
            "{": "}",
            "[": "]",
            "(": ")"
          };
          var nameStartChar = "_a-zA-Z\xC0-\xD6\xD8-\xF6\xF8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD";
          var nameChar = nameStartChar + "\\-0-9\xB7\u0300-\u036F\u203F-\u2040";
          var nameRegexp = new RegExp("^[:" + nameStartChar + "](?::[" + nameChar + "]|[" + nameChar + "]*)");
          var attributeNameRegexp = new RegExp("^[:" + nameStartChar + "][:\\." + nameChar + "]*(?=\\s*=)");
          var wrappedAttributeNameRegexp = new RegExp("^[:" + nameStartChar + "][:\\." + nameChar + "]*");
          var classNameRegexp = /^\.-?[_a-zA-Z]+[\w\-]*/;
          var classIdRegexp = /^#[_a-zA-Z]+[\w\-]*/;
          function backup(pos, tokenize, style) {
            var restore = function(stream, state) {
              state.tokenize = tokenize;
              if (stream.pos < pos) {
                stream.pos = pos;
                return style;
              }
              return state.tokenize(stream, state);
            };
            return function(stream, state) {
              state.tokenize = restore;
              return tokenize(stream, state);
            };
          }
          function maybeBackup(stream, state, pat, offset, style) {
            var cur = stream.current();
            var idx = cur.search(pat);
            if (idx > -1) {
              state.tokenize = backup(stream.pos, state.tokenize, style);
              stream.backUp(cur.length - idx - offset);
            }
            return style;
          }
          function continueLine(state, column) {
            state.stack = {
              parent: state.stack,
              style: "continuation",
              indented: column,
              tokenize: state.line
            };
            state.line = state.tokenize;
          }
          function finishContinue(state) {
            if (state.line == state.tokenize) {
              state.line = state.stack.tokenize;
              state.stack = state.stack.parent;
            }
          }
          function lineContinuable(column, tokenize) {
            return function(stream, state) {
              finishContinue(state);
              if (stream.match(/^\\$/)) {
                continueLine(state, column);
                return "lineContinuation";
              }
              var style = tokenize(stream, state);
              if (stream.eol() && stream.current().match(/(?:^|[^\\])(?:\\\\)*\\$/)) {
                stream.backUp(1);
              }
              return style;
            };
          }
          function commaContinuable(column, tokenize) {
            return function(stream, state) {
              finishContinue(state);
              var style = tokenize(stream, state);
              if (stream.eol() && stream.current().match(/,$/)) {
                continueLine(state, column);
              }
              return style;
            };
          }
          function rubyInQuote(endQuote, tokenize) {
            return function(stream, state) {
              var ch = stream.peek();
              if (ch == endQuote && state.rubyState.tokenize.length == 1) {
                stream.next();
                state.tokenize = tokenize;
                return "closeAttributeTag";
              } else {
                return ruby(stream, state);
              }
            };
          }
          function startRubySplat(tokenize) {
            var rubyState;
            var runSplat = function(stream, state) {
              if (state.rubyState.tokenize.length == 1 && !state.rubyState.context.prev) {
                stream.backUp(1);
                if (stream.eatSpace()) {
                  state.rubyState = rubyState;
                  state.tokenize = tokenize;
                  return tokenize(stream, state);
                }
                stream.next();
              }
              return ruby(stream, state);
            };
            return function(stream, state) {
              rubyState = state.rubyState;
              state.rubyState = CodeMirror5.startState(rubyMode);
              state.tokenize = runSplat;
              return ruby(stream, state);
            };
          }
          function ruby(stream, state) {
            return rubyMode.token(stream, state.rubyState);
          }
          function htmlLine(stream, state) {
            if (stream.match(/^\\$/)) {
              return "lineContinuation";
            }
            return html(stream, state);
          }
          function html(stream, state) {
            if (stream.match(/^#\{/)) {
              state.tokenize = rubyInQuote("}", state.tokenize);
              return null;
            }
            return maybeBackup(stream, state, /[^\\]#\{/, 1, htmlMode.token(stream, state.htmlState));
          }
          function startHtmlLine(lastTokenize) {
            return function(stream, state) {
              var style = htmlLine(stream, state);
              if (stream.eol())
                state.tokenize = lastTokenize;
              return style;
            };
          }
          function startHtmlMode(stream, state, offset) {
            state.stack = {
              parent: state.stack,
              style: "html",
              indented: stream.column() + offset,
              tokenize: state.line
            };
            state.line = state.tokenize = html;
            return null;
          }
          function comment(stream, state) {
            stream.skipToEnd();
            return state.stack.style;
          }
          function commentMode(stream, state) {
            state.stack = {
              parent: state.stack,
              style: "comment",
              indented: state.indented + 1,
              tokenize: state.line
            };
            state.line = comment;
            return comment(stream, state);
          }
          function attributeWrapper(stream, state) {
            if (stream.eat(state.stack.endQuote)) {
              state.line = state.stack.line;
              state.tokenize = state.stack.tokenize;
              state.stack = state.stack.parent;
              return null;
            }
            if (stream.match(wrappedAttributeNameRegexp)) {
              state.tokenize = attributeWrapperAssign;
              return "slimAttribute";
            }
            stream.next();
            return null;
          }
          function attributeWrapperAssign(stream, state) {
            if (stream.match(/^==?/)) {
              state.tokenize = attributeWrapperValue;
              return null;
            }
            return attributeWrapper(stream, state);
          }
          function attributeWrapperValue(stream, state) {
            var ch = stream.peek();
            if (ch == '"' || ch == "'") {
              state.tokenize = readQuoted(ch, "string", true, false, attributeWrapper);
              stream.next();
              return state.tokenize(stream, state);
            }
            if (ch == "[") {
              return startRubySplat(attributeWrapper)(stream, state);
            }
            if (stream.match(/^(true|false|nil)\b/)) {
              state.tokenize = attributeWrapper;
              return "keyword";
            }
            return startRubySplat(attributeWrapper)(stream, state);
          }
          function startAttributeWrapperMode(state, endQuote, tokenize) {
            state.stack = {
              parent: state.stack,
              style: "wrapper",
              indented: state.indented + 1,
              tokenize,
              line: state.line,
              endQuote
            };
            state.line = state.tokenize = attributeWrapper;
            return null;
          }
          function sub(stream, state) {
            if (stream.match(/^#\{/)) {
              state.tokenize = rubyInQuote("}", state.tokenize);
              return null;
            }
            var subStream = new CodeMirror5.StringStream(stream.string.slice(state.stack.indented), stream.tabSize);
            subStream.pos = stream.pos - state.stack.indented;
            subStream.start = stream.start - state.stack.indented;
            subStream.lastColumnPos = stream.lastColumnPos - state.stack.indented;
            subStream.lastColumnValue = stream.lastColumnValue - state.stack.indented;
            var style = state.subMode.token(subStream, state.subState);
            stream.pos = subStream.pos + state.stack.indented;
            return style;
          }
          function firstSub(stream, state) {
            state.stack.indented = stream.column();
            state.line = state.tokenize = sub;
            return state.tokenize(stream, state);
          }
          function createMode2(mode3) {
            var query = embedded[mode3];
            var spec = CodeMirror5.mimeModes[query];
            if (spec) {
              return CodeMirror5.getMode(config3, spec);
            }
            var factory2 = CodeMirror5.modes[query];
            if (factory2) {
              return factory2(config3, { name: query });
            }
            return CodeMirror5.getMode(config3, "null");
          }
          function getMode2(mode3) {
            if (!modes.hasOwnProperty(mode3)) {
              return modes[mode3] = createMode2(mode3);
            }
            return modes[mode3];
          }
          function startSubMode(mode3, state) {
            var subMode = getMode2(mode3);
            var subState = CodeMirror5.startState(subMode);
            state.subMode = subMode;
            state.subState = subState;
            state.stack = {
              parent: state.stack,
              style: "sub",
              indented: state.indented + 1,
              tokenize: state.line
            };
            state.line = state.tokenize = firstSub;
            return "slimSubmode";
          }
          function doctypeLine(stream, _state) {
            stream.skipToEnd();
            return "slimDoctype";
          }
          function startLine(stream, state) {
            var ch = stream.peek();
            if (ch == "<") {
              return (state.tokenize = startHtmlLine(state.tokenize))(stream, state);
            }
            if (stream.match(/^[|']/)) {
              return startHtmlMode(stream, state, 1);
            }
            if (stream.match(/^\/(!|\[\w+])?/)) {
              return commentMode(stream, state);
            }
            if (stream.match(/^(-|==?[<>]?)/)) {
              state.tokenize = lineContinuable(stream.column(), commaContinuable(stream.column(), ruby));
              return "slimSwitch";
            }
            if (stream.match(/^doctype\b/)) {
              state.tokenize = doctypeLine;
              return "keyword";
            }
            var m3 = stream.match(embeddedRegexp);
            if (m3) {
              return startSubMode(m3[1], state);
            }
            return slimTag(stream, state);
          }
          function slim(stream, state) {
            if (state.startOfLine) {
              return startLine(stream, state);
            }
            return slimTag(stream, state);
          }
          function slimTag(stream, state) {
            if (stream.eat("*")) {
              state.tokenize = startRubySplat(slimTagExtras);
              return null;
            }
            if (stream.match(nameRegexp)) {
              state.tokenize = slimTagExtras;
              return "slimTag";
            }
            return slimClass(stream, state);
          }
          function slimTagExtras(stream, state) {
            if (stream.match(/^(<>?|><?)/)) {
              state.tokenize = slimClass;
              return null;
            }
            return slimClass(stream, state);
          }
          function slimClass(stream, state) {
            if (stream.match(classIdRegexp)) {
              state.tokenize = slimClass;
              return "slimId";
            }
            if (stream.match(classNameRegexp)) {
              state.tokenize = slimClass;
              return "slimClass";
            }
            return slimAttribute(stream, state);
          }
          function slimAttribute(stream, state) {
            if (stream.match(/^([\[\{\(])/)) {
              return startAttributeWrapperMode(state, closing[RegExp.$1], slimAttribute);
            }
            if (stream.match(attributeNameRegexp)) {
              state.tokenize = slimAttributeAssign;
              return "slimAttribute";
            }
            if (stream.peek() == "*") {
              stream.next();
              state.tokenize = startRubySplat(slimContent);
              return null;
            }
            return slimContent(stream, state);
          }
          function slimAttributeAssign(stream, state) {
            if (stream.match(/^==?/)) {
              state.tokenize = slimAttributeValue;
              return null;
            }
            return slimAttribute(stream, state);
          }
          function slimAttributeValue(stream, state) {
            var ch = stream.peek();
            if (ch == '"' || ch == "'") {
              state.tokenize = readQuoted(ch, "string", true, false, slimAttribute);
              stream.next();
              return state.tokenize(stream, state);
            }
            if (ch == "[") {
              return startRubySplat(slimAttribute)(stream, state);
            }
            if (ch == ":") {
              return startRubySplat(slimAttributeSymbols)(stream, state);
            }
            if (stream.match(/^(true|false|nil)\b/)) {
              state.tokenize = slimAttribute;
              return "keyword";
            }
            return startRubySplat(slimAttribute)(stream, state);
          }
          function slimAttributeSymbols(stream, state) {
            stream.backUp(1);
            if (stream.match(/^[^\s],(?=:)/)) {
              state.tokenize = startRubySplat(slimAttributeSymbols);
              return null;
            }
            stream.next();
            return slimAttribute(stream, state);
          }
          function readQuoted(quote, style, embed, unescaped, nextTokenize) {
            return function(stream, state) {
              finishContinue(state);
              var fresh = stream.current().length == 0;
              if (stream.match(/^\\$/, fresh)) {
                if (!fresh)
                  return style;
                continueLine(state, state.indented);
                return "lineContinuation";
              }
              if (stream.match(/^#\{/, fresh)) {
                if (!fresh)
                  return style;
                state.tokenize = rubyInQuote("}", state.tokenize);
                return null;
              }
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && (unescaped || !escaped)) {
                  state.tokenize = nextTokenize;
                  break;
                }
                if (embed && ch == "#" && !escaped) {
                  if (stream.eat("{")) {
                    stream.backUp(2);
                    break;
                  }
                }
                escaped = !escaped && ch == "\\";
              }
              if (stream.eol() && escaped) {
                stream.backUp(1);
              }
              return style;
            };
          }
          function slimContent(stream, state) {
            if (stream.match(/^==?/)) {
              state.tokenize = ruby;
              return "slimSwitch";
            }
            if (stream.match(/^\/$/)) {
              state.tokenize = slim;
              return null;
            }
            if (stream.match(/^:/)) {
              state.tokenize = slimTag;
              return "slimSwitch";
            }
            startHtmlMode(stream, state, 0);
            return state.tokenize(stream, state);
          }
          var mode2 = {
            startState: function() {
              var htmlState = CodeMirror5.startState(htmlMode);
              var rubyState = CodeMirror5.startState(rubyMode);
              return {
                htmlState,
                rubyState,
                stack: null,
                last: null,
                tokenize: slim,
                line: slim,
                indented: 0
              };
            },
            copyState: function(state) {
              return {
                htmlState: CodeMirror5.copyState(htmlMode, state.htmlState),
                rubyState: CodeMirror5.copyState(rubyMode, state.rubyState),
                subMode: state.subMode,
                subState: state.subMode && CodeMirror5.copyState(state.subMode, state.subState),
                stack: state.stack,
                last: state.last,
                tokenize: state.tokenize,
                line: state.line
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                state.indented = stream.indentation();
                state.startOfLine = true;
                state.tokenize = state.line;
                while (state.stack && state.stack.indented > state.indented && state.last != "slimSubmode") {
                  state.line = state.tokenize = state.stack.tokenize;
                  state.stack = state.stack.parent;
                  state.subMode = null;
                  state.subState = null;
                }
              }
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              state.startOfLine = false;
              if (style)
                state.last = style;
              return styleMap.hasOwnProperty(style) ? styleMap[style] : style;
            },
            blankLine: function(state) {
              if (state.subMode && state.subMode.blankLine) {
                return state.subMode.blankLine(state.subState);
              }
            },
            innerMode: function(state) {
              if (state.subMode)
                return { state: state.subState, mode: state.subMode };
              return { state, mode: mode2 };
            }
          };
          return mode2;
        }, "htmlmixed", "ruby");
        CodeMirror5.defineMIME("text/x-slim", "slim");
        CodeMirror5.defineMIME("application/x-slim", "slim");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/smalltalk/smalltalk.js
  var require_smalltalk = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/smalltalk/smalltalk.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("smalltalk", function(config3) {
          var specialChars = /[+\-\/\\*~<>=@%|&?!.,:;^]/;
          var keywords2 = /true|false|nil|self|super|thisContext/;
          var Context = function(tokenizer, parent) {
            this.next = tokenizer;
            this.parent = parent;
          };
          var Token = function(name106, context, eos) {
            this.name = name106;
            this.context = context;
            this.eos = eos;
          };
          var State = function() {
            this.context = new Context(next, null);
            this.expectVariable = true;
            this.indentation = 0;
            this.userIndentationDelta = 0;
          };
          State.prototype.userIndent = function(indentation) {
            this.userIndentationDelta = indentation > 0 ? indentation / config3.indentUnit - this.indentation : 0;
          };
          var next = function(stream, context, state) {
            var token = new Token(null, context, false);
            var aChar = stream.next();
            if (aChar === '"') {
              token = nextComment(stream, new Context(nextComment, context));
            } else if (aChar === "'") {
              token = nextString(stream, new Context(nextString, context));
            } else if (aChar === "#") {
              if (stream.peek() === "'") {
                stream.next();
                token = nextSymbol(stream, new Context(nextSymbol, context));
              } else {
                if (stream.eatWhile(/[^\s.{}\[\]()]/))
                  token.name = "string-2";
                else
                  token.name = "meta";
              }
            } else if (aChar === "$") {
              if (stream.next() === "<") {
                stream.eatWhile(/[^\s>]/);
                stream.next();
              }
              token.name = "string-2";
            } else if (aChar === "|" && state.expectVariable) {
              token.context = new Context(nextTemporaries, context);
            } else if (/[\[\]{}()]/.test(aChar)) {
              token.name = "bracket";
              token.eos = /[\[{(]/.test(aChar);
              if (aChar === "[") {
                state.indentation++;
              } else if (aChar === "]") {
                state.indentation = Math.max(0, state.indentation - 1);
              }
            } else if (specialChars.test(aChar)) {
              stream.eatWhile(specialChars);
              token.name = "operator";
              token.eos = aChar !== ";";
            } else if (/\d/.test(aChar)) {
              stream.eatWhile(/[\w\d]/);
              token.name = "number";
            } else if (/[\w_]/.test(aChar)) {
              stream.eatWhile(/[\w\d_]/);
              token.name = state.expectVariable ? keywords2.test(stream.current()) ? "keyword" : "variable" : null;
            } else {
              token.eos = state.expectVariable;
            }
            return token;
          };
          var nextComment = function(stream, context) {
            stream.eatWhile(/[^"]/);
            return new Token("comment", stream.eat('"') ? context.parent : context, true);
          };
          var nextString = function(stream, context) {
            stream.eatWhile(/[^']/);
            return new Token("string", stream.eat("'") ? context.parent : context, false);
          };
          var nextSymbol = function(stream, context) {
            stream.eatWhile(/[^']/);
            return new Token("string-2", stream.eat("'") ? context.parent : context, false);
          };
          var nextTemporaries = function(stream, context) {
            var token = new Token(null, context, false);
            var aChar = stream.next();
            if (aChar === "|") {
              token.context = context.parent;
              token.eos = true;
            } else {
              stream.eatWhile(/[^|]/);
              token.name = "variable";
            }
            return token;
          };
          return {
            startState: function() {
              return new State();
            },
            token: function(stream, state) {
              state.userIndent(stream.indentation());
              if (stream.eatSpace()) {
                return null;
              }
              var token = state.context.next(stream, state.context, state);
              state.context = token.context;
              state.expectVariable = token.eos;
              return token.name;
            },
            blankLine: function(state) {
              state.userIndent(0);
            },
            indent: function(state, textAfter) {
              var i3 = state.context.next === next && textAfter && textAfter.charAt(0) === "]" ? -1 : state.userIndentationDelta;
              return (state.indentation + i3) * config3.indentUnit;
            },
            electricChars: "]"
          };
        });
        CodeMirror5.defineMIME("text/x-stsrc", { name: "smalltalk" });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/smarty/smarty.js
  var require_smarty = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/smarty/smarty.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("smarty", function(config3, parserConf) {
          var rightDelimiter = parserConf.rightDelimiter || "}";
          var leftDelimiter = parserConf.leftDelimiter || "{";
          var version3 = parserConf.version || 2;
          var baseMode = CodeMirror5.getMode(config3, parserConf.baseMode || "null");
          var keyFunctions = ["debug", "extends", "function", "include", "literal"];
          var regs = {
            operatorChars: /[+\-*&%=<>!?]/,
            validIdentifier: /[a-zA-Z0-9_]/,
            stringChar: /['"]/
          };
          var last;
          function cont(style, lastType) {
            last = lastType;
            return style;
          }
          function chain2(stream, state, parser2) {
            state.tokenize = parser2;
            return parser2(stream, state);
          }
          function doesNotCount(stream, pos) {
            if (pos == null)
              pos = stream.pos;
            return version3 === 3 && leftDelimiter == "{" && (pos == stream.string.length || /\s/.test(stream.string.charAt(pos)));
          }
          function tokenTop(stream, state) {
            var string2 = stream.string;
            for (var scan = stream.pos; ; ) {
              var nextMatch2 = string2.indexOf(leftDelimiter, scan);
              scan = nextMatch2 + leftDelimiter.length;
              if (nextMatch2 == -1 || !doesNotCount(stream, nextMatch2 + leftDelimiter.length))
                break;
            }
            if (nextMatch2 == stream.pos) {
              stream.match(leftDelimiter);
              if (stream.eat("*")) {
                return chain2(stream, state, tokenBlock("comment", "*" + rightDelimiter));
              } else {
                state.depth++;
                state.tokenize = tokenSmarty;
                last = "startTag";
                return "tag";
              }
            }
            if (nextMatch2 > -1)
              stream.string = string2.slice(0, nextMatch2);
            var token = baseMode.token(stream, state.base);
            if (nextMatch2 > -1)
              stream.string = string2;
            return token;
          }
          function tokenSmarty(stream, state) {
            if (stream.match(rightDelimiter, true)) {
              if (version3 === 3) {
                state.depth--;
                if (state.depth <= 0) {
                  state.tokenize = tokenTop;
                }
              } else {
                state.tokenize = tokenTop;
              }
              return cont("tag", null);
            }
            if (stream.match(leftDelimiter, true)) {
              state.depth++;
              return cont("tag", "startTag");
            }
            var ch = stream.next();
            if (ch == "$") {
              stream.eatWhile(regs.validIdentifier);
              return cont("variable-2", "variable");
            } else if (ch == "|") {
              return cont("operator", "pipe");
            } else if (ch == ".") {
              return cont("operator", "property");
            } else if (regs.stringChar.test(ch)) {
              state.tokenize = tokenAttribute(ch);
              return cont("string", "string");
            } else if (regs.operatorChars.test(ch)) {
              stream.eatWhile(regs.operatorChars);
              return cont("operator", "operator");
            } else if (ch == "[" || ch == "]") {
              return cont("bracket", "bracket");
            } else if (ch == "(" || ch == ")") {
              return cont("bracket", "operator");
            } else if (/\d/.test(ch)) {
              stream.eatWhile(/\d/);
              return cont("number", "number");
            } else {
              if (state.last == "variable") {
                if (ch == "@") {
                  stream.eatWhile(regs.validIdentifier);
                  return cont("property", "property");
                } else if (ch == "|") {
                  stream.eatWhile(regs.validIdentifier);
                  return cont("qualifier", "modifier");
                }
              } else if (state.last == "pipe") {
                stream.eatWhile(regs.validIdentifier);
                return cont("qualifier", "modifier");
              } else if (state.last == "whitespace") {
                stream.eatWhile(regs.validIdentifier);
                return cont("attribute", "modifier");
              }
              if (state.last == "property") {
                stream.eatWhile(regs.validIdentifier);
                return cont("property", null);
              } else if (/\s/.test(ch)) {
                last = "whitespace";
                return null;
              }
              var str = "";
              if (ch != "/") {
                str += ch;
              }
              var c3 = null;
              while (c3 = stream.eat(regs.validIdentifier)) {
                str += c3;
              }
              for (var i3 = 0, j3 = keyFunctions.length; i3 < j3; i3++) {
                if (keyFunctions[i3] == str) {
                  return cont("keyword", "keyword");
                }
              }
              if (/\s/.test(ch)) {
                return null;
              }
              return cont("tag", "tag");
            }
          }
          function tokenAttribute(quote) {
            return function(stream, state) {
              var prevChar = null;
              var currChar = null;
              while (!stream.eol()) {
                currChar = stream.peek();
                if (stream.next() == quote && prevChar !== "\\") {
                  state.tokenize = tokenSmarty;
                  break;
                }
                prevChar = currChar;
              }
              return "string";
            };
          }
          function tokenBlock(style, terminator) {
            return function(stream, state) {
              while (!stream.eol()) {
                if (stream.match(terminator)) {
                  state.tokenize = tokenTop;
                  break;
                }
                stream.next();
              }
              return style;
            };
          }
          return {
            startState: function() {
              return {
                base: CodeMirror5.startState(baseMode),
                tokenize: tokenTop,
                last: null,
                depth: 0
              };
            },
            copyState: function(state) {
              return {
                base: CodeMirror5.copyState(baseMode, state.base),
                tokenize: state.tokenize,
                last: state.last,
                depth: state.depth
              };
            },
            innerMode: function(state) {
              if (state.tokenize == tokenTop)
                return { mode: baseMode, state: state.base };
            },
            token: function(stream, state) {
              var style = state.tokenize(stream, state);
              state.last = last;
              return style;
            },
            indent: function(state, text, line) {
              if (state.tokenize == tokenTop && baseMode.indent)
                return baseMode.indent(state.base, text, line);
              else
                return CodeMirror5.Pass;
            },
            blockCommentStart: leftDelimiter + "*",
            blockCommentEnd: "*" + rightDelimiter
          };
        });
        CodeMirror5.defineMIME("text/x-smarty", "smarty");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/solr/solr.js
  var require_solr = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/solr/solr.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("solr", function() {
          "use strict";
          var isStringChar = /[^\s\|\!\+\-\*\?\~\^\&\:\(\)\[\]\{\}\"\\]/;
          var isOperatorChar = /[\|\!\+\-\*\?\~\^\&]/;
          var isOperatorString = /^(OR|AND|NOT|TO)$/i;
          function isNumber2(word) {
            return parseFloat(word).toString() === word;
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped)
                  break;
                escaped = !escaped && next == "\\";
              }
              if (!escaped)
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function tokenOperator(operator) {
            return function(stream, state) {
              var style = "operator";
              if (operator == "+")
                style += " positive";
              else if (operator == "-")
                style += " negative";
              else if (operator == "|")
                stream.eat(/\|/);
              else if (operator == "&")
                stream.eat(/\&/);
              else if (operator == "^")
                style += " boost";
              state.tokenize = tokenBase;
              return style;
            };
          }
          function tokenWord(ch) {
            return function(stream, state) {
              var word = ch;
              while ((ch = stream.peek()) && ch.match(isStringChar) != null) {
                word += stream.next();
              }
              state.tokenize = tokenBase;
              if (isOperatorString.test(word))
                return "operator";
              else if (isNumber2(word))
                return "number";
              else if (stream.peek() == ":")
                return "field";
              else
                return "string";
            };
          }
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"')
              state.tokenize = tokenString(ch);
            else if (isOperatorChar.test(ch))
              state.tokenize = tokenOperator(ch);
            else if (isStringChar.test(ch))
              state.tokenize = tokenWord(ch);
            return state.tokenize != tokenBase ? state.tokenize(stream, state) : null;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return state.tokenize(stream, state);
            }
          };
        });
        CodeMirror5.defineMIME("text/x-solr", "solr");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/soy/soy.js
  var require_soy = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/soy/soy.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_htmlmixed());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../htmlmixed/htmlmixed"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var paramData = { noEndTag: true, soyState: "param-def" };
        var tags = {
          "alias": { noEndTag: true },
          "delpackage": { noEndTag: true },
          "namespace": { noEndTag: true, soyState: "namespace-def" },
          "@param": paramData,
          "@param?": paramData,
          "@inject": paramData,
          "@inject?": paramData,
          "@state": paramData,
          "template": { soyState: "templ-def", variableScope: true },
          "literal": {},
          "msg": {},
          "fallbackmsg": { noEndTag: true, reduceIndent: true },
          "select": {},
          "plural": {},
          "let": { soyState: "var-def" },
          "if": {},
          "elseif": { noEndTag: true, reduceIndent: true },
          "else": { noEndTag: true, reduceIndent: true },
          "switch": {},
          "case": { noEndTag: true, reduceIndent: true },
          "default": { noEndTag: true, reduceIndent: true },
          "foreach": { variableScope: true, soyState: "var-def" },
          "ifempty": { noEndTag: true, reduceIndent: true },
          "for": { variableScope: true, soyState: "var-def" },
          "call": { soyState: "templ-ref" },
          "param": { soyState: "param-ref" },
          "print": { noEndTag: true },
          "deltemplate": { soyState: "templ-def", variableScope: true },
          "delcall": { soyState: "templ-ref" },
          "log": {},
          "element": { variableScope: true }
        };
        var indentingTags = Object.keys(tags).filter(function(tag) {
          return !tags[tag].noEndTag || tags[tag].reduceIndent;
        });
        CodeMirror5.defineMode("soy", function(config3) {
          var textMode = CodeMirror5.getMode(config3, "text/plain");
          var modes = {
            html: CodeMirror5.getMode(config3, { name: "text/html", multilineTagIndentFactor: 2, multilineTagIndentPastTag: false }),
            attributes: textMode,
            text: textMode,
            uri: textMode,
            trusted_resource_uri: textMode,
            css: CodeMirror5.getMode(config3, "text/css"),
            js: CodeMirror5.getMode(config3, { name: "text/javascript", statementIndent: 2 * config3.indentUnit })
          };
          function last(array) {
            return array[array.length - 1];
          }
          function tokenUntil(stream, state, untilRegExp) {
            if (stream.sol()) {
              for (var indent = 0; indent < state.indent; indent++) {
                if (!stream.eat(/\s/))
                  break;
              }
              if (indent)
                return null;
            }
            var oldString = stream.string;
            var match = untilRegExp.exec(oldString.substr(stream.pos));
            if (match) {
              stream.string = oldString.substr(0, stream.pos + match.index);
            }
            var result = stream.hideFirstChars(state.indent, function() {
              var localState = last(state.localStates);
              return localState.mode.token(stream, localState.state);
            });
            stream.string = oldString;
            return result;
          }
          function contains3(list, element3) {
            while (list) {
              if (list.element === element3)
                return true;
              list = list.next;
            }
            return false;
          }
          function prepend(list, element3) {
            return {
              element: element3,
              next: list
            };
          }
          function popcontext(state) {
            if (!state.context)
              return;
            if (state.context.scope) {
              state.variables = state.context.scope;
            }
            state.context = state.context.previousContext;
          }
          function ref(list, name106, loose) {
            return contains3(list, name106) ? "variable-2" : loose ? "variable" : "variable-2 error";
          }
          function Context(previousContext, tag, scope) {
            this.previousContext = previousContext;
            this.tag = tag;
            this.kind = null;
            this.scope = scope;
          }
          function expression(stream, state) {
            var match;
            if (stream.match(/[[]/)) {
              state.soyState.push("list-literal");
              state.lookupVariables = false;
              return null;
            } else if (stream.match(/map\b/)) {
              state.soyState.push("map-literal");
              return "keyword";
            } else if (stream.match(/record\b/)) {
              state.soyState.push("record-literal");
              return "keyword";
            } else if (stream.match(/([\w]+)(?=\()/)) {
              return "variable callee";
            } else if (match = stream.match(/^["']/)) {
              state.soyState.push("string");
              state.quoteKind = match[0];
              return "string";
            } else if (stream.match(/^[(]/)) {
              state.soyState.push("open-parentheses");
              return null;
            } else if (stream.match(/(null|true|false)(?!\w)/) || stream.match(/0x([0-9a-fA-F]{2,})/) || stream.match(/-?([0-9]*[.])?[0-9]+(e[0-9]*)?/)) {
              return "atom";
            } else if (stream.match(/(\||[+\-*\/%]|[=!]=|\?:|[<>]=?)/)) {
              return "operator";
            } else if (match = stream.match(/^\$([\w]+)/)) {
              return ref(state.variables, match[1], !state.lookupVariables);
            } else if (match = stream.match(/^\w+/)) {
              return /^(?:as|and|or|not|in|if)$/.test(match[0]) ? "keyword" : null;
            }
            stream.next();
            return null;
          }
          return {
            startState: function() {
              return {
                soyState: [],
                variables: prepend(null, "ij"),
                scopes: null,
                indent: 0,
                quoteKind: null,
                context: null,
                lookupVariables: true,
                localStates: [{
                  mode: modes.html,
                  state: CodeMirror5.startState(modes.html)
                }]
              };
            },
            copyState: function(state) {
              return {
                tag: state.tag,
                soyState: state.soyState.concat([]),
                variables: state.variables,
                context: state.context,
                indent: state.indent,
                quoteKind: state.quoteKind,
                lookupVariables: state.lookupVariables,
                localStates: state.localStates.map(function(localState) {
                  return {
                    mode: localState.mode,
                    state: CodeMirror5.copyState(localState.mode, localState.state)
                  };
                })
              };
            },
            token: function(stream, state) {
              var match;
              switch (last(state.soyState)) {
                case "comment":
                  if (stream.match(/^.*?\*\//)) {
                    state.soyState.pop();
                  } else {
                    stream.skipToEnd();
                  }
                  if (!state.context || !state.context.scope) {
                    var paramRe = /@param\??\s+(\S+)/g;
                    var current = stream.current();
                    for (var match; match = paramRe.exec(current); ) {
                      state.variables = prepend(state.variables, match[1]);
                    }
                  }
                  return "comment";
                case "string":
                  var match = stream.match(/^.*?(["']|\\[\s\S])/);
                  if (!match) {
                    stream.skipToEnd();
                  } else if (match[1] == state.quoteKind) {
                    state.quoteKind = null;
                    state.soyState.pop();
                  }
                  return "string";
              }
              if (!state.soyState.length || last(state.soyState) != "literal") {
                if (stream.match(/^\/\*/)) {
                  state.soyState.push("comment");
                  return "comment";
                } else if (stream.match(stream.sol() ? /^\s*\/\/.*/ : /^\s+\/\/.*/)) {
                  return "comment";
                }
              }
              switch (last(state.soyState)) {
                case "templ-def":
                  if (match = stream.match(/^\.?([\w]+(?!\.[\w]+)*)/)) {
                    state.soyState.pop();
                    return "def";
                  }
                  stream.next();
                  return null;
                case "templ-ref":
                  if (match = stream.match(/(\.?[a-zA-Z_][a-zA-Z_0-9]+)+/)) {
                    state.soyState.pop();
                    if (match[0][0] == ".") {
                      return "variable-2";
                    }
                    return "variable";
                  }
                  stream.next();
                  return null;
                case "namespace-def":
                  if (match = stream.match(/^\.?([\w\.]+)/)) {
                    state.soyState.pop();
                    return "variable";
                  }
                  stream.next();
                  return null;
                case "param-def":
                  if (match = stream.match(/^\w+/)) {
                    state.variables = prepend(state.variables, match[0]);
                    state.soyState.pop();
                    state.soyState.push("param-type");
                    return "def";
                  }
                  stream.next();
                  return null;
                case "param-ref":
                  if (match = stream.match(/^\w+/)) {
                    state.soyState.pop();
                    return "property";
                  }
                  stream.next();
                  return null;
                case "open-parentheses":
                  if (stream.match(/[)]/)) {
                    state.soyState.pop();
                    return null;
                  }
                  return expression(stream, state);
                case "param-type":
                  var peekChar = stream.peek();
                  if ("}]=>,".indexOf(peekChar) != -1) {
                    state.soyState.pop();
                    return null;
                  } else if (peekChar == "[") {
                    state.soyState.push("param-type-record");
                    return null;
                  } else if (match = stream.match(/^([\w]+|[?])/)) {
                    if (match[0] == "map" || match[0] == "list") {
                      state.soyState.push("param-type-map-list");
                    }
                    return "type";
                  }
                  stream.next();
                  return null;
                case "param-type-record":
                  var peekChar = stream.peek();
                  if (peekChar == "]") {
                    state.soyState.pop();
                    return null;
                  }
                  if (stream.match(/^\w+/)) {
                    state.soyState.push("param-type");
                    return "property";
                  }
                  stream.next();
                  return null;
                case "param-type-map-list":
                  var peekChar = stream.peek();
                  if (stream.match(/^[>]/)) {
                    state.soyState.pop();
                    return null;
                  }
                  if (stream.match(/^[<,]/)) {
                    state.soyState.push("param-type");
                    return null;
                  }
                  stream.next();
                  return null;
                case "var-def":
                  if (match = stream.match(/^\$([\w]+)/)) {
                    state.variables = prepend(state.variables, match[1]);
                    state.soyState.pop();
                    return "def";
                  }
                  stream.next();
                  return null;
                case "record-literal":
                  if (stream.match(/^[)]/)) {
                    state.soyState.pop();
                    return null;
                  }
                  if (stream.match(/[(,]/)) {
                    state.soyState.push("map-value");
                    state.soyState.push("record-key");
                    return null;
                  }
                  stream.next();
                  return null;
                case "map-literal":
                  if (stream.match(/^[)]/)) {
                    state.soyState.pop();
                    return null;
                  }
                  if (stream.match(/[(,]/)) {
                    state.soyState.push("map-value");
                    state.soyState.push("map-value");
                    return null;
                  }
                  stream.next();
                  return null;
                case "list-literal":
                  if (stream.match(/\]/)) {
                    state.soyState.pop();
                    state.lookupVariables = true;
                    return null;
                  }
                  if (stream.match(/for\b/)) {
                    state.soyState.push("var-def");
                    return "keyword";
                  } else if (stream.match(/in\b/)) {
                    state.lookupVariables = true;
                    return "keyword";
                  }
                  return expression(stream, state);
                case "record-key":
                  if (stream.match(/[\w]+/)) {
                    return "property";
                  }
                  if (stream.match(/^[:]/)) {
                    state.soyState.pop();
                    return null;
                  }
                  stream.next();
                  return null;
                case "map-value":
                  if (stream.peek() == ")" || stream.peek() == "," || stream.match(/^[:)]/)) {
                    state.soyState.pop();
                    return null;
                  }
                  return expression(stream, state);
                case "tag":
                  var endTag = state.tag[0] == "/";
                  var tagName = endTag ? state.tag.substring(1) : state.tag;
                  var tag = tags[tagName];
                  if (stream.match(/^\/?}/)) {
                    var selfClosed = stream.current() == "/}";
                    if (selfClosed && !endTag) {
                      popcontext(state);
                    }
                    if (state.tag == "/template" || state.tag == "/deltemplate") {
                      state.variables = prepend(null, "ij");
                      state.indent = 0;
                    } else {
                      state.indent -= config3.indentUnit * (selfClosed || indentingTags.indexOf(state.tag) == -1 ? 2 : 1);
                    }
                    state.soyState.pop();
                    return "keyword";
                  } else if (stream.match(/^([\w?]+)(?==)/)) {
                    if (state.context && state.context.tag == tagName && stream.current() == "kind" && (match = stream.match(/^="([^"]+)/, false))) {
                      var kind = match[1];
                      state.context.kind = kind;
                      var mode2 = modes[kind] || modes.html;
                      var localState = last(state.localStates);
                      if (localState.mode.indent) {
                        state.indent += localState.mode.indent(localState.state, "", "");
                      }
                      state.localStates.push({
                        mode: mode2,
                        state: CodeMirror5.startState(mode2)
                      });
                    }
                    return "attribute";
                  }
                  return expression(stream, state);
                case "literal":
                  if (stream.match(/^(?=\{\/literal})/)) {
                    state.soyState.pop();
                    return this.token(stream, state);
                  }
                  return tokenUntil(stream, state, /\{\/literal}/);
              }
              if (stream.match(/^\{literal}/)) {
                state.indent += config3.indentUnit;
                state.soyState.push("literal");
                state.context = new Context(state.context, "literal", state.variables);
                return "keyword";
              } else if (match = stream.match(/^\{([/@\\]?\w+\??)(?=$|[\s}]|\/[/*])/)) {
                var prevTag = state.tag;
                state.tag = match[1];
                var endTag = state.tag[0] == "/";
                var indentingTag = !!tags[state.tag];
                var tagName = endTag ? state.tag.substring(1) : state.tag;
                var tag = tags[tagName];
                if (state.tag != "/switch")
                  state.indent += ((endTag || tag && tag.reduceIndent) && prevTag != "switch" ? 1 : 2) * config3.indentUnit;
                state.soyState.push("tag");
                var tagError = false;
                if (tag) {
                  if (!endTag) {
                    if (tag.soyState)
                      state.soyState.push(tag.soyState);
                  }
                  if (!tag.noEndTag && (indentingTag || !endTag)) {
                    state.context = new Context(state.context, state.tag, tag.variableScope ? state.variables : null);
                  } else if (endTag) {
                    if (!state.context || state.context.tag != tagName) {
                      tagError = true;
                    } else if (state.context) {
                      if (state.context.kind) {
                        state.localStates.pop();
                        var localState = last(state.localStates);
                        if (localState.mode.indent) {
                          state.indent -= localState.mode.indent(localState.state, "", "");
                        }
                      }
                      popcontext(state);
                    }
                  }
                } else if (endTag) {
                  tagError = true;
                }
                return (tagError ? "error " : "") + "keyword";
              } else if (stream.eat("{")) {
                state.tag = "print";
                state.indent += 2 * config3.indentUnit;
                state.soyState.push("tag");
                return "keyword";
              }
              return tokenUntil(stream, state, /\{|\s+\/\/|\/\*/);
            },
            indent: function(state, textAfter, line) {
              var indent = state.indent, top = last(state.soyState);
              if (top == "comment")
                return CodeMirror5.Pass;
              if (top == "literal") {
                if (/^\{\/literal}/.test(textAfter))
                  indent -= config3.indentUnit;
              } else {
                if (/^\s*\{\/(template|deltemplate)\b/.test(textAfter))
                  return 0;
                if (/^\{(\/|(fallbackmsg|elseif|else|ifempty)\b)/.test(textAfter))
                  indent -= config3.indentUnit;
                if (state.tag != "switch" && /^\{(case|default)\b/.test(textAfter))
                  indent -= config3.indentUnit;
                if (/^\{\/switch\b/.test(textAfter))
                  indent -= config3.indentUnit;
              }
              var localState = last(state.localStates);
              if (indent && localState.mode.indent) {
                indent += localState.mode.indent(localState.state, textAfter, line);
              }
              return indent;
            },
            innerMode: function(state) {
              if (state.soyState.length && last(state.soyState) != "literal")
                return null;
              else
                return last(state.localStates);
            },
            electricInput: /^\s*\{(\/|\/template|\/deltemplate|\/switch|fallbackmsg|elseif|else|case|default|ifempty|\/literal\})$/,
            lineComment: "//",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            blockCommentContinue: " * ",
            useInnerComments: false,
            fold: "indent"
          };
        }, "htmlmixed");
        CodeMirror5.registerHelper("wordChars", "soy", /[\w$]/);
        CodeMirror5.registerHelper("hintWords", "soy", Object.keys(tags).concat(["css", "debugger"]));
        CodeMirror5.defineMIME("text/x-soy", "soy");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/sparql/sparql.js
  var require_sparql = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/sparql/sparql.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("sparql", function(config3) {
          var indentUnit = config3.indentUnit;
          var curPunc;
          function wordRegexp(words) {
            return new RegExp("^(?:" + words.join("|") + ")$", "i");
          }
          var ops = wordRegexp([
            "str",
            "lang",
            "langmatches",
            "datatype",
            "bound",
            "sameterm",
            "isiri",
            "isuri",
            "iri",
            "uri",
            "bnode",
            "count",
            "sum",
            "min",
            "max",
            "avg",
            "sample",
            "group_concat",
            "rand",
            "abs",
            "ceil",
            "floor",
            "round",
            "concat",
            "substr",
            "strlen",
            "replace",
            "ucase",
            "lcase",
            "encode_for_uri",
            "contains",
            "strstarts",
            "strends",
            "strbefore",
            "strafter",
            "year",
            "month",
            "day",
            "hours",
            "minutes",
            "seconds",
            "timezone",
            "tz",
            "now",
            "uuid",
            "struuid",
            "md5",
            "sha1",
            "sha256",
            "sha384",
            "sha512",
            "coalesce",
            "if",
            "strlang",
            "strdt",
            "isnumeric",
            "regex",
            "exists",
            "isblank",
            "isliteral",
            "a",
            "bind"
          ]);
          var keywords2 = wordRegexp([
            "base",
            "prefix",
            "select",
            "distinct",
            "reduced",
            "construct",
            "describe",
            "ask",
            "from",
            "named",
            "where",
            "order",
            "limit",
            "offset",
            "filter",
            "optional",
            "graph",
            "by",
            "asc",
            "desc",
            "as",
            "having",
            "undef",
            "values",
            "group",
            "minus",
            "in",
            "not",
            "service",
            "silent",
            "using",
            "insert",
            "delete",
            "union",
            "true",
            "false",
            "with",
            "data",
            "copy",
            "to",
            "move",
            "add",
            "create",
            "drop",
            "clear",
            "load"
          ]);
          var operatorChars = /[*+\-<>=&|\^\/!\?]/;
          function tokenBase(stream, state) {
            var ch = stream.next();
            curPunc = null;
            if (ch == "$" || ch == "?") {
              if (ch == "?" && stream.match(/\s/, false)) {
                return "operator";
              }
              stream.match(/^[A-Za-z0-9_\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][A-Za-z0-9_\u00B7\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u037D\u037F-\u1FFF\u200C-\u200D\u203F-\u2040\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]*/);
              return "variable-2";
            } else if (ch == "<" && !stream.match(/^[\s\u00a0=]/, false)) {
              stream.match(/^[^\s\u00a0>]*>?/);
              return "atom";
            } else if (ch == '"' || ch == "'") {
              state.tokenize = tokenLiteral(ch);
              return state.tokenize(stream, state);
            } else if (/[{}\(\),\.;\[\]]/.test(ch)) {
              curPunc = ch;
              return "bracket";
            } else if (ch == "#") {
              stream.skipToEnd();
              return "comment";
            } else if (operatorChars.test(ch)) {
              stream.eatWhile(operatorChars);
              return "operator";
            } else if (ch == ":") {
              stream.eatWhile(/[\w\d\._\-]/);
              return "atom";
            } else if (ch == "@") {
              stream.eatWhile(/[a-z\d\-]/i);
              return "meta";
            } else {
              stream.eatWhile(/[_\w\d]/);
              if (stream.eat(":")) {
                stream.eatWhile(/[\w\d_\-]/);
                return "atom";
              }
              var word = stream.current();
              if (ops.test(word))
                return "builtin";
              else if (keywords2.test(word))
                return "keyword";
              else
                return "variable";
            }
          }
          function tokenLiteral(quote) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped) {
                  state.tokenize = tokenBase;
                  break;
                }
                escaped = !escaped && ch == "\\";
              }
              return "string";
            };
          }
          function pushContext(state, type, col) {
            state.context = { prev: state.context, indent: state.indent, col, type };
          }
          function popContext(state) {
            state.indent = state.context.indent;
            state.context = state.context.prev;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                context: null,
                indent: 0,
                col: 0
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (state.context && state.context.align == null)
                  state.context.align = false;
                state.indent = stream.indentation();
              }
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              if (style != "comment" && state.context && state.context.align == null && state.context.type != "pattern") {
                state.context.align = true;
              }
              if (curPunc == "(")
                pushContext(state, ")", stream.column());
              else if (curPunc == "[")
                pushContext(state, "]", stream.column());
              else if (curPunc == "{")
                pushContext(state, "}", stream.column());
              else if (/[\]\}\)]/.test(curPunc)) {
                while (state.context && state.context.type == "pattern")
                  popContext(state);
                if (state.context && curPunc == state.context.type) {
                  popContext(state);
                  if (curPunc == "}" && state.context && state.context.type == "pattern")
                    popContext(state);
                }
              } else if (curPunc == "." && state.context && state.context.type == "pattern")
                popContext(state);
              else if (/atom|string|variable/.test(style) && state.context) {
                if (/[\}\]]/.test(state.context.type))
                  pushContext(state, "pattern", stream.column());
                else if (state.context.type == "pattern" && !state.context.align) {
                  state.context.align = true;
                  state.context.col = stream.column();
                }
              }
              return style;
            },
            indent: function(state, textAfter) {
              var firstChar = textAfter && textAfter.charAt(0);
              var context = state.context;
              if (/[\]\}]/.test(firstChar))
                while (context && context.type == "pattern")
                  context = context.prev;
              var closing = context && firstChar == context.type;
              if (!context)
                return 0;
              else if (context.type == "pattern")
                return context.col;
              else if (context.align)
                return context.col + (closing ? 0 : 1);
              else
                return context.indent + (closing ? 0 : indentUnit);
            },
            lineComment: "#"
          };
        });
        CodeMirror5.defineMIME("application/sparql-query", "sparql");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/spreadsheet/spreadsheet.js
  var require_spreadsheet = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/spreadsheet/spreadsheet.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("spreadsheet", function() {
          return {
            startState: function() {
              return {
                stringType: null,
                stack: []
              };
            },
            token: function(stream, state) {
              if (!stream)
                return;
              if (state.stack.length === 0) {
                if (stream.peek() == '"' || stream.peek() == "'") {
                  state.stringType = stream.peek();
                  stream.next();
                  state.stack.unshift("string");
                }
              }
              switch (state.stack[0]) {
                case "string":
                  while (state.stack[0] === "string" && !stream.eol()) {
                    if (stream.peek() === state.stringType) {
                      stream.next();
                      state.stack.shift();
                    } else if (stream.peek() === "\\") {
                      stream.next();
                      stream.next();
                    } else {
                      stream.match(/^.[^\\\"\']*/);
                    }
                  }
                  return "string";
                case "characterClass":
                  while (state.stack[0] === "characterClass" && !stream.eol()) {
                    if (!(stream.match(/^[^\]\\]+/) || stream.match(/^\\./)))
                      state.stack.shift();
                  }
                  return "operator";
              }
              var peek = stream.peek();
              switch (peek) {
                case "[":
                  stream.next();
                  state.stack.unshift("characterClass");
                  return "bracket";
                case ":":
                  stream.next();
                  return "operator";
                case "\\":
                  if (stream.match(/\\[a-z]+/))
                    return "string-2";
                  else {
                    stream.next();
                    return "atom";
                  }
                case ".":
                case ",":
                case ";":
                case "*":
                case "-":
                case "+":
                case "^":
                case "<":
                case "/":
                case "=":
                  stream.next();
                  return "atom";
                case "$":
                  stream.next();
                  return "builtin";
              }
              if (stream.match(/\d+/)) {
                if (stream.match(/^\w+/))
                  return "error";
                return "number";
              } else if (stream.match(/^[a-zA-Z_]\w*/)) {
                if (stream.match(/(?=[\(.])/, false))
                  return "keyword";
                return "variable-2";
              } else if (["[", "]", "(", ")", "{", "}"].indexOf(peek) != -1) {
                stream.next();
                return "bracket";
              } else if (!stream.eatSpace()) {
                stream.next();
              }
              return null;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-spreadsheet", "spreadsheet");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/sql/sql.js
  var require_sql = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/sql/sql.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("sql", function(config3, parserConfig) {
          var client = parserConfig.client || {}, atoms = parserConfig.atoms || { "false": true, "true": true, "null": true }, builtin = parserConfig.builtin || set(defaultBuiltin), keywords2 = parserConfig.keywords || set(sqlKeywords), operatorChars = parserConfig.operatorChars || /^[*+\-%<>!=&|~^\/]/, support = parserConfig.support || {}, hooks = parserConfig.hooks || {}, dateSQL = parserConfig.dateSQL || { "date": true, "time": true, "timestamp": true }, backslashStringEscapes = parserConfig.backslashStringEscapes !== false, brackets = parserConfig.brackets || /^[\{}\(\)\[\]]/, punctuation = parserConfig.punctuation || /^[;.,:]/;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (hooks[ch]) {
              var result = hooks[ch](stream, state);
              if (result !== false)
                return result;
            }
            if (support.hexNumber && (ch == "0" && stream.match(/^[xX][0-9a-fA-F]+/) || (ch == "x" || ch == "X") && stream.match(/^'[0-9a-fA-F]+'/))) {
              return "number";
            } else if (support.binaryNumber && ((ch == "b" || ch == "B") && stream.match(/^'[01]+'/) || ch == "0" && stream.match(/^b[01]+/))) {
              return "number";
            } else if (ch.charCodeAt(0) > 47 && ch.charCodeAt(0) < 58) {
              stream.match(/^[0-9]*(\.[0-9]+)?([eE][-+]?[0-9]+)?/);
              support.decimallessFloat && stream.match(/^\.(?!\.)/);
              return "number";
            } else if (ch == "?" && (stream.eatSpace() || stream.eol() || stream.eat(";"))) {
              return "variable-3";
            } else if (ch == "'" || ch == '"' && support.doubleQuote) {
              state.tokenize = tokenLiteral(ch);
              return state.tokenize(stream, state);
            } else if ((support.nCharCast && (ch == "n" || ch == "N") || support.charsetCast && ch == "_" && stream.match(/[a-z][a-z0-9]*/i)) && (stream.peek() == "'" || stream.peek() == '"')) {
              return "keyword";
            } else if (support.escapeConstant && (ch == "e" || ch == "E") && (stream.peek() == "'" || stream.peek() == '"' && support.doubleQuote)) {
              state.tokenize = function(stream2, state2) {
                return (state2.tokenize = tokenLiteral(stream2.next(), true))(stream2, state2);
              };
              return "keyword";
            } else if (support.commentSlashSlash && ch == "/" && stream.eat("/")) {
              stream.skipToEnd();
              return "comment";
            } else if (support.commentHash && ch == "#" || ch == "-" && stream.eat("-") && (!support.commentSpaceRequired || stream.eat(" "))) {
              stream.skipToEnd();
              return "comment";
            } else if (ch == "/" && stream.eat("*")) {
              state.tokenize = tokenComment(1);
              return state.tokenize(stream, state);
            } else if (ch == ".") {
              if (support.zerolessFloat && stream.match(/^(?:\d+(?:e[+-]?\d+)?)/i))
                return "number";
              if (stream.match(/^\.+/))
                return null;
              if (support.ODBCdotTable && stream.match(/^[\w\d_]+/))
                return "variable-2";
            } else if (operatorChars.test(ch)) {
              stream.eatWhile(operatorChars);
              return "operator";
            } else if (brackets.test(ch)) {
              return "bracket";
            } else if (punctuation.test(ch)) {
              stream.eatWhile(punctuation);
              return "punctuation";
            } else if (ch == "{" && (stream.match(/^( )*(d|D|t|T|ts|TS)( )*'[^']*'( )*}/) || stream.match(/^( )*(d|D|t|T|ts|TS)( )*"[^"]*"( )*}/))) {
              return "number";
            } else {
              stream.eatWhile(/^[_\w\d]/);
              var word = stream.current().toLowerCase();
              if (dateSQL.hasOwnProperty(word) && (stream.match(/^( )+'[^']*'/) || stream.match(/^( )+"[^"]*"/)))
                return "number";
              if (atoms.hasOwnProperty(word))
                return "atom";
              if (builtin.hasOwnProperty(word))
                return "builtin";
              if (keywords2.hasOwnProperty(word))
                return "keyword";
              if (client.hasOwnProperty(word))
                return "string-2";
              return null;
            }
          }
          function tokenLiteral(quote, backslashEscapes) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped) {
                  state.tokenize = tokenBase;
                  break;
                }
                escaped = (backslashStringEscapes || backslashEscapes) && !escaped && ch == "\\";
              }
              return "string";
            };
          }
          function tokenComment(depth) {
            return function(stream, state) {
              var m3 = stream.match(/^.*?(\/\*|\*\/)/);
              if (!m3)
                stream.skipToEnd();
              else if (m3[1] == "/*")
                state.tokenize = tokenComment(depth + 1);
              else if (depth > 1)
                state.tokenize = tokenComment(depth - 1);
              else
                state.tokenize = tokenBase;
              return "comment";
            };
          }
          function pushContext(stream, state, type) {
            state.context = {
              prev: state.context,
              indent: stream.indentation(),
              col: stream.column(),
              type
            };
          }
          function popContext(state) {
            state.indent = state.context.indent;
            state.context = state.context.prev;
          }
          return {
            startState: function() {
              return { tokenize: tokenBase, context: null };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (state.context && state.context.align == null)
                  state.context.align = false;
              }
              if (state.tokenize == tokenBase && stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              if (style == "comment")
                return style;
              if (state.context && state.context.align == null)
                state.context.align = true;
              var tok = stream.current();
              if (tok == "(")
                pushContext(stream, state, ")");
              else if (tok == "[")
                pushContext(stream, state, "]");
              else if (state.context && state.context.type == tok)
                popContext(state);
              return style;
            },
            indent: function(state, textAfter) {
              var cx = state.context;
              if (!cx)
                return CodeMirror5.Pass;
              var closing = textAfter.charAt(0) == cx.type;
              if (cx.align)
                return cx.col + (closing ? 0 : 1);
              else
                return cx.indent + (closing ? 0 : config3.indentUnit);
            },
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: support.commentSlashSlash ? "//" : support.commentHash ? "#" : "--",
            closeBrackets: "()[]{}''\"\"``"
          };
        });
        function hookIdentifier(stream) {
          var ch;
          while ((ch = stream.next()) != null) {
            if (ch == "`" && !stream.eat("`"))
              return "variable-2";
          }
          stream.backUp(stream.current().length - 1);
          return stream.eatWhile(/\w/) ? "variable-2" : null;
        }
        function hookIdentifierDoublequote(stream) {
          var ch;
          while ((ch = stream.next()) != null) {
            if (ch == '"' && !stream.eat('"'))
              return "variable-2";
          }
          stream.backUp(stream.current().length - 1);
          return stream.eatWhile(/\w/) ? "variable-2" : null;
        }
        function hookVar(stream) {
          if (stream.eat("@")) {
            stream.match(/^session\./);
            stream.match(/^local\./);
            stream.match(/^global\./);
          }
          if (stream.eat("'")) {
            stream.match(/^.*'/);
            return "variable-2";
          } else if (stream.eat('"')) {
            stream.match(/^.*"/);
            return "variable-2";
          } else if (stream.eat("`")) {
            stream.match(/^.*`/);
            return "variable-2";
          } else if (stream.match(/^[0-9a-zA-Z$\.\_]+/)) {
            return "variable-2";
          }
          return null;
        }
        ;
        function hookClient(stream) {
          if (stream.eat("N")) {
            return "atom";
          }
          return stream.match(/^[a-zA-Z.#!?]/) ? "variable-2" : null;
        }
        var sqlKeywords = "alter and as asc between by count create delete desc distinct drop from group having in insert into is join like not on or order select set table union update values where limit ";
        function set(str) {
          var obj = {}, words = str.split(" ");
          for (var i3 = 0; i3 < words.length; ++i3)
            obj[words[i3]] = true;
          return obj;
        }
        var defaultBuiltin = "bool boolean bit blob enum long longblob longtext medium mediumblob mediumint mediumtext time timestamp tinyblob tinyint tinytext text bigint int int1 int2 int3 int4 int8 integer float float4 float8 double char varbinary varchar varcharacter precision real date datetime year unsigned signed decimal numeric";
        CodeMirror5.defineMIME("text/x-sql", {
          name: "sql",
          keywords: set(sqlKeywords + "begin"),
          builtin: set(defaultBuiltin),
          atoms: set("false true null unknown"),
          dateSQL: set("date time timestamp"),
          support: set("ODBCdotTable doubleQuote binaryNumber hexNumber")
        });
        CodeMirror5.defineMIME("text/x-mssql", {
          name: "sql",
          client: set("$partition binary_checksum checksum connectionproperty context_info current_request_id error_line error_message error_number error_procedure error_severity error_state formatmessage get_filestream_transaction_context getansinull host_id host_name isnull isnumeric min_active_rowversion newid newsequentialid rowcount_big xact_state object_id"),
          keywords: set(sqlKeywords + "begin trigger proc view index for add constraint key primary foreign collate clustered nonclustered declare exec go if use index holdlock nolock nowait paglock readcommitted readcommittedlock readpast readuncommitted repeatableread rowlock serializable snapshot tablock tablockx updlock with"),
          builtin: set("bigint numeric bit smallint decimal smallmoney int tinyint money float real char varchar text nchar nvarchar ntext binary varbinary image cursor timestamp hierarchyid uniqueidentifier sql_variant xml table "),
          atoms: set("is not null like and or in left right between inner outer join all any some cross unpivot pivot exists"),
          operatorChars: /^[*+\-%<>!=^\&|\/]/,
          brackets: /^[\{}\(\)]/,
          punctuation: /^[;.,:/]/,
          backslashStringEscapes: false,
          dateSQL: set("date datetimeoffset datetime2 smalldatetime datetime time"),
          hooks: {
            "@": hookVar
          }
        });
        CodeMirror5.defineMIME("text/x-mysql", {
          name: "sql",
          client: set("charset clear connect edit ego exit go help nopager notee nowarning pager print prompt quit rehash source status system tee"),
          keywords: set(sqlKeywords + "accessible action add after algorithm all analyze asensitive at authors auto_increment autocommit avg avg_row_length before binary binlog both btree cache call cascade cascaded case catalog_name chain change changed character check checkpoint checksum class_origin client_statistics close coalesce code collate collation collations column columns comment commit committed completion concurrent condition connection consistent constraint contains continue contributors convert cross current current_date current_time current_timestamp current_user cursor data database databases day_hour day_microsecond day_minute day_second deallocate dec declare default delay_key_write delayed delimiter des_key_file describe deterministic dev_pop dev_samp deviance diagnostics directory disable discard distinctrow div dual dumpfile each elseif enable enclosed end ends engine engines enum errors escape escaped even event events every execute exists exit explain extended fast fetch field fields first flush for force foreign found_rows full fulltext function general get global grant grants group group_concat handler hash help high_priority hosts hour_microsecond hour_minute hour_second if ignore ignore_server_ids import index index_statistics infile inner innodb inout insensitive insert_method install interval invoker isolation iterate key keys kill language last leading leave left level limit linear lines list load local localtime localtimestamp lock logs low_priority master master_heartbeat_period master_ssl_verify_server_cert masters match max max_rows maxvalue message_text middleint migrate min min_rows minute_microsecond minute_second mod mode modifies modify mutex mysql_errno natural next no no_write_to_binlog offline offset one online open optimize option optionally out outer outfile pack_keys parser partition partitions password phase plugin plugins prepare preserve prev primary privileges procedure processlist profile profiles purge query quick range read read_write reads real rebuild recover references regexp relaylog release remove rename reorganize repair repeatable replace require resignal restrict resume return returns revoke right rlike rollback rollup row row_format rtree savepoint schedule schema schema_name schemas second_microsecond security sensitive separator serializable server session share show signal slave slow smallint snapshot soname spatial specific sql sql_big_result sql_buffer_result sql_cache sql_calc_found_rows sql_no_cache sql_small_result sqlexception sqlstate sqlwarning ssl start starting starts status std stddev stddev_pop stddev_samp storage straight_join subclass_origin sum suspend table_name table_statistics tables tablespace temporary terminated to trailing transaction trigger triggers truncate uncommitted undo uninstall unique unlock upgrade usage use use_frm user user_resources user_statistics using utc_date utc_time utc_timestamp value variables varying view views warnings when while with work write xa xor year_month zerofill begin do then else loop repeat"),
          builtin: set("bool boolean bit blob decimal double float long longblob longtext medium mediumblob mediumint mediumtext time timestamp tinyblob tinyint tinytext text bigint int int1 int2 int3 int4 int8 integer float float4 float8 double char varbinary varchar varcharacter precision date datetime year unsigned signed numeric"),
          atoms: set("false true null unknown"),
          operatorChars: /^[*+\-%<>!=&|^]/,
          dateSQL: set("date time timestamp"),
          support: set("ODBCdotTable decimallessFloat zerolessFloat binaryNumber hexNumber doubleQuote nCharCast charsetCast commentHash commentSpaceRequired"),
          hooks: {
            "@": hookVar,
            "`": hookIdentifier,
            "\\": hookClient
          }
        });
        CodeMirror5.defineMIME("text/x-mariadb", {
          name: "sql",
          client: set("charset clear connect edit ego exit go help nopager notee nowarning pager print prompt quit rehash source status system tee"),
          keywords: set(sqlKeywords + "accessible action add after algorithm all always analyze asensitive at authors auto_increment autocommit avg avg_row_length before binary binlog both btree cache call cascade cascaded case catalog_name chain change changed character check checkpoint checksum class_origin client_statistics close coalesce code collate collation collations column columns comment commit committed completion concurrent condition connection consistent constraint contains continue contributors convert cross current current_date current_time current_timestamp current_user cursor data database databases day_hour day_microsecond day_minute day_second deallocate dec declare default delay_key_write delayed delimiter des_key_file describe deterministic dev_pop dev_samp deviance diagnostics directory disable discard distinctrow div dual dumpfile each elseif enable enclosed end ends engine engines enum errors escape escaped even event events every execute exists exit explain extended fast fetch field fields first flush for force foreign found_rows full fulltext function general generated get global grant grants group groupby_concat handler hard hash help high_priority hosts hour_microsecond hour_minute hour_second if ignore ignore_server_ids import index index_statistics infile inner innodb inout insensitive insert_method install interval invoker isolation iterate key keys kill language last leading leave left level limit linear lines list load local localtime localtimestamp lock logs low_priority master master_heartbeat_period master_ssl_verify_server_cert masters match max max_rows maxvalue message_text middleint migrate min min_rows minute_microsecond minute_second mod mode modifies modify mutex mysql_errno natural next no no_write_to_binlog offline offset one online open optimize option optionally out outer outfile pack_keys parser partition partitions password persistent phase plugin plugins prepare preserve prev primary privileges procedure processlist profile profiles purge query quick range read read_write reads real rebuild recover references regexp relaylog release remove rename reorganize repair repeatable replace require resignal restrict resume return returns revoke right rlike rollback rollup row row_format rtree savepoint schedule schema schema_name schemas second_microsecond security sensitive separator serializable server session share show shutdown signal slave slow smallint snapshot soft soname spatial specific sql sql_big_result sql_buffer_result sql_cache sql_calc_found_rows sql_no_cache sql_small_result sqlexception sqlstate sqlwarning ssl start starting starts status std stddev stddev_pop stddev_samp storage straight_join subclass_origin sum suspend table_name table_statistics tables tablespace temporary terminated to trailing transaction trigger triggers truncate uncommitted undo uninstall unique unlock upgrade usage use use_frm user user_resources user_statistics using utc_date utc_time utc_timestamp value variables varying view views virtual warnings when while with work write xa xor year_month zerofill begin do then else loop repeat"),
          builtin: set("bool boolean bit blob decimal double float long longblob longtext medium mediumblob mediumint mediumtext time timestamp tinyblob tinyint tinytext text bigint int int1 int2 int3 int4 int8 integer float float4 float8 double char varbinary varchar varcharacter precision date datetime year unsigned signed numeric"),
          atoms: set("false true null unknown"),
          operatorChars: /^[*+\-%<>!=&|^]/,
          dateSQL: set("date time timestamp"),
          support: set("ODBCdotTable decimallessFloat zerolessFloat binaryNumber hexNumber doubleQuote nCharCast charsetCast commentHash commentSpaceRequired"),
          hooks: {
            "@": hookVar,
            "`": hookIdentifier,
            "\\": hookClient
          }
        });
        CodeMirror5.defineMIME("text/x-sqlite", {
          name: "sql",
          client: set("auth backup bail binary changes check clone databases dbinfo dump echo eqp exit explain fullschema headers help import imposter indexes iotrace limit lint load log mode nullvalue once open output print prompt quit read restore save scanstats schema separator session shell show stats system tables testcase timeout timer trace vfsinfo vfslist vfsname width"),
          keywords: set(sqlKeywords + "abort action add after all analyze attach autoincrement before begin cascade case cast check collate column commit conflict constraint cross current_date current_time current_timestamp database default deferrable deferred detach each else end escape except exclusive exists explain fail for foreign full glob if ignore immediate index indexed initially inner instead intersect isnull key left limit match natural no notnull null of offset outer plan pragma primary query raise recursive references regexp reindex release rename replace restrict right rollback row savepoint temp temporary then to transaction trigger unique using vacuum view virtual when with without"),
          builtin: set("bool boolean bit blob decimal double float long longblob longtext medium mediumblob mediumint mediumtext time timestamp tinyblob tinyint tinytext text clob bigint int int2 int8 integer float double char varchar date datetime year unsigned signed numeric real"),
          atoms: set("null current_date current_time current_timestamp"),
          operatorChars: /^[*+\-%<>!=&|/~]/,
          dateSQL: set("date time timestamp datetime"),
          support: set("decimallessFloat zerolessFloat"),
          identifierQuote: '"',
          hooks: {
            "@": hookVar,
            ":": hookVar,
            "?": hookVar,
            "$": hookVar,
            '"': hookIdentifierDoublequote,
            "`": hookIdentifier
          }
        });
        CodeMirror5.defineMIME("text/x-cassandra", {
          name: "sql",
          client: {},
          keywords: set("add all allow alter and any apply as asc authorize batch begin by clustering columnfamily compact consistency count create custom delete desc distinct drop each_quorum exists filtering from grant if in index insert into key keyspace keyspaces level limit local_one local_quorum modify nan norecursive nosuperuser not of on one order password permission permissions primary quorum rename revoke schema select set storage superuser table three to token truncate ttl two type unlogged update use user users using values where with writetime"),
          builtin: set("ascii bigint blob boolean counter decimal double float frozen inet int list map static text timestamp timeuuid tuple uuid varchar varint"),
          atoms: set("false true infinity NaN"),
          operatorChars: /^[<>=]/,
          dateSQL: {},
          support: set("commentSlashSlash decimallessFloat"),
          hooks: {}
        });
        CodeMirror5.defineMIME("text/x-plsql", {
          name: "sql",
          client: set("appinfo arraysize autocommit autoprint autorecovery autotrace blockterminator break btitle cmdsep colsep compatibility compute concat copycommit copytypecheck define describe echo editfile embedded escape exec execute feedback flagger flush heading headsep instance linesize lno loboffset logsource long longchunksize markup native newpage numformat numwidth pagesize pause pno recsep recsepchar release repfooter repheader serveroutput shiftinout show showmode size spool sqlblanklines sqlcase sqlcode sqlcontinue sqlnumber sqlpluscompatibility sqlprefix sqlprompt sqlterminator suffix tab term termout time timing trimout trimspool ttitle underline verify version wrap"),
          keywords: set("abort accept access add all alter and any array arraylen as asc assert assign at attributes audit authorization avg base_table begin between binary_integer body boolean by case cast char char_base check close cluster clusters colauth column comment commit compress connect connected constant constraint crash create current currval cursor data_base database date dba deallocate debugoff debugon decimal declare default definition delay delete desc digits dispose distinct do drop else elseif elsif enable end entry escape exception exception_init exchange exclusive exists exit external fast fetch file for force form from function generic goto grant group having identified if immediate in increment index indexes indicator initial initrans insert interface intersect into is key level library like limited local lock log logging long loop master maxextents maxtrans member minextents minus mislabel mode modify multiset new next no noaudit nocompress nologging noparallel not nowait number_base object of off offline on online only open option or order out package parallel partition pctfree pctincrease pctused pls_integer positive positiven pragma primary prior private privileges procedure public raise range raw read rebuild record ref references refresh release rename replace resource restrict return returning returns reverse revoke rollback row rowid rowlabel rownum rows run savepoint schema segment select separate session set share snapshot some space split sql start statement storage subtype successful synonym tabauth table tables tablespace task terminate then to trigger truncate type union unique unlimited unrecoverable unusable update use using validate value values variable view views when whenever where while with work"),
          builtin: set("abs acos add_months ascii asin atan atan2 average bfile bfilename bigserial bit blob ceil character chartorowid chr clob concat convert cos cosh count dec decode deref dual dump dup_val_on_index empty error exp false float floor found glb greatest hextoraw initcap instr instrb int integer isopen last_day least length lengthb ln lower lpad ltrim lub make_ref max min mlslabel mod months_between natural naturaln nchar nclob new_time next_day nextval nls_charset_decl_len nls_charset_id nls_charset_name nls_initcap nls_lower nls_sort nls_upper nlssort no_data_found notfound null number numeric nvarchar2 nvl others power rawtohex real reftohex round rowcount rowidtochar rowtype rpad rtrim serial sign signtype sin sinh smallint soundex sqlcode sqlerrm sqrt stddev string substr substrb sum sysdate tan tanh to_char text to_date to_label to_multi_byte to_number to_single_byte translate true trunc uid unlogged upper user userenv varchar varchar2 variance varying vsize xml"),
          operatorChars: /^[*\/+\-%<>!=~]/,
          dateSQL: set("date time timestamp"),
          support: set("doubleQuote nCharCast zerolessFloat binaryNumber hexNumber")
        });
        CodeMirror5.defineMIME("text/x-hive", {
          name: "sql",
          keywords: set("select alter $elem$ $key$ $value$ add after all analyze and archive as asc before between binary both bucket buckets by cascade case cast change cluster clustered clusterstatus collection column columns comment compute concatenate continue create cross cursor data database databases dbproperties deferred delete delimited desc describe directory disable distinct distribute drop else enable end escaped exclusive exists explain export extended external fetch fields fileformat first format formatted from full function functions grant group having hold_ddltime idxproperties if import in index indexes inpath inputdriver inputformat insert intersect into is items join keys lateral left like limit lines load local location lock locks mapjoin materialized minus msck no_drop nocompress not of offline on option or order out outer outputdriver outputformat overwrite partition partitioned partitions percent plus preserve procedure purge range rcfile read readonly reads rebuild recordreader recordwriter recover reduce regexp rename repair replace restrict revoke right rlike row schema schemas semi sequencefile serde serdeproperties set shared show show_database sort sorted ssl statistics stored streamtable table tables tablesample tblproperties temporary terminated textfile then tmp to touch transform trigger unarchive undo union uniquejoin unlock update use using utc utc_tmestamp view when where while with admin authorization char compact compactions conf cube current current_date current_timestamp day decimal defined dependency directories elem_type exchange file following for grouping hour ignore inner interval jar less logical macro minute month more none noscan over owner partialscan preceding pretty principals protection reload rewrite role roles rollup rows second server sets skewed transactions truncate unbounded unset uri user values window year"),
          builtin: set("bool boolean long timestamp tinyint smallint bigint int float double date datetime unsigned string array struct map uniontype key_type utctimestamp value_type varchar"),
          atoms: set("false true null unknown"),
          operatorChars: /^[*+\-%<>!=]/,
          dateSQL: set("date timestamp"),
          support: set("ODBCdotTable doubleQuote binaryNumber hexNumber")
        });
        CodeMirror5.defineMIME("text/x-pgsql", {
          name: "sql",
          client: set("source"),
          keywords: set(sqlKeywords + "a abort abs absent absolute access according action ada add admin after aggregate alias all allocate also alter always analyse analyze and any are array array_agg array_max_cardinality as asc asensitive assert assertion assignment asymmetric at atomic attach attribute attributes authorization avg backward base64 before begin begin_frame begin_partition bernoulli between bigint binary bit bit_length blob blocked bom boolean both breadth by c cache call called cardinality cascade cascaded case cast catalog catalog_name ceil ceiling chain char char_length character character_length character_set_catalog character_set_name character_set_schema characteristics characters check checkpoint class class_origin clob close cluster coalesce cobol collate collation collation_catalog collation_name collation_schema collect column column_name columns command_function command_function_code comment comments commit committed concurrently condition condition_number configuration conflict connect connection connection_name constant constraint constraint_catalog constraint_name constraint_schema constraints constructor contains content continue control conversion convert copy corr corresponding cost count covar_pop covar_samp create cross csv cube cume_dist current current_catalog current_date current_default_transform_group current_path current_role current_row current_schema current_time current_timestamp current_transform_group_for_type current_user cursor cursor_name cycle data database datalink datatype date datetime_interval_code datetime_interval_precision day db deallocate debug dec decimal declare default defaults deferrable deferred defined definer degree delete delimiter delimiters dense_rank depends depth deref derived desc describe descriptor detach detail deterministic diagnostics dictionary disable discard disconnect dispatch distinct dlnewcopy dlpreviouscopy dlurlcomplete dlurlcompleteonly dlurlcompletewrite dlurlpath dlurlpathonly dlurlpathwrite dlurlscheme dlurlserver dlvalue do document domain double drop dump dynamic dynamic_function dynamic_function_code each element else elseif elsif empty enable encoding encrypted end end_frame end_partition endexec enforced enum equals errcode error escape event every except exception exclude excluding exclusive exec execute exists exit exp explain expression extension external extract false family fetch file filter final first first_value flag float floor following for force foreach foreign fortran forward found frame_row free freeze from fs full function functions fusion g general generated get global go goto grant granted greatest group grouping groups handler having header hex hierarchy hint hold hour id identity if ignore ilike immediate immediately immutable implementation implicit import in include including increment indent index indexes indicator info inherit inherits initially inline inner inout input insensitive insert instance instantiable instead int integer integrity intersect intersection interval into invoker is isnull isolation join k key key_member key_type label lag language large last last_value lateral lead leading leakproof least left length level library like like_regex limit link listen ln load local localtime localtimestamp location locator lock locked log logged loop lower m map mapping match matched materialized max max_cardinality maxvalue member merge message message_length message_octet_length message_text method min minute minvalue mod mode modifies module month more move multiset mumps name names namespace national natural nchar nclob nesting new next nfc nfd nfkc nfkd nil no none normalize normalized not nothing notice notify notnull nowait nth_value ntile null nullable nullif nulls number numeric object occurrences_regex octet_length octets of off offset oids old on only open operator option options or order ordering ordinality others out outer output over overlaps overlay overriding owned owner p pad parallel parameter parameter_mode parameter_name parameter_ordinal_position parameter_specific_catalog parameter_specific_name parameter_specific_schema parser partial partition pascal passing passthrough password path percent percent_rank percentile_cont percentile_disc perform period permission pg_context pg_datatype_name pg_exception_context pg_exception_detail pg_exception_hint placing plans pli policy portion position position_regex power precedes preceding precision prepare prepared preserve primary print_strict_params prior privileges procedural procedure procedures program public publication query quote raise range rank read reads real reassign recheck recovery recursive ref references referencing refresh regr_avgx regr_avgy regr_count regr_intercept regr_r2 regr_slope regr_sxx regr_sxy regr_syy reindex relative release rename repeatable replace replica requiring reset respect restart restore restrict result result_oid return returned_cardinality returned_length returned_octet_length returned_sqlstate returning returns reverse revoke right role rollback rollup routine routine_catalog routine_name routine_schema routines row row_count row_number rows rowtype rule savepoint scale schema schema_name schemas scope scope_catalog scope_name scope_schema scroll search second section security select selective self sensitive sequence sequences serializable server server_name session session_user set setof sets share show similar simple size skip slice smallint snapshot some source space specific specific_name specifictype sql sqlcode sqlerror sqlexception sqlstate sqlwarning sqrt stable stacked standalone start state statement static statistics stddev_pop stddev_samp stdin stdout storage strict strip structure style subclass_origin submultiset subscription substring substring_regex succeeds sum symmetric sysid system system_time system_user t table table_name tables tablesample tablespace temp template temporary text then ties time timestamp timezone_hour timezone_minute to token top_level_count trailing transaction transaction_active transactions_committed transactions_rolled_back transform transforms translate translate_regex translation treat trigger trigger_catalog trigger_name trigger_schema trim trim_array true truncate trusted type types uescape unbounded uncommitted under unencrypted union unique unknown unlink unlisten unlogged unnamed unnest until untyped update upper uri usage use_column use_variable user user_defined_type_catalog user_defined_type_code user_defined_type_name user_defined_type_schema using vacuum valid validate validator value value_of values var_pop var_samp varbinary varchar variable_conflict variadic varying verbose version versioning view views volatile warning when whenever where while whitespace width_bucket window with within without work wrapper write xml xmlagg xmlattributes xmlbinary xmlcast xmlcomment xmlconcat xmldeclaration xmldocument xmlelement xmlexists xmlforest xmliterate xmlnamespaces xmlparse xmlpi xmlquery xmlroot xmlschema xmlserialize xmltable xmltext xmlvalidate year yes zone"),
          builtin: set("bigint int8 bigserial serial8 bit varying varbit boolean bool box bytea character char varchar cidr circle date double precision float8 inet integer int int4 interval json jsonb line lseg macaddr macaddr8 money numeric decimal path pg_lsn point polygon real float4 smallint int2 smallserial serial2 serial serial4 text time without zone with timetz timestamp timestamptz tsquery tsvector txid_snapshot uuid xml"),
          atoms: set("false true null unknown"),
          operatorChars: /^[*\/+\-%<>!=&|^\/#@?~]/,
          backslashStringEscapes: false,
          dateSQL: set("date time timestamp"),
          support: set("ODBCdotTable decimallessFloat zerolessFloat binaryNumber hexNumber nCharCast charsetCast escapeConstant")
        });
        CodeMirror5.defineMIME("text/x-gql", {
          name: "sql",
          keywords: set("ancestor and asc by contains desc descendant distinct from group has in is limit offset on order select superset where"),
          atoms: set("false true"),
          builtin: set("blob datetime first key __key__ string integer double boolean null"),
          operatorChars: /^[*+\-%<>!=]/
        });
        CodeMirror5.defineMIME("text/x-gpsql", {
          name: "sql",
          client: set("source"),
          keywords: set("abort absolute access action active add admin after aggregate all also alter always analyse analyze and any array as asc assertion assignment asymmetric at authorization backward before begin between bigint binary bit boolean both by cache called cascade cascaded case cast chain char character characteristics check checkpoint class close cluster coalesce codegen collate column comment commit committed concurrency concurrently configuration connection constraint constraints contains content continue conversion copy cost cpu_rate_limit create createdb createexttable createrole createuser cross csv cube current current_catalog current_date current_role current_schema current_time current_timestamp current_user cursor cycle data database day deallocate dec decimal declare decode default defaults deferrable deferred definer delete delimiter delimiters deny desc dictionary disable discard distinct distributed do document domain double drop dxl each else enable encoding encrypted end enum errors escape every except exchange exclude excluding exclusive execute exists explain extension external extract false family fetch fields filespace fill filter first float following for force foreign format forward freeze from full function global grant granted greatest group group_id grouping handler hash having header hold host hour identity if ignore ilike immediate immutable implicit in including inclusive increment index indexes inherit inherits initially inline inner inout input insensitive insert instead int integer intersect interval into invoker is isnull isolation join key language large last leading least left level like limit list listen load local localtime localtimestamp location lock log login mapping master match maxvalue median merge minute minvalue missing mode modifies modify month move name names national natural nchar new newline next no nocreatedb nocreateexttable nocreaterole nocreateuser noinherit nologin none noovercommit nosuperuser not nothing notify notnull nowait null nullif nulls numeric object of off offset oids old on only operator option options or order ordered others out outer over overcommit overlaps overlay owned owner parser partial partition partitions passing password percent percentile_cont percentile_disc placing plans position preceding precision prepare prepared preserve primary prior privileges procedural procedure protocol queue quote randomly range read readable reads real reassign recheck recursive ref references reindex reject relative release rename repeatable replace replica reset resource restart restrict returning returns revoke right role rollback rollup rootpartition row rows rule savepoint scatter schema scroll search second security segment select sequence serializable session session_user set setof sets share show similar simple smallint some split sql stable standalone start statement statistics stdin stdout storage strict strip subpartition subpartitions substring superuser symmetric sysid system table tablespace temp template temporary text then threshold ties time timestamp to trailing transaction treat trigger trim true truncate trusted type unbounded uncommitted unencrypted union unique unknown unlisten until update user using vacuum valid validation validator value values varchar variadic varying verbose version view volatile web when where whitespace window with within without work writable write xml xmlattributes xmlconcat xmlelement xmlexists xmlforest xmlparse xmlpi xmlroot xmlserialize year yes zone"),
          builtin: set("bigint int8 bigserial serial8 bit varying varbit boolean bool box bytea character char varchar cidr circle date double precision float float8 inet integer int int4 interval json jsonb line lseg macaddr macaddr8 money numeric decimal path pg_lsn point polygon real float4 smallint int2 smallserial serial2 serial serial4 text time without zone with timetz timestamp timestamptz tsquery tsvector txid_snapshot uuid xml"),
          atoms: set("false true null unknown"),
          operatorChars: /^[*+\-%<>!=&|^\/#@?~]/,
          dateSQL: set("date time timestamp"),
          support: set("ODBCdotTable decimallessFloat zerolessFloat binaryNumber hexNumber nCharCast charsetCast")
        });
        CodeMirror5.defineMIME("text/x-sparksql", {
          name: "sql",
          keywords: set("add after all alter analyze and anti archive array as asc at between bucket buckets by cache cascade case cast change clear cluster clustered codegen collection column columns comment commit compact compactions compute concatenate cost create cross cube current current_date current_timestamp database databases datata dbproperties defined delete delimited deny desc describe dfs directories distinct distribute drop else end escaped except exchange exists explain export extended external false fields fileformat first following for format formatted from full function functions global grant group grouping having if ignore import in index indexes inner inpath inputformat insert intersect interval into is items join keys last lateral lazy left like limit lines list load local location lock locks logical macro map minus msck natural no not null nulls of on optimize option options or order out outer outputformat over overwrite partition partitioned partitions percent preceding principals purge range recordreader recordwriter recover reduce refresh regexp rename repair replace reset restrict revoke right rlike role roles rollback rollup row rows schema schemas select semi separated serde serdeproperties set sets show skewed sort sorted start statistics stored stratify struct table tables tablesample tblproperties temp temporary terminated then to touch transaction transactions transform true truncate unarchive unbounded uncache union unlock unset use using values view when where window with"),
          builtin: set("tinyint smallint int bigint boolean float double string binary timestamp decimal array map struct uniontype delimited serde sequencefile textfile rcfile inputformat outputformat"),
          atoms: set("false true null"),
          operatorChars: /^[*\/+\-%<>!=~&|^]/,
          dateSQL: set("date time timestamp"),
          support: set("ODBCdotTable doubleQuote zerolessFloat")
        });
        CodeMirror5.defineMIME("text/x-esper", {
          name: "sql",
          client: set("source"),
          keywords: set("alter and as asc between by count create delete desc distinct drop from group having in insert into is join like not on or order select set table union update values where limit after all and as at asc avedev avg between by case cast coalesce count create current_timestamp day days delete define desc distinct else end escape events every exists false first from full group having hour hours in inner insert instanceof into irstream is istream join last lastweekday left limit like max match_recognize matches median measures metadatasql min minute minutes msec millisecond milliseconds not null offset on or order outer output partition pattern prev prior regexp retain-union retain-intersection right rstream sec second seconds select set some snapshot sql stddev sum then true unidirectional until update variable weekday when where window"),
          builtin: {},
          atoms: set("false true null"),
          operatorChars: /^[*+\-%<>!=&|^\/#@?~]/,
          dateSQL: set("time"),
          support: set("decimallessFloat zerolessFloat binaryNumber hexNumber")
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/stylus/stylus.js
  var require_stylus = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/stylus/stylus.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("stylus", function(config3) {
          var indentUnit = config3.indentUnit, indentUnitString = "", tagKeywords = keySet(tagKeywords_), tagVariablesRegexp = /^(a|b|i|s|col|em)$/i, propertyKeywords = keySet(propertyKeywords_), nonStandardPropertyKeywords = keySet(nonStandardPropertyKeywords_), valueKeywords = keySet(valueKeywords_), colorKeywords = keySet(colorKeywords_), documentTypes = keySet(documentTypes_), documentTypesRegexp = wordRegexp(documentTypes_), mediaFeatures = keySet(mediaFeatures_), mediaTypes = keySet(mediaTypes_), fontProperties = keySet(fontProperties_), operatorsRegexp = /^\s*([.]{2,3}|&&|\|\||\*\*|[?!=:]?=|[-+*\/%<>]=?|\?:|\~)/, wordOperatorKeywordsRegexp = wordRegexp(wordOperatorKeywords_), blockKeywords = keySet(blockKeywords_), vendorPrefixesRegexp = new RegExp(/^\-(moz|ms|o|webkit)-/i), commonAtoms = keySet(commonAtoms_), firstWordMatch = "", states = {}, ch, style, type, override;
          while (indentUnitString.length < indentUnit)
            indentUnitString += " ";
          function tokenBase(stream, state) {
            firstWordMatch = stream.string.match(/(^[\w-]+\s*=\s*$)|(^\s*[\w-]+\s*=\s*[\w-])|(^\s*(\.|#|@|\$|\&|\[|\d|\+|::?|\{|\>|~|\/)?\s*[\w-]*([a-z0-9-]|\*|\/\*)(\(|,)?)/);
            state.context.line.firstWord = firstWordMatch ? firstWordMatch[0].replace(/^\s*/, "") : "";
            state.context.line.indent = stream.indentation();
            ch = stream.peek();
            if (stream.match("//")) {
              stream.skipToEnd();
              return ["comment", "comment"];
            }
            if (stream.match("/*")) {
              state.tokenize = tokenCComment;
              return tokenCComment(stream, state);
            }
            if (ch == '"' || ch == "'") {
              stream.next();
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (ch == "@") {
              stream.next();
              stream.eatWhile(/[\w\\-]/);
              return ["def", stream.current()];
            }
            if (ch == "#") {
              stream.next();
              if (stream.match(/^[0-9a-f]{3}([0-9a-f]([0-9a-f]{2}){0,2})?\b(?!-)/i)) {
                return ["atom", "atom"];
              }
              if (stream.match(/^[a-z][\w-]*/i)) {
                return ["builtin", "hash"];
              }
            }
            if (stream.match(vendorPrefixesRegexp)) {
              return ["meta", "vendor-prefixes"];
            }
            if (stream.match(/^-?[0-9]?\.?[0-9]/)) {
              stream.eatWhile(/[a-z%]/i);
              return ["number", "unit"];
            }
            if (ch == "!") {
              stream.next();
              return [stream.match(/^(important|optional)/i) ? "keyword" : "operator", "important"];
            }
            if (ch == "." && stream.match(/^\.[a-z][\w-]*/i)) {
              return ["qualifier", "qualifier"];
            }
            if (stream.match(documentTypesRegexp)) {
              if (stream.peek() == "(")
                state.tokenize = tokenParenthesized;
              return ["property", "word"];
            }
            if (stream.match(/^[a-z][\w-]*\(/i)) {
              stream.backUp(1);
              return ["keyword", "mixin"];
            }
            if (stream.match(/^(\+|-)[a-z][\w-]*\(/i)) {
              stream.backUp(1);
              return ["keyword", "block-mixin"];
            }
            if (stream.string.match(/^\s*&/) && stream.match(/^[-_]+[a-z][\w-]*/)) {
              return ["qualifier", "qualifier"];
            }
            if (stream.match(/^(\/|&)(-|_|:|\.|#|[a-z])/)) {
              stream.backUp(1);
              return ["variable-3", "reference"];
            }
            if (stream.match(/^&{1}\s*$/)) {
              return ["variable-3", "reference"];
            }
            if (stream.match(wordOperatorKeywordsRegexp)) {
              return ["operator", "operator"];
            }
            if (stream.match(/^\$?[-_]*[a-z0-9]+[\w-]*/i)) {
              if (stream.match(/^(\.|\[)[\w-\'\"\]]+/i, false)) {
                if (!wordIsTag(stream.current())) {
                  stream.match(/\./);
                  return ["variable-2", "variable-name"];
                }
              }
              return ["variable-2", "word"];
            }
            if (stream.match(operatorsRegexp)) {
              return ["operator", stream.current()];
            }
            if (/[:;,{}\[\]\(\)]/.test(ch)) {
              stream.next();
              return [null, ch];
            }
            stream.next();
            return [null, null];
          }
          function tokenCComment(stream, state) {
            var maybeEnd = false, ch2;
            while ((ch2 = stream.next()) != null) {
              if (maybeEnd && ch2 == "/") {
                state.tokenize = null;
                break;
              }
              maybeEnd = ch2 == "*";
            }
            return ["comment", "comment"];
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, ch2;
              while ((ch2 = stream.next()) != null) {
                if (ch2 == quote && !escaped) {
                  if (quote == ")")
                    stream.backUp(1);
                  break;
                }
                escaped = !escaped && ch2 == "\\";
              }
              if (ch2 == quote || !escaped && quote != ")")
                state.tokenize = null;
              return ["string", "string"];
            };
          }
          function tokenParenthesized(stream, state) {
            stream.next();
            if (!stream.match(/\s*[\"\')]/, false))
              state.tokenize = tokenString(")");
            else
              state.tokenize = null;
            return [null, "("];
          }
          function Context(type2, indent, prev, line) {
            this.type = type2;
            this.indent = indent;
            this.prev = prev;
            this.line = line || { firstWord: "", indent: 0 };
          }
          function pushContext(state, stream, type2, indent) {
            indent = indent >= 0 ? indent : indentUnit;
            state.context = new Context(type2, stream.indentation() + indent, state.context);
            return type2;
          }
          function popContext(state, currentIndent) {
            var contextIndent = state.context.indent - indentUnit;
            currentIndent = currentIndent || false;
            state.context = state.context.prev;
            if (currentIndent)
              state.context.indent = contextIndent;
            return state.context.type;
          }
          function pass(type2, stream, state) {
            return states[state.context.type](type2, stream, state);
          }
          function popAndPass(type2, stream, state, n3) {
            for (var i3 = n3 || 1; i3 > 0; i3--)
              state.context = state.context.prev;
            return pass(type2, stream, state);
          }
          function wordIsTag(word) {
            return word.toLowerCase() in tagKeywords;
          }
          function wordIsProperty(word) {
            word = word.toLowerCase();
            return word in propertyKeywords || word in fontProperties;
          }
          function wordIsBlock(word) {
            return word.toLowerCase() in blockKeywords;
          }
          function wordIsVendorPrefix(word) {
            return word.toLowerCase().match(vendorPrefixesRegexp);
          }
          function wordAsValue(word) {
            var wordLC = word.toLowerCase();
            var override2 = "variable-2";
            if (wordIsTag(word))
              override2 = "tag";
            else if (wordIsBlock(word))
              override2 = "block-keyword";
            else if (wordIsProperty(word))
              override2 = "property";
            else if (wordLC in valueKeywords || wordLC in commonAtoms)
              override2 = "atom";
            else if (wordLC == "return" || wordLC in colorKeywords)
              override2 = "keyword";
            else if (word.match(/^[A-Z]/))
              override2 = "string";
            return override2;
          }
          function typeIsBlock(type2, stream) {
            return endOfLine(stream) && (type2 == "{" || type2 == "]" || type2 == "hash" || type2 == "qualifier") || type2 == "block-mixin";
          }
          function typeIsInterpolation(type2, stream) {
            return type2 == "{" && stream.match(/^\s*\$?[\w-]+/i, false);
          }
          function typeIsPseudo(type2, stream) {
            return type2 == ":" && stream.match(/^[a-z-]+/, false);
          }
          function startOfLine(stream) {
            return stream.sol() || stream.string.match(new RegExp("^\\s*" + escapeRegExp(stream.current())));
          }
          function endOfLine(stream) {
            return stream.eol() || stream.match(/^\s*$/, false);
          }
          function firstWordOfLine(line) {
            var re = /^\s*[-_]*[a-z0-9]+[\w-]*/i;
            var result = typeof line == "string" ? line.match(re) : line.string.match(re);
            return result ? result[0].replace(/^\s*/, "") : "";
          }
          states.block = function(type2, stream, state) {
            if (type2 == "comment" && startOfLine(stream) || type2 == "," && endOfLine(stream) || type2 == "mixin") {
              return pushContext(state, stream, "block", 0);
            }
            if (typeIsInterpolation(type2, stream)) {
              return pushContext(state, stream, "interpolation");
            }
            if (endOfLine(stream) && type2 == "]") {
              if (!/^\s*(\.|#|:|\[|\*|&)/.test(stream.string) && !wordIsTag(firstWordOfLine(stream))) {
                return pushContext(state, stream, "block", 0);
              }
            }
            if (typeIsBlock(type2, stream)) {
              return pushContext(state, stream, "block");
            }
            if (type2 == "}" && endOfLine(stream)) {
              return pushContext(state, stream, "block", 0);
            }
            if (type2 == "variable-name") {
              if (stream.string.match(/^\s?\$[\w-\.\[\]\'\"]+$/) || wordIsBlock(firstWordOfLine(stream))) {
                return pushContext(state, stream, "variableName");
              } else {
                return pushContext(state, stream, "variableName", 0);
              }
            }
            if (type2 == "=") {
              if (!endOfLine(stream) && !wordIsBlock(firstWordOfLine(stream))) {
                return pushContext(state, stream, "block", 0);
              }
              return pushContext(state, stream, "block");
            }
            if (type2 == "*") {
              if (endOfLine(stream) || stream.match(/\s*(,|\.|#|\[|:|{)/, false)) {
                override = "tag";
                return pushContext(state, stream, "block");
              }
            }
            if (typeIsPseudo(type2, stream)) {
              return pushContext(state, stream, "pseudo");
            }
            if (/@(font-face|media|supports|(-moz-)?document)/.test(type2)) {
              return pushContext(state, stream, endOfLine(stream) ? "block" : "atBlock");
            }
            if (/@(-(moz|ms|o|webkit)-)?keyframes$/.test(type2)) {
              return pushContext(state, stream, "keyframes");
            }
            if (/@extends?/.test(type2)) {
              return pushContext(state, stream, "extend", 0);
            }
            if (type2 && type2.charAt(0) == "@") {
              if (stream.indentation() > 0 && wordIsProperty(stream.current().slice(1))) {
                override = "variable-2";
                return "block";
              }
              if (/(@import|@require|@charset)/.test(type2)) {
                return pushContext(state, stream, "block", 0);
              }
              return pushContext(state, stream, "block");
            }
            if (type2 == "reference" && endOfLine(stream)) {
              return pushContext(state, stream, "block");
            }
            if (type2 == "(") {
              return pushContext(state, stream, "parens");
            }
            if (type2 == "vendor-prefixes") {
              return pushContext(state, stream, "vendorPrefixes");
            }
            if (type2 == "word") {
              var word = stream.current();
              override = wordAsValue(word);
              if (override == "property") {
                if (startOfLine(stream)) {
                  return pushContext(state, stream, "block", 0);
                } else {
                  override = "atom";
                  return "block";
                }
              }
              if (override == "tag") {
                if (/embed|menu|pre|progress|sub|table/.test(word)) {
                  if (wordIsProperty(firstWordOfLine(stream))) {
                    override = "atom";
                    return "block";
                  }
                }
                if (stream.string.match(new RegExp("\\[\\s*" + word + "|" + word + "\\s*\\]"))) {
                  override = "atom";
                  return "block";
                }
                if (tagVariablesRegexp.test(word)) {
                  if (startOfLine(stream) && stream.string.match(/=/) || !startOfLine(stream) && !stream.string.match(/^(\s*\.|#|\&|\[|\/|>|\*)/) && !wordIsTag(firstWordOfLine(stream))) {
                    override = "variable-2";
                    if (wordIsBlock(firstWordOfLine(stream)))
                      return "block";
                    return pushContext(state, stream, "block", 0);
                  }
                }
                if (endOfLine(stream))
                  return pushContext(state, stream, "block");
              }
              if (override == "block-keyword") {
                override = "keyword";
                if (stream.current(/(if|unless)/) && !startOfLine(stream)) {
                  return "block";
                }
                return pushContext(state, stream, "block");
              }
              if (word == "return")
                return pushContext(state, stream, "block", 0);
              if (override == "variable-2" && stream.string.match(/^\s?\$[\w-\.\[\]\'\"]+$/)) {
                return pushContext(state, stream, "block");
              }
            }
            return state.context.type;
          };
          states.parens = function(type2, stream, state) {
            if (type2 == "(")
              return pushContext(state, stream, "parens");
            if (type2 == ")") {
              if (state.context.prev.type == "parens") {
                return popContext(state);
              }
              if (stream.string.match(/^[a-z][\w-]*\(/i) && endOfLine(stream) || wordIsBlock(firstWordOfLine(stream)) || /(\.|#|:|\[|\*|&|>|~|\+|\/)/.test(firstWordOfLine(stream)) || !stream.string.match(/^-?[a-z][\w-\.\[\]\'\"]*\s*=/) && wordIsTag(firstWordOfLine(stream))) {
                return pushContext(state, stream, "block");
              }
              if (stream.string.match(/^[\$-]?[a-z][\w-\.\[\]\'\"]*\s*=/) || stream.string.match(/^\s*(\(|\)|[0-9])/) || stream.string.match(/^\s+[a-z][\w-]*\(/i) || stream.string.match(/^\s+[\$-]?[a-z]/i)) {
                return pushContext(state, stream, "block", 0);
              }
              if (endOfLine(stream))
                return pushContext(state, stream, "block");
              else
                return pushContext(state, stream, "block", 0);
            }
            if (type2 && type2.charAt(0) == "@" && wordIsProperty(stream.current().slice(1))) {
              override = "variable-2";
            }
            if (type2 == "word") {
              var word = stream.current();
              override = wordAsValue(word);
              if (override == "tag" && tagVariablesRegexp.test(word)) {
                override = "variable-2";
              }
              if (override == "property" || word == "to")
                override = "atom";
            }
            if (type2 == "variable-name") {
              return pushContext(state, stream, "variableName");
            }
            if (typeIsPseudo(type2, stream)) {
              return pushContext(state, stream, "pseudo");
            }
            return state.context.type;
          };
          states.vendorPrefixes = function(type2, stream, state) {
            if (type2 == "word") {
              override = "property";
              return pushContext(state, stream, "block", 0);
            }
            return popContext(state);
          };
          states.pseudo = function(type2, stream, state) {
            if (!wordIsProperty(firstWordOfLine(stream.string))) {
              stream.match(/^[a-z-]+/);
              override = "variable-3";
              if (endOfLine(stream))
                return pushContext(state, stream, "block");
              return popContext(state);
            }
            return popAndPass(type2, stream, state);
          };
          states.atBlock = function(type2, stream, state) {
            if (type2 == "(")
              return pushContext(state, stream, "atBlock_parens");
            if (typeIsBlock(type2, stream)) {
              return pushContext(state, stream, "block");
            }
            if (typeIsInterpolation(type2, stream)) {
              return pushContext(state, stream, "interpolation");
            }
            if (type2 == "word") {
              var word = stream.current().toLowerCase();
              if (/^(only|not|and|or)$/.test(word))
                override = "keyword";
              else if (documentTypes.hasOwnProperty(word))
                override = "tag";
              else if (mediaTypes.hasOwnProperty(word))
                override = "attribute";
              else if (mediaFeatures.hasOwnProperty(word))
                override = "property";
              else if (nonStandardPropertyKeywords.hasOwnProperty(word))
                override = "string-2";
              else
                override = wordAsValue(stream.current());
              if (override == "tag" && endOfLine(stream)) {
                return pushContext(state, stream, "block");
              }
            }
            if (type2 == "operator" && /^(not|and|or)$/.test(stream.current())) {
              override = "keyword";
            }
            return state.context.type;
          };
          states.atBlock_parens = function(type2, stream, state) {
            if (type2 == "{" || type2 == "}")
              return state.context.type;
            if (type2 == ")") {
              if (endOfLine(stream))
                return pushContext(state, stream, "block");
              else
                return pushContext(state, stream, "atBlock");
            }
            if (type2 == "word") {
              var word = stream.current().toLowerCase();
              override = wordAsValue(word);
              if (/^(max|min)/.test(word))
                override = "property";
              if (override == "tag") {
                tagVariablesRegexp.test(word) ? override = "variable-2" : override = "atom";
              }
              return state.context.type;
            }
            return states.atBlock(type2, stream, state);
          };
          states.keyframes = function(type2, stream, state) {
            if (stream.indentation() == "0" && (type2 == "}" && startOfLine(stream) || type2 == "]" || type2 == "hash" || type2 == "qualifier" || wordIsTag(stream.current()))) {
              return popAndPass(type2, stream, state);
            }
            if (type2 == "{")
              return pushContext(state, stream, "keyframes");
            if (type2 == "}") {
              if (startOfLine(stream))
                return popContext(state, true);
              else
                return pushContext(state, stream, "keyframes");
            }
            if (type2 == "unit" && /^[0-9]+\%$/.test(stream.current())) {
              return pushContext(state, stream, "keyframes");
            }
            if (type2 == "word") {
              override = wordAsValue(stream.current());
              if (override == "block-keyword") {
                override = "keyword";
                return pushContext(state, stream, "keyframes");
              }
            }
            if (/@(font-face|media|supports|(-moz-)?document)/.test(type2)) {
              return pushContext(state, stream, endOfLine(stream) ? "block" : "atBlock");
            }
            if (type2 == "mixin") {
              return pushContext(state, stream, "block", 0);
            }
            return state.context.type;
          };
          states.interpolation = function(type2, stream, state) {
            if (type2 == "{")
              popContext(state) && pushContext(state, stream, "block");
            if (type2 == "}") {
              if (stream.string.match(/^\s*(\.|#|:|\[|\*|&|>|~|\+|\/)/i) || stream.string.match(/^\s*[a-z]/i) && wordIsTag(firstWordOfLine(stream))) {
                return pushContext(state, stream, "block");
              }
              if (!stream.string.match(/^(\{|\s*\&)/) || stream.match(/\s*[\w-]/, false)) {
                return pushContext(state, stream, "block", 0);
              }
              return pushContext(state, stream, "block");
            }
            if (type2 == "variable-name") {
              return pushContext(state, stream, "variableName", 0);
            }
            if (type2 == "word") {
              override = wordAsValue(stream.current());
              if (override == "tag")
                override = "atom";
            }
            return state.context.type;
          };
          states.extend = function(type2, stream, state) {
            if (type2 == "[" || type2 == "=")
              return "extend";
            if (type2 == "]")
              return popContext(state);
            if (type2 == "word") {
              override = wordAsValue(stream.current());
              return "extend";
            }
            return popContext(state);
          };
          states.variableName = function(type2, stream, state) {
            if (type2 == "string" || type2 == "[" || type2 == "]" || stream.current().match(/^(\.|\$)/)) {
              if (stream.current().match(/^\.[\w-]+/i))
                override = "variable-2";
              return "variableName";
            }
            return popAndPass(type2, stream, state);
          };
          return {
            startState: function(base) {
              return {
                tokenize: null,
                state: "block",
                context: new Context("block", base || 0, null)
              };
            },
            token: function(stream, state) {
              if (!state.tokenize && stream.eatSpace())
                return null;
              style = (state.tokenize || tokenBase)(stream, state);
              if (style && typeof style == "object") {
                type = style[1];
                style = style[0];
              }
              override = style;
              state.state = states[state.state](type, stream, state);
              return override;
            },
            indent: function(state, textAfter, line) {
              var cx = state.context, ch2 = textAfter && textAfter.charAt(0), indent = cx.indent, lineFirstWord = firstWordOfLine(textAfter), lineIndent = line.match(/^\s*/)[0].replace(/\t/g, indentUnitString).length, prevLineFirstWord = state.context.prev ? state.context.prev.line.firstWord : "", prevLineIndent = state.context.prev ? state.context.prev.line.indent : lineIndent;
              if (cx.prev && (ch2 == "}" && (cx.type == "block" || cx.type == "atBlock" || cx.type == "keyframes") || ch2 == ")" && (cx.type == "parens" || cx.type == "atBlock_parens") || ch2 == "{" && cx.type == "at")) {
                indent = cx.indent - indentUnit;
              } else if (!/(\})/.test(ch2)) {
                if (/@|\$|\d/.test(ch2) || /^\{/.test(textAfter) || /^\s*\/(\/|\*)/.test(textAfter) || /^\s*\/\*/.test(prevLineFirstWord) || /^\s*[\w-\.\[\]\'\"]+\s*(\?|:|\+)?=/i.test(textAfter) || /^(\+|-)?[a-z][\w-]*\(/i.test(textAfter) || /^return/.test(textAfter) || wordIsBlock(lineFirstWord)) {
                  indent = lineIndent;
                } else if (/(\.|#|:|\[|\*|&|>|~|\+|\/)/.test(ch2) || wordIsTag(lineFirstWord)) {
                  if (/\,\s*$/.test(prevLineFirstWord)) {
                    indent = prevLineIndent;
                  } else if (/^\s+/.test(line) && (/(\.|#|:|\[|\*|&|>|~|\+|\/)/.test(prevLineFirstWord) || wordIsTag(prevLineFirstWord))) {
                    indent = lineIndent <= prevLineIndent ? prevLineIndent : prevLineIndent + indentUnit;
                  } else {
                    indent = lineIndent;
                  }
                } else if (!/,\s*$/.test(line) && (wordIsVendorPrefix(lineFirstWord) || wordIsProperty(lineFirstWord))) {
                  if (wordIsBlock(prevLineFirstWord)) {
                    indent = lineIndent <= prevLineIndent ? prevLineIndent : prevLineIndent + indentUnit;
                  } else if (/^\{/.test(prevLineFirstWord)) {
                    indent = lineIndent <= prevLineIndent ? lineIndent : prevLineIndent + indentUnit;
                  } else if (wordIsVendorPrefix(prevLineFirstWord) || wordIsProperty(prevLineFirstWord)) {
                    indent = lineIndent >= prevLineIndent ? prevLineIndent : lineIndent;
                  } else if (/^(\.|#|:|\[|\*|&|@|\+|\-|>|~|\/)/.test(prevLineFirstWord) || /=\s*$/.test(prevLineFirstWord) || wordIsTag(prevLineFirstWord) || /^\$[\w-\.\[\]\'\"]/.test(prevLineFirstWord)) {
                    indent = prevLineIndent + indentUnit;
                  } else {
                    indent = lineIndent;
                  }
                }
              }
              return indent;
            },
            electricChars: "}",
            lineComment: "//",
            fold: "indent"
          };
        });
        var tagKeywords_ = ["a", "abbr", "address", "area", "article", "aside", "audio", "b", "base", "bdi", "bdo", "bgsound", "blockquote", "body", "br", "button", "canvas", "caption", "cite", "code", "col", "colgroup", "data", "datalist", "dd", "del", "details", "dfn", "div", "dl", "dt", "em", "embed", "fieldset", "figcaption", "figure", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "i", "iframe", "img", "input", "ins", "kbd", "keygen", "label", "legend", "li", "link", "main", "map", "mark", "marquee", "menu", "menuitem", "meta", "meter", "nav", "nobr", "noframes", "noscript", "object", "ol", "optgroup", "option", "output", "p", "param", "pre", "progress", "q", "rp", "rt", "ruby", "s", "samp", "script", "section", "select", "small", "source", "span", "strong", "style", "sub", "summary", "sup", "table", "tbody", "td", "textarea", "tfoot", "th", "thead", "time", "tr", "track", "u", "ul", "var", "video"];
        var documentTypes_ = ["domain", "regexp", "url", "url-prefix"];
        var mediaTypes_ = ["all", "aural", "braille", "handheld", "print", "projection", "screen", "tty", "tv", "embossed"];
        var mediaFeatures_ = ["width", "min-width", "max-width", "height", "min-height", "max-height", "device-width", "min-device-width", "max-device-width", "device-height", "min-device-height", "max-device-height", "aspect-ratio", "min-aspect-ratio", "max-aspect-ratio", "device-aspect-ratio", "min-device-aspect-ratio", "max-device-aspect-ratio", "color", "min-color", "max-color", "color-index", "min-color-index", "max-color-index", "monochrome", "min-monochrome", "max-monochrome", "resolution", "min-resolution", "max-resolution", "scan", "grid"];
        var propertyKeywords_ = ["align-content", "align-items", "align-self", "alignment-adjust", "alignment-baseline", "anchor-point", "animation", "animation-delay", "animation-direction", "animation-duration", "animation-fill-mode", "animation-iteration-count", "animation-name", "animation-play-state", "animation-timing-function", "appearance", "azimuth", "backface-visibility", "background", "background-attachment", "background-clip", "background-color", "background-image", "background-origin", "background-position", "background-repeat", "background-size", "baseline-shift", "binding", "bleed", "bookmark-label", "bookmark-level", "bookmark-state", "bookmark-target", "border", "border-bottom", "border-bottom-color", "border-bottom-left-radius", "border-bottom-right-radius", "border-bottom-style", "border-bottom-width", "border-collapse", "border-color", "border-image", "border-image-outset", "border-image-repeat", "border-image-slice", "border-image-source", "border-image-width", "border-left", "border-left-color", "border-left-style", "border-left-width", "border-radius", "border-right", "border-right-color", "border-right-style", "border-right-width", "border-spacing", "border-style", "border-top", "border-top-color", "border-top-left-radius", "border-top-right-radius", "border-top-style", "border-top-width", "border-width", "bottom", "box-decoration-break", "box-shadow", "box-sizing", "break-after", "break-before", "break-inside", "caption-side", "clear", "clip", "color", "color-profile", "column-count", "column-fill", "column-gap", "column-rule", "column-rule-color", "column-rule-style", "column-rule-width", "column-span", "column-width", "columns", "content", "counter-increment", "counter-reset", "crop", "cue", "cue-after", "cue-before", "cursor", "direction", "display", "dominant-baseline", "drop-initial-after-adjust", "drop-initial-after-align", "drop-initial-before-adjust", "drop-initial-before-align", "drop-initial-size", "drop-initial-value", "elevation", "empty-cells", "fit", "fit-position", "flex", "flex-basis", "flex-direction", "flex-flow", "flex-grow", "flex-shrink", "flex-wrap", "float", "float-offset", "flow-from", "flow-into", "font", "font-feature-settings", "font-family", "font-kerning", "font-language-override", "font-size", "font-size-adjust", "font-stretch", "font-style", "font-synthesis", "font-variant", "font-variant-alternates", "font-variant-caps", "font-variant-east-asian", "font-variant-ligatures", "font-variant-numeric", "font-variant-position", "font-weight", "grid", "grid-area", "grid-auto-columns", "grid-auto-flow", "grid-auto-position", "grid-auto-rows", "grid-column", "grid-column-end", "grid-column-start", "grid-row", "grid-row-end", "grid-row-start", "grid-template", "grid-template-areas", "grid-template-columns", "grid-template-rows", "hanging-punctuation", "height", "hyphens", "icon", "image-orientation", "image-rendering", "image-resolution", "inline-box-align", "justify-content", "left", "letter-spacing", "line-break", "line-height", "line-stacking", "line-stacking-ruby", "line-stacking-shift", "line-stacking-strategy", "list-style", "list-style-image", "list-style-position", "list-style-type", "margin", "margin-bottom", "margin-left", "margin-right", "margin-top", "marker-offset", "marks", "marquee-direction", "marquee-loop", "marquee-play-count", "marquee-speed", "marquee-style", "max-height", "max-width", "min-height", "min-width", "move-to", "nav-down", "nav-index", "nav-left", "nav-right", "nav-up", "object-fit", "object-position", "opacity", "order", "orphans", "outline", "outline-color", "outline-offset", "outline-style", "outline-width", "overflow", "overflow-style", "overflow-wrap", "overflow-x", "overflow-y", "padding", "padding-bottom", "padding-left", "padding-right", "padding-top", "page", "page-break-after", "page-break-before", "page-break-inside", "page-policy", "pause", "pause-after", "pause-before", "perspective", "perspective-origin", "pitch", "pitch-range", "play-during", "position", "presentation-level", "punctuation-trim", "quotes", "region-break-after", "region-break-before", "region-break-inside", "region-fragment", "rendering-intent", "resize", "rest", "rest-after", "rest-before", "richness", "right", "rotation", "rotation-point", "ruby-align", "ruby-overhang", "ruby-position", "ruby-span", "shape-image-threshold", "shape-inside", "shape-margin", "shape-outside", "size", "speak", "speak-as", "speak-header", "speak-numeral", "speak-punctuation", "speech-rate", "stress", "string-set", "tab-size", "table-layout", "target", "target-name", "target-new", "target-position", "text-align", "text-align-last", "text-decoration", "text-decoration-color", "text-decoration-line", "text-decoration-skip", "text-decoration-style", "text-emphasis", "text-emphasis-color", "text-emphasis-position", "text-emphasis-style", "text-height", "text-indent", "text-justify", "text-outline", "text-overflow", "text-shadow", "text-size-adjust", "text-space-collapse", "text-transform", "text-underline-position", "text-wrap", "top", "transform", "transform-origin", "transform-style", "transition", "transition-delay", "transition-duration", "transition-property", "transition-timing-function", "unicode-bidi", "vertical-align", "visibility", "voice-balance", "voice-duration", "voice-family", "voice-pitch", "voice-range", "voice-rate", "voice-stress", "voice-volume", "volume", "white-space", "widows", "width", "will-change", "word-break", "word-spacing", "word-wrap", "z-index", "clip-path", "clip-rule", "mask", "enable-background", "filter", "flood-color", "flood-opacity", "lighting-color", "stop-color", "stop-opacity", "pointer-events", "color-interpolation", "color-interpolation-filters", "color-rendering", "fill", "fill-opacity", "fill-rule", "image-rendering", "marker", "marker-end", "marker-mid", "marker-start", "shape-rendering", "stroke", "stroke-dasharray", "stroke-dashoffset", "stroke-linecap", "stroke-linejoin", "stroke-miterlimit", "stroke-opacity", "stroke-width", "text-rendering", "baseline-shift", "dominant-baseline", "glyph-orientation-horizontal", "glyph-orientation-vertical", "text-anchor", "writing-mode", "font-smoothing", "osx-font-smoothing"];
        var nonStandardPropertyKeywords_ = ["scrollbar-arrow-color", "scrollbar-base-color", "scrollbar-dark-shadow-color", "scrollbar-face-color", "scrollbar-highlight-color", "scrollbar-shadow-color", "scrollbar-3d-light-color", "scrollbar-track-color", "shape-inside", "searchfield-cancel-button", "searchfield-decoration", "searchfield-results-button", "searchfield-results-decoration", "zoom"];
        var fontProperties_ = ["font-family", "src", "unicode-range", "font-variant", "font-feature-settings", "font-stretch", "font-weight", "font-style"];
        var colorKeywords_ = ["aliceblue", "antiquewhite", "aqua", "aquamarine", "azure", "beige", "bisque", "black", "blanchedalmond", "blue", "blueviolet", "brown", "burlywood", "cadetblue", "chartreuse", "chocolate", "coral", "cornflowerblue", "cornsilk", "crimson", "cyan", "darkblue", "darkcyan", "darkgoldenrod", "darkgray", "darkgreen", "darkkhaki", "darkmagenta", "darkolivegreen", "darkorange", "darkorchid", "darkred", "darksalmon", "darkseagreen", "darkslateblue", "darkslategray", "darkturquoise", "darkviolet", "deeppink", "deepskyblue", "dimgray", "dodgerblue", "firebrick", "floralwhite", "forestgreen", "fuchsia", "gainsboro", "ghostwhite", "gold", "goldenrod", "gray", "grey", "green", "greenyellow", "honeydew", "hotpink", "indianred", "indigo", "ivory", "khaki", "lavender", "lavenderblush", "lawngreen", "lemonchiffon", "lightblue", "lightcoral", "lightcyan", "lightgoldenrodyellow", "lightgray", "lightgreen", "lightpink", "lightsalmon", "lightseagreen", "lightskyblue", "lightslategray", "lightsteelblue", "lightyellow", "lime", "limegreen", "linen", "magenta", "maroon", "mediumaquamarine", "mediumblue", "mediumorchid", "mediumpurple", "mediumseagreen", "mediumslateblue", "mediumspringgreen", "mediumturquoise", "mediumvioletred", "midnightblue", "mintcream", "mistyrose", "moccasin", "navajowhite", "navy", "oldlace", "olive", "olivedrab", "orange", "orangered", "orchid", "palegoldenrod", "palegreen", "paleturquoise", "palevioletred", "papayawhip", "peachpuff", "peru", "pink", "plum", "powderblue", "purple", "rebeccapurple", "red", "rosybrown", "royalblue", "saddlebrown", "salmon", "sandybrown", "seagreen", "seashell", "sienna", "silver", "skyblue", "slateblue", "slategray", "snow", "springgreen", "steelblue", "tan", "teal", "thistle", "tomato", "turquoise", "violet", "wheat", "white", "whitesmoke", "yellow", "yellowgreen"];
        var valueKeywords_ = ["above", "absolute", "activeborder", "additive", "activecaption", "afar", "after-white-space", "ahead", "alias", "all", "all-scroll", "alphabetic", "alternate", "always", "amharic", "amharic-abegede", "antialiased", "appworkspace", "arabic-indic", "armenian", "asterisks", "attr", "auto", "avoid", "avoid-column", "avoid-page", "avoid-region", "background", "backwards", "baseline", "below", "bidi-override", "binary", "bengali", "blink", "block", "block-axis", "bold", "bolder", "border", "border-box", "both", "bottom", "break", "break-all", "break-word", "bullets", "button", "button-bevel", "buttonface", "buttonhighlight", "buttonshadow", "buttontext", "calc", "cambodian", "capitalize", "caps-lock-indicator", "caption", "captiontext", "caret", "cell", "center", "checkbox", "circle", "cjk-decimal", "cjk-earthly-branch", "cjk-heavenly-stem", "cjk-ideographic", "clear", "clip", "close-quote", "col-resize", "collapse", "column", "compact", "condensed", "contain", "content", "contents", "content-box", "context-menu", "continuous", "copy", "counter", "counters", "cover", "crop", "cross", "crosshair", "currentcolor", "cursive", "cyclic", "dashed", "decimal", "decimal-leading-zero", "default", "default-button", "destination-atop", "destination-in", "destination-out", "destination-over", "devanagari", "disc", "discard", "disclosure-closed", "disclosure-open", "document", "dot-dash", "dot-dot-dash", "dotted", "double", "down", "e-resize", "ease", "ease-in", "ease-in-out", "ease-out", "element", "ellipse", "ellipsis", "embed", "end", "ethiopic", "ethiopic-abegede", "ethiopic-abegede-am-et", "ethiopic-abegede-gez", "ethiopic-abegede-ti-er", "ethiopic-abegede-ti-et", "ethiopic-halehame-aa-er", "ethiopic-halehame-aa-et", "ethiopic-halehame-am-et", "ethiopic-halehame-gez", "ethiopic-halehame-om-et", "ethiopic-halehame-sid-et", "ethiopic-halehame-so-et", "ethiopic-halehame-ti-er", "ethiopic-halehame-ti-et", "ethiopic-halehame-tig", "ethiopic-numeric", "ew-resize", "expanded", "extends", "extra-condensed", "extra-expanded", "fantasy", "fast", "fill", "fixed", "flat", "flex", "footnotes", "forwards", "from", "geometricPrecision", "georgian", "graytext", "groove", "gujarati", "gurmukhi", "hand", "hangul", "hangul-consonant", "hebrew", "help", "hidden", "hide", "higher", "highlight", "highlighttext", "hiragana", "hiragana-iroha", "horizontal", "hsl", "hsla", "icon", "ignore", "inactiveborder", "inactivecaption", "inactivecaptiontext", "infinite", "infobackground", "infotext", "inherit", "initial", "inline", "inline-axis", "inline-block", "inline-flex", "inline-table", "inset", "inside", "intrinsic", "invert", "italic", "japanese-formal", "japanese-informal", "justify", "kannada", "katakana", "katakana-iroha", "keep-all", "khmer", "korean-hangul-formal", "korean-hanja-formal", "korean-hanja-informal", "landscape", "lao", "large", "larger", "left", "level", "lighter", "line-through", "linear", "linear-gradient", "lines", "list-item", "listbox", "listitem", "local", "logical", "loud", "lower", "lower-alpha", "lower-armenian", "lower-greek", "lower-hexadecimal", "lower-latin", "lower-norwegian", "lower-roman", "lowercase", "ltr", "malayalam", "match", "matrix", "matrix3d", "media-controls-background", "media-current-time-display", "media-fullscreen-button", "media-mute-button", "media-play-button", "media-return-to-realtime-button", "media-rewind-button", "media-seek-back-button", "media-seek-forward-button", "media-slider", "media-sliderthumb", "media-time-remaining-display", "media-volume-slider", "media-volume-slider-container", "media-volume-sliderthumb", "medium", "menu", "menulist", "menulist-button", "menulist-text", "menulist-textfield", "menutext", "message-box", "middle", "min-intrinsic", "mix", "mongolian", "monospace", "move", "multiple", "myanmar", "n-resize", "narrower", "ne-resize", "nesw-resize", "no-close-quote", "no-drop", "no-open-quote", "no-repeat", "none", "normal", "not-allowed", "nowrap", "ns-resize", "numbers", "numeric", "nw-resize", "nwse-resize", "oblique", "octal", "open-quote", "optimizeLegibility", "optimizeSpeed", "oriya", "oromo", "outset", "outside", "outside-shape", "overlay", "overline", "padding", "padding-box", "painted", "page", "paused", "persian", "perspective", "plus-darker", "plus-lighter", "pointer", "polygon", "portrait", "pre", "pre-line", "pre-wrap", "preserve-3d", "progress", "push-button", "radial-gradient", "radio", "read-only", "read-write", "read-write-plaintext-only", "rectangle", "region", "relative", "repeat", "repeating-linear-gradient", "repeating-radial-gradient", "repeat-x", "repeat-y", "reset", "reverse", "rgb", "rgba", "ridge", "right", "rotate", "rotate3d", "rotateX", "rotateY", "rotateZ", "round", "row-resize", "rtl", "run-in", "running", "s-resize", "sans-serif", "scale", "scale3d", "scaleX", "scaleY", "scaleZ", "scroll", "scrollbar", "scroll-position", "se-resize", "searchfield", "searchfield-cancel-button", "searchfield-decoration", "searchfield-results-button", "searchfield-results-decoration", "semi-condensed", "semi-expanded", "separate", "serif", "show", "sidama", "simp-chinese-formal", "simp-chinese-informal", "single", "skew", "skewX", "skewY", "skip-white-space", "slide", "slider-horizontal", "slider-vertical", "sliderthumb-horizontal", "sliderthumb-vertical", "slow", "small", "small-caps", "small-caption", "smaller", "solid", "somali", "source-atop", "source-in", "source-out", "source-over", "space", "spell-out", "square", "square-button", "start", "static", "status-bar", "stretch", "stroke", "sub", "subpixel-antialiased", "super", "sw-resize", "symbolic", "symbols", "table", "table-caption", "table-cell", "table-column", "table-column-group", "table-footer-group", "table-header-group", "table-row", "table-row-group", "tamil", "telugu", "text", "text-bottom", "text-top", "textarea", "textfield", "thai", "thick", "thin", "threeddarkshadow", "threedface", "threedhighlight", "threedlightshadow", "threedshadow", "tibetan", "tigre", "tigrinya-er", "tigrinya-er-abegede", "tigrinya-et", "tigrinya-et-abegede", "to", "top", "trad-chinese-formal", "trad-chinese-informal", "translate", "translate3d", "translateX", "translateY", "translateZ", "transparent", "ultra-condensed", "ultra-expanded", "underline", "up", "upper-alpha", "upper-armenian", "upper-greek", "upper-hexadecimal", "upper-latin", "upper-norwegian", "upper-roman", "uppercase", "urdu", "url", "var", "vertical", "vertical-text", "visible", "visibleFill", "visiblePainted", "visibleStroke", "visual", "w-resize", "wait", "wave", "wider", "window", "windowframe", "windowtext", "words", "x-large", "x-small", "xor", "xx-large", "xx-small", "bicubic", "optimizespeed", "grayscale", "row", "row-reverse", "wrap", "wrap-reverse", "column-reverse", "flex-start", "flex-end", "space-between", "space-around", "unset"];
        var wordOperatorKeywords_ = ["in", "and", "or", "not", "is not", "is a", "is", "isnt", "defined", "if unless"], blockKeywords_ = ["for", "if", "else", "unless", "from", "to"], commonAtoms_ = ["null", "true", "false", "href", "title", "type", "not-allowed", "readonly", "disabled"], commonDef_ = ["@font-face", "@keyframes", "@media", "@viewport", "@page", "@host", "@supports", "@block", "@css"];
        var hintWords = tagKeywords_.concat(documentTypes_, mediaTypes_, mediaFeatures_, propertyKeywords_, nonStandardPropertyKeywords_, colorKeywords_, valueKeywords_, fontProperties_, wordOperatorKeywords_, blockKeywords_, commonAtoms_, commonDef_);
        function wordRegexp(words) {
          words = words.sort(function(a3, b2) {
            return b2 > a3;
          });
          return new RegExp("^((" + words.join(")|(") + "))\\b");
        }
        function keySet(array) {
          var keys = {};
          for (var i3 = 0; i3 < array.length; ++i3)
            keys[array[i3]] = true;
          return keys;
        }
        function escapeRegExp(text) {
          return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
        }
        CodeMirror5.registerHelper("hintWords", "stylus", hintWords);
        CodeMirror5.defineMIME("text/x-styl", "stylus");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/swift/swift.js
  var require_swift = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/swift/swift.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function wordSet(words) {
          var set = {};
          for (var i3 = 0; i3 < words.length; i3++)
            set[words[i3]] = true;
          return set;
        }
        var keywords2 = wordSet([
          "_",
          "var",
          "let",
          "class",
          "enum",
          "extension",
          "import",
          "protocol",
          "struct",
          "func",
          "typealias",
          "associatedtype",
          "open",
          "public",
          "internal",
          "fileprivate",
          "private",
          "deinit",
          "init",
          "new",
          "override",
          "self",
          "subscript",
          "super",
          "convenience",
          "dynamic",
          "final",
          "indirect",
          "lazy",
          "required",
          "static",
          "unowned",
          "unowned(safe)",
          "unowned(unsafe)",
          "weak",
          "as",
          "is",
          "break",
          "case",
          "continue",
          "default",
          "else",
          "fallthrough",
          "for",
          "guard",
          "if",
          "in",
          "repeat",
          "switch",
          "where",
          "while",
          "defer",
          "return",
          "inout",
          "mutating",
          "nonmutating",
          "catch",
          "do",
          "rethrows",
          "throw",
          "throws",
          "try",
          "didSet",
          "get",
          "set",
          "willSet",
          "assignment",
          "associativity",
          "infix",
          "left",
          "none",
          "operator",
          "postfix",
          "precedence",
          "precedencegroup",
          "prefix",
          "right",
          "Any",
          "AnyObject",
          "Type",
          "dynamicType",
          "Self",
          "Protocol",
          "__COLUMN__",
          "__FILE__",
          "__FUNCTION__",
          "__LINE__"
        ]);
        var definingKeywords = wordSet(["var", "let", "class", "enum", "extension", "import", "protocol", "struct", "func", "typealias", "associatedtype", "for"]);
        var atoms = wordSet(["true", "false", "nil", "self", "super", "_"]);
        var types = wordSet([
          "Array",
          "Bool",
          "Character",
          "Dictionary",
          "Double",
          "Float",
          "Int",
          "Int8",
          "Int16",
          "Int32",
          "Int64",
          "Never",
          "Optional",
          "Set",
          "String",
          "UInt8",
          "UInt16",
          "UInt32",
          "UInt64",
          "Void"
        ]);
        var operators = "+-/*%=|&<>~^?!";
        var punc = ":;,.(){}[]";
        var binary = /^\-?0b[01][01_]*/;
        var octal = /^\-?0o[0-7][0-7_]*/;
        var hexadecimal = /^\-?0x[\dA-Fa-f][\dA-Fa-f_]*(?:(?:\.[\dA-Fa-f][\dA-Fa-f_]*)?[Pp]\-?\d[\d_]*)?/;
        var decimal = /^\-?\d[\d_]*(?:\.\d[\d_]*)?(?:[Ee]\-?\d[\d_]*)?/;
        var identifier = /^\$\d+|(`?)[_A-Za-z][_A-Za-z$0-9]*\1/;
        var property = /^\.(?:\$\d+|(`?)[_A-Za-z][_A-Za-z$0-9]*\1)/;
        var instruction = /^\#[A-Za-z]+/;
        var attribute = /^@(?:\$\d+|(`?)[_A-Za-z][_A-Za-z$0-9]*\1)/;
        function tokenBase(stream, state, prev) {
          if (stream.sol())
            state.indented = stream.indentation();
          if (stream.eatSpace())
            return null;
          var ch = stream.peek();
          if (ch == "/") {
            if (stream.match("//")) {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match("/*")) {
              state.tokenize.push(tokenComment);
              return tokenComment(stream, state);
            }
          }
          if (stream.match(instruction))
            return "builtin";
          if (stream.match(attribute))
            return "attribute";
          if (stream.match(binary))
            return "number";
          if (stream.match(octal))
            return "number";
          if (stream.match(hexadecimal))
            return "number";
          if (stream.match(decimal))
            return "number";
          if (stream.match(property))
            return "property";
          if (operators.indexOf(ch) > -1) {
            stream.next();
            return "operator";
          }
          if (punc.indexOf(ch) > -1) {
            stream.next();
            stream.match("..");
            return "punctuation";
          }
          var stringMatch;
          if (stringMatch = stream.match(/("""|"|')/)) {
            var tokenize = tokenString.bind(null, stringMatch[0]);
            state.tokenize.push(tokenize);
            return tokenize(stream, state);
          }
          if (stream.match(identifier)) {
            var ident = stream.current();
            if (types.hasOwnProperty(ident))
              return "variable-2";
            if (atoms.hasOwnProperty(ident))
              return "atom";
            if (keywords2.hasOwnProperty(ident)) {
              if (definingKeywords.hasOwnProperty(ident))
                state.prev = "define";
              return "keyword";
            }
            if (prev == "define")
              return "def";
            return "variable";
          }
          stream.next();
          return null;
        }
        function tokenUntilClosingParen() {
          var depth = 0;
          return function(stream, state, prev) {
            var inner = tokenBase(stream, state, prev);
            if (inner == "punctuation") {
              if (stream.current() == "(")
                ++depth;
              else if (stream.current() == ")") {
                if (depth == 0) {
                  stream.backUp(1);
                  state.tokenize.pop();
                  return state.tokenize[state.tokenize.length - 1](stream, state);
                } else
                  --depth;
              }
            }
            return inner;
          };
        }
        function tokenString(openQuote, stream, state) {
          var singleLine = openQuote.length == 1;
          var ch, escaped = false;
          while (ch = stream.peek()) {
            if (escaped) {
              stream.next();
              if (ch == "(") {
                state.tokenize.push(tokenUntilClosingParen());
                return "string";
              }
              escaped = false;
            } else if (stream.match(openQuote)) {
              state.tokenize.pop();
              return "string";
            } else {
              stream.next();
              escaped = ch == "\\";
            }
          }
          if (singleLine) {
            state.tokenize.pop();
          }
          return "string";
        }
        function tokenComment(stream, state) {
          var ch;
          while (true) {
            stream.match(/^[^/*]+/, true);
            ch = stream.next();
            if (!ch)
              break;
            if (ch === "/" && stream.eat("*")) {
              state.tokenize.push(tokenComment);
            } else if (ch === "*" && stream.eat("/")) {
              state.tokenize.pop();
            }
          }
          return "comment";
        }
        function Context(prev, align, indented) {
          this.prev = prev;
          this.align = align;
          this.indented = indented;
        }
        function pushContext(state, stream) {
          var align = stream.match(/^\s*($|\/[\/\*])/, false) ? null : stream.column() + 1;
          state.context = new Context(state.context, align, state.indented);
        }
        function popContext(state) {
          if (state.context) {
            state.indented = state.context.indented;
            state.context = state.context.prev;
          }
        }
        CodeMirror5.defineMode("swift", function(config3) {
          return {
            startState: function() {
              return {
                prev: null,
                context: null,
                indented: 0,
                tokenize: []
              };
            },
            token: function(stream, state) {
              var prev = state.prev;
              state.prev = null;
              var tokenize = state.tokenize[state.tokenize.length - 1] || tokenBase;
              var style = tokenize(stream, state, prev);
              if (!style || style == "comment")
                state.prev = prev;
              else if (!state.prev)
                state.prev = style;
              if (style == "punctuation") {
                var bracket = /[\(\[\{]|([\]\)\}])/.exec(stream.current());
                if (bracket)
                  (bracket[1] ? popContext : pushContext)(state, stream);
              }
              return style;
            },
            indent: function(state, textAfter) {
              var cx = state.context;
              if (!cx)
                return 0;
              var closing = /^[\]\}\)]/.test(textAfter);
              if (cx.align != null)
                return cx.align - (closing ? 1 : 0);
              return cx.indented + (closing ? 0 : config3.indentUnit);
            },
            electricInput: /^\s*[\)\}\]]$/,
            lineComment: "//",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            fold: "brace",
            closeBrackets: "()[]{}''\"\"``"
          };
        });
        CodeMirror5.defineMIME("text/x-swift", "swift");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/tcl/tcl.js
  var require_tcl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/tcl/tcl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("tcl", function() {
          function parseWords(str) {
            var obj = {}, words = str.split(" ");
            for (var i3 = 0; i3 < words.length; ++i3)
              obj[words[i3]] = true;
            return obj;
          }
          var keywords2 = parseWords("Tcl safe after append array auto_execok auto_import auto_load auto_mkindex auto_mkindex_old auto_qualify auto_reset bgerror binary break catch cd close concat continue dde eof encoding error eval exec exit expr fblocked fconfigure fcopy file fileevent filename filename flush for foreach format gets glob global history http if incr info interp join lappend lindex linsert list llength load lrange lreplace lsearch lset lsort memory msgcat namespace open package parray pid pkg::create pkg_mkIndex proc puts pwd re_syntax read regex regexp registry regsub rename resource return scan seek set socket source split string subst switch tcl_endOfWord tcl_findLibrary tcl_startOfNextWord tcl_wordBreakAfter tcl_startOfPreviousWord tcl_wordBreakBefore tcltest tclvars tell time trace unknown unset update uplevel upvar variable vwait");
          var functions = parseWords("if elseif else and not or eq ne in ni for foreach while switch");
          var isOperatorChar = /[+\-*&%=<>!?^\/\|]/;
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function tokenBase(stream, state) {
            var beforeParams = state.beforeParams;
            state.beforeParams = false;
            var ch = stream.next();
            if ((ch == '"' || ch == "'") && state.inParams) {
              return chain2(stream, state, tokenString(ch));
            } else if (/[\[\]{}\(\),;\.]/.test(ch)) {
              if (ch == "(" && beforeParams)
                state.inParams = true;
              else if (ch == ")")
                state.inParams = false;
              return null;
            } else if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            } else if (ch == "#") {
              if (stream.eat("*"))
                return chain2(stream, state, tokenComment);
              if (ch == "#" && stream.match(/ *\[ *\[/))
                return chain2(stream, state, tokenUnparsed);
              stream.skipToEnd();
              return "comment";
            } else if (ch == '"') {
              stream.skipTo(/"/);
              return "comment";
            } else if (ch == "$") {
              stream.eatWhile(/[$_a-z0-9A-Z\.{:]/);
              stream.eatWhile(/}/);
              state.beforeParams = true;
              return "builtin";
            } else if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "comment";
            } else {
              stream.eatWhile(/[\w\$_{}\xa1-\uffff]/);
              var word = stream.current().toLowerCase();
              if (keywords2 && keywords2.propertyIsEnumerable(word))
                return "keyword";
              if (functions && functions.propertyIsEnumerable(word)) {
                state.beforeParams = true;
                return "keyword";
              }
              return null;
            }
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end)
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "#" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function tokenUnparsed(stream, state) {
            var maybeEnd = 0, ch;
            while (ch = stream.next()) {
              if (ch == "#" && maybeEnd == 2) {
                state.tokenize = tokenBase;
                break;
              }
              if (ch == "]")
                maybeEnd++;
              else if (ch != " ")
                maybeEnd = 0;
            }
            return "meta";
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                beforeParams: false,
                inParams: false
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return state.tokenize(stream, state);
            }
          };
        });
        CodeMirror5.defineMIME("text/x-tcl", "tcl");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/textile/textile.js
  var require_textile = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/textile/textile.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object") {
          mod2(require_codemirror());
        } else if (typeof define == "function" && define.amd) {
          define(["../../lib/codemirror"], mod2);
        } else {
          mod2(CodeMirror);
        }
      })(function(CodeMirror5) {
        "use strict";
        var TOKEN_STYLES = {
          addition: "positive",
          attributes: "attribute",
          bold: "strong",
          cite: "keyword",
          code: "atom",
          definitionList: "number",
          deletion: "negative",
          div: "punctuation",
          em: "em",
          footnote: "variable",
          footCite: "qualifier",
          header: "header",
          html: "comment",
          image: "string",
          italic: "em",
          link: "link",
          linkDefinition: "link",
          list1: "variable-2",
          list2: "variable-3",
          list3: "keyword",
          notextile: "string-2",
          pre: "operator",
          p: "property",
          quote: "bracket",
          span: "quote",
          specialChar: "tag",
          strong: "strong",
          sub: "builtin",
          sup: "builtin",
          table: "variable-3",
          tableHeading: "operator"
        };
        function startNewLine(stream, state) {
          state.mode = Modes.newLayout;
          state.tableHeading = false;
          if (state.layoutType === "definitionList" && state.spanningLayout && stream.match(RE("definitionListEnd"), false))
            state.spanningLayout = false;
        }
        function handlePhraseModifier(stream, state, ch) {
          if (ch === "_") {
            if (stream.eat("_"))
              return togglePhraseModifier(stream, state, "italic", /__/, 2);
            else
              return togglePhraseModifier(stream, state, "em", /_/, 1);
          }
          if (ch === "*") {
            if (stream.eat("*")) {
              return togglePhraseModifier(stream, state, "bold", /\*\*/, 2);
            }
            return togglePhraseModifier(stream, state, "strong", /\*/, 1);
          }
          if (ch === "[") {
            if (stream.match(/\d+\]/))
              state.footCite = true;
            return tokenStyles(state);
          }
          if (ch === "(") {
            var spec = stream.match(/^(r|tm|c)\)/);
            if (spec)
              return tokenStylesWith(state, TOKEN_STYLES.specialChar);
          }
          if (ch === "<" && stream.match(/(\w+)[^>]+>[^<]+<\/\1>/))
            return tokenStylesWith(state, TOKEN_STYLES.html);
          if (ch === "?" && stream.eat("?"))
            return togglePhraseModifier(stream, state, "cite", /\?\?/, 2);
          if (ch === "=" && stream.eat("="))
            return togglePhraseModifier(stream, state, "notextile", /==/, 2);
          if (ch === "-" && !stream.eat("-"))
            return togglePhraseModifier(stream, state, "deletion", /-/, 1);
          if (ch === "+")
            return togglePhraseModifier(stream, state, "addition", /\+/, 1);
          if (ch === "~")
            return togglePhraseModifier(stream, state, "sub", /~/, 1);
          if (ch === "^")
            return togglePhraseModifier(stream, state, "sup", /\^/, 1);
          if (ch === "%")
            return togglePhraseModifier(stream, state, "span", /%/, 1);
          if (ch === "@")
            return togglePhraseModifier(stream, state, "code", /@/, 1);
          if (ch === "!") {
            var type = togglePhraseModifier(stream, state, "image", /(?:\([^\)]+\))?!/, 1);
            stream.match(/^:\S+/);
            return type;
          }
          return tokenStyles(state);
        }
        function togglePhraseModifier(stream, state, phraseModifier, closeRE, openSize) {
          var charBefore = stream.pos > openSize ? stream.string.charAt(stream.pos - openSize - 1) : null;
          var charAfter = stream.peek();
          if (state[phraseModifier]) {
            if ((!charAfter || /\W/.test(charAfter)) && charBefore && /\S/.test(charBefore)) {
              var type = tokenStyles(state);
              state[phraseModifier] = false;
              return type;
            }
          } else if ((!charBefore || /\W/.test(charBefore)) && charAfter && /\S/.test(charAfter) && stream.match(new RegExp("^.*\\S" + closeRE.source + "(?:\\W|$)"), false)) {
            state[phraseModifier] = true;
            state.mode = Modes.attributes;
          }
          return tokenStyles(state);
        }
        ;
        function tokenStyles(state) {
          var disabled = textileDisabled(state);
          if (disabled)
            return disabled;
          var styles = [];
          if (state.layoutType)
            styles.push(TOKEN_STYLES[state.layoutType]);
          styles = styles.concat(activeStyles(state, "addition", "bold", "cite", "code", "deletion", "em", "footCite", "image", "italic", "link", "span", "strong", "sub", "sup", "table", "tableHeading"));
          if (state.layoutType === "header")
            styles.push(TOKEN_STYLES.header + "-" + state.header);
          return styles.length ? styles.join(" ") : null;
        }
        function textileDisabled(state) {
          var type = state.layoutType;
          switch (type) {
            case "notextile":
            case "code":
            case "pre":
              return TOKEN_STYLES[type];
            default:
              if (state.notextile)
                return TOKEN_STYLES.notextile + (type ? " " + TOKEN_STYLES[type] : "");
              return null;
          }
        }
        function tokenStylesWith(state, extraStyles) {
          var disabled = textileDisabled(state);
          if (disabled)
            return disabled;
          var type = tokenStyles(state);
          if (extraStyles)
            return type ? type + " " + extraStyles : extraStyles;
          else
            return type;
        }
        function activeStyles(state) {
          var styles = [];
          for (var i3 = 1; i3 < arguments.length; ++i3) {
            if (state[arguments[i3]])
              styles.push(TOKEN_STYLES[arguments[i3]]);
          }
          return styles;
        }
        function blankLine(state) {
          var spanningLayout = state.spanningLayout, type = state.layoutType;
          for (var key in state)
            if (state.hasOwnProperty(key))
              delete state[key];
          state.mode = Modes.newLayout;
          if (spanningLayout) {
            state.layoutType = type;
            state.spanningLayout = true;
          }
        }
        var REs = {
          cache: {},
          single: {
            bc: "bc",
            bq: "bq",
            definitionList: /- .*?:=+/,
            definitionListEnd: /.*=:\s*$/,
            div: "div",
            drawTable: /\|.*\|/,
            foot: /fn\d+/,
            header: /h[1-6]/,
            html: /\s*<(?:\/)?(\w+)(?:[^>]+)?>(?:[^<]+<\/\1>)?/,
            link: /[^"]+":\S/,
            linkDefinition: /\[[^\s\]]+\]\S+/,
            list: /(?:#+|\*+)/,
            notextile: "notextile",
            para: "p",
            pre: "pre",
            table: "table",
            tableCellAttributes: /[\/\\]\d+/,
            tableHeading: /\|_\./,
            tableText: /[^"_\*\[\(\?\+~\^%@|-]+/,
            text: /[^!"_=\*\[\(<\?\+~\^%@-]+/
          },
          attributes: {
            align: /(?:<>|<|>|=)/,
            selector: /\([^\(][^\)]+\)/,
            lang: /\[[^\[\]]+\]/,
            pad: /(?:\(+|\)+){1,2}/,
            css: /\{[^\}]+\}/
          },
          createRe: function(name106) {
            switch (name106) {
              case "drawTable":
                return REs.makeRe("^", REs.single.drawTable, "$");
              case "html":
                return REs.makeRe("^", REs.single.html, "(?:", REs.single.html, ")*", "$");
              case "linkDefinition":
                return REs.makeRe("^", REs.single.linkDefinition, "$");
              case "listLayout":
                return REs.makeRe("^", REs.single.list, RE("allAttributes"), "*\\s+");
              case "tableCellAttributes":
                return REs.makeRe("^", REs.choiceRe(REs.single.tableCellAttributes, RE("allAttributes")), "+\\.");
              case "type":
                return REs.makeRe("^", RE("allTypes"));
              case "typeLayout":
                return REs.makeRe("^", RE("allTypes"), RE("allAttributes"), "*\\.\\.?", "(\\s+|$)");
              case "attributes":
                return REs.makeRe("^", RE("allAttributes"), "+");
              case "allTypes":
                return REs.choiceRe(REs.single.div, REs.single.foot, REs.single.header, REs.single.bc, REs.single.bq, REs.single.notextile, REs.single.pre, REs.single.table, REs.single.para);
              case "allAttributes":
                return REs.choiceRe(REs.attributes.selector, REs.attributes.css, REs.attributes.lang, REs.attributes.align, REs.attributes.pad);
              default:
                return REs.makeRe("^", REs.single[name106]);
            }
          },
          makeRe: function() {
            var pattern = "";
            for (var i3 = 0; i3 < arguments.length; ++i3) {
              var arg = arguments[i3];
              pattern += typeof arg === "string" ? arg : arg.source;
            }
            return new RegExp(pattern);
          },
          choiceRe: function() {
            var parts = [arguments[0]];
            for (var i3 = 1; i3 < arguments.length; ++i3) {
              parts[i3 * 2 - 1] = "|";
              parts[i3 * 2] = arguments[i3];
            }
            parts.unshift("(?:");
            parts.push(")");
            return REs.makeRe.apply(null, parts);
          }
        };
        function RE(name106) {
          return REs.cache[name106] || (REs.cache[name106] = REs.createRe(name106));
        }
        var Modes = {
          newLayout: function(stream, state) {
            if (stream.match(RE("typeLayout"), false)) {
              state.spanningLayout = false;
              return (state.mode = Modes.blockType)(stream, state);
            }
            var newMode;
            if (!textileDisabled(state)) {
              if (stream.match(RE("listLayout"), false))
                newMode = Modes.list;
              else if (stream.match(RE("drawTable"), false))
                newMode = Modes.table;
              else if (stream.match(RE("linkDefinition"), false))
                newMode = Modes.linkDefinition;
              else if (stream.match(RE("definitionList")))
                newMode = Modes.definitionList;
              else if (stream.match(RE("html"), false))
                newMode = Modes.html;
            }
            return (state.mode = newMode || Modes.text)(stream, state);
          },
          blockType: function(stream, state) {
            var match, type;
            state.layoutType = null;
            if (match = stream.match(RE("type")))
              type = match[0];
            else
              return (state.mode = Modes.text)(stream, state);
            if (match = type.match(RE("header"))) {
              state.layoutType = "header";
              state.header = parseInt(match[0][1]);
            } else if (type.match(RE("bq"))) {
              state.layoutType = "quote";
            } else if (type.match(RE("bc"))) {
              state.layoutType = "code";
            } else if (type.match(RE("foot"))) {
              state.layoutType = "footnote";
            } else if (type.match(RE("notextile"))) {
              state.layoutType = "notextile";
            } else if (type.match(RE("pre"))) {
              state.layoutType = "pre";
            } else if (type.match(RE("div"))) {
              state.layoutType = "div";
            } else if (type.match(RE("table"))) {
              state.layoutType = "table";
            }
            state.mode = Modes.attributes;
            return tokenStyles(state);
          },
          text: function(stream, state) {
            if (stream.match(RE("text")))
              return tokenStyles(state);
            var ch = stream.next();
            if (ch === '"')
              return (state.mode = Modes.link)(stream, state);
            return handlePhraseModifier(stream, state, ch);
          },
          attributes: function(stream, state) {
            state.mode = Modes.layoutLength;
            if (stream.match(RE("attributes")))
              return tokenStylesWith(state, TOKEN_STYLES.attributes);
            else
              return tokenStyles(state);
          },
          layoutLength: function(stream, state) {
            if (stream.eat(".") && stream.eat("."))
              state.spanningLayout = true;
            state.mode = Modes.text;
            return tokenStyles(state);
          },
          list: function(stream, state) {
            var match = stream.match(RE("list"));
            state.listDepth = match[0].length;
            var listMod = (state.listDepth - 1) % 3;
            if (!listMod)
              state.layoutType = "list1";
            else if (listMod === 1)
              state.layoutType = "list2";
            else
              state.layoutType = "list3";
            state.mode = Modes.attributes;
            return tokenStyles(state);
          },
          link: function(stream, state) {
            state.mode = Modes.text;
            if (stream.match(RE("link"))) {
              stream.match(/\S+/);
              return tokenStylesWith(state, TOKEN_STYLES.link);
            }
            return tokenStyles(state);
          },
          linkDefinition: function(stream, state) {
            stream.skipToEnd();
            return tokenStylesWith(state, TOKEN_STYLES.linkDefinition);
          },
          definitionList: function(stream, state) {
            stream.match(RE("definitionList"));
            state.layoutType = "definitionList";
            if (stream.match(/\s*$/))
              state.spanningLayout = true;
            else
              state.mode = Modes.attributes;
            return tokenStyles(state);
          },
          html: function(stream, state) {
            stream.skipToEnd();
            return tokenStylesWith(state, TOKEN_STYLES.html);
          },
          table: function(stream, state) {
            state.layoutType = "table";
            return (state.mode = Modes.tableCell)(stream, state);
          },
          tableCell: function(stream, state) {
            if (stream.match(RE("tableHeading")))
              state.tableHeading = true;
            else
              stream.eat("|");
            state.mode = Modes.tableCellAttributes;
            return tokenStyles(state);
          },
          tableCellAttributes: function(stream, state) {
            state.mode = Modes.tableText;
            if (stream.match(RE("tableCellAttributes")))
              return tokenStylesWith(state, TOKEN_STYLES.attributes);
            else
              return tokenStyles(state);
          },
          tableText: function(stream, state) {
            if (stream.match(RE("tableText")))
              return tokenStyles(state);
            if (stream.peek() === "|") {
              state.mode = Modes.tableCell;
              return tokenStyles(state);
            }
            return handlePhraseModifier(stream, state, stream.next());
          }
        };
        CodeMirror5.defineMode("textile", function() {
          return {
            startState: function() {
              return { mode: Modes.newLayout };
            },
            token: function(stream, state) {
              if (stream.sol())
                startNewLine(stream, state);
              return state.mode(stream, state);
            },
            blankLine
          };
        });
        CodeMirror5.defineMIME("text/x-textile", "textile");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/tiddlywiki/tiddlywiki.js
  var require_tiddlywiki = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/tiddlywiki/tiddlywiki.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("tiddlywiki", function() {
          var textwords = {};
          var keywords2 = {
            "allTags": true,
            "closeAll": true,
            "list": true,
            "newJournal": true,
            "newTiddler": true,
            "permaview": true,
            "saveChanges": true,
            "search": true,
            "slider": true,
            "tabs": true,
            "tag": true,
            "tagging": true,
            "tags": true,
            "tiddler": true,
            "timeline": true,
            "today": true,
            "version": true,
            "option": true,
            "with": true,
            "filter": true
          };
          var isSpaceName = /[\w_\-]/i, reHR = /^\-\-\-\-+$/, reWikiCommentStart = /^\/\*\*\*$/, reWikiCommentStop = /^\*\*\*\/$/, reBlockQuote = /^<<<$/, reJsCodeStart = /^\/\/\{\{\{$/, reJsCodeStop = /^\/\/\}\}\}$/, reXmlCodeStart = /^<!--\{\{\{-->$/, reXmlCodeStop = /^<!--\}\}\}-->$/, reCodeBlockStart = /^\{\{\{$/, reCodeBlockStop = /^\}\}\}$/, reUntilCodeStop = /.*?\}\}\}/;
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function tokenBase(stream, state) {
            var sol = stream.sol(), ch = stream.peek();
            state.block = false;
            if (sol && /[<\/\*{}\-]/.test(ch)) {
              if (stream.match(reCodeBlockStart)) {
                state.block = true;
                return chain2(stream, state, twTokenCode);
              }
              if (stream.match(reBlockQuote))
                return "quote";
              if (stream.match(reWikiCommentStart) || stream.match(reWikiCommentStop))
                return "comment";
              if (stream.match(reJsCodeStart) || stream.match(reJsCodeStop) || stream.match(reXmlCodeStart) || stream.match(reXmlCodeStop))
                return "comment";
              if (stream.match(reHR))
                return "hr";
            }
            stream.next();
            if (sol && /[\/\*!#;:>|]/.test(ch)) {
              if (ch == "!") {
                stream.skipToEnd();
                return "header";
              }
              if (ch == "*") {
                stream.eatWhile("*");
                return "comment";
              }
              if (ch == "#") {
                stream.eatWhile("#");
                return "comment";
              }
              if (ch == ";") {
                stream.eatWhile(";");
                return "comment";
              }
              if (ch == ":") {
                stream.eatWhile(":");
                return "comment";
              }
              if (ch == ">") {
                stream.eatWhile(">");
                return "quote";
              }
              if (ch == "|")
                return "header";
            }
            if (ch == "{" && stream.match(/\{\{/))
              return chain2(stream, state, twTokenCode);
            if (/[hf]/i.test(ch) && /[ti]/i.test(stream.peek()) && stream.match(/\b(ttps?|tp|ile):\/\/[\-A-Z0-9+&@#\/%?=~_|$!:,.;]*[A-Z0-9+&@#\/%=~_|$]/i))
              return "link";
            if (ch == '"')
              return "string";
            if (ch == "~")
              return "brace";
            if (/[\[\]]/.test(ch) && stream.match(ch))
              return "brace";
            if (ch == "@") {
              stream.eatWhile(isSpaceName);
              return "link";
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/\d/);
              return "number";
            }
            if (ch == "/") {
              if (stream.eat("%")) {
                return chain2(stream, state, twTokenComment);
              } else if (stream.eat("/")) {
                return chain2(stream, state, twTokenEm);
              }
            }
            if (ch == "_" && stream.eat("_"))
              return chain2(stream, state, twTokenUnderline);
            if (ch == "-" && stream.eat("-")) {
              if (stream.peek() != " ")
                return chain2(stream, state, twTokenStrike);
              if (stream.peek() == " ")
                return "brace";
            }
            if (ch == "'" && stream.eat("'"))
              return chain2(stream, state, twTokenStrong);
            if (ch == "<" && stream.eat("<"))
              return chain2(stream, state, twTokenMacro);
            stream.eatWhile(/[\w\$_]/);
            return textwords.propertyIsEnumerable(stream.current()) ? "keyword" : null;
          }
          function twTokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "%";
            }
            return "comment";
          }
          function twTokenStrong(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "'" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "'";
            }
            return "strong";
          }
          function twTokenCode(stream, state) {
            var sb = state.block;
            if (sb && stream.current()) {
              return "comment";
            }
            if (!sb && stream.match(reUntilCodeStop)) {
              state.tokenize = tokenBase;
              return "comment";
            }
            if (sb && stream.sol() && stream.match(reCodeBlockStop)) {
              state.tokenize = tokenBase;
              return "comment";
            }
            stream.next();
            return "comment";
          }
          function twTokenEm(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "/";
            }
            return "em";
          }
          function twTokenUnderline(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "_" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "_";
            }
            return "underlined";
          }
          function twTokenStrike(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "-" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "-";
            }
            return "strikethrough";
          }
          function twTokenMacro(stream, state) {
            if (stream.current() == "<<") {
              return "macro";
            }
            var ch = stream.next();
            if (!ch) {
              state.tokenize = tokenBase;
              return null;
            }
            if (ch == ">") {
              if (stream.peek() == ">") {
                stream.next();
                state.tokenize = tokenBase;
                return "macro";
              }
            }
            stream.eatWhile(/[\w\$_]/);
            return keywords2.propertyIsEnumerable(stream.current()) ? "keyword" : null;
          }
          return {
            startState: function() {
              return { tokenize: tokenBase };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              return style;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-tiddlywiki", "tiddlywiki");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/tiki/tiki.js
  var require_tiki = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/tiki/tiki.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("tiki", function(config3) {
          function inBlock(style, terminator, returnTokenizer) {
            return function(stream, state) {
              while (!stream.eol()) {
                if (stream.match(terminator)) {
                  state.tokenize = inText;
                  break;
                }
                stream.next();
              }
              if (returnTokenizer)
                state.tokenize = returnTokenizer;
              return style;
            };
          }
          function inLine(style) {
            return function(stream, state) {
              while (!stream.eol()) {
                stream.next();
              }
              state.tokenize = inText;
              return style;
            };
          }
          function inText(stream, state) {
            function chain2(parser2) {
              state.tokenize = parser2;
              return parser2(stream, state);
            }
            var sol = stream.sol();
            var ch = stream.next();
            switch (ch) {
              case "{":
                stream.eat("/");
                stream.eatSpace();
                stream.eatWhile(/[^\s\u00a0=\"\'\/?(}]/);
                state.tokenize = inPlugin;
                return "tag";
              case "_":
                if (stream.eat("_"))
                  return chain2(inBlock("strong", "__", inText));
                break;
              case "'":
                if (stream.eat("'"))
                  return chain2(inBlock("em", "''", inText));
                break;
              case "(":
                if (stream.eat("("))
                  return chain2(inBlock("variable-2", "))", inText));
                break;
              case "[":
                return chain2(inBlock("variable-3", "]", inText));
                break;
              case "|":
                if (stream.eat("|"))
                  return chain2(inBlock("comment", "||"));
                break;
              case "-":
                if (stream.eat("=")) {
                  return chain2(inBlock("header string", "=-", inText));
                } else if (stream.eat("-")) {
                  return chain2(inBlock("error tw-deleted", "--", inText));
                }
                break;
              case "=":
                if (stream.match("=="))
                  return chain2(inBlock("tw-underline", "===", inText));
                break;
              case ":":
                if (stream.eat(":"))
                  return chain2(inBlock("comment", "::"));
                break;
              case "^":
                return chain2(inBlock("tw-box", "^"));
                break;
              case "~":
                if (stream.match("np~"))
                  return chain2(inBlock("meta", "~/np~"));
                break;
            }
            if (sol) {
              switch (ch) {
                case "!":
                  if (stream.match("!!!!!")) {
                    return chain2(inLine("header string"));
                  } else if (stream.match("!!!!")) {
                    return chain2(inLine("header string"));
                  } else if (stream.match("!!!")) {
                    return chain2(inLine("header string"));
                  } else if (stream.match("!!")) {
                    return chain2(inLine("header string"));
                  } else {
                    return chain2(inLine("header string"));
                  }
                  break;
                case "*":
                case "#":
                case "+":
                  return chain2(inLine("tw-listitem bracket"));
                  break;
              }
            }
            return null;
          }
          var indentUnit = config3.indentUnit;
          var pluginName, type;
          function inPlugin(stream, state) {
            var ch = stream.next();
            var peek = stream.peek();
            if (ch == "}") {
              state.tokenize = inText;
              return "tag";
            } else if (ch == "(" || ch == ")") {
              return "bracket";
            } else if (ch == "=") {
              type = "equals";
              if (peek == ">") {
                stream.next();
                peek = stream.peek();
              }
              if (!/[\'\"]/.test(peek)) {
                state.tokenize = inAttributeNoQuote();
              }
              return "operator";
            } else if (/[\'\"]/.test(ch)) {
              state.tokenize = inAttribute(ch);
              return state.tokenize(stream, state);
            } else {
              stream.eatWhile(/[^\s\u00a0=\"\'\/?]/);
              return "keyword";
            }
          }
          function inAttribute(quote) {
            return function(stream, state) {
              while (!stream.eol()) {
                if (stream.next() == quote) {
                  state.tokenize = inPlugin;
                  break;
                }
              }
              return "string";
            };
          }
          function inAttributeNoQuote() {
            return function(stream, state) {
              while (!stream.eol()) {
                var ch = stream.next();
                var peek = stream.peek();
                if (ch == " " || ch == "," || /[ )}]/.test(peek)) {
                  state.tokenize = inPlugin;
                  break;
                }
              }
              return "string";
            };
          }
          var curState, setStyle2;
          function pass() {
            for (var i3 = arguments.length - 1; i3 >= 0; i3--)
              curState.cc.push(arguments[i3]);
          }
          function cont() {
            pass.apply(null, arguments);
            return true;
          }
          function pushContext(pluginName2, startOfLine) {
            var noIndent = curState.context && curState.context.noIndent;
            curState.context = {
              prev: curState.context,
              pluginName: pluginName2,
              indent: curState.indented,
              startOfLine,
              noIndent
            };
          }
          function popContext() {
            if (curState.context)
              curState.context = curState.context.prev;
          }
          function element3(type2) {
            if (type2 == "openPlugin") {
              curState.pluginName = pluginName;
              return cont(attributes, endplugin(curState.startOfLine));
            } else if (type2 == "closePlugin") {
              var err = false;
              if (curState.context) {
                err = curState.context.pluginName != pluginName;
                popContext();
              } else {
                err = true;
              }
              if (err)
                setStyle2 = "error";
              return cont(endcloseplugin(err));
            } else if (type2 == "string") {
              if (!curState.context || curState.context.name != "!cdata")
                pushContext("!cdata");
              if (curState.tokenize == inText)
                popContext();
              return cont();
            } else
              return cont();
          }
          function endplugin(startOfLine) {
            return function(type2) {
              if (type2 == "selfclosePlugin" || type2 == "endPlugin")
                return cont();
              if (type2 == "endPlugin") {
                pushContext(curState.pluginName, startOfLine);
                return cont();
              }
              return cont();
            };
          }
          function endcloseplugin(err) {
            return function(type2) {
              if (err)
                setStyle2 = "error";
              if (type2 == "endPlugin")
                return cont();
              return pass();
            };
          }
          function attributes(type2) {
            if (type2 == "keyword") {
              setStyle2 = "attribute";
              return cont(attributes);
            }
            if (type2 == "equals")
              return cont(attvalue, attributes);
            return pass();
          }
          function attvalue(type2) {
            if (type2 == "keyword") {
              setStyle2 = "string";
              return cont();
            }
            if (type2 == "string")
              return cont(attvaluemaybe);
            return pass();
          }
          function attvaluemaybe(type2) {
            if (type2 == "string")
              return cont(attvaluemaybe);
            else
              return pass();
          }
          return {
            startState: function() {
              return { tokenize: inText, cc: [], indented: 0, startOfLine: true, pluginName: null, context: null };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                state.startOfLine = true;
                state.indented = stream.indentation();
              }
              if (stream.eatSpace())
                return null;
              setStyle2 = type = pluginName = null;
              var style = state.tokenize(stream, state);
              if ((style || type) && style != "comment") {
                curState = state;
                while (true) {
                  var comb = state.cc.pop() || element3;
                  if (comb(type || style))
                    break;
                }
              }
              state.startOfLine = false;
              return setStyle2 || style;
            },
            indent: function(state, textAfter) {
              var context = state.context;
              if (context && context.noIndent)
                return 0;
              if (context && /^{\//.test(textAfter))
                context = context.prev;
              while (context && !context.startOfLine)
                context = context.prev;
              if (context)
                return context.indent + indentUnit;
              else
                return 0;
            },
            electricChars: "/"
          };
        });
        CodeMirror5.defineMIME("text/tiki", "tiki");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/toml/toml.js
  var require_toml = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/toml/toml.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("toml", function() {
          return {
            startState: function() {
              return {
                inString: false,
                stringType: "",
                lhs: true,
                inArray: 0
              };
            },
            token: function(stream, state) {
              if (!state.inString && (stream.peek() == '"' || stream.peek() == "'")) {
                state.stringType = stream.peek();
                stream.next();
                state.inString = true;
              }
              if (stream.sol() && state.inArray === 0) {
                state.lhs = true;
              }
              if (state.inString) {
                while (state.inString && !stream.eol()) {
                  if (stream.peek() === state.stringType) {
                    stream.next();
                    state.inString = false;
                  } else if (stream.peek() === "\\") {
                    stream.next();
                    stream.next();
                  } else {
                    stream.match(/^.[^\\\"\']*/);
                  }
                }
                return state.lhs ? "property string" : "string";
              } else if (state.inArray && stream.peek() === "]") {
                stream.next();
                state.inArray--;
                return "bracket";
              } else if (state.lhs && stream.peek() === "[" && stream.skipTo("]")) {
                stream.next();
                if (stream.peek() === "]")
                  stream.next();
                return "atom";
              } else if (stream.peek() === "#") {
                stream.skipToEnd();
                return "comment";
              } else if (stream.eatSpace()) {
                return null;
              } else if (state.lhs && stream.eatWhile(function(c3) {
                return c3 != "=" && c3 != " ";
              })) {
                return "property";
              } else if (state.lhs && stream.peek() === "=") {
                stream.next();
                state.lhs = false;
                return null;
              } else if (!state.lhs && stream.match(/^\d\d\d\d[\d\-\:\.T]*Z/)) {
                return "atom";
              } else if (!state.lhs && (stream.match("true") || stream.match("false"))) {
                return "atom";
              } else if (!state.lhs && stream.peek() === "[") {
                state.inArray++;
                stream.next();
                return "bracket";
              } else if (!state.lhs && stream.match(/^\-?\d+(?:\.\d+)?/)) {
                return "number";
              } else if (!stream.eatSpace()) {
                stream.next();
              }
              return null;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-toml", "toml");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/tornado/tornado.js
  var require_tornado = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/tornado/tornado.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_htmlmixed(), require_overlay());
        else if (typeof define == "function" && define.amd)
          define([
            "../../lib/codemirror",
            "../htmlmixed/htmlmixed",
            "../../addon/mode/overlay"
          ], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("tornado:inner", function() {
          var keywords2 = [
            "and",
            "as",
            "assert",
            "autoescape",
            "block",
            "break",
            "class",
            "comment",
            "context",
            "continue",
            "datetime",
            "def",
            "del",
            "elif",
            "else",
            "end",
            "escape",
            "except",
            "exec",
            "extends",
            "false",
            "finally",
            "for",
            "from",
            "global",
            "if",
            "import",
            "in",
            "include",
            "is",
            "json_encode",
            "lambda",
            "length",
            "linkify",
            "load",
            "module",
            "none",
            "not",
            "or",
            "pass",
            "print",
            "put",
            "raise",
            "raw",
            "return",
            "self",
            "set",
            "squeeze",
            "super",
            "true",
            "try",
            "url_escape",
            "while",
            "with",
            "without",
            "xhtml_escape",
            "yield"
          ];
          keywords2 = new RegExp("^((" + keywords2.join(")|(") + "))\\b");
          function tokenBase(stream, state) {
            stream.eatWhile(/[^\{]/);
            var ch = stream.next();
            if (ch == "{") {
              if (ch = stream.eat(/\{|%|#/)) {
                state.tokenize = inTag(ch);
                return "tag";
              }
            }
          }
          function inTag(close) {
            if (close == "{") {
              close = "}";
            }
            return function(stream, state) {
              var ch = stream.next();
              if (ch == close && stream.eat("}")) {
                state.tokenize = tokenBase;
                return "tag";
              }
              if (stream.match(keywords2)) {
                return "keyword";
              }
              return close == "#" ? "comment" : "string";
            };
          }
          return {
            startState: function() {
              return { tokenize: tokenBase };
            },
            token: function(stream, state) {
              return state.tokenize(stream, state);
            }
          };
        });
        CodeMirror5.defineMode("tornado", function(config3) {
          var htmlBase = CodeMirror5.getMode(config3, "text/html");
          var tornadoInner = CodeMirror5.getMode(config3, "tornado:inner");
          return CodeMirror5.overlayMode(htmlBase, tornadoInner);
        });
        CodeMirror5.defineMIME("text/x-tornado", "tornado");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/troff/troff.js
  var require_troff = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/troff/troff.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("troff", function() {
          var words = {};
          function tokenBase(stream) {
            if (stream.eatSpace())
              return null;
            var sol = stream.sol();
            var ch = stream.next();
            if (ch === "\\") {
              if (stream.match("fB") || stream.match("fR") || stream.match("fI") || stream.match("u") || stream.match("d") || stream.match("%") || stream.match("&")) {
                return "string";
              }
              if (stream.match("m[")) {
                stream.skipTo("]");
                stream.next();
                return "string";
              }
              if (stream.match("s+") || stream.match("s-")) {
                stream.eatWhile(/[\d-]/);
                return "string";
              }
              if (stream.match("(") || stream.match("*(")) {
                stream.eatWhile(/[\w-]/);
                return "string";
              }
              return "string";
            }
            if (sol && (ch === "." || ch === "'")) {
              if (stream.eat("\\") && stream.eat('"')) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (sol && ch === ".") {
              if (stream.match("B ") || stream.match("I ") || stream.match("R ")) {
                return "attribute";
              }
              if (stream.match("TH ") || stream.match("SH ") || stream.match("SS ") || stream.match("HP ")) {
                stream.skipToEnd();
                return "quote";
              }
              if (stream.match(/[A-Z]/) && stream.match(/[A-Z]/) || stream.match(/[a-z]/) && stream.match(/[a-z]/)) {
                return "attribute";
              }
            }
            stream.eatWhile(/[\w-]/);
            var cur = stream.current();
            return words.hasOwnProperty(cur) ? words[cur] : null;
          }
          function tokenize(stream, state) {
            return (state.tokens[0] || tokenBase)(stream, state);
          }
          ;
          return {
            startState: function() {
              return { tokens: [] };
            },
            token: function(stream, state) {
              return tokenize(stream, state);
            }
          };
        });
        CodeMirror5.defineMIME("text/troff", "troff");
        CodeMirror5.defineMIME("text/x-troff", "troff");
        CodeMirror5.defineMIME("application/x-troff", "troff");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/ttcn/ttcn.js
  var require_ttcn = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/ttcn/ttcn.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("ttcn", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit, keywords2 = parserConfig.keywords || {}, builtin = parserConfig.builtin || {}, timerOps = parserConfig.timerOps || {}, portOps = parserConfig.portOps || {}, configOps = parserConfig.configOps || {}, verdictOps = parserConfig.verdictOps || {}, sutOps = parserConfig.sutOps || {}, functionOps = parserConfig.functionOps || {}, verdictConsts = parserConfig.verdictConsts || {}, booleanConsts = parserConfig.booleanConsts || {}, otherConsts = parserConfig.otherConsts || {}, types = parserConfig.types || {}, visibilityModifiers = parserConfig.visibilityModifiers || {}, templateMatch = parserConfig.templateMatch || {}, multiLineStrings = parserConfig.multiLineStrings, indentStatements = parserConfig.indentStatements !== false;
          var isOperatorChar = /[+\-*&@=<>!\/]/;
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[\[\]{}\(\),;\\:\?\.]/.test(ch)) {
              curPunc = ch;
              return "punctuation";
            }
            if (ch == "#") {
              stream.skipToEnd();
              return "atom preprocessor";
            }
            if (ch == "%") {
              stream.eatWhile(/\b/);
              return "atom ttcn3Macros";
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            }
            if (ch == "/") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              if (ch == "@") {
                if (stream.match("try") || stream.match("catch") || stream.match("lazy")) {
                  return "keyword";
                }
              }
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_\xa1-\uffff]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur))
              return "keyword";
            if (builtin.propertyIsEnumerable(cur))
              return "builtin";
            if (timerOps.propertyIsEnumerable(cur))
              return "def timerOps";
            if (configOps.propertyIsEnumerable(cur))
              return "def configOps";
            if (verdictOps.propertyIsEnumerable(cur))
              return "def verdictOps";
            if (portOps.propertyIsEnumerable(cur))
              return "def portOps";
            if (sutOps.propertyIsEnumerable(cur))
              return "def sutOps";
            if (functionOps.propertyIsEnumerable(cur))
              return "def functionOps";
            if (verdictConsts.propertyIsEnumerable(cur))
              return "string verdictConsts";
            if (booleanConsts.propertyIsEnumerable(cur))
              return "string booleanConsts";
            if (otherConsts.propertyIsEnumerable(cur))
              return "string otherConsts";
            if (types.propertyIsEnumerable(cur))
              return "builtin types";
            if (visibilityModifiers.propertyIsEnumerable(cur))
              return "builtin visibilityModifiers";
            if (templateMatch.propertyIsEnumerable(cur))
              return "atom templateMatch";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  var afterQuote = stream.peek();
                  if (afterQuote) {
                    afterQuote = afterQuote.toLowerCase();
                    if (afterQuote == "b" || afterQuote == "h" || afterQuote == "o")
                      stream.next();
                  }
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = null;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = null;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            var indent = state.indented;
            if (state.context && state.context.type == "statement")
              indent = state.context.indented;
            return state.context = new Context(indent, col, type, null, state.context);
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if ((curPunc == ";" || curPunc == ":" || curPunc == ",") && ctx.type == "statement") {
                popContext(state);
              } else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if (indentStatements && ((ctx.type == "}" || ctx.type == "top") && curPunc != ";" || ctx.type == "statement" && curPunc == "newstatement"))
                pushContext(state, stream.column(), "statement");
              state.startOfLine = false;
              return style;
            },
            electricChars: "{}",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//",
            fold: "brace"
          };
        });
        function words(str) {
          var obj = {}, words2 = str.split(" ");
          for (var i3 = 0; i3 < words2.length; ++i3)
            obj[words2[i3]] = true;
          return obj;
        }
        function def(mimes, mode2) {
          if (typeof mimes == "string")
            mimes = [mimes];
          var words2 = [];
          function add2(obj) {
            if (obj) {
              for (var prop in obj)
                if (obj.hasOwnProperty(prop))
                  words2.push(prop);
            }
          }
          add2(mode2.keywords);
          add2(mode2.builtin);
          add2(mode2.timerOps);
          add2(mode2.portOps);
          if (words2.length) {
            mode2.helperType = mimes[0];
            CodeMirror5.registerHelper("hintWords", mimes[0], words2);
          }
          for (var i3 = 0; i3 < mimes.length; ++i3)
            CodeMirror5.defineMIME(mimes[i3], mode2);
        }
        def(["text/x-ttcn", "text/x-ttcn3", "text/x-ttcnpp"], {
          name: "ttcn",
          keywords: words("activate address alive all alt altstep and and4b any break case component const continue control deactivate display do else encode enumerated except exception execute extends extension external for from function goto group if import in infinity inout interleave label language length log match message mixed mod modifies module modulepar mtc noblock not not4b nowait of on optional or or4b out override param pattern port procedure record recursive rem repeat return runs select self sender set signature system template testcase to type union value valueof var variant while with xor xor4b"),
          builtin: words("bit2hex bit2int bit2oct bit2str char2int char2oct encvalue decomp decvalue float2int float2str hex2bit hex2int hex2oct hex2str int2bit int2char int2float int2hex int2oct int2str int2unichar isbound ischosen ispresent isvalue lengthof log2str oct2bit oct2char oct2hex oct2int oct2str regexp replace rnd sizeof str2bit str2float str2hex str2int str2oct substr unichar2int unichar2char enum2int"),
          types: words("anytype bitstring boolean char charstring default float hexstring integer objid octetstring universal verdicttype timer"),
          timerOps: words("read running start stop timeout"),
          portOps: words("call catch check clear getcall getreply halt raise receive reply send trigger"),
          configOps: words("create connect disconnect done kill killed map unmap"),
          verdictOps: words("getverdict setverdict"),
          sutOps: words("action"),
          functionOps: words("apply derefers refers"),
          verdictConsts: words("error fail inconc none pass"),
          booleanConsts: words("true false"),
          otherConsts: words("null NULL omit"),
          visibilityModifiers: words("private public friend"),
          templateMatch: words("complement ifpresent subset superset permutation"),
          multiLineStrings: true
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/ttcn-cfg/ttcn-cfg.js
  var require_ttcn_cfg = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/ttcn-cfg/ttcn-cfg.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("ttcn-cfg", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit, keywords2 = parserConfig.keywords || {}, fileNCtrlMaskOptions = parserConfig.fileNCtrlMaskOptions || {}, externalCommands = parserConfig.externalCommands || {}, multiLineStrings = parserConfig.multiLineStrings, indentStatements = parserConfig.indentStatements !== false;
          var isOperatorChar = /[\|]/;
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (ch == '"' || ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[:=]/.test(ch)) {
              curPunc = ch;
              return "punctuation";
            }
            if (ch == "#") {
              stream.skipToEnd();
              return "comment";
            }
            if (/\d/.test(ch)) {
              stream.eatWhile(/[\w\.]/);
              return "number";
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            if (ch == "[") {
              stream.eatWhile(/[\w_\]]/);
              return "number sectionTitle";
            }
            stream.eatWhile(/[\w\$_]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur))
              return "keyword";
            if (fileNCtrlMaskOptions.propertyIsEnumerable(cur))
              return "negative fileNCtrlMaskOptions";
            if (externalCommands.propertyIsEnumerable(cur))
              return "negative externalCommands";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  var afterNext = stream.peek();
                  if (afterNext) {
                    afterNext = afterNext.toLowerCase();
                    if (afterNext == "b" || afterNext == "h" || afterNext == "o")
                      stream.next();
                  }
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = null;
              return "string";
            };
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            var indent = state.indented;
            if (state.context && state.context.type == "statement")
              indent = state.context.indented;
            return state.context = new Context(indent, col, type, null, state.context);
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if ((curPunc == ";" || curPunc == ":" || curPunc == ",") && ctx.type == "statement") {
                popContext(state);
              } else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if (indentStatements && ((ctx.type == "}" || ctx.type == "top") && curPunc != ";" || ctx.type == "statement" && curPunc == "newstatement"))
                pushContext(state, stream.column(), "statement");
              state.startOfLine = false;
              return style;
            },
            electricChars: "{}",
            lineComment: "#",
            fold: "brace"
          };
        });
        function words(str) {
          var obj = {}, words2 = str.split(" ");
          for (var i3 = 0; i3 < words2.length; ++i3)
            obj[words2[i3]] = true;
          return obj;
        }
        CodeMirror5.defineMIME("text/x-ttcn-cfg", {
          name: "ttcn-cfg",
          keywords: words("Yes No LogFile FileMask ConsoleMask AppendFile TimeStampFormat LogEventTypes SourceInfoFormat LogEntityName LogSourceInfo DiskFullAction LogFileNumber LogFileSize MatchingHints Detailed Compact SubCategories Stack Single None Seconds DateTime Time Stop Error Retry Delete TCPPort KillTimer NumHCs UnixSocketsEnabled LocalAddress"),
          fileNCtrlMaskOptions: words("TTCN_EXECUTOR TTCN_ERROR TTCN_WARNING TTCN_PORTEVENT TTCN_TIMEROP TTCN_VERDICTOP TTCN_DEFAULTOP TTCN_TESTCASE TTCN_ACTION TTCN_USER TTCN_FUNCTION TTCN_STATISTICS TTCN_PARALLEL TTCN_MATCHING TTCN_DEBUG EXECUTOR ERROR WARNING PORTEVENT TIMEROP VERDICTOP DEFAULTOP TESTCASE ACTION USER FUNCTION STATISTICS PARALLEL MATCHING DEBUG LOG_ALL LOG_NOTHING ACTION_UNQUALIFIED DEBUG_ENCDEC DEBUG_TESTPORT DEBUG_UNQUALIFIED DEFAULTOP_ACTIVATE DEFAULTOP_DEACTIVATE DEFAULTOP_EXIT DEFAULTOP_UNQUALIFIED ERROR_UNQUALIFIED EXECUTOR_COMPONENT EXECUTOR_CONFIGDATA EXECUTOR_EXTCOMMAND EXECUTOR_LOGOPTIONS EXECUTOR_RUNTIME EXECUTOR_UNQUALIFIED FUNCTION_RND FUNCTION_UNQUALIFIED MATCHING_DONE MATCHING_MCSUCCESS MATCHING_MCUNSUCC MATCHING_MMSUCCESS MATCHING_MMUNSUCC MATCHING_PCSUCCESS MATCHING_PCUNSUCC MATCHING_PMSUCCESS MATCHING_PMUNSUCC MATCHING_PROBLEM MATCHING_TIMEOUT MATCHING_UNQUALIFIED PARALLEL_PORTCONN PARALLEL_PORTMAP PARALLEL_PTC PARALLEL_UNQUALIFIED PORTEVENT_DUALRECV PORTEVENT_DUALSEND PORTEVENT_MCRECV PORTEVENT_MCSEND PORTEVENT_MMRECV PORTEVENT_MMSEND PORTEVENT_MQUEUE PORTEVENT_PCIN PORTEVENT_PCOUT PORTEVENT_PMIN PORTEVENT_PMOUT PORTEVENT_PQUEUE PORTEVENT_STATE PORTEVENT_UNQUALIFIED STATISTICS_UNQUALIFIED STATISTICS_VERDICT TESTCASE_FINISH TESTCASE_START TESTCASE_UNQUALIFIED TIMEROP_GUARD TIMEROP_READ TIMEROP_START TIMEROP_STOP TIMEROP_TIMEOUT TIMEROP_UNQUALIFIED USER_UNQUALIFIED VERDICTOP_FINAL VERDICTOP_GETVERDICT VERDICTOP_SETVERDICT VERDICTOP_UNQUALIFIED WARNING_UNQUALIFIED"),
          externalCommands: words("BeginControlPart EndControlPart BeginTestCase EndTestCase"),
          multiLineStrings: true
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/turtle/turtle.js
  var require_turtle = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/turtle/turtle.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("turtle", function(config3) {
          var indentUnit = config3.indentUnit;
          var curPunc;
          function wordRegexp(words) {
            return new RegExp("^(?:" + words.join("|") + ")$", "i");
          }
          var ops = wordRegexp([]);
          var keywords2 = wordRegexp(["@prefix", "@base", "a"]);
          var operatorChars = /[*+\-<>=&|]/;
          function tokenBase(stream, state) {
            var ch = stream.next();
            curPunc = null;
            if (ch == "<" && !stream.match(/^[\s\u00a0=]/, false)) {
              stream.match(/^[^\s\u00a0>]*>?/);
              return "atom";
            } else if (ch == '"' || ch == "'") {
              state.tokenize = tokenLiteral(ch);
              return state.tokenize(stream, state);
            } else if (/[{}\(\),\.;\[\]]/.test(ch)) {
              curPunc = ch;
              return null;
            } else if (ch == "#") {
              stream.skipToEnd();
              return "comment";
            } else if (operatorChars.test(ch)) {
              stream.eatWhile(operatorChars);
              return null;
            } else if (ch == ":") {
              return "operator";
            } else {
              stream.eatWhile(/[_\w\d]/);
              if (stream.peek() == ":") {
                return "variable-3";
              } else {
                var word = stream.current();
                if (keywords2.test(word)) {
                  return "meta";
                }
                if (ch >= "A" && ch <= "Z") {
                  return "comment";
                } else {
                  return "keyword";
                }
              }
              var word = stream.current();
              if (ops.test(word))
                return null;
              else if (keywords2.test(word))
                return "meta";
              else
                return "variable";
            }
          }
          function tokenLiteral(quote) {
            return function(stream, state) {
              var escaped = false, ch;
              while ((ch = stream.next()) != null) {
                if (ch == quote && !escaped) {
                  state.tokenize = tokenBase;
                  break;
                }
                escaped = !escaped && ch == "\\";
              }
              return "string";
            };
          }
          function pushContext(state, type, col) {
            state.context = { prev: state.context, indent: state.indent, col, type };
          }
          function popContext(state) {
            state.indent = state.context.indent;
            state.context = state.context.prev;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                context: null,
                indent: 0,
                col: 0
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                if (state.context && state.context.align == null)
                  state.context.align = false;
                state.indent = stream.indentation();
              }
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              if (style != "comment" && state.context && state.context.align == null && state.context.type != "pattern") {
                state.context.align = true;
              }
              if (curPunc == "(")
                pushContext(state, ")", stream.column());
              else if (curPunc == "[")
                pushContext(state, "]", stream.column());
              else if (curPunc == "{")
                pushContext(state, "}", stream.column());
              else if (/[\]\}\)]/.test(curPunc)) {
                while (state.context && state.context.type == "pattern")
                  popContext(state);
                if (state.context && curPunc == state.context.type)
                  popContext(state);
              } else if (curPunc == "." && state.context && state.context.type == "pattern")
                popContext(state);
              else if (/atom|string|variable/.test(style) && state.context) {
                if (/[\}\]]/.test(state.context.type))
                  pushContext(state, "pattern", stream.column());
                else if (state.context.type == "pattern" && !state.context.align) {
                  state.context.align = true;
                  state.context.col = stream.column();
                }
              }
              return style;
            },
            indent: function(state, textAfter) {
              var firstChar = textAfter && textAfter.charAt(0);
              var context = state.context;
              if (/[\]\}]/.test(firstChar))
                while (context && context.type == "pattern")
                  context = context.prev;
              var closing = context && firstChar == context.type;
              if (!context)
                return 0;
              else if (context.type == "pattern")
                return context.col;
              else if (context.align)
                return context.col + (closing ? 0 : 1);
              else
                return context.indent + (closing ? 0 : indentUnit);
            },
            lineComment: "#"
          };
        });
        CodeMirror5.defineMIME("text/turtle", "turtle");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/twig/twig.js
  var require_twig = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/twig/twig.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_multiplex());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../../addon/mode/multiplex"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("twig:inner", function() {
          var keywords2 = ["and", "as", "autoescape", "endautoescape", "block", "do", "endblock", "else", "elseif", "extends", "for", "endfor", "embed", "endembed", "filter", "endfilter", "flush", "from", "if", "endif", "in", "is", "include", "import", "not", "or", "set", "spaceless", "endspaceless", "with", "endwith", "trans", "endtrans", "blocktrans", "endblocktrans", "macro", "endmacro", "use", "verbatim", "endverbatim"], operator = /^[+\-*&%=<>!?|~^]/, sign3 = /^[:\[\(\{]/, atom = ["true", "false", "null", "empty", "defined", "divisibleby", "divisible by", "even", "odd", "iterable", "sameas", "same as"], number2 = /^(\d[+\-\*\/])?\d+(\.\d+)?/;
          keywords2 = new RegExp("((" + keywords2.join(")|(") + "))\\b");
          atom = new RegExp("((" + atom.join(")|(") + "))\\b");
          function tokenBase(stream, state) {
            var ch = stream.peek();
            if (state.incomment) {
              if (!stream.skipTo("#}")) {
                stream.skipToEnd();
              } else {
                stream.eatWhile(/\#|}/);
                state.incomment = false;
              }
              return "comment";
            } else if (state.intag) {
              if (state.operator) {
                state.operator = false;
                if (stream.match(atom)) {
                  return "atom";
                }
                if (stream.match(number2)) {
                  return "number";
                }
              }
              if (state.sign) {
                state.sign = false;
                if (stream.match(atom)) {
                  return "atom";
                }
                if (stream.match(number2)) {
                  return "number";
                }
              }
              if (state.instring) {
                if (ch == state.instring) {
                  state.instring = false;
                }
                stream.next();
                return "string";
              } else if (ch == "'" || ch == '"') {
                state.instring = ch;
                stream.next();
                return "string";
              } else if (stream.match(state.intag + "}") || stream.eat("-") && stream.match(state.intag + "}")) {
                state.intag = false;
                return "tag";
              } else if (stream.match(operator)) {
                state.operator = true;
                return "operator";
              } else if (stream.match(sign3)) {
                state.sign = true;
              } else {
                if (stream.eat(" ") || stream.sol()) {
                  if (stream.match(keywords2)) {
                    return "keyword";
                  }
                  if (stream.match(atom)) {
                    return "atom";
                  }
                  if (stream.match(number2)) {
                    return "number";
                  }
                  if (stream.sol()) {
                    stream.next();
                  }
                } else {
                  stream.next();
                }
              }
              return "variable";
            } else if (stream.eat("{")) {
              if (stream.eat("#")) {
                state.incomment = true;
                if (!stream.skipTo("#}")) {
                  stream.skipToEnd();
                } else {
                  stream.eatWhile(/\#|}/);
                  state.incomment = false;
                }
                return "comment";
              } else if (ch = stream.eat(/\{|%/)) {
                state.intag = ch;
                if (ch == "{") {
                  state.intag = "}";
                }
                stream.eat("-");
                return "tag";
              }
            }
            stream.next();
          }
          ;
          return {
            startState: function() {
              return {};
            },
            token: function(stream, state) {
              return tokenBase(stream, state);
            }
          };
        });
        CodeMirror5.defineMode("twig", function(config3, parserConfig) {
          var twigInner = CodeMirror5.getMode(config3, "twig:inner");
          if (!parserConfig || !parserConfig.base)
            return twigInner;
          return CodeMirror5.multiplexingMode(CodeMirror5.getMode(config3, parserConfig.base), {
            open: /\{[{#%]/,
            close: /[}#%]\}/,
            mode: twigInner,
            parseDelimiters: true
          });
        });
        CodeMirror5.defineMIME("text/x-twig", "twig");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/vb/vb.js
  var require_vb = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/vb/vb.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("vb", function(conf, parserConf) {
          var ERRORCLASS = "error";
          function wordRegexp(words) {
            return new RegExp("^((" + words.join(")|(") + "))\\b", "i");
          }
          var singleOperators = new RegExp("^[\\+\\-\\*/%&\\\\|\\^~<>!]");
          var singleDelimiters = new RegExp("^[\\(\\)\\[\\]\\{\\}@,:`=;\\.]");
          var doubleOperators = new RegExp("^((==)|(<>)|(<=)|(>=)|(<>)|(<<)|(>>)|(//)|(\\*\\*))");
          var doubleDelimiters = new RegExp("^((\\+=)|(\\-=)|(\\*=)|(%=)|(/=)|(&=)|(\\|=)|(\\^=))");
          var tripleDelimiters = new RegExp("^((//=)|(>>=)|(<<=)|(\\*\\*=))");
          var identifiers = new RegExp("^[_A-Za-z][_A-Za-z0-9]*");
          var openingKeywords = ["class", "module", "sub", "enum", "select", "while", "if", "function", "get", "set", "property", "try", "structure", "synclock", "using", "with"];
          var middleKeywords = ["else", "elseif", "case", "catch", "finally"];
          var endKeywords = ["next", "loop"];
          var operatorKeywords = ["and", "andalso", "or", "orelse", "xor", "in", "not", "is", "isnot", "like"];
          var wordOperators = wordRegexp(operatorKeywords);
          var commonKeywords = ["#const", "#else", "#elseif", "#end", "#if", "#region", "addhandler", "addressof", "alias", "as", "byref", "byval", "cbool", "cbyte", "cchar", "cdate", "cdbl", "cdec", "cint", "clng", "cobj", "compare", "const", "continue", "csbyte", "cshort", "csng", "cstr", "cuint", "culng", "cushort", "declare", "default", "delegate", "dim", "directcast", "each", "erase", "error", "event", "exit", "explicit", "false", "for", "friend", "gettype", "goto", "handles", "implements", "imports", "infer", "inherits", "interface", "isfalse", "istrue", "lib", "me", "mod", "mustinherit", "mustoverride", "my", "mybase", "myclass", "namespace", "narrowing", "new", "nothing", "notinheritable", "notoverridable", "of", "off", "on", "operator", "option", "optional", "out", "overloads", "overridable", "overrides", "paramarray", "partial", "private", "protected", "public", "raiseevent", "readonly", "redim", "removehandler", "resume", "return", "shadows", "shared", "static", "step", "stop", "strict", "then", "throw", "to", "true", "trycast", "typeof", "until", "until", "when", "widening", "withevents", "writeonly"];
          var commontypes = ["object", "boolean", "char", "string", "byte", "sbyte", "short", "ushort", "int16", "uint16", "integer", "uinteger", "int32", "uint32", "long", "ulong", "int64", "uint64", "decimal", "single", "double", "float", "date", "datetime", "intptr", "uintptr"];
          var keywords2 = wordRegexp(commonKeywords);
          var types = wordRegexp(commontypes);
          var stringPrefixes = '"';
          var opening = wordRegexp(openingKeywords);
          var middle = wordRegexp(middleKeywords);
          var closing = wordRegexp(endKeywords);
          var doubleClosing = wordRegexp(["end"]);
          var doOpening = wordRegexp(["do"]);
          var indentInfo = null;
          CodeMirror5.registerHelper("hintWords", "vb", openingKeywords.concat(middleKeywords).concat(endKeywords).concat(operatorKeywords).concat(commonKeywords).concat(commontypes));
          function indent(_stream, state) {
            state.currentIndent++;
          }
          function dedent(_stream, state) {
            state.currentIndent--;
          }
          function tokenBase(stream, state) {
            if (stream.eatSpace()) {
              return null;
            }
            var ch = stream.peek();
            if (ch === "'") {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match(/^((&H)|(&O))?[0-9\.a-f]/i, false)) {
              var floatLiteral = false;
              if (stream.match(/^\d*\.\d+F?/i)) {
                floatLiteral = true;
              } else if (stream.match(/^\d+\.\d*F?/)) {
                floatLiteral = true;
              } else if (stream.match(/^\.\d+F?/)) {
                floatLiteral = true;
              }
              if (floatLiteral) {
                stream.eat(/J/i);
                return "number";
              }
              var intLiteral = false;
              if (stream.match(/^&H[0-9a-f]+/i)) {
                intLiteral = true;
              } else if (stream.match(/^&O[0-7]+/i)) {
                intLiteral = true;
              } else if (stream.match(/^[1-9]\d*F?/)) {
                stream.eat(/J/i);
                intLiteral = true;
              } else if (stream.match(/^0(?![\dx])/i)) {
                intLiteral = true;
              }
              if (intLiteral) {
                stream.eat(/L/i);
                return "number";
              }
            }
            if (stream.match(stringPrefixes)) {
              state.tokenize = tokenStringFactory(stream.current());
              return state.tokenize(stream, state);
            }
            if (stream.match(tripleDelimiters) || stream.match(doubleDelimiters)) {
              return null;
            }
            if (stream.match(doubleOperators) || stream.match(singleOperators) || stream.match(wordOperators)) {
              return "operator";
            }
            if (stream.match(singleDelimiters)) {
              return null;
            }
            if (stream.match(doOpening)) {
              indent(stream, state);
              state.doInCurrentLine = true;
              return "keyword";
            }
            if (stream.match(opening)) {
              if (!state.doInCurrentLine)
                indent(stream, state);
              else
                state.doInCurrentLine = false;
              return "keyword";
            }
            if (stream.match(middle)) {
              return "keyword";
            }
            if (stream.match(doubleClosing)) {
              dedent(stream, state);
              dedent(stream, state);
              return "keyword";
            }
            if (stream.match(closing)) {
              dedent(stream, state);
              return "keyword";
            }
            if (stream.match(types)) {
              return "keyword";
            }
            if (stream.match(keywords2)) {
              return "keyword";
            }
            if (stream.match(identifiers)) {
              return "variable";
            }
            stream.next();
            return ERRORCLASS;
          }
          function tokenStringFactory(delimiter) {
            var singleline = delimiter.length == 1;
            var OUTCLASS = "string";
            return function(stream, state) {
              while (!stream.eol()) {
                stream.eatWhile(/[^'"]/);
                if (stream.match(delimiter)) {
                  state.tokenize = tokenBase;
                  return OUTCLASS;
                } else {
                  stream.eat(/['"]/);
                }
              }
              if (singleline) {
                if (parserConf.singleLineStringErrors) {
                  return ERRORCLASS;
                } else {
                  state.tokenize = tokenBase;
                }
              }
              return OUTCLASS;
            };
          }
          function tokenLexer(stream, state) {
            var style = state.tokenize(stream, state);
            var current = stream.current();
            if (current === ".") {
              style = state.tokenize(stream, state);
              if (style === "variable") {
                return "variable";
              } else {
                return ERRORCLASS;
              }
            }
            var delimiter_index = "[({".indexOf(current);
            if (delimiter_index !== -1) {
              indent(stream, state);
            }
            if (indentInfo === "dedent") {
              if (dedent(stream, state)) {
                return ERRORCLASS;
              }
            }
            delimiter_index = "])}".indexOf(current);
            if (delimiter_index !== -1) {
              if (dedent(stream, state)) {
                return ERRORCLASS;
              }
            }
            return style;
          }
          var external = {
            electricChars: "dDpPtTfFeE ",
            startState: function() {
              return {
                tokenize: tokenBase,
                lastToken: null,
                currentIndent: 0,
                nextLineIndent: 0,
                doInCurrentLine: false
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                state.currentIndent += state.nextLineIndent;
                state.nextLineIndent = 0;
                state.doInCurrentLine = 0;
              }
              var style = tokenLexer(stream, state);
              state.lastToken = { style, content: stream.current() };
              return style;
            },
            indent: function(state, textAfter) {
              var trueText = textAfter.replace(/^\s+|\s+$/g, "");
              if (trueText.match(closing) || trueText.match(doubleClosing) || trueText.match(middle))
                return conf.indentUnit * (state.currentIndent - 1);
              if (state.currentIndent < 0)
                return 0;
              return state.currentIndent * conf.indentUnit;
            },
            lineComment: "'"
          };
          return external;
        });
        CodeMirror5.defineMIME("text/x-vb", "vb");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/vbscript/vbscript.js
  var require_vbscript = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/vbscript/vbscript.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("vbscript", function(conf, parserConf) {
          var ERRORCLASS = "error";
          function wordRegexp(words) {
            return new RegExp("^((" + words.join(")|(") + "))\\b", "i");
          }
          var singleOperators = new RegExp("^[\\+\\-\\*/&\\\\\\^<>=]");
          var doubleOperators = new RegExp("^((<>)|(<=)|(>=))");
          var singleDelimiters = new RegExp("^[\\.,]");
          var brakets = new RegExp("^[\\(\\)]");
          var identifiers = new RegExp("^[A-Za-z][_A-Za-z0-9]*");
          var openingKeywords = ["class", "sub", "select", "while", "if", "function", "property", "with", "for"];
          var middleKeywords = ["else", "elseif", "case"];
          var endKeywords = ["next", "loop", "wend"];
          var wordOperators = wordRegexp(["and", "or", "not", "xor", "is", "mod", "eqv", "imp"]);
          var commonkeywords = [
            "dim",
            "redim",
            "then",
            "until",
            "randomize",
            "byval",
            "byref",
            "new",
            "property",
            "exit",
            "in",
            "const",
            "private",
            "public",
            "get",
            "set",
            "let",
            "stop",
            "on error resume next",
            "on error goto 0",
            "option explicit",
            "call",
            "me"
          ];
          var atomWords = ["true", "false", "nothing", "empty", "null"];
          var builtinFuncsWords = [
            "abs",
            "array",
            "asc",
            "atn",
            "cbool",
            "cbyte",
            "ccur",
            "cdate",
            "cdbl",
            "chr",
            "cint",
            "clng",
            "cos",
            "csng",
            "cstr",
            "date",
            "dateadd",
            "datediff",
            "datepart",
            "dateserial",
            "datevalue",
            "day",
            "escape",
            "eval",
            "execute",
            "exp",
            "filter",
            "formatcurrency",
            "formatdatetime",
            "formatnumber",
            "formatpercent",
            "getlocale",
            "getobject",
            "getref",
            "hex",
            "hour",
            "inputbox",
            "instr",
            "instrrev",
            "int",
            "fix",
            "isarray",
            "isdate",
            "isempty",
            "isnull",
            "isnumeric",
            "isobject",
            "join",
            "lbound",
            "lcase",
            "left",
            "len",
            "loadpicture",
            "log",
            "ltrim",
            "rtrim",
            "trim",
            "maths",
            "mid",
            "minute",
            "month",
            "monthname",
            "msgbox",
            "now",
            "oct",
            "replace",
            "rgb",
            "right",
            "rnd",
            "round",
            "scriptengine",
            "scriptenginebuildversion",
            "scriptenginemajorversion",
            "scriptengineminorversion",
            "second",
            "setlocale",
            "sgn",
            "sin",
            "space",
            "split",
            "sqr",
            "strcomp",
            "string",
            "strreverse",
            "tan",
            "time",
            "timer",
            "timeserial",
            "timevalue",
            "typename",
            "ubound",
            "ucase",
            "unescape",
            "vartype",
            "weekday",
            "weekdayname",
            "year"
          ];
          var builtinConsts = [
            "vbBlack",
            "vbRed",
            "vbGreen",
            "vbYellow",
            "vbBlue",
            "vbMagenta",
            "vbCyan",
            "vbWhite",
            "vbBinaryCompare",
            "vbTextCompare",
            "vbSunday",
            "vbMonday",
            "vbTuesday",
            "vbWednesday",
            "vbThursday",
            "vbFriday",
            "vbSaturday",
            "vbUseSystemDayOfWeek",
            "vbFirstJan1",
            "vbFirstFourDays",
            "vbFirstFullWeek",
            "vbGeneralDate",
            "vbLongDate",
            "vbShortDate",
            "vbLongTime",
            "vbShortTime",
            "vbObjectError",
            "vbOKOnly",
            "vbOKCancel",
            "vbAbortRetryIgnore",
            "vbYesNoCancel",
            "vbYesNo",
            "vbRetryCancel",
            "vbCritical",
            "vbQuestion",
            "vbExclamation",
            "vbInformation",
            "vbDefaultButton1",
            "vbDefaultButton2",
            "vbDefaultButton3",
            "vbDefaultButton4",
            "vbApplicationModal",
            "vbSystemModal",
            "vbOK",
            "vbCancel",
            "vbAbort",
            "vbRetry",
            "vbIgnore",
            "vbYes",
            "vbNo",
            "vbCr",
            "VbCrLf",
            "vbFormFeed",
            "vbLf",
            "vbNewLine",
            "vbNullChar",
            "vbNullString",
            "vbTab",
            "vbVerticalTab",
            "vbUseDefault",
            "vbTrue",
            "vbFalse",
            "vbEmpty",
            "vbNull",
            "vbInteger",
            "vbLong",
            "vbSingle",
            "vbDouble",
            "vbCurrency",
            "vbDate",
            "vbString",
            "vbObject",
            "vbError",
            "vbBoolean",
            "vbVariant",
            "vbDataObject",
            "vbDecimal",
            "vbByte",
            "vbArray"
          ];
          var builtinObjsWords = ["WScript", "err", "debug", "RegExp"];
          var knownProperties = ["description", "firstindex", "global", "helpcontext", "helpfile", "ignorecase", "length", "number", "pattern", "source", "value", "count"];
          var knownMethods = ["clear", "execute", "raise", "replace", "test", "write", "writeline", "close", "open", "state", "eof", "update", "addnew", "end", "createobject", "quit"];
          var aspBuiltinObjsWords = ["server", "response", "request", "session", "application"];
          var aspKnownProperties = [
            "buffer",
            "cachecontrol",
            "charset",
            "contenttype",
            "expires",
            "expiresabsolute",
            "isclientconnected",
            "pics",
            "status",
            "clientcertificate",
            "cookies",
            "form",
            "querystring",
            "servervariables",
            "totalbytes",
            "contents",
            "staticobjects",
            "codepage",
            "lcid",
            "sessionid",
            "timeout",
            "scripttimeout"
          ];
          var aspKnownMethods = [
            "addheader",
            "appendtolog",
            "binarywrite",
            "end",
            "flush",
            "redirect",
            "binaryread",
            "remove",
            "removeall",
            "lock",
            "unlock",
            "abandon",
            "getlasterror",
            "htmlencode",
            "mappath",
            "transfer",
            "urlencode"
          ];
          var knownWords = knownMethods.concat(knownProperties);
          builtinObjsWords = builtinObjsWords.concat(builtinConsts);
          if (conf.isASP) {
            builtinObjsWords = builtinObjsWords.concat(aspBuiltinObjsWords);
            knownWords = knownWords.concat(aspKnownMethods, aspKnownProperties);
          }
          ;
          var keywords2 = wordRegexp(commonkeywords);
          var atoms = wordRegexp(atomWords);
          var builtinFuncs = wordRegexp(builtinFuncsWords);
          var builtinObjs = wordRegexp(builtinObjsWords);
          var known = wordRegexp(knownWords);
          var stringPrefixes = '"';
          var opening = wordRegexp(openingKeywords);
          var middle = wordRegexp(middleKeywords);
          var closing = wordRegexp(endKeywords);
          var doubleClosing = wordRegexp(["end"]);
          var doOpening = wordRegexp(["do"]);
          var noIndentWords = wordRegexp(["on error resume next", "exit"]);
          var comment = wordRegexp(["rem"]);
          function indent(_stream, state) {
            state.currentIndent++;
          }
          function dedent(_stream, state) {
            state.currentIndent--;
          }
          function tokenBase(stream, state) {
            if (stream.eatSpace()) {
              return "space";
            }
            var ch = stream.peek();
            if (ch === "'") {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match(comment)) {
              stream.skipToEnd();
              return "comment";
            }
            if (stream.match(/^((&H)|(&O))?[0-9\.]/i, false) && !stream.match(/^((&H)|(&O))?[0-9\.]+[a-z_]/i, false)) {
              var floatLiteral = false;
              if (stream.match(/^\d*\.\d+/i)) {
                floatLiteral = true;
              } else if (stream.match(/^\d+\.\d*/)) {
                floatLiteral = true;
              } else if (stream.match(/^\.\d+/)) {
                floatLiteral = true;
              }
              if (floatLiteral) {
                stream.eat(/J/i);
                return "number";
              }
              var intLiteral = false;
              if (stream.match(/^&H[0-9a-f]+/i)) {
                intLiteral = true;
              } else if (stream.match(/^&O[0-7]+/i)) {
                intLiteral = true;
              } else if (stream.match(/^[1-9]\d*F?/)) {
                stream.eat(/J/i);
                intLiteral = true;
              } else if (stream.match(/^0(?![\dx])/i)) {
                intLiteral = true;
              }
              if (intLiteral) {
                stream.eat(/L/i);
                return "number";
              }
            }
            if (stream.match(stringPrefixes)) {
              state.tokenize = tokenStringFactory(stream.current());
              return state.tokenize(stream, state);
            }
            if (stream.match(doubleOperators) || stream.match(singleOperators) || stream.match(wordOperators)) {
              return "operator";
            }
            if (stream.match(singleDelimiters)) {
              return null;
            }
            if (stream.match(brakets)) {
              return "bracket";
            }
            if (stream.match(noIndentWords)) {
              state.doInCurrentLine = true;
              return "keyword";
            }
            if (stream.match(doOpening)) {
              indent(stream, state);
              state.doInCurrentLine = true;
              return "keyword";
            }
            if (stream.match(opening)) {
              if (!state.doInCurrentLine)
                indent(stream, state);
              else
                state.doInCurrentLine = false;
              return "keyword";
            }
            if (stream.match(middle)) {
              return "keyword";
            }
            if (stream.match(doubleClosing)) {
              dedent(stream, state);
              dedent(stream, state);
              return "keyword";
            }
            if (stream.match(closing)) {
              if (!state.doInCurrentLine)
                dedent(stream, state);
              else
                state.doInCurrentLine = false;
              return "keyword";
            }
            if (stream.match(keywords2)) {
              return "keyword";
            }
            if (stream.match(atoms)) {
              return "atom";
            }
            if (stream.match(known)) {
              return "variable-2";
            }
            if (stream.match(builtinFuncs)) {
              return "builtin";
            }
            if (stream.match(builtinObjs)) {
              return "variable-2";
            }
            if (stream.match(identifiers)) {
              return "variable";
            }
            stream.next();
            return ERRORCLASS;
          }
          function tokenStringFactory(delimiter) {
            var singleline = delimiter.length == 1;
            var OUTCLASS = "string";
            return function(stream, state) {
              while (!stream.eol()) {
                stream.eatWhile(/[^'"]/);
                if (stream.match(delimiter)) {
                  state.tokenize = tokenBase;
                  return OUTCLASS;
                } else {
                  stream.eat(/['"]/);
                }
              }
              if (singleline) {
                if (parserConf.singleLineStringErrors) {
                  return ERRORCLASS;
                } else {
                  state.tokenize = tokenBase;
                }
              }
              return OUTCLASS;
            };
          }
          function tokenLexer(stream, state) {
            var style = state.tokenize(stream, state);
            var current = stream.current();
            if (current === ".") {
              style = state.tokenize(stream, state);
              current = stream.current();
              if (style && (style.substr(0, 8) === "variable" || style === "builtin" || style === "keyword")) {
                if (style === "builtin" || style === "keyword")
                  style = "variable";
                if (knownWords.indexOf(current.substr(1)) > -1)
                  style = "variable-2";
                return style;
              } else {
                return ERRORCLASS;
              }
            }
            return style;
          }
          var external = {
            electricChars: "dDpPtTfFeE ",
            startState: function() {
              return {
                tokenize: tokenBase,
                lastToken: null,
                currentIndent: 0,
                nextLineIndent: 0,
                doInCurrentLine: false,
                ignoreKeyword: false
              };
            },
            token: function(stream, state) {
              if (stream.sol()) {
                state.currentIndent += state.nextLineIndent;
                state.nextLineIndent = 0;
                state.doInCurrentLine = 0;
              }
              var style = tokenLexer(stream, state);
              state.lastToken = { style, content: stream.current() };
              if (style === "space")
                style = null;
              return style;
            },
            indent: function(state, textAfter) {
              var trueText = textAfter.replace(/^\s+|\s+$/g, "");
              if (trueText.match(closing) || trueText.match(doubleClosing) || trueText.match(middle))
                return conf.indentUnit * (state.currentIndent - 1);
              if (state.currentIndent < 0)
                return 0;
              return state.currentIndent * conf.indentUnit;
            }
          };
          return external;
        });
        CodeMirror5.defineMIME("text/vbscript", "vbscript");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/velocity/velocity.js
  var require_velocity = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/velocity/velocity.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("velocity", function() {
          function parseWords(str) {
            var obj = {}, words = str.split(" ");
            for (var i3 = 0; i3 < words.length; ++i3)
              obj[words[i3]] = true;
            return obj;
          }
          var keywords2 = parseWords("#end #else #break #stop #[[ #]] #{end} #{else} #{break} #{stop}");
          var functions = parseWords("#if #elseif #foreach #set #include #parse #macro #define #evaluate #{if} #{elseif} #{foreach} #{set} #{include} #{parse} #{macro} #{define} #{evaluate}");
          var specials = parseWords("$foreach.count $foreach.hasNext $foreach.first $foreach.last $foreach.topmost $foreach.parent.count $foreach.parent.hasNext $foreach.parent.first $foreach.parent.last $foreach.parent $velocityCount $!bodyContent $bodyContent");
          var isOperatorChar = /[+\-*&%=<>!?:\/|]/;
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function tokenBase(stream, state) {
            var beforeParams = state.beforeParams;
            state.beforeParams = false;
            var ch = stream.next();
            if (ch == "'" && !state.inString && state.inParams) {
              state.lastTokenWasBuiltin = false;
              return chain2(stream, state, tokenString(ch));
            } else if (ch == '"') {
              state.lastTokenWasBuiltin = false;
              if (state.inString) {
                state.inString = false;
                return "string";
              } else if (state.inParams)
                return chain2(stream, state, tokenString(ch));
            } else if (/[\[\]{}\(\),;\.]/.test(ch)) {
              if (ch == "(" && beforeParams)
                state.inParams = true;
              else if (ch == ")") {
                state.inParams = false;
                state.lastTokenWasBuiltin = true;
              }
              return null;
            } else if (/\d/.test(ch)) {
              state.lastTokenWasBuiltin = false;
              stream.eatWhile(/[\w\.]/);
              return "number";
            } else if (ch == "#" && stream.eat("*")) {
              state.lastTokenWasBuiltin = false;
              return chain2(stream, state, tokenComment);
            } else if (ch == "#" && stream.match(/ *\[ *\[/)) {
              state.lastTokenWasBuiltin = false;
              return chain2(stream, state, tokenUnparsed);
            } else if (ch == "#" && stream.eat("#")) {
              state.lastTokenWasBuiltin = false;
              stream.skipToEnd();
              return "comment";
            } else if (ch == "$") {
              stream.eatWhile(/[\w\d\$_\.{}-]/);
              if (specials && specials.propertyIsEnumerable(stream.current())) {
                return "keyword";
              } else {
                state.lastTokenWasBuiltin = true;
                state.beforeParams = true;
                return "builtin";
              }
            } else if (isOperatorChar.test(ch)) {
              state.lastTokenWasBuiltin = false;
              stream.eatWhile(isOperatorChar);
              return "operator";
            } else {
              stream.eatWhile(/[\w\$_{}@]/);
              var word = stream.current();
              if (keywords2 && keywords2.propertyIsEnumerable(word))
                return "keyword";
              if (functions && functions.propertyIsEnumerable(word) || stream.current().match(/^#@?[a-z0-9_]+ *$/i) && stream.peek() == "(" && !(functions && functions.propertyIsEnumerable(word.toLowerCase()))) {
                state.beforeParams = true;
                state.lastTokenWasBuiltin = false;
                return "keyword";
              }
              if (state.inString) {
                state.lastTokenWasBuiltin = false;
                return "string";
              }
              if (stream.pos > word.length && stream.string.charAt(stream.pos - word.length - 1) == "." && state.lastTokenWasBuiltin)
                return "builtin";
              state.lastTokenWasBuiltin = false;
              return null;
            }
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                if (quote == '"' && stream.peek() == "$" && !escaped) {
                  state.inString = true;
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end)
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "#" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function tokenUnparsed(stream, state) {
            var maybeEnd = 0, ch;
            while (ch = stream.next()) {
              if (ch == "#" && maybeEnd == 2) {
                state.tokenize = tokenBase;
                break;
              }
              if (ch == "]")
                maybeEnd++;
              else if (ch != " ")
                maybeEnd = 0;
            }
            return "meta";
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                beforeParams: false,
                inParams: false,
                inString: false,
                lastTokenWasBuiltin: false
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return state.tokenize(stream, state);
            },
            blockCommentStart: "#*",
            blockCommentEnd: "*#",
            lineComment: "##",
            fold: "velocity"
          };
        });
        CodeMirror5.defineMIME("text/velocity", "velocity");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/verilog/verilog.js
  var require_verilog = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/verilog/verilog.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("verilog", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit, statementIndentUnit = parserConfig.statementIndentUnit || indentUnit, dontAlignCalls = parserConfig.dontAlignCalls, noIndentKeywords = parserConfig.noIndentKeywords || [], multiLineStrings = parserConfig.multiLineStrings, hooks = parserConfig.hooks || {};
          function words(str) {
            var obj = {}, words2 = str.split(" ");
            for (var i4 = 0; i4 < words2.length; ++i4)
              obj[words2[i4]] = true;
            return obj;
          }
          var keywords2 = words("accept_on alias always always_comb always_ff always_latch and assert assign assume automatic before begin bind bins binsof bit break buf bufif0 bufif1 byte case casex casez cell chandle checker class clocking cmos config const constraint context continue cover covergroup coverpoint cross deassign default defparam design disable dist do edge else end endcase endchecker endclass endclocking endconfig endfunction endgenerate endgroup endinterface endmodule endpackage endprimitive endprogram endproperty endspecify endsequence endtable endtask enum event eventually expect export extends extern final first_match for force foreach forever fork forkjoin function generate genvar global highz0 highz1 if iff ifnone ignore_bins illegal_bins implements implies import incdir include initial inout input inside instance int integer interconnect interface intersect join join_any join_none large let liblist library local localparam logic longint macromodule matches medium modport module nand negedge nettype new nexttime nmos nor noshowcancelled not notif0 notif1 null or output package packed parameter pmos posedge primitive priority program property protected pull0 pull1 pulldown pullup pulsestyle_ondetect pulsestyle_onevent pure rand randc randcase randsequence rcmos real realtime ref reg reject_on release repeat restrict return rnmos rpmos rtran rtranif0 rtranif1 s_always s_eventually s_nexttime s_until s_until_with scalared sequence shortint shortreal showcancelled signed small soft solve specify specparam static string strong strong0 strong1 struct super supply0 supply1 sync_accept_on sync_reject_on table tagged task this throughout time timeprecision timeunit tran tranif0 tranif1 tri tri0 tri1 triand trior trireg type typedef union unique unique0 unsigned until until_with untyped use uwire var vectored virtual void wait wait_order wand weak weak0 weak1 while wildcard wire with within wor xnor xor");
          var isOperatorChar = /[\+\-\*\/!~&|^%=?:]/;
          var isBracketChar = /[\[\]{}()]/;
          var unsignedNumber = /\d[0-9_]*/;
          var decimalLiteral = /\d*\s*'s?d\s*\d[0-9_]*/i;
          var binaryLiteral = /\d*\s*'s?b\s*[xz01][xz01_]*/i;
          var octLiteral = /\d*\s*'s?o\s*[xz0-7][xz0-7_]*/i;
          var hexLiteral = /\d*\s*'s?h\s*[0-9a-fxz?][0-9a-fxz?_]*/i;
          var realLiteral = /(\d[\d_]*(\.\d[\d_]*)?E-?[\d_]+)|(\d[\d_]*\.\d[\d_]*)/i;
          var closingBracketOrWord = /^((\w+)|[)}\]])/;
          var closingBracket = /[)}\]]/;
          var curPunc;
          var curKeyword;
          var blockKeywords = words("case checker class clocking config function generate interface module package primitive program property specify sequence table task");
          var openClose = {};
          for (var keyword in blockKeywords) {
            openClose[keyword] = "end" + keyword;
          }
          openClose["begin"] = "end";
          openClose["casex"] = "endcase";
          openClose["casez"] = "endcase";
          openClose["do"] = "while";
          openClose["fork"] = "join;join_any;join_none";
          openClose["covergroup"] = "endgroup";
          for (var i3 in noIndentKeywords) {
            var keyword = noIndentKeywords[i3];
            if (openClose[keyword]) {
              openClose[keyword] = void 0;
            }
          }
          var statementKeywords = words("always always_comb always_ff always_latch assert assign assume else export for foreach forever if import initial repeat while");
          function tokenBase(stream, state) {
            var ch = stream.peek(), style;
            if (hooks[ch] && (style = hooks[ch](stream, state)) != false)
              return style;
            if (hooks.tokenBase && (style = hooks.tokenBase(stream, state)) != false)
              return style;
            if (/[,;:\.]/.test(ch)) {
              curPunc = stream.next();
              return null;
            }
            if (isBracketChar.test(ch)) {
              curPunc = stream.next();
              return "bracket";
            }
            if (ch == "`") {
              stream.next();
              if (stream.eatWhile(/[\w\$_]/)) {
                return "def";
              } else {
                return null;
              }
            }
            if (ch == "$") {
              stream.next();
              if (stream.eatWhile(/[\w\$_]/)) {
                return "meta";
              } else {
                return null;
              }
            }
            if (ch == "#") {
              stream.next();
              stream.eatWhile(/[\d_.]/);
              return "def";
            }
            if (ch == '"') {
              stream.next();
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (ch == "/") {
              stream.next();
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return tokenComment(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
              stream.backUp(1);
            }
            if (stream.match(realLiteral) || stream.match(decimalLiteral) || stream.match(binaryLiteral) || stream.match(octLiteral) || stream.match(hexLiteral) || stream.match(unsignedNumber) || stream.match(realLiteral)) {
              return "number";
            }
            if (stream.eatWhile(isOperatorChar)) {
              return "meta";
            }
            if (stream.eatWhile(/[\w\$_]/)) {
              var cur = stream.current();
              if (keywords2[cur]) {
                if (openClose[cur]) {
                  curPunc = "newblock";
                }
                if (statementKeywords[cur]) {
                  curPunc = "newstatement";
                }
                curKeyword = cur;
                return "keyword";
              }
              return "variable";
            }
            stream.next();
            return null;
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "\\";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, ch;
            while (ch = stream.next()) {
              if (ch == "/" && maybeEnd) {
                state.tokenize = tokenBase;
                break;
              }
              maybeEnd = ch == "*";
            }
            return "comment";
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            var indent = state.indented;
            var c3 = new Context(indent, col, type, null, state.context);
            return state.context = c3;
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}") {
              state.indented = state.context.indented;
            }
            return state.context = state.context.prev;
          }
          function isClosing(text, contextClosing) {
            if (text == contextClosing) {
              return true;
            } else {
              var closingKeywords = contextClosing.split(";");
              for (var i4 in closingKeywords) {
                if (text == closingKeywords[i4]) {
                  return true;
                }
              }
              return false;
            }
          }
          function buildElectricInputRegEx() {
            var allClosings = [];
            for (var i4 in openClose) {
              if (openClose[i4]) {
                var closings = openClose[i4].split(";");
                for (var j3 in closings) {
                  allClosings.push(closings[j3]);
                }
              }
            }
            var re = new RegExp("[{}()\\[\\]]|(" + allClosings.join("|") + ")$");
            return re;
          }
          return {
            electricInput: buildElectricInputRegEx(),
            startState: function(basecolumn) {
              var state = {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
              if (hooks.startState)
                hooks.startState(state);
              return state;
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (hooks.token) {
                var style = hooks.token(stream, state);
                if (style !== void 0) {
                  return style;
                }
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              curKeyword = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment" || style == "meta" || style == "variable")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if (curPunc == ctx.type) {
                popContext(state);
              } else if (curPunc == ";" && ctx.type == "statement" || ctx.type && isClosing(curKeyword, ctx.type)) {
                ctx = popContext(state);
                while (ctx && ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == "{") {
                pushContext(state, stream.column(), "}");
              } else if (curPunc == "[") {
                pushContext(state, stream.column(), "]");
              } else if (curPunc == "(") {
                pushContext(state, stream.column(), ")");
              } else if (ctx && ctx.type == "endcase" && curPunc == ":") {
                pushContext(state, stream.column(), "statement");
              } else if (curPunc == "newstatement") {
                pushContext(state, stream.column(), "statement");
              } else if (curPunc == "newblock") {
                if (curKeyword == "function" && ctx && (ctx.type == "statement" || ctx.type == "endgroup")) {
                } else if (curKeyword == "task" && ctx && ctx.type == "statement") {
                } else {
                  var close = openClose[curKeyword];
                  pushContext(state, stream.column(), close);
                }
              }
              state.startOfLine = false;
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase && state.tokenize != null)
                return CodeMirror5.Pass;
              if (hooks.indent) {
                var fromHook = hooks.indent(state);
                if (fromHook >= 0)
                  return fromHook;
              }
              var ctx = state.context, firstChar = textAfter && textAfter.charAt(0);
              if (ctx.type == "statement" && firstChar == "}")
                ctx = ctx.prev;
              var closing = false;
              var possibleClosing = textAfter.match(closingBracketOrWord);
              if (possibleClosing)
                closing = isClosing(possibleClosing[0], ctx.type);
              if (ctx.type == "statement")
                return ctx.indented + (firstChar == "{" ? 0 : statementIndentUnit);
              else if (closingBracket.test(ctx.type) && ctx.align && !dontAlignCalls)
                return ctx.column + (closing ? 0 : 1);
              else if (ctx.type == ")" && !closing)
                return ctx.indented + statementIndentUnit;
              else
                return ctx.indented + (closing ? 0 : indentUnit);
            },
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//",
            fold: "indent"
          };
        });
        CodeMirror5.defineMIME("text/x-verilog", {
          name: "verilog"
        });
        CodeMirror5.defineMIME("text/x-systemverilog", {
          name: "verilog"
        });
        var tlvIdentifierStyle = {
          "|": "link",
          ">": "property",
          "$": "variable",
          "$$": "variable",
          "?$": "qualifier",
          "?*": "qualifier",
          "-": "hr",
          "/": "property",
          "/-": "property",
          "@": "variable-3",
          "@-": "variable-3",
          "@++": "variable-3",
          "@+=": "variable-3",
          "@+=-": "variable-3",
          "@--": "variable-3",
          "@-=": "variable-3",
          "%+": "tag",
          "%-": "tag",
          "%": "tag",
          ">>": "tag",
          "<<": "tag",
          "<>": "tag",
          "#": "tag",
          "^": "attribute",
          "^^": "attribute",
          "^!": "attribute",
          "*": "variable-2",
          "**": "variable-2",
          "\\": "keyword",
          '"': "comment"
        };
        var tlvScopePrefixChars = {
          "/": "beh-hier",
          ">": "beh-hier",
          "-": "phys-hier",
          "|": "pipe",
          "?": "when",
          "@": "stage",
          "\\": "keyword"
        };
        var tlvIndentUnit = 3;
        var tlvTrackStatements = false;
        var tlvIdentMatch = /^([~!@#\$%\^&\*-\+=\?\/\\\|'"<>]+)([\d\w_]*)/;
        var tlvFirstLevelIndentMatch = /^[! ]  /;
        var tlvLineIndentationMatch = /^[! ] */;
        var tlvCommentMatch = /^\/[\/\*]/;
        function tlvScopeStyle(state, indentation, type) {
          var depth = indentation / tlvIndentUnit;
          return "tlv-" + state.tlvIndentationStyle[depth] + "-" + type;
        }
        function tlvIdentNext(stream) {
          var match;
          return (match = stream.match(tlvIdentMatch, false)) && match[2].length > 0;
        }
        CodeMirror5.defineMIME("text/x-tlv", {
          name: "verilog",
          hooks: {
            electricInput: false,
            token: function(stream, state) {
              var style = void 0;
              var match;
              if (stream.sol() && !state.tlvInBlockComment) {
                if (stream.peek() == "\\") {
                  style = "def";
                  stream.skipToEnd();
                  if (stream.string.match(/\\SV/)) {
                    state.tlvCodeActive = false;
                  } else if (stream.string.match(/\\TLV/)) {
                    state.tlvCodeActive = true;
                  }
                }
                if (state.tlvCodeActive && stream.pos == 0 && state.indented == 0 && (match = stream.match(tlvLineIndentationMatch, false))) {
                  state.indented = match[0].length;
                }
                var indented = state.indented;
                var depth = indented / tlvIndentUnit;
                if (depth <= state.tlvIndentationStyle.length) {
                  var blankline = stream.string.length == indented;
                  var chPos = depth * tlvIndentUnit;
                  if (chPos < stream.string.length) {
                    var bodyString = stream.string.slice(chPos);
                    var ch = bodyString[0];
                    if (tlvScopePrefixChars[ch] && ((match = bodyString.match(tlvIdentMatch)) && tlvIdentifierStyle[match[1]])) {
                      indented += tlvIndentUnit;
                      if (!(ch == "\\" && chPos > 0)) {
                        state.tlvIndentationStyle[depth] = tlvScopePrefixChars[ch];
                        if (tlvTrackStatements) {
                          state.statementComment = false;
                        }
                        depth++;
                      }
                    }
                  }
                  if (!blankline) {
                    while (state.tlvIndentationStyle.length > depth) {
                      state.tlvIndentationStyle.pop();
                    }
                  }
                }
                state.tlvNextIndent = indented;
              }
              if (state.tlvCodeActive) {
                var beginStatement = false;
                if (tlvTrackStatements) {
                  beginStatement = stream.peek() != " " && style === void 0 && !state.tlvInBlockComment && stream.column() == state.tlvIndentationStyle.length * tlvIndentUnit;
                  if (beginStatement) {
                    if (state.statementComment) {
                      beginStatement = false;
                    }
                    state.statementComment = stream.match(tlvCommentMatch, false);
                  }
                }
                var match;
                if (style !== void 0) {
                  style += " " + tlvScopeStyle(state, 0, "scope-ident");
                } else if (stream.pos / tlvIndentUnit < state.tlvIndentationStyle.length && (match = stream.match(stream.sol() ? tlvFirstLevelIndentMatch : /^   /))) {
                  style = "tlv-indent-" + (stream.pos % 2 == 0 ? "even" : "odd") + " " + tlvScopeStyle(state, stream.pos - tlvIndentUnit, "indent");
                  if (match[0].charAt(0) == "!") {
                    style += " tlv-alert-line-prefix";
                  }
                  if (tlvIdentNext(stream)) {
                    style += " " + tlvScopeStyle(state, stream.pos, "before-scope-ident");
                  }
                } else if (state.tlvInBlockComment) {
                  if (stream.match(/^.*?\*\//)) {
                    state.tlvInBlockComment = false;
                    if (tlvTrackStatements && !stream.eol()) {
                      state.statementComment = false;
                    }
                  } else {
                    stream.skipToEnd();
                  }
                  style = "comment";
                } else if ((match = stream.match(tlvCommentMatch)) && !state.tlvInBlockComment) {
                  if (match[0] == "//") {
                    stream.skipToEnd();
                  } else {
                    state.tlvInBlockComment = true;
                  }
                  style = "comment";
                } else if (match = stream.match(tlvIdentMatch)) {
                  var prefix = match[1];
                  var mnemonic = match[2];
                  if (tlvIdentifierStyle.hasOwnProperty(prefix) && (mnemonic.length > 0 || stream.eol())) {
                    style = tlvIdentifierStyle[prefix];
                    if (stream.column() == state.indented) {
                      style += " " + tlvScopeStyle(state, stream.column(), "scope-ident");
                    }
                  } else {
                    stream.backUp(stream.current().length - 1);
                    style = "tlv-default";
                  }
                } else if (stream.match(/^\t+/)) {
                  style = "tlv-tab";
                } else if (stream.match(/^[\[\]{}\(\);\:]+/)) {
                  style = "meta";
                } else if (match = stream.match(/^[mM]4([\+_])?[\w\d_]*/)) {
                  style = match[1] == "+" ? "tlv-m4-plus" : "tlv-m4";
                } else if (stream.match(/^ +/)) {
                  if (stream.eol()) {
                    style = "error";
                  } else {
                    style = "tlv-default";
                  }
                } else if (stream.match(/^[\w\d_]+/)) {
                  style = "number";
                } else {
                  stream.next();
                  style = "tlv-default";
                }
                if (beginStatement) {
                  style += " tlv-statement";
                }
              } else {
                if (stream.match(/^[mM]4([\w\d_]*)/)) {
                  style = "tlv-m4";
                }
              }
              return style;
            },
            indent: function(state) {
              return state.tlvCodeActive == true ? state.tlvNextIndent : -1;
            },
            startState: function(state) {
              state.tlvIndentationStyle = [];
              state.tlvCodeActive = true;
              state.tlvNextIndent = -1;
              state.tlvInBlockComment = false;
              if (tlvTrackStatements) {
                state.statementComment = false;
              }
            }
          }
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/vhdl/vhdl.js
  var require_vhdl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/vhdl/vhdl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function words(str) {
          var obj = {}, words2 = str.split(",");
          for (var i3 = 0; i3 < words2.length; ++i3) {
            var allCaps = words2[i3].toUpperCase();
            var firstCap = words2[i3].charAt(0).toUpperCase() + words2[i3].slice(1);
            obj[words2[i3]] = true;
            obj[allCaps] = true;
            obj[firstCap] = true;
          }
          return obj;
        }
        function metaHook(stream) {
          stream.eatWhile(/[\w\$_]/);
          return "meta";
        }
        CodeMirror5.defineMode("vhdl", function(config3, parserConfig) {
          var indentUnit = config3.indentUnit, atoms = parserConfig.atoms || words("null"), hooks = parserConfig.hooks || { "`": metaHook, "$": metaHook }, multiLineStrings = parserConfig.multiLineStrings;
          var keywords2 = words("abs,access,after,alias,all,and,architecture,array,assert,attribute,begin,block,body,buffer,bus,case,component,configuration,constant,disconnect,downto,else,elsif,end,end block,end case,end component,end for,end generate,end if,end loop,end process,end record,end units,entity,exit,file,for,function,generate,generic,generic map,group,guarded,if,impure,in,inertial,inout,is,label,library,linkage,literal,loop,map,mod,nand,new,next,nor,null,of,on,open,or,others,out,package,package body,port,port map,postponed,procedure,process,pure,range,record,register,reject,rem,report,return,rol,ror,select,severity,signal,sla,sll,sra,srl,subtype,then,to,transport,type,unaffected,units,until,use,variable,wait,when,while,with,xnor,xor");
          var blockKeywords = words("architecture,entity,begin,case,port,else,elsif,end,for,function,if");
          var isOperatorChar = /[&|~><!\)\(*#%@+\/=?\:;}{,\.\^\-\[\]]/;
          var curPunc;
          function tokenBase(stream, state) {
            var ch = stream.next();
            if (hooks[ch]) {
              var result = hooks[ch](stream, state);
              if (result !== false)
                return result;
            }
            if (ch == '"') {
              state.tokenize = tokenString2(ch);
              return state.tokenize(stream, state);
            }
            if (ch == "'") {
              state.tokenize = tokenString(ch);
              return state.tokenize(stream, state);
            }
            if (/[\[\]{}\(\),;\:\.]/.test(ch)) {
              curPunc = ch;
              return null;
            }
            if (/[\d']/.test(ch)) {
              stream.eatWhile(/[\w\.']/);
              return "number";
            }
            if (ch == "-") {
              if (stream.eat("-")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            if (isOperatorChar.test(ch)) {
              stream.eatWhile(isOperatorChar);
              return "operator";
            }
            stream.eatWhile(/[\w\$_]/);
            var cur = stream.current();
            if (keywords2.propertyIsEnumerable(cur.toLowerCase())) {
              if (blockKeywords.propertyIsEnumerable(cur))
                curPunc = "newstatement";
              return "keyword";
            }
            if (atoms.propertyIsEnumerable(cur))
              return "atom";
            return "variable";
          }
          function tokenString(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "--";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = tokenBase;
              return "string";
            };
          }
          function tokenString2(quote) {
            return function(stream, state) {
              var escaped = false, next, end = false;
              while ((next = stream.next()) != null) {
                if (next == quote && !escaped) {
                  end = true;
                  break;
                }
                escaped = !escaped && next == "--";
              }
              if (end || !(escaped || multiLineStrings))
                state.tokenize = tokenBase;
              return "string-2";
            };
          }
          function Context(indented, column, type, align, prev) {
            this.indented = indented;
            this.column = column;
            this.type = type;
            this.align = align;
            this.prev = prev;
          }
          function pushContext(state, col, type) {
            return state.context = new Context(state.indented, col, type, null, state.context);
          }
          function popContext(state) {
            var t3 = state.context.type;
            if (t3 == ")" || t3 == "]" || t3 == "}")
              state.indented = state.context.indented;
            return state.context = state.context.prev;
          }
          return {
            startState: function(basecolumn) {
              return {
                tokenize: null,
                context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
                indented: 0,
                startOfLine: true
              };
            },
            token: function(stream, state) {
              var ctx = state.context;
              if (stream.sol()) {
                if (ctx.align == null)
                  ctx.align = false;
                state.indented = stream.indentation();
                state.startOfLine = true;
              }
              if (stream.eatSpace())
                return null;
              curPunc = null;
              var style = (state.tokenize || tokenBase)(stream, state);
              if (style == "comment" || style == "meta")
                return style;
              if (ctx.align == null)
                ctx.align = true;
              if ((curPunc == ";" || curPunc == ":") && ctx.type == "statement")
                popContext(state);
              else if (curPunc == "{")
                pushContext(state, stream.column(), "}");
              else if (curPunc == "[")
                pushContext(state, stream.column(), "]");
              else if (curPunc == "(")
                pushContext(state, stream.column(), ")");
              else if (curPunc == "}") {
                while (ctx.type == "statement")
                  ctx = popContext(state);
                if (ctx.type == "}")
                  ctx = popContext(state);
                while (ctx.type == "statement")
                  ctx = popContext(state);
              } else if (curPunc == ctx.type)
                popContext(state);
              else if (ctx.type == "}" || ctx.type == "top" || ctx.type == "statement" && curPunc == "newstatement")
                pushContext(state, stream.column(), "statement");
              state.startOfLine = false;
              return style;
            },
            indent: function(state, textAfter) {
              if (state.tokenize != tokenBase && state.tokenize != null)
                return 0;
              var firstChar = textAfter && textAfter.charAt(0), ctx = state.context, closing = firstChar == ctx.type;
              if (ctx.type == "statement")
                return ctx.indented + (firstChar == "{" ? 0 : indentUnit);
              else if (ctx.align)
                return ctx.column + (closing ? 0 : 1);
              else
                return ctx.indented + (closing ? 0 : indentUnit);
            },
            electricChars: "{}"
          };
        });
        CodeMirror5.defineMIME("text/x-vhdl", "vhdl");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/vue/vue.js
  var require_vue = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/vue/vue.js"(exports, module) {
      (function(mod2) {
        "use strict";
        if (typeof exports === "object" && typeof module === "object") {
          mod2(require_codemirror(), require_overlay(), require_xml(), require_javascript(), require_coffeescript(), require_css(), require_sass(), require_stylus(), require_pug(), require_handlebars());
        } else if (typeof define === "function" && define.amd) {
          define([
            "../../lib/codemirror",
            "../../addon/mode/overlay",
            "../xml/xml",
            "../javascript/javascript",
            "../coffeescript/coffeescript",
            "../css/css",
            "../sass/sass",
            "../stylus/stylus",
            "../pug/pug",
            "../handlebars/handlebars"
          ], mod2);
        } else {
          mod2(CodeMirror);
        }
      })(function(CodeMirror5) {
        var tagLanguages = {
          script: [
            ["lang", /coffee(script)?/, "coffeescript"],
            ["type", /^(?:text|application)\/(?:x-)?coffee(?:script)?$/, "coffeescript"],
            ["lang", /^babel$/, "javascript"],
            ["type", /^text\/babel$/, "javascript"],
            ["type", /^text\/ecmascript-\d+$/, "javascript"]
          ],
          style: [
            ["lang", /^stylus$/i, "stylus"],
            ["lang", /^sass$/i, "sass"],
            ["lang", /^less$/i, "text/x-less"],
            ["lang", /^scss$/i, "text/x-scss"],
            ["type", /^(text\/)?(x-)?styl(us)?$/i, "stylus"],
            ["type", /^text\/sass/i, "sass"],
            ["type", /^(text\/)?(x-)?scss$/i, "text/x-scss"],
            ["type", /^(text\/)?(x-)?less$/i, "text/x-less"]
          ],
          template: [
            ["lang", /^vue-template$/i, "vue"],
            ["lang", /^pug$/i, "pug"],
            ["lang", /^handlebars$/i, "handlebars"],
            ["type", /^(text\/)?(x-)?pug$/i, "pug"],
            ["type", /^text\/x-handlebars-template$/i, "handlebars"],
            [null, null, "vue-template"]
          ]
        };
        CodeMirror5.defineMode("vue-template", function(config3, parserConfig) {
          var mustacheOverlay = {
            token: function(stream) {
              if (stream.match(/^\{\{.*?\}\}/))
                return "meta mustache";
              while (stream.next() && !stream.match("{{", false)) {
              }
              return null;
            }
          };
          return CodeMirror5.overlayMode(CodeMirror5.getMode(config3, parserConfig.backdrop || "text/html"), mustacheOverlay);
        });
        CodeMirror5.defineMode("vue", function(config3) {
          return CodeMirror5.getMode(config3, { name: "htmlmixed", tags: tagLanguages });
        }, "htmlmixed", "xml", "javascript", "coffeescript", "css", "sass", "stylus", "pug", "handlebars");
        CodeMirror5.defineMIME("script/x-vue", "vue");
        CodeMirror5.defineMIME("text/x-vue", "vue");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/wast/wast.js
  var require_wast = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/wast/wast.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_simple());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "../../addon/mode/simple"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineSimpleMode("wast", {
          start: [
            { regex: /[+\-]?(?:nan(?::0x[0-9a-fA-F]+)?|infinity|inf|0x[0-9a-fA-F]+\.?[0-9a-fA-F]*p[+\/-]?\d+|\d+(?:\.\d*)?[eE][+\-]?\d*|\d+\.\d*|0x[0-9a-fA-F]+|\d+)/, token: "number" },
            { regex: /anyfunc|mut|nop|block|if|then|else|loop|br|br_if|br_table|call|call_indirect|drop|end|return|local\.get|local\.set|tee_local|global\.get|global\.set|i32\.load|i64\.load|f32\.load|f64\.load|i32\.store|i64\.store|f32\.store|f64\.store|i32\.load8_s|i64\.load8_s|i32\.load8_u|i64\.load8_u|i32\.load16_s|i64\.load16_s|i32\.load16_u|i64\.load16_u|i64\.load32_s|i64\.load32_u|i32\.store8|i64\.store8|i32\.store16|i64\.store16|i32\.const|i64\.const|f32\.const|f64\.const|i32\.eqz|i64\.eqz|i32\.clz|i64\.clz|i32\.ctz|i64\.ctz|i32\.popcnt|i64\.popcnt|f32\.neg|f64\.neg|f32\.abs|f64\.abs|f32\.sqrt|f64\.sqrt|f32\.ceil|f64\.ceil|f32\.floor|f64\.floor|f32\.trunc|f64\.trunc|f32\.nearest|f64\.nearest|i32\.add|i64\.add|i32\.sub|i64\.sub|i32\.mul|i64\.mul|i32\.div_s|i64\.div_s|i32\.div_u|i64\.div_u|i32\.rem_s|i64\.rem_s|i32\.rem_u|i64\.rem_u|i32\.and|i64\.and|i32\.or|i64\.or|i32\.xor|i64\.xor|i32\.shl|i64\.shl|i32\.shr_s|i64\.shr_s|i32\.shr_u|i64\.shr_u|i32\.rotl|i64\.rotl|i32\.rotr|i64\.rotr|f32\.add|f64\.add|f32\.sub|f64\.sub|f32\.mul|f64\.mul|f32\.div|f64\.div|f32\.min|f64\.min|f32\.max|f64\.max|f32\.copysign|f64\.copysign|i32\.eq|i64\.eq|i32\.ne|i64\.ne|i32\.lt_s|i64\.lt_s|i32\.lt_u|i64\.lt_u|i32\.le_s|i64\.le_s|i32\.le_u|i64\.le_u|i32\.gt_s|i64\.gt_s|i32\.gt_u|i64\.gt_u|i32\.ge_s|i64\.ge_s|i32\.ge_u|i64\.ge_u|f32\.eq|f64\.eq|f32\.ne|f64\.ne|f32\.lt|f64\.lt|f32\.le|f64\.le|f32\.gt|f64\.gt|f32\.ge|f64\.ge|i64\.extend_s\/i32|i64\.extend_u\/i32|i32\.wrap\/i64|i32\.trunc_s\/f32|i64\.trunc_s\/f32|i32\.trunc_s\/f64|i64\.trunc_s\/f64|i32\.trunc_u\/f32|i64\.trunc_u\/f32|i32\.trunc_u\/f64|i64\.trunc_u\/f64|f32\.convert_s\/i32|f64\.convert_s\/i32|f32\.convert_s\/i64|f64\.convert_s\/i64|f32\.convert_u\/i32|f64\.convert_u\/i32|f32\.convert_u\/i64|f64\.convert_u\/i64|f64\.promote\/f32|f32\.demote\/f64|f32\.reinterpret\/i32|i32\.reinterpret\/f32|f64\.reinterpret\/i64|i64\.reinterpret\/f64|select|unreachable|current_memory|memory.size|grow_memory|memory.grow|type|func|param|result|local|global|module|table|memory|start|elem|data|offset|import|export/, token: "keyword" },
            { regex: /\b(i32|i64|f32|f64)\b/, token: "atom" },
            { regex: /\$([a-zA-Z0-9_`\+\-\*\/\\\^~=<>!\?@#$%&|:\.]+)/, token: "variable-2" },
            { regex: /"(?:[^"\\\x00-\x1f\x7f]|\\[nt\\'"]|\\[0-9a-fA-F][0-9a-fA-F])*"/, token: "string" },
            { regex: /\(;.*?/, token: "comment", next: "comment" },
            { regex: /;;.*$/, token: "comment" },
            { regex: /\(/, indent: true },
            { regex: /\)/, dedent: true }
          ],
          comment: [
            { regex: /.*?;\)/, token: "comment", next: "start" },
            { regex: /.*/, token: "comment" }
          ],
          meta: {
            dontIndentStates: ["comment"]
          }
        });
        CodeMirror5.defineMIME("text/webassembly", "wast");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/webidl/webidl.js
  var require_webidl = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/webidl/webidl.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function wordRegexp(words) {
          return new RegExp("^((" + words.join(")|(") + "))\\b");
        }
        ;
        var builtinArray = [
          "Clamp",
          "Constructor",
          "EnforceRange",
          "Exposed",
          "ImplicitThis",
          "Global",
          "PrimaryGlobal",
          "LegacyArrayClass",
          "LegacyUnenumerableNamedProperties",
          "LenientThis",
          "NamedConstructor",
          "NewObject",
          "NoInterfaceObject",
          "OverrideBuiltins",
          "PutForwards",
          "Replaceable",
          "SameObject",
          "TreatNonObjectAsNull",
          "TreatNullAs",
          "EmptyString",
          "Unforgeable",
          "Unscopeable"
        ];
        var builtins = wordRegexp(builtinArray);
        var typeArray = [
          "unsigned",
          "short",
          "long",
          "unrestricted",
          "float",
          "double",
          "boolean",
          "byte",
          "octet",
          "Promise",
          "ArrayBuffer",
          "DataView",
          "Int8Array",
          "Int16Array",
          "Int32Array",
          "Uint8Array",
          "Uint16Array",
          "Uint32Array",
          "Uint8ClampedArray",
          "Float32Array",
          "Float64Array",
          "ByteString",
          "DOMString",
          "USVString",
          "sequence",
          "object",
          "RegExp",
          "Error",
          "DOMException",
          "FrozenArray",
          "any",
          "void"
        ];
        var types = wordRegexp(typeArray);
        var keywordArray = [
          "attribute",
          "callback",
          "const",
          "deleter",
          "dictionary",
          "enum",
          "getter",
          "implements",
          "inherit",
          "interface",
          "iterable",
          "legacycaller",
          "maplike",
          "partial",
          "required",
          "serializer",
          "setlike",
          "setter",
          "static",
          "stringifier",
          "typedef",
          "optional",
          "readonly",
          "or"
        ];
        var keywords2 = wordRegexp(keywordArray);
        var atomArray = [
          "true",
          "false",
          "Infinity",
          "NaN",
          "null"
        ];
        var atoms = wordRegexp(atomArray);
        CodeMirror5.registerHelper("hintWords", "webidl", builtinArray.concat(typeArray).concat(keywordArray).concat(atomArray));
        var startDefArray = ["callback", "dictionary", "enum", "interface"];
        var startDefs = wordRegexp(startDefArray);
        var endDefArray = ["typedef"];
        var endDefs = wordRegexp(endDefArray);
        var singleOperators = /^[:<=>?]/;
        var integers = /^-?([1-9][0-9]*|0[Xx][0-9A-Fa-f]+|0[0-7]*)/;
        var floats = /^-?(([0-9]+\.[0-9]*|[0-9]*\.[0-9]+)([Ee][+-]?[0-9]+)?|[0-9]+[Ee][+-]?[0-9]+)/;
        var identifiers = /^_?[A-Za-z][0-9A-Z_a-z-]*/;
        var identifiersEnd = /^_?[A-Za-z][0-9A-Z_a-z-]*(?=\s*;)/;
        var strings = /^"[^"]*"/;
        var multilineComments = /^\/\*.*?\*\//;
        var multilineCommentsStart = /^\/\*.*/;
        var multilineCommentsEnd = /^.*?\*\//;
        function readToken(stream, state) {
          if (stream.eatSpace())
            return null;
          if (state.inComment) {
            if (stream.match(multilineCommentsEnd)) {
              state.inComment = false;
              return "comment";
            }
            stream.skipToEnd();
            return "comment";
          }
          if (stream.match("//")) {
            stream.skipToEnd();
            return "comment";
          }
          if (stream.match(multilineComments))
            return "comment";
          if (stream.match(multilineCommentsStart)) {
            state.inComment = true;
            return "comment";
          }
          if (stream.match(/^-?[0-9\.]/, false)) {
            if (stream.match(integers) || stream.match(floats))
              return "number";
          }
          if (stream.match(strings))
            return "string";
          if (state.startDef && stream.match(identifiers))
            return "def";
          if (state.endDef && stream.match(identifiersEnd)) {
            state.endDef = false;
            return "def";
          }
          if (stream.match(keywords2))
            return "keyword";
          if (stream.match(types)) {
            var lastToken = state.lastToken;
            var nextToken = (stream.match(/^\s*(.+?)\b/, false) || [])[1];
            if (lastToken === ":" || lastToken === "implements" || nextToken === "implements" || nextToken === "=") {
              return "builtin";
            } else {
              return "variable-3";
            }
          }
          if (stream.match(builtins))
            return "builtin";
          if (stream.match(atoms))
            return "atom";
          if (stream.match(identifiers))
            return "variable";
          if (stream.match(singleOperators))
            return "operator";
          stream.next();
          return null;
        }
        ;
        CodeMirror5.defineMode("webidl", function() {
          return {
            startState: function() {
              return {
                inComment: false,
                lastToken: "",
                startDef: false,
                endDef: false
              };
            },
            token: function(stream, state) {
              var style = readToken(stream, state);
              if (style) {
                var cur = stream.current();
                state.lastToken = cur;
                if (style === "keyword") {
                  state.startDef = startDefs.test(cur);
                  state.endDef = state.endDef || endDefs.test(cur);
                } else {
                  state.startDef = false;
                }
              }
              return style;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-webidl", "webidl");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/xquery/xquery.js
  var require_xquery = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/xquery/xquery.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("xquery", function() {
          var keywords2 = function() {
            function kw(type) {
              return { type, style: "keyword" };
            }
            var operator = kw("operator"), atom = { type: "atom", style: "atom" }, punctuation = { type: "punctuation", style: null }, qualifier = { type: "axis_specifier", style: "qualifier" };
            var kwObj = {
              ",": punctuation
            };
            var basic = [
              "after",
              "all",
              "allowing",
              "ancestor",
              "ancestor-or-self",
              "any",
              "array",
              "as",
              "ascending",
              "at",
              "attribute",
              "base-uri",
              "before",
              "boundary-space",
              "by",
              "case",
              "cast",
              "castable",
              "catch",
              "child",
              "collation",
              "comment",
              "construction",
              "contains",
              "content",
              "context",
              "copy",
              "copy-namespaces",
              "count",
              "decimal-format",
              "declare",
              "default",
              "delete",
              "descendant",
              "descendant-or-self",
              "descending",
              "diacritics",
              "different",
              "distance",
              "document",
              "document-node",
              "element",
              "else",
              "empty",
              "empty-sequence",
              "encoding",
              "end",
              "entire",
              "every",
              "exactly",
              "except",
              "external",
              "first",
              "following",
              "following-sibling",
              "for",
              "from",
              "ftand",
              "ftnot",
              "ft-option",
              "ftor",
              "function",
              "fuzzy",
              "greatest",
              "group",
              "if",
              "import",
              "in",
              "inherit",
              "insensitive",
              "insert",
              "instance",
              "intersect",
              "into",
              "invoke",
              "is",
              "item",
              "language",
              "last",
              "lax",
              "least",
              "let",
              "levels",
              "lowercase",
              "map",
              "modify",
              "module",
              "most",
              "namespace",
              "next",
              "no",
              "node",
              "nodes",
              "no-inherit",
              "no-preserve",
              "not",
              "occurs",
              "of",
              "only",
              "option",
              "order",
              "ordered",
              "ordering",
              "paragraph",
              "paragraphs",
              "parent",
              "phrase",
              "preceding",
              "preceding-sibling",
              "preserve",
              "previous",
              "processing-instruction",
              "relationship",
              "rename",
              "replace",
              "return",
              "revalidation",
              "same",
              "satisfies",
              "schema",
              "schema-attribute",
              "schema-element",
              "score",
              "self",
              "sensitive",
              "sentence",
              "sentences",
              "sequence",
              "skip",
              "sliding",
              "some",
              "stable",
              "start",
              "stemming",
              "stop",
              "strict",
              "strip",
              "switch",
              "text",
              "then",
              "thesaurus",
              "times",
              "to",
              "transform",
              "treat",
              "try",
              "tumbling",
              "type",
              "typeswitch",
              "union",
              "unordered",
              "update",
              "updating",
              "uppercase",
              "using",
              "validate",
              "value",
              "variable",
              "version",
              "weight",
              "when",
              "where",
              "wildcards",
              "window",
              "with",
              "without",
              "word",
              "words",
              "xquery"
            ];
            for (var i3 = 0, l3 = basic.length; i3 < l3; i3++) {
              kwObj[basic[i3]] = kw(basic[i3]);
            }
            ;
            var types = [
              "xs:anyAtomicType",
              "xs:anySimpleType",
              "xs:anyType",
              "xs:anyURI",
              "xs:base64Binary",
              "xs:boolean",
              "xs:byte",
              "xs:date",
              "xs:dateTime",
              "xs:dateTimeStamp",
              "xs:dayTimeDuration",
              "xs:decimal",
              "xs:double",
              "xs:duration",
              "xs:ENTITIES",
              "xs:ENTITY",
              "xs:float",
              "xs:gDay",
              "xs:gMonth",
              "xs:gMonthDay",
              "xs:gYear",
              "xs:gYearMonth",
              "xs:hexBinary",
              "xs:ID",
              "xs:IDREF",
              "xs:IDREFS",
              "xs:int",
              "xs:integer",
              "xs:item",
              "xs:java",
              "xs:language",
              "xs:long",
              "xs:Name",
              "xs:NCName",
              "xs:negativeInteger",
              "xs:NMTOKEN",
              "xs:NMTOKENS",
              "xs:nonNegativeInteger",
              "xs:nonPositiveInteger",
              "xs:normalizedString",
              "xs:NOTATION",
              "xs:numeric",
              "xs:positiveInteger",
              "xs:precisionDecimal",
              "xs:QName",
              "xs:short",
              "xs:string",
              "xs:time",
              "xs:token",
              "xs:unsignedByte",
              "xs:unsignedInt",
              "xs:unsignedLong",
              "xs:unsignedShort",
              "xs:untyped",
              "xs:untypedAtomic",
              "xs:yearMonthDuration"
            ];
            for (var i3 = 0, l3 = types.length; i3 < l3; i3++) {
              kwObj[types[i3]] = atom;
            }
            ;
            var operators = ["eq", "ne", "lt", "le", "gt", "ge", ":=", "=", ">", ">=", "<", "<=", ".", "|", "?", "and", "or", "div", "idiv", "mod", "*", "/", "+", "-"];
            for (var i3 = 0, l3 = operators.length; i3 < l3; i3++) {
              kwObj[operators[i3]] = operator;
            }
            ;
            var axis_specifiers = [
              "self::",
              "attribute::",
              "child::",
              "descendant::",
              "descendant-or-self::",
              "parent::",
              "ancestor::",
              "ancestor-or-self::",
              "following::",
              "preceding::",
              "following-sibling::",
              "preceding-sibling::"
            ];
            for (var i3 = 0, l3 = axis_specifiers.length; i3 < l3; i3++) {
              kwObj[axis_specifiers[i3]] = qualifier;
            }
            ;
            return kwObj;
          }();
          function chain2(stream, state, f3) {
            state.tokenize = f3;
            return f3(stream, state);
          }
          function tokenBase(stream, state) {
            var ch = stream.next(), mightBeFunction = false, isEQName = isEQNameAhead(stream);
            if (ch == "<") {
              if (stream.match("!--", true))
                return chain2(stream, state, tokenXMLComment);
              if (stream.match("![CDATA", false)) {
                state.tokenize = tokenCDATA;
                return "tag";
              }
              if (stream.match("?", false)) {
                return chain2(stream, state, tokenPreProcessing);
              }
              var isclose = stream.eat("/");
              stream.eatSpace();
              var tagName = "", c3;
              while (c3 = stream.eat(/[^\s\u00a0=<>\"\'\/?]/))
                tagName += c3;
              return chain2(stream, state, tokenTag(tagName, isclose));
            } else if (ch == "{") {
              pushStateStack(state, { type: "codeblock" });
              return null;
            } else if (ch == "}") {
              popStateStack(state);
              return null;
            } else if (isInXmlBlock(state)) {
              if (ch == ">")
                return "tag";
              else if (ch == "/" && stream.eat(">")) {
                popStateStack(state);
                return "tag";
              } else
                return "variable";
            } else if (/\d/.test(ch)) {
              stream.match(/^\d*(?:\.\d*)?(?:E[+\-]?\d+)?/);
              return "atom";
            } else if (ch === "(" && stream.eat(":")) {
              pushStateStack(state, { type: "comment" });
              return chain2(stream, state, tokenComment);
            } else if (!isEQName && (ch === '"' || ch === "'"))
              return chain2(stream, state, tokenString(ch));
            else if (ch === "$") {
              return chain2(stream, state, tokenVariable);
            } else if (ch === ":" && stream.eat("=")) {
              return "keyword";
            } else if (ch === "(") {
              pushStateStack(state, { type: "paren" });
              return null;
            } else if (ch === ")") {
              popStateStack(state);
              return null;
            } else if (ch === "[") {
              pushStateStack(state, { type: "bracket" });
              return null;
            } else if (ch === "]") {
              popStateStack(state);
              return null;
            } else {
              var known = keywords2.propertyIsEnumerable(ch) && keywords2[ch];
              if (isEQName && ch === '"')
                while (stream.next() !== '"') {
                }
              if (isEQName && ch === "'")
                while (stream.next() !== "'") {
                }
              if (!known)
                stream.eatWhile(/[\w\$_-]/);
              var foundColon = stream.eat(":");
              if (!stream.eat(":") && foundColon) {
                stream.eatWhile(/[\w\$_-]/);
              }
              if (stream.match(/^[ \t]*\(/, false)) {
                mightBeFunction = true;
              }
              var word = stream.current();
              known = keywords2.propertyIsEnumerable(word) && keywords2[word];
              if (mightBeFunction && !known)
                known = { type: "function_call", style: "variable def" };
              if (isInXmlConstructor(state)) {
                popStateStack(state);
                return "variable";
              }
              if (word == "element" || word == "attribute" || known.type == "axis_specifier")
                pushStateStack(state, { type: "xmlconstructor" });
              return known ? known.style : "variable";
            }
          }
          function tokenComment(stream, state) {
            var maybeEnd = false, maybeNested = false, nestedCount = 0, ch;
            while (ch = stream.next()) {
              if (ch == ")" && maybeEnd) {
                if (nestedCount > 0)
                  nestedCount--;
                else {
                  popStateStack(state);
                  break;
                }
              } else if (ch == ":" && maybeNested) {
                nestedCount++;
              }
              maybeEnd = ch == ":";
              maybeNested = ch == "(";
            }
            return "comment";
          }
          function tokenString(quote, f3) {
            return function(stream, state) {
              var ch;
              if (isInString(state) && stream.current() == quote) {
                popStateStack(state);
                if (f3)
                  state.tokenize = f3;
                return "string";
              }
              pushStateStack(state, { type: "string", name: quote, tokenize: tokenString(quote, f3) });
              if (stream.match("{", false) && isInXmlAttributeBlock(state)) {
                state.tokenize = tokenBase;
                return "string";
              }
              while (ch = stream.next()) {
                if (ch == quote) {
                  popStateStack(state);
                  if (f3)
                    state.tokenize = f3;
                  break;
                } else {
                  if (stream.match("{", false) && isInXmlAttributeBlock(state)) {
                    state.tokenize = tokenBase;
                    return "string";
                  }
                }
              }
              return "string";
            };
          }
          function tokenVariable(stream, state) {
            var isVariableChar = /[\w\$_-]/;
            if (stream.eat('"')) {
              while (stream.next() !== '"') {
              }
              ;
              stream.eat(":");
            } else {
              stream.eatWhile(isVariableChar);
              if (!stream.match(":=", false))
                stream.eat(":");
            }
            stream.eatWhile(isVariableChar);
            state.tokenize = tokenBase;
            return "variable";
          }
          function tokenTag(name106, isclose) {
            return function(stream, state) {
              stream.eatSpace();
              if (isclose && stream.eat(">")) {
                popStateStack(state);
                state.tokenize = tokenBase;
                return "tag";
              }
              if (!stream.eat("/"))
                pushStateStack(state, { type: "tag", name: name106, tokenize: tokenBase });
              if (!stream.eat(">")) {
                state.tokenize = tokenAttribute;
                return "tag";
              } else {
                state.tokenize = tokenBase;
              }
              return "tag";
            };
          }
          function tokenAttribute(stream, state) {
            var ch = stream.next();
            if (ch == "/" && stream.eat(">")) {
              if (isInXmlAttributeBlock(state))
                popStateStack(state);
              if (isInXmlBlock(state))
                popStateStack(state);
              return "tag";
            }
            if (ch == ">") {
              if (isInXmlAttributeBlock(state))
                popStateStack(state);
              return "tag";
            }
            if (ch == "=")
              return null;
            if (ch == '"' || ch == "'")
              return chain2(stream, state, tokenString(ch, tokenAttribute));
            if (!isInXmlAttributeBlock(state))
              pushStateStack(state, { type: "attribute", tokenize: tokenAttribute });
            stream.eat(/[a-zA-Z_:]/);
            stream.eatWhile(/[-a-zA-Z0-9_:.]/);
            stream.eatSpace();
            if (stream.match(">", false) || stream.match("/", false)) {
              popStateStack(state);
              state.tokenize = tokenBase;
            }
            return "attribute";
          }
          function tokenXMLComment(stream, state) {
            var ch;
            while (ch = stream.next()) {
              if (ch == "-" && stream.match("->", true)) {
                state.tokenize = tokenBase;
                return "comment";
              }
            }
          }
          function tokenCDATA(stream, state) {
            var ch;
            while (ch = stream.next()) {
              if (ch == "]" && stream.match("]", true)) {
                state.tokenize = tokenBase;
                return "comment";
              }
            }
          }
          function tokenPreProcessing(stream, state) {
            var ch;
            while (ch = stream.next()) {
              if (ch == "?" && stream.match(">", true)) {
                state.tokenize = tokenBase;
                return "comment meta";
              }
            }
          }
          function isInXmlBlock(state) {
            return isIn(state, "tag");
          }
          function isInXmlAttributeBlock(state) {
            return isIn(state, "attribute");
          }
          function isInXmlConstructor(state) {
            return isIn(state, "xmlconstructor");
          }
          function isInString(state) {
            return isIn(state, "string");
          }
          function isEQNameAhead(stream) {
            if (stream.current() === '"')
              return stream.match(/^[^\"]+\"\:/, false);
            else if (stream.current() === "'")
              return stream.match(/^[^\"]+\'\:/, false);
            else
              return false;
          }
          function isIn(state, type) {
            return state.stack.length && state.stack[state.stack.length - 1].type == type;
          }
          function pushStateStack(state, newState) {
            state.stack.push(newState);
          }
          function popStateStack(state) {
            state.stack.pop();
            var reinstateTokenize = state.stack.length && state.stack[state.stack.length - 1].tokenize;
            state.tokenize = reinstateTokenize || tokenBase;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                cc: [],
                stack: []
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              var style = state.tokenize(stream, state);
              return style;
            },
            blockCommentStart: "(:",
            blockCommentEnd: ":)"
          };
        });
        CodeMirror5.defineMIME("application/xquery", "xquery");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/yacas/yacas.js
  var require_yacas = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/yacas/yacas.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("yacas", function(_config, _parserConfig) {
          function words(str) {
            var obj = {}, words2 = str.split(" ");
            for (var i3 = 0; i3 < words2.length; ++i3)
              obj[words2[i3]] = true;
            return obj;
          }
          var bodiedOps = words("Assert BackQuote D Defun Deriv For ForEach FromFile FromString Function Integrate InverseTaylor Limit LocalSymbols Macro MacroRule MacroRulePattern NIntegrate Rule RulePattern Subst TD TExplicitSum TSum Taylor Taylor1 Taylor2 Taylor3 ToFile ToStdout ToString TraceRule Until While");
          var pFloatForm = "(?:(?:\\.\\d+|\\d+\\.\\d*|\\d+)(?:[eE][+-]?\\d+)?)";
          var pIdentifier = "(?:[a-zA-Z\\$'][a-zA-Z0-9\\$']*)";
          var reFloatForm = new RegExp(pFloatForm);
          var reIdentifier = new RegExp(pIdentifier);
          var rePattern = new RegExp(pIdentifier + "?_" + pIdentifier);
          var reFunctionLike = new RegExp(pIdentifier + "\\s*\\(");
          function tokenBase(stream, state) {
            var ch;
            ch = stream.next();
            if (ch === '"') {
              state.tokenize = tokenString;
              return state.tokenize(stream, state);
            }
            if (ch === "/") {
              if (stream.eat("*")) {
                state.tokenize = tokenComment;
                return state.tokenize(stream, state);
              }
              if (stream.eat("/")) {
                stream.skipToEnd();
                return "comment";
              }
            }
            stream.backUp(1);
            var m3 = stream.match(/^(\w+)\s*\(/, false);
            if (m3 !== null && bodiedOps.hasOwnProperty(m3[1]))
              state.scopes.push("bodied");
            var scope = currentScope(state);
            if (scope === "bodied" && ch === "[")
              state.scopes.pop();
            if (ch === "[" || ch === "{" || ch === "(")
              state.scopes.push(ch);
            scope = currentScope(state);
            if (scope === "[" && ch === "]" || scope === "{" && ch === "}" || scope === "(" && ch === ")")
              state.scopes.pop();
            if (ch === ";") {
              while (scope === "bodied") {
                state.scopes.pop();
                scope = currentScope(state);
              }
            }
            if (stream.match(/\d+ *#/, true, false)) {
              return "qualifier";
            }
            if (stream.match(reFloatForm, true, false)) {
              return "number";
            }
            if (stream.match(rePattern, true, false)) {
              return "variable-3";
            }
            if (stream.match(/(?:\[|\]|{|}|\(|\))/, true, false)) {
              return "bracket";
            }
            if (stream.match(reFunctionLike, true, false)) {
              stream.backUp(1);
              return "variable";
            }
            if (stream.match(reIdentifier, true, false)) {
              return "variable-2";
            }
            if (stream.match(/(?:\\|\+|\-|\*|\/|,|;|\.|:|@|~|=|>|<|&|\||_|`|'|\^|\?|!|%|#)/, true, false)) {
              return "operator";
            }
            return "error";
          }
          function tokenString(stream, state) {
            var next, end = false, escaped = false;
            while ((next = stream.next()) != null) {
              if (next === '"' && !escaped) {
                end = true;
                break;
              }
              escaped = !escaped && next === "\\";
            }
            if (end && !escaped) {
              state.tokenize = tokenBase;
            }
            return "string";
          }
          ;
          function tokenComment(stream, state) {
            var prev, next;
            while ((next = stream.next()) != null) {
              if (prev === "*" && next === "/") {
                state.tokenize = tokenBase;
                break;
              }
              prev = next;
            }
            return "comment";
          }
          function currentScope(state) {
            var scope = null;
            if (state.scopes.length > 0)
              scope = state.scopes[state.scopes.length - 1];
            return scope;
          }
          return {
            startState: function() {
              return {
                tokenize: tokenBase,
                scopes: []
              };
            },
            token: function(stream, state) {
              if (stream.eatSpace())
                return null;
              return state.tokenize(stream, state);
            },
            indent: function(state, textAfter) {
              if (state.tokenize !== tokenBase && state.tokenize !== null)
                return CodeMirror5.Pass;
              var delta = 0;
              if (textAfter === "]" || textAfter === "];" || textAfter === "}" || textAfter === "};" || textAfter === ");")
                delta = -1;
              return (state.scopes.length + delta) * _config.indentUnit;
            },
            electricChars: "{}[]();",
            blockCommentStart: "/*",
            blockCommentEnd: "*/",
            lineComment: "//"
          };
        });
        CodeMirror5.defineMIME("text/x-yacas", {
          name: "yacas"
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/yaml/yaml.js
  var require_yaml = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/yaml/yaml.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("yaml", function() {
          var cons = ["true", "false", "on", "off", "yes", "no"];
          var keywordRegex = new RegExp("\\b((" + cons.join(")|(") + "))$", "i");
          return {
            token: function(stream, state) {
              var ch = stream.peek();
              var esc = state.escaped;
              state.escaped = false;
              if (ch == "#" && (stream.pos == 0 || /\s/.test(stream.string.charAt(stream.pos - 1)))) {
                stream.skipToEnd();
                return "comment";
              }
              if (stream.match(/^('([^']|\\.)*'?|"([^"]|\\.)*"?)/))
                return "string";
              if (state.literal && stream.indentation() > state.keyCol) {
                stream.skipToEnd();
                return "string";
              } else if (state.literal) {
                state.literal = false;
              }
              if (stream.sol()) {
                state.keyCol = 0;
                state.pair = false;
                state.pairStart = false;
                if (stream.match(/---/)) {
                  return "def";
                }
                if (stream.match(/\.\.\./)) {
                  return "def";
                }
                if (stream.match(/\s*-\s+/)) {
                  return "meta";
                }
              }
              if (stream.match(/^(\{|\}|\[|\])/)) {
                if (ch == "{")
                  state.inlinePairs++;
                else if (ch == "}")
                  state.inlinePairs--;
                else if (ch == "[")
                  state.inlineList++;
                else
                  state.inlineList--;
                return "meta";
              }
              if (state.inlineList > 0 && !esc && ch == ",") {
                stream.next();
                return "meta";
              }
              if (state.inlinePairs > 0 && !esc && ch == ",") {
                state.keyCol = 0;
                state.pair = false;
                state.pairStart = false;
                stream.next();
                return "meta";
              }
              if (state.pairStart) {
                if (stream.match(/^\s*(\||\>)\s*/)) {
                  state.literal = true;
                  return "meta";
                }
                ;
                if (stream.match(/^\s*(\&|\*)[a-z0-9\._-]+\b/i)) {
                  return "variable-2";
                }
                if (state.inlinePairs == 0 && stream.match(/^\s*-?[0-9\.\,]+\s?$/)) {
                  return "number";
                }
                if (state.inlinePairs > 0 && stream.match(/^\s*-?[0-9\.\,]+\s?(?=(,|}))/)) {
                  return "number";
                }
                if (stream.match(keywordRegex)) {
                  return "keyword";
                }
              }
              if (!state.pair && stream.match(/^\s*(?:[,\[\]{}&*!|>'"%@`][^\s'":]|[^,\[\]{}#&*!|>'"%@`])[^#]*?(?=\s*:($|\s))/)) {
                state.pair = true;
                state.keyCol = stream.indentation();
                return "atom";
              }
              if (state.pair && stream.match(/^:\s*/)) {
                state.pairStart = true;
                return "meta";
              }
              state.pairStart = false;
              state.escaped = ch == "\\";
              stream.next();
              return null;
            },
            startState: function() {
              return {
                pair: false,
                pairStart: false,
                keyCol: 0,
                inlinePairs: 0,
                inlineList: 0,
                literal: false,
                escaped: false
              };
            },
            lineComment: "#",
            fold: "indent"
          };
        });
        CodeMirror5.defineMIME("text/x-yaml", "yaml");
        CodeMirror5.defineMIME("text/yaml", "yaml");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/mode/z80/z80.js
  var require_z80 = __commonJS({
    "node_modules/@plaincontext/codemirror/mode/z80/z80.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineMode("z80", function(_config, parserConfig) {
          var ez80 = parserConfig.ez80;
          var keywords1, keywords2;
          if (ez80) {
            keywords1 = /^(exx?|(ld|cp)([di]r?)?|[lp]ea|pop|push|ad[cd]|cpl|daa|dec|inc|neg|sbc|sub|and|bit|[cs]cf|x?or|res|set|r[lr]c?a?|r[lr]d|s[lr]a|srl|djnz|nop|[de]i|halt|im|in([di]mr?|ir?|irx|2r?)|ot(dmr?|[id]rx|imr?)|out(0?|[di]r?|[di]2r?)|tst(io)?|slp)(\.([sl]?i)?[sl])?\b/i;
            keywords2 = /^(((call|j[pr]|rst|ret[in]?)(\.([sl]?i)?[sl])?)|(rs|st)mix)\b/i;
          } else {
            keywords1 = /^(exx?|(ld|cp|in)([di]r?)?|pop|push|ad[cd]|cpl|daa|dec|inc|neg|sbc|sub|and|bit|[cs]cf|x?or|res|set|r[lr]c?a?|r[lr]d|s[lr]a|srl|djnz|nop|rst|[de]i|halt|im|ot[di]r|out[di]?)\b/i;
            keywords2 = /^(call|j[pr]|ret[in]?|b_?(call|jump))\b/i;
          }
          var variables1 = /^(af?|bc?|c|de?|e|hl?|l|i[xy]?|r|sp)\b/i;
          var variables2 = /^(n?[zc]|p[oe]?|m)\b/i;
          var errors = /^([hl][xy]|i[xy][hl]|slia|sll)\b/i;
          var numbers = /^([\da-f]+h|[0-7]+o|[01]+b|\d+d?)\b/i;
          return {
            startState: function() {
              return {
                context: 0
              };
            },
            token: function(stream, state) {
              if (!stream.column())
                state.context = 0;
              if (stream.eatSpace())
                return null;
              var w3;
              if (stream.eatWhile(/\w/)) {
                if (ez80 && stream.eat(".")) {
                  stream.eatWhile(/\w/);
                }
                w3 = stream.current();
                if (stream.indentation()) {
                  if ((state.context == 1 || state.context == 4) && variables1.test(w3)) {
                    state.context = 4;
                    return "var2";
                  }
                  if (state.context == 2 && variables2.test(w3)) {
                    state.context = 4;
                    return "var3";
                  }
                  if (keywords1.test(w3)) {
                    state.context = 1;
                    return "keyword";
                  } else if (keywords2.test(w3)) {
                    state.context = 2;
                    return "keyword";
                  } else if (state.context == 4 && numbers.test(w3)) {
                    return "number";
                  }
                  if (errors.test(w3))
                    return "error";
                } else if (stream.match(numbers)) {
                  return "number";
                } else {
                  return null;
                }
              } else if (stream.eat(";")) {
                stream.skipToEnd();
                return "comment";
              } else if (stream.eat('"')) {
                while (w3 = stream.next()) {
                  if (w3 == '"')
                    break;
                  if (w3 == "\\")
                    stream.next();
                }
                return "string";
              } else if (stream.eat("'")) {
                if (stream.match(/\\?.'/))
                  return "number";
              } else if (stream.eat(".") || stream.sol() && stream.eat("#")) {
                state.context = 5;
                if (stream.eatWhile(/\w/))
                  return "def";
              } else if (stream.eat("$")) {
                if (stream.eatWhile(/[\da-f]/i))
                  return "number";
              } else if (stream.eat("%")) {
                if (stream.eatWhile(/[01]/))
                  return "number";
              } else {
                stream.next();
              }
              return null;
            }
          };
        });
        CodeMirror5.defineMIME("text/x-z80", "z80");
        CodeMirror5.defineMIME("text/x-ez80", { name: "z80", ez80: true });
      });
    }
  });

  // src/model/codemirror-modes.js
  var codemirror_modes_default;
  var init_codemirror_modes = __esm({
    "src/model/codemirror-modes.js"() {
      codemirror_modes_default = {
        "text/apl": () => Promise.resolve().then(() => __toModule(require_apl())),
        apl: () => Promise.resolve().then(() => __toModule(require_apl())),
        "application/pgp": () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        pgp: () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        "application/pgp-encrypted": () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        "pgp-encrypted": () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        "application/pgp-keys": () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        "pgp-keys": () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        "application/pgp-signature": () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        "pgp-signature": () => Promise.resolve().then(() => __toModule(require_asciiarmor())),
        "text/x-ttcn-asn": () => Promise.resolve().then(() => __toModule(require_asn_1())),
        "ttcn-asn": () => Promise.resolve().then(() => __toModule(require_asn_1())),
        "text/x-asterisk": () => Promise.resolve().then(() => __toModule(require_asterisk())),
        asterisk: () => Promise.resolve().then(() => __toModule(require_asterisk())),
        "text/x-brainfuck": () => Promise.resolve().then(() => __toModule(require_brainfuck())),
        brainfuck: () => Promise.resolve().then(() => __toModule(require_brainfuck())),
        "text/x-chdr": () => Promise.resolve().then(() => __toModule(require_clike())),
        chdr: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-c++hdr": () => Promise.resolve().then(() => __toModule(require_clike())),
        "c++hdr": () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-java": () => Promise.resolve().then(() => __toModule(require_clike())),
        java: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-csharp": () => Promise.resolve().then(() => __toModule(require_clike())),
        csharp: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-scala": () => Promise.resolve().then(() => __toModule(require_clike())),
        scala: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-kotlin": () => Promise.resolve().then(() => __toModule(require_clike())),
        kotlin: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-nesc": () => Promise.resolve().then(() => __toModule(require_clike())),
        nesc: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-objectivec": () => Promise.resolve().then(() => __toModule(require_clike())),
        objectivec: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-objectivec++": () => Promise.resolve().then(() => __toModule(require_clike())),
        "objectivec++": () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-squirrel": () => Promise.resolve().then(() => __toModule(require_clike())),
        squirrel: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-ceylon": () => Promise.resolve().then(() => __toModule(require_clike())),
        ceylon: () => Promise.resolve().then(() => __toModule(require_clike())),
        "text/x-clojure": () => Promise.resolve().then(() => __toModule(require_clojure())),
        clojure: () => Promise.resolve().then(() => __toModule(require_clojure())),
        "text/x-clojurescript": () => Promise.resolve().then(() => __toModule(require_clojure())),
        clojurescript: () => Promise.resolve().then(() => __toModule(require_clojure())),
        "application/edn": () => Promise.resolve().then(() => __toModule(require_clojure())),
        edn: () => Promise.resolve().then(() => __toModule(require_clojure())),
        "text/x-cmake": () => Promise.resolve().then(() => __toModule(require_cmake())),
        cmake: () => Promise.resolve().then(() => __toModule(require_cmake())),
        "text/x-cobol": () => Promise.resolve().then(() => __toModule(require_cobol())),
        cobol: () => Promise.resolve().then(() => __toModule(require_cobol())),
        "application/vnd.coffeescript": () => Promise.resolve().then(() => __toModule(require_coffeescript())),
        "vnd.coffeescript": () => Promise.resolve().then(() => __toModule(require_coffeescript())),
        "text/x-coffeescript": () => Promise.resolve().then(() => __toModule(require_coffeescript())),
        coffeescript: () => Promise.resolve().then(() => __toModule(require_coffeescript())),
        "text/coffeescript": () => Promise.resolve().then(() => __toModule(require_coffeescript())),
        "text/x-common-lisp": () => Promise.resolve().then(() => __toModule(require_commonlisp())),
        "common-lisp": () => Promise.resolve().then(() => __toModule(require_commonlisp())),
        "text/x-crystal": () => Promise.resolve().then(() => __toModule(require_crystal())),
        crystal: () => Promise.resolve().then(() => __toModule(require_crystal())),
        "text/css": () => Promise.resolve().then(() => __toModule(require_css())),
        css: () => Promise.resolve().then(() => __toModule(require_css())),
        "text/x-scss": () => Promise.resolve().then(() => __toModule(require_css())),
        scss: () => Promise.resolve().then(() => __toModule(require_css())),
        "text/x-less": () => Promise.resolve().then(() => __toModule(require_css())),
        less: () => Promise.resolve().then(() => __toModule(require_css())),
        "text/x-gss": () => Promise.resolve().then(() => __toModule(require_css())),
        gss: () => Promise.resolve().then(() => __toModule(require_css())),
        "application/x-cypher-query": () => Promise.resolve().then(() => __toModule(require_cypher())),
        "cypher-query": () => Promise.resolve().then(() => __toModule(require_cypher())),
        "text/x-d": () => Promise.resolve().then(() => __toModule(require_d())),
        d: () => Promise.resolve().then(() => __toModule(require_d())),
        "application/dart": () => Promise.resolve().then(() => __toModule(require_dart())),
        dart: () => Promise.resolve().then(() => __toModule(require_dart())),
        "text/x-diff": () => Promise.resolve().then(() => __toModule(require_diff())),
        diff: () => Promise.resolve().then(() => __toModule(require_diff())),
        "text/x-django": () => Promise.resolve().then(() => __toModule(require_django())),
        django: () => Promise.resolve().then(() => __toModule(require_django())),
        "text/x-dockerfile": () => Promise.resolve().then(() => __toModule(require_dockerfile())),
        dockerfile: () => Promise.resolve().then(() => __toModule(require_dockerfile())),
        "application/xml-dtd": () => Promise.resolve().then(() => __toModule(require_dtd())),
        "xml-dtd": () => Promise.resolve().then(() => __toModule(require_dtd())),
        "text/x-dylan": () => Promise.resolve().then(() => __toModule(require_dylan())),
        dylan: () => Promise.resolve().then(() => __toModule(require_dylan())),
        "text/x-ebnf": () => Promise.resolve().then(() => __toModule(require_ebnf())),
        ebnf: () => Promise.resolve().then(() => __toModule(require_ebnf())),
        "text/x-ecl": () => Promise.resolve().then(() => __toModule(require_ecl())),
        ecl: () => Promise.resolve().then(() => __toModule(require_ecl())),
        "text/x-eiffel": () => Promise.resolve().then(() => __toModule(require_eiffel())),
        eiffel: () => Promise.resolve().then(() => __toModule(require_eiffel())),
        "text/x-elm": () => Promise.resolve().then(() => __toModule(require_elm())),
        elm: () => Promise.resolve().then(() => __toModule(require_elm())),
        "text/x-erlang": () => Promise.resolve().then(() => __toModule(require_erlang())),
        erlang: () => Promise.resolve().then(() => __toModule(require_erlang())),
        "text/x-factor": () => Promise.resolve().then(() => __toModule(require_factor())),
        factor: () => Promise.resolve().then(() => __toModule(require_factor())),
        "text/x-fcl": () => Promise.resolve().then(() => __toModule(require_fcl())),
        fcl: () => Promise.resolve().then(() => __toModule(require_fcl())),
        "text/x-forth": () => Promise.resolve().then(() => __toModule(require_forth())),
        forth: () => Promise.resolve().then(() => __toModule(require_forth())),
        "text/x-fortran": () => Promise.resolve().then(() => __toModule(require_fortran())),
        fortran: () => Promise.resolve().then(() => __toModule(require_fortran())),
        "text/x-gfm": () => Promise.resolve().then(() => __toModule(require_gfm())),
        gfm: () => Promise.resolve().then(() => __toModule(require_gfm())),
        "text/x-feature": () => Promise.resolve().then(() => __toModule(require_gherkin())),
        feature: () => Promise.resolve().then(() => __toModule(require_gherkin())),
        "text/x-go": () => Promise.resolve().then(() => __toModule(require_go())),
        go: () => Promise.resolve().then(() => __toModule(require_go())),
        "text/x-groovy": () => Promise.resolve().then(() => __toModule(require_groovy())),
        groovy: () => Promise.resolve().then(() => __toModule(require_groovy())),
        "text/x-haml": () => Promise.resolve().then(() => __toModule(require_haml())),
        haml: () => Promise.resolve().then(() => __toModule(require_haml())),
        "text/x-handlebars-template": () => Promise.resolve().then(() => __toModule(require_handlebars())),
        "handlebars-template": () => Promise.resolve().then(() => __toModule(require_handlebars())),
        "text/x-haskell": () => Promise.resolve().then(() => __toModule(require_haskell())),
        haskell: () => Promise.resolve().then(() => __toModule(require_haskell())),
        "text/x-literate-haskell": () => Promise.resolve().then(() => __toModule(require_haskell_literate())),
        "literate-haskell": () => Promise.resolve().then(() => __toModule(require_haskell_literate())),
        "text/x-haxe": () => Promise.resolve().then(() => __toModule(require_haxe())),
        haxe: () => Promise.resolve().then(() => __toModule(require_haxe())),
        "text/x-hxml": () => Promise.resolve().then(() => __toModule(require_haxe())),
        hxml: () => Promise.resolve().then(() => __toModule(require_haxe())),
        "application/x-ejs": () => Promise.resolve().then(() => __toModule(require_htmlembedded())),
        ejs: () => Promise.resolve().then(() => __toModule(require_htmlembedded())),
        "application/x-erb": () => Promise.resolve().then(() => __toModule(require_htmlembedded())),
        erb: () => Promise.resolve().then(() => __toModule(require_htmlembedded())),
        "text/html": () => Promise.resolve().then(() => __toModule(require_htmlmixed())),
        html: () => Promise.resolve().then(() => __toModule(require_htmlmixed())),
        "text/x-idl": () => Promise.resolve().then(() => __toModule(require_idl())),
        idl: () => Promise.resolve().then(() => __toModule(require_idl())),
        "text/javascript": () => Promise.resolve().then(() => __toModule(require_javascript())),
        javascript: () => Promise.resolve().then(() => __toModule(require_javascript())),
        "text/ecmascript": () => Promise.resolve().then(() => __toModule(require_javascript())),
        ecmascript: () => Promise.resolve().then(() => __toModule(require_javascript())),
        "application/javascript": () => Promise.resolve().then(() => __toModule(require_javascript())),
        "application/x-javascript": () => Promise.resolve().then(() => __toModule(require_javascript())),
        "application/ecmascript": () => Promise.resolve().then(() => __toModule(require_javascript())),
        "application/json": () => Promise.resolve().then(() => __toModule(require_javascript())),
        json: () => Promise.resolve().then(() => __toModule(require_javascript())),
        "application/x-json": () => Promise.resolve().then(() => __toModule(require_javascript())),
        "application/ld+json": () => Promise.resolve().then(() => __toModule(require_javascript())),
        "ld+json": () => Promise.resolve().then(() => __toModule(require_javascript())),
        "text/typescript": () => Promise.resolve().then(() => __toModule(require_javascript())),
        typescript: () => Promise.resolve().then(() => __toModule(require_javascript())),
        "application/typescript": () => Promise.resolve().then(() => __toModule(require_javascript())),
        "text/jinja2": () => Promise.resolve().then(() => __toModule(require_jinja2())),
        jinja2: () => Promise.resolve().then(() => __toModule(require_jinja2())),
        "text/jsx": () => Promise.resolve().then(() => __toModule(require_jsx())),
        jsx: () => Promise.resolve().then(() => __toModule(require_jsx())),
        "text/typescript-jsx": () => Promise.resolve().then(() => __toModule(require_jsx())),
        "typescript-jsx": () => Promise.resolve().then(() => __toModule(require_jsx())),
        "text/x-julia": () => Promise.resolve().then(() => __toModule(require_julia())),
        julia: () => Promise.resolve().then(() => __toModule(require_julia())),
        "text/x-livescript": () => Promise.resolve().then(() => __toModule(require_livescript())),
        livescript: () => Promise.resolve().then(() => __toModule(require_livescript())),
        "text/x-lua": () => Promise.resolve().then(() => __toModule(require_lua())),
        lua: () => Promise.resolve().then(() => __toModule(require_lua())),
        "text/markdown": () => Promise.resolve().then(() => __toModule(require_markdown())),
        markdown: () => Promise.resolve().then(() => __toModule(require_markdown())),
        "text/x-markdown": () => Promise.resolve().then(() => __toModule(require_markdown())),
        "text/x-mathematica": () => Promise.resolve().then(() => __toModule(require_mathematica())),
        mathematica: () => Promise.resolve().then(() => __toModule(require_mathematica())),
        "application/mbox": () => Promise.resolve().then(() => __toModule(require_mbox())),
        mbox: () => Promise.resolve().then(() => __toModule(require_mbox())),
        "text/mirc": () => Promise.resolve().then(() => __toModule(require_mirc())),
        mirc: () => Promise.resolve().then(() => __toModule(require_mirc())),
        "text/x-ocaml": () => Promise.resolve().then(() => __toModule(require_mllike())),
        ocaml: () => Promise.resolve().then(() => __toModule(require_mllike())),
        "text/x-fsharp": () => Promise.resolve().then(() => __toModule(require_mllike())),
        fsharp: () => Promise.resolve().then(() => __toModule(require_mllike())),
        "text/x-sml": () => Promise.resolve().then(() => __toModule(require_mllike())),
        sml: () => Promise.resolve().then(() => __toModule(require_mllike())),
        "text/x-modelica": () => Promise.resolve().then(() => __toModule(require_modelica())),
        modelica: () => Promise.resolve().then(() => __toModule(require_modelica())),
        "text/x-mscgen": () => Promise.resolve().then(() => __toModule(require_mscgen())),
        mscgen: () => Promise.resolve().then(() => __toModule(require_mscgen())),
        "text/x-xu": () => Promise.resolve().then(() => __toModule(require_mscgen())),
        xu: () => Promise.resolve().then(() => __toModule(require_mscgen())),
        "text/x-msgenny": () => Promise.resolve().then(() => __toModule(require_mscgen())),
        msgenny: () => Promise.resolve().then(() => __toModule(require_mscgen())),
        "text/x-mumps": () => Promise.resolve().then(() => __toModule(require_mumps())),
        mumps: () => Promise.resolve().then(() => __toModule(require_mumps())),
        "text/x-nginx-conf": () => Promise.resolve().then(() => __toModule(require_nginx())),
        "nginx-conf": () => Promise.resolve().then(() => __toModule(require_nginx())),
        "text/x-nsis": () => Promise.resolve().then(() => __toModule(require_nsis())),
        nsis: () => Promise.resolve().then(() => __toModule(require_nsis())),
        "application/n-triples": () => Promise.resolve().then(() => __toModule(require_ntriples())),
        "n-triples": () => Promise.resolve().then(() => __toModule(require_ntriples())),
        "application/n-quads": () => Promise.resolve().then(() => __toModule(require_ntriples())),
        "n-quads": () => Promise.resolve().then(() => __toModule(require_ntriples())),
        "text/n-triples": () => Promise.resolve().then(() => __toModule(require_ntriples())),
        "text/x-octave": () => Promise.resolve().then(() => __toModule(require_octave())),
        octave: () => Promise.resolve().then(() => __toModule(require_octave())),
        "text/x-oz": () => Promise.resolve().then(() => __toModule(require_oz())),
        oz: () => Promise.resolve().then(() => __toModule(require_oz())),
        "text/x-pascal": () => Promise.resolve().then(() => __toModule(require_pascal())),
        pascal: () => Promise.resolve().then(() => __toModule(require_pascal())),
        "text/x-perl": () => Promise.resolve().then(() => __toModule(require_perl())),
        perl: () => Promise.resolve().then(() => __toModule(require_perl())),
        "application/x-httpd-php": () => Promise.resolve().then(() => __toModule(require_php())),
        "httpd-php": () => Promise.resolve().then(() => __toModule(require_php())),
        "application/x-httpd-php-open": () => Promise.resolve().then(() => __toModule(require_php())),
        "httpd-php-open": () => Promise.resolve().then(() => __toModule(require_php())),
        "text/x-php": () => Promise.resolve().then(() => __toModule(require_php())),
        php: () => Promise.resolve().then(() => __toModule(require_php())),
        "text/x-pig": () => Promise.resolve().then(() => __toModule(require_pig())),
        pig: () => Promise.resolve().then(() => __toModule(require_pig())),
        "application/x-powershell": () => Promise.resolve().then(() => __toModule(require_powershell())),
        powershell: () => Promise.resolve().then(() => __toModule(require_powershell())),
        "text/x-properties": () => Promise.resolve().then(() => __toModule(require_properties())),
        properties: () => Promise.resolve().then(() => __toModule(require_properties())),
        "text/x-ini": () => Promise.resolve().then(() => __toModule(require_properties())),
        ini: () => Promise.resolve().then(() => __toModule(require_properties())),
        "text/x-protobuf": () => Promise.resolve().then(() => __toModule(require_protobuf())),
        protobuf: () => Promise.resolve().then(() => __toModule(require_protobuf())),
        "text/x-pug": () => Promise.resolve().then(() => __toModule(require_pug())),
        pug: () => Promise.resolve().then(() => __toModule(require_pug())),
        "text/x-jade": () => Promise.resolve().then(() => __toModule(require_pug())),
        jade: () => Promise.resolve().then(() => __toModule(require_pug())),
        "text/x-puppet": () => Promise.resolve().then(() => __toModule(require_puppet())),
        puppet: () => Promise.resolve().then(() => __toModule(require_puppet())),
        "text/x-python": () => Promise.resolve().then(() => __toModule(require_python())),
        python: () => Promise.resolve().then(() => __toModule(require_python())),
        "text/x-cython": () => Promise.resolve().then(() => __toModule(require_python())),
        cython: () => Promise.resolve().then(() => __toModule(require_python())),
        "text/x-q": () => Promise.resolve().then(() => __toModule(require_q())),
        q: () => Promise.resolve().then(() => __toModule(require_q())),
        "text/x-rsrc": () => Promise.resolve().then(() => __toModule(require_r())),
        rsrc: () => Promise.resolve().then(() => __toModule(require_r())),
        "text/x-rpm-changes": () => Promise.resolve().then(() => __toModule(require_rpm())),
        "rpm-changes": () => Promise.resolve().then(() => __toModule(require_rpm())),
        "text/x-rpm-spec": () => Promise.resolve().then(() => __toModule(require_rpm())),
        "rpm-spec": () => Promise.resolve().then(() => __toModule(require_rpm())),
        "text/x-rst": () => Promise.resolve().then(() => __toModule(require_rst())),
        rst: () => Promise.resolve().then(() => __toModule(require_rst())),
        "text/x-ruby": () => Promise.resolve().then(() => __toModule(require_ruby())),
        ruby: () => Promise.resolve().then(() => __toModule(require_ruby())),
        "text/x-rustsrc": () => Promise.resolve().then(() => __toModule(require_rust())),
        rustsrc: () => Promise.resolve().then(() => __toModule(require_rust())),
        "text/rust": () => Promise.resolve().then(() => __toModule(require_rust())),
        rust: () => Promise.resolve().then(() => __toModule(require_rust())),
        "text/x-sas": () => Promise.resolve().then(() => __toModule(require_sas())),
        sas: () => Promise.resolve().then(() => __toModule(require_sas())),
        "text/x-sass": () => Promise.resolve().then(() => __toModule(require_sass())),
        sass: () => Promise.resolve().then(() => __toModule(require_sass())),
        "text/x-scheme": () => Promise.resolve().then(() => __toModule(require_scheme())),
        scheme: () => Promise.resolve().then(() => __toModule(require_scheme())),
        "text/x-sh": () => Promise.resolve().then(() => __toModule(require_shell())),
        sh: () => Promise.resolve().then(() => __toModule(require_shell())),
        "application/x-sh": () => Promise.resolve().then(() => __toModule(require_shell())),
        "application/sieve": () => Promise.resolve().then(() => __toModule(require_sieve())),
        sieve: () => Promise.resolve().then(() => __toModule(require_sieve())),
        "text/x-slim": () => Promise.resolve().then(() => __toModule(require_slim())),
        slim: () => Promise.resolve().then(() => __toModule(require_slim())),
        "application/x-slim": () => Promise.resolve().then(() => __toModule(require_slim())),
        "text/x-stsrc": () => Promise.resolve().then(() => __toModule(require_smalltalk())),
        stsrc: () => Promise.resolve().then(() => __toModule(require_smalltalk())),
        "text/x-smarty": () => Promise.resolve().then(() => __toModule(require_smarty())),
        smarty: () => Promise.resolve().then(() => __toModule(require_smarty())),
        "text/x-solr": () => Promise.resolve().then(() => __toModule(require_solr())),
        solr: () => Promise.resolve().then(() => __toModule(require_solr())),
        "text/x-soy": () => Promise.resolve().then(() => __toModule(require_soy())),
        soy: () => Promise.resolve().then(() => __toModule(require_soy())),
        "application/sparql-query": () => Promise.resolve().then(() => __toModule(require_sparql())),
        "sparql-query": () => Promise.resolve().then(() => __toModule(require_sparql())),
        "text/x-spreadsheet": () => Promise.resolve().then(() => __toModule(require_spreadsheet())),
        spreadsheet: () => Promise.resolve().then(() => __toModule(require_spreadsheet())),
        "text/x-sql": () => Promise.resolve().then(() => __toModule(require_sql())),
        sql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-mssql": () => Promise.resolve().then(() => __toModule(require_sql())),
        mssql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-mysql": () => Promise.resolve().then(() => __toModule(require_sql())),
        mysql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-mariadb": () => Promise.resolve().then(() => __toModule(require_sql())),
        mariadb: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-sqlite": () => Promise.resolve().then(() => __toModule(require_sql())),
        sqlite: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-cassandra": () => Promise.resolve().then(() => __toModule(require_sql())),
        cassandra: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-plsql": () => Promise.resolve().then(() => __toModule(require_sql())),
        plsql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-hive": () => Promise.resolve().then(() => __toModule(require_sql())),
        hive: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-pgsql": () => Promise.resolve().then(() => __toModule(require_sql())),
        pgsql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-gql": () => Promise.resolve().then(() => __toModule(require_sql())),
        gql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-gpsql": () => Promise.resolve().then(() => __toModule(require_sql())),
        gpsql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-sparksql": () => Promise.resolve().then(() => __toModule(require_sql())),
        sparksql: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-esper": () => Promise.resolve().then(() => __toModule(require_sql())),
        esper: () => Promise.resolve().then(() => __toModule(require_sql())),
        "text/x-stex": () => Promise.resolve().then(() => __toModule(require_stex())),
        stex: () => Promise.resolve().then(() => __toModule(require_stex())),
        "text/x-latex": () => Promise.resolve().then(() => __toModule(require_stex())),
        latex: () => Promise.resolve().then(() => __toModule(require_stex())),
        "text/x-styl": () => Promise.resolve().then(() => __toModule(require_stylus())),
        styl: () => Promise.resolve().then(() => __toModule(require_stylus())),
        "text/x-swift": () => Promise.resolve().then(() => __toModule(require_swift())),
        swift: () => Promise.resolve().then(() => __toModule(require_swift())),
        "text/x-tcl": () => Promise.resolve().then(() => __toModule(require_tcl())),
        tcl: () => Promise.resolve().then(() => __toModule(require_tcl())),
        "text/x-textile": () => Promise.resolve().then(() => __toModule(require_textile())),
        textile: () => Promise.resolve().then(() => __toModule(require_textile())),
        "text/x-tiddlywiki": () => Promise.resolve().then(() => __toModule(require_tiddlywiki())),
        tiddlywiki: () => Promise.resolve().then(() => __toModule(require_tiddlywiki())),
        "text/tiki": () => Promise.resolve().then(() => __toModule(require_tiki())),
        tiki: () => Promise.resolve().then(() => __toModule(require_tiki())),
        "text/x-toml": () => Promise.resolve().then(() => __toModule(require_toml())),
        toml: () => Promise.resolve().then(() => __toModule(require_toml())),
        "text/x-tornado": () => Promise.resolve().then(() => __toModule(require_tornado())),
        tornado: () => Promise.resolve().then(() => __toModule(require_tornado())),
        "text/troff": () => Promise.resolve().then(() => __toModule(require_troff())),
        troff: () => Promise.resolve().then(() => __toModule(require_troff())),
        "text/x-troff": () => Promise.resolve().then(() => __toModule(require_troff())),
        "application/x-troff": () => Promise.resolve().then(() => __toModule(require_troff())),
        "text/x-ttcnpp": () => Promise.resolve().then(() => __toModule(require_ttcn())),
        ttcnpp: () => Promise.resolve().then(() => __toModule(require_ttcn())),
        "text/x-ttcn-cfg": () => Promise.resolve().then(() => __toModule(require_ttcn_cfg())),
        "ttcn-cfg": () => Promise.resolve().then(() => __toModule(require_ttcn_cfg())),
        "text/turtle": () => Promise.resolve().then(() => __toModule(require_turtle())),
        turtle: () => Promise.resolve().then(() => __toModule(require_turtle())),
        "text/x-twig": () => Promise.resolve().then(() => __toModule(require_twig())),
        twig: () => Promise.resolve().then(() => __toModule(require_twig())),
        "text/x-vb": () => Promise.resolve().then(() => __toModule(require_vb())),
        vb: () => Promise.resolve().then(() => __toModule(require_vb())),
        "text/vbscript": () => Promise.resolve().then(() => __toModule(require_vbscript())),
        vbscript: () => Promise.resolve().then(() => __toModule(require_vbscript())),
        "text/velocity": () => Promise.resolve().then(() => __toModule(require_velocity())),
        velocity: () => Promise.resolve().then(() => __toModule(require_velocity())),
        "text/x-verilog": () => Promise.resolve().then(() => __toModule(require_verilog())),
        verilog: () => Promise.resolve().then(() => __toModule(require_verilog())),
        "text/x-systemverilog": () => Promise.resolve().then(() => __toModule(require_verilog())),
        systemverilog: () => Promise.resolve().then(() => __toModule(require_verilog())),
        "text/x-tlv": () => Promise.resolve().then(() => __toModule(require_verilog())),
        tlv: () => Promise.resolve().then(() => __toModule(require_verilog())),
        "text/x-vhdl": () => Promise.resolve().then(() => __toModule(require_vhdl())),
        vhdl: () => Promise.resolve().then(() => __toModule(require_vhdl())),
        "text/x-vue": () => Promise.resolve().then(() => __toModule(require_vue())),
        vue: () => Promise.resolve().then(() => __toModule(require_vue())),
        "text/webassembly": () => Promise.resolve().then(() => __toModule(require_wast())),
        webassembly: () => Promise.resolve().then(() => __toModule(require_wast())),
        "text/x-webidl": () => Promise.resolve().then(() => __toModule(require_webidl())),
        webidl: () => Promise.resolve().then(() => __toModule(require_webidl())),
        "text/xml": () => Promise.resolve().then(() => __toModule(require_xml())),
        xml: () => Promise.resolve().then(() => __toModule(require_xml())),
        "application/xml": () => Promise.resolve().then(() => __toModule(require_xml())),
        "application/xquery": () => Promise.resolve().then(() => __toModule(require_xquery())),
        xquery: () => Promise.resolve().then(() => __toModule(require_xquery())),
        "text/x-yacas": () => Promise.resolve().then(() => __toModule(require_yacas())),
        yacas: () => Promise.resolve().then(() => __toModule(require_yacas())),
        "text/x-yaml": () => Promise.resolve().then(() => __toModule(require_yaml())),
        yaml: () => Promise.resolve().then(() => __toModule(require_yaml())),
        "text/yaml": () => Promise.resolve().then(() => __toModule(require_yaml())),
        "text/x-z80": () => Promise.resolve().then(() => __toModule(require_z80())),
        z80: () => Promise.resolve().then(() => __toModule(require_z80())),
        "text/x-ez80": () => Promise.resolve().then(() => __toModule(require_z80())),
        ez80: () => Promise.resolve().then(() => __toModule(require_z80()))
      };
    }
  });

  // src/model/taxonomy/helpers/codemirrormodehelper.js
  function importModeDependencies(mode2) {
    var _a;
    const deps = (_a = import_codemirror2.default.modes[mode2]) == null ? void 0 : _a.dependencies;
    if (!deps)
      return Promise.resolve(null);
    let missing = [];
    for (let i3 = 0; i3 < deps.length; ++i3) {
      if (!Object.prototype.hasOwnProperty.call(deps[i3]))
        missing.push(deps[i3]);
    }
    if (!missing.length)
      return Promise.resolve(null);
    const promises = missing.map((missing2) => importMode(null, missing2).then((imported) => {
      modeCache[missing2] = imported;
      return imported;
    }));
    return Promise.all(promises);
  }
  function getLoadedModeFromCodeMirror(options, mimeType) {
    let mode2 = import_codemirror2.default.getMode(options || {}, mimeType);
    if (mode2.name === "null") {
      mode2 = import_codemirror2.default.getMode(options || {}, `text/${mimeType}`);
      if (mode2.name === "null") {
        mode2 = import_codemirror2.default.getMode(options || {}, `text/x-${mimeType}`);
        if (mode2.name === "null") {
          mode2 = import_codemirror2.default.getMode(options || {}, `application/${mimeType}`);
        }
      }
    }
    if (!mode2) {
      mode2 = null;
    }
    return mode2;
  }
  function importMode(options, mode2) {
    if (!isValidMode(mode2))
      return Promise.resolve(null);
    let importPromise;
    if (modeCache[mode2])
      importPromise = Promise.resolve(modeCache[mode2]);
    else
      importPromise = codemirror_modes_default[mode2]().then(() => {
        modeCache[mode2] = getLoadedModeFromCodeMirror(options, mode2);
        return modeCache[mode2];
      });
    return importPromise.then((importedMode) => {
      return importModeDependencies(mode2).then(() => importedMode);
    });
  }
  function isValidMode(modeName) {
    if (!import_codemirror2.default)
      return false;
    return !!codemirror_modes_default[modeName];
  }
  function getMode(options, mimeType, sync = false) {
    if (!import_codemirror2.default)
      return null;
    let mode2 = modeCache[mimeType];
    if (mode2)
      return mode2;
    if (sync) {
      mode2 = getLoadedModeFromCodeMirror(options, mimeType);
      if (mode2) {
        modeCache[mimeType] = mode2;
        return mode2;
      }
    }
    return importMode(options, mimeType).then((result) => {
      var _a, _b, _c;
      if (!result)
        return;
      const tree = (_a = getEditor()) == null ? void 0 : _a.tree();
      if (!tree)
        return;
      result && ((_c = (_b = getEditor()) == null ? void 0 : _b.tree()) == null ? void 0 : _c.reClassifyAll());
    });
  }
  function runMode(mode2, state, text) {
    let stream = text.escapedTextStream();
    while (!stream.eol()) {
      stream.start = stream.pos;
      let style = mode2.token(stream, state);
      if (style) {
        const styles = style.split(" ");
        const value = stream.current();
        const length = styles.length;
        let i3;
        for (i3 = 0; i3 < length; i3++) {
          text.addAttributeInRange(`mode-${styles[i3]}`, value, stream.start, stream.pos - stream.start);
        }
      }
    }
  }
  function copyState(state) {
    if (!import_codemirror2.default || !state) {
      return void 0;
    }
    return {
      mode: state.mode,
      state: state.state ? import_codemirror2.default.copyState(state.mode, state.state) : null
    };
  }
  function stateEquals(a3, b2) {
    if (!import_codemirror2.default)
      return true;
    if (a3 === b2) {
      return true;
    }
    if (!a3 || !b2) {
      return false;
    }
    if (a3.mode !== b2.mode) {
      return false;
    }
    return shallowEquals(a3.state, b2.state);
  }
  function getEditor() {
    return editor || null;
  }
  function setEditor(_editor2) {
    editor = _editor2;
  }
  var import_codemirror2, modeCache, editor, attributesToClear;
  var init_codemirrormodehelper = __esm({
    "src/model/taxonomy/helpers/codemirrormodehelper.js"() {
      import_codemirror2 = __toModule(require_codemirror());
      init_objectutils();
      init_codemirror_modes();
      init_extensions();
      import_codemirror2.default.defineMIME("json", { name: "javascript", json: true });
      modeCache = {};
      attributesToClear = [
        "mode-keyword",
        "mode-atom",
        "mode-number",
        "mode-def",
        "mode-variable",
        "mode-variable-2",
        "mode-variable-3",
        "mode-property",
        "mode-operator",
        "mode-comment",
        "mode-string",
        "mode-string-2",
        "mode-meta",
        "mode-error",
        "mode-qualifier",
        "mode-builtin",
        "mode-bracket",
        "mode-tag",
        "mode-attribute",
        "mode-heading",
        "mode-quote",
        "mode-hr",
        "mode-link",
        "mode-negative",
        "mode-positive",
        "mode-heading",
        "mode-strong",
        "mode-em",
        "mode-link",
        "mode-invalidchar"
      ];
      Extensions.addInit((editor2) => {
        setEditor(editor2);
      });
    }
  });

  // node_modules/moment/moment.js
  var require_moment = __commonJS({
    "node_modules/moment/moment.js"(exports, module) {
      (function(global2, factory2) {
        typeof exports === "object" && typeof module !== "undefined" ? module.exports = factory2() : typeof define === "function" && define.amd ? define(factory2) : global2.moment = factory2();
      })(exports, function() {
        "use strict";
        var hookCallback;
        function hooks() {
          return hookCallback.apply(null, arguments);
        }
        function setHookCallback(callback) {
          hookCallback = callback;
        }
        function isArray2(input) {
          return input instanceof Array || Object.prototype.toString.call(input) === "[object Array]";
        }
        function isObject2(input) {
          return input != null && Object.prototype.toString.call(input) === "[object Object]";
        }
        function hasOwnProp(a3, b2) {
          return Object.prototype.hasOwnProperty.call(a3, b2);
        }
        function isObjectEmpty(obj) {
          if (Object.getOwnPropertyNames) {
            return Object.getOwnPropertyNames(obj).length === 0;
          } else {
            var k3;
            for (k3 in obj) {
              if (hasOwnProp(obj, k3)) {
                return false;
              }
            }
            return true;
          }
        }
        function isUndefined2(input) {
          return input === void 0;
        }
        function isNumber2(input) {
          return typeof input === "number" || Object.prototype.toString.call(input) === "[object Number]";
        }
        function isDate2(input) {
          return input instanceof Date || Object.prototype.toString.call(input) === "[object Date]";
        }
        function map3(arr, fn) {
          var res = [], i3;
          for (i3 = 0; i3 < arr.length; ++i3) {
            res.push(fn(arr[i3], i3));
          }
          return res;
        }
        function extend2(a3, b2) {
          for (var i3 in b2) {
            if (hasOwnProp(b2, i3)) {
              a3[i3] = b2[i3];
            }
          }
          if (hasOwnProp(b2, "toString")) {
            a3.toString = b2.toString;
          }
          if (hasOwnProp(b2, "valueOf")) {
            a3.valueOf = b2.valueOf;
          }
          return a3;
        }
        function createUTC(input, format6, locale2, strict) {
          return createLocalOrUTC(input, format6, locale2, strict, true).utc();
        }
        function defaultParsingFlags() {
          return {
            empty: false,
            unusedTokens: [],
            unusedInput: [],
            overflow: -2,
            charsLeftOver: 0,
            nullInput: false,
            invalidEra: null,
            invalidMonth: null,
            invalidFormat: false,
            userInvalidated: false,
            iso: false,
            parsedDateParts: [],
            era: null,
            meridiem: null,
            rfc2822: false,
            weekdayMismatch: false
          };
        }
        function getParsingFlags(m3) {
          if (m3._pf == null) {
            m3._pf = defaultParsingFlags();
          }
          return m3._pf;
        }
        var some;
        if (Array.prototype.some) {
          some = Array.prototype.some;
        } else {
          some = function(fun) {
            var t3 = Object(this), len = t3.length >>> 0, i3;
            for (i3 = 0; i3 < len; i3++) {
              if (i3 in t3 && fun.call(this, t3[i3], i3, t3)) {
                return true;
              }
            }
            return false;
          };
        }
        function isValid(m3) {
          if (m3._isValid == null) {
            var flags = getParsingFlags(m3), parsedParts = some.call(flags.parsedDateParts, function(i3) {
              return i3 != null;
            }), isNowValid = !isNaN(m3._d.getTime()) && flags.overflow < 0 && !flags.empty && !flags.invalidEra && !flags.invalidMonth && !flags.invalidWeekday && !flags.weekdayMismatch && !flags.nullInput && !flags.invalidFormat && !flags.userInvalidated && (!flags.meridiem || flags.meridiem && parsedParts);
            if (m3._strict) {
              isNowValid = isNowValid && flags.charsLeftOver === 0 && flags.unusedTokens.length === 0 && flags.bigHour === void 0;
            }
            if (Object.isFrozen == null || !Object.isFrozen(m3)) {
              m3._isValid = isNowValid;
            } else {
              return isNowValid;
            }
          }
          return m3._isValid;
        }
        function createInvalid(flags) {
          var m3 = createUTC(NaN);
          if (flags != null) {
            extend2(getParsingFlags(m3), flags);
          } else {
            getParsingFlags(m3).userInvalidated = true;
          }
          return m3;
        }
        var momentProperties = hooks.momentProperties = [], updateInProgress = false;
        function copyConfig(to2, from2) {
          var i3, prop, val;
          if (!isUndefined2(from2._isAMomentObject)) {
            to2._isAMomentObject = from2._isAMomentObject;
          }
          if (!isUndefined2(from2._i)) {
            to2._i = from2._i;
          }
          if (!isUndefined2(from2._f)) {
            to2._f = from2._f;
          }
          if (!isUndefined2(from2._l)) {
            to2._l = from2._l;
          }
          if (!isUndefined2(from2._strict)) {
            to2._strict = from2._strict;
          }
          if (!isUndefined2(from2._tzm)) {
            to2._tzm = from2._tzm;
          }
          if (!isUndefined2(from2._isUTC)) {
            to2._isUTC = from2._isUTC;
          }
          if (!isUndefined2(from2._offset)) {
            to2._offset = from2._offset;
          }
          if (!isUndefined2(from2._pf)) {
            to2._pf = getParsingFlags(from2);
          }
          if (!isUndefined2(from2._locale)) {
            to2._locale = from2._locale;
          }
          if (momentProperties.length > 0) {
            for (i3 = 0; i3 < momentProperties.length; i3++) {
              prop = momentProperties[i3];
              val = from2[prop];
              if (!isUndefined2(val)) {
                to2[prop] = val;
              }
            }
          }
          return to2;
        }
        function Moment(config3) {
          copyConfig(this, config3);
          this._d = new Date(config3._d != null ? config3._d.getTime() : NaN);
          if (!this.isValid()) {
            this._d = new Date(NaN);
          }
          if (updateInProgress === false) {
            updateInProgress = true;
            hooks.updateOffset(this);
            updateInProgress = false;
          }
        }
        function isMoment(obj) {
          return obj instanceof Moment || obj != null && obj._isAMomentObject != null;
        }
        function warn(msg) {
          if (hooks.suppressDeprecationWarnings === false && typeof console !== "undefined" && console.warn) {
            console.warn("Deprecation warning: " + msg);
          }
        }
        function deprecate(msg, fn) {
          var firstTime = true;
          return extend2(function() {
            if (hooks.deprecationHandler != null) {
              hooks.deprecationHandler(null, msg);
            }
            if (firstTime) {
              var args = [], arg, i3, key;
              for (i3 = 0; i3 < arguments.length; i3++) {
                arg = "";
                if (typeof arguments[i3] === "object") {
                  arg += "\n[" + i3 + "] ";
                  for (key in arguments[0]) {
                    if (hasOwnProp(arguments[0], key)) {
                      arg += key + ": " + arguments[0][key] + ", ";
                    }
                  }
                  arg = arg.slice(0, -2);
                } else {
                  arg = arguments[i3];
                }
                args.push(arg);
              }
              warn(msg + "\nArguments: " + Array.prototype.slice.call(args).join("") + "\n" + new Error().stack);
              firstTime = false;
            }
            return fn.apply(this, arguments);
          }, fn);
        }
        var deprecations = {};
        function deprecateSimple(name106, msg) {
          if (hooks.deprecationHandler != null) {
            hooks.deprecationHandler(name106, msg);
          }
          if (!deprecations[name106]) {
            warn(msg);
            deprecations[name106] = true;
          }
        }
        hooks.suppressDeprecationWarnings = false;
        hooks.deprecationHandler = null;
        function isFunction2(input) {
          return typeof Function !== "undefined" && input instanceof Function || Object.prototype.toString.call(input) === "[object Function]";
        }
        function set(config3) {
          var prop, i3;
          for (i3 in config3) {
            if (hasOwnProp(config3, i3)) {
              prop = config3[i3];
              if (isFunction2(prop)) {
                this[i3] = prop;
              } else {
                this["_" + i3] = prop;
              }
            }
          }
          this._config = config3;
          this._dayOfMonthOrdinalParseLenient = new RegExp((this._dayOfMonthOrdinalParse.source || this._ordinalParse.source) + "|" + /\d{1,2}/.source);
        }
        function mergeConfigs(parentConfig, childConfig) {
          var res = extend2({}, parentConfig), prop;
          for (prop in childConfig) {
            if (hasOwnProp(childConfig, prop)) {
              if (isObject2(parentConfig[prop]) && isObject2(childConfig[prop])) {
                res[prop] = {};
                extend2(res[prop], parentConfig[prop]);
                extend2(res[prop], childConfig[prop]);
              } else if (childConfig[prop] != null) {
                res[prop] = childConfig[prop];
              } else {
                delete res[prop];
              }
            }
          }
          for (prop in parentConfig) {
            if (hasOwnProp(parentConfig, prop) && !hasOwnProp(childConfig, prop) && isObject2(parentConfig[prop])) {
              res[prop] = extend2({}, res[prop]);
            }
          }
          return res;
        }
        function Locale(config3) {
          if (config3 != null) {
            this.set(config3);
          }
        }
        var keys;
        if (Object.keys) {
          keys = Object.keys;
        } else {
          keys = function(obj) {
            var i3, res = [];
            for (i3 in obj) {
              if (hasOwnProp(obj, i3)) {
                res.push(i3);
              }
            }
            return res;
          };
        }
        var defaultCalendar = {
          sameDay: "[Today at] LT",
          nextDay: "[Tomorrow at] LT",
          nextWeek: "dddd [at] LT",
          lastDay: "[Yesterday at] LT",
          lastWeek: "[Last] dddd [at] LT",
          sameElse: "L"
        };
        function calendar(key, mom, now2) {
          var output = this._calendar[key] || this._calendar["sameElse"];
          return isFunction2(output) ? output.call(mom, now2) : output;
        }
        function zeroFill(number2, targetLength, forceSign) {
          var absNumber2 = "" + Math.abs(number2), zerosToFill = targetLength - absNumber2.length, sign4 = number2 >= 0;
          return (sign4 ? forceSign ? "+" : "" : "-") + Math.pow(10, Math.max(0, zerosToFill)).toString().substr(1) + absNumber2;
        }
        var formattingTokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g, localFormattingTokens = /(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g, formatFunctions = {}, formatTokenFunctions = {};
        function addFormatToken(token2, padded, ordinal2, callback) {
          var func = callback;
          if (typeof callback === "string") {
            func = function() {
              return this[callback]();
            };
          }
          if (token2) {
            formatTokenFunctions[token2] = func;
          }
          if (padded) {
            formatTokenFunctions[padded[0]] = function() {
              return zeroFill(func.apply(this, arguments), padded[1], padded[2]);
            };
          }
          if (ordinal2) {
            formatTokenFunctions[ordinal2] = function() {
              return this.localeData().ordinal(func.apply(this, arguments), token2);
            };
          }
        }
        function removeFormattingTokens(input) {
          if (input.match(/\[[\s\S]/)) {
            return input.replace(/^\[|\]$/g, "");
          }
          return input.replace(/\\/g, "");
        }
        function makeFormatFunction(format6) {
          var array = format6.match(formattingTokens), i3, length;
          for (i3 = 0, length = array.length; i3 < length; i3++) {
            if (formatTokenFunctions[array[i3]]) {
              array[i3] = formatTokenFunctions[array[i3]];
            } else {
              array[i3] = removeFormattingTokens(array[i3]);
            }
          }
          return function(mom) {
            var output = "", i4;
            for (i4 = 0; i4 < length; i4++) {
              output += isFunction2(array[i4]) ? array[i4].call(mom, format6) : array[i4];
            }
            return output;
          };
        }
        function formatMoment(m3, format6) {
          if (!m3.isValid()) {
            return m3.localeData().invalidDate();
          }
          format6 = expandFormat(format6, m3.localeData());
          formatFunctions[format6] = formatFunctions[format6] || makeFormatFunction(format6);
          return formatFunctions[format6](m3);
        }
        function expandFormat(format6, locale2) {
          var i3 = 5;
          function replaceLongDateFormatTokens(input) {
            return locale2.longDateFormat(input) || input;
          }
          localFormattingTokens.lastIndex = 0;
          while (i3 >= 0 && localFormattingTokens.test(format6)) {
            format6 = format6.replace(localFormattingTokens, replaceLongDateFormatTokens);
            localFormattingTokens.lastIndex = 0;
            i3 -= 1;
          }
          return format6;
        }
        var defaultLongDateFormat = {
          LTS: "h:mm:ss A",
          LT: "h:mm A",
          L: "MM/DD/YYYY",
          LL: "MMMM D, YYYY",
          LLL: "MMMM D, YYYY h:mm A",
          LLLL: "dddd, MMMM D, YYYY h:mm A"
        };
        function longDateFormat(key) {
          var format6 = this._longDateFormat[key], formatUpper = this._longDateFormat[key.toUpperCase()];
          if (format6 || !formatUpper) {
            return format6;
          }
          this._longDateFormat[key] = formatUpper.match(formattingTokens).map(function(tok) {
            if (tok === "MMMM" || tok === "MM" || tok === "DD" || tok === "dddd") {
              return tok.slice(1);
            }
            return tok;
          }).join("");
          return this._longDateFormat[key];
        }
        var defaultInvalidDate = "Invalid date";
        function invalidDate() {
          return this._invalidDate;
        }
        var defaultOrdinal = "%d", defaultDayOfMonthOrdinalParse = /\d{1,2}/;
        function ordinal(number2) {
          return this._ordinal.replace("%d", number2);
        }
        var defaultRelativeTime = {
          future: "in %s",
          past: "%s ago",
          s: "a few seconds",
          ss: "%d seconds",
          m: "a minute",
          mm: "%d minutes",
          h: "an hour",
          hh: "%d hours",
          d: "a day",
          dd: "%d days",
          w: "a week",
          ww: "%d weeks",
          M: "a month",
          MM: "%d months",
          y: "a year",
          yy: "%d years"
        };
        function relativeTime(number2, withoutSuffix, string2, isFuture) {
          var output = this._relativeTime[string2];
          return isFunction2(output) ? output(number2, withoutSuffix, string2, isFuture) : output.replace(/%d/i, number2);
        }
        function pastFuture(diff2, output) {
          var format6 = this._relativeTime[diff2 > 0 ? "future" : "past"];
          return isFunction2(format6) ? format6(output) : format6.replace(/%s/i, output);
        }
        var aliases = {};
        function addUnitAlias(unit, shorthand) {
          var lowerCase = unit.toLowerCase();
          aliases[lowerCase] = aliases[lowerCase + "s"] = aliases[shorthand] = unit;
        }
        function normalizeUnits(units) {
          return typeof units === "string" ? aliases[units] || aliases[units.toLowerCase()] : void 0;
        }
        function normalizeObjectUnits(inputObject) {
          var normalizedInput = {}, normalizedProp, prop;
          for (prop in inputObject) {
            if (hasOwnProp(inputObject, prop)) {
              normalizedProp = normalizeUnits(prop);
              if (normalizedProp) {
                normalizedInput[normalizedProp] = inputObject[prop];
              }
            }
          }
          return normalizedInput;
        }
        var priorities = {};
        function addUnitPriority(unit, priority) {
          priorities[unit] = priority;
        }
        function getPrioritizedUnits(unitsObj) {
          var units = [], u3;
          for (u3 in unitsObj) {
            if (hasOwnProp(unitsObj, u3)) {
              units.push({ unit: u3, priority: priorities[u3] });
            }
          }
          units.sort(function(a3, b2) {
            return a3.priority - b2.priority;
          });
          return units;
        }
        function isLeapYear(year) {
          return year % 4 === 0 && year % 100 !== 0 || year % 400 === 0;
        }
        function absFloor(number2) {
          if (number2 < 0) {
            return Math.ceil(number2) || 0;
          } else {
            return Math.floor(number2);
          }
        }
        function toInt(argumentForCoercion) {
          var coercedNumber = +argumentForCoercion, value = 0;
          if (coercedNumber !== 0 && isFinite(coercedNumber)) {
            value = absFloor(coercedNumber);
          }
          return value;
        }
        function makeGetSet(unit, keepTime) {
          return function(value) {
            if (value != null) {
              set$1(this, unit, value);
              hooks.updateOffset(this, keepTime);
              return this;
            } else {
              return get(this, unit);
            }
          };
        }
        function get(mom, unit) {
          return mom.isValid() ? mom._d["get" + (mom._isUTC ? "UTC" : "") + unit]() : NaN;
        }
        function set$1(mom, unit, value) {
          if (mom.isValid() && !isNaN(value)) {
            if (unit === "FullYear" && isLeapYear(mom.year()) && mom.month() === 1 && mom.date() === 29) {
              value = toInt(value);
              mom._d["set" + (mom._isUTC ? "UTC" : "") + unit](value, mom.month(), daysInMonth(value, mom.month()));
            } else {
              mom._d["set" + (mom._isUTC ? "UTC" : "") + unit](value);
            }
          }
        }
        function stringGet(units) {
          units = normalizeUnits(units);
          if (isFunction2(this[units])) {
            return this[units]();
          }
          return this;
        }
        function stringSet(units, value) {
          if (typeof units === "object") {
            units = normalizeObjectUnits(units);
            var prioritized = getPrioritizedUnits(units), i3;
            for (i3 = 0; i3 < prioritized.length; i3++) {
              this[prioritized[i3].unit](units[prioritized[i3].unit]);
            }
          } else {
            units = normalizeUnits(units);
            if (isFunction2(this[units])) {
              return this[units](value);
            }
          }
          return this;
        }
        var match1 = /\d/, match2 = /\d\d/, match3 = /\d{3}/, match4 = /\d{4}/, match6 = /[+-]?\d{6}/, match1to2 = /\d\d?/, match3to4 = /\d\d\d\d?/, match5to6 = /\d\d\d\d\d\d?/, match1to3 = /\d{1,3}/, match1to4 = /\d{1,4}/, match1to6 = /[+-]?\d{1,6}/, matchUnsigned = /\d+/, matchSigned = /[+-]?\d+/, matchOffset = /Z|[+-]\d\d:?\d\d/gi, matchShortOffset = /Z|[+-]\d\d(?::?\d\d)?/gi, matchTimestamp = /[+-]?\d+(\.\d{1,3})?/, matchWord = /[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i, regexes;
        regexes = {};
        function addRegexToken(token2, regex, strictRegex) {
          regexes[token2] = isFunction2(regex) ? regex : function(isStrict, localeData2) {
            return isStrict && strictRegex ? strictRegex : regex;
          };
        }
        function getParseRegexForToken(token2, config3) {
          if (!hasOwnProp(regexes, token2)) {
            return new RegExp(unescapeFormat(token2));
          }
          return regexes[token2](config3._strict, config3._locale);
        }
        function unescapeFormat(s3) {
          return regexEscape(s3.replace("\\", "").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g, function(matched, p1, p22, p3, p4) {
            return p1 || p22 || p3 || p4;
          }));
        }
        function regexEscape(s3) {
          return s3.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&");
        }
        var tokens = {};
        function addParseToken(token2, callback) {
          var i3, func = callback;
          if (typeof token2 === "string") {
            token2 = [token2];
          }
          if (isNumber2(callback)) {
            func = function(input, array) {
              array[callback] = toInt(input);
            };
          }
          for (i3 = 0; i3 < token2.length; i3++) {
            tokens[token2[i3]] = func;
          }
        }
        function addWeekParseToken(token2, callback) {
          addParseToken(token2, function(input, array, config3, token3) {
            config3._w = config3._w || {};
            callback(input, config3._w, config3, token3);
          });
        }
        function addTimeToArrayFromToken(token2, input, config3) {
          if (input != null && hasOwnProp(tokens, token2)) {
            tokens[token2](input, config3._a, config3, token2);
          }
        }
        var YEAR = 0, MONTH = 1, DATE = 2, HOUR = 3, MINUTE = 4, SECOND = 5, MILLISECOND = 6, WEEK = 7, WEEKDAY = 8;
        function mod2(n3, x3) {
          return (n3 % x3 + x3) % x3;
        }
        var indexOf;
        if (Array.prototype.indexOf) {
          indexOf = Array.prototype.indexOf;
        } else {
          indexOf = function(o3) {
            var i3;
            for (i3 = 0; i3 < this.length; ++i3) {
              if (this[i3] === o3) {
                return i3;
              }
            }
            return -1;
          };
        }
        function daysInMonth(year, month) {
          if (isNaN(year) || isNaN(month)) {
            return NaN;
          }
          var modMonth = mod2(month, 12);
          year += (month - modMonth) / 12;
          return modMonth === 1 ? isLeapYear(year) ? 29 : 28 : 31 - modMonth % 7 % 2;
        }
        addFormatToken("M", ["MM", 2], "Mo", function() {
          return this.month() + 1;
        });
        addFormatToken("MMM", 0, 0, function(format6) {
          return this.localeData().monthsShort(this, format6);
        });
        addFormatToken("MMMM", 0, 0, function(format6) {
          return this.localeData().months(this, format6);
        });
        addUnitAlias("month", "M");
        addUnitPriority("month", 8);
        addRegexToken("M", match1to2);
        addRegexToken("MM", match1to2, match2);
        addRegexToken("MMM", function(isStrict, locale2) {
          return locale2.monthsShortRegex(isStrict);
        });
        addRegexToken("MMMM", function(isStrict, locale2) {
          return locale2.monthsRegex(isStrict);
        });
        addParseToken(["M", "MM"], function(input, array) {
          array[MONTH] = toInt(input) - 1;
        });
        addParseToken(["MMM", "MMMM"], function(input, array, config3, token2) {
          var month = config3._locale.monthsParse(input, token2, config3._strict);
          if (month != null) {
            array[MONTH] = month;
          } else {
            getParsingFlags(config3).invalidMonth = input;
          }
        });
        var defaultLocaleMonths = "January_February_March_April_May_June_July_August_September_October_November_December".split("_"), defaultLocaleMonthsShort = "Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"), MONTHS_IN_FORMAT = /D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/, defaultMonthsShortRegex = matchWord, defaultMonthsRegex = matchWord;
        function localeMonths(m3, format6) {
          if (!m3) {
            return isArray2(this._months) ? this._months : this._months["standalone"];
          }
          return isArray2(this._months) ? this._months[m3.month()] : this._months[(this._months.isFormat || MONTHS_IN_FORMAT).test(format6) ? "format" : "standalone"][m3.month()];
        }
        function localeMonthsShort(m3, format6) {
          if (!m3) {
            return isArray2(this._monthsShort) ? this._monthsShort : this._monthsShort["standalone"];
          }
          return isArray2(this._monthsShort) ? this._monthsShort[m3.month()] : this._monthsShort[MONTHS_IN_FORMAT.test(format6) ? "format" : "standalone"][m3.month()];
        }
        function handleStrictParse(monthName, format6, strict) {
          var i3, ii, mom, llc = monthName.toLocaleLowerCase();
          if (!this._monthsParse) {
            this._monthsParse = [];
            this._longMonthsParse = [];
            this._shortMonthsParse = [];
            for (i3 = 0; i3 < 12; ++i3) {
              mom = createUTC([2e3, i3]);
              this._shortMonthsParse[i3] = this.monthsShort(mom, "").toLocaleLowerCase();
              this._longMonthsParse[i3] = this.months(mom, "").toLocaleLowerCase();
            }
          }
          if (strict) {
            if (format6 === "MMM") {
              ii = indexOf.call(this._shortMonthsParse, llc);
              return ii !== -1 ? ii : null;
            } else {
              ii = indexOf.call(this._longMonthsParse, llc);
              return ii !== -1 ? ii : null;
            }
          } else {
            if (format6 === "MMM") {
              ii = indexOf.call(this._shortMonthsParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._longMonthsParse, llc);
              return ii !== -1 ? ii : null;
            } else {
              ii = indexOf.call(this._longMonthsParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._shortMonthsParse, llc);
              return ii !== -1 ? ii : null;
            }
          }
        }
        function localeMonthsParse(monthName, format6, strict) {
          var i3, mom, regex;
          if (this._monthsParseExact) {
            return handleStrictParse.call(this, monthName, format6, strict);
          }
          if (!this._monthsParse) {
            this._monthsParse = [];
            this._longMonthsParse = [];
            this._shortMonthsParse = [];
          }
          for (i3 = 0; i3 < 12; i3++) {
            mom = createUTC([2e3, i3]);
            if (strict && !this._longMonthsParse[i3]) {
              this._longMonthsParse[i3] = new RegExp("^" + this.months(mom, "").replace(".", "") + "$", "i");
              this._shortMonthsParse[i3] = new RegExp("^" + this.monthsShort(mom, "").replace(".", "") + "$", "i");
            }
            if (!strict && !this._monthsParse[i3]) {
              regex = "^" + this.months(mom, "") + "|^" + this.monthsShort(mom, "");
              this._monthsParse[i3] = new RegExp(regex.replace(".", ""), "i");
            }
            if (strict && format6 === "MMMM" && this._longMonthsParse[i3].test(monthName)) {
              return i3;
            } else if (strict && format6 === "MMM" && this._shortMonthsParse[i3].test(monthName)) {
              return i3;
            } else if (!strict && this._monthsParse[i3].test(monthName)) {
              return i3;
            }
          }
        }
        function setMonth(mom, value) {
          var dayOfMonth;
          if (!mom.isValid()) {
            return mom;
          }
          if (typeof value === "string") {
            if (/^\d+$/.test(value)) {
              value = toInt(value);
            } else {
              value = mom.localeData().monthsParse(value);
              if (!isNumber2(value)) {
                return mom;
              }
            }
          }
          dayOfMonth = Math.min(mom.date(), daysInMonth(mom.year(), value));
          mom._d["set" + (mom._isUTC ? "UTC" : "") + "Month"](value, dayOfMonth);
          return mom;
        }
        function getSetMonth(value) {
          if (value != null) {
            setMonth(this, value);
            hooks.updateOffset(this, true);
            return this;
          } else {
            return get(this, "Month");
          }
        }
        function getDaysInMonth() {
          return daysInMonth(this.year(), this.month());
        }
        function monthsShortRegex(isStrict) {
          if (this._monthsParseExact) {
            if (!hasOwnProp(this, "_monthsRegex")) {
              computeMonthsParse.call(this);
            }
            if (isStrict) {
              return this._monthsShortStrictRegex;
            } else {
              return this._monthsShortRegex;
            }
          } else {
            if (!hasOwnProp(this, "_monthsShortRegex")) {
              this._monthsShortRegex = defaultMonthsShortRegex;
            }
            return this._monthsShortStrictRegex && isStrict ? this._monthsShortStrictRegex : this._monthsShortRegex;
          }
        }
        function monthsRegex(isStrict) {
          if (this._monthsParseExact) {
            if (!hasOwnProp(this, "_monthsRegex")) {
              computeMonthsParse.call(this);
            }
            if (isStrict) {
              return this._monthsStrictRegex;
            } else {
              return this._monthsRegex;
            }
          } else {
            if (!hasOwnProp(this, "_monthsRegex")) {
              this._monthsRegex = defaultMonthsRegex;
            }
            return this._monthsStrictRegex && isStrict ? this._monthsStrictRegex : this._monthsRegex;
          }
        }
        function computeMonthsParse() {
          function cmpLenRev(a3, b2) {
            return b2.length - a3.length;
          }
          var shortPieces = [], longPieces = [], mixedPieces = [], i3, mom;
          for (i3 = 0; i3 < 12; i3++) {
            mom = createUTC([2e3, i3]);
            shortPieces.push(this.monthsShort(mom, ""));
            longPieces.push(this.months(mom, ""));
            mixedPieces.push(this.months(mom, ""));
            mixedPieces.push(this.monthsShort(mom, ""));
          }
          shortPieces.sort(cmpLenRev);
          longPieces.sort(cmpLenRev);
          mixedPieces.sort(cmpLenRev);
          for (i3 = 0; i3 < 12; i3++) {
            shortPieces[i3] = regexEscape(shortPieces[i3]);
            longPieces[i3] = regexEscape(longPieces[i3]);
          }
          for (i3 = 0; i3 < 24; i3++) {
            mixedPieces[i3] = regexEscape(mixedPieces[i3]);
          }
          this._monthsRegex = new RegExp("^(" + mixedPieces.join("|") + ")", "i");
          this._monthsShortRegex = this._monthsRegex;
          this._monthsStrictRegex = new RegExp("^(" + longPieces.join("|") + ")", "i");
          this._monthsShortStrictRegex = new RegExp("^(" + shortPieces.join("|") + ")", "i");
        }
        addFormatToken("Y", 0, 0, function() {
          var y2 = this.year();
          return y2 <= 9999 ? zeroFill(y2, 4) : "+" + y2;
        });
        addFormatToken(0, ["YY", 2], 0, function() {
          return this.year() % 100;
        });
        addFormatToken(0, ["YYYY", 4], 0, "year");
        addFormatToken(0, ["YYYYY", 5], 0, "year");
        addFormatToken(0, ["YYYYYY", 6, true], 0, "year");
        addUnitAlias("year", "y");
        addUnitPriority("year", 1);
        addRegexToken("Y", matchSigned);
        addRegexToken("YY", match1to2, match2);
        addRegexToken("YYYY", match1to4, match4);
        addRegexToken("YYYYY", match1to6, match6);
        addRegexToken("YYYYYY", match1to6, match6);
        addParseToken(["YYYYY", "YYYYYY"], YEAR);
        addParseToken("YYYY", function(input, array) {
          array[YEAR] = input.length === 2 ? hooks.parseTwoDigitYear(input) : toInt(input);
        });
        addParseToken("YY", function(input, array) {
          array[YEAR] = hooks.parseTwoDigitYear(input);
        });
        addParseToken("Y", function(input, array) {
          array[YEAR] = parseInt(input, 10);
        });
        function daysInYear(year) {
          return isLeapYear(year) ? 366 : 365;
        }
        hooks.parseTwoDigitYear = function(input) {
          return toInt(input) + (toInt(input) > 68 ? 1900 : 2e3);
        };
        var getSetYear = makeGetSet("FullYear", true);
        function getIsLeapYear() {
          return isLeapYear(this.year());
        }
        function createDate(y2, m3, d4, h2, M2, s3, ms) {
          var date2;
          if (y2 < 100 && y2 >= 0) {
            date2 = new Date(y2 + 400, m3, d4, h2, M2, s3, ms);
            if (isFinite(date2.getFullYear())) {
              date2.setFullYear(y2);
            }
          } else {
            date2 = new Date(y2, m3, d4, h2, M2, s3, ms);
          }
          return date2;
        }
        function createUTCDate(y2) {
          var date2, args;
          if (y2 < 100 && y2 >= 0) {
            args = Array.prototype.slice.call(arguments);
            args[0] = y2 + 400;
            date2 = new Date(Date.UTC.apply(null, args));
            if (isFinite(date2.getUTCFullYear())) {
              date2.setUTCFullYear(y2);
            }
          } else {
            date2 = new Date(Date.UTC.apply(null, arguments));
          }
          return date2;
        }
        function firstWeekOffset(year, dow, doy) {
          var fwd = 7 + dow - doy, fwdlw = (7 + createUTCDate(year, 0, fwd).getUTCDay() - dow) % 7;
          return -fwdlw + fwd - 1;
        }
        function dayOfYearFromWeeks(year, week, weekday, dow, doy) {
          var localWeekday = (7 + weekday - dow) % 7, weekOffset = firstWeekOffset(year, dow, doy), dayOfYear = 1 + 7 * (week - 1) + localWeekday + weekOffset, resYear, resDayOfYear;
          if (dayOfYear <= 0) {
            resYear = year - 1;
            resDayOfYear = daysInYear(resYear) + dayOfYear;
          } else if (dayOfYear > daysInYear(year)) {
            resYear = year + 1;
            resDayOfYear = dayOfYear - daysInYear(year);
          } else {
            resYear = year;
            resDayOfYear = dayOfYear;
          }
          return {
            year: resYear,
            dayOfYear: resDayOfYear
          };
        }
        function weekOfYear(mom, dow, doy) {
          var weekOffset = firstWeekOffset(mom.year(), dow, doy), week = Math.floor((mom.dayOfYear() - weekOffset - 1) / 7) + 1, resWeek, resYear;
          if (week < 1) {
            resYear = mom.year() - 1;
            resWeek = week + weeksInYear(resYear, dow, doy);
          } else if (week > weeksInYear(mom.year(), dow, doy)) {
            resWeek = week - weeksInYear(mom.year(), dow, doy);
            resYear = mom.year() + 1;
          } else {
            resYear = mom.year();
            resWeek = week;
          }
          return {
            week: resWeek,
            year: resYear
          };
        }
        function weeksInYear(year, dow, doy) {
          var weekOffset = firstWeekOffset(year, dow, doy), weekOffsetNext = firstWeekOffset(year + 1, dow, doy);
          return (daysInYear(year) - weekOffset + weekOffsetNext) / 7;
        }
        addFormatToken("w", ["ww", 2], "wo", "week");
        addFormatToken("W", ["WW", 2], "Wo", "isoWeek");
        addUnitAlias("week", "w");
        addUnitAlias("isoWeek", "W");
        addUnitPriority("week", 5);
        addUnitPriority("isoWeek", 5);
        addRegexToken("w", match1to2);
        addRegexToken("ww", match1to2, match2);
        addRegexToken("W", match1to2);
        addRegexToken("WW", match1to2, match2);
        addWeekParseToken(["w", "ww", "W", "WW"], function(input, week, config3, token2) {
          week[token2.substr(0, 1)] = toInt(input);
        });
        function localeWeek(mom) {
          return weekOfYear(mom, this._week.dow, this._week.doy).week;
        }
        var defaultLocaleWeek = {
          dow: 0,
          doy: 6
        };
        function localeFirstDayOfWeek() {
          return this._week.dow;
        }
        function localeFirstDayOfYear() {
          return this._week.doy;
        }
        function getSetWeek(input) {
          var week = this.localeData().week(this);
          return input == null ? week : this.add((input - week) * 7, "d");
        }
        function getSetISOWeek(input) {
          var week = weekOfYear(this, 1, 4).week;
          return input == null ? week : this.add((input - week) * 7, "d");
        }
        addFormatToken("d", 0, "do", "day");
        addFormatToken("dd", 0, 0, function(format6) {
          return this.localeData().weekdaysMin(this, format6);
        });
        addFormatToken("ddd", 0, 0, function(format6) {
          return this.localeData().weekdaysShort(this, format6);
        });
        addFormatToken("dddd", 0, 0, function(format6) {
          return this.localeData().weekdays(this, format6);
        });
        addFormatToken("e", 0, 0, "weekday");
        addFormatToken("E", 0, 0, "isoWeekday");
        addUnitAlias("day", "d");
        addUnitAlias("weekday", "e");
        addUnitAlias("isoWeekday", "E");
        addUnitPriority("day", 11);
        addUnitPriority("weekday", 11);
        addUnitPriority("isoWeekday", 11);
        addRegexToken("d", match1to2);
        addRegexToken("e", match1to2);
        addRegexToken("E", match1to2);
        addRegexToken("dd", function(isStrict, locale2) {
          return locale2.weekdaysMinRegex(isStrict);
        });
        addRegexToken("ddd", function(isStrict, locale2) {
          return locale2.weekdaysShortRegex(isStrict);
        });
        addRegexToken("dddd", function(isStrict, locale2) {
          return locale2.weekdaysRegex(isStrict);
        });
        addWeekParseToken(["dd", "ddd", "dddd"], function(input, week, config3, token2) {
          var weekday = config3._locale.weekdaysParse(input, token2, config3._strict);
          if (weekday != null) {
            week.d = weekday;
          } else {
            getParsingFlags(config3).invalidWeekday = input;
          }
        });
        addWeekParseToken(["d", "e", "E"], function(input, week, config3, token2) {
          week[token2] = toInt(input);
        });
        function parseWeekday(input, locale2) {
          if (typeof input !== "string") {
            return input;
          }
          if (!isNaN(input)) {
            return parseInt(input, 10);
          }
          input = locale2.weekdaysParse(input);
          if (typeof input === "number") {
            return input;
          }
          return null;
        }
        function parseIsoWeekday(input, locale2) {
          if (typeof input === "string") {
            return locale2.weekdaysParse(input) % 7 || 7;
          }
          return isNaN(input) ? null : input;
        }
        function shiftWeekdays(ws, n3) {
          return ws.slice(n3, 7).concat(ws.slice(0, n3));
        }
        var defaultLocaleWeekdays = "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), defaultLocaleWeekdaysShort = "Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"), defaultLocaleWeekdaysMin = "Su_Mo_Tu_We_Th_Fr_Sa".split("_"), defaultWeekdaysRegex = matchWord, defaultWeekdaysShortRegex = matchWord, defaultWeekdaysMinRegex = matchWord;
        function localeWeekdays(m3, format6) {
          var weekdays = isArray2(this._weekdays) ? this._weekdays : this._weekdays[m3 && m3 !== true && this._weekdays.isFormat.test(format6) ? "format" : "standalone"];
          return m3 === true ? shiftWeekdays(weekdays, this._week.dow) : m3 ? weekdays[m3.day()] : weekdays;
        }
        function localeWeekdaysShort(m3) {
          return m3 === true ? shiftWeekdays(this._weekdaysShort, this._week.dow) : m3 ? this._weekdaysShort[m3.day()] : this._weekdaysShort;
        }
        function localeWeekdaysMin(m3) {
          return m3 === true ? shiftWeekdays(this._weekdaysMin, this._week.dow) : m3 ? this._weekdaysMin[m3.day()] : this._weekdaysMin;
        }
        function handleStrictParse$1(weekdayName, format6, strict) {
          var i3, ii, mom, llc = weekdayName.toLocaleLowerCase();
          if (!this._weekdaysParse) {
            this._weekdaysParse = [];
            this._shortWeekdaysParse = [];
            this._minWeekdaysParse = [];
            for (i3 = 0; i3 < 7; ++i3) {
              mom = createUTC([2e3, 1]).day(i3);
              this._minWeekdaysParse[i3] = this.weekdaysMin(mom, "").toLocaleLowerCase();
              this._shortWeekdaysParse[i3] = this.weekdaysShort(mom, "").toLocaleLowerCase();
              this._weekdaysParse[i3] = this.weekdays(mom, "").toLocaleLowerCase();
            }
          }
          if (strict) {
            if (format6 === "dddd") {
              ii = indexOf.call(this._weekdaysParse, llc);
              return ii !== -1 ? ii : null;
            } else if (format6 === "ddd") {
              ii = indexOf.call(this._shortWeekdaysParse, llc);
              return ii !== -1 ? ii : null;
            } else {
              ii = indexOf.call(this._minWeekdaysParse, llc);
              return ii !== -1 ? ii : null;
            }
          } else {
            if (format6 === "dddd") {
              ii = indexOf.call(this._weekdaysParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._shortWeekdaysParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._minWeekdaysParse, llc);
              return ii !== -1 ? ii : null;
            } else if (format6 === "ddd") {
              ii = indexOf.call(this._shortWeekdaysParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._weekdaysParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._minWeekdaysParse, llc);
              return ii !== -1 ? ii : null;
            } else {
              ii = indexOf.call(this._minWeekdaysParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._weekdaysParse, llc);
              if (ii !== -1) {
                return ii;
              }
              ii = indexOf.call(this._shortWeekdaysParse, llc);
              return ii !== -1 ? ii : null;
            }
          }
        }
        function localeWeekdaysParse(weekdayName, format6, strict) {
          var i3, mom, regex;
          if (this._weekdaysParseExact) {
            return handleStrictParse$1.call(this, weekdayName, format6, strict);
          }
          if (!this._weekdaysParse) {
            this._weekdaysParse = [];
            this._minWeekdaysParse = [];
            this._shortWeekdaysParse = [];
            this._fullWeekdaysParse = [];
          }
          for (i3 = 0; i3 < 7; i3++) {
            mom = createUTC([2e3, 1]).day(i3);
            if (strict && !this._fullWeekdaysParse[i3]) {
              this._fullWeekdaysParse[i3] = new RegExp("^" + this.weekdays(mom, "").replace(".", "\\.?") + "$", "i");
              this._shortWeekdaysParse[i3] = new RegExp("^" + this.weekdaysShort(mom, "").replace(".", "\\.?") + "$", "i");
              this._minWeekdaysParse[i3] = new RegExp("^" + this.weekdaysMin(mom, "").replace(".", "\\.?") + "$", "i");
            }
            if (!this._weekdaysParse[i3]) {
              regex = "^" + this.weekdays(mom, "") + "|^" + this.weekdaysShort(mom, "") + "|^" + this.weekdaysMin(mom, "");
              this._weekdaysParse[i3] = new RegExp(regex.replace(".", ""), "i");
            }
            if (strict && format6 === "dddd" && this._fullWeekdaysParse[i3].test(weekdayName)) {
              return i3;
            } else if (strict && format6 === "ddd" && this._shortWeekdaysParse[i3].test(weekdayName)) {
              return i3;
            } else if (strict && format6 === "dd" && this._minWeekdaysParse[i3].test(weekdayName)) {
              return i3;
            } else if (!strict && this._weekdaysParse[i3].test(weekdayName)) {
              return i3;
            }
          }
        }
        function getSetDayOfWeek(input) {
          if (!this.isValid()) {
            return input != null ? this : NaN;
          }
          var day = this._isUTC ? this._d.getUTCDay() : this._d.getDay();
          if (input != null) {
            input = parseWeekday(input, this.localeData());
            return this.add(input - day, "d");
          } else {
            return day;
          }
        }
        function getSetLocaleDayOfWeek(input) {
          if (!this.isValid()) {
            return input != null ? this : NaN;
          }
          var weekday = (this.day() + 7 - this.localeData()._week.dow) % 7;
          return input == null ? weekday : this.add(input - weekday, "d");
        }
        function getSetISODayOfWeek(input) {
          if (!this.isValid()) {
            return input != null ? this : NaN;
          }
          if (input != null) {
            var weekday = parseIsoWeekday(input, this.localeData());
            return this.day(this.day() % 7 ? weekday : weekday - 7);
          } else {
            return this.day() || 7;
          }
        }
        function weekdaysRegex(isStrict) {
          if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, "_weekdaysRegex")) {
              computeWeekdaysParse.call(this);
            }
            if (isStrict) {
              return this._weekdaysStrictRegex;
            } else {
              return this._weekdaysRegex;
            }
          } else {
            if (!hasOwnProp(this, "_weekdaysRegex")) {
              this._weekdaysRegex = defaultWeekdaysRegex;
            }
            return this._weekdaysStrictRegex && isStrict ? this._weekdaysStrictRegex : this._weekdaysRegex;
          }
        }
        function weekdaysShortRegex(isStrict) {
          if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, "_weekdaysRegex")) {
              computeWeekdaysParse.call(this);
            }
            if (isStrict) {
              return this._weekdaysShortStrictRegex;
            } else {
              return this._weekdaysShortRegex;
            }
          } else {
            if (!hasOwnProp(this, "_weekdaysShortRegex")) {
              this._weekdaysShortRegex = defaultWeekdaysShortRegex;
            }
            return this._weekdaysShortStrictRegex && isStrict ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex;
          }
        }
        function weekdaysMinRegex(isStrict) {
          if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, "_weekdaysRegex")) {
              computeWeekdaysParse.call(this);
            }
            if (isStrict) {
              return this._weekdaysMinStrictRegex;
            } else {
              return this._weekdaysMinRegex;
            }
          } else {
            if (!hasOwnProp(this, "_weekdaysMinRegex")) {
              this._weekdaysMinRegex = defaultWeekdaysMinRegex;
            }
            return this._weekdaysMinStrictRegex && isStrict ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex;
          }
        }
        function computeWeekdaysParse() {
          function cmpLenRev(a3, b2) {
            return b2.length - a3.length;
          }
          var minPieces = [], shortPieces = [], longPieces = [], mixedPieces = [], i3, mom, minp, shortp, longp;
          for (i3 = 0; i3 < 7; i3++) {
            mom = createUTC([2e3, 1]).day(i3);
            minp = regexEscape(this.weekdaysMin(mom, ""));
            shortp = regexEscape(this.weekdaysShort(mom, ""));
            longp = regexEscape(this.weekdays(mom, ""));
            minPieces.push(minp);
            shortPieces.push(shortp);
            longPieces.push(longp);
            mixedPieces.push(minp);
            mixedPieces.push(shortp);
            mixedPieces.push(longp);
          }
          minPieces.sort(cmpLenRev);
          shortPieces.sort(cmpLenRev);
          longPieces.sort(cmpLenRev);
          mixedPieces.sort(cmpLenRev);
          this._weekdaysRegex = new RegExp("^(" + mixedPieces.join("|") + ")", "i");
          this._weekdaysShortRegex = this._weekdaysRegex;
          this._weekdaysMinRegex = this._weekdaysRegex;
          this._weekdaysStrictRegex = new RegExp("^(" + longPieces.join("|") + ")", "i");
          this._weekdaysShortStrictRegex = new RegExp("^(" + shortPieces.join("|") + ")", "i");
          this._weekdaysMinStrictRegex = new RegExp("^(" + minPieces.join("|") + ")", "i");
        }
        function hFormat() {
          return this.hours() % 12 || 12;
        }
        function kFormat() {
          return this.hours() || 24;
        }
        addFormatToken("H", ["HH", 2], 0, "hour");
        addFormatToken("h", ["hh", 2], 0, hFormat);
        addFormatToken("k", ["kk", 2], 0, kFormat);
        addFormatToken("hmm", 0, 0, function() {
          return "" + hFormat.apply(this) + zeroFill(this.minutes(), 2);
        });
        addFormatToken("hmmss", 0, 0, function() {
          return "" + hFormat.apply(this) + zeroFill(this.minutes(), 2) + zeroFill(this.seconds(), 2);
        });
        addFormatToken("Hmm", 0, 0, function() {
          return "" + this.hours() + zeroFill(this.minutes(), 2);
        });
        addFormatToken("Hmmss", 0, 0, function() {
          return "" + this.hours() + zeroFill(this.minutes(), 2) + zeroFill(this.seconds(), 2);
        });
        function meridiem(token2, lowercase) {
          addFormatToken(token2, 0, 0, function() {
            return this.localeData().meridiem(this.hours(), this.minutes(), lowercase);
          });
        }
        meridiem("a", true);
        meridiem("A", false);
        addUnitAlias("hour", "h");
        addUnitPriority("hour", 13);
        function matchMeridiem(isStrict, locale2) {
          return locale2._meridiemParse;
        }
        addRegexToken("a", matchMeridiem);
        addRegexToken("A", matchMeridiem);
        addRegexToken("H", match1to2);
        addRegexToken("h", match1to2);
        addRegexToken("k", match1to2);
        addRegexToken("HH", match1to2, match2);
        addRegexToken("hh", match1to2, match2);
        addRegexToken("kk", match1to2, match2);
        addRegexToken("hmm", match3to4);
        addRegexToken("hmmss", match5to6);
        addRegexToken("Hmm", match3to4);
        addRegexToken("Hmmss", match5to6);
        addParseToken(["H", "HH"], HOUR);
        addParseToken(["k", "kk"], function(input, array, config3) {
          var kInput = toInt(input);
          array[HOUR] = kInput === 24 ? 0 : kInput;
        });
        addParseToken(["a", "A"], function(input, array, config3) {
          config3._isPm = config3._locale.isPM(input);
          config3._meridiem = input;
        });
        addParseToken(["h", "hh"], function(input, array, config3) {
          array[HOUR] = toInt(input);
          getParsingFlags(config3).bigHour = true;
        });
        addParseToken("hmm", function(input, array, config3) {
          var pos = input.length - 2;
          array[HOUR] = toInt(input.substr(0, pos));
          array[MINUTE] = toInt(input.substr(pos));
          getParsingFlags(config3).bigHour = true;
        });
        addParseToken("hmmss", function(input, array, config3) {
          var pos1 = input.length - 4, pos2 = input.length - 2;
          array[HOUR] = toInt(input.substr(0, pos1));
          array[MINUTE] = toInt(input.substr(pos1, 2));
          array[SECOND] = toInt(input.substr(pos2));
          getParsingFlags(config3).bigHour = true;
        });
        addParseToken("Hmm", function(input, array, config3) {
          var pos = input.length - 2;
          array[HOUR] = toInt(input.substr(0, pos));
          array[MINUTE] = toInt(input.substr(pos));
        });
        addParseToken("Hmmss", function(input, array, config3) {
          var pos1 = input.length - 4, pos2 = input.length - 2;
          array[HOUR] = toInt(input.substr(0, pos1));
          array[MINUTE] = toInt(input.substr(pos1, 2));
          array[SECOND] = toInt(input.substr(pos2));
        });
        function localeIsPM(input) {
          return (input + "").toLowerCase().charAt(0) === "p";
        }
        var defaultLocaleMeridiemParse = /[ap]\.?m?\.?/i, getSetHour = makeGetSet("Hours", true);
        function localeMeridiem(hours2, minutes2, isLower) {
          if (hours2 > 11) {
            return isLower ? "pm" : "PM";
          } else {
            return isLower ? "am" : "AM";
          }
        }
        var baseConfig = {
          calendar: defaultCalendar,
          longDateFormat: defaultLongDateFormat,
          invalidDate: defaultInvalidDate,
          ordinal: defaultOrdinal,
          dayOfMonthOrdinalParse: defaultDayOfMonthOrdinalParse,
          relativeTime: defaultRelativeTime,
          months: defaultLocaleMonths,
          monthsShort: defaultLocaleMonthsShort,
          week: defaultLocaleWeek,
          weekdays: defaultLocaleWeekdays,
          weekdaysMin: defaultLocaleWeekdaysMin,
          weekdaysShort: defaultLocaleWeekdaysShort,
          meridiemParse: defaultLocaleMeridiemParse
        };
        var locales = {}, localeFamilies = {}, globalLocale;
        function commonPrefix(arr1, arr2) {
          var i3, minl = Math.min(arr1.length, arr2.length);
          for (i3 = 0; i3 < minl; i3 += 1) {
            if (arr1[i3] !== arr2[i3]) {
              return i3;
            }
          }
          return minl;
        }
        function normalizeLocale(key) {
          return key ? key.toLowerCase().replace("_", "-") : key;
        }
        function chooseLocale(names) {
          var i3 = 0, j3, next, locale2, split;
          while (i3 < names.length) {
            split = normalizeLocale(names[i3]).split("-");
            j3 = split.length;
            next = normalizeLocale(names[i3 + 1]);
            next = next ? next.split("-") : null;
            while (j3 > 0) {
              locale2 = loadLocale(split.slice(0, j3).join("-"));
              if (locale2) {
                return locale2;
              }
              if (next && next.length >= j3 && commonPrefix(split, next) >= j3 - 1) {
                break;
              }
              j3--;
            }
            i3++;
          }
          return globalLocale;
        }
        function loadLocale(name106) {
          var oldLocale = null, aliasedRequire;
          if (locales[name106] === void 0 && typeof module !== "undefined" && module && module.exports) {
            try {
              oldLocale = globalLocale._abbr;
              aliasedRequire = __require;
              aliasedRequire("./locale/" + name106);
              getSetGlobalLocale(oldLocale);
            } catch (e5) {
              locales[name106] = null;
            }
          }
          return locales[name106];
        }
        function getSetGlobalLocale(key, values2) {
          var data;
          if (key) {
            if (isUndefined2(values2)) {
              data = getLocale(key);
            } else {
              data = defineLocale(key, values2);
            }
            if (data) {
              globalLocale = data;
            } else {
              if (typeof console !== "undefined" && console.warn) {
                console.warn("Locale " + key + " not found. Did you forget to load it?");
              }
            }
          }
          return globalLocale._abbr;
        }
        function defineLocale(name106, config3) {
          if (config3 !== null) {
            var locale2, parentConfig = baseConfig;
            config3.abbr = name106;
            if (locales[name106] != null) {
              deprecateSimple("defineLocaleOverride", "use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info.");
              parentConfig = locales[name106]._config;
            } else if (config3.parentLocale != null) {
              if (locales[config3.parentLocale] != null) {
                parentConfig = locales[config3.parentLocale]._config;
              } else {
                locale2 = loadLocale(config3.parentLocale);
                if (locale2 != null) {
                  parentConfig = locale2._config;
                } else {
                  if (!localeFamilies[config3.parentLocale]) {
                    localeFamilies[config3.parentLocale] = [];
                  }
                  localeFamilies[config3.parentLocale].push({
                    name: name106,
                    config: config3
                  });
                  return null;
                }
              }
            }
            locales[name106] = new Locale(mergeConfigs(parentConfig, config3));
            if (localeFamilies[name106]) {
              localeFamilies[name106].forEach(function(x3) {
                defineLocale(x3.name, x3.config);
              });
            }
            getSetGlobalLocale(name106);
            return locales[name106];
          } else {
            delete locales[name106];
            return null;
          }
        }
        function updateLocale(name106, config3) {
          if (config3 != null) {
            var locale2, tmpLocale, parentConfig = baseConfig;
            if (locales[name106] != null && locales[name106].parentLocale != null) {
              locales[name106].set(mergeConfigs(locales[name106]._config, config3));
            } else {
              tmpLocale = loadLocale(name106);
              if (tmpLocale != null) {
                parentConfig = tmpLocale._config;
              }
              config3 = mergeConfigs(parentConfig, config3);
              if (tmpLocale == null) {
                config3.abbr = name106;
              }
              locale2 = new Locale(config3);
              locale2.parentLocale = locales[name106];
              locales[name106] = locale2;
            }
            getSetGlobalLocale(name106);
          } else {
            if (locales[name106] != null) {
              if (locales[name106].parentLocale != null) {
                locales[name106] = locales[name106].parentLocale;
                if (name106 === getSetGlobalLocale()) {
                  getSetGlobalLocale(name106);
                }
              } else if (locales[name106] != null) {
                delete locales[name106];
              }
            }
          }
          return locales[name106];
        }
        function getLocale(key) {
          var locale2;
          if (key && key._locale && key._locale._abbr) {
            key = key._locale._abbr;
          }
          if (!key) {
            return globalLocale;
          }
          if (!isArray2(key)) {
            locale2 = loadLocale(key);
            if (locale2) {
              return locale2;
            }
            key = [key];
          }
          return chooseLocale(key);
        }
        function listLocales() {
          return keys(locales);
        }
        function checkOverflow(m3) {
          var overflow, a3 = m3._a;
          if (a3 && getParsingFlags(m3).overflow === -2) {
            overflow = a3[MONTH] < 0 || a3[MONTH] > 11 ? MONTH : a3[DATE] < 1 || a3[DATE] > daysInMonth(a3[YEAR], a3[MONTH]) ? DATE : a3[HOUR] < 0 || a3[HOUR] > 24 || a3[HOUR] === 24 && (a3[MINUTE] !== 0 || a3[SECOND] !== 0 || a3[MILLISECOND] !== 0) ? HOUR : a3[MINUTE] < 0 || a3[MINUTE] > 59 ? MINUTE : a3[SECOND] < 0 || a3[SECOND] > 59 ? SECOND : a3[MILLISECOND] < 0 || a3[MILLISECOND] > 999 ? MILLISECOND : -1;
            if (getParsingFlags(m3)._overflowDayOfYear && (overflow < YEAR || overflow > DATE)) {
              overflow = DATE;
            }
            if (getParsingFlags(m3)._overflowWeeks && overflow === -1) {
              overflow = WEEK;
            }
            if (getParsingFlags(m3)._overflowWeekday && overflow === -1) {
              overflow = WEEKDAY;
            }
            getParsingFlags(m3).overflow = overflow;
          }
          return m3;
        }
        var extendedIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/, basicIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/, tzRegex = /Z|[+-]\d\d(?::?\d\d)?/, isoDates = [
          ["YYYYYY-MM-DD", /[+-]\d{6}-\d\d-\d\d/],
          ["YYYY-MM-DD", /\d{4}-\d\d-\d\d/],
          ["GGGG-[W]WW-E", /\d{4}-W\d\d-\d/],
          ["GGGG-[W]WW", /\d{4}-W\d\d/, false],
          ["YYYY-DDD", /\d{4}-\d{3}/],
          ["YYYY-MM", /\d{4}-\d\d/, false],
          ["YYYYYYMMDD", /[+-]\d{10}/],
          ["YYYYMMDD", /\d{8}/],
          ["GGGG[W]WWE", /\d{4}W\d{3}/],
          ["GGGG[W]WW", /\d{4}W\d{2}/, false],
          ["YYYYDDD", /\d{7}/],
          ["YYYYMM", /\d{6}/, false],
          ["YYYY", /\d{4}/, false]
        ], isoTimes = [
          ["HH:mm:ss.SSSS", /\d\d:\d\d:\d\d\.\d+/],
          ["HH:mm:ss,SSSS", /\d\d:\d\d:\d\d,\d+/],
          ["HH:mm:ss", /\d\d:\d\d:\d\d/],
          ["HH:mm", /\d\d:\d\d/],
          ["HHmmss.SSSS", /\d\d\d\d\d\d\.\d+/],
          ["HHmmss,SSSS", /\d\d\d\d\d\d,\d+/],
          ["HHmmss", /\d\d\d\d\d\d/],
          ["HHmm", /\d\d\d\d/],
          ["HH", /\d\d/]
        ], aspNetJsonRegex = /^\/?Date\((-?\d+)/i, rfc2822 = /^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/, obsOffsets = {
          UT: 0,
          GMT: 0,
          EDT: -4 * 60,
          EST: -5 * 60,
          CDT: -5 * 60,
          CST: -6 * 60,
          MDT: -6 * 60,
          MST: -7 * 60,
          PDT: -7 * 60,
          PST: -8 * 60
        };
        function configFromISO(config3) {
          var i3, l3, string2 = config3._i, match = extendedIsoRegex.exec(string2) || basicIsoRegex.exec(string2), allowTime, dateFormat, timeFormat, tzFormat;
          if (match) {
            getParsingFlags(config3).iso = true;
            for (i3 = 0, l3 = isoDates.length; i3 < l3; i3++) {
              if (isoDates[i3][1].exec(match[1])) {
                dateFormat = isoDates[i3][0];
                allowTime = isoDates[i3][2] !== false;
                break;
              }
            }
            if (dateFormat == null) {
              config3._isValid = false;
              return;
            }
            if (match[3]) {
              for (i3 = 0, l3 = isoTimes.length; i3 < l3; i3++) {
                if (isoTimes[i3][1].exec(match[3])) {
                  timeFormat = (match[2] || " ") + isoTimes[i3][0];
                  break;
                }
              }
              if (timeFormat == null) {
                config3._isValid = false;
                return;
              }
            }
            if (!allowTime && timeFormat != null) {
              config3._isValid = false;
              return;
            }
            if (match[4]) {
              if (tzRegex.exec(match[4])) {
                tzFormat = "Z";
              } else {
                config3._isValid = false;
                return;
              }
            }
            config3._f = dateFormat + (timeFormat || "") + (tzFormat || "");
            configFromStringAndFormat(config3);
          } else {
            config3._isValid = false;
          }
        }
        function extractFromRFC2822Strings(yearStr, monthStr, dayStr, hourStr, minuteStr, secondStr) {
          var result = [
            untruncateYear(yearStr),
            defaultLocaleMonthsShort.indexOf(monthStr),
            parseInt(dayStr, 10),
            parseInt(hourStr, 10),
            parseInt(minuteStr, 10)
          ];
          if (secondStr) {
            result.push(parseInt(secondStr, 10));
          }
          return result;
        }
        function untruncateYear(yearStr) {
          var year = parseInt(yearStr, 10);
          if (year <= 49) {
            return 2e3 + year;
          } else if (year <= 999) {
            return 1900 + year;
          }
          return year;
        }
        function preprocessRFC2822(s3) {
          return s3.replace(/\([^)]*\)|[\n\t]/g, " ").replace(/(\s\s+)/g, " ").replace(/^\s\s*/, "").replace(/\s\s*$/, "");
        }
        function checkWeekday(weekdayStr, parsedInput, config3) {
          if (weekdayStr) {
            var weekdayProvided = defaultLocaleWeekdaysShort.indexOf(weekdayStr), weekdayActual = new Date(parsedInput[0], parsedInput[1], parsedInput[2]).getDay();
            if (weekdayProvided !== weekdayActual) {
              getParsingFlags(config3).weekdayMismatch = true;
              config3._isValid = false;
              return false;
            }
          }
          return true;
        }
        function calculateOffset(obsOffset, militaryOffset, numOffset) {
          if (obsOffset) {
            return obsOffsets[obsOffset];
          } else if (militaryOffset) {
            return 0;
          } else {
            var hm = parseInt(numOffset, 10), m3 = hm % 100, h2 = (hm - m3) / 100;
            return h2 * 60 + m3;
          }
        }
        function configFromRFC2822(config3) {
          var match = rfc2822.exec(preprocessRFC2822(config3._i)), parsedArray;
          if (match) {
            parsedArray = extractFromRFC2822Strings(match[4], match[3], match[2], match[5], match[6], match[7]);
            if (!checkWeekday(match[1], parsedArray, config3)) {
              return;
            }
            config3._a = parsedArray;
            config3._tzm = calculateOffset(match[8], match[9], match[10]);
            config3._d = createUTCDate.apply(null, config3._a);
            config3._d.setUTCMinutes(config3._d.getUTCMinutes() - config3._tzm);
            getParsingFlags(config3).rfc2822 = true;
          } else {
            config3._isValid = false;
          }
        }
        function configFromString(config3) {
          var matched = aspNetJsonRegex.exec(config3._i);
          if (matched !== null) {
            config3._d = new Date(+matched[1]);
            return;
          }
          configFromISO(config3);
          if (config3._isValid === false) {
            delete config3._isValid;
          } else {
            return;
          }
          configFromRFC2822(config3);
          if (config3._isValid === false) {
            delete config3._isValid;
          } else {
            return;
          }
          if (config3._strict) {
            config3._isValid = false;
          } else {
            hooks.createFromInputFallback(config3);
          }
        }
        hooks.createFromInputFallback = deprecate("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.", function(config3) {
          config3._d = new Date(config3._i + (config3._useUTC ? " UTC" : ""));
        });
        function defaults(a3, b2, c3) {
          if (a3 != null) {
            return a3;
          }
          if (b2 != null) {
            return b2;
          }
          return c3;
        }
        function currentDateArray(config3) {
          var nowValue = new Date(hooks.now());
          if (config3._useUTC) {
            return [
              nowValue.getUTCFullYear(),
              nowValue.getUTCMonth(),
              nowValue.getUTCDate()
            ];
          }
          return [nowValue.getFullYear(), nowValue.getMonth(), nowValue.getDate()];
        }
        function configFromArray(config3) {
          var i3, date2, input = [], currentDate, expectedWeekday, yearToUse;
          if (config3._d) {
            return;
          }
          currentDate = currentDateArray(config3);
          if (config3._w && config3._a[DATE] == null && config3._a[MONTH] == null) {
            dayOfYearFromWeekInfo(config3);
          }
          if (config3._dayOfYear != null) {
            yearToUse = defaults(config3._a[YEAR], currentDate[YEAR]);
            if (config3._dayOfYear > daysInYear(yearToUse) || config3._dayOfYear === 0) {
              getParsingFlags(config3)._overflowDayOfYear = true;
            }
            date2 = createUTCDate(yearToUse, 0, config3._dayOfYear);
            config3._a[MONTH] = date2.getUTCMonth();
            config3._a[DATE] = date2.getUTCDate();
          }
          for (i3 = 0; i3 < 3 && config3._a[i3] == null; ++i3) {
            config3._a[i3] = input[i3] = currentDate[i3];
          }
          for (; i3 < 7; i3++) {
            config3._a[i3] = input[i3] = config3._a[i3] == null ? i3 === 2 ? 1 : 0 : config3._a[i3];
          }
          if (config3._a[HOUR] === 24 && config3._a[MINUTE] === 0 && config3._a[SECOND] === 0 && config3._a[MILLISECOND] === 0) {
            config3._nextDay = true;
            config3._a[HOUR] = 0;
          }
          config3._d = (config3._useUTC ? createUTCDate : createDate).apply(null, input);
          expectedWeekday = config3._useUTC ? config3._d.getUTCDay() : config3._d.getDay();
          if (config3._tzm != null) {
            config3._d.setUTCMinutes(config3._d.getUTCMinutes() - config3._tzm);
          }
          if (config3._nextDay) {
            config3._a[HOUR] = 24;
          }
          if (config3._w && typeof config3._w.d !== "undefined" && config3._w.d !== expectedWeekday) {
            getParsingFlags(config3).weekdayMismatch = true;
          }
        }
        function dayOfYearFromWeekInfo(config3) {
          var w3, weekYear, week, weekday, dow, doy, temp, weekdayOverflow, curWeek;
          w3 = config3._w;
          if (w3.GG != null || w3.W != null || w3.E != null) {
            dow = 1;
            doy = 4;
            weekYear = defaults(w3.GG, config3._a[YEAR], weekOfYear(createLocal(), 1, 4).year);
            week = defaults(w3.W, 1);
            weekday = defaults(w3.E, 1);
            if (weekday < 1 || weekday > 7) {
              weekdayOverflow = true;
            }
          } else {
            dow = config3._locale._week.dow;
            doy = config3._locale._week.doy;
            curWeek = weekOfYear(createLocal(), dow, doy);
            weekYear = defaults(w3.gg, config3._a[YEAR], curWeek.year);
            week = defaults(w3.w, curWeek.week);
            if (w3.d != null) {
              weekday = w3.d;
              if (weekday < 0 || weekday > 6) {
                weekdayOverflow = true;
              }
            } else if (w3.e != null) {
              weekday = w3.e + dow;
              if (w3.e < 0 || w3.e > 6) {
                weekdayOverflow = true;
              }
            } else {
              weekday = dow;
            }
          }
          if (week < 1 || week > weeksInYear(weekYear, dow, doy)) {
            getParsingFlags(config3)._overflowWeeks = true;
          } else if (weekdayOverflow != null) {
            getParsingFlags(config3)._overflowWeekday = true;
          } else {
            temp = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy);
            config3._a[YEAR] = temp.year;
            config3._dayOfYear = temp.dayOfYear;
          }
        }
        hooks.ISO_8601 = function() {
        };
        hooks.RFC_2822 = function() {
        };
        function configFromStringAndFormat(config3) {
          if (config3._f === hooks.ISO_8601) {
            configFromISO(config3);
            return;
          }
          if (config3._f === hooks.RFC_2822) {
            configFromRFC2822(config3);
            return;
          }
          config3._a = [];
          getParsingFlags(config3).empty = true;
          var string2 = "" + config3._i, i3, parsedInput, tokens2, token2, skipped, stringLength = string2.length, totalParsedInputLength = 0, era;
          tokens2 = expandFormat(config3._f, config3._locale).match(formattingTokens) || [];
          for (i3 = 0; i3 < tokens2.length; i3++) {
            token2 = tokens2[i3];
            parsedInput = (string2.match(getParseRegexForToken(token2, config3)) || [])[0];
            if (parsedInput) {
              skipped = string2.substr(0, string2.indexOf(parsedInput));
              if (skipped.length > 0) {
                getParsingFlags(config3).unusedInput.push(skipped);
              }
              string2 = string2.slice(string2.indexOf(parsedInput) + parsedInput.length);
              totalParsedInputLength += parsedInput.length;
            }
            if (formatTokenFunctions[token2]) {
              if (parsedInput) {
                getParsingFlags(config3).empty = false;
              } else {
                getParsingFlags(config3).unusedTokens.push(token2);
              }
              addTimeToArrayFromToken(token2, parsedInput, config3);
            } else if (config3._strict && !parsedInput) {
              getParsingFlags(config3).unusedTokens.push(token2);
            }
          }
          getParsingFlags(config3).charsLeftOver = stringLength - totalParsedInputLength;
          if (string2.length > 0) {
            getParsingFlags(config3).unusedInput.push(string2);
          }
          if (config3._a[HOUR] <= 12 && getParsingFlags(config3).bigHour === true && config3._a[HOUR] > 0) {
            getParsingFlags(config3).bigHour = void 0;
          }
          getParsingFlags(config3).parsedDateParts = config3._a.slice(0);
          getParsingFlags(config3).meridiem = config3._meridiem;
          config3._a[HOUR] = meridiemFixWrap(config3._locale, config3._a[HOUR], config3._meridiem);
          era = getParsingFlags(config3).era;
          if (era !== null) {
            config3._a[YEAR] = config3._locale.erasConvertYear(era, config3._a[YEAR]);
          }
          configFromArray(config3);
          checkOverflow(config3);
        }
        function meridiemFixWrap(locale2, hour, meridiem2) {
          var isPm;
          if (meridiem2 == null) {
            return hour;
          }
          if (locale2.meridiemHour != null) {
            return locale2.meridiemHour(hour, meridiem2);
          } else if (locale2.isPM != null) {
            isPm = locale2.isPM(meridiem2);
            if (isPm && hour < 12) {
              hour += 12;
            }
            if (!isPm && hour === 12) {
              hour = 0;
            }
            return hour;
          } else {
            return hour;
          }
        }
        function configFromStringAndArray(config3) {
          var tempConfig, bestMoment, scoreToBeat, i3, currentScore, validFormatFound, bestFormatIsValid = false;
          if (config3._f.length === 0) {
            getParsingFlags(config3).invalidFormat = true;
            config3._d = new Date(NaN);
            return;
          }
          for (i3 = 0; i3 < config3._f.length; i3++) {
            currentScore = 0;
            validFormatFound = false;
            tempConfig = copyConfig({}, config3);
            if (config3._useUTC != null) {
              tempConfig._useUTC = config3._useUTC;
            }
            tempConfig._f = config3._f[i3];
            configFromStringAndFormat(tempConfig);
            if (isValid(tempConfig)) {
              validFormatFound = true;
            }
            currentScore += getParsingFlags(tempConfig).charsLeftOver;
            currentScore += getParsingFlags(tempConfig).unusedTokens.length * 10;
            getParsingFlags(tempConfig).score = currentScore;
            if (!bestFormatIsValid) {
              if (scoreToBeat == null || currentScore < scoreToBeat || validFormatFound) {
                scoreToBeat = currentScore;
                bestMoment = tempConfig;
                if (validFormatFound) {
                  bestFormatIsValid = true;
                }
              }
            } else {
              if (currentScore < scoreToBeat) {
                scoreToBeat = currentScore;
                bestMoment = tempConfig;
              }
            }
          }
          extend2(config3, bestMoment || tempConfig);
        }
        function configFromObject(config3) {
          if (config3._d) {
            return;
          }
          var i3 = normalizeObjectUnits(config3._i), dayOrDate = i3.day === void 0 ? i3.date : i3.day;
          config3._a = map3([i3.year, i3.month, dayOrDate, i3.hour, i3.minute, i3.second, i3.millisecond], function(obj) {
            return obj && parseInt(obj, 10);
          });
          configFromArray(config3);
        }
        function createFromConfig(config3) {
          var res = new Moment(checkOverflow(prepareConfig(config3)));
          if (res._nextDay) {
            res.add(1, "d");
            res._nextDay = void 0;
          }
          return res;
        }
        function prepareConfig(config3) {
          var input = config3._i, format6 = config3._f;
          config3._locale = config3._locale || getLocale(config3._l);
          if (input === null || format6 === void 0 && input === "") {
            return createInvalid({ nullInput: true });
          }
          if (typeof input === "string") {
            config3._i = input = config3._locale.preparse(input);
          }
          if (isMoment(input)) {
            return new Moment(checkOverflow(input));
          } else if (isDate2(input)) {
            config3._d = input;
          } else if (isArray2(format6)) {
            configFromStringAndArray(config3);
          } else if (format6) {
            configFromStringAndFormat(config3);
          } else {
            configFromInput(config3);
          }
          if (!isValid(config3)) {
            config3._d = null;
          }
          return config3;
        }
        function configFromInput(config3) {
          var input = config3._i;
          if (isUndefined2(input)) {
            config3._d = new Date(hooks.now());
          } else if (isDate2(input)) {
            config3._d = new Date(input.valueOf());
          } else if (typeof input === "string") {
            configFromString(config3);
          } else if (isArray2(input)) {
            config3._a = map3(input.slice(0), function(obj) {
              return parseInt(obj, 10);
            });
            configFromArray(config3);
          } else if (isObject2(input)) {
            configFromObject(config3);
          } else if (isNumber2(input)) {
            config3._d = new Date(input);
          } else {
            hooks.createFromInputFallback(config3);
          }
        }
        function createLocalOrUTC(input, format6, locale2, strict, isUTC) {
          var c3 = {};
          if (format6 === true || format6 === false) {
            strict = format6;
            format6 = void 0;
          }
          if (locale2 === true || locale2 === false) {
            strict = locale2;
            locale2 = void 0;
          }
          if (isObject2(input) && isObjectEmpty(input) || isArray2(input) && input.length === 0) {
            input = void 0;
          }
          c3._isAMomentObject = true;
          c3._useUTC = c3._isUTC = isUTC;
          c3._l = locale2;
          c3._i = input;
          c3._f = format6;
          c3._strict = strict;
          return createFromConfig(c3);
        }
        function createLocal(input, format6, locale2, strict) {
          return createLocalOrUTC(input, format6, locale2, strict, false);
        }
        var prototypeMin = deprecate("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/", function() {
          var other = createLocal.apply(null, arguments);
          if (this.isValid() && other.isValid()) {
            return other < this ? this : other;
          } else {
            return createInvalid();
          }
        }), prototypeMax = deprecate("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/", function() {
          var other = createLocal.apply(null, arguments);
          if (this.isValid() && other.isValid()) {
            return other > this ? this : other;
          } else {
            return createInvalid();
          }
        });
        function pickBy(fn, moments) {
          var res, i3;
          if (moments.length === 1 && isArray2(moments[0])) {
            moments = moments[0];
          }
          if (!moments.length) {
            return createLocal();
          }
          res = moments[0];
          for (i3 = 1; i3 < moments.length; ++i3) {
            if (!moments[i3].isValid() || moments[i3][fn](res)) {
              res = moments[i3];
            }
          }
          return res;
        }
        function min2() {
          var args = [].slice.call(arguments, 0);
          return pickBy("isBefore", args);
        }
        function max2() {
          var args = [].slice.call(arguments, 0);
          return pickBy("isAfter", args);
        }
        var now = function() {
          return Date.now ? Date.now() : +new Date();
        };
        var ordering = [
          "year",
          "quarter",
          "month",
          "week",
          "day",
          "hour",
          "minute",
          "second",
          "millisecond"
        ];
        function isDurationValid(m3) {
          var key, unitHasDecimal = false, i3;
          for (key in m3) {
            if (hasOwnProp(m3, key) && !(indexOf.call(ordering, key) !== -1 && (m3[key] == null || !isNaN(m3[key])))) {
              return false;
            }
          }
          for (i3 = 0; i3 < ordering.length; ++i3) {
            if (m3[ordering[i3]]) {
              if (unitHasDecimal) {
                return false;
              }
              if (parseFloat(m3[ordering[i3]]) !== toInt(m3[ordering[i3]])) {
                unitHasDecimal = true;
              }
            }
          }
          return true;
        }
        function isValid$1() {
          return this._isValid;
        }
        function createInvalid$1() {
          return createDuration(NaN);
        }
        function Duration(duration) {
          var normalizedInput = normalizeObjectUnits(duration), years2 = normalizedInput.year || 0, quarters = normalizedInput.quarter || 0, months2 = normalizedInput.month || 0, weeks2 = normalizedInput.week || normalizedInput.isoWeek || 0, days2 = normalizedInput.day || 0, hours2 = normalizedInput.hour || 0, minutes2 = normalizedInput.minute || 0, seconds2 = normalizedInput.second || 0, milliseconds2 = normalizedInput.millisecond || 0;
          this._isValid = isDurationValid(normalizedInput);
          this._milliseconds = +milliseconds2 + seconds2 * 1e3 + minutes2 * 6e4 + hours2 * 1e3 * 60 * 60;
          this._days = +days2 + weeks2 * 7;
          this._months = +months2 + quarters * 3 + years2 * 12;
          this._data = {};
          this._locale = getLocale();
          this._bubble();
        }
        function isDuration(obj) {
          return obj instanceof Duration;
        }
        function absRound(number2) {
          if (number2 < 0) {
            return Math.round(-1 * number2) * -1;
          } else {
            return Math.round(number2);
          }
        }
        function compareArrays(array1, array2, dontConvert) {
          var len = Math.min(array1.length, array2.length), lengthDiff = Math.abs(array1.length - array2.length), diffs = 0, i3;
          for (i3 = 0; i3 < len; i3++) {
            if (dontConvert && array1[i3] !== array2[i3] || !dontConvert && toInt(array1[i3]) !== toInt(array2[i3])) {
              diffs++;
            }
          }
          return diffs + lengthDiff;
        }
        function offset(token2, separator) {
          addFormatToken(token2, 0, 0, function() {
            var offset2 = this.utcOffset(), sign4 = "+";
            if (offset2 < 0) {
              offset2 = -offset2;
              sign4 = "-";
            }
            return sign4 + zeroFill(~~(offset2 / 60), 2) + separator + zeroFill(~~offset2 % 60, 2);
          });
        }
        offset("Z", ":");
        offset("ZZ", "");
        addRegexToken("Z", matchShortOffset);
        addRegexToken("ZZ", matchShortOffset);
        addParseToken(["Z", "ZZ"], function(input, array, config3) {
          config3._useUTC = true;
          config3._tzm = offsetFromString(matchShortOffset, input);
        });
        var chunkOffset = /([\+\-]|\d\d)/gi;
        function offsetFromString(matcher, string2) {
          var matches = (string2 || "").match(matcher), chunk, parts, minutes2;
          if (matches === null) {
            return null;
          }
          chunk = matches[matches.length - 1] || [];
          parts = (chunk + "").match(chunkOffset) || ["-", 0, 0];
          minutes2 = +(parts[1] * 60) + toInt(parts[2]);
          return minutes2 === 0 ? 0 : parts[0] === "+" ? minutes2 : -minutes2;
        }
        function cloneWithOffset(input, model) {
          var res, diff2;
          if (model._isUTC) {
            res = model.clone();
            diff2 = (isMoment(input) || isDate2(input) ? input.valueOf() : createLocal(input).valueOf()) - res.valueOf();
            res._d.setTime(res._d.valueOf() + diff2);
            hooks.updateOffset(res, false);
            return res;
          } else {
            return createLocal(input).local();
          }
        }
        function getDateOffset(m3) {
          return -Math.round(m3._d.getTimezoneOffset());
        }
        hooks.updateOffset = function() {
        };
        function getSetOffset(input, keepLocalTime, keepMinutes) {
          var offset2 = this._offset || 0, localAdjust;
          if (!this.isValid()) {
            return input != null ? this : NaN;
          }
          if (input != null) {
            if (typeof input === "string") {
              input = offsetFromString(matchShortOffset, input);
              if (input === null) {
                return this;
              }
            } else if (Math.abs(input) < 16 && !keepMinutes) {
              input = input * 60;
            }
            if (!this._isUTC && keepLocalTime) {
              localAdjust = getDateOffset(this);
            }
            this._offset = input;
            this._isUTC = true;
            if (localAdjust != null) {
              this.add(localAdjust, "m");
            }
            if (offset2 !== input) {
              if (!keepLocalTime || this._changeInProgress) {
                addSubtract(this, createDuration(input - offset2, "m"), 1, false);
              } else if (!this._changeInProgress) {
                this._changeInProgress = true;
                hooks.updateOffset(this, true);
                this._changeInProgress = null;
              }
            }
            return this;
          } else {
            return this._isUTC ? offset2 : getDateOffset(this);
          }
        }
        function getSetZone(input, keepLocalTime) {
          if (input != null) {
            if (typeof input !== "string") {
              input = -input;
            }
            this.utcOffset(input, keepLocalTime);
            return this;
          } else {
            return -this.utcOffset();
          }
        }
        function setOffsetToUTC(keepLocalTime) {
          return this.utcOffset(0, keepLocalTime);
        }
        function setOffsetToLocal(keepLocalTime) {
          if (this._isUTC) {
            this.utcOffset(0, keepLocalTime);
            this._isUTC = false;
            if (keepLocalTime) {
              this.subtract(getDateOffset(this), "m");
            }
          }
          return this;
        }
        function setOffsetToParsedOffset() {
          if (this._tzm != null) {
            this.utcOffset(this._tzm, false, true);
          } else if (typeof this._i === "string") {
            var tZone = offsetFromString(matchOffset, this._i);
            if (tZone != null) {
              this.utcOffset(tZone);
            } else {
              this.utcOffset(0, true);
            }
          }
          return this;
        }
        function hasAlignedHourOffset(input) {
          if (!this.isValid()) {
            return false;
          }
          input = input ? createLocal(input).utcOffset() : 0;
          return (this.utcOffset() - input) % 60 === 0;
        }
        function isDaylightSavingTime() {
          return this.utcOffset() > this.clone().month(0).utcOffset() || this.utcOffset() > this.clone().month(5).utcOffset();
        }
        function isDaylightSavingTimeShifted() {
          if (!isUndefined2(this._isDSTShifted)) {
            return this._isDSTShifted;
          }
          var c3 = {}, other;
          copyConfig(c3, this);
          c3 = prepareConfig(c3);
          if (c3._a) {
            other = c3._isUTC ? createUTC(c3._a) : createLocal(c3._a);
            this._isDSTShifted = this.isValid() && compareArrays(c3._a, other.toArray()) > 0;
          } else {
            this._isDSTShifted = false;
          }
          return this._isDSTShifted;
        }
        function isLocal() {
          return this.isValid() ? !this._isUTC : false;
        }
        function isUtcOffset() {
          return this.isValid() ? this._isUTC : false;
        }
        function isUtc() {
          return this.isValid() ? this._isUTC && this._offset === 0 : false;
        }
        var aspNetRegex = /^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/, isoRegex = /^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;
        function createDuration(input, key) {
          var duration = input, match = null, sign4, ret, diffRes;
          if (isDuration(input)) {
            duration = {
              ms: input._milliseconds,
              d: input._days,
              M: input._months
            };
          } else if (isNumber2(input) || !isNaN(+input)) {
            duration = {};
            if (key) {
              duration[key] = +input;
            } else {
              duration.milliseconds = +input;
            }
          } else if (match = aspNetRegex.exec(input)) {
            sign4 = match[1] === "-" ? -1 : 1;
            duration = {
              y: 0,
              d: toInt(match[DATE]) * sign4,
              h: toInt(match[HOUR]) * sign4,
              m: toInt(match[MINUTE]) * sign4,
              s: toInt(match[SECOND]) * sign4,
              ms: toInt(absRound(match[MILLISECOND] * 1e3)) * sign4
            };
          } else if (match = isoRegex.exec(input)) {
            sign4 = match[1] === "-" ? -1 : 1;
            duration = {
              y: parseIso(match[2], sign4),
              M: parseIso(match[3], sign4),
              w: parseIso(match[4], sign4),
              d: parseIso(match[5], sign4),
              h: parseIso(match[6], sign4),
              m: parseIso(match[7], sign4),
              s: parseIso(match[8], sign4)
            };
          } else if (duration == null) {
            duration = {};
          } else if (typeof duration === "object" && ("from" in duration || "to" in duration)) {
            diffRes = momentsDifference(createLocal(duration.from), createLocal(duration.to));
            duration = {};
            duration.ms = diffRes.milliseconds;
            duration.M = diffRes.months;
          }
          ret = new Duration(duration);
          if (isDuration(input) && hasOwnProp(input, "_locale")) {
            ret._locale = input._locale;
          }
          if (isDuration(input) && hasOwnProp(input, "_isValid")) {
            ret._isValid = input._isValid;
          }
          return ret;
        }
        createDuration.fn = Duration.prototype;
        createDuration.invalid = createInvalid$1;
        function parseIso(inp, sign4) {
          var res = inp && parseFloat(inp.replace(",", "."));
          return (isNaN(res) ? 0 : res) * sign4;
        }
        function positiveMomentsDifference(base, other) {
          var res = {};
          res.months = other.month() - base.month() + (other.year() - base.year()) * 12;
          if (base.clone().add(res.months, "M").isAfter(other)) {
            --res.months;
          }
          res.milliseconds = +other - +base.clone().add(res.months, "M");
          return res;
        }
        function momentsDifference(base, other) {
          var res;
          if (!(base.isValid() && other.isValid())) {
            return { milliseconds: 0, months: 0 };
          }
          other = cloneWithOffset(other, base);
          if (base.isBefore(other)) {
            res = positiveMomentsDifference(base, other);
          } else {
            res = positiveMomentsDifference(other, base);
            res.milliseconds = -res.milliseconds;
            res.months = -res.months;
          }
          return res;
        }
        function createAdder(direction, name106) {
          return function(val, period) {
            var dur, tmp;
            if (period !== null && !isNaN(+period)) {
              deprecateSimple(name106, "moment()." + name106 + "(period, number) is deprecated. Please use moment()." + name106 + "(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info.");
              tmp = val;
              val = period;
              period = tmp;
            }
            dur = createDuration(val, period);
            addSubtract(this, dur, direction);
            return this;
          };
        }
        function addSubtract(mom, duration, isAdding, updateOffset) {
          var milliseconds2 = duration._milliseconds, days2 = absRound(duration._days), months2 = absRound(duration._months);
          if (!mom.isValid()) {
            return;
          }
          updateOffset = updateOffset == null ? true : updateOffset;
          if (months2) {
            setMonth(mom, get(mom, "Month") + months2 * isAdding);
          }
          if (days2) {
            set$1(mom, "Date", get(mom, "Date") + days2 * isAdding);
          }
          if (milliseconds2) {
            mom._d.setTime(mom._d.valueOf() + milliseconds2 * isAdding);
          }
          if (updateOffset) {
            hooks.updateOffset(mom, days2 || months2);
          }
        }
        var add2 = createAdder(1, "add"), subtract2 = createAdder(-1, "subtract");
        function isString2(input) {
          return typeof input === "string" || input instanceof String;
        }
        function isMomentInput(input) {
          return isMoment(input) || isDate2(input) || isString2(input) || isNumber2(input) || isNumberOrStringArray(input) || isMomentInputObject(input) || input === null || input === void 0;
        }
        function isMomentInputObject(input) {
          var objectTest = isObject2(input) && !isObjectEmpty(input), propertyTest = false, properties2 = [
            "years",
            "year",
            "y",
            "months",
            "month",
            "M",
            "days",
            "day",
            "d",
            "dates",
            "date",
            "D",
            "hours",
            "hour",
            "h",
            "minutes",
            "minute",
            "m",
            "seconds",
            "second",
            "s",
            "milliseconds",
            "millisecond",
            "ms"
          ], i3, property;
          for (i3 = 0; i3 < properties2.length; i3 += 1) {
            property = properties2[i3];
            propertyTest = propertyTest || hasOwnProp(input, property);
          }
          return objectTest && propertyTest;
        }
        function isNumberOrStringArray(input) {
          var arrayTest = isArray2(input), dataTypeTest = false;
          if (arrayTest) {
            dataTypeTest = input.filter(function(item) {
              return !isNumber2(item) && isString2(input);
            }).length === 0;
          }
          return arrayTest && dataTypeTest;
        }
        function isCalendarSpec(input) {
          var objectTest = isObject2(input) && !isObjectEmpty(input), propertyTest = false, properties2 = [
            "sameDay",
            "nextDay",
            "lastDay",
            "nextWeek",
            "lastWeek",
            "sameElse"
          ], i3, property;
          for (i3 = 0; i3 < properties2.length; i3 += 1) {
            property = properties2[i3];
            propertyTest = propertyTest || hasOwnProp(input, property);
          }
          return objectTest && propertyTest;
        }
        function getCalendarFormat(myMoment, now2) {
          var diff2 = myMoment.diff(now2, "days", true);
          return diff2 < -6 ? "sameElse" : diff2 < -1 ? "lastWeek" : diff2 < 0 ? "lastDay" : diff2 < 1 ? "sameDay" : diff2 < 2 ? "nextDay" : diff2 < 7 ? "nextWeek" : "sameElse";
        }
        function calendar$1(time, formats) {
          if (arguments.length === 1) {
            if (!arguments[0]) {
              time = void 0;
              formats = void 0;
            } else if (isMomentInput(arguments[0])) {
              time = arguments[0];
              formats = void 0;
            } else if (isCalendarSpec(arguments[0])) {
              formats = arguments[0];
              time = void 0;
            }
          }
          var now2 = time || createLocal(), sod = cloneWithOffset(now2, this).startOf("day"), format6 = hooks.calendarFormat(this, sod) || "sameElse", output = formats && (isFunction2(formats[format6]) ? formats[format6].call(this, now2) : formats[format6]);
          return this.format(output || this.localeData().calendar(format6, this, createLocal(now2)));
        }
        function clone3() {
          return new Moment(this);
        }
        function isAfter(input, units) {
          var localInput = isMoment(input) ? input : createLocal(input);
          if (!(this.isValid() && localInput.isValid())) {
            return false;
          }
          units = normalizeUnits(units) || "millisecond";
          if (units === "millisecond") {
            return this.valueOf() > localInput.valueOf();
          } else {
            return localInput.valueOf() < this.clone().startOf(units).valueOf();
          }
        }
        function isBefore(input, units) {
          var localInput = isMoment(input) ? input : createLocal(input);
          if (!(this.isValid() && localInput.isValid())) {
            return false;
          }
          units = normalizeUnits(units) || "millisecond";
          if (units === "millisecond") {
            return this.valueOf() < localInput.valueOf();
          } else {
            return this.clone().endOf(units).valueOf() < localInput.valueOf();
          }
        }
        function isBetween(from2, to2, units, inclusivity) {
          var localFrom = isMoment(from2) ? from2 : createLocal(from2), localTo = isMoment(to2) ? to2 : createLocal(to2);
          if (!(this.isValid() && localFrom.isValid() && localTo.isValid())) {
            return false;
          }
          inclusivity = inclusivity || "()";
          return (inclusivity[0] === "(" ? this.isAfter(localFrom, units) : !this.isBefore(localFrom, units)) && (inclusivity[1] === ")" ? this.isBefore(localTo, units) : !this.isAfter(localTo, units));
        }
        function isSame(input, units) {
          var localInput = isMoment(input) ? input : createLocal(input), inputMs;
          if (!(this.isValid() && localInput.isValid())) {
            return false;
          }
          units = normalizeUnits(units) || "millisecond";
          if (units === "millisecond") {
            return this.valueOf() === localInput.valueOf();
          } else {
            inputMs = localInput.valueOf();
            return this.clone().startOf(units).valueOf() <= inputMs && inputMs <= this.clone().endOf(units).valueOf();
          }
        }
        function isSameOrAfter(input, units) {
          return this.isSame(input, units) || this.isAfter(input, units);
        }
        function isSameOrBefore(input, units) {
          return this.isSame(input, units) || this.isBefore(input, units);
        }
        function diff(input, units, asFloat) {
          var that, zoneDelta, output;
          if (!this.isValid()) {
            return NaN;
          }
          that = cloneWithOffset(input, this);
          if (!that.isValid()) {
            return NaN;
          }
          zoneDelta = (that.utcOffset() - this.utcOffset()) * 6e4;
          units = normalizeUnits(units);
          switch (units) {
            case "year":
              output = monthDiff(this, that) / 12;
              break;
            case "month":
              output = monthDiff(this, that);
              break;
            case "quarter":
              output = monthDiff(this, that) / 3;
              break;
            case "second":
              output = (this - that) / 1e3;
              break;
            case "minute":
              output = (this - that) / 6e4;
              break;
            case "hour":
              output = (this - that) / 36e5;
              break;
            case "day":
              output = (this - that - zoneDelta) / 864e5;
              break;
            case "week":
              output = (this - that - zoneDelta) / 6048e5;
              break;
            default:
              output = this - that;
          }
          return asFloat ? output : absFloor(output);
        }
        function monthDiff(a3, b2) {
          if (a3.date() < b2.date()) {
            return -monthDiff(b2, a3);
          }
          var wholeMonthDiff = (b2.year() - a3.year()) * 12 + (b2.month() - a3.month()), anchor = a3.clone().add(wholeMonthDiff, "months"), anchor2, adjust;
          if (b2 - anchor < 0) {
            anchor2 = a3.clone().add(wholeMonthDiff - 1, "months");
            adjust = (b2 - anchor) / (anchor - anchor2);
          } else {
            anchor2 = a3.clone().add(wholeMonthDiff + 1, "months");
            adjust = (b2 - anchor) / (anchor2 - anchor);
          }
          return -(wholeMonthDiff + adjust) || 0;
        }
        hooks.defaultFormat = "YYYY-MM-DDTHH:mm:ssZ";
        hooks.defaultFormatUtc = "YYYY-MM-DDTHH:mm:ss[Z]";
        function toString() {
          return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ");
        }
        function toISOString(keepOffset) {
          if (!this.isValid()) {
            return null;
          }
          var utc = keepOffset !== true, m3 = utc ? this.clone().utc() : this;
          if (m3.year() < 0 || m3.year() > 9999) {
            return formatMoment(m3, utc ? "YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYYYY-MM-DD[T]HH:mm:ss.SSSZ");
          }
          if (isFunction2(Date.prototype.toISOString)) {
            if (utc) {
              return this.toDate().toISOString();
            } else {
              return new Date(this.valueOf() + this.utcOffset() * 60 * 1e3).toISOString().replace("Z", formatMoment(m3, "Z"));
            }
          }
          return formatMoment(m3, utc ? "YYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYY-MM-DD[T]HH:mm:ss.SSSZ");
        }
        function inspect() {
          if (!this.isValid()) {
            return "moment.invalid(/* " + this._i + " */)";
          }
          var func = "moment", zone = "", prefix, year, datetime, suffix;
          if (!this.isLocal()) {
            func = this.utcOffset() === 0 ? "moment.utc" : "moment.parseZone";
            zone = "Z";
          }
          prefix = "[" + func + '("]';
          year = 0 <= this.year() && this.year() <= 9999 ? "YYYY" : "YYYYYY";
          datetime = "-MM-DD[T]HH:mm:ss.SSS";
          suffix = zone + '[")]';
          return this.format(prefix + year + datetime + suffix);
        }
        function format5(inputString) {
          if (!inputString) {
            inputString = this.isUtc() ? hooks.defaultFormatUtc : hooks.defaultFormat;
          }
          var output = formatMoment(this, inputString);
          return this.localeData().postformat(output);
        }
        function from(time, withoutSuffix) {
          if (this.isValid() && (isMoment(time) && time.isValid() || createLocal(time).isValid())) {
            return createDuration({ to: this, from: time }).locale(this.locale()).humanize(!withoutSuffix);
          } else {
            return this.localeData().invalidDate();
          }
        }
        function fromNow(withoutSuffix) {
          return this.from(createLocal(), withoutSuffix);
        }
        function to(time, withoutSuffix) {
          if (this.isValid() && (isMoment(time) && time.isValid() || createLocal(time).isValid())) {
            return createDuration({ from: this, to: time }).locale(this.locale()).humanize(!withoutSuffix);
          } else {
            return this.localeData().invalidDate();
          }
        }
        function toNow(withoutSuffix) {
          return this.to(createLocal(), withoutSuffix);
        }
        function locale(key) {
          var newLocaleData;
          if (key === void 0) {
            return this._locale._abbr;
          } else {
            newLocaleData = getLocale(key);
            if (newLocaleData != null) {
              this._locale = newLocaleData;
            }
            return this;
          }
        }
        var lang = deprecate("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.", function(key) {
          if (key === void 0) {
            return this.localeData();
          } else {
            return this.locale(key);
          }
        });
        function localeData() {
          return this._locale;
        }
        var MS_PER_SECOND = 1e3, MS_PER_MINUTE = 60 * MS_PER_SECOND, MS_PER_HOUR = 60 * MS_PER_MINUTE, MS_PER_400_YEARS = (365 * 400 + 97) * 24 * MS_PER_HOUR;
        function mod$1(dividend, divisor) {
          return (dividend % divisor + divisor) % divisor;
        }
        function localStartOfDate(y2, m3, d4) {
          if (y2 < 100 && y2 >= 0) {
            return new Date(y2 + 400, m3, d4) - MS_PER_400_YEARS;
          } else {
            return new Date(y2, m3, d4).valueOf();
          }
        }
        function utcStartOfDate(y2, m3, d4) {
          if (y2 < 100 && y2 >= 0) {
            return Date.UTC(y2 + 400, m3, d4) - MS_PER_400_YEARS;
          } else {
            return Date.UTC(y2, m3, d4);
          }
        }
        function startOf(units) {
          var time, startOfDate;
          units = normalizeUnits(units);
          if (units === void 0 || units === "millisecond" || !this.isValid()) {
            return this;
          }
          startOfDate = this._isUTC ? utcStartOfDate : localStartOfDate;
          switch (units) {
            case "year":
              time = startOfDate(this.year(), 0, 1);
              break;
            case "quarter":
              time = startOfDate(this.year(), this.month() - this.month() % 3, 1);
              break;
            case "month":
              time = startOfDate(this.year(), this.month(), 1);
              break;
            case "week":
              time = startOfDate(this.year(), this.month(), this.date() - this.weekday());
              break;
            case "isoWeek":
              time = startOfDate(this.year(), this.month(), this.date() - (this.isoWeekday() - 1));
              break;
            case "day":
            case "date":
              time = startOfDate(this.year(), this.month(), this.date());
              break;
            case "hour":
              time = this._d.valueOf();
              time -= mod$1(time + (this._isUTC ? 0 : this.utcOffset() * MS_PER_MINUTE), MS_PER_HOUR);
              break;
            case "minute":
              time = this._d.valueOf();
              time -= mod$1(time, MS_PER_MINUTE);
              break;
            case "second":
              time = this._d.valueOf();
              time -= mod$1(time, MS_PER_SECOND);
              break;
          }
          this._d.setTime(time);
          hooks.updateOffset(this, true);
          return this;
        }
        function endOf(units) {
          var time, startOfDate;
          units = normalizeUnits(units);
          if (units === void 0 || units === "millisecond" || !this.isValid()) {
            return this;
          }
          startOfDate = this._isUTC ? utcStartOfDate : localStartOfDate;
          switch (units) {
            case "year":
              time = startOfDate(this.year() + 1, 0, 1) - 1;
              break;
            case "quarter":
              time = startOfDate(this.year(), this.month() - this.month() % 3 + 3, 1) - 1;
              break;
            case "month":
              time = startOfDate(this.year(), this.month() + 1, 1) - 1;
              break;
            case "week":
              time = startOfDate(this.year(), this.month(), this.date() - this.weekday() + 7) - 1;
              break;
            case "isoWeek":
              time = startOfDate(this.year(), this.month(), this.date() - (this.isoWeekday() - 1) + 7) - 1;
              break;
            case "day":
            case "date":
              time = startOfDate(this.year(), this.month(), this.date() + 1) - 1;
              break;
            case "hour":
              time = this._d.valueOf();
              time += MS_PER_HOUR - mod$1(time + (this._isUTC ? 0 : this.utcOffset() * MS_PER_MINUTE), MS_PER_HOUR) - 1;
              break;
            case "minute":
              time = this._d.valueOf();
              time += MS_PER_MINUTE - mod$1(time, MS_PER_MINUTE) - 1;
              break;
            case "second":
              time = this._d.valueOf();
              time += MS_PER_SECOND - mod$1(time, MS_PER_SECOND) - 1;
              break;
          }
          this._d.setTime(time);
          hooks.updateOffset(this, true);
          return this;
        }
        function valueOf() {
          return this._d.valueOf() - (this._offset || 0) * 6e4;
        }
        function unix() {
          return Math.floor(this.valueOf() / 1e3);
        }
        function toDate() {
          return new Date(this.valueOf());
        }
        function toArray() {
          var m3 = this;
          return [
            m3.year(),
            m3.month(),
            m3.date(),
            m3.hour(),
            m3.minute(),
            m3.second(),
            m3.millisecond()
          ];
        }
        function toObject() {
          var m3 = this;
          return {
            years: m3.year(),
            months: m3.month(),
            date: m3.date(),
            hours: m3.hours(),
            minutes: m3.minutes(),
            seconds: m3.seconds(),
            milliseconds: m3.milliseconds()
          };
        }
        function toJSON() {
          return this.isValid() ? this.toISOString() : null;
        }
        function isValid$2() {
          return isValid(this);
        }
        function parsingFlags() {
          return extend2({}, getParsingFlags(this));
        }
        function invalidAt() {
          return getParsingFlags(this).overflow;
        }
        function creationData() {
          return {
            input: this._i,
            format: this._f,
            locale: this._locale,
            isUTC: this._isUTC,
            strict: this._strict
          };
        }
        addFormatToken("N", 0, 0, "eraAbbr");
        addFormatToken("NN", 0, 0, "eraAbbr");
        addFormatToken("NNN", 0, 0, "eraAbbr");
        addFormatToken("NNNN", 0, 0, "eraName");
        addFormatToken("NNNNN", 0, 0, "eraNarrow");
        addFormatToken("y", ["y", 1], "yo", "eraYear");
        addFormatToken("y", ["yy", 2], 0, "eraYear");
        addFormatToken("y", ["yyy", 3], 0, "eraYear");
        addFormatToken("y", ["yyyy", 4], 0, "eraYear");
        addRegexToken("N", matchEraAbbr);
        addRegexToken("NN", matchEraAbbr);
        addRegexToken("NNN", matchEraAbbr);
        addRegexToken("NNNN", matchEraName);
        addRegexToken("NNNNN", matchEraNarrow);
        addParseToken(["N", "NN", "NNN", "NNNN", "NNNNN"], function(input, array, config3, token2) {
          var era = config3._locale.erasParse(input, token2, config3._strict);
          if (era) {
            getParsingFlags(config3).era = era;
          } else {
            getParsingFlags(config3).invalidEra = input;
          }
        });
        addRegexToken("y", matchUnsigned);
        addRegexToken("yy", matchUnsigned);
        addRegexToken("yyy", matchUnsigned);
        addRegexToken("yyyy", matchUnsigned);
        addRegexToken("yo", matchEraYearOrdinal);
        addParseToken(["y", "yy", "yyy", "yyyy"], YEAR);
        addParseToken(["yo"], function(input, array, config3, token2) {
          var match;
          if (config3._locale._eraYearOrdinalRegex) {
            match = input.match(config3._locale._eraYearOrdinalRegex);
          }
          if (config3._locale.eraYearOrdinalParse) {
            array[YEAR] = config3._locale.eraYearOrdinalParse(input, match);
          } else {
            array[YEAR] = parseInt(input, 10);
          }
        });
        function localeEras(m3, format6) {
          var i3, l3, date2, eras = this._eras || getLocale("en")._eras;
          for (i3 = 0, l3 = eras.length; i3 < l3; ++i3) {
            switch (typeof eras[i3].since) {
              case "string":
                date2 = hooks(eras[i3].since).startOf("day");
                eras[i3].since = date2.valueOf();
                break;
            }
            switch (typeof eras[i3].until) {
              case "undefined":
                eras[i3].until = Infinity;
                break;
              case "string":
                date2 = hooks(eras[i3].until).startOf("day").valueOf();
                eras[i3].until = date2.valueOf();
                break;
            }
          }
          return eras;
        }
        function localeErasParse(eraName, format6, strict) {
          var i3, l3, eras = this.eras(), name106, abbr, narrow;
          eraName = eraName.toUpperCase();
          for (i3 = 0, l3 = eras.length; i3 < l3; ++i3) {
            name106 = eras[i3].name.toUpperCase();
            abbr = eras[i3].abbr.toUpperCase();
            narrow = eras[i3].narrow.toUpperCase();
            if (strict) {
              switch (format6) {
                case "N":
                case "NN":
                case "NNN":
                  if (abbr === eraName) {
                    return eras[i3];
                  }
                  break;
                case "NNNN":
                  if (name106 === eraName) {
                    return eras[i3];
                  }
                  break;
                case "NNNNN":
                  if (narrow === eraName) {
                    return eras[i3];
                  }
                  break;
              }
            } else if ([name106, abbr, narrow].indexOf(eraName) >= 0) {
              return eras[i3];
            }
          }
        }
        function localeErasConvertYear(era, year) {
          var dir = era.since <= era.until ? 1 : -1;
          if (year === void 0) {
            return hooks(era.since).year();
          } else {
            return hooks(era.since).year() + (year - era.offset) * dir;
          }
        }
        function getEraName() {
          var i3, l3, val, eras = this.localeData().eras();
          for (i3 = 0, l3 = eras.length; i3 < l3; ++i3) {
            val = this.clone().startOf("day").valueOf();
            if (eras[i3].since <= val && val <= eras[i3].until) {
              return eras[i3].name;
            }
            if (eras[i3].until <= val && val <= eras[i3].since) {
              return eras[i3].name;
            }
          }
          return "";
        }
        function getEraNarrow() {
          var i3, l3, val, eras = this.localeData().eras();
          for (i3 = 0, l3 = eras.length; i3 < l3; ++i3) {
            val = this.clone().startOf("day").valueOf();
            if (eras[i3].since <= val && val <= eras[i3].until) {
              return eras[i3].narrow;
            }
            if (eras[i3].until <= val && val <= eras[i3].since) {
              return eras[i3].narrow;
            }
          }
          return "";
        }
        function getEraAbbr() {
          var i3, l3, val, eras = this.localeData().eras();
          for (i3 = 0, l3 = eras.length; i3 < l3; ++i3) {
            val = this.clone().startOf("day").valueOf();
            if (eras[i3].since <= val && val <= eras[i3].until) {
              return eras[i3].abbr;
            }
            if (eras[i3].until <= val && val <= eras[i3].since) {
              return eras[i3].abbr;
            }
          }
          return "";
        }
        function getEraYear() {
          var i3, l3, dir, val, eras = this.localeData().eras();
          for (i3 = 0, l3 = eras.length; i3 < l3; ++i3) {
            dir = eras[i3].since <= eras[i3].until ? 1 : -1;
            val = this.clone().startOf("day").valueOf();
            if (eras[i3].since <= val && val <= eras[i3].until || eras[i3].until <= val && val <= eras[i3].since) {
              return (this.year() - hooks(eras[i3].since).year()) * dir + eras[i3].offset;
            }
          }
          return this.year();
        }
        function erasNameRegex(isStrict) {
          if (!hasOwnProp(this, "_erasNameRegex")) {
            computeErasParse.call(this);
          }
          return isStrict ? this._erasNameRegex : this._erasRegex;
        }
        function erasAbbrRegex(isStrict) {
          if (!hasOwnProp(this, "_erasAbbrRegex")) {
            computeErasParse.call(this);
          }
          return isStrict ? this._erasAbbrRegex : this._erasRegex;
        }
        function erasNarrowRegex(isStrict) {
          if (!hasOwnProp(this, "_erasNarrowRegex")) {
            computeErasParse.call(this);
          }
          return isStrict ? this._erasNarrowRegex : this._erasRegex;
        }
        function matchEraAbbr(isStrict, locale2) {
          return locale2.erasAbbrRegex(isStrict);
        }
        function matchEraName(isStrict, locale2) {
          return locale2.erasNameRegex(isStrict);
        }
        function matchEraNarrow(isStrict, locale2) {
          return locale2.erasNarrowRegex(isStrict);
        }
        function matchEraYearOrdinal(isStrict, locale2) {
          return locale2._eraYearOrdinalRegex || matchUnsigned;
        }
        function computeErasParse() {
          var abbrPieces = [], namePieces = [], narrowPieces = [], mixedPieces = [], i3, l3, eras = this.eras();
          for (i3 = 0, l3 = eras.length; i3 < l3; ++i3) {
            namePieces.push(regexEscape(eras[i3].name));
            abbrPieces.push(regexEscape(eras[i3].abbr));
            narrowPieces.push(regexEscape(eras[i3].narrow));
            mixedPieces.push(regexEscape(eras[i3].name));
            mixedPieces.push(regexEscape(eras[i3].abbr));
            mixedPieces.push(regexEscape(eras[i3].narrow));
          }
          this._erasRegex = new RegExp("^(" + mixedPieces.join("|") + ")", "i");
          this._erasNameRegex = new RegExp("^(" + namePieces.join("|") + ")", "i");
          this._erasAbbrRegex = new RegExp("^(" + abbrPieces.join("|") + ")", "i");
          this._erasNarrowRegex = new RegExp("^(" + narrowPieces.join("|") + ")", "i");
        }
        addFormatToken(0, ["gg", 2], 0, function() {
          return this.weekYear() % 100;
        });
        addFormatToken(0, ["GG", 2], 0, function() {
          return this.isoWeekYear() % 100;
        });
        function addWeekYearFormatToken(token2, getter) {
          addFormatToken(0, [token2, token2.length], 0, getter);
        }
        addWeekYearFormatToken("gggg", "weekYear");
        addWeekYearFormatToken("ggggg", "weekYear");
        addWeekYearFormatToken("GGGG", "isoWeekYear");
        addWeekYearFormatToken("GGGGG", "isoWeekYear");
        addUnitAlias("weekYear", "gg");
        addUnitAlias("isoWeekYear", "GG");
        addUnitPriority("weekYear", 1);
        addUnitPriority("isoWeekYear", 1);
        addRegexToken("G", matchSigned);
        addRegexToken("g", matchSigned);
        addRegexToken("GG", match1to2, match2);
        addRegexToken("gg", match1to2, match2);
        addRegexToken("GGGG", match1to4, match4);
        addRegexToken("gggg", match1to4, match4);
        addRegexToken("GGGGG", match1to6, match6);
        addRegexToken("ggggg", match1to6, match6);
        addWeekParseToken(["gggg", "ggggg", "GGGG", "GGGGG"], function(input, week, config3, token2) {
          week[token2.substr(0, 2)] = toInt(input);
        });
        addWeekParseToken(["gg", "GG"], function(input, week, config3, token2) {
          week[token2] = hooks.parseTwoDigitYear(input);
        });
        function getSetWeekYear(input) {
          return getSetWeekYearHelper.call(this, input, this.week(), this.weekday(), this.localeData()._week.dow, this.localeData()._week.doy);
        }
        function getSetISOWeekYear(input) {
          return getSetWeekYearHelper.call(this, input, this.isoWeek(), this.isoWeekday(), 1, 4);
        }
        function getISOWeeksInYear() {
          return weeksInYear(this.year(), 1, 4);
        }
        function getISOWeeksInISOWeekYear() {
          return weeksInYear(this.isoWeekYear(), 1, 4);
        }
        function getWeeksInYear() {
          var weekInfo = this.localeData()._week;
          return weeksInYear(this.year(), weekInfo.dow, weekInfo.doy);
        }
        function getWeeksInWeekYear() {
          var weekInfo = this.localeData()._week;
          return weeksInYear(this.weekYear(), weekInfo.dow, weekInfo.doy);
        }
        function getSetWeekYearHelper(input, week, weekday, dow, doy) {
          var weeksTarget;
          if (input == null) {
            return weekOfYear(this, dow, doy).year;
          } else {
            weeksTarget = weeksInYear(input, dow, doy);
            if (week > weeksTarget) {
              week = weeksTarget;
            }
            return setWeekAll.call(this, input, week, weekday, dow, doy);
          }
        }
        function setWeekAll(weekYear, week, weekday, dow, doy) {
          var dayOfYearData = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy), date2 = createUTCDate(dayOfYearData.year, 0, dayOfYearData.dayOfYear);
          this.year(date2.getUTCFullYear());
          this.month(date2.getUTCMonth());
          this.date(date2.getUTCDate());
          return this;
        }
        addFormatToken("Q", 0, "Qo", "quarter");
        addUnitAlias("quarter", "Q");
        addUnitPriority("quarter", 7);
        addRegexToken("Q", match1);
        addParseToken("Q", function(input, array) {
          array[MONTH] = (toInt(input) - 1) * 3;
        });
        function getSetQuarter(input) {
          return input == null ? Math.ceil((this.month() + 1) / 3) : this.month((input - 1) * 3 + this.month() % 3);
        }
        addFormatToken("D", ["DD", 2], "Do", "date");
        addUnitAlias("date", "D");
        addUnitPriority("date", 9);
        addRegexToken("D", match1to2);
        addRegexToken("DD", match1to2, match2);
        addRegexToken("Do", function(isStrict, locale2) {
          return isStrict ? locale2._dayOfMonthOrdinalParse || locale2._ordinalParse : locale2._dayOfMonthOrdinalParseLenient;
        });
        addParseToken(["D", "DD"], DATE);
        addParseToken("Do", function(input, array) {
          array[DATE] = toInt(input.match(match1to2)[0]);
        });
        var getSetDayOfMonth = makeGetSet("Date", true);
        addFormatToken("DDD", ["DDDD", 3], "DDDo", "dayOfYear");
        addUnitAlias("dayOfYear", "DDD");
        addUnitPriority("dayOfYear", 4);
        addRegexToken("DDD", match1to3);
        addRegexToken("DDDD", match3);
        addParseToken(["DDD", "DDDD"], function(input, array, config3) {
          config3._dayOfYear = toInt(input);
        });
        function getSetDayOfYear(input) {
          var dayOfYear = Math.round((this.clone().startOf("day") - this.clone().startOf("year")) / 864e5) + 1;
          return input == null ? dayOfYear : this.add(input - dayOfYear, "d");
        }
        addFormatToken("m", ["mm", 2], 0, "minute");
        addUnitAlias("minute", "m");
        addUnitPriority("minute", 14);
        addRegexToken("m", match1to2);
        addRegexToken("mm", match1to2, match2);
        addParseToken(["m", "mm"], MINUTE);
        var getSetMinute = makeGetSet("Minutes", false);
        addFormatToken("s", ["ss", 2], 0, "second");
        addUnitAlias("second", "s");
        addUnitPriority("second", 15);
        addRegexToken("s", match1to2);
        addRegexToken("ss", match1to2, match2);
        addParseToken(["s", "ss"], SECOND);
        var getSetSecond = makeGetSet("Seconds", false);
        addFormatToken("S", 0, 0, function() {
          return ~~(this.millisecond() / 100);
        });
        addFormatToken(0, ["SS", 2], 0, function() {
          return ~~(this.millisecond() / 10);
        });
        addFormatToken(0, ["SSS", 3], 0, "millisecond");
        addFormatToken(0, ["SSSS", 4], 0, function() {
          return this.millisecond() * 10;
        });
        addFormatToken(0, ["SSSSS", 5], 0, function() {
          return this.millisecond() * 100;
        });
        addFormatToken(0, ["SSSSSS", 6], 0, function() {
          return this.millisecond() * 1e3;
        });
        addFormatToken(0, ["SSSSSSS", 7], 0, function() {
          return this.millisecond() * 1e4;
        });
        addFormatToken(0, ["SSSSSSSS", 8], 0, function() {
          return this.millisecond() * 1e5;
        });
        addFormatToken(0, ["SSSSSSSSS", 9], 0, function() {
          return this.millisecond() * 1e6;
        });
        addUnitAlias("millisecond", "ms");
        addUnitPriority("millisecond", 16);
        addRegexToken("S", match1to3, match1);
        addRegexToken("SS", match1to3, match2);
        addRegexToken("SSS", match1to3, match3);
        var token, getSetMillisecond;
        for (token = "SSSS"; token.length <= 9; token += "S") {
          addRegexToken(token, matchUnsigned);
        }
        function parseMs(input, array) {
          array[MILLISECOND] = toInt(("0." + input) * 1e3);
        }
        for (token = "S"; token.length <= 9; token += "S") {
          addParseToken(token, parseMs);
        }
        getSetMillisecond = makeGetSet("Milliseconds", false);
        addFormatToken("z", 0, 0, "zoneAbbr");
        addFormatToken("zz", 0, 0, "zoneName");
        function getZoneAbbr() {
          return this._isUTC ? "UTC" : "";
        }
        function getZoneName() {
          return this._isUTC ? "Coordinated Universal Time" : "";
        }
        var proto = Moment.prototype;
        proto.add = add2;
        proto.calendar = calendar$1;
        proto.clone = clone3;
        proto.diff = diff;
        proto.endOf = endOf;
        proto.format = format5;
        proto.from = from;
        proto.fromNow = fromNow;
        proto.to = to;
        proto.toNow = toNow;
        proto.get = stringGet;
        proto.invalidAt = invalidAt;
        proto.isAfter = isAfter;
        proto.isBefore = isBefore;
        proto.isBetween = isBetween;
        proto.isSame = isSame;
        proto.isSameOrAfter = isSameOrAfter;
        proto.isSameOrBefore = isSameOrBefore;
        proto.isValid = isValid$2;
        proto.lang = lang;
        proto.locale = locale;
        proto.localeData = localeData;
        proto.max = prototypeMax;
        proto.min = prototypeMin;
        proto.parsingFlags = parsingFlags;
        proto.set = stringSet;
        proto.startOf = startOf;
        proto.subtract = subtract2;
        proto.toArray = toArray;
        proto.toObject = toObject;
        proto.toDate = toDate;
        proto.toISOString = toISOString;
        proto.inspect = inspect;
        if (typeof Symbol !== "undefined" && Symbol.for != null) {
          proto[Symbol.for("nodejs.util.inspect.custom")] = function() {
            return "Moment<" + this.format() + ">";
          };
        }
        proto.toJSON = toJSON;
        proto.toString = toString;
        proto.unix = unix;
        proto.valueOf = valueOf;
        proto.creationData = creationData;
        proto.eraName = getEraName;
        proto.eraNarrow = getEraNarrow;
        proto.eraAbbr = getEraAbbr;
        proto.eraYear = getEraYear;
        proto.year = getSetYear;
        proto.isLeapYear = getIsLeapYear;
        proto.weekYear = getSetWeekYear;
        proto.isoWeekYear = getSetISOWeekYear;
        proto.quarter = proto.quarters = getSetQuarter;
        proto.month = getSetMonth;
        proto.daysInMonth = getDaysInMonth;
        proto.week = proto.weeks = getSetWeek;
        proto.isoWeek = proto.isoWeeks = getSetISOWeek;
        proto.weeksInYear = getWeeksInYear;
        proto.weeksInWeekYear = getWeeksInWeekYear;
        proto.isoWeeksInYear = getISOWeeksInYear;
        proto.isoWeeksInISOWeekYear = getISOWeeksInISOWeekYear;
        proto.date = getSetDayOfMonth;
        proto.day = proto.days = getSetDayOfWeek;
        proto.weekday = getSetLocaleDayOfWeek;
        proto.isoWeekday = getSetISODayOfWeek;
        proto.dayOfYear = getSetDayOfYear;
        proto.hour = proto.hours = getSetHour;
        proto.minute = proto.minutes = getSetMinute;
        proto.second = proto.seconds = getSetSecond;
        proto.millisecond = proto.milliseconds = getSetMillisecond;
        proto.utcOffset = getSetOffset;
        proto.utc = setOffsetToUTC;
        proto.local = setOffsetToLocal;
        proto.parseZone = setOffsetToParsedOffset;
        proto.hasAlignedHourOffset = hasAlignedHourOffset;
        proto.isDST = isDaylightSavingTime;
        proto.isLocal = isLocal;
        proto.isUtcOffset = isUtcOffset;
        proto.isUtc = isUtc;
        proto.isUTC = isUtc;
        proto.zoneAbbr = getZoneAbbr;
        proto.zoneName = getZoneName;
        proto.dates = deprecate("dates accessor is deprecated. Use date instead.", getSetDayOfMonth);
        proto.months = deprecate("months accessor is deprecated. Use month instead", getSetMonth);
        proto.years = deprecate("years accessor is deprecated. Use year instead", getSetYear);
        proto.zone = deprecate("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/", getSetZone);
        proto.isDSTShifted = deprecate("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information", isDaylightSavingTimeShifted);
        function createUnix(input) {
          return createLocal(input * 1e3);
        }
        function createInZone() {
          return createLocal.apply(null, arguments).parseZone();
        }
        function preParsePostFormat(string2) {
          return string2;
        }
        var proto$1 = Locale.prototype;
        proto$1.calendar = calendar;
        proto$1.longDateFormat = longDateFormat;
        proto$1.invalidDate = invalidDate;
        proto$1.ordinal = ordinal;
        proto$1.preparse = preParsePostFormat;
        proto$1.postformat = preParsePostFormat;
        proto$1.relativeTime = relativeTime;
        proto$1.pastFuture = pastFuture;
        proto$1.set = set;
        proto$1.eras = localeEras;
        proto$1.erasParse = localeErasParse;
        proto$1.erasConvertYear = localeErasConvertYear;
        proto$1.erasAbbrRegex = erasAbbrRegex;
        proto$1.erasNameRegex = erasNameRegex;
        proto$1.erasNarrowRegex = erasNarrowRegex;
        proto$1.months = localeMonths;
        proto$1.monthsShort = localeMonthsShort;
        proto$1.monthsParse = localeMonthsParse;
        proto$1.monthsRegex = monthsRegex;
        proto$1.monthsShortRegex = monthsShortRegex;
        proto$1.week = localeWeek;
        proto$1.firstDayOfYear = localeFirstDayOfYear;
        proto$1.firstDayOfWeek = localeFirstDayOfWeek;
        proto$1.weekdays = localeWeekdays;
        proto$1.weekdaysMin = localeWeekdaysMin;
        proto$1.weekdaysShort = localeWeekdaysShort;
        proto$1.weekdaysParse = localeWeekdaysParse;
        proto$1.weekdaysRegex = weekdaysRegex;
        proto$1.weekdaysShortRegex = weekdaysShortRegex;
        proto$1.weekdaysMinRegex = weekdaysMinRegex;
        proto$1.isPM = localeIsPM;
        proto$1.meridiem = localeMeridiem;
        function get$1(format6, index2, field, setter) {
          var locale2 = getLocale(), utc = createUTC().set(setter, index2);
          return locale2[field](utc, format6);
        }
        function listMonthsImpl(format6, index2, field) {
          if (isNumber2(format6)) {
            index2 = format6;
            format6 = void 0;
          }
          format6 = format6 || "";
          if (index2 != null) {
            return get$1(format6, index2, field, "month");
          }
          var i3, out = [];
          for (i3 = 0; i3 < 12; i3++) {
            out[i3] = get$1(format6, i3, field, "month");
          }
          return out;
        }
        function listWeekdaysImpl(localeSorted, format6, index2, field) {
          if (typeof localeSorted === "boolean") {
            if (isNumber2(format6)) {
              index2 = format6;
              format6 = void 0;
            }
            format6 = format6 || "";
          } else {
            format6 = localeSorted;
            index2 = format6;
            localeSorted = false;
            if (isNumber2(format6)) {
              index2 = format6;
              format6 = void 0;
            }
            format6 = format6 || "";
          }
          var locale2 = getLocale(), shift = localeSorted ? locale2._week.dow : 0, i3, out = [];
          if (index2 != null) {
            return get$1(format6, (index2 + shift) % 7, field, "day");
          }
          for (i3 = 0; i3 < 7; i3++) {
            out[i3] = get$1(format6, (i3 + shift) % 7, field, "day");
          }
          return out;
        }
        function listMonths(format6, index2) {
          return listMonthsImpl(format6, index2, "months");
        }
        function listMonthsShort(format6, index2) {
          return listMonthsImpl(format6, index2, "monthsShort");
        }
        function listWeekdays(localeSorted, format6, index2) {
          return listWeekdaysImpl(localeSorted, format6, index2, "weekdays");
        }
        function listWeekdaysShort(localeSorted, format6, index2) {
          return listWeekdaysImpl(localeSorted, format6, index2, "weekdaysShort");
        }
        function listWeekdaysMin(localeSorted, format6, index2) {
          return listWeekdaysImpl(localeSorted, format6, index2, "weekdaysMin");
        }
        getSetGlobalLocale("en", {
          eras: [
            {
              since: "0001-01-01",
              until: Infinity,
              offset: 1,
              name: "Anno Domini",
              narrow: "AD",
              abbr: "AD"
            },
            {
              since: "0000-12-31",
              until: -Infinity,
              offset: 1,
              name: "Before Christ",
              narrow: "BC",
              abbr: "BC"
            }
          ],
          dayOfMonthOrdinalParse: /\d{1,2}(th|st|nd|rd)/,
          ordinal: function(number2) {
            var b2 = number2 % 10, output = toInt(number2 % 100 / 10) === 1 ? "th" : b2 === 1 ? "st" : b2 === 2 ? "nd" : b2 === 3 ? "rd" : "th";
            return number2 + output;
          }
        });
        hooks.lang = deprecate("moment.lang is deprecated. Use moment.locale instead.", getSetGlobalLocale);
        hooks.langData = deprecate("moment.langData is deprecated. Use moment.localeData instead.", getLocale);
        var mathAbs = Math.abs;
        function abs2() {
          var data = this._data;
          this._milliseconds = mathAbs(this._milliseconds);
          this._days = mathAbs(this._days);
          this._months = mathAbs(this._months);
          data.milliseconds = mathAbs(data.milliseconds);
          data.seconds = mathAbs(data.seconds);
          data.minutes = mathAbs(data.minutes);
          data.hours = mathAbs(data.hours);
          data.months = mathAbs(data.months);
          data.years = mathAbs(data.years);
          return this;
        }
        function addSubtract$1(duration, input, value, direction) {
          var other = createDuration(input, value);
          duration._milliseconds += direction * other._milliseconds;
          duration._days += direction * other._days;
          duration._months += direction * other._months;
          return duration._bubble();
        }
        function add$1(input, value) {
          return addSubtract$1(this, input, value, 1);
        }
        function subtract$1(input, value) {
          return addSubtract$1(this, input, value, -1);
        }
        function absCeil(number2) {
          if (number2 < 0) {
            return Math.floor(number2);
          } else {
            return Math.ceil(number2);
          }
        }
        function bubble() {
          var milliseconds2 = this._milliseconds, days2 = this._days, months2 = this._months, data = this._data, seconds2, minutes2, hours2, years2, monthsFromDays;
          if (!(milliseconds2 >= 0 && days2 >= 0 && months2 >= 0 || milliseconds2 <= 0 && days2 <= 0 && months2 <= 0)) {
            milliseconds2 += absCeil(monthsToDays(months2) + days2) * 864e5;
            days2 = 0;
            months2 = 0;
          }
          data.milliseconds = milliseconds2 % 1e3;
          seconds2 = absFloor(milliseconds2 / 1e3);
          data.seconds = seconds2 % 60;
          minutes2 = absFloor(seconds2 / 60);
          data.minutes = minutes2 % 60;
          hours2 = absFloor(minutes2 / 60);
          data.hours = hours2 % 24;
          days2 += absFloor(hours2 / 24);
          monthsFromDays = absFloor(daysToMonths(days2));
          months2 += monthsFromDays;
          days2 -= absCeil(monthsToDays(monthsFromDays));
          years2 = absFloor(months2 / 12);
          months2 %= 12;
          data.days = days2;
          data.months = months2;
          data.years = years2;
          return this;
        }
        function daysToMonths(days2) {
          return days2 * 4800 / 146097;
        }
        function monthsToDays(months2) {
          return months2 * 146097 / 4800;
        }
        function as(units) {
          if (!this.isValid()) {
            return NaN;
          }
          var days2, months2, milliseconds2 = this._milliseconds;
          units = normalizeUnits(units);
          if (units === "month" || units === "quarter" || units === "year") {
            days2 = this._days + milliseconds2 / 864e5;
            months2 = this._months + daysToMonths(days2);
            switch (units) {
              case "month":
                return months2;
              case "quarter":
                return months2 / 3;
              case "year":
                return months2 / 12;
            }
          } else {
            days2 = this._days + Math.round(monthsToDays(this._months));
            switch (units) {
              case "week":
                return days2 / 7 + milliseconds2 / 6048e5;
              case "day":
                return days2 + milliseconds2 / 864e5;
              case "hour":
                return days2 * 24 + milliseconds2 / 36e5;
              case "minute":
                return days2 * 1440 + milliseconds2 / 6e4;
              case "second":
                return days2 * 86400 + milliseconds2 / 1e3;
              case "millisecond":
                return Math.floor(days2 * 864e5) + milliseconds2;
              default:
                throw new Error("Unknown unit " + units);
            }
          }
        }
        function valueOf$1() {
          if (!this.isValid()) {
            return NaN;
          }
          return this._milliseconds + this._days * 864e5 + this._months % 12 * 2592e6 + toInt(this._months / 12) * 31536e6;
        }
        function makeAs(alias) {
          return function() {
            return this.as(alias);
          };
        }
        var asMilliseconds = makeAs("ms"), asSeconds = makeAs("s"), asMinutes = makeAs("m"), asHours = makeAs("h"), asDays = makeAs("d"), asWeeks = makeAs("w"), asMonths = makeAs("M"), asQuarters = makeAs("Q"), asYears = makeAs("y");
        function clone$1() {
          return createDuration(this);
        }
        function get$2(units) {
          units = normalizeUnits(units);
          return this.isValid() ? this[units + "s"]() : NaN;
        }
        function makeGetter(name106) {
          return function() {
            return this.isValid() ? this._data[name106] : NaN;
          };
        }
        var milliseconds = makeGetter("milliseconds"), seconds = makeGetter("seconds"), minutes = makeGetter("minutes"), hours = makeGetter("hours"), days = makeGetter("days"), months = makeGetter("months"), years = makeGetter("years");
        function weeks() {
          return absFloor(this.days() / 7);
        }
        var round2 = Math.round, thresholds = {
          ss: 44,
          s: 45,
          m: 45,
          h: 22,
          d: 26,
          w: null,
          M: 11
        };
        function substituteTimeAgo(string2, number2, withoutSuffix, isFuture, locale2) {
          return locale2.relativeTime(number2 || 1, !!withoutSuffix, string2, isFuture);
        }
        function relativeTime$1(posNegDuration, withoutSuffix, thresholds2, locale2) {
          var duration = createDuration(posNegDuration).abs(), seconds2 = round2(duration.as("s")), minutes2 = round2(duration.as("m")), hours2 = round2(duration.as("h")), days2 = round2(duration.as("d")), months2 = round2(duration.as("M")), weeks2 = round2(duration.as("w")), years2 = round2(duration.as("y")), a3 = seconds2 <= thresholds2.ss && ["s", seconds2] || seconds2 < thresholds2.s && ["ss", seconds2] || minutes2 <= 1 && ["m"] || minutes2 < thresholds2.m && ["mm", minutes2] || hours2 <= 1 && ["h"] || hours2 < thresholds2.h && ["hh", hours2] || days2 <= 1 && ["d"] || days2 < thresholds2.d && ["dd", days2];
          if (thresholds2.w != null) {
            a3 = a3 || weeks2 <= 1 && ["w"] || weeks2 < thresholds2.w && ["ww", weeks2];
          }
          a3 = a3 || months2 <= 1 && ["M"] || months2 < thresholds2.M && ["MM", months2] || years2 <= 1 && ["y"] || ["yy", years2];
          a3[2] = withoutSuffix;
          a3[3] = +posNegDuration > 0;
          a3[4] = locale2;
          return substituteTimeAgo.apply(null, a3);
        }
        function getSetRelativeTimeRounding(roundingFunction) {
          if (roundingFunction === void 0) {
            return round2;
          }
          if (typeof roundingFunction === "function") {
            round2 = roundingFunction;
            return true;
          }
          return false;
        }
        function getSetRelativeTimeThreshold(threshold, limit) {
          if (thresholds[threshold] === void 0) {
            return false;
          }
          if (limit === void 0) {
            return thresholds[threshold];
          }
          thresholds[threshold] = limit;
          if (threshold === "s") {
            thresholds.ss = limit - 1;
          }
          return true;
        }
        function humanize(argWithSuffix, argThresholds) {
          if (!this.isValid()) {
            return this.localeData().invalidDate();
          }
          var withSuffix = false, th = thresholds, locale2, output;
          if (typeof argWithSuffix === "object") {
            argThresholds = argWithSuffix;
            argWithSuffix = false;
          }
          if (typeof argWithSuffix === "boolean") {
            withSuffix = argWithSuffix;
          }
          if (typeof argThresholds === "object") {
            th = Object.assign({}, thresholds, argThresholds);
            if (argThresholds.s != null && argThresholds.ss == null) {
              th.ss = argThresholds.s - 1;
            }
          }
          locale2 = this.localeData();
          output = relativeTime$1(this, !withSuffix, th, locale2);
          if (withSuffix) {
            output = locale2.pastFuture(+this, output);
          }
          return locale2.postformat(output);
        }
        var abs$1 = Math.abs;
        function sign3(x3) {
          return (x3 > 0) - (x3 < 0) || +x3;
        }
        function toISOString$1() {
          if (!this.isValid()) {
            return this.localeData().invalidDate();
          }
          var seconds2 = abs$1(this._milliseconds) / 1e3, days2 = abs$1(this._days), months2 = abs$1(this._months), minutes2, hours2, years2, s3, total = this.asSeconds(), totalSign, ymSign, daysSign, hmsSign;
          if (!total) {
            return "P0D";
          }
          minutes2 = absFloor(seconds2 / 60);
          hours2 = absFloor(minutes2 / 60);
          seconds2 %= 60;
          minutes2 %= 60;
          years2 = absFloor(months2 / 12);
          months2 %= 12;
          s3 = seconds2 ? seconds2.toFixed(3).replace(/\.?0+$/, "") : "";
          totalSign = total < 0 ? "-" : "";
          ymSign = sign3(this._months) !== sign3(total) ? "-" : "";
          daysSign = sign3(this._days) !== sign3(total) ? "-" : "";
          hmsSign = sign3(this._milliseconds) !== sign3(total) ? "-" : "";
          return totalSign + "P" + (years2 ? ymSign + years2 + "Y" : "") + (months2 ? ymSign + months2 + "M" : "") + (days2 ? daysSign + days2 + "D" : "") + (hours2 || minutes2 || seconds2 ? "T" : "") + (hours2 ? hmsSign + hours2 + "H" : "") + (minutes2 ? hmsSign + minutes2 + "M" : "") + (seconds2 ? hmsSign + s3 + "S" : "");
        }
        var proto$2 = Duration.prototype;
        proto$2.isValid = isValid$1;
        proto$2.abs = abs2;
        proto$2.add = add$1;
        proto$2.subtract = subtract$1;
        proto$2.as = as;
        proto$2.asMilliseconds = asMilliseconds;
        proto$2.asSeconds = asSeconds;
        proto$2.asMinutes = asMinutes;
        proto$2.asHours = asHours;
        proto$2.asDays = asDays;
        proto$2.asWeeks = asWeeks;
        proto$2.asMonths = asMonths;
        proto$2.asQuarters = asQuarters;
        proto$2.asYears = asYears;
        proto$2.valueOf = valueOf$1;
        proto$2._bubble = bubble;
        proto$2.clone = clone$1;
        proto$2.get = get$2;
        proto$2.milliseconds = milliseconds;
        proto$2.seconds = seconds;
        proto$2.minutes = minutes;
        proto$2.hours = hours;
        proto$2.days = days;
        proto$2.weeks = weeks;
        proto$2.months = months;
        proto$2.years = years;
        proto$2.humanize = humanize;
        proto$2.toISOString = toISOString$1;
        proto$2.toString = toISOString$1;
        proto$2.toJSON = toISOString$1;
        proto$2.locale = locale;
        proto$2.localeData = localeData;
        proto$2.toIsoString = deprecate("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)", toISOString$1);
        proto$2.lang = lang;
        addFormatToken("X", 0, 0, "unix");
        addFormatToken("x", 0, 0, "valueOf");
        addRegexToken("x", matchSigned);
        addRegexToken("X", matchTimestamp);
        addParseToken("X", function(input, array, config3) {
          config3._d = new Date(parseFloat(input) * 1e3);
        });
        addParseToken("x", function(input, array, config3) {
          config3._d = new Date(toInt(input));
        });
        hooks.version = "2.29.1";
        setHookCallback(createLocal);
        hooks.fn = proto;
        hooks.min = min2;
        hooks.max = max2;
        hooks.now = now;
        hooks.utc = createUTC;
        hooks.unix = createUnix;
        hooks.months = listMonths;
        hooks.isDate = isDate2;
        hooks.locale = getSetGlobalLocale;
        hooks.invalid = createInvalid;
        hooks.duration = createDuration;
        hooks.isMoment = isMoment;
        hooks.weekdays = listWeekdays;
        hooks.parseZone = createInZone;
        hooks.localeData = getLocale;
        hooks.isDuration = isDuration;
        hooks.monthsShort = listMonthsShort;
        hooks.weekdaysMin = listWeekdaysMin;
        hooks.defineLocale = defineLocale;
        hooks.updateLocale = updateLocale;
        hooks.locales = listLocales;
        hooks.weekdaysShort = listWeekdaysShort;
        hooks.normalizeUnits = normalizeUnits;
        hooks.relativeTimeRounding = getSetRelativeTimeRounding;
        hooks.relativeTimeThreshold = getSetRelativeTimeThreshold;
        hooks.calendarFormat = getCalendarFormat;
        hooks.prototype = proto;
        hooks.HTML5_FMT = {
          DATETIME_LOCAL: "YYYY-MM-DDTHH:mm",
          DATETIME_LOCAL_SECONDS: "YYYY-MM-DDTHH:mm:ss",
          DATETIME_LOCAL_MS: "YYYY-MM-DDTHH:mm:ss.SSS",
          DATE: "YYYY-MM-DD",
          TIME: "HH:mm",
          TIME_SECONDS: "HH:mm:ss",
          TIME_MS: "HH:mm:ss.SSS",
          WEEK: "GGGG-[W]WW",
          MONTH: "YYYY-MM"
        };
        return hooks;
      });
    }
  });

  // src/model/datetime.js
  var import_moment, DateTime, isoDurationRegex, _DateTime;
  var init_datetime = __esm({
    "src/model/datetime.js"() {
      import_moment = __toModule(require_moment());
      DateTime = class {
        constructor(dateTime) {
          if (dateTime) {
            let moments = dateTime._moments, momentsCopy = [], intervals = dateTime._intervals, intervalsCopy = [], durations = dateTime._durations, durationsCopy = [], length, i3;
            length = moments.length;
            for (i3 = 0; i3 < length; i3++) {
              momentsCopy.push((0, import_moment.default)(moments[i3]));
            }
            length = intervals.length;
            for (i3 = 0; i3 < length; i3++) {
              intervalsCopy.push((0, import_moment.interval)(intervals[i3]));
            }
            length = durations.length;
            for (i3 = 0; i3 < length; i3++) {
              durationsCopy.push((0, import_moment.duration)(durations[i3]));
            }
            this._moments = momentsCopy;
            this._intervals = intervalsCopy;
            this._durations = durationsCopy;
          } else {
            this._moments = [];
            this._intervals = [];
            this._durations = [];
          }
        }
        copy() {
          return new DateTime(this);
        }
        equalsDateTime(dateTime) {
          if (!dateTime || !dateTime._moments || !dateTime._intervals || !dateTime._durations)
            return false;
          if (dateTime._moments.length !== this._moments.length)
            return false;
          if (dateTime._intervals.length !== this._intervals.length)
            return false;
          if (dateTime._durations.length !== this._durations.length)
            return false;
          let i3;
          for (i3 = 0; i3 < dateTime._moments.length; i3++) {
            if (dateTime._moments[i3] !== this._moments[i3])
              return false;
          }
          for (i3 = 0; i3 < dateTime._intervals.length; i3++) {
            if (dateTime._intervals[i3] !== this._intervals[i3])
              return false;
          }
          for (i3 = 0; i3 < dateTime._durations.length; i3++) {
            if (dateTime._durations[i3] !== this._durations[i3])
              return false;
          }
          return true;
        }
        moments() {
          return this._moments;
        }
        addMoment(moment3) {
          this._moments.push(moment3);
        }
        intervals() {
          return this._intervals;
        }
        addInterval() {
          return this._intervals;
        }
        durations() {
          return this._durations;
        }
        addDuration(duration) {
          this._durations.push(duration);
        }
        static isMomentString(string2) {
          return (0, import_moment.default)(string2, import_moment.ISO_8601).isValid();
        }
        static stringToMoment(string2) {
          let m3 = (0, import_moment.default)(string2, import_moment.ISO_8601);
          if (m3.isValid()) {
            return m3;
          }
          return void 0;
        }
        static momentToString(moment3) {
          if (!moment3) {
            return "";
          }
          let format5;
          if (moment3.hour() > 0 || moment3.minute() > 0 || moment3.second() > 0) {
            if (moment3.second() > 0) {
              format5 = "YYYY-MM-DD HH:mm:ss";
            } else {
              format5 = "YYYY-MM-DD HH:mm";
            }
          } else {
            format5 = "YYYY-MM-DD";
          }
          return moment3.format(format5);
        }
        static isDurationString(string2) {
          return isoDurationRegex.test(string2);
        }
        static stringToDuration(string2) {
          if (isoDurationRegex.test(string2)) {
            return (0, import_moment.duration)(string2);
          }
          return void 0;
        }
        static durationToString(duration) {
          if (!duration) {
            return 0;
          }
          function append(number2, suffix) {
            return number2 > 0 ? `${number2}${suffix}` : "";
          }
          return `P${duration.days() > 0 && duration.days() % 7 !== 0 ? "" : append(Math.abs(duration.weeks()), "W")}${append(Math.abs(duration.years()), "Y")}${append(Math.abs(duration.months()), "M")}${duration.days() > 0 && duration.days() % 7 === 0 ? "" : append(Math.abs(duration.days()), "D")}${Math.abs(duration.hours()) + Math.abs(duration.minutes()) + Math.abs(duration.seconds()) + Math.abs(duration.milliseconds()) > 0 ? "T" : ""}${append(Math.abs(duration.hours()), "H")}${append(Math.abs(duration.minutes()), "M")}${append(Math.abs(duration.seconds()) + Math.abs(duration.milliseconds()) / 1e3, "S")}`;
        }
        static isIntervalString() {
          return false;
        }
        static stringToInterval() {
          return void 0;
        }
        static intervalToString() {
          return "";
        }
      };
      isoDurationRegex = /^(-)?P(?:(?:([0-9,.]*)Y)?(?:([0-9,.]*)M)?(?:([0-9,.]*)D)?(?:T(?:([0-9,.]*)H)?(?:([0-9,.]*)M)?(?:([0-9,.]*)S)?)?|([0-9,.]*)W)$/;
      DateTime.moment = import_moment.default;
      _DateTime = DateTime;
    }
  });

  // src/model/taxonomy/helpers/datetimehelper.js
  function dateTimeClone(dateTime) {
    if (dateTime) {
      return dateTime.copy();
    }
    return dateTime;
  }
  function dateTimeEquals(a3, b2) {
    if (!a3 || !b2)
      return a3 === b2;
    return a3.equalsDateTime(b2);
  }
  var attributesToClear2;
  var init_datetimehelper = __esm({
    "src/model/taxonomy/helpers/datetimehelper.js"() {
      init_datetime();
      init_extensions();
      Extensions.add("com.foldingtext.taxonomy.anglebrackets", {
        matches(text) {
          text = text.slice(1, -1);
          if (text[0] === "P") {
            return _DateTime.isDurationString(text);
          } else if (!isNaN(text[0]) && !isNaN(text[0])) {
            if (_DateTime.isMomentString(text)) {
              return true;
            }
            return _DateTime.isIntervalString(text);
          }
        },
        classifyAngleBrackets(angleBracketsText, angleBracketsStart, angleBracketsLength, text, state) {
          let dateText = angleBracketsText.slice(1, -1), moment3 = _DateTime.stringToMoment(dateText), duration = moment3 ? null : _DateTime.stringToDuration(dateText), interval2 = moment3 || duration ? null : _DateTime.stringToInterval(dateText);
          if (duration || moment3 || interval2) {
            let dateTime = state.dateTime;
            if (!dateTime) {
              dateTime = new _DateTime();
              state.dateTime = dateTime;
            }
            if (duration) {
              text.addAttributeInRange("duration", dateText, angleBracketsStart, angleBracketsLength);
              dateTime.addDuration(duration);
            } else if (moment3) {
              text.addAttributeInRange("moment", dateText, angleBracketsStart, angleBracketsLength);
              dateTime.addMoment(moment3);
            } else {
              text.addAttributeInRange("interval", dateText, angleBracketsStart, angleBracketsLength);
              dateTime.addInterval(interval2);
            }
            text.addAttributeInRange("keyword", "<", angleBracketsStart, 1);
            text.addAttributeInRange("keyword", ">", angleBracketsStart + angleBracketsLength - 1, 1);
            return true;
          }
        }
      });
      attributesToClear2 = ["moment", "duration", "interval"];
    }
  });

  // src/model/taxonomy/helpers/anglebracketshelper.js
  function isReservedSyntax(text) {
    return Extensions.processExtensions("com.foldingtext.taxonomy.anglebrackets", (each) => {
      return each.matches(text);
    }, true);
  }
  function parseAngleBrackets(text, state, previousState) {
    let escapedText = text.escapedText(), angleBracketsStart, angleBracketsText, angleBracketsLength, match;
    if (escapedText.indexOf(">") === -1) {
      return;
    }
    function processExtension(each) {
      return each.classifyAngleBrackets(angleBracketsText, angleBracketsStart, angleBracketsLength, text, state, previousState);
    }
    while (match = angleBracketsRegex.exec(escapedText)) {
      angleBracketsStart = match.index;
      angleBracketsText = match[0];
      angleBracketsLength = angleBracketsText.length;
      let handled = Extensions.processExtensions("com.foldingtext.taxonomy.anglebrackets", processExtension, true);
      if (handled) {
        escapedText = escapedText.substr(0, angleBracketsStart) + IGNORE_CHAR + escapedText.substr(angleBracketsStart + 1);
        escapedText = escapedText.substr(0, angleBracketsStart + angleBracketsLength - 1) + IGNORE_CHAR + escapedText.substr(angleBracketsStart + angleBracketsLength);
        text.updateEscapedText(escapedText);
      }
    }
  }
  var angleBracketsRegex, IGNORE_CHAR;
  var init_anglebracketshelper = __esm({
    "src/model/taxonomy/helpers/anglebracketshelper.js"() {
      init_extensions();
      angleBracketsRegex = /<.*?>/g;
      IGNORE_CHAR = "\uE006";
    }
  });

  // src/model/taxonomy/helpers/autolinkhelper.js
  var webAutoLinkReplaceRegex, emailAutoLinkReplaceRegex, attributesToClear3;
  var init_autolinkhelper = __esm({
    "src/model/taxonomy/helpers/autolinkhelper.js"() {
      init_extensions();
      webAutoLinkReplaceRegex = /<((https?|ftp|dict):[^'">\s]+)>/i;
      emailAutoLinkReplaceRegex = /<(mailto:)?([-.\w]+@[-a-z0-9]+(\.[-a-z0-9]+)*\.[a-z]+)>/i;
      Extensions.add("com.foldingtext.taxonomy.anglebrackets", {
        matches(text) {
          if (webAutoLinkReplaceRegex.test(text)) {
            return true;
          }
          if (emailAutoLinkReplaceRegex.test(text)) {
            return true;
          }
        },
        classifyAngleBrackets(angleBracketsText, angleBracketsStart, angleBracketsLength, text) {
          let emailMatch = emailAutoLinkReplaceRegex.exec(angleBracketsText), webLinkMatch = emailMatch ? null : webAutoLinkReplaceRegex.exec(angleBracketsText);
          if (emailMatch || webLinkMatch) {
            text.addAttributeInRange("autolink", angleBracketsText, angleBracketsStart, angleBracketsLength);
            text.addAttributeInRange("keyword", "<", angleBracketsStart, 1);
            if (emailMatch) {
              if (emailMatch[1] === "mailto:") {
                text.addAttributeInRange("linktarget", angleBracketsText, angleBracketsStart + 1, angleBracketsLength - 2);
              } else {
                text.addAttributeInRange("linktarget", `mailto:${angleBracketsText}`, angleBracketsStart + 1, angleBracketsLength - 2);
              }
            } else {
              text.addAttributeInRange("linktarget", angleBracketsText, angleBracketsStart + 1, angleBracketsLength - 2);
            }
            text.addAttributeInRange("keyword", ">", angleBracketsStart + angleBracketsLength - 1, 1);
            return true;
          }
        }
      });
      attributesToClear3 = ["autolink", "keyword", "linktarget"];
    }
  });

  // src/model/taxonomy/helpers/criticmarkuphelper.js
  function matchAndHighlightInTextFromIndex(text, t3, i3, found, looking, style) {
    let end = t3.indexOf(looking, i3 + found.length);
    if (end !== -1) {
      text.addAttributeInRange(style, text.textSubstring(i3 + found.length, end), i3, end + looking.length - i3);
      text.addAttributeInRange("criticstart", "{", i3, 1);
      text.addAttributeInRange("keyword", found, i3, found.length);
      text.addAttributeInRange("keyword", looking, end, looking.length);
      text.addAttributeInRange("criticend", "}", end + looking.length - 1, 1);
      return end + looking.length;
    }
    return i3 + found.length;
  }
  function parseCriticMarkup(text) {
    let t3 = text.escapedText(), i3 = t3.indexOf("{"), ch1, ch2, end;
    while (i3 !== -1) {
      ch1 = t3[i3 + 1];
      ch2 = t3[i3 + 2];
      if (ch1 === "+" && ch2 === "+") {
        i3 = matchAndHighlightInTextFromIndex(text, t3, i3, "{++", "++}", "criticinsertion");
      } else if (ch1 === "-" && ch2 === "-") {
        i3 = matchAndHighlightInTextFromIndex(text, t3, i3, "{--", "--}", "criticdeletion");
      } else if (ch1 === "~" && ch2 === "~") {
        end = t3.indexOf("~~}", i3 + 3);
        if (end !== -1) {
          let middle = t3.indexOf("~>", i3);
          if (middle !== -1 && middle < end) {
            matchAndHighlightInTextFromIndex(text, t3, i3, "{~~", "~~}", "criticsubstitution");
            text.addAttributeInRange("criticdeletion", text.textSubstring(i3 + 3, middle), i3 + 3, middle - (i3 + 3));
            text.addAttributeInRange("keyword", "~>", middle, 2);
            text.addAttributeInRange("criticinsertion", text.textSubstring(i3 + 3, middle), middle + 2, end - middle - 2);
            i3 = end + 3;
          } else {
            i3 = i3 + 3;
          }
        } else {
          i3 = i3 + 3;
        }
      } else if (ch1 === ">" && ch2 === ">") {
        i3 = matchAndHighlightInTextFromIndex(text, t3, i3, "{>>", "<<}", "criticcomment");
      } else if (ch1 === "=" && ch2 === "=") {
        i3 = matchAndHighlightInTextFromIndex(text, t3, i3, "{==", "==}", "critichighlight");
      } else {
        i3 = t3.indexOf("{", i3 + 1);
      }
    }
  }
  var attributesToClear4;
  var init_criticmarkuphelper = __esm({
    "src/model/taxonomy/helpers/criticmarkuphelper.js"() {
      init_extensions();
      Extensions.addCommand({
        name: "toggleAddition",
        performCommand(editor2) {
          editor2.toggleSelectionFormatting(editor2, "{++", "++}");
        }
      });
      Extensions.addCommand({
        name: "toggleDeletion",
        performCommand(editor2) {
          editor2.toggleSelectionFormatting(editor2, "{--", "--}");
        }
      });
      Extensions.addCommand({
        name: "toggleSubstitution",
        performCommand(editor2) {
          if (editor2.toggleSelectionFormatting(editor2, "{~~", "~~}")) {
            let range2 = editor2.selectedRange().rangeByCollapsing(false);
            editor2.setSelectedRange(range2);
            editor2.replaceSelection("~>");
          }
        }
      });
      Extensions.addCommand({
        name: "toggleComment",
        performCommand(editor2) {
          editor2.toggleSelectionFormatting(editor2, "{>>", "<<}");
        }
      });
      Extensions.addCommand({
        name: "toggleHighlight",
        performCommand(editor2) {
          editor2.toggleSelectionFormatting(editor2, "{==", "==}");
        }
      });
      Extensions.add("com.foldingtext.editor.clearInlineFormatting", (formattedText) => {
        let format5 = formattedText.format();
        if (format5 === "criticinsertion" || format5 === "criticdeletion" || format5 === "criticsubstitution" || format5 === "criticcomment" || format5 === "critichighlight") {
          formattedText.replaceInRange("", formattedText.length() - 3, 3);
          formattedText.replaceInRange("", 0, 3);
          if (format5 === "criticsubstitution") {
            let index2 = formattedText.string().indexOf("~>");
            if (index2 !== -1) {
              formattedText.replaceInRange("", index2, 2);
            }
          }
        }
      });
      attributesToClear4 = [
        "criticinsertion",
        "criticdeletion",
        "criticsubstitution",
        "criticcomment",
        "critichighlight"
      ];
    }
  });

  // src/model/taxonomy/helpers/magiclinkhelper.js
  function allowsMagicLinkAtLocation(text, location) {
    return true;
  }
  function parseEmailLinks(text) {
    let escapedText = text.text(), match;
    if (escapedText.indexOf("@") === -1) {
      return;
    }
    emailRegexp.lastIndex = 0;
    while (match = emailRegexp.exec(escapedText)) {
      let linkStart = match.index, emailLink = text.textSubstring(linkStart, linkStart + match[0].length);
      if (escapedText[linkStart - 1] === ":") {
        return;
      }
      if (allowsMagicLinkAtLocation(text, linkStart)) {
        text.addAttributeInRange("magiclink", emailLink, linkStart, emailLink.length);
        text.addAttributeInRange("linktarget", `mailto:${emailLink}`, linkStart, emailLink.length);
      }
    }
  }
  function parseWebLinks(text) {
    let escapedText = text.escapedText(), match;
    webRegexp.lastIndex = 0;
    while (match = webRegexp.exec(escapedText)) {
      let linkStart = match.index, linkText = text.textSubstring(linkStart, linkStart + match[0].length), linkTarget = linkText;
      if (allowsMagicLinkAtLocation(text, linkStart)) {
        if (escapedText.indexOf("www") === 0) {
          linkTarget = `http://${linkText}`;
        }
        text.addAttributeInRange("magiclink", linkText, linkStart, linkText.length);
        text.addAttributeInRange("linktarget", linkTarget, linkStart, linkText.length);
      }
    }
  }
  var emailRegexp, webRegexp, attributesToClear5;
  var init_magiclinkhelper = __esm({
    "src/model/taxonomy/helpers/magiclinkhelper.js"() {
      emailRegexp = /\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/gi;
      webRegexp = /\b(?:([a-z][\w-]+:(?:\/{1,3}|[a-z0-9%])|www\d{0,3}[.])(?:[^\s()<>]+|\([^\s()<>]+\))+(?:\([^\s()<>]+\)|[^`!()[\]{};:'".,<>?«»“”‘’\s]))/gi;
      attributesToClear5 = ["magiclink", "linktarget"];
    }
  });

  // src/model/taxonomy/helpers/inlineshelper.js
  var inlineshelper_exports = {};
  __export(inlineshelper_exports, {
    attributesToClear: () => attributesToClear7,
    parseInlines: () => parseInlines,
    stripInlineSyntax: () => stripInlineSyntax
  });
  function _pad(padChar, num) {
    let result = "";
    for (let i3 = 0; i3 < num; i3++) {
      result += padChar;
    }
    return result;
  }
  function _escapeCodeSpanMatch(wholeMatch, m1, m22, m3) {
    let codeSyntaxString = _pad(CODE_SYNTAX_CHAR, m22.length);
    let escapeCharString = _pad(CODE_CONTENT_SYNTAX_CHAR, m3.length);
    return m1 + codeSyntaxString + escapeCharString + codeSyntaxString;
  }
  function resetAllRegexps() {
    escaptedSyntaxRegex.lastIndex = 0;
    codeReplaceRegex.lastIndex = 0;
    strongReplaceRegex.lastIndex = 0;
    emReplaceRegex.lastIndex = 0;
    underscoreInWordRegex.lastIndex = 0;
    referenceLinkRegex.lastIndex = 0;
    inlineLineRegex.lastIndex = 0;
    footnoteLinkRE.lastIndex = 0;
  }
  function parseInlines(text, state, previousState, htmlMode, parseCriticMarkup2, parseMagicLinks, inwordunderscores) {
    let escapedText = text.escapedText(), match;
    resetAllRegexps();
    if (parseCriticMarkup2) {
      parseCriticMarkup(text, state, previousState);
    }
    let hasPotentialCode = escapedText.indexOf("`") !== -1;
    if (hasPotentialCode) {
      escapedText = escapedText.replace(codeReplaceRegex, _escapeCodeSpanMatch);
      text.updateEscapedText(escapedText);
    }
    let hasPotentialStrong = escapedText.indexOf("**") !== -1 || escapedText.indexOf("__") !== -1;
    if (hasPotentialStrong) {
      escapedText = escapedText.replace(strongReplaceRegex, `${doubleStrongSyntaxChar}$2${doubleStrongSyntaxChar}`);
      text.updateEscapedText(escapedText);
    }
    let hasUnderscore = escapedText.indexOf("_") !== -1, hasPotentialEmphasis = hasUnderscore || escapedText.indexOf("*") !== -1;
    if (hasPotentialEmphasis) {
      if (hasUnderscore && !inwordunderscores) {
        escapedText = escapedText.replace(underscoreInWordRegex, `$1${IGNORE_CHAR2}$2`);
      }
      escapedText = escapedText.replace(emReplaceRegex, `${EM_SYNTAX_CHAR}$2${EM_SYNTAX_CHAR}`);
      text.updateEscapedText(escapedText);
    }
    if (text.text() !== escapedText) {
      let codeStart = -1;
      let strongStart = -1;
      let italicStart = -1;
      let contentString;
      let keyword;
      while (match = escaptedSyntaxRegex.exec(escapedText)) {
        let escaptedSyntax = match[0];
        let escaptedSyntaxChar = escaptedSyntax[0];
        let index2 = match.index;
        if (escaptedSyntaxChar === ESCAPE_SYNTAX_CHAR3) {
          text.addAttributeInRange("keyword", "\\", index2, 1);
        } else if (escaptedSyntaxChar === CODE_SYNTAX_CHAR) {
          if (codeStart >= 0) {
            contentString = text.textSubstring(codeStart, index2 + escaptedSyntax.length);
            keyword = contentString.substring(0, 2);
            text.addAttributeInRange("keyword", keyword, codeStart, escaptedSyntax.length);
            text.addAttributeInRange("code", contentString.substring(escaptedSyntax.length, contentString.length - escaptedSyntax.length), codeStart, contentString.length);
            text.addAttributeInRange("keyword", keyword, codeStart + contentString.length - escaptedSyntax.length, escaptedSyntax.length);
            codeStart = -1;
          } else {
            codeStart = match.index;
          }
        } else if (escaptedSyntaxChar === STRONG_SYNTAX_CHAR) {
          if (strongStart >= 0) {
            contentString = text.textSubstring(strongStart, index2 + 2);
            keyword = contentString.substring(0, 2);
            text.addAttributeInRange("keyword", keyword, strongStart, 2);
            text.addAttributeInRange("strong", contentString.substring(2, contentString.length - 2), strongStart, contentString.length);
            text.addAttributeInRange("keyword", keyword, strongStart + contentString.length - 2, 2);
            strongStart = -1;
          } else {
            strongStart = match.index;
          }
        } else if (escaptedSyntaxChar === EM_SYNTAX_CHAR) {
          if (italicStart >= 0) {
            contentString = text.textSubstring(italicStart, index2 + 1);
            keyword = contentString[0];
            text.addAttributeInRange("keyword", keyword, italicStart, 1);
            text.addAttributeInRange("em", contentString.substring(1, contentString.length - 1), italicStart, contentString.length);
            text.addAttributeInRange("keyword", keyword, italicStart + contentString.length - 1, 1);
            italicStart = -1;
          } else {
            italicStart = match.index;
          }
        }
      }
    }
    parseAngleBrackets(text, state, previousState);
    if (htmlMode) {
      parseHTML(text, null, false, htmlMode);
    }
    let hasPotentialLinks = escapedText.indexOf("]") !== -1;
    if (hasPotentialLinks) {
      let linkTarget;
      let linkLabel;
      let link;
      let linkStart;
      let linkLength;
      let isImage;
      while (match = referenceLinkRegex.exec(escapedText)) {
        link = match[0];
        linkLabel = match[2];
        linkTarget = match[3];
        link = text.textSubstr(match.index, link.length);
        linkLabel = text.textSubstr(match.index + 1, linkLabel.length);
        linkTarget = text.textSubstr(match.index + link.length - (1 + linkTarget.length), linkTarget.length);
        linkStart = match.index;
        linkLength = link.length;
        isImage = link[0] === "!";
        text.addAttributeInRange("referencelink", link, linkStart, link.length);
        if (isImage) {
          text.addAttributeInRange("keyword", "!", linkStart, 1);
          linkStart++;
          linkLength--;
        }
        text.addAttributeInRange("keyword", "[", linkStart, 1);
        text.addAttributeInRange("linklabel", linkLabel, linkStart + 1, linkLabel.length);
        text.addAttributeInRange("keyword", "]", linkStart + 1 + linkLabel.length, 1);
        text.addAttributeInRange("keyword", "[", linkStart + (linkLength - (linkTarget.length + 2)), 1);
        text.addAttributeInRange("linktarget", linkTarget, linkStart + (linkLength - (1 + linkTarget.length)), linkTarget.length);
        text.addAttributeInRange("keyword", "]", linkStart + linkLength - 1, 1);
      }
      while (match = inlineLineRegex.exec(escapedText)) {
        link = match[0];
        linkLabel = match[2];
        linkTarget = match[4];
        link = text.textSubstr(match.index, link.length);
        linkLabel = text.textSubstr(match.index + 1, linkLabel.length);
        linkTarget = text.textSubstr(match.index + 1 + linkLabel.length + 1 + 1, linkTarget.length);
        linkStart = match.index;
        linkLength = link.length;
        isImage = link[0] === "!";
        state.links.push({
          linkLabel,
          linkTarget,
          isImage
        });
        text.addAttributeInRange("inlinelink", link, linkStart, link.length);
        if (isImage) {
          text.addAttributeInRange("keyword", "!", linkStart, 1);
          linkStart++;
          linkLength--;
        }
        text.addAttributeInRange("keyword", "[", linkStart, 1);
        text.addAttributeInRange("linklabel", linkLabel, linkStart + 1, linkLabel.length);
        text.addAttributeInRange("keyword", "]", linkStart + 1 + linkLabel.length, 1);
        text.addAttributeInRange("keyword", "(", linkStart + 1 + linkLabel.length + 1, 1);
        text.addAttributeInRange("linktarget", linkTarget, linkStart + 1 + linkLabel.length + 1 + 1, linkLength - (1 + linkLabel.length + 1 + 1 + 1));
        text.addAttributeInRange("keyword", ")", linkStart + linkLength - 1, 1);
      }
      while (match = footnoteLinkRE.exec(escapedText)) {
        link = match[0];
        linkLabel = match[1];
        link = text.textSubstr(match.index, link.length);
        linkLabel = text.textSubstr(match.index + 2, linkLabel.length);
        linkStart = match.index;
        text.addAttributeInRange("footnotelink", link, linkStart, link.length);
        text.addAttributeInRange("keyword", "[^", linkStart, 2);
        text.addAttributeInRange("linklabel", linkLabel, linkStart + 2, linkLabel.length);
        text.addAttributeInRange("keyword", "]", linkStart + 2 + linkLabel.length, 1);
      }
    }
    if (parseMagicLinks) {
      if (escapedText.indexOf("@") !== -1) {
        parseEmailLinks(text, state, previousState);
      }
      parseWebLinks(text, state, previousState);
    }
  }
  function replace(string2, info) {
    if (!info.match)
      return string2;
    return info.pair.replace(string2, info.match);
  }
  function stripInlineSyntax(text) {
    let stripped = text;
    let escapes = [
      [/\\_/g, "\uE001", /\uE001/g, "\\_"],
      [/\\\*/g, "\uE002", /\uE002/g, "\\*"],
      [/\\`/g, "\uE003", /\uE003/g, "\\`"]
    ];
    let dynamicReplaceStart = "\uE007";
    let dynamicReplaceEnd = "\uE008";
    let dynamicEscapes = [];
    let keepCaptureGroup = function(index2) {
      return function(string2, match) {
        return string2.substr(0, match.index) + match[index2] + string2.substr(match.index + match[0].length);
      };
    };
    let keepCaptureGroupWithOmit = function(index2) {
      return function(string2, match) {
        let dynamicEscapeIndex = dynamicEscapes.length;
        dynamicEscapes.push(match[index2]);
        return string2.substr(0, match.index) + dynamicReplaceStart + dynamicEscapeIndex + dynamicReplaceEnd + string2.substr(match.index + match[0].length);
      };
    };
    let discardAll = function(string2, match) {
      return string2.substr(0, match.index) + string2.substr(match.index + match[0].length);
    };
    let regexes = [
      {
        regex: /\b_(?=\S)((?:__|\\[\s\S]|[^\\_])+?)_(?!_)/,
        replace: keepCaptureGroup(1)
      },
      {
        regex: /\*(?=\S)((?:\*\*|\s+[^*\s]|[^\s*])*?[^\s*])\*/,
        replace: keepCaptureGroup(1)
      },
      {
        regex: /\*\*([\s\S]+?)\*\*(?!\*)/,
        replace: keepCaptureGroup(1)
      },
      {
        regex: /\b__([\s\S]+?)__/,
        replace: keepCaptureGroup(1)
      },
      {
        regex: /(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,
        replace: keepCaptureGroupWithOmit(2)
      },
      {
        regex: /!?\[((?:\[[^\]]*\]|[^\]]|\](?=[^[]*\]))*)\]\(\s*<?([^\s]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*\)/,
        replace: keepCaptureGroup(1)
      },
      {
        regex: /!?\[((?:\[[^\]]*\]|[^\]]|\](?=[^[]*\]))*)\]\s*\[([^\]]*)\]/,
        replace: keepCaptureGroup(1)
      },
      {
        regex: /<(?!\s)[^>]+?>/,
        replace: discardAll
      }
    ];
    let noMatch = false;
    escapes.forEach((escape2) => {
      stripped = stripped.replace(escape2[0], escape2[1]);
    });
    let getMatches = function(pair) {
      let match = pair.regex.exec(stripped);
      return {
        match,
        pair
      };
    };
    let getFirstMatch = function(firstMatch, match) {
      if (!match.match)
        return firstMatch;
      if (firstMatch) {
        if (firstMatch.match.index > match.match.index) {
          return match;
        }
        return firstMatch;
      }
      return match;
    };
    while (!noMatch) {
      let match = regexes.map(getMatches).reduce(getFirstMatch, null);
      if (!match || !match.match) {
        noMatch = true;
      } else {
        stripped = replace(stripped, match);
        noMatch = false;
      }
    }
    dynamicEscapes.forEach((escape2, index2) => {
      let marker = dynamicReplaceStart + index2 + dynamicReplaceEnd;
      stripped = stripped.replace(marker, escape2);
    });
    escapes.forEach((escape2) => {
      stripped = stripped.replace(escape2[2], escape2[3]);
    });
    return stripped;
  }
  var CODE_SYNTAX_CHAR, CODE_CONTENT_SYNTAX_CHAR, ESCAPE_SYNTAX_CHAR3, STRONG_SYNTAX_CHAR, EM_SYNTAX_CHAR, IGNORE_CHAR2, doubleStrongSyntaxChar, escaptedSyntaxRegex, codeReplaceRegex, strongReplaceRegex, emReplaceRegex, underscoreInWordRegex, referenceLinkRegex, inlineLineRegex, footnoteLinkRE, attributesToClear7;
  var init_inlineshelper = __esm({
    "src/model/taxonomy/helpers/inlineshelper.js"() {
      init_extensions();
      init_anglebracketshelper();
      init_autolinkhelper();
      init_criticmarkuphelper();
      init_datetimehelper();
      init_htmlhelper();
      init_magiclinkhelper();
      CODE_SYNTAX_CHAR = "\uE000";
      CODE_CONTENT_SYNTAX_CHAR = "\uE001";
      ESCAPE_SYNTAX_CHAR3 = "\uE002";
      STRONG_SYNTAX_CHAR = "\uE003";
      EM_SYNTAX_CHAR = "\uE004";
      IGNORE_CHAR2 = "\uE006";
      doubleStrongSyntaxChar = STRONG_SYNTAX_CHAR + STRONG_SYNTAX_CHAR;
      escaptedSyntaxRegex = new RegExp(`${ESCAPE_SYNTAX_CHAR3}{2}|${CODE_SYNTAX_CHAR}+|${STRONG_SYNTAX_CHAR}+|${EM_SYNTAX_CHAR}+`, "g");
      codeReplaceRegex = /(^|[^\\])(`+)([^\r]*?[^`])\2(?!`)/g;
      strongReplaceRegex = /(\*\*|__)(?=\S)([^\r]*?\S[*_]*)\1/g;
      emReplaceRegex = /(\*|_)(?=\S)([^\r]*?\S)\1/g;
      underscoreInWordRegex = /(\w)_(\w)/g;
      referenceLinkRegex = /(!?\[((?:\[[^\]]*\]|[^[\]])*)\][ ]?(?:\n[ ]*)?\[(.*?)\])()()()()/g;
      inlineLineRegex = /(!?\[((?:\[[^\]]*\]|[^[\]])*)\]\([ \t]*()<?((?:\([^)]*\)|[^()])*?)>?[ \t]*((['"])(.*?)\6[ \t]*)?\))/g;
      footnoteLinkRE = /\[\^([^\]]*)\]/g;
      attributesToClear7 = [
        "keyword",
        "code",
        "strong",
        "em",
        "linktarget",
        "linklabel",
        "linktitle",
        "footnotelink",
        "referencelink",
        "inlinelink"
      ].concat(attributesToClear4).concat(attributesToClear6).concat(attributesToClear3).concat(attributesToClear2).concat(attributesToClear5);
      Extensions.add("com.foldingtext.editor.clearInlineFormatting", (formattedText) => {
        let format5 = formattedText.format();
        if (format5 === "strong") {
          formattedText.replaceInRange("", formattedText.length() - 2, 2);
          formattedText.replaceInRange("", 0, 2);
        } else if (format5 === "em") {
          formattedText.replaceInRange("", formattedText.length() - 1, 1);
          formattedText.replaceInRange("", 0, 1);
        } else if (format5 === "code") {
          formattedText.replaceInRange("", formattedText.length() - 1, 1);
          formattedText.replaceInRange("", 0, 1);
        }
      });
    }
  });

  // src/model/taxonomy/helpers/htmlhelper.js
  function matchXMLBlockStart(text) {
    if (text.indexOf(">") !== -1) {
      let match = htmlOpenTagRegex.exec(text);
      if (match) {
        if (isReservedSyntax(match[0])) {
          return null;
        }
        return match;
      }
      return htmlCommentTagRegex.exec(text);
    }
    return null;
  }
  function matchAnyXMLTag(text) {
    let match;
    htmlTagRegex.lastIndex = 0;
    while (match = htmlTagRegex.exec(text)) {
      if (isReservedSyntax(match[0])) {
        continue;
      }
      return match;
    }
    return null;
  }
  function shouldRunHTMLMode(text, codemirrorState, forceParseFromStart) {
    let escapedText = text.escapedText();
    if (forceParseFromStart) {
      if (escapedText[0] === "<") {
        let match = matchXMLBlockStart(escapedText);
        return !!match && match.index === 0;
      }
    } else {
      if (codemirrorState) {
        return true;
      }
      if (escapedText.indexOf("<") !== -1) {
        return !!matchAnyXMLTag(escapedText);
      }
    }
    return false;
  }
  function parseHTML(text, codemirrorState, forceParseFromStart, htmlMode) {
    if (!htmlMode || !shouldRunHTMLMode(text, codemirrorState, forceParseFromStart)) {
      return null;
    }
    if (!codemirrorState) {
      codemirrorState = {
        mode: htmlMode,
        state: htmlMode.startState()
      };
    }
    runMode(htmlMode, codemirrorState.state, text);
    return codemirrorState;
  }
  function detectAndHighlightHtmlBlock(text, state, previousState, htmlMode) {
    let forceParseFromStart = false, codemirrorState;
    if (previousState.codemirrorState) {
      codemirrorState = copyState(previousState.codemirrorState);
    } else {
      if (previousState.type !== "empty" && !text.isFirstLine()) {
        return false;
      }
      forceParseFromStart = true;
    }
    if (!InlinesHelper) {
      InlinesHelper = (init_inlineshelper(), inlineshelper_exports);
    }
    codemirrorState = parseHTML(text, codemirrorState, forceParseFromStart, htmlMode);
    if (codemirrorState) {
      state.type = "htmlblock";
      state.codemirrorState = codemirrorState;
      return true;
    }
    return false;
  }
  var htmlTagRegex, htmlOpenTagRegex, htmlCommentTagRegex, InlinesHelper, attributesToClear6;
  var init_htmlhelper = __esm({
    "src/model/taxonomy/helpers/htmlhelper.js"() {
      init_anglebracketshelper();
      init_codemirrormodehelper();
      htmlTagRegex = /<(\/)?\w+.*?(\/)?>/g;
      htmlOpenTagRegex = /<\w+.*?(\/)?>/;
      htmlCommentTagRegex = /<!--.*-->/;
      attributesToClear6 = [];
    }
  });

  // node_modules/lodash.clonedeep/index.js
  var require_lodash = __commonJS({
    "node_modules/lodash.clonedeep/index.js"(exports, module) {
      var LARGE_ARRAY_SIZE = 200;
      var HASH_UNDEFINED = "__lodash_hash_undefined__";
      var MAX_SAFE_INTEGER = 9007199254740991;
      var argsTag = "[object Arguments]";
      var arrayTag = "[object Array]";
      var boolTag = "[object Boolean]";
      var dateTag = "[object Date]";
      var errorTag = "[object Error]";
      var funcTag = "[object Function]";
      var genTag = "[object GeneratorFunction]";
      var mapTag = "[object Map]";
      var numberTag = "[object Number]";
      var objectTag = "[object Object]";
      var promiseTag = "[object Promise]";
      var regexpTag = "[object RegExp]";
      var setTag = "[object Set]";
      var stringTag = "[object String]";
      var symbolTag = "[object Symbol]";
      var weakMapTag = "[object WeakMap]";
      var arrayBufferTag = "[object ArrayBuffer]";
      var dataViewTag = "[object DataView]";
      var float32Tag = "[object Float32Array]";
      var float64Tag = "[object Float64Array]";
      var int8Tag = "[object Int8Array]";
      var int16Tag = "[object Int16Array]";
      var int32Tag = "[object Int32Array]";
      var uint8Tag = "[object Uint8Array]";
      var uint8ClampedTag = "[object Uint8ClampedArray]";
      var uint16Tag = "[object Uint16Array]";
      var uint32Tag = "[object Uint32Array]";
      var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
      var reFlags = /\w*$/;
      var reIsHostCtor = /^\[object .+?Constructor\]$/;
      var reIsUint = /^(?:0|[1-9]\d*)$/;
      var cloneableTags = {};
      cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
      cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
      var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
      var freeSelf = typeof self == "object" && self && self.Object === Object && self;
      var root = freeGlobal || freeSelf || Function("return this")();
      var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
      var freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module;
      var moduleExports = freeModule && freeModule.exports === freeExports;
      function addMapEntry(map3, pair) {
        map3.set(pair[0], pair[1]);
        return map3;
      }
      function addSetEntry(set, value) {
        set.add(value);
        return set;
      }
      function arrayEach(array, iteratee) {
        var index2 = -1, length = array ? array.length : 0;
        while (++index2 < length) {
          if (iteratee(array[index2], index2, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayPush(array, values2) {
        var index2 = -1, length = values2.length, offset = array.length;
        while (++index2 < length) {
          array[offset + index2] = values2[index2];
        }
        return array;
      }
      function arrayReduce(array, iteratee, accumulator, initAccum) {
        var index2 = -1, length = array ? array.length : 0;
        if (initAccum && length) {
          accumulator = array[++index2];
        }
        while (++index2 < length) {
          accumulator = iteratee(accumulator, array[index2], index2, array);
        }
        return accumulator;
      }
      function baseTimes(n3, iteratee) {
        var index2 = -1, result = Array(n3);
        while (++index2 < n3) {
          result[index2] = iteratee(index2);
        }
        return result;
      }
      function getValue(object, key) {
        return object == null ? void 0 : object[key];
      }
      function isHostObject(value) {
        var result = false;
        if (value != null && typeof value.toString != "function") {
          try {
            result = !!(value + "");
          } catch (e5) {
          }
        }
        return result;
      }
      function mapToArray(map3) {
        var index2 = -1, result = Array(map3.size);
        map3.forEach(function(value, key) {
          result[++index2] = [key, value];
        });
        return result;
      }
      function overArg(func, transform) {
        return function(arg) {
          return func(transform(arg));
        };
      }
      function setToArray(set) {
        var index2 = -1, result = Array(set.size);
        set.forEach(function(value) {
          result[++index2] = value;
        });
        return result;
      }
      var arrayProto = Array.prototype;
      var funcProto = Function.prototype;
      var objectProto = Object.prototype;
      var coreJsData = root["__core-js_shared__"];
      var maskSrcKey = function() {
        var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
        return uid ? "Symbol(src)_1." + uid : "";
      }();
      var funcToString = funcProto.toString;
      var hasOwnProperty3 = objectProto.hasOwnProperty;
      var objectToString = objectProto.toString;
      var reIsNative = RegExp("^" + funcToString.call(hasOwnProperty3).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
      var Buffer2 = moduleExports ? root.Buffer : void 0;
      var Symbol2 = root.Symbol;
      var Uint8Array2 = root.Uint8Array;
      var getPrototype = overArg(Object.getPrototypeOf, Object);
      var objectCreate = Object.create;
      var propertyIsEnumerable = objectProto.propertyIsEnumerable;
      var splice = arrayProto.splice;
      var nativeGetSymbols = Object.getOwnPropertySymbols;
      var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
      var nativeKeys = overArg(Object.keys, Object);
      var DataView = getNative(root, "DataView");
      var Map = getNative(root, "Map");
      var Promise2 = getNative(root, "Promise");
      var Set2 = getNative(root, "Set");
      var WeakMap = getNative(root, "WeakMap");
      var nativeCreate = getNative(Object, "create");
      var dataViewCtorString = toSource(DataView);
      var mapCtorString = toSource(Map);
      var promiseCtorString = toSource(Promise2);
      var setCtorString = toSource(Set2);
      var weakMapCtorString = toSource(WeakMap);
      var symbolProto = Symbol2 ? Symbol2.prototype : void 0;
      var symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
      function Hash(entries) {
        var index2 = -1, length = entries ? entries.length : 0;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function hashClear() {
        this.__data__ = nativeCreate ? nativeCreate(null) : {};
      }
      function hashDelete(key) {
        return this.has(key) && delete this.__data__[key];
      }
      function hashGet(key) {
        var data = this.__data__;
        if (nativeCreate) {
          var result = data[key];
          return result === HASH_UNDEFINED ? void 0 : result;
        }
        return hasOwnProperty3.call(data, key) ? data[key] : void 0;
      }
      function hashHas(key) {
        var data = this.__data__;
        return nativeCreate ? data[key] !== void 0 : hasOwnProperty3.call(data, key);
      }
      function hashSet(key, value) {
        var data = this.__data__;
        data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value;
        return this;
      }
      Hash.prototype.clear = hashClear;
      Hash.prototype["delete"] = hashDelete;
      Hash.prototype.get = hashGet;
      Hash.prototype.has = hashHas;
      Hash.prototype.set = hashSet;
      function ListCache(entries) {
        var index2 = -1, length = entries ? entries.length : 0;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function listCacheClear() {
        this.__data__ = [];
      }
      function listCacheDelete(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          return false;
        }
        var lastIndex = data.length - 1;
        if (index2 == lastIndex) {
          data.pop();
        } else {
          splice.call(data, index2, 1);
        }
        return true;
      }
      function listCacheGet(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        return index2 < 0 ? void 0 : data[index2][1];
      }
      function listCacheHas(key) {
        return assocIndexOf(this.__data__, key) > -1;
      }
      function listCacheSet(key, value) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          data.push([key, value]);
        } else {
          data[index2][1] = value;
        }
        return this;
      }
      ListCache.prototype.clear = listCacheClear;
      ListCache.prototype["delete"] = listCacheDelete;
      ListCache.prototype.get = listCacheGet;
      ListCache.prototype.has = listCacheHas;
      ListCache.prototype.set = listCacheSet;
      function MapCache(entries) {
        var index2 = -1, length = entries ? entries.length : 0;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function mapCacheClear() {
        this.__data__ = {
          "hash": new Hash(),
          "map": new (Map || ListCache)(),
          "string": new Hash()
        };
      }
      function mapCacheDelete(key) {
        return getMapData(this, key)["delete"](key);
      }
      function mapCacheGet(key) {
        return getMapData(this, key).get(key);
      }
      function mapCacheHas(key) {
        return getMapData(this, key).has(key);
      }
      function mapCacheSet(key, value) {
        getMapData(this, key).set(key, value);
        return this;
      }
      MapCache.prototype.clear = mapCacheClear;
      MapCache.prototype["delete"] = mapCacheDelete;
      MapCache.prototype.get = mapCacheGet;
      MapCache.prototype.has = mapCacheHas;
      MapCache.prototype.set = mapCacheSet;
      function Stack(entries) {
        this.__data__ = new ListCache(entries);
      }
      function stackClear() {
        this.__data__ = new ListCache();
      }
      function stackDelete(key) {
        return this.__data__["delete"](key);
      }
      function stackGet(key) {
        return this.__data__.get(key);
      }
      function stackHas(key) {
        return this.__data__.has(key);
      }
      function stackSet(key, value) {
        var cache = this.__data__;
        if (cache instanceof ListCache) {
          var pairs = cache.__data__;
          if (!Map || pairs.length < LARGE_ARRAY_SIZE - 1) {
            pairs.push([key, value]);
            return this;
          }
          cache = this.__data__ = new MapCache(pairs);
        }
        cache.set(key, value);
        return this;
      }
      Stack.prototype.clear = stackClear;
      Stack.prototype["delete"] = stackDelete;
      Stack.prototype.get = stackGet;
      Stack.prototype.has = stackHas;
      Stack.prototype.set = stackSet;
      function arrayLikeKeys(value, inherited) {
        var result = isArray2(value) || isArguments2(value) ? baseTimes(value.length, String) : [];
        var length = result.length, skipIndexes = !!length;
        for (var key in value) {
          if ((inherited || hasOwnProperty3.call(value, key)) && !(skipIndexes && (key == "length" || isIndex2(key, length)))) {
            result.push(key);
          }
        }
        return result;
      }
      function assignValue(object, key, value) {
        var objValue = object[key];
        if (!(hasOwnProperty3.call(object, key) && eq(objValue, value)) || value === void 0 && !(key in object)) {
          object[key] = value;
        }
      }
      function assocIndexOf(array, key) {
        var length = array.length;
        while (length--) {
          if (eq(array[length][0], key)) {
            return length;
          }
        }
        return -1;
      }
      function baseAssign(object, source) {
        return object && copyObject(source, keys(source), object);
      }
      function baseClone(value, isDeep, isFull, customizer, key, object, stack) {
        var result;
        if (customizer) {
          result = object ? customizer(value, key, object, stack) : customizer(value);
        }
        if (result !== void 0) {
          return result;
        }
        if (!isObject2(value)) {
          return value;
        }
        var isArr = isArray2(value);
        if (isArr) {
          result = initCloneArray(value);
          if (!isDeep) {
            return copyArray(value, result);
          }
        } else {
          var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
          if (isBuffer(value)) {
            return cloneBuffer(value, isDeep);
          }
          if (tag == objectTag || tag == argsTag || isFunc && !object) {
            if (isHostObject(value)) {
              return object ? value : {};
            }
            result = initCloneObject(isFunc ? {} : value);
            if (!isDeep) {
              return copySymbols(value, baseAssign(result, value));
            }
          } else {
            if (!cloneableTags[tag]) {
              return object ? value : {};
            }
            result = initCloneByTag(value, tag, baseClone, isDeep);
          }
        }
        stack || (stack = new Stack());
        var stacked = stack.get(value);
        if (stacked) {
          return stacked;
        }
        stack.set(value, result);
        if (!isArr) {
          var props = isFull ? getAllKeys(value) : keys(value);
        }
        arrayEach(props || value, function(subValue, key2) {
          if (props) {
            key2 = subValue;
            subValue = value[key2];
          }
          assignValue(result, key2, baseClone(subValue, isDeep, isFull, customizer, key2, value, stack));
        });
        return result;
      }
      function baseCreate(proto) {
        return isObject2(proto) ? objectCreate(proto) : {};
      }
      function baseGetAllKeys(object, keysFunc, symbolsFunc) {
        var result = keysFunc(object);
        return isArray2(object) ? result : arrayPush(result, symbolsFunc(object));
      }
      function baseGetTag(value) {
        return objectToString.call(value);
      }
      function baseIsNative(value) {
        if (!isObject2(value) || isMasked(value)) {
          return false;
        }
        var pattern = isFunction2(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
        return pattern.test(toSource(value));
      }
      function baseKeys(object) {
        if (!isPrototype(object)) {
          return nativeKeys(object);
        }
        var result = [];
        for (var key in Object(object)) {
          if (hasOwnProperty3.call(object, key) && key != "constructor") {
            result.push(key);
          }
        }
        return result;
      }
      function cloneBuffer(buffer, isDeep) {
        if (isDeep) {
          return buffer.slice();
        }
        var result = new buffer.constructor(buffer.length);
        buffer.copy(result);
        return result;
      }
      function cloneArrayBuffer(arrayBuffer) {
        var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
        new Uint8Array2(result).set(new Uint8Array2(arrayBuffer));
        return result;
      }
      function cloneDataView(dataView, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
        return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
      }
      function cloneMap(map3, isDeep, cloneFunc) {
        var array = isDeep ? cloneFunc(mapToArray(map3), true) : mapToArray(map3);
        return arrayReduce(array, addMapEntry, new map3.constructor());
      }
      function cloneRegExp(regexp) {
        var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
        result.lastIndex = regexp.lastIndex;
        return result;
      }
      function cloneSet(set, isDeep, cloneFunc) {
        var array = isDeep ? cloneFunc(setToArray(set), true) : setToArray(set);
        return arrayReduce(array, addSetEntry, new set.constructor());
      }
      function cloneSymbol(symbol) {
        return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
      }
      function cloneTypedArray(typedArray, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
        return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
      }
      function copyArray(source, array) {
        var index2 = -1, length = source.length;
        array || (array = Array(length));
        while (++index2 < length) {
          array[index2] = source[index2];
        }
        return array;
      }
      function copyObject(source, props, object, customizer) {
        object || (object = {});
        var index2 = -1, length = props.length;
        while (++index2 < length) {
          var key = props[index2];
          var newValue = customizer ? customizer(object[key], source[key], key, object, source) : void 0;
          assignValue(object, key, newValue === void 0 ? source[key] : newValue);
        }
        return object;
      }
      function copySymbols(source, object) {
        return copyObject(source, getSymbols(source), object);
      }
      function getAllKeys(object) {
        return baseGetAllKeys(object, keys, getSymbols);
      }
      function getMapData(map3, key) {
        var data = map3.__data__;
        return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
      }
      function getNative(object, key) {
        var value = getValue(object, key);
        return baseIsNative(value) ? value : void 0;
      }
      var getSymbols = nativeGetSymbols ? overArg(nativeGetSymbols, Object) : stubArray;
      var getTag = baseGetTag;
      if (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag || Map && getTag(new Map()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap && getTag(new WeakMap()) != weakMapTag) {
        getTag = function(value) {
          var result = objectToString.call(value), Ctor = result == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : void 0;
          if (ctorString) {
            switch (ctorString) {
              case dataViewCtorString:
                return dataViewTag;
              case mapCtorString:
                return mapTag;
              case promiseCtorString:
                return promiseTag;
              case setCtorString:
                return setTag;
              case weakMapCtorString:
                return weakMapTag;
            }
          }
          return result;
        };
      }
      function initCloneArray(array) {
        var length = array.length, result = array.constructor(length);
        if (length && typeof array[0] == "string" && hasOwnProperty3.call(array, "index")) {
          result.index = array.index;
          result.input = array.input;
        }
        return result;
      }
      function initCloneObject(object) {
        return typeof object.constructor == "function" && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
      }
      function initCloneByTag(object, tag, cloneFunc, isDeep) {
        var Ctor = object.constructor;
        switch (tag) {
          case arrayBufferTag:
            return cloneArrayBuffer(object);
          case boolTag:
          case dateTag:
            return new Ctor(+object);
          case dataViewTag:
            return cloneDataView(object, isDeep);
          case float32Tag:
          case float64Tag:
          case int8Tag:
          case int16Tag:
          case int32Tag:
          case uint8Tag:
          case uint8ClampedTag:
          case uint16Tag:
          case uint32Tag:
            return cloneTypedArray(object, isDeep);
          case mapTag:
            return cloneMap(object, isDeep, cloneFunc);
          case numberTag:
          case stringTag:
            return new Ctor(object);
          case regexpTag:
            return cloneRegExp(object);
          case setTag:
            return cloneSet(object, isDeep, cloneFunc);
          case symbolTag:
            return cloneSymbol(object);
        }
      }
      function isIndex2(value, length) {
        length = length == null ? MAX_SAFE_INTEGER : length;
        return !!length && (typeof value == "number" || reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
      }
      function isKeyable(value) {
        var type = typeof value;
        return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
      }
      function isMasked(func) {
        return !!maskSrcKey && maskSrcKey in func;
      }
      function isPrototype(value) {
        var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
        return value === proto;
      }
      function toSource(func) {
        if (func != null) {
          try {
            return funcToString.call(func);
          } catch (e5) {
          }
          try {
            return func + "";
          } catch (e5) {
          }
        }
        return "";
      }
      function cloneDeep2(value) {
        return baseClone(value, true, true);
      }
      function eq(value, other) {
        return value === other || value !== value && other !== other;
      }
      function isArguments2(value) {
        return isArrayLikeObject(value) && hasOwnProperty3.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
      }
      var isArray2 = Array.isArray;
      function isArrayLike(value) {
        return value != null && isLength(value.length) && !isFunction2(value);
      }
      function isArrayLikeObject(value) {
        return isObjectLike(value) && isArrayLike(value);
      }
      var isBuffer = nativeIsBuffer || stubFalse;
      function isFunction2(value) {
        var tag = isObject2(value) ? objectToString.call(value) : "";
        return tag == funcTag || tag == genTag;
      }
      function isLength(value) {
        return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
      }
      function isObject2(value) {
        var type = typeof value;
        return !!value && (type == "object" || type == "function");
      }
      function isObjectLike(value) {
        return !!value && typeof value == "object";
      }
      function keys(object) {
        return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
      }
      function stubArray() {
        return [];
      }
      function stubFalse() {
        return false;
      }
      module.exports = cloneDeep2;
    }
  });

  // src/model/nodepathparser.js
  var require_nodepathparser = __commonJS({
    "src/model/nodepathparser.js"(exports, module) {
      function peg$subclass(child, parent) {
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
      }
      function peg$SyntaxError(message, expected, found, location) {
        this.message = message;
        this.expected = expected;
        this.found = found;
        this.location = location;
        this.name = "SyntaxError";
        if (typeof Error.captureStackTrace === "function") {
          Error.captureStackTrace(this, peg$SyntaxError);
        }
      }
      peg$subclass(peg$SyntaxError, Error);
      peg$SyntaxError.buildMessage = function(expected, found) {
        let DESCRIBE_EXPECTATION_FNS = {
          literal(expectation) {
            return `"${literalEscape(expectation.text)}"`;
          },
          class(expectation) {
            let escapedParts = "", i3;
            for (i3 = 0; i3 < expectation.parts.length; i3++) {
              escapedParts += expectation.parts[i3] instanceof Array ? `${classEscape(expectation.parts[i3][0])}-${classEscape(expectation.parts[i3][1])}` : classEscape(expectation.parts[i3]);
            }
            return `[${expectation.inverted ? "^" : ""}${escapedParts}]`;
          },
          any(expectation) {
            return "any character";
          },
          end(expectation) {
            return "end of input";
          },
          other(expectation) {
            return expectation.description;
          }
        };
        function hex(ch) {
          return ch.charCodeAt(0).toString(16).toUpperCase();
        }
        function literalEscape(s3) {
          return s3.replace(/\\/g, "\\\\").replace(/"/g, '\\"').replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, (ch) => {
            return `\\x0${hex(ch)}`;
          }).replace(/[\x10-\x1F\x7F-\x9F]/g, (ch) => {
            return `\\x${hex(ch)}`;
          });
        }
        function classEscape(s3) {
          return s3.replace(/\\/g, "\\\\").replace(/\]/g, "\\]").replace(/\^/g, "\\^").replace(/-/g, "\\-").replace(/\0/g, "\\0").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\r/g, "\\r").replace(/[\x00-\x0F]/g, (ch) => {
            return `\\x0${hex(ch)}`;
          }).replace(/[\x10-\x1F\x7F-\x9F]/g, (ch) => {
            return `\\x${hex(ch)}`;
          });
        }
        function describeExpectation(expectation) {
          return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
        }
        function describeExpected(expected2) {
          let descriptions = new Array(expected2.length), i3, j3;
          for (i3 = 0; i3 < expected2.length; i3++) {
            descriptions[i3] = describeExpectation(expected2[i3]);
          }
          descriptions.sort();
          if (descriptions.length > 0) {
            for (i3 = 1, j3 = 1; i3 < descriptions.length; i3++) {
              if (descriptions[i3 - 1] !== descriptions[i3]) {
                descriptions[j3] = descriptions[i3];
                j3++;
              }
            }
            descriptions.length = j3;
          }
          switch (descriptions.length) {
            case 1:
              return descriptions[0];
            case 2:
              return `${descriptions[0]} or ${descriptions[1]}`;
            default:
              return `${descriptions.slice(0, -1).join(", ")}, or ${descriptions[descriptions.length - 1]}`;
          }
        }
        function describeFound(found2) {
          return found2 ? `"${literalEscape(found2)}"` : "end of input";
        }
        return `Expected ${describeExpected(expected)} but ${describeFound(found)} found.`;
      };
      function peg$parse(input, options) {
        options = options !== void 0 ? options : {};
        let peg$FAILED = {}, peg$startRuleFunctions = {
          NodePathExpression: peg$parseNodePathExpression,
          Value: peg$parseValue
        }, peg$startRuleFunction = peg$parseNodePathExpression, peg$c0 = function(paths) {
          paths.keywords = keywords2;
          return paths;
        }, peg$c1 = function(left, right) {
          return combine(left, right, "union");
        }, peg$c2 = "union", peg$c3 = peg$literalExpectation("union", false), peg$c4 = function(union) {
          keyword("keyword");
          return union;
        }, peg$c5 = function(left, right) {
          return combine(left, right, "except");
        }, peg$c6 = "except", peg$c7 = peg$literalExpectation("except", false), peg$c8 = function(except) {
          keyword("keyword");
          return except;
        }, peg$c9 = function(left, right) {
          return combine(left, right, "intersect");
        }, peg$c10 = "intersect", peg$c11 = peg$literalExpectation("intersect", false), peg$c12 = function(intersect) {
          keyword("keyword");
          return intersect;
        }, peg$c13 = "[", peg$c14 = peg$literalExpectation("[", false), peg$c15 = "]", peg$c16 = peg$literalExpectation("]", false), peg$c17 = function(start2, end) {
          return {
            start: start2 === null ? 0 : start2,
            end
          };
        }, peg$c18 = ":", peg$c19 = peg$literalExpectation(":", false), peg$c20 = function(integer) {
          if (integer !== null) {
            return integer;
          }
          return Number.MAX_VALUE;
        }, peg$c21 = "-", peg$c22 = peg$literalExpectation("-", false), peg$c23 = /^[0-9]/, peg$c24 = peg$classExpectation([["0", "9"]], false, false), peg$c25 = function(sign3, number2) {
          if (sign3) {
            return -parseInt(number2.join(""), 10);
          }
          return parseInt(number2.join(""), 10);
        }, peg$c26 = "(", peg$c27 = peg$literalExpectation("(", false), peg$c28 = ")", peg$c29 = peg$literalExpectation(")", false), peg$c30 = function(expression, slice) {
          expression.slice = slice;
          return expression;
        }, peg$c31 = "/", peg$c32 = peg$literalExpectation("/", false), peg$c33 = function(absolute, step, trailingSteps) {
          let steps = [step];
          if (trailingSteps) {
            steps = steps.concat(trailingSteps);
          }
          return {
            absolute: !!absolute,
            steps
          };
        }, peg$c34 = function(axis, type, predicate, slice) {
          return type || predicate;
        }, peg$c35 = function(axis, type, predicate, slice) {
          if (!axis) {
            axis = "child";
          }
          if (!type) {
            type = "*";
          }
          if (!predicate) {
            predicate = "*";
          }
          return {
            axis,
            type,
            predicate,
            slice
          };
        }, peg$c36 = "ancestor-or-self::", peg$c37 = peg$literalExpectation("ancestor-or-self::", false), peg$c38 = "ancestor::", peg$c39 = peg$literalExpectation("ancestor::", false), peg$c40 = "child::", peg$c41 = peg$literalExpectation("child::", false), peg$c42 = "descendant-or-self::", peg$c43 = peg$literalExpectation("descendant-or-self::", false), peg$c44 = "descendant::", peg$c45 = peg$literalExpectation("descendant::", false), peg$c46 = "filter-descendants::", peg$c47 = peg$literalExpectation("filter-descendants::", false), peg$c48 = "following-sibling::", peg$c49 = peg$literalExpectation("following-sibling::", false), peg$c50 = "following::", peg$c51 = peg$literalExpectation("following::", false), peg$c52 = "preceding-sibling::", peg$c53 = peg$literalExpectation("preceding-sibling::", false), peg$c54 = "preceding::", peg$c55 = peg$literalExpectation("preceding::", false), peg$c56 = "parent::", peg$c57 = peg$literalExpectation("parent::", false), peg$c58 = "self::", peg$c59 = peg$literalExpectation("self::", false), peg$c60 = "//", peg$c61 = peg$literalExpectation("//", false), peg$c62 = "..", peg$c63 = peg$literalExpectation("..", false), peg$c64 = function(axis) {
          keyword("axis");
          switch (axis) {
            case "//":
              return "filter-descendants";
            case "/":
              return "descendant";
            case "..":
              return "parent";
            default:
              return axis.substr(0, axis.length - 2);
          }
        }, peg$c65 = function(name106) {
          let types = options.types;
          return types && types[name106];
        }, peg$c66 = function(name106) {
          keyword("keyword");
          return name106;
        }, peg$c67 = function(step) {
          return step;
        }, peg$c68 = function(left, right) {
          return combine(left, right, "or");
        }, peg$c69 = "or", peg$c70 = peg$literalExpectation("or", false), peg$c71 = function(or2) {
          keyword("keyword");
          return or2;
        }, peg$c72 = function(left, right) {
          return combine(left, right, "and");
        }, peg$c73 = "and", peg$c74 = peg$literalExpectation("and", false), peg$c75 = function(and2) {
          keyword("keyword");
          return and2;
        }, peg$c76 = function(not2, expression) {
          if (not2 && not2.length % 2) {
            return {
              not: expression
            };
          }
          return expression;
        }, peg$c77 = "not", peg$c78 = peg$literalExpectation("not", false), peg$c79 = function(not2) {
          keyword("keyword");
          return not2;
        }, peg$c80 = function(expression) {
          return expression;
        }, peg$c81 = "*", peg$c82 = peg$literalExpectation("*", false), peg$c83 = function(attributePath, relation, modifier, value) {
          return {
            attributePath,
            relation,
            modifier,
            value
          };
        }, peg$c84 = function(attributePath) {
          return {
            attributePath,
            relation: null,
            value: null
          };
        }, peg$c85 = "@", peg$c86 = peg$literalExpectation("@", false), peg$c87 = function(name106, trailingSegments) {
          let segments = [name106];
          if (trailingSegments) {
            segments = segments.concat(trailingSegments);
          }
          keyword("attributepath");
          return segments;
        }, peg$c88 = function(name106) {
          return name106;
        }, peg$c89 = function(startchar, chars) {
          return startchar + chars.join("");
        }, peg$c90 = function(char) {
          return char;
        }, peg$c91 = "beginswith", peg$c92 = peg$literalExpectation("beginswith", false), peg$c93 = "contains", peg$c94 = peg$literalExpectation("contains", false), peg$c95 = "endswith", peg$c96 = peg$literalExpectation("endswith", false), peg$c97 = "like", peg$c98 = peg$literalExpectation("like", false), peg$c99 = "matches", peg$c100 = peg$literalExpectation("matches", false), peg$c101 = "=", peg$c102 = peg$literalExpectation("=", false), peg$c103 = "!=", peg$c104 = peg$literalExpectation("!=", false), peg$c105 = "<=", peg$c106 = peg$literalExpectation("<=", false), peg$c107 = ">=", peg$c108 = peg$literalExpectation(">=", false), peg$c109 = "<", peg$c110 = peg$literalExpectation("<", false), peg$c111 = ">", peg$c112 = peg$literalExpectation(">", false), peg$c113 = function(relation) {
          keyword("relation");
          return relation;
        }, peg$c114 = "s", peg$c115 = peg$literalExpectation("s", false), peg$c116 = "i", peg$c117 = peg$literalExpectation("i", false), peg$c118 = "n", peg$c119 = peg$literalExpectation("n", false), peg$c120 = "d", peg$c121 = peg$literalExpectation("d", false), peg$c122 = function(modifier) {
          keyword("modifier");
          return modifier;
        }, peg$c123 = function(strings) {
          let results = [];
          for (let i3 = 0; i3 < strings.length; i3++) {
            results.push(strings[i3].join(""));
          }
          keyword("value");
          return results.join("").trim();
        }, peg$c124 = peg$otherExpectation("string"), peg$c125 = '"', peg$c126 = peg$literalExpectation('"', false), peg$c127 = function() {
          return "";
        }, peg$c128 = function(chars) {
          return chars;
        }, peg$c129 = function(chars) {
          return chars.join("");
        }, peg$c130 = /^[^"\\\0-\x1F\x7F]/, peg$c131 = peg$classExpectation(['"', "\\", ["\0", ""], "\x7F"], true, false), peg$c132 = '\\"', peg$c133 = peg$literalExpectation('\\"', false), peg$c134 = function() {
          return '"';
        }, peg$c135 = "\\\\", peg$c136 = peg$literalExpectation("\\\\", false), peg$c137 = function() {
          return "\\";
        }, peg$c138 = "\\/", peg$c139 = peg$literalExpectation("\\/", false), peg$c140 = function() {
          return "/";
        }, peg$c141 = "\\b", peg$c142 = peg$literalExpectation("\\b", false), peg$c143 = function() {
          return "\b";
        }, peg$c144 = "\\f", peg$c145 = peg$literalExpectation("\\f", false), peg$c146 = function() {
          return "\f";
        }, peg$c147 = "\\n", peg$c148 = peg$literalExpectation("\\n", false), peg$c149 = function() {
          return "\n";
        }, peg$c150 = "\\r", peg$c151 = peg$literalExpectation("\\r", false), peg$c152 = function() {
          return "\r";
        }, peg$c153 = "\\t", peg$c154 = peg$literalExpectation("\\t", false), peg$c155 = function() {
          return "	";
        }, peg$c156 = /^[.,]/, peg$c157 = peg$classExpectation([".", ","], false, false), peg$c158 = function(string2) {
          return string2;
        }, peg$c159 = /^[A-Z]/, peg$c160 = peg$classExpectation([["A", "Z"]], false, false), peg$c161 = "_", peg$c162 = peg$literalExpectation("_", false), peg$c163 = /^[a-z]/, peg$c164 = peg$classExpectation([["a", "z"]], false, false), peg$c165 = /^[\xC0-\xD6]/, peg$c166 = peg$classExpectation([["\xC0", "\xD6"]], false, false), peg$c167 = /^[\xD8-\xF6]/, peg$c168 = peg$classExpectation([["\xD8", "\xF6"]], false, false), peg$c169 = /^[\xF8-\u02FF]/, peg$c170 = peg$classExpectation([["\xF8", "\u02FF"]], false, false), peg$c171 = /^[\u0370-\u037D]/, peg$c172 = peg$classExpectation([["\u0370", "\u037D"]], false, false), peg$c173 = /^[\u037F-\u1FFF]/, peg$c174 = peg$classExpectation([["\u037F", "\u1FFF"]], false, false), peg$c175 = /^[\u200C-\u200D]/, peg$c176 = peg$classExpectation([["\u200C", "\u200D"]], false, false), peg$c177 = /^[\u2070-\u218F]/, peg$c178 = peg$classExpectation([["\u2070", "\u218F"]], false, false), peg$c179 = /^[\u2C00-\u2FEF]/, peg$c180 = peg$classExpectation([["\u2C00", "\u2FEF"]], false, false), peg$c181 = /^[\u3001-\uD7FF]/, peg$c182 = peg$classExpectation([["\u3001", "\uD7FF"]], false, false), peg$c183 = /^[\uF900-\uFDCF]/, peg$c184 = peg$classExpectation([["\uF900", "\uFDCF"]], false, false), peg$c185 = /^[\uFDF0-\uFFFD]/, peg$c186 = peg$classExpectation([["\uFDF0", "\uFFFD"]], false, false), peg$c187 = ".", peg$c188 = peg$literalExpectation(".", false), peg$c189 = /^[\xB7]/, peg$c190 = peg$classExpectation(["\xB7"], false, false), peg$c191 = /^[\u0300-\u036F]/, peg$c192 = peg$classExpectation([["\u0300", "\u036F"]], false, false), peg$c193 = /^[\u203F-\u2040]/, peg$c194 = peg$classExpectation([["\u203F", "\u2040"]], false, false), peg$c195 = peg$otherExpectation("whitespace"), peg$c196 = function(whitespace) {
          return whitespace.join("");
        }, peg$c197 = /^[ \t\n\r]/, peg$c198 = peg$classExpectation([" ", "	", "\n", "\r"], false, false), peg$currPos = 0, peg$savedPos = 0, peg$posDetailsCache = [{ line: 1, column: 1 }], peg$maxFailPos = 0, peg$maxFailExpected = [], peg$silentFails = 0, peg$result;
        if ("startRule" in options) {
          if (!(options.startRule in peg$startRuleFunctions)) {
            throw new Error(`Can't start parsing from rule "${options.startRule}".`);
          }
          peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
        }
        function text() {
          return input.substring(peg$savedPos, peg$currPos);
        }
        function location() {
          return peg$computeLocation(peg$savedPos, peg$currPos);
        }
        function expected(description, location2) {
          location2 = location2 !== void 0 ? location2 : peg$computeLocation(peg$savedPos, peg$currPos);
          throw peg$buildStructuredError([peg$otherExpectation(description)], input.substring(peg$savedPos, peg$currPos), location2);
        }
        function error(message, location2) {
          location2 = location2 !== void 0 ? location2 : peg$computeLocation(peg$savedPos, peg$currPos);
          throw peg$buildSimpleError(message, location2);
        }
        function peg$literalExpectation(text2, ignoreCase) {
          return { type: "literal", text: text2, ignoreCase };
        }
        function peg$classExpectation(parts, inverted, ignoreCase) {
          return { type: "class", parts, inverted, ignoreCase };
        }
        function peg$anyExpectation() {
          return { type: "any" };
        }
        function peg$endExpectation() {
          return { type: "end" };
        }
        function peg$otherExpectation(description) {
          return { type: "other", description };
        }
        function peg$computePosDetails(pos) {
          let details = peg$posDetailsCache[pos], p3;
          if (details) {
            return details;
          }
          p3 = pos - 1;
          while (!peg$posDetailsCache[p3]) {
            p3--;
          }
          details = peg$posDetailsCache[p3];
          details = {
            line: details.line,
            column: details.column
          };
          while (p3 < pos) {
            if (input.charCodeAt(p3) === 10) {
              details.line++;
              details.column = 1;
            } else {
              details.column++;
            }
            p3++;
          }
          peg$posDetailsCache[pos] = details;
          return details;
        }
        function peg$computeLocation(startPos, endPos) {
          let startPosDetails = peg$computePosDetails(startPos), endPosDetails = peg$computePosDetails(endPos);
          return {
            start: {
              offset: startPos,
              line: startPosDetails.line,
              column: startPosDetails.column
            },
            end: {
              offset: endPos,
              line: endPosDetails.line,
              column: endPosDetails.column
            }
          };
        }
        function peg$fail(expected2) {
          if (peg$currPos < peg$maxFailPos) {
            return;
          }
          if (peg$currPos > peg$maxFailPos) {
            peg$maxFailPos = peg$currPos;
            peg$maxFailExpected = [];
          }
          peg$maxFailExpected.push(expected2);
        }
        function peg$buildSimpleError(message, location2) {
          return new peg$SyntaxError(message, null, null, location2);
        }
        function peg$buildStructuredError(expected2, found, location2) {
          return new peg$SyntaxError(peg$SyntaxError.buildMessage(expected2, found), expected2, found, location2);
        }
        function peg$parseNodePathExpression() {
          let s0, s1, s22;
          s0 = peg$currPos;
          s1 = peg$parseUnionPaths();
          if (s1 !== peg$FAILED) {
            s22 = peg$parse_();
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c0(s1);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseUnionPaths() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = peg$parseExceptPaths();
          if (s1 !== peg$FAILED) {
            s22 = peg$parse_();
            if (s22 !== peg$FAILED) {
              s3 = peg$parseUnionKeyword();
              if (s3 !== peg$FAILED) {
                s4 = peg$parse_();
                if (s4 !== peg$FAILED) {
                  s5 = peg$parseUnionPaths();
                  if (s5 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c1(s1, s5);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseExceptPaths();
          }
          return s0;
        }
        function peg$parseUnionKeyword() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 5) === peg$c2) {
            s1 = peg$c2;
            peg$currPos += 5;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c3);
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c4(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseExceptPaths() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = peg$parseIntersectPaths();
          if (s1 !== peg$FAILED) {
            s22 = peg$parse_();
            if (s22 !== peg$FAILED) {
              s3 = peg$parseExceptKeyword();
              if (s3 !== peg$FAILED) {
                s4 = peg$parse_();
                if (s4 !== peg$FAILED) {
                  s5 = peg$parseExceptPaths();
                  if (s5 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c5(s1, s5);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseIntersectPaths();
          }
          return s0;
        }
        function peg$parseExceptKeyword() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 6) === peg$c6) {
            s1 = peg$c6;
            peg$currPos += 6;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c7);
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c8(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseIntersectPaths() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = peg$parsePathExpression();
          if (s1 !== peg$FAILED) {
            s22 = peg$parse_();
            if (s22 !== peg$FAILED) {
              s3 = peg$parseIntersectKeyword();
              if (s3 !== peg$FAILED) {
                s4 = peg$parse_();
                if (s4 !== peg$FAILED) {
                  s5 = peg$parseIntersectPaths();
                  if (s5 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c9(s1, s5);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parsePathExpression();
          }
          return s0;
        }
        function peg$parseIntersectKeyword() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 9) === peg$c10) {
            s1 = peg$c10;
            peg$currPos += 9;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c11);
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c12(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseSlice() {
          let s0, s1, s22, s3, s4;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 91) {
            s1 = peg$c13;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c14);
            }
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parseInteger();
            if (s22 !== peg$FAILED) {
              s3 = peg$parseSliceEnd();
              if (s3 === peg$FAILED) {
                s3 = null;
              }
              if (s3 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 93) {
                  s4 = peg$c15;
                  peg$currPos++;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c16);
                  }
                }
                if (s4 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c17(s22, s3);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseSliceEnd() {
          let s0, s1, s22;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 58) {
            s1 = peg$c18;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c19);
            }
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parseInteger();
            if (s22 === peg$FAILED) {
              s22 = null;
            }
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c20(s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseInteger() {
          let s0, s1, s22, s3;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 45) {
            s1 = peg$c21;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c22);
            }
          }
          if (s1 === peg$FAILED) {
            s1 = null;
          }
          if (s1 !== peg$FAILED) {
            s22 = [];
            if (peg$c23.test(input.charAt(peg$currPos))) {
              s3 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c24);
              }
            }
            if (s3 !== peg$FAILED) {
              while (s3 !== peg$FAILED) {
                s22.push(s3);
                if (peg$c23.test(input.charAt(peg$currPos))) {
                  s3 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s3 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c24);
                  }
                }
              }
            } else {
              s22 = peg$FAILED;
            }
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c25(s1, s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parsePathExpression() {
          let s0, s1, s22, s3, s4, s5, s6, s7;
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          s22 = peg$parseOrPredicates();
          peg$silentFails--;
          if (s22 === peg$FAILED) {
            s1 = void 0;
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 40) {
              s22 = peg$c26;
              peg$currPos++;
            } else {
              s22 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c27);
              }
            }
            if (s22 !== peg$FAILED) {
              s3 = peg$parse_();
              if (s3 !== peg$FAILED) {
                s4 = peg$parseUnionPaths();
                if (s4 !== peg$FAILED) {
                  s5 = peg$parse_();
                  if (s5 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 41) {
                      s6 = peg$c28;
                      peg$currPos++;
                    } else {
                      s6 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$c29);
                      }
                    }
                    if (s6 !== peg$FAILED) {
                      s7 = peg$parseSlice();
                      if (s7 === peg$FAILED) {
                        s7 = null;
                      }
                      if (s7 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c30(s4, s7);
                        s0 = s1;
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseNodePath();
          }
          return s0;
        }
        function peg$parseNodePath() {
          let s0, s1, s22, s3, s4;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 47) {
            s1 = peg$c31;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c32);
            }
          }
          if (s1 === peg$FAILED) {
            s1 = null;
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parsePathStep();
            if (s22 !== peg$FAILED) {
              s3 = [];
              s4 = peg$parseNodePathTrailingStep();
              while (s4 !== peg$FAILED) {
                s3.push(s4);
                s4 = peg$parseNodePathTrailingStep();
              }
              if (s3 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c33(s1, s22, s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parsePathStep() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = peg$parsePathStepAxis();
          if (s1 === peg$FAILED) {
            s1 = null;
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parsePathStepType();
            if (s22 === peg$FAILED) {
              s22 = null;
            }
            if (s22 !== peg$FAILED) {
              s3 = peg$parseOrPredicates();
              if (s3 === peg$FAILED) {
                s3 = null;
              }
              if (s3 !== peg$FAILED) {
                s4 = peg$parseSlice();
                if (s4 === peg$FAILED) {
                  s4 = null;
                }
                if (s4 !== peg$FAILED) {
                  peg$savedPos = peg$currPos;
                  s5 = peg$c34(s1, s22, s3, s4);
                  if (s5) {
                    s5 = void 0;
                  } else {
                    s5 = peg$FAILED;
                  }
                  if (s5 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c35(s1, s22, s3, s4);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parsePathStepAxis() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 18) === peg$c36) {
            s1 = peg$c36;
            peg$currPos += 18;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c37);
            }
          }
          if (s1 === peg$FAILED) {
            if (input.substr(peg$currPos, 10) === peg$c38) {
              s1 = peg$c38;
              peg$currPos += 10;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c39);
              }
            }
            if (s1 === peg$FAILED) {
              if (input.substr(peg$currPos, 7) === peg$c40) {
                s1 = peg$c40;
                peg$currPos += 7;
              } else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c41);
                }
              }
              if (s1 === peg$FAILED) {
                if (input.substr(peg$currPos, 20) === peg$c42) {
                  s1 = peg$c42;
                  peg$currPos += 20;
                } else {
                  s1 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c43);
                  }
                }
                if (s1 === peg$FAILED) {
                  if (input.substr(peg$currPos, 12) === peg$c44) {
                    s1 = peg$c44;
                    peg$currPos += 12;
                  } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c45);
                    }
                  }
                  if (s1 === peg$FAILED) {
                    if (input.substr(peg$currPos, 20) === peg$c46) {
                      s1 = peg$c46;
                      peg$currPos += 20;
                    } else {
                      s1 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$c47);
                      }
                    }
                    if (s1 === peg$FAILED) {
                      if (input.substr(peg$currPos, 19) === peg$c48) {
                        s1 = peg$c48;
                        peg$currPos += 19;
                      } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                          peg$fail(peg$c49);
                        }
                      }
                      if (s1 === peg$FAILED) {
                        if (input.substr(peg$currPos, 11) === peg$c50) {
                          s1 = peg$c50;
                          peg$currPos += 11;
                        } else {
                          s1 = peg$FAILED;
                          if (peg$silentFails === 0) {
                            peg$fail(peg$c51);
                          }
                        }
                        if (s1 === peg$FAILED) {
                          if (input.substr(peg$currPos, 19) === peg$c52) {
                            s1 = peg$c52;
                            peg$currPos += 19;
                          } else {
                            s1 = peg$FAILED;
                            if (peg$silentFails === 0) {
                              peg$fail(peg$c53);
                            }
                          }
                          if (s1 === peg$FAILED) {
                            if (input.substr(peg$currPos, 11) === peg$c54) {
                              s1 = peg$c54;
                              peg$currPos += 11;
                            } else {
                              s1 = peg$FAILED;
                              if (peg$silentFails === 0) {
                                peg$fail(peg$c55);
                              }
                            }
                            if (s1 === peg$FAILED) {
                              if (input.substr(peg$currPos, 8) === peg$c56) {
                                s1 = peg$c56;
                                peg$currPos += 8;
                              } else {
                                s1 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                  peg$fail(peg$c57);
                                }
                              }
                              if (s1 === peg$FAILED) {
                                if (input.substr(peg$currPos, 6) === peg$c58) {
                                  s1 = peg$c58;
                                  peg$currPos += 6;
                                } else {
                                  s1 = peg$FAILED;
                                  if (peg$silentFails === 0) {
                                    peg$fail(peg$c59);
                                  }
                                }
                                if (s1 === peg$FAILED) {
                                  if (input.substr(peg$currPos, 2) === peg$c60) {
                                    s1 = peg$c60;
                                    peg$currPos += 2;
                                  } else {
                                    s1 = peg$FAILED;
                                    if (peg$silentFails === 0) {
                                      peg$fail(peg$c61);
                                    }
                                  }
                                  if (s1 === peg$FAILED) {
                                    if (input.charCodeAt(peg$currPos) === 47) {
                                      s1 = peg$c31;
                                      peg$currPos++;
                                    } else {
                                      s1 = peg$FAILED;
                                      if (peg$silentFails === 0) {
                                        peg$fail(peg$c32);
                                      }
                                    }
                                    if (s1 === peg$FAILED) {
                                      if (input.substr(peg$currPos, 2) === peg$c62) {
                                        s1 = peg$c62;
                                        peg$currPos += 2;
                                      } else {
                                        s1 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                          peg$fail(peg$c63);
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c64(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parsePathStepType() {
          let s0, s1, s22, s3;
          s0 = peg$currPos;
          s1 = peg$parseName();
          if (s1 !== peg$FAILED) {
            peg$savedPos = peg$currPos;
            s22 = peg$c65(s1);
            if (s22) {
              s22 = void 0;
            } else {
              s22 = peg$FAILED;
            }
            if (s22 !== peg$FAILED) {
              s3 = peg$parse_();
              if (s3 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c66(s1);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseNodePathTrailingStep() {
          let s0, s1, s22;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 47) {
            s1 = peg$c31;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c32);
            }
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parsePathStep();
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c67(s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseOrPredicates() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = peg$parseAndPredicates();
          if (s1 !== peg$FAILED) {
            s22 = peg$parse_();
            if (s22 !== peg$FAILED) {
              s3 = peg$parseOrKeyword();
              if (s3 !== peg$FAILED) {
                s4 = peg$parse_();
                if (s4 !== peg$FAILED) {
                  s5 = peg$parseOrPredicates();
                  if (s5 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c68(s1, s5);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseAndPredicates();
          }
          return s0;
        }
        function peg$parseOrKeyword() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 2) === peg$c69) {
            s1 = peg$c69;
            peg$currPos += 2;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c70);
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c71(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseAndPredicates() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = peg$parseNotPredicate();
          if (s1 !== peg$FAILED) {
            s22 = peg$parse_();
            if (s22 !== peg$FAILED) {
              s3 = peg$parseAndKeyword();
              if (s3 !== peg$FAILED) {
                s4 = peg$parse_();
                if (s4 !== peg$FAILED) {
                  s5 = peg$parseAndPredicates();
                  if (s5 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c72(s1, s5);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parseNotPredicate();
          }
          return s0;
        }
        function peg$parseAndKeyword() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 3) === peg$c73) {
            s1 = peg$c73;
            peg$currPos += 3;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c74);
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c75(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseNotPredicate() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = [];
          s22 = peg$currPos;
          s3 = peg$parseNotKeyword();
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parsewhitespace();
            if (s5 !== peg$FAILED) {
              while (s5 !== peg$FAILED) {
                s4.push(s5);
                s5 = peg$parsewhitespace();
              }
            } else {
              s4 = peg$FAILED;
            }
            if (s4 !== peg$FAILED) {
              s3 = [s3, s4];
              s22 = s3;
            } else {
              peg$currPos = s22;
              s22 = peg$FAILED;
            }
          } else {
            peg$currPos = s22;
            s22 = peg$FAILED;
          }
          while (s22 !== peg$FAILED) {
            s1.push(s22);
            s22 = peg$currPos;
            s3 = peg$parseNotKeyword();
            if (s3 !== peg$FAILED) {
              s4 = [];
              s5 = peg$parsewhitespace();
              if (s5 !== peg$FAILED) {
                while (s5 !== peg$FAILED) {
                  s4.push(s5);
                  s5 = peg$parsewhitespace();
                }
              } else {
                s4 = peg$FAILED;
              }
              if (s4 !== peg$FAILED) {
                s3 = [s3, s4];
                s22 = s3;
              } else {
                peg$currPos = s22;
                s22 = peg$FAILED;
              }
            } else {
              peg$currPos = s22;
              s22 = peg$FAILED;
            }
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parsePredicateExpression();
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c76(s1, s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseNotKeyword() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 3) === peg$c77) {
            s1 = peg$c77;
            peg$currPos += 3;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c78);
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c79(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parsePredicateExpression() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 40) {
            s1 = peg$c26;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c27);
            }
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parse_();
            if (s22 !== peg$FAILED) {
              s3 = peg$parseOrPredicates();
              if (s3 !== peg$FAILED) {
                s4 = peg$parse_();
                if (s4 !== peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 41) {
                    s5 = peg$c28;
                    peg$currPos++;
                  } else {
                    s5 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c29);
                    }
                  }
                  if (s5 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c80(s3);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$parsePredicate();
          }
          return s0;
        }
        function peg$parsePredicate() {
          let s0, s1, s22, s3, s4, s5, s6, s7;
          if (input.charCodeAt(peg$currPos) === 42) {
            s0 = peg$c81;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c82);
            }
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseAttributePath();
            if (s1 === peg$FAILED) {
              s1 = null;
            }
            if (s1 !== peg$FAILED) {
              s22 = peg$parse_();
              if (s22 !== peg$FAILED) {
                s3 = peg$parseRelation();
                if (s3 === peg$FAILED) {
                  s3 = null;
                }
                if (s3 !== peg$FAILED) {
                  s4 = peg$parse_();
                  if (s4 !== peg$FAILED) {
                    s5 = peg$parseModifier();
                    if (s5 === peg$FAILED) {
                      s5 = null;
                    }
                    if (s5 !== peg$FAILED) {
                      s6 = peg$parse_();
                      if (s6 !== peg$FAILED) {
                        s7 = peg$parseValue();
                        if (s7 !== peg$FAILED) {
                          peg$savedPos = s0;
                          s1 = peg$c83(s1, s3, s5, s7);
                          s0 = s1;
                        } else {
                          peg$currPos = s0;
                          s0 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              s1 = peg$parseAttributePath();
              if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c84(s1);
              }
              s0 = s1;
            }
          }
          return s0;
        }
        function peg$parseAttributePath() {
          let s0, s1, s22, s3, s4;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 64) {
            s1 = peg$c85;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c86);
            }
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parseAttributePathSegmentName();
            if (s22 !== peg$FAILED) {
              s3 = [];
              s4 = peg$parseAttributePathSegment();
              while (s4 !== peg$FAILED) {
                s3.push(s4);
                s4 = peg$parseAttributePathSegment();
              }
              if (s3 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c87(s22, s3);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseAttributePathSegment() {
          let s0, s1, s22;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 58) {
            s1 = peg$c18;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c19);
            }
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parseAttributePathSegmentName();
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c88(s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseAttributePathSegmentName() {
          let s0, s1, s22, s3;
          s0 = peg$currPos;
          s1 = peg$parseAttributePathSegmentNameStartChar();
          if (s1 !== peg$FAILED) {
            s22 = [];
            s3 = peg$parseAttributePathSegmentNameChar();
            while (s3 !== peg$FAILED) {
              s22.push(s3);
              s3 = peg$parseAttributePathSegmentNameChar();
            }
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c89(s1, s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseAttributePathSegmentNameStartChar() {
          let s0, s1, s22;
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          if (input.charCodeAt(peg$currPos) === 58) {
            s22 = peg$c18;
            peg$currPos++;
          } else {
            s22 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c19);
            }
          }
          peg$silentFails--;
          if (s22 === peg$FAILED) {
            s1 = void 0;
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parseNameStartChar();
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c90(s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseAttributePathSegmentNameChar() {
          let s0, s1, s22;
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          if (input.charCodeAt(peg$currPos) === 58) {
            s22 = peg$c18;
            peg$currPos++;
          } else {
            s22 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c19);
            }
          }
          peg$silentFails--;
          if (s22 === peg$FAILED) {
            s1 = void 0;
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            s22 = peg$parseNameChar();
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c90(s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseRelation() {
          let s0, s1;
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 10) === peg$c91) {
            s1 = peg$c91;
            peg$currPos += 10;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c92);
            }
          }
          if (s1 === peg$FAILED) {
            if (input.substr(peg$currPos, 8) === peg$c93) {
              s1 = peg$c93;
              peg$currPos += 8;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c94);
              }
            }
            if (s1 === peg$FAILED) {
              if (input.substr(peg$currPos, 8) === peg$c95) {
                s1 = peg$c95;
                peg$currPos += 8;
              } else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c96);
                }
              }
              if (s1 === peg$FAILED) {
                if (input.substr(peg$currPos, 4) === peg$c97) {
                  s1 = peg$c97;
                  peg$currPos += 4;
                } else {
                  s1 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c98);
                  }
                }
                if (s1 === peg$FAILED) {
                  if (input.substr(peg$currPos, 7) === peg$c99) {
                    s1 = peg$c99;
                    peg$currPos += 7;
                  } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c100);
                    }
                  }
                  if (s1 === peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 61) {
                      s1 = peg$c101;
                      peg$currPos++;
                    } else {
                      s1 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$c102);
                      }
                    }
                    if (s1 === peg$FAILED) {
                      if (input.substr(peg$currPos, 2) === peg$c103) {
                        s1 = peg$c103;
                        peg$currPos += 2;
                      } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                          peg$fail(peg$c104);
                        }
                      }
                      if (s1 === peg$FAILED) {
                        if (input.substr(peg$currPos, 2) === peg$c105) {
                          s1 = peg$c105;
                          peg$currPos += 2;
                        } else {
                          s1 = peg$FAILED;
                          if (peg$silentFails === 0) {
                            peg$fail(peg$c106);
                          }
                        }
                        if (s1 === peg$FAILED) {
                          if (input.substr(peg$currPos, 2) === peg$c107) {
                            s1 = peg$c107;
                            peg$currPos += 2;
                          } else {
                            s1 = peg$FAILED;
                            if (peg$silentFails === 0) {
                              peg$fail(peg$c108);
                            }
                          }
                          if (s1 === peg$FAILED) {
                            if (input.charCodeAt(peg$currPos) === 60) {
                              s1 = peg$c109;
                              peg$currPos++;
                            } else {
                              s1 = peg$FAILED;
                              if (peg$silentFails === 0) {
                                peg$fail(peg$c110);
                              }
                            }
                            if (s1 === peg$FAILED) {
                              if (input.charCodeAt(peg$currPos) === 62) {
                                s1 = peg$c111;
                                peg$currPos++;
                              } else {
                                s1 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                  peg$fail(peg$c112);
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c113(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseModifier() {
          let s0, s1, s22, s3;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 91) {
            s1 = peg$c13;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c14);
            }
          }
          if (s1 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 115) {
              s22 = peg$c114;
              peg$currPos++;
            } else {
              s22 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c115);
              }
            }
            if (s22 === peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 105) {
                s22 = peg$c116;
                peg$currPos++;
              } else {
                s22 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c117);
                }
              }
              if (s22 === peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 110) {
                  s22 = peg$c118;
                  peg$currPos++;
                } else {
                  s22 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c119);
                  }
                }
                if (s22 === peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 100) {
                    s22 = peg$c120;
                    peg$currPos++;
                  } else {
                    s22 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c121);
                    }
                  }
                }
              }
            }
            if (s22 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 93) {
                s3 = peg$c15;
                peg$currPos++;
              } else {
                s3 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c16);
                }
              }
              if (s3 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c122(s22);
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parseValue() {
          let s0, s1, s22, s3, s4, s5;
          s0 = peg$currPos;
          s1 = [];
          s22 = peg$currPos;
          s3 = peg$parse_();
          if (s3 !== peg$FAILED) {
            s4 = peg$parseQuotedString();
            if (s4 === peg$FAILED) {
              s4 = peg$parseUnquotedString();
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              if (s5 !== peg$FAILED) {
                s3 = [s3, s4, s5];
                s22 = s3;
              } else {
                peg$currPos = s22;
                s22 = peg$FAILED;
              }
            } else {
              peg$currPos = s22;
              s22 = peg$FAILED;
            }
          } else {
            peg$currPos = s22;
            s22 = peg$FAILED;
          }
          if (s22 !== peg$FAILED) {
            while (s22 !== peg$FAILED) {
              s1.push(s22);
              s22 = peg$currPos;
              s3 = peg$parse_();
              if (s3 !== peg$FAILED) {
                s4 = peg$parseQuotedString();
                if (s4 === peg$FAILED) {
                  s4 = peg$parseUnquotedString();
                }
                if (s4 !== peg$FAILED) {
                  s5 = peg$parse_();
                  if (s5 !== peg$FAILED) {
                    s3 = [s3, s4, s5];
                    s22 = s3;
                  } else {
                    peg$currPos = s22;
                    s22 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s22;
                  s22 = peg$FAILED;
                }
              } else {
                peg$currPos = s22;
                s22 = peg$FAILED;
              }
            }
          } else {
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c123(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseQuotedString() {
          let s0, s1, s22, s3;
          peg$silentFails++;
          s0 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 34) {
            s1 = peg$c125;
            peg$currPos++;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c126);
            }
          }
          if (s1 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 34) {
              s22 = peg$c125;
              peg$currPos++;
            } else {
              s22 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c126);
              }
            }
            if (s22 !== peg$FAILED) {
              s3 = peg$parse_();
              if (s3 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c127();
                s0 = s1;
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 34) {
              s1 = peg$c125;
              peg$currPos++;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c126);
              }
            }
            if (s1 !== peg$FAILED) {
              s22 = peg$parseChars();
              if (s22 !== peg$FAILED) {
                if (input.charCodeAt(peg$currPos) === 34) {
                  s3 = peg$c125;
                  peg$currPos++;
                } else {
                  s3 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c126);
                  }
                }
                if (s3 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c128(s22);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          }
          peg$silentFails--;
          if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c124);
            }
          }
          return s0;
        }
        function peg$parseChars() {
          let s0, s1, s22;
          s0 = peg$currPos;
          s1 = [];
          s22 = peg$parseChar();
          if (s22 !== peg$FAILED) {
            while (s22 !== peg$FAILED) {
              s1.push(s22);
              s22 = peg$parseChar();
            }
          } else {
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c129(s1);
          }
          s0 = s1;
          return s0;
        }
        function peg$parseChar() {
          let s0, s1;
          if (peg$c130.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c131);
            }
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.substr(peg$currPos, 2) === peg$c132) {
              s1 = peg$c132;
              peg$currPos += 2;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c133);
              }
            }
            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c134();
            }
            s0 = s1;
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              if (input.substr(peg$currPos, 2) === peg$c135) {
                s1 = peg$c135;
                peg$currPos += 2;
              } else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c136);
                }
              }
              if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c137();
              }
              s0 = s1;
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                if (input.substr(peg$currPos, 2) === peg$c138) {
                  s1 = peg$c138;
                  peg$currPos += 2;
                } else {
                  s1 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c139);
                  }
                }
                if (s1 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c140();
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                  s0 = peg$currPos;
                  if (input.substr(peg$currPos, 2) === peg$c141) {
                    s1 = peg$c141;
                    peg$currPos += 2;
                  } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c142);
                    }
                  }
                  if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c143();
                  }
                  s0 = s1;
                  if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    if (input.substr(peg$currPos, 2) === peg$c144) {
                      s1 = peg$c144;
                      peg$currPos += 2;
                    } else {
                      s1 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$c145);
                      }
                    }
                    if (s1 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s1 = peg$c146();
                    }
                    s0 = s1;
                    if (s0 === peg$FAILED) {
                      s0 = peg$currPos;
                      if (input.substr(peg$currPos, 2) === peg$c147) {
                        s1 = peg$c147;
                        peg$currPos += 2;
                      } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) {
                          peg$fail(peg$c148);
                        }
                      }
                      if (s1 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s1 = peg$c149();
                      }
                      s0 = s1;
                      if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        if (input.substr(peg$currPos, 2) === peg$c150) {
                          s1 = peg$c150;
                          peg$currPos += 2;
                        } else {
                          s1 = peg$FAILED;
                          if (peg$silentFails === 0) {
                            peg$fail(peg$c151);
                          }
                        }
                        if (s1 !== peg$FAILED) {
                          peg$savedPos = s0;
                          s1 = peg$c152();
                        }
                        s0 = s1;
                        if (s0 === peg$FAILED) {
                          s0 = peg$currPos;
                          if (input.substr(peg$currPos, 2) === peg$c153) {
                            s1 = peg$c153;
                            peg$currPos += 2;
                          } else {
                            s1 = peg$FAILED;
                            if (peg$silentFails === 0) {
                              peg$fail(peg$c154);
                            }
                          }
                          if (s1 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s1 = peg$c155();
                          }
                          s0 = s1;
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          return s0;
        }
        function peg$parseUnquotedString() {
          let s0, s1, s22, s3, s4, s5;
          peg$silentFails++;
          s0 = peg$currPos;
          s1 = peg$currPos;
          peg$silentFails++;
          s22 = peg$currPos;
          s3 = peg$parseReserved();
          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parsewhitespace();
            if (s5 !== peg$FAILED) {
              while (s5 !== peg$FAILED) {
                s4.push(s5);
                s5 = peg$parsewhitespace();
              }
            } else {
              s4 = peg$FAILED;
            }
            if (s4 !== peg$FAILED) {
              s3 = [s3, s4];
              s22 = s3;
            } else {
              peg$currPos = s22;
              s22 = peg$FAILED;
            }
          } else {
            peg$currPos = s22;
            s22 = peg$FAILED;
          }
          peg$silentFails--;
          if (s22 === peg$FAILED) {
            s1 = void 0;
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
          if (s1 !== peg$FAILED) {
            if (peg$c23.test(input.charAt(peg$currPos))) {
              s22 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s22 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c24);
              }
            }
            if (s22 === peg$FAILED) {
              if (peg$c156.test(input.charAt(peg$currPos))) {
                s22 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s22 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c157);
                }
              }
              if (s22 === peg$FAILED) {
                s22 = peg$parseName();
              }
            }
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c158(s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          peg$silentFails--;
          if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c124);
            }
          }
          return s0;
        }
        function peg$parseReserved() {
          let s0;
          if (input.substr(peg$currPos, 5) === peg$c2) {
            s0 = peg$c2;
            peg$currPos += 5;
          } else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c3);
            }
          }
          if (s0 === peg$FAILED) {
            if (input.substr(peg$currPos, 6) === peg$c6) {
              s0 = peg$c6;
              peg$currPos += 6;
            } else {
              s0 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c7);
              }
            }
            if (s0 === peg$FAILED) {
              if (input.substr(peg$currPos, 9) === peg$c10) {
                s0 = peg$c10;
                peg$currPos += 9;
              } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c11);
                }
              }
              if (s0 === peg$FAILED) {
                if (input.substr(peg$currPos, 3) === peg$c73) {
                  s0 = peg$c73;
                  peg$currPos += 3;
                } else {
                  s0 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c74);
                  }
                }
                if (s0 === peg$FAILED) {
                  if (input.substr(peg$currPos, 2) === peg$c69) {
                    s0 = peg$c69;
                    peg$currPos += 2;
                  } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c70);
                    }
                  }
                  if (s0 === peg$FAILED) {
                    if (input.substr(peg$currPos, 3) === peg$c77) {
                      s0 = peg$c77;
                      peg$currPos += 3;
                    } else {
                      s0 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$c78);
                      }
                    }
                  }
                }
              }
            }
          }
          return s0;
        }
        function peg$parseNameStartChar() {
          let s0;
          if (input.charCodeAt(peg$currPos) === 58) {
            s0 = peg$c18;
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c19);
            }
          }
          if (s0 === peg$FAILED) {
            if (peg$c159.test(input.charAt(peg$currPos))) {
              s0 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s0 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c160);
              }
            }
            if (s0 === peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 95) {
                s0 = peg$c161;
                peg$currPos++;
              } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c162);
                }
              }
              if (s0 === peg$FAILED) {
                if (peg$c163.test(input.charAt(peg$currPos))) {
                  s0 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s0 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c164);
                  }
                }
                if (s0 === peg$FAILED) {
                  if (peg$c165.test(input.charAt(peg$currPos))) {
                    s0 = input.charAt(peg$currPos);
                    peg$currPos++;
                  } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c166);
                    }
                  }
                  if (s0 === peg$FAILED) {
                    if (peg$c167.test(input.charAt(peg$currPos))) {
                      s0 = input.charAt(peg$currPos);
                      peg$currPos++;
                    } else {
                      s0 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$c168);
                      }
                    }
                    if (s0 === peg$FAILED) {
                      if (peg$c169.test(input.charAt(peg$currPos))) {
                        s0 = input.charAt(peg$currPos);
                        peg$currPos++;
                      } else {
                        s0 = peg$FAILED;
                        if (peg$silentFails === 0) {
                          peg$fail(peg$c170);
                        }
                      }
                      if (s0 === peg$FAILED) {
                        if (peg$c171.test(input.charAt(peg$currPos))) {
                          s0 = input.charAt(peg$currPos);
                          peg$currPos++;
                        } else {
                          s0 = peg$FAILED;
                          if (peg$silentFails === 0) {
                            peg$fail(peg$c172);
                          }
                        }
                        if (s0 === peg$FAILED) {
                          if (peg$c173.test(input.charAt(peg$currPos))) {
                            s0 = input.charAt(peg$currPos);
                            peg$currPos++;
                          } else {
                            s0 = peg$FAILED;
                            if (peg$silentFails === 0) {
                              peg$fail(peg$c174);
                            }
                          }
                          if (s0 === peg$FAILED) {
                            if (peg$c175.test(input.charAt(peg$currPos))) {
                              s0 = input.charAt(peg$currPos);
                              peg$currPos++;
                            } else {
                              s0 = peg$FAILED;
                              if (peg$silentFails === 0) {
                                peg$fail(peg$c176);
                              }
                            }
                            if (s0 === peg$FAILED) {
                              if (peg$c177.test(input.charAt(peg$currPos))) {
                                s0 = input.charAt(peg$currPos);
                                peg$currPos++;
                              } else {
                                s0 = peg$FAILED;
                                if (peg$silentFails === 0) {
                                  peg$fail(peg$c178);
                                }
                              }
                              if (s0 === peg$FAILED) {
                                if (peg$c179.test(input.charAt(peg$currPos))) {
                                  s0 = input.charAt(peg$currPos);
                                  peg$currPos++;
                                } else {
                                  s0 = peg$FAILED;
                                  if (peg$silentFails === 0) {
                                    peg$fail(peg$c180);
                                  }
                                }
                                if (s0 === peg$FAILED) {
                                  if (peg$c181.test(input.charAt(peg$currPos))) {
                                    s0 = input.charAt(peg$currPos);
                                    peg$currPos++;
                                  } else {
                                    s0 = peg$FAILED;
                                    if (peg$silentFails === 0) {
                                      peg$fail(peg$c182);
                                    }
                                  }
                                  if (s0 === peg$FAILED) {
                                    if (peg$c183.test(input.charAt(peg$currPos))) {
                                      s0 = input.charAt(peg$currPos);
                                      peg$currPos++;
                                    } else {
                                      s0 = peg$FAILED;
                                      if (peg$silentFails === 0) {
                                        peg$fail(peg$c184);
                                      }
                                    }
                                    if (s0 === peg$FAILED) {
                                      if (peg$c185.test(input.charAt(peg$currPos))) {
                                        s0 = input.charAt(peg$currPos);
                                        peg$currPos++;
                                      } else {
                                        s0 = peg$FAILED;
                                        if (peg$silentFails === 0) {
                                          peg$fail(peg$c186);
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          return s0;
        }
        function peg$parseNameChar() {
          let s0;
          s0 = peg$parseNameStartChar();
          if (s0 === peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 45) {
              s0 = peg$c21;
              peg$currPos++;
            } else {
              s0 = peg$FAILED;
              if (peg$silentFails === 0) {
                peg$fail(peg$c22);
              }
            }
            if (s0 === peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 46) {
                s0 = peg$c187;
                peg$currPos++;
              } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) {
                  peg$fail(peg$c188);
                }
              }
              if (s0 === peg$FAILED) {
                if (peg$c23.test(input.charAt(peg$currPos))) {
                  s0 = input.charAt(peg$currPos);
                  peg$currPos++;
                } else {
                  s0 = peg$FAILED;
                  if (peg$silentFails === 0) {
                    peg$fail(peg$c24);
                  }
                }
                if (s0 === peg$FAILED) {
                  if (peg$c189.test(input.charAt(peg$currPos))) {
                    s0 = input.charAt(peg$currPos);
                    peg$currPos++;
                  } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) {
                      peg$fail(peg$c190);
                    }
                  }
                  if (s0 === peg$FAILED) {
                    if (peg$c191.test(input.charAt(peg$currPos))) {
                      s0 = input.charAt(peg$currPos);
                      peg$currPos++;
                    } else {
                      s0 = peg$FAILED;
                      if (peg$silentFails === 0) {
                        peg$fail(peg$c192);
                      }
                    }
                    if (s0 === peg$FAILED) {
                      if (peg$c193.test(input.charAt(peg$currPos))) {
                        s0 = input.charAt(peg$currPos);
                        peg$currPos++;
                      } else {
                        s0 = peg$FAILED;
                        if (peg$silentFails === 0) {
                          peg$fail(peg$c194);
                        }
                      }
                    }
                  }
                }
              }
            }
          }
          return s0;
        }
        function peg$parseName() {
          let s0, s1, s22, s3;
          s0 = peg$currPos;
          s1 = peg$parseNameStartChar();
          if (s1 !== peg$FAILED) {
            s22 = [];
            s3 = peg$parseNameChar();
            while (s3 !== peg$FAILED) {
              s22.push(s3);
              s3 = peg$parseNameChar();
            }
            if (s22 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c89(s1, s22);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          return s0;
        }
        function peg$parse_() {
          let s0, s1, s22;
          peg$silentFails++;
          s0 = peg$currPos;
          s1 = [];
          s22 = peg$parsewhitespace();
          while (s22 !== peg$FAILED) {
            s1.push(s22);
            s22 = peg$parsewhitespace();
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c196(s1);
          }
          s0 = s1;
          peg$silentFails--;
          if (s0 === peg$FAILED) {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c195);
            }
          }
          return s0;
        }
        function peg$parsewhitespace() {
          let s0;
          if (peg$c197.test(input.charAt(peg$currPos))) {
            s0 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) {
              peg$fail(peg$c198);
            }
          }
          return s0;
        }
        function combine(left, right, label) {
          if (right) {
            let result = {};
            result[label] = [left, right];
            return result;
          }
          return left;
        }
        var keywords2 = [];
        function keyword(label, offsetValue, textValue) {
          offsetValue = offsetValue === void 0 ? location() : offsetValue;
          textValue = textValue === void 0 ? text() : textValue;
          keywords2.push({
            label,
            offset: offsetValue,
            text: textValue
          });
        }
        peg$result = peg$startRuleFunction();
        if (peg$result !== peg$FAILED && peg$currPos === input.length) {
          return peg$result;
        }
        if (peg$result !== peg$FAILED && peg$currPos < input.length) {
          peg$fail(peg$endExpectation());
        }
        throw peg$buildStructuredError(peg$maxFailExpected, peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null, peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos));
      }
      module.exports = {
        SyntaxError: peg$SyntaxError,
        parse: peg$parse
      };
    }
  });

  // node_modules/@plaincontext/codemirror/addon/search/searchcursor.js
  var require_searchcursor = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/search/searchcursor.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var Pos = CodeMirror5.Pos;
        function regexpFlags(regexp) {
          var flags = regexp.flags;
          return flags != null ? flags : (regexp.ignoreCase ? "i" : "") + (regexp.global ? "g" : "") + (regexp.multiline ? "m" : "");
        }
        function ensureFlags(regexp, flags) {
          var current = regexpFlags(regexp), target = current;
          for (var i3 = 0; i3 < flags.length; i3++)
            if (target.indexOf(flags.charAt(i3)) == -1)
              target += flags.charAt(i3);
          return current == target ? regexp : new RegExp(regexp.source, target);
        }
        function maybeMultiline(regexp) {
          return /\\s|\\n|\n|\\W|\\D|\[\^/.test(regexp.source);
        }
        function searchRegexpForward(doc, regexp, start2) {
          regexp = ensureFlags(regexp, "g");
          for (var line = start2.line, ch = start2.ch, last = doc.lastLine(); line <= last; line++, ch = 0) {
            regexp.lastIndex = ch;
            var string2 = doc.getLine(line), match = regexp.exec(string2);
            if (match)
              return {
                from: Pos(line, match.index),
                to: Pos(line, match.index + match[0].length),
                match
              };
          }
        }
        function searchRegexpForwardMultiline(doc, regexp, start2) {
          if (!maybeMultiline(regexp))
            return searchRegexpForward(doc, regexp, start2);
          regexp = ensureFlags(regexp, "gm");
          var string2, chunk = 1;
          for (var line = start2.line, last = doc.lastLine(); line <= last; ) {
            for (var i3 = 0; i3 < chunk; i3++) {
              if (line > last)
                break;
              var curLine = doc.getLine(line++);
              string2 = string2 == null ? curLine : string2 + "\n" + curLine;
            }
            chunk = chunk * 2;
            regexp.lastIndex = start2.ch;
            var match = regexp.exec(string2);
            if (match) {
              var before = string2.slice(0, match.index).split("\n"), inside = match[0].split("\n");
              var startLine = start2.line + before.length - 1, startCh = before[before.length - 1].length;
              return {
                from: Pos(startLine, startCh),
                to: Pos(startLine + inside.length - 1, inside.length == 1 ? startCh + inside[0].length : inside[inside.length - 1].length),
                match
              };
            }
          }
        }
        function lastMatchIn(string2, regexp, endMargin) {
          var match, from = 0;
          while (from <= string2.length) {
            regexp.lastIndex = from;
            var newMatch = regexp.exec(string2);
            if (!newMatch)
              break;
            var end = newMatch.index + newMatch[0].length;
            if (end > string2.length - endMargin)
              break;
            if (!match || end > match.index + match[0].length)
              match = newMatch;
            from = newMatch.index + 1;
          }
          return match;
        }
        function searchRegexpBackward(doc, regexp, start2) {
          regexp = ensureFlags(regexp, "g");
          for (var line = start2.line, ch = start2.ch, first = doc.firstLine(); line >= first; line--, ch = -1) {
            var string2 = doc.getLine(line);
            var match = lastMatchIn(string2, regexp, ch < 0 ? 0 : string2.length - ch);
            if (match)
              return {
                from: Pos(line, match.index),
                to: Pos(line, match.index + match[0].length),
                match
              };
          }
        }
        function searchRegexpBackwardMultiline(doc, regexp, start2) {
          if (!maybeMultiline(regexp))
            return searchRegexpBackward(doc, regexp, start2);
          regexp = ensureFlags(regexp, "gm");
          var string2, chunkSize = 1, endMargin = doc.getLine(start2.line).length - start2.ch;
          for (var line = start2.line, first = doc.firstLine(); line >= first; ) {
            for (var i3 = 0; i3 < chunkSize && line >= first; i3++) {
              var curLine = doc.getLine(line--);
              string2 = string2 == null ? curLine : curLine + "\n" + string2;
            }
            chunkSize *= 2;
            var match = lastMatchIn(string2, regexp, endMargin);
            if (match) {
              var before = string2.slice(0, match.index).split("\n"), inside = match[0].split("\n");
              var startLine = line + before.length, startCh = before[before.length - 1].length;
              return {
                from: Pos(startLine, startCh),
                to: Pos(startLine + inside.length - 1, inside.length == 1 ? startCh + inside[0].length : inside[inside.length - 1].length),
                match
              };
            }
          }
        }
        var doFold, noFold;
        if (String.prototype.normalize) {
          doFold = function(str) {
            return str.normalize("NFD").toLowerCase();
          };
          noFold = function(str) {
            return str.normalize("NFD");
          };
        } else {
          doFold = function(str) {
            return str.toLowerCase();
          };
          noFold = function(str) {
            return str;
          };
        }
        function adjustPos(orig, folded, pos, foldFunc) {
          if (orig.length == folded.length)
            return pos;
          for (var min2 = 0, max2 = pos + Math.max(0, orig.length - folded.length); ; ) {
            if (min2 == max2)
              return min2;
            var mid = min2 + max2 >> 1;
            var len = foldFunc(orig.slice(0, mid)).length;
            if (len == pos)
              return mid;
            else if (len > pos)
              max2 = mid;
            else
              min2 = mid + 1;
          }
        }
        function searchStringForward(doc, query, start2, caseFold) {
          if (!query.length)
            return null;
          var fold = caseFold ? doFold : noFold;
          var lines = fold(query).split(/\r|\n\r?/);
          search:
            for (var line = start2.line, ch = start2.ch, last = doc.lastLine() + 1 - lines.length; line <= last; line++, ch = 0) {
              var orig = doc.getLine(line).slice(ch), string2 = fold(orig);
              if (lines.length == 1) {
                var found = string2.indexOf(lines[0]);
                if (found == -1)
                  continue search;
                var start2 = adjustPos(orig, string2, found, fold) + ch;
                return {
                  from: Pos(line, adjustPos(orig, string2, found, fold) + ch),
                  to: Pos(line, adjustPos(orig, string2, found + lines[0].length, fold) + ch)
                };
              } else {
                var cutFrom = string2.length - lines[0].length;
                if (string2.slice(cutFrom) != lines[0])
                  continue search;
                for (var i3 = 1; i3 < lines.length - 1; i3++)
                  if (fold(doc.getLine(line + i3)) != lines[i3])
                    continue search;
                var end = doc.getLine(line + lines.length - 1), endString = fold(end), lastLine = lines[lines.length - 1];
                if (endString.slice(0, lastLine.length) != lastLine)
                  continue search;
                return {
                  from: Pos(line, adjustPos(orig, string2, cutFrom, fold) + ch),
                  to: Pos(line + lines.length - 1, adjustPos(end, endString, lastLine.length, fold))
                };
              }
            }
        }
        function searchStringBackward(doc, query, start2, caseFold) {
          if (!query.length)
            return null;
          var fold = caseFold ? doFold : noFold;
          var lines = fold(query).split(/\r|\n\r?/);
          search:
            for (var line = start2.line, ch = start2.ch, first = doc.firstLine() - 1 + lines.length; line >= first; line--, ch = -1) {
              var orig = doc.getLine(line);
              if (ch > -1)
                orig = orig.slice(0, ch);
              var string2 = fold(orig);
              if (lines.length == 1) {
                var found = string2.lastIndexOf(lines[0]);
                if (found == -1)
                  continue search;
                return {
                  from: Pos(line, adjustPos(orig, string2, found, fold)),
                  to: Pos(line, adjustPos(orig, string2, found + lines[0].length, fold))
                };
              } else {
                var lastLine = lines[lines.length - 1];
                if (string2.slice(0, lastLine.length) != lastLine)
                  continue search;
                for (var i3 = 1, start2 = line - lines.length + 1; i3 < lines.length - 1; i3++)
                  if (fold(doc.getLine(start2 + i3)) != lines[i3])
                    continue search;
                var top = doc.getLine(line + 1 - lines.length), topString = fold(top);
                if (topString.slice(topString.length - lines[0].length) != lines[0])
                  continue search;
                return {
                  from: Pos(line + 1 - lines.length, adjustPos(top, topString, top.length - lines[0].length, fold)),
                  to: Pos(line, adjustPos(orig, string2, lastLine.length, fold))
                };
              }
            }
        }
        function SearchCursor(doc, query, pos, options) {
          this.atOccurrence = false;
          this.doc = doc;
          pos = pos ? doc.clipPos(pos) : Pos(0, 0);
          this.pos = { from: pos, to: pos };
          var caseFold;
          if (typeof options == "object") {
            caseFold = options.caseFold;
          } else {
            caseFold = options;
            options = null;
          }
          if (typeof query == "string") {
            if (caseFold == null)
              caseFold = false;
            this.matches = function(reverse, pos2) {
              return (reverse ? searchStringBackward : searchStringForward)(doc, query, pos2, caseFold);
            };
          } else {
            query = ensureFlags(query, "gm");
            if (!options || options.multiline !== false)
              this.matches = function(reverse, pos2) {
                return (reverse ? searchRegexpBackwardMultiline : searchRegexpForwardMultiline)(doc, query, pos2);
              };
            else
              this.matches = function(reverse, pos2) {
                return (reverse ? searchRegexpBackward : searchRegexpForward)(doc, query, pos2);
              };
          }
        }
        SearchCursor.prototype = {
          findNext: function() {
            return this.find(false);
          },
          findPrevious: function() {
            return this.find(true);
          },
          find: function(reverse) {
            var result = this.matches(reverse, this.doc.clipPos(reverse ? this.pos.from : this.pos.to));
            while (result && CodeMirror5.cmpPos(result.from, result.to) == 0) {
              if (reverse) {
                if (result.from.ch)
                  result.from = Pos(result.from.line, result.from.ch - 1);
                else if (result.from.line == this.doc.firstLine())
                  result = null;
                else
                  result = this.matches(reverse, this.doc.clipPos(Pos(result.from.line - 1)));
              } else {
                if (result.to.ch < this.doc.getLine(result.to.line).length)
                  result.to = Pos(result.to.line, result.to.ch + 1);
                else if (result.to.line == this.doc.lastLine())
                  result = null;
                else
                  result = this.matches(reverse, Pos(result.to.line + 1, 0));
              }
            }
            if (result) {
              this.pos = result;
              this.atOccurrence = true;
              return this.pos.match || true;
            } else {
              var end = Pos(reverse ? this.doc.firstLine() : this.doc.lastLine() + 1, 0);
              this.pos = { from: end, to: end };
              return this.atOccurrence = false;
            }
          },
          from: function() {
            if (this.atOccurrence)
              return this.pos.from;
          },
          to: function() {
            if (this.atOccurrence)
              return this.pos.to;
          },
          replace: function(newText, origin) {
            if (!this.atOccurrence)
              return;
            var lines = CodeMirror5.splitLines(newText);
            this.doc.replaceRange(lines, this.pos.from, this.pos.to, origin);
            this.pos.to = Pos(this.pos.from.line + lines.length - 1, lines[lines.length - 1].length + (lines.length == 1 ? this.pos.from.ch : 0));
          }
        };
        CodeMirror5.defineExtension("getSearchCursor", function(query, pos, caseFold) {
          return new SearchCursor(this.doc, query, pos, caseFold);
        });
        CodeMirror5.defineDocExtension("getSearchCursor", function(query, pos, caseFold) {
          return new SearchCursor(this, query, pos, caseFold);
        });
        CodeMirror5.defineExtension("selectMatches", function(query, caseFold) {
          var ranges = [];
          var cur = this.getSearchCursor(query, this.getCursor("from"), caseFold);
          while (cur.findNext()) {
            if (CodeMirror5.cmpPos(cur.to(), this.getCursor("to")) > 0)
              break;
            ranges.push({ anchor: cur.from(), head: cur.to() });
          }
          if (ranges.length)
            this.setSelections(ranges, 0);
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/dialog/dialog.js
  var require_dialog = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/dialog/dialog.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        function dialogDiv(cm, template, bottom) {
          var wrap = cm.getWrapperElement();
          var dialog;
          dialog = wrap.appendChild(document.createElement("div"));
          if (bottom)
            dialog.className = "CodeMirror-dialog CodeMirror-dialog-bottom";
          else
            dialog.className = "CodeMirror-dialog CodeMirror-dialog-top";
          if (typeof template == "string") {
            dialog.innerHTML = template;
          } else {
            dialog.appendChild(template);
          }
          CodeMirror5.addClass(wrap, "dialog-opened");
          return dialog;
        }
        function closeNotification(cm, newVal) {
          if (cm.state.currentNotificationClose)
            cm.state.currentNotificationClose();
          cm.state.currentNotificationClose = newVal;
        }
        CodeMirror5.defineExtension("openDialog", function(template, callback, options) {
          if (!options)
            options = {};
          closeNotification(this, null);
          var dialog = dialogDiv(this, template, options.bottom);
          var closed = false, me = this;
          function close(newVal) {
            if (typeof newVal == "string") {
              inp.value = newVal;
            } else {
              if (closed)
                return;
              closed = true;
              CodeMirror5.rmClass(dialog.parentNode, "dialog-opened");
              dialog.parentNode.removeChild(dialog);
              me.focus();
              if (options.onClose)
                options.onClose(dialog);
            }
          }
          var inp = dialog.getElementsByTagName("input")[0], button;
          if (inp) {
            inp.focus();
            if (options.value) {
              inp.value = options.value;
              if (options.selectValueOnOpen !== false) {
                inp.select();
              }
            }
            if (options.onInput)
              CodeMirror5.on(inp, "input", function(e5) {
                options.onInput(e5, inp.value, close);
              });
            if (options.onKeyUp)
              CodeMirror5.on(inp, "keyup", function(e5) {
                options.onKeyUp(e5, inp.value, close);
              });
            CodeMirror5.on(inp, "keydown", function(e5) {
              if (options && options.onKeyDown && options.onKeyDown(e5, inp.value, close)) {
                return;
              }
              if (e5.keyCode == 27 || options.closeOnEnter !== false && e5.keyCode == 13) {
                inp.blur();
                CodeMirror5.e_stop(e5);
                close();
              }
              if (e5.keyCode == 13)
                callback(inp.value, e5);
            });
            if (options.closeOnBlur !== false)
              CodeMirror5.on(dialog, "focusout", function(evt) {
                if (evt.relatedTarget !== null)
                  close();
              });
          } else if (button = dialog.getElementsByTagName("button")[0]) {
            CodeMirror5.on(button, "click", function() {
              close();
              me.focus();
            });
            if (options.closeOnBlur !== false)
              CodeMirror5.on(button, "blur", close);
            button.focus();
          }
          return close;
        });
        CodeMirror5.defineExtension("openConfirm", function(template, callbacks, options) {
          closeNotification(this, null);
          var dialog = dialogDiv(this, template, options && options.bottom);
          var buttons = dialog.getElementsByTagName("button");
          var closed = false, me = this, blurring = 1;
          function close() {
            if (closed)
              return;
            closed = true;
            CodeMirror5.rmClass(dialog.parentNode, "dialog-opened");
            dialog.parentNode.removeChild(dialog);
            me.focus();
          }
          buttons[0].focus();
          for (var i3 = 0; i3 < buttons.length; ++i3) {
            var b2 = buttons[i3];
            (function(callback) {
              CodeMirror5.on(b2, "click", function(e5) {
                CodeMirror5.e_preventDefault(e5);
                close();
                if (callback)
                  callback(me);
              });
            })(callbacks[i3]);
            CodeMirror5.on(b2, "blur", function() {
              --blurring;
              setTimeout(function() {
                if (blurring <= 0)
                  close();
              }, 200);
            });
            CodeMirror5.on(b2, "focus", function() {
              ++blurring;
            });
          }
        });
        CodeMirror5.defineExtension("openNotification", function(template, options) {
          closeNotification(this, close);
          var dialog = dialogDiv(this, template, options && options.bottom);
          var closed = false, doneTimer;
          var duration = options && typeof options.duration !== "undefined" ? options.duration : 5e3;
          function close() {
            if (closed)
              return;
            closed = true;
            clearTimeout(doneTimer);
            CodeMirror5.rmClass(dialog.parentNode, "dialog-opened");
            dialog.parentNode.removeChild(dialog);
          }
          CodeMirror5.on(dialog, "click", function(e5) {
            CodeMirror5.e_preventDefault(e5);
            close();
          });
          if (duration)
            doneTimer = setTimeout(close, duration);
          return close;
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/display/rulers.js
  var require_rulers = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/display/rulers.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineOption("rulers", false, function(cm, val) {
          if (cm.state.rulerDiv) {
            cm.state.rulerDiv.parentElement.removeChild(cm.state.rulerDiv);
            cm.state.rulerDiv = null;
            cm.off("refresh", drawRulers);
          }
          if (val && val.length) {
            cm.state.rulerDiv = cm.display.lineSpace.parentElement.insertBefore(document.createElement("div"), cm.display.lineSpace);
            cm.state.rulerDiv.className = "CodeMirror-rulers";
            drawRulers(cm);
            cm.on("refresh", drawRulers);
          }
        });
        function drawRulers(cm) {
          cm.state.rulerDiv.textContent = "";
          var val = cm.getOption("rulers");
          var cw = cm.defaultCharWidth();
          var left = cm.charCoords(CodeMirror5.Pos(cm.firstLine(), 0), "div").left;
          cm.state.rulerDiv.style.minHeight = cm.display.scroller.offsetHeight + 30 + "px";
          for (var i3 = 0; i3 < val.length; i3++) {
            var elt = document.createElement("div");
            elt.className = "CodeMirror-ruler";
            var col, conf = val[i3];
            if (typeof conf == "number") {
              col = conf;
            } else {
              col = conf.column;
              if (conf.className)
                elt.className += " " + conf.className;
              if (conf.color)
                elt.style.borderColor = conf.color;
              if (conf.lineStyle)
                elt.style.borderLeftStyle = conf.lineStyle;
              if (conf.width)
                elt.style.borderLeftWidth = conf.width;
            }
            elt.style.left = left + col * cw + "px";
            cm.state.rulerDiv.appendChild(elt);
          }
        }
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/edit/closebrackets.js
  var require_closebrackets = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/edit/closebrackets.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        var defaults = {
          pairs: `()[]{}''""`,
          closeBefore: `)]}'":;>`,
          triples: "",
          explode: "[]{}"
        };
        var Pos = CodeMirror5.Pos;
        CodeMirror5.defineOption("autoCloseBrackets", false, function(cm, val, old) {
          if (old && old != CodeMirror5.Init) {
            cm.removeKeyMap(keyMap);
            cm.state.closeBrackets = null;
          }
          if (val) {
            ensureBound(getOption(val, "pairs"));
            cm.state.closeBrackets = val;
            cm.addKeyMap(keyMap);
          }
        });
        function getOption(conf, name106) {
          if (name106 == "pairs" && typeof conf == "string")
            return conf;
          if (typeof conf == "object" && conf[name106] != null)
            return conf[name106];
          return defaults[name106];
        }
        var keyMap = { Backspace: handleBackspace, Enter: handleEnter };
        function ensureBound(chars) {
          for (var i3 = 0; i3 < chars.length; i3++) {
            var ch = chars.charAt(i3), key = "'" + ch + "'";
            if (!keyMap[key])
              keyMap[key] = handler(ch);
          }
        }
        ensureBound(defaults.pairs + "`");
        function handler(ch) {
          return function(cm) {
            return handleChar(cm, ch);
          };
        }
        function getConfig(cm) {
          var deflt = cm.state.closeBrackets;
          if (!deflt || deflt.override)
            return deflt;
          var mode2 = cm.getModeAt(cm.getCursor());
          return mode2.closeBrackets || deflt;
        }
        function handleBackspace(cm) {
          var conf = getConfig(cm);
          if (!conf || cm.getOption("disableInput"))
            return CodeMirror5.Pass;
          var pairs = getOption(conf, "pairs");
          var ranges = cm.listSelections();
          for (var i3 = 0; i3 < ranges.length; i3++) {
            if (!ranges[i3].empty())
              return CodeMirror5.Pass;
            var around = charsAround(cm, ranges[i3].head);
            if (!around || pairs.indexOf(around) % 2 != 0)
              return CodeMirror5.Pass;
          }
          for (var i3 = ranges.length - 1; i3 >= 0; i3--) {
            var cur = ranges[i3].head;
            cm.replaceRange("", Pos(cur.line, cur.ch - 1), Pos(cur.line, cur.ch + 1), "+delete");
          }
        }
        function handleEnter(cm) {
          var conf = getConfig(cm);
          var explode = conf && getOption(conf, "explode");
          if (!explode || cm.getOption("disableInput"))
            return CodeMirror5.Pass;
          var ranges = cm.listSelections();
          for (var i3 = 0; i3 < ranges.length; i3++) {
            if (!ranges[i3].empty())
              return CodeMirror5.Pass;
            var around = charsAround(cm, ranges[i3].head);
            if (!around || explode.indexOf(around) % 2 != 0)
              return CodeMirror5.Pass;
          }
          cm.operation(function() {
            var linesep = cm.lineSeparator() || "\n";
            cm.replaceSelection(linesep + linesep, null);
            cm.execCommand("goCharLeft");
            ranges = cm.listSelections();
            for (var i4 = 0; i4 < ranges.length; i4++) {
              var line = ranges[i4].head.line;
              cm.indentLine(line, null, true);
              cm.indentLine(line + 1, null, true);
            }
          });
        }
        function contractSelection2(sel) {
          var inverted = CodeMirror5.cmpPos(sel.anchor, sel.head) > 0;
          return {
            anchor: new Pos(sel.anchor.line, sel.anchor.ch + (inverted ? -1 : 1)),
            head: new Pos(sel.head.line, sel.head.ch + (inverted ? 1 : -1))
          };
        }
        function handleChar(cm, ch) {
          var conf = getConfig(cm);
          if (!conf || cm.getOption("disableInput"))
            return CodeMirror5.Pass;
          var pairs = getOption(conf, "pairs");
          var pos = pairs.indexOf(ch);
          if (pos == -1)
            return CodeMirror5.Pass;
          var closeBefore = getOption(conf, "closeBefore");
          var triples = getOption(conf, "triples");
          var identical = pairs.charAt(pos + 1) == ch;
          var ranges = cm.listSelections();
          var opening = pos % 2 == 0;
          var type;
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3], cur = range2.head, curType;
            var next = cm.getRange(cur, Pos(cur.line, cur.ch + 1));
            if (opening && !range2.empty()) {
              curType = "surround";
            } else if ((identical || !opening) && next == ch) {
              if (identical && stringStartsAfter(cm, cur))
                curType = "both";
              else if (triples.indexOf(ch) >= 0 && cm.getRange(cur, Pos(cur.line, cur.ch + 3)) == ch + ch + ch)
                curType = "skipThree";
              else
                curType = "skip";
            } else if (identical && cur.ch > 1 && triples.indexOf(ch) >= 0 && cm.getRange(Pos(cur.line, cur.ch - 2), cur) == ch + ch) {
              if (cur.ch > 2 && /\bstring/.test(cm.getTokenTypeAt(Pos(cur.line, cur.ch - 2))))
                return CodeMirror5.Pass;
              curType = "addFour";
            } else if (identical) {
              var prev = cur.ch == 0 ? " " : cm.getRange(Pos(cur.line, cur.ch - 1), cur);
              if (!CodeMirror5.isWordChar(next) && prev != ch && !CodeMirror5.isWordChar(prev))
                curType = "both";
              else
                return CodeMirror5.Pass;
            } else if (opening && (next.length === 0 || /\s/.test(next) || closeBefore.indexOf(next) > -1)) {
              curType = "both";
            } else {
              return CodeMirror5.Pass;
            }
            if (!type)
              type = curType;
            else if (type != curType)
              return CodeMirror5.Pass;
          }
          var left = pos % 2 ? pairs.charAt(pos - 1) : ch;
          var right = pos % 2 ? ch : pairs.charAt(pos + 1);
          cm.operation(function() {
            if (type == "skip") {
              cm.execCommand("goCharRight");
            } else if (type == "skipThree") {
              for (var i4 = 0; i4 < 3; i4++)
                cm.execCommand("goCharRight");
            } else if (type == "surround") {
              var sels = cm.getSelections();
              for (var i4 = 0; i4 < sels.length; i4++)
                sels[i4] = left + sels[i4] + right;
              cm.replaceSelections(sels, "around");
              sels = cm.listSelections().slice();
              for (var i4 = 0; i4 < sels.length; i4++)
                sels[i4] = contractSelection2(sels[i4]);
              cm.setSelections(sels);
            } else if (type == "both") {
              cm.replaceSelection(left + right, null);
              cm.triggerElectric(left + right);
              cm.execCommand("goCharLeft");
            } else if (type == "addFour") {
              cm.replaceSelection(left + left + left + left, "before");
              cm.execCommand("goCharRight");
            }
          });
        }
        function charsAround(cm, pos) {
          var str = cm.getRange(Pos(pos.line, pos.ch - 1), Pos(pos.line, pos.ch + 1));
          return str.length == 2 ? str : null;
        }
        function stringStartsAfter(cm, pos) {
          var token = cm.getTokenAt(Pos(pos.line, pos.ch + 1));
          return /\bstring/.test(token.type) && token.start == pos.ch && (pos.ch == 0 || !/\bstring/.test(cm.getTokenTypeAt(pos)));
        }
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/selection/active-line.js
  var require_active_line = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/selection/active-line.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var WRAP_CLASS = "CodeMirror-activeline";
        var BACK_CLASS = "CodeMirror-activeline-background";
        var GUTT_CLASS = "CodeMirror-activeline-gutter";
        CodeMirror5.defineOption("styleActiveLine", false, function(cm, val, old) {
          var prev = old == CodeMirror5.Init ? false : old;
          if (val == prev)
            return;
          if (prev) {
            cm.off("beforeSelectionChange", selectionChange);
            clearActiveLines(cm);
            delete cm.state.activeLines;
          }
          if (val) {
            cm.state.activeLines = [];
            updateActiveLines(cm, cm.listSelections());
            cm.on("beforeSelectionChange", selectionChange);
          }
        });
        function clearActiveLines(cm) {
          for (var i3 = 0; i3 < cm.state.activeLines.length; i3++) {
            cm.removeLineClass(cm.state.activeLines[i3], "wrap", WRAP_CLASS);
            cm.removeLineClass(cm.state.activeLines[i3], "background", BACK_CLASS);
            cm.removeLineClass(cm.state.activeLines[i3], "gutter", GUTT_CLASS);
          }
        }
        function sameArray(a3, b2) {
          if (a3.length != b2.length)
            return false;
          for (var i3 = 0; i3 < a3.length; i3++)
            if (a3[i3] != b2[i3])
              return false;
          return true;
        }
        function updateActiveLines(cm, ranges) {
          var active = [];
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3];
            var option = cm.getOption("styleActiveLine");
            if (typeof option == "object" && option.nonEmpty ? range2.anchor.line != range2.head.line : !range2.empty())
              continue;
            var line = cm.getLineHandleVisualStart(range2.head.line);
            if (active[active.length - 1] != line)
              active.push(line);
          }
          if (sameArray(cm.state.activeLines, active))
            return;
          cm.operation(function() {
            clearActiveLines(cm);
            for (var i4 = 0; i4 < active.length; i4++) {
              cm.addLineClass(active[i4], "wrap", WRAP_CLASS);
              cm.addLineClass(active[i4], "background", BACK_CLASS);
              cm.addLineClass(active[i4], "gutter", GUTT_CLASS);
            }
            cm.state.activeLines = active;
          });
        }
        function selectionChange(cm, sel) {
          updateActiveLines(cm, sel.ranges);
        }
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/scroll/annotatescrollbar.js
  var require_annotatescrollbar = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/scroll/annotatescrollbar.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineExtension("annotateScrollbar", function(options) {
          if (typeof options == "string")
            options = { className: options };
          return new Annotation(this, options);
        });
        CodeMirror5.defineOption("scrollButtonHeight", 0);
        function Annotation(cm, options) {
          this.cm = cm;
          this.options = options;
          this.buttonHeight = options.scrollButtonHeight || cm.getOption("scrollButtonHeight");
          this.annotations = [];
          this.doRedraw = this.doUpdate = null;
          this.div = cm.getWrapperElement().appendChild(document.createElement("div"));
          this.div.style.cssText = "position: absolute; right: 0; top: 0; z-index: 7; pointer-events: none";
          this.computeScale();
          function scheduleRedraw(delay) {
            clearTimeout(self2.doRedraw);
            self2.doRedraw = setTimeout(function() {
              self2.redraw();
            }, delay);
          }
          var self2 = this;
          cm.on("refresh", this.resizeHandler = function() {
            clearTimeout(self2.doUpdate);
            self2.doUpdate = setTimeout(function() {
              if (self2.computeScale())
                scheduleRedraw(20);
            }, 100);
          });
          cm.on("markerAdded", this.resizeHandler);
          cm.on("markerCleared", this.resizeHandler);
          if (options.listenForChanges !== false)
            cm.on("changes", this.changeHandler = function() {
              scheduleRedraw(250);
            });
        }
        Annotation.prototype.computeScale = function() {
          var cm = this.cm;
          var hScale = (cm.getWrapperElement().clientHeight - cm.display.barHeight - this.buttonHeight * 2) / cm.getScrollerElement().scrollHeight;
          if (hScale != this.hScale) {
            this.hScale = hScale;
            return true;
          }
        };
        Annotation.prototype.update = function(annotations) {
          this.annotations = annotations;
          this.redraw();
        };
        Annotation.prototype.redraw = function(compute) {
          if (compute !== false)
            this.computeScale();
          var cm = this.cm, hScale = this.hScale;
          var frag = document.createDocumentFragment(), anns = this.annotations;
          var wrapping = cm.getOption("lineWrapping");
          var singleLineH = wrapping && cm.defaultTextHeight() * 1.5;
          var curLine = null, curLineObj = null;
          function getY(pos, top2) {
            if (curLine != pos.line) {
              curLine = pos.line;
              curLineObj = cm.getLineHandle(curLine);
            }
            if (curLineObj.widgets && curLineObj.widgets.length || wrapping && curLineObj.height > singleLineH)
              return cm.charCoords(pos, "local")[top2 ? "top" : "bottom"];
            var topY = cm.heightAtLine(curLineObj, "local");
            return topY + (top2 ? 0 : curLineObj.height);
          }
          var lastLine = cm.lastLine();
          if (cm.display.barWidth)
            for (var i3 = 0, nextTop; i3 < anns.length; i3++) {
              var ann = anns[i3];
              if (ann.to.line > lastLine)
                continue;
              var top = nextTop || getY(ann.from, true) * hScale;
              var bottom = getY(ann.to, false) * hScale;
              while (i3 < anns.length - 1) {
                if (anns[i3 + 1].to.line > lastLine)
                  break;
                nextTop = getY(anns[i3 + 1].from, true) * hScale;
                if (nextTop > bottom + 0.9)
                  break;
                ann = anns[++i3];
                bottom = getY(ann.to, false) * hScale;
              }
              if (bottom == top)
                continue;
              var height = Math.max(bottom - top, 3);
              var elt = frag.appendChild(document.createElement("div"));
              elt.style.cssText = "position: absolute; right: 0px; width: " + Math.max(cm.display.barWidth - 1, 2) + "px; top: " + (top + this.buttonHeight) + "px; height: " + height + "px";
              elt.className = this.options.className;
              if (ann.id) {
                elt.setAttribute("annotation-id", ann.id);
              }
            }
          this.div.textContent = "";
          this.div.appendChild(frag);
        };
        Annotation.prototype.clear = function() {
          this.cm.off("refresh", this.resizeHandler);
          this.cm.off("markerAdded", this.resizeHandler);
          this.cm.off("markerCleared", this.resizeHandler);
          if (this.changeHandler)
            this.cm.off("changes", this.changeHandler);
          this.div.parentNode.removeChild(this.div);
        };
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/search/matchesonscrollbar.js
  var require_matchesonscrollbar = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/search/matchesonscrollbar.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_searchcursor(), require_annotatescrollbar());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "./searchcursor", "../scroll/annotatescrollbar"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        CodeMirror5.defineExtension("showMatchesOnScrollbar", function(query, caseFold, options) {
          if (typeof options == "string")
            options = { className: options };
          if (!options)
            options = {};
          return new SearchAnnotation(this, query, caseFold, options);
        });
        function SearchAnnotation(cm, query, caseFold, options) {
          this.cm = cm;
          this.options = options;
          var annotateOptions = { listenForChanges: false };
          for (var prop in options)
            annotateOptions[prop] = options[prop];
          if (!annotateOptions.className)
            annotateOptions.className = "CodeMirror-search-match";
          this.annotation = cm.annotateScrollbar(annotateOptions);
          this.query = query;
          this.caseFold = caseFold;
          this.gap = { from: cm.firstLine(), to: cm.lastLine() + 1 };
          this.matches = [];
          this.update = null;
          this.findMatches();
          this.annotation.update(this.matches);
          var self2 = this;
          cm.on("change", this.changeHandler = function(_cm, change) {
            self2.onChange(change);
          });
        }
        var MAX_MATCHES = 1e3;
        SearchAnnotation.prototype.findMatches = function() {
          if (!this.gap)
            return;
          for (var i3 = 0; i3 < this.matches.length; i3++) {
            var match = this.matches[i3];
            if (match.from.line >= this.gap.to)
              break;
            if (match.to.line >= this.gap.from)
              this.matches.splice(i3--, 1);
          }
          var cursor = this.cm.getSearchCursor(this.query, CodeMirror5.Pos(this.gap.from, 0), { caseFold: this.caseFold, multiline: this.options.multiline });
          var maxMatches = this.options && this.options.maxMatches || MAX_MATCHES;
          while (cursor.findNext()) {
            var match = { from: cursor.from(), to: cursor.to() };
            if (match.from.line >= this.gap.to)
              break;
            this.matches.splice(i3++, 0, match);
            if (this.matches.length > maxMatches)
              break;
          }
          this.gap = null;
        };
        function offsetLine(line, changeStart, sizeChange) {
          if (line <= changeStart)
            return line;
          return Math.max(changeStart, line + sizeChange);
        }
        SearchAnnotation.prototype.onChange = function(change) {
          var startLine = change.from.line;
          var endLine = CodeMirror5.changeEnd(change).line;
          var sizeChange = endLine - change.to.line;
          if (this.gap) {
            this.gap.from = Math.min(offsetLine(this.gap.from, startLine, sizeChange), change.from.line);
            this.gap.to = Math.max(offsetLine(this.gap.to, startLine, sizeChange), change.from.line);
          } else {
            this.gap = { from: change.from.line, to: endLine + 1 };
          }
          if (sizeChange)
            for (var i3 = 0; i3 < this.matches.length; i3++) {
              var match = this.matches[i3];
              var newFrom = offsetLine(match.from.line, startLine, sizeChange);
              if (newFrom != match.from.line)
                match.from = CodeMirror5.Pos(newFrom, match.from.ch);
              var newTo = offsetLine(match.to.line, startLine, sizeChange);
              if (newTo != match.to.line)
                match.to = CodeMirror5.Pos(newTo, match.to.ch);
            }
          clearTimeout(this.update);
          var self2 = this;
          this.update = setTimeout(function() {
            self2.updateAfterChange();
          }, 250);
        };
        SearchAnnotation.prototype.updateAfterChange = function() {
          this.findMatches();
          this.annotation.update(this.matches);
        };
        SearchAnnotation.prototype.clear = function() {
          this.cm.off("change", this.changeHandler);
          this.annotation.clear();
        };
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/search/match-highlighter.js
  var require_match_highlighter = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/search/match-highlighter.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_matchesonscrollbar());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "./matchesonscrollbar"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var defaults = {
          style: "matchhighlight",
          minChars: 2,
          delay: 100,
          wordsOnly: false,
          annotateScrollbar: false,
          showToken: false,
          trim: true
        };
        function State(options) {
          this.options = {};
          for (var name106 in defaults)
            this.options[name106] = (options && options.hasOwnProperty(name106) ? options : defaults)[name106];
          this.overlay = this.timeout = null;
          this.matchesonscroll = null;
          this.active = false;
        }
        CodeMirror5.defineOption("highlightSelectionMatches", false, function(cm, val, old) {
          if (old && old != CodeMirror5.Init) {
            removeOverlay(cm);
            clearTimeout(cm.state.matchHighlighter.timeout);
            cm.state.matchHighlighter = null;
            cm.off("cursorActivity", cursorActivity);
            cm.off("focus", onFocus);
          }
          if (val) {
            var state = cm.state.matchHighlighter = new State(val);
            if (cm.hasFocus()) {
              state.active = true;
              highlightMatches(cm);
            } else {
              cm.on("focus", onFocus);
            }
            cm.on("cursorActivity", cursorActivity);
          }
        });
        function cursorActivity(cm) {
          var state = cm.state.matchHighlighter;
          if (state.active || cm.hasFocus())
            scheduleHighlight(cm, state);
        }
        function onFocus(cm) {
          var state = cm.state.matchHighlighter;
          if (!state.active) {
            state.active = true;
            scheduleHighlight(cm, state);
          }
        }
        function scheduleHighlight(cm, state) {
          clearTimeout(state.timeout);
          state.timeout = setTimeout(function() {
            highlightMatches(cm);
          }, state.options.delay);
        }
        function addOverlay(cm, query, hasBoundary, style) {
          var state = cm.state.matchHighlighter;
          cm.addOverlay(state.overlay = makeOverlay(query, hasBoundary, style));
          if (state.options.annotateScrollbar && cm.showMatchesOnScrollbar) {
            var searchFor = hasBoundary ? new RegExp("\\b" + query.replace(/[\\\[.+*?(){|^$]/g, "\\$&") + "\\b") : query;
            state.matchesonscroll = cm.showMatchesOnScrollbar(searchFor, false, { className: "CodeMirror-selection-highlight-scrollbar" });
          }
        }
        function removeOverlay(cm) {
          var state = cm.state.matchHighlighter;
          if (state.overlay) {
            cm.removeOverlay(state.overlay);
            state.overlay = null;
            if (state.matchesonscroll) {
              state.matchesonscroll.clear();
              state.matchesonscroll = null;
            }
          }
        }
        function highlightMatches(cm) {
          cm.operation(function() {
            var state = cm.state.matchHighlighter;
            removeOverlay(cm);
            if (!cm.somethingSelected() && state.options.showToken) {
              var re = state.options.showToken === true ? /[\w$]/ : state.options.showToken;
              var cur = cm.getCursor(), line = cm.getLine(cur.line), start2 = cur.ch, end = start2;
              while (start2 && re.test(line.charAt(start2 - 1)))
                --start2;
              while (end < line.length && re.test(line.charAt(end)))
                ++end;
              if (start2 < end)
                addOverlay(cm, line.slice(start2, end), re, state.options.style);
              return;
            }
            var from = cm.getCursor("from"), to = cm.getCursor("to");
            if (from.line != to.line)
              return;
            if (state.options.wordsOnly && !isWord(cm, from, to))
              return;
            var selection = cm.getRange(from, to);
            if (state.options.trim)
              selection = selection.replace(/^\s+|\s+$/g, "");
            if (selection.length >= state.options.minChars)
              addOverlay(cm, selection, false, state.options.style);
          });
        }
        function isWord(cm, from, to) {
          var str = cm.getRange(from, to);
          if (str.match(/^\w+$/) !== null) {
            if (from.ch > 0) {
              var pos = { line: from.line, ch: from.ch - 1 };
              var chr = cm.getRange(pos, from);
              if (chr.match(/\W/) === null)
                return false;
            }
            if (to.ch < cm.getLine(from.line).length) {
              var pos = { line: to.line, ch: to.ch + 1 };
              var chr = cm.getRange(to, pos);
              if (chr.match(/\W/) === null)
                return false;
            }
            return true;
          } else
            return false;
        }
        function boundariesAround(stream, re) {
          return (!stream.start || !re.test(stream.string.charAt(stream.start - 1))) && (stream.pos == stream.string.length || !re.test(stream.string.charAt(stream.pos)));
        }
        function makeOverlay(query, hasBoundary, style) {
          return { token: function(stream) {
            if (stream.match(query) && (!hasBoundary || boundariesAround(stream, hasBoundary)))
              return style;
            stream.next();
            stream.skipTo(query.charAt(0)) || stream.skipToEnd();
          } };
        }
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/search/search.js
  var require_search = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/search/search.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_searchcursor(), require_dialog());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror", "./searchcursor", "../dialog/dialog"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        function searchOverlay(query, caseInsensitive) {
          if (typeof query == "string")
            query = new RegExp(query.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&"), caseInsensitive ? "gi" : "g");
          else if (!query.global)
            query = new RegExp(query.source, query.ignoreCase ? "gi" : "g");
          return { token: function(stream) {
            query.lastIndex = stream.pos;
            var match = query.exec(stream.string);
            if (match && match.index == stream.pos) {
              stream.pos += match[0].length || 1;
              return "searching";
            } else if (match) {
              stream.pos = match.index;
            } else {
              stream.skipToEnd();
            }
          } };
        }
        function SearchState() {
          this.posFrom = this.posTo = this.lastQuery = this.query = null;
          this.overlay = null;
        }
        function getSearchState2(cm) {
          return cm.state.search || (cm.state.search = new SearchState());
        }
        function queryCaseInsensitive(query) {
          return typeof query == "string" && query == query.toLowerCase();
        }
        function getSearchCursor2(cm, query, pos) {
          return cm.getSearchCursor(query, pos, { caseFold: queryCaseInsensitive(query), multiline: true });
        }
        function persistentDialog(cm, text, deflt, onEnter, onKeyDown) {
          cm.openDialog(text, onEnter, {
            value: deflt,
            selectValueOnOpen: true,
            closeOnEnter: false,
            onClose: function() {
              clearSearch(cm);
            },
            onKeyDown
          });
        }
        function dialog(cm, text, shortText, deflt, f3) {
          if (cm.openDialog)
            cm.openDialog(text, f3, { value: deflt, selectValueOnOpen: true });
          else
            f3(prompt(shortText, deflt));
        }
        function confirmDialog(cm, text, shortText, fs) {
          if (cm.openConfirm)
            cm.openConfirm(text, fs);
          else if (confirm(shortText))
            fs[0]();
        }
        function parseString(string2) {
          return string2.replace(/\\([nrt\\])/g, function(match, ch) {
            if (ch == "n")
              return "\n";
            if (ch == "r")
              return "\r";
            if (ch == "t")
              return "	";
            if (ch == "\\")
              return "\\";
            return match;
          });
        }
        function parseQuery(query) {
          var isRE = query.match(/^\/(.*)\/([a-z]*)$/);
          if (isRE) {
            try {
              query = new RegExp(isRE[1], isRE[2].indexOf("i") == -1 ? "" : "i");
            } catch (e5) {
            }
          } else {
            query = parseString(query);
          }
          if (typeof query == "string" ? query == "" : query.test(""))
            query = /x^/;
          return query;
        }
        function startSearch(cm, state, query) {
          state.queryText = query;
          state.query = parseQuery(query);
          cm.removeOverlay(state.overlay, queryCaseInsensitive(state.query));
          state.overlay = searchOverlay(state.query, queryCaseInsensitive(state.query));
          cm.addOverlay(state.overlay);
          if (cm.showMatchesOnScrollbar) {
            if (state.annotate) {
              state.annotate.clear();
              state.annotate = null;
            }
            state.annotate = cm.showMatchesOnScrollbar(state.query, queryCaseInsensitive(state.query));
          }
        }
        function doSearch(cm, rev, persistent, immediate) {
          var state = getSearchState2(cm);
          if (state.query)
            return findNext(cm, rev);
          var q = cm.getSelection() || state.lastQuery;
          if (q instanceof RegExp && q.source == "x^")
            q = null;
          if (persistent && cm.openDialog) {
            var hiding = null;
            var searchNext = function(query, event2) {
              CodeMirror5.e_stop(event2);
              if (!query)
                return;
              if (query != state.queryText) {
                startSearch(cm, state, query);
                state.posFrom = state.posTo = cm.getCursor();
              }
              if (hiding)
                hiding.style.opacity = 1;
              findNext(cm, event2.shiftKey, function(_2, to) {
                var dialog2;
                if (to.line < 3 && document.querySelector && (dialog2 = cm.display.wrapper.querySelector(".CodeMirror-dialog")) && dialog2.getBoundingClientRect().bottom - 4 > cm.cursorCoords(to, "window").top)
                  (hiding = dialog2).style.opacity = 0.4;
              });
            };
            persistentDialog(cm, getQueryDialog(cm), q, searchNext, function(event2, query) {
              var keyName = CodeMirror5.keyName(event2);
              var extra = cm.getOption("extraKeys"), cmd = extra && extra[keyName] || CodeMirror5.keyMap[cm.getOption("keyMap")][keyName];
              if (cmd == "findNext" || cmd == "findPrev" || cmd == "findPersistentNext" || cmd == "findPersistentPrev") {
                CodeMirror5.e_stop(event2);
                startSearch(cm, getSearchState2(cm), query);
                cm.execCommand(cmd);
              } else if (cmd == "find" || cmd == "findPersistent") {
                CodeMirror5.e_stop(event2);
                searchNext(query, event2);
              }
            });
            if (immediate && q) {
              startSearch(cm, state, q);
              findNext(cm, rev);
            }
          } else {
            dialog(cm, getQueryDialog(cm), "Search for:", q, function(query) {
              if (query && !state.query)
                cm.operation(function() {
                  startSearch(cm, state, query);
                  state.posFrom = state.posTo = cm.getCursor();
                  findNext(cm, rev);
                });
            });
          }
        }
        function findNext(cm, rev, callback) {
          cm.operation(function() {
            var state = getSearchState2(cm);
            var cursor = getSearchCursor2(cm, state.query, rev ? state.posFrom : state.posTo);
            if (!cursor.find(rev)) {
              cursor = getSearchCursor2(cm, state.query, rev ? CodeMirror5.Pos(cm.lastLine()) : CodeMirror5.Pos(cm.firstLine(), 0));
              if (!cursor.find(rev))
                return;
            }
            cm.setSelection(cursor.from(), cursor.to());
            cm.scrollIntoView({ from: cursor.from(), to: cursor.to() }, 20);
            state.posFrom = cursor.from();
            state.posTo = cursor.to();
            if (callback)
              callback(cursor.from(), cursor.to());
          });
        }
        function clearSearch(cm) {
          cm.operation(function() {
            var state = getSearchState2(cm);
            state.lastQuery = state.query;
            if (!state.query)
              return;
            state.query = state.queryText = null;
            cm.removeOverlay(state.overlay);
            if (state.annotate) {
              state.annotate.clear();
              state.annotate = null;
            }
          });
        }
        function getQueryDialog(cm) {
          return '<span class="CodeMirror-search-label">' + cm.phrase("Search:") + '</span> <input type="text" style="width: 10em" class="CodeMirror-search-field"/> <span style="color: #888" class="CodeMirror-search-hint">' + cm.phrase("(Use /re/ syntax for regexp search)") + "</span>";
        }
        function getReplaceQueryDialog(cm) {
          return ' <input type="text" style="width: 10em" class="CodeMirror-search-field"/> <span style="color: #888" class="CodeMirror-search-hint">' + cm.phrase("(Use /re/ syntax for regexp search)") + "</span>";
        }
        function getReplacementQueryDialog(cm) {
          return '<span class="CodeMirror-search-label">' + cm.phrase("With:") + '</span> <input type="text" style="width: 10em" class="CodeMirror-search-field"/>';
        }
        function getDoReplaceConfirm(cm) {
          return '<span class="CodeMirror-search-label">' + cm.phrase("Replace?") + "</span> <button>" + cm.phrase("Yes") + "</button> <button>" + cm.phrase("No") + "</button> <button>" + cm.phrase("All") + "</button> <button>" + cm.phrase("Stop") + "</button> ";
        }
        function replaceAll(cm, query, text) {
          cm.operation(function() {
            for (var cursor = getSearchCursor2(cm, query); cursor.findNext(); ) {
              if (typeof query != "string") {
                var match = cm.getRange(cursor.from(), cursor.to()).match(query);
                cursor.replace(text.replace(/\$(\d)/g, function(_2, i3) {
                  return match[i3];
                }));
              } else
                cursor.replace(text);
            }
          });
        }
        function replace3(cm, all2) {
          if (cm.getOption("readOnly"))
            return;
          var query = cm.getSelection() || getSearchState2(cm).lastQuery;
          var dialogText = '<span class="CodeMirror-search-label">' + (all2 ? cm.phrase("Replace all:") : cm.phrase("Replace:")) + "</span>";
          dialog(cm, dialogText + getReplaceQueryDialog(cm), dialogText, query, function(query2) {
            if (!query2)
              return;
            query2 = parseQuery(query2);
            dialog(cm, getReplacementQueryDialog(cm), cm.phrase("Replace with:"), "", function(text) {
              text = parseString(text);
              if (all2) {
                replaceAll(cm, query2, text);
              } else {
                clearSearch(cm);
                var cursor = getSearchCursor2(cm, query2, cm.getCursor("from"));
                var advance = function() {
                  var start2 = cursor.from(), match;
                  if (!(match = cursor.findNext())) {
                    cursor = getSearchCursor2(cm, query2);
                    if (!(match = cursor.findNext()) || start2 && cursor.from().line == start2.line && cursor.from().ch == start2.ch)
                      return;
                  }
                  cm.setSelection(cursor.from(), cursor.to());
                  cm.scrollIntoView({ from: cursor.from(), to: cursor.to() });
                  confirmDialog(cm, getDoReplaceConfirm(cm), cm.phrase("Replace?"), [
                    function() {
                      doReplace(match);
                    },
                    advance,
                    function() {
                      replaceAll(cm, query2, text);
                    }
                  ]);
                };
                var doReplace = function(match) {
                  cursor.replace(typeof query2 == "string" ? text : text.replace(/\$(\d)/g, function(_2, i3) {
                    return match[i3];
                  }));
                  advance();
                };
                advance();
              }
            });
          });
        }
        CodeMirror5.commands.find = function(cm) {
          clearSearch(cm);
          doSearch(cm);
        };
        CodeMirror5.commands.findPersistent = function(cm) {
          clearSearch(cm);
          doSearch(cm, false, true);
        };
        CodeMirror5.commands.findPersistentNext = function(cm) {
          doSearch(cm, false, true, true);
        };
        CodeMirror5.commands.findPersistentPrev = function(cm) {
          doSearch(cm, true, true, true);
        };
        CodeMirror5.commands.findNext = doSearch;
        CodeMirror5.commands.findPrev = function(cm) {
          doSearch(cm, true);
        };
        CodeMirror5.commands.clearSearch = clearSearch;
        CodeMirror5.commands.replace = replace3;
        CodeMirror5.commands.replaceAll = function(cm) {
          replace3(cm, true);
        };
      });
    }
  });

  // node_modules/@plaincontext/codemirror/keymap/emacs.js
  var require_emacs = __commonJS({
    "node_modules/@plaincontext/codemirror/keymap/emacs.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var Pos = CodeMirror5.Pos;
        function posEq(a3, b2) {
          return a3.line == b2.line && a3.ch == b2.ch;
        }
        var killRing = [];
        function addToRing(str) {
          killRing.push(str);
          if (killRing.length > 50)
            killRing.shift();
        }
        function growRingTop(str) {
          if (!killRing.length)
            return addToRing(str);
          killRing[killRing.length - 1] += str;
        }
        function getFromRing(n3) {
          return killRing[killRing.length - (n3 ? Math.min(n3, 1) : 1)] || "";
        }
        function popFromRing() {
          if (killRing.length > 1)
            killRing.pop();
          return getFromRing();
        }
        var lastKill = null;
        function kill(cm, from, to, ring, text) {
          if (text == null)
            text = cm.getRange(from, to);
          if (ring == "grow" && lastKill && lastKill.cm == cm && posEq(from, lastKill.pos) && cm.isClean(lastKill.gen))
            growRingTop(text);
          else if (ring !== false)
            addToRing(text);
          cm.replaceRange("", from, to, "+delete");
          if (ring == "grow")
            lastKill = { cm, pos: from, gen: cm.changeGeneration() };
          else
            lastKill = null;
        }
        function byChar(cm, pos, dir) {
          return cm.findPosH(pos, dir, "char", true);
        }
        function byWord(cm, pos, dir) {
          return cm.findPosH(pos, dir, "word", true);
        }
        function byLine(cm, pos, dir) {
          return cm.findPosV(pos, dir, "line", cm.doc.sel.goalColumn);
        }
        function byPage(cm, pos, dir) {
          return cm.findPosV(pos, dir, "page", cm.doc.sel.goalColumn);
        }
        function byParagraph(cm, pos, dir) {
          var no = pos.line, line = cm.getLine(no);
          var sawText = /\S/.test(dir < 0 ? line.slice(0, pos.ch) : line.slice(pos.ch));
          var fst = cm.firstLine(), lst = cm.lastLine();
          for (; ; ) {
            no += dir;
            if (no < fst || no > lst)
              return cm.clipPos(Pos(no - dir, dir < 0 ? 0 : null));
            line = cm.getLine(no);
            var hasText = /\S/.test(line);
            if (hasText)
              sawText = true;
            else if (sawText)
              return Pos(no, 0);
          }
        }
        function bySentence(cm, pos, dir) {
          var line = pos.line, ch = pos.ch;
          var text = cm.getLine(pos.line), sawWord = false;
          for (; ; ) {
            var next = text.charAt(ch + (dir < 0 ? -1 : 0));
            if (!next) {
              if (line == (dir < 0 ? cm.firstLine() : cm.lastLine()))
                return Pos(line, ch);
              text = cm.getLine(line + dir);
              if (!/\S/.test(text))
                return Pos(line, ch);
              line += dir;
              ch = dir < 0 ? text.length : 0;
              continue;
            }
            if (sawWord && /[!?.]/.test(next))
              return Pos(line, ch + (dir > 0 ? 1 : 0));
            if (!sawWord)
              sawWord = /\w/.test(next);
            ch += dir;
          }
        }
        function byExpr(cm, pos, dir) {
          var wrap;
          if (cm.findMatchingBracket && (wrap = cm.findMatchingBracket(pos, { strict: true })) && wrap.match && (wrap.forward ? 1 : -1) == dir)
            return dir > 0 ? Pos(wrap.to.line, wrap.to.ch + 1) : wrap.to;
          for (var first = true; ; first = false) {
            var token = cm.getTokenAt(pos);
            var after = Pos(pos.line, dir < 0 ? token.start : token.end);
            if (first && dir > 0 && token.end == pos.ch || !/\w/.test(token.string)) {
              var newPos = cm.findPosH(after, dir, "char");
              if (posEq(after, newPos))
                return pos;
              else
                pos = newPos;
            } else {
              return after;
            }
          }
        }
        function getPrefix(cm, precise) {
          var digits2 = cm.state.emacsPrefix;
          if (!digits2)
            return precise ? null : 1;
          clearPrefix(cm);
          return digits2 == "-" ? -1 : Number(digits2);
        }
        function repeated(cmd) {
          var f3 = typeof cmd == "string" ? function(cm) {
            cm.execCommand(cmd);
          } : cmd;
          return function(cm) {
            var prefix = getPrefix(cm);
            f3(cm);
            for (var i4 = 1; i4 < prefix; ++i4)
              f3(cm);
          };
        }
        function findEnd(cm, pos, by, dir) {
          var prefix = getPrefix(cm);
          if (prefix < 0) {
            dir = -dir;
            prefix = -prefix;
          }
          for (var i4 = 0; i4 < prefix; ++i4) {
            var newPos = by(cm, pos, dir);
            if (posEq(newPos, pos))
              break;
            pos = newPos;
          }
          return pos;
        }
        function move(by, dir) {
          var f3 = function(cm) {
            cm.extendSelection(findEnd(cm, cm.getCursor(), by, dir));
          };
          f3.motion = true;
          return f3;
        }
        function killTo(cm, by, dir, ring) {
          var selections = cm.listSelections(), cursor;
          var i4 = selections.length;
          while (i4--) {
            cursor = selections[i4].head;
            kill(cm, cursor, findEnd(cm, cursor, by, dir), ring);
          }
        }
        function killRegion(cm, ring) {
          if (cm.somethingSelected()) {
            var selections = cm.listSelections(), selection;
            var i4 = selections.length;
            while (i4--) {
              selection = selections[i4];
              kill(cm, selection.anchor, selection.head, ring);
            }
            return true;
          }
        }
        function addPrefix(cm, digit) {
          if (cm.state.emacsPrefix) {
            if (digit != "-")
              cm.state.emacsPrefix += digit;
            return;
          }
          cm.state.emacsPrefix = digit;
          cm.on("keyHandled", maybeClearPrefix);
          cm.on("inputRead", maybeDuplicateInput);
        }
        var prefixPreservingKeys = { "Alt-G": true, "Ctrl-X": true, "Ctrl-Q": true, "Ctrl-U": true };
        function maybeClearPrefix(cm, arg) {
          if (!cm.state.emacsPrefixMap && !prefixPreservingKeys.hasOwnProperty(arg))
            clearPrefix(cm);
        }
        function clearPrefix(cm) {
          cm.state.emacsPrefix = null;
          cm.off("keyHandled", maybeClearPrefix);
          cm.off("inputRead", maybeDuplicateInput);
        }
        function maybeDuplicateInput(cm, event2) {
          var dup = getPrefix(cm);
          if (dup > 1 && event2.origin == "+input") {
            var one = event2.text.join("\n"), txt = "";
            for (var i4 = 1; i4 < dup; ++i4)
              txt += one;
            cm.replaceSelection(txt);
          }
        }
        function addPrefixMap(cm) {
          cm.state.emacsPrefixMap = true;
          cm.addKeyMap(prefixMap);
          cm.on("keyHandled", maybeRemovePrefixMap);
          cm.on("inputRead", maybeRemovePrefixMap);
        }
        function maybeRemovePrefixMap(cm, arg) {
          if (typeof arg == "string" && (/^\d$/.test(arg) || arg == "Ctrl-U"))
            return;
          cm.removeKeyMap(prefixMap);
          cm.state.emacsPrefixMap = false;
          cm.off("keyHandled", maybeRemovePrefixMap);
          cm.off("inputRead", maybeRemovePrefixMap);
        }
        function setMark(cm) {
          cm.setCursor(cm.getCursor());
          cm.setExtending(!cm.getExtending());
          cm.on("change", function() {
            cm.setExtending(false);
          });
        }
        function clearMark(cm) {
          cm.setExtending(false);
          cm.setCursor(cm.getCursor());
        }
        function getInput(cm, msg, f3) {
          if (cm.openDialog)
            cm.openDialog(msg + ': <input type="text" style="width: 10em"/>', f3, { bottom: true });
          else
            f3(prompt(msg, ""));
        }
        function operateOnWord(cm, op) {
          var start2 = cm.getCursor(), end = cm.findPosH(start2, 1, "word");
          cm.replaceRange(op(cm.getRange(start2, end)), start2, end);
          cm.setCursor(end);
        }
        function toEnclosingExpr(cm) {
          var pos = cm.getCursor(), line = pos.line, ch = pos.ch;
          var stack = [];
          while (line >= cm.firstLine()) {
            var text = cm.getLine(line);
            for (var i4 = ch == null ? text.length : ch; i4 > 0; ) {
              var ch = text.charAt(--i4);
              if (ch == ")")
                stack.push("(");
              else if (ch == "]")
                stack.push("[");
              else if (ch == "}")
                stack.push("{");
              else if (/[\(\{\[]/.test(ch) && (!stack.length || stack.pop() != ch))
                return cm.extendSelection(Pos(line, i4));
            }
            --line;
            ch = null;
          }
        }
        function quit(cm) {
          cm.execCommand("clearSearch");
          clearMark(cm);
        }
        CodeMirror5.emacs = { kill, killRegion, repeated };
        var keyMap = CodeMirror5.keyMap.emacs = CodeMirror5.normalizeKeyMap({
          "Ctrl-W": function(cm) {
            kill(cm, cm.getCursor("start"), cm.getCursor("end"), true);
          },
          "Ctrl-K": repeated(function(cm) {
            var start2 = cm.getCursor(), end = cm.clipPos(Pos(start2.line));
            var text = cm.getRange(start2, end);
            if (!/\S/.test(text)) {
              text += "\n";
              end = Pos(start2.line + 1, 0);
            }
            kill(cm, start2, end, "grow", text);
          }),
          "Alt-W": function(cm) {
            addToRing(cm.getSelection());
            clearMark(cm);
          },
          "Ctrl-Y": function(cm) {
            var start2 = cm.getCursor();
            cm.replaceRange(getFromRing(getPrefix(cm)), start2, start2, "paste");
            cm.setSelection(start2, cm.getCursor());
          },
          "Alt-Y": function(cm) {
            cm.replaceSelection(popFromRing(), "around", "paste");
          },
          "Ctrl-Space": setMark,
          "Ctrl-Shift-2": setMark,
          "Ctrl-F": move(byChar, 1),
          "Ctrl-B": move(byChar, -1),
          "Right": move(byChar, 1),
          "Left": move(byChar, -1),
          "Ctrl-D": function(cm) {
            killTo(cm, byChar, 1, false);
          },
          "Delete": function(cm) {
            killRegion(cm, false) || killTo(cm, byChar, 1, false);
          },
          "Ctrl-H": function(cm) {
            killTo(cm, byChar, -1, false);
          },
          "Backspace": function(cm) {
            killRegion(cm, false) || killTo(cm, byChar, -1, false);
          },
          "Alt-F": move(byWord, 1),
          "Alt-B": move(byWord, -1),
          "Alt-Right": move(byWord, 1),
          "Alt-Left": move(byWord, -1),
          "Alt-D": function(cm) {
            killTo(cm, byWord, 1, "grow");
          },
          "Alt-Backspace": function(cm) {
            killTo(cm, byWord, -1, "grow");
          },
          "Ctrl-N": move(byLine, 1),
          "Ctrl-P": move(byLine, -1),
          "Down": move(byLine, 1),
          "Up": move(byLine, -1),
          "Ctrl-A": "goLineStart",
          "Ctrl-E": "goLineEnd",
          "End": "goLineEnd",
          "Home": "goLineStart",
          "Alt-V": move(byPage, -1),
          "Ctrl-V": move(byPage, 1),
          "PageUp": move(byPage, -1),
          "PageDown": move(byPage, 1),
          "Ctrl-Up": move(byParagraph, -1),
          "Ctrl-Down": move(byParagraph, 1),
          "Alt-A": move(bySentence, -1),
          "Alt-E": move(bySentence, 1),
          "Alt-K": function(cm) {
            killTo(cm, bySentence, 1, "grow");
          },
          "Ctrl-Alt-K": function(cm) {
            killTo(cm, byExpr, 1, "grow");
          },
          "Ctrl-Alt-Backspace": function(cm) {
            killTo(cm, byExpr, -1, "grow");
          },
          "Ctrl-Alt-F": move(byExpr, 1),
          "Ctrl-Alt-B": move(byExpr, -1, "grow"),
          "Shift-Ctrl-Alt-2": function(cm) {
            var cursor = cm.getCursor();
            cm.setSelection(findEnd(cm, cursor, byExpr, 1), cursor);
          },
          "Ctrl-Alt-T": function(cm) {
            var leftStart = byExpr(cm, cm.getCursor(), -1), leftEnd = byExpr(cm, leftStart, 1);
            var rightEnd = byExpr(cm, leftEnd, 1), rightStart = byExpr(cm, rightEnd, -1);
            cm.replaceRange(cm.getRange(rightStart, rightEnd) + cm.getRange(leftEnd, rightStart) + cm.getRange(leftStart, leftEnd), leftStart, rightEnd);
          },
          "Ctrl-Alt-U": repeated(toEnclosingExpr),
          "Alt-Space": function(cm) {
            var pos = cm.getCursor(), from = pos.ch, to = pos.ch, text = cm.getLine(pos.line);
            while (from && /\s/.test(text.charAt(from - 1)))
              --from;
            while (to < text.length && /\s/.test(text.charAt(to)))
              ++to;
            cm.replaceRange(" ", Pos(pos.line, from), Pos(pos.line, to));
          },
          "Ctrl-O": repeated(function(cm) {
            cm.replaceSelection("\n", "start");
          }),
          "Ctrl-T": repeated(function(cm) {
            cm.execCommand("transposeChars");
          }),
          "Alt-C": repeated(function(cm) {
            operateOnWord(cm, function(w3) {
              var letter = w3.search(/\w/);
              if (letter == -1)
                return w3;
              return w3.slice(0, letter) + w3.charAt(letter).toUpperCase() + w3.slice(letter + 1).toLowerCase();
            });
          }),
          "Alt-U": repeated(function(cm) {
            operateOnWord(cm, function(w3) {
              return w3.toUpperCase();
            });
          }),
          "Alt-L": repeated(function(cm) {
            operateOnWord(cm, function(w3) {
              return w3.toLowerCase();
            });
          }),
          "Alt-;": "toggleComment",
          "Ctrl-/": repeated("undo"),
          "Shift-Ctrl--": repeated("undo"),
          "Ctrl-Z": repeated("undo"),
          "Cmd-Z": repeated("undo"),
          "Shift-Ctrl-Z": "redo",
          "Shift-Alt-,": "goDocStart",
          "Shift-Alt-.": "goDocEnd",
          "Ctrl-S": "findPersistentNext",
          "Ctrl-R": "findPersistentPrev",
          "Ctrl-G": quit,
          "Shift-Alt-5": "replace",
          "Alt-/": "autocomplete",
          "Enter": "newlineAndIndent",
          "Ctrl-J": repeated(function(cm) {
            cm.replaceSelection("\n", "end");
          }),
          "Tab": "indentAuto",
          "Alt-G G": function(cm) {
            var prefix = getPrefix(cm, true);
            if (prefix != null && prefix > 0)
              return cm.setCursor(prefix - 1);
            getInput(cm, "Goto line", function(str) {
              var num;
              if (str && !isNaN(num = Number(str)) && num == (num | 0) && num > 0)
                cm.setCursor(num - 1);
            });
          },
          "Ctrl-X Tab": function(cm) {
            cm.indentSelection(getPrefix(cm, true) || cm.getOption("indentUnit"));
          },
          "Ctrl-X Ctrl-X": function(cm) {
            cm.setSelection(cm.getCursor("head"), cm.getCursor("anchor"));
          },
          "Ctrl-X Ctrl-S": "save",
          "Ctrl-X Ctrl-W": "save",
          "Ctrl-X S": "saveAll",
          "Ctrl-X F": "open",
          "Ctrl-X U": repeated("undo"),
          "Ctrl-X K": "close",
          "Ctrl-X Delete": function(cm) {
            kill(cm, cm.getCursor(), bySentence(cm, cm.getCursor(), 1), "grow");
          },
          "Ctrl-X H": "selectAll",
          "Ctrl-Q Tab": repeated("insertTab"),
          "Ctrl-U": addPrefixMap,
          "fallthrough": "default"
        });
        var prefixMap = { "Ctrl-G": clearPrefix };
        function regPrefix(d4) {
          prefixMap[d4] = function(cm) {
            addPrefix(cm, d4);
          };
          keyMap["Ctrl-" + d4] = function(cm) {
            addPrefix(cm, d4);
          };
          prefixPreservingKeys["Ctrl-" + d4] = true;
        }
        for (var i3 = 0; i3 < 10; ++i3)
          regPrefix(String(i3));
        regPrefix("-");
      });
    }
  });

  // node_modules/@plaincontext/codemirror/addon/edit/matchbrackets.js
  var require_matchbrackets = __commonJS({
    "node_modules/@plaincontext/codemirror/addon/edit/matchbrackets.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror());
        else if (typeof define == "function" && define.amd)
          define(["../../lib/codemirror"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        var ie_lt8 = /MSIE \d/.test(navigator.userAgent) && (document.documentMode == null || document.documentMode < 8);
        var Pos = CodeMirror5.Pos;
        var matching = { "(": ")>", ")": "(<", "[": "]>", "]": "[<", "{": "}>", "}": "{<", "<": ">>", ">": "<<" };
        function bracketRegex(config3) {
          return config3 && config3.bracketRegex || /[(){}[\]]/;
        }
        function findMatchingBracket(cm, where, config3) {
          var line = cm.getLineHandle(where.line), pos = where.ch - 1;
          var afterCursor = config3 && config3.afterCursor;
          if (afterCursor == null)
            afterCursor = /(^| )cm-fat-cursor($| )/.test(cm.getWrapperElement().className);
          var re = bracketRegex(config3);
          var match = !afterCursor && pos >= 0 && re.test(line.text.charAt(pos)) && matching[line.text.charAt(pos)] || re.test(line.text.charAt(pos + 1)) && matching[line.text.charAt(++pos)];
          if (!match)
            return null;
          var dir = match.charAt(1) == ">" ? 1 : -1;
          if (config3 && config3.strict && dir > 0 != (pos == where.ch))
            return null;
          var style = cm.getTokenTypeAt(Pos(where.line, pos + 1));
          var found = scanForBracket(cm, Pos(where.line, pos + (dir > 0 ? 1 : 0)), dir, style || null, config3);
          if (found == null)
            return null;
          return {
            from: Pos(where.line, pos),
            to: found && found.pos,
            match: found && found.ch == match.charAt(0),
            forward: dir > 0
          };
        }
        function scanForBracket(cm, where, dir, style, config3) {
          var maxScanLen = config3 && config3.maxScanLineLength || 1e4;
          var maxScanLines = config3 && config3.maxScanLines || 1e3;
          var stack = [];
          var re = bracketRegex(config3);
          var lineEnd = dir > 0 ? Math.min(where.line + maxScanLines, cm.lastLine() + 1) : Math.max(cm.firstLine() - 1, where.line - maxScanLines);
          for (var lineNo = where.line; lineNo != lineEnd; lineNo += dir) {
            var line = cm.getLine(lineNo);
            if (!line)
              continue;
            var pos = dir > 0 ? 0 : line.length - 1, end = dir > 0 ? line.length : -1;
            if (line.length > maxScanLen)
              continue;
            if (lineNo == where.line)
              pos = where.ch - (dir < 0 ? 1 : 0);
            for (; pos != end; pos += dir) {
              var ch = line.charAt(pos);
              if (re.test(ch) && (style === void 0 || cm.getTokenTypeAt(Pos(lineNo, pos + 1)) == style)) {
                var match = matching[ch];
                if (match && match.charAt(1) == ">" == dir > 0)
                  stack.push(ch);
                else if (!stack.length)
                  return { pos: Pos(lineNo, pos), ch };
                else
                  stack.pop();
              }
            }
          }
          return lineNo - dir == (dir > 0 ? cm.lastLine() : cm.firstLine()) ? false : null;
        }
        function matchBrackets(cm, autoclear, config3) {
          var maxHighlightLen = cm.state.matchBrackets.maxHighlightLineLength || 1e3;
          var marks = [], ranges = cm.listSelections();
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var match = ranges[i3].empty() && findMatchingBracket(cm, ranges[i3].head, config3);
            if (match && cm.getLine(match.from.line).length <= maxHighlightLen) {
              var style = match.match ? "CodeMirror-matchingbracket" : "CodeMirror-nonmatchingbracket";
              marks.push(cm.markText(match.from, Pos(match.from.line, match.from.ch + 1), { className: style }));
              if (match.to && cm.getLine(match.to.line).length <= maxHighlightLen)
                marks.push(cm.markText(match.to, Pos(match.to.line, match.to.ch + 1), { className: style }));
            }
          }
          if (marks.length) {
            if (ie_lt8 && cm.state.focused)
              cm.focus();
            var clear = function() {
              cm.operation(function() {
                for (var i4 = 0; i4 < marks.length; i4++)
                  marks[i4].clear();
              });
            };
            if (autoclear)
              setTimeout(clear, 800);
            else
              return clear;
          }
        }
        function doMatchBrackets(cm) {
          cm.operation(function() {
            if (cm.state.matchBrackets.currentlyHighlighted) {
              cm.state.matchBrackets.currentlyHighlighted();
              cm.state.matchBrackets.currentlyHighlighted = null;
            }
            cm.state.matchBrackets.currentlyHighlighted = matchBrackets(cm, false, cm.state.matchBrackets);
          });
        }
        CodeMirror5.defineOption("matchBrackets", false, function(cm, val, old) {
          function clear(cm2) {
            if (cm2.state.matchBrackets && cm2.state.matchBrackets.currentlyHighlighted) {
              cm2.state.matchBrackets.currentlyHighlighted();
              cm2.state.matchBrackets.currentlyHighlighted = null;
            }
          }
          if (old && old != CodeMirror5.Init) {
            cm.off("cursorActivity", doMatchBrackets);
            cm.off("focus", doMatchBrackets);
            cm.off("blur", clear);
            clear(cm);
          }
          if (val) {
            cm.state.matchBrackets = typeof val == "object" ? val : {};
            cm.on("cursorActivity", doMatchBrackets);
            cm.on("focus", doMatchBrackets);
            cm.on("blur", clear);
          }
        });
        CodeMirror5.defineExtension("matchBrackets", function() {
          matchBrackets(this, true);
        });
        CodeMirror5.defineExtension("findMatchingBracket", function(pos, config3, oldConfig) {
          if (oldConfig || typeof config3 == "boolean") {
            if (!oldConfig) {
              config3 = config3 ? { strict: true } : null;
            } else {
              oldConfig.strict = config3;
              config3 = oldConfig;
            }
          }
          return findMatchingBracket(this, pos, config3);
        });
        CodeMirror5.defineExtension("scanForBracket", function(pos, dir, style, config3) {
          return scanForBracket(this, pos, dir, style, config3);
        });
      });
    }
  });

  // node_modules/@plaincontext/codemirror/keymap/sublime.js
  var require_sublime = __commonJS({
    "node_modules/@plaincontext/codemirror/keymap/sublime.js"(exports, module) {
      (function(mod2) {
        if (typeof exports == "object" && typeof module == "object")
          mod2(require_codemirror(), require_searchcursor(), require_matchbrackets());
        else if (typeof define == "function" && define.amd)
          define(["../lib/codemirror", "../addon/search/searchcursor", "../addon/edit/matchbrackets"], mod2);
        else
          mod2(CodeMirror);
      })(function(CodeMirror5) {
        "use strict";
        var cmds = CodeMirror5.commands;
        var Pos = CodeMirror5.Pos;
        function findPosSubword(doc, start2, dir) {
          if (dir < 0 && start2.ch == 0)
            return doc.clipPos(Pos(start2.line - 1));
          var line = doc.getLine(start2.line);
          if (dir > 0 && start2.ch >= line.length)
            return doc.clipPos(Pos(start2.line + 1, 0));
          var state = "start", type, startPos = start2.ch;
          for (var pos = startPos, e5 = dir < 0 ? 0 : line.length, i3 = 0; pos != e5; pos += dir, i3++) {
            var next = line.charAt(dir < 0 ? pos - 1 : pos);
            var cat = next != "_" && CodeMirror5.isWordChar(next) ? "w" : "o";
            if (cat == "w" && next.toUpperCase() == next)
              cat = "W";
            if (state == "start") {
              if (cat != "o") {
                state = "in";
                type = cat;
              } else
                startPos = pos + dir;
            } else if (state == "in") {
              if (type != cat) {
                if (type == "w" && cat == "W" && dir < 0)
                  pos--;
                if (type == "W" && cat == "w" && dir > 0) {
                  if (pos == startPos + 1) {
                    type = "w";
                    continue;
                  } else
                    pos--;
                }
                break;
              }
            }
          }
          return Pos(start2.line, pos);
        }
        function moveSubword(cm, dir) {
          cm.extendSelectionsBy(function(range2) {
            if (cm.display.shift || cm.doc.extend || range2.empty())
              return findPosSubword(cm.doc, range2.head, dir);
            else
              return dir < 0 ? range2.from() : range2.to();
          });
        }
        cmds.goSubwordLeft = function(cm) {
          moveSubword(cm, -1);
        };
        cmds.goSubwordRight = function(cm) {
          moveSubword(cm, 1);
        };
        cmds.scrollLineUp = function(cm) {
          var info = cm.getScrollInfo();
          if (!cm.somethingSelected()) {
            var visibleBottomLine = cm.lineAtHeight(info.top + info.clientHeight, "local");
            if (cm.getCursor().line >= visibleBottomLine)
              cm.execCommand("goLineUp");
          }
          cm.scrollTo(null, info.top - cm.defaultTextHeight());
        };
        cmds.scrollLineDown = function(cm) {
          var info = cm.getScrollInfo();
          if (!cm.somethingSelected()) {
            var visibleTopLine = cm.lineAtHeight(info.top, "local") + 1;
            if (cm.getCursor().line <= visibleTopLine)
              cm.execCommand("goLineDown");
          }
          cm.scrollTo(null, info.top + cm.defaultTextHeight());
        };
        cmds.splitSelectionByLine = function(cm) {
          var ranges = cm.listSelections(), lineRanges = [];
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var from = ranges[i3].from(), to = ranges[i3].to();
            for (var line = from.line; line <= to.line; ++line)
              if (!(to.line > from.line && line == to.line && to.ch == 0))
                lineRanges.push({
                  anchor: line == from.line ? from : Pos(line, 0),
                  head: line == to.line ? to : Pos(line)
                });
          }
          cm.setSelections(lineRanges, 0);
        };
        cmds.singleSelectionTop = function(cm) {
          var range2 = cm.listSelections()[0];
          cm.setSelection(range2.anchor, range2.head, { scroll: false });
        };
        cmds.selectLine = function(cm) {
          var ranges = cm.listSelections(), extended = [];
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3];
            extended.push({
              anchor: Pos(range2.from().line, 0),
              head: Pos(range2.to().line + 1, 0)
            });
          }
          cm.setSelections(extended);
        };
        function insertLine(cm, above) {
          if (cm.isReadOnly())
            return CodeMirror5.Pass;
          cm.operation(function() {
            var len = cm.listSelections().length, newSelection = [], last = -1;
            for (var i3 = 0; i3 < len; i3++) {
              var head = cm.listSelections()[i3].head;
              if (head.line <= last)
                continue;
              var at = Pos(head.line + (above ? 0 : 1), 0);
              cm.replaceRange("\n", at, null, "+insertLine");
              cm.indentLine(at.line, null, true);
              newSelection.push({ head: at, anchor: at });
              last = head.line + 1;
            }
            cm.setSelections(newSelection);
          });
          cm.execCommand("indentAuto");
        }
        cmds.insertLineAfter = function(cm) {
          return insertLine(cm, false);
        };
        cmds.insertLineBefore = function(cm) {
          return insertLine(cm, true);
        };
        function wordAt(cm, pos) {
          var start2 = pos.ch, end = start2, line = cm.getLine(pos.line);
          while (start2 && CodeMirror5.isWordChar(line.charAt(start2 - 1)))
            --start2;
          while (end < line.length && CodeMirror5.isWordChar(line.charAt(end)))
            ++end;
          return { from: Pos(pos.line, start2), to: Pos(pos.line, end), word: line.slice(start2, end) };
        }
        cmds.selectNextOccurrence = function(cm) {
          var from = cm.getCursor("from"), to = cm.getCursor("to");
          var fullWord = cm.state.sublimeFindFullWord == cm.doc.sel;
          if (CodeMirror5.cmpPos(from, to) == 0) {
            var word = wordAt(cm, from);
            if (!word.word)
              return;
            cm.setSelection(word.from, word.to);
            fullWord = true;
          } else {
            var text = cm.getRange(from, to);
            var query = fullWord ? new RegExp("\\b" + text + "\\b") : text;
            var cur = cm.getSearchCursor(query, to);
            var found = cur.findNext();
            if (!found) {
              cur = cm.getSearchCursor(query, Pos(cm.firstLine(), 0));
              found = cur.findNext();
            }
            if (!found || isSelectedRange(cm.listSelections(), cur.from(), cur.to()))
              return;
            cm.addSelection(cur.from(), cur.to());
          }
          if (fullWord)
            cm.state.sublimeFindFullWord = cm.doc.sel;
        };
        cmds.skipAndSelectNextOccurrence = function(cm) {
          var prevAnchor = cm.getCursor("anchor"), prevHead = cm.getCursor("head");
          cmds.selectNextOccurrence(cm);
          if (CodeMirror5.cmpPos(prevAnchor, prevHead) != 0) {
            cm.doc.setSelections(cm.doc.listSelections().filter(function(sel) {
              return sel.anchor != prevAnchor || sel.head != prevHead;
            }));
          }
        };
        function addCursorToSelection(cm, dir) {
          var ranges = cm.listSelections(), newRanges = [];
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3];
            var newAnchor = cm.findPosV(range2.anchor, dir, "line", range2.anchor.goalColumn);
            var newHead = cm.findPosV(range2.head, dir, "line", range2.head.goalColumn);
            newAnchor.goalColumn = range2.anchor.goalColumn != null ? range2.anchor.goalColumn : cm.cursorCoords(range2.anchor, "div").left;
            newHead.goalColumn = range2.head.goalColumn != null ? range2.head.goalColumn : cm.cursorCoords(range2.head, "div").left;
            var newRange = { anchor: newAnchor, head: newHead };
            newRanges.push(range2);
            newRanges.push(newRange);
          }
          cm.setSelections(newRanges);
        }
        cmds.addCursorToPrevLine = function(cm) {
          addCursorToSelection(cm, -1);
        };
        cmds.addCursorToNextLine = function(cm) {
          addCursorToSelection(cm, 1);
        };
        function isSelectedRange(ranges, from, to) {
          for (var i3 = 0; i3 < ranges.length; i3++)
            if (CodeMirror5.cmpPos(ranges[i3].from(), from) == 0 && CodeMirror5.cmpPos(ranges[i3].to(), to) == 0)
              return true;
          return false;
        }
        var mirror = "(){}[]";
        function selectBetweenBrackets(cm) {
          var ranges = cm.listSelections(), newRanges = [];
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3], pos = range2.head, opening = cm.scanForBracket(pos, -1);
            if (!opening)
              return false;
            for (; ; ) {
              var closing = cm.scanForBracket(pos, 1);
              if (!closing)
                return false;
              if (closing.ch == mirror.charAt(mirror.indexOf(opening.ch) + 1)) {
                var startPos = Pos(opening.pos.line, opening.pos.ch + 1);
                if (CodeMirror5.cmpPos(startPos, range2.from()) == 0 && CodeMirror5.cmpPos(closing.pos, range2.to()) == 0) {
                  opening = cm.scanForBracket(opening.pos, -1);
                  if (!opening)
                    return false;
                } else {
                  newRanges.push({ anchor: startPos, head: closing.pos });
                  break;
                }
              }
              pos = Pos(closing.pos.line, closing.pos.ch + 1);
            }
          }
          cm.setSelections(newRanges);
          return true;
        }
        cmds.selectScope = function(cm) {
          selectBetweenBrackets(cm) || cm.execCommand("selectAll");
        };
        cmds.selectBetweenBrackets = function(cm) {
          if (!selectBetweenBrackets(cm))
            return CodeMirror5.Pass;
        };
        function puncType(type) {
          return !type ? null : /\bpunctuation\b/.test(type) ? type : void 0;
        }
        cmds.goToBracket = function(cm) {
          cm.extendSelectionsBy(function(range2) {
            var next = cm.scanForBracket(range2.head, 1, puncType(cm.getTokenTypeAt(range2.head)));
            if (next && CodeMirror5.cmpPos(next.pos, range2.head) != 0)
              return next.pos;
            var prev = cm.scanForBracket(range2.head, -1, puncType(cm.getTokenTypeAt(Pos(range2.head.line, range2.head.ch + 1))));
            return prev && Pos(prev.pos.line, prev.pos.ch + 1) || range2.head;
          });
        };
        cmds.swapLineUp = function(cm) {
          if (cm.isReadOnly())
            return CodeMirror5.Pass;
          var ranges = cm.listSelections(), linesToMove = [], at = cm.firstLine() - 1, newSels = [];
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3], from = range2.from().line - 1, to = range2.to().line;
            newSels.push({
              anchor: Pos(range2.anchor.line - 1, range2.anchor.ch),
              head: Pos(range2.head.line - 1, range2.head.ch)
            });
            if (range2.to().ch == 0 && !range2.empty())
              --to;
            if (from > at)
              linesToMove.push(from, to);
            else if (linesToMove.length)
              linesToMove[linesToMove.length - 1] = to;
            at = to;
          }
          cm.operation(function() {
            for (var i4 = 0; i4 < linesToMove.length; i4 += 2) {
              var from2 = linesToMove[i4], to2 = linesToMove[i4 + 1];
              var line = cm.getLine(from2);
              cm.replaceRange("", Pos(from2, 0), Pos(from2 + 1, 0), "+swapLine");
              if (to2 > cm.lastLine())
                cm.replaceRange("\n" + line, Pos(cm.lastLine()), null, "+swapLine");
              else
                cm.replaceRange(line + "\n", Pos(to2, 0), null, "+swapLine");
            }
            cm.setSelections(newSels);
            cm.scrollIntoView();
          });
        };
        cmds.swapLineDown = function(cm) {
          if (cm.isReadOnly())
            return CodeMirror5.Pass;
          var ranges = cm.listSelections(), linesToMove = [], at = cm.lastLine() + 1;
          for (var i3 = ranges.length - 1; i3 >= 0; i3--) {
            var range2 = ranges[i3], from = range2.to().line + 1, to = range2.from().line;
            if (range2.to().ch == 0 && !range2.empty())
              from--;
            if (from < at)
              linesToMove.push(from, to);
            else if (linesToMove.length)
              linesToMove[linesToMove.length - 1] = to;
            at = to;
          }
          cm.operation(function() {
            for (var i4 = linesToMove.length - 2; i4 >= 0; i4 -= 2) {
              var from2 = linesToMove[i4], to2 = linesToMove[i4 + 1];
              var line = cm.getLine(from2);
              if (from2 == cm.lastLine())
                cm.replaceRange("", Pos(from2 - 1), Pos(from2), "+swapLine");
              else
                cm.replaceRange("", Pos(from2, 0), Pos(from2 + 1, 0), "+swapLine");
              cm.replaceRange(line + "\n", Pos(to2, 0), null, "+swapLine");
            }
            cm.scrollIntoView();
          });
        };
        cmds.toggleCommentIndented = function(cm) {
          cm.toggleComment({ indent: true });
        };
        cmds.joinLines = function(cm) {
          var ranges = cm.listSelections(), joined = [];
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3], from = range2.from();
            var start2 = from.line, end = range2.to().line;
            while (i3 < ranges.length - 1 && ranges[i3 + 1].from().line == end)
              end = ranges[++i3].to().line;
            joined.push({ start: start2, end, anchor: !range2.empty() && from });
          }
          cm.operation(function() {
            var offset = 0, ranges2 = [];
            for (var i4 = 0; i4 < joined.length; i4++) {
              var obj = joined[i4];
              var anchor = obj.anchor && Pos(obj.anchor.line - offset, obj.anchor.ch), head;
              for (var line = obj.start; line <= obj.end; line++) {
                var actual = line - offset;
                if (line == obj.end)
                  head = Pos(actual, cm.getLine(actual).length + 1);
                if (actual < cm.lastLine()) {
                  cm.replaceRange(" ", Pos(actual), Pos(actual + 1, /^\s*/.exec(cm.getLine(actual + 1))[0].length));
                  ++offset;
                }
              }
              ranges2.push({ anchor: anchor || head, head });
            }
            cm.setSelections(ranges2, 0);
          });
        };
        cmds.duplicateLine = function(cm) {
          cm.operation(function() {
            var rangeCount = cm.listSelections().length;
            for (var i3 = 0; i3 < rangeCount; i3++) {
              var range2 = cm.listSelections()[i3];
              if (range2.empty())
                cm.replaceRange(cm.getLine(range2.head.line) + "\n", Pos(range2.head.line, 0));
              else
                cm.replaceRange(cm.getRange(range2.from(), range2.to()), range2.from());
            }
            cm.scrollIntoView();
          });
        };
        function sortLines(cm, caseSensitive) {
          if (cm.isReadOnly())
            return CodeMirror5.Pass;
          var ranges = cm.listSelections(), toSort = [], selected;
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var range2 = ranges[i3];
            if (range2.empty())
              continue;
            var from = range2.from().line, to = range2.to().line;
            while (i3 < ranges.length - 1 && ranges[i3 + 1].from().line == to)
              to = ranges[++i3].to().line;
            if (!ranges[i3].to().ch)
              to--;
            toSort.push(from, to);
          }
          if (toSort.length)
            selected = true;
          else
            toSort.push(cm.firstLine(), cm.lastLine());
          cm.operation(function() {
            var ranges2 = [];
            for (var i4 = 0; i4 < toSort.length; i4 += 2) {
              var from2 = toSort[i4], to2 = toSort[i4 + 1];
              var start2 = Pos(from2, 0), end = Pos(to2);
              var lines = cm.getRange(start2, end, false);
              if (caseSensitive)
                lines.sort();
              else
                lines.sort(function(a3, b2) {
                  var au = a3.toUpperCase(), bu = b2.toUpperCase();
                  if (au != bu) {
                    a3 = au;
                    b2 = bu;
                  }
                  return a3 < b2 ? -1 : a3 == b2 ? 0 : 1;
                });
              cm.replaceRange(lines, start2, end);
              if (selected)
                ranges2.push({ anchor: start2, head: Pos(to2 + 1, 0) });
            }
            if (selected)
              cm.setSelections(ranges2, 0);
          });
        }
        cmds.sortLines = function(cm) {
          sortLines(cm, true);
        };
        cmds.sortLinesInsensitive = function(cm) {
          sortLines(cm, false);
        };
        cmds.nextBookmark = function(cm) {
          var marks = cm.state.sublimeBookmarks;
          if (marks)
            while (marks.length) {
              var current = marks.shift();
              var found = current.find();
              if (found) {
                marks.push(current);
                return cm.setSelection(found.from, found.to);
              }
            }
        };
        cmds.prevBookmark = function(cm) {
          var marks = cm.state.sublimeBookmarks;
          if (marks)
            while (marks.length) {
              marks.unshift(marks.pop());
              var found = marks[marks.length - 1].find();
              if (!found)
                marks.pop();
              else
                return cm.setSelection(found.from, found.to);
            }
        };
        cmds.toggleBookmark = function(cm) {
          var ranges = cm.listSelections();
          var marks = cm.state.sublimeBookmarks || (cm.state.sublimeBookmarks = []);
          for (var i3 = 0; i3 < ranges.length; i3++) {
            var from = ranges[i3].from(), to = ranges[i3].to();
            var found = ranges[i3].empty() ? cm.findMarksAt(from) : cm.findMarks(from, to);
            for (var j3 = 0; j3 < found.length; j3++) {
              if (found[j3].sublimeBookmark) {
                found[j3].clear();
                for (var k3 = 0; k3 < marks.length; k3++)
                  if (marks[k3] == found[j3])
                    marks.splice(k3--, 1);
                break;
              }
            }
            if (j3 == found.length)
              marks.push(cm.markText(from, to, { sublimeBookmark: true, clearWhenEmpty: false }));
          }
        };
        cmds.clearBookmarks = function(cm) {
          var marks = cm.state.sublimeBookmarks;
          if (marks)
            for (var i3 = 0; i3 < marks.length; i3++)
              marks[i3].clear();
          marks.length = 0;
        };
        cmds.selectBookmarks = function(cm) {
          var marks = cm.state.sublimeBookmarks, ranges = [];
          if (marks)
            for (var i3 = 0; i3 < marks.length; i3++) {
              var found = marks[i3].find();
              if (!found)
                marks.splice(i3--, 0);
              else
                ranges.push({ anchor: found.from, head: found.to });
            }
          if (ranges.length)
            cm.setSelections(ranges, 0);
        };
        function modifyWordOrSelection(cm, mod2) {
          cm.operation(function() {
            var ranges = cm.listSelections(), indices = [], replacements = [];
            for (var i3 = 0; i3 < ranges.length; i3++) {
              var range2 = ranges[i3];
              if (range2.empty()) {
                indices.push(i3);
                replacements.push("");
              } else
                replacements.push(mod2(cm.getRange(range2.from(), range2.to())));
            }
            cm.replaceSelections(replacements, "around", "case");
            for (var i3 = indices.length - 1, at; i3 >= 0; i3--) {
              var range2 = ranges[indices[i3]];
              if (at && CodeMirror5.cmpPos(range2.head, at) > 0)
                continue;
              var word = wordAt(cm, range2.head);
              at = word.from;
              cm.replaceRange(mod2(word.word), word.from, word.to);
            }
          });
        }
        cmds.smartBackspace = function(cm) {
          if (cm.somethingSelected())
            return CodeMirror5.Pass;
          cm.operation(function() {
            var cursors = cm.listSelections();
            var indentUnit = cm.getOption("indentUnit");
            for (var i3 = cursors.length - 1; i3 >= 0; i3--) {
              var cursor = cursors[i3].head;
              var toStartOfLine = cm.getRange({ line: cursor.line, ch: 0 }, cursor);
              var column = CodeMirror5.countColumn(toStartOfLine, null, cm.getOption("tabSize"));
              var deletePos = cm.findPosH(cursor, -1, "char", false);
              if (toStartOfLine && !/\S/.test(toStartOfLine) && column % indentUnit == 0) {
                var prevIndent = new Pos(cursor.line, CodeMirror5.findColumn(toStartOfLine, column - indentUnit, indentUnit));
                if (prevIndent.ch != cursor.ch)
                  deletePos = prevIndent;
              }
              cm.replaceRange("", deletePos, cursor, "+delete");
            }
          });
        };
        cmds.delLineRight = function(cm) {
          cm.operation(function() {
            var ranges = cm.listSelections();
            for (var i3 = ranges.length - 1; i3 >= 0; i3--)
              cm.replaceRange("", ranges[i3].anchor, Pos(ranges[i3].to().line), "+delete");
            cm.scrollIntoView();
          });
        };
        cmds.upcaseAtCursor = function(cm) {
          modifyWordOrSelection(cm, function(str) {
            return str.toUpperCase();
          });
        };
        cmds.downcaseAtCursor = function(cm) {
          modifyWordOrSelection(cm, function(str) {
            return str.toLowerCase();
          });
        };
        cmds.setSublimeMark = function(cm) {
          if (cm.state.sublimeMark)
            cm.state.sublimeMark.clear();
          cm.state.sublimeMark = cm.setBookmark(cm.getCursor());
        };
        cmds.selectToSublimeMark = function(cm) {
          var found = cm.state.sublimeMark && cm.state.sublimeMark.find();
          if (found)
            cm.setSelection(cm.getCursor(), found);
        };
        cmds.deleteToSublimeMark = function(cm) {
          var found = cm.state.sublimeMark && cm.state.sublimeMark.find();
          if (found) {
            var from = cm.getCursor(), to = found;
            if (CodeMirror5.cmpPos(from, to) > 0) {
              var tmp = to;
              to = from;
              from = tmp;
            }
            cm.state.sublimeKilled = cm.getRange(from, to);
            cm.replaceRange("", from, to);
          }
        };
        cmds.swapWithSublimeMark = function(cm) {
          var found = cm.state.sublimeMark && cm.state.sublimeMark.find();
          if (found) {
            cm.state.sublimeMark.clear();
            cm.state.sublimeMark = cm.setBookmark(cm.getCursor());
            cm.setCursor(found);
          }
        };
        cmds.sublimeYank = function(cm) {
          if (cm.state.sublimeKilled != null)
            cm.replaceSelection(cm.state.sublimeKilled, null, "paste");
        };
        cmds.showInCenter = function(cm) {
          var pos = cm.cursorCoords(null, "local");
          cm.scrollTo(null, (pos.top + pos.bottom) / 2 - cm.getScrollInfo().clientHeight / 2);
        };
        function getTarget(cm) {
          var from = cm.getCursor("from"), to = cm.getCursor("to");
          if (CodeMirror5.cmpPos(from, to) == 0) {
            var word = wordAt(cm, from);
            if (!word.word)
              return;
            from = word.from;
            to = word.to;
          }
          return { from, to, query: cm.getRange(from, to), word };
        }
        function findAndGoTo(cm, forward) {
          var target = getTarget(cm);
          if (!target)
            return;
          var query = target.query;
          var cur = cm.getSearchCursor(query, forward ? target.to : target.from);
          if (forward ? cur.findNext() : cur.findPrevious()) {
            cm.setSelection(cur.from(), cur.to());
          } else {
            cur = cm.getSearchCursor(query, forward ? Pos(cm.firstLine(), 0) : cm.clipPos(Pos(cm.lastLine())));
            if (forward ? cur.findNext() : cur.findPrevious())
              cm.setSelection(cur.from(), cur.to());
            else if (target.word)
              cm.setSelection(target.from, target.to);
          }
        }
        ;
        cmds.findUnder = function(cm) {
          findAndGoTo(cm, true);
        };
        cmds.findUnderPrevious = function(cm) {
          findAndGoTo(cm, false);
        };
        cmds.findAllUnder = function(cm) {
          var target = getTarget(cm);
          if (!target)
            return;
          var cur = cm.getSearchCursor(target.query);
          var matches = [];
          var primaryIndex = -1;
          while (cur.findNext()) {
            matches.push({ anchor: cur.from(), head: cur.to() });
            if (cur.from().line <= target.from.line && cur.from().ch <= target.from.ch)
              primaryIndex++;
          }
          cm.setSelections(matches, primaryIndex);
        };
        var keyMap = CodeMirror5.keyMap;
        keyMap.macSublime = {
          "Cmd-Left": "goLineStartSmart",
          "Shift-Tab": "indentLess",
          "Shift-Ctrl-K": "deleteLine",
          "Alt-Q": "wrapLines",
          "Ctrl-Left": "goSubwordLeft",
          "Ctrl-Right": "goSubwordRight",
          "Ctrl-Alt-Up": "scrollLineUp",
          "Ctrl-Alt-Down": "scrollLineDown",
          "Cmd-L": "selectLine",
          "Shift-Cmd-L": "splitSelectionByLine",
          "Esc": "singleSelectionTop",
          "Cmd-Enter": "insertLineAfter",
          "Shift-Cmd-Enter": "insertLineBefore",
          "Cmd-D": "selectNextOccurrence",
          "Shift-Cmd-Space": "selectScope",
          "Shift-Cmd-M": "selectBetweenBrackets",
          "Cmd-M": "goToBracket",
          "Cmd-Ctrl-Up": "swapLineUp",
          "Cmd-Ctrl-Down": "swapLineDown",
          "Cmd-/": "toggleCommentIndented",
          "Cmd-J": "joinLines",
          "Shift-Cmd-D": "duplicateLine",
          "F5": "sortLines",
          "Cmd-F5": "sortLinesInsensitive",
          "F2": "nextBookmark",
          "Shift-F2": "prevBookmark",
          "Cmd-F2": "toggleBookmark",
          "Shift-Cmd-F2": "clearBookmarks",
          "Alt-F2": "selectBookmarks",
          "Backspace": "smartBackspace",
          "Cmd-K Cmd-D": "skipAndSelectNextOccurrence",
          "Cmd-K Cmd-K": "delLineRight",
          "Cmd-K Cmd-U": "upcaseAtCursor",
          "Cmd-K Cmd-L": "downcaseAtCursor",
          "Cmd-K Cmd-Space": "setSublimeMark",
          "Cmd-K Cmd-A": "selectToSublimeMark",
          "Cmd-K Cmd-W": "deleteToSublimeMark",
          "Cmd-K Cmd-X": "swapWithSublimeMark",
          "Cmd-K Cmd-Y": "sublimeYank",
          "Cmd-K Cmd-C": "showInCenter",
          "Cmd-K Cmd-G": "clearBookmarks",
          "Cmd-K Cmd-Backspace": "delLineLeft",
          "Cmd-K Cmd-1": "foldAll",
          "Cmd-K Cmd-0": "unfoldAll",
          "Cmd-K Cmd-J": "unfoldAll",
          "Ctrl-Shift-Up": "addCursorToPrevLine",
          "Ctrl-Shift-Down": "addCursorToNextLine",
          "Cmd-F3": "findUnder",
          "Shift-Cmd-F3": "findUnderPrevious",
          "Alt-F3": "findAllUnder",
          "Shift-Cmd-[": "fold",
          "Shift-Cmd-]": "unfold",
          "Cmd-I": "findIncremental",
          "Shift-Cmd-I": "findIncrementalReverse",
          "Cmd-H": "replace",
          "F3": "findNext",
          "Shift-F3": "findPrev",
          "fallthrough": "macDefault"
        };
        CodeMirror5.normalizeKeyMap(keyMap.macSublime);
        keyMap.pcSublime = {
          "Shift-Tab": "indentLess",
          "Shift-Ctrl-K": "deleteLine",
          "Alt-Q": "wrapLines",
          "Ctrl-T": "transposeChars",
          "Alt-Left": "goSubwordLeft",
          "Alt-Right": "goSubwordRight",
          "Ctrl-Up": "scrollLineUp",
          "Ctrl-Down": "scrollLineDown",
          "Ctrl-L": "selectLine",
          "Shift-Ctrl-L": "splitSelectionByLine",
          "Esc": "singleSelectionTop",
          "Ctrl-Enter": "insertLineAfter",
          "Shift-Ctrl-Enter": "insertLineBefore",
          "Ctrl-D": "selectNextOccurrence",
          "Shift-Ctrl-Space": "selectScope",
          "Shift-Ctrl-M": "selectBetweenBrackets",
          "Ctrl-M": "goToBracket",
          "Shift-Ctrl-Up": "swapLineUp",
          "Shift-Ctrl-Down": "swapLineDown",
          "Ctrl-/": "toggleCommentIndented",
          "Ctrl-J": "joinLines",
          "Shift-Ctrl-D": "duplicateLine",
          "F9": "sortLines",
          "Ctrl-F9": "sortLinesInsensitive",
          "F2": "nextBookmark",
          "Shift-F2": "prevBookmark",
          "Ctrl-F2": "toggleBookmark",
          "Shift-Ctrl-F2": "clearBookmarks",
          "Alt-F2": "selectBookmarks",
          "Backspace": "smartBackspace",
          "Ctrl-K Ctrl-D": "skipAndSelectNextOccurrence",
          "Ctrl-K Ctrl-K": "delLineRight",
          "Ctrl-K Ctrl-U": "upcaseAtCursor",
          "Ctrl-K Ctrl-L": "downcaseAtCursor",
          "Ctrl-K Ctrl-Space": "setSublimeMark",
          "Ctrl-K Ctrl-A": "selectToSublimeMark",
          "Ctrl-K Ctrl-W": "deleteToSublimeMark",
          "Ctrl-K Ctrl-X": "swapWithSublimeMark",
          "Ctrl-K Ctrl-Y": "sublimeYank",
          "Ctrl-K Ctrl-C": "showInCenter",
          "Ctrl-K Ctrl-G": "clearBookmarks",
          "Ctrl-K Ctrl-Backspace": "delLineLeft",
          "Ctrl-K Ctrl-1": "foldAll",
          "Ctrl-K Ctrl-0": "unfoldAll",
          "Ctrl-K Ctrl-J": "unfoldAll",
          "Ctrl-Alt-Up": "addCursorToPrevLine",
          "Ctrl-Alt-Down": "addCursorToNextLine",
          "Ctrl-F3": "findUnder",
          "Shift-Ctrl-F3": "findUnderPrevious",
          "Alt-F3": "findAllUnder",
          "Shift-Ctrl-[": "fold",
          "Shift-Ctrl-]": "unfold",
          "Ctrl-I": "findIncremental",
          "Shift-Ctrl-I": "findIncrementalReverse",
          "Ctrl-H": "replace",
          "F3": "findNext",
          "Shift-F3": "findPrev",
          "fallthrough": "pcDefault"
        };
        CodeMirror5.normalizeKeyMap(keyMap.pcSublime);
        var mac = keyMap.default == keyMap.macDefault;
        keyMap.sublime = mac ? keyMap.macSublime : keyMap.pcSublime;
      });
    }
  });

  // node_modules/paralleljs/lib/parallel.js
  var require_parallel = __commonJS({
    "node_modules/paralleljs/lib/parallel.js"(exports, module) {
      (function() {
        const isCommonJS = typeof module !== "undefined" && module.exports;
        const isNode2 = !(typeof window !== "undefined" && this === window);
        var setImmediate = setImmediate || function(cb) {
          setTimeout(cb, 0);
        };
        const Worker = isNode2 ? __require(`${__dirname}/Worker.js`) : self.Worker;
        const URL = typeof self !== "undefined" ? self.URL ? self.URL : self.webkitURL : null;
        const _supports = !!(isNode2 || self.Worker);
        function extend2(from, to) {
          if (!to)
            to = {};
          for (const i3 in from) {
            if (to[i3] === void 0)
              to[i3] = from[i3];
          }
          return to;
        }
        function Operation() {
          this._callbacks = [];
          this._errCallbacks = [];
          this._resolved = 0;
          this._result = null;
        }
        Operation.prototype.resolve = function(err, res) {
          if (!err) {
            this._resolved = 1;
            this._result = res;
            for (let i3 = 0; i3 < this._callbacks.length; ++i3) {
              this._callbacks[i3](res);
            }
          } else {
            this._resolved = 2;
            this._result = err;
            for (let iE = 0; iE < this._errCallbacks.length; ++iE) {
              this._errCallbacks[iE](err);
            }
          }
          this._callbacks = [];
          this._errCallbacks = [];
        };
        Operation.prototype.then = function(cb, errCb) {
          if (this._resolved === 1) {
            if (cb) {
              cb(this._result);
            }
            return;
          }
          if (this._resolved === 2) {
            if (errCb) {
              errCb(this._result);
            }
            return;
          }
          if (cb) {
            this._callbacks[this._callbacks.length] = cb;
          }
          if (errCb) {
            this._errCallbacks[this._errCallbacks.length] = errCb;
          }
          return this;
        };
        const defaults = {
          evalPath: isNode2 ? `${__dirname}/eval.js` : null,
          maxWorkers: isNode2 ? __require("os").cpus().length : navigator.hardwareConcurrency || 4,
          synchronous: true,
          env: {},
          envNamespace: "env"
        };
        function Parallel2(data, options) {
          this.data = data;
          this.options = extend2(defaults, options);
          this.operation = new Operation();
          this.operation.resolve(null, this.data);
          this.requiredScripts = [];
          this.requiredFunctions = [];
        }
        Parallel2.isSupported = function() {
          return _supports;
        };
        Parallel2.prototype.getWorkerSource = function(cb, env) {
          const that = this;
          let preStr = "";
          let i3 = 0;
          if (!isNode2 && this.requiredScripts.length !== 0) {
            preStr += `importScripts("${this.requiredScripts.join('","')}");\r
`;
          }
          for (i3 = 0; i3 < this.requiredFunctions.length; ++i3) {
            if (this.requiredFunctions[i3].name) {
              preStr += `var ${this.requiredFunctions[i3].name} = ${this.requiredFunctions[i3].fn.toString()};`;
            } else {
              preStr += this.requiredFunctions[i3].fn.toString();
            }
          }
          env = JSON.stringify(env || {});
          const ns = this.options.envNamespace;
          if (isNode2) {
            return `${preStr}process.on("message", function(e) {global.${ns} = ${env};process.send(JSON.stringify((${cb.toString()})(JSON.parse(e).data)))})`;
          }
          return `${preStr}self.onmessage = function(e) {var global = {}; global.${ns} = ${env};self.postMessage((${cb.toString()})(e.data))}`;
        };
        Parallel2.prototype.require = function() {
          const args = Array.prototype.slice.call(arguments, 0);
          let func;
          for (let i3 = 0; i3 < args.length; i3++) {
            func = args[i3];
            if (typeof func === "string") {
              this.requiredScripts.push(func);
            } else if (typeof func === "function") {
              this.requiredFunctions.push({ fn: func });
            } else if (typeof func === "object") {
              this.requiredFunctions.push(func);
            }
          }
          return this;
        };
        Parallel2.prototype._spawnWorker = function(cb, env) {
          let wrk;
          const src = this.getWorkerSource(cb, env);
          if (isNode2) {
            wrk = new Worker(this.options.evalPath);
            wrk.postMessage(src);
          } else {
            if (Worker === void 0) {
              return void 0;
            }
            try {
              if (this.requiredScripts.length !== 0) {
                if (this.options.evalPath !== null) {
                  wrk = new Worker(this.options.evalPath);
                  wrk.postMessage(src);
                } else {
                  throw new Error("Can't use required scripts without eval.js!");
                }
              } else if (!URL) {
                throw new Error("Can't create a blob URL in this browser!");
              } else {
                const blob = new Blob([src], { type: "text/javascript" });
                const url = URL.createObjectURL(blob);
                wrk = new Worker(url);
              }
            } catch (e5) {
              if (this.options.evalPath !== null) {
                wrk = new Worker(this.options.evalPath);
                wrk.postMessage(src);
              } else {
                throw e5;
              }
            }
          }
          return wrk;
        };
        Parallel2.prototype.spawn = function(cb, env) {
          const that = this;
          const newOp = new Operation();
          let timeout;
          env = extend2(this.options.env, env || {});
          this.operation.then(() => {
            if (env.timeout) {
              timeout = setTimeout(function() {
                if (!newOp.resolved) {
                  wrk.terminate();
                  newOp.resolve(new Error("Operation timed out!"), null);
                }
              }, env.timeout);
            }
            const wrk = that._spawnWorker(cb, env);
            if (wrk !== void 0) {
              wrk.onmessage = function(msg) {
                if (timeout)
                  clearTimeout(timeout);
                wrk.terminate();
                that.data = msg.data;
                newOp.resolve(null, that.data);
              };
              wrk.onerror = function(e5) {
                if (timeout)
                  clearTimeout(timeout);
                wrk.terminate();
                newOp.resolve(e5, null);
              };
              wrk.postMessage(that.data);
            } else if (that.options.synchronous) {
              setImmediate(() => {
                try {
                  that.data = cb(that.data);
                  newOp.resolve(null, that.data);
                } catch (e5) {
                  newOp.resolve(e5, null);
                }
              });
            } else {
              throw new Error("Workers do not exist and synchronous operation not allowed!");
            }
          });
          this.operation = newOp;
          return this;
        };
        Parallel2.prototype._spawnMapWorker = function(i3, cb, done, env, wrk) {
          const that = this;
          if (!wrk)
            wrk = that._spawnWorker(cb, env);
          if (wrk !== void 0) {
            wrk.onmessage = function(msg) {
              that.data[i3] = msg.data;
              done(null, wrk);
            };
            wrk.onerror = function(e5) {
              wrk.terminate();
              done(e5);
            };
            wrk.postMessage(that.data[i3]);
          } else if (that.options.synchronous) {
            setImmediate(() => {
              that.data[i3] = cb(that.data[i3]);
              done();
            });
          } else {
            throw new Error("Workers do not exist and synchronous operation not allowed!");
          }
        };
        Parallel2.prototype.map = function(cb, env) {
          env = extend2(this.options.env, env || {});
          if (!this.data.length) {
            return this.spawn(cb, env);
          }
          const that = this;
          let startedOps = 0;
          let doneOps = 0;
          function done(err, wrk) {
            if (err) {
              newOp.resolve(err, null);
            } else if (++doneOps === that.data.length) {
              newOp.resolve(null, that.data);
              if (wrk)
                wrk.terminate();
            } else if (startedOps < that.data.length) {
              that._spawnMapWorker(startedOps++, cb, done, env, wrk);
            } else if (wrk)
              wrk.terminate();
          }
          var newOp = new Operation();
          this.operation.then(() => {
            for (; startedOps - doneOps < that.options.maxWorkers && startedOps < that.data.length; ++startedOps) {
              that._spawnMapWorker(startedOps, cb, done, env);
            }
          }, (err) => {
            newOp.resolve(err, null);
          });
          this.operation = newOp;
          return this;
        };
        Parallel2.prototype._spawnReduceWorker = function(data, cb, done, env, wrk) {
          const that = this;
          if (!wrk)
            wrk = that._spawnWorker(cb, env);
          if (wrk !== void 0) {
            wrk.onmessage = function(msg) {
              that.data[that.data.length] = msg.data;
              done(null, wrk);
            };
            wrk.onerror = function(e5) {
              wrk.terminate();
              done(e5, null);
            };
            wrk.postMessage(data);
          } else if (that.options.synchronous) {
            setImmediate(() => {
              that.data[that.data.length] = cb(data);
              done();
            });
          } else {
            throw new Error("Workers do not exist and synchronous operation not allowed!");
          }
        };
        Parallel2.prototype.reduce = function(cb, env) {
          env = extend2(this.options.env, env || {});
          if (!this.data.length) {
            throw new Error("Can't reduce non-array data");
          }
          let runningWorkers = 0;
          const that = this;
          function done(err, wrk) {
            --runningWorkers;
            if (err) {
              newOp.resolve(err, null);
            } else if (that.data.length === 1 && runningWorkers === 0) {
              that.data = that.data[0];
              newOp.resolve(null, that.data);
              if (wrk)
                wrk.terminate();
            } else if (that.data.length > 1) {
              ++runningWorkers;
              that._spawnReduceWorker([that.data[0], that.data[1]], cb, done, env, wrk);
              that.data.splice(0, 2);
            } else if (wrk)
              wrk.terminate();
          }
          var newOp = new Operation();
          this.operation.then(() => {
            if (that.data.length === 1) {
              newOp.resolve(null, that.data[0]);
            } else {
              for (var i3 = 0; i3 < that.options.maxWorkers && i3 < Math.floor(that.data.length / 2); ++i3) {
                ++runningWorkers;
                that._spawnReduceWorker([that.data[i3 * 2], that.data[i3 * 2 + 1]], cb, done, env);
              }
              that.data.splice(0, i3 * 2);
            }
          });
          this.operation = newOp;
          return this;
        };
        Parallel2.prototype.then = function(cb, errCb) {
          const that = this;
          const newOp = new Operation();
          errCb = typeof errCb === "function" ? errCb : function() {
          };
          this.operation.then(() => {
            let retData;
            try {
              if (cb) {
                retData = cb(that.data);
                if (retData !== void 0) {
                  that.data = retData;
                }
              }
              newOp.resolve(null, that.data);
            } catch (e5) {
              if (errCb) {
                retData = errCb(e5);
                if (retData !== void 0) {
                  that.data = retData;
                }
                newOp.resolve(null, that.data);
              } else {
                newOp.resolve(null, e5);
              }
            }
          }, (err) => {
            if (errCb) {
              const retData = errCb(err);
              if (retData !== void 0) {
                that.data = retData;
              }
              newOp.resolve(null, that.data);
            } else {
              newOp.resolve(null, err);
            }
          });
          this.operation = newOp;
          return this;
        };
        if (isCommonJS) {
          module.exports = Parallel2;
        } else {
          self.Parallel = Parallel2;
        }
      })();
    }
  });

  // node_modules/mathjs/es/core/config.js
  var DEFAULT_CONFIG;
  var init_config = __esm({
    "node_modules/mathjs/es/core/config.js"() {
      DEFAULT_CONFIG = {
        epsilon: 1e-12,
        matrix: "Matrix",
        number: "number",
        precision: 64,
        predictable: false,
        randomSeed: null
      };
    }
  });

  // node_modules/mathjs/es/utils/is.js
  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof(obj);
  }
  function isNumber(x3) {
    return typeof x3 === "number";
  }
  function isBigNumber(x3) {
    return x3 && x3.constructor.prototype.isBigNumber === true || false;
  }
  function isComplex(x3) {
    return x3 && _typeof(x3) === "object" && Object.getPrototypeOf(x3).isComplex === true || false;
  }
  function isFraction(x3) {
    return x3 && _typeof(x3) === "object" && Object.getPrototypeOf(x3).isFraction === true || false;
  }
  function isUnit(x3) {
    return x3 && x3.constructor.prototype.isUnit === true || false;
  }
  function isString(x3) {
    return typeof x3 === "string";
  }
  function isMatrix(x3) {
    return x3 && x3.constructor.prototype.isMatrix === true || false;
  }
  function isCollection(x3) {
    return Array.isArray(x3) || isMatrix(x3);
  }
  function isDenseMatrix(x3) {
    return x3 && x3.isDenseMatrix && x3.constructor.prototype.isMatrix === true || false;
  }
  function isSparseMatrix(x3) {
    return x3 && x3.isSparseMatrix && x3.constructor.prototype.isMatrix === true || false;
  }
  function isRange(x3) {
    return x3 && x3.constructor.prototype.isRange === true || false;
  }
  function isIndex(x3) {
    return x3 && x3.constructor.prototype.isIndex === true || false;
  }
  function isBoolean(x3) {
    return typeof x3 === "boolean";
  }
  function isResultSet(x3) {
    return x3 && x3.constructor.prototype.isResultSet === true || false;
  }
  function isHelp(x3) {
    return x3 && x3.constructor.prototype.isHelp === true || false;
  }
  function isFunction(x3) {
    return typeof x3 === "function";
  }
  function isDate(x3) {
    return x3 instanceof Date;
  }
  function isRegExp(x3) {
    return x3 instanceof RegExp;
  }
  function isObject(x3) {
    return !!(x3 && _typeof(x3) === "object" && x3.constructor === Object && !isComplex(x3) && !isFraction(x3));
  }
  function isNull(x3) {
    return x3 === null;
  }
  function isUndefined(x3) {
    return x3 === void 0;
  }
  function isAccessorNode(x3) {
    return x3 && x3.isAccessorNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isArrayNode(x3) {
    return x3 && x3.isArrayNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isAssignmentNode(x3) {
    return x3 && x3.isAssignmentNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isBlockNode(x3) {
    return x3 && x3.isBlockNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isConditionalNode(x3) {
    return x3 && x3.isConditionalNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isConstantNode(x3) {
    return x3 && x3.isConstantNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isFunctionAssignmentNode(x3) {
    return x3 && x3.isFunctionAssignmentNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isFunctionNode(x3) {
    return x3 && x3.isFunctionNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isIndexNode(x3) {
    return x3 && x3.isIndexNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isNode(x3) {
    return x3 && x3.isNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isObjectNode(x3) {
    return x3 && x3.isObjectNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isOperatorNode(x3) {
    return x3 && x3.isOperatorNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isParenthesisNode(x3) {
    return x3 && x3.isParenthesisNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isRangeNode(x3) {
    return x3 && x3.isRangeNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isSymbolNode(x3) {
    return x3 && x3.isSymbolNode === true && x3.constructor.prototype.isNode === true || false;
  }
  function isChain(x3) {
    return x3 && x3.constructor.prototype.isChain === true || false;
  }
  function typeOf(x3) {
    var t3 = _typeof(x3);
    if (t3 === "object") {
      if (x3 === null)
        return "null";
      if (Array.isArray(x3))
        return "Array";
      if (x3 instanceof Date)
        return "Date";
      if (x3 instanceof RegExp)
        return "RegExp";
      if (isBigNumber(x3))
        return "BigNumber";
      if (isComplex(x3))
        return "Complex";
      if (isFraction(x3))
        return "Fraction";
      if (isMatrix(x3))
        return "Matrix";
      if (isUnit(x3))
        return "Unit";
      if (isIndex(x3))
        return "Index";
      if (isRange(x3))
        return "Range";
      if (isResultSet(x3))
        return "ResultSet";
      if (isNode(x3))
        return x3.type;
      if (isChain(x3))
        return "Chain";
      if (isHelp(x3))
        return "Help";
      return "Object";
    }
    if (t3 === "function")
      return "Function";
    return t3;
  }
  var isArray;
  var init_is = __esm({
    "node_modules/mathjs/es/utils/is.js"() {
      isArray = Array.isArray;
    }
  });

  // node_modules/mathjs/es/utils/object.js
  function _typeof2(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof2 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof2 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof2(obj);
  }
  function clone(x3) {
    var type = _typeof2(x3);
    if (type === "number" || type === "string" || type === "boolean" || x3 === null || x3 === void 0) {
      return x3;
    }
    if (typeof x3.clone === "function") {
      return x3.clone();
    }
    if (Array.isArray(x3)) {
      return x3.map(function(value) {
        return clone(value);
      });
    }
    if (x3 instanceof Date)
      return new Date(x3.valueOf());
    if (isBigNumber(x3))
      return x3;
    if (x3 instanceof RegExp)
      throw new TypeError("Cannot clone " + x3);
    return mapObject(x3, clone);
  }
  function mapObject(object, callback) {
    var clone3 = {};
    for (var key in object) {
      if (hasOwnProperty2(object, key)) {
        clone3[key] = callback(object[key]);
      }
    }
    return clone3;
  }
  function extend(a3, b2) {
    for (var prop in b2) {
      if (hasOwnProperty2(b2, prop)) {
        a3[prop] = b2[prop];
      }
    }
    return a3;
  }
  function deepExtend(a3, b2) {
    if (Array.isArray(b2)) {
      throw new TypeError("Arrays are not supported by deepExtend");
    }
    for (var prop in b2) {
      if (hasOwnProperty2(b2, prop) && !(prop in Object.prototype) && !(prop in Function.prototype)) {
        if (b2[prop] && b2[prop].constructor === Object) {
          if (a3[prop] === void 0) {
            a3[prop] = {};
          }
          if (a3[prop] && a3[prop].constructor === Object) {
            deepExtend(a3[prop], b2[prop]);
          } else {
            a3[prop] = b2[prop];
          }
        } else if (Array.isArray(b2[prop])) {
          throw new TypeError("Arrays are not supported by deepExtend");
        } else {
          a3[prop] = b2[prop];
        }
      }
    }
    return a3;
  }
  function deepStrictEqual(a3, b2) {
    var prop, i3, len;
    if (Array.isArray(a3)) {
      if (!Array.isArray(b2)) {
        return false;
      }
      if (a3.length !== b2.length) {
        return false;
      }
      for (i3 = 0, len = a3.length; i3 < len; i3++) {
        if (!deepStrictEqual(a3[i3], b2[i3])) {
          return false;
        }
      }
      return true;
    } else if (typeof a3 === "function") {
      return a3 === b2;
    } else if (a3 instanceof Object) {
      if (Array.isArray(b2) || !(b2 instanceof Object)) {
        return false;
      }
      for (prop in a3) {
        if (!(prop in b2) || !deepStrictEqual(a3[prop], b2[prop])) {
          return false;
        }
      }
      for (prop in b2) {
        if (!(prop in a3) || !deepStrictEqual(a3[prop], b2[prop])) {
          return false;
        }
      }
      return true;
    } else {
      return a3 === b2;
    }
  }
  function deepFlatten(nestedObject) {
    var flattenedObject = {};
    _deepFlatten(nestedObject, flattenedObject);
    return flattenedObject;
  }
  function _deepFlatten(nestedObject, flattenedObject) {
    for (var prop in nestedObject) {
      if (hasOwnProperty2(nestedObject, prop)) {
        var value = nestedObject[prop];
        if (_typeof2(value) === "object" && value !== null) {
          _deepFlatten(value, flattenedObject);
        } else {
          flattenedObject[prop] = value;
        }
      }
    }
  }
  function lazy(object, prop, valueResolver) {
    var _uninitialized = true;
    var _value;
    Object.defineProperty(object, prop, {
      get: function get() {
        if (_uninitialized) {
          _value = valueResolver();
          _uninitialized = false;
        }
        return _value;
      },
      set: function set(value) {
        _value = value;
        _uninitialized = false;
      },
      configurable: true,
      enumerable: true
    });
  }
  function hasOwnProperty2(object, property) {
    return object && Object.hasOwnProperty.call(object, property);
  }
  function isLegacyFactory(object) {
    return object && typeof object.factory === "function";
  }
  function pickShallow(object, properties2) {
    var copy2 = {};
    for (var i3 = 0; i3 < properties2.length; i3++) {
      var key = properties2[i3];
      var value = object[key];
      if (value !== void 0) {
        copy2[key] = value;
      }
    }
    return copy2;
  }
  function values(object) {
    return Object.keys(object).map(function(key) {
      return object[key];
    });
  }
  var init_object = __esm({
    "node_modules/mathjs/es/utils/object.js"() {
      init_is();
    }
  });

  // node_modules/mathjs/es/core/function/config.js
  function configFactory(config3, emit) {
    function _config(options) {
      if (options) {
        var prev = mapObject(config3, clone);
        validateOption(options, "matrix", MATRIX_OPTIONS);
        validateOption(options, "number", NUMBER_OPTIONS);
        deepExtend(config3, options);
        var curr = mapObject(config3, clone);
        var changes = mapObject(options, clone);
        emit("config", curr, prev, changes);
        return curr;
      } else {
        return mapObject(config3, clone);
      }
    }
    _config.MATRIX_OPTIONS = MATRIX_OPTIONS;
    _config.NUMBER_OPTIONS = NUMBER_OPTIONS;
    Object.keys(DEFAULT_CONFIG).forEach(function(key) {
      Object.defineProperty(_config, key, {
        get: function get() {
          return config3[key];
        },
        enumerable: true,
        configurable: true
      });
    });
    return _config;
  }
  function contains(array, item) {
    return array.indexOf(item) !== -1;
  }
  function validateOption(options, name106, values2) {
    if (options[name106] !== void 0 && !contains(values2, options[name106])) {
      console.warn('Warning: Unknown value "' + options[name106] + '" for configuration option "' + name106 + '". Available options: ' + values2.map(function(value) {
        return JSON.stringify(value);
      }).join(", ") + ".");
    }
  }
  var MATRIX_OPTIONS, NUMBER_OPTIONS;
  var init_config2 = __esm({
    "node_modules/mathjs/es/core/function/config.js"() {
      init_object();
      init_config();
      MATRIX_OPTIONS = ["Matrix", "Array"];
      NUMBER_OPTIONS = ["number", "BigNumber", "Fraction"];
    }
  });

  // node_modules/mathjs/es/entry/configReadonly.js
  function _extends() {
    _extends = Object.assign || function(target) {
      for (var i3 = 1; i3 < arguments.length; i3++) {
        var source = arguments[i3];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends.apply(this, arguments);
  }
  var config;
  var init_configReadonly = __esm({
    "node_modules/mathjs/es/entry/configReadonly.js"() {
      init_config();
      init_config2();
      config = function config2(options) {
        if (options) {
          throw new Error("The global config is readonly. \nPlease create a mathjs instance if you want to change the default configuration. \nExample:\n\n  import { create, all } from 'mathjs';\n  const mathjs = create(all);\n  mathjs.config({ number: 'BigNumber' });\n");
        }
        return Object.freeze(DEFAULT_CONFIG);
      };
      _extends(config, DEFAULT_CONFIG, {
        MATRIX_OPTIONS,
        NUMBER_OPTIONS
      });
    }
  });

  // node_modules/mathjs/es/utils/number.js
  function isInteger(value) {
    if (typeof value === "boolean") {
      return true;
    }
    return isFinite(value) ? value === Math.round(value) : false;
  }
  function format(value, options) {
    if (typeof options === "function") {
      return options(value);
    }
    if (value === Infinity) {
      return "Infinity";
    } else if (value === -Infinity) {
      return "-Infinity";
    } else if (isNaN(value)) {
      return "NaN";
    }
    var notation = "auto";
    var precision;
    if (options) {
      if (options.notation) {
        notation = options.notation;
      }
      if (isNumber(options)) {
        precision = options;
      } else if (isNumber(options.precision)) {
        precision = options.precision;
      }
    }
    switch (notation) {
      case "fixed":
        return toFixed(value, precision);
      case "exponential":
        return toExponential(value, precision);
      case "engineering":
        return toEngineering(value, precision);
      case "auto":
        return toPrecision(value, precision, options && options).replace(/((\.\d*?)(0+))($|e)/, function() {
          var digits2 = arguments[2];
          var e5 = arguments[4];
          return digits2 !== "." ? digits2 + e5 : e5;
        });
      default:
        throw new Error('Unknown notation "' + notation + '". Choose "auto", "exponential", or "fixed".');
    }
  }
  function splitNumber(value) {
    var match = String(value).toLowerCase().match(/^0*?(-?)(\d+\.?\d*)(e([+-]?\d+))?$/);
    if (!match) {
      throw new SyntaxError("Invalid number " + value);
    }
    var sign3 = match[1];
    var digits2 = match[2];
    var exponent = parseFloat(match[4] || "0");
    var dot = digits2.indexOf(".");
    exponent += dot !== -1 ? dot - 1 : digits2.length - 1;
    var coefficients = digits2.replace(".", "").replace(/^0*/, function(zeros2) {
      exponent -= zeros2.length;
      return "";
    }).replace(/0*$/, "").split("").map(function(d4) {
      return parseInt(d4);
    });
    if (coefficients.length === 0) {
      coefficients.push(0);
      exponent++;
    }
    return {
      sign: sign3,
      coefficients,
      exponent
    };
  }
  function toEngineering(value, precision) {
    if (isNaN(value) || !isFinite(value)) {
      return String(value);
    }
    var split = splitNumber(value);
    var rounded = roundDigits(split, precision);
    var e5 = rounded.exponent;
    var c3 = rounded.coefficients;
    var newExp = e5 % 3 === 0 ? e5 : e5 < 0 ? e5 - 3 - e5 % 3 : e5 - e5 % 3;
    if (isNumber(precision)) {
      while (precision > c3.length || e5 - newExp + 1 > c3.length) {
        c3.push(0);
      }
    } else {
      var missingZeros = Math.abs(e5 - newExp) - (c3.length - 1);
      for (var i3 = 0; i3 < missingZeros; i3++) {
        c3.push(0);
      }
    }
    var expDiff = Math.abs(e5 - newExp);
    var decimalIdx = 1;
    while (expDiff > 0) {
      decimalIdx++;
      expDiff--;
    }
    var decimals = c3.slice(decimalIdx).join("");
    var decimalVal = isNumber(precision) && decimals.length || decimals.match(/[1-9]/) ? "." + decimals : "";
    var str = c3.slice(0, decimalIdx).join("") + decimalVal + "e" + (e5 >= 0 ? "+" : "") + newExp.toString();
    return rounded.sign + str;
  }
  function toFixed(value, precision) {
    if (isNaN(value) || !isFinite(value)) {
      return String(value);
    }
    var splitValue = splitNumber(value);
    var rounded = typeof precision === "number" ? roundDigits(splitValue, splitValue.exponent + 1 + precision) : splitValue;
    var c3 = rounded.coefficients;
    var p3 = rounded.exponent + 1;
    var pp = p3 + (precision || 0);
    if (c3.length < pp) {
      c3 = c3.concat(zeros(pp - c3.length));
    }
    if (p3 < 0) {
      c3 = zeros(-p3 + 1).concat(c3);
      p3 = 1;
    }
    if (p3 < c3.length) {
      c3.splice(p3, 0, p3 === 0 ? "0." : ".");
    }
    return rounded.sign + c3.join("");
  }
  function toExponential(value, precision) {
    if (isNaN(value) || !isFinite(value)) {
      return String(value);
    }
    var split = splitNumber(value);
    var rounded = precision ? roundDigits(split, precision) : split;
    var c3 = rounded.coefficients;
    var e5 = rounded.exponent;
    if (c3.length < precision) {
      c3 = c3.concat(zeros(precision - c3.length));
    }
    var first = c3.shift();
    return rounded.sign + first + (c3.length > 0 ? "." + c3.join("") : "") + "e" + (e5 >= 0 ? "+" : "") + e5;
  }
  function toPrecision(value, precision, options) {
    if (isNaN(value) || !isFinite(value)) {
      return String(value);
    }
    var lowerExp = options && options.lowerExp !== void 0 ? options.lowerExp : -3;
    var upperExp = options && options.upperExp !== void 0 ? options.upperExp : 5;
    var split = splitNumber(value);
    var rounded = precision ? roundDigits(split, precision) : split;
    if (rounded.exponent < lowerExp || rounded.exponent >= upperExp) {
      return toExponential(value, precision);
    } else {
      var c3 = rounded.coefficients;
      var e5 = rounded.exponent;
      if (c3.length < precision) {
        c3 = c3.concat(zeros(precision - c3.length));
      }
      c3 = c3.concat(zeros(e5 - c3.length + 1 + (c3.length < precision ? precision - c3.length : 0)));
      c3 = zeros(-e5).concat(c3);
      var dot = e5 > 0 ? e5 : 0;
      if (dot < c3.length - 1) {
        c3.splice(dot + 1, 0, ".");
      }
      return rounded.sign + c3.join("");
    }
  }
  function roundDigits(split, precision) {
    var rounded = {
      sign: split.sign,
      coefficients: split.coefficients,
      exponent: split.exponent
    };
    var c3 = rounded.coefficients;
    while (precision <= 0) {
      c3.unshift(0);
      rounded.exponent++;
      precision++;
    }
    if (c3.length > precision) {
      var removed = c3.splice(precision, c3.length - precision);
      if (removed[0] >= 5) {
        var i3 = precision - 1;
        c3[i3]++;
        while (c3[i3] === 10) {
          c3.pop();
          if (i3 === 0) {
            c3.unshift(0);
            rounded.exponent++;
            i3++;
          }
          i3--;
          c3[i3]++;
        }
      }
    }
    return rounded;
  }
  function zeros(length) {
    var arr = [];
    for (var i3 = 0; i3 < length; i3++) {
      arr.push(0);
    }
    return arr;
  }
  function digits(value) {
    return value.toExponential().replace(/e.*$/, "").replace(/^0\.?0*|\./, "").length;
  }
  function nearlyEqual(x3, y2, epsilon) {
    if (epsilon === null || epsilon === void 0) {
      return x3 === y2;
    }
    if (x3 === y2) {
      return true;
    }
    if (isNaN(x3) || isNaN(y2)) {
      return false;
    }
    if (isFinite(x3) && isFinite(y2)) {
      var diff = Math.abs(x3 - y2);
      if (diff < DBL_EPSILON) {
        return true;
      } else {
        return diff <= Math.max(Math.abs(x3), Math.abs(y2)) * epsilon;
      }
    }
    return false;
  }
  var sign, log2, log10, log1p, cbrt, expm1, DBL_EPSILON, acosh, asinh, atanh, cosh, sinh, tanh;
  var init_number = __esm({
    "node_modules/mathjs/es/utils/number.js"() {
      init_is();
      sign = Math.sign || function(x3) {
        if (x3 > 0) {
          return 1;
        } else if (x3 < 0) {
          return -1;
        } else {
          return 0;
        }
      };
      log2 = Math.log2 || function log22(x3) {
        return Math.log(x3) / Math.LN2;
      };
      log10 = Math.log10 || function log102(x3) {
        return Math.log(x3) / Math.LN10;
      };
      log1p = Math.log1p || function(x3) {
        return Math.log(x3 + 1);
      };
      cbrt = Math.cbrt || function cbrt2(x3) {
        if (x3 === 0) {
          return x3;
        }
        var negate = x3 < 0;
        var result;
        if (negate) {
          x3 = -x3;
        }
        if (isFinite(x3)) {
          result = Math.exp(Math.log(x3) / 3);
          result = (x3 / (result * result) + 2 * result) / 3;
        } else {
          result = x3;
        }
        return negate ? -result : result;
      };
      expm1 = Math.expm1 || function expm12(x3) {
        return x3 >= 2e-4 || x3 <= -2e-4 ? Math.exp(x3) - 1 : x3 + x3 * x3 / 2 + x3 * x3 * x3 / 6;
      };
      DBL_EPSILON = Number.EPSILON || 2220446049250313e-31;
      acosh = Math.acosh || function(x3) {
        return Math.log(Math.sqrt(x3 * x3 - 1) + x3);
      };
      asinh = Math.asinh || function(x3) {
        return Math.log(Math.sqrt(x3 * x3 + 1) + x3);
      };
      atanh = Math.atanh || function(x3) {
        return Math.log((1 + x3) / (1 - x3)) / 2;
      };
      cosh = Math.cosh || function(x3) {
        return (Math.exp(x3) + Math.exp(-x3)) / 2;
      };
      sinh = Math.sinh || function(x3) {
        return (Math.exp(x3) - Math.exp(-x3)) / 2;
      };
      tanh = Math.tanh || function(x3) {
        var e5 = Math.exp(2 * x3);
        return (e5 - 1) / (e5 + 1);
      };
    }
  });

  // node_modules/mathjs/es/plain/number/arithmetic.js
  function absNumber(a3) {
    return Math.abs(a3);
  }
  function addNumber(a3, b2) {
    return a3 + b2;
  }
  function subtractNumber(a3, b2) {
    return a3 - b2;
  }
  function multiplyNumber(a3, b2) {
    return a3 * b2;
  }
  function divideNumber(a3, b2) {
    return a3 / b2;
  }
  function unaryMinusNumber(x3) {
    return -x3;
  }
  function unaryPlusNumber(x3) {
    return x3;
  }
  function cbrtNumber(x3) {
    return cbrt(x3);
  }
  function ceilNumber(x3) {
    return Math.ceil(x3);
  }
  function cubeNumber(x3) {
    return x3 * x3 * x3;
  }
  function expNumber(x3) {
    return Math.exp(x3);
  }
  function expm1Number(x3) {
    return expm1(x3);
  }
  function fixNumber(x3) {
    return x3 > 0 ? Math.floor(x3) : Math.ceil(x3);
  }
  function floorNumber(x3) {
    return Math.floor(x3);
  }
  function gcdNumber(a3, b2) {
    if (!isInteger(a3) || !isInteger(b2)) {
      throw new Error("Parameters in function gcd must be integer numbers");
    }
    var r3;
    while (b2 !== 0) {
      r3 = a3 % b2;
      a3 = b2;
      b2 = r3;
    }
    return a3 < 0 ? -a3 : a3;
  }
  function lcmNumber(a3, b2) {
    if (!isInteger(a3) || !isInteger(b2)) {
      throw new Error("Parameters in function lcm must be integer numbers");
    }
    if (a3 === 0 || b2 === 0) {
      return 0;
    }
    var t3;
    var prod2 = a3 * b2;
    while (b2 !== 0) {
      t3 = b2;
      b2 = a3 % t3;
      a3 = t3;
    }
    return Math.abs(prod2 / a3);
  }
  function logNumber(x3) {
    return Math.log(x3);
  }
  function log10Number(x3) {
    return log10(x3);
  }
  function log2Number(x3) {
    return log2(x3);
  }
  function log1pNumber(x3) {
    return log1p(x3);
  }
  function modNumber(x3, y2) {
    if (y2 > 0) {
      return x3 - y2 * Math.floor(x3 / y2);
    } else if (y2 === 0) {
      return x3;
    } else {
      throw new Error("Cannot calculate mod for a negative divisor");
    }
  }
  function nthRootNumber(a3, root) {
    var inv = root < 0;
    if (inv) {
      root = -root;
    }
    if (root === 0) {
      throw new Error("Root must be non-zero");
    }
    if (a3 < 0 && Math.abs(root) % 2 !== 1) {
      throw new Error("Root must be odd when a is negative.");
    }
    if (a3 === 0) {
      return inv ? Infinity : 0;
    }
    if (!isFinite(a3)) {
      return inv ? 0 : a3;
    }
    var x3 = Math.pow(Math.abs(a3), 1 / root);
    x3 = a3 < 0 ? -x3 : x3;
    return inv ? 1 / x3 : x3;
  }
  function signNumber(x3) {
    return sign(x3);
  }
  function sqrtNumber(x3) {
    return Math.sqrt(x3);
  }
  function squareNumber(x3) {
    return x3 * x3;
  }
  function xgcdNumber(a3, b2) {
    var t3;
    var q;
    var r3;
    var x3 = 0;
    var lastx = 1;
    var y2 = 1;
    var lasty = 0;
    if (!isInteger(a3) || !isInteger(b2)) {
      throw new Error("Parameters in function xgcd must be integer numbers");
    }
    while (b2) {
      q = Math.floor(a3 / b2);
      r3 = a3 - q * b2;
      t3 = x3;
      x3 = lastx - q * x3;
      lastx = t3;
      t3 = y2;
      y2 = lasty - q * y2;
      lasty = t3;
      a3 = b2;
      b2 = r3;
    }
    var res;
    if (a3 < 0) {
      res = [-a3, -lastx, -lasty];
    } else {
      res = [a3, a3 ? lastx : 0, lasty];
    }
    return res;
  }
  function powNumber(x3, y2) {
    if (x3 * x3 < 1 && y2 === Infinity || x3 * x3 > 1 && y2 === -Infinity) {
      return 0;
    }
    return Math.pow(x3, y2);
  }
  function roundNumber(value) {
    var decimals = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 0;
    return parseFloat(toFixed(value, decimals));
  }
  function normNumber(x3) {
    return Math.abs(x3);
  }
  var n1, n2;
  var init_arithmetic = __esm({
    "node_modules/mathjs/es/plain/number/arithmetic.js"() {
      init_number();
      n1 = "number";
      n2 = "number, number";
      absNumber.signature = n1;
      addNumber.signature = n2;
      subtractNumber.signature = n2;
      multiplyNumber.signature = n2;
      divideNumber.signature = n2;
      unaryMinusNumber.signature = n1;
      unaryPlusNumber.signature = n1;
      cbrtNumber.signature = n1;
      ceilNumber.signature = n1;
      cubeNumber.signature = n1;
      expNumber.signature = n1;
      expm1Number.signature = n1;
      fixNumber.signature = n1;
      floorNumber.signature = n1;
      gcdNumber.signature = n2;
      lcmNumber.signature = n2;
      logNumber.signature = n1;
      log10Number.signature = n1;
      log2Number.signature = n1;
      log1pNumber.signature = n1;
      modNumber.signature = n2;
      nthRootNumber.signature = n2;
      signNumber.signature = n1;
      sqrtNumber.signature = n1;
      squareNumber.signature = n1;
      xgcdNumber.signature = n2;
      powNumber.signature = n2;
      roundNumber.signature = n2;
      normNumber.signature = n1;
    }
  });

  // node_modules/mathjs/es/plain/number/bitwise.js
  function bitAndNumber(x3, y2) {
    if (!isInteger(x3) || !isInteger(y2)) {
      throw new Error("Integers expected in function bitAnd");
    }
    return x3 & y2;
  }
  function bitNotNumber(x3) {
    if (!isInteger(x3)) {
      throw new Error("Integer expected in function bitNot");
    }
    return ~x3;
  }
  function bitOrNumber(x3, y2) {
    if (!isInteger(x3) || !isInteger(y2)) {
      throw new Error("Integers expected in function bitOr");
    }
    return x3 | y2;
  }
  function bitXorNumber(x3, y2) {
    if (!isInteger(x3) || !isInteger(y2)) {
      throw new Error("Integers expected in function bitXor");
    }
    return x3 ^ y2;
  }
  function leftShiftNumber(x3, y2) {
    if (!isInteger(x3) || !isInteger(y2)) {
      throw new Error("Integers expected in function leftShift");
    }
    return x3 << y2;
  }
  function rightArithShiftNumber(x3, y2) {
    if (!isInteger(x3) || !isInteger(y2)) {
      throw new Error("Integers expected in function rightArithShift");
    }
    return x3 >> y2;
  }
  function rightLogShiftNumber(x3, y2) {
    if (!isInteger(x3) || !isInteger(y2)) {
      throw new Error("Integers expected in function rightLogShift");
    }
    return x3 >>> y2;
  }
  var n12, n22;
  var init_bitwise = __esm({
    "node_modules/mathjs/es/plain/number/bitwise.js"() {
      init_number();
      n12 = "number";
      n22 = "number, number";
      bitAndNumber.signature = n22;
      bitNotNumber.signature = n12;
      bitOrNumber.signature = n22;
      bitXorNumber.signature = n22;
      leftShiftNumber.signature = n22;
      rightArithShiftNumber.signature = n22;
      rightLogShiftNumber.signature = n22;
    }
  });

  // node_modules/mathjs/es/utils/product.js
  function product(i3, n3) {
    if (n3 < i3) {
      return 1;
    }
    if (n3 === i3) {
      return n3;
    }
    var half = n3 + i3 >> 1;
    return product(i3, half) * product(half + 1, n3);
  }
  var init_product = __esm({
    "node_modules/mathjs/es/utils/product.js"() {
    }
  });

  // node_modules/mathjs/es/plain/number/combinations.js
  function combinationsNumber(n3, k3) {
    if (!isInteger(n3) || n3 < 0) {
      throw new TypeError("Positive integer value expected in function combinations");
    }
    if (!isInteger(k3) || k3 < 0) {
      throw new TypeError("Positive integer value expected in function combinations");
    }
    if (k3 > n3) {
      throw new TypeError("k must be less than or equal to n");
    }
    var nMinusk = n3 - k3;
    var prodrange;
    if (k3 < nMinusk) {
      prodrange = product(nMinusk + 1, n3);
      return prodrange / product(1, k3);
    }
    prodrange = product(k3 + 1, n3);
    return prodrange / product(1, nMinusk);
  }
  var init_combinations = __esm({
    "node_modules/mathjs/es/plain/number/combinations.js"() {
      init_number();
      init_product();
      combinationsNumber.signature = "number, number";
    }
  });

  // node_modules/mathjs/es/plain/number/constants.js
  var pi, tau, e3, phi;
  var init_constants = __esm({
    "node_modules/mathjs/es/plain/number/constants.js"() {
      pi = Math.PI;
      tau = 2 * Math.PI;
      e3 = Math.E;
      phi = 1.618033988749895;
    }
  });

  // node_modules/mathjs/es/plain/number/logical.js
  function notNumber(x3) {
    return !x3;
  }
  function orNumber(x3, y2) {
    return !!(x3 || y2);
  }
  function xorNumber(x3, y2) {
    return !!x3 !== !!y2;
  }
  function andNumber(x3, y2) {
    return !!(x3 && y2);
  }
  var n13, n23;
  var init_logical = __esm({
    "node_modules/mathjs/es/plain/number/logical.js"() {
      n13 = "number";
      n23 = "number, number";
      notNumber.signature = n13;
      orNumber.signature = n23;
      xorNumber.signature = n23;
      andNumber.signature = n23;
    }
  });

  // node_modules/mathjs/es/plain/number/relational.js
  var init_relational = __esm({
    "node_modules/mathjs/es/plain/number/relational.js"() {
    }
  });

  // node_modules/mathjs/es/plain/number/probability.js
  function gammaNumber(n3) {
    var x3;
    if (isInteger(n3)) {
      if (n3 <= 0) {
        return isFinite(n3) ? Infinity : NaN;
      }
      if (n3 > 171) {
        return Infinity;
      }
      return product(1, n3 - 1);
    }
    if (n3 < 0.5) {
      return Math.PI / (Math.sin(Math.PI * n3) * gammaNumber(1 - n3));
    }
    if (n3 >= 171.35) {
      return Infinity;
    }
    if (n3 > 85) {
      var twoN = n3 * n3;
      var threeN = twoN * n3;
      var fourN = threeN * n3;
      var fiveN = fourN * n3;
      return Math.sqrt(2 * Math.PI / n3) * Math.pow(n3 / Math.E, n3) * (1 + 1 / (12 * n3) + 1 / (288 * twoN) - 139 / (51840 * threeN) - 571 / (2488320 * fourN) + 163879 / (209018880 * fiveN) + 5246819 / (75246796800 * fiveN * n3));
    }
    --n3;
    x3 = gammaP[0];
    for (var i3 = 1; i3 < gammaP.length; ++i3) {
      x3 += gammaP[i3] / (n3 + i3);
    }
    var t3 = n3 + gammaG + 0.5;
    return Math.sqrt(2 * Math.PI) * Math.pow(t3, n3 + 0.5) * Math.exp(-t3) * x3;
  }
  var gammaG, gammaP;
  var init_probability = __esm({
    "node_modules/mathjs/es/plain/number/probability.js"() {
      init_number();
      init_product();
      gammaNumber.signature = "number";
      gammaG = 4.7421875;
      gammaP = [0.9999999999999971, 57.15623566586292, -59.59796035547549, 14.136097974741746, -0.4919138160976202, 3399464998481189e-20, 4652362892704858e-20, -9837447530487956e-20, 1580887032249125e-19, -21026444172410488e-20, 21743961811521265e-20, -1643181065367639e-19, 8441822398385275e-20, -26190838401581408e-21, 36899182659531625e-22];
    }
  });

  // node_modules/mathjs/es/plain/number/trigonometry.js
  function acosNumber(x3) {
    return Math.acos(x3);
  }
  function acoshNumber(x3) {
    return acosh(x3);
  }
  function acotNumber(x3) {
    return Math.atan(1 / x3);
  }
  function acothNumber(x3) {
    return isFinite(x3) ? (Math.log((x3 + 1) / x3) + Math.log(x3 / (x3 - 1))) / 2 : 0;
  }
  function acscNumber(x3) {
    return Math.asin(1 / x3);
  }
  function acschNumber(x3) {
    var xInv = 1 / x3;
    return Math.log(xInv + Math.sqrt(xInv * xInv + 1));
  }
  function asecNumber(x3) {
    return Math.acos(1 / x3);
  }
  function asechNumber(x3) {
    var xInv = 1 / x3;
    var ret = Math.sqrt(xInv * xInv - 1);
    return Math.log(ret + xInv);
  }
  function asinNumber(x3) {
    return Math.asin(x3);
  }
  function asinhNumber(x3) {
    return asinh(x3);
  }
  function atanNumber(x3) {
    return Math.atan(x3);
  }
  function atan2Number(y2, x3) {
    return Math.atan2(y2, x3);
  }
  function atanhNumber(x3) {
    return atanh(x3);
  }
  function cosNumber(x3) {
    return Math.cos(x3);
  }
  function coshNumber(x3) {
    return cosh(x3);
  }
  function cotNumber(x3) {
    return 1 / Math.tan(x3);
  }
  function cothNumber(x3) {
    var e5 = Math.exp(2 * x3);
    return (e5 + 1) / (e5 - 1);
  }
  function cscNumber(x3) {
    return 1 / Math.sin(x3);
  }
  function cschNumber(x3) {
    if (x3 === 0) {
      return Number.POSITIVE_INFINITY;
    } else {
      return Math.abs(2 / (Math.exp(x3) - Math.exp(-x3))) * sign(x3);
    }
  }
  function secNumber(x3) {
    return 1 / Math.cos(x3);
  }
  function sechNumber(x3) {
    return 2 / (Math.exp(x3) + Math.exp(-x3));
  }
  function sinNumber(x3) {
    return Math.sin(x3);
  }
  function sinhNumber(x3) {
    return sinh(x3);
  }
  function tanNumber(x3) {
    return Math.tan(x3);
  }
  function tanhNumber(x3) {
    return tanh(x3);
  }
  var n14, n24;
  var init_trigonometry = __esm({
    "node_modules/mathjs/es/plain/number/trigonometry.js"() {
      init_number();
      n14 = "number";
      n24 = "number, number";
      acosNumber.signature = n14;
      acoshNumber.signature = n14;
      acotNumber.signature = n14;
      acothNumber.signature = n14;
      acscNumber.signature = n14;
      acschNumber.signature = n14;
      asecNumber.signature = n14;
      asechNumber.signature = n14;
      asinNumber.signature = n14;
      asinhNumber.signature = n14;
      atanNumber.signature = n14;
      atan2Number.signature = n24;
      atanhNumber.signature = n14;
      cosNumber.signature = n14;
      coshNumber.signature = n14;
      cotNumber.signature = n14;
      cothNumber.signature = n14;
      cscNumber.signature = n14;
      cschNumber.signature = n14;
      secNumber.signature = n14;
      sechNumber.signature = n14;
      sinNumber.signature = n14;
      sinhNumber.signature = n14;
      tanNumber.signature = n14;
      tanhNumber.signature = n14;
    }
  });

  // node_modules/mathjs/es/plain/number/utils.js
  function isIntegerNumber(x3) {
    return isInteger(x3);
  }
  function isNegativeNumber(x3) {
    return x3 < 0;
  }
  function isPositiveNumber(x3) {
    return x3 > 0;
  }
  function isZeroNumber(x3) {
    return x3 === 0;
  }
  function isNaNNumber(x3) {
    return Number.isNaN(x3);
  }
  var n15;
  var init_utils = __esm({
    "node_modules/mathjs/es/plain/number/utils.js"() {
      init_number();
      n15 = "number";
      isIntegerNumber.signature = n15;
      isNegativeNumber.signature = n15;
      isPositiveNumber.signature = n15;
      isZeroNumber.signature = n15;
      isNaNNumber.signature = n15;
    }
  });

  // node_modules/mathjs/es/plain/number/index.js
  var init_number2 = __esm({
    "node_modules/mathjs/es/plain/number/index.js"() {
      init_arithmetic();
      init_bitwise();
      init_combinations();
      init_constants();
      init_logical();
      init_relational();
      init_probability();
      init_trigonometry();
      init_utils();
    }
  });

  // node_modules/mathjs/es/utils/bignumber/formatter.js
  function format2(value, options) {
    if (typeof options === "function") {
      return options(value);
    }
    if (!value.isFinite()) {
      return value.isNaN() ? "NaN" : value.gt(0) ? "Infinity" : "-Infinity";
    }
    var notation = "auto";
    var precision;
    if (options !== void 0) {
      if (options.notation) {
        notation = options.notation;
      }
      if (typeof options === "number") {
        precision = options;
      } else if (options.precision) {
        precision = options.precision;
      }
    }
    switch (notation) {
      case "fixed":
        return toFixed2(value, precision);
      case "exponential":
        return toExponential2(value, precision);
      case "engineering":
        return toEngineering2(value, precision);
      case "auto": {
        var lowerExp = options && options.lowerExp !== void 0 ? options.lowerExp : -3;
        var upperExp = options && options.upperExp !== void 0 ? options.upperExp : 5;
        if (value.isZero())
          return "0";
        var str;
        var rounded = value.toSignificantDigits(precision);
        var exp2 = rounded.e;
        if (exp2 >= lowerExp && exp2 < upperExp) {
          str = rounded.toFixed();
        } else {
          str = toExponential2(value, precision);
        }
        return str.replace(/((\.\d*?)(0+))($|e)/, function() {
          var digits2 = arguments[2];
          var e5 = arguments[4];
          return digits2 !== "." ? digits2 + e5 : e5;
        });
      }
      default:
        throw new Error('Unknown notation "' + notation + '". Choose "auto", "exponential", or "fixed".');
    }
  }
  function toEngineering2(value, precision) {
    var e5 = value.e;
    var newExp = e5 % 3 === 0 ? e5 : e5 < 0 ? e5 - 3 - e5 % 3 : e5 - e5 % 3;
    var valueWithoutExp = value.mul(Math.pow(10, -newExp));
    var valueStr = valueWithoutExp.toPrecision(precision);
    if (valueStr.indexOf("e") !== -1) {
      valueStr = valueWithoutExp.toString();
    }
    return valueStr + "e" + (e5 >= 0 ? "+" : "") + newExp.toString();
  }
  function toExponential2(value, precision) {
    if (precision !== void 0) {
      return value.toExponential(precision - 1);
    } else {
      return value.toExponential();
    }
  }
  function toFixed2(value, precision) {
    return value.toFixed(precision);
  }
  var init_formatter = __esm({
    "node_modules/mathjs/es/utils/bignumber/formatter.js"() {
    }
  });

  // node_modules/mathjs/es/utils/string.js
  function _typeof3(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof3 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof3 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof3(obj);
  }
  function format3(value, options) {
    if (typeof value === "number") {
      return format(value, options);
    }
    if (isBigNumber(value)) {
      return format2(value, options);
    }
    if (looksLikeFraction(value)) {
      if (!options || options.fraction !== "decimal") {
        return value.s * value.n + "/" + value.d;
      } else {
        return value.toString();
      }
    }
    if (Array.isArray(value)) {
      return formatArray(value, options);
    }
    if (isString(value)) {
      return '"' + value + '"';
    }
    if (typeof value === "function") {
      return value.syntax ? String(value.syntax) : "function";
    }
    if (value && _typeof3(value) === "object") {
      if (typeof value.format === "function") {
        return value.format(options);
      } else if (value && value.toString(options) !== {}.toString()) {
        return value.toString(options);
      } else {
        var entries = Object.keys(value).map(function(key) {
          return '"' + key + '": ' + format3(value[key], options);
        });
        return "{" + entries.join(", ") + "}";
      }
    }
    return String(value);
  }
  function stringify(value) {
    var text = String(value);
    var escaped = "";
    var i3 = 0;
    while (i3 < text.length) {
      var c3 = text.charAt(i3);
      if (c3 === "\\") {
        escaped += c3;
        i3++;
        c3 = text.charAt(i3);
        if (c3 === "" || '"\\/bfnrtu'.indexOf(c3) === -1) {
          escaped += "\\";
        }
        escaped += c3;
      } else if (c3 === '"') {
        escaped += '\\"';
      } else {
        escaped += c3;
      }
      i3++;
    }
    return '"' + escaped + '"';
  }
  function escape(value) {
    var text = String(value);
    text = text.replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#39;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
    return text;
  }
  function formatArray(array, options) {
    if (Array.isArray(array)) {
      var str = "[";
      var len = array.length;
      for (var i3 = 0; i3 < len; i3++) {
        if (i3 !== 0) {
          str += ", ";
        }
        str += formatArray(array[i3], options);
      }
      str += "]";
      return str;
    } else {
      return format3(array, options);
    }
  }
  function looksLikeFraction(value) {
    return value && _typeof3(value) === "object" && typeof value.s === "number" && typeof value.n === "number" && typeof value.d === "number" || false;
  }
  function compareText(x3, y2) {
    if (!isString(x3)) {
      throw new TypeError("Unexpected type of argument in function compareText (expected: string or Array or Matrix, actual: " + typeOf(x3) + ", index: 0)");
    }
    if (!isString(y2)) {
      throw new TypeError("Unexpected type of argument in function compareText (expected: string or Array or Matrix, actual: " + typeOf(y2) + ", index: 1)");
    }
    return x3 === y2 ? 0 : x3 > y2 ? 1 : -1;
  }
  var init_string = __esm({
    "node_modules/mathjs/es/utils/string.js"() {
      init_is();
      init_number();
      init_formatter();
    }
  });

  // node_modules/mathjs/es/error/DimensionError.js
  function DimensionError(actual, expected, relation) {
    if (!(this instanceof DimensionError)) {
      throw new SyntaxError("Constructor must be called with the new operator");
    }
    this.actual = actual;
    this.expected = expected;
    this.relation = relation;
    this.message = "Dimension mismatch (" + (Array.isArray(actual) ? "[" + actual.join(", ") + "]" : actual) + " " + (this.relation || "!=") + " " + (Array.isArray(expected) ? "[" + expected.join(", ") + "]" : expected) + ")";
    this.stack = new Error().stack;
  }
  var init_DimensionError = __esm({
    "node_modules/mathjs/es/error/DimensionError.js"() {
      DimensionError.prototype = new RangeError();
      DimensionError.prototype.constructor = RangeError;
      DimensionError.prototype.name = "DimensionError";
      DimensionError.prototype.isDimensionError = true;
    }
  });

  // node_modules/mathjs/es/error/IndexError.js
  function IndexError(index2, min2, max2) {
    if (!(this instanceof IndexError)) {
      throw new SyntaxError("Constructor must be called with the new operator");
    }
    this.index = index2;
    if (arguments.length < 3) {
      this.min = 0;
      this.max = min2;
    } else {
      this.min = min2;
      this.max = max2;
    }
    if (this.min !== void 0 && this.index < this.min) {
      this.message = "Index out of range (" + this.index + " < " + this.min + ")";
    } else if (this.max !== void 0 && this.index >= this.max) {
      this.message = "Index out of range (" + this.index + " > " + (this.max - 1) + ")";
    } else {
      this.message = "Index out of range (" + this.index + ")";
    }
    this.stack = new Error().stack;
  }
  var init_IndexError = __esm({
    "node_modules/mathjs/es/error/IndexError.js"() {
      IndexError.prototype = new RangeError();
      IndexError.prototype.constructor = RangeError;
      IndexError.prototype.name = "IndexError";
      IndexError.prototype.isIndexError = true;
    }
  });

  // node_modules/mathjs/es/utils/array.js
  function arraySize(x3) {
    var s3 = [];
    while (Array.isArray(x3)) {
      s3.push(x3.length);
      x3 = x3[0];
    }
    return s3;
  }
  function validateIndex(index2, length) {
    if (!isNumber(index2) || !isInteger(index2)) {
      throw new TypeError("Index must be an integer (value: " + index2 + ")");
    }
    if (index2 < 0 || typeof length === "number" && index2 >= length) {
      throw new IndexError(index2, length);
    }
  }
  function flatten(array) {
    if (!Array.isArray(array)) {
      return array;
    }
    var flat = [];
    array.forEach(function callback(value) {
      if (Array.isArray(value)) {
        value.forEach(callback);
      } else {
        flat.push(value);
      }
    });
    return flat;
  }
  function map(array, callback) {
    return Array.prototype.map.call(array, callback);
  }
  function forEach(array, callback) {
    Array.prototype.forEach.call(array, callback);
  }
  function filter(array, callback) {
    if (arraySize(array).length !== 1) {
      throw new Error("Only one dimensional matrices supported");
    }
    return Array.prototype.filter.call(array, callback);
  }
  function filterRegExp(array, regexp) {
    if (arraySize(array).length !== 1) {
      throw new Error("Only one dimensional matrices supported");
    }
    return Array.prototype.filter.call(array, function(entry) {
      return regexp.test(entry);
    });
  }
  function join(array, separator) {
    return Array.prototype.join.call(array, separator);
  }
  function contains2(array, item) {
    return array.indexOf(item) !== -1;
  }
  var init_array = __esm({
    "node_modules/mathjs/es/utils/array.js"() {
      init_number();
      init_is();
      init_IndexError();
    }
  });

  // node_modules/mathjs/es/utils/factory.js
  function factory(name106, dependencies95, create3, meta) {
    function assertAndCreate(scope) {
      var deps = pickShallow(scope, dependencies95.map(stripOptionalNotation));
      assertDependencies(name106, dependencies95, scope);
      return create3(deps);
    }
    assertAndCreate.isFactory = true;
    assertAndCreate.fn = name106;
    assertAndCreate.dependencies = dependencies95.slice().sort();
    if (meta) {
      assertAndCreate.meta = meta;
    }
    return assertAndCreate;
  }
  function isFactory(obj) {
    return typeof obj === "function" && typeof obj.fn === "string" && Array.isArray(obj.dependencies);
  }
  function assertDependencies(name106, dependencies95, scope) {
    var allDefined = dependencies95.filter(function(dependency) {
      return !isOptionalDependency(dependency);
    }).every(function(dependency) {
      return scope[dependency] !== void 0;
    });
    if (!allDefined) {
      var missingDependencies = dependencies95.filter(function(dependency) {
        return scope[dependency] === void 0;
      });
      throw new Error('Cannot create function "'.concat(name106, '", ') + "some dependencies are missing: ".concat(missingDependencies.map(function(d4) {
        return '"'.concat(d4, '"');
      }).join(", "), "."));
    }
  }
  function isOptionalDependency(dependency) {
    return dependency && dependency[0] === "?";
  }
  function stripOptionalNotation(dependency) {
    return dependency && dependency[0] === "?" ? dependency.slice(1) : dependency;
  }
  var init_factory = __esm({
    "node_modules/mathjs/es/utils/factory.js"() {
      init_object();
    }
  });

  // node_modules/mathjs/es/utils/noop.js
  function noBignumber() {
    throw new Error('No "bignumber" implementation available');
  }
  function noFraction() {
    throw new Error('No "fraction" implementation available');
  }
  function noMatrix() {
    throw new Error('No "matrix" implementation available');
  }
  function noIndex() {
    throw new Error('No "index" implementation available');
  }
  function noSubset() {
    throw new Error('No "matrix" implementation available');
  }
  var init_noop = __esm({
    "node_modules/mathjs/es/utils/noop.js"() {
    }
  });

  // node_modules/typed-function/typed-function.js
  var require_typed_function = __commonJS({
    "node_modules/typed-function/typed-function.js"(exports, module) {
      "use strict";
      (function(root, factory2) {
        if (typeof define === "function" && define.amd) {
          define([], factory2);
        } else if (typeof exports === "object") {
          module.exports = factory2();
        } else {
          root.typed = factory2();
        }
      })(exports, function() {
        function ok5() {
          return true;
        }
        function notOk() {
          return false;
        }
        function undef() {
          return void 0;
        }
        function create3() {
          var _types = [
            { name: "number", test: function(x3) {
              return typeof x3 === "number";
            } },
            { name: "string", test: function(x3) {
              return typeof x3 === "string";
            } },
            { name: "boolean", test: function(x3) {
              return typeof x3 === "boolean";
            } },
            { name: "Function", test: function(x3) {
              return typeof x3 === "function";
            } },
            { name: "Array", test: Array.isArray },
            { name: "Date", test: function(x3) {
              return x3 instanceof Date;
            } },
            { name: "RegExp", test: function(x3) {
              return x3 instanceof RegExp;
            } },
            { name: "Object", test: function(x3) {
              return typeof x3 === "object" && x3 !== null && x3.constructor === Object;
            } },
            { name: "null", test: function(x3) {
              return x3 === null;
            } },
            { name: "undefined", test: function(x3) {
              return x3 === void 0;
            } }
          ];
          var anyType = {
            name: "any",
            test: ok5
          };
          var _ignore = [];
          var _conversions = [];
          var typed2 = {
            types: _types,
            conversions: _conversions,
            ignore: _ignore
          };
          function findTypeByName(typeName) {
            var entry = findInArray(typed2.types, function(entry2) {
              return entry2.name === typeName;
            });
            if (entry) {
              return entry;
            }
            if (typeName === "any") {
              return anyType;
            }
            var hint = findInArray(typed2.types, function(entry2) {
              return entry2.name.toLowerCase() === typeName.toLowerCase();
            });
            throw new TypeError('Unknown type "' + typeName + '"' + (hint ? '. Did you mean "' + hint.name + '"?' : ""));
          }
          function findTypeIndex(type) {
            if (type === anyType) {
              return 999;
            }
            return typed2.types.indexOf(type);
          }
          function findTypeName(value) {
            var entry = findInArray(typed2.types, function(entry2) {
              return entry2.test(value);
            });
            if (entry) {
              return entry.name;
            }
            throw new TypeError("Value has unknown type. Value: " + value);
          }
          function find(fn, signature) {
            if (!fn.signatures) {
              throw new TypeError("Function is no typed-function");
            }
            var arr;
            if (typeof signature === "string") {
              arr = signature.split(",");
              for (var i3 = 0; i3 < arr.length; i3++) {
                arr[i3] = arr[i3].trim();
              }
            } else if (Array.isArray(signature)) {
              arr = signature;
            } else {
              throw new TypeError("String array or a comma separated string expected");
            }
            var str = arr.join(",");
            var match = fn.signatures[str];
            if (match) {
              return match;
            }
            throw new TypeError("Signature not found (signature: " + (fn.name || "unnamed") + "(" + arr.join(", ") + "))");
          }
          function convert(value, type) {
            var from = findTypeName(value);
            if (type === from) {
              return value;
            }
            for (var i3 = 0; i3 < typed2.conversions.length; i3++) {
              var conversion = typed2.conversions[i3];
              if (conversion.from === from && conversion.to === type) {
                return conversion.convert(value);
              }
            }
            throw new Error("Cannot convert from " + from + " to " + type);
          }
          function stringifyParams(params) {
            return params.map(function(param) {
              var typeNames = param.types.map(getTypeName);
              return (param.restParam ? "..." : "") + typeNames.join("|");
            }).join(",");
          }
          function parseParam(param, conversions) {
            var restParam = param.indexOf("...") === 0;
            var types = !restParam ? param : param.length > 3 ? param.slice(3) : "any";
            var typeNames = types.split("|").map(trim).filter(notEmpty).filter(notIgnore);
            var matchingConversions = filterConversions(conversions, typeNames);
            var exactTypes = typeNames.map(function(typeName) {
              var type = findTypeByName(typeName);
              return {
                name: typeName,
                typeIndex: findTypeIndex(type),
                test: type.test,
                conversion: null,
                conversionIndex: -1
              };
            });
            var convertibleTypes = matchingConversions.map(function(conversion) {
              var type = findTypeByName(conversion.from);
              return {
                name: conversion.from,
                typeIndex: findTypeIndex(type),
                test: type.test,
                conversion,
                conversionIndex: conversions.indexOf(conversion)
              };
            });
            return {
              types: exactTypes.concat(convertibleTypes),
              restParam
            };
          }
          function parseSignature(signature, fn, conversions) {
            var params = [];
            if (signature.trim() !== "") {
              params = signature.split(",").map(trim).map(function(param, index2, array) {
                var parsedParam = parseParam(param, conversions);
                if (parsedParam.restParam && index2 !== array.length - 1) {
                  throw new SyntaxError('Unexpected rest parameter "' + param + '": only allowed for the last parameter');
                }
                return parsedParam;
              });
            }
            if (params.some(isInvalidParam)) {
              return null;
            }
            return {
              params,
              fn
            };
          }
          function hasRestParam(params) {
            var param = last(params);
            return param ? param.restParam : false;
          }
          function hasConversions(param) {
            return param.types.some(function(type) {
              return type.conversion != null;
            });
          }
          function compileTest(param) {
            if (!param || param.types.length === 0) {
              return ok5;
            } else if (param.types.length === 1) {
              return findTypeByName(param.types[0].name).test;
            } else if (param.types.length === 2) {
              var test0 = findTypeByName(param.types[0].name).test;
              var test1 = findTypeByName(param.types[1].name).test;
              return function or2(x3) {
                return test0(x3) || test1(x3);
              };
            } else {
              var tests = param.types.map(function(type) {
                return findTypeByName(type.name).test;
              });
              return function or2(x3) {
                for (var i3 = 0; i3 < tests.length; i3++) {
                  if (tests[i3](x3)) {
                    return true;
                  }
                }
                return false;
              };
            }
          }
          function compileTests(params) {
            var tests, test0, test1;
            if (hasRestParam(params)) {
              tests = initial(params).map(compileTest);
              var varIndex = tests.length;
              var lastTest = compileTest(last(params));
              var testRestParam = function(args) {
                for (var i3 = varIndex; i3 < args.length; i3++) {
                  if (!lastTest(args[i3])) {
                    return false;
                  }
                }
                return true;
              };
              return function testArgs(args) {
                for (var i3 = 0; i3 < tests.length; i3++) {
                  if (!tests[i3](args[i3])) {
                    return false;
                  }
                }
                return testRestParam(args) && args.length >= varIndex + 1;
              };
            } else {
              if (params.length === 0) {
                return function testArgs(args) {
                  return args.length === 0;
                };
              } else if (params.length === 1) {
                test0 = compileTest(params[0]);
                return function testArgs(args) {
                  return test0(args[0]) && args.length === 1;
                };
              } else if (params.length === 2) {
                test0 = compileTest(params[0]);
                test1 = compileTest(params[1]);
                return function testArgs(args) {
                  return test0(args[0]) && test1(args[1]) && args.length === 2;
                };
              } else {
                tests = params.map(compileTest);
                return function testArgs(args) {
                  for (var i3 = 0; i3 < tests.length; i3++) {
                    if (!tests[i3](args[i3])) {
                      return false;
                    }
                  }
                  return args.length === tests.length;
                };
              }
            }
          }
          function getParamAtIndex(signature, index2) {
            return index2 < signature.params.length ? signature.params[index2] : hasRestParam(signature.params) ? last(signature.params) : null;
          }
          function getExpectedTypeNames(signature, index2, excludeConversions) {
            var param = getParamAtIndex(signature, index2);
            var types = param ? excludeConversions ? param.types.filter(isExactType) : param.types : [];
            return types.map(getTypeName);
          }
          function getTypeName(type) {
            return type.name;
          }
          function isExactType(type) {
            return type.conversion === null || type.conversion === void 0;
          }
          function mergeExpectedParams(signatures, index2) {
            var typeNames = uniq(flatMap(signatures, function(signature) {
              return getExpectedTypeNames(signature, index2, false);
            }));
            return typeNames.indexOf("any") !== -1 ? ["any"] : typeNames;
          }
          function createError(name106, args, signatures) {
            var err, expected;
            var _name = name106 || "unnamed";
            var matchingSignatures = signatures;
            var index2;
            for (index2 = 0; index2 < args.length; index2++) {
              var nextMatchingDefs = matchingSignatures.filter(function(signature) {
                var test = compileTest(getParamAtIndex(signature, index2));
                return (index2 < signature.params.length || hasRestParam(signature.params)) && test(args[index2]);
              });
              if (nextMatchingDefs.length === 0) {
                expected = mergeExpectedParams(matchingSignatures, index2);
                if (expected.length > 0) {
                  var actualType = findTypeName(args[index2]);
                  err = new TypeError("Unexpected type of argument in function " + _name + " (expected: " + expected.join(" or ") + ", actual: " + actualType + ", index: " + index2 + ")");
                  err.data = {
                    category: "wrongType",
                    fn: _name,
                    index: index2,
                    actual: actualType,
                    expected
                  };
                  return err;
                }
              } else {
                matchingSignatures = nextMatchingDefs;
              }
            }
            var lengths = matchingSignatures.map(function(signature) {
              return hasRestParam(signature.params) ? Infinity : signature.params.length;
            });
            if (args.length < Math.min.apply(null, lengths)) {
              expected = mergeExpectedParams(matchingSignatures, index2);
              err = new TypeError("Too few arguments in function " + _name + " (expected: " + expected.join(" or ") + ", index: " + args.length + ")");
              err.data = {
                category: "tooFewArgs",
                fn: _name,
                index: args.length,
                expected
              };
              return err;
            }
            var maxLength = Math.max.apply(null, lengths);
            if (args.length > maxLength) {
              err = new TypeError("Too many arguments in function " + _name + " (expected: " + maxLength + ", actual: " + args.length + ")");
              err.data = {
                category: "tooManyArgs",
                fn: _name,
                index: args.length,
                expectedLength: maxLength
              };
              return err;
            }
            err = new TypeError('Arguments of type "' + args.join(", ") + '" do not match any of the defined signatures of function ' + _name + ".");
            err.data = {
              category: "mismatch",
              actual: args.map(findTypeName)
            };
            return err;
          }
          function getLowestTypeIndex(param) {
            var min2 = 999;
            for (var i3 = 0; i3 < param.types.length; i3++) {
              if (isExactType(param.types[i3])) {
                min2 = Math.min(min2, param.types[i3].typeIndex);
              }
            }
            return min2;
          }
          function getLowestConversionIndex(param) {
            var min2 = 999;
            for (var i3 = 0; i3 < param.types.length; i3++) {
              if (!isExactType(param.types[i3])) {
                min2 = Math.min(min2, param.types[i3].conversionIndex);
              }
            }
            return min2;
          }
          function compareParams(param1, param2) {
            var c3;
            c3 = param1.restParam - param2.restParam;
            if (c3 !== 0) {
              return c3;
            }
            c3 = hasConversions(param1) - hasConversions(param2);
            if (c3 !== 0) {
              return c3;
            }
            c3 = getLowestTypeIndex(param1) - getLowestTypeIndex(param2);
            if (c3 !== 0) {
              return c3;
            }
            return getLowestConversionIndex(param1) - getLowestConversionIndex(param2);
          }
          function compareSignatures(signature1, signature2) {
            var len = Math.min(signature1.params.length, signature2.params.length);
            var i3;
            var c3;
            c3 = signature1.params.some(hasConversions) - signature2.params.some(hasConversions);
            if (c3 !== 0) {
              return c3;
            }
            for (i3 = 0; i3 < len; i3++) {
              c3 = hasConversions(signature1.params[i3]) - hasConversions(signature2.params[i3]);
              if (c3 !== 0) {
                return c3;
              }
            }
            for (i3 = 0; i3 < len; i3++) {
              c3 = compareParams(signature1.params[i3], signature2.params[i3]);
              if (c3 !== 0) {
                return c3;
              }
            }
            return signature1.params.length - signature2.params.length;
          }
          function filterConversions(conversions, typeNames) {
            var matches = {};
            conversions.forEach(function(conversion) {
              if (typeNames.indexOf(conversion.from) === -1 && typeNames.indexOf(conversion.to) !== -1 && !matches[conversion.from]) {
                matches[conversion.from] = conversion;
              }
            });
            return Object.keys(matches).map(function(from) {
              return matches[from];
            });
          }
          function compileArgsPreprocessing(params, fn) {
            var fnConvert = fn;
            if (params.some(hasConversions)) {
              var restParam = hasRestParam(params);
              var compiledConversions = params.map(compileArgConversion);
              fnConvert = function convertArgs() {
                var args = [];
                var last2 = restParam ? arguments.length - 1 : arguments.length;
                for (var i3 = 0; i3 < last2; i3++) {
                  args[i3] = compiledConversions[i3](arguments[i3]);
                }
                if (restParam) {
                  args[last2] = arguments[last2].map(compiledConversions[last2]);
                }
                return fn.apply(this, args);
              };
            }
            var fnPreprocess = fnConvert;
            if (hasRestParam(params)) {
              var offset = params.length - 1;
              fnPreprocess = function preprocessRestParams() {
                return fnConvert.apply(this, slice(arguments, 0, offset).concat([slice(arguments, offset)]));
              };
            }
            return fnPreprocess;
          }
          function compileArgConversion(param) {
            var test0, test1, conversion0, conversion1;
            var tests = [];
            var conversions = [];
            param.types.forEach(function(type) {
              if (type.conversion) {
                tests.push(findTypeByName(type.conversion.from).test);
                conversions.push(type.conversion.convert);
              }
            });
            switch (conversions.length) {
              case 0:
                return function convertArg(arg) {
                  return arg;
                };
              case 1:
                test0 = tests[0];
                conversion0 = conversions[0];
                return function convertArg(arg) {
                  if (test0(arg)) {
                    return conversion0(arg);
                  }
                  return arg;
                };
              case 2:
                test0 = tests[0];
                test1 = tests[1];
                conversion0 = conversions[0];
                conversion1 = conversions[1];
                return function convertArg(arg) {
                  if (test0(arg)) {
                    return conversion0(arg);
                  }
                  if (test1(arg)) {
                    return conversion1(arg);
                  }
                  return arg;
                };
              default:
                return function convertArg(arg) {
                  for (var i3 = 0; i3 < conversions.length; i3++) {
                    if (tests[i3](arg)) {
                      return conversions[i3](arg);
                    }
                  }
                  return arg;
                };
            }
          }
          function createSignaturesMap(signatures) {
            var signaturesMap = {};
            signatures.forEach(function(signature) {
              if (!signature.params.some(hasConversions)) {
                splitParams(signature.params, true).forEach(function(params) {
                  signaturesMap[stringifyParams(params)] = signature.fn;
                });
              }
            });
            return signaturesMap;
          }
          function splitParams(params, ignoreConversionTypes) {
            function _splitParams(params2, index2, types) {
              if (index2 < params2.length) {
                var param = params2[index2];
                var filteredTypes = ignoreConversionTypes ? param.types.filter(isExactType) : param.types;
                var typeGroups;
                if (param.restParam) {
                  var exactTypes = filteredTypes.filter(isExactType);
                  typeGroups = exactTypes.length < filteredTypes.length ? [exactTypes, filteredTypes] : [filteredTypes];
                } else {
                  typeGroups = filteredTypes.map(function(type) {
                    return [type];
                  });
                }
                return flatMap(typeGroups, function(typeGroup) {
                  return _splitParams(params2, index2 + 1, types.concat([typeGroup]));
                });
              } else {
                var splittedParams = types.map(function(type, typeIndex) {
                  return {
                    types: type,
                    restParam: typeIndex === params2.length - 1 && hasRestParam(params2)
                  };
                });
                return [splittedParams];
              }
            }
            return _splitParams(params, 0, []);
          }
          function hasConflictingParams(signature1, signature2) {
            var ii = Math.max(signature1.params.length, signature2.params.length);
            for (var i3 = 0; i3 < ii; i3++) {
              var typesNames1 = getExpectedTypeNames(signature1, i3, true);
              var typesNames2 = getExpectedTypeNames(signature2, i3, true);
              if (!hasOverlap(typesNames1, typesNames2)) {
                return false;
              }
            }
            var len1 = signature1.params.length;
            var len2 = signature2.params.length;
            var restParam1 = hasRestParam(signature1.params);
            var restParam2 = hasRestParam(signature2.params);
            return restParam1 ? restParam2 ? len1 === len2 : len2 >= len1 : restParam2 ? len1 >= len2 : len1 === len2;
          }
          function createTypedFunction(name106, signaturesMap) {
            if (Object.keys(signaturesMap).length === 0) {
              throw new SyntaxError("No signatures provided");
            }
            var parsedSignatures = [];
            Object.keys(signaturesMap).map(function(signature) {
              return parseSignature(signature, signaturesMap[signature], typed2.conversions);
            }).filter(notNull).forEach(function(parsedSignature) {
              var conflictingSignature = findInArray(parsedSignatures, function(s3) {
                return hasConflictingParams(s3, parsedSignature);
              });
              if (conflictingSignature) {
                throw new TypeError('Conflicting signatures "' + stringifyParams(conflictingSignature.params) + '" and "' + stringifyParams(parsedSignature.params) + '".');
              }
              parsedSignatures.push(parsedSignature);
            });
            var signatures = flatMap(parsedSignatures, function(parsedSignature) {
              var params = parsedSignature ? splitParams(parsedSignature.params, false) : [];
              return params.map(function(params2) {
                return {
                  params: params2,
                  fn: parsedSignature.fn
                };
              });
            }).filter(notNull);
            signatures.sort(compareSignatures);
            var ok0 = signatures[0] && signatures[0].params.length <= 2 && !hasRestParam(signatures[0].params);
            var ok1 = signatures[1] && signatures[1].params.length <= 2 && !hasRestParam(signatures[1].params);
            var ok22 = signatures[2] && signatures[2].params.length <= 2 && !hasRestParam(signatures[2].params);
            var ok32 = signatures[3] && signatures[3].params.length <= 2 && !hasRestParam(signatures[3].params);
            var ok42 = signatures[4] && signatures[4].params.length <= 2 && !hasRestParam(signatures[4].params);
            var ok52 = signatures[5] && signatures[5].params.length <= 2 && !hasRestParam(signatures[5].params);
            var allOk = ok0 && ok1 && ok22 && ok32 && ok42 && ok52;
            var tests = signatures.map(function(signature) {
              return compileTests(signature.params);
            });
            var test00 = ok0 ? compileTest(signatures[0].params[0]) : notOk;
            var test10 = ok1 ? compileTest(signatures[1].params[0]) : notOk;
            var test20 = ok22 ? compileTest(signatures[2].params[0]) : notOk;
            var test30 = ok32 ? compileTest(signatures[3].params[0]) : notOk;
            var test40 = ok42 ? compileTest(signatures[4].params[0]) : notOk;
            var test50 = ok52 ? compileTest(signatures[5].params[0]) : notOk;
            var test01 = ok0 ? compileTest(signatures[0].params[1]) : notOk;
            var test11 = ok1 ? compileTest(signatures[1].params[1]) : notOk;
            var test21 = ok22 ? compileTest(signatures[2].params[1]) : notOk;
            var test31 = ok32 ? compileTest(signatures[3].params[1]) : notOk;
            var test41 = ok42 ? compileTest(signatures[4].params[1]) : notOk;
            var test51 = ok52 ? compileTest(signatures[5].params[1]) : notOk;
            var fns = signatures.map(function(signature) {
              return compileArgsPreprocessing(signature.params, signature.fn);
            });
            var fn0 = ok0 ? fns[0] : undef;
            var fn1 = ok1 ? fns[1] : undef;
            var fn2 = ok22 ? fns[2] : undef;
            var fn3 = ok32 ? fns[3] : undef;
            var fn4 = ok42 ? fns[4] : undef;
            var fn5 = ok52 ? fns[5] : undef;
            var len0 = ok0 ? signatures[0].params.length : -1;
            var len1 = ok1 ? signatures[1].params.length : -1;
            var len2 = ok22 ? signatures[2].params.length : -1;
            var len3 = ok32 ? signatures[3].params.length : -1;
            var len4 = ok42 ? signatures[4].params.length : -1;
            var len5 = ok52 ? signatures[5].params.length : -1;
            var iStart = allOk ? 6 : 0;
            var iEnd = signatures.length;
            var generic = function generic2() {
              "use strict";
              for (var i3 = iStart; i3 < iEnd; i3++) {
                if (tests[i3](arguments)) {
                  return fns[i3].apply(this, arguments);
                }
              }
              throw createError(name106, arguments, signatures);
            };
            var fn = function fn6(arg0, arg1) {
              "use strict";
              if (arguments.length === len0 && test00(arg0) && test01(arg1)) {
                return fn0.apply(fn6, arguments);
              }
              if (arguments.length === len1 && test10(arg0) && test11(arg1)) {
                return fn1.apply(fn6, arguments);
              }
              if (arguments.length === len2 && test20(arg0) && test21(arg1)) {
                return fn2.apply(fn6, arguments);
              }
              if (arguments.length === len3 && test30(arg0) && test31(arg1)) {
                return fn3.apply(fn6, arguments);
              }
              if (arguments.length === len4 && test40(arg0) && test41(arg1)) {
                return fn4.apply(fn6, arguments);
              }
              if (arguments.length === len5 && test50(arg0) && test51(arg1)) {
                return fn5.apply(fn6, arguments);
              }
              return generic.apply(fn6, arguments);
            };
            try {
              Object.defineProperty(fn, "name", { value: name106 });
            } catch (err) {
            }
            fn.signatures = createSignaturesMap(signatures);
            return fn;
          }
          function notIgnore(typeName) {
            return typed2.ignore.indexOf(typeName) === -1;
          }
          function trim(str) {
            return str.trim();
          }
          function notEmpty(str) {
            return !!str;
          }
          function notNull(value) {
            return value !== null;
          }
          function isInvalidParam(param) {
            return param.types.length === 0;
          }
          function initial(arr) {
            return arr.slice(0, arr.length - 1);
          }
          function last(arr) {
            return arr[arr.length - 1];
          }
          function slice(arr, start2, end) {
            return Array.prototype.slice.call(arr, start2, end);
          }
          function contains3(array, item) {
            return array.indexOf(item) !== -1;
          }
          function hasOverlap(array1, array2) {
            for (var i3 = 0; i3 < array1.length; i3++) {
              if (contains3(array2, array1[i3])) {
                return true;
              }
            }
            return false;
          }
          function findInArray(arr, test) {
            for (var i3 = 0; i3 < arr.length; i3++) {
              if (test(arr[i3])) {
                return arr[i3];
              }
            }
            return void 0;
          }
          function uniq(arr) {
            var entries = {};
            for (var i3 = 0; i3 < arr.length; i3++) {
              entries[arr[i3]] = true;
            }
            return Object.keys(entries);
          }
          function flatMap(arr, callback) {
            return Array.prototype.concat.apply([], arr.map(callback));
          }
          function getName(fns) {
            var name106 = "";
            for (var i3 = 0; i3 < fns.length; i3++) {
              var fn = fns[i3];
              if ((typeof fn.signatures === "object" || typeof fn.signature === "string") && fn.name !== "") {
                if (name106 === "") {
                  name106 = fn.name;
                } else if (name106 !== fn.name) {
                  var err = new Error("Function names do not match (expected: " + name106 + ", actual: " + fn.name + ")");
                  err.data = {
                    actual: fn.name,
                    expected: name106
                  };
                  throw err;
                }
              }
            }
            return name106;
          }
          function extractSignatures(fns) {
            var err;
            var signaturesMap = {};
            function validateUnique(_signature, _fn) {
              if (signaturesMap.hasOwnProperty(_signature) && _fn !== signaturesMap[_signature]) {
                err = new Error('Signature "' + _signature + '" is defined twice');
                err.data = { signature: _signature };
                throw err;
              }
            }
            for (var i3 = 0; i3 < fns.length; i3++) {
              var fn = fns[i3];
              if (typeof fn.signatures === "object") {
                for (var signature in fn.signatures) {
                  if (fn.signatures.hasOwnProperty(signature)) {
                    validateUnique(signature, fn.signatures[signature]);
                    signaturesMap[signature] = fn.signatures[signature];
                  }
                }
              } else if (typeof fn.signature === "string") {
                validateUnique(fn.signature, fn);
                signaturesMap[fn.signature] = fn;
              } else {
                err = new TypeError("Function is no typed-function (index: " + i3 + ")");
                err.data = { index: i3 };
                throw err;
              }
            }
            return signaturesMap;
          }
          typed2 = createTypedFunction("typed", {
            "string, Object": createTypedFunction,
            "Object": function(signaturesMap) {
              var fns = [];
              for (var signature in signaturesMap) {
                if (signaturesMap.hasOwnProperty(signature)) {
                  fns.push(signaturesMap[signature]);
                }
              }
              var name106 = getName(fns);
              return createTypedFunction(name106, signaturesMap);
            },
            "...Function": function(fns) {
              return createTypedFunction(getName(fns), extractSignatures(fns));
            },
            "string, ...Function": function(name106, fns) {
              return createTypedFunction(name106, extractSignatures(fns));
            }
          });
          typed2.create = create3;
          typed2.types = _types;
          typed2.conversions = _conversions;
          typed2.ignore = _ignore;
          typed2.convert = convert;
          typed2.find = find;
          typed2.addType = function(type, beforeObjectTest) {
            if (!type || typeof type.name !== "string" || typeof type.test !== "function") {
              throw new TypeError("Object with properties {name: string, test: function} expected");
            }
            if (beforeObjectTest !== false) {
              for (var i3 = 0; i3 < typed2.types.length; i3++) {
                if (typed2.types[i3].name === "Object") {
                  typed2.types.splice(i3, 0, type);
                  return;
                }
              }
            }
            typed2.types.push(type);
          };
          typed2.addConversion = function(conversion) {
            if (!conversion || typeof conversion.from !== "string" || typeof conversion.to !== "string" || typeof conversion.convert !== "function") {
              throw new TypeError("Object with properties {from: string, to: string, convert: function} expected");
            }
            typed2.conversions.push(conversion);
          };
          return typed2;
        }
        return create3();
      });
    }
  });

  // node_modules/mathjs/es/core/function/typed.js
  function throwNoBignumber(x3) {
    throw new Error("Cannot convert value ".concat(x3, " into a BigNumber: no class 'BigNumber' provided"));
  }
  function throwNoComplex(x3) {
    throw new Error("Cannot convert value ".concat(x3, " into a Complex number: no class 'Complex' provided"));
  }
  function throwNoMatrix() {
    throw new Error("Cannot convert array into a Matrix: no class 'DenseMatrix' provided");
  }
  function throwNoFraction(x3) {
    throw new Error("Cannot convert value ".concat(x3, " into a Fraction, no class 'Fraction' provided."));
  }
  var import_typed_function, _createTyped2, dependencies, createTyped;
  var init_typed = __esm({
    "node_modules/mathjs/es/core/function/typed.js"() {
      init_is();
      import_typed_function = __toModule(require_typed_function());
      init_number();
      init_factory();
      _createTyped2 = function _createTyped() {
        _createTyped2 = import_typed_function.default.create;
        return import_typed_function.default;
      };
      dependencies = ["?BigNumber", "?Complex", "?DenseMatrix", "?Fraction"];
      createTyped = /* @__PURE__ */ factory("typed", dependencies, function createTyped2(_ref) {
        var BigNumber = _ref.BigNumber, Complex = _ref.Complex, DenseMatrix = _ref.DenseMatrix, Fraction = _ref.Fraction;
        var typed2 = _createTyped2();
        typed2.types = [
          {
            name: "number",
            test: isNumber
          },
          {
            name: "Complex",
            test: isComplex
          },
          {
            name: "BigNumber",
            test: isBigNumber
          },
          {
            name: "Fraction",
            test: isFraction
          },
          {
            name: "Unit",
            test: isUnit
          },
          {
            name: "string",
            test: isString
          },
          {
            name: "Chain",
            test: isChain
          },
          {
            name: "Array",
            test: isArray
          },
          {
            name: "Matrix",
            test: isMatrix
          },
          {
            name: "DenseMatrix",
            test: isDenseMatrix
          },
          {
            name: "SparseMatrix",
            test: isSparseMatrix
          },
          {
            name: "Range",
            test: isRange
          },
          {
            name: "Index",
            test: isIndex
          },
          {
            name: "boolean",
            test: isBoolean
          },
          {
            name: "ResultSet",
            test: isResultSet
          },
          {
            name: "Help",
            test: isHelp
          },
          {
            name: "function",
            test: isFunction
          },
          {
            name: "Date",
            test: isDate
          },
          {
            name: "RegExp",
            test: isRegExp
          },
          {
            name: "null",
            test: isNull
          },
          {
            name: "undefined",
            test: isUndefined
          },
          {
            name: "AccessorNode",
            test: isAccessorNode
          },
          {
            name: "ArrayNode",
            test: isArrayNode
          },
          {
            name: "AssignmentNode",
            test: isAssignmentNode
          },
          {
            name: "BlockNode",
            test: isBlockNode
          },
          {
            name: "ConditionalNode",
            test: isConditionalNode
          },
          {
            name: "ConstantNode",
            test: isConstantNode
          },
          {
            name: "FunctionNode",
            test: isFunctionNode
          },
          {
            name: "FunctionAssignmentNode",
            test: isFunctionAssignmentNode
          },
          {
            name: "IndexNode",
            test: isIndexNode
          },
          {
            name: "Node",
            test: isNode
          },
          {
            name: "ObjectNode",
            test: isObjectNode
          },
          {
            name: "OperatorNode",
            test: isOperatorNode
          },
          {
            name: "ParenthesisNode",
            test: isParenthesisNode
          },
          {
            name: "RangeNode",
            test: isRangeNode
          },
          {
            name: "SymbolNode",
            test: isSymbolNode
          },
          {
            name: "Object",
            test: isObject
          }
        ];
        typed2.conversions = [{
          from: "number",
          to: "BigNumber",
          convert: function convert(x3) {
            if (!BigNumber) {
              throwNoBignumber(x3);
            }
            if (digits(x3) > 15) {
              throw new TypeError("Cannot implicitly convert a number with >15 significant digits to BigNumber (value: " + x3 + "). Use function bignumber(x) to convert to BigNumber.");
            }
            return new BigNumber(x3);
          }
        }, {
          from: "number",
          to: "Complex",
          convert: function convert(x3) {
            if (!Complex) {
              throwNoComplex(x3);
            }
            return new Complex(x3, 0);
          }
        }, {
          from: "number",
          to: "string",
          convert: function convert(x3) {
            return x3 + "";
          }
        }, {
          from: "BigNumber",
          to: "Complex",
          convert: function convert(x3) {
            if (!Complex) {
              throwNoComplex(x3);
            }
            return new Complex(x3.toNumber(), 0);
          }
        }, {
          from: "Fraction",
          to: "BigNumber",
          convert: function convert(x3) {
            throw new TypeError("Cannot implicitly convert a Fraction to BigNumber or vice versa. Use function bignumber(x) to convert to BigNumber or fraction(x) to convert to Fraction.");
          }
        }, {
          from: "Fraction",
          to: "Complex",
          convert: function convert(x3) {
            if (!Complex) {
              throwNoComplex(x3);
            }
            return new Complex(x3.valueOf(), 0);
          }
        }, {
          from: "number",
          to: "Fraction",
          convert: function convert(x3) {
            if (!Fraction) {
              throwNoFraction(x3);
            }
            var f3 = new Fraction(x3);
            if (f3.valueOf() !== x3) {
              throw new TypeError("Cannot implicitly convert a number to a Fraction when there will be a loss of precision (value: " + x3 + "). Use function fraction(x) to convert to Fraction.");
            }
            return f3;
          }
        }, {
          from: "string",
          to: "number",
          convert: function convert(x3) {
            var n3 = Number(x3);
            if (isNaN(n3)) {
              throw new Error('Cannot convert "' + x3 + '" to a number');
            }
            return n3;
          }
        }, {
          from: "string",
          to: "BigNumber",
          convert: function convert(x3) {
            if (!BigNumber) {
              throwNoBignumber(x3);
            }
            try {
              return new BigNumber(x3);
            } catch (err) {
              throw new Error('Cannot convert "' + x3 + '" to BigNumber');
            }
          }
        }, {
          from: "string",
          to: "Fraction",
          convert: function convert(x3) {
            if (!Fraction) {
              throwNoFraction(x3);
            }
            try {
              return new Fraction(x3);
            } catch (err) {
              throw new Error('Cannot convert "' + x3 + '" to Fraction');
            }
          }
        }, {
          from: "string",
          to: "Complex",
          convert: function convert(x3) {
            if (!Complex) {
              throwNoComplex(x3);
            }
            try {
              return new Complex(x3);
            } catch (err) {
              throw new Error('Cannot convert "' + x3 + '" to Complex');
            }
          }
        }, {
          from: "boolean",
          to: "number",
          convert: function convert(x3) {
            return +x3;
          }
        }, {
          from: "boolean",
          to: "BigNumber",
          convert: function convert(x3) {
            if (!BigNumber) {
              throwNoBignumber(x3);
            }
            return new BigNumber(+x3);
          }
        }, {
          from: "boolean",
          to: "Fraction",
          convert: function convert(x3) {
            if (!Fraction) {
              throwNoFraction(x3);
            }
            return new Fraction(+x3);
          }
        }, {
          from: "boolean",
          to: "string",
          convert: function convert(x3) {
            return String(x3);
          }
        }, {
          from: "Array",
          to: "Matrix",
          convert: function convert(array) {
            if (!DenseMatrix) {
              throwNoMatrix();
            }
            return new DenseMatrix(array);
          }
        }, {
          from: "Matrix",
          to: "Array",
          convert: function convert(matrix2) {
            return matrix2.valueOf();
          }
        }];
        return typed2;
      });
    }
  });

  // node_modules/mathjs/es/type/resultset/ResultSet.js
  var name, dependencies2, createResultSet;
  var init_ResultSet = __esm({
    "node_modules/mathjs/es/type/resultset/ResultSet.js"() {
      init_factory();
      name = "ResultSet";
      dependencies2 = [];
      createResultSet = /* @__PURE__ */ factory(name, dependencies2, function() {
        function ResultSet2(entries) {
          if (!(this instanceof ResultSet2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          this.entries = entries || [];
        }
        ResultSet2.prototype.type = "ResultSet";
        ResultSet2.prototype.isResultSet = true;
        ResultSet2.prototype.valueOf = function() {
          return this.entries;
        };
        ResultSet2.prototype.toString = function() {
          return "[" + this.entries.join(", ") + "]";
        };
        ResultSet2.prototype.toJSON = function() {
          return {
            mathjs: "ResultSet",
            entries: this.entries
          };
        };
        ResultSet2.fromJSON = function(json) {
          return new ResultSet2(json.entries);
        };
        return ResultSet2;
      }, {
        isClass: true
      });
    }
  });

  // node_modules/mathjs/es/type/matrix/Range.js
  var name2, dependencies3, createRangeClass;
  var init_Range = __esm({
    "node_modules/mathjs/es/type/matrix/Range.js"() {
      init_is();
      init_number();
      init_factory();
      name2 = "Range";
      dependencies3 = [];
      createRangeClass = /* @__PURE__ */ factory(name2, dependencies3, function() {
        function Range3(start2, end, step) {
          if (!(this instanceof Range3)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          var hasStart = start2 !== null && start2 !== void 0;
          var hasEnd = end !== null && end !== void 0;
          var hasStep = step !== null && step !== void 0;
          if (hasStart) {
            if (isBigNumber(start2)) {
              start2 = start2.toNumber();
            } else if (typeof start2 !== "number") {
              throw new TypeError("Parameter start must be a number");
            }
          }
          if (hasEnd) {
            if (isBigNumber(end)) {
              end = end.toNumber();
            } else if (typeof end !== "number") {
              throw new TypeError("Parameter end must be a number");
            }
          }
          if (hasStep) {
            if (isBigNumber(step)) {
              step = step.toNumber();
            } else if (typeof step !== "number") {
              throw new TypeError("Parameter step must be a number");
            }
          }
          this.start = hasStart ? parseFloat(start2) : 0;
          this.end = hasEnd ? parseFloat(end) : 0;
          this.step = hasStep ? parseFloat(step) : 1;
        }
        Range3.prototype.type = "Range";
        Range3.prototype.isRange = true;
        Range3.parse = function(str) {
          if (typeof str !== "string") {
            return null;
          }
          var args = str.split(":");
          var nums = args.map(function(arg) {
            return parseFloat(arg);
          });
          var invalid = nums.some(function(num) {
            return isNaN(num);
          });
          if (invalid) {
            return null;
          }
          switch (nums.length) {
            case 2:
              return new Range3(nums[0], nums[1]);
            case 3:
              return new Range3(nums[0], nums[2], nums[1]);
            default:
              return null;
          }
        };
        Range3.prototype.clone = function() {
          return new Range3(this.start, this.end, this.step);
        };
        Range3.prototype.size = function() {
          var len = 0;
          var start2 = this.start;
          var step = this.step;
          var end = this.end;
          var diff = end - start2;
          if (sign(step) === sign(diff)) {
            len = Math.ceil(diff / step);
          } else if (diff === 0) {
            len = 0;
          }
          if (isNaN(len)) {
            len = 0;
          }
          return [len];
        };
        Range3.prototype.min = function() {
          var size2 = this.size()[0];
          if (size2 > 0) {
            if (this.step > 0) {
              return this.start;
            } else {
              return this.start + (size2 - 1) * this.step;
            }
          } else {
            return void 0;
          }
        };
        Range3.prototype.max = function() {
          var size2 = this.size()[0];
          if (size2 > 0) {
            if (this.step > 0) {
              return this.start + (size2 - 1) * this.step;
            } else {
              return this.start;
            }
          } else {
            return void 0;
          }
        };
        Range3.prototype.forEach = function(callback) {
          var x3 = this.start;
          var step = this.step;
          var end = this.end;
          var i3 = 0;
          if (step > 0) {
            while (x3 < end) {
              callback(x3, [i3], this);
              x3 += step;
              i3++;
            }
          } else if (step < 0) {
            while (x3 > end) {
              callback(x3, [i3], this);
              x3 += step;
              i3++;
            }
          }
        };
        Range3.prototype.map = function(callback) {
          var array = [];
          this.forEach(function(value, index2, obj) {
            array[index2[0]] = callback(value, index2, obj);
          });
          return array;
        };
        Range3.prototype.toArray = function() {
          var array = [];
          this.forEach(function(value, index2) {
            array[index2[0]] = value;
          });
          return array;
        };
        Range3.prototype.valueOf = function() {
          return this.toArray();
        };
        Range3.prototype.format = function(options) {
          var str = format(this.start, options);
          if (this.step !== 1) {
            str += ":" + format(this.step, options);
          }
          str += ":" + format(this.end, options);
          return str;
        };
        Range3.prototype.toString = function() {
          return this.format();
        };
        Range3.prototype.toJSON = function() {
          return {
            mathjs: "Range",
            start: this.start,
            end: this.end,
            step: this.step
          };
        };
        Range3.fromJSON = function(json) {
          return new Range3(json.start, json.end, json.step);
        };
        return Range3;
      }, {
        isClass: true
      });
    }
  });

  // node_modules/mathjs/es/expression/Help.js
  var name3, dependencies4, createHelpClass;
  var init_Help = __esm({
    "node_modules/mathjs/es/expression/Help.js"() {
      init_is();
      init_object();
      init_string();
      init_factory();
      name3 = "Help";
      dependencies4 = ["parse"];
      createHelpClass = /* @__PURE__ */ factory(name3, dependencies4, function(_ref) {
        var parse2 = _ref.parse;
        function Help2(doc) {
          if (!(this instanceof Help2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (!doc)
            throw new Error('Argument "doc" missing');
          this.doc = doc;
        }
        Help2.prototype.type = "Help";
        Help2.prototype.isHelp = true;
        Help2.prototype.toString = function() {
          var doc = this.doc || {};
          var desc = "\n";
          if (doc.name) {
            desc += "Name: " + doc.name + "\n\n";
          }
          if (doc.category) {
            desc += "Category: " + doc.category + "\n\n";
          }
          if (doc.description) {
            desc += "Description:\n    " + doc.description + "\n\n";
          }
          if (doc.syntax) {
            desc += "Syntax:\n    " + doc.syntax.join("\n    ") + "\n\n";
          }
          if (doc.examples) {
            desc += "Examples:\n";
            var scope = {};
            for (var i3 = 0; i3 < doc.examples.length; i3++) {
              var expr = doc.examples[i3];
              desc += "    " + expr + "\n";
              var res = void 0;
              try {
                res = parse2(expr).compile().evaluate(scope);
              } catch (e5) {
                res = e5;
              }
              if (res !== void 0 && !isHelp(res)) {
                desc += "        " + format3(res, {
                  precision: 14
                }) + "\n";
              }
            }
            desc += "\n";
          }
          if (doc.seealso && doc.seealso.length) {
            desc += "See also: " + doc.seealso.join(", ") + "\n";
          }
          return desc;
        };
        Help2.prototype.toJSON = function() {
          var obj = clone(this.doc);
          obj.mathjs = "Help";
          return obj;
        };
        Help2.fromJSON = function(json) {
          var doc = {};
          Object.keys(json).filter(function(prop) {
            return prop !== "mathjs";
          }).forEach(function(prop) {
            doc[prop] = json[prop];
          });
          return new Help2(doc);
        };
        Help2.prototype.valueOf = Help2.prototype.toString;
        return Help2;
      }, {
        isClass: true
      });
    }
  });

  // node_modules/mathjs/es/type/chain/Chain.js
  var name4, dependencies5, createChainClass;
  var init_Chain = __esm({
    "node_modules/mathjs/es/type/chain/Chain.js"() {
      init_is();
      init_string();
      init_object();
      init_factory();
      name4 = "Chain";
      dependencies5 = ["?on", "math"];
      createChainClass = /* @__PURE__ */ factory(name4, dependencies5, function(_ref) {
        var on = _ref.on, math2 = _ref.math;
        function Chain2(value) {
          if (!(this instanceof Chain2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (isChain(value)) {
            this.value = value.value;
          } else {
            this.value = value;
          }
        }
        Chain2.prototype.type = "Chain";
        Chain2.prototype.isChain = true;
        Chain2.prototype.done = function() {
          return this.value;
        };
        Chain2.prototype.valueOf = function() {
          return this.value;
        };
        Chain2.prototype.toString = function() {
          return format3(this.value);
        };
        Chain2.prototype.toJSON = function() {
          return {
            mathjs: "Chain",
            value: this.value
          };
        };
        Chain2.fromJSON = function(json) {
          return new Chain2(json.value);
        };
        function createProxy(name106, fn) {
          if (typeof fn === "function") {
            Chain2.prototype[name106] = chainify(fn);
          }
        }
        function createLazyProxy(name106, resolver) {
          lazy(Chain2.prototype, name106, function outerResolver() {
            var fn = resolver();
            if (typeof fn === "function") {
              return chainify(fn);
            }
            return void 0;
          });
        }
        function chainify(fn) {
          return function() {
            var args = [this.value];
            for (var i3 = 0; i3 < arguments.length; i3++) {
              args[i3 + 1] = arguments[i3];
            }
            return new Chain2(fn.apply(fn, args));
          };
        }
        Chain2.createProxy = function(arg0, arg1) {
          if (typeof arg0 === "string") {
            createProxy(arg0, arg1);
          } else {
            var _loop = function _loop2(_name2) {
              if (hasOwnProperty2(arg0, _name2) && excludedNames[_name2] === void 0) {
                createLazyProxy(_name2, function() {
                  return arg0[_name2];
                });
              }
            };
            for (var _name in arg0) {
              _loop(_name);
            }
          }
        };
        var excludedNames = {
          expression: true,
          docs: true,
          type: true,
          classes: true,
          json: true,
          error: true,
          isChain: true
        };
        Chain2.createProxy(math2);
        if (on) {
          on("import", function(name106, resolver, path) {
            if (!path) {
              createLazyProxy(name106, resolver);
            }
          });
        }
        return Chain2;
      }, {
        isClass: true
      });
    }
  });

  // node_modules/mathjs/es/utils/customs.js
  function _typeof4(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof4 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof4 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof4(obj);
  }
  function getSafeProperty(object, prop) {
    if (isPlainObject(object) && isSafeProperty(object, prop)) {
      return object[prop];
    }
    if (typeof object[prop] === "function" && isSafeMethod(object, prop)) {
      throw new Error('Cannot access method "' + prop + '" as a property');
    }
    throw new Error('No access to property "' + prop + '"');
  }
  function setSafeProperty(object, prop, value) {
    if (isPlainObject(object) && isSafeProperty(object, prop)) {
      object[prop] = value;
      return value;
    }
    throw new Error('No access to property "' + prop + '"');
  }
  function isSafeProperty(object, prop) {
    if (!object || _typeof4(object) !== "object") {
      return false;
    }
    if (hasOwnProperty2(safeNativeProperties, prop)) {
      return true;
    }
    if (prop in Object.prototype) {
      return false;
    }
    if (prop in Function.prototype) {
      return false;
    }
    return true;
  }
  function validateSafeMethod(object, method) {
    if (!isSafeMethod(object, method)) {
      throw new Error('No access to method "' + method + '"');
    }
  }
  function isSafeMethod(object, method) {
    if (object === null || object === void 0 || typeof object[method] !== "function") {
      return false;
    }
    if (hasOwnProperty2(object, method) && Object.getPrototypeOf && method in Object.getPrototypeOf(object)) {
      return false;
    }
    if (hasOwnProperty2(safeNativeMethods, method)) {
      return true;
    }
    if (method in Object.prototype) {
      return false;
    }
    if (method in Function.prototype) {
      return false;
    }
    return true;
  }
  function isPlainObject(object) {
    return _typeof4(object) === "object" && object && object.constructor === Object;
  }
  var safeNativeProperties, safeNativeMethods;
  var init_customs = __esm({
    "node_modules/mathjs/es/utils/customs.js"() {
      init_object();
      safeNativeProperties = {
        length: true,
        name: true
      };
      safeNativeMethods = {
        toString: true,
        valueOf: true,
        toLocaleString: true
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/bignumber.js
  var bignumberDocs;
  var init_bignumber = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/bignumber.js"() {
      bignumberDocs = {
        name: "bignumber",
        category: "Construction",
        syntax: ["bignumber(x)"],
        description: "Create a big number from a number or string.",
        examples: ["0.1 + 0.2", "bignumber(0.1) + bignumber(0.2)", 'bignumber("7.2")', 'bignumber("7.2e500")', "bignumber([0.1, 0.2, 0.3])"],
        seealso: ["boolean", "complex", "fraction", "index", "matrix", "string", "unit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/typeOf.js
  var typeOfDocs;
  var init_typeOf = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/typeOf.js"() {
      typeOfDocs = {
        name: "typeOf",
        category: "Utils",
        syntax: ["typeOf(x)"],
        description: "Get the type of a variable.",
        examples: ["typeOf(3.5)", "typeOf(2 - 4i)", "typeOf(45 deg)", 'typeOf("hello world")'],
        seealso: ["getMatrixDataType"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/isZero.js
  var isZeroDocs;
  var init_isZero = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/isZero.js"() {
      isZeroDocs = {
        name: "isZero",
        category: "Utils",
        syntax: ["isZero(x)"],
        description: "Test whether a value is zero.",
        examples: ["isZero(2)", "isZero(0)", "isZero(-4)", "isZero([3, 0, -2, 0])"],
        seealso: ["isInteger", "isNumeric", "isNegative", "isPositive"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/isPrime.js
  var isPrimeDocs;
  var init_isPrime = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/isPrime.js"() {
      isPrimeDocs = {
        name: "isPrime",
        category: "Utils",
        syntax: ["isPrime(x)"],
        description: "Test whether a value is prime: has no divisors other than itself and one.",
        examples: ["isPrime(3)", "isPrime(-2)", "isPrime([2, 17, 100])"],
        seealso: ["isInteger", "isNumeric", "isNegative", "isZero"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/isPositive.js
  var isPositiveDocs;
  var init_isPositive = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/isPositive.js"() {
      isPositiveDocs = {
        name: "isPositive",
        category: "Utils",
        syntax: ["isPositive(x)"],
        description: "Test whether a value is positive: larger than zero.",
        examples: ["isPositive(2)", "isPositive(0)", "isPositive(-4)", "isPositive([3, 0.5, -2])"],
        seealso: ["isInteger", "isNumeric", "isNegative", "isZero"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/isNumeric.js
  var isNumericDocs;
  var init_isNumeric = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/isNumeric.js"() {
      isNumericDocs = {
        name: "isNumeric",
        category: "Utils",
        syntax: ["isNumeric(x)"],
        description: "Test whether a value is a numeric value. Returns true when the input is a number, BigNumber, Fraction, or boolean.",
        examples: ["isNumeric(2)", 'isNumeric("2")', 'hasNumericValue("2")', "isNumeric(0)", "isNumeric(bignumber(500))", "isNumeric(fraction(0.125))", "isNumeric(2 + 3i)", 'isNumeric([2.3, "foo", false])'],
        seealso: ["isInteger", "isZero", "isNegative", "isPositive", "isNaN", "hasNumericValue"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/hasNumericValue.js
  var hasNumericValueDocs;
  var init_hasNumericValue = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/hasNumericValue.js"() {
      hasNumericValueDocs = {
        name: "hasNumericValue",
        category: "Utils",
        syntax: ["hasNumericValue(x)"],
        description: "Test whether a value is an numeric value. In case of a string, true is returned if the string contains a numeric value.",
        examples: ["hasNumericValue(2)", 'hasNumericValue("2")', 'isNumeric("2")', "hasNumericValue(0)", "hasNumericValue(bignumber(500))", "hasNumericValue(fraction(0.125))", "hasNumericValue(2 + 3i)", 'hasNumericValue([2.3, "foo", false])'],
        seealso: ["isInteger", "isZero", "isNegative", "isPositive", "isNaN", "isNumeric"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/isNegative.js
  var isNegativeDocs;
  var init_isNegative = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/isNegative.js"() {
      isNegativeDocs = {
        name: "isNegative",
        category: "Utils",
        syntax: ["isNegative(x)"],
        description: "Test whether a value is negative: smaller than zero.",
        examples: ["isNegative(2)", "isNegative(0)", "isNegative(-4)", "isNegative([3, 0.5, -2])"],
        seealso: ["isInteger", "isNumeric", "isPositive", "isZero"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/isInteger.js
  var isIntegerDocs;
  var init_isInteger = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/isInteger.js"() {
      isIntegerDocs = {
        name: "isInteger",
        category: "Utils",
        syntax: ["isInteger(x)"],
        description: "Test whether a value is an integer number.",
        examples: ["isInteger(2)", "isInteger(3.5)", "isInteger([3, 0.5, -2])"],
        seealso: ["isNegative", "isNumeric", "isPositive", "isZero"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/isNaN.js
  var isNaNDocs;
  var init_isNaN = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/isNaN.js"() {
      isNaNDocs = {
        name: "isNaN",
        category: "Utils",
        syntax: ["isNaN(x)"],
        description: "Test whether a value is NaN (not a number)",
        examples: ["isNaN(2)", "isNaN(0 / 0)", "isNaN(NaN)", "isNaN(Infinity)"],
        seealso: ["isNegative", "isNumeric", "isPositive", "isZero"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/format.js
  var formatDocs;
  var init_format = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/format.js"() {
      formatDocs = {
        name: "format",
        category: "Utils",
        syntax: ["format(value)", "format(value, precision)"],
        description: "Format a value of any type as string.",
        examples: ["format(2.3)", "format(3 - 4i)", "format([])", "format(pi, 3)"],
        seealso: ["print"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/bin.js
  var binDocs;
  var init_bin = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/bin.js"() {
      binDocs = {
        name: "bin",
        category: "Utils",
        syntax: ["bin(value)"],
        description: "Format a number as binary",
        examples: ["bin(2)"],
        seealso: ["oct", "hex"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/oct.js
  var octDocs;
  var init_oct = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/oct.js"() {
      octDocs = {
        name: "oct",
        category: "Utils",
        syntax: ["oct(value)"],
        description: "Format a number as octal",
        examples: ["oct(56)"],
        seealso: ["bin", "hex"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/hex.js
  var hexDocs;
  var init_hex = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/hex.js"() {
      hexDocs = {
        name: "hex",
        category: "Utils",
        syntax: ["hex(value)"],
        description: "Format a number as hexadecimal",
        examples: ["hex(240)"],
        seealso: ["bin", "oct"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/clone.js
  var cloneDocs;
  var init_clone = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/clone.js"() {
      cloneDocs = {
        name: "clone",
        category: "Utils",
        syntax: ["clone(x)"],
        description: "Clone a variable. Creates a copy of primitive variables,and a deep copy of matrices",
        examples: ["clone(3.5)", "clone(2 - 4i)", "clone(45 deg)", "clone([1, 2; 3, 4])", 'clone("hello world")'],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/units/to.js
  var toDocs;
  var init_to = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/units/to.js"() {
      toDocs = {
        name: "to",
        category: "Units",
        syntax: ["x to unit", "to(x, unit)"],
        description: "Change the unit of a value.",
        examples: ["5 inch to cm", "3.2kg to g", "16 bytes in bits"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/tanh.js
  var tanhDocs;
  var init_tanh = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/tanh.js"() {
      tanhDocs = {
        name: "tanh",
        category: "Trigonometry",
        syntax: ["tanh(x)"],
        description: "Compute the hyperbolic tangent of x in radians.",
        examples: ["tanh(0.5)", "sinh(0.5) / cosh(0.5)"],
        seealso: ["sinh", "cosh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/tan.js
  var tanDocs;
  var init_tan = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/tan.js"() {
      tanDocs = {
        name: "tan",
        category: "Trigonometry",
        syntax: ["tan(x)"],
        description: "Compute the tangent of x in radians.",
        examples: ["tan(0.5)", "sin(0.5) / cos(0.5)", "tan(pi / 4)", "tan(45 deg)"],
        seealso: ["atan", "sin", "cos"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sinh.js
  var sinhDocs;
  var init_sinh = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sinh.js"() {
      sinhDocs = {
        name: "sinh",
        category: "Trigonometry",
        syntax: ["sinh(x)"],
        description: "Compute the hyperbolic sine of x in radians.",
        examples: ["sinh(0.5)"],
        seealso: ["cosh", "tanh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sech.js
  var sechDocs;
  var init_sech = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sech.js"() {
      sechDocs = {
        name: "sech",
        category: "Trigonometry",
        syntax: ["sech(x)"],
        description: "Compute the hyperbolic secant of x in radians. Defined as 1/cosh(x)",
        examples: ["sech(2)", "1 / cosh(2)"],
        seealso: ["coth", "csch", "cosh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sec.js
  var secDocs;
  var init_sec = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sec.js"() {
      secDocs = {
        name: "sec",
        category: "Trigonometry",
        syntax: ["sec(x)"],
        description: "Compute the secant of x in radians. Defined as 1/cos(x)",
        examples: ["sec(2)", "1 / cos(2)"],
        seealso: ["cot", "csc", "cos"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/csch.js
  var cschDocs;
  var init_csch = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/csch.js"() {
      cschDocs = {
        name: "csch",
        category: "Trigonometry",
        syntax: ["csch(x)"],
        description: "Compute the hyperbolic cosecant of x in radians. Defined as 1/sinh(x)",
        examples: ["csch(2)", "1 / sinh(2)"],
        seealso: ["sech", "coth", "sinh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/csc.js
  var cscDocs;
  var init_csc = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/csc.js"() {
      cscDocs = {
        name: "csc",
        category: "Trigonometry",
        syntax: ["csc(x)"],
        description: "Compute the cosecant of x in radians. Defined as 1/sin(x)",
        examples: ["csc(2)", "1 / sin(2)"],
        seealso: ["sec", "cot", "sin"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/coth.js
  var cothDocs;
  var init_coth = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/coth.js"() {
      cothDocs = {
        name: "coth",
        category: "Trigonometry",
        syntax: ["coth(x)"],
        description: "Compute the hyperbolic cotangent of x in radians.",
        examples: ["coth(2)", "1 / tanh(2)"],
        seealso: ["sech", "csch", "tanh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/cot.js
  var cotDocs;
  var init_cot = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/cot.js"() {
      cotDocs = {
        name: "cot",
        category: "Trigonometry",
        syntax: ["cot(x)"],
        description: "Compute the cotangent of x in radians. Defined as 1/tan(x)",
        examples: ["cot(2)", "1 / tan(2)"],
        seealso: ["sec", "csc", "tan"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/cosh.js
  var coshDocs;
  var init_cosh = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/cosh.js"() {
      coshDocs = {
        name: "cosh",
        category: "Trigonometry",
        syntax: ["cosh(x)"],
        description: "Compute the hyperbolic cosine of x in radians.",
        examples: ["cosh(0.5)"],
        seealso: ["sinh", "tanh", "coth"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/cos.js
  var cosDocs;
  var init_cos = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/cos.js"() {
      cosDocs = {
        name: "cos",
        category: "Trigonometry",
        syntax: ["cos(x)"],
        description: "Compute the cosine of x in radians.",
        examples: ["cos(2)", "cos(pi / 4) ^ 2", "cos(180 deg)", "cos(60 deg)", "sin(0.2)^2 + cos(0.2)^2"],
        seealso: ["acos", "sin", "tan"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/atan2.js
  var atan2Docs;
  var init_atan2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/atan2.js"() {
      atan2Docs = {
        name: "atan2",
        category: "Trigonometry",
        syntax: ["atan2(y, x)"],
        description: "Computes the principal value of the arc tangent of y/x in radians.",
        examples: ["atan2(2, 2) / pi", "angle = 60 deg in rad", "x = cos(angle)", "y = sin(angle)", "atan2(y, x)"],
        seealso: ["sin", "cos", "tan"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/atanh.js
  var atanhDocs;
  var init_atanh = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/atanh.js"() {
      atanhDocs = {
        name: "atanh",
        category: "Trigonometry",
        syntax: ["atanh(x)"],
        description: "Calculate the hyperbolic arctangent of a value, defined as `atanh(x) = ln((1 + x)/(1 - x)) / 2`.",
        examples: ["atanh(0.5)"],
        seealso: ["acosh", "asinh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/atan.js
  var atanDocs;
  var init_atan = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/atan.js"() {
      atanDocs = {
        name: "atan",
        category: "Trigonometry",
        syntax: ["atan(x)"],
        description: "Compute the inverse tangent of a value in radians.",
        examples: ["atan(0.5)", "atan(tan(0.5))"],
        seealso: ["tan", "acos", "asin"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asinh.js
  var asinhDocs;
  var init_asinh = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asinh.js"() {
      asinhDocs = {
        name: "asinh",
        category: "Trigonometry",
        syntax: ["asinh(x)"],
        description: "Calculate the hyperbolic arcsine of a value, defined as `asinh(x) = ln(x + sqrt(x^2 + 1))`.",
        examples: ["asinh(0.5)"],
        seealso: ["acosh", "atanh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asin.js
  var asinDocs;
  var init_asin = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asin.js"() {
      asinDocs = {
        name: "asin",
        category: "Trigonometry",
        syntax: ["asin(x)"],
        description: "Compute the inverse sine of a value in radians.",
        examples: ["asin(0.5)", "asin(sin(0.5))"],
        seealso: ["sin", "acos", "atan"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asech.js
  var asechDocs;
  var init_asech = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asech.js"() {
      asechDocs = {
        name: "asech",
        category: "Trigonometry",
        syntax: ["asech(x)"],
        description: "Calculate the inverse secant of a value.",
        examples: ["asech(0.5)"],
        seealso: ["acsch", "acoth"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asec.js
  var asecDocs;
  var init_asec = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/asec.js"() {
      asecDocs = {
        name: "asec",
        category: "Trigonometry",
        syntax: ["asec(x)"],
        description: "Calculate the inverse secant of a value.",
        examples: ["asec(0.5)", "asec(sec(0.5))", "asec(2)"],
        seealso: ["acos", "acot", "acsc"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acsch.js
  var acschDocs;
  var init_acsch = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acsch.js"() {
      acschDocs = {
        name: "acsch",
        category: "Trigonometry",
        syntax: ["acsch(x)"],
        description: "Calculate the hyperbolic arccosecant of a value, defined as `acsch(x) = ln(1/x + sqrt(1/x^2 + 1))`.",
        examples: ["acsch(0.5)"],
        seealso: ["asech", "acoth"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acsc.js
  var acscDocs;
  var init_acsc = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acsc.js"() {
      acscDocs = {
        name: "acsc",
        category: "Trigonometry",
        syntax: ["acsc(x)"],
        description: "Calculate the inverse cotangent of a value.",
        examples: ["acsc(2)", "acsc(csc(0.5))", "acsc(0.5)"],
        seealso: ["csc", "asin", "asec"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acoth.js
  var acothDocs;
  var init_acoth = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acoth.js"() {
      acothDocs = {
        name: "acoth",
        category: "Trigonometry",
        syntax: ["acoth(x)"],
        description: "Calculate the hyperbolic arccotangent of a value, defined as `acoth(x) = (ln((x+1)/x) + ln(x/(x-1))) / 2`.",
        examples: ["acoth(2)", "acoth(0.5)"],
        seealso: ["acsch", "asech"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acot.js
  var acotDocs;
  var init_acot = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acot.js"() {
      acotDocs = {
        name: "acot",
        category: "Trigonometry",
        syntax: ["acot(x)"],
        description: "Calculate the inverse cotangent of a value.",
        examples: ["acot(0.5)", "acot(cot(0.5))", "acot(2)"],
        seealso: ["cot", "atan"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acosh.js
  var acoshDocs;
  var init_acosh = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acosh.js"() {
      acoshDocs = {
        name: "acosh",
        category: "Trigonometry",
        syntax: ["acosh(x)"],
        description: "Calculate the hyperbolic arccos of a value, defined as `acosh(x) = ln(sqrt(x^2 - 1) + x)`.",
        examples: ["acosh(1.5)"],
        seealso: ["cosh", "asinh", "atanh"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acos.js
  var acosDocs;
  var init_acos = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/acos.js"() {
      acosDocs = {
        name: "acos",
        category: "Trigonometry",
        syntax: ["acos(x)"],
        description: "Compute the inverse cosine of a value in radians.",
        examples: ["acos(0.5)", "acos(cos(2.3))"],
        seealso: ["cos", "atan", "asin"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/sum.js
  var sumDocs;
  var init_sum = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/sum.js"() {
      sumDocs = {
        name: "sum",
        category: "Statistics",
        syntax: ["sum(a, b, c, ...)", "sum(A)"],
        description: "Compute the sum of all values.",
        examples: ["sum(2, 3, 4, 1)", "sum([2, 3, 4, 1])", "sum([2, 5; 4, 3])"],
        seealso: ["max", "mean", "median", "min", "prod", "std", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/std.js
  var stdDocs;
  var init_std = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/std.js"() {
      stdDocs = {
        name: "std",
        category: "Statistics",
        syntax: ["std(a, b, c, ...)", "std(A)", "std(A, normalization)"],
        description: 'Compute the standard deviation of all values, defined as std(A) = sqrt(variance(A)). Optional parameter normalization can be "unbiased" (default), "uncorrected", or "biased".',
        examples: ["std(2, 4, 6)", "std([2, 4, 6, 8])", 'std([2, 4, 6, 8], "uncorrected")', 'std([2, 4, 6, 8], "biased")', "std([1, 2, 3; 4, 5, 6])"],
        seealso: ["max", "mean", "min", "median", "prod", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/quantileSeq.js
  var quantileSeqDocs;
  var init_quantileSeq = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/quantileSeq.js"() {
      quantileSeqDocs = {
        name: "quantileSeq",
        category: "Statistics",
        syntax: ["quantileSeq(A, prob[, sorted])", "quantileSeq(A, [prob1, prob2, ...][, sorted])", "quantileSeq(A, N[, sorted])"],
        description: "Compute the prob order quantile of a matrix or a list with values. The sequence is sorted and the middle value is returned. Supported types of sequence values are: Number, BigNumber, Unit Supported types of probablity are: Number, BigNumber. \n\nIn case of a (multi dimensional) array or matrix, the prob order quantile of all elements will be calculated.",
        examples: ["quantileSeq([3, -1, 5, 7], 0.5)", "quantileSeq([3, -1, 5, 7], [1/3, 2/3])", "quantileSeq([3, -1, 5, 7], 2)", "quantileSeq([-1, 3, 5, 7], 0.5, true)"],
        seealso: ["mean", "median", "min", "max", "prod", "std", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/prod.js
  var prodDocs;
  var init_prod = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/prod.js"() {
      prodDocs = {
        name: "prod",
        category: "Statistics",
        syntax: ["prod(a, b, c, ...)", "prod(A)"],
        description: "Compute the product of all values.",
        examples: ["prod(2, 3, 4)", "prod([2, 3, 4])", "prod([2, 5; 4, 3])"],
        seealso: ["max", "mean", "min", "median", "min", "std", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/mode.js
  var modeDocs;
  var init_mode = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/mode.js"() {
      modeDocs = {
        name: "mode",
        category: "Statistics",
        syntax: ["mode(a, b, c, ...)", "mode(A)", "mode(A, a, b, B, c, ...)"],
        description: "Computes the mode of all values as an array. In case mode being more than one, multiple values are returned in an array.",
        examples: ["mode(2, 1, 4, 3, 1)", "mode([1, 2.7, 3.2, 4, 2.7])", "mode(1, 4, 6, 1, 6)"],
        seealso: ["max", "mean", "min", "median", "prod", "std", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/min.js
  var minDocs;
  var init_min = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/min.js"() {
      minDocs = {
        name: "min",
        category: "Statistics",
        syntax: ["min(a, b, c, ...)", "min(A)", "min(A, dim)"],
        description: "Compute the minimum value of a list of values.",
        examples: ["min(2, 3, 4, 1)", "min([2, 3, 4, 1])", "min([2, 5; 4, 3])", "min([2, 5; 4, 3], 1)", "min([2, 5; 4, 3], 2)", "min(2.7, 7.1, -4.5, 2.0, 4.1)", "max(2.7, 7.1, -4.5, 2.0, 4.1)"],
        seealso: ["max", "mean", "median", "prod", "std", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/median.js
  var medianDocs;
  var init_median = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/median.js"() {
      medianDocs = {
        name: "median",
        category: "Statistics",
        syntax: ["median(a, b, c, ...)", "median(A)"],
        description: "Compute the median of all values. The values are sorted and the middle value is returned. In case of an even number of values, the average of the two middle values is returned.",
        examples: ["median(5, 2, 7)", "median([3, -1, 5, 7])"],
        seealso: ["max", "mean", "min", "prod", "std", "sum", "variance", "quantileSeq"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/mean.js
  var meanDocs;
  var init_mean = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/mean.js"() {
      meanDocs = {
        name: "mean",
        category: "Statistics",
        syntax: ["mean(a, b, c, ...)", "mean(A)", "mean(A, dim)"],
        description: "Compute the arithmetic mean of a list of values.",
        examples: ["mean(2, 3, 4, 1)", "mean([2, 3, 4, 1])", "mean([2, 5; 4, 3])", "mean([2, 5; 4, 3], 1)", "mean([2, 5; 4, 3], 2)", "mean([1.0, 2.7, 3.2, 4.0])"],
        seealso: ["max", "median", "min", "prod", "std", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/max.js
  var maxDocs;
  var init_max = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/max.js"() {
      maxDocs = {
        name: "max",
        category: "Statistics",
        syntax: ["max(a, b, c, ...)", "max(A)", "max(A, dim)"],
        description: "Compute the maximum value of a list of values.",
        examples: ["max(2, 3, 4, 1)", "max([2, 3, 4, 1])", "max([2, 5; 4, 3])", "max([2, 5; 4, 3], 1)", "max([2, 5; 4, 3], 2)", "max(2.7, 7.1, -4.5, 2.0, 4.1)", "min(2.7, 7.1, -4.5, 2.0, 4.1)"],
        seealso: ["mean", "median", "min", "prod", "std", "sum", "variance"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/mad.js
  var madDocs;
  var init_mad = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/mad.js"() {
      madDocs = {
        name: "mad",
        category: "Statistics",
        syntax: ["mad(a, b, c, ...)", "mad(A)"],
        description: "Compute the median absolute deviation of a matrix or a list with values. The median absolute deviation is defined as the median of the absolute deviations from the median.",
        examples: ["mad(10, 20, 30)", "mad([1, 2, 3])"],
        seealso: ["mean", "median", "std", "abs"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/special/erf.js
  var erfDocs;
  var init_erf = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/special/erf.js"() {
      erfDocs = {
        name: "erf",
        category: "Special",
        syntax: ["erf(x)"],
        description: "Compute the erf function of a value using a rational Chebyshev approximations for different intervals of x",
        examples: ["erf(0.2)", "erf(-0.5)", "erf(4)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setUnion.js
  var setUnionDocs;
  var init_setUnion = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setUnion.js"() {
      setUnionDocs = {
        name: "setUnion",
        category: "Set",
        syntax: ["setUnion(set1, set2)"],
        description: "Create the union of two (multi)sets. Multi-dimension arrays will be converted to single-dimension arrays before the operation.",
        examples: ["setUnion([1, 2, 3, 4], [3, 4, 5, 6])", "setUnion([[1, 2], [3, 4]], [[3, 4], [5, 6]])"],
        seealso: ["setIntersect", "setDifference"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setSymDifference.js
  var setSymDifferenceDocs;
  var init_setSymDifference = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setSymDifference.js"() {
      setSymDifferenceDocs = {
        name: "setSymDifference",
        category: "Set",
        syntax: ["setSymDifference(set1, set2)"],
        description: "Create the symmetric difference of two (multi)sets. Multi-dimension arrays will be converted to single-dimension arrays before the operation.",
        examples: ["setSymDifference([1, 2, 3, 4], [3, 4, 5, 6])", "setSymDifference([[1, 2], [3, 4]], [[3, 4], [5, 6]])"],
        seealso: ["setUnion", "setIntersect", "setDifference"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setSize.js
  var setSizeDocs;
  var init_setSize = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setSize.js"() {
      setSizeDocs = {
        name: "setSize",
        category: "Set",
        syntax: ["setSize(set)", "setSize(set, unique)"],
        description: 'Count the number of elements of a (multi)set. When the second parameter "unique" is true, count only the unique values. A multi-dimension array will be converted to a single-dimension array before the operation.',
        examples: ["setSize([1, 2, 2, 4])", "setSize([1, 2, 2, 4], true)"],
        seealso: ["setUnion", "setIntersect", "setDifference"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setPowerset.js
  var setPowersetDocs;
  var init_setPowerset = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setPowerset.js"() {
      setPowersetDocs = {
        name: "setPowerset",
        category: "Set",
        syntax: ["setPowerset(set)"],
        description: "Create the powerset of a (multi)set: the powerset contains very possible subsets of a (multi)set. A multi-dimension array will be converted to a single-dimension array before the operation.",
        examples: ["setPowerset([1, 2, 3])"],
        seealso: ["setCartesian"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setMultiplicity.js
  var setMultiplicityDocs;
  var init_setMultiplicity = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setMultiplicity.js"() {
      setMultiplicityDocs = {
        name: "setMultiplicity",
        category: "Set",
        syntax: ["setMultiplicity(element, set)"],
        description: "Count the multiplicity of an element in a multiset. A multi-dimension array will be converted to a single-dimension array before the operation.",
        examples: ["setMultiplicity(1, [1, 2, 2, 4])", "setMultiplicity(2, [1, 2, 2, 4])"],
        seealso: ["setDistinct", "setSize"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setIsSubset.js
  var setIsSubsetDocs;
  var init_setIsSubset = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setIsSubset.js"() {
      setIsSubsetDocs = {
        name: "setIsSubset",
        category: "Set",
        syntax: ["setIsSubset(set1, set2)"],
        description: "Check whether a (multi)set is a subset of another (multi)set: every element of set1 is the element of set2. Multi-dimension arrays will be converted to single-dimension arrays before the operation.",
        examples: ["setIsSubset([1, 2], [3, 4, 5, 6])", "setIsSubset([3, 4], [3, 4, 5, 6])"],
        seealso: ["setUnion", "setIntersect", "setDifference"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setIntersect.js
  var setIntersectDocs;
  var init_setIntersect = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setIntersect.js"() {
      setIntersectDocs = {
        name: "setIntersect",
        category: "Set",
        syntax: ["setIntersect(set1, set2)"],
        description: "Create the intersection of two (multi)sets. Multi-dimension arrays will be converted to single-dimension arrays before the operation.",
        examples: ["setIntersect([1, 2, 3, 4], [3, 4, 5, 6])", "setIntersect([[1, 2], [3, 4]], [[3, 4], [5, 6]])"],
        seealso: ["setUnion", "setDifference"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setDistinct.js
  var setDistinctDocs;
  var init_setDistinct = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setDistinct.js"() {
      setDistinctDocs = {
        name: "setDistinct",
        category: "Set",
        syntax: ["setDistinct(set)"],
        description: "Collect the distinct elements of a multiset. A multi-dimension array will be converted to a single-dimension array before the operation.",
        examples: ["setDistinct([1, 1, 1, 2, 2, 3])"],
        seealso: ["setMultiplicity"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setDifference.js
  var setDifferenceDocs;
  var init_setDifference = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setDifference.js"() {
      setDifferenceDocs = {
        name: "setDifference",
        category: "Set",
        syntax: ["setDifference(set1, set2)"],
        description: "Create the difference of two (multi)sets: every element of set1, that is not the element of set2. Multi-dimension arrays will be converted to single-dimension arrays before the operation.",
        examples: ["setDifference([1, 2, 3, 4], [3, 4, 5, 6])", "setDifference([[1, 2], [3, 4]], [[3, 4], [5, 6]])"],
        seealso: ["setUnion", "setIntersect", "setSymDifference"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/set/setCartesian.js
  var setCartesianDocs;
  var init_setCartesian = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/set/setCartesian.js"() {
      setCartesianDocs = {
        name: "setCartesian",
        category: "Set",
        syntax: ["setCartesian(set1, set2)"],
        description: "Create the cartesian product of two (multi)sets. Multi-dimension arrays will be converted to single-dimension arrays before the operation.",
        examples: ["setCartesian([1, 2], [3, 4])"],
        seealso: ["setUnion", "setIntersect", "setDifference", "setPowerset"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/unequal.js
  var unequalDocs;
  var init_unequal = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/unequal.js"() {
      unequalDocs = {
        name: "unequal",
        category: "Relational",
        syntax: ["x != y", "unequal(x, y)"],
        description: "Check unequality of two values. Returns true if the values are unequal, and false if they are equal.",
        examples: ["2+2 != 3", "2+2 != 4", "a = 3.2", "b = 6-2.8", "a != b", "50cm != 0.5m", "5 cm != 2 inch"],
        seealso: ["equal", "smaller", "larger", "smallerEq", "largerEq", "compare", "deepEqual"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/smallerEq.js
  var smallerEqDocs;
  var init_smallerEq = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/smallerEq.js"() {
      smallerEqDocs = {
        name: "smallerEq",
        category: "Relational",
        syntax: ["x <= y", "smallerEq(x, y)"],
        description: "Check if value x is smaller or equal to value y. Returns true if x is smaller than y, and false if not.",
        examples: ["2 <= 1+1", "2 < 1+1", "a = 3.2", "b = 6-2.8", "(a <= b)"],
        seealso: ["equal", "unequal", "larger", "smaller", "largerEq", "compare"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/smaller.js
  var smallerDocs;
  var init_smaller = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/smaller.js"() {
      smallerDocs = {
        name: "smaller",
        category: "Relational",
        syntax: ["x < y", "smaller(x, y)"],
        description: "Check if value x is smaller than value y. Returns true if x is smaller than y, and false if not.",
        examples: ["2 < 3", "5 < 2*2", "a = 3.3", "b = 6-2.8", "(a < b)", "5 cm < 2 inch"],
        seealso: ["equal", "unequal", "larger", "smallerEq", "largerEq", "compare"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/largerEq.js
  var largerEqDocs;
  var init_largerEq = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/largerEq.js"() {
      largerEqDocs = {
        name: "largerEq",
        category: "Relational",
        syntax: ["x >= y", "largerEq(x, y)"],
        description: "Check if value x is larger or equal to y. Returns true if x is larger or equal to y, and false if not.",
        examples: ["2 >= 1+1", "2 > 1+1", "a = 3.2", "b = 6-2.8", "(a >= b)"],
        seealso: ["equal", "unequal", "smallerEq", "smaller", "compare"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/larger.js
  var largerDocs;
  var init_larger = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/larger.js"() {
      largerDocs = {
        name: "larger",
        category: "Relational",
        syntax: ["x > y", "larger(x, y)"],
        description: "Check if value x is larger than y. Returns true if x is larger than y, and false if not.",
        examples: ["2 > 3", "5 > 2*2", "a = 3.3", "b = 6-2.8", "(a > b)", "(b < a)", "5 cm > 2 inch"],
        seealso: ["equal", "unequal", "smaller", "smallerEq", "largerEq", "compare"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/equalText.js
  var equalTextDocs;
  var init_equalText = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/equalText.js"() {
      equalTextDocs = {
        name: "equalText",
        category: "Relational",
        syntax: ["equalText(x, y)"],
        description: "Check equality of two strings. Comparison is case sensitive. Returns true if the values are equal, and false if not.",
        examples: ['equalText("Hello", "Hello")', 'equalText("a", "A")', 'equal("2e3", "2000")', 'equalText("2e3", "2000")', 'equalText("B", ["A", "B", "C"])'],
        seealso: ["compare", "compareNatural", "compareText", "equal"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/equal.js
  var equalDocs;
  var init_equal = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/equal.js"() {
      equalDocs = {
        name: "equal",
        category: "Relational",
        syntax: ["x == y", "equal(x, y)"],
        description: "Check equality of two values. Returns true if the values are equal, and false if not.",
        examples: ["2+2 == 3", "2+2 == 4", "a = 3.2", "b = 6-2.8", "a == b", "50cm == 0.5m"],
        seealso: ["unequal", "smaller", "larger", "smallerEq", "largerEq", "compare", "deepEqual", "equalText"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/deepEqual.js
  var deepEqualDocs;
  var init_deepEqual = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/deepEqual.js"() {
      deepEqualDocs = {
        name: "deepEqual",
        category: "Relational",
        syntax: ["deepEqual(x, y)"],
        description: "Check equality of two matrices element wise. Returns true if the size of both matrices is equal and when and each of the elements are equal.",
        examples: ["deepEqual([1,3,4], [1,3,4])", "deepEqual([1,3,4], [1,3])"],
        seealso: ["equal", "unequal", "smaller", "larger", "smallerEq", "largerEq", "compare"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/compareText.js
  var compareTextDocs;
  var init_compareText = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/compareText.js"() {
      compareTextDocs = {
        name: "compareText",
        category: "Relational",
        syntax: ["compareText(x, y)"],
        description: "Compare two strings lexically. Comparison is case sensitive. Returns 1 when x > y, -1 when x < y, and 0 when x == y.",
        examples: ['compareText("B", "A")', 'compareText("A", "B")', 'compareText("A", "A")', 'compareText("2", "10")', 'compare("2", "10")', "compare(2, 10)", 'compareNatural("2", "10")', 'compareText("B", ["A", "B", "C"])'],
        seealso: ["compare", "compareNatural"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/compareNatural.js
  var compareNaturalDocs;
  var init_compareNatural = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/compareNatural.js"() {
      compareNaturalDocs = {
        name: "compareNatural",
        category: "Relational",
        syntax: ["compareNatural(x, y)"],
        description: "Compare two values of any type in a deterministic, natural way. Returns 1 when x > y, -1 when x < y, and 0 when x == y.",
        examples: ["compareNatural(2, 3)", "compareNatural(3, 2)", "compareNatural(2, 2)", "compareNatural(5cm, 40mm)", 'compareNatural("2", "10")', "compareNatural(2 + 3i, 2 + 4i)", "compareNatural([1, 2, 4], [1, 2, 3])", "compareNatural([1, 5], [1, 2, 3])", "compareNatural([1, 2], [1, 2])", "compareNatural({a: 2}, {a: 4})"],
        seealso: ["equal", "unequal", "smaller", "smallerEq", "largerEq", "compare", "compareText"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/relational/compare.js
  var compareDocs;
  var init_compare = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/relational/compare.js"() {
      compareDocs = {
        name: "compare",
        category: "Relational",
        syntax: ["compare(x, y)"],
        description: "Compare two values. Returns 1 when x > y, -1 when x < y, and 0 when x == y.",
        examples: ["compare(2, 3)", "compare(3, 2)", "compare(2, 2)", "compare(5cm, 40mm)", "compare(2, [1, 2, 3])"],
        seealso: ["equal", "unequal", "smaller", "smallerEq", "largerEq", "compareNatural", "compareText"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/randomInt.js
  var randomIntDocs;
  var init_randomInt = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/randomInt.js"() {
      randomIntDocs = {
        name: "randomInt",
        category: "Probability",
        syntax: ["randomInt(max)", "randomInt(min, max)", "randomInt(size)", "randomInt(size, max)", "randomInt(size, min, max)"],
        description: "Return a random integer number",
        examples: ["randomInt(10, 20)", "randomInt([2, 3], 10)"],
        seealso: ["pickRandom", "random"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/random.js
  var randomDocs;
  var init_random = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/random.js"() {
      randomDocs = {
        name: "random",
        category: "Probability",
        syntax: ["random()", "random(max)", "random(min, max)", "random(size)", "random(size, max)", "random(size, min, max)"],
        description: "Return a random number.",
        examples: ["random()", "random(10, 20)", "random([2, 3])"],
        seealso: ["pickRandom", "randomInt"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/pickRandom.js
  var pickRandomDocs;
  var init_pickRandom = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/pickRandom.js"() {
      pickRandomDocs = {
        name: "pickRandom",
        category: "Probability",
        syntax: ["pickRandom(array)", "pickRandom(array, number)", "pickRandom(array, weights)", "pickRandom(array, number, weights)", "pickRandom(array, weights, number)"],
        description: "Pick a random entry from a given array.",
        examples: ["pickRandom(0:10)", "pickRandom([1, 3, 1, 6])", "pickRandom([1, 3, 1, 6], 2)", "pickRandom([1, 3, 1, 6], [2, 3, 2, 1])", "pickRandom([1, 3, 1, 6], 2, [2, 3, 2, 1])", "pickRandom([1, 3, 1, 6], [2, 3, 2, 1], 2)"],
        seealso: ["random", "randomInt"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/permutations.js
  var permutationsDocs;
  var init_permutations = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/permutations.js"() {
      permutationsDocs = {
        name: "permutations",
        category: "Probability",
        syntax: ["permutations(n)", "permutations(n, k)"],
        description: "Compute the number of permutations of n items taken k at a time",
        examples: ["permutations(5)", "permutations(5, 3)"],
        seealso: ["combinations", "combinationsWithRep", "factorial"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/multinomial.js
  var multinomialDocs;
  var init_multinomial = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/multinomial.js"() {
      multinomialDocs = {
        name: "multinomial",
        category: "Probability",
        syntax: ["multinomial(A)"],
        description: "Multinomial Coefficients compute the number of ways of picking a1, a2, ..., ai unordered outcomes from `n` possibilities. multinomial takes one array of integers as an argument. The following condition must be enforced: every ai > 0.",
        examples: ["multinomial([1, 2, 1])"],
        seealso: ["combinations", "factorial"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/kldivergence.js
  var kldivergenceDocs;
  var init_kldivergence = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/kldivergence.js"() {
      kldivergenceDocs = {
        name: "kldivergence",
        category: "Probability",
        syntax: ["kldivergence(x, y)"],
        description: "Calculate the Kullback-Leibler (KL) divergence  between two distributions.",
        examples: ["kldivergence([0.7,0.5,0.4], [0.2,0.9,0.5])"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/gamma.js
  var gammaDocs;
  var init_gamma = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/gamma.js"() {
      gammaDocs = {
        name: "gamma",
        category: "Probability",
        syntax: ["gamma(n)"],
        description: "Compute the gamma function. For small values, the Lanczos approximation is used, and for large values the extended Stirling approximation.",
        examples: ["gamma(4)", "3!", "gamma(1/2)", "sqrt(pi)"],
        seealso: ["factorial"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/factorial.js
  var factorialDocs;
  var init_factorial = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/factorial.js"() {
      factorialDocs = {
        name: "factorial",
        category: "Probability",
        syntax: ["n!", "factorial(n)"],
        description: "Compute the factorial of a value",
        examples: ["5!", "5 * 4 * 3 * 2 * 1", "3!"],
        seealso: ["combinations", "combinationsWithRep", "permutations", "gamma"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/combinations.js
  var combinationsDocs;
  var init_combinations2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/combinations.js"() {
      combinationsDocs = {
        name: "combinations",
        category: "Probability",
        syntax: ["combinations(n, k)"],
        description: "Compute the number of combinations of n items taken k at a time",
        examples: ["combinations(7, 5)"],
        seealso: ["combinationsWithRep", "permutations", "factorial"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/probability/combinationsWithRep.js
  var combinationsWithRepDocs;
  var init_combinationsWithRep = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/probability/combinationsWithRep.js"() {
      combinationsWithRepDocs = {
        name: "combinationsWithRep",
        category: "Probability",
        syntax: ["combinationsWithRep(n, k)"],
        description: "Compute the number of combinations of n items taken k at a time with replacements.",
        examples: ["combinationsWithRep(7, 5)"],
        seealso: ["combinations", "permutations", "factorial"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/zeros.js
  var zerosDocs;
  var init_zeros = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/zeros.js"() {
      zerosDocs = {
        name: "zeros",
        category: "Matrix",
        syntax: ["zeros(m)", "zeros(m, n)", "zeros(m, n, p, ...)", "zeros([m])", "zeros([m, n])", "zeros([m, n, p, ...])"],
        description: "Create a matrix containing zeros.",
        examples: ["zeros(3)", "zeros(3, 5)", "a = [1, 2, 3; 4, 5, 6]", "zeros(size(a))"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "range", "size", "squeeze", "subset", "trace", "transpose"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/transpose.js
  var transposeDocs;
  var init_transpose = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/transpose.js"() {
      transposeDocs = {
        name: "transpose",
        category: "Matrix",
        syntax: ["x'", "transpose(x)"],
        description: "Transpose a matrix",
        examples: ["a = [1, 2, 3; 4, 5, 6]", "a'", "transpose(a)"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "range", "size", "squeeze", "subset", "trace", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/trace.js
  var traceDocs;
  var init_trace = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/trace.js"() {
      traceDocs = {
        name: "trace",
        category: "Matrix",
        syntax: ["trace(A)"],
        description: "Calculate the trace of a matrix: the sum of the elements on the main diagonal of a square matrix.",
        examples: ["A = [1, 2, 3; -1, 2, 3; 2, 0, 3]", "trace(A)"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "range", "size", "squeeze", "subset", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/subset.js
  var subsetDocs;
  var init_subset = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/subset.js"() {
      subsetDocs = {
        name: "subset",
        category: "Matrix",
        syntax: ["value(index)", "value(index) = replacement", "subset(value, [index])", "subset(value, [index], replacement)"],
        description: "Get or set a subset of a matrix or string. Indexes are one-based. Both the ranges lower-bound and upper-bound are included.",
        examples: ["d = [1, 2; 3, 4]", "e = []", "e[1, 1:2] = [5, 6]", "e[2, :] = [7, 8]", "f = d * e", "f[2, 1]", "f[:, 1]"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "range", "size", "squeeze", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/squeeze.js
  var squeezeDocs;
  var init_squeeze = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/squeeze.js"() {
      squeezeDocs = {
        name: "squeeze",
        category: "Matrix",
        syntax: ["squeeze(x)"],
        description: "Remove inner and outer singleton dimensions from a matrix.",
        examples: ["a = zeros(3,2,1)", "size(squeeze(a))", "b = zeros(1,1,3)", "size(squeeze(b))"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "range", "size", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/sort.js
  var sortDocs;
  var init_sort = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/sort.js"() {
      sortDocs = {
        name: "sort",
        category: "Matrix",
        syntax: ["sort(x)", "sort(x, compare)"],
        description: 'Sort the items in a matrix. Compare can be a string "asc", "desc", "natural", or a custom sort function.',
        examples: ["sort([5, 10, 1])", 'sort(["C", "B", "A", "D"])', "sortByLength(a, b) = size(a)[1] - size(b)[1]", 'sort(["Langdon", "Tom", "Sara"], sortByLength)', 'sort(["10", "1", "2"], "natural")'],
        seealso: ["map", "filter", "forEach"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/size.js
  var sizeDocs;
  var init_size = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/size.js"() {
      sizeDocs = {
        name: "size",
        category: "Matrix",
        syntax: ["size(x)"],
        description: "Calculate the size of a matrix.",
        examples: ["size(2.3)", 'size("hello world")', "a = [1, 2; 3, 4; 5, 6]", "size(a)", "size(1:6)"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "range", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/diff.js
  var diffDocs;
  var init_diff = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/diff.js"() {
      diffDocs = {
        name: "diff",
        category: "Matrix",
        syntax: ["diff(arr)", "diff(arr, dim)"],
        description: ["Create a new matrix or array with the difference of the passed matrix or array.", "Dim parameter is optional and used to indicant the dimension of the array/matrix to apply the difference", "If no dimension parameter is passed it is assumed as dimension 0", "Dimension is zero-based in javascript and one-based in the parser", "Arrays must be 'rectangular' meaning arrays like [1, 2]", "If something is passed as a matrix it will be returned as a matrix but other than that all matrices are converted to arrays"],
        examples: ["diff([1, 2, 4, 7, 0])", "diff([1, 2, 4, 7, 0], 0)", "diff(matrix([1, 2, 4, 7, 0]))", "diff([[1, 2], [3, 4]])", "diff([[1, 2], [3, 4]], 0)", "diff([[1, 2], [3, 4]], 1)", "diff([[1, 2], [3, 4]], bignumber(1))", "diff(matrix([[1, 2], [3, 4]]), 1)", "diff([[1, 2], matrix([3, 4])], 1)"],
        seealso: ["subtract", "partitionSelect"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/reshape.js
  var reshapeDocs;
  var init_reshape = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/reshape.js"() {
      reshapeDocs = {
        name: "reshape",
        category: "Matrix",
        syntax: ["reshape(x, sizes)"],
        description: "Reshape a multi dimensional array to fit the specified dimensions.",
        examples: ["reshape([1, 2, 3, 4, 5, 6], [2, 3])", "reshape([[1, 2], [3, 4]], [1, 4])", "reshape([[1, 2], [3, 4]], [4])"],
        seealso: ["size", "squeeze", "resize"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/resize.js
  var resizeDocs;
  var init_resize = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/resize.js"() {
      resizeDocs = {
        name: "resize",
        category: "Matrix",
        syntax: ["resize(x, size)", "resize(x, size, defaultValue)"],
        description: "Resize a matrix.",
        examples: ["resize([1,2,3,4,5], [3])", "resize([1,2,3], [5])", "resize([1,2,3], [5], -1)", "resize(2, [2, 3])", 'resize("hello", [8], "!")'],
        seealso: ["size", "subset", "squeeze", "reshape"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/range.js
  var rangeDocs;
  var init_range = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/range.js"() {
      rangeDocs = {
        name: "range",
        category: "Type",
        syntax: ["start:end", "start:step:end", "range(start, end)", "range(start, end, step)", "range(string)"],
        description: "Create a range. Lower bound of the range is included, upper bound is excluded.",
        examples: ["1:5", "3:-1:-3", "range(3, 7)", "range(0, 12, 2)", 'range("4:10")', "a = [1, 2, 3, 4; 5, 6, 7, 8]", "a[1:2, 1:2]"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "size", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/partitionSelect.js
  var partitionSelectDocs;
  var init_partitionSelect = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/partitionSelect.js"() {
      partitionSelectDocs = {
        name: "partitionSelect",
        category: "Matrix",
        syntax: ["partitionSelect(x, k)", "partitionSelect(x, k, compare)"],
        description: "Partition-based selection of an array or 1D matrix. Will find the kth smallest value, and mutates the input array. Uses Quickselect.",
        examples: ["partitionSelect([5, 10, 1], 2)", 'partitionSelect(["C", "B", "A", "D"], 1)'],
        seealso: ["sort"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/ones.js
  var onesDocs;
  var init_ones = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/ones.js"() {
      onesDocs = {
        name: "ones",
        category: "Matrix",
        syntax: ["ones(m)", "ones(m, n)", "ones(m, n, p, ...)", "ones([m])", "ones([m, n])", "ones([m, n, p, ...])"],
        description: "Create a matrix containing ones.",
        examples: ["ones(3)", "ones(3, 5)", "ones([2,3]) * 4.5", "a = [1, 2, 3; 4, 5, 6]", "ones(size(a))"],
        seealso: ["concat", "det", "diag", "identity", "inv", "range", "size", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/map.js
  var mapDocs;
  var init_map = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/map.js"() {
      mapDocs = {
        name: "map",
        category: "Matrix",
        syntax: ["map(x, callback)"],
        description: "Create a new matrix or array with the results of the callback function executed on each entry of the matrix/array.",
        examples: ["map([1, 2, 3], square)"],
        seealso: ["filter", "forEach"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/kron.js
  var kronDocs;
  var init_kron = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/kron.js"() {
      kronDocs = {
        name: "kron",
        category: "Matrix",
        syntax: ["kron(x, y)"],
        description: "Calculates the kronecker product of 2 matrices or vectors.",
        examples: ["kron([[1, 0], [0, 1]], [[1, 2], [3, 4]])", "kron([1,1], [2,3,4])"],
        seealso: ["multiply", "dot", "cross"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/inv.js
  var invDocs;
  var init_inv = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/inv.js"() {
      invDocs = {
        name: "inv",
        category: "Matrix",
        syntax: ["inv(x)"],
        description: "Calculate the inverse of a matrix",
        examples: ["inv([1, 2; 3, 4])", "inv(4)", "1 / 4"],
        seealso: ["concat", "det", "diag", "identity", "ones", "range", "size", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/forEach.js
  var forEachDocs;
  var init_forEach = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/forEach.js"() {
      forEachDocs = {
        name: "forEach",
        category: "Matrix",
        syntax: ["forEach(x, callback)"],
        description: "Iterates over all elements of a matrix/array, and executes the given callback function.",
        examples: ["forEach([1, 2, 3], function(val) { console.log(val) })"],
        seealso: ["map", "sort", "filter"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/flatten.js
  var flattenDocs;
  var init_flatten = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/flatten.js"() {
      flattenDocs = {
        name: "flatten",
        category: "Matrix",
        syntax: ["flatten(x)"],
        description: "Flatten a multi dimensional matrix into a single dimensional matrix.",
        examples: ["a = [1, 2, 3; 4, 5, 6]", "size(a)", "b = flatten(a)", "size(b)"],
        seealso: ["concat", "resize", "size", "squeeze"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/filter.js
  var filterDocs;
  var init_filter = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/filter.js"() {
      filterDocs = {
        name: "filter",
        category: "Matrix",
        syntax: ["filter(x, test)"],
        description: "Filter items in a matrix.",
        examples: ["isPositive(x) = x > 0", "filter([6, -2, -1, 4, 3], isPositive)", "filter([6, -2, 0, 1, 0], x != 0)"],
        seealso: ["sort", "map", "forEach"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/identity.js
  var identityDocs;
  var init_identity = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/identity.js"() {
      identityDocs = {
        name: "identity",
        category: "Matrix",
        syntax: ["identity(n)", "identity(m, n)", "identity([m, n])"],
        description: "Returns the identity matrix with size m-by-n. The matrix has ones on the diagonal and zeros elsewhere.",
        examples: ["identity(3)", "identity(3, 5)", "a = [1, 2, 3; 4, 5, 6]", "identity(size(a))"],
        seealso: ["concat", "det", "diag", "inv", "ones", "range", "size", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/getMatrixDataType.js
  var getMatrixDataTypeDocs;
  var init_getMatrixDataType = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/getMatrixDataType.js"() {
      getMatrixDataTypeDocs = {
        name: "getMatrixDataType",
        category: "Matrix",
        syntax: ["getMatrixDataType(x)"],
        description: 'Find the data type of all elements in a matrix or array, for example "number" if all items are a number and "Complex" if all values are complex numbers. If a matrix contains more than one data type, it will return "mixed".',
        examples: ["getMatrixDataType([1, 2, 3])", "getMatrixDataType([[5 cm], [2 inch]])", 'getMatrixDataType([1, "text"])', "getMatrixDataType([1, bignumber(4)])"],
        seealso: ["matrix", "sparse", "typeOf"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/dot.js
  var dotDocs;
  var init_dot = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/dot.js"() {
      dotDocs = {
        name: "dot",
        category: "Matrix",
        syntax: ["dot(A, B)", "A * B"],
        description: "Calculate the dot product of two vectors. The dot product of A = [a1, a2, a3, ..., an] and B = [b1, b2, b3, ..., bn] is defined as dot(A, B) = a1 * b1 + a2 * b2 + a3 * b3 + ... + an * bn",
        examples: ["dot([2, 4, 1], [2, 2, 3])", "[2, 4, 1] * [2, 2, 3]"],
        seealso: ["multiply", "cross"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/diag.js
  var diagDocs;
  var init_diag = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/diag.js"() {
      diagDocs = {
        name: "diag",
        category: "Matrix",
        syntax: ["diag(x)", "diag(x, k)"],
        description: "Create a diagonal matrix or retrieve the diagonal of a matrix. When x is a vector, a matrix with the vector values on the diagonal will be returned. When x is a matrix, a vector with the diagonal values of the matrix is returned. When k is provided, the k-th diagonal will be filled in or retrieved, if k is positive, the values are placed on the super diagonal. When k is negative, the values are placed on the sub diagonal.",
        examples: ["diag(1:3)", "diag(1:3, 1)", "a = [1, 2, 3; 4, 5, 6; 7, 8, 9]", "diag(a)"],
        seealso: ["concat", "det", "identity", "inv", "ones", "range", "size", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/det.js
  var detDocs;
  var init_det = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/det.js"() {
      detDocs = {
        name: "det",
        category: "Matrix",
        syntax: ["det(x)"],
        description: "Calculate the determinant of a matrix",
        examples: ["det([1, 2; 3, 4])", "det([-2, 2, 3; -1, 1, 3; 2, 0, -1])"],
        seealso: ["concat", "diag", "identity", "inv", "ones", "range", "size", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/ctranspose.js
  var ctransposeDocs;
  var init_ctranspose = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/ctranspose.js"() {
      ctransposeDocs = {
        name: "ctranspose",
        category: "Matrix",
        syntax: ["x'", "ctranspose(x)"],
        description: "Complex Conjugate and Transpose a matrix",
        examples: ["a = [1, 2, 3; 4, 5, 6]", "a'", "ctranspose(a)"],
        seealso: ["concat", "det", "diag", "identity", "inv", "ones", "range", "size", "squeeze", "subset", "trace", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/cross.js
  var crossDocs;
  var init_cross = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/cross.js"() {
      crossDocs = {
        name: "cross",
        category: "Matrix",
        syntax: ["cross(A, B)"],
        description: "Calculate the cross product for two vectors in three dimensional space.",
        examples: ["cross([1, 1, 0],  [0, 1, 1])", "cross([3, -3, 1], [4, 9, 2])", "cross([2, 3, 4],  [5, 6, 7])"],
        seealso: ["multiply", "dot"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/concat.js
  var concatDocs;
  var init_concat = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/concat.js"() {
      concatDocs = {
        name: "concat",
        category: "Matrix",
        syntax: ["concat(A, B, C, ...)", "concat(A, B, C, ..., dim)"],
        description: "Concatenate matrices. By default, the matrices are concatenated by the last dimension. The dimension on which to concatenate can be provided as last argument.",
        examples: ["A = [1, 2; 5, 6]", "B = [3, 4; 7, 8]", "concat(A, B)", "concat(A, B, 1)", "concat(A, B, 2)"],
        seealso: ["det", "diag", "identity", "inv", "ones", "range", "size", "squeeze", "subset", "trace", "transpose", "zeros"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/logical/xor.js
  var xorDocs;
  var init_xor = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/logical/xor.js"() {
      xorDocs = {
        name: "xor",
        category: "Logical",
        syntax: ["x xor y", "xor(x, y)"],
        description: "Logical exclusive or, xor. Test whether one and only one value is defined with a nonzero/nonempty value.",
        examples: ["true xor false", "false xor false", "true xor true", "0 xor 4"],
        seealso: ["not", "and", "or"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/logical/or.js
  var orDocs;
  var init_or = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/logical/or.js"() {
      orDocs = {
        name: "or",
        category: "Logical",
        syntax: ["x or y", "or(x, y)"],
        description: "Logical or. Test if at least one value is defined with a nonzero/nonempty value.",
        examples: ["true or false", "false or false", "0 or 4"],
        seealso: ["not", "and", "xor"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/logical/not.js
  var notDocs;
  var init_not = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/logical/not.js"() {
      notDocs = {
        name: "not",
        category: "Logical",
        syntax: ["not x", "not(x)"],
        description: "Logical not. Flips the boolean value of given argument.",
        examples: ["not true", "not false", "not 2", "not 0"],
        seealso: ["and", "or", "xor"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/logical/and.js
  var andDocs;
  var init_and = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/logical/and.js"() {
      andDocs = {
        name: "and",
        category: "Logical",
        syntax: ["x and y", "and(x, y)"],
        description: "Logical and. Test whether two values are both defined with a nonzero/nonempty value.",
        examples: ["true and false", "true and true", "2 and 4"],
        seealso: ["not", "or", "xor"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/geometry/intersect.js
  var intersectDocs;
  var init_intersect = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/geometry/intersect.js"() {
      intersectDocs = {
        name: "intersect",
        category: "Geometry",
        syntax: ["intersect(expr1, expr2, expr3, expr4)", "intersect(expr1, expr2, expr3)"],
        description: "Computes the intersection point of lines and/or planes.",
        examples: ["intersect([0, 0], [10, 10], [10, 0], [0, 10])", "intersect([1, 0, 1],  [4, -2, 2], [1, 1, 1, 6])"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/geometry/distance.js
  var distanceDocs;
  var init_distance = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/geometry/distance.js"() {
      distanceDocs = {
        name: "distance",
        category: "Geometry",
        syntax: ["distance([x1, y1], [x2, y2])", "distance([[x1, y1], [x2, y2]])"],
        description: "Calculates the Euclidean distance between two points.",
        examples: ["distance([0,0], [4,4])", "distance([[0,0], [4,4]])"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/expression/help.js
  var helpDocs;
  var init_help = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/expression/help.js"() {
      helpDocs = {
        name: "help",
        category: "Expression",
        syntax: ["help(object)", "help(string)"],
        description: "Display documentation on a function or data type.",
        examples: ["help(sqrt)", 'help("complex")'],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/expression/evaluate.js
  var evaluateDocs;
  var init_evaluate = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/expression/evaluate.js"() {
      evaluateDocs = {
        name: "evaluate",
        category: "Expression",
        syntax: ["evaluate(expression)", "evaluate([expr1, expr2, expr3, ...])"],
        description: "Evaluate an expression or an array with expressions.",
        examples: ['evaluate("2 + 3")', 'evaluate("sqrt(" + 4 + ")")'],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/complex/im.js
  var imDocs;
  var init_im = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/complex/im.js"() {
      imDocs = {
        name: "im",
        category: "Complex",
        syntax: ["im(x)"],
        description: "Get the imaginary part of a complex number.",
        examples: ["im(2 + 3i)", "re(2 + 3i)", "im(-5.2i)", "im(2.4)"],
        seealso: ["re", "conj", "abs", "arg"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/complex/re.js
  var reDocs;
  var init_re = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/complex/re.js"() {
      reDocs = {
        name: "re",
        category: "Complex",
        syntax: ["re(x)"],
        description: "Get the real part of a complex number.",
        examples: ["re(2 + 3i)", "im(2 + 3i)", "re(-5.2i)", "re(2.4)"],
        seealso: ["im", "conj", "abs", "arg"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/complex/conj.js
  var conjDocs;
  var init_conj = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/complex/conj.js"() {
      conjDocs = {
        name: "conj",
        category: "Complex",
        syntax: ["conj(x)"],
        description: "Compute the complex conjugate of a complex value. If x = a+bi, the complex conjugate is a-bi.",
        examples: ["conj(2 + 3i)", "conj(2 - 3i)", "conj(-5.2i)"],
        seealso: ["re", "im", "abs", "arg"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/complex/arg.js
  var argDocs;
  var init_arg = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/complex/arg.js"() {
      argDocs = {
        name: "arg",
        category: "Complex",
        syntax: ["arg(x)"],
        description: "Compute the argument of a complex value. If x = a+bi, the argument is computed as atan2(b, a).",
        examples: ["arg(2 + 2i)", "atan2(3, 2)", "arg(2 + 3i)"],
        seealso: ["re", "im", "conj", "abs"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/core/typed.js
  var typedDocs;
  var init_typed2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/core/typed.js"() {
      typedDocs = {
        name: "typed",
        category: "Core",
        syntax: ["typed(signatures)", "typed(name, signatures)"],
        description: "Create a typed function.",
        examples: ['double = typed({ "number, number": f(x)=x+x })', "double(2)", 'double("hello")'],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/core/import.js
  var importDocs;
  var init_import = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/core/import.js"() {
      importDocs = {
        name: "import",
        category: "Core",
        syntax: ["import(functions)", "import(functions, options)"],
        description: "Import functions or constants from an object.",
        examples: ["import({myFn: f(x)=x^2, myConstant: 32 })", "myFn(2)", "myConstant"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/core/config.js
  var configDocs;
  var init_config3 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/core/config.js"() {
      configDocs = {
        name: "config",
        category: "Core",
        syntax: ["config()", "config(options)"],
        description: "Get configuration or change configuration.",
        examples: ["config()", "1/3 + 1/4", 'config({number: "Fraction"})', "1/3 + 1/4"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/stirlingS2.js
  var stirlingS2Docs;
  var init_stirlingS2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/stirlingS2.js"() {
      stirlingS2Docs = {
        name: "stirlingS2",
        category: "Combinatorics",
        syntax: ["stirlingS2(n, k)"],
        description: "he Stirling numbers of the second kind, counts the number of ways to partition a set of n labelled objects into k nonempty unlabelled subsets. `stirlingS2` only takes integer arguments. The following condition must be enforced: k <= n. If n = k or k = 1, then s(n,k) = 1.",
        examples: ["stirlingS2(5, 3)"],
        seealso: ["bellNumbers"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/composition.js
  var compositionDocs;
  var init_composition = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/composition.js"() {
      compositionDocs = {
        name: "composition",
        category: "Combinatorics",
        syntax: ["composition(n, k)"],
        description: "The composition counts of n into k parts. composition only takes integer arguments. The following condition must be enforced: k <= n.",
        examples: ["composition(5, 3)"],
        seealso: ["combinations"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/catalan.js
  var catalanDocs;
  var init_catalan = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/catalan.js"() {
      catalanDocs = {
        name: "catalan",
        category: "Combinatorics",
        syntax: ["catalan(n)"],
        description: "The Catalan Numbers enumerate combinatorial structures of many different types. catalan only takes integer arguments. The following condition must be enforced: n >= 0.",
        examples: ["catalan(3)", "catalan(8)"],
        seealso: ["bellNumbers"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/bellNumbers.js
  var bellNumbersDocs;
  var init_bellNumbers = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/combinatorics/bellNumbers.js"() {
      bellNumbersDocs = {
        name: "bellNumbers",
        category: "Combinatorics",
        syntax: ["bellNumbers(n)"],
        description: "The Bell Numbers count the number of partitions of a set. A partition is a pairwise disjoint subset of S whose union is S. `bellNumbers` only takes integer arguments. The following condition must be enforced: n >= 0.",
        examples: ["bellNumbers(3)", "bellNumbers(8)"],
        seealso: ["stirlingS2"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/rightLogShift.js
  var rightLogShiftDocs;
  var init_rightLogShift = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/rightLogShift.js"() {
      rightLogShiftDocs = {
        name: "rightLogShift",
        category: "Bitwise",
        syntax: ["x >>> y", "rightLogShift(x, y)"],
        description: "Bitwise right logical shift of a value x by y number of bits.",
        examples: ["8 >>> 1", "4 << 1", "-12 >>> 2"],
        seealso: ["bitAnd", "bitNot", "bitOr", "bitXor", "leftShift", "rightArithShift"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/rightArithShift.js
  var rightArithShiftDocs;
  var init_rightArithShift = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/rightArithShift.js"() {
      rightArithShiftDocs = {
        name: "rightArithShift",
        category: "Bitwise",
        syntax: ["x >> y", "rightArithShift(x, y)"],
        description: "Bitwise right arithmetic shift of a value x by y number of bits.",
        examples: ["8 >> 1", "4 << 1", "-12 >> 2"],
        seealso: ["bitAnd", "bitNot", "bitOr", "bitXor", "leftShift", "rightLogShift"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/leftShift.js
  var leftShiftDocs;
  var init_leftShift = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/leftShift.js"() {
      leftShiftDocs = {
        name: "leftShift",
        category: "Bitwise",
        syntax: ["x << y", "leftShift(x, y)"],
        description: "Bitwise left logical shift of a value x by y number of bits.",
        examples: ["4 << 1", "8 >> 1"],
        seealso: ["bitAnd", "bitNot", "bitOr", "bitXor", "rightArithShift", "rightLogShift"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitXor.js
  var bitXorDocs;
  var init_bitXor = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitXor.js"() {
      bitXorDocs = {
        name: "bitXor",
        category: "Bitwise",
        syntax: ["bitXor(x, y)"],
        description: "Bitwise XOR operation, exclusive OR. Performs the logical exclusive OR operation on each pair of corresponding bits of the two given values. The result in each position is 1 if only the first bit is 1 or only the second bit is 1, but will be 0 if both are 0 or both are 1.",
        examples: ["bitOr(1, 2)", "bitXor([2, 3, 4], 4)"],
        seealso: ["bitAnd", "bitNot", "bitOr", "leftShift", "rightArithShift", "rightLogShift"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitOr.js
  var bitOrDocs;
  var init_bitOr = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitOr.js"() {
      bitOrDocs = {
        name: "bitOr",
        category: "Bitwise",
        syntax: ["x | y", "bitOr(x, y)"],
        description: "Bitwise OR operation. Performs the logical inclusive OR operation on each pair of corresponding bits of the two given values. The result in each position is 1 if the first bit is 1 or the second bit is 1 or both bits are 1, otherwise, the result is 0.",
        examples: ["5 | 3", "bitOr([1, 2, 3], 4)"],
        seealso: ["bitAnd", "bitNot", "bitXor", "leftShift", "rightArithShift", "rightLogShift"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitNot.js
  var bitNotDocs;
  var init_bitNot = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitNot.js"() {
      bitNotDocs = {
        name: "bitNot",
        category: "Bitwise",
        syntax: ["~x", "bitNot(x)"],
        description: "Bitwise NOT operation. Performs a logical negation on each bit of the given value. Bits that are 0 become 1, and those that are 1 become 0.",
        examples: ["~1", "~2", "bitNot([2, -3, 4])"],
        seealso: ["bitAnd", "bitOr", "bitXor", "leftShift", "rightArithShift", "rightLogShift"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitAnd.js
  var bitAndDocs;
  var init_bitAnd = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/bitwise/bitAnd.js"() {
      bitAndDocs = {
        name: "bitAnd",
        category: "Bitwise",
        syntax: ["x & y", "bitAnd(x, y)"],
        description: "Bitwise AND operation. Performs the logical AND operation on each pair of the corresponding bits of the two given values by multiplying them. If both bits in the compared position are 1, the bit in the resulting binary representation is 1, otherwise, the result is 0",
        examples: ["5 & 3", "bitAnd(53, 131)", "[1, 12, 31] & 42"],
        seealso: ["bitNot", "bitOr", "bitXor", "leftShift", "rightArithShift", "rightLogShift"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/xgcd.js
  var xgcdDocs;
  var init_xgcd = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/xgcd.js"() {
      xgcdDocs = {
        name: "xgcd",
        category: "Arithmetic",
        syntax: ["xgcd(a, b)"],
        description: "Calculate the extended greatest common divisor for two values. The result is an array [d, x, y] with 3 entries, where d is the greatest common divisor, and d = x * a + y * b.",
        examples: ["xgcd(8, 12)", "gcd(8, 12)", "xgcd(36163, 21199)"],
        seealso: ["gcd", "lcm"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/unaryPlus.js
  var unaryPlusDocs;
  var init_unaryPlus = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/unaryPlus.js"() {
      unaryPlusDocs = {
        name: "unaryPlus",
        category: "Operators",
        syntax: ["+x", "unaryPlus(x)"],
        description: "Converts booleans and strings to numbers.",
        examples: ["+true", '+"2"'],
        seealso: ["add", "subtract", "unaryMinus"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/unaryMinus.js
  var unaryMinusDocs;
  var init_unaryMinus = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/unaryMinus.js"() {
      unaryMinusDocs = {
        name: "unaryMinus",
        category: "Operators",
        syntax: ["-x", "unaryMinus(x)"],
        description: "Inverse the sign of a value. Converts booleans and strings to numbers.",
        examples: ["-4.5", "-(-5.6)", '-"22"'],
        seealso: ["add", "subtract", "unaryPlus"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/square.js
  var squareDocs;
  var init_square = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/square.js"() {
      squareDocs = {
        name: "square",
        category: "Arithmetic",
        syntax: ["square(x)"],
        description: "Compute the square of a value. The square of x is x * x.",
        examples: ["square(3)", "sqrt(9)", "3^2", "3 * 3"],
        seealso: ["multiply", "pow", "sqrt", "cube"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/sqrtm.js
  var sqrtmDocs;
  var init_sqrtm = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/sqrtm.js"() {
      sqrtmDocs = {
        name: "sqrtm",
        category: "Arithmetic",
        syntax: ["sqrtm(x)"],
        description: "Calculate the principal square root of a square matrix. The principal square root matrix `X` of another matrix `A` is such that `X * X = A`.",
        examples: ["sqrtm([[1, 2], [3, 4]])"],
        seealso: ["sqrt", "abs", "square", "multiply"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/sqrt.js
  var sqrtDocs;
  var init_sqrt = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/sqrt.js"() {
      sqrtDocs = {
        name: "sqrt",
        category: "Arithmetic",
        syntax: ["sqrt(x)"],
        description: "Compute the square root value. If x = y * y, then y is the square root of x.",
        examples: ["sqrt(25)", "5 * 5", "sqrt(-1)"],
        seealso: ["square", "sqrtm", "multiply", "nthRoot", "nthRoots", "pow"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/sign.js
  var signDocs;
  var init_sign = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/sign.js"() {
      signDocs = {
        name: "sign",
        category: "Arithmetic",
        syntax: ["sign(x)"],
        description: "Compute the sign of a value. The sign of a value x is 1 when x>1, -1 when x<0, and 0 when x=0.",
        examples: ["sign(3.5)", "sign(-4.2)", "sign(0)"],
        seealso: ["abs"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/round.js
  var roundDocs;
  var init_round = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/round.js"() {
      roundDocs = {
        name: "round",
        category: "Arithmetic",
        syntax: ["round(x)", "round(x, n)"],
        description: "round a value towards the nearest integer.If x is complex, both real and imaginary part are rounded towards the nearest integer. When n is specified, the value is rounded to n decimals.",
        examples: ["round(3.2)", "round(3.8)", "round(-4.2)", "round(-4.8)", "round(pi, 3)", "round(123.45678, 2)"],
        seealso: ["ceil", "floor", "fix"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/pow.js
  var powDocs;
  var init_pow = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/pow.js"() {
      powDocs = {
        name: "pow",
        category: "Operators",
        syntax: ["x ^ y", "pow(x, y)"],
        description: "Calculates the power of x to y, x^y.",
        examples: ["2^3", "2*2*2", "1 + e ^ (pi * i)"],
        seealso: ["multiply", "nthRoot", "nthRoots", "sqrt"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/nthRoots.js
  var nthRootsDocs;
  var init_nthRoots = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/nthRoots.js"() {
      nthRootsDocs = {
        name: "nthRoots",
        category: "Arithmetic",
        syntax: ["nthRoots(A)", "nthRoots(A, root)"],
        description: 'Calculate the nth roots of a value. An nth root of a positive real number A, is a positive real solution of the equation "x^root = A". This function returns an array of complex values.',
        examples: ["nthRoots(1)", "nthRoots(1, 3)"],
        seealso: ["sqrt", "pow", "nthRoot"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/nthRoot.js
  var nthRootDocs;
  var init_nthRoot = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/nthRoot.js"() {
      nthRootDocs = {
        name: "nthRoot",
        category: "Arithmetic",
        syntax: ["nthRoot(a)", "nthRoot(a, root)"],
        description: 'Calculate the nth root of a value. The principal nth root of a positive real number A, is the positive real solution of the equation "x^root = A".',
        examples: ["4 ^ 3", "nthRoot(64, 3)", "nthRoot(9, 2)", "sqrt(9)"],
        seealso: ["nthRoots", "pow", "sqrt"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/norm.js
  var normDocs;
  var init_norm = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/norm.js"() {
      normDocs = {
        name: "norm",
        category: "Arithmetic",
        syntax: ["norm(x)", "norm(x, p)"],
        description: "Calculate the norm of a number, vector or matrix.",
        examples: ["abs(-3.5)", "norm(-3.5)", "norm(3 - 4i)", "norm([1, 2, -3], Infinity)", "norm([1, 2, -3], -Infinity)", "norm([3, 4], 2)", "norm([[1, 2], [3, 4]], 1)", 'norm([[1, 2], [3, 4]], "inf")', 'norm([[1, 2], [3, 4]], "fro")']
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/multiply.js
  var multiplyDocs;
  var init_multiply = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/multiply.js"() {
      multiplyDocs = {
        name: "multiply",
        category: "Operators",
        syntax: ["x * y", "multiply(x, y)"],
        description: "multiply two values.",
        examples: ["a = 2.1 * 3.4", "a / 3.4", "2 * 3 + 4", "2 * (3 + 4)", "3 * 2.1 km"],
        seealso: ["divide"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/mod.js
  var modDocs;
  var init_mod = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/mod.js"() {
      modDocs = {
        name: "mod",
        category: "Operators",
        syntax: ["x % y", "x mod y", "mod(x, y)"],
        description: "Calculates the modulus, the remainder of an integer division.",
        examples: ["7 % 3", "11 % 2", "10 mod 4", "isOdd(x) = x % 2", "isOdd(2)", "isOdd(3)"],
        seealso: ["divide"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log10.js
  var log10Docs;
  var init_log10 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log10.js"() {
      log10Docs = {
        name: "log10",
        category: "Arithmetic",
        syntax: ["log10(x)"],
        description: "Compute the 10-base logarithm of a value.",
        examples: ["log10(0.00001)", "log10(10000)", "10 ^ 4", "log(10000) / log(10)", "log(10000, 10)"],
        seealso: ["exp", "log"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log1p.js
  var log1pDocs;
  var init_log1p = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log1p.js"() {
      log1pDocs = {
        name: "log1p",
        category: "Arithmetic",
        syntax: ["log1p(x)", "log1p(x, base)"],
        description: "Calculate the logarithm of a `value+1`",
        examples: ["log1p(2.5)", "exp(log1p(1.4))", "pow(10, 4)", "log1p(9999, 10)", "log1p(9999) / log(10)"],
        seealso: ["exp", "log", "log2", "log10"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log2.js
  var log2Docs;
  var init_log2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log2.js"() {
      log2Docs = {
        name: "log2",
        category: "Arithmetic",
        syntax: ["log2(x)"],
        description: "Calculate the 2-base of a value. This is the same as calculating `log(x, 2)`.",
        examples: ["log2(0.03125)", "log2(16)", "log2(16) / log2(2)", "pow(2, 4)"],
        seealso: ["exp", "log1p", "log", "log10"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log.js
  var logDocs;
  var init_log = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/log.js"() {
      logDocs = {
        name: "log",
        category: "Arithmetic",
        syntax: ["log(x)", "log(x, base)"],
        description: "Compute the logarithm of a value. If no base is provided, the natural logarithm of x is calculated. If base if provided, the logarithm is calculated for the specified base. log(x, base) is defined as log(x) / log(base).",
        examples: ["log(3.5)", "a = log(2.4)", "exp(a)", "10 ^ 4", "log(10000, 10)", "log(10000) / log(10)", "b = log(1024, 2)", "2 ^ b"],
        seealso: ["exp", "log1p", "log2", "log10"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/lcm.js
  var lcmDocs;
  var init_lcm = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/lcm.js"() {
      lcmDocs = {
        name: "lcm",
        category: "Arithmetic",
        syntax: ["lcm(x, y)"],
        description: "Compute the least common multiple.",
        examples: ["lcm(4, 6)", "lcm(6, 21)", "lcm(6, 21, 5)"],
        seealso: ["gcd"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/hypot.js
  var hypotDocs;
  var init_hypot = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/hypot.js"() {
      hypotDocs = {
        name: "hypot",
        category: "Arithmetic",
        syntax: ["hypot(a, b, c, ...)", "hypot([a, b, c, ...])"],
        description: "Calculate the hypotenusa of a list with values. ",
        examples: ["hypot(3, 4)", "sqrt(3^2 + 4^2)", "hypot(-2)", "hypot([3, 4, 5])"],
        seealso: ["abs", "norm"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/gcd.js
  var gcdDocs;
  var init_gcd = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/gcd.js"() {
      gcdDocs = {
        name: "gcd",
        category: "Arithmetic",
        syntax: ["gcd(a, b)", "gcd(a, b, c, ...)"],
        description: "Compute the greatest common divisor.",
        examples: ["gcd(8, 12)", "gcd(-4, 6)", "gcd(25, 15, -10)"],
        seealso: ["lcm", "xgcd"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/floor.js
  var floorDocs;
  var init_floor = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/floor.js"() {
      floorDocs = {
        name: "floor",
        category: "Arithmetic",
        syntax: ["floor(x)"],
        description: "Round a value towards minus infinity.If x is complex, both real and imaginary part are rounded towards minus infinity.",
        examples: ["floor(3.2)", "floor(3.8)", "floor(-4.2)"],
        seealso: ["ceil", "fix", "round"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/fix.js
  var fixDocs;
  var init_fix = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/fix.js"() {
      fixDocs = {
        name: "fix",
        category: "Arithmetic",
        syntax: ["fix(x)"],
        description: "Round a value towards zero. If x is complex, both real and imaginary part are rounded towards zero.",
        examples: ["fix(3.2)", "fix(3.8)", "fix(-4.2)", "fix(-4.8)"],
        seealso: ["ceil", "floor", "round"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/expm1.js
  var expm1Docs;
  var init_expm1 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/expm1.js"() {
      expm1Docs = {
        name: "expm1",
        category: "Arithmetic",
        syntax: ["expm1(x)"],
        description: "Calculate the value of subtracting 1 from the exponential value.",
        examples: ["expm1(2)", "pow(e, 2) - 1", "log(expm1(2) + 1)"],
        seealso: ["exp", "pow", "log"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/expm.js
  var expmDocs;
  var init_expm = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/expm.js"() {
      expmDocs = {
        name: "expm",
        category: "Arithmetic",
        syntax: ["exp(x)"],
        description: "Compute the matrix exponential, expm(A) = e^A. The matrix must be square. Not to be confused with exp(a), which performs element-wise exponentiation.",
        examples: ["expm([[0,2],[0,0]])"],
        seealso: ["exp"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/eigs.js
  var eigsDocs;
  var init_eigs = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/eigs.js"() {
      eigsDocs = {
        name: "eigs",
        category: "Matrix",
        syntax: ["eigs(x)"],
        description: "Calculate the eigenvalues and eigenvectors of a real symmetric matrix",
        examples: ["eigs([[5, 2.3], [2.3, 1]])"],
        seealso: ["inv"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/exp.js
  var expDocs;
  var init_exp = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/exp.js"() {
      expDocs = {
        name: "exp",
        category: "Arithmetic",
        syntax: ["exp(x)"],
        description: "Calculate the exponent of a value.",
        examples: ["exp(1.3)", "e ^ 1.3", "log(exp(1.3))", "x = 2.4", "(exp(i*x) == cos(x) + i*sin(x))   # Euler's formula"],
        seealso: ["expm", "expm1", "pow", "log"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/dotMultiply.js
  var dotMultiplyDocs;
  var init_dotMultiply = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/dotMultiply.js"() {
      dotMultiplyDocs = {
        name: "dotMultiply",
        category: "Operators",
        syntax: ["x .* y", "dotMultiply(x, y)"],
        description: "Multiply two values element wise.",
        examples: ["a = [1, 2, 3; 4, 5, 6]", "b = [2, 1, 1; 3, 2, 5]", "a .* b"],
        seealso: ["multiply", "divide", "dotDivide"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/dotDivide.js
  var dotDivideDocs;
  var init_dotDivide = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/dotDivide.js"() {
      dotDivideDocs = {
        name: "dotDivide",
        category: "Operators",
        syntax: ["x ./ y", "dotDivide(x, y)"],
        description: "Divide two values element wise.",
        examples: ["a = [1, 2, 3; 4, 5, 6]", "b = [2, 1, 1; 3, 2, 5]", "a ./ b"],
        seealso: ["multiply", "dotMultiply", "divide"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/divide.js
  var divideDocs;
  var init_divide = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/divide.js"() {
      divideDocs = {
        name: "divide",
        category: "Operators",
        syntax: ["x / y", "divide(x, y)"],
        description: "Divide two values.",
        examples: ["a = 2 / 3", "a * 3", "4.5 / 2", "3 + 4 / 2", "(3 + 4) / 2", "18 km / 4.5"],
        seealso: ["multiply"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/cube.js
  var cubeDocs;
  var init_cube = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/cube.js"() {
      cubeDocs = {
        name: "cube",
        category: "Arithmetic",
        syntax: ["cube(x)"],
        description: "Compute the cube of a value. The cube of x is x * x * x.",
        examples: ["cube(2)", "2^3", "2 * 2 * 2"],
        seealso: ["multiply", "square", "pow"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/ceil.js
  var ceilDocs;
  var init_ceil = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/ceil.js"() {
      ceilDocs = {
        name: "ceil",
        category: "Arithmetic",
        syntax: ["ceil(x)"],
        description: "Round a value towards plus infinity. If x is complex, both real and imaginary part are rounded towards plus infinity.",
        examples: ["ceil(3.2)", "ceil(3.8)", "ceil(-4.2)"],
        seealso: ["floor", "fix", "round"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/cbrt.js
  var cbrtDocs;
  var init_cbrt = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/cbrt.js"() {
      cbrtDocs = {
        name: "cbrt",
        category: "Arithmetic",
        syntax: ["cbrt(x)", "cbrt(x, allRoots)"],
        description: "Compute the cubic root value. If x = y * y * y, then y is the cubic root of x. When `x` is a number or complex number, an optional second argument `allRoots` can be provided to return all three cubic roots. If not provided, the principal root is returned",
        examples: ["cbrt(64)", "cube(4)", "cbrt(-8)", "cbrt(2 + 3i)", "cbrt(8i)", "cbrt(8i, true)", "cbrt(27 m^3)"],
        seealso: ["square", "sqrt", "cube", "multiply"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/add.js
  var addDocs;
  var init_add = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/add.js"() {
      addDocs = {
        name: "add",
        category: "Operators",
        syntax: ["x + y", "add(x, y)"],
        description: "Add two values.",
        examples: ["a = 2.1 + 3.6", "a - 3.6", "3 + 2i", "3 cm + 2 inch", '"2.3" + "4"'],
        seealso: ["subtract"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/abs.js
  var absDocs;
  var init_abs = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/abs.js"() {
      absDocs = {
        name: "abs",
        category: "Arithmetic",
        syntax: ["abs(x)"],
        description: "Compute the absolute value.",
        examples: ["abs(3.5)", "abs(-4.2)"],
        seealso: ["sign"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/qr.js
  var qrDocs;
  var init_qr = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/qr.js"() {
      qrDocs = {
        name: "qr",
        category: "Algebra",
        syntax: ["qr(A)"],
        description: "Calculates the Matrix QR decomposition. Matrix `A` is decomposed in two matrices (`Q`, `R`) where `Q` is an orthogonal matrix and `R` is an upper triangular matrix.",
        examples: ["qr([[1, -1,  4], [1,  4, -2], [1,  4,  2], [1,  -1, 0]])"],
        seealso: ["lup", "slu", "matrix"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/usolve.js
  var usolveDocs;
  var init_usolve = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/usolve.js"() {
      usolveDocs = {
        name: "usolve",
        category: "Algebra",
        syntax: ["x=usolve(U, b)"],
        description: "Finds one solution of the linear system U * x = b where U is an [n x n] upper triangular matrix and b is a [n] column vector.",
        examples: ["x=usolve(sparse([1, 1, 1, 1; 0, 1, 1, 1; 0, 0, 1, 1; 0, 0, 0, 1]), [1; 2; 3; 4])"],
        seealso: ["usolveAll", "lup", "lusolve", "lsolve", "matrix", "sparse"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/usolveAll.js
  var usolveAllDocs;
  var init_usolveAll = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/usolveAll.js"() {
      usolveAllDocs = {
        name: "usolveAll",
        category: "Algebra",
        syntax: ["x=usolve(U, b)"],
        description: "Finds all solutions of the linear system U * x = b where U is an [n x n] upper triangular matrix and b is a [n] column vector.",
        examples: ["x=usolve(sparse([1, 1, 1, 1; 0, 1, 1, 1; 0, 0, 1, 1; 0, 0, 0, 1]), [1; 2; 3; 4])"],
        seealso: ["usolve", "lup", "lusolve", "lsolve", "matrix", "sparse"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/slu.js
  var sluDocs;
  var init_slu = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/slu.js"() {
      sluDocs = {
        name: "slu",
        category: "Algebra",
        syntax: ["slu(A, order, threshold)"],
        description: "Calculate the Matrix LU decomposition with full pivoting. Matrix A is decomposed in two matrices (L, U) and two permutation vectors (pinv, q) where P * A * Q = L * U",
        examples: ["slu(sparse([4.5, 0, 3.2, 0; 3.1, 2.9, 0, 0.9; 0, 1.7, 3, 0; 3.5, 0.4, 0, 1]), 1, 0.001)"],
        seealso: ["lusolve", "lsolve", "usolve", "matrix", "sparse", "lup", "qr"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/rationalize.js
  var rationalizeDocs;
  var init_rationalize = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/rationalize.js"() {
      rationalizeDocs = {
        name: "rationalize",
        category: "Algebra",
        syntax: ["rationalize(expr)", "rationalize(expr, scope)", "rationalize(expr, scope, detailed)"],
        description: "Transform a rationalizable expression in a rational fraction. If rational fraction is one variable polynomial then converts the numerator and denominator in canonical form, with decreasing exponents, returning the coefficients of numerator.",
        examples: ['rationalize("2x/y - y/(x+1)")', 'rationalize("2x/y - y/(x+1)", true)'],
        seealso: ["simplify"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/simplify.js
  var simplifyDocs;
  var init_simplify = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/simplify.js"() {
      simplifyDocs = {
        name: "simplify",
        category: "Algebra",
        syntax: ["simplify(expr)", "simplify(expr, rules)"],
        description: "Simplify an expression tree.",
        examples: ['simplify("3 + 2 / 4")', 'simplify("2x + x")', 'f = parse("x * (x + 2 + x)")', "simplified = simplify(f)", "simplified.evaluate({x: 2})"],
        seealso: ["derivative", "parse", "evaluate"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lup.js
  var lupDocs;
  var init_lup = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lup.js"() {
      lupDocs = {
        name: "lup",
        category: "Algebra",
        syntax: ["lup(m)"],
        description: "Calculate the Matrix LU decomposition with partial pivoting. Matrix A is decomposed in three matrices (L, U, P) where P * A = L * U",
        examples: ["lup([[2, 1], [1, 4]])", "lup(matrix([[2, 1], [1, 4]]))", "lup(sparse([[2, 1], [1, 4]]))"],
        seealso: ["lusolve", "lsolve", "usolve", "matrix", "sparse", "slu", "qr"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lsolve.js
  var lsolveDocs;
  var init_lsolve = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lsolve.js"() {
      lsolveDocs = {
        name: "lsolve",
        category: "Algebra",
        syntax: ["x=lsolve(L, b)"],
        description: "Finds one solution of the linear system L * x = b where L is an [n x n] lower triangular matrix and b is a [n] column vector.",
        examples: ["a = [-2, 3; 2, 1]", "b = [11, 9]", "x = lsolve(a, b)"],
        seealso: ["lsolveAll", "lup", "lusolve", "usolve", "matrix", "sparse"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lsolveAll.js
  var lsolveAllDocs;
  var init_lsolveAll = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lsolveAll.js"() {
      lsolveAllDocs = {
        name: "lsolveAll",
        category: "Algebra",
        syntax: ["x=lsolveAll(L, b)"],
        description: "Finds all solutions of the linear system L * x = b where L is an [n x n] lower triangular matrix and b is a [n] column vector.",
        examples: ["a = [-2, 3; 2, 1]", "b = [11, 9]", "x = lsolve(a, b)"],
        seealso: ["lsolve", "lup", "lusolve", "usolve", "matrix", "sparse"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/derivative.js
  var derivativeDocs;
  var init_derivative = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/derivative.js"() {
      derivativeDocs = {
        name: "derivative",
        category: "Algebra",
        syntax: ["derivative(expr, variable)", "derivative(expr, variable, {simplify: boolean})"],
        description: "Takes the derivative of an expression expressed in parser Nodes. The derivative will be taken over the supplied variable in the second parameter. If there are multiple variables in the expression, it will return a partial derivative.",
        examples: ['derivative("2x^3", "x")', 'derivative("2x^3", "x", {simplify: false})', 'derivative("2x^2 + 3x + 4", "x")', 'derivative("sin(2x)", "x")', 'f = parse("x^2 + x")', 'x = parse("x")', "df = derivative(f, x)", "df.evaluate({x: 3})"],
        seealso: ["simplify", "parse", "evaluate"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/version.js
  var versionDocs;
  var init_version = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/version.js"() {
      versionDocs = {
        name: "version",
        category: "Constants",
        syntax: ["version"],
        description: "A string with the version number of math.js",
        examples: ["version"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/true.js
  var trueDocs;
  var init_true = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/true.js"() {
      trueDocs = {
        name: "true",
        category: "Constants",
        syntax: ["true"],
        description: "Boolean value true",
        examples: ["true"],
        seealso: ["false"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/tau.js
  var tauDocs;
  var init_tau = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/tau.js"() {
      tauDocs = {
        name: "tau",
        category: "Constants",
        syntax: ["tau"],
        description: "Tau is the ratio constant of a circle's circumference to radius, equal to 2 * pi, approximately 6.2832.",
        examples: ["tau", "2 * pi"],
        seealso: ["pi"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/SQRT2.js
  var SQRT2Docs;
  var init_SQRT2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/SQRT2.js"() {
      SQRT2Docs = {
        name: "SQRT2",
        category: "Constants",
        syntax: ["SQRT2"],
        description: "Returns the square root of 2, approximately equal to 1.414",
        examples: ["SQRT2", "sqrt(2)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/SQRT1_2.js
  var SQRT12Docs;
  var init_SQRT1_2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/SQRT1_2.js"() {
      SQRT12Docs = {
        name: "SQRT1_2",
        category: "Constants",
        syntax: ["SQRT1_2"],
        description: "Returns the square root of 1/2, approximately equal to 0.707",
        examples: ["SQRT1_2", "sqrt(1/2)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/phi.js
  var phiDocs;
  var init_phi = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/phi.js"() {
      phiDocs = {
        name: "phi",
        category: "Constants",
        syntax: ["phi"],
        description: "Phi is the golden ratio. Two quantities are in the golden ratio if their ratio is the same as the ratio of their sum to the larger of the two quantities. Phi is defined as `(1 + sqrt(5)) / 2` and is approximately 1.618034...",
        examples: ["phi"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/pi.js
  var piDocs;
  var init_pi = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/pi.js"() {
      piDocs = {
        name: "pi",
        category: "Constants",
        syntax: ["pi"],
        description: "The number pi is a mathematical constant that is the ratio of a circle's circumference to its diameter, and is approximately equal to 3.14159",
        examples: ["pi", "sin(pi/2)"],
        seealso: ["tau"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/null.js
  var nullDocs;
  var init_null = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/null.js"() {
      nullDocs = {
        name: "null",
        category: "Constants",
        syntax: ["null"],
        description: "Value null",
        examples: ["null"],
        seealso: ["true", "false"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/NaN.js
  var NaNDocs;
  var init_NaN = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/NaN.js"() {
      NaNDocs = {
        name: "NaN",
        category: "Constants",
        syntax: ["NaN"],
        description: "Not a number",
        examples: ["NaN", "0 / 0"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/LOG10E.js
  var LOG10EDocs;
  var init_LOG10E = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/LOG10E.js"() {
      LOG10EDocs = {
        name: "LOG10E",
        category: "Constants",
        syntax: ["LOG10E"],
        description: "Returns the base-10 logarithm of E, approximately equal to 0.434",
        examples: ["LOG10E", "log(e, 10)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/LOG2E.js
  var LOG2EDocs;
  var init_LOG2E = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/LOG2E.js"() {
      LOG2EDocs = {
        name: "LOG2E",
        category: "Constants",
        syntax: ["LOG2E"],
        description: "Returns the base-2 logarithm of E, approximately equal to 1.442",
        examples: ["LOG2E", "log(e, 2)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/LN10.js
  var LN10Docs;
  var init_LN10 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/LN10.js"() {
      LN10Docs = {
        name: "LN10",
        category: "Constants",
        syntax: ["LN10"],
        description: "Returns the natural logarithm of 10, approximately equal to 2.302",
        examples: ["LN10", "log(10)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/LN2.js
  var LN2Docs;
  var init_LN2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/LN2.js"() {
      LN2Docs = {
        name: "LN2",
        category: "Constants",
        syntax: ["LN2"],
        description: "Returns the natural logarithm of 2, approximately equal to 0.693",
        examples: ["LN2", "log(2)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/Infinity.js
  var InfinityDocs;
  var init_Infinity = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/Infinity.js"() {
      InfinityDocs = {
        name: "Infinity",
        category: "Constants",
        syntax: ["Infinity"],
        description: "Infinity, a number which is larger than the maximum number that can be handled by a floating point number.",
        examples: ["Infinity", "1 / 0"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/i.js
  var iDocs;
  var init_i = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/i.js"() {
      iDocs = {
        name: "i",
        category: "Constants",
        syntax: ["i"],
        description: "Imaginary unit, defined as i*i=-1. A complex number is described as a + b*i, where a is the real part, and b is the imaginary part.",
        examples: ["i", "i * i", "sqrt(-1)"],
        seealso: []
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/false.js
  var falseDocs;
  var init_false = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/false.js"() {
      falseDocs = {
        name: "false",
        category: "Constants",
        syntax: ["false"],
        description: "Boolean value false",
        examples: ["false"],
        seealso: ["true"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/constants/e.js
  var eDocs;
  var init_e = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/constants/e.js"() {
      eDocs = {
        name: "e",
        category: "Constants",
        syntax: ["e"],
        description: "Euler's number, the base of the natural logarithm. Approximately equal to 2.71828",
        examples: ["e", "e ^ 2", "exp(2)", "log(e)"],
        seealso: ["exp"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/unit.js
  var unitDocs;
  var init_unit = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/unit.js"() {
      unitDocs = {
        name: "unit",
        category: "Construction",
        syntax: ["value unit", "unit(value, unit)", "unit(string)"],
        description: "Create a unit.",
        examples: ["5.5 mm", "3 inch", 'unit(7.1, "kilogram")', 'unit("23 deg")'],
        seealso: ["bignumber", "boolean", "complex", "index", "matrix", "number", "string"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/string.js
  var stringDocs;
  var init_string2 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/string.js"() {
      stringDocs = {
        name: "string",
        category: "Construction",
        syntax: ['"text"', "string(x)"],
        description: "Create a string or convert a value to a string",
        examples: ['"Hello World!"', "string(4.2)", "string(3 + 2i)"],
        seealso: ["bignumber", "boolean", "complex", "index", "matrix", "number", "unit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/splitUnit.js
  var splitUnitDocs;
  var init_splitUnit = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/splitUnit.js"() {
      splitUnitDocs = {
        name: "splitUnit",
        category: "Construction",
        syntax: ["splitUnit(unit: Unit, parts: Unit[])"],
        description: "Split a unit in an array of units whose sum is equal to the original unit.",
        examples: ['splitUnit(1 m, ["feet", "inch"])'],
        seealso: ["unit", "createUnit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/sparse.js
  var sparseDocs;
  var init_sparse = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/sparse.js"() {
      sparseDocs = {
        name: "sparse",
        category: "Construction",
        syntax: ["sparse()", "sparse([a1, b1, ...; a1, b2, ...])", 'sparse([a1, b1, ...; a1, b2, ...], "number")'],
        description: "Create a sparse matrix.",
        examples: ["sparse()", "sparse([3, 4; 5, 6])", 'sparse([3, 0; 5, 0], "number")'],
        seealso: ["bignumber", "boolean", "complex", "index", "number", "string", "unit", "matrix"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/number.js
  var numberDocs;
  var init_number3 = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/number.js"() {
      numberDocs = {
        name: "number",
        category: "Construction",
        syntax: ["x", "number(x)", "number(unit, valuelessUnit)"],
        description: "Create a number or convert a string or boolean into a number.",
        examples: ["2", "2e3", "4.05", "number(2)", 'number("7.2")', "number(true)", "number([true, false, true, true])", 'number(unit("52cm"), "m")'],
        seealso: ["bignumber", "boolean", "complex", "fraction", "index", "matrix", "string", "unit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/matrix.js
  var matrixDocs;
  var init_matrix = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/matrix.js"() {
      matrixDocs = {
        name: "matrix",
        category: "Construction",
        syntax: ["[]", "[a1, b1, ...; a2, b2, ...]", "matrix()", 'matrix("dense")', "matrix([...])"],
        description: "Create a matrix.",
        examples: ["[]", "[1, 2, 3]", "[1, 2, 3; 4, 5, 6]", "matrix()", "matrix([3, 4])", 'matrix([3, 4; 5, 6], "sparse")', 'matrix([3, 4; 5, 6], "sparse", "number")'],
        seealso: ["bignumber", "boolean", "complex", "index", "number", "string", "unit", "sparse"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/index.js
  var indexDocs;
  var init_construction = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/index.js"() {
      indexDocs = {
        name: "index",
        category: "Construction",
        syntax: ["[start]", "[start:end]", "[start:step:end]", "[start1, start 2, ...]", "[start1:end1, start2:end2, ...]", "[start1:step1:end1, start2:step2:end2, ...]"],
        description: "Create an index to get or replace a subset of a matrix",
        examples: ["[]", "[1, 2, 3]", "A = [1, 2, 3; 4, 5, 6]", "A[1, :]", "A[1, 2] = 50", "A[0:2, 0:2] = ones(2, 2)"],
        seealso: ["bignumber", "boolean", "complex", "matrix,", "number", "range", "string", "unit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/fraction.js
  var fractionDocs;
  var init_fraction = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/fraction.js"() {
      fractionDocs = {
        name: "fraction",
        category: "Construction",
        syntax: ["fraction(num)", "fraction(num,den)"],
        description: "Create a fraction from a number or from a numerator and denominator.",
        examples: ["fraction(0.125)", "fraction(1, 3) + fraction(2, 5)"],
        seealso: ["bignumber", "boolean", "complex", "index", "matrix", "string", "unit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/createUnit.js
  var createUnitDocs;
  var init_createUnit = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/createUnit.js"() {
      createUnitDocs = {
        name: "createUnit",
        category: "Construction",
        syntax: ["createUnit(definitions)", "createUnit(name, definition)"],
        description: "Create a user-defined unit and register it with the Unit type.",
        examples: ['createUnit("foo")', 'createUnit("knot", {definition: "0.514444444 m/s", aliases: ["knots", "kt", "kts"]})', 'createUnit("mph", "1 mile/hour")'],
        seealso: ["unit", "splitUnit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/complex.js
  var complexDocs;
  var init_complex = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/complex.js"() {
      complexDocs = {
        name: "complex",
        category: "Construction",
        syntax: ["complex()", "complex(re, im)", "complex(string)"],
        description: "Create a complex number.",
        examples: ["complex()", "complex(2, 3)", 'complex("7 - 2i")'],
        seealso: ["bignumber", "boolean", "index", "matrix", "number", "string", "unit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/construction/boolean.js
  var booleanDocs;
  var init_boolean = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/construction/boolean.js"() {
      booleanDocs = {
        name: "boolean",
        category: "Construction",
        syntax: ["x", "boolean(x)"],
        description: "Convert a string or number into a boolean.",
        examples: ["boolean(0)", "boolean(1)", "boolean(3)", 'boolean("true")', 'boolean("false")', "boolean([1, 0, 1, 1])"],
        seealso: ["bignumber", "complex", "index", "matrix", "number", "string", "unit"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/dotPow.js
  var dotPowDocs;
  var init_dotPow = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/dotPow.js"() {
      dotPowDocs = {
        name: "dotPow",
        category: "Operators",
        syntax: ["x .^ y", "dotPow(x, y)"],
        description: "Calculates the power of x to y element wise.",
        examples: ["a = [1, 2, 3; 4, 5, 6]", "a .^ 2"],
        seealso: ["pow"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lusolve.js
  var lusolveDocs;
  var init_lusolve = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/algebra/lusolve.js"() {
      lusolveDocs = {
        name: "lusolve",
        category: "Algebra",
        syntax: ["x=lusolve(A, b)", "x=lusolve(lu, b)"],
        description: "Solves the linear system A * x = b where A is an [n x n] matrix and b is a [n] column vector.",
        examples: ["a = [-2, 3; 2, 1]", "b = [11, 9]", "x = lusolve(a, b)"],
        seealso: ["lup", "slu", "lsolve", "usolve", "matrix", "sparse"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/subtract.js
  var subtractDocs;
  var init_subtract = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/arithmetic/subtract.js"() {
      subtractDocs = {
        name: "subtract",
        category: "Operators",
        syntax: ["x - y", "subtract(x, y)"],
        description: "subtract two values.",
        examples: ["a = 5.3 - 2", "a + 2", "2/3 - 1/6", "2 * 3 - 3", "2.1 km - 500m"],
        seealso: ["add"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/statistics/variance.js
  var varianceDocs;
  var init_variance = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/statistics/variance.js"() {
      varianceDocs = {
        name: "variance",
        category: "Statistics",
        syntax: ["variance(a, b, c, ...)", "variance(A)", "variance(A, normalization)"],
        description: 'Compute the variance of all values. Optional parameter normalization can be "unbiased" (default), "uncorrected", or "biased".',
        examples: ["variance(2, 4, 6)", "variance([2, 4, 6, 8])", 'variance([2, 4, 6, 8], "uncorrected")', 'variance([2, 4, 6, 8], "biased")', "variance([1, 2, 3; 4, 5, 6])"],
        seealso: ["max", "mean", "min", "median", "min", "prod", "std", "sum"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sin.js
  var sinDocs;
  var init_sin = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/trigonometry/sin.js"() {
      sinDocs = {
        name: "sin",
        category: "Trigonometry",
        syntax: ["sin(x)"],
        description: "Compute the sine of x in radians.",
        examples: ["sin(2)", "sin(pi / 4) ^ 2", "sin(90 deg)", "sin(30 deg)", "sin(0.2)^2 + cos(0.2)^2"],
        seealso: ["asin", "cos", "tan"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/utils/numeric.js
  var numericDocs;
  var init_numeric = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/utils/numeric.js"() {
      numericDocs = {
        name: "numeric",
        category: "Utils",
        syntax: ["numeric(x)"],
        description: "Convert a numeric input to a specific numeric type: number, BigNumber, or Fraction.",
        examples: ['numeric("4")', 'numeric("4", "number")', 'numeric("4", "BigNumber")', 'numeric("4", "Fraction)', 'numeric(4, "Fraction")', 'numeric(fraction(2, 5), "number)'],
        seealso: ["number", "fraction", "bignumber", "string", "format"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/column.js
  var columnDocs;
  var init_column = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/column.js"() {
      columnDocs = {
        name: "column",
        category: "Matrix",
        syntax: ["column(x, index)"],
        description: "Return a column from a matrix or array.",
        examples: ["A = [[1, 2], [3, 4]]", "column(A, 1)", "column(A, 2)"],
        seealso: ["row"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/row.js
  var rowDocs;
  var init_row = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/row.js"() {
      rowDocs = {
        name: "row",
        category: "Matrix",
        syntax: ["row(x, index)"],
        description: "Return a row from a matrix or array.",
        examples: ["A = [[1, 2], [3, 4]]", "row(A, 1)", "row(A, 2)"],
        seealso: ["column"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/function/matrix/rotationMatrix.js
  var rotationMatrixDocs;
  var init_rotationMatrix = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/function/matrix/rotationMatrix.js"() {
      rotationMatrixDocs = {
        name: "rotationMatrix",
        category: "Matrix",
        syntax: ["rotationMatrix(theta)", "rotationMatrix(theta, v)", "rotationMatrix(theta, v, format)"],
        description: "Returns a 2-D rotation matrix (2x2) for a given angle (in radians). Returns a 2-D rotation matrix (3x3) of a given angle (in radians) around given axis.",
        examples: ["rotationMatrix(pi / 2)", 'rotationMatrix(unit("45deg"), [0, 0, 1])', 'rotationMatrix(1, matrix([0, 0, 1]), "sparse")'],
        seealso: ["cos", "sin"]
      };
    }
  });

  // node_modules/mathjs/es/expression/embeddedDocs/embeddedDocs.js
  var embeddedDocs;
  var init_embeddedDocs = __esm({
    "node_modules/mathjs/es/expression/embeddedDocs/embeddedDocs.js"() {
      init_bignumber();
      init_typeOf();
      init_isZero();
      init_isPrime();
      init_isPositive();
      init_isNumeric();
      init_hasNumericValue();
      init_isNegative();
      init_isInteger();
      init_isNaN();
      init_format();
      init_bin();
      init_oct();
      init_hex();
      init_clone();
      init_to();
      init_tanh();
      init_tan();
      init_sinh();
      init_sech();
      init_sec();
      init_csch();
      init_csc();
      init_coth();
      init_cot();
      init_cosh();
      init_cos();
      init_atan2();
      init_atanh();
      init_atan();
      init_asinh();
      init_asin();
      init_asech();
      init_asec();
      init_acsch();
      init_acsc();
      init_acoth();
      init_acot();
      init_acosh();
      init_acos();
      init_sum();
      init_std();
      init_quantileSeq();
      init_prod();
      init_mode();
      init_min();
      init_median();
      init_mean();
      init_max();
      init_mad();
      init_erf();
      init_setUnion();
      init_setSymDifference();
      init_setSize();
      init_setPowerset();
      init_setMultiplicity();
      init_setIsSubset();
      init_setIntersect();
      init_setDistinct();
      init_setDifference();
      init_setCartesian();
      init_unequal();
      init_smallerEq();
      init_smaller();
      init_largerEq();
      init_larger();
      init_equalText();
      init_equal();
      init_deepEqual();
      init_compareText();
      init_compareNatural();
      init_compare();
      init_randomInt();
      init_random();
      init_pickRandom();
      init_permutations();
      init_multinomial();
      init_kldivergence();
      init_gamma();
      init_factorial();
      init_combinations2();
      init_combinationsWithRep();
      init_zeros();
      init_transpose();
      init_trace();
      init_subset();
      init_squeeze();
      init_sort();
      init_size();
      init_diff();
      init_reshape();
      init_resize();
      init_range();
      init_partitionSelect();
      init_ones();
      init_map();
      init_kron();
      init_inv();
      init_forEach();
      init_flatten();
      init_filter();
      init_identity();
      init_getMatrixDataType();
      init_dot();
      init_diag();
      init_det();
      init_ctranspose();
      init_cross();
      init_concat();
      init_xor();
      init_or();
      init_not();
      init_and();
      init_intersect();
      init_distance();
      init_help();
      init_evaluate();
      init_im();
      init_re();
      init_conj();
      init_arg();
      init_typed2();
      init_import();
      init_config3();
      init_stirlingS2();
      init_composition();
      init_catalan();
      init_bellNumbers();
      init_rightLogShift();
      init_rightArithShift();
      init_leftShift();
      init_bitXor();
      init_bitOr();
      init_bitNot();
      init_bitAnd();
      init_xgcd();
      init_unaryPlus();
      init_unaryMinus();
      init_square();
      init_sqrtm();
      init_sqrt();
      init_sign();
      init_round();
      init_pow();
      init_nthRoots();
      init_nthRoot();
      init_norm();
      init_multiply();
      init_mod();
      init_log10();
      init_log1p();
      init_log2();
      init_log();
      init_lcm();
      init_hypot();
      init_gcd();
      init_floor();
      init_fix();
      init_expm1();
      init_expm();
      init_eigs();
      init_exp();
      init_dotMultiply();
      init_dotDivide();
      init_divide();
      init_cube();
      init_ceil();
      init_cbrt();
      init_add();
      init_abs();
      init_qr();
      init_usolve();
      init_usolveAll();
      init_slu();
      init_rationalize();
      init_simplify();
      init_lup();
      init_lsolve();
      init_lsolveAll();
      init_derivative();
      init_version();
      init_true();
      init_tau();
      init_SQRT2();
      init_SQRT1_2();
      init_phi();
      init_pi();
      init_null();
      init_NaN();
      init_LOG10E();
      init_LOG2E();
      init_LN10();
      init_LN2();
      init_Infinity();
      init_i();
      init_false();
      init_e();
      init_unit();
      init_string2();
      init_splitUnit();
      init_sparse();
      init_number3();
      init_matrix();
      init_construction();
      init_fraction();
      init_createUnit();
      init_complex();
      init_boolean();
      init_dotPow();
      init_lusolve();
      init_subtract();
      init_variance();
      init_sin();
      init_numeric();
      init_column();
      init_row();
      init_rotationMatrix();
      embeddedDocs = {
        bignumber: bignumberDocs,
        "boolean": booleanDocs,
        complex: complexDocs,
        createUnit: createUnitDocs,
        fraction: fractionDocs,
        index: indexDocs,
        matrix: matrixDocs,
        number: numberDocs,
        sparse: sparseDocs,
        splitUnit: splitUnitDocs,
        string: stringDocs,
        unit: unitDocs,
        e: eDocs,
        E: eDocs,
        "false": falseDocs,
        i: iDocs,
        Infinity: InfinityDocs,
        LN2: LN2Docs,
        LN10: LN10Docs,
        LOG2E: LOG2EDocs,
        LOG10E: LOG10EDocs,
        NaN: NaNDocs,
        "null": nullDocs,
        pi: piDocs,
        PI: piDocs,
        phi: phiDocs,
        SQRT1_2: SQRT12Docs,
        SQRT2: SQRT2Docs,
        tau: tauDocs,
        "true": trueDocs,
        version: versionDocs,
        speedOfLight: {
          description: "Speed of light in vacuum",
          examples: ["speedOfLight"]
        },
        gravitationConstant: {
          description: "Newtonian constant of gravitation",
          examples: ["gravitationConstant"]
        },
        planckConstant: {
          description: "Planck constant",
          examples: ["planckConstant"]
        },
        reducedPlanckConstant: {
          description: "Reduced Planck constant",
          examples: ["reducedPlanckConstant"]
        },
        magneticConstant: {
          description: "Magnetic constant (vacuum permeability)",
          examples: ["magneticConstant"]
        },
        electricConstant: {
          description: "Electric constant (vacuum permeability)",
          examples: ["electricConstant"]
        },
        vacuumImpedance: {
          description: "Characteristic impedance of vacuum",
          examples: ["vacuumImpedance"]
        },
        coulomb: {
          description: "Coulomb's constant",
          examples: ["coulomb"]
        },
        elementaryCharge: {
          description: "Elementary charge",
          examples: ["elementaryCharge"]
        },
        bohrMagneton: {
          description: "Borh magneton",
          examples: ["bohrMagneton"]
        },
        conductanceQuantum: {
          description: "Conductance quantum",
          examples: ["conductanceQuantum"]
        },
        inverseConductanceQuantum: {
          description: "Inverse conductance quantum",
          examples: ["inverseConductanceQuantum"]
        },
        magneticFluxQuantum: {
          description: "Magnetic flux quantum",
          examples: ["magneticFluxQuantum"]
        },
        nuclearMagneton: {
          description: "Nuclear magneton",
          examples: ["nuclearMagneton"]
        },
        klitzing: {
          description: "Von Klitzing constant",
          examples: ["klitzing"]
        },
        bohrRadius: {
          description: "Borh radius",
          examples: ["bohrRadius"]
        },
        classicalElectronRadius: {
          description: "Classical electron radius",
          examples: ["classicalElectronRadius"]
        },
        electronMass: {
          description: "Electron mass",
          examples: ["electronMass"]
        },
        fermiCoupling: {
          description: "Fermi coupling constant",
          examples: ["fermiCoupling"]
        },
        fineStructure: {
          description: "Fine-structure constant",
          examples: ["fineStructure"]
        },
        hartreeEnergy: {
          description: "Hartree energy",
          examples: ["hartreeEnergy"]
        },
        protonMass: {
          description: "Proton mass",
          examples: ["protonMass"]
        },
        deuteronMass: {
          description: "Deuteron Mass",
          examples: ["deuteronMass"]
        },
        neutronMass: {
          description: "Neutron mass",
          examples: ["neutronMass"]
        },
        quantumOfCirculation: {
          description: "Quantum of circulation",
          examples: ["quantumOfCirculation"]
        },
        rydberg: {
          description: "Rydberg constant",
          examples: ["rydberg"]
        },
        thomsonCrossSection: {
          description: "Thomson cross section",
          examples: ["thomsonCrossSection"]
        },
        weakMixingAngle: {
          description: "Weak mixing angle",
          examples: ["weakMixingAngle"]
        },
        efimovFactor: {
          description: "Efimov factor",
          examples: ["efimovFactor"]
        },
        atomicMass: {
          description: "Atomic mass constant",
          examples: ["atomicMass"]
        },
        avogadro: {
          description: "Avogadro's number",
          examples: ["avogadro"]
        },
        boltzmann: {
          description: "Boltzmann constant",
          examples: ["boltzmann"]
        },
        faraday: {
          description: "Faraday constant",
          examples: ["faraday"]
        },
        firstRadiation: {
          description: "First radiation constant",
          examples: ["firstRadiation"]
        },
        loschmidt: {
          description: "Loschmidt constant at T=273.15 K and p=101.325 kPa",
          examples: ["loschmidt"]
        },
        gasConstant: {
          description: "Gas constant",
          examples: ["gasConstant"]
        },
        molarPlanckConstant: {
          description: "Molar Planck constant",
          examples: ["molarPlanckConstant"]
        },
        molarVolume: {
          description: "Molar volume of an ideal gas at T=273.15 K and p=101.325 kPa",
          examples: ["molarVolume"]
        },
        sackurTetrode: {
          description: "Sackur-Tetrode constant at T=1 K and p=101.325 kPa",
          examples: ["sackurTetrode"]
        },
        secondRadiation: {
          description: "Second radiation constant",
          examples: ["secondRadiation"]
        },
        stefanBoltzmann: {
          description: "Stefan-Boltzmann constant",
          examples: ["stefanBoltzmann"]
        },
        wienDisplacement: {
          description: "Wien displacement law constant",
          examples: ["wienDisplacement"]
        },
        molarMass: {
          description: "Molar mass constant",
          examples: ["molarMass"]
        },
        molarMassC12: {
          description: "Molar mass constant of carbon-12",
          examples: ["molarMassC12"]
        },
        gravity: {
          description: "Standard acceleration of gravity (standard acceleration of free-fall on Earth)",
          examples: ["gravity"]
        },
        planckLength: {
          description: "Planck length",
          examples: ["planckLength"]
        },
        planckMass: {
          description: "Planck mass",
          examples: ["planckMass"]
        },
        planckTime: {
          description: "Planck time",
          examples: ["planckTime"]
        },
        planckCharge: {
          description: "Planck charge",
          examples: ["planckCharge"]
        },
        planckTemperature: {
          description: "Planck temperature",
          examples: ["planckTemperature"]
        },
        derivative: derivativeDocs,
        lsolve: lsolveDocs,
        lsolveAll: lsolveAllDocs,
        lup: lupDocs,
        lusolve: lusolveDocs,
        simplify: simplifyDocs,
        rationalize: rationalizeDocs,
        slu: sluDocs,
        usolve: usolveDocs,
        usolveAll: usolveAllDocs,
        qr: qrDocs,
        abs: absDocs,
        add: addDocs,
        cbrt: cbrtDocs,
        ceil: ceilDocs,
        cube: cubeDocs,
        divide: divideDocs,
        dotDivide: dotDivideDocs,
        dotMultiply: dotMultiplyDocs,
        dotPow: dotPowDocs,
        exp: expDocs,
        expm: expmDocs,
        expm1: expm1Docs,
        fix: fixDocs,
        floor: floorDocs,
        gcd: gcdDocs,
        hypot: hypotDocs,
        lcm: lcmDocs,
        log: logDocs,
        log2: log2Docs,
        log1p: log1pDocs,
        log10: log10Docs,
        mod: modDocs,
        multiply: multiplyDocs,
        norm: normDocs,
        nthRoot: nthRootDocs,
        nthRoots: nthRootsDocs,
        pow: powDocs,
        round: roundDocs,
        sign: signDocs,
        sqrt: sqrtDocs,
        sqrtm: sqrtmDocs,
        square: squareDocs,
        subtract: subtractDocs,
        unaryMinus: unaryMinusDocs,
        unaryPlus: unaryPlusDocs,
        xgcd: xgcdDocs,
        bitAnd: bitAndDocs,
        bitNot: bitNotDocs,
        bitOr: bitOrDocs,
        bitXor: bitXorDocs,
        leftShift: leftShiftDocs,
        rightArithShift: rightArithShiftDocs,
        rightLogShift: rightLogShiftDocs,
        bellNumbers: bellNumbersDocs,
        catalan: catalanDocs,
        composition: compositionDocs,
        stirlingS2: stirlingS2Docs,
        config: configDocs,
        "import": importDocs,
        typed: typedDocs,
        arg: argDocs,
        conj: conjDocs,
        re: reDocs,
        im: imDocs,
        evaluate: evaluateDocs,
        help: helpDocs,
        distance: distanceDocs,
        intersect: intersectDocs,
        and: andDocs,
        not: notDocs,
        or: orDocs,
        xor: xorDocs,
        concat: concatDocs,
        cross: crossDocs,
        column: columnDocs,
        ctranspose: ctransposeDocs,
        det: detDocs,
        diag: diagDocs,
        diff: diffDocs,
        dot: dotDocs,
        getMatrixDataType: getMatrixDataTypeDocs,
        identity: identityDocs,
        filter: filterDocs,
        flatten: flattenDocs,
        forEach: forEachDocs,
        inv: invDocs,
        eigs: eigsDocs,
        kron: kronDocs,
        map: mapDocs,
        ones: onesDocs,
        partitionSelect: partitionSelectDocs,
        range: rangeDocs,
        resize: resizeDocs,
        reshape: reshapeDocs,
        rotationMatrix: rotationMatrixDocs,
        row: rowDocs,
        size: sizeDocs,
        sort: sortDocs,
        squeeze: squeezeDocs,
        subset: subsetDocs,
        trace: traceDocs,
        transpose: transposeDocs,
        zeros: zerosDocs,
        combinations: combinationsDocs,
        combinationsWithRep: combinationsWithRepDocs,
        factorial: factorialDocs,
        gamma: gammaDocs,
        kldivergence: kldivergenceDocs,
        multinomial: multinomialDocs,
        permutations: permutationsDocs,
        pickRandom: pickRandomDocs,
        random: randomDocs,
        randomInt: randomIntDocs,
        compare: compareDocs,
        compareNatural: compareNaturalDocs,
        compareText: compareTextDocs,
        deepEqual: deepEqualDocs,
        equal: equalDocs,
        equalText: equalTextDocs,
        larger: largerDocs,
        largerEq: largerEqDocs,
        smaller: smallerDocs,
        smallerEq: smallerEqDocs,
        unequal: unequalDocs,
        setCartesian: setCartesianDocs,
        setDifference: setDifferenceDocs,
        setDistinct: setDistinctDocs,
        setIntersect: setIntersectDocs,
        setIsSubset: setIsSubsetDocs,
        setMultiplicity: setMultiplicityDocs,
        setPowerset: setPowersetDocs,
        setSize: setSizeDocs,
        setSymDifference: setSymDifferenceDocs,
        setUnion: setUnionDocs,
        erf: erfDocs,
        mad: madDocs,
        max: maxDocs,
        mean: meanDocs,
        median: medianDocs,
        min: minDocs,
        mode: modeDocs,
        prod: prodDocs,
        quantileSeq: quantileSeqDocs,
        std: stdDocs,
        sum: sumDocs,
        variance: varianceDocs,
        acos: acosDocs,
        acosh: acoshDocs,
        acot: acotDocs,
        acoth: acothDocs,
        acsc: acscDocs,
        acsch: acschDocs,
        asec: asecDocs,
        asech: asechDocs,
        asin: asinDocs,
        asinh: asinhDocs,
        atan: atanDocs,
        atanh: atanhDocs,
        atan2: atan2Docs,
        cos: cosDocs,
        cosh: coshDocs,
        cot: cotDocs,
        coth: cothDocs,
        csc: cscDocs,
        csch: cschDocs,
        sec: secDocs,
        sech: sechDocs,
        sin: sinDocs,
        sinh: sinhDocs,
        tan: tanDocs,
        tanh: tanhDocs,
        to: toDocs,
        clone: cloneDocs,
        format: formatDocs,
        bin: binDocs,
        oct: octDocs,
        hex: hexDocs,
        isNaN: isNaNDocs,
        isInteger: isIntegerDocs,
        isNegative: isNegativeDocs,
        isNumeric: isNumericDocs,
        hasNumericValue: hasNumericValueDocs,
        isPositive: isPositiveDocs,
        isPrime: isPrimeDocs,
        isZero: isZeroDocs,
        typeOf: typeOfDocs,
        numeric: numericDocs
      };
    }
  });

  // node_modules/mathjs/es/expression/function/help.js
  var name5, dependencies6, createHelp;
  var init_help2 = __esm({
    "node_modules/mathjs/es/expression/function/help.js"() {
      init_factory();
      init_customs();
      init_embeddedDocs();
      init_object();
      name5 = "help";
      dependencies6 = ["typed", "mathWithTransform", "Help"];
      createHelp = /* @__PURE__ */ factory(name5, dependencies6, function(_ref) {
        var typed2 = _ref.typed, mathWithTransform2 = _ref.mathWithTransform, Help2 = _ref.Help;
        return typed2(name5, {
          any: function any(search) {
            var prop;
            var searchName = search;
            if (typeof search !== "string") {
              for (prop in mathWithTransform2) {
                if (hasOwnProperty2(mathWithTransform2, prop) && search === mathWithTransform2[prop]) {
                  searchName = prop;
                  break;
                }
              }
            }
            var doc = getSafeProperty(embeddedDocs, searchName);
            if (!doc) {
              var searchText = typeof searchName === "function" ? searchName.name : searchName;
              throw new Error('No documentation found on "' + searchText + '"');
            }
            return new Help2(doc);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/type/chain/function/chain.js
  var name6, dependencies7, createChain;
  var init_chain = __esm({
    "node_modules/mathjs/es/type/chain/function/chain.js"() {
      init_factory();
      name6 = "chain";
      dependencies7 = ["typed", "Chain"];
      createChain = /* @__PURE__ */ factory(name6, dependencies7, function(_ref) {
        var typed2 = _ref.typed, Chain2 = _ref.Chain;
        return typed2(name6, {
          "": function _2() {
            return new Chain2();
          },
          any: function any(value) {
            return new Chain2(value);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/algebra/simplify/util.js
  var name7, dependencies8, createUtil;
  var init_util = __esm({
    "node_modules/mathjs/es/function/algebra/simplify/util.js"() {
      init_is();
      init_factory();
      init_object();
      name7 = "simplifyUtil";
      dependencies8 = ["FunctionNode", "OperatorNode", "SymbolNode"];
      createUtil = /* @__PURE__ */ factory(name7, dependencies8, function(_ref) {
        var FunctionNode2 = _ref.FunctionNode, OperatorNode2 = _ref.OperatorNode, SymbolNode2 = _ref.SymbolNode;
        var commutative = {
          add: true,
          multiply: true
        };
        var associative = {
          add: true,
          multiply: true
        };
        function isCommutative(node, context) {
          if (!isOperatorNode(node)) {
            return true;
          }
          var name106 = node.fn.toString();
          if (context && hasOwnProperty2(context, name106) && hasOwnProperty2(context[name106], "commutative")) {
            return context[name106].commutative;
          }
          return commutative[name106] || false;
        }
        function isAssociative(node, context) {
          if (!isOperatorNode(node)) {
            return false;
          }
          var name106 = node.fn.toString();
          if (context && hasOwnProperty2(context, name106) && hasOwnProperty2(context[name106], "associative")) {
            return context[name106].associative;
          }
          return associative[name106] || false;
        }
        function flatten2(node) {
          if (!node.args || node.args.length === 0) {
            return node;
          }
          node.args = allChildren(node);
          for (var i3 = 0; i3 < node.args.length; i3++) {
            flatten2(node.args[i3]);
          }
        }
        function allChildren(node) {
          var op;
          var children = [];
          var findChildren = function findChildren2(node2) {
            for (var i3 = 0; i3 < node2.args.length; i3++) {
              var child = node2.args[i3];
              if (isOperatorNode(child) && op === child.op) {
                findChildren2(child);
              } else {
                children.push(child);
              }
            }
          };
          if (isAssociative(node)) {
            op = node.op;
            findChildren(node);
            return children;
          } else {
            return node.args;
          }
        }
        function unflattenr(node) {
          if (!node.args || node.args.length === 0) {
            return;
          }
          var makeNode = createMakeNodeFunction(node);
          var l3 = node.args.length;
          for (var i3 = 0; i3 < l3; i3++) {
            unflattenr(node.args[i3]);
          }
          if (l3 > 2 && isAssociative(node)) {
            var curnode = node.args.pop();
            while (node.args.length > 0) {
              curnode = makeNode([node.args.pop(), curnode]);
            }
            node.args = curnode.args;
          }
        }
        function unflattenl(node) {
          if (!node.args || node.args.length === 0) {
            return;
          }
          var makeNode = createMakeNodeFunction(node);
          var l3 = node.args.length;
          for (var i3 = 0; i3 < l3; i3++) {
            unflattenl(node.args[i3]);
          }
          if (l3 > 2 && isAssociative(node)) {
            var curnode = node.args.shift();
            while (node.args.length > 0) {
              curnode = makeNode([curnode, node.args.shift()]);
            }
            node.args = curnode.args;
          }
        }
        function createMakeNodeFunction(node) {
          if (isOperatorNode(node)) {
            return function(args) {
              try {
                return new OperatorNode2(node.op, node.fn, args, node.implicit);
              } catch (err) {
                console.error(err);
                return [];
              }
            };
          } else {
            return function(args) {
              return new FunctionNode2(new SymbolNode2(node.name), args);
            };
          }
        }
        return {
          createMakeNodeFunction,
          isCommutative,
          isAssociative,
          flatten: flatten2,
          allChildren,
          unflattenr,
          unflattenl
        };
      });
    }
  });

  // node_modules/mathjs/es/function/algebra/simplify/simplifyCore.js
  var name8, dependencies9, createSimplifyCore;
  var init_simplifyCore = __esm({
    "node_modules/mathjs/es/function/algebra/simplify/simplifyCore.js"() {
      init_is();
      init_factory();
      name8 = "simplifyCore";
      dependencies9 = ["equal", "isZero", "add", "subtract", "multiply", "divide", "pow", "ConstantNode", "OperatorNode", "FunctionNode", "ParenthesisNode"];
      createSimplifyCore = /* @__PURE__ */ factory(name8, dependencies9, function(_ref) {
        var equal3 = _ref.equal, isZero2 = _ref.isZero, add2 = _ref.add, subtract2 = _ref.subtract, multiply2 = _ref.multiply, divide2 = _ref.divide, pow2 = _ref.pow, ConstantNode2 = _ref.ConstantNode, OperatorNode2 = _ref.OperatorNode, FunctionNode2 = _ref.FunctionNode, ParenthesisNode2 = _ref.ParenthesisNode;
        var node0 = new ConstantNode2(0);
        var node1 = new ConstantNode2(1);
        function simplifyCore(node) {
          if (isOperatorNode(node) && node.isUnary()) {
            var a0 = simplifyCore(node.args[0]);
            if (node.op === "+") {
              return a0;
            }
            if (node.op === "-") {
              if (isOperatorNode(a0)) {
                if (a0.isUnary() && a0.op === "-") {
                  return a0.args[0];
                } else if (a0.isBinary() && a0.fn === "subtract") {
                  return new OperatorNode2("-", "subtract", [a0.args[1], a0.args[0]]);
                }
              }
              return new OperatorNode2(node.op, node.fn, [a0]);
            }
          } else if (isOperatorNode(node) && node.isBinary()) {
            var _a = simplifyCore(node.args[0]);
            var a1 = simplifyCore(node.args[1]);
            if (node.op === "+") {
              if (isConstantNode(_a)) {
                if (isZero2(_a.value)) {
                  return a1;
                } else if (isConstantNode(a1)) {
                  return new ConstantNode2(add2(_a.value, a1.value));
                }
              }
              if (isConstantNode(a1) && isZero2(a1.value)) {
                return _a;
              }
              if (isOperatorNode(a1) && a1.isUnary() && a1.op === "-") {
                return new OperatorNode2("-", "subtract", [_a, a1.args[0]]);
              }
              return new OperatorNode2(node.op, node.fn, a1 ? [_a, a1] : [_a]);
            } else if (node.op === "-") {
              if (isConstantNode(_a) && a1) {
                if (isConstantNode(a1)) {
                  return new ConstantNode2(subtract2(_a.value, a1.value));
                } else if (isZero2(_a.value)) {
                  return new OperatorNode2("-", "unaryMinus", [a1]);
                }
              }
              if (node.fn === "subtract") {
                if (isConstantNode(a1) && isZero2(a1.value)) {
                  return _a;
                }
                if (isOperatorNode(a1) && a1.isUnary() && a1.op === "-") {
                  return simplifyCore(new OperatorNode2("+", "add", [_a, a1.args[0]]));
                }
                return new OperatorNode2(node.op, node.fn, [_a, a1]);
              }
            } else if (node.op === "*") {
              if (isConstantNode(_a)) {
                if (isZero2(_a.value)) {
                  return node0;
                } else if (equal3(_a.value, 1)) {
                  return a1;
                } else if (isConstantNode(a1)) {
                  return new ConstantNode2(multiply2(_a.value, a1.value));
                }
              }
              if (isConstantNode(a1)) {
                if (isZero2(a1.value)) {
                  return node0;
                } else if (equal3(a1.value, 1)) {
                  return _a;
                } else if (isOperatorNode(_a) && _a.isBinary() && _a.op === node.op) {
                  var a00 = _a.args[0];
                  if (isConstantNode(a00)) {
                    var a00a1 = new ConstantNode2(multiply2(a00.value, a1.value));
                    return new OperatorNode2(node.op, node.fn, [a00a1, _a.args[1]], node.implicit);
                  }
                }
                return new OperatorNode2(node.op, node.fn, [a1, _a], node.implicit);
              }
              return new OperatorNode2(node.op, node.fn, [_a, a1], node.implicit);
            } else if (node.op === "/") {
              if (isConstantNode(_a)) {
                if (isZero2(_a.value)) {
                  return node0;
                } else if (isConstantNode(a1) && (equal3(a1.value, 1) || equal3(a1.value, 2) || equal3(a1.value, 4))) {
                  return new ConstantNode2(divide2(_a.value, a1.value));
                }
              }
              return new OperatorNode2(node.op, node.fn, [_a, a1]);
            } else if (node.op === "^") {
              if (isConstantNode(a1)) {
                if (isZero2(a1.value)) {
                  return node1;
                } else if (equal3(a1.value, 1)) {
                  return _a;
                } else {
                  if (isConstantNode(_a)) {
                    return new ConstantNode2(pow2(_a.value, a1.value));
                  } else if (isOperatorNode(_a) && _a.isBinary() && _a.op === "^") {
                    var a01 = _a.args[1];
                    if (isConstantNode(a01)) {
                      return new OperatorNode2(node.op, node.fn, [_a.args[0], new ConstantNode2(multiply2(a01.value, a1.value))]);
                    }
                  }
                }
              }
              return new OperatorNode2(node.op, node.fn, [_a, a1]);
            }
          } else if (isParenthesisNode(node)) {
            var c3 = simplifyCore(node.content);
            if (isParenthesisNode(c3) || isSymbolNode(c3) || isConstantNode(c3)) {
              return c3;
            }
            return new ParenthesisNode2(c3);
          } else if (isFunctionNode(node)) {
            var args = node.args.map(simplifyCore).map(function(arg) {
              return isParenthesisNode(arg) ? arg.content : arg;
            });
            return new FunctionNode2(simplifyCore(node.fn), args);
          } else {
          }
          return node;
        }
        return simplifyCore;
      });
    }
  });

  // node_modules/mathjs/es/function/algebra/simplify/simplifyConstant.js
  var name9, dependencies10, createSimplifyConstant;
  var init_simplifyConstant = __esm({
    "node_modules/mathjs/es/function/algebra/simplify/simplifyConstant.js"() {
      init_is();
      init_factory();
      init_util();
      init_noop();
      name9 = "simplifyConstant";
      dependencies10 = ["typed", "config", "mathWithTransform", "?fraction", "?bignumber", "ConstantNode", "OperatorNode", "FunctionNode", "SymbolNode"];
      createSimplifyConstant = /* @__PURE__ */ factory(name9, dependencies10, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, mathWithTransform2 = _ref.mathWithTransform, fraction = _ref.fraction, bignumber = _ref.bignumber, ConstantNode2 = _ref.ConstantNode, OperatorNode2 = _ref.OperatorNode, FunctionNode2 = _ref.FunctionNode, SymbolNode2 = _ref.SymbolNode;
        var _createUtil = createUtil({
          FunctionNode: FunctionNode2,
          OperatorNode: OperatorNode2,
          SymbolNode: SymbolNode2
        }), isCommutative = _createUtil.isCommutative, isAssociative = _createUtil.isAssociative, allChildren = _createUtil.allChildren, createMakeNodeFunction = _createUtil.createMakeNodeFunction;
        function simplifyConstant(expr, options) {
          var res = foldFraction(expr, options);
          return isNode(res) ? res : _toNode(res);
        }
        function _eval(fnname, args, options) {
          try {
            return _toNumber(mathWithTransform2[fnname].apply(null, args), options);
          } catch (ignore) {
            args = args.map(function(x3) {
              if (isFraction(x3)) {
                return x3.valueOf();
              }
              return x3;
            });
            return _toNumber(mathWithTransform2[fnname].apply(null, args), options);
          }
        }
        var _toNode = typed2({
          Fraction: _fractionToNode,
          number: function number2(n3) {
            if (n3 < 0) {
              return unaryMinusNode(new ConstantNode2(-n3));
            }
            return new ConstantNode2(n3);
          },
          BigNumber: function BigNumber(n3) {
            if (n3 < 0) {
              return unaryMinusNode(new ConstantNode2(-n3));
            }
            return new ConstantNode2(n3);
          },
          Complex: function Complex(s3) {
            throw new Error("Cannot convert Complex number to Node");
          }
        });
        function _exactFraction(n3, options) {
          var exactFractions = options && options.exactFractions !== false;
          if (exactFractions && isFinite(n3) && fraction) {
            var f3 = fraction(n3);
            if (f3.valueOf() === n3) {
              return f3;
            }
          }
          return n3;
        }
        var _toNumber = typed2({
          "string, Object": function stringObject(s3, options) {
            if (config3.number === "BigNumber") {
              if (bignumber === void 0) {
                noBignumber();
              }
              return bignumber(s3);
            } else if (config3.number === "Fraction") {
              if (fraction === void 0) {
                noFraction();
              }
              return fraction(s3);
            } else {
              var n3 = parseFloat(s3);
              return _exactFraction(n3, options);
            }
          },
          "Fraction, Object": function FractionObject(s3, options) {
            return s3;
          },
          "BigNumber, Object": function BigNumberObject(s3, options) {
            return s3;
          },
          "number, Object": function numberObject(s3, options) {
            return _exactFraction(s3, options);
          },
          "Complex, Object": function ComplexObject(s3, options) {
            if (s3.im !== 0) {
              return s3;
            }
            return _exactFraction(s3.re, options);
          }
        });
        function unaryMinusNode(n3) {
          return new OperatorNode2("-", "unaryMinus", [n3]);
        }
        function _fractionToNode(f3) {
          var n3;
          var vn = f3.s * f3.n;
          if (vn < 0) {
            n3 = new OperatorNode2("-", "unaryMinus", [new ConstantNode2(-vn)]);
          } else {
            n3 = new ConstantNode2(vn);
          }
          if (f3.d === 1) {
            return n3;
          }
          return new OperatorNode2("/", "divide", [n3, new ConstantNode2(f3.d)]);
        }
        function foldOp(fn, args, makeNode, options) {
          return args.reduce(function(a3, b2) {
            if (!isNode(a3) && !isNode(b2)) {
              try {
                return _eval(fn, [a3, b2], options);
              } catch (ignoreandcontinue) {
              }
              a3 = _toNode(a3);
              b2 = _toNode(b2);
            } else if (!isNode(a3)) {
              a3 = _toNode(a3);
            } else if (!isNode(b2)) {
              b2 = _toNode(b2);
            }
            return makeNode([a3, b2]);
          });
        }
        function foldFraction(node, options) {
          switch (node.type) {
            case "SymbolNode":
              return node;
            case "ConstantNode":
              if (typeof node.value === "number" || !isNaN(node.value)) {
                return _toNumber(node.value, options);
              }
              return node;
            case "FunctionNode":
              if (mathWithTransform2[node.name] && mathWithTransform2[node.name].rawArgs) {
                return node;
              }
              {
                var operatorFunctions = ["add", "multiply"];
                if (operatorFunctions.indexOf(node.name) === -1) {
                  var args = node.args.map(function(arg) {
                    return foldFraction(arg, options);
                  });
                  if (!args.some(isNode)) {
                    try {
                      return _eval(node.name, args, options);
                    } catch (ignoreandcontine) {
                    }
                  }
                  args = args.map(function(arg) {
                    return isNode(arg) ? arg : _toNode(arg);
                  });
                  return new FunctionNode2(node.name, args);
                } else {
                }
              }
            case "OperatorNode": {
              var fn = node.fn.toString();
              var _args;
              var res;
              var makeNode = createMakeNodeFunction(node);
              if (isOperatorNode(node) && node.isUnary()) {
                _args = [foldFraction(node.args[0], options)];
                if (!isNode(_args[0])) {
                  res = _eval(fn, _args, options);
                } else {
                  res = makeNode(_args);
                }
              } else if (isAssociative(node)) {
                _args = allChildren(node);
                _args = _args.map(function(arg) {
                  return foldFraction(arg, options);
                });
                if (isCommutative(fn)) {
                  var consts = [];
                  var vars = [];
                  for (var i3 = 0; i3 < _args.length; i3++) {
                    if (!isNode(_args[i3])) {
                      consts.push(_args[i3]);
                    } else {
                      vars.push(_args[i3]);
                    }
                  }
                  if (consts.length > 1) {
                    res = foldOp(fn, consts, makeNode, options);
                    vars.unshift(res);
                    res = foldOp(fn, vars, makeNode, options);
                  } else {
                    res = foldOp(fn, _args, makeNode, options);
                  }
                } else {
                  res = foldOp(fn, _args, makeNode, options);
                }
              } else {
                _args = node.args.map(function(arg) {
                  return foldFraction(arg, options);
                });
                res = foldOp(fn, _args, makeNode, options);
              }
              return res;
            }
            case "ParenthesisNode":
              return foldFraction(node.content, options);
            case "AccessorNode":
            case "ArrayNode":
            case "AssignmentNode":
            case "BlockNode":
            case "FunctionAssignmentNode":
            case "IndexNode":
            case "ObjectNode":
            case "RangeNode":
            case "ConditionalNode":
            default:
              throw new Error("Unimplemented node type in simplifyConstant: ".concat(node.type));
          }
        }
        return simplifyConstant;
      });
    }
  });

  // node_modules/mathjs/es/function/algebra/simplify/resolve.js
  var name10, dependencies11, createResolve;
  var init_resolve = __esm({
    "node_modules/mathjs/es/function/algebra/simplify/resolve.js"() {
      init_is();
      init_factory();
      name10 = "resolve";
      dependencies11 = ["parse", "FunctionNode", "OperatorNode", "ParenthesisNode"];
      createResolve = /* @__PURE__ */ factory(name10, dependencies11, function(_ref) {
        var parse2 = _ref.parse, FunctionNode2 = _ref.FunctionNode, OperatorNode2 = _ref.OperatorNode, ParenthesisNode2 = _ref.ParenthesisNode;
        function resolve(node, scope) {
          if (!scope) {
            return node;
          }
          if (isSymbolNode(node)) {
            var value = scope[node.name];
            if (isNode(value)) {
              return resolve(value, scope);
            } else if (typeof value === "number") {
              return parse2(String(value));
            }
          } else if (isOperatorNode(node)) {
            var args = node.args.map(function(arg) {
              return resolve(arg, scope);
            });
            return new OperatorNode2(node.op, node.fn, args, node.implicit);
          } else if (isParenthesisNode(node)) {
            return new ParenthesisNode2(resolve(node.content, scope));
          } else if (isFunctionNode(node)) {
            var _args = node.args.map(function(arg) {
              return resolve(arg, scope);
            });
            return new FunctionNode2(node.name, _args);
          }
          return node;
        }
        return resolve;
      });
    }
  });

  // node_modules/mathjs/es/function/algebra/simplify.js
  function _typeof5(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof5 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof5 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof5(obj);
  }
  var name11, dependencies12, createSimplify;
  var init_simplify2 = __esm({
    "node_modules/mathjs/es/function/algebra/simplify.js"() {
      init_is();
      init_factory();
      init_util();
      init_simplifyCore();
      init_simplifyConstant();
      init_resolve();
      init_object();
      name11 = "simplify";
      dependencies12 = ["config", "typed", "parse", "add", "subtract", "multiply", "divide", "pow", "isZero", "equal", "?fraction", "?bignumber", "mathWithTransform", "ConstantNode", "FunctionNode", "OperatorNode", "ParenthesisNode", "SymbolNode"];
      createSimplify = /* @__PURE__ */ factory(name11, dependencies12, function(_ref) {
        var config3 = _ref.config, typed2 = _ref.typed, parse2 = _ref.parse, add2 = _ref.add, subtract2 = _ref.subtract, multiply2 = _ref.multiply, divide2 = _ref.divide, pow2 = _ref.pow, isZero2 = _ref.isZero, equal3 = _ref.equal, fraction = _ref.fraction, bignumber = _ref.bignumber, mathWithTransform2 = _ref.mathWithTransform, ConstantNode2 = _ref.ConstantNode, FunctionNode2 = _ref.FunctionNode, OperatorNode2 = _ref.OperatorNode, ParenthesisNode2 = _ref.ParenthesisNode, SymbolNode2 = _ref.SymbolNode;
        var simplifyConstant = createSimplifyConstant({
          typed: typed2,
          config: config3,
          mathWithTransform: mathWithTransform2,
          fraction,
          bignumber,
          ConstantNode: ConstantNode2,
          OperatorNode: OperatorNode2,
          FunctionNode: FunctionNode2,
          SymbolNode: SymbolNode2
        });
        var simplifyCore = createSimplifyCore({
          equal: equal3,
          isZero: isZero2,
          add: add2,
          subtract: subtract2,
          multiply: multiply2,
          divide: divide2,
          pow: pow2,
          ConstantNode: ConstantNode2,
          OperatorNode: OperatorNode2,
          FunctionNode: FunctionNode2,
          ParenthesisNode: ParenthesisNode2
        });
        var resolve = createResolve({
          parse: parse2,
          FunctionNode: FunctionNode2,
          OperatorNode: OperatorNode2,
          ParenthesisNode: ParenthesisNode2
        });
        var _createUtil = createUtil({
          FunctionNode: FunctionNode2,
          OperatorNode: OperatorNode2,
          SymbolNode: SymbolNode2
        }), isCommutative = _createUtil.isCommutative, isAssociative = _createUtil.isAssociative, flatten2 = _createUtil.flatten, unflattenr = _createUtil.unflattenr, unflattenl = _createUtil.unflattenl, createMakeNodeFunction = _createUtil.createMakeNodeFunction;
        var simplify2 = typed2("simplify", {
          string: function string2(expr) {
            return this(parse2(expr), this.rules, {}, {});
          },
          "string, Object": function stringObject(expr, scope) {
            return this(parse2(expr), this.rules, scope, {});
          },
          "string, Object, Object": function stringObjectObject(expr, scope, options) {
            return this(parse2(expr), this.rules, scope, options);
          },
          "string, Array": function stringArray(expr, rules) {
            return this(parse2(expr), rules, {}, {});
          },
          "string, Array, Object": function stringArrayObject(expr, rules, scope) {
            return this(parse2(expr), rules, scope, {});
          },
          "string, Array, Object, Object": function stringArrayObjectObject(expr, rules, scope, options) {
            return this(parse2(expr), rules, scope, options);
          },
          "Node, Object": function NodeObject(expr, scope) {
            return this(expr, this.rules, scope, {});
          },
          "Node, Object, Object": function NodeObjectObject(expr, scope, options) {
            return this(expr, this.rules, scope, options);
          },
          Node: function Node3(expr) {
            return this(expr, this.rules, {}, {});
          },
          "Node, Array": function NodeArray(expr, rules) {
            return this(expr, rules, {}, {});
          },
          "Node, Array, Object": function NodeArrayObject(expr, rules, scope) {
            return this(expr, rules, scope, {});
          },
          "Node, Array, Object, Object": function NodeArrayObjectObject(expr, rules, scope, options) {
            rules = _buildRules(rules);
            var res = resolve(expr, scope);
            res = removeParens(res);
            var visited = {};
            var str = res.toString({
              parenthesis: "all"
            });
            while (!visited[str]) {
              visited[str] = true;
              _lastsym = 0;
              for (var i3 = 0; i3 < rules.length; i3++) {
                if (typeof rules[i3] === "function") {
                  res = rules[i3](res, options);
                } else {
                  flatten2(res);
                  res = applyRule(res, rules[i3]);
                }
                unflattenl(res);
              }
              str = res.toString({
                parenthesis: "all"
              });
            }
            return res;
          }
        });
        simplify2.simplifyCore = simplifyCore;
        simplify2.resolve = resolve;
        function removeParens(node) {
          return node.transform(function(node2, path, parent) {
            return isParenthesisNode(node2) ? removeParens(node2.content) : node2;
          });
        }
        var SUPPORTED_CONSTANTS = {
          "true": true,
          "false": true,
          e: true,
          i: true,
          Infinity: true,
          LN2: true,
          LN10: true,
          LOG2E: true,
          LOG10E: true,
          NaN: true,
          phi: true,
          pi: true,
          SQRT1_2: true,
          SQRT2: true,
          tau: true
        };
        simplify2.rules = [
          simplifyCore,
          {
            l: "log(e)",
            r: "1"
          },
          {
            l: "n-n1",
            r: "n+-n1"
          },
          {
            l: "-(c*v)",
            r: "(-c) * v"
          },
          {
            l: "-v",
            r: "(-1) * v"
          },
          {
            l: "n/n1^n2",
            r: "n*n1^-n2"
          },
          {
            l: "n/n1",
            r: "n*n1^-1"
          },
          {
            l: "(n ^ n1) ^ n2",
            r: "n ^ (n1 * n2)"
          },
          {
            l: "n*n",
            r: "n^2"
          },
          {
            l: "n * n^n1",
            r: "n^(n1+1)"
          },
          {
            l: "n^n1 * n^n2",
            r: "n^(n1+n2)"
          },
          {
            l: "n+n",
            r: "2*n"
          },
          {
            l: "n+-n",
            r: "0"
          },
          {
            l: "n1*n2 + n2",
            r: "(n1+1)*n2"
          },
          {
            l: "n1*n3 + n2*n3",
            r: "(n1+n2)*n3"
          },
          {
            l: "n1 + -1 * (n2 + n3)",
            r: "n1 + -1 * n2 + -1 * n3"
          },
          simplifyConstant,
          {
            l: "(-n)*n1",
            r: "-(n*n1)"
          },
          {
            l: "c+v",
            r: "v+c",
            context: {
              add: {
                commutative: false
              }
            }
          },
          {
            l: "v*c",
            r: "c*v",
            context: {
              multiply: {
                commutative: false
              }
            }
          },
          {
            l: "n+-n1",
            r: "n-n1"
          },
          {
            l: "n*(n1^-1)",
            r: "n/n1"
          },
          {
            l: "n*n1^-n2",
            r: "n/n1^n2"
          },
          {
            l: "n1^-1",
            r: "1/n1"
          },
          {
            l: "n*(n1/n2)",
            r: "(n*n1)/n2"
          },
          {
            l: "n-(n1+n2)",
            r: "n-n1-n2"
          },
          {
            l: "1*n",
            r: "n"
          },
          {
            l: "n1/(n2/n3)",
            r: "(n1*n3)/n2"
          }
        ];
        function _buildRules(rules) {
          var ruleSet = [];
          for (var i3 = 0; i3 < rules.length; i3++) {
            var rule = rules[i3];
            var newRule = void 0;
            var ruleType = _typeof5(rule);
            switch (ruleType) {
              case "string": {
                var lr = rule.split("->");
                if (lr.length === 2) {
                  rule = {
                    l: lr[0],
                    r: lr[1]
                  };
                } else {
                  throw SyntaxError("Could not parse rule: " + rule);
                }
              }
              case "object":
                newRule = {
                  l: removeParens(parse2(rule.l)),
                  r: removeParens(parse2(rule.r))
                };
                if (rule.context) {
                  newRule.evaluate = rule.context;
                }
                if (rule.evaluate) {
                  newRule.evaluate = parse2(rule.evaluate);
                }
                if (isAssociative(newRule.l)) {
                  var makeNode = createMakeNodeFunction(newRule.l);
                  var expandsym = _getExpandPlaceholderSymbol();
                  newRule.expanded = {};
                  newRule.expanded.l = makeNode([newRule.l.clone(), expandsym]);
                  flatten2(newRule.expanded.l);
                  unflattenr(newRule.expanded.l);
                  newRule.expanded.r = makeNode([newRule.r, expandsym]);
                }
                break;
              case "function":
                newRule = rule;
                break;
              default:
                throw TypeError("Unsupported type of rule: " + ruleType);
            }
            ruleSet.push(newRule);
          }
          return ruleSet;
        }
        var _lastsym = 0;
        function _getExpandPlaceholderSymbol() {
          return new SymbolNode2("_p" + _lastsym++);
        }
        var applyRule = typed2("applyRule", {
          "Node, Object": function NodeObject(node, rule) {
            var res = node;
            if (res instanceof OperatorNode2 || res instanceof FunctionNode2) {
              if (res.args) {
                for (var i3 = 0; i3 < res.args.length; i3++) {
                  res.args[i3] = applyRule(res.args[i3], rule);
                }
              }
            } else if (res instanceof ParenthesisNode2) {
              if (res.content) {
                res.content = applyRule(res.content, rule);
              }
            }
            var repl = rule.r;
            var matches = _ruleMatch(rule.l, res)[0];
            if (!matches && rule.expanded) {
              repl = rule.expanded.r;
              matches = _ruleMatch(rule.expanded.l, res)[0];
            }
            if (matches) {
              var implicit = res.implicit;
              res = repl.clone();
              if (implicit && "implicit" in repl) {
                res.implicit = true;
              }
              res = res.transform(function(node2) {
                if (node2.isSymbolNode && hasOwnProperty2(matches.placeholders, node2.name)) {
                  return matches.placeholders[node2.name].clone();
                } else {
                  return node2;
                }
              });
            }
            return res;
          }
        });
        function getSplits(node, context) {
          var res = [];
          var right, rightArgs;
          var makeNode = createMakeNodeFunction(node);
          if (isCommutative(node, context)) {
            for (var i3 = 0; i3 < node.args.length; i3++) {
              rightArgs = node.args.slice(0);
              rightArgs.splice(i3, 1);
              right = rightArgs.length === 1 ? rightArgs[0] : makeNode(rightArgs);
              res.push(makeNode([node.args[i3], right]));
            }
          } else {
            rightArgs = node.args.slice(1);
            right = rightArgs.length === 1 ? rightArgs[0] : makeNode(rightArgs);
            res.push(makeNode([node.args[0], right]));
          }
          return res;
        }
        function mergeMatch(match1, match2) {
          var res = {
            placeholders: {}
          };
          if (!match1.placeholders && !match2.placeholders) {
            return res;
          } else if (!match1.placeholders) {
            return match2;
          } else if (!match2.placeholders) {
            return match1;
          }
          for (var key in match1.placeholders) {
            if (hasOwnProperty2(match1.placeholders, key)) {
              res.placeholders[key] = match1.placeholders[key];
              if (hasOwnProperty2(match2.placeholders, key)) {
                if (!_exactMatch(match1.placeholders[key], match2.placeholders[key])) {
                  return null;
                }
              }
            }
          }
          for (var _key in match2.placeholders) {
            if (hasOwnProperty2(match2.placeholders, _key)) {
              res.placeholders[_key] = match2.placeholders[_key];
            }
          }
          return res;
        }
        function combineChildMatches(list1, list2) {
          var res = [];
          if (list1.length === 0 || list2.length === 0) {
            return res;
          }
          var merged;
          for (var i1 = 0; i1 < list1.length; i1++) {
            for (var i22 = 0; i22 < list2.length; i22++) {
              merged = mergeMatch(list1[i1], list2[i22]);
              if (merged) {
                res.push(merged);
              }
            }
          }
          return res;
        }
        function mergeChildMatches(childMatches) {
          if (childMatches.length === 0) {
            return childMatches;
          }
          var sets = childMatches.reduce(combineChildMatches);
          var uniqueSets = [];
          var unique = {};
          for (var i3 = 0; i3 < sets.length; i3++) {
            var s3 = JSON.stringify(sets[i3]);
            if (!unique[s3]) {
              unique[s3] = true;
              uniqueSets.push(sets[i3]);
            }
          }
          return uniqueSets;
        }
        function _ruleMatch(rule, node, isSplit) {
          var res = [{
            placeholders: {}
          }];
          if (rule instanceof OperatorNode2 && node instanceof OperatorNode2 || rule instanceof FunctionNode2 && node instanceof FunctionNode2) {
            if (rule instanceof OperatorNode2) {
              if (rule.op !== node.op || rule.fn !== node.fn) {
                return [];
              }
            } else if (rule instanceof FunctionNode2) {
              if (rule.name !== node.name) {
                return [];
              }
            }
            if (node.args.length === 1 && rule.args.length === 1 || !isAssociative(node) || isSplit) {
              var childMatches = [];
              for (var i3 = 0; i3 < rule.args.length; i3++) {
                var childMatch = _ruleMatch(rule.args[i3], node.args[i3]);
                if (childMatch.length === 0) {
                  return [];
                }
                childMatches.push(childMatch);
              }
              res = mergeChildMatches(childMatches);
            } else if (node.args.length >= 2 && rule.args.length === 2) {
              var splits = getSplits(node, rule.context);
              var splitMatches = [];
              for (var _i = 0; _i < splits.length; _i++) {
                var matchSet = _ruleMatch(rule, splits[_i], true);
                splitMatches = splitMatches.concat(matchSet);
              }
              return splitMatches;
            } else if (rule.args.length > 2) {
              throw Error("Unexpected non-binary associative function: " + rule.toString());
            } else {
              return [];
            }
          } else if (rule instanceof SymbolNode2) {
            if (rule.name.length === 0) {
              throw new Error("Symbol in rule has 0 length...!?");
            }
            if (SUPPORTED_CONSTANTS[rule.name]) {
              if (rule.name !== node.name) {
                return [];
              }
            } else if (rule.name[0] === "n" || rule.name.substring(0, 2) === "_p") {
              res[0].placeholders[rule.name] = node;
            } else if (rule.name[0] === "v") {
              if (!isConstantNode(node)) {
                res[0].placeholders[rule.name] = node;
              } else {
                return [];
              }
            } else if (rule.name[0] === "c") {
              if (node instanceof ConstantNode2) {
                res[0].placeholders[rule.name] = node;
              } else {
                return [];
              }
            } else {
              throw new Error("Invalid symbol in rule: " + rule.name);
            }
          } else if (rule instanceof ConstantNode2) {
            if (!equal3(rule.value, node.value)) {
              return [];
            }
          } else {
            return [];
          }
          return res;
        }
        function _exactMatch(p3, q) {
          if (p3 instanceof ConstantNode2 && q instanceof ConstantNode2) {
            if (!equal3(p3.value, q.value)) {
              return false;
            }
          } else if (p3 instanceof SymbolNode2 && q instanceof SymbolNode2) {
            if (p3.name !== q.name) {
              return false;
            }
          } else if (p3 instanceof OperatorNode2 && q instanceof OperatorNode2 || p3 instanceof FunctionNode2 && q instanceof FunctionNode2) {
            if (p3 instanceof OperatorNode2) {
              if (p3.op !== q.op || p3.fn !== q.fn) {
                return false;
              }
            } else if (p3 instanceof FunctionNode2) {
              if (p3.name !== q.name) {
                return false;
              }
            }
            if (p3.args.length !== q.args.length) {
              return false;
            }
            for (var i3 = 0; i3 < p3.args.length; i3++) {
              if (!_exactMatch(p3.args[i3], q.args[i3])) {
                return false;
              }
            }
          } else {
            return false;
          }
          return true;
        }
        return simplify2;
      });
    }
  });

  // node_modules/mathjs/es/function/algebra/derivative.js
  var name12, dependencies13, createDerivative;
  var init_derivative2 = __esm({
    "node_modules/mathjs/es/function/algebra/derivative.js"() {
      init_is();
      init_factory();
      name12 = "derivative";
      dependencies13 = ["typed", "config", "parse", "simplify", "equal", "isZero", "numeric", "ConstantNode", "FunctionNode", "OperatorNode", "ParenthesisNode", "SymbolNode"];
      createDerivative = /* @__PURE__ */ factory(name12, dependencies13, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, parse2 = _ref.parse, simplify2 = _ref.simplify, equal3 = _ref.equal, isZero2 = _ref.isZero, numeric3 = _ref.numeric, ConstantNode2 = _ref.ConstantNode, FunctionNode2 = _ref.FunctionNode, OperatorNode2 = _ref.OperatorNode, ParenthesisNode2 = _ref.ParenthesisNode, SymbolNode2 = _ref.SymbolNode;
        var derivative2 = typed2("derivative", {
          "Node, SymbolNode, Object": function NodeSymbolNodeObject(expr, variable, options) {
            var constNodes = {};
            constTag(constNodes, expr, variable.name);
            var res = _derivative(expr, constNodes);
            return options.simplify ? simplify2(res) : res;
          },
          "Node, SymbolNode": function NodeSymbolNode(expr, variable) {
            return this(expr, variable, {
              simplify: true
            });
          },
          "string, SymbolNode": function stringSymbolNode(expr, variable) {
            return this(parse2(expr), variable);
          },
          "string, SymbolNode, Object": function stringSymbolNodeObject(expr, variable, options) {
            return this(parse2(expr), variable, options);
          },
          "string, string": function stringString(expr, variable) {
            return this(parse2(expr), parse2(variable));
          },
          "string, string, Object": function stringStringObject(expr, variable, options) {
            return this(parse2(expr), parse2(variable), options);
          },
          "Node, string": function NodeString(expr, variable) {
            return this(expr, parse2(variable));
          },
          "Node, string, Object": function NodeStringObject(expr, variable, options) {
            return this(expr, parse2(variable), options);
          }
        });
        derivative2._simplify = true;
        derivative2.toTex = function(deriv) {
          return _derivTex.apply(null, deriv.args);
        };
        var _derivTex = typed2("_derivTex", {
          "Node, SymbolNode": function NodeSymbolNode(expr, x3) {
            if (isConstantNode(expr) && typeOf(expr.value) === "string") {
              return _derivTex(parse2(expr.value).toString(), x3.toString(), 1);
            } else {
              return _derivTex(expr.toString(), x3.toString(), 1);
            }
          },
          "Node, ConstantNode": function NodeConstantNode(expr, x3) {
            if (typeOf(x3.value) === "string") {
              return _derivTex(expr, parse2(x3.value));
            } else {
              throw new Error("The second parameter to 'derivative' is a non-string constant");
            }
          },
          "Node, SymbolNode, ConstantNode": function NodeSymbolNodeConstantNode(expr, x3, order) {
            return _derivTex(expr.toString(), x3.name, order.value);
          },
          "string, string, number": function stringStringNumber(expr, x3, order) {
            var d4;
            if (order === 1) {
              d4 = "{d\\over d" + x3 + "}";
            } else {
              d4 = "{d^{" + order + "}\\over d" + x3 + "^{" + order + "}}";
            }
            return d4 + "\\left[".concat(expr, "\\right]");
          }
        });
        var constTag = typed2("constTag", {
          "Object, ConstantNode, string": function ObjectConstantNodeString(constNodes, node) {
            constNodes[node] = true;
            return true;
          },
          "Object, SymbolNode, string": function ObjectSymbolNodeString(constNodes, node, varName) {
            if (node.name !== varName) {
              constNodes[node] = true;
              return true;
            }
            return false;
          },
          "Object, ParenthesisNode, string": function ObjectParenthesisNodeString(constNodes, node, varName) {
            return constTag(constNodes, node.content, varName);
          },
          "Object, FunctionAssignmentNode, string": function ObjectFunctionAssignmentNodeString(constNodes, node, varName) {
            if (node.params.indexOf(varName) === -1) {
              constNodes[node] = true;
              return true;
            }
            return constTag(constNodes, node.expr, varName);
          },
          "Object, FunctionNode | OperatorNode, string": function ObjectFunctionNodeOperatorNodeString(constNodes, node, varName) {
            if (node.args.length > 0) {
              var isConst = constTag(constNodes, node.args[0], varName);
              for (var i3 = 1; i3 < node.args.length; ++i3) {
                isConst = constTag(constNodes, node.args[i3], varName) && isConst;
              }
              if (isConst) {
                constNodes[node] = true;
                return true;
              }
            }
            return false;
          }
        });
        var _derivative = typed2("_derivative", {
          "ConstantNode, Object": function ConstantNodeObject(node) {
            return createConstantNode2(0);
          },
          "SymbolNode, Object": function SymbolNodeObject(node, constNodes) {
            if (constNodes[node] !== void 0) {
              return createConstantNode2(0);
            }
            return createConstantNode2(1);
          },
          "ParenthesisNode, Object": function ParenthesisNodeObject(node, constNodes) {
            return new ParenthesisNode2(_derivative(node.content, constNodes));
          },
          "FunctionAssignmentNode, Object": function FunctionAssignmentNodeObject(node, constNodes) {
            if (constNodes[node] !== void 0) {
              return createConstantNode2(0);
            }
            return _derivative(node.expr, constNodes);
          },
          "FunctionNode, Object": function FunctionNodeObject(node, constNodes) {
            if (node.args.length !== 1) {
              funcArgsCheck(node);
            }
            if (constNodes[node] !== void 0) {
              return createConstantNode2(0);
            }
            var arg0 = node.args[0];
            var arg1;
            var div = false;
            var negative = false;
            var funcDerivative;
            switch (node.name) {
              case "cbrt":
                div = true;
                funcDerivative = new OperatorNode2("*", "multiply", [createConstantNode2(3), new OperatorNode2("^", "pow", [arg0, new OperatorNode2("/", "divide", [createConstantNode2(2), createConstantNode2(3)])])]);
                break;
              case "sqrt":
              case "nthRoot":
                if (node.args.length === 1) {
                  div = true;
                  funcDerivative = new OperatorNode2("*", "multiply", [createConstantNode2(2), new FunctionNode2("sqrt", [arg0])]);
                } else if (node.args.length === 2) {
                  arg1 = new OperatorNode2("/", "divide", [createConstantNode2(1), node.args[1]]);
                  constNodes[arg1] = constNodes[node.args[1]];
                  return _derivative(new OperatorNode2("^", "pow", [arg0, arg1]), constNodes);
                }
                break;
              case "log10":
                arg1 = createConstantNode2(10);
              case "log":
                if (!arg1 && node.args.length === 1) {
                  funcDerivative = arg0.clone();
                  div = true;
                } else if (node.args.length === 1 && arg1 || node.args.length === 2 && constNodes[node.args[1]] !== void 0) {
                  funcDerivative = new OperatorNode2("*", "multiply", [arg0.clone(), new FunctionNode2("log", [arg1 || node.args[1]])]);
                  div = true;
                } else if (node.args.length === 2) {
                  return _derivative(new OperatorNode2("/", "divide", [new FunctionNode2("log", [arg0]), new FunctionNode2("log", [node.args[1]])]), constNodes);
                }
                break;
              case "pow":
                constNodes[arg1] = constNodes[node.args[1]];
                return _derivative(new OperatorNode2("^", "pow", [arg0, node.args[1]]), constNodes);
              case "exp":
                funcDerivative = new FunctionNode2("exp", [arg0.clone()]);
                break;
              case "sin":
                funcDerivative = new FunctionNode2("cos", [arg0.clone()]);
                break;
              case "cos":
                funcDerivative = new OperatorNode2("-", "unaryMinus", [new FunctionNode2("sin", [arg0.clone()])]);
                break;
              case "tan":
                funcDerivative = new OperatorNode2("^", "pow", [new FunctionNode2("sec", [arg0.clone()]), createConstantNode2(2)]);
                break;
              case "sec":
                funcDerivative = new OperatorNode2("*", "multiply", [node, new FunctionNode2("tan", [arg0.clone()])]);
                break;
              case "csc":
                negative = true;
                funcDerivative = new OperatorNode2("*", "multiply", [node, new FunctionNode2("cot", [arg0.clone()])]);
                break;
              case "cot":
                negative = true;
                funcDerivative = new OperatorNode2("^", "pow", [new FunctionNode2("csc", [arg0.clone()]), createConstantNode2(2)]);
                break;
              case "asin":
                div = true;
                funcDerivative = new FunctionNode2("sqrt", [new OperatorNode2("-", "subtract", [createConstantNode2(1), new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)])])]);
                break;
              case "acos":
                div = true;
                negative = true;
                funcDerivative = new FunctionNode2("sqrt", [new OperatorNode2("-", "subtract", [createConstantNode2(1), new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)])])]);
                break;
              case "atan":
                div = true;
                funcDerivative = new OperatorNode2("+", "add", [new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)]), createConstantNode2(1)]);
                break;
              case "asec":
                div = true;
                funcDerivative = new OperatorNode2("*", "multiply", [new FunctionNode2("abs", [arg0.clone()]), new FunctionNode2("sqrt", [new OperatorNode2("-", "subtract", [new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)]), createConstantNode2(1)])])]);
                break;
              case "acsc":
                div = true;
                negative = true;
                funcDerivative = new OperatorNode2("*", "multiply", [new FunctionNode2("abs", [arg0.clone()]), new FunctionNode2("sqrt", [new OperatorNode2("-", "subtract", [new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)]), createConstantNode2(1)])])]);
                break;
              case "acot":
                div = true;
                negative = true;
                funcDerivative = new OperatorNode2("+", "add", [new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)]), createConstantNode2(1)]);
                break;
              case "sinh":
                funcDerivative = new FunctionNode2("cosh", [arg0.clone()]);
                break;
              case "cosh":
                funcDerivative = new FunctionNode2("sinh", [arg0.clone()]);
                break;
              case "tanh":
                funcDerivative = new OperatorNode2("^", "pow", [new FunctionNode2("sech", [arg0.clone()]), createConstantNode2(2)]);
                break;
              case "sech":
                negative = true;
                funcDerivative = new OperatorNode2("*", "multiply", [node, new FunctionNode2("tanh", [arg0.clone()])]);
                break;
              case "csch":
                negative = true;
                funcDerivative = new OperatorNode2("*", "multiply", [node, new FunctionNode2("coth", [arg0.clone()])]);
                break;
              case "coth":
                negative = true;
                funcDerivative = new OperatorNode2("^", "pow", [new FunctionNode2("csch", [arg0.clone()]), createConstantNode2(2)]);
                break;
              case "asinh":
                div = true;
                funcDerivative = new FunctionNode2("sqrt", [new OperatorNode2("+", "add", [new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)]), createConstantNode2(1)])]);
                break;
              case "acosh":
                div = true;
                funcDerivative = new FunctionNode2("sqrt", [new OperatorNode2("-", "subtract", [new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)]), createConstantNode2(1)])]);
                break;
              case "atanh":
                div = true;
                funcDerivative = new OperatorNode2("-", "subtract", [createConstantNode2(1), new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)])]);
                break;
              case "asech":
                div = true;
                negative = true;
                funcDerivative = new OperatorNode2("*", "multiply", [arg0.clone(), new FunctionNode2("sqrt", [new OperatorNode2("-", "subtract", [createConstantNode2(1), new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)])])])]);
                break;
              case "acsch":
                div = true;
                negative = true;
                funcDerivative = new OperatorNode2("*", "multiply", [new FunctionNode2("abs", [arg0.clone()]), new FunctionNode2("sqrt", [new OperatorNode2("+", "add", [new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)]), createConstantNode2(1)])])]);
                break;
              case "acoth":
                div = true;
                negative = true;
                funcDerivative = new OperatorNode2("-", "subtract", [createConstantNode2(1), new OperatorNode2("^", "pow", [arg0.clone(), createConstantNode2(2)])]);
                break;
              case "abs":
                funcDerivative = new OperatorNode2("/", "divide", [new FunctionNode2(new SymbolNode2("abs"), [arg0.clone()]), arg0.clone()]);
                break;
              case "gamma":
              default:
                throw new Error('Function "' + node.name + '" is not supported by derivative, or a wrong number of arguments is passed');
            }
            var op, func;
            if (div) {
              op = "/";
              func = "divide";
            } else {
              op = "*";
              func = "multiply";
            }
            var chainDerivative = _derivative(arg0, constNodes);
            if (negative) {
              chainDerivative = new OperatorNode2("-", "unaryMinus", [chainDerivative]);
            }
            return new OperatorNode2(op, func, [chainDerivative, funcDerivative]);
          },
          "OperatorNode, Object": function OperatorNodeObject(node, constNodes) {
            if (constNodes[node] !== void 0) {
              return createConstantNode2(0);
            }
            if (node.op === "+") {
              return new OperatorNode2(node.op, node.fn, node.args.map(function(arg) {
                return _derivative(arg, constNodes);
              }));
            }
            if (node.op === "-") {
              if (node.isUnary()) {
                return new OperatorNode2(node.op, node.fn, [_derivative(node.args[0], constNodes)]);
              }
              if (node.isBinary()) {
                return new OperatorNode2(node.op, node.fn, [_derivative(node.args[0], constNodes), _derivative(node.args[1], constNodes)]);
              }
            }
            if (node.op === "*") {
              var constantTerms = node.args.filter(function(arg) {
                return constNodes[arg] !== void 0;
              });
              if (constantTerms.length > 0) {
                var nonConstantTerms = node.args.filter(function(arg) {
                  return constNodes[arg] === void 0;
                });
                var nonConstantNode = nonConstantTerms.length === 1 ? nonConstantTerms[0] : new OperatorNode2("*", "multiply", nonConstantTerms);
                var newArgs = constantTerms.concat(_derivative(nonConstantNode, constNodes));
                return new OperatorNode2("*", "multiply", newArgs);
              }
              return new OperatorNode2("+", "add", node.args.map(function(argOuter) {
                return new OperatorNode2("*", "multiply", node.args.map(function(argInner) {
                  return argInner === argOuter ? _derivative(argInner, constNodes) : argInner.clone();
                }));
              }));
            }
            if (node.op === "/" && node.isBinary()) {
              var arg0 = node.args[0];
              var arg1 = node.args[1];
              if (constNodes[arg1] !== void 0) {
                return new OperatorNode2("/", "divide", [_derivative(arg0, constNodes), arg1]);
              }
              if (constNodes[arg0] !== void 0) {
                return new OperatorNode2("*", "multiply", [new OperatorNode2("-", "unaryMinus", [arg0]), new OperatorNode2("/", "divide", [_derivative(arg1, constNodes), new OperatorNode2("^", "pow", [arg1.clone(), createConstantNode2(2)])])]);
              }
              return new OperatorNode2("/", "divide", [new OperatorNode2("-", "subtract", [new OperatorNode2("*", "multiply", [_derivative(arg0, constNodes), arg1.clone()]), new OperatorNode2("*", "multiply", [arg0.clone(), _derivative(arg1, constNodes)])]), new OperatorNode2("^", "pow", [arg1.clone(), createConstantNode2(2)])]);
            }
            if (node.op === "^" && node.isBinary()) {
              var _arg = node.args[0];
              var _arg2 = node.args[1];
              if (constNodes[_arg] !== void 0) {
                if (isConstantNode(_arg) && (isZero2(_arg.value) || equal3(_arg.value, 1))) {
                  return createConstantNode2(0);
                }
                return new OperatorNode2("*", "multiply", [node, new OperatorNode2("*", "multiply", [new FunctionNode2("log", [_arg.clone()]), _derivative(_arg2.clone(), constNodes)])]);
              }
              if (constNodes[_arg2] !== void 0) {
                if (isConstantNode(_arg2)) {
                  if (isZero2(_arg2.value)) {
                    return createConstantNode2(0);
                  }
                  if (equal3(_arg2.value, 1)) {
                    return _derivative(_arg, constNodes);
                  }
                }
                var powMinusOne = new OperatorNode2("^", "pow", [_arg.clone(), new OperatorNode2("-", "subtract", [_arg2, createConstantNode2(1)])]);
                return new OperatorNode2("*", "multiply", [_arg2.clone(), new OperatorNode2("*", "multiply", [_derivative(_arg, constNodes), powMinusOne])]);
              }
              return new OperatorNode2("*", "multiply", [new OperatorNode2("^", "pow", [_arg.clone(), _arg2.clone()]), new OperatorNode2("+", "add", [new OperatorNode2("*", "multiply", [_derivative(_arg, constNodes), new OperatorNode2("/", "divide", [_arg2.clone(), _arg.clone()])]), new OperatorNode2("*", "multiply", [_derivative(_arg2, constNodes), new FunctionNode2("log", [_arg.clone()])])])]);
            }
            throw new Error('Operator "' + node.op + '" is not supported by derivative, or a wrong number of arguments is passed');
          }
        });
        function funcArgsCheck(node) {
          if ((node.name === "log" || node.name === "nthRoot" || node.name === "pow") && node.args.length === 2) {
            return;
          }
          for (var i3 = 0; i3 < node.args.length; ++i3) {
            node.args[i3] = createConstantNode2(0);
          }
          node.compile().evaluate();
          throw new Error("Expected TypeError, but none found");
        }
        function createConstantNode2(value, valueType) {
          return new ConstantNode2(numeric3(value, valueType || config3.number));
        }
        return derivative2;
      });
    }
  });

  // node_modules/mathjs/es/function/algebra/rationalize.js
  var name13, dependencies14, createRationalize;
  var init_rationalize2 = __esm({
    "node_modules/mathjs/es/function/algebra/rationalize.js"() {
      init_number();
      init_factory();
      init_simplifyConstant();
      init_simplifyCore();
      name13 = "rationalize";
      dependencies14 = ["config", "typed", "equal", "isZero", "add", "subtract", "multiply", "divide", "pow", "parse", "simplify", "?bignumber", "?fraction", "mathWithTransform", "ConstantNode", "OperatorNode", "FunctionNode", "SymbolNode", "ParenthesisNode"];
      createRationalize = /* @__PURE__ */ factory(name13, dependencies14, function(_ref) {
        var config3 = _ref.config, typed2 = _ref.typed, equal3 = _ref.equal, isZero2 = _ref.isZero, add2 = _ref.add, subtract2 = _ref.subtract, multiply2 = _ref.multiply, divide2 = _ref.divide, pow2 = _ref.pow, parse2 = _ref.parse, simplify2 = _ref.simplify, fraction = _ref.fraction, bignumber = _ref.bignumber, mathWithTransform2 = _ref.mathWithTransform, ConstantNode2 = _ref.ConstantNode, OperatorNode2 = _ref.OperatorNode, FunctionNode2 = _ref.FunctionNode, SymbolNode2 = _ref.SymbolNode, ParenthesisNode2 = _ref.ParenthesisNode;
        var simplifyConstant = createSimplifyConstant({
          typed: typed2,
          config: config3,
          mathWithTransform: mathWithTransform2,
          fraction,
          bignumber,
          ConstantNode: ConstantNode2,
          OperatorNode: OperatorNode2,
          FunctionNode: FunctionNode2,
          SymbolNode: SymbolNode2
        });
        var simplifyCore = createSimplifyCore({
          equal: equal3,
          isZero: isZero2,
          add: add2,
          subtract: subtract2,
          multiply: multiply2,
          divide: divide2,
          pow: pow2,
          ConstantNode: ConstantNode2,
          OperatorNode: OperatorNode2,
          FunctionNode: FunctionNode2,
          ParenthesisNode: ParenthesisNode2
        });
        return typed2(name13, {
          string: function string2(expr) {
            return this(parse2(expr), {}, false);
          },
          "string, boolean": function stringBoolean(expr, detailed) {
            return this(parse2(expr), {}, detailed);
          },
          "string, Object": function stringObject(expr, scope) {
            return this(parse2(expr), scope, false);
          },
          "string, Object, boolean": function stringObjectBoolean(expr, scope, detailed) {
            return this(parse2(expr), scope, detailed);
          },
          Node: function Node3(expr) {
            return this(expr, {}, false);
          },
          "Node, boolean": function NodeBoolean(expr, detailed) {
            return this(expr, {}, detailed);
          },
          "Node, Object": function NodeObject(expr, scope) {
            return this(expr, scope, false);
          },
          "Node, Object, boolean": function NodeObjectBoolean(expr, scope, detailed) {
            var setRules = rulesRationalize();
            var polyRet = polynomial(expr, scope, true, setRules.firstRules);
            var nVars = polyRet.variables.length;
            expr = polyRet.expression;
            if (nVars >= 1) {
              expr = expandPower(expr);
              var sBefore;
              var rules;
              var eDistrDiv = true;
              var redoInic = false;
              expr = simplify2(expr, setRules.firstRules, {}, {
                exactFractions: false
              });
              var s3;
              while (true) {
                rules = eDistrDiv ? setRules.distrDivRules : setRules.sucDivRules;
                expr = simplify2(expr, rules);
                eDistrDiv = !eDistrDiv;
                s3 = expr.toString();
                if (s3 === sBefore) {
                  break;
                }
                redoInic = true;
                sBefore = s3;
              }
              if (redoInic) {
                expr = simplify2(expr, setRules.firstRulesAgain, {}, {
                  exactFractions: false
                });
              }
              expr = simplify2(expr, setRules.finalRules, {}, {
                exactFractions: false
              });
            }
            var coefficients = [];
            var retRationalize = {};
            if (expr.type === "OperatorNode" && expr.isBinary() && expr.op === "/") {
              if (nVars === 1) {
                expr.args[0] = polyToCanonical(expr.args[0], coefficients);
                expr.args[1] = polyToCanonical(expr.args[1]);
              }
              if (detailed) {
                retRationalize.numerator = expr.args[0];
                retRationalize.denominator = expr.args[1];
              }
            } else {
              if (nVars === 1) {
                expr = polyToCanonical(expr, coefficients);
              }
              if (detailed) {
                retRationalize.numerator = expr;
                retRationalize.denominator = null;
              }
            }
            if (!detailed)
              return expr;
            retRationalize.coefficients = coefficients;
            retRationalize.variables = polyRet.variables;
            retRationalize.expression = expr;
            return retRationalize;
          }
        });
        function polynomial(expr, scope, extended, rules) {
          var variables = [];
          var node = simplify2(expr, rules, scope, {
            exactFractions: false
          });
          extended = !!extended;
          var oper = "+-*" + (extended ? "/" : "");
          recPoly(node);
          var retFunc = {};
          retFunc.expression = node;
          retFunc.variables = variables;
          return retFunc;
          function recPoly(node2) {
            var tp = node2.type;
            if (tp === "FunctionNode") {
              throw new Error("There is an unsolved function call");
            } else if (tp === "OperatorNode") {
              if (node2.op === "^") {
                if (node2.args[1].type !== "ConstantNode" || !isInteger(parseFloat(node2.args[1].value))) {
                  throw new Error("There is a non-integer exponent");
                } else {
                  recPoly(node2.args[0]);
                }
              } else {
                if (oper.indexOf(node2.op) === -1) {
                  throw new Error("Operator " + node2.op + " invalid in polynomial expression");
                }
                for (var i3 = 0; i3 < node2.args.length; i3++) {
                  recPoly(node2.args[i3]);
                }
              }
            } else if (tp === "SymbolNode") {
              var _name = node2.name;
              var pos = variables.indexOf(_name);
              if (pos === -1) {
                variables.push(_name);
              }
            } else if (tp === "ParenthesisNode") {
              recPoly(node2.content);
            } else if (tp !== "ConstantNode") {
              throw new Error("type " + tp + " is not allowed in polynomial expression");
            }
          }
        }
        function rulesRationalize() {
          var oldRules = [
            simplifyCore,
            {
              l: "n+n",
              r: "2*n"
            },
            {
              l: "n+-n",
              r: "0"
            },
            simplifyConstant,
            {
              l: "n*(n1^-1)",
              r: "n/n1"
            },
            {
              l: "n*n1^-n2",
              r: "n/n1^n2"
            },
            {
              l: "n1^-1",
              r: "1/n1"
            },
            {
              l: "n*(n1/n2)",
              r: "(n*n1)/n2"
            },
            {
              l: "1*n",
              r: "n"
            }
          ];
          var rulesFirst = [
            {
              l: "(-n1)/(-n2)",
              r: "n1/n2"
            },
            {
              l: "(-n1)*(-n2)",
              r: "n1*n2"
            },
            {
              l: "n1--n2",
              r: "n1+n2"
            },
            {
              l: "n1-n2",
              r: "n1+(-n2)"
            },
            {
              l: "(n1+n2)*n3",
              r: "(n1*n3 + n2*n3)"
            },
            {
              l: "n1*(n2+n3)",
              r: "(n1*n2+n1*n3)"
            },
            {
              l: "c1*n + c2*n",
              r: "(c1+c2)*n"
            },
            {
              l: "c1*n + n",
              r: "(c1+1)*n"
            },
            {
              l: "c1*n - c2*n",
              r: "(c1-c2)*n"
            },
            {
              l: "c1*n - n",
              r: "(c1-1)*n"
            },
            {
              l: "v/c",
              r: "(1/c)*v"
            },
            {
              l: "v/-c",
              r: "-(1/c)*v"
            },
            {
              l: "-v*-c",
              r: "c*v"
            },
            {
              l: "-v*c",
              r: "-c*v"
            },
            {
              l: "v*-c",
              r: "-c*v"
            },
            {
              l: "v*c",
              r: "c*v"
            },
            {
              l: "-(-n1*n2)",
              r: "(n1*n2)"
            },
            {
              l: "-(n1*n2)",
              r: "(-n1*n2)"
            },
            {
              l: "-(-n1+n2)",
              r: "(n1-n2)"
            },
            {
              l: "-(n1+n2)",
              r: "(-n1-n2)"
            },
            {
              l: "(n1^n2)^n3",
              r: "(n1^(n2*n3))"
            },
            {
              l: "-(-n1/n2)",
              r: "(n1/n2)"
            },
            {
              l: "-(n1/n2)",
              r: "(-n1/n2)"
            }
          ];
          var rulesDistrDiv = [
            {
              l: "(n1/n2 + n3/n4)",
              r: "((n1*n4 + n3*n2)/(n2*n4))"
            },
            {
              l: "(n1/n2 + n3)",
              r: "((n1 + n3*n2)/n2)"
            },
            {
              l: "(n1 + n2/n3)",
              r: "((n1*n3 + n2)/n3)"
            }
          ];
          var rulesSucDiv = [
            {
              l: "(n1/(n2/n3))",
              r: "((n1*n3)/n2)"
            },
            {
              l: "(n1/n2/n3)",
              r: "(n1/(n2*n3))"
            }
          ];
          var setRules = {};
          setRules.firstRules = oldRules.concat(rulesFirst, rulesSucDiv);
          setRules.distrDivRules = rulesDistrDiv;
          setRules.sucDivRules = rulesSucDiv;
          setRules.firstRulesAgain = oldRules.concat(rulesFirst);
          setRules.finalRules = [
            simplifyCore,
            {
              l: "n*-n",
              r: "-n^2"
            },
            {
              l: "n*n",
              r: "n^2"
            },
            simplifyConstant,
            {
              l: "n*-n^n1",
              r: "-n^(n1+1)"
            },
            {
              l: "n*n^n1",
              r: "n^(n1+1)"
            },
            {
              l: "n^n1*-n^n2",
              r: "-n^(n1+n2)"
            },
            {
              l: "n^n1*n^n2",
              r: "n^(n1+n2)"
            },
            {
              l: "n^n1*-n",
              r: "-n^(n1+1)"
            },
            {
              l: "n^n1*n",
              r: "n^(n1+1)"
            },
            {
              l: "n^n1/-n",
              r: "-n^(n1-1)"
            },
            {
              l: "n^n1/n",
              r: "n^(n1-1)"
            },
            {
              l: "n/-n^n1",
              r: "-n^(1-n1)"
            },
            {
              l: "n/n^n1",
              r: "n^(1-n1)"
            },
            {
              l: "n^n1/-n^n2",
              r: "n^(n1-n2)"
            },
            {
              l: "n^n1/n^n2",
              r: "n^(n1-n2)"
            },
            {
              l: "n1+(-n2*n3)",
              r: "n1-n2*n3"
            },
            {
              l: "v*(-c)",
              r: "-c*v"
            },
            {
              l: "n1+-n2",
              r: "n1-n2"
            },
            {
              l: "v*c",
              r: "c*v"
            },
            {
              l: "(n1^n2)^n3",
              r: "(n1^(n2*n3))"
            }
          ];
          return setRules;
        }
        function expandPower(node, parent, indParent) {
          var tp = node.type;
          var internal = arguments.length > 1;
          if (tp === "OperatorNode" && node.isBinary()) {
            var does = false;
            var val;
            if (node.op === "^") {
              if ((node.args[0].type === "ParenthesisNode" || node.args[0].type === "OperatorNode") && node.args[1].type === "ConstantNode") {
                val = parseFloat(node.args[1].value);
                does = val >= 2 && isInteger(val);
              }
            }
            if (does) {
              if (val > 2) {
                var nEsqTopo = node.args[0];
                var nDirTopo = new OperatorNode2("^", "pow", [node.args[0].cloneDeep(), new ConstantNode2(val - 1)]);
                node = new OperatorNode2("*", "multiply", [nEsqTopo, nDirTopo]);
              } else {
                node = new OperatorNode2("*", "multiply", [node.args[0], node.args[0].cloneDeep()]);
              }
              if (internal) {
                if (indParent === "content") {
                  parent.content = node;
                } else {
                  parent.args[indParent] = node;
                }
              }
            }
          }
          if (tp === "ParenthesisNode") {
            expandPower(node.content, node, "content");
          } else if (tp !== "ConstantNode" && tp !== "SymbolNode") {
            for (var i3 = 0; i3 < node.args.length; i3++) {
              expandPower(node.args[i3], node, i3);
            }
          }
          if (!internal) {
            return node;
          }
        }
        function polyToCanonical(node, coefficients) {
          if (coefficients === void 0) {
            coefficients = [];
          }
          coefficients[0] = 0;
          var o3 = {};
          o3.cte = 1;
          o3.oper = "+";
          o3.fire = "";
          var maxExpo = 0;
          var varname = "";
          recurPol(node, null, o3);
          maxExpo = coefficients.length - 1;
          var first = true;
          var no;
          for (var i3 = maxExpo; i3 >= 0; i3--) {
            if (coefficients[i3] === 0)
              continue;
            var n16 = new ConstantNode2(first ? coefficients[i3] : Math.abs(coefficients[i3]));
            var op = coefficients[i3] < 0 ? "-" : "+";
            if (i3 > 0) {
              var n25 = new SymbolNode2(varname);
              if (i3 > 1) {
                var n3 = new ConstantNode2(i3);
                n25 = new OperatorNode2("^", "pow", [n25, n3]);
              }
              if (coefficients[i3] === -1 && first) {
                n16 = new OperatorNode2("-", "unaryMinus", [n25]);
              } else if (Math.abs(coefficients[i3]) === 1) {
                n16 = n25;
              } else {
                n16 = new OperatorNode2("*", "multiply", [n16, n25]);
              }
            }
            if (first) {
              no = n16;
            } else if (op === "+") {
              no = new OperatorNode2("+", "add", [no, n16]);
            } else {
              no = new OperatorNode2("-", "subtract", [no, n16]);
            }
            first = false;
          }
          if (first) {
            return new ConstantNode2(0);
          } else {
            return no;
          }
          function recurPol(node2, noPai, o4) {
            var tp = node2.type;
            if (tp === "FunctionNode") {
              throw new Error("There is an unsolved function call");
            } else if (tp === "OperatorNode") {
              if ("+-*^".indexOf(node2.op) === -1)
                throw new Error("Operator " + node2.op + " invalid");
              if (noPai !== null) {
                if ((node2.fn === "unaryMinus" || node2.fn === "pow") && noPai.fn !== "add" && noPai.fn !== "subtract" && noPai.fn !== "multiply") {
                  throw new Error("Invalid " + node2.op + " placing");
                }
                if ((node2.fn === "subtract" || node2.fn === "add" || node2.fn === "multiply") && noPai.fn !== "add" && noPai.fn !== "subtract") {
                  throw new Error("Invalid " + node2.op + " placing");
                }
                if ((node2.fn === "subtract" || node2.fn === "add" || node2.fn === "unaryMinus") && o4.noFil !== 0) {
                  throw new Error("Invalid " + node2.op + " placing");
                }
              }
              if (node2.op === "^" || node2.op === "*") {
                o4.fire = node2.op;
              }
              for (var _i = 0; _i < node2.args.length; _i++) {
                if (node2.fn === "unaryMinus")
                  o4.oper = "-";
                if (node2.op === "+" || node2.fn === "subtract") {
                  o4.fire = "";
                  o4.cte = 1;
                  o4.oper = _i === 0 ? "+" : node2.op;
                }
                o4.noFil = _i;
                recurPol(node2.args[_i], node2, o4);
              }
            } else if (tp === "SymbolNode") {
              if (node2.name !== varname && varname !== "") {
                throw new Error("There is more than one variable");
              }
              varname = node2.name;
              if (noPai === null) {
                coefficients[1] = 1;
                return;
              }
              if (noPai.op === "^" && o4.noFil !== 0) {
                throw new Error("In power the variable should be the first parameter");
              }
              if (noPai.op === "*" && o4.noFil !== 1) {
                throw new Error("In multiply the variable should be the second parameter");
              }
              if (o4.fire === "" || o4.fire === "*") {
                if (maxExpo < 1)
                  coefficients[1] = 0;
                coefficients[1] += o4.cte * (o4.oper === "+" ? 1 : -1);
                maxExpo = Math.max(1, maxExpo);
              }
            } else if (tp === "ConstantNode") {
              var valor = parseFloat(node2.value);
              if (noPai === null) {
                coefficients[0] = valor;
                return;
              }
              if (noPai.op === "^") {
                if (o4.noFil !== 1)
                  throw new Error("Constant cannot be powered");
                if (!isInteger(valor) || valor <= 0) {
                  throw new Error("Non-integer exponent is not allowed");
                }
                for (var _i2 = maxExpo + 1; _i2 < valor; _i2++) {
                  coefficients[_i2] = 0;
                }
                if (valor > maxExpo)
                  coefficients[valor] = 0;
                coefficients[valor] += o4.cte * (o4.oper === "+" ? 1 : -1);
                maxExpo = Math.max(valor, maxExpo);
                return;
              }
              o4.cte = valor;
              if (o4.fire === "") {
                coefficients[0] += o4.cte * (o4.oper === "+" ? 1 : -1);
              }
            } else {
              throw new Error("Type " + tp + " is not allowed");
            }
          }
        }
      });
    }
  });

  // node_modules/mathjs/es/utils/collection.js
  function containsCollections(array) {
    for (var i3 = 0; i3 < array.length; i3++) {
      if (isCollection(array[i3])) {
        return true;
      }
    }
    return false;
  }
  function deepForEach(array, callback) {
    if (isMatrix(array)) {
      array = array.valueOf();
    }
    for (var i3 = 0, ii = array.length; i3 < ii; i3++) {
      var value = array[i3];
      if (Array.isArray(value)) {
        deepForEach(value, callback);
      } else {
        callback(value);
      }
    }
  }
  function deepMap(array, callback, skipZeros) {
    if (array && typeof array.map === "function") {
      return array.map(function(x3) {
        return deepMap(x3, callback, skipZeros);
      });
    } else {
      return callback(array);
    }
  }
  function reduce(mat, dim, callback) {
    var size2 = Array.isArray(mat) ? arraySize(mat) : mat.size();
    if (dim < 0 || dim >= size2.length) {
      throw new IndexError(dim, size2.length);
    }
    if (isMatrix(mat)) {
      return mat.create(_reduce(mat.valueOf(), dim, callback));
    } else {
      return _reduce(mat, dim, callback);
    }
  }
  function _reduce(mat, dim, callback) {
    var i3, ret, val, tran;
    if (dim <= 0) {
      if (!Array.isArray(mat[0])) {
        val = mat[0];
        for (i3 = 1; i3 < mat.length; i3++) {
          val = callback(val, mat[i3]);
        }
        return val;
      } else {
        tran = _switch(mat);
        ret = [];
        for (i3 = 0; i3 < tran.length; i3++) {
          ret[i3] = _reduce(tran[i3], dim - 1, callback);
        }
        return ret;
      }
    } else {
      ret = [];
      for (i3 = 0; i3 < mat.length; i3++) {
        ret[i3] = _reduce(mat[i3], dim - 1, callback);
      }
      return ret;
    }
  }
  function _switch(mat) {
    var I2 = mat.length;
    var J = mat[0].length;
    var i3, j3;
    var ret = [];
    for (j3 = 0; j3 < J; j3++) {
      var tmp = [];
      for (i3 = 0; i3 < I2; i3++) {
        tmp.push(mat[i3][j3]);
      }
      ret.push(tmp);
    }
    return ret;
  }
  var init_collection = __esm({
    "node_modules/mathjs/es/utils/collection.js"() {
      init_is();
      init_IndexError();
      init_array();
    }
  });

  // node_modules/mathjs/es/function/arithmetic/nthRoot.js
  var name14, createNthRootNumber;
  var init_nthRoot2 = __esm({
    "node_modules/mathjs/es/function/arithmetic/nthRoot.js"() {
      init_factory();
      init_number2();
      name14 = "nthRoot";
      createNthRootNumber = /* @__PURE__ */ factory(name14, ["typed"], function(_ref2) {
        var typed2 = _ref2.typed;
        return typed2(name14, {
          number: nthRootNumber,
          "number, number": nthRootNumber
        });
      });
    }
  });

  // node_modules/mathjs/es/function/arithmetic/round.js
  var NO_INT, name15, roundNumberSignatures, createRoundNumber;
  var init_round2 = __esm({
    "node_modules/mathjs/es/function/arithmetic/round.js"() {
      init_factory();
      init_number();
      init_number2();
      NO_INT = "Number of decimals in function round must be an integer";
      name15 = "round";
      roundNumberSignatures = {
        number: roundNumber,
        "number, number": function numberNumber(x3, n3) {
          if (!isInteger(n3)) {
            throw new TypeError(NO_INT);
          }
          if (n3 < 0 || n3 > 15) {
            throw new Error("Number of decimals in function round must be in te range of 0-15");
          }
          return roundNumber(x3, n3);
        }
      };
      createRoundNumber = /* @__PURE__ */ factory(name15, ["typed"], function(_ref2) {
        var typed2 = _ref2.typed;
        return typed2(name15, roundNumberSignatures);
      });
    }
  });

  // node_modules/mathjs/es/function/arithmetic/hypot.js
  var name16, dependencies15, createHypot;
  var init_hypot2 = __esm({
    "node_modules/mathjs/es/function/arithmetic/hypot.js"() {
      init_factory();
      init_array();
      name16 = "hypot";
      dependencies15 = ["typed", "abs", "addScalar", "divideScalar", "multiplyScalar", "sqrt", "smaller", "isPositive"];
      createHypot = /* @__PURE__ */ factory(name16, dependencies15, function(_ref) {
        var typed2 = _ref.typed, abs2 = _ref.abs, addScalar2 = _ref.addScalar, divideScalar2 = _ref.divideScalar, multiplyScalar2 = _ref.multiplyScalar, sqrt2 = _ref.sqrt, smaller2 = _ref.smaller, isPositive2 = _ref.isPositive;
        return typed2(name16, {
          "... number | BigNumber": _hypot,
          Array: function Array2(x3) {
            return this.apply(this, flatten(x3));
          },
          Matrix: function Matrix(x3) {
            return this.apply(this, flatten(x3.toArray()));
          }
        });
        function _hypot(args) {
          var result = 0;
          var largest = 0;
          for (var i3 = 0; i3 < args.length; i3++) {
            var value = abs2(args[i3]);
            if (smaller2(largest, value)) {
              result = multiplyScalar2(result, multiplyScalar2(divideScalar2(largest, value), divideScalar2(largest, value)));
              result = addScalar2(result, 1);
              largest = value;
            } else {
              result = addScalar2(result, isPositive2(value) ? multiplyScalar2(divideScalar2(value, largest), divideScalar2(value, largest)) : value);
            }
          }
          return multiplyScalar2(largest, sqrt2(result));
        }
      });
    }
  });

  // node_modules/mathjs/es/function/combinatorics/stirlingS2.js
  var name17, dependencies16, createStirlingS2;
  var init_stirlingS22 = __esm({
    "node_modules/mathjs/es/function/combinatorics/stirlingS2.js"() {
      init_factory();
      name17 = "stirlingS2";
      dependencies16 = ["typed", "addScalar", "subtract", "multiplyScalar", "divideScalar", "pow", "factorial", "combinations", "isNegative", "isInteger", "larger"];
      createStirlingS2 = /* @__PURE__ */ factory(name17, dependencies16, function(_ref) {
        var typed2 = _ref.typed, addScalar2 = _ref.addScalar, subtract2 = _ref.subtract, multiplyScalar2 = _ref.multiplyScalar, divideScalar2 = _ref.divideScalar, pow2 = _ref.pow, factorial2 = _ref.factorial, combinations2 = _ref.combinations, isNegative2 = _ref.isNegative, isInteger3 = _ref.isInteger, larger2 = _ref.larger;
        return typed2(name17, {
          "number | BigNumber, number | BigNumber": function numberBigNumberNumberBigNumber(n3, k3) {
            if (!isInteger3(n3) || isNegative2(n3) || !isInteger3(k3) || isNegative2(k3)) {
              throw new TypeError("Non-negative integer value expected in function stirlingS2");
            } else if (larger2(k3, n3)) {
              throw new TypeError("k must be less than or equal to n in function stirlingS2");
            }
            var kFactorial = factorial2(k3);
            var result = 0;
            for (var i3 = 0; i3 <= k3; i3++) {
              var negativeOne = pow2(-1, subtract2(k3, i3));
              var kChooseI = combinations2(k3, i3);
              var iPower = pow2(i3, n3);
              result = addScalar2(result, multiplyScalar2(multiplyScalar2(kChooseI, iPower), negativeOne));
            }
            return divideScalar2(result, kFactorial);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/combinatorics/bellNumbers.js
  var name18, dependencies17, createBellNumbers;
  var init_bellNumbers2 = __esm({
    "node_modules/mathjs/es/function/combinatorics/bellNumbers.js"() {
      init_factory();
      name18 = "bellNumbers";
      dependencies17 = ["typed", "addScalar", "isNegative", "isInteger", "stirlingS2"];
      createBellNumbers = /* @__PURE__ */ factory(name18, dependencies17, function(_ref) {
        var typed2 = _ref.typed, addScalar2 = _ref.addScalar, isNegative2 = _ref.isNegative, isInteger3 = _ref.isInteger, stirlingS22 = _ref.stirlingS2;
        return typed2(name18, {
          "number | BigNumber": function numberBigNumber(n3) {
            if (!isInteger3(n3) || isNegative2(n3)) {
              throw new TypeError("Non-negative integer value expected in function bellNumbers");
            }
            var result = 0;
            for (var i3 = 0; i3 <= n3; i3++) {
              result = addScalar2(result, stirlingS22(n3, i3));
            }
            return result;
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/combinatorics/catalan.js
  var name19, dependencies18, createCatalan;
  var init_catalan2 = __esm({
    "node_modules/mathjs/es/function/combinatorics/catalan.js"() {
      init_factory();
      name19 = "catalan";
      dependencies18 = ["typed", "addScalar", "divideScalar", "multiplyScalar", "combinations", "isNegative", "isInteger"];
      createCatalan = /* @__PURE__ */ factory(name19, dependencies18, function(_ref) {
        var typed2 = _ref.typed, addScalar2 = _ref.addScalar, divideScalar2 = _ref.divideScalar, multiplyScalar2 = _ref.multiplyScalar, combinations2 = _ref.combinations, isNegative2 = _ref.isNegative, isInteger3 = _ref.isInteger;
        return typed2(name19, {
          "number | BigNumber": function numberBigNumber(n3) {
            if (!isInteger3(n3) || isNegative2(n3)) {
              throw new TypeError("Non-negative integer value expected in function catalan");
            }
            return divideScalar2(combinations2(multiplyScalar2(n3, 2), n3), addScalar2(n3, 1));
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/combinatorics/composition.js
  var name20, dependencies19, createComposition;
  var init_composition2 = __esm({
    "node_modules/mathjs/es/function/combinatorics/composition.js"() {
      init_factory();
      name20 = "composition";
      dependencies19 = ["typed", "addScalar", "combinations", "isNegative", "isPositive", "isInteger", "larger"];
      createComposition = /* @__PURE__ */ factory(name20, dependencies19, function(_ref) {
        var typed2 = _ref.typed, addScalar2 = _ref.addScalar, combinations2 = _ref.combinations, isPositive2 = _ref.isPositive, isNegative2 = _ref.isNegative, isInteger3 = _ref.isInteger, larger2 = _ref.larger;
        return typed2(name20, {
          "number | BigNumber, number | BigNumber": function numberBigNumberNumberBigNumber(n3, k3) {
            if (!isInteger3(n3) || !isPositive2(n3) || !isInteger3(k3) || !isPositive2(k3)) {
              throw new TypeError("Positive integer value expected in function composition");
            } else if (larger2(k3, n3)) {
              throw new TypeError("k must be less than or equal to n in function composition");
            }
            return combinations2(addScalar2(n3, -1), addScalar2(k3, -1));
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/version.js
  var version;
  var init_version2 = __esm({
    "node_modules/mathjs/es/version.js"() {
      version = "7.5.1";
    }
  });

  // node_modules/mathjs/es/utils/function.js
  function _typeof6(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof6 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof6 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof6(obj);
  }
  function memoize(fn, hasher2) {
    return function memoize2() {
      if (_typeof6(memoize2.cache) !== "object") {
        memoize2.cache = {};
      }
      var args = [];
      for (var i3 = 0; i3 < arguments.length; i3++) {
        args[i3] = arguments[i3];
      }
      var hash = hasher2 ? hasher2(args) : JSON.stringify(args);
      if (!(hash in memoize2.cache)) {
        memoize2.cache[hash] = fn.apply(fn, args);
      }
      return memoize2.cache[hash];
    };
  }
  function maxArgumentCount(fn) {
    return Object.keys(fn.signatures || {}).reduce(function(args, signature) {
      var count = (signature.match(/,/g) || []).length + 1;
      return Math.max(args, count);
    }, -1);
  }
  var init_function = __esm({
    "node_modules/mathjs/es/utils/function.js"() {
    }
  });

  // node_modules/mathjs/es/utils/bignumber/constants.js
  function hasher(args) {
    return args[0].precision;
  }
  var createBigNumberE, createBigNumberPhi, createBigNumberPi, createBigNumberTau;
  var init_constants2 = __esm({
    "node_modules/mathjs/es/utils/bignumber/constants.js"() {
      init_function();
      createBigNumberE = memoize(function(BigNumber) {
        return new BigNumber(1).exp();
      }, hasher);
      createBigNumberPhi = memoize(function(BigNumber) {
        return new BigNumber(1).plus(new BigNumber(5).sqrt()).div(2);
      }, hasher);
      createBigNumberPi = memoize(function(BigNumber) {
        return BigNumber.acos(-1);
      }, hasher);
      createBigNumberTau = memoize(function(BigNumber) {
        return createBigNumberPi(BigNumber).times(2);
      }, hasher);
    }
  });

  // node_modules/mathjs/es/constants.js
  function recreateFactory(name106, dependencies95, create3) {
    return factory(name106, dependencies95, create3, {
      recreateOnConfigChange: true
    });
  }
  var createTrue, createFalse, createNull, createInfinity, createNaN, createPi, createTau, createE, createPhi, createLN2, createLN10, createLOG2E, createLOG10E, createSQRT1_2, createSQRT2, createUppercasePi, createUppercaseE, createVersion;
  var init_constants3 = __esm({
    "node_modules/mathjs/es/constants.js"() {
      init_factory();
      init_version2();
      init_constants2();
      init_number2();
      createTrue = /* @__PURE__ */ factory("true", [], function() {
        return true;
      });
      createFalse = /* @__PURE__ */ factory("false", [], function() {
        return false;
      });
      createNull = /* @__PURE__ */ factory("null", [], function() {
        return null;
      });
      createInfinity = /* @__PURE__ */ recreateFactory("Infinity", ["config", "?BigNumber"], function(_ref) {
        var config3 = _ref.config, BigNumber = _ref.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber(Infinity) : Infinity;
      });
      createNaN = /* @__PURE__ */ recreateFactory("NaN", ["config", "?BigNumber"], function(_ref2) {
        var config3 = _ref2.config, BigNumber = _ref2.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber(NaN) : NaN;
      });
      createPi = /* @__PURE__ */ recreateFactory("pi", ["config", "?BigNumber"], function(_ref3) {
        var config3 = _ref3.config, BigNumber = _ref3.BigNumber;
        return config3.number === "BigNumber" ? createBigNumberPi(BigNumber) : pi;
      });
      createTau = /* @__PURE__ */ recreateFactory("tau", ["config", "?BigNumber"], function(_ref4) {
        var config3 = _ref4.config, BigNumber = _ref4.BigNumber;
        return config3.number === "BigNumber" ? createBigNumberTau(BigNumber) : tau;
      });
      createE = /* @__PURE__ */ recreateFactory("e", ["config", "?BigNumber"], function(_ref5) {
        var config3 = _ref5.config, BigNumber = _ref5.BigNumber;
        return config3.number === "BigNumber" ? createBigNumberE(BigNumber) : e3;
      });
      createPhi = /* @__PURE__ */ recreateFactory("phi", ["config", "?BigNumber"], function(_ref6) {
        var config3 = _ref6.config, BigNumber = _ref6.BigNumber;
        return config3.number === "BigNumber" ? createBigNumberPhi(BigNumber) : phi;
      });
      createLN2 = /* @__PURE__ */ recreateFactory("LN2", ["config", "?BigNumber"], function(_ref7) {
        var config3 = _ref7.config, BigNumber = _ref7.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber(2).ln() : Math.LN2;
      });
      createLN10 = /* @__PURE__ */ recreateFactory("LN10", ["config", "?BigNumber"], function(_ref8) {
        var config3 = _ref8.config, BigNumber = _ref8.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber(10).ln() : Math.LN10;
      });
      createLOG2E = /* @__PURE__ */ recreateFactory("LOG2E", ["config", "?BigNumber"], function(_ref9) {
        var config3 = _ref9.config, BigNumber = _ref9.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber(1).div(new BigNumber(2).ln()) : Math.LOG2E;
      });
      createLOG10E = /* @__PURE__ */ recreateFactory("LOG10E", ["config", "?BigNumber"], function(_ref10) {
        var config3 = _ref10.config, BigNumber = _ref10.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber(1).div(new BigNumber(10).ln()) : Math.LOG10E;
      });
      createSQRT1_2 = /* @__PURE__ */ recreateFactory("SQRT1_2", ["config", "?BigNumber"], function(_ref11) {
        var config3 = _ref11.config, BigNumber = _ref11.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber("0.5").sqrt() : Math.SQRT1_2;
      });
      createSQRT2 = /* @__PURE__ */ recreateFactory("SQRT2", ["config", "?BigNumber"], function(_ref12) {
        var config3 = _ref12.config, BigNumber = _ref12.BigNumber;
        return config3.number === "BigNumber" ? new BigNumber(2).sqrt() : Math.SQRT2;
      });
      createUppercasePi = /* @__PURE__ */ factory("PI", ["pi"], function(_ref14) {
        var pi3 = _ref14.pi;
        return pi3;
      });
      createUppercaseE = /* @__PURE__ */ factory("E", ["e"], function(_ref15) {
        var e5 = _ref15.e;
        return e5;
      });
      createVersion = /* @__PURE__ */ factory("version", [], function() {
        return version;
      });
    }
  });

  // node_modules/mathjs/es/type/number.js
  var name21, dependencies20, createNumber;
  var init_number4 = __esm({
    "node_modules/mathjs/es/type/number.js"() {
      init_factory();
      init_collection();
      name21 = "number";
      dependencies20 = ["typed"];
      createNumber = /* @__PURE__ */ factory(name21, dependencies20, function(_ref) {
        var typed2 = _ref.typed;
        var number2 = typed2("number", {
          "": function _2() {
            return 0;
          },
          number: function number3(x3) {
            return x3;
          },
          string: function string2(x3) {
            if (x3 === "NaN")
              return NaN;
            var num = Number(x3);
            if (isNaN(num)) {
              throw new SyntaxError('String "' + x3 + '" is no valid number');
            }
            if (["0b", "0o", "0x"].includes(x3.substring(0, 2))) {
              if (num > Math.pow(2, 32) - 1) {
                throw new SyntaxError('String "'.concat(x3, '" is out of range'));
              }
              if (num & 2147483648) {
                num = -1 * ~(num - 1);
              }
            }
            return num;
          },
          BigNumber: function BigNumber(x3) {
            return x3.toNumber();
          },
          Fraction: function Fraction(x3) {
            return x3.valueOf();
          },
          Unit: function Unit(x3) {
            throw new Error("Second argument with valueless unit expected");
          },
          "null": function _null2(x3) {
            return 0;
          },
          "Unit, string | Unit": function UnitStringUnit(unit, valuelessUnit) {
            return unit.toNumber(valuelessUnit);
          },
          "Array | Matrix": function ArrayMatrix(x3) {
            return deepMap(x3, this);
          }
        });
        number2.fromJSON = function(json) {
          return parseFloat(json.value);
        };
        return number2;
      });
    }
  });

  // node_modules/mathjs/es/type/string.js
  var name22, dependencies21, createString;
  var init_string3 = __esm({
    "node_modules/mathjs/es/type/string.js"() {
      init_factory();
      init_collection();
      init_number();
      name22 = "string";
      dependencies21 = ["typed"];
      createString = /* @__PURE__ */ factory(name22, dependencies21, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name22, {
          "": function _2() {
            return "";
          },
          number: format,
          "null": function _null2(x3) {
            return "null";
          },
          "boolean": function boolean(x3) {
            return x3 + "";
          },
          string: function string2(x3) {
            return x3;
          },
          "Array | Matrix": function ArrayMatrix(x3) {
            return deepMap(x3, this);
          },
          any: function any(x3) {
            return String(x3);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/type/boolean.js
  var name23, dependencies22, createBoolean;
  var init_boolean2 = __esm({
    "node_modules/mathjs/es/type/boolean.js"() {
      init_factory();
      init_collection();
      name23 = "boolean";
      dependencies22 = ["typed"];
      createBoolean = /* @__PURE__ */ factory(name23, dependencies22, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name23, {
          "": function _2() {
            return false;
          },
          "boolean": function boolean(x3) {
            return x3;
          },
          number: function number2(x3) {
            return !!x3;
          },
          "null": function _null2(x3) {
            return false;
          },
          BigNumber: function BigNumber(x3) {
            return !x3.isZero();
          },
          string: function string2(x3) {
            var lcase = x3.toLowerCase();
            if (lcase === "true") {
              return true;
            } else if (lcase === "false") {
              return false;
            }
            var num = Number(x3);
            if (x3 !== "" && !isNaN(num)) {
              return !!num;
            }
            throw new Error('Cannot convert "' + x3 + '" to a boolean');
          },
          "Array | Matrix": function ArrayMatrix(x3) {
            return deepMap(x3, this);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/expression/function/parser.js
  var name24, dependencies23, createParser;
  var init_parser = __esm({
    "node_modules/mathjs/es/expression/function/parser.js"() {
      init_factory();
      name24 = "parser";
      dependencies23 = ["typed", "Parser"];
      createParser = /* @__PURE__ */ factory(name24, dependencies23, function(_ref) {
        var typed2 = _ref.typed, Parser2 = _ref.Parser;
        return typed2(name24, {
          "": function _2() {
            return new Parser2();
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/expression/keywords.js
  var keywords;
  var init_keywords = __esm({
    "node_modules/mathjs/es/expression/keywords.js"() {
      keywords = {
        end: true
      };
    }
  });

  // node_modules/mathjs/es/expression/node/Node.js
  function _typeof7(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof7 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof7 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof7(obj);
  }
  var name25, dependencies24, createNode;
  var init_Node = __esm({
    "node_modules/mathjs/es/expression/node/Node.js"() {
      init_is();
      init_keywords();
      init_object();
      init_factory();
      name25 = "Node";
      dependencies24 = ["mathWithTransform"];
      createNode = /* @__PURE__ */ factory(name25, dependencies24, function(_ref) {
        var mathWithTransform2 = _ref.mathWithTransform;
        function Node3() {
          if (!(this instanceof Node3)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
        }
        Node3.prototype.evaluate = function(scope) {
          return this.compile().evaluate(scope);
        };
        Node3.prototype.type = "Node";
        Node3.prototype.isNode = true;
        Node3.prototype.comment = "";
        Node3.prototype.compile = function() {
          var expr = this._compile(mathWithTransform2, {});
          var args = {};
          var context = null;
          function evaluate2(scope) {
            var s3 = scope || {};
            _validateScope(s3);
            return expr(s3, args, context);
          }
          return {
            evaluate: evaluate2
          };
        };
        Node3.prototype._compile = function(math2, argNames) {
          throw new Error("Method _compile should be implemented by type " + this.type);
        };
        Node3.prototype.forEach = function(callback) {
          throw new Error("Cannot run forEach on a Node interface");
        };
        Node3.prototype.map = function(callback) {
          throw new Error("Cannot run map on a Node interface");
        };
        Node3.prototype._ifNode = function(node) {
          if (!isNode(node)) {
            throw new TypeError("Callback function must return a Node");
          }
          return node;
        };
        Node3.prototype.traverse = function(callback) {
          callback(this, null, null);
          function _traverse(node, callback2) {
            node.forEach(function(child, path, parent) {
              callback2(child, path, parent);
              _traverse(child, callback2);
            });
          }
          _traverse(this, callback);
        };
        Node3.prototype.transform = function(callback) {
          function _transform(child, path, parent) {
            var replacement = callback(child, path, parent);
            if (replacement !== child) {
              return replacement;
            }
            return child.map(_transform);
          }
          return _transform(this, null, null);
        };
        Node3.prototype.filter = function(callback) {
          var nodes = [];
          this.traverse(function(node, path, parent) {
            if (callback(node, path, parent)) {
              nodes.push(node);
            }
          });
          return nodes;
        };
        Node3.prototype.clone = function() {
          throw new Error("Cannot clone a Node interface");
        };
        Node3.prototype.cloneDeep = function() {
          return this.map(function(node) {
            return node.cloneDeep();
          });
        };
        Node3.prototype.equals = function(other) {
          return other ? deepStrictEqual(this, other) : false;
        };
        Node3.prototype.toString = function(options) {
          var customString;
          if (options && _typeof7(options) === "object") {
            switch (_typeof7(options.handler)) {
              case "object":
              case "undefined":
                break;
              case "function":
                customString = options.handler(this, options);
                break;
              default:
                throw new TypeError("Object or function expected as callback");
            }
          }
          if (typeof customString !== "undefined") {
            return customString;
          }
          return this._toString(options);
        };
        Node3.prototype.toJSON = function() {
          throw new Error("Cannot serialize object: toJSON not implemented by " + this.type);
        };
        Node3.prototype.toHTML = function(options) {
          var customString;
          if (options && _typeof7(options) === "object") {
            switch (_typeof7(options.handler)) {
              case "object":
              case "undefined":
                break;
              case "function":
                customString = options.handler(this, options);
                break;
              default:
                throw new TypeError("Object or function expected as callback");
            }
          }
          if (typeof customString !== "undefined") {
            return customString;
          }
          return this.toHTML(options);
        };
        Node3.prototype._toString = function() {
          throw new Error("_toString not implemented for " + this.type);
        };
        Node3.prototype.toTex = function(options) {
          var customTex;
          if (options && _typeof7(options) === "object") {
            switch (_typeof7(options.handler)) {
              case "object":
              case "undefined":
                break;
              case "function":
                customTex = options.handler(this, options);
                break;
              default:
                throw new TypeError("Object or function expected as callback");
            }
          }
          if (typeof customTex !== "undefined") {
            return customTex;
          }
          return this._toTex(options);
        };
        Node3.prototype._toTex = function(options) {
          throw new Error("_toTex not implemented for " + this.type);
        };
        Node3.prototype.getIdentifier = function() {
          return this.type;
        };
        Node3.prototype.getContent = function() {
          return this;
        };
        function _validateScope(scope) {
          for (var symbol in scope) {
            if (hasOwnProperty2(scope, symbol)) {
              if (symbol in keywords) {
                throw new Error('Scope contains an illegal symbol, "' + symbol + '" is a reserved keyword');
              }
            }
          }
        }
        return Node3;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/utils/errorTransform.js
  function errorTransform(err) {
    if (err && err.isIndexError) {
      return new IndexError(err.index + 1, err.min + 1, err.max !== void 0 ? err.max + 1 : void 0);
    }
    return err;
  }
  var init_errorTransform = __esm({
    "node_modules/mathjs/es/expression/transform/utils/errorTransform.js"() {
      init_IndexError();
    }
  });

  // node_modules/mathjs/es/expression/node/utils/access.js
  function _typeof8(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof8 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof8 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof8(obj);
  }
  function accessFactory(_ref) {
    var subset2 = _ref.subset;
    return function access(object, index2) {
      try {
        if (Array.isArray(object)) {
          return subset2(object, index2);
        } else if (object && typeof object.subset === "function") {
          return object.subset(index2);
        } else if (typeof object === "string") {
          return subset2(object, index2);
        } else if (_typeof8(object) === "object") {
          if (!index2.isObjectProperty()) {
            throw new TypeError("Cannot apply a numeric index as object property");
          }
          return getSafeProperty(object, index2.getObjectProperty());
        } else {
          throw new TypeError("Cannot apply index: unsupported type of object");
        }
      } catch (err) {
        throw errorTransform(err);
      }
    };
  }
  var init_access = __esm({
    "node_modules/mathjs/es/expression/node/utils/access.js"() {
      init_errorTransform();
      init_customs();
    }
  });

  // node_modules/mathjs/es/expression/node/AccessorNode.js
  var name26, dependencies25, createAccessorNode;
  var init_AccessorNode = __esm({
    "node_modules/mathjs/es/expression/node/AccessorNode.js"() {
      init_is();
      init_customs();
      init_factory();
      init_access();
      name26 = "AccessorNode";
      dependencies25 = ["subset", "Node"];
      createAccessorNode = /* @__PURE__ */ factory(name26, dependencies25, function(_ref) {
        var subset2 = _ref.subset, Node3 = _ref.Node;
        var access = accessFactory({
          subset: subset2
        });
        function AccessorNode2(object, index2) {
          if (!(this instanceof AccessorNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (!isNode(object)) {
            throw new TypeError('Node expected for parameter "object"');
          }
          if (!isIndexNode(index2)) {
            throw new TypeError('IndexNode expected for parameter "index"');
          }
          this.object = object || null;
          this.index = index2;
          Object.defineProperty(this, "name", {
            get: function() {
              if (this.index) {
                return this.index.isObjectProperty() ? this.index.getObjectProperty() : "";
              } else {
                return this.object.name || "";
              }
            }.bind(this),
            set: function set() {
              throw new Error("Cannot assign a new name, name is read-only");
            }
          });
        }
        AccessorNode2.prototype = new Node3();
        AccessorNode2.prototype.type = "AccessorNode";
        AccessorNode2.prototype.isAccessorNode = true;
        AccessorNode2.prototype._compile = function(math2, argNames) {
          var evalObject = this.object._compile(math2, argNames);
          var evalIndex = this.index._compile(math2, argNames);
          if (this.index.isObjectProperty()) {
            var prop = this.index.getObjectProperty();
            return function evalAccessorNode(scope, args, context) {
              return getSafeProperty(evalObject(scope, args, context), prop);
            };
          } else {
            return function evalAccessorNode(scope, args, context) {
              var object = evalObject(scope, args, context);
              var index2 = evalIndex(scope, args, object);
              return access(object, index2);
            };
          }
        };
        AccessorNode2.prototype.forEach = function(callback) {
          callback(this.object, "object", this);
          callback(this.index, "index", this);
        };
        AccessorNode2.prototype.map = function(callback) {
          return new AccessorNode2(this._ifNode(callback(this.object, "object", this)), this._ifNode(callback(this.index, "index", this)));
        };
        AccessorNode2.prototype.clone = function() {
          return new AccessorNode2(this.object, this.index);
        };
        AccessorNode2.prototype._toString = function(options) {
          var object = this.object.toString(options);
          if (needParenthesis(this.object)) {
            object = "(" + object + ")";
          }
          return object + this.index.toString(options);
        };
        AccessorNode2.prototype.toHTML = function(options) {
          var object = this.object.toHTML(options);
          if (needParenthesis(this.object)) {
            object = '<span class="math-parenthesis math-round-parenthesis">(</span>' + object + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          return object + this.index.toHTML(options);
        };
        AccessorNode2.prototype._toTex = function(options) {
          var object = this.object.toTex(options);
          if (needParenthesis(this.object)) {
            object = "\\left(' + object + '\\right)";
          }
          return object + this.index.toTex(options);
        };
        AccessorNode2.prototype.toJSON = function() {
          return {
            mathjs: "AccessorNode",
            object: this.object,
            index: this.index
          };
        };
        AccessorNode2.fromJSON = function(json) {
          return new AccessorNode2(json.object, json.index);
        };
        function needParenthesis(node) {
          return !(isAccessorNode(node) || isArrayNode(node) || isConstantNode(node) || isFunctionNode(node) || isObjectNode(node) || isParenthesisNode(node) || isSymbolNode(node));
        }
        return AccessorNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/ArrayNode.js
  var name27, dependencies26, createArrayNode;
  var init_ArrayNode = __esm({
    "node_modules/mathjs/es/expression/node/ArrayNode.js"() {
      init_is();
      init_array();
      init_factory();
      name27 = "ArrayNode";
      dependencies26 = ["Node"];
      createArrayNode = /* @__PURE__ */ factory(name27, dependencies26, function(_ref) {
        var Node3 = _ref.Node;
        function ArrayNode2(items) {
          if (!(this instanceof ArrayNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          this.items = items || [];
          if (!Array.isArray(this.items) || !this.items.every(isNode)) {
            throw new TypeError("Array containing Nodes expected");
          }
        }
        ArrayNode2.prototype = new Node3();
        ArrayNode2.prototype.type = "ArrayNode";
        ArrayNode2.prototype.isArrayNode = true;
        ArrayNode2.prototype._compile = function(math2, argNames) {
          var evalItems = map(this.items, function(item) {
            return item._compile(math2, argNames);
          });
          var asMatrix = math2.config.matrix !== "Array";
          if (asMatrix) {
            var matrix2 = math2.matrix;
            return function evalArrayNode(scope, args, context) {
              return matrix2(map(evalItems, function(evalItem) {
                return evalItem(scope, args, context);
              }));
            };
          } else {
            return function evalArrayNode(scope, args, context) {
              return map(evalItems, function(evalItem) {
                return evalItem(scope, args, context);
              });
            };
          }
        };
        ArrayNode2.prototype.forEach = function(callback) {
          for (var i3 = 0; i3 < this.items.length; i3++) {
            var node = this.items[i3];
            callback(node, "items[" + i3 + "]", this);
          }
        };
        ArrayNode2.prototype.map = function(callback) {
          var items = [];
          for (var i3 = 0; i3 < this.items.length; i3++) {
            items[i3] = this._ifNode(callback(this.items[i3], "items[" + i3 + "]", this));
          }
          return new ArrayNode2(items);
        };
        ArrayNode2.prototype.clone = function() {
          return new ArrayNode2(this.items.slice(0));
        };
        ArrayNode2.prototype._toString = function(options) {
          var items = this.items.map(function(node) {
            return node.toString(options);
          });
          return "[" + items.join(", ") + "]";
        };
        ArrayNode2.prototype.toJSON = function() {
          return {
            mathjs: "ArrayNode",
            items: this.items
          };
        };
        ArrayNode2.fromJSON = function(json) {
          return new ArrayNode2(json.items);
        };
        ArrayNode2.prototype.toHTML = function(options) {
          var items = this.items.map(function(node) {
            return node.toHTML(options);
          });
          return '<span class="math-parenthesis math-square-parenthesis">[</span>' + items.join('<span class="math-separator">,</span>') + '<span class="math-parenthesis math-square-parenthesis">]</span>';
        };
        ArrayNode2.prototype._toTex = function(options) {
          var s3 = "\\begin{bmatrix}";
          this.items.forEach(function(node) {
            if (node.items) {
              s3 += node.items.map(function(childNode) {
                return childNode.toTex(options);
              }).join("&");
            } else {
              s3 += node.toTex(options);
            }
            s3 += "\\\\";
          });
          s3 += "\\end{bmatrix}";
          return s3;
        };
        return ArrayNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/utils/assign.js
  function _typeof9(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof9 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof9 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof9(obj);
  }
  function assignFactory(_ref) {
    var subset2 = _ref.subset, matrix2 = _ref.matrix;
    return function assign(object, index2, value) {
      try {
        if (Array.isArray(object)) {
          return matrix2(object).subset(index2, value).valueOf();
        } else if (object && typeof object.subset === "function") {
          return object.subset(index2, value);
        } else if (typeof object === "string") {
          return subset2(object, index2, value);
        } else if (_typeof9(object) === "object") {
          if (!index2.isObjectProperty()) {
            throw TypeError("Cannot apply a numeric index as object property");
          }
          setSafeProperty(object, index2.getObjectProperty(), value);
          return object;
        } else {
          throw new TypeError("Cannot apply index: unsupported type of object");
        }
      } catch (err) {
        throw errorTransform(err);
      }
    };
  }
  var init_assign = __esm({
    "node_modules/mathjs/es/expression/node/utils/assign.js"() {
      init_errorTransform();
      init_customs();
    }
  });

  // node_modules/mathjs/es/expression/operators.js
  function getPrecedence(_node, parenthesis) {
    var node = _node;
    if (parenthesis !== "keep") {
      node = _node.getContent();
    }
    var identifier = node.getIdentifier();
    for (var i3 = 0; i3 < properties.length; i3++) {
      if (identifier in properties[i3]) {
        return i3;
      }
    }
    return null;
  }
  function getAssociativity(_node, parenthesis) {
    var node = _node;
    if (parenthesis !== "keep") {
      node = _node.getContent();
    }
    var identifier = node.getIdentifier();
    var index2 = getPrecedence(node, parenthesis);
    if (index2 === null) {
      return null;
    }
    var property = properties[index2][identifier];
    if (hasOwnProperty2(property, "associativity")) {
      if (property.associativity === "left") {
        return "left";
      }
      if (property.associativity === "right") {
        return "right";
      }
      throw Error("'" + identifier + "' has the invalid associativity '" + property.associativity + "'.");
    }
    return null;
  }
  function isAssociativeWith(nodeA, nodeB, parenthesis) {
    var a3 = parenthesis !== "keep" ? nodeA.getContent() : nodeA;
    var b2 = parenthesis !== "keep" ? nodeA.getContent() : nodeB;
    var identifierA = a3.getIdentifier();
    var identifierB = b2.getIdentifier();
    var index2 = getPrecedence(a3, parenthesis);
    if (index2 === null) {
      return null;
    }
    var property = properties[index2][identifierA];
    if (hasOwnProperty2(property, "associativeWith") && property.associativeWith instanceof Array) {
      for (var i3 = 0; i3 < property.associativeWith.length; i3++) {
        if (property.associativeWith[i3] === identifierB) {
          return true;
        }
      }
      return false;
    }
    return null;
  }
  var properties;
  var init_operators = __esm({
    "node_modules/mathjs/es/expression/operators.js"() {
      init_object();
      properties = [{
        AssignmentNode: {},
        FunctionAssignmentNode: {}
      }, {
        ConditionalNode: {
          latexLeftParens: false,
          latexRightParens: false,
          latexParens: false
        }
      }, {
        "OperatorNode:or": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:xor": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:and": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:bitOr": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:bitXor": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:bitAnd": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:equal": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:unequal": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:smaller": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:larger": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:smallerEq": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:largerEq": {
          associativity: "left",
          associativeWith: []
        },
        RelationalNode: {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:leftShift": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:rightArithShift": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:rightLogShift": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:to": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        RangeNode: {}
      }, {
        "OperatorNode:add": {
          associativity: "left",
          associativeWith: ["OperatorNode:add", "OperatorNode:subtract"]
        },
        "OperatorNode:subtract": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:multiply": {
          associativity: "left",
          associativeWith: ["OperatorNode:multiply", "OperatorNode:divide", "Operator:dotMultiply", "Operator:dotDivide"]
        },
        "OperatorNode:divide": {
          associativity: "left",
          associativeWith: [],
          latexLeftParens: false,
          latexRightParens: false,
          latexParens: false
        },
        "OperatorNode:dotMultiply": {
          associativity: "left",
          associativeWith: ["OperatorNode:multiply", "OperatorNode:divide", "OperatorNode:dotMultiply", "OperatorNode:doDivide"]
        },
        "OperatorNode:dotDivide": {
          associativity: "left",
          associativeWith: []
        },
        "OperatorNode:mod": {
          associativity: "left",
          associativeWith: []
        }
      }, {
        "OperatorNode:unaryPlus": {
          associativity: "right"
        },
        "OperatorNode:unaryMinus": {
          associativity: "right"
        },
        "OperatorNode:bitNot": {
          associativity: "right"
        },
        "OperatorNode:not": {
          associativity: "right"
        }
      }, {
        "OperatorNode:pow": {
          associativity: "right",
          associativeWith: [],
          latexRightParens: false
        },
        "OperatorNode:dotPow": {
          associativity: "right",
          associativeWith: []
        }
      }, {
        "OperatorNode:factorial": {
          associativity: "left"
        }
      }, {
        "OperatorNode:transpose": {
          associativity: "left"
        }
      }];
    }
  });

  // node_modules/mathjs/es/expression/node/AssignmentNode.js
  var name28, dependencies27, createAssignmentNode;
  var init_AssignmentNode = __esm({
    "node_modules/mathjs/es/expression/node/AssignmentNode.js"() {
      init_is();
      init_customs();
      init_factory();
      init_access();
      init_assign();
      init_operators();
      name28 = "AssignmentNode";
      dependencies27 = [
        "subset",
        "?matrix",
        "Node"
      ];
      createAssignmentNode = /* @__PURE__ */ factory(name28, dependencies27, function(_ref) {
        var subset2 = _ref.subset, matrix2 = _ref.matrix, Node3 = _ref.Node;
        var access = accessFactory({
          subset: subset2
        });
        var assign = assignFactory({
          subset: subset2,
          matrix: matrix2
        });
        function AssignmentNode2(object, index2, value) {
          if (!(this instanceof AssignmentNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          this.object = object;
          this.index = value ? index2 : null;
          this.value = value || index2;
          if (!isSymbolNode(object) && !isAccessorNode(object)) {
            throw new TypeError('SymbolNode or AccessorNode expected as "object"');
          }
          if (isSymbolNode(object) && object.name === "end") {
            throw new Error('Cannot assign to symbol "end"');
          }
          if (this.index && !isIndexNode(this.index)) {
            throw new TypeError('IndexNode expected as "index"');
          }
          if (!isNode(this.value)) {
            throw new TypeError('Node expected as "value"');
          }
          Object.defineProperty(this, "name", {
            get: function() {
              if (this.index) {
                return this.index.isObjectProperty() ? this.index.getObjectProperty() : "";
              } else {
                return this.object.name || "";
              }
            }.bind(this),
            set: function set() {
              throw new Error("Cannot assign a new name, name is read-only");
            }
          });
        }
        AssignmentNode2.prototype = new Node3();
        AssignmentNode2.prototype.type = "AssignmentNode";
        AssignmentNode2.prototype.isAssignmentNode = true;
        AssignmentNode2.prototype._compile = function(math2, argNames) {
          var evalObject = this.object._compile(math2, argNames);
          var evalIndex = this.index ? this.index._compile(math2, argNames) : null;
          var evalValue = this.value._compile(math2, argNames);
          var name106 = this.object.name;
          if (!this.index) {
            if (!isSymbolNode(this.object)) {
              throw new TypeError("SymbolNode expected as object");
            }
            return function evalAssignmentNode(scope, args, context) {
              return setSafeProperty(scope, name106, evalValue(scope, args, context));
            };
          } else if (this.index.isObjectProperty()) {
            var prop = this.index.getObjectProperty();
            return function evalAssignmentNode(scope, args, context) {
              var object = evalObject(scope, args, context);
              var value = evalValue(scope, args, context);
              return setSafeProperty(object, prop, value);
            };
          } else if (isSymbolNode(this.object)) {
            return function evalAssignmentNode(scope, args, context) {
              var childObject = evalObject(scope, args, context);
              var value = evalValue(scope, args, context);
              var index2 = evalIndex(scope, args, childObject);
              setSafeProperty(scope, name106, assign(childObject, index2, value));
              return value;
            };
          } else {
            var evalParentObject = this.object.object._compile(math2, argNames);
            if (this.object.index.isObjectProperty()) {
              var parentProp = this.object.index.getObjectProperty();
              return function evalAssignmentNode(scope, args, context) {
                var parent = evalParentObject(scope, args, context);
                var childObject = getSafeProperty(parent, parentProp);
                var index2 = evalIndex(scope, args, childObject);
                var value = evalValue(scope, args, context);
                setSafeProperty(parent, parentProp, assign(childObject, index2, value));
                return value;
              };
            } else {
              var evalParentIndex = this.object.index._compile(math2, argNames);
              return function evalAssignmentNode(scope, args, context) {
                var parent = evalParentObject(scope, args, context);
                var parentIndex = evalParentIndex(scope, args, parent);
                var childObject = access(parent, parentIndex);
                var index2 = evalIndex(scope, args, childObject);
                var value = evalValue(scope, args, context);
                assign(parent, parentIndex, assign(childObject, index2, value));
                return value;
              };
            }
          }
        };
        AssignmentNode2.prototype.forEach = function(callback) {
          callback(this.object, "object", this);
          if (this.index) {
            callback(this.index, "index", this);
          }
          callback(this.value, "value", this);
        };
        AssignmentNode2.prototype.map = function(callback) {
          var object = this._ifNode(callback(this.object, "object", this));
          var index2 = this.index ? this._ifNode(callback(this.index, "index", this)) : null;
          var value = this._ifNode(callback(this.value, "value", this));
          return new AssignmentNode2(object, index2, value);
        };
        AssignmentNode2.prototype.clone = function() {
          return new AssignmentNode2(this.object, this.index, this.value);
        };
        function needParenthesis(node, parenthesis) {
          if (!parenthesis) {
            parenthesis = "keep";
          }
          var precedence = getPrecedence(node, parenthesis);
          var exprPrecedence = getPrecedence(node.value, parenthesis);
          return parenthesis === "all" || exprPrecedence !== null && exprPrecedence <= precedence;
        }
        AssignmentNode2.prototype._toString = function(options) {
          var object = this.object.toString(options);
          var index2 = this.index ? this.index.toString(options) : "";
          var value = this.value.toString(options);
          if (needParenthesis(this, options && options.parenthesis)) {
            value = "(" + value + ")";
          }
          return object + index2 + " = " + value;
        };
        AssignmentNode2.prototype.toJSON = function() {
          return {
            mathjs: "AssignmentNode",
            object: this.object,
            index: this.index,
            value: this.value
          };
        };
        AssignmentNode2.fromJSON = function(json) {
          return new AssignmentNode2(json.object, json.index, json.value);
        };
        AssignmentNode2.prototype.toHTML = function(options) {
          var object = this.object.toHTML(options);
          var index2 = this.index ? this.index.toHTML(options) : "";
          var value = this.value.toHTML(options);
          if (needParenthesis(this, options && options.parenthesis)) {
            value = '<span class="math-paranthesis math-round-parenthesis">(</span>' + value + '<span class="math-paranthesis math-round-parenthesis">)</span>';
          }
          return object + index2 + '<span class="math-operator math-assignment-operator math-variable-assignment-operator math-binary-operator">=</span>' + value;
        };
        AssignmentNode2.prototype._toTex = function(options) {
          var object = this.object.toTex(options);
          var index2 = this.index ? this.index.toTex(options) : "";
          var value = this.value.toTex(options);
          if (needParenthesis(this, options && options.parenthesis)) {
            value = "\\left(".concat(value, "\\right)");
          }
          return object + index2 + ":=" + value;
        };
        return AssignmentNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/BlockNode.js
  var name29, dependencies28, createBlockNode;
  var init_BlockNode = __esm({
    "node_modules/mathjs/es/expression/node/BlockNode.js"() {
      init_is();
      init_array();
      init_factory();
      name29 = "BlockNode";
      dependencies28 = ["ResultSet", "Node"];
      createBlockNode = /* @__PURE__ */ factory(name29, dependencies28, function(_ref) {
        var ResultSet2 = _ref.ResultSet, Node3 = _ref.Node;
        function BlockNode2(blocks) {
          if (!(this instanceof BlockNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (!Array.isArray(blocks))
            throw new Error("Array expected");
          this.blocks = blocks.map(function(block) {
            var node = block && block.node;
            var visible = block && block.visible !== void 0 ? block.visible : true;
            if (!isNode(node))
              throw new TypeError('Property "node" must be a Node');
            if (typeof visible !== "boolean")
              throw new TypeError('Property "visible" must be a boolean');
            return {
              node,
              visible
            };
          });
        }
        BlockNode2.prototype = new Node3();
        BlockNode2.prototype.type = "BlockNode";
        BlockNode2.prototype.isBlockNode = true;
        BlockNode2.prototype._compile = function(math2, argNames) {
          var evalBlocks = map(this.blocks, function(block) {
            return {
              evaluate: block.node._compile(math2, argNames),
              visible: block.visible
            };
          });
          return function evalBlockNodes(scope, args, context) {
            var results = [];
            forEach(evalBlocks, function evalBlockNode(block) {
              var result = block.evaluate(scope, args, context);
              if (block.visible) {
                results.push(result);
              }
            });
            return new ResultSet2(results);
          };
        };
        BlockNode2.prototype.forEach = function(callback) {
          for (var i3 = 0; i3 < this.blocks.length; i3++) {
            callback(this.blocks[i3].node, "blocks[" + i3 + "].node", this);
          }
        };
        BlockNode2.prototype.map = function(callback) {
          var blocks = [];
          for (var i3 = 0; i3 < this.blocks.length; i3++) {
            var block = this.blocks[i3];
            var node = this._ifNode(callback(block.node, "blocks[" + i3 + "].node", this));
            blocks[i3] = {
              node,
              visible: block.visible
            };
          }
          return new BlockNode2(blocks);
        };
        BlockNode2.prototype.clone = function() {
          var blocks = this.blocks.map(function(block) {
            return {
              node: block.node,
              visible: block.visible
            };
          });
          return new BlockNode2(blocks);
        };
        BlockNode2.prototype._toString = function(options) {
          return this.blocks.map(function(param) {
            return param.node.toString(options) + (param.visible ? "" : ";");
          }).join("\n");
        };
        BlockNode2.prototype.toJSON = function() {
          return {
            mathjs: "BlockNode",
            blocks: this.blocks
          };
        };
        BlockNode2.fromJSON = function(json) {
          return new BlockNode2(json.blocks);
        };
        BlockNode2.prototype.toHTML = function(options) {
          return this.blocks.map(function(param) {
            return param.node.toHTML(options) + (param.visible ? "" : '<span class="math-separator">;</span>');
          }).join('<span class="math-separator"><br /></span>');
        };
        BlockNode2.prototype._toTex = function(options) {
          return this.blocks.map(function(param) {
            return param.node.toTex(options) + (param.visible ? "" : ";");
          }).join("\\;\\;\n");
        };
        return BlockNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/ConditionalNode.js
  var name30, dependencies29, createConditionalNode;
  var init_ConditionalNode = __esm({
    "node_modules/mathjs/es/expression/node/ConditionalNode.js"() {
      init_is();
      init_factory();
      init_operators();
      name30 = "ConditionalNode";
      dependencies29 = ["Node"];
      createConditionalNode = /* @__PURE__ */ factory(name30, dependencies29, function(_ref) {
        var Node3 = _ref.Node;
        function ConditionalNode2(condition, trueExpr, falseExpr) {
          if (!(this instanceof ConditionalNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (!isNode(condition))
            throw new TypeError("Parameter condition must be a Node");
          if (!isNode(trueExpr))
            throw new TypeError("Parameter trueExpr must be a Node");
          if (!isNode(falseExpr))
            throw new TypeError("Parameter falseExpr must be a Node");
          this.condition = condition;
          this.trueExpr = trueExpr;
          this.falseExpr = falseExpr;
        }
        ConditionalNode2.prototype = new Node3();
        ConditionalNode2.prototype.type = "ConditionalNode";
        ConditionalNode2.prototype.isConditionalNode = true;
        ConditionalNode2.prototype._compile = function(math2, argNames) {
          var evalCondition = this.condition._compile(math2, argNames);
          var evalTrueExpr = this.trueExpr._compile(math2, argNames);
          var evalFalseExpr = this.falseExpr._compile(math2, argNames);
          return function evalConditionalNode(scope, args, context) {
            return testCondition(evalCondition(scope, args, context)) ? evalTrueExpr(scope, args, context) : evalFalseExpr(scope, args, context);
          };
        };
        ConditionalNode2.prototype.forEach = function(callback) {
          callback(this.condition, "condition", this);
          callback(this.trueExpr, "trueExpr", this);
          callback(this.falseExpr, "falseExpr", this);
        };
        ConditionalNode2.prototype.map = function(callback) {
          return new ConditionalNode2(this._ifNode(callback(this.condition, "condition", this)), this._ifNode(callback(this.trueExpr, "trueExpr", this)), this._ifNode(callback(this.falseExpr, "falseExpr", this)));
        };
        ConditionalNode2.prototype.clone = function() {
          return new ConditionalNode2(this.condition, this.trueExpr, this.falseExpr);
        };
        ConditionalNode2.prototype._toString = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var precedence = getPrecedence(this, parenthesis);
          var condition = this.condition.toString(options);
          var conditionPrecedence = getPrecedence(this.condition, parenthesis);
          if (parenthesis === "all" || this.condition.type === "OperatorNode" || conditionPrecedence !== null && conditionPrecedence <= precedence) {
            condition = "(" + condition + ")";
          }
          var trueExpr = this.trueExpr.toString(options);
          var truePrecedence = getPrecedence(this.trueExpr, parenthesis);
          if (parenthesis === "all" || this.trueExpr.type === "OperatorNode" || truePrecedence !== null && truePrecedence <= precedence) {
            trueExpr = "(" + trueExpr + ")";
          }
          var falseExpr = this.falseExpr.toString(options);
          var falsePrecedence = getPrecedence(this.falseExpr, parenthesis);
          if (parenthesis === "all" || this.falseExpr.type === "OperatorNode" || falsePrecedence !== null && falsePrecedence <= precedence) {
            falseExpr = "(" + falseExpr + ")";
          }
          return condition + " ? " + trueExpr + " : " + falseExpr;
        };
        ConditionalNode2.prototype.toJSON = function() {
          return {
            mathjs: "ConditionalNode",
            condition: this.condition,
            trueExpr: this.trueExpr,
            falseExpr: this.falseExpr
          };
        };
        ConditionalNode2.fromJSON = function(json) {
          return new ConditionalNode2(json.condition, json.trueExpr, json.falseExpr);
        };
        ConditionalNode2.prototype.toHTML = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var precedence = getPrecedence(this, parenthesis);
          var condition = this.condition.toHTML(options);
          var conditionPrecedence = getPrecedence(this.condition, parenthesis);
          if (parenthesis === "all" || this.condition.type === "OperatorNode" || conditionPrecedence !== null && conditionPrecedence <= precedence) {
            condition = '<span class="math-parenthesis math-round-parenthesis">(</span>' + condition + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          var trueExpr = this.trueExpr.toHTML(options);
          var truePrecedence = getPrecedence(this.trueExpr, parenthesis);
          if (parenthesis === "all" || this.trueExpr.type === "OperatorNode" || truePrecedence !== null && truePrecedence <= precedence) {
            trueExpr = '<span class="math-parenthesis math-round-parenthesis">(</span>' + trueExpr + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          var falseExpr = this.falseExpr.toHTML(options);
          var falsePrecedence = getPrecedence(this.falseExpr, parenthesis);
          if (parenthesis === "all" || this.falseExpr.type === "OperatorNode" || falsePrecedence !== null && falsePrecedence <= precedence) {
            falseExpr = '<span class="math-parenthesis math-round-parenthesis">(</span>' + falseExpr + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          return condition + '<span class="math-operator math-conditional-operator">?</span>' + trueExpr + '<span class="math-operator math-conditional-operator">:</span>' + falseExpr;
        };
        ConditionalNode2.prototype._toTex = function(options) {
          return "\\begin{cases} {" + this.trueExpr.toTex(options) + "}, &\\quad{\\text{if }\\;" + this.condition.toTex(options) + "}\\\\{" + this.falseExpr.toTex(options) + "}, &\\quad{\\text{otherwise}}\\end{cases}";
        };
        function testCondition(condition) {
          if (typeof condition === "number" || typeof condition === "boolean" || typeof condition === "string") {
            return !!condition;
          }
          if (condition) {
            if (isBigNumber(condition)) {
              return !condition.isZero();
            }
            if (isComplex(condition)) {
              return !!(condition.re || condition.im);
            }
            if (isUnit(condition)) {
              return !!condition.value;
            }
          }
          if (condition === null || condition === void 0) {
            return false;
          }
          throw new TypeError('Unsupported type of condition "' + typeOf(condition) + '"');
        }
        return ConditionalNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/escape-latex/dist/index.js
  var require_dist = __commonJS({
    "node_modules/escape-latex/dist/index.js"(exports, module) {
      "use strict";
      var _extends6 = Object.assign || function(target) {
        for (var i3 = 1; i3 < arguments.length; i3++) {
          var source = arguments[i3];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      var defaultEscapes = {
        "{": "\\{",
        "}": "\\}",
        "\\": "\\textbackslash{}",
        "#": "\\#",
        $: "\\$",
        "%": "\\%",
        "&": "\\&",
        "^": "\\textasciicircum{}",
        _: "\\_",
        "~": "\\textasciitilde{}"
      };
      var formatEscapes = {
        "\u2013": "\\--",
        "\u2014": "\\---",
        " ": "~",
        "	": "\\qquad{}",
        "\r\n": "\\newline{}",
        "\n": "\\newline{}"
      };
      var defaultEscapeMapFn = function defaultEscapeMapFn2(defaultEscapes2, formatEscapes2) {
        return _extends6({}, defaultEscapes2, formatEscapes2);
      };
      module.exports = function(str) {
        var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ref$preserveFormatti = _ref.preserveFormatting, preserveFormatting = _ref$preserveFormatti === void 0 ? false : _ref$preserveFormatti, _ref$escapeMapFn = _ref.escapeMapFn, escapeMapFn = _ref$escapeMapFn === void 0 ? defaultEscapeMapFn : _ref$escapeMapFn;
        var runningStr = String(str);
        var result = "";
        var escapes = escapeMapFn(_extends6({}, defaultEscapes), preserveFormatting ? _extends6({}, formatEscapes) : {});
        var escapeKeys = Object.keys(escapes);
        var _loop = function _loop2() {
          var specialCharFound = false;
          escapeKeys.forEach(function(key, index2) {
            if (specialCharFound) {
              return;
            }
            if (runningStr.length >= key.length && runningStr.slice(0, key.length) === key) {
              result += escapes[escapeKeys[index2]];
              runningStr = runningStr.slice(key.length, runningStr.length);
              specialCharFound = true;
            }
          });
          if (!specialCharFound) {
            result += runningStr.slice(0, 1);
            runningStr = runningStr.slice(1, runningStr.length);
          }
        };
        while (runningStr) {
          _loop();
        }
        return result;
      };
    }
  });

  // node_modules/mathjs/es/utils/latex.js
  function escapeLatex(string2) {
    return (0, import_escape_latex.default)(string2, {
      preserveFormatting: true
    });
  }
  function toSymbol(name106, isUnit2) {
    isUnit2 = typeof isUnit2 === "undefined" ? false : isUnit2;
    if (isUnit2) {
      if (hasOwnProperty2(latexUnits, name106)) {
        return latexUnits[name106];
      }
      return "\\mathrm{" + escapeLatex(name106) + "}";
    }
    if (hasOwnProperty2(latexSymbols, name106)) {
      return latexSymbols[name106];
    }
    return escapeLatex(name106);
  }
  var import_escape_latex, latexSymbols, latexOperators, latexFunctions, defaultTemplate, latexUnits;
  var init_latex = __esm({
    "node_modules/mathjs/es/utils/latex.js"() {
      import_escape_latex = __toModule(require_dist());
      init_object();
      latexSymbols = {
        Alpha: "A",
        alpha: "\\alpha",
        Beta: "B",
        beta: "\\beta",
        Gamma: "\\Gamma",
        gamma: "\\gamma",
        Delta: "\\Delta",
        delta: "\\delta",
        Epsilon: "E",
        epsilon: "\\epsilon",
        varepsilon: "\\varepsilon",
        Zeta: "Z",
        zeta: "\\zeta",
        Eta: "H",
        eta: "\\eta",
        Theta: "\\Theta",
        theta: "\\theta",
        vartheta: "\\vartheta",
        Iota: "I",
        iota: "\\iota",
        Kappa: "K",
        kappa: "\\kappa",
        varkappa: "\\varkappa",
        Lambda: "\\Lambda",
        lambda: "\\lambda",
        Mu: "M",
        mu: "\\mu",
        Nu: "N",
        nu: "\\nu",
        Xi: "\\Xi",
        xi: "\\xi",
        Omicron: "O",
        omicron: "o",
        Pi: "\\Pi",
        pi: "\\pi",
        varpi: "\\varpi",
        Rho: "P",
        rho: "\\rho",
        varrho: "\\varrho",
        Sigma: "\\Sigma",
        sigma: "\\sigma",
        varsigma: "\\varsigma",
        Tau: "T",
        tau: "\\tau",
        Upsilon: "\\Upsilon",
        upsilon: "\\upsilon",
        Phi: "\\Phi",
        phi: "\\phi",
        varphi: "\\varphi",
        Chi: "X",
        chi: "\\chi",
        Psi: "\\Psi",
        psi: "\\psi",
        Omega: "\\Omega",
        omega: "\\omega",
        "true": "\\mathrm{True}",
        "false": "\\mathrm{False}",
        i: "i",
        inf: "\\infty",
        Inf: "\\infty",
        infinity: "\\infty",
        Infinity: "\\infty",
        oo: "\\infty",
        lim: "\\lim",
        undefined: "\\mathbf{?}"
      };
      latexOperators = {
        transpose: "^\\top",
        ctranspose: "^H",
        factorial: "!",
        pow: "^",
        dotPow: ".^\\wedge",
        unaryPlus: "+",
        unaryMinus: "-",
        bitNot: "\\~",
        not: "\\neg",
        multiply: "\\cdot",
        divide: "\\frac",
        dotMultiply: ".\\cdot",
        dotDivide: ".:",
        mod: "\\mod",
        add: "+",
        subtract: "-",
        to: "\\rightarrow",
        leftShift: "<<",
        rightArithShift: ">>",
        rightLogShift: ">>>",
        equal: "=",
        unequal: "\\neq",
        smaller: "<",
        larger: ">",
        smallerEq: "\\leq",
        largerEq: "\\geq",
        bitAnd: "\\&",
        bitXor: "\\underline{|}",
        bitOr: "|",
        and: "\\wedge",
        xor: "\\veebar",
        or: "\\vee"
      };
      latexFunctions = {
        abs: {
          1: "\\left|${args[0]}\\right|"
        },
        add: {
          2: "\\left(${args[0]}".concat(latexOperators.add, "${args[1]}\\right)")
        },
        cbrt: {
          1: "\\sqrt[3]{${args[0]}}"
        },
        ceil: {
          1: "\\left\\lceil${args[0]}\\right\\rceil"
        },
        cube: {
          1: "\\left(${args[0]}\\right)^3"
        },
        divide: {
          2: "\\frac{${args[0]}}{${args[1]}}"
        },
        dotDivide: {
          2: "\\left(${args[0]}".concat(latexOperators.dotDivide, "${args[1]}\\right)")
        },
        dotMultiply: {
          2: "\\left(${args[0]}".concat(latexOperators.dotMultiply, "${args[1]}\\right)")
        },
        dotPow: {
          2: "\\left(${args[0]}".concat(latexOperators.dotPow, "${args[1]}\\right)")
        },
        exp: {
          1: "\\exp\\left(${args[0]}\\right)"
        },
        expm1: "\\left(e".concat(latexOperators.pow, "{${args[0]}}-1\\right)"),
        fix: {
          1: "\\mathrm{${name}}\\left(${args[0]}\\right)"
        },
        floor: {
          1: "\\left\\lfloor${args[0]}\\right\\rfloor"
        },
        gcd: "\\gcd\\left(${args}\\right)",
        hypot: "\\hypot\\left(${args}\\right)",
        log: {
          1: "\\ln\\left(${args[0]}\\right)",
          2: "\\log_{${args[1]}}\\left(${args[0]}\\right)"
        },
        log10: {
          1: "\\log_{10}\\left(${args[0]}\\right)"
        },
        log1p: {
          1: "\\ln\\left(${args[0]}+1\\right)",
          2: "\\log_{${args[1]}}\\left(${args[0]}+1\\right)"
        },
        log2: "\\log_{2}\\left(${args[0]}\\right)",
        mod: {
          2: "\\left(${args[0]}".concat(latexOperators.mod, "${args[1]}\\right)")
        },
        multiply: {
          2: "\\left(${args[0]}".concat(latexOperators.multiply, "${args[1]}\\right)")
        },
        norm: {
          1: "\\left\\|${args[0]}\\right\\|",
          2: void 0
        },
        nthRoot: {
          2: "\\sqrt[${args[1]}]{${args[0]}}"
        },
        nthRoots: {
          2: "\\{y : $y^{args[1]} = {${args[0]}}\\}"
        },
        pow: {
          2: "\\left(${args[0]}\\right)".concat(latexOperators.pow, "{${args[1]}}")
        },
        round: {
          1: "\\left\\lfloor${args[0]}\\right\\rceil",
          2: void 0
        },
        sign: {
          1: "\\mathrm{${name}}\\left(${args[0]}\\right)"
        },
        sqrt: {
          1: "\\sqrt{${args[0]}}"
        },
        square: {
          1: "\\left(${args[0]}\\right)^2"
        },
        subtract: {
          2: "\\left(${args[0]}".concat(latexOperators.subtract, "${args[1]}\\right)")
        },
        unaryMinus: {
          1: "".concat(latexOperators.unaryMinus, "\\left(${args[0]}\\right)")
        },
        unaryPlus: {
          1: "".concat(latexOperators.unaryPlus, "\\left(${args[0]}\\right)")
        },
        bitAnd: {
          2: "\\left(${args[0]}".concat(latexOperators.bitAnd, "${args[1]}\\right)")
        },
        bitNot: {
          1: latexOperators.bitNot + "\\left(${args[0]}\\right)"
        },
        bitOr: {
          2: "\\left(${args[0]}".concat(latexOperators.bitOr, "${args[1]}\\right)")
        },
        bitXor: {
          2: "\\left(${args[0]}".concat(latexOperators.bitXor, "${args[1]}\\right)")
        },
        leftShift: {
          2: "\\left(${args[0]}".concat(latexOperators.leftShift, "${args[1]}\\right)")
        },
        rightArithShift: {
          2: "\\left(${args[0]}".concat(latexOperators.rightArithShift, "${args[1]}\\right)")
        },
        rightLogShift: {
          2: "\\left(${args[0]}".concat(latexOperators.rightLogShift, "${args[1]}\\right)")
        },
        bellNumbers: {
          1: "\\mathrm{B}_{${args[0]}}"
        },
        catalan: {
          1: "\\mathrm{C}_{${args[0]}}"
        },
        stirlingS2: {
          2: "\\mathrm{S}\\left(${args}\\right)"
        },
        arg: {
          1: "\\arg\\left(${args[0]}\\right)"
        },
        conj: {
          1: "\\left(${args[0]}\\right)^*"
        },
        im: {
          1: "\\Im\\left\\lbrace${args[0]}\\right\\rbrace"
        },
        re: {
          1: "\\Re\\left\\lbrace${args[0]}\\right\\rbrace"
        },
        and: {
          2: "\\left(${args[0]}".concat(latexOperators.and, "${args[1]}\\right)")
        },
        not: {
          1: latexOperators.not + "\\left(${args[0]}\\right)"
        },
        or: {
          2: "\\left(${args[0]}".concat(latexOperators.or, "${args[1]}\\right)")
        },
        xor: {
          2: "\\left(${args[0]}".concat(latexOperators.xor, "${args[1]}\\right)")
        },
        cross: {
          2: "\\left(${args[0]}\\right)\\times\\left(${args[1]}\\right)"
        },
        ctranspose: {
          1: "\\left(${args[0]}\\right)".concat(latexOperators.ctranspose)
        },
        det: {
          1: "\\det\\left(${args[0]}\\right)"
        },
        dot: {
          2: "\\left(${args[0]}\\cdot${args[1]}\\right)"
        },
        expm: {
          1: "\\exp\\left(${args[0]}\\right)"
        },
        inv: {
          1: "\\left(${args[0]}\\right)^{-1}"
        },
        sqrtm: {
          1: "{${args[0]}}".concat(latexOperators.pow, "{\\frac{1}{2}}")
        },
        trace: {
          1: "\\mathrm{tr}\\left(${args[0]}\\right)"
        },
        transpose: {
          1: "\\left(${args[0]}\\right)".concat(latexOperators.transpose)
        },
        combinations: {
          2: "\\binom{${args[0]}}{${args[1]}}"
        },
        combinationsWithRep: {
          2: "\\left(\\!\\!{\\binom{${args[0]}}{${args[1]}}}\\!\\!\\right)"
        },
        factorial: {
          1: "\\left(${args[0]}\\right)".concat(latexOperators.factorial)
        },
        gamma: {
          1: "\\Gamma\\left(${args[0]}\\right)"
        },
        equal: {
          2: "\\left(${args[0]}".concat(latexOperators.equal, "${args[1]}\\right)")
        },
        larger: {
          2: "\\left(${args[0]}".concat(latexOperators.larger, "${args[1]}\\right)")
        },
        largerEq: {
          2: "\\left(${args[0]}".concat(latexOperators.largerEq, "${args[1]}\\right)")
        },
        smaller: {
          2: "\\left(${args[0]}".concat(latexOperators.smaller, "${args[1]}\\right)")
        },
        smallerEq: {
          2: "\\left(${args[0]}".concat(latexOperators.smallerEq, "${args[1]}\\right)")
        },
        unequal: {
          2: "\\left(${args[0]}".concat(latexOperators.unequal, "${args[1]}\\right)")
        },
        erf: {
          1: "erf\\left(${args[0]}\\right)"
        },
        max: "\\max\\left(${args}\\right)",
        min: "\\min\\left(${args}\\right)",
        variance: "\\mathrm{Var}\\left(${args}\\right)",
        acos: {
          1: "\\cos^{-1}\\left(${args[0]}\\right)"
        },
        acosh: {
          1: "\\cosh^{-1}\\left(${args[0]}\\right)"
        },
        acot: {
          1: "\\cot^{-1}\\left(${args[0]}\\right)"
        },
        acoth: {
          1: "\\coth^{-1}\\left(${args[0]}\\right)"
        },
        acsc: {
          1: "\\csc^{-1}\\left(${args[0]}\\right)"
        },
        acsch: {
          1: "\\mathrm{csch}^{-1}\\left(${args[0]}\\right)"
        },
        asec: {
          1: "\\sec^{-1}\\left(${args[0]}\\right)"
        },
        asech: {
          1: "\\mathrm{sech}^{-1}\\left(${args[0]}\\right)"
        },
        asin: {
          1: "\\sin^{-1}\\left(${args[0]}\\right)"
        },
        asinh: {
          1: "\\sinh^{-1}\\left(${args[0]}\\right)"
        },
        atan: {
          1: "\\tan^{-1}\\left(${args[0]}\\right)"
        },
        atan2: {
          2: "\\mathrm{atan2}\\left(${args}\\right)"
        },
        atanh: {
          1: "\\tanh^{-1}\\left(${args[0]}\\right)"
        },
        cos: {
          1: "\\cos\\left(${args[0]}\\right)"
        },
        cosh: {
          1: "\\cosh\\left(${args[0]}\\right)"
        },
        cot: {
          1: "\\cot\\left(${args[0]}\\right)"
        },
        coth: {
          1: "\\coth\\left(${args[0]}\\right)"
        },
        csc: {
          1: "\\csc\\left(${args[0]}\\right)"
        },
        csch: {
          1: "\\mathrm{csch}\\left(${args[0]}\\right)"
        },
        sec: {
          1: "\\sec\\left(${args[0]}\\right)"
        },
        sech: {
          1: "\\mathrm{sech}\\left(${args[0]}\\right)"
        },
        sin: {
          1: "\\sin\\left(${args[0]}\\right)"
        },
        sinh: {
          1: "\\sinh\\left(${args[0]}\\right)"
        },
        tan: {
          1: "\\tan\\left(${args[0]}\\right)"
        },
        tanh: {
          1: "\\tanh\\left(${args[0]}\\right)"
        },
        to: {
          2: "\\left(${args[0]}".concat(latexOperators.to, "${args[1]}\\right)")
        },
        numeric: function numeric(node, options) {
          return node.args[0].toTex();
        },
        number: {
          0: "0",
          1: "\\left(${args[0]}\\right)",
          2: "\\left(\\left(${args[0]}\\right)${args[1]}\\right)"
        },
        string: {
          0: '\\mathtt{""}',
          1: "\\mathrm{string}\\left(${args[0]}\\right)"
        },
        bignumber: {
          0: "0",
          1: "\\left(${args[0]}\\right)"
        },
        complex: {
          0: "0",
          1: "\\left(${args[0]}\\right)",
          2: "\\left(\\left(${args[0]}\\right)+".concat(latexSymbols.i, "\\cdot\\left(${args[1]}\\right)\\right)")
        },
        matrix: {
          0: "\\begin{bmatrix}\\end{bmatrix}",
          1: "\\left(${args[0]}\\right)",
          2: "\\left(${args[0]}\\right)"
        },
        sparse: {
          0: "\\begin{bsparse}\\end{bsparse}",
          1: "\\left(${args[0]}\\right)"
        },
        unit: {
          1: "\\left(${args[0]}\\right)",
          2: "\\left(\\left(${args[0]}\\right)${args[1]}\\right)"
        }
      };
      defaultTemplate = "\\mathrm{${name}}\\left(${args}\\right)";
      latexUnits = {
        deg: "^\\circ"
      };
    }
  });

  // node_modules/mathjs/es/expression/node/ConstantNode.js
  var name31, dependencies30, createConstantNode;
  var init_ConstantNode = __esm({
    "node_modules/mathjs/es/expression/node/ConstantNode.js"() {
      init_string();
      init_is();
      init_latex();
      init_factory();
      name31 = "ConstantNode";
      dependencies30 = ["Node"];
      createConstantNode = /* @__PURE__ */ factory(name31, dependencies30, function(_ref) {
        var Node3 = _ref.Node;
        function ConstantNode2(value) {
          if (!(this instanceof ConstantNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          this.value = value;
        }
        ConstantNode2.prototype = new Node3();
        ConstantNode2.prototype.type = "ConstantNode";
        ConstantNode2.prototype.isConstantNode = true;
        ConstantNode2.prototype._compile = function(math2, argNames) {
          var value = this.value;
          return function evalConstantNode() {
            return value;
          };
        };
        ConstantNode2.prototype.forEach = function(callback) {
        };
        ConstantNode2.prototype.map = function(callback) {
          return this.clone();
        };
        ConstantNode2.prototype.clone = function() {
          return new ConstantNode2(this.value);
        };
        ConstantNode2.prototype._toString = function(options) {
          return format3(this.value, options);
        };
        ConstantNode2.prototype.toHTML = function(options) {
          var value = this._toString(options);
          switch (typeOf(this.value)) {
            case "number":
            case "BigNumber":
            case "Fraction":
              return '<span class="math-number">' + value + "</span>";
            case "string":
              return '<span class="math-string">' + value + "</span>";
            case "boolean":
              return '<span class="math-boolean">' + value + "</span>";
            case "null":
              return '<span class="math-null-symbol">' + value + "</span>";
            case "undefined":
              return '<span class="math-undefined">' + value + "</span>";
            default:
              return '<span class="math-symbol">' + value + "</span>";
          }
        };
        ConstantNode2.prototype.toJSON = function() {
          return {
            mathjs: "ConstantNode",
            value: this.value
          };
        };
        ConstantNode2.fromJSON = function(json) {
          return new ConstantNode2(json.value);
        };
        ConstantNode2.prototype._toTex = function(options) {
          var value = this._toString(options);
          switch (typeOf(this.value)) {
            case "string":
              return "\\mathtt{" + escapeLatex(value) + "}";
            case "number":
            case "BigNumber":
              {
                if (!isFinite(this.value)) {
                  return this.value.valueOf() < 0 ? "-\\infty" : "\\infty";
                }
                var index2 = value.toLowerCase().indexOf("e");
                if (index2 !== -1) {
                  return value.substring(0, index2) + "\\cdot10^{" + value.substring(index2 + 1) + "}";
                }
              }
              return value;
            case "Fraction":
              return this.value.toLatex();
            default:
              return value;
          }
        };
        return ConstantNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/FunctionAssignmentNode.js
  var name32, dependencies31, createFunctionAssignmentNode;
  var init_FunctionAssignmentNode = __esm({
    "node_modules/mathjs/es/expression/node/FunctionAssignmentNode.js"() {
      init_is();
      init_keywords();
      init_string();
      init_array();
      init_latex();
      init_operators();
      init_customs();
      init_factory();
      name32 = "FunctionAssignmentNode";
      dependencies31 = ["typed", "Node"];
      createFunctionAssignmentNode = /* @__PURE__ */ factory(name32, dependencies31, function(_ref) {
        var typed2 = _ref.typed, Node3 = _ref.Node;
        function FunctionAssignmentNode2(name106, params, expr) {
          if (!(this instanceof FunctionAssignmentNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (typeof name106 !== "string")
            throw new TypeError('String expected for parameter "name"');
          if (!Array.isArray(params))
            throw new TypeError('Array containing strings or objects expected for parameter "params"');
          if (!isNode(expr))
            throw new TypeError('Node expected for parameter "expr"');
          if (name106 in keywords)
            throw new Error('Illegal function name, "' + name106 + '" is a reserved keyword');
          this.name = name106;
          this.params = params.map(function(param) {
            return param && param.name || param;
          });
          this.types = params.map(function(param) {
            return param && param.type || "any";
          });
          this.expr = expr;
        }
        FunctionAssignmentNode2.prototype = new Node3();
        FunctionAssignmentNode2.prototype.type = "FunctionAssignmentNode";
        FunctionAssignmentNode2.prototype.isFunctionAssignmentNode = true;
        FunctionAssignmentNode2.prototype._compile = function(math2, argNames) {
          var childArgNames = Object.create(argNames);
          forEach(this.params, function(param) {
            childArgNames[param] = true;
          });
          var evalExpr = this.expr._compile(math2, childArgNames);
          var name106 = this.name;
          var params = this.params;
          var signature = join(this.types, ",");
          var syntax = name106 + "(" + join(this.params, ", ") + ")";
          return function evalFunctionAssignmentNode(scope, args, context) {
            var signatures = {};
            signatures[signature] = function() {
              var childArgs = Object.create(args);
              for (var i3 = 0; i3 < params.length; i3++) {
                childArgs[params[i3]] = arguments[i3];
              }
              return evalExpr(scope, childArgs, context);
            };
            var fn = typed2(name106, signatures);
            fn.syntax = syntax;
            setSafeProperty(scope, name106, fn);
            return fn;
          };
        };
        FunctionAssignmentNode2.prototype.forEach = function(callback) {
          callback(this.expr, "expr", this);
        };
        FunctionAssignmentNode2.prototype.map = function(callback) {
          var expr = this._ifNode(callback(this.expr, "expr", this));
          return new FunctionAssignmentNode2(this.name, this.params.slice(0), expr);
        };
        FunctionAssignmentNode2.prototype.clone = function() {
          return new FunctionAssignmentNode2(this.name, this.params.slice(0), this.expr);
        };
        function needParenthesis(node, parenthesis) {
          var precedence = getPrecedence(node, parenthesis);
          var exprPrecedence = getPrecedence(node.expr, parenthesis);
          return parenthesis === "all" || exprPrecedence !== null && exprPrecedence <= precedence;
        }
        FunctionAssignmentNode2.prototype._toString = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var expr = this.expr.toString(options);
          if (needParenthesis(this, parenthesis)) {
            expr = "(" + expr + ")";
          }
          return this.name + "(" + this.params.join(", ") + ") = " + expr;
        };
        FunctionAssignmentNode2.prototype.toJSON = function() {
          var types = this.types;
          return {
            mathjs: "FunctionAssignmentNode",
            name: this.name,
            params: this.params.map(function(param, index2) {
              return {
                name: param,
                type: types[index2]
              };
            }),
            expr: this.expr
          };
        };
        FunctionAssignmentNode2.fromJSON = function(json) {
          return new FunctionAssignmentNode2(json.name, json.params, json.expr);
        };
        FunctionAssignmentNode2.prototype.toHTML = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var params = [];
          for (var i3 = 0; i3 < this.params.length; i3++) {
            params.push('<span class="math-symbol math-parameter">' + escape(this.params[i3]) + "</span>");
          }
          var expr = this.expr.toHTML(options);
          if (needParenthesis(this, parenthesis)) {
            expr = '<span class="math-parenthesis math-round-parenthesis">(</span>' + expr + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          return '<span class="math-function">' + escape(this.name) + '</span><span class="math-parenthesis math-round-parenthesis">(</span>' + params.join('<span class="math-separator">,</span>') + '<span class="math-parenthesis math-round-parenthesis">)</span><span class="math-operator math-assignment-operator math-variable-assignment-operator math-binary-operator">=</span>' + expr;
        };
        FunctionAssignmentNode2.prototype._toTex = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var expr = this.expr.toTex(options);
          if (needParenthesis(this, parenthesis)) {
            expr = "\\left(".concat(expr, "\\right)");
          }
          return "\\mathrm{" + this.name + "}\\left(" + this.params.map(toSymbol).join(",") + "\\right):=" + expr;
        };
        return FunctionAssignmentNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/IndexNode.js
  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
  }
  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _unsupportedIterableToArray(o3, minLen) {
    if (!o3)
      return;
    if (typeof o3 === "string")
      return _arrayLikeToArray(o3, minLen);
    var n3 = Object.prototype.toString.call(o3).slice(8, -1);
    if (n3 === "Object" && o3.constructor)
      n3 = o3.constructor.name;
    if (n3 === "Map" || n3 === "Set")
      return Array.from(o3);
    if (n3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n3))
      return _arrayLikeToArray(o3, minLen);
  }
  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter))
      return Array.from(iter);
  }
  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr))
      return _arrayLikeToArray(arr);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length)
      len = arr.length;
    for (var i3 = 0, arr2 = new Array(len); i3 < len; i3++) {
      arr2[i3] = arr[i3];
    }
    return arr2;
  }
  var name33, dependencies32, createIndexNode;
  var init_IndexNode = __esm({
    "node_modules/mathjs/es/expression/node/IndexNode.js"() {
      init_is();
      init_array();
      init_string();
      init_factory();
      init_customs();
      name33 = "IndexNode";
      dependencies32 = ["Range", "Node", "size"];
      createIndexNode = /* @__PURE__ */ factory(name33, dependencies32, function(_ref) {
        var Range3 = _ref.Range, Node3 = _ref.Node, size2 = _ref.size;
        function IndexNode2(dimensions, dotNotation) {
          if (!(this instanceof IndexNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          this.dimensions = dimensions;
          this.dotNotation = dotNotation || false;
          if (!Array.isArray(dimensions) || !dimensions.every(isNode)) {
            throw new TypeError('Array containing Nodes expected for parameter "dimensions"');
          }
          if (this.dotNotation && !this.isObjectProperty()) {
            throw new Error("dotNotation only applicable for object properties");
          }
        }
        IndexNode2.prototype = new Node3();
        IndexNode2.prototype.type = "IndexNode";
        IndexNode2.prototype.isIndexNode = true;
        IndexNode2.prototype._compile = function(math2, argNames) {
          var evalDimensions = map(this.dimensions, function(range2, i3) {
            if (isRangeNode(range2)) {
              if (range2.needsEnd()) {
                var childArgNames = Object.create(argNames);
                childArgNames.end = true;
                var evalStart = range2.start._compile(math2, childArgNames);
                var evalEnd = range2.end._compile(math2, childArgNames);
                var evalStep = range2.step ? range2.step._compile(math2, childArgNames) : function() {
                  return 1;
                };
                return function evalDimension(scope, args, context) {
                  var s3 = size2(context).valueOf();
                  var childArgs = Object.create(args);
                  childArgs.end = s3[i3];
                  return createRange2(evalStart(scope, childArgs, context), evalEnd(scope, childArgs, context), evalStep(scope, childArgs, context));
                };
              } else {
                var _evalStart = range2.start._compile(math2, argNames);
                var _evalEnd = range2.end._compile(math2, argNames);
                var _evalStep = range2.step ? range2.step._compile(math2, argNames) : function() {
                  return 1;
                };
                return function evalDimension(scope, args, context) {
                  return createRange2(_evalStart(scope, args, context), _evalEnd(scope, args, context), _evalStep(scope, args, context));
                };
              }
            } else if (isSymbolNode(range2) && range2.name === "end") {
              var _childArgNames = Object.create(argNames);
              _childArgNames.end = true;
              var evalRange = range2._compile(math2, _childArgNames);
              return function evalDimension(scope, args, context) {
                var s3 = size2(context).valueOf();
                var childArgs = Object.create(args);
                childArgs.end = s3[i3];
                return evalRange(scope, childArgs, context);
              };
            } else {
              var _evalRange = range2._compile(math2, argNames);
              return function evalDimension(scope, args, context) {
                return _evalRange(scope, args, context);
              };
            }
          });
          var index2 = getSafeProperty(math2, "index");
          return function evalIndexNode(scope, args, context) {
            var dimensions = map(evalDimensions, function(evalDimension) {
              return evalDimension(scope, args, context);
            });
            return index2.apply(void 0, _toConsumableArray(dimensions));
          };
        };
        IndexNode2.prototype.forEach = function(callback) {
          for (var i3 = 0; i3 < this.dimensions.length; i3++) {
            callback(this.dimensions[i3], "dimensions[" + i3 + "]", this);
          }
        };
        IndexNode2.prototype.map = function(callback) {
          var dimensions = [];
          for (var i3 = 0; i3 < this.dimensions.length; i3++) {
            dimensions[i3] = this._ifNode(callback(this.dimensions[i3], "dimensions[" + i3 + "]", this));
          }
          return new IndexNode2(dimensions, this.dotNotation);
        };
        IndexNode2.prototype.clone = function() {
          return new IndexNode2(this.dimensions.slice(0), this.dotNotation);
        };
        IndexNode2.prototype.isObjectProperty = function() {
          return this.dimensions.length === 1 && isConstantNode(this.dimensions[0]) && typeof this.dimensions[0].value === "string";
        };
        IndexNode2.prototype.getObjectProperty = function() {
          return this.isObjectProperty() ? this.dimensions[0].value : null;
        };
        IndexNode2.prototype._toString = function(options) {
          return this.dotNotation ? "." + this.getObjectProperty() : "[" + this.dimensions.join(", ") + "]";
        };
        IndexNode2.prototype.toJSON = function() {
          return {
            mathjs: "IndexNode",
            dimensions: this.dimensions,
            dotNotation: this.dotNotation
          };
        };
        IndexNode2.fromJSON = function(json) {
          return new IndexNode2(json.dimensions, json.dotNotation);
        };
        IndexNode2.prototype.toHTML = function(options) {
          var dimensions = [];
          for (var i3 = 0; i3 < this.dimensions.length; i3++) {
            dimensions[i3] = this.dimensions[i3].toHTML();
          }
          if (this.dotNotation) {
            return '<span class="math-operator math-accessor-operator">.</span><span class="math-symbol math-property">' + escape(this.getObjectProperty()) + "</span>";
          } else {
            return '<span class="math-parenthesis math-square-parenthesis">[</span>' + dimensions.join('<span class="math-separator">,</span>') + '<span class="math-parenthesis math-square-parenthesis">]</span>';
          }
        };
        IndexNode2.prototype._toTex = function(options) {
          var dimensions = this.dimensions.map(function(range2) {
            return range2.toTex(options);
          });
          return this.dotNotation ? "." + this.getObjectProperty() + "" : "_{" + dimensions.join(",") + "}";
        };
        function createRange2(start2, end, step) {
          return new Range3(isBigNumber(start2) ? start2.toNumber() : start2, isBigNumber(end) ? end.toNumber() : end, isBigNumber(step) ? step.toNumber() : step);
        }
        return IndexNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/ObjectNode.js
  function _typeof10(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof10 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof10 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof10(obj);
  }
  var name34, dependencies33, createObjectNode;
  var init_ObjectNode = __esm({
    "node_modules/mathjs/es/expression/node/ObjectNode.js"() {
      init_is();
      init_string();
      init_customs();
      init_object();
      init_factory();
      name34 = "ObjectNode";
      dependencies33 = ["Node"];
      createObjectNode = /* @__PURE__ */ factory(name34, dependencies33, function(_ref) {
        var Node3 = _ref.Node;
        function ObjectNode2(properties2) {
          if (!(this instanceof ObjectNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          this.properties = properties2 || {};
          if (properties2) {
            if (!(_typeof10(properties2) === "object") || !Object.keys(properties2).every(function(key) {
              return isNode(properties2[key]);
            })) {
              throw new TypeError("Object containing Nodes expected");
            }
          }
        }
        ObjectNode2.prototype = new Node3();
        ObjectNode2.prototype.type = "ObjectNode";
        ObjectNode2.prototype.isObjectNode = true;
        ObjectNode2.prototype._compile = function(math2, argNames) {
          var evalEntries = {};
          for (var key in this.properties) {
            if (hasOwnProperty2(this.properties, key)) {
              var stringifiedKey = stringify(key);
              var parsedKey = JSON.parse(stringifiedKey);
              if (!isSafeProperty(this.properties, parsedKey)) {
                throw new Error('No access to property "' + parsedKey + '"');
              }
              evalEntries[parsedKey] = this.properties[key]._compile(math2, argNames);
            }
          }
          return function evalObjectNode(scope, args, context) {
            var obj = {};
            for (var _key in evalEntries) {
              if (hasOwnProperty2(evalEntries, _key)) {
                obj[_key] = evalEntries[_key](scope, args, context);
              }
            }
            return obj;
          };
        };
        ObjectNode2.prototype.forEach = function(callback) {
          for (var key in this.properties) {
            if (hasOwnProperty2(this.properties, key)) {
              callback(this.properties[key], "properties[" + stringify(key) + "]", this);
            }
          }
        };
        ObjectNode2.prototype.map = function(callback) {
          var properties2 = {};
          for (var key in this.properties) {
            if (hasOwnProperty2(this.properties, key)) {
              properties2[key] = this._ifNode(callback(this.properties[key], "properties[" + stringify(key) + "]", this));
            }
          }
          return new ObjectNode2(properties2);
        };
        ObjectNode2.prototype.clone = function() {
          var properties2 = {};
          for (var key in this.properties) {
            if (hasOwnProperty2(this.properties, key)) {
              properties2[key] = this.properties[key];
            }
          }
          return new ObjectNode2(properties2);
        };
        ObjectNode2.prototype._toString = function(options) {
          var entries = [];
          for (var key in this.properties) {
            if (hasOwnProperty2(this.properties, key)) {
              entries.push(stringify(key) + ": " + this.properties[key].toString(options));
            }
          }
          return "{" + entries.join(", ") + "}";
        };
        ObjectNode2.prototype.toJSON = function() {
          return {
            mathjs: "ObjectNode",
            properties: this.properties
          };
        };
        ObjectNode2.fromJSON = function(json) {
          return new ObjectNode2(json.properties);
        };
        ObjectNode2.prototype.toHTML = function(options) {
          var entries = [];
          for (var key in this.properties) {
            if (hasOwnProperty2(this.properties, key)) {
              entries.push('<span class="math-symbol math-property">' + escape(key) + '</span><span class="math-operator math-assignment-operator math-property-assignment-operator math-binary-operator">:</span>' + this.properties[key].toHTML(options));
            }
          }
          return '<span class="math-parenthesis math-curly-parenthesis">{</span>' + entries.join('<span class="math-separator">,</span>') + '<span class="math-parenthesis math-curly-parenthesis">}</span>';
        };
        ObjectNode2.prototype._toTex = function(options) {
          var entries = [];
          for (var key in this.properties) {
            if (hasOwnProperty2(this.properties, key)) {
              entries.push("\\mathbf{" + key + ":} & " + this.properties[key].toTex(options) + "\\\\");
            }
          }
          return "\\left\\{\\begin{array}{ll}".concat(entries.join("\n"), "\\end{array}\\right\\}");
        };
        return ObjectNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/OperatorNode.js
  var name35, dependencies34, createOperatorNode;
  var init_OperatorNode = __esm({
    "node_modules/mathjs/es/expression/node/OperatorNode.js"() {
      init_is();
      init_array();
      init_string();
      init_customs();
      init_operators();
      init_latex();
      init_factory();
      name35 = "OperatorNode";
      dependencies34 = ["Node"];
      createOperatorNode = /* @__PURE__ */ factory(name35, dependencies34, function(_ref) {
        var Node3 = _ref.Node;
        function OperatorNode2(op, fn, args, implicit) {
          if (!(this instanceof OperatorNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (typeof op !== "string") {
            throw new TypeError('string expected for parameter "op"');
          }
          if (typeof fn !== "string") {
            throw new TypeError('string expected for parameter "fn"');
          }
          if (!Array.isArray(args) || !args.every(isNode)) {
            throw new TypeError('Array containing Nodes expected for parameter "args"');
          }
          this.implicit = implicit === true;
          this.op = op;
          this.fn = fn;
          this.args = args || [];
        }
        OperatorNode2.prototype = new Node3();
        OperatorNode2.prototype.type = "OperatorNode";
        OperatorNode2.prototype.isOperatorNode = true;
        OperatorNode2.prototype._compile = function(math2, argNames) {
          if (typeof this.fn !== "string" || !isSafeMethod(math2, this.fn)) {
            if (!math2[this.fn]) {
              throw new Error("Function " + this.fn + ' missing in provided namespace "math"');
            } else {
              throw new Error('No access to function "' + this.fn + '"');
            }
          }
          var fn = getSafeProperty(math2, this.fn);
          var evalArgs = map(this.args, function(arg) {
            return arg._compile(math2, argNames);
          });
          if (evalArgs.length === 1) {
            var evalArg0 = evalArgs[0];
            return function evalOperatorNode(scope, args, context) {
              return fn(evalArg0(scope, args, context));
            };
          } else if (evalArgs.length === 2) {
            var _evalArg = evalArgs[0];
            var evalArg1 = evalArgs[1];
            return function evalOperatorNode(scope, args, context) {
              return fn(_evalArg(scope, args, context), evalArg1(scope, args, context));
            };
          } else {
            return function evalOperatorNode(scope, args, context) {
              return fn.apply(null, map(evalArgs, function(evalArg) {
                return evalArg(scope, args, context);
              }));
            };
          }
        };
        OperatorNode2.prototype.forEach = function(callback) {
          for (var i3 = 0; i3 < this.args.length; i3++) {
            callback(this.args[i3], "args[" + i3 + "]", this);
          }
        };
        OperatorNode2.prototype.map = function(callback) {
          var args = [];
          for (var i3 = 0; i3 < this.args.length; i3++) {
            args[i3] = this._ifNode(callback(this.args[i3], "args[" + i3 + "]", this));
          }
          return new OperatorNode2(this.op, this.fn, args, this.implicit);
        };
        OperatorNode2.prototype.clone = function() {
          return new OperatorNode2(this.op, this.fn, this.args.slice(0), this.implicit);
        };
        OperatorNode2.prototype.isUnary = function() {
          return this.args.length === 1;
        };
        OperatorNode2.prototype.isBinary = function() {
          return this.args.length === 2;
        };
        function calculateNecessaryParentheses(root, parenthesis, implicit, args, latex) {
          var precedence = getPrecedence(root, parenthesis);
          var associativity = getAssociativity(root, parenthesis);
          if (parenthesis === "all" || args.length > 2 && root.getIdentifier() !== "OperatorNode:add" && root.getIdentifier() !== "OperatorNode:multiply") {
            return args.map(function(arg) {
              switch (arg.getContent().type) {
                case "ArrayNode":
                case "ConstantNode":
                case "SymbolNode":
                case "ParenthesisNode":
                  return false;
                default:
                  return true;
              }
            });
          }
          var result;
          switch (args.length) {
            case 0:
              result = [];
              break;
            case 1:
              {
                var operandPrecedence = getPrecedence(args[0], parenthesis);
                if (latex && operandPrecedence !== null) {
                  var operandIdentifier;
                  var rootIdentifier;
                  if (parenthesis === "keep") {
                    operandIdentifier = args[0].getIdentifier();
                    rootIdentifier = root.getIdentifier();
                  } else {
                    operandIdentifier = args[0].getContent().getIdentifier();
                    rootIdentifier = root.getContent().getIdentifier();
                  }
                  if (properties[precedence][rootIdentifier].latexLeftParens === false) {
                    result = [false];
                    break;
                  }
                  if (properties[operandPrecedence][operandIdentifier].latexParens === false) {
                    result = [false];
                    break;
                  }
                }
                if (operandPrecedence === null) {
                  result = [false];
                  break;
                }
                if (operandPrecedence <= precedence) {
                  result = [true];
                  break;
                }
                result = [false];
              }
              break;
            case 2:
              {
                var lhsParens;
                var lhsPrecedence = getPrecedence(args[0], parenthesis);
                var assocWithLhs = isAssociativeWith(root, args[0], parenthesis);
                if (lhsPrecedence === null) {
                  lhsParens = false;
                } else if (lhsPrecedence === precedence && associativity === "right" && !assocWithLhs) {
                  lhsParens = true;
                } else if (lhsPrecedence < precedence) {
                  lhsParens = true;
                } else {
                  lhsParens = false;
                }
                var rhsParens;
                var rhsPrecedence = getPrecedence(args[1], parenthesis);
                var assocWithRhs = isAssociativeWith(root, args[1], parenthesis);
                if (rhsPrecedence === null) {
                  rhsParens = false;
                } else if (rhsPrecedence === precedence && associativity === "left" && !assocWithRhs) {
                  rhsParens = true;
                } else if (rhsPrecedence < precedence) {
                  rhsParens = true;
                } else {
                  rhsParens = false;
                }
                if (latex) {
                  var _rootIdentifier;
                  var lhsIdentifier;
                  var rhsIdentifier;
                  if (parenthesis === "keep") {
                    _rootIdentifier = root.getIdentifier();
                    lhsIdentifier = root.args[0].getIdentifier();
                    rhsIdentifier = root.args[1].getIdentifier();
                  } else {
                    _rootIdentifier = root.getContent().getIdentifier();
                    lhsIdentifier = root.args[0].getContent().getIdentifier();
                    rhsIdentifier = root.args[1].getContent().getIdentifier();
                  }
                  if (lhsPrecedence !== null) {
                    if (properties[precedence][_rootIdentifier].latexLeftParens === false) {
                      lhsParens = false;
                    }
                    if (properties[lhsPrecedence][lhsIdentifier].latexParens === false) {
                      lhsParens = false;
                    }
                  }
                  if (rhsPrecedence !== null) {
                    if (properties[precedence][_rootIdentifier].latexRightParens === false) {
                      rhsParens = false;
                    }
                    if (properties[rhsPrecedence][rhsIdentifier].latexParens === false) {
                      rhsParens = false;
                    }
                  }
                }
                result = [lhsParens, rhsParens];
              }
              break;
            default:
              if (root.getIdentifier() === "OperatorNode:add" || root.getIdentifier() === "OperatorNode:multiply") {
                result = args.map(function(arg) {
                  var argPrecedence = getPrecedence(arg, parenthesis);
                  var assocWithArg = isAssociativeWith(root, arg, parenthesis);
                  var argAssociativity = getAssociativity(arg, parenthesis);
                  if (argPrecedence === null) {
                    return false;
                  } else if (precedence === argPrecedence && associativity === argAssociativity && !assocWithArg) {
                    return true;
                  } else if (argPrecedence < precedence) {
                    return true;
                  }
                  return false;
                });
              }
              break;
          }
          if (args.length >= 2 && root.getIdentifier() === "OperatorNode:multiply" && root.implicit && parenthesis === "auto" && implicit === "hide") {
            result = args.map(function(arg, index2) {
              var isParenthesisNode2 = arg.getIdentifier() === "ParenthesisNode";
              if (result[index2] || isParenthesisNode2) {
                return true;
              }
              return false;
            });
          }
          return result;
        }
        OperatorNode2.prototype._toString = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var implicit = options && options.implicit ? options.implicit : "hide";
          var args = this.args;
          var parens = calculateNecessaryParentheses(this, parenthesis, implicit, args, false);
          if (args.length === 1) {
            var assoc = getAssociativity(this, parenthesis);
            var operand = args[0].toString(options);
            if (parens[0]) {
              operand = "(" + operand + ")";
            }
            var opIsNamed = /[a-zA-Z]+/.test(this.op);
            if (assoc === "right") {
              return this.op + (opIsNamed ? " " : "") + operand;
            } else if (assoc === "left") {
              return operand + (opIsNamed ? " " : "") + this.op;
            }
            return operand + this.op;
          } else if (args.length === 2) {
            var lhs = args[0].toString(options);
            var rhs = args[1].toString(options);
            if (parens[0]) {
              lhs = "(" + lhs + ")";
            }
            if (parens[1]) {
              rhs = "(" + rhs + ")";
            }
            if (this.implicit && this.getIdentifier() === "OperatorNode:multiply" && implicit === "hide") {
              return lhs + " " + rhs;
            }
            return lhs + " " + this.op + " " + rhs;
          } else if (args.length > 2 && (this.getIdentifier() === "OperatorNode:add" || this.getIdentifier() === "OperatorNode:multiply")) {
            var stringifiedArgs = args.map(function(arg, index2) {
              arg = arg.toString(options);
              if (parens[index2]) {
                arg = "(" + arg + ")";
              }
              return arg;
            });
            if (this.implicit && this.getIdentifier() === "OperatorNode:multiply" && implicit === "hide") {
              return stringifiedArgs.join(" ");
            }
            return stringifiedArgs.join(" " + this.op + " ");
          } else {
            return this.fn + "(" + this.args.join(", ") + ")";
          }
        };
        OperatorNode2.prototype.toJSON = function() {
          return {
            mathjs: "OperatorNode",
            op: this.op,
            fn: this.fn,
            args: this.args,
            implicit: this.implicit
          };
        };
        OperatorNode2.fromJSON = function(json) {
          return new OperatorNode2(json.op, json.fn, json.args, json.implicit);
        };
        OperatorNode2.prototype.toHTML = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var implicit = options && options.implicit ? options.implicit : "hide";
          var args = this.args;
          var parens = calculateNecessaryParentheses(this, parenthesis, implicit, args, false);
          if (args.length === 1) {
            var assoc = getAssociativity(this, parenthesis);
            var operand = args[0].toHTML(options);
            if (parens[0]) {
              operand = '<span class="math-parenthesis math-round-parenthesis">(</span>' + operand + '<span class="math-parenthesis math-round-parenthesis">)</span>';
            }
            if (assoc === "right") {
              return '<span class="math-operator math-unary-operator math-lefthand-unary-operator">' + escape(this.op) + "</span>" + operand;
            } else {
              return operand + '<span class="math-operator math-unary-operator math-righthand-unary-operator">' + escape(this.op) + "</span>";
            }
          } else if (args.length === 2) {
            var lhs = args[0].toHTML(options);
            var rhs = args[1].toHTML(options);
            if (parens[0]) {
              lhs = '<span class="math-parenthesis math-round-parenthesis">(</span>' + lhs + '<span class="math-parenthesis math-round-parenthesis">)</span>';
            }
            if (parens[1]) {
              rhs = '<span class="math-parenthesis math-round-parenthesis">(</span>' + rhs + '<span class="math-parenthesis math-round-parenthesis">)</span>';
            }
            if (this.implicit && this.getIdentifier() === "OperatorNode:multiply" && implicit === "hide") {
              return lhs + '<span class="math-operator math-binary-operator math-implicit-binary-operator"></span>' + rhs;
            }
            return lhs + '<span class="math-operator math-binary-operator math-explicit-binary-operator">' + escape(this.op) + "</span>" + rhs;
          } else {
            var stringifiedArgs = args.map(function(arg, index2) {
              arg = arg.toHTML(options);
              if (parens[index2]) {
                arg = '<span class="math-parenthesis math-round-parenthesis">(</span>' + arg + '<span class="math-parenthesis math-round-parenthesis">)</span>';
              }
              return arg;
            });
            if (args.length > 2 && (this.getIdentifier() === "OperatorNode:add" || this.getIdentifier() === "OperatorNode:multiply")) {
              if (this.implicit && this.getIdentifier() === "OperatorNode:multiply" && implicit === "hide") {
                return stringifiedArgs.join('<span class="math-operator math-binary-operator math-implicit-binary-operator"></span>');
              }
              return stringifiedArgs.join('<span class="math-operator math-binary-operator math-explicit-binary-operator">' + escape(this.op) + "</span>");
            } else {
              return '<span class="math-function">' + escape(this.fn) + '</span><span class="math-paranthesis math-round-parenthesis">(</span>' + stringifiedArgs.join('<span class="math-separator">,</span>') + '<span class="math-paranthesis math-round-parenthesis">)</span>';
            }
          }
        };
        OperatorNode2.prototype._toTex = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var implicit = options && options.implicit ? options.implicit : "hide";
          var args = this.args;
          var parens = calculateNecessaryParentheses(this, parenthesis, implicit, args, true);
          var op = latexOperators[this.fn];
          op = typeof op === "undefined" ? this.op : op;
          if (args.length === 1) {
            var assoc = getAssociativity(this, parenthesis);
            var operand = args[0].toTex(options);
            if (parens[0]) {
              operand = "\\left(".concat(operand, "\\right)");
            }
            if (assoc === "right") {
              return op + operand;
            } else if (assoc === "left") {
              return operand + op;
            }
            return operand + op;
          } else if (args.length === 2) {
            var lhs = args[0];
            var lhsTex = lhs.toTex(options);
            if (parens[0]) {
              lhsTex = "\\left(".concat(lhsTex, "\\right)");
            }
            var rhs = args[1];
            var rhsTex = rhs.toTex(options);
            if (parens[1]) {
              rhsTex = "\\left(".concat(rhsTex, "\\right)");
            }
            var lhsIdentifier;
            if (parenthesis === "keep") {
              lhsIdentifier = lhs.getIdentifier();
            } else {
              lhsIdentifier = lhs.getContent().getIdentifier();
            }
            switch (this.getIdentifier()) {
              case "OperatorNode:divide":
                return op + "{" + lhsTex + "}{" + rhsTex + "}";
              case "OperatorNode:pow":
                lhsTex = "{" + lhsTex + "}";
                rhsTex = "{" + rhsTex + "}";
                switch (lhsIdentifier) {
                  case "ConditionalNode":
                  case "OperatorNode:divide":
                    lhsTex = "\\left(".concat(lhsTex, "\\right)");
                }
                break;
              case "OperatorNode:multiply":
                if (this.implicit && implicit === "hide") {
                  return lhsTex + "~" + rhsTex;
                }
            }
            return lhsTex + op + rhsTex;
          } else if (args.length > 2 && (this.getIdentifier() === "OperatorNode:add" || this.getIdentifier() === "OperatorNode:multiply")) {
            var texifiedArgs = args.map(function(arg, index2) {
              arg = arg.toTex(options);
              if (parens[index2]) {
                arg = "\\left(".concat(arg, "\\right)");
              }
              return arg;
            });
            if (this.getIdentifier() === "OperatorNode:multiply" && this.implicit) {
              return texifiedArgs.join("~");
            }
            return texifiedArgs.join(op);
          } else {
            return "\\mathrm{" + this.fn + "}\\left(" + args.map(function(arg) {
              return arg.toTex(options);
            }).join(",") + "\\right)";
          }
        };
        OperatorNode2.prototype.getIdentifier = function() {
          return this.type + ":" + this.fn;
        };
        return OperatorNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/ParenthesisNode.js
  var name36, dependencies35, createParenthesisNode;
  var init_ParenthesisNode = __esm({
    "node_modules/mathjs/es/expression/node/ParenthesisNode.js"() {
      init_is();
      init_factory();
      name36 = "ParenthesisNode";
      dependencies35 = ["Node"];
      createParenthesisNode = /* @__PURE__ */ factory(name36, dependencies35, function(_ref) {
        var Node3 = _ref.Node;
        function ParenthesisNode2(content) {
          if (!(this instanceof ParenthesisNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (!isNode(content)) {
            throw new TypeError('Node expected for parameter "content"');
          }
          this.content = content;
        }
        ParenthesisNode2.prototype = new Node3();
        ParenthesisNode2.prototype.type = "ParenthesisNode";
        ParenthesisNode2.prototype.isParenthesisNode = true;
        ParenthesisNode2.prototype._compile = function(math2, argNames) {
          return this.content._compile(math2, argNames);
        };
        ParenthesisNode2.prototype.getContent = function() {
          return this.content.getContent();
        };
        ParenthesisNode2.prototype.forEach = function(callback) {
          callback(this.content, "content", this);
        };
        ParenthesisNode2.prototype.map = function(callback) {
          var content = callback(this.content, "content", this);
          return new ParenthesisNode2(content);
        };
        ParenthesisNode2.prototype.clone = function() {
          return new ParenthesisNode2(this.content);
        };
        ParenthesisNode2.prototype._toString = function(options) {
          if (!options || options && !options.parenthesis || options && options.parenthesis === "keep") {
            return "(" + this.content.toString(options) + ")";
          }
          return this.content.toString(options);
        };
        ParenthesisNode2.prototype.toJSON = function() {
          return {
            mathjs: "ParenthesisNode",
            content: this.content
          };
        };
        ParenthesisNode2.fromJSON = function(json) {
          return new ParenthesisNode2(json.content);
        };
        ParenthesisNode2.prototype.toHTML = function(options) {
          if (!options || options && !options.parenthesis || options && options.parenthesis === "keep") {
            return '<span class="math-parenthesis math-round-parenthesis">(</span>' + this.content.toHTML(options) + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          return this.content.toHTML(options);
        };
        ParenthesisNode2.prototype._toTex = function(options) {
          if (!options || options && !options.parenthesis || options && options.parenthesis === "keep") {
            return "\\left(".concat(this.content.toTex(options), "\\right)");
          }
          return this.content.toTex(options);
        };
        return ParenthesisNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/RangeNode.js
  var name37, dependencies36, createRangeNode;
  var init_RangeNode = __esm({
    "node_modules/mathjs/es/expression/node/RangeNode.js"() {
      init_is();
      init_factory();
      init_operators();
      name37 = "RangeNode";
      dependencies36 = ["Node"];
      createRangeNode = /* @__PURE__ */ factory(name37, dependencies36, function(_ref) {
        var Node3 = _ref.Node;
        function RangeNode2(start2, end, step) {
          if (!(this instanceof RangeNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (!isNode(start2))
            throw new TypeError("Node expected");
          if (!isNode(end))
            throw new TypeError("Node expected");
          if (step && !isNode(step))
            throw new TypeError("Node expected");
          if (arguments.length > 3)
            throw new Error("Too many arguments");
          this.start = start2;
          this.end = end;
          this.step = step || null;
        }
        RangeNode2.prototype = new Node3();
        RangeNode2.prototype.type = "RangeNode";
        RangeNode2.prototype.isRangeNode = true;
        RangeNode2.prototype.needsEnd = function() {
          var endSymbols = this.filter(function(node) {
            return isSymbolNode(node) && node.name === "end";
          });
          return endSymbols.length > 0;
        };
        RangeNode2.prototype._compile = function(math2, argNames) {
          var range2 = math2.range;
          var evalStart = this.start._compile(math2, argNames);
          var evalEnd = this.end._compile(math2, argNames);
          if (this.step) {
            var evalStep = this.step._compile(math2, argNames);
            return function evalRangeNode(scope, args, context) {
              return range2(evalStart(scope, args, context), evalEnd(scope, args, context), evalStep(scope, args, context));
            };
          } else {
            return function evalRangeNode(scope, args, context) {
              return range2(evalStart(scope, args, context), evalEnd(scope, args, context));
            };
          }
        };
        RangeNode2.prototype.forEach = function(callback) {
          callback(this.start, "start", this);
          callback(this.end, "end", this);
          if (this.step) {
            callback(this.step, "step", this);
          }
        };
        RangeNode2.prototype.map = function(callback) {
          return new RangeNode2(this._ifNode(callback(this.start, "start", this)), this._ifNode(callback(this.end, "end", this)), this.step && this._ifNode(callback(this.step, "step", this)));
        };
        RangeNode2.prototype.clone = function() {
          return new RangeNode2(this.start, this.end, this.step && this.step);
        };
        function calculateNecessaryParentheses(node, parenthesis) {
          var precedence = getPrecedence(node, parenthesis);
          var parens = {};
          var startPrecedence = getPrecedence(node.start, parenthesis);
          parens.start = startPrecedence !== null && startPrecedence <= precedence || parenthesis === "all";
          if (node.step) {
            var stepPrecedence = getPrecedence(node.step, parenthesis);
            parens.step = stepPrecedence !== null && stepPrecedence <= precedence || parenthesis === "all";
          }
          var endPrecedence = getPrecedence(node.end, parenthesis);
          parens.end = endPrecedence !== null && endPrecedence <= precedence || parenthesis === "all";
          return parens;
        }
        RangeNode2.prototype._toString = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var parens = calculateNecessaryParentheses(this, parenthesis);
          var str;
          var start2 = this.start.toString(options);
          if (parens.start) {
            start2 = "(" + start2 + ")";
          }
          str = start2;
          if (this.step) {
            var step = this.step.toString(options);
            if (parens.step) {
              step = "(" + step + ")";
            }
            str += ":" + step;
          }
          var end = this.end.toString(options);
          if (parens.end) {
            end = "(" + end + ")";
          }
          str += ":" + end;
          return str;
        };
        RangeNode2.prototype.toJSON = function() {
          return {
            mathjs: "RangeNode",
            start: this.start,
            end: this.end,
            step: this.step
          };
        };
        RangeNode2.fromJSON = function(json) {
          return new RangeNode2(json.start, json.end, json.step);
        };
        RangeNode2.prototype.toHTML = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var parens = calculateNecessaryParentheses(this, parenthesis);
          var str;
          var start2 = this.start.toHTML(options);
          if (parens.start) {
            start2 = '<span class="math-parenthesis math-round-parenthesis">(</span>' + start2 + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          str = start2;
          if (this.step) {
            var step = this.step.toHTML(options);
            if (parens.step) {
              step = '<span class="math-parenthesis math-round-parenthesis">(</span>' + step + '<span class="math-parenthesis math-round-parenthesis">)</span>';
            }
            str += '<span class="math-operator math-range-operator">:</span>' + step;
          }
          var end = this.end.toHTML(options);
          if (parens.end) {
            end = '<span class="math-parenthesis math-round-parenthesis">(</span>' + end + '<span class="math-parenthesis math-round-parenthesis">)</span>';
          }
          str += '<span class="math-operator math-range-operator">:</span>' + end;
          return str;
        };
        RangeNode2.prototype._toTex = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var parens = calculateNecessaryParentheses(this, parenthesis);
          var str = this.start.toTex(options);
          if (parens.start) {
            str = "\\left(".concat(str, "\\right)");
          }
          if (this.step) {
            var step = this.step.toTex(options);
            if (parens.step) {
              step = "\\left(".concat(step, "\\right)");
            }
            str += ":" + step;
          }
          var end = this.end.toTex(options);
          if (parens.end) {
            end = "\\left(".concat(end, "\\right)");
          }
          str += ":" + end;
          return str;
        };
        return RangeNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/RelationalNode.js
  var name38, dependencies37, createRelationalNode;
  var init_RelationalNode = __esm({
    "node_modules/mathjs/es/expression/node/RelationalNode.js"() {
      init_operators();
      init_string();
      init_customs();
      init_latex();
      init_factory();
      name38 = "RelationalNode";
      dependencies37 = ["Node"];
      createRelationalNode = /* @__PURE__ */ factory(name38, dependencies37, function(_ref) {
        var Node3 = _ref.Node;
        function RelationalNode2(conditionals, params) {
          if (!(this instanceof RelationalNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (!Array.isArray(conditionals))
            throw new TypeError("Parameter conditionals must be an array");
          if (!Array.isArray(params))
            throw new TypeError("Parameter params must be an array");
          if (conditionals.length !== params.length - 1)
            throw new TypeError("Parameter params must contain exactly one more element than parameter conditionals");
          this.conditionals = conditionals;
          this.params = params;
        }
        RelationalNode2.prototype = new Node3();
        RelationalNode2.prototype.type = "RelationalNode";
        RelationalNode2.prototype.isRelationalNode = true;
        RelationalNode2.prototype._compile = function(math2, argNames) {
          var self2 = this;
          var compiled = this.params.map(function(p3) {
            return p3._compile(math2, argNames);
          });
          return function evalRelationalNode(scope, args, context) {
            var evalLhs;
            var evalRhs = compiled[0](scope, args, context);
            for (var i3 = 0; i3 < self2.conditionals.length; i3++) {
              evalLhs = evalRhs;
              evalRhs = compiled[i3 + 1](scope, args, context);
              var condFn = getSafeProperty(math2, self2.conditionals[i3]);
              if (!condFn(evalLhs, evalRhs)) {
                return false;
              }
            }
            return true;
          };
        };
        RelationalNode2.prototype.forEach = function(callback) {
          var _this = this;
          this.params.forEach(function(n3, i3) {
            return callback(n3, "params[" + i3 + "]", _this);
          }, this);
        };
        RelationalNode2.prototype.map = function(callback) {
          var _this2 = this;
          return new RelationalNode2(this.conditionals.slice(), this.params.map(function(n3, i3) {
            return _this2._ifNode(callback(n3, "params[" + i3 + "]", _this2));
          }, this));
        };
        RelationalNode2.prototype.clone = function() {
          return new RelationalNode2(this.conditionals, this.params);
        };
        RelationalNode2.prototype._toString = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var precedence = getPrecedence(this, parenthesis);
          var paramStrings = this.params.map(function(p3, index2) {
            var paramPrecedence = getPrecedence(p3, parenthesis);
            return parenthesis === "all" || paramPrecedence !== null && paramPrecedence <= precedence ? "(" + p3.toString(options) + ")" : p3.toString(options);
          });
          var operatorMap = {
            equal: "==",
            unequal: "!=",
            smaller: "<",
            larger: ">",
            smallerEq: "<=",
            largerEq: ">="
          };
          var ret = paramStrings[0];
          for (var i3 = 0; i3 < this.conditionals.length; i3++) {
            ret += " " + operatorMap[this.conditionals[i3]] + " " + paramStrings[i3 + 1];
          }
          return ret;
        };
        RelationalNode2.prototype.toJSON = function() {
          return {
            mathjs: "RelationalNode",
            conditionals: this.conditionals,
            params: this.params
          };
        };
        RelationalNode2.fromJSON = function(json) {
          return new RelationalNode2(json.conditionals, json.params);
        };
        RelationalNode2.prototype.toHTML = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var precedence = getPrecedence(this, parenthesis);
          var paramStrings = this.params.map(function(p3, index2) {
            var paramPrecedence = getPrecedence(p3, parenthesis);
            return parenthesis === "all" || paramPrecedence !== null && paramPrecedence <= precedence ? '<span class="math-parenthesis math-round-parenthesis">(</span>' + p3.toHTML(options) + '<span class="math-parenthesis math-round-parenthesis">)</span>' : p3.toHTML(options);
          });
          var operatorMap = {
            equal: "==",
            unequal: "!=",
            smaller: "<",
            larger: ">",
            smallerEq: "<=",
            largerEq: ">="
          };
          var ret = paramStrings[0];
          for (var i3 = 0; i3 < this.conditionals.length; i3++) {
            ret += '<span class="math-operator math-binary-operator math-explicit-binary-operator">' + escape(operatorMap[this.conditionals[i3]]) + "</span>" + paramStrings[i3 + 1];
          }
          return ret;
        };
        RelationalNode2.prototype._toTex = function(options) {
          var parenthesis = options && options.parenthesis ? options.parenthesis : "keep";
          var precedence = getPrecedence(this, parenthesis);
          var paramStrings = this.params.map(function(p3, index2) {
            var paramPrecedence = getPrecedence(p3, parenthesis);
            return parenthesis === "all" || paramPrecedence !== null && paramPrecedence <= precedence ? "\\left(" + p3.toTex(options) + "\right)" : p3.toTex(options);
          });
          var ret = paramStrings[0];
          for (var i3 = 0; i3 < this.conditionals.length; i3++) {
            ret += latexOperators[this.conditionals[i3]] + paramStrings[i3 + 1];
          }
          return ret;
        };
        return RelationalNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/SymbolNode.js
  var name39, dependencies38, createSymbolNode;
  var init_SymbolNode = __esm({
    "node_modules/mathjs/es/expression/node/SymbolNode.js"() {
      init_string();
      init_customs();
      init_factory();
      init_latex();
      name39 = "SymbolNode";
      dependencies38 = ["math", "?Unit", "Node"];
      createSymbolNode = /* @__PURE__ */ factory(name39, dependencies38, function(_ref) {
        var math2 = _ref.math, Unit = _ref.Unit, Node3 = _ref.Node;
        function isValuelessUnit(name106) {
          return Unit ? Unit.isValuelessUnit(name106) : false;
        }
        function SymbolNode2(name106) {
          if (!(this instanceof SymbolNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (typeof name106 !== "string")
            throw new TypeError('String expected for parameter "name"');
          this.name = name106;
        }
        SymbolNode2.prototype = new Node3();
        SymbolNode2.prototype.type = "SymbolNode";
        SymbolNode2.prototype.isSymbolNode = true;
        SymbolNode2.prototype._compile = function(math3, argNames) {
          var name106 = this.name;
          if (argNames[name106] === true) {
            return function(scope, args, context) {
              return args[name106];
            };
          } else if (name106 in math3) {
            return function(scope, args, context) {
              return name106 in scope ? getSafeProperty(scope, name106) : getSafeProperty(math3, name106);
            };
          } else {
            var isUnit2 = isValuelessUnit(name106);
            return function(scope, args, context) {
              return name106 in scope ? getSafeProperty(scope, name106) : isUnit2 ? new Unit(null, name106) : undef(name106);
            };
          }
        };
        SymbolNode2.prototype.forEach = function(callback) {
        };
        SymbolNode2.prototype.map = function(callback) {
          return this.clone();
        };
        function undef(name106) {
          throw new Error("Undefined symbol " + name106);
        }
        SymbolNode2.prototype.clone = function() {
          return new SymbolNode2(this.name);
        };
        SymbolNode2.prototype._toString = function(options) {
          return this.name;
        };
        SymbolNode2.prototype.toHTML = function(options) {
          var name106 = escape(this.name);
          if (name106 === "true" || name106 === "false") {
            return '<span class="math-symbol math-boolean">' + name106 + "</span>";
          } else if (name106 === "i") {
            return '<span class="math-symbol math-imaginary-symbol">' + name106 + "</span>";
          } else if (name106 === "Infinity") {
            return '<span class="math-symbol math-infinity-symbol">' + name106 + "</span>";
          } else if (name106 === "NaN") {
            return '<span class="math-symbol math-nan-symbol">' + name106 + "</span>";
          } else if (name106 === "null") {
            return '<span class="math-symbol math-null-symbol">' + name106 + "</span>";
          } else if (name106 === "undefined") {
            return '<span class="math-symbol math-undefined-symbol">' + name106 + "</span>";
          }
          return '<span class="math-symbol">' + name106 + "</span>";
        };
        SymbolNode2.prototype.toJSON = function() {
          return {
            mathjs: "SymbolNode",
            name: this.name
          };
        };
        SymbolNode2.fromJSON = function(json) {
          return new SymbolNode2(json.name);
        };
        SymbolNode2.prototype._toTex = function(options) {
          var isUnit2 = false;
          if (typeof math2[this.name] === "undefined" && isValuelessUnit(this.name)) {
            isUnit2 = true;
          }
          var symbol = toSymbol(this.name, isUnit2);
          if (symbol[0] === "\\") {
            return symbol;
          }
          return " " + symbol;
        };
        return SymbolNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/node/FunctionNode.js
  function _typeof11(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof11 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof11 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof11(obj);
  }
  function _extends2() {
    _extends2 = Object.assign || function(target) {
      for (var i3 = 1; i3 < arguments.length; i3++) {
        var source = arguments[i3];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends2.apply(this, arguments);
  }
  var name40, dependencies39, createFunctionNode;
  var init_FunctionNode = __esm({
    "node_modules/mathjs/es/expression/node/FunctionNode.js"() {
      init_is();
      init_string();
      init_object();
      init_array();
      init_customs();
      init_factory();
      init_latex();
      name40 = "FunctionNode";
      dependencies39 = ["math", "Node", "SymbolNode"];
      createFunctionNode = /* @__PURE__ */ factory(name40, dependencies39, function(_ref) {
        var math2 = _ref.math, Node3 = _ref.Node, SymbolNode2 = _ref.SymbolNode;
        function FunctionNode2(fn, args) {
          if (!(this instanceof FunctionNode2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          if (typeof fn === "string") {
            fn = new SymbolNode2(fn);
          }
          if (!isNode(fn))
            throw new TypeError('Node expected as parameter "fn"');
          if (!Array.isArray(args) || !args.every(isNode)) {
            throw new TypeError('Array containing Nodes expected for parameter "args"');
          }
          this.fn = fn;
          this.args = args || [];
          Object.defineProperty(this, "name", {
            get: function() {
              return this.fn.name || "";
            }.bind(this),
            set: function set() {
              throw new Error("Cannot assign a new name, name is read-only");
            }
          });
        }
        FunctionNode2.prototype = new Node3();
        FunctionNode2.prototype.type = "FunctionNode";
        FunctionNode2.prototype.isFunctionNode = true;
        FunctionNode2.prototype._compile = function(math3, argNames) {
          if (!(this instanceof FunctionNode2)) {
            throw new TypeError("No valid FunctionNode");
          }
          var evalArgs = map(this.args, function(arg) {
            return arg._compile(math3, argNames);
          });
          if (isSymbolNode(this.fn)) {
            var _name = this.fn.name;
            var fn = _name in math3 ? getSafeProperty(math3, _name) : void 0;
            var isRaw = typeof fn === "function" && fn.rawArgs === true;
            if (isRaw) {
              var rawArgs = this.args;
              return function evalFunctionNode(scope, args, context) {
                return (_name in scope ? getSafeProperty(scope, _name) : fn)(rawArgs, math3, _extends2({}, scope, args));
              };
            } else {
              if (evalArgs.length === 1) {
                var evalArg0 = evalArgs[0];
                return function evalFunctionNode(scope, args, context) {
                  return (_name in scope ? getSafeProperty(scope, _name) : fn)(evalArg0(scope, args, context));
                };
              } else if (evalArgs.length === 2) {
                var _evalArg = evalArgs[0];
                var evalArg1 = evalArgs[1];
                return function evalFunctionNode(scope, args, context) {
                  return (_name in scope ? getSafeProperty(scope, _name) : fn)(_evalArg(scope, args, context), evalArg1(scope, args, context));
                };
              } else {
                return function evalFunctionNode(scope, args, context) {
                  return (_name in scope ? getSafeProperty(scope, _name) : fn).apply(null, map(evalArgs, function(evalArg) {
                    return evalArg(scope, args, context);
                  }));
                };
              }
            }
          } else if (isAccessorNode(this.fn) && isIndexNode(this.fn.index) && this.fn.index.isObjectProperty()) {
            var evalObject = this.fn.object._compile(math3, argNames);
            var prop = this.fn.index.getObjectProperty();
            var _rawArgs = this.args;
            return function evalFunctionNode(scope, args, context) {
              var object = evalObject(scope, args, context);
              validateSafeMethod(object, prop);
              var isRaw2 = object[prop] && object[prop].rawArgs;
              return isRaw2 ? object[prop](_rawArgs, math3, _extends2({}, scope, args)) : object[prop].apply(object, map(evalArgs, function(evalArg) {
                return evalArg(scope, args, context);
              }));
            };
          } else {
            var evalFn = this.fn._compile(math3, argNames);
            var _rawArgs2 = this.args;
            return function evalFunctionNode(scope, args, context) {
              var fn2 = evalFn(scope, args, context);
              var isRaw2 = fn2 && fn2.rawArgs;
              return isRaw2 ? fn2(_rawArgs2, math3, _extends2({}, scope, args)) : fn2.apply(fn2, map(evalArgs, function(evalArg) {
                return evalArg(scope, args, context);
              }));
            };
          }
        };
        FunctionNode2.prototype.forEach = function(callback) {
          callback(this.fn, "fn", this);
          for (var i3 = 0; i3 < this.args.length; i3++) {
            callback(this.args[i3], "args[" + i3 + "]", this);
          }
        };
        FunctionNode2.prototype.map = function(callback) {
          var fn = this._ifNode(callback(this.fn, "fn", this));
          var args = [];
          for (var i3 = 0; i3 < this.args.length; i3++) {
            args[i3] = this._ifNode(callback(this.args[i3], "args[" + i3 + "]", this));
          }
          return new FunctionNode2(fn, args);
        };
        FunctionNode2.prototype.clone = function() {
          return new FunctionNode2(this.fn, this.args.slice(0));
        };
        var nodeToString = FunctionNode2.prototype.toString;
        FunctionNode2.prototype.toString = function(options) {
          var customString;
          var name106 = this.fn.toString(options);
          if (options && _typeof11(options.handler) === "object" && hasOwnProperty2(options.handler, name106)) {
            customString = options.handler[name106](this, options);
          }
          if (typeof customString !== "undefined") {
            return customString;
          }
          return nodeToString.call(this, options);
        };
        FunctionNode2.prototype._toString = function(options) {
          var args = this.args.map(function(arg) {
            return arg.toString(options);
          });
          var fn = isFunctionAssignmentNode(this.fn) ? "(" + this.fn.toString(options) + ")" : this.fn.toString(options);
          return fn + "(" + args.join(", ") + ")";
        };
        FunctionNode2.prototype.toJSON = function() {
          return {
            mathjs: "FunctionNode",
            fn: this.fn,
            args: this.args
          };
        };
        FunctionNode2.fromJSON = function(json) {
          return new FunctionNode2(json.fn, json.args);
        };
        FunctionNode2.prototype.toHTML = function(options) {
          var args = this.args.map(function(arg) {
            return arg.toHTML(options);
          });
          return '<span class="math-function">' + escape(this.fn) + '</span><span class="math-paranthesis math-round-parenthesis">(</span>' + args.join('<span class="math-separator">,</span>') + '<span class="math-paranthesis math-round-parenthesis">)</span>';
        };
        function expandTemplate(template, node, options) {
          var latex = "";
          var regex = new RegExp("\\$(?:\\{([a-z_][a-z_0-9]*)(?:\\[([0-9]+)\\])?\\}|\\$)", "ig");
          var inputPos = 0;
          var match;
          while ((match = regex.exec(template)) !== null) {
            latex += template.substring(inputPos, match.index);
            inputPos = match.index;
            if (match[0] === "$$") {
              latex += "$";
              inputPos++;
            } else {
              inputPos += match[0].length;
              var property = node[match[1]];
              if (!property) {
                throw new ReferenceError("Template: Property " + match[1] + " does not exist.");
              }
              if (match[2] === void 0) {
                switch (_typeof11(property)) {
                  case "string":
                    latex += property;
                    break;
                  case "object":
                    if (isNode(property)) {
                      latex += property.toTex(options);
                    } else if (Array.isArray(property)) {
                      latex += property.map(function(arg, index2) {
                        if (isNode(arg)) {
                          return arg.toTex(options);
                        }
                        throw new TypeError("Template: " + match[1] + "[" + index2 + "] is not a Node.");
                      }).join(",");
                    } else {
                      throw new TypeError("Template: " + match[1] + " has to be a Node, String or array of Nodes");
                    }
                    break;
                  default:
                    throw new TypeError("Template: " + match[1] + " has to be a Node, String or array of Nodes");
                }
              } else {
                if (isNode(property[match[2]] && property[match[2]])) {
                  latex += property[match[2]].toTex(options);
                } else {
                  throw new TypeError("Template: " + match[1] + "[" + match[2] + "] is not a Node.");
                }
              }
            }
          }
          latex += template.slice(inputPos);
          return latex;
        }
        var nodeToTex = FunctionNode2.prototype.toTex;
        FunctionNode2.prototype.toTex = function(options) {
          var customTex;
          if (options && _typeof11(options.handler) === "object" && hasOwnProperty2(options.handler, this.name)) {
            customTex = options.handler[this.name](this, options);
          }
          if (typeof customTex !== "undefined") {
            return customTex;
          }
          return nodeToTex.call(this, options);
        };
        FunctionNode2.prototype._toTex = function(options) {
          var args = this.args.map(function(arg) {
            return arg.toTex(options);
          });
          var latexConverter;
          if (latexFunctions[this.name]) {
            latexConverter = latexFunctions[this.name];
          }
          if (math2[this.name] && (typeof math2[this.name].toTex === "function" || _typeof11(math2[this.name].toTex) === "object" || typeof math2[this.name].toTex === "string")) {
            latexConverter = math2[this.name].toTex;
          }
          var customToTex;
          switch (_typeof11(latexConverter)) {
            case "function":
              customToTex = latexConverter(this, options);
              break;
            case "string":
              customToTex = expandTemplate(latexConverter, this, options);
              break;
            case "object":
              switch (_typeof11(latexConverter[args.length])) {
                case "function":
                  customToTex = latexConverter[args.length](this, options);
                  break;
                case "string":
                  customToTex = expandTemplate(latexConverter[args.length], this, options);
                  break;
              }
          }
          if (typeof customToTex !== "undefined") {
            return customToTex;
          }
          return expandTemplate(defaultTemplate, this, options);
        };
        FunctionNode2.prototype.getIdentifier = function() {
          return this.type + ":" + this.name;
        };
        return FunctionNode2;
      }, {
        isClass: true,
        isNode: true
      });
    }
  });

  // node_modules/mathjs/es/expression/parse.js
  function _extends3() {
    _extends3 = Object.assign || function(target) {
      for (var i3 = 1; i3 < arguments.length; i3++) {
        var source = arguments[i3];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends3.apply(this, arguments);
  }
  var name41, dependencies40, createParse;
  var init_parse = __esm({
    "node_modules/mathjs/es/expression/parse.js"() {
      init_factory();
      init_is();
      init_collection();
      init_object();
      name41 = "parse";
      dependencies40 = ["typed", "numeric", "config", "AccessorNode", "ArrayNode", "AssignmentNode", "BlockNode", "ConditionalNode", "ConstantNode", "FunctionAssignmentNode", "FunctionNode", "IndexNode", "ObjectNode", "OperatorNode", "ParenthesisNode", "RangeNode", "RelationalNode", "SymbolNode"];
      createParse = /* @__PURE__ */ factory(name41, dependencies40, function(_ref) {
        var typed2 = _ref.typed, numeric3 = _ref.numeric, config3 = _ref.config, AccessorNode2 = _ref.AccessorNode, ArrayNode2 = _ref.ArrayNode, AssignmentNode2 = _ref.AssignmentNode, BlockNode2 = _ref.BlockNode, ConditionalNode2 = _ref.ConditionalNode, ConstantNode2 = _ref.ConstantNode, FunctionAssignmentNode2 = _ref.FunctionAssignmentNode, FunctionNode2 = _ref.FunctionNode, IndexNode2 = _ref.IndexNode, ObjectNode2 = _ref.ObjectNode, OperatorNode2 = _ref.OperatorNode, ParenthesisNode2 = _ref.ParenthesisNode, RangeNode2 = _ref.RangeNode, RelationalNode2 = _ref.RelationalNode, SymbolNode2 = _ref.SymbolNode;
        var parse2 = typed2(name41, {
          string: function string2(expression) {
            return parseStart(expression, {});
          },
          "Array | Matrix": function ArrayMatrix(expressions) {
            return parseMultiple(expressions, {});
          },
          "string, Object": function stringObject(expression, options) {
            var extraNodes = options.nodes !== void 0 ? options.nodes : {};
            return parseStart(expression, extraNodes);
          },
          "Array | Matrix, Object": parseMultiple
        });
        function parseMultiple(expressions) {
          var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
          var extraNodes = options.nodes !== void 0 ? options.nodes : {};
          return deepMap(expressions, function(elem) {
            if (typeof elem !== "string")
              throw new TypeError("String expected");
            return parseStart(elem, extraNodes);
          });
        }
        var TOKENTYPE = {
          NULL: 0,
          DELIMITER: 1,
          NUMBER: 2,
          SYMBOL: 3,
          UNKNOWN: 4
        };
        var DELIMITERS = {
          ",": true,
          "(": true,
          ")": true,
          "[": true,
          "]": true,
          "{": true,
          "}": true,
          '"': true,
          "'": true,
          ";": true,
          "+": true,
          "-": true,
          "*": true,
          ".*": true,
          "/": true,
          "./": true,
          "%": true,
          "^": true,
          ".^": true,
          "~": true,
          "!": true,
          "&": true,
          "|": true,
          "^|": true,
          "=": true,
          ":": true,
          "?": true,
          "==": true,
          "!=": true,
          "<": true,
          ">": true,
          "<=": true,
          ">=": true,
          "<<": true,
          ">>": true,
          ">>>": true
        };
        var NAMED_DELIMITERS = {
          mod: true,
          to: true,
          "in": true,
          and: true,
          xor: true,
          or: true,
          not: true
        };
        var CONSTANTS = {
          "true": true,
          "false": false,
          "null": null,
          undefined: void 0
        };
        var NUMERIC_CONSTANTS = ["NaN", "Infinity"];
        function initialState() {
          return {
            extraNodes: {},
            expression: "",
            comment: "",
            index: 0,
            token: "",
            tokenType: TOKENTYPE.NULL,
            nestingLevel: 0,
            conditionalLevel: null
          };
        }
        function currentString(state, length) {
          return state.expression.substr(state.index, length);
        }
        function currentCharacter(state) {
          return currentString(state, 1);
        }
        function next(state) {
          state.index++;
        }
        function prevCharacter(state) {
          return state.expression.charAt(state.index - 1);
        }
        function nextCharacter(state) {
          return state.expression.charAt(state.index + 1);
        }
        function getToken(state) {
          state.tokenType = TOKENTYPE.NULL;
          state.token = "";
          state.comment = "";
          while (parse2.isWhitespace(currentCharacter(state), state.nestingLevel)) {
            next(state);
          }
          if (currentCharacter(state) === "#") {
            while (currentCharacter(state) !== "\n" && currentCharacter(state) !== "") {
              state.comment += currentCharacter(state);
              next(state);
            }
          }
          if (currentCharacter(state) === "") {
            state.tokenType = TOKENTYPE.DELIMITER;
            return;
          }
          if (currentCharacter(state) === "\n" && !state.nestingLevel) {
            state.tokenType = TOKENTYPE.DELIMITER;
            state.token = currentCharacter(state);
            next(state);
            return;
          }
          var c1 = currentCharacter(state);
          var c22 = currentString(state, 2);
          var c3 = currentString(state, 3);
          if (c3.length === 3 && DELIMITERS[c3]) {
            state.tokenType = TOKENTYPE.DELIMITER;
            state.token = c3;
            next(state);
            next(state);
            next(state);
            return;
          }
          if (c22.length === 2 && DELIMITERS[c22]) {
            state.tokenType = TOKENTYPE.DELIMITER;
            state.token = c22;
            next(state);
            next(state);
            return;
          }
          if (DELIMITERS[c1]) {
            state.tokenType = TOKENTYPE.DELIMITER;
            state.token = c1;
            next(state);
            return;
          }
          if (parse2.isDigitDot(c1)) {
            state.tokenType = TOKENTYPE.NUMBER;
            var _c = currentString(state, 2);
            if (_c === "0b" || _c === "0o" || _c === "0x") {
              state.token += currentCharacter(state);
              next(state);
              state.token += currentCharacter(state);
              next(state);
              while (parse2.isHexDigit(currentCharacter(state))) {
                state.token += currentCharacter(state);
                next(state);
              }
              return;
            }
            if (currentCharacter(state) === ".") {
              state.token += currentCharacter(state);
              next(state);
              if (!parse2.isDigit(currentCharacter(state))) {
                state.tokenType = TOKENTYPE.DELIMITER;
              }
            } else {
              while (parse2.isDigit(currentCharacter(state))) {
                state.token += currentCharacter(state);
                next(state);
              }
              if (parse2.isDecimalMark(currentCharacter(state), nextCharacter(state))) {
                state.token += currentCharacter(state);
                next(state);
              }
            }
            while (parse2.isDigit(currentCharacter(state))) {
              state.token += currentCharacter(state);
              next(state);
            }
            if (currentCharacter(state) === "E" || currentCharacter(state) === "e") {
              if (parse2.isDigit(nextCharacter(state)) || nextCharacter(state) === "-" || nextCharacter(state) === "+") {
                state.token += currentCharacter(state);
                next(state);
                if (currentCharacter(state) === "+" || currentCharacter(state) === "-") {
                  state.token += currentCharacter(state);
                  next(state);
                }
                if (!parse2.isDigit(currentCharacter(state))) {
                  throw createSyntaxError(state, 'Digit expected, got "' + currentCharacter(state) + '"');
                }
                while (parse2.isDigit(currentCharacter(state))) {
                  state.token += currentCharacter(state);
                  next(state);
                }
                if (parse2.isDecimalMark(currentCharacter(state), nextCharacter(state))) {
                  throw createSyntaxError(state, 'Digit expected, got "' + currentCharacter(state) + '"');
                }
              } else if (nextCharacter(state) === ".") {
                next(state);
                throw createSyntaxError(state, 'Digit expected, got "' + currentCharacter(state) + '"');
              }
            }
            return;
          }
          if (parse2.isAlpha(currentCharacter(state), prevCharacter(state), nextCharacter(state))) {
            while (parse2.isAlpha(currentCharacter(state), prevCharacter(state), nextCharacter(state)) || parse2.isDigit(currentCharacter(state))) {
              state.token += currentCharacter(state);
              next(state);
            }
            if (hasOwnProperty2(NAMED_DELIMITERS, state.token)) {
              state.tokenType = TOKENTYPE.DELIMITER;
            } else {
              state.tokenType = TOKENTYPE.SYMBOL;
            }
            return;
          }
          state.tokenType = TOKENTYPE.UNKNOWN;
          while (currentCharacter(state) !== "") {
            state.token += currentCharacter(state);
            next(state);
          }
          throw createSyntaxError(state, 'Syntax error in part "' + state.token + '"');
        }
        function getTokenSkipNewline(state) {
          do {
            getToken(state);
          } while (state.token === "\n");
        }
        function openParams(state) {
          state.nestingLevel++;
        }
        function closeParams(state) {
          state.nestingLevel--;
        }
        parse2.isAlpha = function isAlpha(c3, cPrev, cNext) {
          return parse2.isValidLatinOrGreek(c3) || parse2.isValidMathSymbol(c3, cNext) || parse2.isValidMathSymbol(cPrev, c3);
        };
        parse2.isValidLatinOrGreek = function isValidLatinOrGreek(c3) {
          return /^[a-zA-Z_$\u00C0-\u02AF\u0370-\u03FF\u2100-\u214F]$/.test(c3);
        };
        parse2.isValidMathSymbol = function isValidMathSymbol(high, low) {
          return /^[\uD835]$/.test(high) && /^[\uDC00-\uDFFF]$/.test(low) && /^[^\uDC55\uDC9D\uDCA0\uDCA1\uDCA3\uDCA4\uDCA7\uDCA8\uDCAD\uDCBA\uDCBC\uDCC4\uDD06\uDD0B\uDD0C\uDD15\uDD1D\uDD3A\uDD3F\uDD45\uDD47-\uDD49\uDD51\uDEA6\uDEA7\uDFCC\uDFCD]$/.test(low);
        };
        parse2.isWhitespace = function isWhitespace(c3, nestingLevel) {
          return c3 === " " || c3 === "	" || c3 === "\n" && nestingLevel > 0;
        };
        parse2.isDecimalMark = function isDecimalMark(c3, cNext) {
          return c3 === "." && cNext !== "/" && cNext !== "*" && cNext !== "^";
        };
        parse2.isDigitDot = function isDigitDot(c3) {
          return c3 >= "0" && c3 <= "9" || c3 === ".";
        };
        parse2.isDigit = function isDigit(c3) {
          return c3 >= "0" && c3 <= "9";
        };
        parse2.isHexDigit = function isHexDigit(c3) {
          return c3 >= "0" && c3 <= "9" || c3 >= "a" && c3 <= "f" || c3 >= "A" && c3 <= "F";
        };
        function parseStart(expression, extraNodes) {
          var state = initialState();
          _extends3(state, {
            expression,
            extraNodes
          });
          getToken(state);
          var node = parseBlock(state);
          if (state.token !== "") {
            if (state.tokenType === TOKENTYPE.DELIMITER) {
              throw createError(state, "Unexpected operator " + state.token);
            } else {
              throw createSyntaxError(state, 'Unexpected part "' + state.token + '"');
            }
          }
          return node;
        }
        function parseBlock(state) {
          var node;
          var blocks = [];
          var visible;
          if (state.token !== "" && state.token !== "\n" && state.token !== ";") {
            node = parseAssignment(state);
            node.comment = state.comment;
          }
          while (state.token === "\n" || state.token === ";") {
            if (blocks.length === 0 && node) {
              visible = state.token !== ";";
              blocks.push({
                node,
                visible
              });
            }
            getToken(state);
            if (state.token !== "\n" && state.token !== ";" && state.token !== "") {
              node = parseAssignment(state);
              node.comment = state.comment;
              visible = state.token !== ";";
              blocks.push({
                node,
                visible
              });
            }
          }
          if (blocks.length > 0) {
            return new BlockNode2(blocks);
          } else {
            if (!node) {
              node = new ConstantNode2(void 0);
              node.comment = state.comment;
            }
            return node;
          }
        }
        function parseAssignment(state) {
          var name106, args, value, valid;
          var node = parseConditional(state);
          if (state.token === "=") {
            if (isSymbolNode(node)) {
              name106 = node.name;
              getTokenSkipNewline(state);
              value = parseAssignment(state);
              return new AssignmentNode2(new SymbolNode2(name106), value);
            } else if (isAccessorNode(node)) {
              getTokenSkipNewline(state);
              value = parseAssignment(state);
              return new AssignmentNode2(node.object, node.index, value);
            } else if (isFunctionNode(node) && isSymbolNode(node.fn)) {
              valid = true;
              args = [];
              name106 = node.name;
              node.args.forEach(function(arg, index2) {
                if (isSymbolNode(arg)) {
                  args[index2] = arg.name;
                } else {
                  valid = false;
                }
              });
              if (valid) {
                getTokenSkipNewline(state);
                value = parseAssignment(state);
                return new FunctionAssignmentNode2(name106, args, value);
              }
            }
            throw createSyntaxError(state, "Invalid left hand side of assignment operator =");
          }
          return node;
        }
        function parseConditional(state) {
          var node = parseLogicalOr(state);
          while (state.token === "?") {
            var prev = state.conditionalLevel;
            state.conditionalLevel = state.nestingLevel;
            getTokenSkipNewline(state);
            var condition = node;
            var trueExpr = parseAssignment(state);
            if (state.token !== ":")
              throw createSyntaxError(state, "False part of conditional expression expected");
            state.conditionalLevel = null;
            getTokenSkipNewline(state);
            var falseExpr = parseAssignment(state);
            node = new ConditionalNode2(condition, trueExpr, falseExpr);
            state.conditionalLevel = prev;
          }
          return node;
        }
        function parseLogicalOr(state) {
          var node = parseLogicalXor(state);
          while (state.token === "or") {
            getTokenSkipNewline(state);
            node = new OperatorNode2("or", "or", [node, parseLogicalXor(state)]);
          }
          return node;
        }
        function parseLogicalXor(state) {
          var node = parseLogicalAnd(state);
          while (state.token === "xor") {
            getTokenSkipNewline(state);
            node = new OperatorNode2("xor", "xor", [node, parseLogicalAnd(state)]);
          }
          return node;
        }
        function parseLogicalAnd(state) {
          var node = parseBitwiseOr(state);
          while (state.token === "and") {
            getTokenSkipNewline(state);
            node = new OperatorNode2("and", "and", [node, parseBitwiseOr(state)]);
          }
          return node;
        }
        function parseBitwiseOr(state) {
          var node = parseBitwiseXor(state);
          while (state.token === "|") {
            getTokenSkipNewline(state);
            node = new OperatorNode2("|", "bitOr", [node, parseBitwiseXor(state)]);
          }
          return node;
        }
        function parseBitwiseXor(state) {
          var node = parseBitwiseAnd(state);
          while (state.token === "^|") {
            getTokenSkipNewline(state);
            node = new OperatorNode2("^|", "bitXor", [node, parseBitwiseAnd(state)]);
          }
          return node;
        }
        function parseBitwiseAnd(state) {
          var node = parseRelational(state);
          while (state.token === "&") {
            getTokenSkipNewline(state);
            node = new OperatorNode2("&", "bitAnd", [node, parseRelational(state)]);
          }
          return node;
        }
        function parseRelational(state) {
          var params = [parseShift(state)];
          var conditionals = [];
          var operators = {
            "==": "equal",
            "!=": "unequal",
            "<": "smaller",
            ">": "larger",
            "<=": "smallerEq",
            ">=": "largerEq"
          };
          while (hasOwnProperty2(operators, state.token)) {
            var cond = {
              name: state.token,
              fn: operators[state.token]
            };
            conditionals.push(cond);
            getTokenSkipNewline(state);
            params.push(parseShift(state));
          }
          if (params.length === 1) {
            return params[0];
          } else if (params.length === 2) {
            return new OperatorNode2(conditionals[0].name, conditionals[0].fn, params);
          } else {
            return new RelationalNode2(conditionals.map(function(c3) {
              return c3.fn;
            }), params);
          }
        }
        function parseShift(state) {
          var node, name106, fn, params;
          node = parseConversion(state);
          var operators = {
            "<<": "leftShift",
            ">>": "rightArithShift",
            ">>>": "rightLogShift"
          };
          while (hasOwnProperty2(operators, state.token)) {
            name106 = state.token;
            fn = operators[name106];
            getTokenSkipNewline(state);
            params = [node, parseConversion(state)];
            node = new OperatorNode2(name106, fn, params);
          }
          return node;
        }
        function parseConversion(state) {
          var node, name106, fn, params;
          node = parseRange(state);
          var operators = {
            to: "to",
            "in": "to"
          };
          while (hasOwnProperty2(operators, state.token)) {
            name106 = state.token;
            fn = operators[name106];
            getTokenSkipNewline(state);
            if (name106 === "in" && state.token === "") {
              node = new OperatorNode2("*", "multiply", [node, new SymbolNode2("in")], true);
            } else {
              params = [node, parseRange(state)];
              node = new OperatorNode2(name106, fn, params);
            }
          }
          return node;
        }
        function parseRange(state) {
          var node;
          var params = [];
          if (state.token === ":") {
            node = new ConstantNode2(1);
          } else {
            node = parseAddSubtract(state);
          }
          if (state.token === ":" && state.conditionalLevel !== state.nestingLevel) {
            params.push(node);
            while (state.token === ":" && params.length < 3) {
              getTokenSkipNewline(state);
              if (state.token === ")" || state.token === "]" || state.token === "," || state.token === "") {
                params.push(new SymbolNode2("end"));
              } else {
                params.push(parseAddSubtract(state));
              }
            }
            if (params.length === 3) {
              node = new RangeNode2(params[0], params[2], params[1]);
            } else {
              node = new RangeNode2(params[0], params[1]);
            }
          }
          return node;
        }
        function parseAddSubtract(state) {
          var node, name106, fn, params;
          node = parseMultiplyDivide(state);
          var operators = {
            "+": "add",
            "-": "subtract"
          };
          while (hasOwnProperty2(operators, state.token)) {
            name106 = state.token;
            fn = operators[name106];
            getTokenSkipNewline(state);
            params = [node, parseMultiplyDivide(state)];
            node = new OperatorNode2(name106, fn, params);
          }
          return node;
        }
        function parseMultiplyDivide(state) {
          var node, last, name106, fn;
          node = parseImplicitMultiplication(state);
          last = node;
          var operators = {
            "*": "multiply",
            ".*": "dotMultiply",
            "/": "divide",
            "./": "dotDivide",
            "%": "mod",
            mod: "mod"
          };
          while (true) {
            if (hasOwnProperty2(operators, state.token)) {
              name106 = state.token;
              fn = operators[name106];
              getTokenSkipNewline(state);
              last = parseImplicitMultiplication(state);
              node = new OperatorNode2(name106, fn, [node, last]);
            } else {
              break;
            }
          }
          return node;
        }
        function parseImplicitMultiplication(state) {
          var node, last;
          node = parseRule2(state);
          last = node;
          while (true) {
            if (state.tokenType === TOKENTYPE.SYMBOL || state.token === "in" && isConstantNode(node) || state.tokenType === TOKENTYPE.NUMBER && !isConstantNode(last) && (!isOperatorNode(last) || last.op === "!") || state.token === "(") {
              last = parseRule2(state);
              node = new OperatorNode2("*", "multiply", [node, last], true);
            } else {
              break;
            }
          }
          return node;
        }
        function parseRule2(state) {
          var node = parseUnary(state);
          var last = node;
          var tokenStates = [];
          while (true) {
            if (state.token === "/" && isConstantNode(last)) {
              tokenStates.push(_extends3({}, state));
              getTokenSkipNewline(state);
              if (state.tokenType === TOKENTYPE.NUMBER) {
                tokenStates.push(_extends3({}, state));
                getTokenSkipNewline(state);
                if (state.tokenType === TOKENTYPE.SYMBOL || state.token === "(") {
                  _extends3(state, tokenStates.pop());
                  tokenStates.pop();
                  last = parseUnary(state);
                  node = new OperatorNode2("/", "divide", [node, last]);
                } else {
                  tokenStates.pop();
                  _extends3(state, tokenStates.pop());
                  break;
                }
              } else {
                _extends3(state, tokenStates.pop());
                break;
              }
            } else {
              break;
            }
          }
          return node;
        }
        function parseUnary(state) {
          var name106, params, fn;
          var operators = {
            "-": "unaryMinus",
            "+": "unaryPlus",
            "~": "bitNot",
            not: "not"
          };
          if (hasOwnProperty2(operators, state.token)) {
            fn = operators[state.token];
            name106 = state.token;
            getTokenSkipNewline(state);
            params = [parseUnary(state)];
            return new OperatorNode2(name106, fn, params);
          }
          return parsePow(state);
        }
        function parsePow(state) {
          var node, name106, fn, params;
          node = parseLeftHandOperators(state);
          if (state.token === "^" || state.token === ".^") {
            name106 = state.token;
            fn = name106 === "^" ? "pow" : "dotPow";
            getTokenSkipNewline(state);
            params = [node, parseUnary(state)];
            node = new OperatorNode2(name106, fn, params);
          }
          return node;
        }
        function parseLeftHandOperators(state) {
          var node, name106, fn, params;
          node = parseCustomNodes(state);
          var operators = {
            "!": "factorial",
            "'": "ctranspose"
          };
          while (hasOwnProperty2(operators, state.token)) {
            name106 = state.token;
            fn = operators[name106];
            getToken(state);
            params = [node];
            node = new OperatorNode2(name106, fn, params);
            node = parseAccessors(state, node);
          }
          return node;
        }
        function parseCustomNodes(state) {
          var params = [];
          if (state.tokenType === TOKENTYPE.SYMBOL && hasOwnProperty2(state.extraNodes, state.token)) {
            var CustomNode = state.extraNodes[state.token];
            getToken(state);
            if (state.token === "(") {
              params = [];
              openParams(state);
              getToken(state);
              if (state.token !== ")") {
                params.push(parseAssignment(state));
                while (state.token === ",") {
                  getToken(state);
                  params.push(parseAssignment(state));
                }
              }
              if (state.token !== ")") {
                throw createSyntaxError(state, "Parenthesis ) expected");
              }
              closeParams(state);
              getToken(state);
            }
            return new CustomNode(params);
          }
          return parseSymbol(state);
        }
        function parseSymbol(state) {
          var node, name106;
          if (state.tokenType === TOKENTYPE.SYMBOL || state.tokenType === TOKENTYPE.DELIMITER && state.token in NAMED_DELIMITERS) {
            name106 = state.token;
            getToken(state);
            if (hasOwnProperty2(CONSTANTS, name106)) {
              node = new ConstantNode2(CONSTANTS[name106]);
            } else if (NUMERIC_CONSTANTS.indexOf(name106) !== -1) {
              node = new ConstantNode2(numeric3(name106, "number"));
            } else {
              node = new SymbolNode2(name106);
            }
            node = parseAccessors(state, node);
            return node;
          }
          return parseDoubleQuotesString(state);
        }
        function parseAccessors(state, node, types) {
          var params;
          while ((state.token === "(" || state.token === "[" || state.token === ".") && (!types || types.indexOf(state.token) !== -1)) {
            params = [];
            if (state.token === "(") {
              if (isSymbolNode(node) || isAccessorNode(node)) {
                openParams(state);
                getToken(state);
                if (state.token !== ")") {
                  params.push(parseAssignment(state));
                  while (state.token === ",") {
                    getToken(state);
                    params.push(parseAssignment(state));
                  }
                }
                if (state.token !== ")") {
                  throw createSyntaxError(state, "Parenthesis ) expected");
                }
                closeParams(state);
                getToken(state);
                node = new FunctionNode2(node, params);
              } else {
                return node;
              }
            } else if (state.token === "[") {
              openParams(state);
              getToken(state);
              if (state.token !== "]") {
                params.push(parseAssignment(state));
                while (state.token === ",") {
                  getToken(state);
                  params.push(parseAssignment(state));
                }
              }
              if (state.token !== "]") {
                throw createSyntaxError(state, "Parenthesis ] expected");
              }
              closeParams(state);
              getToken(state);
              node = new AccessorNode2(node, new IndexNode2(params));
            } else {
              getToken(state);
              if (state.tokenType !== TOKENTYPE.SYMBOL) {
                throw createSyntaxError(state, "Property name expected after dot");
              }
              params.push(new ConstantNode2(state.token));
              getToken(state);
              var dotNotation = true;
              node = new AccessorNode2(node, new IndexNode2(params, dotNotation));
            }
          }
          return node;
        }
        function parseDoubleQuotesString(state) {
          var node, str;
          if (state.token === '"') {
            str = parseDoubleQuotesStringToken(state);
            node = new ConstantNode2(str);
            node = parseAccessors(state, node);
            return node;
          }
          return parseSingleQuotesString(state);
        }
        function parseDoubleQuotesStringToken(state) {
          var str = "";
          while (currentCharacter(state) !== "" && currentCharacter(state) !== '"') {
            if (currentCharacter(state) === "\\") {
              str += currentCharacter(state);
              next(state);
            }
            str += currentCharacter(state);
            next(state);
          }
          getToken(state);
          if (state.token !== '"') {
            throw createSyntaxError(state, 'End of string " expected');
          }
          getToken(state);
          return JSON.parse('"' + str + '"');
        }
        function parseSingleQuotesString(state) {
          var node, str;
          if (state.token === "'") {
            str = parseSingleQuotesStringToken(state);
            node = new ConstantNode2(str);
            node = parseAccessors(state, node);
            return node;
          }
          return parseMatrix(state);
        }
        function parseSingleQuotesStringToken(state) {
          var str = "";
          while (currentCharacter(state) !== "" && currentCharacter(state) !== "'") {
            if (currentCharacter(state) === "\\") {
              str += currentCharacter(state);
              next(state);
            }
            str += currentCharacter(state);
            next(state);
          }
          getToken(state);
          if (state.token !== "'") {
            throw createSyntaxError(state, "End of string ' expected");
          }
          getToken(state);
          return JSON.parse('"' + str + '"');
        }
        function parseMatrix(state) {
          var array, params, rows, cols;
          if (state.token === "[") {
            openParams(state);
            getToken(state);
            if (state.token !== "]") {
              var row = parseRow(state);
              if (state.token === ";") {
                rows = 1;
                params = [row];
                while (state.token === ";") {
                  getToken(state);
                  params[rows] = parseRow(state);
                  rows++;
                }
                if (state.token !== "]") {
                  throw createSyntaxError(state, "End of matrix ] expected");
                }
                closeParams(state);
                getToken(state);
                cols = params[0].items.length;
                for (var r3 = 1; r3 < rows; r3++) {
                  if (params[r3].items.length !== cols) {
                    throw createError(state, "Column dimensions mismatch (" + params[r3].items.length + " !== " + cols + ")");
                  }
                }
                array = new ArrayNode2(params);
              } else {
                if (state.token !== "]") {
                  throw createSyntaxError(state, "End of matrix ] expected");
                }
                closeParams(state);
                getToken(state);
                array = row;
              }
            } else {
              closeParams(state);
              getToken(state);
              array = new ArrayNode2([]);
            }
            return parseAccessors(state, array);
          }
          return parseObject(state);
        }
        function parseRow(state) {
          var params = [parseAssignment(state)];
          var len = 1;
          while (state.token === ",") {
            getToken(state);
            params[len] = parseAssignment(state);
            len++;
          }
          return new ArrayNode2(params);
        }
        function parseObject(state) {
          if (state.token === "{") {
            openParams(state);
            var key;
            var properties2 = {};
            do {
              getToken(state);
              if (state.token !== "}") {
                if (state.token === '"') {
                  key = parseDoubleQuotesStringToken(state);
                } else if (state.token === "'") {
                  key = parseSingleQuotesStringToken(state);
                } else if (state.tokenType === TOKENTYPE.SYMBOL || state.tokenType === TOKENTYPE.DELIMITER && state.token in NAMED_DELIMITERS) {
                  key = state.token;
                  getToken(state);
                } else {
                  throw createSyntaxError(state, "Symbol or string expected as object key");
                }
                if (state.token !== ":") {
                  throw createSyntaxError(state, "Colon : expected after object key");
                }
                getToken(state);
                properties2[key] = parseAssignment(state);
              }
            } while (state.token === ",");
            if (state.token !== "}") {
              throw createSyntaxError(state, "Comma , or bracket } expected after object value");
            }
            closeParams(state);
            getToken(state);
            var node = new ObjectNode2(properties2);
            node = parseAccessors(state, node);
            return node;
          }
          return parseNumber(state);
        }
        function parseNumber(state) {
          var numberStr;
          if (state.tokenType === TOKENTYPE.NUMBER) {
            numberStr = state.token;
            getToken(state);
            return new ConstantNode2(numeric3(numberStr, config3.number));
          }
          return parseParentheses(state);
        }
        function parseParentheses(state) {
          var node;
          if (state.token === "(") {
            openParams(state);
            getToken(state);
            node = parseAssignment(state);
            if (state.token !== ")") {
              throw createSyntaxError(state, "Parenthesis ) expected");
            }
            closeParams(state);
            getToken(state);
            node = new ParenthesisNode2(node);
            node = parseAccessors(state, node);
            return node;
          }
          return parseEnd(state);
        }
        function parseEnd(state) {
          if (state.token === "") {
            throw createSyntaxError(state, "Unexpected end of expression");
          } else {
            throw createSyntaxError(state, "Value expected");
          }
        }
        function col(state) {
          return state.index - state.token.length + 1;
        }
        function createSyntaxError(state, message) {
          var c3 = col(state);
          var error = new SyntaxError(message + " (char " + c3 + ")");
          error["char"] = c3;
          return error;
        }
        function createError(state, message) {
          var c3 = col(state);
          var error = new SyntaxError(message + " (char " + c3 + ")");
          error["char"] = c3;
          return error;
        }
        return parse2;
      });
    }
  });

  // node_modules/mathjs/es/expression/function/compile.js
  var name42, dependencies41, createCompile;
  var init_compile = __esm({
    "node_modules/mathjs/es/expression/function/compile.js"() {
      init_collection();
      init_factory();
      name42 = "compile";
      dependencies41 = ["typed", "parse"];
      createCompile = /* @__PURE__ */ factory(name42, dependencies41, function(_ref) {
        var typed2 = _ref.typed, parse2 = _ref.parse;
        return typed2(name42, {
          string: function string2(expr) {
            return parse2(expr).compile();
          },
          "Array | Matrix": function ArrayMatrix(expr) {
            return deepMap(expr, function(entry) {
              return parse2(entry).compile();
            });
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/expression/function/evaluate.js
  var name43, dependencies42, createEvaluate;
  var init_evaluate2 = __esm({
    "node_modules/mathjs/es/expression/function/evaluate.js"() {
      init_collection();
      init_factory();
      name43 = "evaluate";
      dependencies42 = ["typed", "parse"];
      createEvaluate = /* @__PURE__ */ factory(name43, dependencies42, function(_ref) {
        var typed2 = _ref.typed, parse2 = _ref.parse;
        return typed2(name43, {
          string: function string2(expr) {
            var scope = {};
            return parse2(expr).compile().evaluate(scope);
          },
          "string, Object": function stringObject(expr, scope) {
            return parse2(expr).compile().evaluate(scope);
          },
          "Array | Matrix": function ArrayMatrix(expr) {
            var scope = {};
            return deepMap(expr, function(entry) {
              return parse2(entry).compile().evaluate(scope);
            });
          },
          "Array | Matrix, Object": function ArrayMatrixObject(expr, scope) {
            return deepMap(expr, function(entry) {
              return parse2(entry).compile().evaluate(scope);
            });
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/expression/Parser.js
  var name44, dependencies43, createParserClass;
  var init_Parser = __esm({
    "node_modules/mathjs/es/expression/Parser.js"() {
      init_factory();
      init_object();
      init_customs();
      name44 = "Parser";
      dependencies43 = ["parse"];
      createParserClass = /* @__PURE__ */ factory(name44, dependencies43, function(_ref) {
        var parse2 = _ref.parse;
        function Parser2() {
          if (!(this instanceof Parser2)) {
            throw new SyntaxError("Constructor must be called with the new operator");
          }
          this.scope = {};
        }
        Parser2.prototype.type = "Parser";
        Parser2.prototype.isParser = true;
        Parser2.prototype.evaluate = function(expr) {
          return parse2(expr).compile().evaluate(this.scope);
        };
        Parser2.prototype.get = function(name106) {
          return name106 in this.scope ? getSafeProperty(this.scope, name106) : void 0;
        };
        Parser2.prototype.getAll = function() {
          return extend({}, this.scope);
        };
        Parser2.prototype.set = function(name106, value) {
          return setSafeProperty(this.scope, name106, value);
        };
        Parser2.prototype.remove = function(name106) {
          delete this.scope[name106];
        };
        Parser2.prototype.clear = function() {
          for (var _name in this.scope) {
            if (hasOwnProperty2(this.scope, _name)) {
              delete this.scope[_name];
            }
          }
        };
        return Parser2;
      }, {
        isClass: true
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/apply.js
  function _apply(mat, dim, callback) {
    var i3, ret, tran;
    if (dim <= 0) {
      if (!Array.isArray(mat[0])) {
        return callback(mat);
      } else {
        tran = _switch2(mat);
        ret = [];
        for (i3 = 0; i3 < tran.length; i3++) {
          ret[i3] = _apply(tran[i3], dim - 1, callback);
        }
        return ret;
      }
    } else {
      ret = [];
      for (i3 = 0; i3 < mat.length; i3++) {
        ret[i3] = _apply(mat[i3], dim - 1, callback);
      }
      return ret;
    }
  }
  function _switch2(mat) {
    var I2 = mat.length;
    var J = mat[0].length;
    var i3, j3;
    var ret = [];
    for (j3 = 0; j3 < J; j3++) {
      var tmp = [];
      for (i3 = 0; i3 < I2; i3++) {
        tmp.push(mat[i3][j3]);
      }
      ret.push(tmp);
    }
    return ret;
  }
  var name45, dependencies44, createApply;
  var init_apply = __esm({
    "node_modules/mathjs/es/function/matrix/apply.js"() {
      init_factory();
      init_array();
      init_is();
      init_IndexError();
      name45 = "apply";
      dependencies44 = ["typed", "isInteger"];
      createApply = /* @__PURE__ */ factory(name45, dependencies44, function(_ref) {
        var typed2 = _ref.typed, isInteger3 = _ref.isInteger;
        return typed2(name45, {
          "Array | Matrix, number | BigNumber, function": function ArrayMatrixNumberBigNumberFunction(mat, dim, callback) {
            if (!isInteger3(dim)) {
              throw new TypeError("Integer number expected for dimension");
            }
            var size2 = Array.isArray(mat) ? arraySize(mat) : mat.size();
            if (dim < 0 || dim >= size2.length) {
              throw new IndexError(dim, size2.length);
            }
            if (isMatrix(mat)) {
              return mat.create(_apply(mat.valueOf(), dim, callback));
            } else {
              return _apply(mat, dim, callback);
            }
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/filter.js
  function _filterCallback(x3, callback) {
    var args = maxArgumentCount(callback);
    return filter(x3, function(value, index2, array) {
      if (args === 1) {
        return callback(value);
      } else if (args === 2) {
        return callback(value, [index2]);
      } else {
        return callback(value, [index2], array);
      }
    });
  }
  var name46, dependencies45, createFilter;
  var init_filter2 = __esm({
    "node_modules/mathjs/es/function/matrix/filter.js"() {
      init_array();
      init_function();
      init_factory();
      name46 = "filter";
      dependencies45 = ["typed"];
      createFilter = /* @__PURE__ */ factory(name46, dependencies45, function(_ref) {
        var typed2 = _ref.typed;
        return typed2("filter", {
          "Array, function": _filterCallback,
          "Matrix, function": function MatrixFunction(x3, test) {
            return x3.create(_filterCallback(x3.toArray(), test));
          },
          "Array, RegExp": filterRegExp,
          "Matrix, RegExp": function MatrixRegExp(x3, test) {
            return x3.create(filterRegExp(x3.toArray(), test));
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/forEach.js
  function _forEach(array, callback) {
    var args = maxArgumentCount(callback);
    var recurse = function recurse2(value, index2) {
      if (Array.isArray(value)) {
        forEach(value, function(child, i3) {
          recurse2(child, index2.concat(i3));
        });
      } else {
        if (args === 1) {
          callback(value);
        } else if (args === 2) {
          callback(value, index2);
        } else {
          callback(value, index2, array);
        }
      }
    };
    recurse(array, []);
  }
  var name47, dependencies46, createForEach;
  var init_forEach2 = __esm({
    "node_modules/mathjs/es/function/matrix/forEach.js"() {
      init_function();
      init_array();
      init_factory();
      name47 = "forEach";
      dependencies46 = ["typed"];
      createForEach = /* @__PURE__ */ factory(name47, dependencies46, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name47, {
          "Array, function": _forEach,
          "Matrix, function": function MatrixFunction(x3, callback) {
            return x3.forEach(callback);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/map.js
  function _map(array, callback) {
    var args = maxArgumentCount(callback);
    var recurse = function recurse2(value, index2) {
      if (Array.isArray(value)) {
        return value.map(function(child, i3) {
          return recurse2(child, index2.concat(i3));
        });
      } else {
        if (args === 1) {
          return callback(value);
        } else if (args === 2) {
          return callback(value, index2);
        } else {
          return callback(value, index2, array);
        }
      }
    };
    return recurse(array, []);
  }
  var name48, dependencies47, createMap;
  var init_map2 = __esm({
    "node_modules/mathjs/es/function/matrix/map.js"() {
      init_function();
      init_factory();
      name48 = "map";
      dependencies47 = ["typed"];
      createMap = /* @__PURE__ */ factory(name48, dependencies47, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name48, {
          "Array, function": _map,
          "Matrix, function": function MatrixFunction(x3, callback) {
            return x3.map(callback);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/range.js
  var name49, dependencies48, createRange;
  var init_range2 = __esm({
    "node_modules/mathjs/es/function/matrix/range.js"() {
      init_factory();
      init_noop();
      name49 = "range";
      dependencies48 = ["typed", "config", "?matrix", "?bignumber", "smaller", "smallerEq", "larger", "largerEq"];
      createRange = /* @__PURE__ */ factory(name49, dependencies48, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, matrix2 = _ref.matrix, bignumber = _ref.bignumber, smaller2 = _ref.smaller, smallerEq2 = _ref.smallerEq, larger2 = _ref.larger, largerEq2 = _ref.largerEq;
        return typed2(name49, {
          string: _strRange,
          "string, boolean": _strRange,
          "number, number": function numberNumber2(start2, end) {
            return _out(_rangeEx(start2, end, 1));
          },
          "number, number, number": function numberNumberNumber(start2, end, step) {
            return _out(_rangeEx(start2, end, step));
          },
          "number, number, boolean": function numberNumberBoolean(start2, end, includeEnd) {
            return includeEnd ? _out(_rangeInc(start2, end, 1)) : _out(_rangeEx(start2, end, 1));
          },
          "number, number, number, boolean": function numberNumberNumberBoolean(start2, end, step, includeEnd) {
            return includeEnd ? _out(_rangeInc(start2, end, step)) : _out(_rangeEx(start2, end, step));
          },
          "BigNumber, BigNumber": function BigNumberBigNumber(start2, end) {
            var BigNumber = start2.constructor;
            return _out(_bigRangeEx(start2, end, new BigNumber(1)));
          },
          "BigNumber, BigNumber, BigNumber": function BigNumberBigNumberBigNumber(start2, end, step) {
            return _out(_bigRangeEx(start2, end, step));
          },
          "BigNumber, BigNumber, boolean": function BigNumberBigNumberBoolean(start2, end, includeEnd) {
            var BigNumber = start2.constructor;
            return includeEnd ? _out(_bigRangeInc(start2, end, new BigNumber(1))) : _out(_bigRangeEx(start2, end, new BigNumber(1)));
          },
          "BigNumber, BigNumber, BigNumber, boolean": function BigNumberBigNumberBigNumberBoolean(start2, end, step, includeEnd) {
            return includeEnd ? _out(_bigRangeInc(start2, end, step)) : _out(_bigRangeEx(start2, end, step));
          }
        });
        function _out(arr) {
          if (config3.matrix === "Matrix") {
            return matrix2 ? matrix2(arr) : noMatrix();
          }
          return arr;
        }
        function _strRange(str, includeEnd) {
          var r3 = _parse2(str);
          if (!r3) {
            throw new SyntaxError('String "' + str + '" is no valid range');
          }
          var fn;
          if (config3.number === "BigNumber") {
            if (bignumber === void 0) {
              noBignumber();
            }
            fn = includeEnd ? _bigRangeInc : _bigRangeEx;
            return _out(fn(bignumber(r3.start), bignumber(r3.end), bignumber(r3.step)));
          } else {
            fn = includeEnd ? _rangeInc : _rangeEx;
            return _out(fn(r3.start, r3.end, r3.step));
          }
        }
        function _rangeEx(start2, end, step) {
          var array = [];
          var x3 = start2;
          if (step > 0) {
            while (smaller2(x3, end)) {
              array.push(x3);
              x3 += step;
            }
          } else if (step < 0) {
            while (larger2(x3, end)) {
              array.push(x3);
              x3 += step;
            }
          }
          return array;
        }
        function _rangeInc(start2, end, step) {
          var array = [];
          var x3 = start2;
          if (step > 0) {
            while (smallerEq2(x3, end)) {
              array.push(x3);
              x3 += step;
            }
          } else if (step < 0) {
            while (largerEq2(x3, end)) {
              array.push(x3);
              x3 += step;
            }
          }
          return array;
        }
        function _bigRangeEx(start2, end, step) {
          var zero = bignumber(0);
          var array = [];
          var x3 = start2;
          if (step.gt(zero)) {
            while (smaller2(x3, end)) {
              array.push(x3);
              x3 = x3.plus(step);
            }
          } else if (step.lt(zero)) {
            while (larger2(x3, end)) {
              array.push(x3);
              x3 = x3.plus(step);
            }
          }
          return array;
        }
        function _bigRangeInc(start2, end, step) {
          var zero = bignumber(0);
          var array = [];
          var x3 = start2;
          if (step.gt(zero)) {
            while (smallerEq2(x3, end)) {
              array.push(x3);
              x3 = x3.plus(step);
            }
          } else if (step.lt(zero)) {
            while (largerEq2(x3, end)) {
              array.push(x3);
              x3 = x3.plus(step);
            }
          }
          return array;
        }
        function _parse2(str) {
          var args = str.split(":");
          var nums = args.map(function(arg) {
            return Number(arg);
          });
          var invalid = nums.some(function(num) {
            return isNaN(num);
          });
          if (invalid) {
            return null;
          }
          switch (nums.length) {
            case 2:
              return {
                start: nums[0],
                end: nums[1],
                step: 1
              };
            case 3:
              return {
                start: nums[0],
                end: nums[2],
                step: nums[1]
              };
            default:
              return null;
          }
        }
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/size.js
  var name50, dependencies49, createSize;
  var init_size2 = __esm({
    "node_modules/mathjs/es/function/matrix/size.js"() {
      init_array();
      init_factory();
      init_noop();
      name50 = "size";
      dependencies49 = ["typed", "config", "?matrix"];
      createSize = /* @__PURE__ */ factory(name50, dependencies49, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, matrix2 = _ref.matrix;
        return typed2(name50, {
          Matrix: function Matrix(x3) {
            return x3.create(x3.size());
          },
          Array: arraySize,
          string: function string2(x3) {
            return config3.matrix === "Array" ? [x3.length] : matrix2([x3.length]);
          },
          "number | Complex | BigNumber | Unit | boolean | null": function numberComplexBigNumberUnitBooleanNull(x3) {
            return config3.matrix === "Array" ? [] : matrix2 ? matrix2([]) : noMatrix();
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/partitionSelect.js
  var name51, dependencies50, createPartitionSelect;
  var init_partitionSelect2 = __esm({
    "node_modules/mathjs/es/function/matrix/partitionSelect.js"() {
      init_is();
      init_number();
      init_factory();
      name51 = "partitionSelect";
      dependencies50 = ["typed", "isNumeric", "isNaN", "compare"];
      createPartitionSelect = /* @__PURE__ */ factory(name51, dependencies50, function(_ref) {
        var typed2 = _ref.typed, isNumeric2 = _ref.isNumeric, isNaN3 = _ref.isNaN, compare2 = _ref.compare;
        var asc = compare2;
        var desc = function desc2(a3, b2) {
          return -compare2(a3, b2);
        };
        return typed2(name51, {
          "Array | Matrix, number": function ArrayMatrixNumber(x3, k3) {
            return _partitionSelect(x3, k3, asc);
          },
          "Array | Matrix, number, string": function ArrayMatrixNumberString(x3, k3, compare3) {
            if (compare3 === "asc") {
              return _partitionSelect(x3, k3, asc);
            } else if (compare3 === "desc") {
              return _partitionSelect(x3, k3, desc);
            } else {
              throw new Error('Compare string must be "asc" or "desc"');
            }
          },
          "Array | Matrix, number, function": _partitionSelect
        });
        function _partitionSelect(x3, k3, compare3) {
          if (!isInteger(k3) || k3 < 0) {
            throw new Error("k must be a non-negative integer");
          }
          if (isMatrix(x3)) {
            var size2 = x3.size();
            if (size2.length > 1) {
              throw new Error("Only one dimensional matrices supported");
            }
            return quickSelect(x3.valueOf(), k3, compare3);
          }
          if (Array.isArray(x3)) {
            return quickSelect(x3, k3, compare3);
          }
        }
        function quickSelect(arr, k3, compare3) {
          if (k3 >= arr.length) {
            throw new Error("k out of bounds");
          }
          for (var i3 = 0; i3 < arr.length; i3++) {
            if (isNumeric2(arr[i3]) && isNaN3(arr[i3])) {
              return arr[i3];
            }
          }
          var from = 0;
          var to = arr.length - 1;
          while (from < to) {
            var r3 = from;
            var w3 = to;
            var pivot = arr[Math.floor(Math.random() * (to - from + 1)) + from];
            while (r3 < w3) {
              if (compare3(arr[r3], pivot) >= 0) {
                var tmp = arr[w3];
                arr[w3] = arr[r3];
                arr[r3] = tmp;
                --w3;
              } else {
                ++r3;
              }
            }
            if (compare3(arr[r3], pivot) > 0) {
              --r3;
            }
            if (k3 <= r3) {
              to = r3;
            } else {
              from = r3 + 1;
            }
          }
          return arr[k3];
        }
      });
    }
  });

  // node_modules/mathjs/es/function/probability/combinationsWithRep.js
  function isPositiveInteger(n3) {
    return n3.isInteger() && n3.gte(0);
  }
  var name52, dependencies51, createCombinationsWithRep;
  var init_combinationsWithRep2 = __esm({
    "node_modules/mathjs/es/function/probability/combinationsWithRep.js"() {
      init_factory();
      init_number();
      init_product();
      name52 = "combinationsWithRep";
      dependencies51 = ["typed"];
      createCombinationsWithRep = /* @__PURE__ */ factory(name52, dependencies51, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name52, {
          "number, number": function numberNumber2(n3, k3) {
            if (!isInteger(n3) || n3 < 0) {
              throw new TypeError("Positive integer value expected in function combinationsWithRep");
            }
            if (!isInteger(k3) || k3 < 0) {
              throw new TypeError("Positive integer value expected in function combinationsWithRep");
            }
            if (n3 < 1) {
              throw new TypeError("k must be less than or equal to n + k - 1");
            }
            if (k3 < n3 - 1) {
              var _prodrange = product(n3, n3 + k3 - 1);
              return _prodrange / product(1, k3);
            }
            var prodrange = product(k3 + 1, n3 + k3 - 1);
            return prodrange / product(1, n3 - 1);
          },
          "BigNumber, BigNumber": function BigNumberBigNumber(n3, k3) {
            var BigNumber = n3.constructor;
            var result, i3;
            var one = new BigNumber(1);
            var nMinusOne = n3.minus(one);
            if (!isPositiveInteger(n3) || !isPositiveInteger(k3)) {
              throw new TypeError("Positive integer value expected in function combinationsWithRep");
            }
            if (n3.lt(one)) {
              throw new TypeError("k must be less than or equal to n + k - 1 in function combinationsWithRep");
            }
            result = one;
            if (k3.lt(nMinusOne)) {
              for (i3 = one; i3.lte(nMinusOne); i3 = i3.plus(one)) {
                result = result.times(k3.plus(i3)).dividedBy(i3);
              }
            } else {
              for (i3 = one; i3.lte(k3); i3 = i3.plus(one)) {
                result = result.times(nMinusOne.plus(i3)).dividedBy(i3);
              }
            }
            return result;
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/probability/factorial.js
  var name53, dependencies52, createFactorial;
  var init_factorial2 = __esm({
    "node_modules/mathjs/es/function/probability/factorial.js"() {
      init_collection();
      init_factory();
      name53 = "factorial";
      dependencies52 = ["typed", "gamma"];
      createFactorial = /* @__PURE__ */ factory(name53, dependencies52, function(_ref) {
        var typed2 = _ref.typed, gamma2 = _ref.gamma;
        return typed2(name53, {
          number: function number2(n3) {
            if (n3 < 0) {
              throw new Error("Value must be non-negative");
            }
            return gamma2(n3 + 1);
          },
          BigNumber: function BigNumber(n3) {
            if (n3.isNegative()) {
              throw new Error("Value must be non-negative");
            }
            return gamma2(n3.plus(1));
          },
          "Array | Matrix": function ArrayMatrix(n3) {
            return deepMap(n3, this);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/probability/multinomial.js
  var name54, dependencies53, createMultinomial;
  var init_multinomial2 = __esm({
    "node_modules/mathjs/es/function/probability/multinomial.js"() {
      init_collection();
      init_factory();
      name54 = "multinomial";
      dependencies53 = ["typed", "add", "divide", "multiply", "factorial", "isInteger", "isPositive"];
      createMultinomial = /* @__PURE__ */ factory(name54, dependencies53, function(_ref) {
        var typed2 = _ref.typed, add2 = _ref.add, divide2 = _ref.divide, multiply2 = _ref.multiply, factorial2 = _ref.factorial, isInteger3 = _ref.isInteger, isPositive2 = _ref.isPositive;
        return typed2(name54, {
          "Array | Matrix": function ArrayMatrix(a3) {
            var sum2 = 0;
            var denom = 1;
            deepForEach(a3, function(ai) {
              if (!isInteger3(ai) || !isPositive2(ai)) {
                throw new TypeError("Positive integer value expected in function multinomial");
              }
              sum2 = add2(sum2, ai);
              denom = multiply2(denom, factorial2(ai));
            });
            return divide2(factorial2(sum2), denom);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/probability/permutations.js
  function isPositiveInteger2(n3) {
    return n3.isInteger() && n3.gte(0);
  }
  var name55, dependencies54, createPermutations;
  var init_permutations2 = __esm({
    "node_modules/mathjs/es/function/probability/permutations.js"() {
      init_number();
      init_product();
      init_factory();
      name55 = "permutations";
      dependencies54 = ["typed", "factorial"];
      createPermutations = /* @__PURE__ */ factory(name55, dependencies54, function(_ref) {
        var typed2 = _ref.typed, factorial2 = _ref.factorial;
        return typed2(name55, {
          "number | BigNumber": factorial2,
          "number, number": function numberNumber2(n3, k3) {
            if (!isInteger(n3) || n3 < 0) {
              throw new TypeError("Positive integer value expected in function permutations");
            }
            if (!isInteger(k3) || k3 < 0) {
              throw new TypeError("Positive integer value expected in function permutations");
            }
            if (k3 > n3) {
              throw new TypeError("second argument k must be less than or equal to first argument n");
            }
            return product(n3 - k3 + 1, n3);
          },
          "BigNumber, BigNumber": function BigNumberBigNumber(n3, k3) {
            var result, i3;
            if (!isPositiveInteger2(n3) || !isPositiveInteger2(k3)) {
              throw new TypeError("Positive integer value expected in function permutations");
            }
            if (k3.gt(n3)) {
              throw new TypeError("second argument k must be less than or equal to first argument n");
            }
            var one = n3.mul(0).add(1);
            result = one;
            for (i3 = n3.minus(k3).plus(1); i3.lte(n3); i3 = i3.plus(1)) {
              result = result.times(i3);
            }
            return result;
          }
        });
      });
    }
  });

  // node_modules/seed-random/index.js
  var require_seed_random = __commonJS({
    "node_modules/seed-random/index.js"(exports, module) {
      "use strict";
      var width = 256;
      var chunks = 6;
      var digits2 = 52;
      var pool = [];
      var GLOBAL = typeof global === "undefined" ? window : global;
      var startdenom = Math.pow(width, chunks);
      var significance = Math.pow(2, digits2);
      var overflow = significance * 2;
      var mask = width - 1;
      var oldRandom = Math.random;
      module.exports = function(seed, options) {
        if (options && options.global === true) {
          options.global = false;
          Math.random = module.exports(seed, options);
          options.global = true;
          return Math.random;
        }
        var use_entropy = options && options.entropy || false;
        var key = [];
        var shortseed = mixkey(flatten2(use_entropy ? [seed, tostring(pool)] : 0 in arguments ? seed : autoseed(), 3), key);
        var arc4 = new ARC4(key);
        mixkey(tostring(arc4.S), pool);
        return function() {
          var n3 = arc4.g(chunks), d4 = startdenom, x3 = 0;
          while (n3 < significance) {
            n3 = (n3 + x3) * width;
            d4 *= width;
            x3 = arc4.g(1);
          }
          while (n3 >= overflow) {
            n3 /= 2;
            d4 /= 2;
            x3 >>>= 1;
          }
          return (n3 + x3) / d4;
        };
      };
      module.exports.resetGlobal = function() {
        Math.random = oldRandom;
      };
      function ARC4(key) {
        var t3, keylen = key.length, me = this, i3 = 0, j3 = me.i = me.j = 0, s3 = me.S = [];
        if (!keylen) {
          key = [keylen++];
        }
        while (i3 < width) {
          s3[i3] = i3++;
        }
        for (i3 = 0; i3 < width; i3++) {
          s3[i3] = s3[j3 = mask & j3 + key[i3 % keylen] + (t3 = s3[i3])];
          s3[j3] = t3;
        }
        (me.g = function(count) {
          var t4, r3 = 0, i4 = me.i, j4 = me.j, s4 = me.S;
          while (count--) {
            t4 = s4[i4 = mask & i4 + 1];
            r3 = r3 * width + s4[mask & (s4[i4] = s4[j4 = mask & j4 + t4]) + (s4[j4] = t4)];
          }
          me.i = i4;
          me.j = j4;
          return r3;
        })(width);
      }
      function flatten2(obj, depth) {
        var result = [], typ = (typeof obj)[0], prop;
        if (depth && typ == "o") {
          for (prop in obj) {
            try {
              result.push(flatten2(obj[prop], depth - 1));
            } catch (e5) {
            }
          }
        }
        return result.length ? result : typ == "s" ? obj : obj + "\0";
      }
      function mixkey(seed, key) {
        var stringseed = seed + "", smear, j3 = 0;
        while (j3 < stringseed.length) {
          key[mask & j3] = mask & (smear ^= key[mask & j3] * 19) + stringseed.charCodeAt(j3++);
        }
        return tostring(key);
      }
      function autoseed(seed) {
        try {
          GLOBAL.crypto.getRandomValues(seed = new Uint8Array(width));
          return tostring(seed);
        } catch (e5) {
          return [
            +new Date(),
            GLOBAL,
            GLOBAL.navigator && GLOBAL.navigator.plugins,
            GLOBAL.screen,
            tostring(pool)
          ];
        }
      }
      function tostring(a3) {
        return String.fromCharCode.apply(0, a3);
      }
      mixkey(Math.random(), pool);
    }
  });

  // node_modules/mathjs/es/function/probability/util/seededRNG.js
  function createRng(randomSeed) {
    var random2;
    function setSeed(seed) {
      random2 = seed === null ? singletonRandom : (0, import_seed_random.default)(String(seed));
    }
    setSeed(randomSeed);
    function rng() {
      return random2();
    }
    return rng;
  }
  var import_seed_random, singletonRandom;
  var init_seededRNG = __esm({
    "node_modules/mathjs/es/function/probability/util/seededRNG.js"() {
      import_seed_random = __toModule(require_seed_random());
      singletonRandom = /* @__PURE__ */ (0, import_seed_random.default)();
    }
  });

  // node_modules/mathjs/es/function/probability/pickRandom.js
  var name56, dependencies55, createPickRandom;
  var init_pickRandom2 = __esm({
    "node_modules/mathjs/es/function/probability/pickRandom.js"() {
      init_factory();
      init_is();
      init_seededRNG();
      init_array();
      name56 = "pickRandom";
      dependencies55 = ["typed", "config", "?on"];
      createPickRandom = /* @__PURE__ */ factory(name56, dependencies55, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, on = _ref.on;
        var rng = createRng(config3.randomSeed);
        if (on) {
          on("config", function(curr, prev) {
            if (curr.randomSeed !== prev.randomSeed) {
              rng = createRng(curr.randomSeed);
            }
          });
        }
        return typed2({
          "Array | Matrix": function ArrayMatrix(possibles) {
            return _pickRandom(possibles);
          },
          "Array | Matrix, number": function ArrayMatrixNumber(possibles, number2) {
            return _pickRandom(possibles, number2, void 0);
          },
          "Array | Matrix, Array": function ArrayMatrixArray(possibles, weights) {
            return _pickRandom(possibles, void 0, weights);
          },
          "Array | Matrix, Array | Matrix, number": function ArrayMatrixArrayMatrixNumber(possibles, weights, number2) {
            return _pickRandom(possibles, number2, weights);
          },
          "Array | Matrix, number, Array | Matrix": function ArrayMatrixNumberArrayMatrix(possibles, number2, weights) {
            return _pickRandom(possibles, number2, weights);
          }
        });
        function _pickRandom(possibles, number2, weights) {
          var single = typeof number2 === "undefined";
          if (single) {
            number2 = 1;
          }
          possibles = flatten(possibles.valueOf()).valueOf();
          if (weights) {
            weights = weights.valueOf();
          }
          var totalWeights = 0;
          if (typeof weights !== "undefined") {
            if (weights.length !== possibles.length) {
              throw new Error("Weights must have the same length as possibles");
            }
            for (var i3 = 0, len = weights.length; i3 < len; i3++) {
              if (!isNumber(weights[i3]) || weights[i3] < 0) {
                throw new Error("Weights must be an array of positive numbers");
              }
              totalWeights += weights[i3];
            }
          }
          var length = possibles.length;
          if (length === 0) {
            return [];
          } else if (number2 >= length) {
            return number2 > 1 ? possibles : possibles[0];
          }
          var result = [];
          var pick;
          while (result.length < number2) {
            if (typeof weights === "undefined") {
              pick = possibles[Math.floor(rng() * length)];
            } else {
              var randKey = rng() * totalWeights;
              for (var _i = 0, _len = possibles.length; _i < _len; _i++) {
                randKey -= weights[_i];
                if (randKey < 0) {
                  pick = possibles[_i];
                  break;
                }
              }
            }
            if (result.indexOf(pick) === -1) {
              result.push(pick);
            }
          }
          return single ? result[0] : result;
        }
      });
    }
  });

  // node_modules/mathjs/es/function/probability/util/randomMatrix.js
  function randomMatrix(size2, random2) {
    var data = [];
    size2 = size2.slice(0);
    if (size2.length > 1) {
      for (var i3 = 0, length = size2.shift(); i3 < length; i3++) {
        data.push(randomMatrix(size2, random2));
      }
    } else {
      for (var _i = 0, _length = size2.shift(); _i < _length; _i++) {
        data.push(random2());
      }
    }
    return data;
  }
  var init_randomMatrix = __esm({
    "node_modules/mathjs/es/function/probability/util/randomMatrix.js"() {
    }
  });

  // node_modules/mathjs/es/function/probability/random.js
  var name57, createRandomNumber;
  var init_random2 = __esm({
    "node_modules/mathjs/es/function/probability/random.js"() {
      init_factory();
      init_seededRNG();
      name57 = "random";
      createRandomNumber = /* @__PURE__ */ factory(name57, ["typed", "config", "?on"], function(_ref2) {
        var typed2 = _ref2.typed, config3 = _ref2.config, on = _ref2.on, matrix2 = _ref2.matrix;
        var rng = createRng(config3.randomSeed);
        if (on) {
          on("config", function(curr, prev) {
            if (curr.randomSeed !== prev.randomSeed) {
              rng = createRng(curr.randomSeed);
            }
          });
        }
        return typed2(name57, {
          "": function _2() {
            return _random(0, 1);
          },
          number: function number2(max2) {
            return _random(0, max2);
          },
          "number, number": function numberNumber2(min2, max2) {
            return _random(min2, max2);
          }
        });
        function _random(min2, max2) {
          return min2 + rng() * (max2 - min2);
        }
      });
    }
  });

  // node_modules/mathjs/es/function/probability/randomInt.js
  var name58, dependencies56, createRandomInt;
  var init_randomInt2 = __esm({
    "node_modules/mathjs/es/function/probability/randomInt.js"() {
      init_factory();
      init_randomMatrix();
      init_seededRNG();
      init_is();
      name58 = "randomInt";
      dependencies56 = ["typed", "config", "?on"];
      createRandomInt = /* @__PURE__ */ factory(name58, dependencies56, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, on = _ref.on;
        var rng = createRng(config3.randomSeed);
        if (on) {
          on("config", function(curr, prev) {
            if (curr.randomSeed !== prev.randomSeed) {
              rng = createRng(curr.randomSeed);
            }
          });
        }
        return typed2(name58, {
          "": function _2() {
            return _randomInt(0, 1);
          },
          number: function number2(max2) {
            return _randomInt(0, max2);
          },
          "number, number": function numberNumber2(min2, max2) {
            return _randomInt(min2, max2);
          },
          "Array | Matrix": function ArrayMatrix(size2) {
            return _randomIntMatrix(size2, 0, 1);
          },
          "Array | Matrix, number": function ArrayMatrixNumber(size2, max2) {
            return _randomIntMatrix(size2, 0, max2);
          },
          "Array | Matrix, number, number": function ArrayMatrixNumberNumber(size2, min2, max2) {
            return _randomIntMatrix(size2, min2, max2);
          }
        });
        function _randomIntMatrix(size2, min2, max2) {
          var res = randomMatrix(size2.valueOf(), function() {
            return _randomInt(min2, max2);
          });
          return isMatrix(size2) ? size2.create(res) : res;
        }
        function _randomInt(min2, max2) {
          return Math.floor(min2 + rng() * (max2 - min2));
        }
      });
    }
  });

  // node_modules/mathjs/es/function/relational/equalScalar.js
  var name59, createEqualScalarNumber;
  var init_equalScalar = __esm({
    "node_modules/mathjs/es/function/relational/equalScalar.js"() {
      init_number();
      init_factory();
      name59 = "equalScalar";
      createEqualScalarNumber = factory(name59, ["typed", "config"], function(_ref2) {
        var typed2 = _ref2.typed, config3 = _ref2.config;
        return typed2(name59, {
          "number, number": function numberNumber2(x3, y2) {
            return nearlyEqual(x3, y2, config3.epsilon);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/compare.js
  var name60, createCompareNumber;
  var init_compare2 = __esm({
    "node_modules/mathjs/es/function/relational/compare.js"() {
      init_number();
      init_factory();
      name60 = "compare";
      createCompareNumber = /* @__PURE__ */ factory(name60, ["typed", "config"], function(_ref2) {
        var typed2 = _ref2.typed, config3 = _ref2.config;
        return typed2(name60, {
          "number, number": function numberNumber2(x3, y2) {
            return nearlyEqual(x3, y2, config3.epsilon) ? 0 : x3 > y2 ? 1 : -1;
          }
        });
      });
    }
  });

  // node_modules/javascript-natural-sort/naturalSort.js
  var require_naturalSort = __commonJS({
    "node_modules/javascript-natural-sort/naturalSort.js"(exports, module) {
      module.exports = function naturalSort2(a3, b2) {
        "use strict";
        var re = /(^([+\-]?(?:0|[1-9]\d*)(?:\.\d*)?(?:[eE][+\-]?\d+)?)?$|^0x[0-9a-f]+$|\d+)/gi, sre = /(^[ ]*|[ ]*$)/g, dre = /(^([\w ]+,?[\w ]+)?[\w ]+,?[\w ]+\d+:\d+(:\d+)?[\w ]?|^\d{1,4}[\/\-]\d{1,4}[\/\-]\d{1,4}|^\w+, \w+ \d+, \d{4})/, hre = /^0x[0-9a-f]+$/i, ore = /^0/, i3 = function(s3) {
          return naturalSort2.insensitive && ("" + s3).toLowerCase() || "" + s3;
        }, x3 = i3(a3).replace(sre, "") || "", y2 = i3(b2).replace(sre, "") || "", xN = x3.replace(re, "\0$1\0").replace(/\0$/, "").replace(/^\0/, "").split("\0"), yN = y2.replace(re, "\0$1\0").replace(/\0$/, "").replace(/^\0/, "").split("\0"), xD = parseInt(x3.match(hre), 16) || xN.length !== 1 && x3.match(dre) && Date.parse(x3), yD = parseInt(y2.match(hre), 16) || xD && y2.match(dre) && Date.parse(y2) || null, oFxNcL, oFyNcL;
        if (yD) {
          if (xD < yD) {
            return -1;
          } else if (xD > yD) {
            return 1;
          }
        }
        for (var cLoc = 0, numS = Math.max(xN.length, yN.length); cLoc < numS; cLoc++) {
          oFxNcL = !(xN[cLoc] || "").match(ore) && parseFloat(xN[cLoc]) || xN[cLoc] || 0;
          oFyNcL = !(yN[cLoc] || "").match(ore) && parseFloat(yN[cLoc]) || yN[cLoc] || 0;
          if (isNaN(oFxNcL) !== isNaN(oFyNcL)) {
            return isNaN(oFxNcL) ? 1 : -1;
          } else if (typeof oFxNcL !== typeof oFyNcL) {
            oFxNcL += "";
            oFyNcL += "";
          }
          if (oFxNcL < oFyNcL) {
            return -1;
          }
          if (oFxNcL > oFyNcL) {
            return 1;
          }
        }
        return 0;
      };
    }
  });

  // node_modules/mathjs/es/function/relational/compareNatural.js
  function compareComplexNumbers(x3, y2) {
    if (x3.re > y2.re) {
      return 1;
    }
    if (x3.re < y2.re) {
      return -1;
    }
    if (x3.im > y2.im) {
      return 1;
    }
    if (x3.im < y2.im) {
      return -1;
    }
    return 0;
  }
  var import_javascript_natural_sort, name61, dependencies57, createCompareNatural;
  var init_compareNatural2 = __esm({
    "node_modules/mathjs/es/function/relational/compareNatural.js"() {
      import_javascript_natural_sort = __toModule(require_naturalSort());
      init_is();
      init_factory();
      name61 = "compareNatural";
      dependencies57 = ["typed", "compare"];
      createCompareNatural = /* @__PURE__ */ factory(name61, dependencies57, function(_ref) {
        var typed2 = _ref.typed, compare2 = _ref.compare;
        var compareBooleans = compare2.signatures["boolean,boolean"];
        return typed2(name61, {
          "any, any": function anyAny(x3, y2) {
            var typeX = typeOf(x3);
            var typeY = typeOf(y2);
            var c3;
            if ((typeX === "number" || typeX === "BigNumber" || typeX === "Fraction") && (typeY === "number" || typeY === "BigNumber" || typeY === "Fraction")) {
              c3 = compare2(x3, y2);
              if (c3.toString() !== "0") {
                return c3 > 0 ? 1 : -1;
              } else {
                return (0, import_javascript_natural_sort.default)(typeX, typeY);
              }
            }
            if (typeX === "Array" || typeX === "Matrix" || typeY === "Array" || typeY === "Matrix") {
              c3 = compareMatricesAndArrays(this, x3, y2);
              if (c3 !== 0) {
                return c3;
              } else {
                return (0, import_javascript_natural_sort.default)(typeX, typeY);
              }
            }
            if (typeX !== typeY) {
              return (0, import_javascript_natural_sort.default)(typeX, typeY);
            }
            if (typeX === "Complex") {
              return compareComplexNumbers(x3, y2);
            }
            if (typeX === "Unit") {
              if (x3.equalBase(y2)) {
                return this(x3.value, y2.value);
              }
              return compareArrays(this, x3.formatUnits(), y2.formatUnits());
            }
            if (typeX === "boolean") {
              return compareBooleans(x3, y2);
            }
            if (typeX === "string") {
              return (0, import_javascript_natural_sort.default)(x3, y2);
            }
            if (typeX === "Object") {
              return compareObjects(this, x3, y2);
            }
            if (typeX === "null") {
              return 0;
            }
            if (typeX === "undefined") {
              return 0;
            }
            throw new TypeError('Unsupported type of value "' + typeX + '"');
          }
        });
        function compareMatricesAndArrays(compareNatural2, x3, y2) {
          if (isSparseMatrix(x3) && isSparseMatrix(y2)) {
            return compareArrays(compareNatural2, x3.toJSON().values, y2.toJSON().values);
          }
          if (isSparseMatrix(x3)) {
            return compareMatricesAndArrays(compareNatural2, x3.toArray(), y2);
          }
          if (isSparseMatrix(y2)) {
            return compareMatricesAndArrays(compareNatural2, x3, y2.toArray());
          }
          if (isDenseMatrix(x3)) {
            return compareMatricesAndArrays(compareNatural2, x3.toJSON().data, y2);
          }
          if (isDenseMatrix(y2)) {
            return compareMatricesAndArrays(compareNatural2, x3, y2.toJSON().data);
          }
          if (!Array.isArray(x3)) {
            return compareMatricesAndArrays(compareNatural2, [x3], y2);
          }
          if (!Array.isArray(y2)) {
            return compareMatricesAndArrays(compareNatural2, x3, [y2]);
          }
          return compareArrays(compareNatural2, x3, y2);
        }
        function compareArrays(compareNatural2, x3, y2) {
          for (var i3 = 0, ii = Math.min(x3.length, y2.length); i3 < ii; i3++) {
            var v3 = compareNatural2(x3[i3], y2[i3]);
            if (v3 !== 0) {
              return v3;
            }
          }
          if (x3.length > y2.length) {
            return 1;
          }
          if (x3.length < y2.length) {
            return -1;
          }
          return 0;
        }
        function compareObjects(compareNatural2, x3, y2) {
          var keysX = Object.keys(x3);
          var keysY = Object.keys(y2);
          keysX.sort(import_javascript_natural_sort.default);
          keysY.sort(import_javascript_natural_sort.default);
          var c3 = compareArrays(compareNatural2, keysX, keysY);
          if (c3 !== 0) {
            return c3;
          }
          for (var i3 = 0; i3 < keysX.length; i3++) {
            var v3 = compareNatural2(x3[keysX[i3]], y2[keysY[i3]]);
            if (v3 !== 0) {
              return v3;
            }
          }
          return 0;
        }
      });
    }
  });

  // node_modules/mathjs/es/function/relational/compareText.js
  var name62, createCompareTextNumber;
  var init_compareText2 = __esm({
    "node_modules/mathjs/es/function/relational/compareText.js"() {
      init_string();
      init_factory();
      name62 = "compareText";
      createCompareTextNumber = /* @__PURE__ */ factory(name62, ["typed"], function(_ref2) {
        var typed2 = _ref2.typed;
        return typed2(name62, {
          "any, any": compareText
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/equal.js
  var name63, createEqualNumber;
  var init_equal2 = __esm({
    "node_modules/mathjs/es/function/relational/equal.js"() {
      init_factory();
      name63 = "equal";
      createEqualNumber = factory(name63, ["typed", "equalScalar"], function(_ref2) {
        var typed2 = _ref2.typed, equalScalar2 = _ref2.equalScalar;
        return typed2(name63, {
          "any, any": function anyAny(x3, y2) {
            if (x3 === null) {
              return y2 === null;
            }
            if (y2 === null) {
              return x3 === null;
            }
            if (x3 === void 0) {
              return y2 === void 0;
            }
            if (y2 === void 0) {
              return x3 === void 0;
            }
            return equalScalar2(x3, y2);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/equalText.js
  var name64, dependencies58, createEqualText;
  var init_equalText2 = __esm({
    "node_modules/mathjs/es/function/relational/equalText.js"() {
      init_factory();
      name64 = "equalText";
      dependencies58 = ["typed", "compareText", "isZero"];
      createEqualText = /* @__PURE__ */ factory(name64, dependencies58, function(_ref) {
        var typed2 = _ref.typed, compareText3 = _ref.compareText, isZero2 = _ref.isZero;
        return typed2(name64, {
          "any, any": function anyAny(x3, y2) {
            return isZero2(compareText3(x3, y2));
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/smaller.js
  var name65, createSmallerNumber;
  var init_smaller2 = __esm({
    "node_modules/mathjs/es/function/relational/smaller.js"() {
      init_number();
      init_factory();
      name65 = "smaller";
      createSmallerNumber = /* @__PURE__ */ factory(name65, ["typed", "config"], function(_ref2) {
        var typed2 = _ref2.typed, config3 = _ref2.config;
        return typed2(name65, {
          "number, number": function numberNumber2(x3, y2) {
            return x3 < y2 && !nearlyEqual(x3, y2, config3.epsilon);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/smallerEq.js
  var name66, createSmallerEqNumber;
  var init_smallerEq2 = __esm({
    "node_modules/mathjs/es/function/relational/smallerEq.js"() {
      init_number();
      init_factory();
      name66 = "smallerEq";
      createSmallerEqNumber = /* @__PURE__ */ factory(name66, ["typed", "config"], function(_ref2) {
        var typed2 = _ref2.typed, config3 = _ref2.config;
        return typed2(name66, {
          "number, number": function numberNumber2(x3, y2) {
            return x3 <= y2 || nearlyEqual(x3, y2, config3.epsilon);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/larger.js
  var name67, createLargerNumber;
  var init_larger2 = __esm({
    "node_modules/mathjs/es/function/relational/larger.js"() {
      init_number();
      init_factory();
      name67 = "larger";
      createLargerNumber = /* @__PURE__ */ factory(name67, ["typed", "config"], function(_ref2) {
        var typed2 = _ref2.typed, config3 = _ref2.config;
        return typed2(name67, {
          "number, number": function numberNumber2(x3, y2) {
            return x3 > y2 && !nearlyEqual(x3, y2, config3.epsilon);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/largerEq.js
  var name68, createLargerEqNumber;
  var init_largerEq2 = __esm({
    "node_modules/mathjs/es/function/relational/largerEq.js"() {
      init_number();
      init_factory();
      name68 = "largerEq";
      createLargerEqNumber = /* @__PURE__ */ factory(name68, ["typed", "config"], function(_ref2) {
        var typed2 = _ref2.typed, config3 = _ref2.config;
        return typed2(name68, {
          "number, number": function numberNumber2(x3, y2) {
            return x3 >= y2 || nearlyEqual(x3, y2, config3.epsilon);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/relational/deepEqual.js
  var name69, dependencies59, createDeepEqual;
  var init_deepEqual2 = __esm({
    "node_modules/mathjs/es/function/relational/deepEqual.js"() {
      init_factory();
      name69 = "deepEqual";
      dependencies59 = ["typed", "equal"];
      createDeepEqual = /* @__PURE__ */ factory(name69, dependencies59, function(_ref) {
        var typed2 = _ref.typed, equal3 = _ref.equal;
        return typed2(name69, {
          "any, any": function anyAny(x3, y2) {
            return _deepEqual2(x3.valueOf(), y2.valueOf());
          }
        });
        function _deepEqual2(x3, y2) {
          if (Array.isArray(x3)) {
            if (Array.isArray(y2)) {
              var len = x3.length;
              if (len !== y2.length) {
                return false;
              }
              for (var i3 = 0; i3 < len; i3++) {
                if (!_deepEqual2(x3[i3], y2[i3])) {
                  return false;
                }
              }
              return true;
            } else {
              return false;
            }
          } else {
            if (Array.isArray(y2)) {
              return false;
            } else {
              return equal3(x3, y2);
            }
          }
        }
      });
    }
  });

  // node_modules/mathjs/es/function/relational/unequal.js
  var name70, createUnequalNumber;
  var init_unequal2 = __esm({
    "node_modules/mathjs/es/function/relational/unequal.js"() {
      init_factory();
      name70 = "unequal";
      createUnequalNumber = factory(name70, ["typed", "equalScalar"], function(_ref2) {
        var typed2 = _ref2.typed, equalScalar2 = _ref2.equalScalar;
        return typed2(name70, {
          "any, any": function anyAny(x3, y2) {
            if (x3 === null) {
              return y2 !== null;
            }
            if (y2 === null) {
              return x3 !== null;
            }
            if (x3 === void 0) {
              return y2 !== void 0;
            }
            if (y2 === void 0) {
              return x3 !== void 0;
            }
            return !equalScalar2(x3, y2);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/special/erf.js
  var name71, dependencies60, createErf, THRESH, SQRPI, P2, Q, MAX_NUM;
  var init_erf2 = __esm({
    "node_modules/mathjs/es/function/special/erf.js"() {
      init_collection();
      init_number();
      init_factory();
      name71 = "erf";
      dependencies60 = ["typed"];
      createErf = /* @__PURE__ */ factory(name71, dependencies60, function(_ref) {
        var typed2 = _ref.typed;
        return typed2("name", {
          number: function number2(x3) {
            var y2 = Math.abs(x3);
            if (y2 >= MAX_NUM) {
              return sign(x3);
            }
            if (y2 <= THRESH) {
              return sign(x3) * erf1(y2);
            }
            if (y2 <= 4) {
              return sign(x3) * (1 - erfc2(y2));
            }
            return sign(x3) * (1 - erfc3(y2));
          },
          "Array | Matrix": function ArrayMatrix(n3) {
            return deepMap(n3, this);
          }
        });
        function erf1(y2) {
          var ysq = y2 * y2;
          var xnum = P2[0][4] * ysq;
          var xden = ysq;
          var i3;
          for (i3 = 0; i3 < 3; i3 += 1) {
            xnum = (xnum + P2[0][i3]) * ysq;
            xden = (xden + Q[0][i3]) * ysq;
          }
          return y2 * (xnum + P2[0][3]) / (xden + Q[0][3]);
        }
        function erfc2(y2) {
          var xnum = P2[1][8] * y2;
          var xden = y2;
          var i3;
          for (i3 = 0; i3 < 7; i3 += 1) {
            xnum = (xnum + P2[1][i3]) * y2;
            xden = (xden + Q[1][i3]) * y2;
          }
          var result = (xnum + P2[1][7]) / (xden + Q[1][7]);
          var ysq = parseInt(y2 * 16) / 16;
          var del = (y2 - ysq) * (y2 + ysq);
          return Math.exp(-ysq * ysq) * Math.exp(-del) * result;
        }
        function erfc3(y2) {
          var ysq = 1 / (y2 * y2);
          var xnum = P2[2][5] * ysq;
          var xden = ysq;
          var i3;
          for (i3 = 0; i3 < 4; i3 += 1) {
            xnum = (xnum + P2[2][i3]) * ysq;
            xden = (xden + Q[2][i3]) * ysq;
          }
          var result = ysq * (xnum + P2[2][4]) / (xden + Q[2][4]);
          result = (SQRPI - result) / y2;
          ysq = parseInt(y2 * 16) / 16;
          var del = (y2 - ysq) * (y2 + ysq);
          return Math.exp(-ysq * ysq) * Math.exp(-del) * result;
        }
      });
      THRESH = 0.46875;
      SQRPI = 0.5641895835477563;
      P2 = [[3.1611237438705655, 113.86415415105016, 377.485237685302, 3209.3775891384694, 0.18577770618460315], [0.5641884969886701, 8.883149794388377, 66.11919063714163, 298.6351381974001, 881.952221241769, 1712.0476126340707, 2051.0783778260716, 1230.3393547979972, 21531153547440383e-24], [0.30532663496123236, 0.36034489994980445, 0.12578172611122926, 0.016083785148742275, 6587491615298378e-19, 0.016315387137302097]];
      Q = [[23.601290952344122, 244.02463793444417, 1282.6165260773723, 2844.236833439171], [15.744926110709835, 117.6939508913125, 537.1811018620099, 1621.3895745666903, 3290.7992357334597, 4362.619090143247, 3439.3676741437216, 1230.3393548037495], [2.568520192289822, 1.8729528499234604, 0.5279051029514285, 0.06051834131244132, 0.0023352049762686918]];
      MAX_NUM = Math.pow(2, 53);
    }
  });

  // node_modules/mathjs/es/function/statistics/mode.js
  var name72, dependencies61, createMode;
  var init_mode2 = __esm({
    "node_modules/mathjs/es/function/statistics/mode.js"() {
      init_array();
      init_factory();
      name72 = "mode";
      dependencies61 = ["typed", "isNaN", "isNumeric"];
      createMode = /* @__PURE__ */ factory(name72, dependencies61, function(_ref) {
        var typed2 = _ref.typed, isNaN3 = _ref.isNaN, isNumeric2 = _ref.isNumeric;
        return typed2(name72, {
          "Array | Matrix": _mode,
          "...": function _2(args) {
            return _mode(args);
          }
        });
        function _mode(values2) {
          values2 = flatten(values2.valueOf());
          var num = values2.length;
          if (num === 0) {
            throw new Error("Cannot calculate mode of an empty array");
          }
          var count = {};
          var mode2 = [];
          var max2 = 0;
          for (var i3 = 0; i3 < values2.length; i3++) {
            var value = values2[i3];
            if (isNumeric2(value) && isNaN3(value)) {
              throw new Error("Cannot calculate mode of an array containing NaN values");
            }
            if (!(value in count)) {
              count[value] = 0;
            }
            count[value]++;
            if (count[value] === max2) {
              mode2.push(value);
            } else if (count[value] > max2) {
              max2 = count[value];
              mode2 = [value];
            }
          }
          return mode2;
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/utils/improveErrorMessage.js
  function improveErrorMessage(err, fnName, value) {
    var details;
    if (String(err).indexOf("Unexpected type") !== -1) {
      details = arguments.length > 2 ? " (type: " + typeOf(value) + ", value: " + JSON.stringify(value) + ")" : " (type: " + err.data.actual + ")";
      return new TypeError("Cannot calculate " + fnName + ", unexpected type of argument" + details);
    }
    if (String(err).indexOf("complex numbers") !== -1) {
      details = arguments.length > 2 ? " (type: " + typeOf(value) + ", value: " + JSON.stringify(value) + ")" : "";
      return new TypeError("Cannot calculate " + fnName + ", no ordering relation is defined for complex numbers" + details);
    }
    return err;
  }
  var init_improveErrorMessage = __esm({
    "node_modules/mathjs/es/function/statistics/utils/improveErrorMessage.js"() {
      init_is();
    }
  });

  // node_modules/mathjs/es/function/statistics/prod.js
  var name73, dependencies62, createProd;
  var init_prod2 = __esm({
    "node_modules/mathjs/es/function/statistics/prod.js"() {
      init_collection();
      init_factory();
      init_improveErrorMessage();
      name73 = "prod";
      dependencies62 = ["typed", "config", "multiplyScalar", "numeric"];
      createProd = /* @__PURE__ */ factory(name73, dependencies62, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, multiplyScalar2 = _ref.multiplyScalar, numeric3 = _ref.numeric;
        return typed2(name73, {
          "Array | Matrix": _prod,
          "Array | Matrix, number | BigNumber": function ArrayMatrixNumberBigNumber(array, dim) {
            throw new Error("prod(A, dim) is not yet supported");
          },
          "...": function _2(args) {
            return _prod(args);
          }
        });
        function _prod(array) {
          var prod2;
          deepForEach(array, function(value) {
            try {
              prod2 = prod2 === void 0 ? value : multiplyScalar2(prod2, value);
            } catch (err) {
              throw improveErrorMessage(err, "prod", value);
            }
          });
          if (typeof prod2 === "string") {
            prod2 = numeric3(prod2, config3.number);
          }
          if (prod2 === void 0) {
            throw new Error("Cannot calculate prod of an empty array");
          }
          return prod2;
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/max.js
  var name74, dependencies63, createMax;
  var init_max2 = __esm({
    "node_modules/mathjs/es/function/statistics/max.js"() {
      init_collection();
      init_factory();
      init_improveErrorMessage();
      name74 = "max";
      dependencies63 = ["typed", "config", "numeric", "larger"];
      createMax = /* @__PURE__ */ factory(name74, dependencies63, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, numeric3 = _ref.numeric, larger2 = _ref.larger;
        return typed2(name74, {
          "Array | Matrix": _max,
          "Array | Matrix, number | BigNumber": function ArrayMatrixNumberBigNumber(array, dim) {
            return reduce(array, dim.valueOf(), _largest);
          },
          "...": function _2(args) {
            if (containsCollections(args)) {
              throw new TypeError("Scalar values expected in function max");
            }
            return _max(args);
          }
        });
        function _largest(x3, y2) {
          try {
            return larger2(x3, y2) ? x3 : y2;
          } catch (err) {
            throw improveErrorMessage(err, "max", y2);
          }
        }
        function _max(array) {
          var res;
          deepForEach(array, function(value) {
            try {
              if (isNaN(value) && typeof value === "number") {
                res = NaN;
              } else if (res === void 0 || larger2(value, res)) {
                res = value;
              }
            } catch (err) {
              throw improveErrorMessage(err, "max", value);
            }
          });
          if (res === void 0) {
            throw new Error("Cannot calculate max of an empty array");
          }
          if (typeof res === "string") {
            res = numeric3(res, config3.number);
          }
          return res;
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/min.js
  var name75, dependencies64, createMin;
  var init_min2 = __esm({
    "node_modules/mathjs/es/function/statistics/min.js"() {
      init_collection();
      init_factory();
      init_improveErrorMessage();
      name75 = "min";
      dependencies64 = ["typed", "config", "numeric", "smaller"];
      createMin = /* @__PURE__ */ factory(name75, dependencies64, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, numeric3 = _ref.numeric, smaller2 = _ref.smaller;
        return typed2(name75, {
          "Array | Matrix": _min,
          "Array | Matrix, number | BigNumber": function ArrayMatrixNumberBigNumber(array, dim) {
            return reduce(array, dim.valueOf(), _smallest);
          },
          "...": function _2(args) {
            if (containsCollections(args)) {
              throw new TypeError("Scalar values expected in function min");
            }
            return _min(args);
          }
        });
        function _smallest(x3, y2) {
          try {
            return smaller2(x3, y2) ? x3 : y2;
          } catch (err) {
            throw improveErrorMessage(err, "min", y2);
          }
        }
        function _min(array) {
          var min2;
          deepForEach(array, function(value) {
            try {
              if (isNaN(value) && typeof value === "number") {
                min2 = NaN;
              } else if (min2 === void 0 || smaller2(value, min2)) {
                min2 = value;
              }
            } catch (err) {
              throw improveErrorMessage(err, "min", value);
            }
          });
          if (min2 === void 0) {
            throw new Error("Cannot calculate min of an empty array");
          }
          if (typeof min2 === "string") {
            min2 = numeric3(min2, config3.number);
          }
          return min2;
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/sum.js
  var name76, dependencies65, createSum;
  var init_sum2 = __esm({
    "node_modules/mathjs/es/function/statistics/sum.js"() {
      init_collection();
      init_factory();
      init_improveErrorMessage();
      name76 = "sum";
      dependencies65 = ["typed", "config", "add", "numeric"];
      createSum = /* @__PURE__ */ factory(name76, dependencies65, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, add2 = _ref.add, numeric3 = _ref.numeric;
        return typed2(name76, {
          "Array | Matrix": _sum,
          "Array | Matrix, number | BigNumber": _nsumDim,
          "...": function _2(args) {
            if (containsCollections(args)) {
              throw new TypeError("Scalar values expected in function sum");
            }
            return _sum(args);
          }
        });
        function _sum(array) {
          var sum2;
          deepForEach(array, function(value) {
            try {
              sum2 = sum2 === void 0 ? value : add2(sum2, value);
            } catch (err) {
              throw improveErrorMessage(err, "sum", value);
            }
          });
          if (sum2 === void 0) {
            sum2 = numeric3(0, config3.number);
          }
          if (typeof sum2 === "string") {
            sum2 = numeric3(sum2, config3.number);
          }
          return sum2;
        }
        function _nsumDim(array, dim) {
          try {
            var sum2 = reduce(array, dim, add2);
            return sum2;
          } catch (err) {
            throw improveErrorMessage(err, "sum");
          }
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/mean.js
  var name77, dependencies66, createMean;
  var init_mean2 = __esm({
    "node_modules/mathjs/es/function/statistics/mean.js"() {
      init_collection();
      init_array();
      init_factory();
      init_improveErrorMessage();
      name77 = "mean";
      dependencies66 = ["typed", "add", "divide"];
      createMean = /* @__PURE__ */ factory(name77, dependencies66, function(_ref) {
        var typed2 = _ref.typed, add2 = _ref.add, divide2 = _ref.divide;
        return typed2(name77, {
          "Array | Matrix": _mean,
          "Array | Matrix, number | BigNumber": _nmeanDim,
          "...": function _2(args) {
            if (containsCollections(args)) {
              throw new TypeError("Scalar values expected in function mean");
            }
            return _mean(args);
          }
        });
        function _nmeanDim(array, dim) {
          try {
            var sum2 = reduce(array, dim, add2);
            var s3 = Array.isArray(array) ? arraySize(array) : array.size();
            return divide2(sum2, s3[dim]);
          } catch (err) {
            throw improveErrorMessage(err, "mean");
          }
        }
        function _mean(array) {
          var sum2;
          var num = 0;
          deepForEach(array, function(value) {
            try {
              sum2 = sum2 === void 0 ? value : add2(sum2, value);
              num++;
            } catch (err) {
              throw improveErrorMessage(err, "mean", value);
            }
          });
          if (num === 0) {
            throw new Error("Cannot calculate the mean of an empty array");
          }
          return divide2(sum2, num);
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/median.js
  var name78, dependencies67, createMedian;
  var init_median2 = __esm({
    "node_modules/mathjs/es/function/statistics/median.js"() {
      init_collection();
      init_array();
      init_factory();
      init_improveErrorMessage();
      name78 = "median";
      dependencies67 = ["typed", "add", "divide", "compare", "partitionSelect"];
      createMedian = /* @__PURE__ */ factory(name78, dependencies67, function(_ref) {
        var typed2 = _ref.typed, add2 = _ref.add, divide2 = _ref.divide, compare2 = _ref.compare, partitionSelect2 = _ref.partitionSelect;
        function _median(array) {
          try {
            array = flatten(array.valueOf());
            var num = array.length;
            if (num === 0) {
              throw new Error("Cannot calculate median of an empty array");
            }
            if (num % 2 === 0) {
              var mid = num / 2 - 1;
              var right = partitionSelect2(array, mid + 1);
              var left = array[mid];
              for (var i3 = 0; i3 < mid; ++i3) {
                if (compare2(array[i3], left) > 0) {
                  left = array[i3];
                }
              }
              return middle2(left, right);
            } else {
              var m3 = partitionSelect2(array, (num - 1) / 2);
              return middle(m3);
            }
          } catch (err) {
            throw improveErrorMessage(err, "median");
          }
        }
        var middle = typed2({
          "number | BigNumber | Complex | Unit": function numberBigNumberComplexUnit(value) {
            return value;
          }
        });
        var middle2 = typed2({
          "number | BigNumber | Complex | Unit, number | BigNumber | Complex | Unit": function numberBigNumberComplexUnitNumberBigNumberComplexUnit(left, right) {
            return divide2(add2(left, right), 2);
          }
        });
        return typed2(name78, {
          "Array | Matrix": _median,
          "Array | Matrix, number | BigNumber": function ArrayMatrixNumberBigNumber(array, dim) {
            throw new Error("median(A, dim) is not yet supported");
          },
          "...": function _2(args) {
            if (containsCollections(args)) {
              throw new TypeError("Scalar values expected in function median");
            }
            return _median(args);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/mad.js
  var name79, dependencies68, createMad;
  var init_mad2 = __esm({
    "node_modules/mathjs/es/function/statistics/mad.js"() {
      init_array();
      init_factory();
      init_improveErrorMessage();
      name79 = "mad";
      dependencies68 = ["typed", "abs", "map", "median", "subtract"];
      createMad = /* @__PURE__ */ factory(name79, dependencies68, function(_ref) {
        var typed2 = _ref.typed, abs2 = _ref.abs, map3 = _ref.map, median2 = _ref.median, subtract2 = _ref.subtract;
        return typed2(name79, {
          "Array | Matrix": _mad,
          "...": function _2(args) {
            return _mad(args);
          }
        });
        function _mad(array) {
          array = flatten(array.valueOf());
          if (array.length === 0) {
            throw new Error("Cannot calculate median absolute deviation (mad) of an empty array");
          }
          try {
            var med = median2(array);
            return median2(map3(array, function(value) {
              return abs2(subtract2(value, med));
            }));
          } catch (err) {
            if (err instanceof TypeError && err.message.indexOf("median") !== -1) {
              throw new TypeError(err.message.replace("median", "mad"));
            } else {
              throw improveErrorMessage(err, "mad");
            }
          }
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/variance.js
  var DEFAULT_NORMALIZATION, name80, dependencies69, createVariance;
  var init_variance2 = __esm({
    "node_modules/mathjs/es/function/statistics/variance.js"() {
      init_collection();
      init_is();
      init_factory();
      init_improveErrorMessage();
      DEFAULT_NORMALIZATION = "unbiased";
      name80 = "variance";
      dependencies69 = ["typed", "add", "subtract", "multiply", "divide", "apply", "isNaN"];
      createVariance = /* @__PURE__ */ factory(name80, dependencies69, function(_ref) {
        var typed2 = _ref.typed, add2 = _ref.add, subtract2 = _ref.subtract, multiply2 = _ref.multiply, divide2 = _ref.divide, apply2 = _ref.apply, isNaN3 = _ref.isNaN;
        return typed2(name80, {
          "Array | Matrix": function ArrayMatrix(array) {
            return _var(array, DEFAULT_NORMALIZATION);
          },
          "Array | Matrix, string": _var,
          "Array | Matrix, number | BigNumber": function ArrayMatrixNumberBigNumber(array, dim) {
            return _varDim(array, dim, DEFAULT_NORMALIZATION);
          },
          "Array | Matrix, number | BigNumber, string": _varDim,
          "...": function _2(args) {
            return _var(args, DEFAULT_NORMALIZATION);
          }
        });
        function _var(array, normalization) {
          var sum2;
          var num = 0;
          if (array.length === 0) {
            throw new SyntaxError("Function variance requires one or more parameters (0 provided)");
          }
          deepForEach(array, function(value) {
            try {
              sum2 = sum2 === void 0 ? value : add2(sum2, value);
              num++;
            } catch (err) {
              throw improveErrorMessage(err, "variance", value);
            }
          });
          if (num === 0)
            throw new Error("Cannot calculate variance of an empty array");
          var mean2 = divide2(sum2, num);
          sum2 = void 0;
          deepForEach(array, function(value) {
            var diff = subtract2(value, mean2);
            sum2 = sum2 === void 0 ? multiply2(diff, diff) : add2(sum2, multiply2(diff, diff));
          });
          if (isNaN3(sum2)) {
            return sum2;
          }
          switch (normalization) {
            case "uncorrected":
              return divide2(sum2, num);
            case "biased":
              return divide2(sum2, num + 1);
            case "unbiased": {
              var zero = isBigNumber(sum2) ? sum2.mul(0) : 0;
              return num === 1 ? zero : divide2(sum2, num - 1);
            }
            default:
              throw new Error('Unknown normalization "' + normalization + '". Choose "unbiased" (default), "uncorrected", or "biased".');
          }
        }
        function _varDim(array, dim, normalization) {
          try {
            if (array.length === 0) {
              throw new SyntaxError("Function variance requires one or more parameters (0 provided)");
            }
            return apply2(array, dim, function(x3) {
              return _var(x3, normalization);
            });
          } catch (err) {
            throw improveErrorMessage(err, "variance");
          }
        }
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/quantileSeq.js
  var name81, dependencies70, createQuantileSeq;
  var init_quantileSeq2 = __esm({
    "node_modules/mathjs/es/function/statistics/quantileSeq.js"() {
      init_is();
      init_number();
      init_array();
      init_factory();
      name81 = "quantileSeq";
      dependencies70 = ["typed", "add", "multiply", "partitionSelect", "compare"];
      createQuantileSeq = /* @__PURE__ */ factory(name81, dependencies70, function(_ref) {
        var typed2 = _ref.typed, add2 = _ref.add, multiply2 = _ref.multiply, partitionSelect2 = _ref.partitionSelect, compare2 = _ref.compare;
        function quantileSeq2(data, probOrN, sorted) {
          var probArr, dataArr, one;
          if (arguments.length < 2 || arguments.length > 3) {
            throw new SyntaxError("Function quantileSeq requires two or three parameters");
          }
          if (isCollection(data)) {
            sorted = sorted || false;
            if (typeof sorted === "boolean") {
              dataArr = data.valueOf();
              if (isNumber(probOrN)) {
                if (probOrN < 0) {
                  throw new Error("N/prob must be non-negative");
                }
                if (probOrN <= 1) {
                  return _quantileSeq(dataArr, probOrN, sorted);
                }
                if (probOrN > 1) {
                  if (!isInteger(probOrN)) {
                    throw new Error("N must be a positive integer");
                  }
                  var nPlusOne = probOrN + 1;
                  probArr = new Array(probOrN);
                  for (var i3 = 0; i3 < probOrN; ) {
                    probArr[i3] = _quantileSeq(dataArr, ++i3 / nPlusOne, sorted);
                  }
                  return probArr;
                }
              }
              if (isBigNumber(probOrN)) {
                var BigNumber = probOrN.constructor;
                if (probOrN.isNegative()) {
                  throw new Error("N/prob must be non-negative");
                }
                one = new BigNumber(1);
                if (probOrN.lte(one)) {
                  return new BigNumber(_quantileSeq(dataArr, probOrN, sorted));
                }
                if (probOrN.gt(one)) {
                  if (!probOrN.isInteger()) {
                    throw new Error("N must be a positive integer");
                  }
                  var intN = probOrN.toNumber();
                  if (intN > 4294967295) {
                    throw new Error("N must be less than or equal to 2^32-1, as that is the maximum length of an Array");
                  }
                  var _nPlusOne = new BigNumber(intN + 1);
                  probArr = new Array(intN);
                  for (var _i = 0; _i < intN; ) {
                    probArr[_i] = new BigNumber(_quantileSeq(dataArr, new BigNumber(++_i).div(_nPlusOne), sorted));
                  }
                  return probArr;
                }
              }
              if (Array.isArray(probOrN)) {
                probArr = new Array(probOrN.length);
                for (var _i2 = 0; _i2 < probArr.length; ++_i2) {
                  var currProb = probOrN[_i2];
                  if (isNumber(currProb)) {
                    if (currProb < 0 || currProb > 1) {
                      throw new Error("Probability must be between 0 and 1, inclusive");
                    }
                  } else if (isBigNumber(currProb)) {
                    one = new currProb.constructor(1);
                    if (currProb.isNegative() || currProb.gt(one)) {
                      throw new Error("Probability must be between 0 and 1, inclusive");
                    }
                  } else {
                    throw new TypeError("Unexpected type of argument in function quantileSeq");
                  }
                  probArr[_i2] = _quantileSeq(dataArr, currProb, sorted);
                }
                return probArr;
              }
              throw new TypeError("Unexpected type of argument in function quantileSeq");
            }
            throw new TypeError("Unexpected type of argument in function quantileSeq");
          }
          throw new TypeError("Unexpected type of argument in function quantileSeq");
        }
        function _quantileSeq(array, prob, sorted) {
          var flat = flatten(array);
          var len = flat.length;
          if (len === 0) {
            throw new Error("Cannot calculate quantile of an empty sequence");
          }
          if (isNumber(prob)) {
            var _index = prob * (len - 1);
            var _fracPart = _index % 1;
            if (_fracPart === 0) {
              var value = sorted ? flat[_index] : partitionSelect2(flat, _index);
              validate(value);
              return value;
            }
            var _integerPart = Math.floor(_index);
            var _left;
            var _right;
            if (sorted) {
              _left = flat[_integerPart];
              _right = flat[_integerPart + 1];
            } else {
              _right = partitionSelect2(flat, _integerPart + 1);
              _left = flat[_integerPart];
              for (var i3 = 0; i3 < _integerPart; ++i3) {
                if (compare2(flat[i3], _left) > 0) {
                  _left = flat[i3];
                }
              }
            }
            validate(_left);
            validate(_right);
            return add2(multiply2(_left, 1 - _fracPart), multiply2(_right, _fracPart));
          }
          var index2 = prob.times(len - 1);
          if (index2.isInteger()) {
            index2 = index2.toNumber();
            var _value = sorted ? flat[index2] : partitionSelect2(flat, index2);
            validate(_value);
            return _value;
          }
          var integerPart = index2.floor();
          var fracPart = index2.minus(integerPart);
          var integerPartNumber = integerPart.toNumber();
          var left;
          var right;
          if (sorted) {
            left = flat[integerPartNumber];
            right = flat[integerPartNumber + 1];
          } else {
            right = partitionSelect2(flat, integerPartNumber + 1);
            left = flat[integerPartNumber];
            for (var _i3 = 0; _i3 < integerPartNumber; ++_i3) {
              if (compare2(flat[_i3], left) > 0) {
                left = flat[_i3];
              }
            }
          }
          validate(left);
          validate(right);
          var one = new fracPart.constructor(1);
          return add2(multiply2(left, one.minus(fracPart)), multiply2(right, fracPart));
        }
        var validate = typed2({
          "number | BigNumber | Unit": function numberBigNumberUnit(x3) {
            return x3;
          }
        });
        return quantileSeq2;
      });
    }
  });

  // node_modules/mathjs/es/function/statistics/std.js
  var name82, dependencies71, createStd;
  var init_std2 = __esm({
    "node_modules/mathjs/es/function/statistics/std.js"() {
      init_factory();
      name82 = "std";
      dependencies71 = ["typed", "sqrt", "variance"];
      createStd = /* @__PURE__ */ factory(name82, dependencies71, function(_ref) {
        var typed2 = _ref.typed, sqrt2 = _ref.sqrt, variance2 = _ref.variance;
        return typed2(name82, {
          "Array | Matrix": _std,
          "Array | Matrix, string": _std,
          "Array | Matrix, number | BigNumber": _std,
          "Array | Matrix, number | BigNumber, string": _std,
          "...": function _2(args) {
            return _std(args);
          }
        });
        function _std(array, normalization) {
          if (array.length === 0) {
            throw new SyntaxError("Function std requires one or more parameters (0 provided)");
          }
          try {
            return sqrt2(variance2.apply(null, arguments));
          } catch (err) {
            if (err instanceof TypeError && err.message.indexOf(" variance") !== -1) {
              throw new TypeError(err.message.replace(" variance", " std"));
            } else {
              throw err;
            }
          }
        }
      });
    }
  });

  // node_modules/mathjs/es/function/string/format.js
  var name83, dependencies72, createFormat;
  var init_format2 = __esm({
    "node_modules/mathjs/es/function/string/format.js"() {
      init_string();
      init_factory();
      name83 = "format";
      dependencies72 = ["typed"];
      createFormat = /* @__PURE__ */ factory(name83, dependencies72, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name83, {
          any: format3,
          "any, Object | function | number": format3
        });
      });
    }
  });

  // node_modules/mathjs/es/function/string/print.js
  function _print(template, values2, options) {
    return template.replace(/\$([\w.]+)/g, function(original, key) {
      var keys = key.split(".");
      var value = values2[keys.shift()];
      while (keys.length && value !== void 0) {
        var k3 = keys.shift();
        value = k3 ? value[k3] : value + ".";
      }
      if (value !== void 0) {
        if (!isString(value)) {
          return format3(value, options);
        } else {
          return value;
        }
      }
      return original;
    });
  }
  var name84, dependencies73, createPrint;
  var init_print = __esm({
    "node_modules/mathjs/es/function/string/print.js"() {
      init_string();
      init_is();
      init_factory();
      name84 = "print";
      dependencies73 = ["typed"];
      createPrint = /* @__PURE__ */ factory(name84, dependencies73, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name84, {
          "string, Object | Array": _print,
          "string, Object | Array, number | Object": _print
        });
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/apply.transform.js
  var name85, dependencies74, createApplyTransform;
  var init_apply_transform = __esm({
    "node_modules/mathjs/es/expression/transform/apply.transform.js"() {
      init_errorTransform();
      init_factory();
      init_apply();
      init_is();
      name85 = "apply";
      dependencies74 = ["typed", "isInteger"];
      createApplyTransform = /* @__PURE__ */ factory(name85, dependencies74, function(_ref) {
        var typed2 = _ref.typed, isInteger3 = _ref.isInteger;
        var apply2 = createApply({
          typed: typed2,
          isInteger: isInteger3
        });
        return typed2("apply", {
          "...any": function any(args) {
            var dim = args[1];
            if (isNumber(dim)) {
              args[1] = dim - 1;
            } else if (isBigNumber(dim)) {
              args[1] = dim.minus(1);
            }
            try {
              return apply2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/utils/compileInlineExpression.js
  function compileInlineExpression(expression, math2, scope) {
    var symbol = expression.filter(function(node) {
      return isSymbolNode(node) && !(node.name in math2) && !(node.name in scope);
    })[0];
    if (!symbol) {
      throw new Error('No undefined variable found in inline expression "' + expression + '"');
    }
    var name106 = symbol.name;
    var subScope = Object.create(scope);
    var eq = expression.compile();
    return function inlineExpression(x3) {
      subScope[name106] = x3;
      return eq.evaluate(subScope);
    };
  }
  var init_compileInlineExpression = __esm({
    "node_modules/mathjs/es/expression/transform/utils/compileInlineExpression.js"() {
      init_is();
    }
  });

  // node_modules/mathjs/es/expression/transform/filter.transform.js
  function _filter(x3, callback) {
    var args = maxArgumentCount(callback);
    return filter(x3, function(value, index2, array) {
      if (args === 1) {
        return callback(value);
      } else if (args === 2) {
        return callback(value, [index2 + 1]);
      } else {
        return callback(value, [index2 + 1], array);
      }
    });
  }
  var name86, dependencies75, createFilterTransform;
  var init_filter_transform = __esm({
    "node_modules/mathjs/es/expression/transform/filter.transform.js"() {
      init_is();
      init_array();
      init_function();
      init_compileInlineExpression();
      init_factory();
      name86 = "filter";
      dependencies75 = ["typed"];
      createFilterTransform = /* @__PURE__ */ factory(name86, dependencies75, function(_ref) {
        var typed2 = _ref.typed;
        function filterTransform(args, math2, scope) {
          var x3, callback;
          if (args[0]) {
            x3 = args[0].compile().evaluate(scope);
          }
          if (args[1]) {
            if (isSymbolNode(args[1]) || isFunctionAssignmentNode(args[1])) {
              callback = args[1].compile().evaluate(scope);
            } else {
              callback = compileInlineExpression(args[1], math2, scope);
            }
          }
          return filter3(x3, callback);
        }
        filterTransform.rawArgs = true;
        var filter3 = typed2("filter", {
          "Array, function": _filter,
          "Matrix, function": function MatrixFunction(x3, test) {
            return x3.create(_filter(x3.toArray(), test));
          },
          "Array, RegExp": filterRegExp,
          "Matrix, RegExp": function MatrixRegExp(x3, test) {
            return x3.create(filterRegExp(x3.toArray(), test));
          }
        });
        return filterTransform;
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/forEach.transform.js
  var name87, dependencies76, createForEachTransform;
  var init_forEach_transform = __esm({
    "node_modules/mathjs/es/expression/transform/forEach.transform.js"() {
      init_is();
      init_function();
      init_array();
      init_factory();
      init_compileInlineExpression();
      name87 = "forEach";
      dependencies76 = ["typed"];
      createForEachTransform = /* @__PURE__ */ factory(name87, dependencies76, function(_ref) {
        var typed2 = _ref.typed;
        function forEachTransform(args, math2, scope) {
          var x3, callback;
          if (args[0]) {
            x3 = args[0].compile().evaluate(scope);
          }
          if (args[1]) {
            if (isSymbolNode(args[1]) || isFunctionAssignmentNode(args[1])) {
              callback = args[1].compile().evaluate(scope);
            } else {
              callback = compileInlineExpression(args[1], math2, scope);
            }
          }
          return _forEach2(x3, callback);
        }
        forEachTransform.rawArgs = true;
        var _forEach2 = typed2("forEach", {
          "Array | Matrix, function": function ArrayMatrixFunction(array, callback) {
            var args = maxArgumentCount(callback);
            var recurse = function recurse2(value, index2) {
              if (Array.isArray(value)) {
                forEach(value, function(child, i3) {
                  recurse2(child, index2.concat(i3 + 1));
                });
              } else {
                if (args === 1) {
                  callback(value);
                } else if (args === 2) {
                  callback(value, index2);
                } else {
                  callback(value, index2, array);
                }
              }
            };
            recurse(array.valueOf(), []);
          }
        });
        return forEachTransform;
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/map.transform.js
  function _map2(array, callback, orig) {
    var argsCount = maxArgumentCount(callback);
    function recurse(value, index2) {
      if (Array.isArray(value)) {
        return map(value, function(child, i3) {
          return recurse(child, index2.concat(i3 + 1));
        });
      } else {
        if (argsCount === 1) {
          return callback(value);
        } else if (argsCount === 2) {
          return callback(value, index2);
        } else {
          return callback(value, index2, orig);
        }
      }
    }
    return recurse(array, []);
  }
  var name88, dependencies77, createMapTransform;
  var init_map_transform = __esm({
    "node_modules/mathjs/es/expression/transform/map.transform.js"() {
      init_is();
      init_function();
      init_array();
      init_factory();
      init_compileInlineExpression();
      name88 = "map";
      dependencies77 = ["typed"];
      createMapTransform = /* @__PURE__ */ factory(name88, dependencies77, function(_ref) {
        var typed2 = _ref.typed;
        function mapTransform(args, math2, scope) {
          var x3, callback;
          if (args[0]) {
            x3 = args[0].compile().evaluate(scope);
          }
          if (args[1]) {
            if (isSymbolNode(args[1]) || isFunctionAssignmentNode(args[1])) {
              callback = args[1].compile().evaluate(scope);
            } else {
              callback = compileInlineExpression(args[1], math2, scope);
            }
          }
          return map3(x3, callback);
        }
        mapTransform.rawArgs = true;
        var map3 = typed2("map", {
          "Array, function": function ArrayFunction(x3, callback) {
            return _map2(x3, callback, x3);
          },
          "Matrix, function": function MatrixFunction(x3, callback) {
            return x3.create(_map2(x3.valueOf(), callback, x3));
          }
        });
        return mapTransform;
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/max.transform.js
  var name89, dependencies78, createMaxTransform;
  var init_max_transform = __esm({
    "node_modules/mathjs/es/expression/transform/max.transform.js"() {
      init_is();
      init_factory();
      init_errorTransform();
      init_max2();
      name89 = "max";
      dependencies78 = ["typed", "config", "numeric", "larger"];
      createMaxTransform = /* @__PURE__ */ factory(name89, dependencies78, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, numeric3 = _ref.numeric, larger2 = _ref.larger;
        var max2 = createMax({
          typed: typed2,
          config: config3,
          numeric: numeric3,
          larger: larger2
        });
        return typed2("max", {
          "...any": function any(args) {
            if (args.length === 2 && isCollection(args[0])) {
              var dim = args[1];
              if (isNumber(dim)) {
                args[1] = dim - 1;
              } else if (isBigNumber(dim)) {
                args[1] = dim.minus(1);
              }
            }
            try {
              return max2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/mean.transform.js
  var name90, dependencies79, createMeanTransform;
  var init_mean_transform = __esm({
    "node_modules/mathjs/es/expression/transform/mean.transform.js"() {
      init_is();
      init_factory();
      init_errorTransform();
      init_mean2();
      name90 = "mean";
      dependencies79 = ["typed", "add", "divide"];
      createMeanTransform = /* @__PURE__ */ factory(name90, dependencies79, function(_ref) {
        var typed2 = _ref.typed, add2 = _ref.add, divide2 = _ref.divide;
        var mean2 = createMean({
          typed: typed2,
          add: add2,
          divide: divide2
        });
        return typed2("mean", {
          "...any": function any(args) {
            if (args.length === 2 && isCollection(args[0])) {
              var dim = args[1];
              if (isNumber(dim)) {
                args[1] = dim - 1;
              } else if (isBigNumber(dim)) {
                args[1] = dim.minus(1);
              }
            }
            try {
              return mean2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/min.transform.js
  var name91, dependencies80, createMinTransform;
  var init_min_transform = __esm({
    "node_modules/mathjs/es/expression/transform/min.transform.js"() {
      init_is();
      init_factory();
      init_errorTransform();
      init_min2();
      name91 = "min";
      dependencies80 = ["typed", "config", "numeric", "smaller"];
      createMinTransform = /* @__PURE__ */ factory(name91, dependencies80, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, numeric3 = _ref.numeric, smaller2 = _ref.smaller;
        var min2 = createMin({
          typed: typed2,
          config: config3,
          numeric: numeric3,
          smaller: smaller2
        });
        return typed2("min", {
          "...any": function any(args) {
            if (args.length === 2 && isCollection(args[0])) {
              var dim = args[1];
              if (isNumber(dim)) {
                args[1] = dim - 1;
              } else if (isBigNumber(dim)) {
                args[1] = dim.minus(1);
              }
            }
            try {
              return min2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/range.transform.js
  var name92, dependencies81, createRangeTransform;
  var init_range_transform = __esm({
    "node_modules/mathjs/es/expression/transform/range.transform.js"() {
      init_factory();
      init_range2();
      name92 = "range";
      dependencies81 = ["typed", "config", "?matrix", "?bignumber", "smaller", "smallerEq", "larger", "largerEq"];
      createRangeTransform = /* @__PURE__ */ factory(name92, dependencies81, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, matrix2 = _ref.matrix, bignumber = _ref.bignumber, smaller2 = _ref.smaller, smallerEq2 = _ref.smallerEq, larger2 = _ref.larger, largerEq2 = _ref.largerEq;
        var range2 = createRange({
          typed: typed2,
          config: config3,
          matrix: matrix2,
          bignumber,
          smaller: smaller2,
          smallerEq: smallerEq2,
          larger: larger2,
          largerEq: largerEq2
        });
        return typed2("range", {
          "...any": function any(args) {
            var lastIndex = args.length - 1;
            var last = args[lastIndex];
            if (typeof last !== "boolean") {
              args.push(true);
            }
            return range2.apply(null, args);
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/function/matrix/subset.js
  function _getSubstring(str, index2) {
    if (!isIndex(index2)) {
      throw new TypeError("Index expected");
    }
    if (index2.size().length !== 1) {
      throw new DimensionError(index2.size().length, 1);
    }
    var strLen = str.length;
    validateIndex(index2.min()[0], strLen);
    validateIndex(index2.max()[0], strLen);
    var range2 = index2.dimension(0);
    var substr = "";
    range2.forEach(function(v3) {
      substr += str.charAt(v3);
    });
    return substr;
  }
  function _setSubstring(str, index2, replacement, defaultValue) {
    if (!index2 || index2.isIndex !== true) {
      throw new TypeError("Index expected");
    }
    if (index2.size().length !== 1) {
      throw new DimensionError(index2.size().length, 1);
    }
    if (defaultValue !== void 0) {
      if (typeof defaultValue !== "string" || defaultValue.length !== 1) {
        throw new TypeError("Single character expected as defaultValue");
      }
    } else {
      defaultValue = " ";
    }
    var range2 = index2.dimension(0);
    var len = range2.size()[0];
    if (len !== replacement.length) {
      throw new DimensionError(range2.size()[0], replacement.length);
    }
    var strLen = str.length;
    validateIndex(index2.min()[0]);
    validateIndex(index2.max()[0]);
    var chars = [];
    for (var i3 = 0; i3 < strLen; i3++) {
      chars[i3] = str.charAt(i3);
    }
    range2.forEach(function(v3, i4) {
      chars[v3] = replacement.charAt(i4[0]);
    });
    if (chars.length > strLen) {
      for (var _i = strLen - 1, _len = chars.length; _i < _len; _i++) {
        if (!chars[_i]) {
          chars[_i] = defaultValue;
        }
      }
    }
    return chars.join("");
  }
  function _getObjectProperty(object, index2) {
    if (index2.size().length !== 1) {
      throw new DimensionError(index2.size(), 1);
    }
    var key = index2.dimension(0);
    if (typeof key !== "string") {
      throw new TypeError("String expected as index to retrieve an object property");
    }
    return getSafeProperty(object, key);
  }
  function _setObjectProperty(object, index2, replacement) {
    if (index2.size().length !== 1) {
      throw new DimensionError(index2.size(), 1);
    }
    var key = index2.dimension(0);
    if (typeof key !== "string") {
      throw new TypeError("String expected as index to retrieve an object property");
    }
    var updated = clone(object);
    setSafeProperty(updated, key, replacement);
    return updated;
  }
  var name93, dependencies82, createSubset;
  var init_subset2 = __esm({
    "node_modules/mathjs/es/function/matrix/subset.js"() {
      init_is();
      init_object();
      init_array();
      init_customs();
      init_DimensionError();
      init_factory();
      name93 = "subset";
      dependencies82 = ["typed", "matrix"];
      createSubset = /* @__PURE__ */ factory(name93, dependencies82, function(_ref) {
        var typed2 = _ref.typed, matrix2 = _ref.matrix;
        return typed2(name93, {
          "Array, Index": function ArrayIndex(value, index2) {
            var m3 = matrix2(value);
            var subset2 = m3.subset(index2);
            return index2.isScalar() ? subset2 : subset2.valueOf();
          },
          "Matrix, Index": function MatrixIndex(value, index2) {
            return value.subset(index2);
          },
          "Object, Index": _getObjectProperty,
          "string, Index": _getSubstring,
          "Array, Index, any": function ArrayIndexAny(value, index2, replacement) {
            return matrix2(clone(value)).subset(index2, replacement, void 0).valueOf();
          },
          "Array, Index, any, any": function ArrayIndexAnyAny(value, index2, replacement, defaultValue) {
            return matrix2(clone(value)).subset(index2, replacement, defaultValue).valueOf();
          },
          "Matrix, Index, any": function MatrixIndexAny(value, index2, replacement) {
            return value.clone().subset(index2, replacement);
          },
          "Matrix, Index, any, any": function MatrixIndexAnyAny(value, index2, replacement, defaultValue) {
            return value.clone().subset(index2, replacement, defaultValue);
          },
          "string, Index, string": _setSubstring,
          "string, Index, string, string": _setSubstring,
          "Object, Index, any": _setObjectProperty
        });
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/subset.transform.js
  var name94, dependencies83, createSubsetTransform;
  var init_subset_transform = __esm({
    "node_modules/mathjs/es/expression/transform/subset.transform.js"() {
      init_factory();
      init_errorTransform();
      init_subset2();
      name94 = "subset";
      dependencies83 = ["typed", "matrix"];
      createSubsetTransform = /* @__PURE__ */ factory(name94, dependencies83, function(_ref) {
        var typed2 = _ref.typed, matrix2 = _ref.matrix;
        var subset2 = createSubset({
          typed: typed2,
          matrix: matrix2
        });
        return typed2("subset", {
          "...any": function any(args) {
            try {
              return subset2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/std.transform.js
  var name95, dependencies84, createStdTransform;
  var init_std_transform = __esm({
    "node_modules/mathjs/es/expression/transform/std.transform.js"() {
      init_factory();
      init_std2();
      init_is();
      init_errorTransform();
      name95 = "std";
      dependencies84 = ["typed", "sqrt", "variance"];
      createStdTransform = /* @__PURE__ */ factory(name95, dependencies84, function(_ref) {
        var typed2 = _ref.typed, sqrt2 = _ref.sqrt, variance2 = _ref.variance;
        var std2 = createStd({
          typed: typed2,
          sqrt: sqrt2,
          variance: variance2
        });
        return typed2("std", {
          "...any": function any(args) {
            if (args.length >= 2 && isCollection(args[0])) {
              var dim = args[1];
              if (isNumber(dim)) {
                args[1] = dim - 1;
              } else if (isBigNumber(dim)) {
                args[1] = dim.minus(1);
              }
            }
            try {
              return std2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/sum.transform.js
  var name96, dependencies85, createSumTransform;
  var init_sum_transform = __esm({
    "node_modules/mathjs/es/expression/transform/sum.transform.js"() {
      init_is();
      init_factory();
      init_errorTransform();
      init_sum2();
      name96 = "sum";
      dependencies85 = ["typed", "config", "add", "numeric"];
      createSumTransform = /* @__PURE__ */ factory(name96, dependencies85, function(_ref) {
        var typed2 = _ref.typed, config3 = _ref.config, add2 = _ref.add, numeric3 = _ref.numeric;
        var sum2 = createSum({
          typed: typed2,
          config: config3,
          add: add2,
          numeric: numeric3
        });
        return typed2(name96, {
          "...any": function any(args) {
            if (args.length === 2 && isCollection(args[0])) {
              var dim = args[1];
              if (isNumber(dim)) {
                args[1] = dim - 1;
              } else if (isBigNumber(dim)) {
                args[1] = dim.minus(1);
              }
            }
            try {
              return sum2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/expression/transform/variance.transform.js
  var name97, dependencies86, createVarianceTransform;
  var init_variance_transform = __esm({
    "node_modules/mathjs/es/expression/transform/variance.transform.js"() {
      init_factory();
      init_is();
      init_errorTransform();
      init_variance2();
      name97 = "variance";
      dependencies86 = ["typed", "add", "subtract", "multiply", "divide", "apply", "isNaN"];
      createVarianceTransform = /* @__PURE__ */ factory(name97, dependencies86, function(_ref) {
        var typed2 = _ref.typed, add2 = _ref.add, subtract2 = _ref.subtract, multiply2 = _ref.multiply, divide2 = _ref.divide, apply2 = _ref.apply, isNaN3 = _ref.isNaN;
        var variance2 = createVariance({
          typed: typed2,
          add: add2,
          subtract: subtract2,
          multiply: multiply2,
          divide: divide2,
          apply: apply2,
          isNaN: isNaN3
        });
        return typed2(name97, {
          "...any": function any(args) {
            if (args.length >= 2 && isCollection(args[0])) {
              var dim = args[1];
              if (isNumber(dim)) {
                args[1] = dim - 1;
              } else if (isBigNumber(dim)) {
                args[1] = dim.minus(1);
              }
            }
            try {
              return variance2.apply(null, args);
            } catch (err) {
              throw errorTransform(err);
            }
          }
        });
      }, {
        isTransformFunction: true
      });
    }
  });

  // node_modules/mathjs/es/function/utils/clone.js
  var name98, dependencies87, createClone;
  var init_clone2 = __esm({
    "node_modules/mathjs/es/function/utils/clone.js"() {
      init_object();
      init_factory();
      name98 = "clone";
      dependencies87 = ["typed"];
      createClone = /* @__PURE__ */ factory(name98, dependencies87, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name98, {
          any: clone
        });
      });
    }
  });

  // node_modules/mathjs/es/function/utils/isNumeric.js
  var name99, dependencies88, createIsNumeric;
  var init_isNumeric2 = __esm({
    "node_modules/mathjs/es/function/utils/isNumeric.js"() {
      init_collection();
      init_factory();
      name99 = "isNumeric";
      dependencies88 = ["typed"];
      createIsNumeric = /* @__PURE__ */ factory(name99, dependencies88, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name99, {
          "number | BigNumber | Fraction | boolean": function numberBigNumberFractionBoolean() {
            return true;
          },
          "Complex | Unit | string | null | undefined | Node": function ComplexUnitStringNullUndefinedNode() {
            return false;
          },
          "Array | Matrix": function ArrayMatrix(x3) {
            return deepMap(x3, this);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/utils/hasNumericValue.js
  var name100, dependencies89, createHasNumericValue;
  var init_hasNumericValue2 = __esm({
    "node_modules/mathjs/es/function/utils/hasNumericValue.js"() {
      init_factory();
      name100 = "hasNumericValue";
      dependencies89 = ["typed", "isNumeric"];
      createHasNumericValue = /* @__PURE__ */ factory(name100, dependencies89, function(_ref) {
        var typed2 = _ref.typed, isNumeric2 = _ref.isNumeric;
        return typed2(name100, {
          string: function string2(x3) {
            return x3.trim().length > 0 && !isNaN(Number(x3));
          },
          any: function any(x3) {
            return isNumeric2(x3);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/utils/typeOf.js
  var name101, dependencies90, createTypeOf;
  var init_typeOf2 = __esm({
    "node_modules/mathjs/es/function/utils/typeOf.js"() {
      init_factory();
      init_is();
      name101 = "typeOf";
      dependencies90 = ["typed"];
      createTypeOf = /* @__PURE__ */ factory(name101, dependencies90, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name101, {
          any: typeOf
        });
      });
    }
  });

  // node_modules/mathjs/es/function/utils/isPrime.js
  var name102, dependencies91, createIsPrime;
  var init_isPrime2 = __esm({
    "node_modules/mathjs/es/function/utils/isPrime.js"() {
      init_collection();
      init_factory();
      name102 = "isPrime";
      dependencies91 = ["typed"];
      createIsPrime = /* @__PURE__ */ factory(name102, dependencies91, function(_ref) {
        var typed2 = _ref.typed;
        return typed2(name102, {
          number: function number2(x3) {
            if (x3 * 0 !== 0) {
              return false;
            }
            if (x3 <= 3) {
              return x3 > 1;
            }
            if (x3 % 2 === 0 || x3 % 3 === 0) {
              return false;
            }
            for (var i3 = 5; i3 * i3 <= x3; i3 += 6) {
              if (x3 % i3 === 0 || x3 % (i3 + 2) === 0) {
                return false;
              }
            }
            return true;
          },
          BigNumber: function BigNumber(n3) {
            if (n3.toNumber() * 0 !== 0) {
              return false;
            }
            if (n3.lte(3))
              return n3.gt(1);
            if (n3.mod(2).eq(0) || n3.mod(3).eq(0))
              return false;
            for (var i3 = 5; n3.gte(i3 * i3); i3 += 6) {
              if (n3.mod(i3).eq(0) || n3.mod(i3 + 2).eq(0)) {
                return false;
              }
            }
            return true;
          },
          "Array | Matrix": function ArrayMatrix(x3) {
            return deepMap(x3, this);
          }
        });
      });
    }
  });

  // node_modules/mathjs/es/function/utils/numeric.js
  var name103, dependencies92, createNumeric;
  var init_numeric2 = __esm({
    "node_modules/mathjs/es/function/utils/numeric.js"() {
      init_is();
      init_factory();
      init_noop();
      name103 = "numeric";
      dependencies92 = ["number", "?bignumber", "?fraction"];
      createNumeric = /* @__PURE__ */ factory(name103, dependencies92, function(_ref) {
        var _number = _ref.number, bignumber = _ref.bignumber, fraction = _ref.fraction;
        var validInputTypes = {
          string: true,
          number: true,
          BigNumber: true,
          Fraction: true
        };
        var validOutputTypes = {
          number: function number2(x3) {
            return _number(x3);
          },
          BigNumber: bignumber ? function(x3) {
            return bignumber(x3);
          } : noBignumber,
          Fraction: fraction ? function(x3) {
            return fraction(x3);
          } : noFraction
        };
        return function numeric3(value, outputType) {
          var inputType = typeOf(value);
          if (!(inputType in validInputTypes)) {
            throw new TypeError("Cannot convert " + value + ' of type "' + inputType + '"; valid input types are ' + Object.keys(validInputTypes).join(", "));
          }
          if (!(outputType in validOutputTypes)) {
            throw new TypeError("Cannot convert " + value + ' to type "' + outputType + '"; valid output types are ' + Object.keys(validOutputTypes).join(", "));
          }
          if (outputType === inputType) {
            return value;
          } else {
            return validOutputTypes[outputType](value);
          }
        };
      });
    }
  });

  // node_modules/mathjs/es/json/reviver.js
  var name104, dependencies93, createReviver;
  var init_reviver = __esm({
    "node_modules/mathjs/es/json/reviver.js"() {
      init_factory();
      name104 = "reviver";
      dependencies93 = ["classes"];
      createReviver = /* @__PURE__ */ factory(name104, dependencies93, function(_ref) {
        var classes2 = _ref.classes;
        return function reviver2(key, value) {
          var constructor = classes2[value && value.mathjs];
          if (constructor && typeof constructor.fromJSON === "function") {
            return constructor.fromJSON(value);
          }
          return value;
        };
      });
    }
  });

  // node_modules/mathjs/es/json/replacer.js
  var name105, dependencies94, createReplacer;
  var init_replacer = __esm({
    "node_modules/mathjs/es/json/replacer.js"() {
      init_factory();
      name105 = "replacer";
      dependencies94 = [];
      createReplacer = /* @__PURE__ */ factory(name105, dependencies94, function() {
        return function replacer3(key, value) {
          if (typeof value === "number" && (!isFinite(value) || isNaN(value))) {
            return {
              mathjs: "number",
              value: String(value)
            };
          }
          return value;
        };
      });
    }
  });

  // node_modules/mathjs/es/factoriesNumber.js
  var factoriesNumber_exports = {};
  __export(factoriesNumber_exports, {
    createAbs: () => createAbs,
    createAccessorNode: () => createAccessorNode,
    createAcos: () => createAcos,
    createAcosh: () => createAcosh,
    createAcot: () => createAcot,
    createAcoth: () => createAcoth,
    createAcsc: () => createAcsc,
    createAcsch: () => createAcsch,
    createAdd: () => createAdd,
    createAddScalar: () => createAddScalar,
    createAnd: () => createAnd,
    createApply: () => createApply,
    createApplyTransform: () => createApplyTransform,
    createArrayNode: () => createArrayNode,
    createAsec: () => createAsec,
    createAsech: () => createAsech,
    createAsin: () => createAsin,
    createAsinh: () => createAsinh,
    createAssignmentNode: () => createAssignmentNode,
    createAtan: () => createAtan,
    createAtan2: () => createAtan2,
    createAtanh: () => createAtanh,
    createBellNumbers: () => createBellNumbers,
    createBitAnd: () => createBitAnd,
    createBitNot: () => createBitNot,
    createBitOr: () => createBitOr,
    createBitXor: () => createBitXor,
    createBlockNode: () => createBlockNode,
    createBoolean: () => createBoolean,
    createCatalan: () => createCatalan,
    createCbrt: () => createCbrt,
    createCeil: () => createCeil,
    createChain: () => createChain,
    createChainClass: () => createChainClass,
    createClone: () => createClone,
    createCombinations: () => createCombinations,
    createCombinationsWithRep: () => createCombinationsWithRep,
    createCompare: () => createCompareNumber,
    createCompareNatural: () => createCompareNatural,
    createCompareText: () => createCompareTextNumber,
    createCompile: () => createCompile,
    createComposition: () => createComposition,
    createConditionalNode: () => createConditionalNode,
    createConstantNode: () => createConstantNode,
    createCos: () => createCos,
    createCosh: () => createCosh,
    createCot: () => createCot,
    createCoth: () => createCoth,
    createCsc: () => createCsc,
    createCsch: () => createCsch,
    createCube: () => createCube,
    createDeepEqual: () => createDeepEqual,
    createDerivative: () => createDerivative,
    createDivide: () => createDivide,
    createDivideScalar: () => createDivideScalar,
    createE: () => createE,
    createEqual: () => createEqualNumber,
    createEqualScalar: () => createEqualScalarNumber,
    createEqualText: () => createEqualText,
    createErf: () => createErf,
    createEvaluate: () => createEvaluate,
    createExp: () => createExp,
    createExpm1: () => createExpm1,
    createFactorial: () => createFactorial,
    createFalse: () => createFalse,
    createFilter: () => createFilter,
    createFilterTransform: () => createFilterTransform,
    createFix: () => createFix,
    createFloor: () => createFloor,
    createForEach: () => createForEach,
    createForEachTransform: () => createForEachTransform,
    createFormat: () => createFormat,
    createFunctionAssignmentNode: () => createFunctionAssignmentNode,
    createFunctionNode: () => createFunctionNode,
    createGamma: () => createGamma,
    createGcd: () => createGcd,
    createHasNumericValue: () => createHasNumericValue,
    createHelp: () => createHelp,
    createHelpClass: () => createHelpClass,
    createHypot: () => createHypot,
    createIndex: () => createIndex,
    createIndexNode: () => createIndexNode,
    createInfinity: () => createInfinity,
    createIsInteger: () => createIsInteger,
    createIsNaN: () => createIsNaN,
    createIsNegative: () => createIsNegative,
    createIsNumeric: () => createIsNumeric,
    createIsPositive: () => createIsPositive,
    createIsPrime: () => createIsPrime,
    createIsZero: () => createIsZero,
    createLN10: () => createLN10,
    createLN2: () => createLN2,
    createLOG10E: () => createLOG10E,
    createLOG2E: () => createLOG2E,
    createLarger: () => createLargerNumber,
    createLargerEq: () => createLargerEqNumber,
    createLcm: () => createLcm,
    createLeftShift: () => createLeftShift,
    createLog: () => createLog,
    createLog10: () => createLog10,
    createLog1p: () => createLog1p,
    createLog2: () => createLog2,
    createMad: () => createMad,
    createMap: () => createMap,
    createMapTransform: () => createMapTransform,
    createMatrix: () => createMatrix,
    createMax: () => createMax,
    createMaxTransform: () => createMaxTransform,
    createMean: () => createMean,
    createMeanTransform: () => createMeanTransform,
    createMedian: () => createMedian,
    createMin: () => createMin,
    createMinTransform: () => createMinTransform,
    createMod: () => createMod,
    createMode: () => createMode,
    createMultinomial: () => createMultinomial,
    createMultiply: () => createMultiply,
    createMultiplyScalar: () => createMultiplyScalar,
    createNaN: () => createNaN,
    createNode: () => createNode,
    createNorm: () => createNorm,
    createNot: () => createNot,
    createNthRoot: () => createNthRootNumber,
    createNull: () => createNull,
    createNumber: () => createNumber,
    createNumeric: () => createNumeric,
    createObjectNode: () => createObjectNode,
    createOperatorNode: () => createOperatorNode,
    createOr: () => createOr,
    createParenthesisNode: () => createParenthesisNode,
    createParse: () => createParse,
    createParser: () => createParser,
    createParserClass: () => createParserClass,
    createPartitionSelect: () => createPartitionSelect,
    createPermutations: () => createPermutations,
    createPhi: () => createPhi,
    createPi: () => createPi,
    createPickRandom: () => createPickRandom,
    createPow: () => createPow,
    createPrint: () => createPrint,
    createProd: () => createProd,
    createQuantileSeq: () => createQuantileSeq,
    createRandom: () => createRandomNumber,
    createRandomInt: () => createRandomInt,
    createRange: () => createRange,
    createRangeClass: () => createRangeClass,
    createRangeNode: () => createRangeNode,
    createRangeTransform: () => createRangeTransform,
    createRationalize: () => createRationalize,
    createRelationalNode: () => createRelationalNode,
    createReplacer: () => createReplacer,
    createResultSet: () => createResultSet,
    createReviver: () => createReviver,
    createRightArithShift: () => createRightArithShift,
    createRightLogShift: () => createRightLogShift,
    createRound: () => createRoundNumber,
    createSQRT1_2: () => createSQRT1_2,
    createSQRT2: () => createSQRT2,
    createSec: () => createSec,
    createSech: () => createSech,
    createSign: () => createSign,
    createSimplify: () => createSimplify,
    createSin: () => createSin,
    createSinh: () => createSinh,
    createSize: () => createSize,
    createSmaller: () => createSmallerNumber,
    createSmallerEq: () => createSmallerEqNumber,
    createSqrt: () => createSqrt,
    createSquare: () => createSquare,
    createStd: () => createStd,
    createStdTransform: () => createStdTransform,
    createStirlingS2: () => createStirlingS2,
    createString: () => createString,
    createSubset: () => createSubset2,
    createSubsetTransform: () => createSubsetTransform,
    createSubtract: () => createSubtract,
    createSum: () => createSum,
    createSumTransform: () => createSumTransform,
    createSymbolNode: () => createSymbolNode,
    createTan: () => createTan,
    createTanh: () => createTanh,
    createTau: () => createTau,
    createTrue: () => createTrue,
    createTypeOf: () => createTypeOf,
    createTyped: () => createTyped,
    createUnaryMinus: () => createUnaryMinus,
    createUnaryPlus: () => createUnaryPlus,
    createUnequal: () => createUnequalNumber,
    createUppercaseE: () => createUppercaseE,
    createUppercasePi: () => createUppercasePi,
    createVariance: () => createVariance,
    createVarianceTransform: () => createVarianceTransform,
    createVersion: () => createVersion,
    createXgcd: () => createXgcd,
    createXor: () => createXor
  });
  function createNumberFactory(name106, fn) {
    return factory(name106, ["typed"], function(_ref) {
      var typed2 = _ref.typed;
      return typed2(fn);
    });
  }
  var createUnaryMinus, createUnaryPlus, createAbs, createAddScalar, createCbrt, createCeil, createCube, createExp, createExpm1, createFix, createFloor, createGcd, createLcm, createLog10, createLog2, createMod, createMultiplyScalar, createMultiply, createSign, createSqrt, createSquare, createSubtract, createXgcd, createDivideScalar, createPow, createLog, createLog1p, createAdd, createNorm, createDivide, createBitAnd, createBitNot, createBitOr, createBitXor, createLeftShift, createRightArithShift, createRightLogShift, createAnd, createNot, createOr, createXor, createIndex, createMatrix, createSubset2, createCombinations, createGamma, createAcos, createAcosh, createAcot, createAcoth, createAcsc, createAcsch, createAsec, createAsech, createAsin, createAsinh, createAtan, createAtan2, createAtanh, createCos, createCosh, createCot, createCoth, createCsc, createCsch, createSec, createSech, createSin, createSinh, createTan, createTanh, createIsInteger, createIsNegative, createIsPositive, createIsZero, createIsNaN;
  var init_factoriesNumber = __esm({
    "node_modules/mathjs/es/factoriesNumber.js"() {
      init_number2();
      init_factory();
      init_noop();
      init_typed();
      init_ResultSet();
      init_Range();
      init_Help();
      init_Chain();
      init_help2();
      init_chain();
      init_simplify2();
      init_derivative2();
      init_rationalize2();
      init_nthRoot2();
      init_round2();
      init_hypot2();
      init_stirlingS22();
      init_bellNumbers2();
      init_catalan2();
      init_composition2();
      init_constants3();
      init_number4();
      init_string3();
      init_boolean2();
      init_parser();
      init_Node();
      init_AccessorNode();
      init_ArrayNode();
      init_AssignmentNode();
      init_BlockNode();
      init_ConditionalNode();
      init_ConstantNode();
      init_FunctionAssignmentNode();
      init_IndexNode();
      init_ObjectNode();
      init_OperatorNode();
      init_ParenthesisNode();
      init_RangeNode();
      init_RelationalNode();
      init_SymbolNode();
      init_FunctionNode();
      init_parse();
      init_compile();
      init_evaluate2();
      init_Parser();
      init_apply();
      init_filter2();
      init_forEach2();
      init_map2();
      init_range2();
      init_size2();
      init_partitionSelect2();
      init_combinationsWithRep2();
      init_factorial2();
      init_multinomial2();
      init_permutations2();
      init_pickRandom2();
      init_random2();
      init_randomInt2();
      init_equalScalar();
      init_compare2();
      init_compareNatural2();
      init_compareText2();
      init_equal2();
      init_equalText2();
      init_smaller2();
      init_smallerEq2();
      init_larger2();
      init_largerEq2();
      init_deepEqual2();
      init_unequal2();
      init_erf2();
      init_mode2();
      init_prod2();
      init_max2();
      init_min2();
      init_sum2();
      init_mean2();
      init_median2();
      init_mad2();
      init_variance2();
      init_quantileSeq2();
      init_std2();
      init_format2();
      init_print();
      init_apply_transform();
      init_filter_transform();
      init_forEach_transform();
      init_map_transform();
      init_max_transform();
      init_mean_transform();
      init_min_transform();
      init_range_transform();
      init_subset_transform();
      init_std_transform();
      init_sum_transform();
      init_variance_transform();
      init_clone2();
      init_isNumeric2();
      init_hasNumericValue2();
      init_typeOf2();
      init_isPrime2();
      init_numeric2();
      init_reviver();
      init_replacer();
      createUnaryMinus = /* @__PURE__ */ createNumberFactory("unaryMinus", unaryMinusNumber);
      createUnaryPlus = /* @__PURE__ */ createNumberFactory("unaryPlus", unaryPlusNumber);
      createAbs = /* @__PURE__ */ createNumberFactory("abs", absNumber);
      createAddScalar = /* @__PURE__ */ createNumberFactory("addScalar", addNumber);
      createCbrt = /* @__PURE__ */ createNumberFactory("cbrt", cbrtNumber);
      createCeil = /* @__PURE__ */ createNumberFactory("ceil", ceilNumber);
      createCube = /* @__PURE__ */ createNumberFactory("cube", cubeNumber);
      createExp = /* @__PURE__ */ createNumberFactory("exp", expNumber);
      createExpm1 = /* @__PURE__ */ createNumberFactory("expm1", expm1Number);
      createFix = /* @__PURE__ */ createNumberFactory("fix", fixNumber);
      createFloor = /* @__PURE__ */ createNumberFactory("floor", floorNumber);
      createGcd = /* @__PURE__ */ createNumberFactory("gcd", gcdNumber);
      createLcm = /* @__PURE__ */ createNumberFactory("lcm", lcmNumber);
      createLog10 = /* @__PURE__ */ createNumberFactory("log10", log10Number);
      createLog2 = /* @__PURE__ */ createNumberFactory("log2", log2Number);
      createMod = /* @__PURE__ */ createNumberFactory("mod", modNumber);
      createMultiplyScalar = /* @__PURE__ */ createNumberFactory("multiplyScalar", multiplyNumber);
      createMultiply = /* @__PURE__ */ createNumberFactory("multiply", multiplyNumber);
      createSign = /* @__PURE__ */ createNumberFactory("sign", signNumber);
      createSqrt = /* @__PURE__ */ createNumberFactory("sqrt", sqrtNumber);
      createSquare = /* @__PURE__ */ createNumberFactory("square", squareNumber);
      createSubtract = /* @__PURE__ */ createNumberFactory("subtract", subtractNumber);
      createXgcd = /* @__PURE__ */ createNumberFactory("xgcd", xgcdNumber);
      createDivideScalar = /* @__PURE__ */ createNumberFactory("divideScalar", divideNumber);
      createPow = /* @__PURE__ */ createNumberFactory("pow", powNumber);
      createLog = /* @__PURE__ */ createNumberFactory("log", logNumber);
      createLog1p = /* @__PURE__ */ createNumberFactory("log1p", log1pNumber);
      createAdd = /* @__PURE__ */ createNumberFactory("add", addNumber);
      createNorm = /* @__PURE__ */ createNumberFactory("norm", normNumber);
      createDivide = /* @__PURE__ */ createNumberFactory("divide", divideNumber);
      createBitAnd = /* @__PURE__ */ createNumberFactory("bitAnd", bitAndNumber);
      createBitNot = /* @__PURE__ */ createNumberFactory("bitNot", bitNotNumber);
      createBitOr = /* @__PURE__ */ createNumberFactory("bitOr", bitOrNumber);
      createBitXor = /* @__PURE__ */ createNumberFactory("bitXor", bitXorNumber);
      createLeftShift = /* @__PURE__ */ createNumberFactory("leftShift", leftShiftNumber);
      createRightArithShift = /* @__PURE__ */ createNumberFactory("rightArithShift", rightArithShiftNumber);
      createRightLogShift = /* @__PURE__ */ createNumberFactory("rightLogShift", rightLogShiftNumber);
      createAnd = /* @__PURE__ */ createNumberFactory("and", andNumber);
      createNot = /* @__PURE__ */ createNumberFactory("not", notNumber);
      createOr = /* @__PURE__ */ createNumberFactory("or", orNumber);
      createXor = /* @__PURE__ */ createNumberFactory("xor", xorNumber);
      createIndex = /* @__PURE__ */ factory("index", [], function() {
        return noIndex;
      });
      createMatrix = /* @__PURE__ */ factory("matrix", [], function() {
        return noMatrix;
      });
      createSubset2 = /* @__PURE__ */ factory("subset", [], function() {
        return noSubset;
      });
      createCombinations = createNumberFactory("combinations", combinationsNumber);
      createGamma = createNumberFactory("gamma", gammaNumber);
      createAcos = /* @__PURE__ */ createNumberFactory("acos", acosNumber);
      createAcosh = /* @__PURE__ */ createNumberFactory("acosh", acoshNumber);
      createAcot = /* @__PURE__ */ createNumberFactory("acot", acotNumber);
      createAcoth = /* @__PURE__ */ createNumberFactory("acoth", acothNumber);
      createAcsc = /* @__PURE__ */ createNumberFactory("acsc", acscNumber);
      createAcsch = /* @__PURE__ */ createNumberFactory("acsch", acschNumber);
      createAsec = /* @__PURE__ */ createNumberFactory("asec", asecNumber);
      createAsech = /* @__PURE__ */ createNumberFactory("asech", asechNumber);
      createAsin = /* @__PURE__ */ createNumberFactory("asin", asinNumber);
      createAsinh = /* @__PURE__ */ createNumberFactory("asinh", asinhNumber);
      createAtan = /* @__PURE__ */ createNumberFactory("atan", atanNumber);
      createAtan2 = /* @__PURE__ */ createNumberFactory("atan2", atan2Number);
      createAtanh = /* @__PURE__ */ createNumberFactory("atanh", atanhNumber);
      createCos = /* @__PURE__ */ createNumberFactory("cos", cosNumber);
      createCosh = /* @__PURE__ */ createNumberFactory("cosh", coshNumber);
      createCot = /* @__PURE__ */ createNumberFactory("cot", cotNumber);
      createCoth = /* @__PURE__ */ createNumberFactory("coth", cothNumber);
      createCsc = /* @__PURE__ */ createNumberFactory("csc", cscNumber);
      createCsch = /* @__PURE__ */ createNumberFactory("csch", cschNumber);
      createSec = /* @__PURE__ */ createNumberFactory("sec", secNumber);
      createSech = /* @__PURE__ */ createNumberFactory("sech", sechNumber);
      createSin = /* @__PURE__ */ createNumberFactory("sin", sinNumber);
      createSinh = /* @__PURE__ */ createNumberFactory("sinh", sinhNumber);
      createTan = /* @__PURE__ */ createNumberFactory("tan", tanNumber);
      createTanh = /* @__PURE__ */ createNumberFactory("tanh", tanhNumber);
      createIsInteger = /* @__PURE__ */ createNumberFactory("isInteger", isIntegerNumber);
      createIsNegative = /* @__PURE__ */ createNumberFactory("isNegative", isNegativeNumber);
      createIsPositive = /* @__PURE__ */ createNumberFactory("isPositive", isPositiveNumber);
      createIsZero = /* @__PURE__ */ createNumberFactory("isZero", isZeroNumber);
      createIsNaN = /* @__PURE__ */ createNumberFactory("isNaN", isNaNNumber);
    }
  });

  // node_modules/mathjs/es/entry/pureFunctionsNumber.generated.js
  var typed, Range2, nthRoot, e4, _false, LN10, LOG10E, _NaN, phi2, SQRT1_2, tau2, version2, string, filter2, map2, combinationsWithRep, pickRandom, randomInt, compare, compareText2, smaller, larger, erf, format4, clone2, typeOf2, unaryMinus, abs, cbrt3, cube, expm13, floor, lcm, log23, multiplyScalar, sign2, square, xgcd, pow, log1p2, norm, bitAnd, bitOr, leftShift, rightLogShift, not, xor, matrix, combinations, acos, acot, acsc, asec, asin, atan, atanh2, cosh2, coth, csch, sech, sinh2, tanh2, isNegative, isZero, ResultSet, round, LN2, _null, SQRT2, number, forEach2, size, random, compareNatural, equalText, largerEq, print, isNumeric, isPrime, replacer2, addScalar, exp, gcd, mod, sqrt, divideScalar, add, bitNot, rightArithShift, or, subset, acosh2, acsch, asinh2, cos, csc, sin, isInteger2, isNaN2, catalan, _Infinity, pi2, _true, apply, partitionSelect, equalScalar, smallerEq, unequal, hasNumericValue, unaryPlus, fix, multiply, log, bitXor, index, acoth, atan2, sec, isPositive, hypot, composition, range, equal2, mode, quantileSeq, numeric2, log103, divide, gamma, cot, LOG2E, factorial, permutations, prod, min, mean, ceil, and, tan, _boolean, multinomial, max, median, subtract, deepEqual2, mad, stirlingS2, variance, std, bellNumbers, asech, sum;
  var init_pureFunctionsNumber_generated = __esm({
    "node_modules/mathjs/es/entry/pureFunctionsNumber.generated.js"() {
      init_configReadonly();
      init_factoriesNumber();
      typed = /* @__PURE__ */ createTyped({});
      Range2 = /* @__PURE__ */ createRangeClass({});
      nthRoot = /* @__PURE__ */ createNthRootNumber({
        typed
      });
      e4 = /* @__PURE__ */ createE({
        config
      });
      _false = /* @__PURE__ */ createFalse({});
      LN10 = /* @__PURE__ */ createLN10({
        config
      });
      LOG10E = /* @__PURE__ */ createLOG10E({
        config
      });
      _NaN = /* @__PURE__ */ createNaN({
        config
      });
      phi2 = /* @__PURE__ */ createPhi({
        config
      });
      SQRT1_2 = /* @__PURE__ */ createSQRT1_2({
        config
      });
      tau2 = /* @__PURE__ */ createTau({
        config
      });
      version2 = /* @__PURE__ */ createVersion({});
      string = /* @__PURE__ */ createString({
        typed
      });
      filter2 = /* @__PURE__ */ createFilter({
        typed
      });
      map2 = /* @__PURE__ */ createMap({
        typed
      });
      combinationsWithRep = /* @__PURE__ */ createCombinationsWithRep({
        typed
      });
      pickRandom = /* @__PURE__ */ createPickRandom({
        config,
        typed
      });
      randomInt = /* @__PURE__ */ createRandomInt({
        config,
        typed
      });
      compare = /* @__PURE__ */ createCompareNumber({
        config,
        typed
      });
      compareText2 = /* @__PURE__ */ createCompareTextNumber({
        typed
      });
      smaller = /* @__PURE__ */ createSmallerNumber({
        config,
        typed
      });
      larger = /* @__PURE__ */ createLargerNumber({
        config,
        typed
      });
      erf = /* @__PURE__ */ createErf({
        typed
      });
      format4 = /* @__PURE__ */ createFormat({
        typed
      });
      clone2 = /* @__PURE__ */ createClone({
        typed
      });
      typeOf2 = /* @__PURE__ */ createTypeOf({
        typed
      });
      unaryMinus = /* @__PURE__ */ createUnaryMinus({
        typed
      });
      abs = /* @__PURE__ */ createAbs({
        typed
      });
      cbrt3 = /* @__PURE__ */ createCbrt({
        typed
      });
      cube = /* @__PURE__ */ createCube({
        typed
      });
      expm13 = /* @__PURE__ */ createExpm1({
        typed
      });
      floor = /* @__PURE__ */ createFloor({
        typed
      });
      lcm = /* @__PURE__ */ createLcm({
        typed
      });
      log23 = /* @__PURE__ */ createLog2({
        typed
      });
      multiplyScalar = /* @__PURE__ */ createMultiplyScalar({
        typed
      });
      sign2 = /* @__PURE__ */ createSign({
        typed
      });
      square = /* @__PURE__ */ createSquare({
        typed
      });
      xgcd = /* @__PURE__ */ createXgcd({
        typed
      });
      pow = /* @__PURE__ */ createPow({
        typed
      });
      log1p2 = /* @__PURE__ */ createLog1p({
        typed
      });
      norm = /* @__PURE__ */ createNorm({
        typed
      });
      bitAnd = /* @__PURE__ */ createBitAnd({
        typed
      });
      bitOr = /* @__PURE__ */ createBitOr({
        typed
      });
      leftShift = /* @__PURE__ */ createLeftShift({
        typed
      });
      rightLogShift = /* @__PURE__ */ createRightLogShift({
        typed
      });
      not = /* @__PURE__ */ createNot({
        typed
      });
      xor = /* @__PURE__ */ createXor({
        typed
      });
      matrix = /* @__PURE__ */ createMatrix({});
      combinations = /* @__PURE__ */ createCombinations({
        typed
      });
      acos = /* @__PURE__ */ createAcos({
        typed
      });
      acot = /* @__PURE__ */ createAcot({
        typed
      });
      acsc = /* @__PURE__ */ createAcsc({
        typed
      });
      asec = /* @__PURE__ */ createAsec({
        typed
      });
      asin = /* @__PURE__ */ createAsin({
        typed
      });
      atan = /* @__PURE__ */ createAtan({
        typed
      });
      atanh2 = /* @__PURE__ */ createAtanh({
        typed
      });
      cosh2 = /* @__PURE__ */ createCosh({
        typed
      });
      coth = /* @__PURE__ */ createCoth({
        typed
      });
      csch = /* @__PURE__ */ createCsch({
        typed
      });
      sech = /* @__PURE__ */ createSech({
        typed
      });
      sinh2 = /* @__PURE__ */ createSinh({
        typed
      });
      tanh2 = /* @__PURE__ */ createTanh({
        typed
      });
      isNegative = /* @__PURE__ */ createIsNegative({
        typed
      });
      isZero = /* @__PURE__ */ createIsZero({
        typed
      });
      ResultSet = /* @__PURE__ */ createResultSet({});
      round = /* @__PURE__ */ createRoundNumber({
        typed
      });
      LN2 = /* @__PURE__ */ createLN2({
        config
      });
      _null = /* @__PURE__ */ createNull({});
      SQRT2 = /* @__PURE__ */ createSQRT2({
        config
      });
      number = /* @__PURE__ */ createNumber({
        typed
      });
      forEach2 = /* @__PURE__ */ createForEach({
        typed
      });
      size = /* @__PURE__ */ createSize({
        matrix,
        config,
        typed
      });
      random = /* @__PURE__ */ createRandomNumber({
        config,
        typed
      });
      compareNatural = /* @__PURE__ */ createCompareNatural({
        compare,
        typed
      });
      equalText = /* @__PURE__ */ createEqualText({
        compareText: compareText2,
        isZero,
        typed
      });
      largerEq = /* @__PURE__ */ createLargerEqNumber({
        config,
        typed
      });
      print = /* @__PURE__ */ createPrint({
        typed
      });
      isNumeric = /* @__PURE__ */ createIsNumeric({
        typed
      });
      isPrime = /* @__PURE__ */ createIsPrime({
        typed
      });
      replacer2 = /* @__PURE__ */ createReplacer({});
      addScalar = /* @__PURE__ */ createAddScalar({
        typed
      });
      exp = /* @__PURE__ */ createExp({
        typed
      });
      gcd = /* @__PURE__ */ createGcd({
        typed
      });
      mod = /* @__PURE__ */ createMod({
        typed
      });
      sqrt = /* @__PURE__ */ createSqrt({
        typed
      });
      divideScalar = /* @__PURE__ */ createDivideScalar({
        typed
      });
      add = /* @__PURE__ */ createAdd({
        typed
      });
      bitNot = /* @__PURE__ */ createBitNot({
        typed
      });
      rightArithShift = /* @__PURE__ */ createRightArithShift({
        typed
      });
      or = /* @__PURE__ */ createOr({
        typed
      });
      subset = /* @__PURE__ */ createSubset2({});
      acosh2 = /* @__PURE__ */ createAcosh({
        typed
      });
      acsch = /* @__PURE__ */ createAcsch({
        typed
      });
      asinh2 = /* @__PURE__ */ createAsinh({
        typed
      });
      cos = /* @__PURE__ */ createCos({
        typed
      });
      csc = /* @__PURE__ */ createCsc({
        typed
      });
      sin = /* @__PURE__ */ createSin({
        typed
      });
      isInteger2 = /* @__PURE__ */ createIsInteger({
        typed
      });
      isNaN2 = /* @__PURE__ */ createIsNaN({
        typed
      });
      catalan = /* @__PURE__ */ createCatalan({
        addScalar,
        combinations,
        divideScalar,
        isInteger: isInteger2,
        isNegative,
        multiplyScalar,
        typed
      });
      _Infinity = /* @__PURE__ */ createInfinity({
        config
      });
      pi2 = /* @__PURE__ */ createPi({
        config
      });
      _true = /* @__PURE__ */ createTrue({});
      apply = /* @__PURE__ */ createApply({
        isInteger: isInteger2,
        typed
      });
      partitionSelect = /* @__PURE__ */ createPartitionSelect({
        compare,
        isNaN: isNaN2,
        isNumeric,
        typed
      });
      equalScalar = /* @__PURE__ */ createEqualScalarNumber({
        config,
        typed
      });
      smallerEq = /* @__PURE__ */ createSmallerEqNumber({
        config,
        typed
      });
      unequal = /* @__PURE__ */ createUnequalNumber({
        equalScalar,
        typed
      });
      hasNumericValue = /* @__PURE__ */ createHasNumericValue({
        isNumeric,
        typed
      });
      unaryPlus = /* @__PURE__ */ createUnaryPlus({
        typed
      });
      fix = /* @__PURE__ */ createFix({
        typed
      });
      multiply = /* @__PURE__ */ createMultiply({
        typed
      });
      log = /* @__PURE__ */ createLog({
        typed
      });
      bitXor = /* @__PURE__ */ createBitXor({
        typed
      });
      index = /* @__PURE__ */ createIndex({});
      acoth = /* @__PURE__ */ createAcoth({
        typed
      });
      atan2 = /* @__PURE__ */ createAtan2({
        typed
      });
      sec = /* @__PURE__ */ createSec({
        typed
      });
      isPositive = /* @__PURE__ */ createIsPositive({
        typed
      });
      hypot = /* @__PURE__ */ createHypot({
        abs,
        addScalar,
        divideScalar,
        isPositive,
        multiplyScalar,
        smaller,
        sqrt,
        typed
      });
      composition = /* @__PURE__ */ createComposition({
        addScalar,
        combinations,
        isInteger: isInteger2,
        isNegative,
        isPositive,
        larger,
        typed
      });
      range = /* @__PURE__ */ createRange({
        matrix,
        config,
        larger,
        largerEq,
        smaller,
        smallerEq,
        typed
      });
      equal2 = /* @__PURE__ */ createEqualNumber({
        equalScalar,
        typed
      });
      mode = /* @__PURE__ */ createMode({
        isNaN: isNaN2,
        isNumeric,
        typed
      });
      quantileSeq = /* @__PURE__ */ createQuantileSeq({
        add,
        compare,
        multiply,
        partitionSelect,
        typed
      });
      numeric2 = /* @__PURE__ */ createNumeric({
        number
      });
      log103 = /* @__PURE__ */ createLog10({
        typed
      });
      divide = /* @__PURE__ */ createDivide({
        typed
      });
      gamma = /* @__PURE__ */ createGamma({
        typed
      });
      cot = /* @__PURE__ */ createCot({
        typed
      });
      LOG2E = /* @__PURE__ */ createLOG2E({
        config
      });
      factorial = /* @__PURE__ */ createFactorial({
        gamma,
        typed
      });
      permutations = /* @__PURE__ */ createPermutations({
        factorial,
        typed
      });
      prod = /* @__PURE__ */ createProd({
        config,
        multiplyScalar,
        numeric: numeric2,
        typed
      });
      min = /* @__PURE__ */ createMin({
        config,
        numeric: numeric2,
        smaller,
        typed
      });
      mean = /* @__PURE__ */ createMean({
        add,
        divide,
        typed
      });
      ceil = /* @__PURE__ */ createCeil({
        typed
      });
      and = /* @__PURE__ */ createAnd({
        typed
      });
      tan = /* @__PURE__ */ createTan({
        typed
      });
      _boolean = /* @__PURE__ */ createBoolean({
        typed
      });
      multinomial = /* @__PURE__ */ createMultinomial({
        add,
        divide,
        factorial,
        isInteger: isInteger2,
        isPositive,
        multiply,
        typed
      });
      max = /* @__PURE__ */ createMax({
        config,
        larger,
        numeric: numeric2,
        typed
      });
      median = /* @__PURE__ */ createMedian({
        add,
        compare,
        divide,
        partitionSelect,
        typed
      });
      subtract = /* @__PURE__ */ createSubtract({
        typed
      });
      deepEqual2 = /* @__PURE__ */ createDeepEqual({
        equal: equal2,
        typed
      });
      mad = /* @__PURE__ */ createMad({
        abs,
        map: map2,
        median,
        subtract,
        typed
      });
      stirlingS2 = /* @__PURE__ */ createStirlingS2({
        addScalar,
        combinations,
        divideScalar,
        factorial,
        isInteger: isInteger2,
        isNegative,
        larger,
        multiplyScalar,
        pow,
        subtract,
        typed
      });
      variance = /* @__PURE__ */ createVariance({
        add,
        apply,
        divide,
        isNaN: isNaN2,
        multiply,
        subtract,
        typed
      });
      std = /* @__PURE__ */ createStd({
        sqrt,
        typed,
        variance
      });
      bellNumbers = /* @__PURE__ */ createBellNumbers({
        addScalar,
        isInteger: isInteger2,
        isNegative,
        stirlingS2,
        typed
      });
      asech = /* @__PURE__ */ createAsech({
        typed
      });
      sum = /* @__PURE__ */ createSum({
        add,
        config,
        numeric: numeric2,
        typed
      });
    }
  });

  // node_modules/mathjs/es/entry/impureFunctionsNumber.generated.js
  function _extends4() {
    _extends4 = Object.assign || function(target) {
      for (var i3 = 1; i3 < arguments.length; i3++) {
        var source = arguments[i3];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends4.apply(this, arguments);
  }
  var math, mathWithTransform, classes, Chain, chain, Node2, ArrayNode, ConditionalNode, FunctionAssignmentNode, ObjectNode, ParenthesisNode, RelationalNode, reviver, BlockNode, OperatorNode, SymbolNode, AccessorNode, ConstantNode, RangeNode, AssignmentNode, FunctionNode, IndexNode, parse, evaluate, Help, simplify, rationalize, compile, help, Parser, derivative, parser;
  var init_impureFunctionsNumber_generated = __esm({
    "node_modules/mathjs/es/entry/impureFunctionsNumber.generated.js"() {
      init_configReadonly();
      init_factoriesNumber();
      init_pureFunctionsNumber_generated();
      init_embeddedDocs();
      math = {};
      mathWithTransform = {};
      classes = {};
      Chain = createChainClass({
        math
      });
      chain = createChain({
        Chain,
        typed
      });
      Node2 = createNode({
        mathWithTransform
      });
      ArrayNode = createArrayNode({
        Node: Node2
      });
      ConditionalNode = createConditionalNode({
        Node: Node2
      });
      FunctionAssignmentNode = createFunctionAssignmentNode({
        Node: Node2,
        typed
      });
      ObjectNode = createObjectNode({
        Node: Node2
      });
      ParenthesisNode = createParenthesisNode({
        Node: Node2
      });
      RelationalNode = createRelationalNode({
        Node: Node2
      });
      reviver = createReviver({
        classes
      });
      BlockNode = createBlockNode({
        Node: Node2,
        ResultSet
      });
      OperatorNode = createOperatorNode({
        Node: Node2
      });
      SymbolNode = createSymbolNode({
        Node: Node2,
        math
      });
      AccessorNode = createAccessorNode({
        Node: Node2,
        subset
      });
      ConstantNode = createConstantNode({
        Node: Node2
      });
      RangeNode = createRangeNode({
        Node: Node2
      });
      AssignmentNode = createAssignmentNode({
        matrix,
        Node: Node2,
        subset
      });
      FunctionNode = createFunctionNode({
        Node: Node2,
        SymbolNode,
        math
      });
      IndexNode = createIndexNode({
        Node: Node2,
        Range: Range2,
        size
      });
      parse = createParse({
        AccessorNode,
        ArrayNode,
        AssignmentNode,
        BlockNode,
        ConditionalNode,
        ConstantNode,
        FunctionAssignmentNode,
        FunctionNode,
        IndexNode,
        ObjectNode,
        OperatorNode,
        ParenthesisNode,
        RangeNode,
        RelationalNode,
        SymbolNode,
        config,
        numeric: numeric2,
        typed
      });
      evaluate = createEvaluate({
        parse,
        typed
      });
      Help = createHelpClass({
        parse
      });
      simplify = createSimplify({
        ConstantNode,
        FunctionNode,
        OperatorNode,
        ParenthesisNode,
        SymbolNode,
        add,
        config,
        divide,
        equal: equal2,
        isZero,
        mathWithTransform,
        multiply,
        parse,
        pow,
        subtract,
        typed
      });
      rationalize = createRationalize({
        ConstantNode,
        FunctionNode,
        OperatorNode,
        ParenthesisNode,
        SymbolNode,
        add,
        config,
        divide,
        equal: equal2,
        isZero,
        mathWithTransform,
        multiply,
        parse,
        pow,
        simplify,
        subtract,
        typed
      });
      compile = createCompile({
        parse,
        typed
      });
      help = createHelp({
        Help,
        mathWithTransform,
        typed
      });
      Parser = createParserClass({
        parse
      });
      derivative = createDerivative({
        ConstantNode,
        FunctionNode,
        OperatorNode,
        ParenthesisNode,
        SymbolNode,
        config,
        equal: equal2,
        isZero,
        numeric: numeric2,
        parse,
        simplify,
        typed
      });
      parser = createParser({
        Parser,
        typed
      });
      _extends4(math, {
        typed,
        chain,
        nthRoot,
        e: e4,
        "false": _false,
        LN10,
        LOG10E,
        NaN: _NaN,
        phi: phi2,
        SQRT1_2,
        tau: tau2,
        version: version2,
        string,
        filter: filter2,
        map: map2,
        combinationsWithRep,
        pickRandom,
        randomInt,
        compare,
        compareText: compareText2,
        smaller,
        larger,
        erf,
        format: format4,
        clone: clone2,
        typeOf: typeOf2,
        reviver,
        unaryMinus,
        abs,
        cbrt: cbrt3,
        cube,
        expm1: expm13,
        floor,
        lcm,
        log2: log23,
        multiplyScalar,
        sign: sign2,
        square,
        xgcd,
        pow,
        log1p: log1p2,
        norm,
        bitAnd,
        bitOr,
        leftShift,
        rightLogShift,
        not,
        xor,
        matrix,
        combinations,
        acos,
        acot,
        acsc,
        asec,
        asin,
        atan,
        atanh: atanh2,
        cosh: cosh2,
        coth,
        csch,
        sech,
        sinh: sinh2,
        tanh: tanh2,
        isNegative,
        isZero,
        round,
        "E": e4,
        LN2,
        "null": _null,
        SQRT2,
        number,
        forEach: forEach2,
        size,
        random,
        compareNatural,
        equalText,
        largerEq,
        print,
        isNumeric,
        isPrime,
        replacer: replacer2,
        addScalar,
        exp,
        gcd,
        mod,
        sqrt,
        divideScalar,
        add,
        bitNot,
        rightArithShift,
        or,
        subset,
        acosh: acosh2,
        acsch,
        asinh: asinh2,
        cos,
        csc,
        sin,
        isInteger: isInteger2,
        isNaN: isNaN2,
        catalan,
        Infinity: _Infinity,
        pi: pi2,
        "true": _true,
        apply,
        partitionSelect,
        equalScalar,
        smallerEq,
        unequal,
        hasNumericValue,
        unaryPlus,
        fix,
        multiply,
        log,
        bitXor,
        index,
        acoth,
        atan2,
        sec,
        isPositive,
        hypot,
        composition,
        "PI": pi2,
        range,
        equal: equal2,
        mode,
        quantileSeq,
        numeric: numeric2,
        log10: log103,
        divide,
        gamma,
        cot,
        LOG2E,
        factorial,
        permutations,
        prod,
        min,
        mean,
        ceil,
        and,
        tan,
        "boolean": _boolean,
        parse,
        evaluate,
        multinomial,
        max,
        median,
        subtract,
        simplify,
        rationalize,
        compile,
        deepEqual: deepEqual2,
        mad,
        help,
        stirlingS2,
        variance,
        derivative,
        parser,
        std,
        bellNumbers,
        asech,
        sum,
        config
      });
      _extends4(mathWithTransform, math, {
        filter: createFilterTransform({
          typed
        }),
        map: createMapTransform({
          typed
        }),
        forEach: createForEachTransform({
          typed
        }),
        subset: createSubsetTransform({
          matrix,
          typed
        }),
        apply: createApplyTransform({
          isInteger: isInteger2,
          typed
        }),
        range: createRangeTransform({
          matrix,
          config,
          larger,
          largerEq,
          smaller,
          smallerEq,
          typed
        }),
        max: createMaxTransform({
          config,
          larger,
          numeric: numeric2,
          typed
        }),
        min: createMinTransform({
          config,
          numeric: numeric2,
          smaller,
          typed
        }),
        sum: createSumTransform({
          add,
          config,
          numeric: numeric2,
          typed
        }),
        mean: createMeanTransform({
          add,
          divide,
          typed
        }),
        variance: createVarianceTransform({
          add,
          apply,
          divide,
          isNaN: isNaN2,
          multiply,
          subtract,
          typed
        }),
        std: createStdTransform({
          sqrt,
          typed,
          variance
        })
      });
      _extends4(classes, {
        Range: Range2,
        Chain,
        Node: Node2,
        ArrayNode,
        ConditionalNode,
        FunctionAssignmentNode,
        ObjectNode,
        ParenthesisNode,
        RelationalNode,
        ResultSet,
        BlockNode,
        OperatorNode,
        SymbolNode,
        AccessorNode,
        ConstantNode,
        RangeNode,
        AssignmentNode,
        FunctionNode,
        IndexNode,
        Help,
        Parser
      });
      Chain.createProxy(math);
    }
  });

  // node_modules/mathjs/es/entry/typeChecks.js
  var init_typeChecks = __esm({
    "node_modules/mathjs/es/entry/typeChecks.js"() {
      init_is();
    }
  });

  // node_modules/mathjs/es/error/ArgumentsError.js
  function ArgumentsError(fn, count, min2, max2) {
    if (!(this instanceof ArgumentsError)) {
      throw new SyntaxError("Constructor must be called with the new operator");
    }
    this.fn = fn;
    this.count = count;
    this.min = min2;
    this.max = max2;
    this.message = "Wrong number of arguments in function " + fn + " (" + count + " provided, " + min2 + (max2 !== void 0 && max2 !== null ? "-" + max2 : "") + " expected)";
    this.stack = new Error().stack;
  }
  var init_ArgumentsError = __esm({
    "node_modules/mathjs/es/error/ArgumentsError.js"() {
      ArgumentsError.prototype = new Error();
      ArgumentsError.prototype.constructor = Error;
      ArgumentsError.prototype.name = "ArgumentsError";
      ArgumentsError.prototype.isArgumentsError = true;
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTyped.generated.js
  var typedDependencies;
  var init_dependenciesTyped_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTyped.generated.js"() {
      init_factoriesNumber();
      typedDependencies = {
        createTyped
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesResultSet.generated.js
  var ResultSetDependencies;
  var init_dependenciesResultSet_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesResultSet.generated.js"() {
      init_factoriesNumber();
      ResultSetDependencies = {
        createResultSet
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRangeClass.generated.js
  var RangeDependencies;
  var init_dependenciesRangeClass_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRangeClass.generated.js"() {
      init_factoriesNumber();
      RangeDependencies = {
        createRangeClass
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNode.generated.js
  var NodeDependencies;
  var init_dependenciesNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNode.generated.js"() {
      init_factoriesNumber();
      NodeDependencies = {
        createNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMatrix.generated.js
  var matrixDependencies;
  var init_dependenciesMatrix_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMatrix.generated.js"() {
      init_factoriesNumber();
      matrixDependencies = {
        createMatrix
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSubsetTransform.generated.js
  var subsetTransformDependencies;
  var init_dependenciesSubsetTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSubsetTransform.generated.js"() {
      init_dependenciesMatrix_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      subsetTransformDependencies = {
        matrixDependencies,
        typedDependencies,
        createSubsetTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAccessorNode.generated.js
  var AccessorNodeDependencies;
  var init_dependenciesAccessorNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAccessorNode.generated.js"() {
      init_dependenciesNode_generated();
      init_dependenciesSubsetTransform_generated();
      init_factoriesNumber();
      AccessorNodeDependencies = {
        NodeDependencies,
        subsetTransformDependencies,
        createAccessorNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesArrayNode.generated.js
  var ArrayNodeDependencies;
  var init_dependenciesArrayNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesArrayNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      ArrayNodeDependencies = {
        NodeDependencies,
        createArrayNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAssignmentNode.generated.js
  var AssignmentNodeDependencies;
  var init_dependenciesAssignmentNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAssignmentNode.generated.js"() {
      init_dependenciesMatrix_generated();
      init_dependenciesNode_generated();
      init_dependenciesSubsetTransform_generated();
      init_factoriesNumber();
      AssignmentNodeDependencies = {
        matrixDependencies,
        NodeDependencies,
        subsetTransformDependencies,
        createAssignmentNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBlockNode.generated.js
  var BlockNodeDependencies;
  var init_dependenciesBlockNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBlockNode.generated.js"() {
      init_dependenciesNode_generated();
      init_dependenciesResultSet_generated();
      init_factoriesNumber();
      BlockNodeDependencies = {
        NodeDependencies,
        ResultSetDependencies,
        createBlockNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesConditionalNode.generated.js
  var ConditionalNodeDependencies;
  var init_dependenciesConditionalNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesConditionalNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      ConditionalNodeDependencies = {
        NodeDependencies,
        createConditionalNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesConstantNode.generated.js
  var ConstantNodeDependencies;
  var init_dependenciesConstantNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesConstantNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      ConstantNodeDependencies = {
        NodeDependencies,
        createConstantNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFunctionAssignmentNode.generated.js
  var FunctionAssignmentNodeDependencies;
  var init_dependenciesFunctionAssignmentNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFunctionAssignmentNode.generated.js"() {
      init_dependenciesNode_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      FunctionAssignmentNodeDependencies = {
        NodeDependencies,
        typedDependencies,
        createFunctionAssignmentNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSymbolNode.generated.js
  var SymbolNodeDependencies;
  var init_dependenciesSymbolNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSymbolNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      SymbolNodeDependencies = {
        NodeDependencies,
        createSymbolNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFunctionNode.generated.js
  var FunctionNodeDependencies;
  var init_dependenciesFunctionNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFunctionNode.generated.js"() {
      init_dependenciesNode_generated();
      init_dependenciesSymbolNode_generated();
      init_factoriesNumber();
      FunctionNodeDependencies = {
        NodeDependencies,
        SymbolNodeDependencies,
        createFunctionNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSize.generated.js
  var sizeDependencies;
  var init_dependenciesSize_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSize.generated.js"() {
      init_dependenciesMatrix_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      sizeDependencies = {
        matrixDependencies,
        typedDependencies,
        createSize
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIndexNode.generated.js
  var IndexNodeDependencies;
  var init_dependenciesIndexNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIndexNode.generated.js"() {
      init_dependenciesNode_generated();
      init_dependenciesRangeClass_generated();
      init_dependenciesSize_generated();
      init_factoriesNumber();
      IndexNodeDependencies = {
        NodeDependencies,
        RangeDependencies,
        sizeDependencies,
        createIndexNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesObjectNode.generated.js
  var ObjectNodeDependencies;
  var init_dependenciesObjectNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesObjectNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      ObjectNodeDependencies = {
        NodeDependencies,
        createObjectNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesOperatorNode.generated.js
  var OperatorNodeDependencies;
  var init_dependenciesOperatorNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesOperatorNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      OperatorNodeDependencies = {
        NodeDependencies,
        createOperatorNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParenthesisNode.generated.js
  var ParenthesisNodeDependencies;
  var init_dependenciesParenthesisNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParenthesisNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      ParenthesisNodeDependencies = {
        NodeDependencies,
        createParenthesisNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRangeNode.generated.js
  var RangeNodeDependencies;
  var init_dependenciesRangeNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRangeNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      RangeNodeDependencies = {
        NodeDependencies,
        createRangeNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRelationalNode.generated.js
  var RelationalNodeDependencies;
  var init_dependenciesRelationalNode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRelationalNode.generated.js"() {
      init_dependenciesNode_generated();
      init_factoriesNumber();
      RelationalNodeDependencies = {
        NodeDependencies,
        createRelationalNode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNumber.generated.js
  var numberDependencies;
  var init_dependenciesNumber_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNumber.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      numberDependencies = {
        typedDependencies,
        createNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNumeric.generated.js
  var numericDependencies;
  var init_dependenciesNumeric_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNumeric.generated.js"() {
      init_dependenciesNumber_generated();
      init_factoriesNumber();
      numericDependencies = {
        numberDependencies,
        createNumeric
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParse.generated.js
  var parseDependencies;
  var init_dependenciesParse_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParse.generated.js"() {
      init_dependenciesAccessorNode_generated();
      init_dependenciesArrayNode_generated();
      init_dependenciesAssignmentNode_generated();
      init_dependenciesBlockNode_generated();
      init_dependenciesConditionalNode_generated();
      init_dependenciesConstantNode_generated();
      init_dependenciesFunctionAssignmentNode_generated();
      init_dependenciesFunctionNode_generated();
      init_dependenciesIndexNode_generated();
      init_dependenciesObjectNode_generated();
      init_dependenciesOperatorNode_generated();
      init_dependenciesParenthesisNode_generated();
      init_dependenciesRangeNode_generated();
      init_dependenciesRelationalNode_generated();
      init_dependenciesSymbolNode_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      parseDependencies = {
        AccessorNodeDependencies,
        ArrayNodeDependencies,
        AssignmentNodeDependencies,
        BlockNodeDependencies,
        ConditionalNodeDependencies,
        ConstantNodeDependencies,
        FunctionAssignmentNodeDependencies,
        FunctionNodeDependencies,
        IndexNodeDependencies,
        ObjectNodeDependencies,
        OperatorNodeDependencies,
        ParenthesisNodeDependencies,
        RangeNodeDependencies,
        RelationalNodeDependencies,
        SymbolNodeDependencies,
        numericDependencies,
        typedDependencies,
        createParse
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHelpClass.generated.js
  var HelpDependencies;
  var init_dependenciesHelpClass_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHelpClass.generated.js"() {
      init_dependenciesParse_generated();
      init_factoriesNumber();
      HelpDependencies = {
        parseDependencies,
        createHelpClass
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesChainClass.generated.js
  var ChainDependencies;
  var init_dependenciesChainClass_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesChainClass.generated.js"() {
      init_factoriesNumber();
      ChainDependencies = {
        createChainClass
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHelp.generated.js
  var helpDependencies;
  var init_dependenciesHelp_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHelp.generated.js"() {
      init_dependenciesHelpClass_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      helpDependencies = {
        HelpDependencies,
        typedDependencies,
        createHelp
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesChain.generated.js
  var chainDependencies;
  var init_dependenciesChain_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesChain.generated.js"() {
      init_dependenciesChainClass_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      chainDependencies = {
        ChainDependencies,
        typedDependencies,
        createChain
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAdd.generated.js
  var addDependencies;
  var init_dependenciesAdd_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAdd.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      addDependencies = {
        typedDependencies,
        createAdd
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDivide.generated.js
  var divideDependencies;
  var init_dependenciesDivide_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDivide.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      divideDependencies = {
        typedDependencies,
        createDivide
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEqualScalar.generated.js
  var equalScalarDependencies;
  var init_dependenciesEqualScalar_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEqualScalar.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      equalScalarDependencies = {
        typedDependencies,
        createEqualScalar: createEqualScalarNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEqual.generated.js
  var equalDependencies;
  var init_dependenciesEqual_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEqual.generated.js"() {
      init_dependenciesEqualScalar_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      equalDependencies = {
        equalScalarDependencies,
        typedDependencies,
        createEqual: createEqualNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsZero.generated.js
  var isZeroDependencies;
  var init_dependenciesIsZero_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsZero.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      isZeroDependencies = {
        typedDependencies,
        createIsZero
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMultiply.generated.js
  var multiplyDependencies;
  var init_dependenciesMultiply_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMultiply.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      multiplyDependencies = {
        typedDependencies,
        createMultiply
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPow.generated.js
  var powDependencies;
  var init_dependenciesPow_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPow.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      powDependencies = {
        typedDependencies,
        createPow
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSubtract.generated.js
  var subtractDependencies;
  var init_dependenciesSubtract_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSubtract.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      subtractDependencies = {
        typedDependencies,
        createSubtract
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSimplify.generated.js
  var simplifyDependencies;
  var init_dependenciesSimplify_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSimplify.generated.js"() {
      init_dependenciesConstantNode_generated();
      init_dependenciesFunctionNode_generated();
      init_dependenciesOperatorNode_generated();
      init_dependenciesParenthesisNode_generated();
      init_dependenciesSymbolNode_generated();
      init_dependenciesAdd_generated();
      init_dependenciesDivide_generated();
      init_dependenciesEqual_generated();
      init_dependenciesIsZero_generated();
      init_dependenciesMultiply_generated();
      init_dependenciesParse_generated();
      init_dependenciesPow_generated();
      init_dependenciesSubtract_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      simplifyDependencies = {
        ConstantNodeDependencies,
        FunctionNodeDependencies,
        OperatorNodeDependencies,
        ParenthesisNodeDependencies,
        SymbolNodeDependencies,
        addDependencies,
        divideDependencies,
        equalDependencies,
        isZeroDependencies,
        multiplyDependencies,
        parseDependencies,
        powDependencies,
        subtractDependencies,
        typedDependencies,
        createSimplify
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDerivative.generated.js
  var derivativeDependencies;
  var init_dependenciesDerivative_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDerivative.generated.js"() {
      init_dependenciesConstantNode_generated();
      init_dependenciesFunctionNode_generated();
      init_dependenciesOperatorNode_generated();
      init_dependenciesParenthesisNode_generated();
      init_dependenciesSymbolNode_generated();
      init_dependenciesEqual_generated();
      init_dependenciesIsZero_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesParse_generated();
      init_dependenciesSimplify_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      derivativeDependencies = {
        ConstantNodeDependencies,
        FunctionNodeDependencies,
        OperatorNodeDependencies,
        ParenthesisNodeDependencies,
        SymbolNodeDependencies,
        equalDependencies,
        isZeroDependencies,
        numericDependencies,
        parseDependencies,
        simplifyDependencies,
        typedDependencies,
        createDerivative
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRationalize.generated.js
  var rationalizeDependencies;
  var init_dependenciesRationalize_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRationalize.generated.js"() {
      init_dependenciesConstantNode_generated();
      init_dependenciesFunctionNode_generated();
      init_dependenciesOperatorNode_generated();
      init_dependenciesParenthesisNode_generated();
      init_dependenciesSymbolNode_generated();
      init_dependenciesAdd_generated();
      init_dependenciesDivide_generated();
      init_dependenciesEqual_generated();
      init_dependenciesIsZero_generated();
      init_dependenciesMultiply_generated();
      init_dependenciesParse_generated();
      init_dependenciesPow_generated();
      init_dependenciesSimplify_generated();
      init_dependenciesSubtract_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      rationalizeDependencies = {
        ConstantNodeDependencies,
        FunctionNodeDependencies,
        OperatorNodeDependencies,
        ParenthesisNodeDependencies,
        SymbolNodeDependencies,
        addDependencies,
        divideDependencies,
        equalDependencies,
        isZeroDependencies,
        multiplyDependencies,
        parseDependencies,
        powDependencies,
        simplifyDependencies,
        subtractDependencies,
        typedDependencies,
        createRationalize
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNthRoot.generated.js
  var nthRootDependencies;
  var init_dependenciesNthRoot_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNthRoot.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      nthRootDependencies = {
        typedDependencies,
        createNthRoot: createNthRootNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRound.generated.js
  var roundDependencies;
  var init_dependenciesRound_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRound.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      roundDependencies = {
        typedDependencies,
        createRound: createRoundNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAbs.generated.js
  var absDependencies;
  var init_dependenciesAbs_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAbs.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      absDependencies = {
        typedDependencies,
        createAbs
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAddScalar.generated.js
  var addScalarDependencies;
  var init_dependenciesAddScalar_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAddScalar.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      addScalarDependencies = {
        typedDependencies,
        createAddScalar
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDivideScalar.generated.js
  var divideScalarDependencies;
  var init_dependenciesDivideScalar_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDivideScalar.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      divideScalarDependencies = {
        typedDependencies,
        createDivideScalar
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsPositive.generated.js
  var isPositiveDependencies;
  var init_dependenciesIsPositive_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsPositive.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      isPositiveDependencies = {
        typedDependencies,
        createIsPositive
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMultiplyScalar.generated.js
  var multiplyScalarDependencies;
  var init_dependenciesMultiplyScalar_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMultiplyScalar.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      multiplyScalarDependencies = {
        typedDependencies,
        createMultiplyScalar
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSmaller.generated.js
  var smallerDependencies;
  var init_dependenciesSmaller_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSmaller.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      smallerDependencies = {
        typedDependencies,
        createSmaller: createSmallerNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSqrt.generated.js
  var sqrtDependencies;
  var init_dependenciesSqrt_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSqrt.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      sqrtDependencies = {
        typedDependencies,
        createSqrt
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHypot.generated.js
  var hypotDependencies;
  var init_dependenciesHypot_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHypot.generated.js"() {
      init_dependenciesAbs_generated();
      init_dependenciesAddScalar_generated();
      init_dependenciesDivideScalar_generated();
      init_dependenciesIsPositive_generated();
      init_dependenciesMultiplyScalar_generated();
      init_dependenciesSmaller_generated();
      init_dependenciesSqrt_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      hypotDependencies = {
        absDependencies,
        addScalarDependencies,
        divideScalarDependencies,
        isPositiveDependencies,
        multiplyScalarDependencies,
        smallerDependencies,
        sqrtDependencies,
        typedDependencies,
        createHypot
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCombinations.generated.js
  var combinationsDependencies;
  var init_dependenciesCombinations_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCombinations.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      combinationsDependencies = {
        typedDependencies,
        createCombinations
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesGamma.generated.js
  var gammaDependencies;
  var init_dependenciesGamma_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesGamma.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      gammaDependencies = {
        typedDependencies,
        createGamma
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFactorial.generated.js
  var factorialDependencies;
  var init_dependenciesFactorial_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFactorial.generated.js"() {
      init_dependenciesGamma_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      factorialDependencies = {
        gammaDependencies,
        typedDependencies,
        createFactorial
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsInteger.generated.js
  var isIntegerDependencies;
  var init_dependenciesIsInteger_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsInteger.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      isIntegerDependencies = {
        typedDependencies,
        createIsInteger
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsNegative.generated.js
  var isNegativeDependencies;
  var init_dependenciesIsNegative_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsNegative.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      isNegativeDependencies = {
        typedDependencies,
        createIsNegative
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLarger.generated.js
  var largerDependencies;
  var init_dependenciesLarger_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLarger.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      largerDependencies = {
        typedDependencies,
        createLarger: createLargerNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesStirlingS2.generated.js
  var stirlingS2Dependencies;
  var init_dependenciesStirlingS2_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesStirlingS2.generated.js"() {
      init_dependenciesAddScalar_generated();
      init_dependenciesCombinations_generated();
      init_dependenciesDivideScalar_generated();
      init_dependenciesFactorial_generated();
      init_dependenciesIsInteger_generated();
      init_dependenciesIsNegative_generated();
      init_dependenciesLarger_generated();
      init_dependenciesMultiplyScalar_generated();
      init_dependenciesPow_generated();
      init_dependenciesSubtract_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      stirlingS2Dependencies = {
        addScalarDependencies,
        combinationsDependencies,
        divideScalarDependencies,
        factorialDependencies,
        isIntegerDependencies,
        isNegativeDependencies,
        largerDependencies,
        multiplyScalarDependencies,
        powDependencies,
        subtractDependencies,
        typedDependencies,
        createStirlingS2
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBellNumbers.generated.js
  var bellNumbersDependencies;
  var init_dependenciesBellNumbers_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBellNumbers.generated.js"() {
      init_dependenciesAddScalar_generated();
      init_dependenciesIsInteger_generated();
      init_dependenciesIsNegative_generated();
      init_dependenciesStirlingS2_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      bellNumbersDependencies = {
        addScalarDependencies,
        isIntegerDependencies,
        isNegativeDependencies,
        stirlingS2Dependencies,
        typedDependencies,
        createBellNumbers
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCatalan.generated.js
  var catalanDependencies;
  var init_dependenciesCatalan_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCatalan.generated.js"() {
      init_dependenciesAddScalar_generated();
      init_dependenciesCombinations_generated();
      init_dependenciesDivideScalar_generated();
      init_dependenciesIsInteger_generated();
      init_dependenciesIsNegative_generated();
      init_dependenciesMultiplyScalar_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      catalanDependencies = {
        addScalarDependencies,
        combinationsDependencies,
        divideScalarDependencies,
        isIntegerDependencies,
        isNegativeDependencies,
        multiplyScalarDependencies,
        typedDependencies,
        createCatalan
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesComposition.generated.js
  var compositionDependencies;
  var init_dependenciesComposition_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesComposition.generated.js"() {
      init_dependenciesAddScalar_generated();
      init_dependenciesCombinations_generated();
      init_dependenciesIsInteger_generated();
      init_dependenciesIsNegative_generated();
      init_dependenciesIsPositive_generated();
      init_dependenciesLarger_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      compositionDependencies = {
        addScalarDependencies,
        combinationsDependencies,
        isIntegerDependencies,
        isNegativeDependencies,
        isPositiveDependencies,
        largerDependencies,
        typedDependencies,
        createComposition
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesE.generated.js
  var eDependencies;
  var init_dependenciesE_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesE.generated.js"() {
      init_factoriesNumber();
      eDependencies = {
        createE
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUppercaseE.generated.js
  var EDependencies;
  var init_dependenciesUppercaseE_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUppercaseE.generated.js"() {
      init_dependenciesE_generated();
      init_factoriesNumber();
      EDependencies = {
        eDependencies,
        createUppercaseE
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFalse.generated.js
  var falseDependencies;
  var init_dependenciesFalse_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFalse.generated.js"() {
      init_factoriesNumber();
      falseDependencies = {
        createFalse
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesInfinity.generated.js
  var InfinityDependencies;
  var init_dependenciesInfinity_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesInfinity.generated.js"() {
      init_factoriesNumber();
      InfinityDependencies = {
        createInfinity
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLN10.generated.js
  var LN10Dependencies;
  var init_dependenciesLN10_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLN10.generated.js"() {
      init_factoriesNumber();
      LN10Dependencies = {
        createLN10
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLN2.generated.js
  var LN2Dependencies;
  var init_dependenciesLN2_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLN2.generated.js"() {
      init_factoriesNumber();
      LN2Dependencies = {
        createLN2
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLOG10E.generated.js
  var LOG10EDependencies;
  var init_dependenciesLOG10E_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLOG10E.generated.js"() {
      init_factoriesNumber();
      LOG10EDependencies = {
        createLOG10E
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLOG2E.generated.js
  var LOG2EDependencies;
  var init_dependenciesLOG2E_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLOG2E.generated.js"() {
      init_factoriesNumber();
      LOG2EDependencies = {
        createLOG2E
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNaN.generated.js
  var NaNDependencies;
  var init_dependenciesNaN_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNaN.generated.js"() {
      init_factoriesNumber();
      NaNDependencies = {
        createNaN
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNull.generated.js
  var nullDependencies;
  var init_dependenciesNull_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNull.generated.js"() {
      init_factoriesNumber();
      nullDependencies = {
        createNull
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPhi.generated.js
  var phiDependencies;
  var init_dependenciesPhi_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPhi.generated.js"() {
      init_factoriesNumber();
      phiDependencies = {
        createPhi
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPi.generated.js
  var piDependencies;
  var init_dependenciesPi_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPi.generated.js"() {
      init_factoriesNumber();
      piDependencies = {
        createPi
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUppercasePi.generated.js
  var PIDependencies;
  var init_dependenciesUppercasePi_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUppercasePi.generated.js"() {
      init_dependenciesPi_generated();
      init_factoriesNumber();
      PIDependencies = {
        piDependencies,
        createUppercasePi
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSQRT1_2.generated.js
  var SQRT1_2Dependencies;
  var init_dependenciesSQRT1_2_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSQRT1_2.generated.js"() {
      init_factoriesNumber();
      SQRT1_2Dependencies = {
        createSQRT1_2
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSQRT2.generated.js
  var SQRT2Dependencies;
  var init_dependenciesSQRT2_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSQRT2.generated.js"() {
      init_factoriesNumber();
      SQRT2Dependencies = {
        createSQRT2
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTau.generated.js
  var tauDependencies;
  var init_dependenciesTau_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTau.generated.js"() {
      init_factoriesNumber();
      tauDependencies = {
        createTau
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTrue.generated.js
  var trueDependencies;
  var init_dependenciesTrue_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTrue.generated.js"() {
      init_factoriesNumber();
      trueDependencies = {
        createTrue
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesVersion.generated.js
  var versionDependencies;
  var init_dependenciesVersion_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesVersion.generated.js"() {
      init_factoriesNumber();
      versionDependencies = {
        createVersion
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesString.generated.js
  var stringDependencies;
  var init_dependenciesString_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesString.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      stringDependencies = {
        typedDependencies,
        createString
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBoolean.generated.js
  var booleanDependencies;
  var init_dependenciesBoolean_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBoolean.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      booleanDependencies = {
        typedDependencies,
        createBoolean
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParserClass.generated.js
  var ParserDependencies;
  var init_dependenciesParserClass_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParserClass.generated.js"() {
      init_dependenciesParse_generated();
      init_factoriesNumber();
      ParserDependencies = {
        parseDependencies,
        createParserClass
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParser.generated.js
  var parserDependencies;
  var init_dependenciesParser_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesParser.generated.js"() {
      init_dependenciesParserClass_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      parserDependencies = {
        ParserDependencies,
        typedDependencies,
        createParser
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompile.generated.js
  var compileDependencies;
  var init_dependenciesCompile_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompile.generated.js"() {
      init_dependenciesParse_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      compileDependencies = {
        parseDependencies,
        typedDependencies,
        createCompile
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEvaluate.generated.js
  var evaluateDependencies;
  var init_dependenciesEvaluate_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEvaluate.generated.js"() {
      init_dependenciesParse_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      evaluateDependencies = {
        parseDependencies,
        typedDependencies,
        createEvaluate
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesApply.generated.js
  var applyDependencies;
  var init_dependenciesApply_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesApply.generated.js"() {
      init_dependenciesIsInteger_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      applyDependencies = {
        isIntegerDependencies,
        typedDependencies,
        createApply
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFilter.generated.js
  var filterDependencies;
  var init_dependenciesFilter_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFilter.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      filterDependencies = {
        typedDependencies,
        createFilter
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesForEach.generated.js
  var forEachDependencies;
  var init_dependenciesForEach_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesForEach.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      forEachDependencies = {
        typedDependencies,
        createForEach
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMap.generated.js
  var mapDependencies;
  var init_dependenciesMap_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMap.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      mapDependencies = {
        typedDependencies,
        createMap
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLargerEq.generated.js
  var largerEqDependencies;
  var init_dependenciesLargerEq_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLargerEq.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      largerEqDependencies = {
        typedDependencies,
        createLargerEq: createLargerEqNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSmallerEq.generated.js
  var smallerEqDependencies;
  var init_dependenciesSmallerEq_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSmallerEq.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      smallerEqDependencies = {
        typedDependencies,
        createSmallerEq: createSmallerEqNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRange.generated.js
  var rangeDependencies;
  var init_dependenciesRange_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRange.generated.js"() {
      init_dependenciesMatrix_generated();
      init_dependenciesLarger_generated();
      init_dependenciesLargerEq_generated();
      init_dependenciesSmaller_generated();
      init_dependenciesSmallerEq_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      rangeDependencies = {
        matrixDependencies,
        largerDependencies,
        largerEqDependencies,
        smallerDependencies,
        smallerEqDependencies,
        typedDependencies,
        createRange
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompare.generated.js
  var compareDependencies;
  var init_dependenciesCompare_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompare.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      compareDependencies = {
        typedDependencies,
        createCompare: createCompareNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsNaN.generated.js
  var isNaNDependencies;
  var init_dependenciesIsNaN_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsNaN.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      isNaNDependencies = {
        typedDependencies,
        createIsNaN
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsNumeric.generated.js
  var isNumericDependencies;
  var init_dependenciesIsNumeric_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsNumeric.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      isNumericDependencies = {
        typedDependencies,
        createIsNumeric
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPartitionSelect.generated.js
  var partitionSelectDependencies;
  var init_dependenciesPartitionSelect_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPartitionSelect.generated.js"() {
      init_dependenciesCompare_generated();
      init_dependenciesIsNaN_generated();
      init_dependenciesIsNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      partitionSelectDependencies = {
        compareDependencies,
        isNaNDependencies,
        isNumericDependencies,
        typedDependencies,
        createPartitionSelect
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCombinationsWithRep.generated.js
  var combinationsWithRepDependencies;
  var init_dependenciesCombinationsWithRep_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCombinationsWithRep.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      combinationsWithRepDependencies = {
        typedDependencies,
        createCombinationsWithRep
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMultinomial.generated.js
  var multinomialDependencies;
  var init_dependenciesMultinomial_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMultinomial.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesDivide_generated();
      init_dependenciesFactorial_generated();
      init_dependenciesIsInteger_generated();
      init_dependenciesIsPositive_generated();
      init_dependenciesMultiply_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      multinomialDependencies = {
        addDependencies,
        divideDependencies,
        factorialDependencies,
        isIntegerDependencies,
        isPositiveDependencies,
        multiplyDependencies,
        typedDependencies,
        createMultinomial
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPermutations.generated.js
  var permutationsDependencies;
  var init_dependenciesPermutations_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPermutations.generated.js"() {
      init_dependenciesFactorial_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      permutationsDependencies = {
        factorialDependencies,
        typedDependencies,
        createPermutations
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPickRandom.generated.js
  var pickRandomDependencies;
  var init_dependenciesPickRandom_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPickRandom.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      pickRandomDependencies = {
        typedDependencies,
        createPickRandom
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRandom.generated.js
  var randomDependencies;
  var init_dependenciesRandom_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRandom.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      randomDependencies = {
        typedDependencies,
        createRandom: createRandomNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRandomInt.generated.js
  var randomIntDependencies;
  var init_dependenciesRandomInt_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRandomInt.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      randomIntDependencies = {
        typedDependencies,
        createRandomInt
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompareNatural.generated.js
  var compareNaturalDependencies;
  var init_dependenciesCompareNatural_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompareNatural.generated.js"() {
      init_dependenciesCompare_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      compareNaturalDependencies = {
        compareDependencies,
        typedDependencies,
        createCompareNatural
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompareText.generated.js
  var compareTextDependencies;
  var init_dependenciesCompareText_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCompareText.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      compareTextDependencies = {
        typedDependencies,
        createCompareText: createCompareTextNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEqualText.generated.js
  var equalTextDependencies;
  var init_dependenciesEqualText_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesEqualText.generated.js"() {
      init_dependenciesCompareText_generated();
      init_dependenciesIsZero_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      equalTextDependencies = {
        compareTextDependencies,
        isZeroDependencies,
        typedDependencies,
        createEqualText
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDeepEqual.generated.js
  var deepEqualDependencies;
  var init_dependenciesDeepEqual_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesDeepEqual.generated.js"() {
      init_dependenciesEqual_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      deepEqualDependencies = {
        equalDependencies,
        typedDependencies,
        createDeepEqual
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUnequal.generated.js
  var unequalDependencies;
  var init_dependenciesUnequal_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUnequal.generated.js"() {
      init_dependenciesEqualScalar_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      unequalDependencies = {
        equalScalarDependencies,
        typedDependencies,
        createUnequal: createUnequalNumber
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesErf.generated.js
  var erfDependencies;
  var init_dependenciesErf_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesErf.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      erfDependencies = {
        typedDependencies,
        createErf
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMode.generated.js
  var modeDependencies;
  var init_dependenciesMode_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMode.generated.js"() {
      init_dependenciesIsNaN_generated();
      init_dependenciesIsNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      modeDependencies = {
        isNaNDependencies,
        isNumericDependencies,
        typedDependencies,
        createMode
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesProd.generated.js
  var prodDependencies;
  var init_dependenciesProd_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesProd.generated.js"() {
      init_dependenciesMultiplyScalar_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      prodDependencies = {
        multiplyScalarDependencies,
        numericDependencies,
        typedDependencies,
        createProd
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMax.generated.js
  var maxDependencies;
  var init_dependenciesMax_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMax.generated.js"() {
      init_dependenciesLarger_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      maxDependencies = {
        largerDependencies,
        numericDependencies,
        typedDependencies,
        createMax
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMin.generated.js
  var minDependencies;
  var init_dependenciesMin_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMin.generated.js"() {
      init_dependenciesNumeric_generated();
      init_dependenciesSmaller_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      minDependencies = {
        numericDependencies,
        smallerDependencies,
        typedDependencies,
        createMin
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSum.generated.js
  var sumDependencies;
  var init_dependenciesSum_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSum.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      sumDependencies = {
        addDependencies,
        numericDependencies,
        typedDependencies,
        createSum
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMean.generated.js
  var meanDependencies;
  var init_dependenciesMean_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMean.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesDivide_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      meanDependencies = {
        addDependencies,
        divideDependencies,
        typedDependencies,
        createMean
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMedian.generated.js
  var medianDependencies;
  var init_dependenciesMedian_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMedian.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesCompare_generated();
      init_dependenciesDivide_generated();
      init_dependenciesPartitionSelect_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      medianDependencies = {
        addDependencies,
        compareDependencies,
        divideDependencies,
        partitionSelectDependencies,
        typedDependencies,
        createMedian
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMad.generated.js
  var madDependencies;
  var init_dependenciesMad_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMad.generated.js"() {
      init_dependenciesAbs_generated();
      init_dependenciesMap_generated();
      init_dependenciesMedian_generated();
      init_dependenciesSubtract_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      madDependencies = {
        absDependencies,
        mapDependencies,
        medianDependencies,
        subtractDependencies,
        typedDependencies,
        createMad
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesVariance.generated.js
  var varianceDependencies;
  var init_dependenciesVariance_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesVariance.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesApply_generated();
      init_dependenciesDivide_generated();
      init_dependenciesIsNaN_generated();
      init_dependenciesMultiply_generated();
      init_dependenciesSubtract_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      varianceDependencies = {
        addDependencies,
        applyDependencies,
        divideDependencies,
        isNaNDependencies,
        multiplyDependencies,
        subtractDependencies,
        typedDependencies,
        createVariance
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesQuantileSeq.generated.js
  var quantileSeqDependencies;
  var init_dependenciesQuantileSeq_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesQuantileSeq.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesCompare_generated();
      init_dependenciesMultiply_generated();
      init_dependenciesPartitionSelect_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      quantileSeqDependencies = {
        addDependencies,
        compareDependencies,
        multiplyDependencies,
        partitionSelectDependencies,
        typedDependencies,
        createQuantileSeq
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesStd.generated.js
  var stdDependencies;
  var init_dependenciesStd_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesStd.generated.js"() {
      init_dependenciesSqrt_generated();
      init_dependenciesTyped_generated();
      init_dependenciesVariance_generated();
      init_factoriesNumber();
      stdDependencies = {
        sqrtDependencies,
        typedDependencies,
        varianceDependencies,
        createStd
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFormat.generated.js
  var formatDependencies;
  var init_dependenciesFormat_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFormat.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      formatDependencies = {
        typedDependencies,
        createFormat
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPrint.generated.js
  var printDependencies;
  var init_dependenciesPrint_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesPrint.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      printDependencies = {
        typedDependencies,
        createPrint
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesApplyTransform.generated.js
  var applyTransformDependencies;
  var init_dependenciesApplyTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesApplyTransform.generated.js"() {
      init_dependenciesIsInteger_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      applyTransformDependencies = {
        isIntegerDependencies,
        typedDependencies,
        createApplyTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFilterTransform.generated.js
  var filterTransformDependencies;
  var init_dependenciesFilterTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFilterTransform.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      filterTransformDependencies = {
        typedDependencies,
        createFilterTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesForEachTransform.generated.js
  var forEachTransformDependencies;
  var init_dependenciesForEachTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesForEachTransform.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      forEachTransformDependencies = {
        typedDependencies,
        createForEachTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMapTransform.generated.js
  var mapTransformDependencies;
  var init_dependenciesMapTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMapTransform.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      mapTransformDependencies = {
        typedDependencies,
        createMapTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMaxTransform.generated.js
  var maxTransformDependencies;
  var init_dependenciesMaxTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMaxTransform.generated.js"() {
      init_dependenciesLarger_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      maxTransformDependencies = {
        largerDependencies,
        numericDependencies,
        typedDependencies,
        createMaxTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMeanTransform.generated.js
  var meanTransformDependencies;
  var init_dependenciesMeanTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMeanTransform.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesDivide_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      meanTransformDependencies = {
        addDependencies,
        divideDependencies,
        typedDependencies,
        createMeanTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMinTransform.generated.js
  var minTransformDependencies;
  var init_dependenciesMinTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMinTransform.generated.js"() {
      init_dependenciesNumeric_generated();
      init_dependenciesSmaller_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      minTransformDependencies = {
        numericDependencies,
        smallerDependencies,
        typedDependencies,
        createMinTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRangeTransform.generated.js
  var rangeTransformDependencies;
  var init_dependenciesRangeTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRangeTransform.generated.js"() {
      init_dependenciesMatrix_generated();
      init_dependenciesLarger_generated();
      init_dependenciesLargerEq_generated();
      init_dependenciesSmaller_generated();
      init_dependenciesSmallerEq_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      rangeTransformDependencies = {
        matrixDependencies,
        largerDependencies,
        largerEqDependencies,
        smallerDependencies,
        smallerEqDependencies,
        typedDependencies,
        createRangeTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesStdTransform.generated.js
  var stdTransformDependencies;
  var init_dependenciesStdTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesStdTransform.generated.js"() {
      init_dependenciesSqrt_generated();
      init_dependenciesTyped_generated();
      init_dependenciesVariance_generated();
      init_factoriesNumber();
      stdTransformDependencies = {
        sqrtDependencies,
        typedDependencies,
        varianceDependencies,
        createStdTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSumTransform.generated.js
  var sumTransformDependencies;
  var init_dependenciesSumTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSumTransform.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      sumTransformDependencies = {
        addDependencies,
        numericDependencies,
        typedDependencies,
        createSumTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesVarianceTransform.generated.js
  var varianceTransformDependencies;
  var init_dependenciesVarianceTransform_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesVarianceTransform.generated.js"() {
      init_dependenciesAdd_generated();
      init_dependenciesApply_generated();
      init_dependenciesDivide_generated();
      init_dependenciesIsNaN_generated();
      init_dependenciesMultiply_generated();
      init_dependenciesSubtract_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      varianceTransformDependencies = {
        addDependencies,
        applyDependencies,
        divideDependencies,
        isNaNDependencies,
        multiplyDependencies,
        subtractDependencies,
        typedDependencies,
        createVarianceTransform
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesClone.generated.js
  var cloneDependencies;
  var init_dependenciesClone_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesClone.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cloneDependencies = {
        typedDependencies,
        createClone
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHasNumericValue.generated.js
  var hasNumericValueDependencies;
  var init_dependenciesHasNumericValue_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesHasNumericValue.generated.js"() {
      init_dependenciesIsNumeric_generated();
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      hasNumericValueDependencies = {
        isNumericDependencies,
        typedDependencies,
        createHasNumericValue
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTypeOf.generated.js
  var typeOfDependencies;
  var init_dependenciesTypeOf_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTypeOf.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      typeOfDependencies = {
        typedDependencies,
        createTypeOf
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsPrime.generated.js
  var isPrimeDependencies;
  var init_dependenciesIsPrime_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIsPrime.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      isPrimeDependencies = {
        typedDependencies,
        createIsPrime
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesReviver.generated.js
  var reviverDependencies;
  var init_dependenciesReviver_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesReviver.generated.js"() {
      init_factoriesNumber();
      reviverDependencies = {
        createReviver
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesReplacer.generated.js
  var replacerDependencies;
  var init_dependenciesReplacer_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesReplacer.generated.js"() {
      init_factoriesNumber();
      replacerDependencies = {
        createReplacer
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUnaryMinus.generated.js
  var unaryMinusDependencies;
  var init_dependenciesUnaryMinus_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUnaryMinus.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      unaryMinusDependencies = {
        typedDependencies,
        createUnaryMinus
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUnaryPlus.generated.js
  var unaryPlusDependencies;
  var init_dependenciesUnaryPlus_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesUnaryPlus.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      unaryPlusDependencies = {
        typedDependencies,
        createUnaryPlus
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCbrt.generated.js
  var cbrtDependencies;
  var init_dependenciesCbrt_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCbrt.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cbrtDependencies = {
        typedDependencies,
        createCbrt
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCeil.generated.js
  var ceilDependencies;
  var init_dependenciesCeil_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCeil.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      ceilDependencies = {
        typedDependencies,
        createCeil
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCube.generated.js
  var cubeDependencies;
  var init_dependenciesCube_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCube.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cubeDependencies = {
        typedDependencies,
        createCube
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesExp.generated.js
  var expDependencies;
  var init_dependenciesExp_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesExp.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      expDependencies = {
        typedDependencies,
        createExp
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesExpm1.generated.js
  var expm1Dependencies;
  var init_dependenciesExpm1_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesExpm1.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      expm1Dependencies = {
        typedDependencies,
        createExpm1
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFix.generated.js
  var fixDependencies;
  var init_dependenciesFix_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFix.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      fixDependencies = {
        typedDependencies,
        createFix
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFloor.generated.js
  var floorDependencies;
  var init_dependenciesFloor_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesFloor.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      floorDependencies = {
        typedDependencies,
        createFloor
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesGcd.generated.js
  var gcdDependencies;
  var init_dependenciesGcd_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesGcd.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      gcdDependencies = {
        typedDependencies,
        createGcd
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLcm.generated.js
  var lcmDependencies;
  var init_dependenciesLcm_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLcm.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      lcmDependencies = {
        typedDependencies,
        createLcm
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog10.generated.js
  var log10Dependencies;
  var init_dependenciesLog10_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog10.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      log10Dependencies = {
        typedDependencies,
        createLog10
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog2.generated.js
  var log2Dependencies;
  var init_dependenciesLog2_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog2.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      log2Dependencies = {
        typedDependencies,
        createLog2
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMod.generated.js
  var modDependencies;
  var init_dependenciesMod_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesMod.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      modDependencies = {
        typedDependencies,
        createMod
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSign.generated.js
  var signDependencies;
  var init_dependenciesSign_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSign.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      signDependencies = {
        typedDependencies,
        createSign
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSquare.generated.js
  var squareDependencies;
  var init_dependenciesSquare_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSquare.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      squareDependencies = {
        typedDependencies,
        createSquare
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesXgcd.generated.js
  var xgcdDependencies;
  var init_dependenciesXgcd_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesXgcd.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      xgcdDependencies = {
        typedDependencies,
        createXgcd
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog.generated.js
  var logDependencies;
  var init_dependenciesLog_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      logDependencies = {
        typedDependencies,
        createLog
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog1p.generated.js
  var log1pDependencies;
  var init_dependenciesLog1p_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLog1p.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      log1pDependencies = {
        typedDependencies,
        createLog1p
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNorm.generated.js
  var normDependencies;
  var init_dependenciesNorm_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNorm.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      normDependencies = {
        typedDependencies,
        createNorm
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitAnd.generated.js
  var bitAndDependencies;
  var init_dependenciesBitAnd_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitAnd.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      bitAndDependencies = {
        typedDependencies,
        createBitAnd
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitNot.generated.js
  var bitNotDependencies;
  var init_dependenciesBitNot_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitNot.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      bitNotDependencies = {
        typedDependencies,
        createBitNot
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitOr.generated.js
  var bitOrDependencies;
  var init_dependenciesBitOr_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitOr.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      bitOrDependencies = {
        typedDependencies,
        createBitOr
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitXor.generated.js
  var bitXorDependencies;
  var init_dependenciesBitXor_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesBitXor.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      bitXorDependencies = {
        typedDependencies,
        createBitXor
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLeftShift.generated.js
  var leftShiftDependencies;
  var init_dependenciesLeftShift_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesLeftShift.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      leftShiftDependencies = {
        typedDependencies,
        createLeftShift
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRightArithShift.generated.js
  var rightArithShiftDependencies;
  var init_dependenciesRightArithShift_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRightArithShift.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      rightArithShiftDependencies = {
        typedDependencies,
        createRightArithShift
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRightLogShift.generated.js
  var rightLogShiftDependencies;
  var init_dependenciesRightLogShift_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesRightLogShift.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      rightLogShiftDependencies = {
        typedDependencies,
        createRightLogShift
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAnd.generated.js
  var andDependencies;
  var init_dependenciesAnd_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAnd.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      andDependencies = {
        typedDependencies,
        createAnd
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNot.generated.js
  var notDependencies;
  var init_dependenciesNot_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesNot.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      notDependencies = {
        typedDependencies,
        createNot
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesOr.generated.js
  var orDependencies;
  var init_dependenciesOr_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesOr.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      orDependencies = {
        typedDependencies,
        createOr
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesXor.generated.js
  var xorDependencies;
  var init_dependenciesXor_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesXor.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      xorDependencies = {
        typedDependencies,
        createXor
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIndex.generated.js
  var indexDependencies;
  var init_dependenciesIndex_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesIndex.generated.js"() {
      init_factoriesNumber();
      indexDependencies = {
        createIndex
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSubset.generated.js
  var subsetDependencies;
  var init_dependenciesSubset_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSubset.generated.js"() {
      init_factoriesNumber();
      subsetDependencies = {
        createSubset: createSubset2
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcos.generated.js
  var acosDependencies;
  var init_dependenciesAcos_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcos.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      acosDependencies = {
        typedDependencies,
        createAcos
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcosh.generated.js
  var acoshDependencies;
  var init_dependenciesAcosh_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcosh.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      acoshDependencies = {
        typedDependencies,
        createAcosh
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcot.generated.js
  var acotDependencies;
  var init_dependenciesAcot_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcot.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      acotDependencies = {
        typedDependencies,
        createAcot
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcoth.generated.js
  var acothDependencies;
  var init_dependenciesAcoth_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcoth.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      acothDependencies = {
        typedDependencies,
        createAcoth
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcsc.generated.js
  var acscDependencies;
  var init_dependenciesAcsc_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcsc.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      acscDependencies = {
        typedDependencies,
        createAcsc
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcsch.generated.js
  var acschDependencies;
  var init_dependenciesAcsch_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAcsch.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      acschDependencies = {
        typedDependencies,
        createAcsch
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsec.generated.js
  var asecDependencies;
  var init_dependenciesAsec_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsec.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      asecDependencies = {
        typedDependencies,
        createAsec
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsech.generated.js
  var asechDependencies;
  var init_dependenciesAsech_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsech.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      asechDependencies = {
        typedDependencies,
        createAsech
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsin.generated.js
  var asinDependencies;
  var init_dependenciesAsin_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsin.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      asinDependencies = {
        typedDependencies,
        createAsin
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsinh.generated.js
  var asinhDependencies;
  var init_dependenciesAsinh_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAsinh.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      asinhDependencies = {
        typedDependencies,
        createAsinh
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAtan.generated.js
  var atanDependencies;
  var init_dependenciesAtan_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAtan.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      atanDependencies = {
        typedDependencies,
        createAtan
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAtan2.generated.js
  var atan2Dependencies;
  var init_dependenciesAtan2_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAtan2.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      atan2Dependencies = {
        typedDependencies,
        createAtan2
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAtanh.generated.js
  var atanhDependencies;
  var init_dependenciesAtanh_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesAtanh.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      atanhDependencies = {
        typedDependencies,
        createAtanh
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCos.generated.js
  var cosDependencies;
  var init_dependenciesCos_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCos.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cosDependencies = {
        typedDependencies,
        createCos
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCosh.generated.js
  var coshDependencies;
  var init_dependenciesCosh_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCosh.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      coshDependencies = {
        typedDependencies,
        createCosh
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCot.generated.js
  var cotDependencies;
  var init_dependenciesCot_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCot.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cotDependencies = {
        typedDependencies,
        createCot
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCoth.generated.js
  var cothDependencies;
  var init_dependenciesCoth_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCoth.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cothDependencies = {
        typedDependencies,
        createCoth
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCsc.generated.js
  var cscDependencies;
  var init_dependenciesCsc_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCsc.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cscDependencies = {
        typedDependencies,
        createCsc
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCsch.generated.js
  var cschDependencies;
  var init_dependenciesCsch_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesCsch.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      cschDependencies = {
        typedDependencies,
        createCsch
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSec.generated.js
  var secDependencies;
  var init_dependenciesSec_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSec.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      secDependencies = {
        typedDependencies,
        createSec
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSech.generated.js
  var sechDependencies;
  var init_dependenciesSech_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSech.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      sechDependencies = {
        typedDependencies,
        createSech
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSin.generated.js
  var sinDependencies;
  var init_dependenciesSin_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSin.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      sinDependencies = {
        typedDependencies,
        createSin
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSinh.generated.js
  var sinhDependencies;
  var init_dependenciesSinh_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesSinh.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      sinhDependencies = {
        typedDependencies,
        createSinh
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTan.generated.js
  var tanDependencies;
  var init_dependenciesTan_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTan.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      tanDependencies = {
        typedDependencies,
        createTan
      };
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTanh.generated.js
  var tanhDependencies;
  var init_dependenciesTanh_generated = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber/dependenciesTanh.generated.js"() {
      init_dependenciesTyped_generated();
      init_factoriesNumber();
      tanhDependencies = {
        typedDependencies,
        createTanh
      };
    }
  });

  // node_modules/mathjs/es/entry/allFactoriesNumber.js
  var all;
  var init_allFactoriesNumber = __esm({
    "node_modules/mathjs/es/entry/allFactoriesNumber.js"() {
      init_factoriesNumber();
      all = factoriesNumber_exports;
    }
  });

  // node_modules/mathjs/es/entry/dependenciesNumber.generated.js
  var init_dependenciesNumber_generated2 = __esm({
    "node_modules/mathjs/es/entry/dependenciesNumber.generated.js"() {
      init_dependenciesTyped_generated();
      init_dependenciesResultSet_generated();
      init_dependenciesRangeClass_generated();
      init_dependenciesHelpClass_generated();
      init_dependenciesChainClass_generated();
      init_dependenciesHelp_generated();
      init_dependenciesChain_generated();
      init_dependenciesSimplify_generated();
      init_dependenciesDerivative_generated();
      init_dependenciesRationalize_generated();
      init_dependenciesNthRoot_generated();
      init_dependenciesRound_generated();
      init_dependenciesHypot_generated();
      init_dependenciesStirlingS2_generated();
      init_dependenciesBellNumbers_generated();
      init_dependenciesCatalan_generated();
      init_dependenciesComposition_generated();
      init_dependenciesE_generated();
      init_dependenciesUppercaseE_generated();
      init_dependenciesFalse_generated();
      init_dependenciesInfinity_generated();
      init_dependenciesLN10_generated();
      init_dependenciesLN2_generated();
      init_dependenciesLOG10E_generated();
      init_dependenciesLOG2E_generated();
      init_dependenciesNaN_generated();
      init_dependenciesNull_generated();
      init_dependenciesPhi_generated();
      init_dependenciesPi_generated();
      init_dependenciesUppercasePi_generated();
      init_dependenciesSQRT1_2_generated();
      init_dependenciesSQRT2_generated();
      init_dependenciesTau_generated();
      init_dependenciesTrue_generated();
      init_dependenciesVersion_generated();
      init_dependenciesNumber_generated();
      init_dependenciesString_generated();
      init_dependenciesBoolean_generated();
      init_dependenciesParser_generated();
      init_dependenciesNode_generated();
      init_dependenciesAccessorNode_generated();
      init_dependenciesArrayNode_generated();
      init_dependenciesAssignmentNode_generated();
      init_dependenciesBlockNode_generated();
      init_dependenciesConditionalNode_generated();
      init_dependenciesConstantNode_generated();
      init_dependenciesFunctionAssignmentNode_generated();
      init_dependenciesIndexNode_generated();
      init_dependenciesObjectNode_generated();
      init_dependenciesOperatorNode_generated();
      init_dependenciesParenthesisNode_generated();
      init_dependenciesRangeNode_generated();
      init_dependenciesRelationalNode_generated();
      init_dependenciesSymbolNode_generated();
      init_dependenciesFunctionNode_generated();
      init_dependenciesParse_generated();
      init_dependenciesCompile_generated();
      init_dependenciesEvaluate_generated();
      init_dependenciesParserClass_generated();
      init_dependenciesApply_generated();
      init_dependenciesFilter_generated();
      init_dependenciesForEach_generated();
      init_dependenciesMap_generated();
      init_dependenciesRange_generated();
      init_dependenciesSize_generated();
      init_dependenciesPartitionSelect_generated();
      init_dependenciesCombinationsWithRep_generated();
      init_dependenciesFactorial_generated();
      init_dependenciesMultinomial_generated();
      init_dependenciesPermutations_generated();
      init_dependenciesPickRandom_generated();
      init_dependenciesRandom_generated();
      init_dependenciesRandomInt_generated();
      init_dependenciesEqualScalar_generated();
      init_dependenciesCompare_generated();
      init_dependenciesCompareNatural_generated();
      init_dependenciesCompareText_generated();
      init_dependenciesEqual_generated();
      init_dependenciesEqualText_generated();
      init_dependenciesSmaller_generated();
      init_dependenciesSmallerEq_generated();
      init_dependenciesLarger_generated();
      init_dependenciesLargerEq_generated();
      init_dependenciesDeepEqual_generated();
      init_dependenciesUnequal_generated();
      init_dependenciesErf_generated();
      init_dependenciesMode_generated();
      init_dependenciesProd_generated();
      init_dependenciesMax_generated();
      init_dependenciesMin_generated();
      init_dependenciesSum_generated();
      init_dependenciesMean_generated();
      init_dependenciesMedian_generated();
      init_dependenciesMad_generated();
      init_dependenciesVariance_generated();
      init_dependenciesQuantileSeq_generated();
      init_dependenciesStd_generated();
      init_dependenciesFormat_generated();
      init_dependenciesPrint_generated();
      init_dependenciesApplyTransform_generated();
      init_dependenciesFilterTransform_generated();
      init_dependenciesForEachTransform_generated();
      init_dependenciesMapTransform_generated();
      init_dependenciesMaxTransform_generated();
      init_dependenciesMeanTransform_generated();
      init_dependenciesMinTransform_generated();
      init_dependenciesRangeTransform_generated();
      init_dependenciesSubsetTransform_generated();
      init_dependenciesStdTransform_generated();
      init_dependenciesSumTransform_generated();
      init_dependenciesVarianceTransform_generated();
      init_dependenciesClone_generated();
      init_dependenciesIsNumeric_generated();
      init_dependenciesHasNumericValue_generated();
      init_dependenciesTypeOf_generated();
      init_dependenciesIsPrime_generated();
      init_dependenciesNumeric_generated();
      init_dependenciesReviver_generated();
      init_dependenciesReplacer_generated();
      init_dependenciesUnaryMinus_generated();
      init_dependenciesUnaryPlus_generated();
      init_dependenciesAbs_generated();
      init_dependenciesAddScalar_generated();
      init_dependenciesCbrt_generated();
      init_dependenciesCeil_generated();
      init_dependenciesCube_generated();
      init_dependenciesExp_generated();
      init_dependenciesExpm1_generated();
      init_dependenciesFix_generated();
      init_dependenciesFloor_generated();
      init_dependenciesGcd_generated();
      init_dependenciesLcm_generated();
      init_dependenciesLog10_generated();
      init_dependenciesLog2_generated();
      init_dependenciesMod_generated();
      init_dependenciesMultiplyScalar_generated();
      init_dependenciesMultiply_generated();
      init_dependenciesSign_generated();
      init_dependenciesSqrt_generated();
      init_dependenciesSquare_generated();
      init_dependenciesSubtract_generated();
      init_dependenciesXgcd_generated();
      init_dependenciesDivideScalar_generated();
      init_dependenciesPow_generated();
      init_dependenciesLog_generated();
      init_dependenciesLog1p_generated();
      init_dependenciesAdd_generated();
      init_dependenciesNorm_generated();
      init_dependenciesDivide_generated();
      init_dependenciesBitAnd_generated();
      init_dependenciesBitNot_generated();
      init_dependenciesBitOr_generated();
      init_dependenciesBitXor_generated();
      init_dependenciesLeftShift_generated();
      init_dependenciesRightArithShift_generated();
      init_dependenciesRightLogShift_generated();
      init_dependenciesAnd_generated();
      init_dependenciesNot_generated();
      init_dependenciesOr_generated();
      init_dependenciesXor_generated();
      init_dependenciesIndex_generated();
      init_dependenciesMatrix_generated();
      init_dependenciesSubset_generated();
      init_dependenciesCombinations_generated();
      init_dependenciesGamma_generated();
      init_dependenciesAcos_generated();
      init_dependenciesAcosh_generated();
      init_dependenciesAcot_generated();
      init_dependenciesAcoth_generated();
      init_dependenciesAcsc_generated();
      init_dependenciesAcsch_generated();
      init_dependenciesAsec_generated();
      init_dependenciesAsech_generated();
      init_dependenciesAsin_generated();
      init_dependenciesAsinh_generated();
      init_dependenciesAtan_generated();
      init_dependenciesAtan2_generated();
      init_dependenciesAtanh_generated();
      init_dependenciesCos_generated();
      init_dependenciesCosh_generated();
      init_dependenciesCot_generated();
      init_dependenciesCoth_generated();
      init_dependenciesCsc_generated();
      init_dependenciesCsch_generated();
      init_dependenciesSec_generated();
      init_dependenciesSech_generated();
      init_dependenciesSin_generated();
      init_dependenciesSinh_generated();
      init_dependenciesTan_generated();
      init_dependenciesTanh_generated();
      init_dependenciesIsInteger_generated();
      init_dependenciesIsNegative_generated();
      init_dependenciesIsPositive_generated();
      init_dependenciesIsZero_generated();
      init_dependenciesIsNaN_generated();
      init_allFactoriesNumber();
    }
  });

  // node_modules/tiny-emitter/index.js
  var require_tiny_emitter = __commonJS({
    "node_modules/tiny-emitter/index.js"(exports, module) {
      function E() {
      }
      E.prototype = {
        on: function(name106, callback, ctx) {
          var e5 = this.e || (this.e = {});
          (e5[name106] || (e5[name106] = [])).push({
            fn: callback,
            ctx
          });
          return this;
        },
        once: function(name106, callback, ctx) {
          var self2 = this;
          function listener() {
            self2.off(name106, listener);
            callback.apply(ctx, arguments);
          }
          ;
          listener._ = callback;
          return this.on(name106, listener, ctx);
        },
        emit: function(name106) {
          var data = [].slice.call(arguments, 1);
          var evtArr = ((this.e || (this.e = {}))[name106] || []).slice();
          var i3 = 0;
          var len = evtArr.length;
          for (i3; i3 < len; i3++) {
            evtArr[i3].fn.apply(evtArr[i3].ctx, data);
          }
          return this;
        },
        off: function(name106, callback) {
          var e5 = this.e || (this.e = {});
          var evts = e5[name106];
          var liveEvents = [];
          if (evts && callback) {
            for (var i3 = 0, len = evts.length; i3 < len; i3++) {
              if (evts[i3].fn !== callback && evts[i3].fn._ !== callback)
                liveEvents.push(evts[i3]);
            }
          }
          liveEvents.length ? e5[name106] = liveEvents : delete e5[name106];
          return this;
        }
      };
      module.exports = E;
      module.exports.TinyEmitter = E;
    }
  });

  // node_modules/mathjs/es/utils/emitter.js
  function mixin(obj) {
    var emitter2 = new import_tiny_emitter.default();
    obj.on = emitter2.on.bind(emitter2);
    obj.off = emitter2.off.bind(emitter2);
    obj.once = emitter2.once.bind(emitter2);
    obj.emit = emitter2.emit.bind(emitter2);
    return obj;
  }
  var import_tiny_emitter;
  var init_emitter = __esm({
    "node_modules/mathjs/es/utils/emitter.js"() {
      import_tiny_emitter = __toModule(require_tiny_emitter());
    }
  });

  // node_modules/mathjs/es/core/function/import.js
  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }
    return obj;
  }
  function _typeof12(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof12 = function _typeof13(obj2) {
        return typeof obj2;
      };
    } else {
      _typeof12 = function _typeof13(obj2) {
        return obj2 && typeof Symbol === "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      };
    }
    return _typeof12(obj);
  }
  function importFactory(typed2, load, math2, importedFactories) {
    function mathImport(functions, options) {
      var num = arguments.length;
      if (num !== 1 && num !== 2) {
        throw new ArgumentsError("import", num, 1, 2);
      }
      if (!options) {
        options = {};
      }
      function flattenImports(flatValues2, value2, name107) {
        if (Array.isArray(value2)) {
          value2.forEach(function(item) {
            return flattenImports(flatValues2, item);
          });
        } else if (_typeof12(value2) === "object") {
          for (var _name in value2) {
            if (hasOwnProperty2(value2, _name)) {
              flattenImports(flatValues2, value2[_name], _name);
            }
          }
        } else if (isFactory(value2) || name107 !== void 0) {
          var flatName = isFactory(value2) ? isTransformFunctionFactory(value2) ? value2.fn + ".transform" : value2.fn : name107;
          if (hasOwnProperty2(flatValues2, flatName) && flatValues2[flatName] !== value2 && !options.silent) {
            throw new Error('Cannot import "' + flatName + '" twice');
          }
          flatValues2[flatName] = value2;
        } else {
          if (!options.silent) {
            throw new TypeError("Factory, Object, or Array expected");
          }
        }
      }
      var flatValues = {};
      flattenImports(flatValues, functions);
      for (var name106 in flatValues) {
        if (hasOwnProperty2(flatValues, name106)) {
          var value = flatValues[name106];
          if (isFactory(value)) {
            _importFactory(value, options);
          } else if (isSupportedType(value)) {
            _import(name106, value, options);
          } else {
            if (!options.silent) {
              throw new TypeError("Factory, Object, or Array expected");
            }
          }
        }
      }
    }
    function _import(name106, value, options) {
      if (options.wrap && typeof value === "function") {
        value = _wrap(value);
      }
      if (hasTypedFunctionSignature(value)) {
        value = typed2(name106, _defineProperty({}, value.signature, value));
      }
      if (isTypedFunction(math2[name106]) && isTypedFunction(value)) {
        if (options.override) {
          value = typed2(name106, value.signatures);
        } else {
          value = typed2(math2[name106], value);
        }
        math2[name106] = value;
        delete importedFactories[name106];
        _importTransform(name106, value);
        math2.emit("import", name106, function resolver() {
          return value;
        });
        return;
      }
      if (math2[name106] === void 0 || options.override) {
        math2[name106] = value;
        delete importedFactories[name106];
        _importTransform(name106, value);
        math2.emit("import", name106, function resolver() {
          return value;
        });
        return;
      }
      if (!options.silent) {
        throw new Error('Cannot import "' + name106 + '": already exists');
      }
    }
    function _importTransform(name106, value) {
      if (value && typeof value.transform === "function") {
        math2.expression.transform[name106] = value.transform;
        if (allowedInExpressions(name106)) {
          math2.expression.mathWithTransform[name106] = value.transform;
        }
      } else {
        delete math2.expression.transform[name106];
        if (allowedInExpressions(name106)) {
          math2.expression.mathWithTransform[name106] = value;
        }
      }
    }
    function _deleteTransform(name106) {
      delete math2.expression.transform[name106];
      if (allowedInExpressions(name106)) {
        math2.expression.mathWithTransform[name106] = math2[name106];
      } else {
        delete math2.expression.mathWithTransform[name106];
      }
    }
    function _wrap(fn) {
      var wrapper = function wrapper2() {
        var args = [];
        for (var i3 = 0, len = arguments.length; i3 < len; i3++) {
          var arg = arguments[i3];
          args[i3] = arg && arg.valueOf();
        }
        return fn.apply(math2, args);
      };
      if (fn.transform) {
        wrapper.transform = fn.transform;
      }
      return wrapper;
    }
    function _importFactory(factory2, options) {
      var name106 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : factory2.fn;
      if (contains2(name106, ".")) {
        throw new Error("Factory name should not contain a nested path. Name: " + JSON.stringify(name106));
      }
      var namespace = isTransformFunctionFactory(factory2) ? math2.expression.transform : math2;
      var existingTransform = name106 in math2.expression.transform;
      var existing = hasOwnProperty2(namespace, name106) ? namespace[name106] : void 0;
      var resolver = function resolver2() {
        var dependencies95 = {};
        factory2.dependencies.map(stripOptionalNotation).forEach(function(dependency) {
          if (contains2(dependency, ".")) {
            throw new Error("Factory dependency should not contain a nested path. Name: " + JSON.stringify(dependency));
          }
          if (dependency === "math") {
            dependencies95.math = math2;
          } else if (dependency === "mathWithTransform") {
            dependencies95.mathWithTransform = math2.expression.mathWithTransform;
          } else if (dependency === "classes") {
            dependencies95.classes = math2;
          } else {
            dependencies95[dependency] = math2[dependency];
          }
        });
        var instance = /* @__PURE__ */ factory2(dependencies95);
        if (instance && typeof instance.transform === "function") {
          throw new Error('Transforms cannot be attached to factory functions. Please create a separate function for it with exports.path="expression.transform"');
        }
        if (existing === void 0 || options.override) {
          return instance;
        }
        if (isTypedFunction(existing) && isTypedFunction(instance)) {
          return typed2(existing, instance);
        }
        if (options.silent) {
          return existing;
        } else {
          throw new Error('Cannot import "' + name106 + '": already exists');
        }
      };
      if (!factory2.meta || factory2.meta.lazy !== false) {
        lazy(namespace, name106, resolver);
        if (existing && existingTransform) {
          _deleteTransform(name106);
        } else {
          if (isTransformFunctionFactory(factory2) || factoryAllowedInExpressions(factory2)) {
            lazy(math2.expression.mathWithTransform, name106, function() {
              return namespace[name106];
            });
          }
        }
      } else {
        namespace[name106] = resolver();
        if (existing && existingTransform) {
          _deleteTransform(name106);
        } else {
          if (isTransformFunctionFactory(factory2) || factoryAllowedInExpressions(factory2)) {
            lazy(math2.expression.mathWithTransform, name106, function() {
              return namespace[name106];
            });
          }
        }
      }
      importedFactories[name106] = factory2;
      math2.emit("import", name106, resolver);
    }
    function isSupportedType(object) {
      return typeof object === "function" || typeof object === "number" || typeof object === "string" || typeof object === "boolean" || object === null || isUnit(object) || isComplex(object) || isBigNumber(object) || isFraction(object) || isMatrix(object) || Array.isArray(object);
    }
    function isTypedFunction(fn) {
      return typeof fn === "function" && _typeof12(fn.signatures) === "object";
    }
    function hasTypedFunctionSignature(fn) {
      return typeof fn === "function" && typeof fn.signature === "string";
    }
    function allowedInExpressions(name106) {
      return !hasOwnProperty2(unsafe, name106);
    }
    function factoryAllowedInExpressions(factory2) {
      return factory2.fn.indexOf(".") === -1 && !hasOwnProperty2(unsafe, factory2.fn) && (!factory2.meta || !factory2.meta.isClass);
    }
    function isTransformFunctionFactory(factory2) {
      return factory2 !== void 0 && factory2.meta !== void 0 && factory2.meta.isTransformFunction === true || false;
    }
    var unsafe = {
      expression: true,
      type: true,
      docs: true,
      error: true,
      json: true,
      chain: true
    };
    return mathImport;
  }
  var init_import2 = __esm({
    "node_modules/mathjs/es/core/function/import.js"() {
      init_is();
      init_factory();
      init_object();
      init_array();
      init_ArgumentsError();
    }
  });

  // node_modules/mathjs/es/core/create.js
  function _extends5() {
    _extends5 = Object.assign || function(target) {
      for (var i3 = 1; i3 < arguments.length; i3++) {
        var source = arguments[i3];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends5.apply(this, arguments);
  }
  function create2(factories, config3) {
    var configInternal = _extends5({}, DEFAULT_CONFIG, config3);
    if (typeof Object.create !== "function") {
      throw new Error("ES5 not supported by this JavaScript engine. Please load the es5-shim and es5-sham library for compatibility.");
    }
    var math2 = mixin({
      isNumber,
      isComplex,
      isBigNumber,
      isFraction,
      isUnit,
      isString,
      isArray,
      isMatrix,
      isCollection,
      isDenseMatrix,
      isSparseMatrix,
      isRange,
      isIndex,
      isBoolean,
      isResultSet,
      isHelp,
      isFunction,
      isDate,
      isRegExp,
      isObject,
      isNull,
      isUndefined,
      isAccessorNode,
      isArrayNode,
      isAssignmentNode,
      isBlockNode,
      isConditionalNode,
      isConstantNode,
      isFunctionAssignmentNode,
      isFunctionNode,
      isIndexNode,
      isNode,
      isObjectNode,
      isOperatorNode,
      isParenthesisNode,
      isRangeNode,
      isSymbolNode,
      isChain
    });
    math2.config = configFactory(configInternal, math2.emit);
    math2.expression = {
      transform: {},
      mathWithTransform: {
        config: math2.config
      }
    };
    var legacyFactories = [];
    var legacyInstances = [];
    function load(factory2) {
      if (isFactory(factory2)) {
        return factory2(math2);
      }
      var firstProperty = factory2[Object.keys(factory2)[0]];
      if (isFactory(firstProperty)) {
        return firstProperty(math2);
      }
      if (!isLegacyFactory(factory2)) {
        console.warn("Factory object with properties `type`, `name`, and `factory` expected", factory2);
        throw new Error("Factory object with properties `type`, `name`, and `factory` expected");
      }
      var index2 = legacyFactories.indexOf(factory2);
      var instance;
      if (index2 === -1) {
        if (factory2.math === true) {
          instance = factory2.factory(math2.type, configInternal, load, math2.typed, math2);
        } else {
          instance = factory2.factory(math2.type, configInternal, load, math2.typed);
        }
        legacyFactories.push(factory2);
        legacyInstances.push(instance);
      } else {
        instance = legacyInstances[index2];
      }
      return instance;
    }
    var importedFactories = {};
    function lazyTyped() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return math2.typed.apply(math2.typed, args);
    }
    var internalImport = importFactory(lazyTyped, load, math2, importedFactories);
    math2["import"] = internalImport;
    math2.on("config", function() {
      values(importedFactories).forEach(function(factory2) {
        if (factory2 && factory2.meta && factory2.meta.recreateOnConfigChange) {
          internalImport(factory2, {
            override: true
          });
        }
      });
    });
    math2.create = create2.bind(null, factories);
    math2.factory = factory;
    math2["import"](values(deepFlatten(factories)));
    math2.ArgumentsError = ArgumentsError;
    math2.DimensionError = DimensionError;
    math2.IndexError = IndexError;
    return math2;
  }
  var init_create = __esm({
    "node_modules/mathjs/es/core/create.js"() {
      init_object();
      init_emitter();
      init_import2();
      init_config2();
      init_factory();
      init_is();
      init_ArgumentsError();
      init_DimensionError();
      init_IndexError();
      init_config();
    }
  });

  // node_modules/mathjs/es/entry/mainNumber.js
  var init_mainNumber = __esm({
    "node_modules/mathjs/es/entry/mainNumber.js"() {
      init_configReadonly();
      init_pureFunctionsNumber_generated();
      init_impureFunctionsNumber_generated();
      init_typeChecks();
      init_IndexError();
      init_DimensionError();
      init_ArgumentsError();
      init_dependenciesNumber_generated2();
      init_factoriesNumber();
      init_create();
      init_factory();
    }
  });

  // node_modules/mathjs/main/esm/number.js
  var init_number5 = __esm({
    "node_modules/mathjs/main/esm/number.js"() {
      init_mainNumber();
    }
  });

  // node_modules/mathjs/number.js
  var number_exports = {};
  __export(number_exports, {
    AccessorNode: () => AccessorNode,
    AccessorNodeDependencies: () => AccessorNodeDependencies,
    ArgumentsError: () => ArgumentsError,
    ArrayNode: () => ArrayNode,
    ArrayNodeDependencies: () => ArrayNodeDependencies,
    AssignmentNode: () => AssignmentNode,
    AssignmentNodeDependencies: () => AssignmentNodeDependencies,
    BlockNode: () => BlockNode,
    BlockNodeDependencies: () => BlockNodeDependencies,
    Chain: () => Chain,
    ChainDependencies: () => ChainDependencies,
    ConditionalNode: () => ConditionalNode,
    ConditionalNodeDependencies: () => ConditionalNodeDependencies,
    ConstantNode: () => ConstantNode,
    ConstantNodeDependencies: () => ConstantNodeDependencies,
    DimensionError: () => DimensionError,
    EDependencies: () => EDependencies,
    FunctionAssignmentNode: () => FunctionAssignmentNode,
    FunctionAssignmentNodeDependencies: () => FunctionAssignmentNodeDependencies,
    FunctionNode: () => FunctionNode,
    FunctionNodeDependencies: () => FunctionNodeDependencies,
    Help: () => Help,
    HelpDependencies: () => HelpDependencies,
    IndexError: () => IndexError,
    IndexNode: () => IndexNode,
    IndexNodeDependencies: () => IndexNodeDependencies,
    InfinityDependencies: () => InfinityDependencies,
    LN10: () => LN10,
    LN10Dependencies: () => LN10Dependencies,
    LN2: () => LN2,
    LN2Dependencies: () => LN2Dependencies,
    LOG10E: () => LOG10E,
    LOG10EDependencies: () => LOG10EDependencies,
    LOG2E: () => LOG2E,
    LOG2EDependencies: () => LOG2EDependencies,
    NaNDependencies: () => NaNDependencies,
    Node: () => Node2,
    NodeDependencies: () => NodeDependencies,
    ObjectNode: () => ObjectNode,
    ObjectNodeDependencies: () => ObjectNodeDependencies,
    OperatorNode: () => OperatorNode,
    OperatorNodeDependencies: () => OperatorNodeDependencies,
    PIDependencies: () => PIDependencies,
    ParenthesisNode: () => ParenthesisNode,
    ParenthesisNodeDependencies: () => ParenthesisNodeDependencies,
    Parser: () => Parser,
    ParserDependencies: () => ParserDependencies,
    Range: () => Range2,
    RangeDependencies: () => RangeDependencies,
    RangeNode: () => RangeNode,
    RangeNodeDependencies: () => RangeNodeDependencies,
    RelationalNode: () => RelationalNode,
    RelationalNodeDependencies: () => RelationalNodeDependencies,
    ResultSet: () => ResultSet,
    ResultSetDependencies: () => ResultSetDependencies,
    SQRT1_2: () => SQRT1_2,
    SQRT1_2Dependencies: () => SQRT1_2Dependencies,
    SQRT2: () => SQRT2,
    SQRT2Dependencies: () => SQRT2Dependencies,
    SymbolNode: () => SymbolNode,
    SymbolNodeDependencies: () => SymbolNodeDependencies,
    _Infinity: () => _Infinity,
    _NaN: () => _NaN,
    _false: () => _false,
    _null: () => _null,
    _true: () => _true,
    abs: () => abs,
    absDependencies: () => absDependencies,
    acos: () => acos,
    acosDependencies: () => acosDependencies,
    acosh: () => acosh2,
    acoshDependencies: () => acoshDependencies,
    acot: () => acot,
    acotDependencies: () => acotDependencies,
    acoth: () => acoth,
    acothDependencies: () => acothDependencies,
    acsc: () => acsc,
    acscDependencies: () => acscDependencies,
    acsch: () => acsch,
    acschDependencies: () => acschDependencies,
    add: () => add,
    addDependencies: () => addDependencies,
    addScalar: () => addScalar,
    addScalarDependencies: () => addScalarDependencies,
    all: () => all,
    and: () => and,
    andDependencies: () => andDependencies,
    apply: () => apply,
    applyDependencies: () => applyDependencies,
    applyTransformDependencies: () => applyTransformDependencies,
    asec: () => asec,
    asecDependencies: () => asecDependencies,
    asech: () => asech,
    asechDependencies: () => asechDependencies,
    asin: () => asin,
    asinDependencies: () => asinDependencies,
    asinh: () => asinh2,
    asinhDependencies: () => asinhDependencies,
    atan: () => atan,
    atan2: () => atan2,
    atan2Dependencies: () => atan2Dependencies,
    atanDependencies: () => atanDependencies,
    atanh: () => atanh2,
    atanhDependencies: () => atanhDependencies,
    bellNumbers: () => bellNumbers,
    bellNumbersDependencies: () => bellNumbersDependencies,
    bitAnd: () => bitAnd,
    bitAndDependencies: () => bitAndDependencies,
    bitNot: () => bitNot,
    bitNotDependencies: () => bitNotDependencies,
    bitOr: () => bitOr,
    bitOrDependencies: () => bitOrDependencies,
    bitXor: () => bitXor,
    bitXorDependencies: () => bitXorDependencies,
    boolean: () => _boolean,
    booleanDependencies: () => booleanDependencies,
    catalan: () => catalan,
    catalanDependencies: () => catalanDependencies,
    cbrt: () => cbrt3,
    cbrtDependencies: () => cbrtDependencies,
    ceil: () => ceil,
    ceilDependencies: () => ceilDependencies,
    chain: () => chain,
    chainDependencies: () => chainDependencies,
    clone: () => clone2,
    cloneDependencies: () => cloneDependencies,
    combinations: () => combinations,
    combinationsDependencies: () => combinationsDependencies,
    combinationsWithRep: () => combinationsWithRep,
    combinationsWithRepDependencies: () => combinationsWithRepDependencies,
    compare: () => compare,
    compareDependencies: () => compareDependencies,
    compareNatural: () => compareNatural,
    compareNaturalDependencies: () => compareNaturalDependencies,
    compareText: () => compareText2,
    compareTextDependencies: () => compareTextDependencies,
    compile: () => compile,
    compileDependencies: () => compileDependencies,
    composition: () => composition,
    compositionDependencies: () => compositionDependencies,
    config: () => config,
    cos: () => cos,
    cosDependencies: () => cosDependencies,
    cosh: () => cosh2,
    coshDependencies: () => coshDependencies,
    cot: () => cot,
    cotDependencies: () => cotDependencies,
    coth: () => coth,
    cothDependencies: () => cothDependencies,
    create: () => create2,
    createAbs: () => createAbs,
    createAccessorNode: () => createAccessorNode,
    createAcos: () => createAcos,
    createAcosh: () => createAcosh,
    createAcot: () => createAcot,
    createAcoth: () => createAcoth,
    createAcsc: () => createAcsc,
    createAcsch: () => createAcsch,
    createAdd: () => createAdd,
    createAddScalar: () => createAddScalar,
    createAnd: () => createAnd,
    createApply: () => createApply,
    createApplyTransform: () => createApplyTransform,
    createArrayNode: () => createArrayNode,
    createAsec: () => createAsec,
    createAsech: () => createAsech,
    createAsin: () => createAsin,
    createAsinh: () => createAsinh,
    createAssignmentNode: () => createAssignmentNode,
    createAtan: () => createAtan,
    createAtan2: () => createAtan2,
    createAtanh: () => createAtanh,
    createBellNumbers: () => createBellNumbers,
    createBitAnd: () => createBitAnd,
    createBitNot: () => createBitNot,
    createBitOr: () => createBitOr,
    createBitXor: () => createBitXor,
    createBlockNode: () => createBlockNode,
    createBoolean: () => createBoolean,
    createCatalan: () => createCatalan,
    createCbrt: () => createCbrt,
    createCeil: () => createCeil,
    createChain: () => createChain,
    createChainClass: () => createChainClass,
    createClone: () => createClone,
    createCombinations: () => createCombinations,
    createCombinationsWithRep: () => createCombinationsWithRep,
    createCompare: () => createCompareNumber,
    createCompareNatural: () => createCompareNatural,
    createCompareText: () => createCompareTextNumber,
    createCompile: () => createCompile,
    createComposition: () => createComposition,
    createConditionalNode: () => createConditionalNode,
    createConstantNode: () => createConstantNode,
    createCos: () => createCos,
    createCosh: () => createCosh,
    createCot: () => createCot,
    createCoth: () => createCoth,
    createCsc: () => createCsc,
    createCsch: () => createCsch,
    createCube: () => createCube,
    createDeepEqual: () => createDeepEqual,
    createDerivative: () => createDerivative,
    createDivide: () => createDivide,
    createDivideScalar: () => createDivideScalar,
    createE: () => createE,
    createEqual: () => createEqualNumber,
    createEqualScalar: () => createEqualScalarNumber,
    createEqualText: () => createEqualText,
    createErf: () => createErf,
    createEvaluate: () => createEvaluate,
    createExp: () => createExp,
    createExpm1: () => createExpm1,
    createFactorial: () => createFactorial,
    createFalse: () => createFalse,
    createFilter: () => createFilter,
    createFilterTransform: () => createFilterTransform,
    createFix: () => createFix,
    createFloor: () => createFloor,
    createForEach: () => createForEach,
    createForEachTransform: () => createForEachTransform,
    createFormat: () => createFormat,
    createFunctionAssignmentNode: () => createFunctionAssignmentNode,
    createFunctionNode: () => createFunctionNode,
    createGamma: () => createGamma,
    createGcd: () => createGcd,
    createHasNumericValue: () => createHasNumericValue,
    createHelp: () => createHelp,
    createHelpClass: () => createHelpClass,
    createHypot: () => createHypot,
    createIndex: () => createIndex,
    createIndexNode: () => createIndexNode,
    createInfinity: () => createInfinity,
    createIsInteger: () => createIsInteger,
    createIsNaN: () => createIsNaN,
    createIsNegative: () => createIsNegative,
    createIsNumeric: () => createIsNumeric,
    createIsPositive: () => createIsPositive,
    createIsPrime: () => createIsPrime,
    createIsZero: () => createIsZero,
    createLN10: () => createLN10,
    createLN2: () => createLN2,
    createLOG10E: () => createLOG10E,
    createLOG2E: () => createLOG2E,
    createLarger: () => createLargerNumber,
    createLargerEq: () => createLargerEqNumber,
    createLcm: () => createLcm,
    createLeftShift: () => createLeftShift,
    createLog: () => createLog,
    createLog10: () => createLog10,
    createLog1p: () => createLog1p,
    createLog2: () => createLog2,
    createMad: () => createMad,
    createMap: () => createMap,
    createMapTransform: () => createMapTransform,
    createMatrix: () => createMatrix,
    createMax: () => createMax,
    createMaxTransform: () => createMaxTransform,
    createMean: () => createMean,
    createMeanTransform: () => createMeanTransform,
    createMedian: () => createMedian,
    createMin: () => createMin,
    createMinTransform: () => createMinTransform,
    createMod: () => createMod,
    createMode: () => createMode,
    createMultinomial: () => createMultinomial,
    createMultiply: () => createMultiply,
    createMultiplyScalar: () => createMultiplyScalar,
    createNaN: () => createNaN,
    createNode: () => createNode,
    createNorm: () => createNorm,
    createNot: () => createNot,
    createNthRoot: () => createNthRootNumber,
    createNull: () => createNull,
    createNumber: () => createNumber,
    createNumeric: () => createNumeric,
    createObjectNode: () => createObjectNode,
    createOperatorNode: () => createOperatorNode,
    createOr: () => createOr,
    createParenthesisNode: () => createParenthesisNode,
    createParse: () => createParse,
    createParser: () => createParser,
    createParserClass: () => createParserClass,
    createPartitionSelect: () => createPartitionSelect,
    createPermutations: () => createPermutations,
    createPhi: () => createPhi,
    createPi: () => createPi,
    createPickRandom: () => createPickRandom,
    createPow: () => createPow,
    createPrint: () => createPrint,
    createProd: () => createProd,
    createQuantileSeq: () => createQuantileSeq,
    createRandom: () => createRandomNumber,
    createRandomInt: () => createRandomInt,
    createRange: () => createRange,
    createRangeClass: () => createRangeClass,
    createRangeNode: () => createRangeNode,
    createRangeTransform: () => createRangeTransform,
    createRationalize: () => createRationalize,
    createRelationalNode: () => createRelationalNode,
    createReplacer: () => createReplacer,
    createResultSet: () => createResultSet,
    createReviver: () => createReviver,
    createRightArithShift: () => createRightArithShift,
    createRightLogShift: () => createRightLogShift,
    createRound: () => createRoundNumber,
    createSQRT1_2: () => createSQRT1_2,
    createSQRT2: () => createSQRT2,
    createSec: () => createSec,
    createSech: () => createSech,
    createSign: () => createSign,
    createSimplify: () => createSimplify,
    createSin: () => createSin,
    createSinh: () => createSinh,
    createSize: () => createSize,
    createSmaller: () => createSmallerNumber,
    createSmallerEq: () => createSmallerEqNumber,
    createSqrt: () => createSqrt,
    createSquare: () => createSquare,
    createStd: () => createStd,
    createStdTransform: () => createStdTransform,
    createStirlingS2: () => createStirlingS2,
    createString: () => createString,
    createSubset: () => createSubset2,
    createSubsetTransform: () => createSubsetTransform,
    createSubtract: () => createSubtract,
    createSum: () => createSum,
    createSumTransform: () => createSumTransform,
    createSymbolNode: () => createSymbolNode,
    createTan: () => createTan,
    createTanh: () => createTanh,
    createTau: () => createTau,
    createTrue: () => createTrue,
    createTypeOf: () => createTypeOf,
    createTyped: () => createTyped,
    createUnaryMinus: () => createUnaryMinus,
    createUnaryPlus: () => createUnaryPlus,
    createUnequal: () => createUnequalNumber,
    createUppercaseE: () => createUppercaseE,
    createUppercasePi: () => createUppercasePi,
    createVariance: () => createVariance,
    createVarianceTransform: () => createVarianceTransform,
    createVersion: () => createVersion,
    createXgcd: () => createXgcd,
    createXor: () => createXor,
    csc: () => csc,
    cscDependencies: () => cscDependencies,
    csch: () => csch,
    cschDependencies: () => cschDependencies,
    cube: () => cube,
    cubeDependencies: () => cubeDependencies,
    deepEqual: () => deepEqual2,
    deepEqualDependencies: () => deepEqualDependencies,
    derivative: () => derivative,
    derivativeDependencies: () => derivativeDependencies,
    divide: () => divide,
    divideDependencies: () => divideDependencies,
    divideScalar: () => divideScalar,
    divideScalarDependencies: () => divideScalarDependencies,
    docs: () => embeddedDocs,
    e: () => e4,
    eDependencies: () => eDependencies,
    equal: () => equal2,
    equalDependencies: () => equalDependencies,
    equalScalar: () => equalScalar,
    equalScalarDependencies: () => equalScalarDependencies,
    equalText: () => equalText,
    equalTextDependencies: () => equalTextDependencies,
    erf: () => erf,
    erfDependencies: () => erfDependencies,
    evaluate: () => evaluate,
    evaluateDependencies: () => evaluateDependencies,
    exp: () => exp,
    expDependencies: () => expDependencies,
    expm1: () => expm13,
    expm1Dependencies: () => expm1Dependencies,
    factorial: () => factorial,
    factorialDependencies: () => factorialDependencies,
    factory: () => factory,
    falseDependencies: () => falseDependencies,
    filter: () => filter2,
    filterDependencies: () => filterDependencies,
    filterTransformDependencies: () => filterTransformDependencies,
    fix: () => fix,
    fixDependencies: () => fixDependencies,
    floor: () => floor,
    floorDependencies: () => floorDependencies,
    forEach: () => forEach2,
    forEachDependencies: () => forEachDependencies,
    forEachTransformDependencies: () => forEachTransformDependencies,
    format: () => format4,
    formatDependencies: () => formatDependencies,
    gamma: () => gamma,
    gammaDependencies: () => gammaDependencies,
    gcd: () => gcd,
    gcdDependencies: () => gcdDependencies,
    hasNumericValue: () => hasNumericValue,
    hasNumericValueDependencies: () => hasNumericValueDependencies,
    help: () => help,
    helpDependencies: () => helpDependencies,
    hypot: () => hypot,
    hypotDependencies: () => hypotDependencies,
    index: () => index,
    indexDependencies: () => indexDependencies,
    isAccessorNode: () => isAccessorNode,
    isArray: () => isArray,
    isArrayNode: () => isArrayNode,
    isAssignmentNode: () => isAssignmentNode,
    isBigNumber: () => isBigNumber,
    isBlockNode: () => isBlockNode,
    isBoolean: () => isBoolean,
    isChain: () => isChain,
    isCollection: () => isCollection,
    isComplex: () => isComplex,
    isConditionalNode: () => isConditionalNode,
    isConstantNode: () => isConstantNode,
    isDate: () => isDate,
    isDenseMatrix: () => isDenseMatrix,
    isFraction: () => isFraction,
    isFunction: () => isFunction,
    isFunctionAssignmentNode: () => isFunctionAssignmentNode,
    isFunctionNode: () => isFunctionNode,
    isHelp: () => isHelp,
    isIndex: () => isIndex,
    isIndexNode: () => isIndexNode,
    isInteger: () => isInteger2,
    isIntegerDependencies: () => isIntegerDependencies,
    isMatrix: () => isMatrix,
    isNaN: () => isNaN2,
    isNaNDependencies: () => isNaNDependencies,
    isNegative: () => isNegative,
    isNegativeDependencies: () => isNegativeDependencies,
    isNode: () => isNode,
    isNull: () => isNull,
    isNumber: () => isNumber,
    isNumeric: () => isNumeric,
    isNumericDependencies: () => isNumericDependencies,
    isObject: () => isObject,
    isObjectNode: () => isObjectNode,
    isOperatorNode: () => isOperatorNode,
    isParenthesisNode: () => isParenthesisNode,
    isPositive: () => isPositive,
    isPositiveDependencies: () => isPositiveDependencies,
    isPrime: () => isPrime,
    isPrimeDependencies: () => isPrimeDependencies,
    isRange: () => isRange,
    isRangeNode: () => isRangeNode,
    isRegExp: () => isRegExp,
    isResultSet: () => isResultSet,
    isSparseMatrix: () => isSparseMatrix,
    isString: () => isString,
    isSymbolNode: () => isSymbolNode,
    isUndefined: () => isUndefined,
    isUnit: () => isUnit,
    isZero: () => isZero,
    isZeroDependencies: () => isZeroDependencies,
    larger: () => larger,
    largerDependencies: () => largerDependencies,
    largerEq: () => largerEq,
    largerEqDependencies: () => largerEqDependencies,
    lcm: () => lcm,
    lcmDependencies: () => lcmDependencies,
    leftShift: () => leftShift,
    leftShiftDependencies: () => leftShiftDependencies,
    log: () => log,
    log10: () => log103,
    log10Dependencies: () => log10Dependencies,
    log1p: () => log1p2,
    log1pDependencies: () => log1pDependencies,
    log2: () => log23,
    log2Dependencies: () => log2Dependencies,
    logDependencies: () => logDependencies,
    mad: () => mad,
    madDependencies: () => madDependencies,
    map: () => map2,
    mapDependencies: () => mapDependencies,
    mapTransformDependencies: () => mapTransformDependencies,
    matrix: () => matrix,
    matrixDependencies: () => matrixDependencies,
    max: () => max,
    maxDependencies: () => maxDependencies,
    maxTransformDependencies: () => maxTransformDependencies,
    mean: () => mean,
    meanDependencies: () => meanDependencies,
    meanTransformDependencies: () => meanTransformDependencies,
    median: () => median,
    medianDependencies: () => medianDependencies,
    min: () => min,
    minDependencies: () => minDependencies,
    minTransformDependencies: () => minTransformDependencies,
    mod: () => mod,
    modDependencies: () => modDependencies,
    mode: () => mode,
    modeDependencies: () => modeDependencies,
    multinomial: () => multinomial,
    multinomialDependencies: () => multinomialDependencies,
    multiply: () => multiply,
    multiplyDependencies: () => multiplyDependencies,
    multiplyScalar: () => multiplyScalar,
    multiplyScalarDependencies: () => multiplyScalarDependencies,
    norm: () => norm,
    normDependencies: () => normDependencies,
    not: () => not,
    notDependencies: () => notDependencies,
    nthRoot: () => nthRoot,
    nthRootDependencies: () => nthRootDependencies,
    nullDependencies: () => nullDependencies,
    number: () => number,
    numberDependencies: () => numberDependencies,
    numeric: () => numeric2,
    numericDependencies: () => numericDependencies,
    or: () => or,
    orDependencies: () => orDependencies,
    parse: () => parse,
    parseDependencies: () => parseDependencies,
    parser: () => parser,
    parserDependencies: () => parserDependencies,
    partitionSelect: () => partitionSelect,
    partitionSelectDependencies: () => partitionSelectDependencies,
    permutations: () => permutations,
    permutationsDependencies: () => permutationsDependencies,
    phi: () => phi2,
    phiDependencies: () => phiDependencies,
    pi: () => pi2,
    piDependencies: () => piDependencies,
    pickRandom: () => pickRandom,
    pickRandomDependencies: () => pickRandomDependencies,
    pow: () => pow,
    powDependencies: () => powDependencies,
    print: () => print,
    printDependencies: () => printDependencies,
    prod: () => prod,
    prodDependencies: () => prodDependencies,
    quantileSeq: () => quantileSeq,
    quantileSeqDependencies: () => quantileSeqDependencies,
    random: () => random,
    randomDependencies: () => randomDependencies,
    randomInt: () => randomInt,
    randomIntDependencies: () => randomIntDependencies,
    range: () => range,
    rangeDependencies: () => rangeDependencies,
    rangeTransformDependencies: () => rangeTransformDependencies,
    rationalize: () => rationalize,
    rationalizeDependencies: () => rationalizeDependencies,
    replacer: () => replacer2,
    replacerDependencies: () => replacerDependencies,
    reviver: () => reviver,
    reviverDependencies: () => reviverDependencies,
    rightArithShift: () => rightArithShift,
    rightArithShiftDependencies: () => rightArithShiftDependencies,
    rightLogShift: () => rightLogShift,
    rightLogShiftDependencies: () => rightLogShiftDependencies,
    round: () => round,
    roundDependencies: () => roundDependencies,
    sec: () => sec,
    secDependencies: () => secDependencies,
    sech: () => sech,
    sechDependencies: () => sechDependencies,
    sign: () => sign2,
    signDependencies: () => signDependencies,
    simplify: () => simplify,
    simplifyDependencies: () => simplifyDependencies,
    sin: () => sin,
    sinDependencies: () => sinDependencies,
    sinh: () => sinh2,
    sinhDependencies: () => sinhDependencies,
    size: () => size,
    sizeDependencies: () => sizeDependencies,
    smaller: () => smaller,
    smallerDependencies: () => smallerDependencies,
    smallerEq: () => smallerEq,
    smallerEqDependencies: () => smallerEqDependencies,
    sqrt: () => sqrt,
    sqrtDependencies: () => sqrtDependencies,
    square: () => square,
    squareDependencies: () => squareDependencies,
    std: () => std,
    stdDependencies: () => stdDependencies,
    stdTransformDependencies: () => stdTransformDependencies,
    stirlingS2: () => stirlingS2,
    stirlingS2Dependencies: () => stirlingS2Dependencies,
    string: () => string,
    stringDependencies: () => stringDependencies,
    subset: () => subset,
    subsetDependencies: () => subsetDependencies,
    subsetTransformDependencies: () => subsetTransformDependencies,
    subtract: () => subtract,
    subtractDependencies: () => subtractDependencies,
    sum: () => sum,
    sumDependencies: () => sumDependencies,
    sumTransformDependencies: () => sumTransformDependencies,
    tan: () => tan,
    tanDependencies: () => tanDependencies,
    tanh: () => tanh2,
    tanhDependencies: () => tanhDependencies,
    tau: () => tau2,
    tauDependencies: () => tauDependencies,
    trueDependencies: () => trueDependencies,
    typeOf: () => typeOf2,
    typeOfDependencies: () => typeOfDependencies,
    typed: () => typed,
    typedDependencies: () => typedDependencies,
    unaryMinus: () => unaryMinus,
    unaryMinusDependencies: () => unaryMinusDependencies,
    unaryPlus: () => unaryPlus,
    unaryPlusDependencies: () => unaryPlusDependencies,
    unequal: () => unequal,
    unequalDependencies: () => unequalDependencies,
    variance: () => variance,
    varianceDependencies: () => varianceDependencies,
    varianceTransformDependencies: () => varianceTransformDependencies,
    version: () => version2,
    versionDependencies: () => versionDependencies,
    xgcd: () => xgcd,
    xgcdDependencies: () => xgcdDependencies,
    xor: () => xor,
    xorDependencies: () => xorDependencies
  });
  var init_number6 = __esm({
    "node_modules/mathjs/number.js"() {
      init_number5();
    }
  });

  // src/model/taxonomies.js
  init_extensions();

  // src/model/taxonomy.js
  init_objectutils();

  // src/util/array.js
  function array_default() {
    if (typeof Array.prototype.lastObject !== "function") {
      Array.prototype.lastObject = function() {
        return this[this.length - 1];
      };
    }
    if (typeof Array.prototype.sortedIndex !== "function") {
      Array.prototype.sortedIndex = function(value, sortfunction) {
        let low = 0, high = this.length;
        while (low < high) {
          let mid = low + high >> 1;
          let less = false;
          if (sortfunction !== void 0) {
            if (sortfunction(this[mid], value) < 0) {
              less = true;
            }
          } else if (this[mid] < value) {
            less = true;
          }
          if (less) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return low;
      };
    }
    if (typeof Array.prototype.shallowEquals !== "function") {
      Array.prototype.shallowEquals = function(array) {
        if (this === array) {
          return true;
        }
        if (this.length !== array.length) {
          return false;
        }
        for (let i3 = 0; i3 < this.length; ++i3) {
          if (this[i3] !== array[i3]) {
            return false;
          }
        }
        return true;
      };
    }
    if (typeof Array.prototype.sortedContains !== "function") {
      Array.prototype.sortedContains = function(value, sortfunction) {
        return this[this.sortedIndex(value, sortfunction)] === value;
      };
    }
    if (typeof Array.prototype.sortedAdd !== "function") {
      Array.prototype.sortedAdd = function(value, noDuplicates, sortfunction) {
        let index2 = this.sortedIndex(value, sortfunction);
        if (noDuplicates && this[index2] === value) {
          return;
        }
        this.splice(index2, 0, value);
      };
    }
    if (typeof Array.prototype.sortedRemove !== "function") {
      Array.prototype.sortedRemove = function(value, sortfunction) {
        let index2 = this.sortedIndex(value, sortfunction);
        if (this[index2] === value) {
          this.splice(index2, 1);
        }
      };
    }
    if (typeof Array.prototype.sortedUniquify !== "function") {
      Array.prototype.sortedUniquify = function(sortfunction) {
        let length = this.length, i3 = 0;
        while (i3 < length - 1) {
          let equal3 = false;
          if (sortfunction !== void 0) {
            equal3 = sortfunction(this[i3], this[i3 + 1]) === 0;
          } else if (this[i3] === this[i3 + 1]) {
            equal3 = true;
          }
          if (equal3) {
            this.splice(i3, 1);
            length--;
          } else {
            i3++;
          }
        }
      };
    }
  }

  // src/util/delay.js
  var Delay = function Delay2() {
    this.id = null;
  };
  (function() {
    this.set = function set(ms, f3) {
      this.clear();
      this.id = setTimeout(f3, ms);
    };
    this.clear = function clear() {
      clearTimeout(this.id);
    };
  }).call(Delay.prototype);
  var delay_default = Delay;

  // src/model/classifiertext.js
  var import_codemirror = __toModule(require_codemirror());
  var ESCAPE_SYNTAX_CHAR = "\uE002";
  var { StringStream } = import_codemirror.default;
  var ClassifierText = class {
    constructor() {
      this._node = null;
      this._attributedString = null;
      this._text = null;
      this._textStart = 0;
      this._escapedText = null;
      this._textStream = new StringStream("", 4);
    }
    _setNode(node, state) {
      this._node = node;
      this._attributedString = node.lineAttributedString();
      this._text = state !== null ? state.text : this._attributedString.string();
      this._textStart = state !== null ? state.textStart : 0;
      this._escapedText = null;
    }
    textStart() {
      return this._textStart;
    }
    text() {
      return this._text;
    }
    textCharAt(index2) {
      return this._text.charAt(index2);
    }
    textMatch(regex) {
      return this._text.match(regex);
    }
    textLength() {
      return this._text.length;
    }
    textSubstr(start2, length) {
      return this._text.substr(start2, length);
    }
    textSubstring(from, to) {
      return this._text.substring(from, to);
    }
    sliceText(start2, end) {
      this._textStart += start2;
      this._text = this._text.slice(start2, end);
      if (this._escapedText) {
        this._escapedText = this._escapedText.slice(start2, end);
      }
    }
    sliceAllText() {
      let length = this._text.length;
      this.sliceText(length, length);
    }
    addAttributeInRange(attribute, value, location, length) {
      this._attributedString.addAttributeInRange(attribute, value, this._textStart + location, length);
    }
    removeAttributeInRange(attribute, location, length) {
      this.removeAttributesInRange([attribute], location, length);
    }
    removeAttributesInRange(attributes, location, length) {
      if (location !== void 0) {
        location += this._textStart;
      }
      this._attributedString.removeAttributesInRange(attributes, location, length);
    }
    escapedTextStream() {
      let s3 = this._textStream;
      if (s3) {
        s3.start = 0;
        s3.pos = 0;
        s3.string = this.escapedText();
        s3.lastColumnPos = 0;
        s3.lastColumnValue = 0;
      }
      return s3;
    }
    escapedText() {
      let result = this._escapedText;
      if (result === null) {
        result = this._text;
        if (result.indexOf("\\") !== -1) {
          result = result.replace(/\\./g, ESCAPE_SYNTAX_CHAR + ESCAPE_SYNTAX_CHAR);
        }
        this._escapedText = result;
      }
      return result;
    }
    updateEscapedText(newEscapedText) {
      this._escapedText = newEscapedText;
    }
    escapedTextMatch(regex) {
      return this.escapedText().match(regex);
    }
    isFirstLine() {
      return this._node.previousLineNode() === null;
    }
    isLastLine() {
      return this._node.nextLineNode() === null;
    }
  };
  var _ClassifierText = ClassifierText;

  // src/model/delta.js
  var emptyArray = [];
  var Delta = class {
    constructor(location, replacedText, insertedText, fromLineCh, toLineCh, updatedNode, removedNodes, insertedNodes) {
      this.location = location;
      this.replacedText = replacedText;
      this.insertedText = insertedText;
      this.fromLineCh = fromLineCh;
      this.toLineCh = toLineCh;
      this.updatedNode = updatedNode;
      this.removedNodes = removedNodes ? removedNodes : emptyArray;
      this.insertedNodes = insertedNodes ? insertedNodes : emptyArray;
    }
    textChanged() {
      return this.insertedText !== void 0;
    }
    changeInTextLength() {
      if (this.insertedText !== void 0) {
        return this.insertedText.length - this.replacedText.length;
      }
      return 0;
    }
    changeInLinesLength() {
      return this.insertedNodes.length - this.removedNodes.length;
    }
    toString() {
      return `replace(${this.location}, ${this.replacedText},${this.insertedText})`;
    }
  };
  var _Delta = Delta;

  // src/model/classifier.js
  var DEFAULT_WORK_TIME = 10;
  var CLASSIFY_NEXT = 1;
  var RECLASSIFY_PREVIOUS = 2;
  array_default();
  var Classifier = class {
    constructor(tree) {
      this.tree = tree;
      this.invalidLineStarts = [0];
      this.delay = new delay_default();
      this.isThisUpdatingTree = false;
      this.startWorker(100);
      tree.addEventListener("treeChanged", this._treeChanged.bind(this));
    }
    cleanupForCollection() {
      this.delay.clear();
    }
    reClassifyAll() {
      const tree = this.tree;
      let each = tree.firstLineNode();
      while (each) {
        const state = each._taxonomyState;
        if (state == null ? void 0 : state.pendingModeLoading) {
          each._taxonomyState = null;
        }
        each = each.nextLineNode();
      }
      this.ensureClassified();
    }
    classify(workTime) {
      this.classifyWorker(null, null, workTime);
    }
    ensureClassified(fromNode, toNode) {
      let tree = this.tree;
      if (!fromNode) {
        fromNode = tree.firstLineNode();
      }
      if (!toNode) {
        toNode = tree.lastLineNode();
      }
      this.classifyWorker(fromNode, toNode, Infinity);
    }
    startWorker(time) {
      if (time) {
        this.delay.clear();
        this.delay.set(time, this.classifyWorker.bind(this, null, null, DEFAULT_WORK_TIME));
      }
    }
    classifyWorker(fromNode, toNode, workTime) {
      workTime = workTime ? workTime : Infinity;
      let tree = this.tree, trackOriginalStates = true, invalidLineStarts = this.invalidLineStarts, classifierText = new _ClassifierText(), classifiedNodesOriginalStates = {}, endTime = Date.now() + workTime, previousAction = CLASSIFY_NEXT, taxonomy3 = tree.taxonomy, classifiedNodeRanges = [], classifiedNodesStartLine, classifiedNodes, outerThis = this, returnToLine, returnTo, eachLine, each, state, newState;
      function prepareStateToBeginClassification() {
        let previousNode = each ? each.previousLineNode() : null;
        if (previousNode && previousNode._taxonomyState) {
          state = taxonomy3.copyState(previousNode._taxonomyState);
        } else {
          state = taxonomy3.startState();
        }
        if (!classifiedNodes || classifiedNodes.length > 0) {
          classifiedNodes = [];
          classifiedNodeRanges.push(classifiedNodes);
        }
        classifiedNodesStartLine = eachLine;
      }
      function retreatToValidLineToBeginClassification() {
        if (!each) {
          invalidLineStarts.sortedRemove(eachLine);
          each = tree.lastLineNode();
          if (each) {
            eachLine = each.lineNumber();
          }
        }
        if (each) {
          let skippedBackwards = false;
          while (each && each._reclassifiedRegion) {
            skippedBackwards = true;
            each = each.previousLineNode();
            eachLine--;
          }
          if (!each) {
            each = tree.firstLineNode();
            eachLine = 0;
          } else if (skippedBackwards) {
            each = each.nextLineNode();
            eachLine++;
          }
        }
      }
      function advanceToNextInvalidStart() {
        if (invalidLineStarts.length) {
          eachLine = invalidLineStarts[0];
          each = tree.lineNumberToNode(eachLine);
          retreatToValidLineToBeginClassification();
        } else {
          eachLine = null;
          each = null;
        }
        prepareStateToBeginClassification();
      }
      function goToNext() {
        each = each.nextLineNode();
        if (each) {
          eachLine++;
        } else {
          eachLine = null;
        }
      }
      function goToPrevious() {
        each = each.previousLineNode();
        eachLine--;
      }
      function goToNextInvalid() {
        if (fromNode || toNode) {
          while (each && each !== toNode && each._taxonomyState !== null && !invalidLineStarts.sortedContains(eachLine)) {
            goToNext();
          }
          if (each === toNode) {
            each = null;
            eachLine = null;
          }
          prepareStateToBeginClassification();
        } else {
          advanceToNextInvalidStart();
        }
      }
      function recordClassifiedNodeAndState(node, taxonomyState, goingForward) {
        node._taxonomyState = taxonomyState;
        if (goingForward) {
          classifiedNodes.push(node);
        } else if (eachLine < classifiedNodesStartLine) {
          classifiedNodesStartLine = eachLine;
          classifiedNodes.unshift(node);
        }
      }
      function copyStateAndGoToPrevious() {
        state = taxonomy3.copyState(each._taxonomyState);
        goToPrevious();
      }
      function recordMarkAndGoPrevious() {
        returnTo = each;
        returnToLine = eachLine;
        goToPrevious();
      }
      function returnToMark() {
        let iter = each, end = returnTo.nextLineNode(), iterPrevLine, iterState;
        while (iter && iter !== end) {
          iterState = iter._taxonomyState;
          if (iterState) {
            classifierText._setNode(iter, iterState);
            taxonomy3.reclassifyDown(classifierText, iterState, iterPrevLine ? iterPrevLine._taxonomyState : null);
            iter._taxonomyState = iterState;
          }
          iterPrevLine = iter;
          iter = iter.nextLineNode();
        }
        each = returnTo;
        eachLine = returnToLine;
        returnTo = null;
        returnToLine = null;
        state = taxonomy3.copyState(each._taxonomyState);
      }
      function lastPossibleEffectedNodeInRange(startLine, endNode) {
        let endNodeParent = endNode.parent;
        while (endNodeParent.lineNumber() >= startLine) {
          endNode = endNodeParent;
          endNodeParent = endNode.parent;
        }
        return endNode.lastDescendantOrSelf();
      }
      function snapshotOriginalState(node) {
        if (!trackOriginalStates) {
          return;
        }
        if (!classifiedNodesOriginalStates[node.id]) {
          let snapshot = node._taxonomyState;
          if (snapshot) {
            snapshot = taxonomy3.copyState(node._taxonomyState);
          } else {
            trackOriginalStates = false;
            return;
          }
          snapshot.styleArray = node.lineAttributedString().toCodeMirrorStyleArray();
          classifiedNodesOriginalStates[node.id] = snapshot;
        }
      }
      function hasChangedFromOriginalStateOrDiffersFromNodeState(node) {
        if (!trackOriginalStates) {
          return true;
        }
        let originalState = classifiedNodesOriginalStates[node.id];
        if (originalState) {
          let currentState = node._taxonomyState;
          if (node._hasChangedFromTaxonomyState(originalState)) {
            return true;
          }
          if (taxonomy3.equalStates(originalState, currentState)) {
            let currentStyleArray = node.lineAttributedString().toCodeMirrorStyleArray();
            if (currentStyleArray.shallowEquals(originalState.styleArray)) {
              return false;
            }
          }
        }
        return true;
      }
      function saveStartAndApplyStateToClassifiedNodes(nextInvalidLine) {
        tree.beginUpdates();
        for (let j3 = 0; j3 < classifiedNodeRanges.length; j3++) {
          const nodesInRange = classifiedNodeRanges[j3];
          let nodeStructureLevelChanged = false;
          let length = nodesInRange.length;
          let eachStructureLevel;
          let each2 = nodesInRange[0];
          while (each2 && !hasChangedFromOriginalStateOrDiffersFromNodeState(each2)) {
            nodesInRange.shift();
            each2 = nodesInRange[0];
            length--;
          }
          each2 = nodesInRange.lastObject();
          while (each2 && !hasChangedFromOriginalStateOrDiffersFromNodeState(each2)) {
            nodesInRange.pop();
            each2 = nodesInRange.lastObject();
            length--;
          }
          if (length) {
            let rangeStartNode = nodesInRange[0], rangeStartLine = rangeStartNode.lineNumber(), rangeEndNode = nodesInRange[nodesInRange.length - 1], rangeMaxEffectedNode = rangeEndNode, rangeMaxEffectedNodeBeforeUpdate = lastPossibleEffectedNodeInRange(rangeStartLine, rangeEndNode);
            tree.disableDeltaRegistration();
            for (let i3 = 0; i3 < length; i3++) {
              each2 = nodesInRange[i3];
              eachStructureLevel = each2._structureLevel;
              each2._updateFromTaxonomyState(each2._taxonomyState);
              if (eachStructureLevel !== each2._structureLevel) {
                nodeStructureLevelChanged = true;
              }
            }
            if (nextInvalidLine !== null) {
              invalidLineStarts.sortedAdd(nextInvalidLine, true);
              outerThis.startWorker(100);
            }
            tree.enableDeltaRegistration();
            if (nodeStructureLevelChanged) {
              let rangeMaxEffectedNodeAfterUpdate = lastPossibleEffectedNodeInRange(rangeStartLine, rangeEndNode);
              if (rangeMaxEffectedNodeAfterUpdate.lineNumber() > rangeMaxEffectedNodeBeforeUpdate.lineNumber()) {
                rangeMaxEffectedNode = rangeMaxEffectedNodeAfterUpdate;
              } else {
                rangeMaxEffectedNode = rangeMaxEffectedNodeBeforeUpdate;
              }
              while (rangeEndNode !== rangeMaxEffectedNode) {
                rangeEndNode = rangeEndNode.nextLineNode();
                nodesInRange.push(rangeEndNode);
              }
            }
            if (nodesInRange.length === 1) {
              if (tree.isDeltaRegistrationEnabled()) {
                tree.recordDelta(new _Delta(rangeStartNode.lineTextStart(), void 0, void 0, { line: rangeStartLine, ch: 0 }, {
                  line: rangeMaxEffectedNode.lineNumber(),
                  ch: rangeMaxEffectedNode.line().length
                }, rangeStartNode, [], []));
              }
            } else if (tree.isDeltaRegistrationEnabled()) {
              tree.recordDelta(new _Delta(rangeStartNode.lineTextStart(), void 0, void 0, { line: rangeStartLine, ch: 0 }, {
                line: rangeMaxEffectedNode.lineNumber(),
                ch: rangeMaxEffectedNode.line().length
              }, null, nodesInRange, nodesInRange));
            }
          }
        }
        outerThis.isThisUpdatingTree = true;
        tree.endUpdates();
        outerThis.isThisUpdatingTree = false;
      }
      if (toNode) {
        toNode = toNode.nextLineNode();
      }
      if (fromNode) {
        each = fromNode;
        eachLine = each.lineNumber();
        goToNextInvalid();
        if (!each) {
          return;
        }
        retreatToValidLineToBeginClassification();
        prepareStateToBeginClassification();
      } else {
        advanceToNextInvalidStart();
      }
      if (!each) {
        return;
      }
      while (each) {
        const originalState = each._taxonomyState;
        const originalWasReclassifiedRegion = each._reclassifiedRegion;
        let nextAction;
        snapshotOriginalState(each);
        if (previousAction === CLASSIFY_NEXT) {
          newState = taxonomy3.startState();
          classifierText._setNode(each, null);
          classifierText.removeAttributesInRange(taxonomy3.textAttributesToClearBeforeClassify());
          taxonomy3.classify(classifierText, newState, state);
          state = newState;
          nextAction = state.nextAction;
          recordClassifiedNodeAndState(each, state, true);
          each._reclassifiedRegion = false;
          invalidLineStarts.sortedRemove(eachLine);
        } else if (previousAction === RECLASSIFY_PREVIOUS) {
          let reclassifiedState = taxonomy3.copyState(each._taxonomyState);
          classifierText._setNode(each, reclassifiedState);
          taxonomy3.reclassifyUp(classifierText, reclassifiedState, state);
          nextAction = reclassifiedState.nextAction;
          recordClassifiedNodeAndState(each, reclassifiedState, false);
          each._reclassifiedRegion = true;
        } else {
          throw new Error("Invalid next action");
        }
        if (nextAction === CLASSIFY_NEXT) {
          if (returnTo) {
            returnToMark();
            goToNext();
          } else if (!originalWasReclassifiedRegion && taxonomy3.equalStates(originalState || {}, state)) {
            goToNextInvalid();
          } else {
            goToNext();
          }
          if (each === toNode) {
            saveStartAndApplyStateToClassifiedNodes(eachLine);
            return;
          }
          if (workTime !== Infinity && endTime < Date.now()) {
            saveStartAndApplyStateToClassifiedNodes(eachLine);
            return;
          }
        } else {
          each._reclassifiedRegion = true;
          if (returnTo) {
            copyStateAndGoToPrevious();
            if (!each || !each._taxonomyState) {
              returnToMark();
              goToNext();
              nextAction = CLASSIFY_NEXT;
            }
          } else {
            recordMarkAndGoPrevious();
          }
        }
        previousAction = nextAction;
      }
      saveStartAndApplyStateToClassifiedNodes(null);
      this.delay.clear();
    }
    _treeChanged() {
      if (this.isThisUpdatingTree) {
        return;
      }
      this.startWorker(100);
    }
    _invalidateLinesForDelta(delta) {
      if (delta.textChanged()) {
        let invalidLineStarts = this.invalidLineStarts, hasInsertedOrDeletedNodes = delta.insertedNodes.length > 0 || delta.removedNodes.length > 0, changeInLinesLength = delta.changeInLinesLength(), length = invalidLineStarts.length, from = delta.fromLineCh.line, newInvalidLineStarts = [], to = delta.toLineCh.line, eachLine, i3;
        for (i3 = length - 1; i3 >= 0; i3--) {
          eachLine = invalidLineStarts[i3];
          if (eachLine > from) {
            if (eachLine < to) {
              eachLine = from;
            } else if (changeInLinesLength !== 0) {
              eachLine += changeInLinesLength;
            }
          }
          newInvalidLineStarts.sortedAdd(eachLine, true);
        }
        invalidLineStarts = newInvalidLineStarts;
        this.invalidLineStarts = invalidLineStarts;
        if (delta.updatedNode) {
          invalidLineStarts.sortedAdd(from, true);
          if (hasInsertedOrDeletedNodes) {
            invalidLineStarts.sortedAdd(from + 1, true);
          }
        } else if (hasInsertedOrDeletedNodes) {
          if (delta.insertedText[0] === "\n") {
            invalidLineStarts.sortedAdd(from, true);
            invalidLineStarts.sortedAdd(from + 1, true);
          } else {
            if (from > 0) {
              invalidLineStarts.sortedAdd(from - 1, true);
            }
            invalidLineStarts.sortedAdd(from, true);
          }
        }
        let tree = this.tree, maxLine = tree.nodeCount() - 1;
        while (invalidLineStarts.lastObject() > maxLine) {
          invalidLineStarts.pop();
        }
      }
    }
  };
  Classifier.CLASSIFY_NEXT = CLASSIFY_NEXT;
  Classifier.RECLASSIFY_PREVIOUS = RECLASSIFY_PREVIOUS;

  // src/model/taxonomy.js
  var ROOT_STRUCTURE_TYPE_LEVEL = -100;
  var ESCAPE_SYNTAX_CHAR2 = "\uE002";
  var spaceRegex = /^\s*/;
  var nonASCIISingleCaseWordChar = /[\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc]/;
  var whiteSpaceChar = /\s/;
  var wordChar = /\w/;
  function isWordChar(ch) {
    return wordChar.test(ch) || ch > "\x80" && (ch.toUpperCase() !== ch.toLowerCase() || nonASCIISingleCaseWordChar.test(ch));
  }
  function isWhitespaceChar(ch) {
    return whiteSpaceChar.test(ch);
  }
  function isNotWhiteSpaceAndNotWordChar(ch) {
    return !isWhitespaceChar(ch) && !isWordChar(ch);
  }
  var Taxonomy = class {
    constructor(spec) {
      this.spec = spec || {};
    }
    wordRange(node, index2) {
      let string2 = node.line(), length = string2.length, foundStart = index2, foundEnd = index2, testFn, i3;
      if (length === 0) {
        return { location: index2, length: 0 };
      }
      let beforeCh = string2[index2 - 1], afterCh = string2[index2];
      if (beforeCh && isWordChar(beforeCh) || afterCh && isWordChar(afterCh)) {
        testFn = isWordChar;
      } else if (beforeCh && /\s/.test(beforeCh) || afterCh && /\s/.test(afterCh)) {
        testFn = isWhitespaceChar;
      } else {
        testFn = isNotWhiteSpaceAndNotWordChar;
      }
      i3 = index2 - 1;
      while (i3 >= 0 && testFn(string2[i3])) {
        i3--;
        foundStart = i3 + 1;
      }
      i3 = index2;
      while (i3 < length && testFn(string2[i3])) {
        i3++;
        foundEnd = i3;
      }
      return { location: foundStart, length: foundEnd - foundStart };
    }
    sentenceRange(node, index2) {
      let string2 = node.line(), length = string2.length;
      if (length === 0) {
        return { location: index2, length: 0 };
      }
      let start2 = 0, end = length, skipsRegex = /(?:^\s*\d\.)|Mr\.|Mrs\.|Ms\.|Jr\.|Dr\.|Prof\.|Sr\./g, sentenceBoundaryRegex = /([.!?]|(?:[.!?]['"]))(\s+|$)/g, match;
      skipsRegex.exec(string2);
      while (match = sentenceBoundaryRegex.exec(string2)) {
        if (skipsRegex.lastIndex - 1 === match.index) {
          skipsRegex.exec(string2);
        } else {
          end = match.index + match[0].length;
          if (end > index2 || end === index2 && end === length) {
            break;
          } else {
            start2 = end;
          }
        }
      }
      if (start2 === end && end < length) {
        end = length;
      }
      return { location: start2, length: end - start2 };
    }
    setType(node, type) {
      return type;
    }
    typeLevelForType() {
      return 0;
    }
    setTypeIndentLevel(node, level) {
      if (level >= 0) {
        return level;
      }
      return 0;
    }
    validatedTypeIndentLevel(node, level) {
      if (level < 0) {
        return 0;
      }
      return level;
    }
    setMode(node, mode2) {
      return mode2;
    }
    removeTag() {
      return true;
    }
    addTag() {
      return true;
    }
    setPropertyNodeValue() {
      throw new Error("Unsupported");
    }
    setText(node, text) {
      let oldTextStart = node._textStart || 0, oldTextLength = node._text.length;
      if (oldTextLength === 0 && oldTextStart < node.line().length) {
        node.replaceLineInRange(`${text} `, oldTextStart, oldTextLength);
      } else {
        node.replaceLineInRange(text, oldTextStart, oldTextLength);
      }
      return text;
    }
    types() {
      return {};
    }
    classify(text, state) {
      state.text = text.text();
      state.nextAction = Classifier.CLASSIFY_NEXT;
    }
    reclassifyUp() {
      throw new Error("Unsupported");
    }
    reclassifyDown() {
      throw new Error("Unsupported");
    }
    textAttributesToClearBeforeClassify() {
      return [];
    }
    startState() {
      return {
        text: "",
        typeLevel: 0,
        typeIndentLevel: 0,
        tags: {},
        nextAction: Classifier.CLASSIFY_NEXT
      };
    }
    copyState(state) {
      return {
        text: state.text,
        typeLevel: state.typeLevel,
        typeIndentLevel: state.typeIndentLevel,
        tags: shallowClone(state.tags),
        nextAction: state.nextAction
      };
    }
    equalStates(a3, b2) {
      return a3.text === b2.text && a3.typeLevel === b2.typeLevel && a3.typeIndentLevel === b2.typeIndentLevel && shallowEquals(a3.tags, b2.tags) && a3.nextAction === b2.nextAction;
    }
    matchLeadForNode(node) {
      return spaceRegex.exec(node.line());
    }
    nextLeadFromNode(node) {
      return this.matchLeadForNode(node)[0];
    }
    renderNode() {
    }
    renderNodeElementStyles(editor2, node, elementRenderer) {
      node.renderNodeElementStyles(elementRenderer);
    }
    rangeToMultiMarkdown(range2) {
      return range2.textInRange();
    }
    stripInlineSyntax(text) {
      return text;
    }
    static escapeText(text) {
      if (text.indexOf("\\") !== -1) {
        text = text.replace(/\\./, ESCAPE_SYNTAX_CHAR2 + ESCAPE_SYNTAX_CHAR2);
      }
      return text;
    }
  };
  Taxonomy.isWordChar = isWordChar;
  Taxonomy.ROOT_STRUCTURE_TYPE_LEVEL = ROOT_STRUCTURE_TYPE_LEVEL;
  Taxonomy.ESCAPE_SYNTAX_CHAR = ESCAPE_SYNTAX_CHAR2;

  // src/model/taxonomies.js
  function gatherTaxonomyExtensions() {
    let taxonomyExtensions = {}, mimeTaxonomies = {}, taxonomies = {};
    Extensions.processExtensions("com.foldingtext.editor.taxonomies", (each) => {
      let configurations = each.configurations, length = configurations.length;
      for (let i3 = 0; i3 < length; i3++) {
        mimeTaxonomies[configurations[i3].mime] = configurations[i3].spec;
      }
      taxonomies[each.name] = each.taxonomy;
    });
    return {
      taxonomyExtensions,
      mimeTaxonomies,
      taxonomies
    };
  }
  function resolveTaxonomy(spec, extensions) {
    if (typeof spec === "string" && Object.prototype.hasOwnProperty.call(extensions.mimeTaxonomies, spec)) {
      spec = extensions.mimeTaxonomies[spec];
    } else if (typeof spec === "string" && /^[\w-]+\/[\w-]+\+xml$/.test(spec)) {
      return resolveTaxonomy("application/xml", extensions);
    }
    if (typeof spec === "string") {
      return { name: spec };
    }
    return spec || { name: "null" };
  }
  function taxonomy(options, spec) {
    let extensions = gatherTaxonomyExtensions();
    spec = resolveTaxonomy(spec, extensions);
    let factory2 = extensions.taxonomies[spec.name];
    if (!factory2) {
      return taxonomy(options, "text/plain");
    }
    let taxonomyObj = factory2(options, spec);
    if (Object.prototype.hasOwnProperty.call(extensions.taxonomyExtensions, spec.name)) {
      let exts = extensions.taxonomyExtensions[spec.name];
      for (let prop in exts) {
        if (!Object.prototype.hasOwnProperty.call(exts, prop)) {
          continue;
        }
        if (Object.prototype.hasOwnProperty.call(taxonomyObj, prop)) {
          taxonomyObj[`_${prop}`] = taxonomyObj[prop];
        }
        taxonomyObj[prop] = exts[prop];
      }
    }
    taxonomyObj.name = spec.name;
    return taxonomyObj;
  }
  Extensions.add("com.foldingtext.editor.taxonomies", {
    name: "null",
    configurations: [{ mime: "text/plain", spec: "null" }],
    taxonomy(spec) {
      return new Taxonomy(spec);
    }
  });

  // src/model/taxonomy/markdowntaxonomy.js
  var import_htmlmixed = __toModule(require_htmlmixed());
  init_objectutils();

  // src/util/string.js
  function string_default() {
    if (typeof String.prototype.startsWith !== "function") {
      String.prototype.startsWith = function(str) {
        return this.slice(0, str.length) === str;
      };
    }
    if (typeof String.prototype.endsWith !== "function") {
      String.prototype.endsWith = function(str) {
        return this.slice(-str.length) === str;
      };
    }
    if (typeof String.prototype.replaceRange !== "function") {
      String.prototype.replaceRange = function(start2, end, substitute) {
        return this.substring(0, start2) + substitute + this.substring(end);
      };
    }
    if (typeof String.prototype.trim !== "function") {
      String.prototype.trim = function() {
        return this.replace(/(^\s*)|(\s*$)/gi, "");
      };
    }
    if (typeof String.prototype.ltrim !== "function") {
      String.prototype.ltrim = function() {
        return this.replace(/^\s+/, "");
      };
    }
    if (typeof String.prototype.rtrim !== "function") {
      String.prototype.rtrim = function() {
        return this.replace(/\s+$/, "");
      };
    }
    if (typeof String.prototype.hashCode !== "function") {
      String.prototype.hashCode = function() {
        let hash = 0, length = this.length;
        if (length === 0) {
          return hash;
        }
        for (let i3 = 0; i3 < length; i3++) {
          let char = this.charCodeAt(i3);
          hash = (hash << 5) - hash + char;
          hash = hash & hash;
        }
        return hash;
      };
    }
    if (typeof String.prototype.escapeForRegex !== "function") {
      String.prototype.escapeForRegex = function() {
        const specials = [
          "-",
          "[",
          "]",
          "/",
          "{",
          "}",
          "(",
          ")",
          "*",
          "+",
          "?",
          ".",
          "\\",
          "^",
          "$",
          "|"
        ];
        const regex = new RegExp(`[${specials.join("\\")}]`, "g");
        return this.replace(regex, "\\$&");
      };
    }
  }

  // src/model/taxonomy/markdowntaxonomy.js
  init_extensions();
  init_codemirrormodehelper();
  init_datetimehelper();
  init_htmlhelper();
  init_inlineshelper();

  // src/model/taxonomy/helpers/linebreakcausingwhitespacehelper.js
  function parseTrailingSpace(text) {
    let length = text.textLength(), i3 = length - 1, ch = text.textCharAt(i3);
    if (ch !== " " || text.textCharAt(i3 - 1) !== " ") {
      return;
    }
    while (ch === " ") {
      i3--;
      ch = text.textCharAt(i3);
    }
    if (i3 !== length - 1) {
      text.addAttributeInRange("linebreak-causing-whitespace", " ", length - 1, 1);
      text.sliceText(0, i3 + 1);
    }
  }
  var attributesToClear8 = ["linebreak-causing-whitespace"];

  // src/model/taxonomy/helpers/modehelper.js
  init_extensions();
  var modeRegExp = /\.(\w+)\s*$/;
  function supportsMode(modeName) {
    return Extensions.processExtensions("com.foldingtext.editor.mode", (each) => {
      if (each.name === modeName) {
        return true;
      }
    }, true);
  }
  function setMode(node, mode2) {
    if (!mode2 || supportsMode(mode2)) {
      let insertString = mode2 ? `.${mode2}` : "", line = node.line(), match;
      if (match = modeRegExp.exec(line)) {
        node.replaceLineInRange(insertString, match.index, match[0].length);
      } else {
        node.replaceLineInRange(insertString, line.length, 0);
      }
      return mode2;
    }
    return node.mode();
  }
  function modeStackEquals(a3, b2) {
    if (a3 === b2) {
      return true;
    }
    if (a3 && b2) {
      let aLen = a3.length, bLen = b2.length;
      if (aLen === bLen) {
        let i3 = aLen - 1;
        while (i3 >= 0) {
          let aRecord = a3[i3], bRecord = b2[i3];
          if (aRecord.mode !== bRecord.mode || aRecord.structureLevel !== bRecord.structureLevel) {
            return false;
          }
          i3--;
        }
        return true;
      }
    }
    return false;
  }
  function modeStackClone(modeStack) {
    if (modeStack && modeStack.length) {
      return modeStack.slice(0);
    }
    return void 0;
  }
  function parseMode(text, state) {
    let match;
    if (match = modeRegExp.exec(text.escapedText())) {
      let mode2 = match[1].toLowerCase(), modeStack = state.modeStack;
      if (supportsMode(mode2)) {
        if (!modeStack) {
          modeStack = [];
          state.modeStack = modeStack;
        }
        modeStack.push({
          node: text._node,
          mode: mode2,
          structureLevel: state.typeLevel + state.typeIndentLevel
        });
        text.addAttributeInRange("mode", match[0], match.index + 1, match[0].length);
        text.addAttributeInRange("keyword", match[0], match.index + 1, match[0].length);
        text.sliceText(0, match.index);
      }
    }
  }
  function reclassifyDown(text, state, previousState) {
    if (previousState) {
      let modeRecord = state.modeStack ? state.modeStack.lastObject() : null;
      if (modeRecord && modeRecord.node === text._node) {
        state.modeStack = [modeRecord];
      } else {
        state.modeStack = void 0;
      }
      maintainValidModeStack(text, state, previousState);
    }
  }
  function maintainValidModeStack(text, state, previousState) {
    if (previousState && previousState.modeStack) {
      let previousModeStack = previousState.modeStack, modeStack = state.modeStack ? state.modeStack : state.modeStack = [], structureLevel = state.typeLevel + state.typeIndentLevel, i3 = previousModeStack.length - 1;
      while (i3 >= 0) {
        let precedingModeRecord = previousModeStack[i3];
        if (precedingModeRecord.structureLevel < structureLevel) {
          modeStack.unshift(precedingModeRecord);
        }
        i3--;
      }
      if (modeStack.length === 0) {
        state.modeStack = void 0;
      }
    }
  }
  var attributesToClear9 = ["mode"];

  // src/model/taxonomy/helpers/propertyhelper.js
  init_inlineshelper();
  var propertyTypeRegex = /^\s*([^\s]*)\s:(?:\s)(.*)/;
  function parsePropertyType(text, state, previousState, criticMarkup, magiclinks, inwordunderscores) {
    let match;
    if (text.text().indexOf(" : ") !== -1 && (match = text.textMatch(propertyTypeRegex))) {
      let propertyName = match[1], propertyValue = match[2];
      state.type = "property";
      state.typeIndentLevel = state.logicalIndent;
      state.tags.name = propertyName.toLowerCase();
      state.tags.value = propertyValue;
      text.addAttributeInRange("propertyname", propertyName, 0, propertyName.length);
      text.addAttributeInRange("keyword", ":", propertyName.length + 1, 1);
      if (propertyValue) {
        text.sliceText(propertyName.length + 3, propertyName.length + 3 + propertyValue.length);
        text.addAttributeInRange("propertyvalue", propertyValue, 0, propertyValue.length);
        parseInlines(text, state, previousState, null, criticMarkup, magiclinks, inwordunderscores);
      }
      return true;
    }
    return false;
  }
  function setPropertyNodeValue(node, propertyValue) {
    try {
      let text = node.lineAttributedString().string();
      let valueStart = text.indexOf(": ") + 2;
      let valueLength = text.length - valueStart;
      node.replaceLineInRange(propertyValue, valueStart, valueLength);
    } catch (e5) {
      return false;
    }
  }
  var attributesToClear10 = ["propertyname", "propertyvalue"];

  // src/model/taxonomy/helpers/tagshelper.js
  init_extensions();
  string_default();
  var tagCharacter = "@";
  var tagStartChars = "[A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD]";
  var tagWordChars = "[\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040]";
  var tagWordRegexString = `${tagStartChars}(?:${tagStartChars}|${tagWordChars})*`;
  var tagRegexTemplate = `(^|\\s+)${tagCharacter}(TAGNAME)(?:\\(([^\\)]*)\\))?(?=\\s|$)`;
  var tagRegex = new RegExp(tagRegexTemplate.replace("TAGNAME", tagWordRegexString), "g");
  function _tagRange(node, tagName) {
    let line = node.line(), matchArea = line.match(new RegExp(`(^|\\s)${tagCharacter}(${tagName.escapeForRegex()})(\\([^\\)]*\\))?`));
    if (matchArea) {
      return { location: matchArea.index, length: matchArea[0].length };
    }
    return null;
  }
  function removeTag(node, tagName) {
    try {
      let range2 = _tagRange(node, tagName);
      if (range2) {
        node.replaceLineInRange("", range2.location, range2.length);
      }
      return true;
    } catch (e5) {
      return false;
    }
  }
  function addTag(node, tagName, tagValue) {
    try {
      let tagString = `${tagCharacter}${tagName}`;
      if (tagValue) {
        tagString += `(${tagValue})`;
      }
      let range2 = _tagRange(node, tagName);
      if (!range2) {
        range2 = { location: node.line().length, length: 0 };
      }
      if (range2.location > 0) {
        tagString = ` ${tagString}`;
      }
      node.replaceLineInRange(tagString, range2.location, range2.length);
      return true;
    } catch (e5) {
      return false;
    }
  }
  var reservedTagNamesLookupCache;
  function reservedTagNamesLookup() {
    if (!reservedTagNamesLookupCache) {
      reservedTagNamesLookupCache = {};
      Extensions.processExtensions("com.foldingtext.editor.reservedTagNames", (tags) => {
        let length = tags.length, i3;
        for (i3 = 0; i3 < length; i3++) {
          reservedTagNamesLookupCache[tags[i3]] = "";
        }
      });
    }
    return reservedTagNamesLookupCache;
  }
  function parseTags(text, state) {
    let escapedText = text.escapedText();
    if (escapedText.indexOf(tagCharacter) === -1) {
      return;
    }
    let tags = state.tags || {}, reservedTags = reservedTagNamesLookup(), trailingTagsLeadingSpaceLength = 0, trailingTagsStart, trailingTagsEnd, match;
    while (match = tagRegex.exec(escapedText)) {
      let leadingSpace = match[1], tag = match[2], value = match[3];
      if (tags[tag] === void 0 && reservedTags[tag] === void 0) {
        if (value === void 0) {
          value = "";
        }
        let tagStart = match.index + leadingSpace.length;
        text.addAttributeInRange("keyword", tagCharacter, tagStart, 1);
        text.addAttributeInRange("tagname", tag, tagStart + 1, tag.length);
        let length = tag.length + 1;
        if (value) {
          text.addAttributeInRange("keyword", "(", tagStart + 1 + tag.length, 1);
          text.addAttributeInRange("tagvalue", value, tagStart + 1 + tag.length + 1, value.length);
          text.addAttributeInRange("keyword", ")", tagStart + 1 + tag.length + value.length + 1, 1);
          length += value.length + 2;
        }
        text.addAttributeInRange("tag", text.textSubstr(match.index + leadingSpace.length, length), tagStart, length);
        tags[tag] = value;
        if (trailingTagsEnd !== match.index) {
          trailingTagsLeadingSpaceLength = leadingSpace.length;
          trailingTagsStart = tagStart;
          trailingTagsEnd = trailingTagsStart + length;
        } else {
          trailingTagsEnd += match[0].length;
        }
      }
    }
    if (trailingTagsEnd !== void 0) {
      let trailingSpaceLength = escapedText.match(/\s*$/)[0].length;
      if (trailingTagsEnd === escapedText.length - trailingSpaceLength) {
        let leadingSpaceStart = trailingTagsStart - trailingTagsLeadingSpaceLength, trailingTagsString = text.textSubstring(trailingTagsStart);
        if (leadingSpaceStart > 0) {
          text.sliceText(0, leadingSpaceStart);
        } else {
          text.sliceText(0, trailingTagsStart);
        }
        text.addAttributeInRange("trailingtags", trailingTagsString, trailingTagsStart, trailingTagsEnd + trailingSpaceLength - trailingTagsStart);
      }
    }
    state.tags = tags;
  }
  function toggleTag(tagName, tagValue, inRange) {
    let tree = this.tree(), range2 = inRange || this.selectedRange(), addTag2;
    tree.beginUpdates();
    range2.forEachNodeInRange((node) => {
      if (addTag2 === void 0) {
        addTag2 = node.tag(tagName) === void 0;
      }
      if (addTag2) {
        node.addTag(tagName, tagValue);
      } else {
        node.removeTag(tagName);
      }
    });
    tree.endUpdates();
  }
  Extensions.add("com.foldingtext.editor.methods", {
    toggleTag
  });
  Extensions.add("com.foldingtext.editor.prefixWordRangeForComplete", (prefixRange) => {
    let startNode = prefixRange.startNode, startOffset = prefixRange.startOffset, line = startNode.line();
    if (line[startOffset - 1] === tagCharacter) {
      if (startOffset > 1 && line[startOffset - 2].trim() === "") {
        return prefixRange.rangeByOffsetting(-1, 1);
      }
    }
    return;
  });
  Extensions.add("com.foldingtext.editor.completions.tags", (filter3, editor2) => {
    return new Promise((resolve) => {
      const completions = [];
      const tags = editor2.tree().tags(true);
      const length = tags.length;
      if (filter3.startsWith(tagCharacter)) {
        filter3 = filter3.substr(1);
      }
      for (let i3 = 0; i3 < length; i3++) {
        const each = tags[i3];
        if (each.startsWith(filter3) && each !== filter3) {
          completions.push(`${tagCharacter}${each}`);
        }
      }
      let isComplete = false;
      if (completions.length === 0 && filter3.length > 0) {
        const firstWord = /^\w+/.exec(filter3);
        completions.push(`${tagCharacter}${firstWord[0]}`);
        if (firstWord[0].length < filter3.length) {
          isComplete = true;
        }
      }
      resolve({
        completions: completions.sort(),
        isComplete
      });
    });
  });
  Extensions.add("com.foldingtext.editor.completionsForPrefixWordRange", (prefixWordRange) => {
    let startNode = prefixWordRange.startNode, startOffset = prefixWordRange.startOffset, line = startNode.line();
    if (line[startOffset] !== tagCharacter || startOffset <= 0) {
      return;
    }
    return "com.foldingtext.editor.completions.tags";
  });
  Extensions.addInit((editor2) => {
    editor2.addKeyMap({
      "'@'"(editor3) {
        const selectedRange = editor3.selectedRange();
        const line = selectedRange.startNode.line();
        const { startOffset } = selectedRange;
        const ch = line[startOffset - 1];
        if (ch === void 0 || ch.match(/\s/)) {
          if (startOffset > 0) {
            editor3.replaceSelection(tagCharacter, "end");
            editor3.performCommand("complete");
          } else {
            editor3.replaceSelection(tagCharacter, "end");
          }
        } else {
          editor3.replaceSelection(tagCharacter, "end");
        }
      }
    });
  });
  Extensions.add("com.foldingtext.editor.reservedTagNames", [
    "id",
    "level",
    "type",
    "line",
    "mode",
    "modeContext",
    "index",
    "property",
    "name",
    "value"
  ]);
  var attributesToClear11 = ["tag", "tagname", "tagvalue", "trailingtags"];

  // src/model/taxonomy/markdowntaxonomy.js
  string_default();
  var HEADER_STRUCTURE_TYPE_LEVEL = 300;
  var BODY_STRUCTURE_TYPE_LEVEL = 400;
  var LINK_DEFINITION_CLOSED = 0;
  var LINK_DEFINITION_SEEK_URL = 1;
  var LINK_DEFINITION_SEEK_TITLE = 2;
  var unordedLeadRegex = /(\s*)([-+*])\s/;
  var taskLeadRegex = /(\s*)([-+*]|[0-9]+\.)(\s+)(\[(?: |x)\]\s)/;
  var orderedLeadRegex = /(\s*)([0-9]+)(\.\s)/;
  var blockquoteLeadRegex = /(> ?)*/;
  var MarkdownTaxonomy = class extends Taxonomy {
    constructor(spec) {
      super(spec);
      this.emptyLineMatchRE = /^\s*$/;
      this.headingMatchRE = /^(#{1,6})(\s*)(?:.*?)(?:(\s*?)(\[([^\]]*)\]))?(?:(\s*?)(#+))?(\s*)$/;
      this.headingUnderlineMatchRE = /^[=-]+\s*$/;
      this.blockquoteMatchRE = /(>\s{0,3})+/;
      this.horizontalruleMatchRE = /^([*|\-|_])([ ]?[ ]?\1){2,}[ \t]*$/;
      this.unorderedMatchRE = /^([-+*])(\s+)(\[(?: |x)\](?:$|\s))?/;
      this.orderedMatchRE = /^(\d+\.)(\s+)(\[(?: |x)\](?:$|\s))?/;
      this.linkDefinitionRE = /\[([^\]]+)\]:(?:(\s*)(?:(?:<([^>]+)>)|(?:(\S+)))?(?:(\s+)(["(](.+?)[")]))?)?/;
      this.linkDefinitionURLOnlyRE = /(?:(?:<([^>]+)>)|(?:(\S+)))/;
      this.linkDefinitionTitleOnlyRE = /^(?:["(](.+?)[")])/;
      this.fencedcodeRE = /^```(\S+)?/;
      this.definitionMatchRE = /^:(?:[ \t]*)/;
      this.whitespaceRE = /\s*/;
      this.renderLineHeadingRE = /^(#+ ?)/;
      this.renderLineUnorderedRE = /^(\t*)([-+*]\s+)/;
      this.renderLineTaskRE = /^(\t*)([-+*]|[0-9]+\.)(\s+)(\[(?: |x)\](?:$|\s))?/;
      this.renderLineOrderedRE = /^(\t*)([0-9]+\.\s+)/;
      this.renderLineLinkDefinitionRE = /\[([^\]]+)\]:(\s*)/;
      this.metadataBoundary = /^(-{3,6})\s*$/;
      this.metadataKeyValuePair = /^(\w[\w\d\- ]+):(.+)$/;
      this.metadataContinuingValue = /^(\s{2,})(.*)$/;
      this.foldingtext = !!spec.foldingtext;
      this.gitmarkdown = !!spec.gitmarkdown;
      this.criticMarkup = !!spec.criticMarkup;
      this.multimarkdown = !!spec.multimarkdown;
      this.magiclinks = this.foldingtext || this.gitmarkdown;
      this.inwordunderscores = !this.foldingtext && !this.gitmarkdown && !this.multimarkdown;
      this.htmlMode = getMode({}, "text/html", true);
      this.metadata = !!spec.metadata;
    }
    setType(node, type) {
      if (node.type() === type) {
        return type;
      }
      let newLead, newLine;
      switch (type) {
        case "heading":
          newLead = "# ";
          break;
        case "definition":
          newLead = ":	";
          break;
        case "blockquote":
          newLead = "> ";
          break;
        case "codeblock":
          newLead = "    ";
          break;
        case "empty":
          newLine = "";
          break;
        case "fencedcodebottomboundary":
        case "fencedcodetopboundary":
          newLine = "```";
          break;
        case "footnotelinkdefinition":
          newLead = "[^]: ";
          break;
        case "headingunderline":
          newLine = "--------";
          break;
        case "horizontalrule":
          newLine = "* * *";
          break;
        case "body":
          newLead = "";
          break;
        case "linkdefinition":
          newLead = "[]: ";
          break;
        case "ordered":
          newLead = "1. ";
          break;
        case "unordered":
          newLead = "- ";
          break;
        case "task":
          newLead = "- [ ] ";
          break;
        case "fencedcode":
        case "linkdefinitiontitle":
        case "linkdefinitionurl":
        case "term":
          break;
        default:
          throw new Error(`Invalid setType: ${type}`);
      }
      if (newLine !== void 0) {
        node.setLine(newLine);
        return type;
      }
      if (newLead !== void 0) {
        node.replaceLineInRange(newLead, 0, node.textStart());
        return type;
      }
      return node.type();
    }
    typeLevelForType(type) {
      switch (type) {
        case "heading":
          return HEADER_STRUCTURE_TYPE_LEVEL;
        case "definition":
          return BODY_STRUCTURE_TYPE_LEVEL + 1;
        case "blockquote":
        case "codeblock":
        case "empty":
        case "fencedcode":
        case "fencedcodebottomboundary":
        case "fencedcodetopboundary":
        case "footnotelinkdefinition":
        case "headingunderline":
        case "horizontalrule":
        case "body":
        case "linkdefinition":
        case "linkdefinitiontitle":
        case "linkdefinitionurl":
        case "ordered":
        case "term":
        case "unordered":
        case "task":
          return BODY_STRUCTURE_TYPE_LEVEL;
        default:
          throw new Error(`Invalid typeLevelForType: ${type}`);
      }
    }
    setTypeIndentLevel(node, level) {
      level = this.validatedTypeIndentLevel(node, level);
      let currentLevel = node.typeIndentLevel(), delta = level - currentLevel, indentationChars;
      if (delta !== 0) {
        switch (node.type()) {
          case "empty":
            return level;
          case "heading":
            indentationChars = "#";
            break;
          case "blockquote":
            indentationChars = "> ";
            break;
          default:
            indentationChars = "	";
            break;
        }
        if (delta < 0) {
          node.replaceLineInRange("", 0, Math.abs(delta) * indentationChars.length);
        } else {
          let indentation = [];
          for (let i3 = 0; i3 < delta; i3++) {
            indentation.push(indentationChars);
          }
          node.replaceLineInRange(indentation.join(""), 0, 0);
        }
      }
      return level;
    }
    validatedTypeIndentLevel(node, level) {
      let type = node.type();
      switch (type) {
        case "definition":
        case "horizontalrule":
          return node.typeIndentLevel() === level;
        case "heading":
        case "ordered":
        case "unordered":
        case "task":
          if (level < 1) {
            return 1;
          }
          break;
        default:
          if (level < 0) {
            return 0;
          }
          break;
      }
      return level;
    }
    setMode(node, mode2) {
      return setMode(node, mode2);
    }
    removeTag(node, tagName) {
      return removeTag(node, tagName);
    }
    addTag(node, tagName, tagValue) {
      return addTag(node, tagName, tagValue);
    }
    setPropertyNodeValue(node, propertyValue) {
      return setPropertyNodeValue(node, propertyValue);
    }
    types() {
      return {
        fencedcode: true,
        fencedcodetopboundary: true,
        fencedcodebottomboundary: true,
        empty: true,
        codeblock: true,
        heading: true,
        headingunderline: true,
        blockquote: true,
        horizontalrule: true,
        linkdefinition: true,
        term: true,
        definition: true,
        unordered: true,
        task: true,
        ordered: true,
        body: true,
        metadatatopboundary: true,
        metadatabottomboundary: true,
        metadata: true
      };
    }
    detectAndHighlightMetadataBlock(text, state, previousState) {
      const isFirstLine = text.isFirstLine();
      const prevType = previousState.type;
      const isPrevTypeMetadata = ["metadatatopboundary", "metadata"].indexOf(prevType) >= 0;
      if (!isFirstLine && !isPrevTypeMetadata)
        return false;
      const boundaryMatch = text.textMatch(this.metadataBoundary);
      if (boundaryMatch) {
        state.type = isFirstLine ? "metadatatopboundary" : "metadatabottomboundary";
        text.addAttributeInRange("keyword", boundaryMatch[1], 0, boundaryMatch[1].length);
        return true;
      }
      if (isPrevTypeMetadata || isFirstLine) {
        const emptyMatch = text.text().match(this.emptyLineMatchRE);
        if (emptyMatch)
          return false;
        const continuingValueMatch = text.text().match(this.metadataContinuingValue);
        const keyValueMatch = text.text().match(this.metadataKeyValuePair);
        if (!isPrevTypeMetadata && !keyValueMatch)
          return false;
        state.type = "metadata";
        if (continuingValueMatch) {
          text.textMatch(this.metadataContinuingValue);
          const lastFoundMetadata = previousState.lastFoundMetadata;
          if (!continuingValueMatch)
            return true;
          if (!lastFoundMetadata)
            return true;
          const value = continuingValueMatch[2].trim();
          const lead = continuingValueMatch[1].length;
          text.addAttributeInRange("metadataValue", value, lead, value.length);
          state.metadata[lastFoundMetadata] = `${previousState.metadata[lastFoundMetadata].trim()} ${value}`;
          state.lastFoundMetadata = lastFoundMetadata;
          return true;
        } else if (keyValueMatch) {
          text.textMatch(this.metadataKeyValuePair);
          const key = keyValueMatch[1];
          const storedKey = key.toLowerCase().replace(/\s/g, "");
          const value = keyValueMatch[2];
          text.addAttributeInRange("metadataKey", key, 0, key.length);
          text.addAttributeInRange("keyword", ":", key.length, 1);
          text.addAttributeInRange("metadataValue", value, key.length + 1, value.length);
          let storedMetadataValue = previousState.metadata[storedKey];
          storedMetadataValue = storedMetadataValue ? `${storedMetadataValue} ` : "";
          storedMetadataValue += value.trim();
          state.metadata[storedKey] = storedMetadataValue;
          state.lastFoundMetadata = storedKey;
        }
        return true;
      }
      return false;
    }
    detectAndHighlightGFMCodeBlock(text, state, previousState) {
      let prevType = previousState.type, continueFenced = prevType === "fencedcodetopboundary" || prevType === "fencedcode", fenceMatch = text.textCharAt(1) === "`" ? text.textMatch(this.fencedcodeRE) : null;
      if (continueFenced || fenceMatch) {
        state.type = "fencedcode";
        state.tags.language = previousState.tags.language;
        if (fenceMatch) {
          text.addAttributeInRange("keyword", "```", 0, 3);
          if (continueFenced) {
            state.type = "fencedcodebottomboundary";
          } else {
            state.type = "fencedcodetopboundary";
            let language = fenceMatch[1];
            if (language) {
              state.tags.language = language;
              text.addAttributeInRange("language", language, 3, language.length);
              const isCodeLoadingSync = true;
              let mode2 = getMode(null, language, isCodeLoadingSync);
              if (mode2 && !mode2.then) {
                state.codemirrorState = {
                  mode: mode2,
                  state: mode2.startState ? mode2.startState() : null
                };
                if (mode2.name !== "null") {
                  text.addAttributeInRange("keyword", language, 3, language.length);
                }
              } else {
                state.pendingModeLoading = true;
              }
            }
          }
        } else {
          let codemirrorState = copyState(previousState.codemirrorState);
          if (codemirrorState) {
            runMode(codemirrorState.mode, codemirrorState.state, text);
            state.codemirrorState = codemirrorState;
          }
        }
        return true;
      }
      return false;
    }
    detectAndHighlightEmpty(text, state, previousState) {
      if (text.text().match(this.emptyLineMatchRE)) {
        state.type = "empty";
        state.listContextLevel = previousState.listContextLevel;
        text.sliceAllText();
        return true;
      }
      return false;
    }
    detectAndHighlightCodeBlock(text, state, previousState) {
      if (state.logicalIndent >= 1) {
        if (state.logicalIndent <= previousState.listContextLevel) {
          return false;
        }
        if (previousState.linkDefinitionState !== LINK_DEFINITION_CLOSED) {
          return false;
        }
        state.type = "codeblock";
        state.listContextLevel = previousState.listContextLevel;
        if (previousState.listContextLevel) {
          state.typeIndentLevel = previousState.listContextLevel + 1;
        }
        return true;
      }
      return false;
    }
    detectAndHighlightAtxHeading(text, state, previousState) {
      let ch = text.textCharAt(0);
      if (ch === "#") {
        let match = text.textMatch(this.headingMatchRE), leadSyntax = match[1], spaceAfterLead = match[2], spaceBeforeLabel = match[3], labelWithSyntax = match[4], label = match[5], spaceBeforeTrail = match[6], trailSyntax = match[7], trailSpace = match[8], textStart = leadSyntax.length + spaceAfterLead.length, textEnd = text.textLength() - (trailSpace ? trailSpace.length : 0);
        state.type = "heading";
        state.typeLevel = this.typeLevelForType(state.type);
        state.typeIndentLevel = leadSyntax.length;
        text.addAttributeInRange("keyword", leadSyntax, match.index, leadSyntax.length);
        text.addAttributeInRange("lead", leadSyntax + spaceAfterLead, match.index, leadSyntax.length + spaceAfterLead.length);
        if (trailSyntax) {
          let trailLength = spaceBeforeTrail.length + trailSyntax.length;
          text.addAttributeInRange("keyword", trailSyntax, textEnd - trailSyntax.length, trailSyntax.length);
          textEnd -= trailLength;
        }
        if (this.multimarkdown && labelWithSyntax) {
          text.addAttributeInRange("label", label, textEnd - (label.length + 2), label.length + 2);
          text.addAttributeInRange("keyword", "[", textEnd - (label.length + 2), 1);
          text.addAttributeInRange("keyword", "]", textEnd - 1, 1);
          textEnd -= spaceBeforeLabel.length + labelWithSyntax.length;
        }
        text.sliceText(textStart, textEnd);
        if (this.foldingtext) {
          parseTags(text, state, previousState);
          parseMode(text, state, previousState);
        }
        parseInlines(text, state, previousState, this.htmlMode, this.criticMarkup, this.magiclinks, this.inwordunderscores);
        return true;
      }
      return false;
    }
    detectAndHighlightSetextHeadingUnderline(text, state, previousState) {
      let match, matchText, ch = text.textCharAt(0);
      if ((ch === "-" || ch === "=") && previousState.type === "body" && (match = text.textMatch(this.headingUnderlineMatchRE))) {
        state.type = "headingunderline";
        state.typeIndentLevel = ch === "=" ? 1 : 2;
        state.nextAction = Classifier.RECLASSIFY_PREVIOUS;
        matchText = match[0];
        text.addAttributeInRange("keyword", matchText, match.index, matchText.length);
        text.sliceAllText();
        return true;
      }
      return false;
    }
    detectAndHighlightBlockquote(text, state, previousState) {
      let match, matchText, ch = text.textCharAt(0);
      if ((ch === ">" || ch === " ") && (match = text.textMatch(this.blockquoteMatchRE))) {
        matchText = match[0];
        let rtrimMatchText = matchText.rtrim();
        state.type = "blockquote";
        state.typeIndentLevel = rtrimMatchText.match(/>/g).length - 1;
        let level = 0;
        for (let i3 = 0; i3 < rtrimMatchText.length; i3++) {
          if (rtrimMatchText[i3] === ">") {
            text.addAttributeInRange("keyword", `>${level}`, i3, 1);
            level++;
          }
        }
        text.addAttributeInRange("lead", rtrimMatchText, 0, rtrimMatchText.length);
        text.sliceText(matchText.length);
        if (this.foldingtext) {
          parseTags(text, state, previousState);
          parseMode(text, state, previousState);
        }
        parseInlines(text, state, previousState, this.htmlMode, this.criticMarkup, this.magiclinks, this.inwordunderscores);
        return true;
      }
      return false;
    }
    detectAndHighlightHorizontalRule(text, state) {
      let match, matchText, ch = text.textCharAt(0);
      if (state.logicalIndent === 0 && (ch === "*" || ch === "-" || ch === "_") && (match = text.textMatch(this.horizontalruleMatchRE))) {
        state.type = "horizontalrule";
        matchText = match[0];
        text.addAttributeInRange("keyword", matchText, 0, matchText.length);
        text.sliceAllText();
        return true;
      }
      return false;
    }
    detectAndHighlightLinkDefinition(text, state, previousState) {
      let match, ch = text.textCharAt(0), previousLinkDefinitionState = previousState.linkDefinitionState, autoLinkURL, anyLinkURL, title, i3 = 0;
      if (previousLinkDefinitionState === LINK_DEFINITION_CLOSED && state.logicalIndent !== 0) {
        return;
      }
      if (ch === "[" && (match = text.textMatch(this.linkDefinitionRE))) {
        state.type = "linkdefinition";
        state.linkDefinitionState = LINK_DEFINITION_SEEK_URL;
        let label = match[1], spaceAfterLabel = match[2], footnote = false;
        autoLinkURL = match[3];
        anyLinkURL = match[4];
        let spaceAfterURL = match[5], titleWithSyntax = match[6];
        title = match[7];
        if (this.multimarkdown && text.textCharAt(1) === "^") {
          footnote = true;
          state.type = "footnotelinkdefinition";
          text.addAttributeInRange("keyword", "[^", i3, 2);
          label = label.slice(1);
          i3 += 2;
        } else {
          text.addAttributeInRange("keyword", "[", i3, 1);
          i3 += 1;
        }
        text.addAttributeInRange("linkid", label, i3, label.length);
        i3 += label.length;
        text.addAttributeInRange("keyword", "]:", i3, 2);
        if (footnote) {
          state.linkDefinitionState = LINK_DEFINITION_CLOSED;
          return true;
        }
        if (autoLinkURL || anyLinkURL) {
          i3 += 2 + spaceAfterLabel.length;
          i3 = highlightURLAndReturnAdvance(i3, autoLinkURL, anyLinkURL, text);
          if (titleWithSyntax) {
            state.linkDefinitionState = LINK_DEFINITION_CLOSED;
            i3 += spaceAfterURL.length;
            i3 = highlightTitleAndReturnAdvance(i3, title, text, this.multimarkdown);
          } else {
            state.linkDefinitionState = LINK_DEFINITION_SEEK_TITLE;
          }
        } else {
          state.linkDefinitionState = LINK_DEFINITION_SEEK_URL;
        }
        highlightTrailingErrorRange(i3, text);
        return true;
      } else if (previousLinkDefinitionState === LINK_DEFINITION_SEEK_URL) {
        state.linkDefinitionState = LINK_DEFINITION_SEEK_TITLE;
        state.type = "linkdefinitionurl";
        state.typeIndentLevel = state.logicalIndent;
        match = text.textMatch(this.linkDefinitionURLOnlyRE);
        i3 = highlightURLAndReturnAdvance(match.index, match[1], match[2], text);
        let fullRemainder = text.escapedText().slice(i3);
        if (fullRemainder) {
          let ltrimRemainder = fullRemainder.ltrim();
          if (ltrimRemainder) {
            match = ltrimRemainder.match(this.linkDefinitionTitleOnlyRE);
            if (match) {
              i3 = highlightTitleAndReturnAdvance(i3 + (fullRemainder.length - ltrimRemainder.length), match[1], text, this.multimarkdown);
              state.linkDefinitionState = LINK_DEFINITION_CLOSED;
            }
          }
        }
        i3 = highlightTrailingErrorRange(i3, text);
        return true;
      } else if (previousLinkDefinitionState === LINK_DEFINITION_SEEK_TITLE) {
        state.linkDefinitionState = LINK_DEFINITION_CLOSED;
        match = text.textMatch(this.linkDefinitionTitleOnlyRE);
        if (match) {
          state.type = "linkdefinitiontitle";
          state.typeIndentLevel = state.logicalIndent;
          i3 = highlightTitleAndReturnAdvance(match.index, match[1], text, this.multimarkdown);
          i3 = highlightTrailingErrorRange(i3, text);
          return true;
        }
      }
      return false;
    }
    detectAndHighlightDefinitionListDefinition(text, state, previousState) {
      let match, matchText, ch = text.textCharAt(0);
      if (ch === ":" && (previousState.type === "body" || previousState.type === "definition") && (match = text.textMatch(this.definitionMatchRE))) {
        state.type = "definition";
        state.typeLevel = this.typeLevelForType(state.type);
        matchText = match[0];
        text.addAttributeInRange("keyword", ":", 0, 1);
        text.sliceText(matchText.length);
        state.nextAction = Classifier.RECLASSIFY_PREVIOUS;
        if (this.foldingtext) {
          parseTags(text, state, previousState);
          parseMode(text, state, previousState);
        }
        parseInlines(text, state, previousState, this.htmlMode, this.criticMarkup, this.magiclinks, this.inwordunderscores);
        return true;
      }
      return false;
    }
    detectAndHighlightList(text, state, previousState) {
      if (canListStartAfterState(this, previousState)) {
        let match, matchText, textStart = 0, ch = text.textCharAt(0);
        if ((ch === "-" || ch === "*" || ch === "+") && (match = text.textMatch(this.unorderedMatchRE))) {
          state.type = "unordered";
        } else if (!isNaN(ch) && (match = text.textMatch(this.orderedMatchRE))) {
          state.type = "ordered";
        }
        if (match) {
          state.typeIndentLevel = state.logicalIndent + 1;
          state.listContextLevel = state.typeIndentLevel;
          matchText = match[1];
          let checkbox = match[3];
          textStart += matchText.length;
          text.addAttributeInRange("keyword", matchText, 0, matchText.length);
          if (!checkbox) {
            text.addAttributeInRange("lead", matchText, 0, matchText.length);
          }
          textStart += match[2].length;
          if (checkbox && this.gitmarkdown) {
            state.type = "task";
            if (checkbox.substr(1, 1) !== " ") {
              state.tags.checked = "";
            }
            text.addAttributeInRange("keyword", "[", textStart, 1);
            text.addAttributeInRange("keyword", "]", textStart + 2, 1);
            text.addAttributeInRange("checkbox", checkbox.substr(0, 3), textStart, 3);
            text.addAttributeInRange("lead", matchText + checkbox, 0, matchText.length + checkbox.length);
            textStart += checkbox.length;
          }
          text.sliceText(textStart);
          if (this.foldingtext) {
            parseTags(text, state, previousState);
            parseMode(text, state, previousState);
          }
          parseInlines(text, state, previousState, this.htmlMode, this.criticMarkup, this.magiclinks, this.inwordunderscores);
          return true;
        }
      }
      return false;
    }
    detectAndHighlightItem(text, state, previousState) {
      if (previousState.type === "blockquote") {
        state.type = "blockquote";
        state.typeLevel = previousState.typeLevel;
        state.typeIndentLevel = previousState.typeIndentLevel;
      } else {
        state.type = "body";
        let foldingtext = this.foldingtext, listContextLevel = previousState.listContextLevel, continueItem = !foldingtext && isListType(previousState.type), continueList = listContextLevel && state.logicalIndent > 0;
        if (continueItem) {
          state.typeIndentLevel = listContextLevel;
        } else if (continueList) {
          state.typeIndentLevel = state.logicalIndent;
        } else if (foldingtext) {
          state.typeIndentLevel = state.logicalIndent;
        }
        if (continueList || continueItem) {
          state.listContextLevel = listContextLevel;
        }
        parseTrailingSpace(text, state, previousState);
      }
      if (this.foldingtext) {
        parseTags(text, state, previousState);
        parseMode(text, state, previousState);
      }
      parseInlines(text, state, previousState, this.htmlMode, this.criticMarkup, this.magiclinks, this.inwordunderscores);
    }
    classify(text, state, previousState) {
      let treeEndsWithEmpty = false;
      if (this.metadata && this.detectAndHighlightMetadataBlock(text, state, previousState)) {
      } else if (this.gitmarkdown && this.detectAndHighlightGFMCodeBlock(text, state, previousState)) {
      } else if (this.detectAndHighlightEmpty(text, state, previousState)) {
        treeEndsWithEmpty = text.isLastLine();
      } else if (detectAndHighlightHtmlBlock(text, state, previousState, this.htmlMode)) {
      } else if (this.detectAndHighlightAtxHeading(text, state, previousState)) {
      } else if (this.detectAndHighlightSetextHeadingUnderline(text, state, previousState)) {
      } else if (this.multimarkdown && this.detectAndHighlightDefinitionListDefinition(text, state, previousState)) {
      } else {
        let foldingtext = this.foldingtext, string2 = text.text(), length = string2.length, logicalIndent = 0, spacesRun = 0, ch, i3;
        for (i3 = 0; i3 < length; i3++) {
          ch = string2[i3];
          if (ch === " ") {
            logicalIndent++;
            spacesRun++;
            if (spacesRun === 4 && foldingtext) {
              i3++;
              break;
            }
          } else if (ch === "	") {
            logicalIndent += 4;
            spacesRun = 0;
          } else {
            break;
          }
        }
        if (logicalIndent) {
          logicalIndent = Math.floor(logicalIndent / 4);
          text.sliceText(i3);
        }
        state.logicalIndent = logicalIndent;
        if (this.detectAndHighlightLinkDefinition(text, state, previousState)) {
        } else if ((!foldingtext || spacesRun === 4) && this.detectAndHighlightCodeBlock(text, state, previousState)) {
        } else if (this.detectAndHighlightBlockquote(text, state, previousState)) {
        } else if (this.detectAndHighlightHorizontalRule(text, state, previousState)) {
        } else if (foldingtext && parsePropertyType(text, state, previousState, this.criticMarkup, this.magiclinks, this.inwordunderscores)) {
        } else if (this.detectAndHighlightList(text, state, previousState)) {
        } else {
          this.detectAndHighlightItem(text, state, previousState);
        }
      }
      maintainValidModeStack(text, state, previousState);
      if (previousState.type === "empty" && (treeEndsWithEmpty || state.type !== "empty")) {
        state.nextAction = Classifier.RECLASSIFY_PREVIOUS;
      }
      Extensions.processExtensions("com.foldingtext.taxonomy.classifier", (classifier) => {
        classifier.classify(text, state, previousState);
      });
      state.text = text.text();
      state.textStart = text.textStart();
      text.addAttributeInRange("text", text.text(), 0, text.textLength());
    }
    reclassifyUp(text, state, nextState) {
      if (state.type === "empty") {
        if (nextState.type === "codeblock" || nextState.type === "potentialemptycodeblockmarker") {
          state.type = "potentialemptycodeblockmarker";
        }
        state.typeLevel = nextState.typeLevel;
        state.typeIndentLevel = nextState.typeIndentLevel;
        state.nextAction = Classifier.RECLASSIFY_PREVIOUS;
      } else if (nextState.type === "headingunderline" && state.type === "body") {
        state.type = "heading";
        state.typeLevel = this.typeLevelForType(state.type);
        state.typeIndentLevel = nextState.typeIndentLevel;
        state.nextAction = Classifier.CLASSIFY_NEXT;
      } else if ((nextState.type === "definition" || nextState.type === "term") && state.type === "body") {
        state.type = "term";
        state.typeLevel = this.typeLevelForType(state.type);
        state.typeIndentLevel = 0;
        state.nextAction = Classifier.RECLASSIFY_PREVIOUS;
      } else {
        state.nextAction = Classifier.CLASSIFY_NEXT;
      }
    }
    reclassifyDown(text, state, previousState) {
      if (state.type === "potentialemptycodeblockmarker") {
        if (previousState.type === "codeblock") {
          state.type = "codeblock";
        } else {
          state.type = "empty";
        }
      }
      if (this.foldingtext) {
        reclassifyDown(text, state, previousState);
        Extensions.processExtensions("com.foldingtext.taxonomy.classifier", (classifier) => {
          classifier.classify(text, state, previousState);
        });
      }
    }
    startState() {
      return {
        nextAction: Classifier.CLASSIFY_NEXT,
        type: void 0,
        typeLevel: BODY_STRUCTURE_TYPE_LEVEL,
        typeIndentLevel: 0,
        logicalIndent: 0,
        listContextLevel: 0,
        linkDefinitionState: LINK_DEFINITION_CLOSED,
        text: "",
        textStart: 0,
        tags: {},
        dateTime: void 0,
        modeStack: void 0,
        metadata: {},
        lastFoundMetadata: void 0,
        codemirrorState: void 0,
        links: []
      };
    }
    copyState(state) {
      return {
        nextAction: state.nextAction,
        type: state.type,
        typeLevel: state.typeLevel,
        typeIndentLevel: state.typeIndentLevel,
        logicalIndent: state.logicalIndent,
        listContextLevel: state.listContextLevel,
        linkDefinitionState: state.linkDefinitionState,
        text: state.text,
        textStart: state.textStart,
        tags: shallowClone(state.tags),
        dateTime: dateTimeClone(state.dateTime),
        modeStack: modeStackClone(state.modeStack),
        codemirrorState: copyState(state.codemirrorState),
        metadata: shallowClone(state.metadata),
        lastFoundMetadata: state.lastFoundMetadata,
        links: [...state.links]
      };
    }
    equalStates(a3, b2) {
      return a3.nextAction === b2.nextAction && a3.type === b2.type && a3.typeLevel === b2.typeLevel && a3.typeIndentLevel === b2.typeIndentLevel && a3.logicalIndent === b2.logicalIndent && a3.listContextLevel === b2.listContextLevel && a3.linkDefinitionState === b2.linkDefinitionState && a3.text === b2.text && a3.textStart === b2.textStart && shallowEquals(a3.tags, b2.tags) && dateTimeEquals(a3.dateTime, b2.dateTime) && modeStackEquals(a3.modeStack, b2.modeStack) && stateEquals(a3.codemirrorState, b2.codemirrorState);
    }
    textAttributesToClearBeforeClassify() {
      let attributesToClear13 = this.attributesToClear;
      if (!attributesToClear13) {
        attributesToClear13 = ["text", "lead", "trail", "error", "language"];
        attributesToClear13 = attributesToClear8.concat(attributesToClear13);
        attributesToClear13 = attributesToClear7.concat(attributesToClear13);
        Extensions.processExtensions("com.foldingtext.taxonomy.classifier", (classifier) => {
          attributesToClear13 = attributesToClear13.concat(classifier.attributesToClear);
        });
        if (this.foldingtext) {
          attributesToClear13 = attributesToClear11.concat(attributesToClear13);
          attributesToClear13 = attributesToClear9.concat(attributesToClear13);
          attributesToClear13 = attributesToClear10.concat(attributesToClear13);
        }
        attributesToClear13 = attributesToClear.concat(attributesToClear13);
        attributesToClear13.sort();
        attributesToClear13.sortedUniquify();
        this.attributesToClear = attributesToClear13;
      }
      return attributesToClear13;
    }
    matchLeadForNode(node) {
      switch (node.type()) {
        case "unordered":
          return unordedLeadRegex.exec(node.line());
        case "task":
          return taskLeadRegex.exec(node.line());
        case "ordered":
          return orderedLeadRegex.exec(node.line());
        case "blockquote":
          return blockquoteLeadRegex.exec(node.line());
      }
      return super.matchLeadForNode(node);
    }
    nextLeadFromNode(node, after) {
      if (node.type() === "ordered") {
        let nodeLeadMatch = this.matchLeadForNode(node), number2 = parseInt(nodeLeadMatch[2], 10);
        if (after) {
          number2++;
        } else {
          number2--;
        }
        if (number2 <= 0) {
          number2 = 1;
        }
        return nodeLeadMatch[1] + number2 + nodeLeadMatch[3];
      }
      return super.nextLeadFromNode(node, after);
    }
    renderNodeElementStyles(editor2, node, elementRenderer) {
      let type = node.type(), line = node.line(), defaultMarginLeft = editor2.defaultPREStyling().marginLeft, charWidth = editor2.defaultCharWidth(), marginLeftAdjust = 0, textIndent = 0, tabWidth, tabsWidth, match;
      super.renderNodeElementStyles(editor2, node, elementRenderer);
      if (type === "heading" && (match = line.match(this.renderLineHeadingRE))) {
        textIndent = -elementRenderer.measureTextRange(match.index, match[0].length).width;
      } else if (type === "blockquote") {
        match = line.match(/\s*(>\s*)+/);
        if (match) {
          textIndent = -elementRenderer.measureTextRange(match.index, match[0].length).width;
        }
        marginLeftAdjust += -textIndent;
      } else if (type === "definition") {
        match = line.match(this.definitionMatchRE);
        textIndent = -elementRenderer.measureTextRange(match.index, match[0].length).width;
        marginLeftAdjust += -textIndent;
      } else if (type === "ordered" && (match = line.match(this.renderLineOrderedRE))) {
        tabWidth = editor2.tabWidth();
        tabsWidth = match[1].length * tabWidth;
        marginLeftAdjust += tabWidth + tabsWidth;
        textIndent = -(tabsWidth + elementRenderer.measureTextRange(match.index + match[1].length, match[2].length).width);
      } else if (type === "unordered" && (match = line.match(this.renderLineUnorderedRE))) {
        tabWidth = editor2.tabWidth();
        tabsWidth = match[1].length * tabWidth;
        marginLeftAdjust += tabWidth + tabsWidth;
        textIndent = -(tabsWidth + elementRenderer.measureTextRange(match.index + match[1].length, match[2].length).width);
      } else if (type === "task" && (match = line.match(this.renderLineTaskRE))) {
        tabWidth = editor2.tabWidth();
        tabsWidth = match[1].length * tabWidth;
        marginLeftAdjust += tabWidth + tabsWidth;
        textIndent = -(tabsWidth + elementRenderer.measureTextRange(match.index + match[1].length, match[0].length - match[1].length).width);
      } else if (type === "codeblock") {
        if (this.foldingtext) {
          match = line.match(/\t*[ ]{4}/);
        } else {
          match = line.match(/(?:[ ]{4})|\t/);
        }
        if (match) {
          textIndent = -elementRenderer.measureTextRange(match.index, match[0].length).width;
          marginLeftAdjust += charWidth * 4;
        }
      } else if (type === "htmlblock" || type === "fencedcode" || type === "fencedcodetopboundary" || type === "fencedcodebottomboundary") {
        marginLeftAdjust += charWidth * 4;
      } else {
        match = line.match(/([ ]{4}|\t)*/);
        textIndent = -elementRenderer.measureTextRange(match.index, match[0].length).width;
        marginLeftAdjust += -textIndent;
      }
      let totalMarginLeft = defaultMarginLeft + marginLeftAdjust, totalNegativeOffset = totalMarginLeft + textIndent;
      if (totalNegativeOffset < charWidth) {
        totalMarginLeft += -totalNegativeOffset;
        totalMarginLeft += charWidth;
      }
      if (totalMarginLeft !== defaultMarginLeft) {
        elementRenderer.setStyle("marginLeft", `${Math.round(totalMarginLeft)}px`);
      }
      if (textIndent !== 0) {
        elementRenderer.setStyle("textIndent", `${Math.round(textIndent)}px`);
      }
    }
    stripInlineSyntax(text) {
      return stripInlineSyntax(text, {}, {}, this.htmlMode, this.criticMarkup, this.magiclinks, this.inwordunderscores);
    }
  };
  function highlightURLAndReturnAdvance(i3, autoLinkURL, anyLinkURL, text) {
    if (autoLinkURL) {
      text.addAttributeInRange("keyword", "<", i3, 1);
      i3 += 1;
      text.addAttributeInRange("linktarget", autoLinkURL, i3, autoLinkURL.length);
      i3 += autoLinkURL.length;
      text.addAttributeInRange("keyword", ">", i3, 1);
      i3 += 1;
    } else if (anyLinkURL) {
      text.addAttributeInRange("linktarget", anyLinkURL, i3, anyLinkURL.length);
      i3 += anyLinkURL.length;
    }
    return i3;
  }
  function highlightTitleAndReturnAdvance(i3, title, text, multimarkdown) {
    text.addAttributeInRange("keyword", '"', i3, 1);
    i3 += 1;
    text.addAttributeInRange("linktitle", title, i3, title.length);
    i3 += title.length;
    text.addAttributeInRange("keyword", '"', i3, 1);
    i3 += 1;
    if (multimarkdown) {
      i3 = text.textLength();
    }
    return i3;
  }
  function highlightTrailingErrorRange(i3, text) {
    let trailLength = text.textLength() - i3;
    if (trailLength > 0) {
      let trailText = text.textSubstr(i3, trailLength);
      trailText = trailText.ltrim();
      let leadingSpace = trailLength - trailText.length;
      trailText = trailText.rtrim();
      if (trailText) {
        text.addAttributeInRange("error", trailText, i3 + leadingSpace, trailText.length);
      }
    }
  }
  function isListType(type) {
    return type === "unordered" || type === "ordered";
  }
  function canListStartAfterState(taxonomy3, state) {
    if (taxonomy3.foldingtext) {
      return true;
    }
    let type = state.type;
    return type === void 0 || type === "empty" || state.listContextLevel > 0 || isListType(type);
  }
  Extensions.add("com.foldingtext.editor.taxonomies", {
    name: "markdown",
    configurations: [{ mime: "text/x-markdown", spec: "markdown" }],
    taxonomy(spec) {
      return new MarkdownTaxonomy(spec);
    }
  });

  // src/util/environment.js
  var environment_default = {
    debug: true,
    applicationName: "FoldingText"
  };

  // src/util/queryparameter.js
  function QueryParameter(name106, defaultValue, href) {
    name106 = name106.replace(/[[]/, "\\[").replace(/[\]]/, "\\]");
    let regex = new RegExp(`[\\?&]${name106}=([^&#]*)`);
    if (!href) {
      href = window.location.href;
      let frameElement = window.frameElement;
      if (frameElement) {
        href = frameElement.src;
      }
    }
    let results = regex.exec(href);
    if (results === null) {
      return defaultValue;
    }
    return decodeURIComponent(results[1].split("+").join(" "));
  }

  // src/ft/extensions/closebrackets.js
  init_extensions();
  Extensions.addInit((editor2) => {
    editor2.cm().setOption("autoCloseBrackets", { pairs: '(){}""' });
  }, Extensions.PriorityLast);

  // src/ft/extensions/complete.jsx
  init_extensions();

  // node_modules/preact/dist/preact.module.js
  var n;
  var l;
  var u;
  var i;
  var t;
  var o;
  var r;
  var f = {};
  var e = [];
  var c = /acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera/i;
  function s(n3, l3) {
    for (var u3 in l3)
      n3[u3] = l3[u3];
    return n3;
  }
  function a(n3) {
    var l3 = n3.parentNode;
    l3 && l3.removeChild(n3);
  }
  function v(n3, l3, u3) {
    var i3, t3, o3, r3 = arguments, f3 = {};
    for (o3 in l3)
      o3 == "key" ? i3 = l3[o3] : o3 == "ref" ? t3 = l3[o3] : f3[o3] = l3[o3];
    if (arguments.length > 3)
      for (u3 = [u3], o3 = 3; o3 < arguments.length; o3++)
        u3.push(r3[o3]);
    if (u3 != null && (f3.children = u3), typeof n3 == "function" && n3.defaultProps != null)
      for (o3 in n3.defaultProps)
        f3[o3] === void 0 && (f3[o3] = n3.defaultProps[o3]);
    return h(n3, f3, i3, t3, null);
  }
  function h(l3, u3, i3, t3, o3) {
    var r3 = { type: l3, props: u3, key: i3, ref: t3, __k: null, __: null, __b: 0, __e: null, __d: void 0, __c: null, __h: null, constructor: void 0, __v: o3 == null ? ++n.__v : o3 };
    return n.vnode != null && n.vnode(r3), r3;
  }
  function p(n3) {
    return n3.children;
  }
  function d2(n3, l3) {
    this.props = n3, this.context = l3;
  }
  function _(n3, l3) {
    if (l3 == null)
      return n3.__ ? _(n3.__, n3.__.__k.indexOf(n3) + 1) : null;
    for (var u3; l3 < n3.__k.length; l3++)
      if ((u3 = n3.__k[l3]) != null && u3.__e != null)
        return u3.__e;
    return typeof n3.type == "function" ? _(n3) : null;
  }
  function w(n3) {
    var l3, u3;
    if ((n3 = n3.__) != null && n3.__c != null) {
      for (n3.__e = n3.__c.base = null, l3 = 0; l3 < n3.__k.length; l3++)
        if ((u3 = n3.__k[l3]) != null && u3.__e != null) {
          n3.__e = n3.__c.base = u3.__e;
          break;
        }
      return w(n3);
    }
  }
  function k(l3) {
    (!l3.__d && (l3.__d = true) && u.push(l3) && !g.__r++ || t !== n.debounceRendering) && ((t = n.debounceRendering) || i)(g);
  }
  function g() {
    for (var n3; g.__r = u.length; )
      n3 = u.sort(function(n4, l3) {
        return n4.__v.__b - l3.__v.__b;
      }), u = [], n3.some(function(n4) {
        var l3, u3, i3, t3, o3, r3, f3;
        n4.__d && (r3 = (o3 = (l3 = n4).__v).__e, (f3 = l3.__P) && (u3 = [], (i3 = s({}, o3)).__v = o3.__v + 1, t3 = $2(f3, o3, i3, l3.__n, f3.ownerSVGElement !== void 0, o3.__h != null ? [r3] : null, u3, r3 == null ? _(o3) : r3, o3.__h), j(u3, o3), t3 != r3 && w(o3)));
      });
  }
  function m(n3, l3, u3, i3, t3, o3, r3, c3, s3, v3) {
    var y2, d4, w3, k3, g3, m3, b2, A2 = i3 && i3.__k || e, P3 = A2.length;
    for (s3 == f && (s3 = r3 != null ? r3[0] : P3 ? _(i3, 0) : null), u3.__k = [], y2 = 0; y2 < l3.length; y2++)
      if ((k3 = u3.__k[y2] = (k3 = l3[y2]) == null || typeof k3 == "boolean" ? null : typeof k3 == "string" || typeof k3 == "number" ? h(null, k3, null, null, k3) : Array.isArray(k3) ? h(p, { children: k3 }, null, null, null) : k3.__e != null || k3.__c != null ? h(k3.type, k3.props, k3.key, null, k3.__v) : k3) != null) {
        if (k3.__ = u3, k3.__b = u3.__b + 1, (w3 = A2[y2]) === null || w3 && k3.key == w3.key && k3.type === w3.type)
          A2[y2] = void 0;
        else
          for (d4 = 0; d4 < P3; d4++) {
            if ((w3 = A2[d4]) && k3.key == w3.key && k3.type === w3.type) {
              A2[d4] = void 0;
              break;
            }
            w3 = null;
          }
        g3 = $2(n3, k3, w3 = w3 || f, t3, o3, r3, c3, s3, v3), (d4 = k3.ref) && w3.ref != d4 && (b2 || (b2 = []), w3.ref && b2.push(w3.ref, null, k3), b2.push(d4, k3.__c || g3, k3)), g3 != null ? (m3 == null && (m3 = g3), s3 = x(n3, k3, w3, A2, r3, g3, s3), v3 || u3.type != "option" ? typeof u3.type == "function" && (u3.__d = s3) : n3.value = "") : s3 && w3.__e == s3 && s3.parentNode != n3 && (s3 = _(w3));
      }
    if (u3.__e = m3, r3 != null && typeof u3.type != "function")
      for (y2 = r3.length; y2--; )
        r3[y2] != null && a(r3[y2]);
    for (y2 = P3; y2--; )
      A2[y2] != null && L(A2[y2], A2[y2]);
    if (b2)
      for (y2 = 0; y2 < b2.length; y2++)
        I(b2[y2], b2[++y2], b2[++y2]);
  }
  function x(n3, l3, u3, i3, t3, o3, r3) {
    var f3, e5, c3;
    if (l3.__d !== void 0)
      f3 = l3.__d, l3.__d = void 0;
    else if (t3 == u3 || o3 != r3 || o3.parentNode == null)
      n:
        if (r3 == null || r3.parentNode !== n3)
          n3.appendChild(o3), f3 = null;
        else {
          for (e5 = r3, c3 = 0; (e5 = e5.nextSibling) && c3 < i3.length; c3 += 2)
            if (e5 == o3)
              break n;
          n3.insertBefore(o3, r3), f3 = r3;
        }
    return f3 !== void 0 ? f3 : o3.nextSibling;
  }
  function A(n3, l3, u3, i3, t3) {
    var o3;
    for (o3 in u3)
      o3 === "children" || o3 === "key" || o3 in l3 || C(n3, o3, null, u3[o3], i3);
    for (o3 in l3)
      t3 && typeof l3[o3] != "function" || o3 === "children" || o3 === "key" || o3 === "value" || o3 === "checked" || u3[o3] === l3[o3] || C(n3, o3, l3[o3], u3[o3], i3);
  }
  function P(n3, l3, u3) {
    l3[0] === "-" ? n3.setProperty(l3, u3) : n3[l3] = u3 == null ? "" : typeof u3 != "number" || c.test(l3) ? u3 : u3 + "px";
  }
  function C(n3, l3, u3, i3, t3) {
    var o3, r3, f3;
    if (t3 && l3 == "className" && (l3 = "class"), l3 === "style")
      if (typeof u3 == "string")
        n3.style.cssText = u3;
      else {
        if (typeof i3 == "string" && (n3.style.cssText = i3 = ""), i3)
          for (l3 in i3)
            u3 && l3 in u3 || P(n3.style, l3, "");
        if (u3)
          for (l3 in u3)
            i3 && u3[l3] === i3[l3] || P(n3.style, l3, u3[l3]);
      }
    else
      l3[0] === "o" && l3[1] === "n" ? (o3 = l3 !== (l3 = l3.replace(/Capture$/, "")), (r3 = l3.toLowerCase()) in n3 && (l3 = r3), l3 = l3.slice(2), n3.l || (n3.l = {}), n3.l[l3 + o3] = u3, f3 = o3 ? N : z, u3 ? i3 || n3.addEventListener(l3, f3, o3) : n3.removeEventListener(l3, f3, o3)) : l3 !== "list" && l3 !== "tagName" && l3 !== "form" && l3 !== "type" && l3 !== "size" && l3 !== "download" && l3 !== "href" && !t3 && l3 in n3 ? n3[l3] = u3 == null ? "" : u3 : typeof u3 != "function" && l3 !== "dangerouslySetInnerHTML" && (l3 !== (l3 = l3.replace(/xlink:?/, "")) ? u3 == null || u3 === false ? n3.removeAttributeNS("http://www.w3.org/1999/xlink", l3.toLowerCase()) : n3.setAttributeNS("http://www.w3.org/1999/xlink", l3.toLowerCase(), u3) : u3 == null || u3 === false && !/^ar/.test(l3) ? n3.removeAttribute(l3) : n3.setAttribute(l3, u3));
  }
  function z(l3) {
    this.l[l3.type + false](n.event ? n.event(l3) : l3);
  }
  function N(l3) {
    this.l[l3.type + true](n.event ? n.event(l3) : l3);
  }
  function T(n3, l3, u3) {
    var i3, t3;
    for (i3 = 0; i3 < n3.__k.length; i3++)
      (t3 = n3.__k[i3]) && (t3.__ = n3, t3.__e && (typeof t3.type == "function" && t3.__k.length > 1 && T(t3, l3, u3), l3 = x(u3, t3, t3, n3.__k, null, t3.__e, l3), typeof n3.type == "function" && (n3.__d = l3)));
  }
  function $2(l3, u3, i3, t3, o3, r3, f3, e5, c3) {
    var a3, v3, h2, y2, _2, w3, k3, g3, b2, x3, A2, P3 = u3.type;
    if (u3.constructor !== void 0)
      return null;
    i3.__h != null && (c3 = i3.__h, e5 = u3.__e = i3.__e, u3.__h = null, r3 = [e5]), (a3 = n.__b) && a3(u3);
    try {
      n:
        if (typeof P3 == "function") {
          if (g3 = u3.props, b2 = (a3 = P3.contextType) && t3[a3.__c], x3 = a3 ? b2 ? b2.props.value : a3.__ : t3, i3.__c ? k3 = (v3 = u3.__c = i3.__c).__ = v3.__E : ("prototype" in P3 && P3.prototype.render ? u3.__c = v3 = new P3(g3, x3) : (u3.__c = v3 = new d2(g3, x3), v3.constructor = P3, v3.render = M), b2 && b2.sub(v3), v3.props = g3, v3.state || (v3.state = {}), v3.context = x3, v3.__n = t3, h2 = v3.__d = true, v3.__h = []), v3.__s == null && (v3.__s = v3.state), P3.getDerivedStateFromProps != null && (v3.__s == v3.state && (v3.__s = s({}, v3.__s)), s(v3.__s, P3.getDerivedStateFromProps(g3, v3.__s))), y2 = v3.props, _2 = v3.state, h2)
            P3.getDerivedStateFromProps == null && v3.componentWillMount != null && v3.componentWillMount(), v3.componentDidMount != null && v3.__h.push(v3.componentDidMount);
          else {
            if (P3.getDerivedStateFromProps == null && g3 !== y2 && v3.componentWillReceiveProps != null && v3.componentWillReceiveProps(g3, x3), !v3.__e && v3.shouldComponentUpdate != null && v3.shouldComponentUpdate(g3, v3.__s, x3) === false || u3.__v === i3.__v) {
              v3.props = g3, v3.state = v3.__s, u3.__v !== i3.__v && (v3.__d = false), v3.__v = u3, u3.__e = i3.__e, u3.__k = i3.__k, v3.__h.length && f3.push(v3), T(u3, e5, l3);
              break n;
            }
            v3.componentWillUpdate != null && v3.componentWillUpdate(g3, v3.__s, x3), v3.componentDidUpdate != null && v3.__h.push(function() {
              v3.componentDidUpdate(y2, _2, w3);
            });
          }
          v3.context = x3, v3.props = g3, v3.state = v3.__s, (a3 = n.__r) && a3(u3), v3.__d = false, v3.__v = u3, v3.__P = l3, a3 = v3.render(v3.props, v3.state, v3.context), v3.state = v3.__s, v3.getChildContext != null && (t3 = s(s({}, t3), v3.getChildContext())), h2 || v3.getSnapshotBeforeUpdate == null || (w3 = v3.getSnapshotBeforeUpdate(y2, _2)), A2 = a3 != null && a3.type == p && a3.key == null ? a3.props.children : a3, m(l3, Array.isArray(A2) ? A2 : [A2], u3, i3, t3, o3, r3, f3, e5, c3), v3.base = u3.__e, u3.__h = null, v3.__h.length && f3.push(v3), k3 && (v3.__E = v3.__ = null), v3.__e = false;
        } else
          r3 == null && u3.__v === i3.__v ? (u3.__k = i3.__k, u3.__e = i3.__e) : u3.__e = H(i3.__e, u3, i3, t3, o3, r3, f3, c3);
      (a3 = n.diffed) && a3(u3);
    } catch (l4) {
      u3.__v = null, (c3 || r3 != null) && (u3.__e = e5, u3.__h = !!c3, r3[r3.indexOf(e5)] = null), n.__e(l4, u3, i3);
    }
    return u3.__e;
  }
  function j(l3, u3) {
    n.__c && n.__c(u3, l3), l3.some(function(u4) {
      try {
        l3 = u4.__h, u4.__h = [], l3.some(function(n3) {
          n3.call(u4);
        });
      } catch (l4) {
        n.__e(l4, u4.__v);
      }
    });
  }
  function H(n3, l3, u3, i3, t3, o3, r3, c3) {
    var s3, a3, v3, h2, y2, p3 = u3.props, d4 = l3.props;
    if (t3 = l3.type === "svg" || t3, o3 != null) {
      for (s3 = 0; s3 < o3.length; s3++)
        if ((a3 = o3[s3]) != null && ((l3.type === null ? a3.nodeType === 3 : a3.localName === l3.type) || n3 == a3)) {
          n3 = a3, o3[s3] = null;
          break;
        }
    }
    if (n3 == null) {
      if (l3.type === null)
        return document.createTextNode(d4);
      n3 = t3 ? document.createElementNS("http://www.w3.org/2000/svg", l3.type) : document.createElement(l3.type, d4.is && { is: d4.is }), o3 = null, c3 = false;
    }
    if (l3.type === null)
      p3 === d4 || c3 && n3.data === d4 || (n3.data = d4);
    else {
      if (o3 != null && (o3 = e.slice.call(n3.childNodes)), v3 = (p3 = u3.props || f).dangerouslySetInnerHTML, h2 = d4.dangerouslySetInnerHTML, !c3) {
        if (o3 != null)
          for (p3 = {}, y2 = 0; y2 < n3.attributes.length; y2++)
            p3[n3.attributes[y2].name] = n3.attributes[y2].value;
        (h2 || v3) && (h2 && (v3 && h2.__html == v3.__html || h2.__html === n3.innerHTML) || (n3.innerHTML = h2 && h2.__html || ""));
      }
      A(n3, d4, p3, t3, c3), h2 ? l3.__k = [] : (s3 = l3.props.children, m(n3, Array.isArray(s3) ? s3 : [s3], l3, u3, i3, l3.type !== "foreignObject" && t3, o3, r3, f, c3)), c3 || ("value" in d4 && (s3 = d4.value) !== void 0 && (s3 !== n3.value || l3.type === "progress" && !s3) && C(n3, "value", s3, p3.value, false), "checked" in d4 && (s3 = d4.checked) !== void 0 && s3 !== n3.checked && C(n3, "checked", s3, p3.checked, false));
    }
    return n3;
  }
  function I(l3, u3, i3) {
    try {
      typeof l3 == "function" ? l3(u3) : l3.current = u3;
    } catch (l4) {
      n.__e(l4, i3);
    }
  }
  function L(l3, u3, i3) {
    var t3, o3, r3;
    if (n.unmount && n.unmount(l3), (t3 = l3.ref) && (t3.current && t3.current !== l3.__e || I(t3, null, u3)), i3 || typeof l3.type == "function" || (i3 = (o3 = l3.__e) != null), l3.__e = l3.__d = void 0, (t3 = l3.__c) != null) {
      if (t3.componentWillUnmount)
        try {
          t3.componentWillUnmount();
        } catch (l4) {
          n.__e(l4, u3);
        }
      t3.base = t3.__P = null;
    }
    if (t3 = l3.__k)
      for (r3 = 0; r3 < t3.length; r3++)
        t3[r3] && L(t3[r3], u3, i3);
    o3 != null && a(o3);
  }
  function M(n3, l3, u3) {
    return this.constructor(n3, u3);
  }
  function O(l3, u3, i3) {
    var t3, r3, c3;
    n.__ && n.__(l3, u3), r3 = (t3 = i3 === o) ? null : i3 && i3.__k || u3.__k, l3 = v(p, null, [l3]), c3 = [], $2(u3, (t3 ? u3 : i3 || u3).__k = l3, r3 || f, f, u3.ownerSVGElement !== void 0, i3 && !t3 ? [i3] : r3 ? null : u3.childNodes.length ? e.slice.call(u3.childNodes) : null, c3, i3 || f, t3), j(c3, l3);
  }
  n = { __e: function(n3, l3) {
    for (var u3, i3, t3, o3 = l3.__h; l3 = l3.__; )
      if ((u3 = l3.__c) && !u3.__)
        try {
          if ((i3 = u3.constructor) && i3.getDerivedStateFromError != null && (u3.setState(i3.getDerivedStateFromError(n3)), t3 = u3.__d), u3.componentDidCatch != null && (u3.componentDidCatch(n3), t3 = u3.__d), t3)
            return l3.__h = o3, u3.__E = u3;
        } catch (l4) {
          n3 = l4;
        }
    throw n3;
  }, __v: 0 }, l = function(n3) {
    return n3 != null && n3.constructor === void 0;
  }, d2.prototype.setState = function(n3, l3) {
    var u3;
    u3 = this.__s != null && this.__s !== this.state ? this.__s : this.__s = s({}, this.state), typeof n3 == "function" && (n3 = n3(s({}, u3), this.props)), n3 && s(u3, n3), n3 != null && this.__v && (l3 && this.__h.push(l3), k(this));
  }, d2.prototype.forceUpdate = function(n3) {
    this.__v && (this.__e = true, n3 && this.__h.push(n3), k(this));
  }, d2.prototype.render = p, u = [], i = typeof Promise == "function" ? Promise.prototype.then.bind(Promise.resolve()) : setTimeout, g.__r = 0, o = f, r = 0;

  // node_modules/preact/hooks/dist/hooks.module.js
  var t2;
  var u2;
  var r2;
  var o2 = 0;
  var i2 = [];
  var c2 = n.__b;
  var f2 = n.__r;
  var e2 = n.diffed;
  var a2 = n.__c;
  var v2 = n.unmount;
  function m2(t3, r3) {
    n.__h && n.__h(u2, t3, o2 || r3), o2 = 0;
    var i3 = u2.__H || (u2.__H = { __: [], __h: [] });
    return t3 >= i3.__.length && i3.__.push({}), i3.__[t3];
  }
  function l2(n3) {
    return o2 = 1, p2(w2, n3);
  }
  function p2(n3, r3, o3) {
    var i3 = m2(t2++, 2);
    return i3.t = n3, i3.__c || (i3.__ = [o3 ? o3(r3) : w2(void 0, r3), function(n4) {
      var t3 = i3.t(i3.__[0], n4);
      i3.__[0] !== t3 && (i3.__ = [t3, i3.__[1]], i3.__c.setState({}));
    }], i3.__c = u2), i3.__;
  }
  function y(r3, o3) {
    var i3 = m2(t2++, 3);
    !n.__s && k2(i3.__H, o3) && (i3.__ = r3, i3.__H = o3, u2.__H.__h.push(i3));
  }
  function s2(n3) {
    return o2 = 5, d3(function() {
      return { current: n3 };
    }, []);
  }
  function d3(n3, u3) {
    var r3 = m2(t2++, 7);
    return k2(r3.__H, u3) && (r3.__ = n3(), r3.__H = u3, r3.__h = n3), r3.__;
  }
  function x2() {
    i2.forEach(function(t3) {
      if (t3.__P)
        try {
          t3.__H.__h.forEach(g2), t3.__H.__h.forEach(j2), t3.__H.__h = [];
        } catch (u3) {
          t3.__H.__h = [], n.__e(u3, t3.__v);
        }
    }), i2 = [];
  }
  n.__b = function(n3) {
    u2 = null, c2 && c2(n3);
  }, n.__r = function(n3) {
    f2 && f2(n3), t2 = 0;
    var r3 = (u2 = n3.__c).__H;
    r3 && (r3.__h.forEach(g2), r3.__h.forEach(j2), r3.__h = []);
  }, n.diffed = function(t3) {
    e2 && e2(t3);
    var o3 = t3.__c;
    o3 && o3.__H && o3.__H.__h.length && (i2.push(o3) !== 1 && r2 === n.requestAnimationFrame || ((r2 = n.requestAnimationFrame) || function(n3) {
      var t4, u3 = function() {
        clearTimeout(r3), b && cancelAnimationFrame(t4), setTimeout(n3);
      }, r3 = setTimeout(u3, 100);
      b && (t4 = requestAnimationFrame(u3));
    })(x2)), u2 = void 0;
  }, n.__c = function(t3, u3) {
    u3.some(function(t4) {
      try {
        t4.__h.forEach(g2), t4.__h = t4.__h.filter(function(n3) {
          return !n3.__ || j2(n3);
        });
      } catch (r3) {
        u3.some(function(n3) {
          n3.__h && (n3.__h = []);
        }), u3 = [], n.__e(r3, t4.__v);
      }
    }), a2 && a2(t3, u3);
  }, n.unmount = function(t3) {
    v2 && v2(t3);
    var u3 = t3.__c;
    if (u3 && u3.__H)
      try {
        u3.__H.__.forEach(g2);
      } catch (t4) {
        n.__e(t4, u3.__v);
      }
  };
  var b = typeof requestAnimationFrame == "function";
  function g2(n3) {
    var t3 = u2;
    typeof n3.__c == "function" && n3.__c(), u2 = t3;
  }
  function j2(n3) {
    var t3 = u2;
    n3.__c = n3.__(), u2 = t3;
  }
  function k2(n3, t3) {
    return !n3 || n3.length !== t3.length || t3.some(function(t4, u3) {
      return t4 !== n3[u3];
    });
  }
  function w2(n3, t3) {
    return typeof t3 == "function" ? t3(n3) : t3;
  }

  // src/ft/extensions/CompletePopup.jsx
  function CompletePopup({
    editor: editor2,
    isLoading,
    caretLocation = null,
    completions = [],
    onClose,
    extensionName,
    isComplete
  }) {
    const [selectedIndex, setSelectedIndex] = l2(0);
    const popupRef = s2(null);
    y(() => {
      if (!popupRef.current) {
        return;
      }
      if (!caretLocation)
        return;
      const localCursorCoords = editor2.cursorCoords(caretLocation, "local");
      const element3 = popupRef.current;
      const offsetHeight = element3.offsetHeight;
      editor2.scrollRectToVisible({
        top: localCursorCoords.top,
        left: 0,
        right: 0,
        bottom: localCursorCoords.bottom + offsetHeight
      });
      window.setTimeout(() => {
        const pageCursorCoords = editor2.cursorCoords(caretLocation, "page");
        const top = pageCursorCoords.bottom;
        const left = pageCursorCoords.left;
        element3.style.top = `${top}px`;
        element3.style.left = `${left}px`;
        setSelectedIndex(0);
      });
    }, [popupRef, caretLocation, editor2]);
    y(() => {
      editor2._completeSavedUndoHistory = editor2.cm().getHistory();
    }, [editor2]);
    y(() => {
      const item = document.querySelector(".completion-item.selected");
      if (item) {
        item.scrollIntoView({
          behavior: "smooth",
          block: "nearest"
        });
      }
    }, [selectedIndex]);
    y(() => {
      editor2.isCompleting = true;
      editor2.completingExtensionName = extensionName;
      setupEditorKeybindings();
      return cleanUp;
    });
    y(() => {
      if (isComplete)
        setTimeout(() => {
          close(false, false);
        });
    });
    const focusEditor = () => {
      setTimeout(() => editor2.focus());
    };
    const cleanUp = () => {
      editor2.isCompleting = false;
      editor2.completingExtensionName = null;
      editor2.removeKeyMap("completePopup");
    };
    const insertMatch = (editor3, match) => {
      const replaceRange = editor3.selectedRange().rangeByOffsetting(-editor3._completePrefixLength, editor3._completePrefixLength);
      editor3.setSelectedRange(replaceRange);
      editor3.replaceSelection(`${match} `, "around");
    };
    const close = (revert, goLeft) => {
      var _a;
      editor2.cm().setHistory(editor2._completeSavedUndoHistory);
      if (!revert) {
        let match = completions[selectedIndex];
        if (((_a = match == null ? void 0 : match.value) == null ? void 0 : _a.indexOf("](NEW_DOCUMENT)")) >= 0) {
          return new Promise((resolve) => {
            editor2.createFile(match.name).then(({ fileId }) => {
              insertMatch(editor2, `[${match.name}](${fileId})`);
              if (goLeft) {
                editor2.performCommand("moveLeft");
              } else {
                editor2.performCommand("moveRight");
              }
              focusEditor();
              onClose();
              resolve();
            });
          });
        }
        if (match.value)
          match = match.value;
        insertMatch(editor2, match);
        if (goLeft) {
          editor2.performCommand("moveLeft");
        } else {
          editor2.performCommand("moveRight");
        }
      }
      focusEditor();
      onClose();
    };
    const setupEditorKeybindings = () => {
      editor2.addKeyMap({
        name: "completePopup",
        Up: () => moveSelection(-1),
        Down: () => moveSelection(1),
        Left: () => close(true),
        Right: () => close(false, false),
        Enter: () => close(false, false),
        Esc: () => close(true),
        Tab: () => close(false, false),
        Delete: () => close(true),
        F5: () => close(true)
      });
    };
    const moveSelection = (by) => {
      if (!completions)
        return;
      let newIndex = selectedIndex + by;
      if (newIndex < 0) {
        newIndex = completions.length - 1;
      }
      if (newIndex >= completions.length) {
        newIndex = 0;
      }
      setSelectedIndex(newIndex);
    };
    return /* @__PURE__ */ v("ul", {
      className: "completion-popup",
      style: {
        top: 0,
        left: -1e3
      },
      ref: popupRef
    }, isLoading && /* @__PURE__ */ v("li", {
      className: "loading"
    }, "Loading..."), completions.map((item, index2) => {
      const name106 = item.name || item;
      return /* @__PURE__ */ v("li", {
        className: `completion-item ${index2 === selectedIndex ? "selected" : ""}`,
        tabIndex: -1,
        key: `completion-${index2}`,
        onClick: () => setSelectedIndex(index2)
      }, /* @__PURE__ */ v("p", {
        className: "name"
      }, name106), item.detail ? /* @__PURE__ */ v("p", {
        className: "detail"
      }, item.detail) : null);
    }));
  }

  // src/ft/extensions/complete.jsx
  var commandWhitelist = [
    "centerSelectionInVisibleArea",
    "replaceTextSnippet",
    "smartInsertSpace",
    "delCharBefore"
  ];
  function renderPopup(editor2, isOpen, isLoading = false, prefixRange = null, extensionName = "", completions = [], isComplete = false) {
    let el = document.getElementById("reacts");
    if (!el) {
      el = document.createElement("div");
      el.id = "reacts";
      document.body.appendChild(el);
    }
    if (!isOpen) {
      editor2.focus();
    }
    O(/* @__PURE__ */ v("div", null, isOpen ? /* @__PURE__ */ v(CompletePopup, {
      editor: editor2,
      isLoading,
      caretLocation: prefixRange == null ? void 0 : prefixRange.startLineCh(),
      completions,
      onClose: () => {
        renderPopup(editor2, false);
      },
      extensionName,
      isComplete
    }) : null), el);
  }
  function renderCompletions(editor2, extensionName, filter3, prefixRange, closeOnEmpty = true) {
    editor2.completionsForExtensionWithFilter(extensionName, filter3).then((options) => {
      const { completions, isComplete } = options;
      if (!completions || completions.length === 0) {
        if (closeOnEmpty)
          renderPopup(editor2, false);
        else {
          renderPopup(editor2, true, false, prefixRange, extensionName, completions, isComplete);
        }
        return;
      }
      renderPopup(editor2, true, false, prefixRange, extensionName, completions, isComplete);
    });
  }
  Extensions.add("com.foldingtext.editor.methods", {
    complete() {
      const editor2 = this;
      const prefixRange = editor2.prefixWordRangeForComplete();
      const prefixLength = prefixRange == null ? void 0 : prefixRange.length();
      if (!prefixLength) {
        renderPopup(editor2, false);
        return;
      }
      editor2._completePrefixLength = prefixLength;
      const extensionName = editor2.completionExtensionNameForPrefixWordRange(prefixRange);
      renderPopup(editor2, true, true, prefixRange, extensionName);
      renderCompletions(editor2, extensionName, "", prefixRange);
    },
    prefixWordRangeForComplete(change) {
      const editor2 = this;
      const tree = editor2.tree();
      const selectedRange = editor2.selectedRange();
      const selectedLocation = selectedRange.location();
      const wordRange = selectedRange.rangeByExtendingToWord();
      const wordLocation = wordRange.location();
      const prefixRange = tree.createRangeFromLocation(wordLocation, selectedLocation - wordLocation);
      const updatedPrefixRange = Extensions.processExtensions("com.foldingtext.editor.prefixWordRangeForComplete", (each) => {
        return each(prefixRange, editor2, change);
      }, true);
      return updatedPrefixRange || prefixRange;
    },
    completionExtensionNameForPrefixWordRange(prefixWordRange) {
      let editor2 = this;
      return Extensions.processExtensions("com.foldingtext.editor.completionsForPrefixWordRange", (each) => {
        return each(prefixWordRange, editor2);
      }, true);
    },
    completionsForExtensionWithFilter(extensionName, filter3) {
      const editor2 = this;
      return Extensions.processExtensionsAsync(extensionName, (each) => each(filter3, editor2)).then((promises) => promises[0]);
    }
  });
  Extensions.add("com.foldingtext.editor.change", (editor2, obj) => {
    if (editor2.isCompleting) {
      const isDeleting = obj.origin === "+delete";
      if (obj.origin !== "+input" && !isDeleting) {
        return renderPopup(editor2, false);
      }
      const prefixRange = editor2.prefixWordRangeForComplete(obj);
      const extensionName = editor2.completionExtensionNameForPrefixWordRange(prefixRange);
      const prefixText = prefixRange.textInRange();
      const prefixFilter = prefixText;
      editor2._completePrefixLength = editor2._completePrefixLength + 1;
      if (!extensionName) {
        return renderPopup(editor2, false);
      }
      renderCompletions(editor2, extensionName, prefixFilter.substr(1), prefixRange, true);
    }
  });
  Extensions.add("com.foldingtext.editor.mouse", {
    mouseDown(editor2) {
      renderPopup(editor2, false);
    }
  });
  Extensions.add("com.foldingtext.editor.viewportDidScroll", (editor2) => {
    renderPopup(editor2, false);
  });
  Extensions.add("com.foldingtext.editor.willPerformCommand", (editor2, command) => {
    const isWhitelistedCommand = commandWhitelist.indexOf(command) >= 0;
    if (!isWhitelistedCommand) {
      renderPopup(editor2, false);
    }
  });

  // src/ft/extensions/current.js
  init_extensions();
  init_objectutils();
  function _syntaxBlockCandidateFunction(candidateRun) {
    let keys = arrayOfKeys(candidateRun.attributes);
    if (keys.length === 1 && keys[0] === "text" || keys.length === 0) {
      return false;
    }
    return true;
  }
  function replaceRangeMarkIfChanged(editor2, varriableName, newRange, className, extensionPoint) {
    let currentMarkTextVarriableName = `${varriableName}Text`, currentMarkOffsetVarriableName = `${varriableName}Offset`, currentMark = editor2[varriableName], currentMarkText = editor2[currentMarkTextVarriableName], currentMarkOffset = editor2[currentMarkOffsetVarriableName], hasNewRange = newRange && !newRange.isCollapsed(), newFrom = hasNewRange ? newRange.startLineCh() : null, newTo = hasNewRange ? newRange.endLineCh() : null, newText = hasNewRange ? newRange.textInRange() : null, newOffset = hasNewRange ? newRange.startOffset : null;
    if (!currentMark && !newRange) {
      return;
    }
    if (currentMark) {
      if (hasNewRange) {
        let currentRange = currentMark.find();
        if (currentRange) {
          let currentFrom = currentRange.from, currentTo = currentRange.to;
          if (currentFrom.line === newFrom.line && currentFrom.ch === newFrom.ch && currentTo.line === newTo.line && currentTo.ch === newTo.ch) {
            if (currentMarkText === newText && currentMarkOffset === newOffset) {
              return;
            }
          }
        }
      }
      currentMark.clear();
      editor2[varriableName] = null;
      editor2[currentMarkTextVarriableName] = null;
      editor2[currentMarkOffsetVarriableName] = null;
    }
    if (hasNewRange) {
      editor2[varriableName] = editor2.cm().markText(newFrom, newTo, {
        className
      });
      editor2[currentMarkTextVarriableName] = newText;
      editor2[currentMarkOffsetVarriableName] = newOffset;
    }
    if (extensionPoint) {
      Extensions.processExtensions(extensionPoint, (each) => {
        each(editor2, newRange);
      });
    }
  }
  function updateCurrentMarks(editor2) {
    let tree = editor2.tree(), selectedRange = editor2.selectedRange(), headNode = selectedRange.headNode(), headOffset = selectedRange.headOffset(), headRange = tree.createRangeFromNodes(headNode, headOffset), attributedString = headNode.lineAttributedString(), syntaxSpanRange = attributedString.attributeRangeCalculatedByFunction(headOffset, _syntaxBlockCandidateFunction), wordRange = null, sentenceRange = null;
    if ((!syntaxSpanRange || syntaxSpanRange.length === 0) && headOffset > 0) {
      syntaxSpanRange = attributedString.attributeRangeCalculatedByFunction(headOffset - 1, _syntaxBlockCandidateFunction);
    }
    let syntaxRange = null;
    if (syntaxSpanRange && syntaxSpanRange.length > 0) {
      syntaxRange = tree.createRangeFromNodes(headNode, syntaxSpanRange.location, headNode, syntaxSpanRange.location + syntaxSpanRange.length);
    }
    replaceRangeMarkIfChanged(editor2, "_currentSyntaxMark", syntaxRange, "cm-current-syntax", null);
    wordRange = headRange.rangeByExtendingToWord();
    sentenceRange = headRange.rangeByExtendingToSentence();
    replaceRangeMarkIfChanged(editor2, "_currentWordMark", wordRange, "cm-current-syntax", "com.foldingtext.editor.currentWordDidChange");
    replaceRangeMarkIfChanged(editor2, "_currentSentenceMark", sentenceRange, "cm-currentsentence", "com.foldingtext.editor.currentSentenceDidChange");
  }
  Extensions.add("com.foldingtext.editor.willEndOperation", (editor2) => {
    editor2.operation(() => {
      updateCurrentMarks(editor2);
    });
  });
  Extensions.add("com.foldingtext.editor.mouseover", () => {
  });
  Extensions.add("com.foldingtext.editor.methods", {
    currentWordRange() {
      let mark = this._currentWordMark;
      if (mark) {
        let range2 = mark.find();
        if (range2) {
          return this.tree().createRangeFromLineChs(range2.from, range2.to);
        }
      }
      return null;
    },
    currentSentenceRange() {
      let mark = this._currentSentenceMark;
      if (mark) {
        let range2 = mark.find();
        if (range2) {
          return this.tree().createRangeFromLineChs(range2.from, range2.to);
        }
      }
      return null;
    }
  });

  // src/ft/extensions/cutcopypaste.js
  init_extensions();

  // src/util/assert.js
  var create = Object.create || function(p3) {
    if (!p3)
      throw Error("no type");
    function f3() {
    }
    f3.prototype = p3;
    return new f3();
  };
  var util = {
    inherits(ctor, superCtor) {
      ctor.super_ = superCtor;
      ctor.prototype = create(superCtor.prototype, {
        constructor: {
          value: ctor,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
    }
  };
  var pSlice = Array.prototype.slice;
  var Object_keys = typeof Object.keys === "function" ? Object.keys : function(obj) {
    let keys = [];
    for (let key in obj)
      keys.push(key);
    return keys;
  };
  var assert = ok;
  assert.AssertionError = function AssertionError(options) {
    this.name = "AssertionError";
    this.message = options.message;
    this.actual = options.actual;
    this.expected = options.expected;
    this.operator = options.operator;
    let stackStartFunction = options.stackStartFunction || fail;
    if (Error.captureStackTrace) {
      Error.captureStackTrace(this, stackStartFunction);
    }
  };
  util.inherits(assert.AssertionError, Error);
  function replacer(key, value) {
    if (value === void 0) {
      return `${value}`;
    }
    if (typeof value === "number" && (isNaN(value) || !isFinite(value))) {
      return value.toString();
    }
    if (typeof value === "function" || value instanceof RegExp) {
      return value.toString();
    }
    return value;
  }
  function truncate(s3, n3) {
    if (typeof s3 == "string") {
      return s3.length < n3 ? s3 : s3.slice(0, n3);
    }
    return s3;
  }
  assert.AssertionError.prototype.toString = function() {
    if (this.message) {
      return [`${this.name}:`, this.message].join(" ");
    }
    return [
      `${this.name}:`,
      truncate(JSON.stringify(this.actual, replacer), 128),
      this.operator,
      truncate(JSON.stringify(this.expected, replacer), 128)
    ].join(" ");
  };
  function fail(actual, expected, message, operator, stackStartFunction) {
    throw new assert.AssertionError({
      message,
      actual,
      expected,
      operator,
      stackStartFunction
    });
  }
  assert.fail = fail;
  function ok(value, message) {
    if (!value)
      fail(value, true, message, "==", assert.ok);
  }
  assert.ok = ok;
  assert.equal = function equal(actual, expected, message) {
    if (actual != expected)
      fail(actual, expected, message, "==", assert.equal);
  };
  assert.notEqual = function notEqual(actual, expected, message) {
    if (actual == expected) {
      fail(actual, expected, message, "!=", assert.notEqual);
    }
  };
  assert.deepEqual = function deepEqual(actual, expected, message) {
    if (!_deepEqual(actual, expected)) {
      fail(actual, expected, message, "deepEqual", assert.deepEqual);
    }
  };
  function _deepEqual(actual, expected) {
    if (actual === expected) {
      return true;
    } else if (actual instanceof Date && expected instanceof Date) {
      return actual.getTime() === expected.getTime();
    } else if (actual instanceof RegExp && expected instanceof RegExp) {
      return actual.source === expected.source && actual.global === expected.global && actual.multiline === expected.multiline && actual.lastIndex === expected.lastIndex && actual.ignoreCase === expected.ignoreCase;
    } else if (typeof actual != "object" && typeof expected != "object") {
      return actual == expected;
    }
    return objEquiv(actual, expected);
  }
  function isUndefinedOrNull(value) {
    return value === null || value === void 0;
  }
  function isArguments(object) {
    return Object.prototype.toString.call(object) == "[object Arguments]";
  }
  function objEquiv(a3, b2) {
    if (isUndefinedOrNull(a3) || isUndefinedOrNull(b2))
      return false;
    if (a3.prototype !== b2.prototype)
      return false;
    if (isArguments(a3)) {
      if (!isArguments(b2)) {
        return false;
      }
      a3 = pSlice.call(a3);
      b2 = pSlice.call(b2);
      return _deepEqual(a3, b2);
    }
    try {
      var ka = Object_keys(a3), kb = Object_keys(b2), key, i3;
    } catch (e5) {
      return false;
    }
    if (ka.length != kb.length)
      return false;
    ka.sort();
    kb.sort();
    for (i3 = ka.length - 1; i3 >= 0; i3--) {
      if (ka[i3] != kb[i3])
        return false;
    }
    for (i3 = ka.length - 1; i3 >= 0; i3--) {
      key = ka[i3];
      if (!_deepEqual(a3[key], b2[key]))
        return false;
    }
    return true;
  }
  assert.notDeepEqual = function notDeepEqual(actual, expected, message) {
    if (_deepEqual(actual, expected)) {
      fail(actual, expected, message, "notDeepEqual", assert.notDeepEqual);
    }
  };
  assert.strictEqual = function strictEqual(actual, expected, message) {
    if (actual !== expected) {
      fail(actual, expected, message, "===", assert.strictEqual);
    }
  };
  assert.notStrictEqual = function notStrictEqual(actual, expected, message) {
    if (actual === expected) {
      fail(actual, expected, message, "!==", assert.notStrictEqual);
    }
  };
  function expectedException(actual, expected) {
    if (!actual || !expected) {
      return false;
    }
    if (Object.prototype.toString.call(expected) == "[object RegExp]") {
      return expected.test(actual);
    } else if (actual instanceof expected) {
      return true;
    } else if (expected.call({}, actual) === true) {
      return true;
    }
    return false;
  }
  function _throws(shouldThrow, block, expected, message) {
    let actual;
    if (typeof expected === "string") {
      message = expected;
      expected = null;
    }
    try {
      block();
    } catch (e5) {
      actual = e5;
    }
    message = (expected && expected.name ? ` (${expected.name}).` : ".") + (message ? ` ${message}` : ".");
    if (shouldThrow && !actual) {
      fail(actual, expected, `Missing expected exception${message}`);
    }
    if (!shouldThrow && expectedException(actual, expected)) {
      fail(actual, expected, `Got unwanted exception${message}`);
    }
    if (shouldThrow && actual && expected && !expectedException(actual, expected) || !shouldThrow && actual) {
      throw actual;
    }
  }
  assert.throws = function(block, error, message) {
    _throws.apply(this, [true].concat(pSlice.call(arguments)));
  };
  assert.doesNotThrow = function(block, message) {
    _throws.apply(this, [false].concat(pSlice.call(arguments)));
  };
  assert.ifError = function(err) {
    if (err) {
      throw err;
    }
  };
  var assert_default = assert;

  // src/util/eventemitter.js
  var EventEmitter = {};
  var stopPropagation = function() {
    this.propagationStopped = true;
  };
  var preventDefault = function() {
    this.defaultPrevented = true;
  };
  EventEmitter._emit = EventEmitter._dispatchEvent = function(eventName, e5) {
    this._eventRegistry || (this._eventRegistry = {});
    this._defaultHandlers || (this._defaultHandlers = {});
    let listeners = this._eventRegistry[eventName] || [];
    let defaultHandler = this._defaultHandlers[eventName];
    if (!listeners.length && !defaultHandler)
      return;
    if (typeof e5 != "object" || !e5)
      e5 = {};
    if (!e5.type)
      e5.type = eventName;
    if (!e5.stopPropagation)
      e5.stopPropagation = stopPropagation;
    if (!e5.preventDefault)
      e5.preventDefault = preventDefault;
    if (!e5.target)
      e5.target = this;
    for (let i3 = 0; i3 < listeners.length; i3++) {
      listeners[i3](e5);
      if (e5.propagationStopped)
        break;
    }
    if (defaultHandler && !e5.defaultPrevented)
      return defaultHandler(e5);
  };
  EventEmitter._signal = function(eventName, e5) {
    let listeners = (this._eventRegistry || {})[eventName];
    if (!listeners)
      return;
    for (let i3 = 0; i3 < listeners.length; i3++)
      listeners[i3](e5);
  };
  EventEmitter.once = function(eventName, callback) {
    let _self = this;
    var newCallback = function() {
      callback && callback.apply(null, arguments);
      _self.removeEventListener(event, newCallback);
    };
    this.addEventListener(event, newCallback);
  };
  EventEmitter.setDefaultHandler = function(eventName, callback) {
    this._defaultHandlers = this._defaultHandlers || {};
    if (this._defaultHandlers[eventName])
      throw new Error(`The default handler for '${eventName}' is already set`);
    this._defaultHandlers[eventName] = callback;
  };
  EventEmitter.on = EventEmitter.addEventListener = function(eventName, callback, capturing) {
    this._eventRegistry = this._eventRegistry || {};
    let listeners = this._eventRegistry[eventName];
    if (!listeners)
      listeners = this._eventRegistry[eventName] = [];
    if (listeners.indexOf(callback) == -1)
      listeners[capturing ? "unshift" : "push"](callback);
    return callback;
  };
  EventEmitter.removeListener = EventEmitter.removeEventListener = function(eventName, callback) {
    this._eventRegistry = this._eventRegistry || {};
    let listeners = this._eventRegistry[eventName];
    if (!listeners)
      return;
    let index2 = listeners.indexOf(callback);
    if (index2 !== -1)
      listeners.splice(index2, 1);
  };
  EventEmitter.removeAllListeners = function(eventName) {
    if (this._eventRegistry)
      this._eventRegistry[eventName] = [];
  };
  var _EventEmitter = EventEmitter;

  // src/util/oop.js
  var inherits = function() {
    let tempCtor = function() {
    };
    return function(ctor, superCtor) {
      tempCtor.prototype = superCtor.prototype;
      ctor.super_ = superCtor.prototype;
      ctor.prototype = new tempCtor();
      ctor.prototype.constructor = ctor;
    };
  }();
  var _mixin = function(obj, mixin2) {
    for (let key in mixin2) {
      obj[key] = mixin2[key];
    }
  };
  function implement(proto, mixin2) {
    _mixin(proto, mixin2);
  }

  // src/util/uuid.js
  function UUID() {
    let s3 = [];
    let hexDigits = "0123456789abcdef";
    for (let i3 = 0; i3 < 36; i3++) {
      s3[i3] = hexDigits.substr(Math.floor(Math.random() * 16), 1);
    }
    s3[14] = "4";
    s3[19] = hexDigits.substr(s3[19] & 3 | 8, 1);
    s3[8] = s3[13] = s3[18] = s3[23] = "-";
    let uuid = s3.join("");
    return uuid;
  }

  // src/model/attributedstring.js
  init_objectutils();

  // src/model/attributerun.js
  init_objectutils();
  var AttributeRun = class {
    constructor(location, length, attributes) {
      this.location = location;
      this.length = length;
      this.attributes = attributes;
    }
    copy() {
      return new AttributeRun(this.location, this.length, shallowClone(this.attributes));
    }
    splitAtIndex(index2) {
      let location = this.location, length = this.length, end = location + length;
      let newAttributeRun = new AttributeRun(index2, location + length - index2, index2 === end ? {} : shallowClone(this.attributes));
      this.length = index2 - location;
      return newAttributeRun;
    }
    toString() {
      let attributes = this.attributes, sortedNames = [], nameValues = [], each, name106, i3;
      for (each in this.attributes) {
        sortedNames.push(each);
      }
      sortedNames.sort();
      let length = sortedNames.length;
      for (i3 = 0; i3 < length; i3++) {
        name106 = sortedNames[i3];
        nameValues.push(`${name106}="${attributes[name106]}"`);
      }
      return `${this.location},${this.length}/${nameValues.join("/")}`;
    }
    _mergeWithNext(attributeRun) {
      if (this.location + this.length === attributeRun.location) {
        if (shallowEquals(this.attributes, attributeRun.attributes)) {
          this.length += attributeRun.length;
          return true;
        }
      }
      return false;
    }
  };
  var _AttributeRun = AttributeRun;

  // src/model/attributedstring.js
  var { debug } = environment_default;
  var { ok: ok2 } = assert_default;
  var AttributedString = class {
    constructor(string2) {
      if (string2 === void 0) {
        string2 = "";
      }
      this._clean = false;
      this._string = string2;
      this._pendingAddAttributes = [];
      this._cmStyleArray = null;
    }
    copy() {
      this._ensureClean();
      let theCopy = new AttributedString(this._string), attributeRuns = this.attributeRuns();
      if (attributeRuns) {
        let attributeRunsCopy = [], length = attributeRuns.length;
        for (let i3 = 0; i3 < length; i3++) {
          attributeRunsCopy.push(attributeRuns[i3].copy());
        }
        theCopy._attributeRuns = attributeRunsCopy;
      }
      return theCopy;
    }
    string() {
      return this._string;
    }
    replaceCharactersInRange(location, length, insertedString) {
      this._validateAttributeRuns();
      let attributeRuns = this.attributeRuns(), maxReplacedRange = location + length, string2 = this._string;
      if (attributeRuns) {
        let updateFromIndex, startingIndex, endingIndex;
        if (length === 0) {
          if (location === 0) {
            startingIndex = 0;
          } else {
            startingIndex = this._indexOfAttributeRunWithCharacterIndex(location > 0 ? location - 1 : location);
          }
          endingIndex = startingIndex;
        } else {
          startingIndex = this._indexOfAttributeRunWithCharacterIndex(location);
          endingIndex = this._indexOfAttributeRunWithCharacterIndex(Math.max(maxReplacedRange - 1, 0));
        }
        let startingAttributeRun = attributeRuns[startingIndex], endingAttributeRun = attributeRuns[endingIndex], additionalLength = insertedString.length - length;
        if (startingIndex === endingIndex) {
          startingAttributeRun.length += additionalLength;
          if (startingAttributeRun.length === 0 && attributeRuns.length > 1) {
            attributeRuns.splice(startingIndex, 1);
            updateFromIndex = startingIndex;
          } else {
            updateFromIndex = startingIndex + 1;
          }
        } else {
          let maxInsertedRange = location + insertedString.length;
          startingAttributeRun.length = maxInsertedRange - startingAttributeRun.location;
          endingAttributeRun.length += endingAttributeRun.location - maxReplacedRange;
          endingAttributeRun.location = maxInsertedRange;
          let startingRemoveIndex = startingIndex + 1, removeLength = endingIndex - startingRemoveIndex;
          if (startingAttributeRun.length === 0) {
            startingRemoveIndex--;
            removeLength++;
          }
          if (endingAttributeRun.length === 0) {
            removeLength++;
            updateFromIndex = startingRemoveIndex;
          } else {
            updateFromIndex = startingRemoveIndex + 1;
          }
          if (removeLength > 0) {
            attributeRuns.splice(startingRemoveIndex, removeLength);
            if (attributeRuns.length === 0) {
              attributeRuns.push(startingAttributeRun);
              startingAttributeRun.attributes = {};
              updateFromIndex = 1;
            }
          }
        }
        if (additionalLength !== 0) {
          while (updateFromIndex < attributeRuns.length) {
            attributeRuns[updateFromIndex++].location += additionalLength;
          }
        }
      }
      this._string = string2.substring(0, location) + insertedString + string2.substring(maxReplacedRange);
      this._clean = false;
      this._cmStyleArray = null;
      this._validateAttributeRuns();
    }
    attributeRuns() {
      let runs = this._attributeRuns, pendingAddAttributes = this._pendingAddAttributes;
      if (!runs) {
        runs = [new _AttributeRun(0, this._string.length, {})];
        this._attributeRuns = runs;
      }
      let length = pendingAddAttributes.length;
      if (length) {
        this._pendingAddAttributes = [];
        let eachPending;
        for (let i3 = 0; i3 < length; i3++) {
          eachPending = pendingAddAttributes[i3];
          this._addAttributeInRange(eachPending.attribute, eachPending.value, eachPending.location, eachPending.length);
        }
      }
      return runs;
    }
    attributesAtIndex(index2, effectiveRange, longestEffectiveRange) {
      this._ensureClean();
      let runIndex = this._indexOfAttributeRunWithCharacterIndex(index2);
      if (runIndex === -1) {
        return null;
      }
      let attributeRun = this.attributeRuns()[runIndex];
      if (effectiveRange) {
        effectiveRange.location = attributeRun.location;
        effectiveRange.length = attributeRun.length;
      }
      if (longestEffectiveRange) {
        let attributes = attributeRun.attributes;
        this._longestEffectiveRange(runIndex, attributeRun, longestEffectiveRange, (candiateRun) => {
          return shallowEquals(candiateRun.attributes, attributes);
        });
      }
      return attributeRun.attributes;
    }
    attributeAtIndex(attribute, index2, effectiveRange, longestEffectiveRange) {
      this._ensureClean();
      let runIndex = this._indexOfAttributeRunWithCharacterIndex(index2);
      if (runIndex === -1) {
        return null;
      }
      let attributeRun = this.attributeRuns()[runIndex];
      if (effectiveRange) {
        effectiveRange.location = attributeRun.location;
        effectiveRange.length = attributeRun.length;
      }
      if (longestEffectiveRange) {
        let comparisonAttribute = attributeRun.attributes[attribute];
        this._longestEffectiveRange(runIndex, attributeRun, longestEffectiveRange, (candiateRun) => {
          return candiateRun.attributes[attribute] === comparisonAttribute;
        });
      }
      return attributeRun.attributes[attribute];
    }
    findAttributeValue(attribute, start2) {
      let runs = this.attributeRuns(), runIndex = !start2 ? 0 : this._indexOfAttributeRunWithCharacterIndex(start2), runCount = runs.length;
      for (; runIndex < runCount; runIndex++) {
        let runAttributes = runs[runIndex].attributes;
        if (runAttributes[attribute]) {
          return runAttributes[attribute];
        }
      }
    }
    attributeRangeCalculatedByFunction(index2, shouldExtendRangeToIncludeRun) {
      this._ensureClean();
      let runIndex = this._indexOfAttributeRunWithCharacterIndex(index2);
      if (runIndex === -1) {
        return null;
      }
      let longestEffectiveRange = { location: index2, length: 0 }, attributeRun = this.attributeRuns()[runIndex];
      if (shouldExtendRangeToIncludeRun(attributeRun)) {
        this._longestEffectiveRange(runIndex, attributeRun, longestEffectiveRange, shouldExtendRangeToIncludeRun);
      }
      return longestEffectiveRange;
    }
    _longestEffectiveRange(runIndex, attributeRun, longestEffectiveRange, shouldExtendRunToInclude) {
      let attributeRuns = this.attributeRuns(), length = attributeRuns.length, nextRun, nextIndex = runIndex - 1, currentRun = attributeRun;
      while (nextIndex >= 0) {
        nextRun = attributeRuns[nextIndex];
        if (shouldExtendRunToInclude(nextRun)) {
          currentRun = nextRun;
          nextIndex--;
        } else {
          break;
        }
      }
      longestEffectiveRange.location = currentRun.location;
      nextIndex = runIndex + 1;
      currentRun = attributeRun;
      while (nextIndex < length) {
        nextRun = attributeRuns[nextIndex];
        if (shouldExtendRunToInclude(nextRun)) {
          currentRun = nextRun;
          nextIndex++;
        } else {
          break;
        }
      }
      longestEffectiveRange.length = currentRun.location + currentRun.length - longestEffectiveRange.location;
    }
    _addAttributeInRange(attribute, value, location, length) {
      if (length === 0) {
        return;
      }
      let attributeRuns = this.attributeRuns(), startRunIndex = this._indexOfAttributeRunForCharacterIndex(location), endRunIndex = this._indexOfAttributeRunForCharacterIndex(location + length), i3 = startRunIndex;
      if (endRunIndex === -1) {
        endRunIndex = attributeRuns.length;
      }
      while (i3 < endRunIndex) {
        attributeRuns[i3].attributes[attribute] = value;
        i3++;
      }
      this._clean = false;
      this._cmStyleArray = null;
    }
    addAttributeInRange(attribute, value, location, length) {
      if (length === 0) {
        return;
      }
      this._pendingAddAttributes.push({
        attribute,
        value,
        location,
        length
      });
      this._clean = false;
      this._cmStyleArray = null;
    }
    hasAttributes() {
      return this._attributeRuns || this._pendingAddAttributes && this._pendingAddAttributes.length > 0;
    }
    removeAttributeInRange(attribute, location, length) {
      if (length === 0 || !this.hasAttributes()) {
        return false;
      }
      return this.removeAttributesInRange([attribute], location, length);
    }
    removeAttributesInRange(attributes, location, length) {
      if (length === 0 || !this.hasAttributes()) {
        return false;
      }
      let didRemove = false, attributeRuns = this.attributeRuns(), startRunIndex = location === void 0 ? 0 : this._indexOfAttributeRunForCharacterIndex(location), endRunIndex = location === void 0 ? -1 : this._indexOfAttributeRunForCharacterIndex(location + length), attributesLength = attributes.length, i3 = startRunIndex, j3;
      if (endRunIndex === -1) {
        endRunIndex = attributeRuns.length;
      }
      while (i3 < endRunIndex) {
        let attributeRunAttributes = attributeRuns[i3].attributes;
        for (j3 = 0; j3 < attributesLength; j3++) {
          let attribute = attributes[j3];
          if (attributeRunAttributes[attribute] !== void 0) {
            delete attributeRunAttributes[attribute];
            didRemove = true;
          }
        }
        i3++;
      }
      if (didRemove) {
        this._clean = false;
        this._cmStyleArray = null;
      }
      return didRemove;
    }
    cacheKeyForRange(location, length) {
      let key = "", string2 = this.string(), attributeRuns = this.attributeRuns(), start2 = this._indexOfAttributeRunForCharacterIndex(location), end = this._indexOfAttributeRunForCharacterIndex(location + length - 1), eachRun, eachAttributes, eachName, i3;
      for (i3 = start2; i3 <= end; i3++) {
        eachRun = attributeRuns[i3];
        key += string2.substr(eachRun.location, eachRun.length);
        eachAttributes = eachRun.attributes;
        for (eachName in eachAttributes) {
          if (Object.prototype.hasOwnProperty.call(eachAttributes, eachName)) {
            key += eachName;
          }
        }
      }
      return key;
    }
    _ensureClean() {
      if (this._clean) {
        return;
      }
      let attributeRuns = this.attributeRuns(), length = attributeRuns.length, previousAttributeRun = attributeRuns[0], attributeRun;
      for (let i3 = 1; i3 < length; i3++) {
        attributeRun = attributeRuns[i3];
        if (previousAttributeRun._mergeWithNext(attributeRun)) {
          attributeRuns.splice(i3, 1);
          length--;
        } else {
          previousAttributeRun = attributeRun;
        }
      }
      this._clean = true;
    }
    toCodeMirrorStyleArray(generateStartAndEndMarkers) {
      this._ensureClean();
      let cmStyleArray = this._cmStyleArray;
      if (!cmStyleArray) {
        let attributeRuns = this.attributeRuns(), length = attributeRuns.length, prevRun, nextRun, attributeRun, attributes, attributeNames, eachAttributeName;
        cmStyleArray = [];
        for (let i3 = 0; i3 < length; i3++) {
          attributeRun = attributeRuns[i3];
          if (attributeRun.length > 0) {
            prevRun = attributeRuns[i3 - 1];
            nextRun = attributeRuns[i3 + 1];
            attributeNames = [];
            attributes = attributeRun.attributes;
            for (eachAttributeName in attributes) {
              if (attributes[eachAttributeName] !== void 0) {
                if (generateStartAndEndMarkers && (!prevRun || prevRun.attributes[eachAttributeName] === void 0)) {
                  attributeNames.push(`${eachAttributeName}-start`);
                }
                attributeNames.push(eachAttributeName);
                if (generateStartAndEndMarkers && (!nextRun || nextRun.attributes[eachAttributeName] === void 0)) {
                  attributeNames.push(`${eachAttributeName}-end`);
                }
              }
            }
            cmStyleArray.push(attributeRun.location + attributeRun.length);
            cmStyleArray.push(attributeNames.join(" "));
          }
        }
        this._cmStyleArray = cmStyleArray;
      }
      return cmStyleArray;
    }
    _attributeRunsHash() {
      let attributeRuns = this.attributeRuns(), length = attributeRuns.length, attributeRun, hash = 0;
      for (let i3 = 0; i3 < length; i3++) {
        attributeRun = attributeRuns[i3];
        hash = (hash << 5) - hash + attributeRun.location;
        hash = (hash << 5) - hash + attributeRun.length;
      }
    }
    toJson() {
      this._ensureClean();
      const { _string: rawText } = this;
      if (rawText.length === 0) {
        return {
          rawText,
          attributeRuns: []
        };
      }
      const attributeRuns = this.attributeRuns();
      const ignoredNames = new Set(["text"]);
      const runsJson = attributeRuns.map((attributeRun) => {
        const { attributes } = attributeRun;
        const runJson = [];
        const attributeNames = Object.keys(attributes).sort();
        const attributeJsons = [];
        for (const name106 of attributeNames) {
          if (!ignoredNames.has(name106))
            attributeJsons.push({ name: name106, value: attributes[name106] });
        }
        runJson.push({
          text: rawText.substr(attributeRun.location, attributeRun.length),
          attributes: attributeJsons
        });
        return runJson;
      }).flat();
      const result = {
        rawText,
        attributeRuns: runsJson
      };
      return result;
    }
    toString(showAttributeValues) {
      this._ensureClean();
      let string2 = this._string, attributeRuns = this.attributeRuns(), length = attributeRuns.length, results = [];
      for (let i3 = 0; i3 < length; i3++) {
        let eachRun = attributeRuns[i3], eachRunAttributes = eachRun.attributes;
        let sortedNames = [];
        for (let each in eachRunAttributes) {
          if (eachRunAttributes[each] !== void 0) {
            sortedNames.push(each);
          }
        }
        sortedNames.sort();
        let nameValues = [], sortedNamesLength = sortedNames.length;
        for (let j3 = 0; j3 < sortedNamesLength; j3++) {
          let name106 = sortedNames[j3];
          if (showAttributeValues) {
            nameValues.push(`${name106}="${eachRunAttributes[name106]}"`);
          } else {
            nameValues.push(name106);
          }
        }
        results.push(`${string2.substr(eachRun.location, eachRun.length)}/${nameValues.join(", ")}`);
      }
      return `(${results.join(")(")})`;
    }
    _indexOfAttributeRunWithCharacterIndex(characterIndex) {
      if (characterIndex < 0 || characterIndex >= this._string.length) {
        return -1;
      }
      let attributeRuns = this.attributeRuns(), low = 0, high = attributeRuns.length - 1, i3, run, location, length, end, result = -1;
      while (low <= high) {
        i3 = low + high >> 1;
        run = attributeRuns[i3];
        location = run.location;
        length = run.length;
        end = location + length;
        if (characterIndex >= location && characterIndex < end) {
          result = i3;
          break;
        } else if (end <= characterIndex) {
          low = i3 + 1;
          continue;
        } else {
          high = i3 - 1;
          continue;
        }
      }
      return result;
    }
    _indexOfAttributeRunForCharacterIndex(characterIndex) {
      let runIndex = this._indexOfAttributeRunWithCharacterIndex(characterIndex);
      if (runIndex === -1) {
        return -1;
      }
      let attributeRuns = this.attributeRuns(), attributeRun = attributeRuns[runIndex], location = attributeRun.location;
      if (location === characterIndex) {
        return runIndex;
      }
      let newAttributeRun = attributeRun.splitAtIndex(characterIndex);
      attributeRuns.splice(runIndex + 1, 0, newAttributeRun);
      return runIndex + 1;
    }
    _validateAttributeRuns() {
      if (debug) {
        let attributeRuns = this.attributeRuns();
        if (attributeRuns) {
          let length = attributeRuns.length;
          if (length) {
            let offset = 0;
            for (let i3 = 0; i3 < length; i3++) {
              let each = attributeRuns[i3];
              if (length > 1) {
                ok2(each.length > 0, "Attribute Run Empty");
              }
              ok2(each.location === offset, "Attribute Run Invalid Location");
              offset += each.length;
            }
            ok2(offset === this._string.length, "Attribute Run Invalid Location");
          } else {
            ok2(false, "Empty Attribute Runs");
          }
        }
      }
    }
  };
  var _AttributedString = AttributedString;

  // src/model/nodepath.js
  var import_lodash = __toModule(require_lodash());

  // src/util/cache.js
  var CachePriority = {
    Low: 1,
    Normal: 2,
    High: 4
  };
  function Cache(maxSize) {
    this.items = {};
    this.count = 0;
    if (maxSize == null)
      maxSize = -1;
    this.maxSize = maxSize;
    this.fillFactor = 0.75;
    this.purgeSize = Math.round(this.maxSize * this.fillFactor);
    this.stats = {};
    this.stats.hits = 0;
    this.stats.misses = 0;
  }
  Cache.prototype.getItem = function(key) {
    let item = this.items[key];
    if (item != null) {
      if (!this._isExpired(item)) {
        item.lastAccessed = new Date().getTime();
      } else {
        this._removeItem(key);
        item = null;
      }
    }
    let returnVal = null;
    if (item != null) {
      returnVal = item.value;
      this.stats.hits++;
    } else {
      this.stats.misses++;
    }
    return returnVal;
  };
  Cache.prototype.setItem = function(key, value, options) {
    function CacheItem(k3, v3, o3) {
      if (k3 == null || k3 == "")
        throw new Error("key cannot be null or empty");
      this.key = k3;
      this.value = v3;
      if (o3 == null)
        o3 = {};
      if (o3.expirationAbsolute != null)
        o3.expirationAbsolute = o3.expirationAbsolute.getTime();
      if (o3.priority == null)
        o3.priority = CachePriority.Normal;
      this.options = o3;
      this.lastAccessed = new Date().getTime();
    }
    if (this.items[key] != null)
      this._removeItem(key);
    this._addItem(new CacheItem(key, value, options));
    if (this.maxSize > 0 && this.count > this.maxSize) {
      this._purge();
    }
  };
  Cache.prototype.clear = function() {
    for (let key in this.items) {
      this._removeItem(key);
    }
  };
  Cache.prototype._purge = function() {
    let tmparray = new Array();
    for (let key in this.items) {
      let item = this.items[key];
      if (this._isExpired(item)) {
        this._removeItem(key);
      } else {
        tmparray.push(item);
      }
    }
    if (tmparray.length > this.purgeSize) {
      tmparray = tmparray.sort((a3, b2) => {
        if (a3.options.priority != b2.options.priority) {
          return b2.options.priority - a3.options.priority;
        }
        return b2.lastAccessed - a3.lastAccessed;
      });
      while (tmparray.length > this.purgeSize) {
        let ritem = tmparray.pop();
        this._removeItem(ritem.key);
      }
    }
  };
  Cache.prototype._addItem = function(item) {
    this.items[item.key] = item;
    this.count++;
  };
  Cache.prototype._removeItem = function(key) {
    let item = this.items[key];
    delete this.items[key];
    this.count--;
    if (item.options.callback != null) {
      let callback = function() {
        item.options.callback(item.key, item.value);
      };
      setTimeout(callback, 0);
    }
  };
  Cache.prototype._isExpired = function(item) {
    let now = new Date().getTime();
    let expired = false;
    if (item.options.expirationAbsolute && item.options.expirationAbsolute < now) {
      expired = true;
    }
    if (!expired && item.options.expirationSliding) {
      let lastAccess = item.lastAccessed + item.options.expirationSliding * 1e3;
      if (lastAccess < now) {
        expired = true;
      }
    }
    return expired;
  };
  Cache.prototype.toHtmlString = function() {
    let returnStr = `${this.count} item(s) in cache<br /><ul>`;
    for (let key in this.items) {
      let item = this.items[key];
      returnStr = `${returnStr}<li>${item.key.toString()} = ${item.value.toString()}</li>`;
    }
    returnStr = `${returnStr}</ul>`;
    return returnStr;
  };

  // src/model/nodepath.js
  var import_nodepathparser = __toModule(require_nodepathparser());
  array_default();
  var NodePath = class {
    constructor(nodePathString, types) {
      this.types = types;
      this.nodePath = NodePath.parse(nodePathString, void 0, types).parsedPath;
      this.nodePathString = nodePathString;
    }
    isShowAllPath() {
      return this.nodePathString === NodePath.SHOW_ALL_PATH;
    }
    evaluate(currentNode) {
      if (this.nodePath === void 0) {
        return [];
      }
      return this._evaluateNodePath(this.nodePath, currentNode);
    }
    _evaluateNodePath(nodePath2, currentNode) {
      let union = nodePath2.union, intersect = nodePath2.intersect, except = nodePath2.except, results;
      if (union) {
        results = this._evaluateUnion(union, currentNode);
      } else if (intersect) {
        results = this._evaluateIntersect(intersect, currentNode);
      } else if (except) {
        results = this._evaluateExcept(except, currentNode);
      } else {
        results = this._evaluatePath(nodePath2, currentNode);
      }
      this._sliceResultsFrom(nodePath2.slice, results, 0);
      return results;
    }
    _unionTreeOrderedResults(results1, results2, tree) {
      let r1Index = -1, r2Index = -1, results = [], i3 = 0, j3 = 0, r1, r22;
      let forever = true;
      while (forever) {
        r1 = results1[i3];
        r22 = results2[j3];
        if (!r1) {
          if (r22) {
            results.push(...results2.slice(j3));
          }
          return results;
        } else if (!r22) {
          if (r1) {
            results.push(...results1.slice(i3));
          }
          return results;
        } else if (r1 === r22) {
          results.push(r22);
          r1Index = -1;
          r2Index = -1;
          i3++;
          j3++;
        } else {
          r1Index = r1Index === -1 ? tree.nodeToLineNumber(r1) : r1Index;
          r2Index = r2Index === -1 ? tree.nodeToLineNumber(r22) : r2Index;
          if (r1Index < r2Index) {
            results.push(r1);
            r1Index = -1;
            i3++;
          } else {
            results.push(r22);
            r2Index = -1;
            j3++;
          }
        }
      }
    }
    _evaluateUnion(paths, currentNode) {
      let results1 = this._evaluateNodePath(paths[0], currentNode), results2 = this._evaluateNodePath(paths[1], currentNode);
      return this._unionTreeOrderedResults(results1, results2, currentNode.tree);
    }
    _evaluateIntersect(paths, currentNode) {
      let results1 = this._evaluateNodePath(paths[0], currentNode), results2 = this._evaluateNodePath(paths[1], currentNode), r1Index = -1, r2Index = -1, tree = currentNode.tree, results = [], i3 = 0, j3 = 0, r1, r22;
      let forever = true;
      while (forever) {
        r1 = results1[i3];
        r22 = results2[j3];
        if (!r1) {
          return results;
        } else if (!r22) {
          return results;
        } else if (r1 === r22) {
          results.push(r22);
          r1Index = -1;
          r2Index = -1;
          i3++;
          j3++;
        } else {
          r1Index = r1Index === -1 ? tree.nodeToLineNumber(r1) : r1Index;
          r2Index = r2Index === -1 ? tree.nodeToLineNumber(r22) : r2Index;
          if (r1Index < r2Index) {
            r1Index = -1;
            i3++;
          } else {
            r2Index = -1;
            j3++;
          }
        }
      }
    }
    _evaluateExcept(paths, currentNode) {
      let results1 = this._evaluateNodePath(paths[0], currentNode), results2 = this._evaluateNodePath(paths[1], currentNode), r1Index = -1, r2Index = -1, tree = currentNode.tree, results = [], i3 = 0, j3 = 0, r1, r22;
      let forever = true;
      while (forever) {
        r1 = results1[i3];
        r22 = results2[j3];
        r1Index = r1Index === -1 ? tree.nodeToLineNumber(r1) : r1Index;
        r2Index = r2Index === -1 ? tree.nodeToLineNumber(r22) : r2Index;
        while (r22 && r1Index > r2Index) {
          j3++;
          r22 = results2[j3];
          r2Index = tree.nodeToLineNumber(r22);
        }
        if (!r1) {
          return results;
        } else if (!r22) {
          results.push(...results1.slice(i3));
          return results;
        } else if (r1 === r22) {
          r1Index = -1;
          r2Index = -1;
          i3++;
          j3++;
        } else {
          results.push(r1);
          r1Index = -1;
          i3++;
        }
      }
    }
    _evaluatePath(path, currentNode) {
      let tree = currentNode.tree, absolute = path.absolute, contexts = [], eachContext, contextsLength, results = null, i3, j3;
      if (absolute) {
        currentNode = currentNode.root();
      }
      contexts.push(currentNode);
      let steps = path.steps, stepsLength = steps.length, step;
      for (i3 = 0; i3 < stepsLength; i3++) {
        step = steps[i3];
        contextsLength = contexts.length;
        results = [];
        for (j3 = 0; j3 < contextsLength; j3++) {
          eachContext = contexts[j3];
          if (results.length) {
            let contextResults = [];
            this._evaluateStep(step, eachContext, contextResults);
            results = this._unionTreeOrderedResults(results, contextResults, tree);
          } else {
            this._evaluateStep(step, eachContext, results);
          }
        }
        contexts = results;
      }
      return results;
    }
    _evaluateStep(step, currentNode, results) {
      let predicate = step.predicate, type = step.type, from = results.length, each, end;
      switch (step.axis) {
        case "ancestor-or-self":
          each = currentNode;
          while (each) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.splice(from, 0, each);
            }
            each = each.parent;
          }
          break;
        case "ancestor":
          each = currentNode.parent;
          while (each) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.splice(from, 0, each);
            }
            each = each.parent;
          }
          break;
        case "child":
          each = currentNode.firstChild;
          while (each) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.push(each);
            }
            each = each.nextSibling;
          }
          break;
        case "descendant-or-self":
          end = currentNode.nextBranch();
          each = currentNode;
          while (each && each !== end) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.push(each);
            }
            each = each.nextLineNode();
          }
          break;
        case "descendant":
          end = currentNode.nextBranch();
          each = currentNode.firstChild;
          while (each && each !== end) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.push(each);
            }
            each = each.nextLineNode();
          }
          break;
        case "filter-descendants": {
          end = currentNode.nextBranch();
          each = currentNode.firstChild;
          const originalFrom = from;
          while (each && each !== end) {
            if (this._evaluatePredicate(type, predicate, each)) {
              let eachAncestor = each.parent;
              while (eachAncestor !== currentNode && results.indexOf(eachAncestor) === -1) {
                results.splice(from, 0, eachAncestor);
                eachAncestor = eachAncestor.parent;
              }
              results.push(each);
              from = results.length;
            }
            each = each.nextLineNode();
          }
          results.splice(originalFrom, 0, currentNode);
          break;
        }
        case "following-sibling":
          each = currentNode.nextSibling;
          while (each) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.push(each);
            }
            each = each.nextSibling;
          }
          break;
        case "following":
          each = currentNode.nextLineNode();
          while (each) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.push(each);
            }
            each = each.nextLineNode();
          }
          break;
        case "parent":
          each = currentNode.parent;
          if (each && this._evaluatePredicate(type, predicate, each)) {
            results.push(each);
          }
          break;
        case "preceding-sibling":
          each = currentNode.previousSibling;
          while (each) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.splice(from, 0, each);
            }
            each = each.previousSibling;
          }
          break;
        case "preceding":
          each = currentNode.previousLineNode();
          while (each) {
            if (this._evaluatePredicate(type, predicate, each)) {
              results.splice(from, 0, each);
            }
            each = each.previousLineNode();
          }
          break;
        case "self":
          if (this._evaluatePredicate(type, predicate, currentNode)) {
            results.push(currentNode);
          }
          break;
      }
      this._sliceResultsFrom(step.slice, results, from);
    }
    _evaluatePredicate(type, predicate, currentNode) {
      if (type !== "*" && type !== currentNode.type()) {
        return false;
      }
      if (predicate === "*") {
        return true;
      }
      let and2 = predicate.and;
      if (and2) {
        return this._evaluatePredicate("*", and2[0], currentNode) && this._evaluatePredicate("*", and2[1], currentNode);
      }
      let or2 = predicate.or;
      if (or2) {
        return this._evaluatePredicate("*", or2[0], currentNode) || this._evaluatePredicate("*", or2[1], currentNode);
      }
      let not2 = predicate.not;
      if (not2) {
        return !this._evaluatePredicate("*", not2, currentNode);
      }
      let attributePath = predicate.attributePath, relation = predicate.relation, modifier = predicate.modifier, value = predicate.value;
      if (!attributePath) {
        attributePath = NodePath.DEFAULT_ATTRIBUTE_PATH;
      }
      if (!relation && !value) {
        return currentNode.valueForAttributePath(attributePath) !== void 0;
      }
      if (!relation) {
        relation = NodePath.DEFAULT_RELATIOIN;
      }
      if (!modifier) {
        modifier = NodePath.DEFAULT_MODIFIER;
      }
      let predicateValueCache = predicate.predicateValueCache;
      if (!predicateValueCache) {
        predicateValueCache = this._convertValueForModifier(value, modifier);
        predicate.predicateValueCache = predicateValueCache;
      }
      let attributeValue = currentNode.valueForAttributePath(attributePath);
      if (attributeValue !== void 0) {
        attributeValue = this._convertValueForModifier(attributeValue.toString(), modifier);
      }
      return this._evaluateRelation(attributeValue, relation, predicateValueCache, predicate);
    }
    _convertValueForModifier(value, modifier) {
      if (modifier === "i") {
        return value.toLowerCase();
      } else if (modifier === "n") {
        return parseFloat(value);
      } else if (modifier === "d") {
        return Date.parse(value);
      }
      return value;
    }
    _evaluateRelation(left, relation, right, predicate) {
      switch (relation) {
        case "=":
          return left === right;
        case "!=":
          return left !== right;
        case "<":
          return left < right;
        case ">":
          return left > right;
        case "<=":
          return left <= right;
        case ">=":
          return left >= right;
        case "beginswith":
          if (!left) {
            return false;
          }
          return left.startsWith(right);
        case "contains":
          if (!left) {
            return false;
          }
          return left.indexOf(right) !== -1;
        case "endswith":
          if (!left) {
            return false;
          }
          return left.endsWith(right);
        case "matches": {
          if (!left) {
            return false;
          }
          let joinedValueRegexCache = predicate.joinedValueRegexCache;
          if (joinedValueRegexCache === void 0) {
            try {
              joinedValueRegexCache = new RegExp(right.toString());
            } catch (e5) {
              joinedValueRegexCache = null;
            }
            predicate.joinedValueRegexCache = joinedValueRegexCache;
          }
          if (joinedValueRegexCache) {
            return left.toString().match(joinedValueRegexCache);
          }
          return false;
        }
      }
    }
    _sliceResultsFrom(slice, results, from) {
      if (slice) {
        let length = results.length - from, start2 = slice.start, end = slice.end;
        if (length === 0) {
          return;
        }
        if (end > length) {
          end = length;
        }
        if (start2 !== 0 || end !== length) {
          let sliced;
          if (start2 < 0) {
            start2 += length;
            if (start2 < 0) {
              start2 = 0;
            }
          }
          if (start2 > length - 1) {
            start2 = length - 1;
          }
          if (end === null) {
            sliced = results[from + start2];
          } else {
            if (end < 0) {
              end += length;
            }
            if (end < start2) {
              end = start2;
            }
            sliced = results.slice(from).slice(start2, end);
          }
          Array.prototype.splice.apply(results, [from, results.length - from].concat(sliced));
        }
      }
    }
    _leftmostNodePath(nodePath2) {
      if (nodePath2.union) {
        return this._leftmostNodePath(nodePath2.union[0]);
      } else if (nodePath2.intersect) {
        return this._leftmostNodePath(nodePath2.intersect[0]);
      } else if (nodePath2.except) {
        return this._leftmostNodePath(nodePath2.except[0]);
      }
      return nodePath2;
    }
    locationPathString(minusLastPathStep) {
      let leftMosNodePath = this._leftmostNodePath(this.nodePath), path = (0, import_lodash.default)(leftMosNodePath), steps = path.steps, length = steps.length, locationSteps = [], each, i3;
      for (i3 = 0; i3 < length; i3++) {
        each = steps[i3];
        if (each.axis === "filter-descendants") {
          break;
        }
        locationSteps.push(each);
      }
      if (minusLastPathStep) {
        locationSteps.pop();
      }
      if (locationSteps.length === 0) {
        return "";
      }
      path.steps = locationSteps;
      return this._pathToString(path);
    }
    setLocationPathString(newLocationPathString) {
      let oldLocationPathString = this.locationPathString(), newNodePathString = newLocationPathString + this.toString().substr(oldLocationPathString.length);
      this.nodePath = NodePath.parse(newNodePathString).parsedPath;
      this.nodePathString = newNodePathString;
      return this;
    }
    filterStepString() {
      let leftMosNodePath = this._leftmostNodePath(this.nodePath), steps = leftMosNodePath.steps, length = steps.length, each, i3;
      for (i3 = 0; i3 < length; i3++) {
        each = steps[i3];
        if (each.axis === "filter-descendants") {
          return this._stepToString(each).substr(2);
        }
      }
      return "";
    }
    setFilterStepString(filterStepString) {
      let newNodePathString = this.locationPathString();
      if (filterStepString) {
        newNodePathString += `///${filterStepString}`;
      }
      this.nodePath = NodePath.parse(newNodePathString).parsedPath;
      this.nodePathString = newNodePathString;
      return this;
    }
    updateNodePathByFocusingOutOneLevel() {
      let filterStepString = this.filterStepString();
      if (filterStepString !== "*") {
        this.setFilterStepString("*");
      } else {
        let locationPathString = this.locationPathString(true);
        if (!locationPathString) {
          locationPathString = "";
        }
        this.setLocationPathString(locationPathString);
      }
      return this;
    }
    _predicateToString(predicate, group) {
      if (predicate === "*") {
        return "*";
      }
      let openGroup = group ? "(" : "", closeGroup = group ? ")" : "";
      let and2 = predicate.and;
      if (and2) {
        return `${openGroup + this._predicateToString(and2[0], true)} and ${this._predicateToString(and2[1], true)}${closeGroup}`;
      }
      let or2 = predicate.or;
      if (or2) {
        return `${openGroup + this._predicateToString(or2[0], true)} or ${this._predicateToString(or2[1], true)}${closeGroup}`;
      }
      let not2 = predicate.not;
      if (not2) {
        return `not ${this._predicateToString(not2, true)}`;
      }
      let attributePath = predicate.attributePath, relation = predicate.relation, modifier = predicate.modifier, value = predicate.value, result = [];
      if (attributePath) {
        result.push(`@${attributePath.join(":")}`);
      }
      if (relation) {
        result.push(relation);
      }
      if (modifier) {
        result.push(`[${modifier}]`);
      }
      if (value) {
        try {
          (0, import_nodepathparser.parse)(value, { startRule: "Value" });
        } catch (e5) {
          value = `"${value}"`;
        }
        result.push(value);
      }
      return result.join(" ");
    }
    _stepToString(step) {
      switch (step.axis) {
        case "child":
          return this._predicateToString(step.predicate);
        case "descendant":
          return `/${this._predicateToString(step.predicate)}`;
        case "filter-descendants":
          return `//${this._predicateToString(step.predicate)}`;
        case "parent":
          return `..${this._predicateToString(step.predicate)}`;
        default:
          return `${step.axis}::${this._predicateToString(step.predicate)}`;
      }
    }
    _pathToString(path) {
      let stepStrings = [], steps = path.steps, stepsLength = steps.length, i3;
      for (i3 = 0; i3 < stepsLength; i3++) {
        stepStrings.push(this._stepToString(steps[i3]));
      }
      if (path.absolute) {
        return `/${stepStrings.join("/")}`;
      }
      return stepStrings.join("/");
    }
    _nodePathToString(nodePath2, group) {
      let openGroup = group ? "(" : "", closeGroup = group ? ")" : "";
      let union = nodePath2.union;
      if (union) {
        return `${openGroup + this._nodePathToString(union[0], true)} union ${this._nodePathToString(union[1], true)}${closeGroup}`;
      }
      let intersect = nodePath2.intersect;
      if (intersect) {
        return `${openGroup + this._nodePathToString(intersect[0], true)} intersect ${this._nodePathToString(intersect[1], true)}${closeGroup}`;
      }
      let except = nodePath2.except;
      if (except) {
        return `${openGroup + this._nodePathToString(except[0], true)} except ${this._nodePathToString(except[1], true)}${closeGroup}`;
      }
      return this._pathToString(nodePath2);
    }
    toString() {
      return this._nodePathToString(this.nodePath);
    }
    static parse(path, startRule, types) {
      if (!startRule) {
        startRule = "NodePathExpression";
      }
      let cache = NodePath._cache, key = path + startRule;
      if (types) {
        for (let each in types) {
          key += each;
        }
      }
      let result = cache.getItem(key);
      if (!result) {
        let exception = null, keywords2 = [], parsedPath;
        try {
          parsedPath = (0, import_nodepathparser.parse)(path, {
            startRule,
            types
          });
        } catch (e5) {
          exception = e5;
        }
        if (parsedPath) {
          keywords2 = parsedPath.keywords;
          keywords2.sort(keywordCompare);
          keywords2.sortedUniquify(keywordCompare);
        }
        result = {
          parsedPath,
          error: exception,
          keywords: keywords2
        };
        cache.setItem(key, result);
      }
      return result;
    }
    static evaluate(nodePath2, currentNode) {
      let isString2 = typeof nodePath2 === "string" || nodePath2 instanceof String;
      if (isString2) {
        nodePath2 = new NodePath(nodePath2, currentNode.tree.taxonomy.types());
      }
      return nodePath2.evaluate(currentNode);
    }
    static calculateMinNodePath(node, includeDescendants) {
      let nodes = [];
      while (node) {
        nodes.push(node);
        node = node.parent;
      }
      nodes = nodes.reverse();
      let pathSegments = [], length = nodes.length, previousParent = nodes[0], i3;
      for (i3 = 1; i3 < length; i3++) {
        const targetChild = nodes[i3];
        const targetChildText = targetChild.text();
        const targetChildTextLength = targetChildText.length;
        let candidateSegment;
        if (targetChildTextLength === 0) {
          candidateSegment = `@id = ${targetChild.id}`;
        } else {
          let candidateSegmentLength = Math.min(4, targetChildTextLength), matches = Number.MAX_VALUE;
          while (candidateSegmentLength <= targetChildTextLength && matches > 1) {
            candidateSegment = targetChildText.substr(0, candidateSegmentLength).toLowerCase().replace(/^\s+|\s+$/g, "");
            matches = 0;
            let each = previousParent.firstChild;
            while (each) {
              if (each.text().toLowerCase().indexOf(candidateSegment) !== -1) {
                matches++;
              }
              each = each.nextSibling;
            }
            candidateSegmentLength++;
          }
          if (matches > 1) {
            candidateSegment = `@id = ${targetChild.id}`;
          } else {
            candidateSegment = candidateSegment.replace(/"/g, '\\"');
            try {
              (0, import_nodepathparser.parse)(candidateSegment, { startRule: "Value" });
            } catch (e5) {
              candidateSegment = `"${candidateSegment}"`;
            }
          }
        }
        pathSegments.push(candidateSegment);
        previousParent = targetChild;
      }
      let result = `/${pathSegments.join("/")}`;
      if (includeDescendants) {
        result += "///*";
      }
      return result;
    }
    static syntaxHighlight(attributedString, startRule, range2) {
      if (!startRule) {
        startRule = "NodePathExpression";
      }
      if (!range2) {
        range2 = { location: 0, length: attributedString.string().length };
      }
      if (range2.length === 0) {
        return attributedString;
      }
      let rangeString = attributedString.string().substr(range2.location, range2.length), results = NodePath.parse(rangeString, startRule), keywords2 = results.keywords, length = keywords2.length, error = results.error, i3;
      for (i3 = 0; i3 < length; i3++) {
        let each = keywords2[i3], label = each.label, offset = each.offset, text = each.text;
        attributedString.addAttributeInRange(label, text, range2.location + offset.start.offset, text.length);
      }
      if (error) {
        let errorOffset = error.offset.start.offset, errorLength = range2.length - errorOffset;
        if (errorLength > 0) {
          let errorString = attributedString.string().substr(errorOffset + range2.location, errorLength);
          attributedString.addAttributeInRange("invalid", errorString, errorOffset + range2.location, errorLength);
        }
      }
      return attributedString;
    }
  };
  NodePath._cache = new Cache(3);
  function keywordCompare(a3, b2) {
    let aOffset = a3.offset, bOffset = b2.offset;
    if (aOffset !== bOffset) {
      return aOffset - bOffset;
    }
    if (a3.text.length !== b2.text.length) {
      return a3.text.length - b2.text.length;
    }
    if (a3.label !== b2.label) {
      if (a3 < b2) {
        return -1;
      }
      return 1;
    }
    return 0;
  }
  NodePath.SHOW_ALL_PATH = "///*";
  NodePath.DEFAULT_ATTRIBUTE_PATH = ["line", "text"];
  NodePath.DEFAULT_RELATIOIN = "contains";
  NodePath.DEFAULT_MODIFIER = "i";

  // src/model/nodeset.js
  init_objectutils();
  var NodeSet = class {
    constructor(nodeSet) {
      this._idsToNodes = {};
      this.count = 0;
      if (nodeSet) {
        this.unionSet(nodeSet);
      }
    }
    copy() {
      return new NodeSet(this);
    }
    nodeForID(id) {
      return this._idsToNodes[id];
    }
    anyNode() {
      if (this.count === 0) {
        return void 0;
      }
      let idsToNodes = this._idsToNodes, key;
      for (key in idsToNodes) {
        let node = idsToNodes[key];
        if (node) {
          return node;
        }
      }
      return void 0;
    }
    containsNode(node) {
      if (this._idsToNodes[node.id]) {
        return true;
      }
      return false;
    }
    containsNodeForID(id) {
      if (this._idsToNodes[id]) {
        return true;
      }
      return false;
    }
    containsNodes(nodes) {
      let length = nodes.length, i3;
      for (i3 = 0; i3 < length; i3++) {
        if (!this.containsNode(nodes[i3])) {
          return false;
        }
      }
      return true;
    }
    addNode(node) {
      let map3 = this._idsToNodes, id = node.id;
      if (!map3[id]) {
        map3[id] = node;
        this.count++;
      }
    }
    addNodeIgnoringNull(node) {
      if (node) {
        this.addNode(node);
      }
    }
    addNodesFromArray(nodes) {
      let length = nodes.length, i3;
      for (i3 = 0; i3 < length; i3++) {
        this.addNode(nodes[i3]);
      }
    }
    removeNode(node) {
      let map3 = this._idsToNodes, id = node.id;
      if (map3[id]) {
        map3[id] = void 0;
        this.count--;
      }
    }
    removeNodeIgnoringNull(node) {
      if (node) {
        this.removeNode(node);
      }
    }
    removeNodesFromArray(nodes) {
      let length = nodes.length, i3;
      for (i3 = 0; i3 < length; i3++) {
        this.removeNode(nodes[i3]);
      }
    }
    removeAllNodes() {
      this._idsToNodes = {};
      this.count = 0;
    }
    equalsSet(nodeSet) {
      if (this.count !== nodeSet.count) {
        return false;
      }
      let thisIdsToNodes = this._idsToNodes, thatIdsToNodes = nodeSet._idsToNodes, key;
      for (key in thatIdsToNodes) {
        if (thatIdsToNodes[key] !== thisIdsToNodes[key]) {
          return false;
        }
      }
      for (key in thisIdsToNodes) {
        if (thisIdsToNodes[key] !== thatIdsToNodes[key]) {
          return false;
        }
      }
      return true;
    }
    unionSet(nodeSet) {
      if (!nodeSet) {
        return;
      }
      let thisIdsToNodes = this._idsToNodes, thatIdsToNodes = nodeSet._idsToNodes;
      for (let key in thatIdsToNodes) {
        if (thatIdsToNodes[key] && !thisIdsToNodes[key]) {
          thisIdsToNodes[key] = thatIdsToNodes[key];
          this.count++;
        }
      }
      return this;
    }
    minusSet(nodeSet) {
      let thisIdsToNodes = this._idsToNodes, thatIdsToNodes = nodeSet._idsToNodes;
      for (let key in thatIdsToNodes) {
        if (thatIdsToNodes[key] && thisIdsToNodes[key]) {
          thisIdsToNodes[key] = void 0;
          this.count--;
        }
      }
      return this;
    }
    intersectSet(nodeSet) {
      let thisIdsToNodes = this._idsToNodes, thatIdsToNodes = nodeSet._idsToNodes, intersectionIDsToNodes = {}, count = 0, key;
      for (key in thatIdsToNodes) {
        if (thatIdsToNodes[key]) {
          let each = thisIdsToNodes[key];
          if (each) {
            intersectionIDsToNodes[key] = each;
            count++;
          }
        }
      }
      this._idsToNodes = intersectionIDsToNodes;
      this.count = count;
      return this;
    }
    forEachNodeInSet(callback) {
      let idsToNodes = this._idsToNodes, each, key;
      for (key in idsToNodes) {
        each = idsToNodes[key];
        if (each) {
          callback(each);
        }
      }
    }
    nodesInLineOrder() {
      let count = this.count, anyNode = this.anyNode(), tree = anyNode ? anyNode.tree : null, idsToNodes;
      if (count === 1) {
        return [anyNode];
      } else if (tree) {
        let results = [], each;
        idsToNodes = this._idsToNodes;
        if (count < tree.nodeCount() / 10) {
          let nodeToLineNumberNumberTable = {}, key;
          for (key in idsToNodes) {
            each = idsToNodes[key];
            if (each) {
              results.push(each);
              nodeToLineNumberNumberTable[each.id] = tree.nodeToLineNumber(each);
            }
          }
          let _lineOrderSorter = function(a3, b2) {
            return nodeToLineNumberNumberTable[a3.id] - nodeToLineNumberNumberTable[b2.id];
          };
          results = results.sort(_lineOrderSorter);
        } else {
          each = tree.root.firstChild;
          while (each) {
            if (idsToNodes[each.id]) {
              results.push(each);
            }
            each = each.nextLineNode();
          }
        }
        return results;
      }
      return [];
    }
    nodesInReverseLineOrder() {
      return this.nodesInLineOrder().reverse();
    }
    nodesInLevelAscendingOrder() {
      let levelAscendingSorter = function(a3, b2) {
        return b2.level - a3.level;
      };
      return arrayOfValues(this._idsToNodes).sort(levelAscendingSorter);
    }
    toIDArray() {
      let idsToNodes = this._idsToNodes, ids = [], id;
      for (id in idsToNodes) {
        ids.push(id);
      }
      return ids;
    }
    toString() {
      let ids = [], nodes = this.nodesInLineOrder(), length = nodes.length;
      for (let i3 = 0; i3 < length; i3++) {
        ids.push(nodes[i3].id);
      }
      return `[${ids.join(", ")}]`;
    }
    static unionSets(nodeSet1, nodeSet2) {
      let result = new NodeSet();
      result.unionSet(nodeSet1);
      result.unionSet(nodeSet2);
      return result;
    }
    static minusSets(nodeSet1, nodeSet2) {
      let result = nodeSet1.copy();
      result.minusSet(nodeSet2);
      return result;
    }
    static intersectSets(nodeSet1, nodeSet2) {
      let result = nodeSet1.copy();
      result.intersectSet(nodeSet2);
      return result;
    }
    static setFromArray(nodes) {
      let result = new NodeSet(), length = nodes.length;
      for (let i3 = 0; i3 < length; i3++) {
        result.addNode(nodes[i3]);
      }
      return result;
    }
    static setFromNode(node) {
      let result = new NodeSet();
      result.addNode(node);
      return result;
    }
  };
  NodeSet.EmptySet = new NodeSet();

  // src/model/redblack-node.js
  var RedBlackNode = class {
    constructor(line = "", tree) {
      this._text = line;
      this.tree = tree;
      this._RBParent = null;
      this._RBLeft = null;
      this._RBRight = null;
      this._RBColor = RedBlackNode.BLACK;
      this._RBTotalLineCount = 1;
      this._RBTotalLength = line.length + 1;
      this._lineAttributedString = new _AttributedString(line);
    }
    _RBHasChildren() {
      return this._RBLeft !== null || this._RBRight !== null;
    }
    _RBIsLeftChild() {
      let _RBParent = this._RBParent;
      return _RBParent !== null && _RBParent._RBLeft === this;
    }
    _RBIsRightChild() {
      let _RBParent = this._RBParent;
      return _RBParent !== null && _RBParent._RBRight === this;
    }
    _RBChildPredecessor() {
      if (!this._RBLeft) {
        return null;
      }
      return this._RBLeft._RBRightMost();
    }
    _RBChildSuccessor() {
      if (!this._RBRight) {
        return null;
      }
      return this._RBRight._RBLeftMost();
    }
    _RBNextLineNode() {
      let node = this, childSuccessor = node._RBChildSuccessor();
      if (childSuccessor) {
        return childSuccessor;
      }
      let parent = node._RBParent;
      while (parent && node === parent._RBRight) {
        node = parent;
        parent = node._RBParent;
      }
      if (parent && !parent.parent) {
        return null;
      }
      return parent;
    }
    _RBPreviousLineNode() {
      let node = this, childPredecessor = node._RBChildPredecessor();
      if (childPredecessor) {
        return childPredecessor;
      }
      let parent = node._RBParent;
      while (parent && node === parent._RBLeft) {
        node = parent;
        parent = node._RBParent;
      }
      return parent;
    }
    _RBDepth() {
      let parent = this._RBParent, depth = 0;
      while (parent) {
        parent = parent._RBParent;
        depth++;
      }
      return depth;
    }
    _RBRightMost() {
      let _RBRight = this;
      let r3;
      while (r3 = _RBRight._RBRight) {
        _RBRight = r3;
      }
      return _RBRight;
    }
    _RBLeftMost() {
      let _RBLeft = this;
      let l3;
      while (l3 = _RBLeft._RBLeft) {
        _RBLeft = l3;
      }
      return _RBLeft;
    }
    _RBSetLeft(child) {
      if (child) {
        child._RBParent = this;
        this._RBLeft = child;
      } else {
        this._RBLeft = null;
      }
    }
    _RBSetRight(child) {
      if (child) {
        child._RBParent = this;
        this._RBRight = child;
      } else {
        this._RBRight = null;
      }
    }
    _RBFillCache() {
      let totalLineCount = this._RBTotalLineCount;
      if (!totalLineCount) {
        let left = this._RBLeft, right = this._RBRight, totalLength = this.line().length + 1;
        totalLineCount = 1;
        if (left) {
          totalLineCount += left.totalLineCount();
          totalLength += left.totalLength();
        }
        if (right) {
          totalLineCount += right.totalLineCount();
          totalLength += right.totalLength();
        }
        this._RBTotalLineCount = totalLineCount;
        this._RBTotalLength = totalLength;
      }
    }
    _RBClearCache() {
      let each = this;
      while (each && each._RBTotalLength !== null) {
        each._RBTotalLength = null;
        each._RBTotalLineCount = null;
        each = each._RBParent;
      }
      return;
    }
    _RBLeftRotate(tree) {
      let y2 = this._RBRight;
      this._RBRight = y2._RBLeft;
      if (y2._RBLeft) {
        y2._RBLeft._RBParent = this;
      }
      y2._RBParent = this._RBParent;
      if (!this._RBParent) {
        tree._RBRoot = y2;
      } else if (this._RBIsLeftChild()) {
        this._RBParent._RBLeft = y2;
      } else {
        this._RBParent._RBRight = y2;
      }
      y2._RBLeft = this;
      this._RBParent = y2;
      y2._RBClearCache();
      this._RBClearCache();
    }
    _RBRightRotate(tree) {
      let y2 = this._RBLeft;
      this._RBLeft = y2._RBRight;
      if (y2._RBRight) {
        y2._RBRight._RBParent = this;
      }
      y2._RBParent = this._RBParent;
      if (!this._RBParent) {
        tree._RBRoot = y2;
      } else if (this._RBIsRightChild()) {
        this._RBParent._RBRight = y2;
      } else {
        this._RBParent._RBLeft = y2;
      }
      y2._RBRight = this;
      this._RBParent = y2;
      y2._RBClearCache();
      this._RBClearCache();
    }
    line() {
      return this._lineAttributedString.string();
    }
    totalLineCount() {
      let result = this._RBTotalLineCount;
      if (!result) {
        this._RBFillCache();
        return this._RBTotalLineCount;
      }
      return result;
    }
    totalLength() {
      let result = this._RBTotalLength;
      if (!result) {
        this._RBFillCache();
        return this._RBTotalLength;
      }
      return result;
    }
    toString(rbTree) {
      if (rbTree) {
        let leftRight = this._RBIsLeftChild() ? "< " : "> ", depth = this._RBDepth(), depthString = "";
        for (let i3 = 0; i3 < depth; i3++) {
          depthString += "| ";
        }
        return `${depthString + leftRight + this.line().replace(/(^[\s]+|[\s]+$)/g, "")} [${this.id}] {len: ${this.totalLength()} cnt: ${this.totalLineCount()}}`;
      }
      return `{node "${this._lineAttributedString.toString()}" }`;
    }
    branchToString(depth) {
      let each = this.firstChild, depthString = "", lines = [], i3;
      for (i3 = 0; i3 < depth - 1; i3++) {
        depthString += "\u2507";
      }
      lines.push(`${depthString}\u2520${each ? "\u2530" : " "}${this.line().replace(/\t/g, "\u25B8").replace(/\n/g, "\\n") || "\u2205"} [${this.id}, ${this.type()}]`);
      while (each) {
        lines.push(each.branchToString(depth + 1));
        each = each.nextSibling;
      }
      return lines.join("\n");
    }
    branchToJson() {
      const result = {
        id: this.id,
        text: this.line(),
        type: this.type(),
        attributedText: this._lineAttributedString.toJson(),
        children: []
      };
      for (let each = this.firstChild; each != null; each = each.nextSibling) {
        result.children.push(each.branchToJson());
      }
      return result;
    }
    static _RBColorOrBlack(nodeOrNull) {
      return nodeOrNull ? nodeOrNull._RBColor : this.BLACK;
    }
    static get BLACK() {
      return 0;
    }
    static get RED() {
      return 1;
    }
  };
  var redblack_node_default = RedBlackNode;

  // src/model/node.js
  var { ok: ok3 } = assert_default;
  var Node = class extends redblack_node_default {
    constructor(line = "", tree) {
      super(line, tree);
      this.tree = tree;
      this.id = tree._nextNodeID();
      this.isTracked = false;
      this.parent = null;
      this.firstChild = null;
      this.lastChild = null;
      this.previousSibling = null;
      this.nextSibling = null;
      this._userData = null;
      this._type = void 0;
      this._typeLevel = 0;
      this._typeIndentLevel = 0;
      this._structureLevel = 0;
      this._text = line;
      this._textStart = 0;
      this._mode = void 0;
      this._modeContext = void 0;
      this._tags = {};
      this._metadata = {};
      this._trackedRanges = void 0;
      this._reclassifiedRegion = false;
      this._taxonomyState = null;
      this._lineAttributedString = new _AttributedString(line);
      this._renderMarks = [];
      this._links = [];
    }
    type() {
      return this._type;
    }
    setType(type) {
      return this._setTaxonomyCalculatedProperty("_type", "setType", type, (node) => {
        node._typeLevel = node.tree.taxonomy.typeLevelForType(node._type);
        node._typeIndentLevel = node.validatedTypeIndentLevel(0);
        node._structureLevel = node._typeLevel + node._typeIndentLevel;
      });
    }
    typeLevel() {
      return this._typeLevel;
    }
    typeIndentLevel() {
      return this._typeIndentLevel;
    }
    validatedTypeIndentLevel(typeIndentLevel) {
      return this.tree.taxonomy.validatedTypeIndentLevel(this, typeIndentLevel);
    }
    setTypeIndentLevel(typeIndentLevel) {
      return this._setTaxonomyCalculatedProperty("_typeIndentLevel", "setTypeIndentLevel", typeIndentLevel, (node) => {
        node._structureLevel = node._typeLevel + node._typeIndentLevel;
      });
    }
    setBranchTypeIndentLevel(typeIndentLevel) {
      typeIndentLevel = this.tree.taxonomy.validatedTypeIndentLevel(this, typeIndentLevel);
      let oldLevel = this.typeIndentLevel(), delta = typeIndentLevel - oldLevel;
      if (delta !== 0) {
        let tree = this.tree, isTracked = this.isTracked;
        if (isTracked) {
          tree.beginUpdates();
        }
        let children = [], typeLevel = this._typeLevel, child = this.firstChild;
        while (child) {
          if (child._typeLevel === typeLevel) {
            children.push(child);
          }
          child = child.nextSibling;
        }
        typeIndentLevel = this.setTypeIndentLevel(typeIndentLevel);
        delta = typeIndentLevel - oldLevel;
        if (delta !== 0) {
          let length = children.length;
          for (let i3 = 0; i3 < length; i3++) {
            child = children[i3];
            child.setBranchTypeIndentLevel(child.typeIndentLevel() + delta);
          }
        }
        if (isTracked) {
          tree.endUpdates();
        }
      }
    }
    validatedBranchTypeIndentLevel(requestedTypeIndentLevel) {
      let possibleTypeIndentLevel = this.tree.taxonomy.validatedTypeIndentLevel(this, requestedTypeIndentLevel), oldLevel = this.typeIndentLevel(), delta = possibleTypeIndentLevel - oldLevel;
      if (delta !== 0) {
        let typeLevel = this.typeLevel(), child = this.firstChild;
        while (child) {
          if (child.typeLevel() === typeLevel) {
            let childRequestedTypeIndentLevel = child.typeIndentLevel() + delta, childPossibleTypeIndentLevel = child.validatedBranchTypeIndentLevel(childRequestedTypeIndentLevel);
            if (childRequestedTypeIndentLevel !== childPossibleTypeIndentLevel) {
              return oldLevel;
            }
          }
          child = child.nextSibling;
        }
      }
      return possibleTypeIndentLevel;
    }
    structureLevel() {
      return this._structureLevel;
    }
    mode() {
      return this._mode;
    }
    setMode(mode2) {
      return this._setTaxonomyCalculatedProperty("_mode", "setMode", mode2, (node) => {
        node._modeContext = node._mode;
      });
    }
    modeContext() {
      return this._modeContext;
    }
    userData(key) {
      let record = this._userData;
      if (!record) {
        record = {};
        this._userData = record;
      }
      return record[key];
    }
    setUserData(key, value) {
      let record = this._userData, isTracked = this.isTracked, tree = this.tree;
      if (!record) {
        record = {};
        this._userData = record;
      }
      if (isTracked) {
        tree.beginUpdates();
      }
      record[key] = value;
      if (isTracked) {
        this.changed();
        tree.endUpdates();
      }
    }
    _setTaxonomyCalculatedProperty(name106, setter, value, onSet) {
      let tree = this.tree, oldValue = this[name106], isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
      }
      let newValue = tree.taxonomy[setter](this, value);
      if (oldValue !== newValue) {
        let oldStructureLevel = this._structureLevel;
        this[name106] = newValue;
        if (onSet) {
          onSet(this, newValue);
        }
        if (isTracked) {
          if (oldStructureLevel !== this._structureLevel) {
            let nextLineNode = this.nextLineNode();
            tree.removeNode(this);
            tree.insertNodeBefore(this, nextLineNode);
          }
        }
      }
      if (isTracked) {
        tree.endUpdates();
      }
      return newValue;
    }
    changed() {
      if (this.isTracked) {
        let tree = this.tree;
        tree.beginUpdates();
        tree._nodeLineWasUpdated(this);
        tree.endUpdates();
      }
    }
    tags() {
      return this._tags;
    }
    tag(tagName) {
      return this.tags()[tagName];
    }
    hasTag(tagName) {
      return this.tags()[tagName] !== void 0;
    }
    addTag(tagName, tagValue) {
      if (this.tree.readOnly)
        return;
      let tree = this.tree, isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
      }
      if (tree.taxonomy.addTag(this, tagName, tagValue)) {
        this._tags[tagName] = tagValue;
      }
      if (isTracked) {
        tree.endUpdates();
      }
    }
    removeTag(tagName) {
      if (this.tree.readOnly)
        return;
      let tree = this.tree, isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
      }
      if (tree.taxonomy.removeTag(this, tagName)) {
        delete this._tags[tagName];
      }
      if (isTracked) {
        tree.endUpdates();
      }
    }
    metadata() {
      return this._metadata;
    }
    links() {
      return this._links;
    }
    propertyNode(propertyName, createIfNeeded) {
      let normalizedPropertyName = propertyName.toLowerCase(), each = this.firstChild;
      while (each && each.type() === "property") {
        if (each.tag("name") === normalizedPropertyName) {
          return each;
        }
        each = each.nextSibling;
      }
      if (createIfNeeded) {
        return this.addPropertyNode(propertyName, "");
      }
      return null;
    }
    addPropertyNode(propertyName, propertyValue) {
      if (this.tree.readOnly)
        return;
      let property = this.tree.createNode(`${propertyName} : ${propertyValue}`), each = this.firstChild;
      while (each && each.type() === "property") {
        each = each.nextSibling;
      }
      this.insertChildBefore(property, each);
      return property;
    }
    removePropertyNode(propertyName) {
      if (this.tree.readOnly)
        return;
      propertyName = propertyName.toLowerCase();
      let each = this.firstChild;
      while (each && each.type() === "property") {
        if (each.tag("name") === propertyName) {
          each.removeFromParent();
          return;
        }
        each = each.nextSibling;
      }
    }
    setPropertyNodeValue(propertyName, propertyValue) {
      if (this.tree.readOnly)
        return;
      this.tree.taxonomy.setPropertyNodeValue(this.propertyNode(propertyName, true), propertyValue);
    }
    _valueForPropertyPath(propertyPath, pathIndex) {
      let each = this.firstChild, end = propertyPath.length - 1, eachTags;
      while (each && each.type() === "property") {
        eachTags = each.tags();
        if (eachTags.name === propertyPath[pathIndex]) {
          if (pathIndex === end) {
            return eachTags.value;
          }
          let result = each._valueForPropertyPath(propertyPath, pathIndex + 1);
          if (result !== void 0) {
            return result;
          }
        }
        each = each.nextSibling;
      }
      return void 0;
    }
    _valueForLineAttributesPath(lineAttributesPath) {
      let attributePathLength = lineAttributesPath.length;
      if (attributePathLength === 2 && lineAttributesPath[1] === "text") {
        return this.text();
      }
      let attributeRuns = this._lineAttributedString.attributeRuns(), length = attributeRuns.length, i3;
      for (i3 = 0; i3 < length; i3++) {
        const attributeRun = attributeRuns[i3];
        const attributes = attributeRun.attributes;
        let matchedAll = true;
        for (let j3 = 1; j3 < attributePathLength; j3++) {
          if (attributes[lineAttributesPath[j3]] === void 0) {
            matchedAll = false;
            break;
          }
        }
        if (matchedAll) {
          return attributes[lineAttributesPath.lastObject()];
        }
      }
      return void 0;
    }
    valueForAttributePath(attributePath) {
      let attributeName = attributePath[0];
      switch (attributeName) {
        case "id":
          return this.id;
        case "type":
          return this.type();
        case "mode":
          return this.mode();
        case "modeContext":
          return this.modeContext();
        case "index":
          return this.indexToSelf();
        case "line":
          if (attributePath.length === 1)
            return this.line();
          return this._valueForLineAttributesPath(attributePath);
        case "property":
          return this._valueForPropertyPath(attributePath, 1);
        default:
          return this.tag(attributeName);
      }
    }
    text() {
      return this._text;
    }
    textStart() {
      return this._textStart;
    }
    textWithoutSyntax() {
      return this.tree.taxonomy.stripInlineSyntax(this._text);
    }
    setText(text) {
      if (this.tree.readOnly)
        return;
      return this._setTaxonomyCalculatedProperty("_text", "setText", text);
    }
    line() {
      return this._lineAttributedString.string();
    }
    lineInRange(location, length) {
      let line = this.line();
      if (length === line.length + 1) {
        return `${line}
`;
      }
      return line.substr(location, length);
    }
    setLine(line) {
      if (this.tree.readOnly)
        return;
      this.replaceLineInRange(line, 0, this.line().length);
    }
    replaceLineInRange(insertedText, location, length) {
      ok3(insertedText.indexOf("\n") === -1, "Node line cannot contain newlines");
      if (this.tree.readOnly)
        return;
      let attributedString = this._lineAttributedString, oldLine = this.line(), oldLineLength = oldLine.length, replacedText, rangeEnd;
      if (location !== null) {
        rangeEnd = location + length;
        replacedText = oldLine.substr(location, length);
      } else {
        location = 0;
        length = oldLineLength;
        rangeEnd = location + length;
        replacedText = oldLine;
      }
      let tree = this.tree, isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
      }
      attributedString.replaceCharactersInRange(location, length, insertedText);
      let trackedRanges = this._trackedRanges;
      if (trackedRanges) {
        for (let i3 = 0; i3 < trackedRanges.length; i3++) {
          let eachRange = trackedRanges[i3];
          if (eachRange.startNode === this) {
            let startOffset = eachRange.startOffset;
            if (startOffset >= rangeEnd) {
              startOffset += insertedText.length - replacedText.length;
            } else if (startOffset > location) {
              startOffset = location;
            }
            eachRange.startOffset = startOffset;
          }
          if (eachRange.endNode === this) {
            let endOffset = eachRange.endOffset;
            if (endOffset >= rangeEnd) {
              endOffset += insertedText.length - replacedText.length;
            } else if (endOffset > location) {
              endOffset = location;
            }
            eachRange.endOffset = endOffset;
          }
        }
      }
      this._RBClearCache();
      if (isTracked) {
        tree._nodeLineWasUpdated(this, location, replacedText, insertedText);
        tree.endUpdates();
      }
    }
    _hasChangedFromTaxonomyState(newState) {
      return this._type !== newState.type || this._typeLevel !== newState.typeLevel || this._typeIndentLevel !== newState.typeIndentLevel || this._text !== newState.text || this._textStart !== newState.textStart;
    }
    _updateFromTaxonomyState(newState) {
      let tree = this.tree, isTracked = this.isTracked, oldStructureLevel = this._structureLevel, oldType = this._type;
      this._taxonomyState = newState;
      this._type = newState.type;
      this._typeLevel = newState.typeLevel;
      this._typeIndentLevel = newState.typeIndentLevel;
      this._structureLevel = this._typeLevel + this._typeIndentLevel;
      this._text = newState.text;
      this._textStart = newState.textStart;
      this._tags = newState.tags;
      this._metadata = newState.metadata;
      this._links = newState.links;
      this._mode = void 0;
      this._modeContext = void 0;
      let modeStack = newState.modeStack;
      if (modeStack) {
        let modeRecord = modeStack.lastObject();
        if (modeRecord) {
          this._modeContext = modeRecord.mode;
          if (modeRecord.node === this) {
            this._mode = modeRecord.mode;
          }
        }
      }
      if (isTracked) {
        let structureLevelChanged = oldStructureLevel !== this._structureLevel;
        if (structureLevelChanged) {
          let nextLineNode = this.nextLineNode();
          tree.beginUpdates();
          tree.removeNode(this);
          tree.insertNodeBefore(this, nextLineNode);
          tree.endUpdates();
        } else {
          if (oldType === "property" || this._type === "property") {
            let nonPropertyAncestor = this.parent.nonPropertyAncestorOrSelf();
            if (nonPropertyAncestor && !nonPropertyAncestor.isRoot()) {
              nonPropertyAncestor.changed();
            }
          }
          this.changed();
        }
      }
    }
    lineNumber() {
      return this.tree.nodeToLineNumber(this);
    }
    lineTextStart() {
      return this.tree.nodeOffsetToTextOffset(this, 0);
    }
    lineAttributedString() {
      return this._lineAttributedString;
    }
    lineAttributeAtIndex(attribute, index2, effectiveRange, longestEffectiveRange) {
      return this._lineAttributedString.attributeAtIndex(attribute, index2, effectiveRange, longestEffectiveRange);
    }
    lineAttributesAtIndex(index2, effectiveRange, longestEffectiveRange) {
      return this._lineAttributedString.attributesAtIndex(index2, effectiveRange, longestEffectiveRange);
    }
    addLineAttributeInRange(attribute, value, location, length) {
      let isTracked = this.isTracked;
      this._lineAttributedString.addAttributeInRange(attribute, value, location, length);
      if (isTracked) {
        this.changed();
      }
    }
    removeLineAttributeInRange(attribute, location, length) {
      this.removeLineAttributesInRange([attribute], location, length);
    }
    removeLineAttributesInRange(attributes, location, length) {
      let isTracked = this.isTracked, didRemove = this._lineAttributedString.removeAttributesInRange(attributes, location, length);
      if (isTracked && didRemove) {
        this.changed();
      }
    }
    addTrackedRange(range2) {
      let trackedRanges = this._trackedRanges;
      if (!trackedRanges) {
        trackedRanges = [];
        this._trackedRanges = trackedRanges;
      }
      trackedRanges.push(range2);
    }
    removeTrackedRange(range2) {
      let trackedRanges = this._trackedRanges;
      if (trackedRanges) {
        let index2 = trackedRanges.indexOf(range2);
        if (index2 !== -1) {
          trackedRanges.splice(index2, 1);
        }
      }
    }
    hasChildren() {
      return this.firstChild !== null;
    }
    children() {
      let results = [], each = this.firstChild;
      while (each) {
        results.push(each);
        each = each.nextSibling;
      }
      return results;
    }
    childAtIndex(index2) {
      if (index2 === -1) {
        return this.lastChild;
      }
      let each = this.firstChild, runningIndex = 0;
      while (each) {
        if (runningIndex === index2) {
          return each;
        }
        runningIndex++;
        each = each.nextSibling;
      }
      return void 0;
    }
    indexToSelf(onlyCountSiblingsWithSameType) {
      if (!this.parent) {
        return void 0;
      }
      let index2 = 0, each = this, type = this.type();
      while (each.previousSibling) {
        each = each.previousSibling;
        if (onlyCountSiblingsWithSameType) {
          if (each.type() === type) {
            index2++;
          }
        } else {
          index2++;
        }
      }
      return index2;
    }
    indexPathToSelf(onlyCountSiblingsWithSameType) {
      let indexPath = [], each = this, index2 = each.indexToSelf(onlyCountSiblingsWithSameType);
      while (index2 !== void 0) {
        indexPath.unshift(index2);
        each = each.parent;
        index2 = each.indexToSelf(onlyCountSiblingsWithSameType);
      }
      return indexPath;
    }
    validateInsertChildBefore(aChild, referenceSibling) {
      let childTypeLevel = aChild.typeLevel(), thisTypeLevel = this.typeLevel();
      if (thisTypeLevel > childTypeLevel) {
        return false;
      }
      let previousConstraint = referenceSibling ? referenceSibling.previousSibling : this.lastChild;
      while (previousConstraint && previousConstraint.type() === "empty") {
        previousConstraint = previousConstraint.previousSibling;
      }
      if (previousConstraint) {
        if (previousConstraint.typeLevel() < childTypeLevel) {
          return false;
        }
      }
      let nextConstraint = referenceSibling;
      while (nextConstraint && nextConstraint.type() === "empty") {
        nextConstraint = nextConstraint.nextSibling;
      }
      if (nextConstraint) {
        if (nextConstraint.typeLevel() > childTypeLevel) {
          return false;
        }
      }
      let minIndent = 0, maxIndent = Number.MAX_VALUE, siblingConstrained = false;
      if (previousConstraint && previousConstraint.typeLevel() === childTypeLevel) {
        maxIndent = previousConstraint.typeIndentLevel();
        siblingConstrained = true;
      }
      if (nextConstraint && nextConstraint.typeLevel() === childTypeLevel) {
        minIndent = nextConstraint.typeIndentLevel();
        siblingConstrained = true;
      }
      if (!siblingConstrained) {
        minIndent = this.typeIndentLevel() + 1;
      }
      let childPossibleIndent = aChild.validatedTypeIndentLevel(minIndent);
      if (childPossibleIndent < minIndent || childPossibleIndent > maxIndent) {
        return false;
      }
      childPossibleIndent = aChild.validatedTypeIndentLevel(childPossibleIndent);
      if (childPossibleIndent < minIndent || childPossibleIndent > maxIndent) {
        return false;
      }
      return true;
    }
    _adjustNewChildBranchTypeIndentLevelToMatchSibling(newChild, referenceSibling) {
      if (referenceSibling && referenceSibling._typeLevel === newChild._typeLevel) {
        newChild.setBranchTypeIndentLevel(referenceSibling._typeIndentLevel);
      } else if (this.lastChild && this.lastChild._typeLevel === newChild._typeLevel) {
        newChild.setBranchTypeIndentLevel(this.lastChild._typeIndentLevel);
      } else if (newChild._typeLevel === this._typeLevel) {
        newChild.setBranchTypeIndentLevel(this.typeIndentLevel() + 1);
      } else {
        newChild.setBranchTypeIndentLevel(0);
      }
    }
    insertChildBefore(aChild, referenceSibling, dontAdjustChildLevel) {
      let tree = this.tree, isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
      }
      aChild.removeFromParent();
      if (!dontAdjustChildLevel) {
        this._adjustNewChildBranchTypeIndentLevelToMatchSibling(aChild, referenceSibling);
      }
      if (isTracked) {
        tree._nodeWillBeInsertedBeforeNode(aChild, referenceSibling ? referenceSibling : this.nextBranch());
      }
      aChild.parent = this;
      if (referenceSibling) {
        aChild.nextSibling = referenceSibling;
        aChild.previousSibling = referenceSibling.previousSibling;
        referenceSibling.previousSibling = aChild;
        if (aChild.previousSibling) {
          aChild.previousSibling.nextSibling = aChild;
        }
      } else {
        aChild.previousSibling = this.lastChild;
        aChild.nextSibling = null;
        if (this.lastChild) {
          this.lastChild.nextSibling = aChild;
        }
      }
      if (!aChild.previousSibling) {
        this.firstChild = aChild;
      }
      if (!aChild.nextSibling) {
        this.lastChild = aChild;
      }
      let previousSibling = aChild.previousSibling;
      while (previousSibling && previousSibling._type === "empty") {
        previousSibling._typeLevel = aChild._typeLevel;
        previousSibling.setTypeIndentLevel(aChild.typeIndentLevel());
        previousSibling = previousSibling.previousSibling;
      }
      if (isTracked) {
        if (aChild.type() === "property") {
          let nonPropertyAncestor = this.nonPropertyAncestorOrSelf();
          if (nonPropertyAncestor && !nonPropertyAncestor.isRoot()) {
            nonPropertyAncestor.changed();
          }
        }
        tree._nodeWasInserted(aChild);
        tree.endUpdates();
      }
    }
    insertChildrenBefore(children, referenceSibling, dontAdjustChildLevel) {
      let tree = this.tree, isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
      }
      let length = children.length;
      for (let i3 = 0; i3 < length; i3++) {
        this.insertChildBefore(children[i3], referenceSibling, dontAdjustChildLevel);
      }
      if (isTracked) {
        tree.endUpdates();
      }
    }
    appendChild(aChild, dontAdjustChildLevel) {
      this.insertChildBefore(aChild, null, dontAdjustChildLevel);
    }
    appendChildren(children, dontAdjustChildLevel) {
      this.insertChildrenBefore(children, null, dontAdjustChildLevel);
    }
    removeChild(aChild) {
      let tree = this.tree, isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
        tree._nodeWillBeRemoved(aChild);
        if (tree._previousParents[aChild.id] === void 0) {
          tree._previousParents[aChild.id] = aChild.parent;
        }
        if (aChild.type() === "property") {
          let nonPropertyAncestor = this.nonPropertyAncestorOrSelf();
          if (nonPropertyAncestor && !nonPropertyAncestor.isRoot()) {
            nonPropertyAncestor.changed();
          }
        }
      }
      if (aChild.previousSibling) {
        aChild.previousSibling.nextSibling = aChild.nextSibling;
      }
      if (aChild.nextSibling) {
        aChild.nextSibling.previousSibling = aChild.previousSibling;
      }
      if (aChild === this.firstChild) {
        this.firstChild = aChild.nextSibling;
      }
      if (aChild === this.lastChild) {
        this.lastChild = aChild.previousSibling;
      }
      aChild.nextSibling = null;
      aChild.previousSibling = null;
      aChild.parent = null;
      if (isTracked) {
        tree.endUpdates();
      }
    }
    removeChildren(children) {
      let tree = this.tree, isTracked = this.isTracked;
      if (isTracked) {
        tree.beginUpdates();
      }
      let length = children.length;
      for (let i3 = 0; i3 < length; i3++) {
        children[i3].removeFromParent();
      }
      if (isTracked) {
        tree.endUpdates();
      }
    }
    removeFromParent() {
      if (this.parent) {
        this.parent.removeChild(this);
      }
    }
    isRoot() {
      return this._typeLevel === Taxonomy.ROOT_STRUCTURE_TYPE_LEVEL;
    }
    isAncestorOfSelf(node) {
      let each = this.parent;
      while (each) {
        if (each === node) {
          return true;
        }
        each = each.parent;
      }
      return false;
    }
    root() {
      if (this.isTracked) {
        return this.tree.root;
      }
      let parent = this;
      while (parent && !parent.isRoot()) {
        parent = parent.parent;
      }
      return parent;
    }
    nonPropertyAncestorOrSelf() {
      let each = this;
      while (each) {
        if (each.type() !== "property") {
          return each;
        }
        each = each.parent;
      }
      return null;
    }
    previousBranch() {
      let previousSibling = this.previousSibling;
      if (previousSibling) {
        return previousSibling;
      }
      return this.previousLineNode();
    }
    nextBranch() {
      return this.lastDescendantOrSelf().nextLineNode();
    }
    descendants() {
      let results = [], end = this.nextBranch(), each = this.nextLineNode();
      while (each !== end) {
        results.push(each);
        each = each.nextLineNode();
      }
      return results;
    }
    lastDescendant() {
      let each = this.lastChild;
      while (each && each.lastChild) {
        each = each.lastChild;
      }
      return each;
    }
    lastDescendantOrSelf() {
      let each = this, lastChild = each.lastChild;
      while (lastChild) {
        each = lastChild;
        lastChild = each.lastChild;
      }
      return each;
    }
    previousLineNode() {
      let parent, previousSibling = this.previousSibling;
      if (previousSibling) {
        return previousSibling.lastDescendantOrSelf();
      }
      parent = this.parent;
      if (!parent || parent.isRoot()) {
        return null;
      }
      return parent;
    }
    previousLineNodeOrRoot() {
      let previousLineNode = this.previousLineNode();
      if (previousLineNode) {
        return previousLineNode;
      }
      return this.parent;
    }
    nextLineNode() {
      let firstChild = this.firstChild;
      if (firstChild) {
        return firstChild;
      }
      let nextSibling = this.nextSibling;
      if (nextSibling) {
        return nextSibling;
      }
      let parent = this.parent;
      while (parent) {
        nextSibling = parent.nextSibling;
        if (nextSibling) {
          return nextSibling;
        }
        parent = parent.parent;
      }
      return null;
    }
    evaluateNodePath(nodePath2) {
      return NodePath.evaluate(nodePath2, this);
    }
    iterateIgnoringEmptyLines(callback) {
      let isString2 = typeof callback === "string" || callback instanceof String, each = isString2 ? this[callback] : callback.call(this);
      while (each && each.type() === "empty") {
        each = isString2 ? each[callback] : callback.call(each);
      }
      return each;
    }
    branchToText() {
      let nextBranch = this.nextBranch();
      if (nextBranch) {
        return this.tree.createRangeFromNodes(this, 0, nextBranch, 0).textInRange();
      }
      let lastDescendantOrSelf = this.lastDescendantOrSelf();
      return this.tree.createRangeFromNodes(this, 0, lastDescendantOrSelf, lastDescendantOrSelf.line().length).textInRange();
    }
    branchNodes() {
      let results = this.descendants();
      results.unshift(this);
      return results;
    }
    branchStructureLevels() {
      let next = this.breadthFirstIterator(), structureLevels = [], each = this;
      while (each) {
        structureLevels.push(each.structureLevel());
        each = next();
      }
      structureLevels.sort();
      structureLevels.sortedUniquify();
      return structureLevels;
    }
    depthFirstIterator(reverseSiblingOrder) {
      let stack = [this];
      return function next() {
        let current = stack.pop();
        if (current) {
          let each = reverseSiblingOrder ? current.lastChild : current.firstChild;
          while (each) {
            stack.push(each);
            each = reverseSiblingOrder ? each.previousSibling : each.nextSibling;
          }
        }
        return current;
      };
    }
    breadthFirstIterator(reverseSiblingOrder) {
      let queue = [this];
      return function next() {
        let current = queue.shift();
        if (current) {
          let each = reverseSiblingOrder ? current.lastChild : current.firstChild;
          while (each) {
            queue.push(each);
            each = reverseSiblingOrder ? each.previousSibling : each.nextSibling;
          }
        }
        return current;
      };
    }
    renderNodeElementStyles(elementRenderer) {
      let prevNode = this.previousLineNode(), nextNode = this.nextLineNode(), modeContext = this.modeContext(), typeStarting = !prevNode || prevNode.type() !== this.type(), typeEnding = !nextNode || nextNode.type() !== this.type(), mode2 = this.mode(), tags = this.tags();
      if (typeStarting) {
        elementRenderer.addWrapClass(`cm-${this.type()}-start-wrapper`);
        elementRenderer.addBackgroundClass(`cm-${this.type()}-start-background`);
        elementRenderer.addTextClass(`cm-${this.type()}-start`);
      }
      elementRenderer.addWrapClass(`cm-${this.type()}-wrapper`);
      elementRenderer.addBackgroundClass(`cm-${this.type()}-background`);
      elementRenderer.addTextClass(`cm-${this.type()}`);
      if (typeEnding) {
        elementRenderer.addWrapClass(`cm-${this.type()}-end-wrapper`);
        elementRenderer.addBackgroundClass(`cm-${this.type()}-end-background`);
        elementRenderer.addTextClass(`cm-${this.type()}-end`);
      }
      if (modeContext) {
        let modeContextStarting = !prevNode || prevNode.modeContext() !== this.modeContext(), modeContextEnding = !nextNode || nextNode.modeContext() !== this.modeContext();
        if (modeContextStarting) {
          elementRenderer.addTextClass(`cm-${modeContext}-start-modecontext`);
        }
        elementRenderer.addTextClass(`cm-${modeContext}-modecontext`);
        if (modeContextEnding) {
          elementRenderer.addTextClass(`cm-${modeContext}-end-modecontext`);
        }
      }
      if (mode2) {
        elementRenderer.addTextClass(`cm-${mode2}-mode`);
      }
      for (let name106 in tags) {
        if (name106 !== "") {
          elementRenderer.setAttribute(`cm-${name106}`, tags[name106]);
        }
      }
      elementRenderer.setAttribute("cm-level", this.typeIndentLevel());
    }
    static commonDescendantsForNodes(nodes) {
      let results = NodeSet.setFromArray(nodes), length = nodes.length;
      for (let i3 = 0; i3 < length; i3++) {
        results.addNodesFromArray(nodes[i3].descendants());
      }
      return results;
    }
    static commonAncestorsForNodes(nodes) {
      let length = nodes.length, i3, each, eachParent, result = NodeSet.setFromArray(nodes);
      for (i3 = 0; i3 < length; i3++) {
        each = nodes[i3];
        eachParent = each.parent;
        while (eachParent) {
          if (result.containsNode(eachParent)) {
            result.removeNode(each);
            break;
          } else {
            eachParent = eachParent.parent;
          }
        }
      }
      return result;
    }
    static ancestorsForNodes(nodes) {
      let results = new NodeSet(), length = nodes.length, i3;
      for (i3 = 0; i3 < length; i3++) {
        let each = nodes[i3];
        while (each = each.parent) {
          results.addNode(each);
        }
      }
      return results;
    }
    static formatNodes(format5, attributes, nodes, alwaysReturnList, dontStringify) {
      let length = nodes.length, result, i3;
      if (format5 === "ids") {
        result = [];
        for (i3 = 0; i3 < length; i3++) {
          result.push(nodes[i3].id);
        }
        return result.join(",");
      }
      if (attributes) {
        attributes = attributes.split(";");
      }
      if (!alwaysReturnList && length === 1) {
        if (format5 === "txt") {
          result = nodes[0].line();
        } else {
          result = nodes[0].toJSON(attributes, true);
        }
      } else {
        result = [];
        for (i3 = 0; i3 < length; i3++) {
          if (format5 === "txt") {
            result.push(nodes[i3].line());
          } else {
            result.push(nodes[i3].toJSON(attributes, true));
          }
        }
      }
      if (format5 === "txt") {
        if (result.join) {
          return result.join("\n");
        }
        return result;
      }
      if (dontStringify) {
        return result;
      }
      return JSON.stringify(result);
    }
    branchToJson() {
      const result = {
        id: this.id,
        text: this.text(),
        type: this.type(),
        tags: this.tags(),
        links: this.links(),
        indentLevel: this.typeIndentLevel(),
        modeContext: this.modeContext(),
        attributedText: this._lineAttributedString.toJson(),
        children: []
      };
      for (let each = this.firstChild; each != null; each = each.nextSibling) {
        result.children.push(each.branchToJson());
      }
      return result;
    }
  };

  // src/model/range.js
  var Range = class {
    constructor(tree, startNode, startOffset, endNode, endOffset, anchoredAtEnd) {
      this._tree = tree;
      if (!startNode) {
        startNode = tree.root.firstChild;
      }
      if (!endNode) {
        endNode = startNode;
      }
      if (startOffset === void 0) {
        startOffset = 0;
        if (endOffset === void 0) {
          endOffset = endNode.line().length;
        }
      } else if (endOffset === void 0) {
        endOffset = startOffset;
      }
      this.startNode = startNode;
      this.startOffset = startOffset;
      this.endNode = endNode;
      this.endOffset = endOffset;
      this.anchoredAtStart = !anchoredAtEnd;
    }
    copy() {
      return new Range(this._tree, this.startNode, this.startOffset, this.endNode, this.endOffset, true);
    }
    isCollapsed() {
      return this.startNode === this.endNode && this.startOffset === this.endOffset;
    }
    isSelectingAll() {
      return this.length() === this._tree.textLength();
    }
    isEqualToRange(range2) {
      return this.startNode === range2.startNode && this.startOffset === range2.startOffset && this.endNode === range2.endNode && this.endOffset === range2.endOffset;
    }
    containsRange(range2) {
      let thisStart = this.location(), thisEnd = thisStart + this.length(), rangeStart = range2.location(), rangeEnd = rangeStart + range2.length();
      return thisStart <= rangeStart && thisEnd >= rangeEnd;
    }
    location() {
      return this._tree.nodeOffsetToTextOffset(this.startNode, this.startOffset);
    }
    length() {
      let startNode = this.startNode, endNode = this.endNode;
      if (startNode === endNode) {
        return this.endOffset - this.startOffset;
      }
      return this._tree.nodeOffsetToTextOffset(endNode, this.endOffset) - this.location();
    }
    textInRange() {
      let lines = [];
      this.forEachNodeInRange((node, line, location, length, fullySelected) => {
        if (fullySelected) {
          lines.push(node.line());
        } else {
          lines.push(node.lineInRange(location, length));
        }
      });
      return lines.join("\n");
    }
    linesInRange() {
      let lines = [];
      this.forEachNodeInRange((node) => {
        lines.push(node.line());
      });
      return lines;
    }
    startLine() {
      return this._tree.nodeToLineNumber(this.startNode);
    }
    startLineCh() {
      return { line: this.startLine(), ch: this.startOffset };
    }
    endLine() {
      return this._tree.nodeToLineNumber(this.endNode);
    }
    endLineCh() {
      return { line: this.endLine(), ch: this.endOffset };
    }
    anchorNode() {
      return this.anchoredAtStart ? this.startNode : this.endNode;
    }
    anchorOffset() {
      return this.anchoredAtStart ? this.startOffset : this.endOffset;
    }
    anchorLineCh() {
      return this.anchoredAtStart ? this.startLineCh() : this.endLineCh();
    }
    headNode() {
      return !this.anchoredAtStart ? this.startNode : this.endNode;
    }
    headOffset() {
      return !this.anchoredAtStart ? this.startOffset : this.endOffset;
    }
    headLineCh() {
      return !this.anchoredAtStart ? this.startLineCh() : this.endLineCh();
    }
    nodesInRange() {
      let nodes = [];
      this.forEachNodeInRange((node) => {
        nodes.push(node);
      });
      return nodes;
    }
    nodeAfterEndNode() {
      return this.endNode.nextLineNode();
    }
    startNodeTextBeforeRange() {
      return this.startNode.line().substr(0, this.startOffset);
    }
    endNodeTextAfterRange() {
      return this.endNode.line().substr(this.endOffset);
    }
    beginTrackingOffsets() {
      if (this.startNode === this.endNode) {
        this.startNode.addTrackedRange(this);
      } else {
        this.startNode.addTrackedRange(this);
        this.endNode.addTrackedRange(this);
      }
    }
    endTrackingOffsets() {
      if (this.startNode === this.endNode) {
        this.startNode.removeTrackedRange(this);
      } else {
        this.startNode.removeTrackedRange(this);
        this.endNode.removeTrackedRange(this);
      }
    }
    forEachNodeInRange(callback) {
      let startNode = this.startNode, startLine = this.startLine(), startOffset = this.startOffset, endNode = this.endNode, endOffset = this.endOffset;
      if (startNode === endNode) {
        callback(startNode, startLine, startOffset, endOffset - startOffset, false);
      } else {
        let each = startNode.nextLineNode();
        callback(startNode, startLine, startOffset, startNode.line().length - startOffset, false);
        while (each !== endNode) {
          callback(each, ++startLine, 0, each.line().length, true);
          each = each.nextLineNode(each);
        }
        callback(endNode, ++startLine, 0, endOffset, false);
      }
    }
    rangeByCollapsing(toStart) {
      let result = this.copy();
      if (toStart) {
        result.endNode = result.startNode;
        result.endOffset = result.startOffset;
      } else {
        result.startNode = result.endNode;
        result.startOffset = result.endOffset;
      }
      return result;
    }
    rangeByOffsetting(locationOffset, lengthOffset) {
      let location = this.location(), length = this.length(), tree = this._tree, textLength = tree.textLength();
      location += locationOffset;
      length += lengthOffset;
      if (location < 0) {
        location = 0;
      }
      if (location > textLength) {
        location = textLength;
      }
      if (length < 0) {
        length = 0;
      }
      if (location + length > textLength) {
        length = textLength - location;
      }
      return tree.createRangeFromLocation(location, length);
    }
    rangeByAdjustingToEffectedNodesInEditor(editor2) {
      let startNode = this.startNode, startOffset = this.startOffset, endNode = this.endNode, endOffset = this.endOffset, tree = this._tree;
      if (editor2) {
        let firstVisible = startNode;
        while (firstVisible && editor2.nodeIsHiddenInFold(firstVisible, true)) {
          firstVisible = firstVisible.previousLineNode();
        }
        if (!firstVisible) {
          firstVisible = tree.firstLineNode();
        }
        if (firstVisible !== startNode) {
          startNode = firstVisible;
          startOffset = 0;
        }
      }
      if (startNode !== endNode && endOffset === 0) {
        endNode = endNode.previousLineNode();
        endOffset = endNode.line().length;
      }
      if (editor2 && (editor2.nodeIsHiddenInFold(endNode) || editor2.isCollapsed(endNode))) {
        let lastHidden = endNode.nextLineNode();
        while (lastHidden && editor2.nodeIsHiddenInFold(lastHidden)) {
          lastHidden = lastHidden.nextLineNode();
        }
        if (lastHidden) {
          lastHidden = lastHidden.previousLineNode();
        } else {
          lastHidden = tree.lastLineNode();
        }
        if (lastHidden !== endNode) {
          endNode = lastHidden;
          endOffset = endNode.line().length;
        }
      }
      return tree.createRangeFromNodes(startNode, startOffset, endNode, endOffset);
    }
    rangeByExtendingToWord(justReturnPseudoRange) {
      let startNode = this.startNode, endNode = this.endNode, taxonomy3 = this._tree.taxonomy, startRange = taxonomy3.wordRange(startNode, this.startOffset), endRange = taxonomy3.wordRange(endNode, this.endOffset);
      if (justReturnPseudoRange) {
        return {
          location: startRange.location,
          length: endRange.location + endRange.length - startRange.location
        };
      }
      let newRange = this._tree.createRangeFromNodes(startNode, startRange.location, endNode, endRange.location + endRange.length);
      if (newRange.textInRange().replace(/^[.?!; ]+$/g, "").length === 0) {
        return this;
      }
      return newRange;
    }
    rangeByExtendingToSentence(justReturnPseudoRange) {
      let startNode = this.startNode, endNode = this.endNode, taxonomy3 = this._tree.taxonomy, startRange = taxonomy3.sentenceRange(startNode, this.startOffset), endRange = taxonomy3.sentenceRange(endNode, this.endOffset);
      if (this.length() > 0 && endRange.location === this.endOffset) {
        if (justReturnPseudoRange) {
          return {
            location: startRange.location,
            length: this.endOffset - startRange.location
          };
        }
        return this._tree.createRangeFromNodes(startNode, startRange.location, endNode, this.endOffset);
      }
      if (justReturnPseudoRange) {
        return {
          location: startRange.location,
          length: endRange.length + endRange.location - startRange.location
        };
      }
      return this._tree.createRangeFromNodes(startNode, startRange.location, endNode, endRange.location + endRange.length);
    }
    rangeByExtendingToLine() {
      let endNode = this.endNode;
      return this._tree.createRangeFromNodes(this.startNode, 0, endNode, endNode.line().length);
    }
    rangeByExtendingToEndOfLine() {
      let tree = this._tree, startNode = this.startNode, startOffset = this.startOffset, endNode = this.endNode;
      return tree.createRangeFromNodes(startNode, startOffset, endNode, endNode.line().length);
    }
    rangeByExtendingToParagraph() {
      let tree = this._tree, startNode = this.startNode, endNode = this.endNode, endOffset = endNode.line().length;
      if (this.length() > 0 && this.endOffset === 0) {
        endOffset = 0;
      } else {
        let lineAfterNode = endNode.nextLineNode();
        if (lineAfterNode) {
          endOffset = 0;
          endNode = lineAfterNode;
        }
      }
      return tree.createRangeFromNodes(startNode, 0, endNode, endOffset);
    }
    rangeByExtendingToBeginningOfParagraph() {
      let tree = this._tree, startNode = this.startNode, endNode = this.endNode, endOffset = this.endOffset;
      return tree.createRangeFromNodes(startNode, 0, endNode, endOffset);
    }
    rangeByExtendingToEndOfParagraph() {
      let tree = this._tree, startNode = this.startNode, startOffset = this.startOffset, extendedRange = this.rangeByExtendingToParagraph();
      return tree.createRangeFromNodes(startNode, startOffset, extendedRange.endNode, extendedRange.endOffset);
    }
    rangeByExtendingToBranch() {
      let branchNodes = new NodeSet(), rangeNodes = this.rangeByAdjustingToEffectedNodesInEditor().nodesInRange(), commonAncestors = Node.commonAncestorsForNodes(rangeNodes);
      commonAncestors.forEachNodeInSet((each) => {
        let descendants = each.descendants(), length = descendants.length, i3;
        branchNodes.addNode(each);
        for (i3 = 0; i3 < length; i3++) {
          branchNodes.addNode(descendants[i3]);
        }
      });
      let orderedBranchNodes = branchNodes.nodesInLineOrder(), firstNode = orderedBranchNodes[0], lastNode = orderedBranchNodes.lastObject(), lineAfterNode = lastNode.nextLineNode();
      if (lineAfterNode) {
        return this._tree.createRangeFromNodes(firstNode, 0, lineAfterNode, 0);
      }
      return this._tree.createRangeFromNodes(firstNode, 0, lastNode, lastNode.line().length);
    }
    rangeByExtendingToSiblingBranches() {
      let range2 = this.rangeByExtendingToBranch(), startNode = range2.startNode.parent.nextLineNode(), endNode = range2.startNode.parent.nextBranch();
      if (endNode === null) {
        endNode = this._tree.lastLineNode();
        return this._tree.createRangeFromNodes(startNode, 0, endNode, endNode.line().length);
      }
      return this._tree.createRangeFromNodes(startNode, 0, endNode, 0);
    }
    rangeByExtendingToParentBranch() {
      let range2 = this.rangeByExtendingToBranch(), startNode = range2.startNode.parent.nextLineNode(), startNodeParent = startNode.parent, tree = this._tree;
      return tree.createRangeFromNodes(startNodeParent, 0).rangeByExtendingToBranch();
    }
    rangeByLevelUpExtension() {
      let startNode = this.startNode, endNode = this.endNode, attributedString = startNode.lineAttributedString(), origRange = { location: this.startOffset }, multiLine = startNode !== endNode, tree = this._tree, startOffset = this.startOffset, endOffset = this.endOffset;
      function narrowerRange(r1, r22) {
        if (r1.location >= startOffset && r1.length + r1.location <= endOffset) {
          return r22;
        }
        if (r22.location >= startOffset && r22.length + r22.location <= endOffset) {
          return r1;
        }
        if (r1.location <= r22.location && r1.location + r1.length >= r22.location + r22.length) {
          return r22;
        }
        return r1;
      }
      if (!multiLine) {
        if (startOffset === 0 && endOffset === this.endNode.line().length) {
          if (endNode.nextLineNode()) {
            return this.rangeByExtendingToParagraph();
          }
          return this.rangeByExtendingToParentBranch();
        }
        origRange.length = endOffset - startOffset;
        let extendedRange = attributedString.extendedRangeFromRange(origRange), narrower;
        if (this.isCollapsed()) {
          let wordRange = this.rangeByExtendingToWord(true);
          narrower = narrowerRange(wordRange, extendedRange);
          return tree.createRangeFromNodes(startNode, narrower.location, startNode, narrower.location + narrower.length);
        }
        let sentenceRange = this.rangeByExtendingToSentence(true);
        narrower = narrowerRange(sentenceRange, extendedRange);
        return tree.createRangeFromNodes(startNode, narrower.location, startNode, narrower.location + narrower.length);
      }
      let parentBranchRange = this.rangeByExtendingToBranch();
      if (this.isEqualToRange(parentBranchRange)) {
        return this.rangeByExtendingToParentBranch();
      }
      return parentBranchRange;
    }
    rangeByExtendingToLevel(level) {
      if (level === 0) {
        return this;
      }
      if (level === 1) {
        return this.rangeByExtendingToWord();
      }
      if (level === 2) {
        return this.rangeByExtendingToSentence();
      }
      if (level === 3) {
        return this.rangeByExtendingToLine();
      }
      if (level === 4) {
        return this.rangeByExtendingToParagraph();
      }
      if (level === 5) {
        return this.rangeByExtendingToBranch();
      }
      let range2 = this, doSiblings = true;
      while (level > 5) {
        if (doSiblings) {
          range2 = range2.rangeByExtendingToSiblingBranches();
        } else {
          range2 = range2.rangeByExtendingToParentBranch();
        }
        doSiblings = !doSiblings;
        level--;
      }
      return range2;
    }
    toString() {
      let startLine = this.startNode.line(), startOffset = this.startOffset, endLine = this.endNode.line(), endOffset = this.endOffset;
      if (this.startNode === this.endNode) {
        let line = `${startLine.substr(0, startOffset)}^${startLine.substr(startOffset)}`;
        if (startOffset !== endOffset) {
          line = `${line.substr(0, endOffset + 1)}^${line.substr(endOffset + 1)}`;
        }
        return `("${line}")`;
      }
      let join2 = [];
      join2.push(`${startLine.substr(0, startOffset)}^${startLine.substr(startOffset)}`);
      join2.push(`${endLine.substr(0, endOffset)}^${endLine.substr(endOffset)}`);
      return `("${join2.join('", "')}")`;
    }
    static copyRanges(ranges) {
      let copiedRanges = [];
      let length = ranges.length;
      let i3;
      for (i3 = 0; i3 < length; i3++) {
        copiedRanges.push(ranges[i3].copy());
      }
      return copiedRanges;
    }
    static areRangesEqual(range1, range2) {
      if (range1 === null) {
        return range2 === null;
      }
      if (range2 === null) {
        return range1 === null;
      }
      return range1.isEqualToRange(range2);
    }
    static areRangeArraysEqual(ranges1, ranges2) {
      if (ranges1 === null) {
        return ranges2 === null;
      }
      if (ranges2 === null) {
        return ranges1 === null;
      }
      let length1 = ranges1.length;
      let length2 = ranges2.length;
      if (length1 !== length2) {
        return false;
      }
      let i3;
      for (i3 = 0; i3 < length1; i3++) {
        let each1 = ranges1[i3];
        let each2 = ranges2[i3];
        if (!each1.isEqualToRange(each2)) {
          return false;
        }
      }
      return true;
    }
    static nodesInRanges(ranges) {
      let nodes = [];
      let length = ranges.length;
      let i3;
      for (i3 = 0; i3 < length; i3++) {
        nodes = nodes.concat(ranges[i3].nodesInRange());
      }
      return nodes;
    }
    static textInRanges(ranges) {
      let lines = [];
      let length = ranges.length;
      let i3;
      for (i3 = 0; i3 < length; i3++) {
        lines.push(ranges[i3].textInRange());
      }
      return lines.join("");
    }
    static forEachNodeInRanges(ranges, block) {
      let length = ranges.length;
      let i3;
      for (i3 = 0; i3 < length; i3++) {
        ranges[i3].forEachNodeInRange(block);
      }
    }
    static isLessThanLineCh(a3, b2) {
      let aLine = a3.line, bLine = b2.line;
      if (aLine < bLine) {
        return true;
      } else if (aLine === bLine) {
        return a3.ch < b2.ch;
      }
      return false;
    }
    static isLessThanOrEqualLineCh(a3, b2) {
      let aLine = a3.line, bLine = b2.line;
      if (aLine < bLine) {
        return true;
      } else if (aLine === bLine) {
        return a3.ch <= b2.ch;
      }
      return false;
    }
    static rangeFromNodes(startNode, endNode) {
      return new Range(startNode.tree, startNode, 0, endNode, endNode.line().length);
    }
  };

  // src/model/redblack-tree.js
  var _RED = redblack_node_default.RED;
  var _BLACK = redblack_node_default.BLACK;
  var RedBlackTree = class {
    constructor() {
      this._RBRoot = null;
    }
    nodeToLineNumber(node) {
      if (!node) {
        return -1;
      }
      let sz = node._RBLeft ? node._RBLeft.totalLineCount() : 0, curr = node;
      while (curr !== this._RBRoot) {
        if (curr._RBIsRightChild()) {
          sz += curr._RBParent._RBLeft ? curr._RBParent._RBLeft.totalLineCount() + 1 : 1;
        }
        curr = curr._RBParent;
      }
      return sz;
    }
    lineNumberToNode(line) {
      if (line < 0 || !this._RBRoot || line >= this._RBRoot.totalLineCount()) {
        return null;
      }
      return this._RBNodeAtSubtreeIndex(this._RBRoot, line);
    }
    _RBNodeAtSubtreeIndex(current, index2) {
      let sz = current._RBLeft ? current._RBLeft.totalLineCount() : 0;
      if (index2 === sz) {
        return current;
      } else if (index2 < sz) {
        return this._RBNodeAtSubtreeIndex(current._RBLeft, index2);
      }
      return this._RBNodeAtSubtreeIndex(current._RBRight, index2 - (sz + 1));
    }
    _RBNodeAtTextOffset(offset) {
      if (offset === this._RBRoot.totalLength()) {
        return this._RBRoot._RBRightMost();
      }
      let node = this._RBRoot;
      while (node) {
        if (node._RBLeft !== null && offset < node._RBLeft.totalLength()) {
          node = node._RBLeft;
        } else {
          if (node._RBLeft !== null) {
            offset -= node._RBLeft.totalLength();
          }
          offset -= node.line().length + 1;
          if (offset < 0) {
            return node;
          }
          node = node._RBRight;
        }
      }
      return null;
    }
    _RBTextOffsetOfNode(node) {
      let offset = node._RBLeft !== null ? node._RBLeft.totalLength() : 0, RBParent;
      while (RBParent = node._RBParent) {
        if (node === RBParent._RBRight) {
          if (RBParent._RBLeft) {
            offset += RBParent._RBLeft.totalLength();
          }
          offset += RBParent.line().length + 1;
        }
        node = RBParent;
      }
      return offset;
    }
    _RBNodeAtYOffset(offset) {
      if (offset <= 0) {
        return this.firstLineNode();
      }
      let textHeight2 = this.textHeight();
      if (offset >= textHeight2) {
        return this.lastLineNode();
      }
      let node = this._RBRoot;
      while (node) {
        if (node._RBLeft !== null && offset < node._RBLeft.totalHeight()) {
          node = node._RBLeft;
        } else {
          if (node._RBLeft !== null) {
            offset -= node._RBLeft.totalHeight();
          }
          offset -= node.height();
          if (offset < 0) {
            return node;
          }
          node = node._RBRight;
        }
      }
      return null;
    }
    _RBYOffsetOfNode(node) {
      let offset = node._RBLeft !== null ? node._RBLeft.totalHeight() : 0;
      while (node._RBParent) {
        if (node === node._RBParent._RBRight) {
          if (node._RBParent._RBLeft) {
            offset += node._RBParent._RBLeft.totalHeight();
          }
          offset += node._RBParent.height();
        }
        node = node._RBParent;
      }
      return offset;
    }
    _RBPreorderTraverse(current, block) {
      if (current) {
        block(current);
        this._RBPreorderTraverse(current._RBLeft, block);
        this._RBPreorderTraverse(current._RBRight, block);
      }
    }
    _RBInsertLineBefore(node, referenceNode) {
      if (this._RBRoot === null) {
        this._RBRoot = node;
        return;
      }
      node._RBColor = _RED;
      if (referenceNode === null) {
        let last = this._RBRoot._RBRightMost();
        last._RBRight = node;
        node._RBParent = last;
        last._RBClearCache();
      } else if (referenceNode._RBLeft === null) {
        referenceNode._RBLeft = node;
        node._RBParent = referenceNode;
        referenceNode._RBClearCache();
      } else {
        let insertPoint = referenceNode._RBChildPredecessor();
        insertPoint._RBRight = node;
        node._RBParent = insertPoint;
        insertPoint._RBClearCache();
      }
      this._RBFixTreeOnInsert(node);
    }
    _RBRemoveLine(node) {
      if (!this._RBRoot._RBHasChildren()) {
        this._RBRoot = null;
        node._RBLeft = null;
        node._RBRight = null;
        node._RBParent = null;
        node._RBColor = _BLACK;
        return;
      }
      let y2 = !node._RBLeft || !node._RBRight ? node : node._RBChildSuccessor(), x3 = y2._RBLeft ? y2._RBLeft : y2._RBRight;
      if (x3) {
        x3._RBParent = y2._RBParent;
      }
      if (!y2._RBParent) {
        this._RBRoot = x3;
      } else if (y2._RBIsLeftChild()) {
        y2._RBParent._RBSetLeft(x3);
      } else {
        y2._RBParent._RBSetRight(x3);
      }
      y2._RBClearCache();
      if (y2 !== node) {
        if (node._RBLeft && node._RBLeft !== y2) {
          y2._RBLeft = node._RBLeft;
          y2._RBLeft._RBParent = y2;
        }
        if (node._RBRight && node._RBRight !== y2) {
          y2._RBRight = node._RBRight;
          y2._RBRight._RBParent = y2;
        }
        y2._RBParent = node._RBParent;
        if (y2._RBParent) {
          if (y2._RBParent._RBLeft === node) {
            y2._RBParent._RBLeft = y2;
          } else {
            y2._RBParent._RBRight = y2;
          }
        } else {
          this._RBRoot = y2;
        }
        y2._RBClearCache();
      }
      if (y2._RBParent) {
        y2._RBParent._RBClearCache();
      }
      y2._RBColor = node._RBColor;
      if (redblack_node_default._RBColorOrBlack(y2) === _BLACK && x3) {
        this._RBFixTreeOnRemove(x3);
      }
      node._RBLeft = null;
      node._RBRight = null;
      node._RBParent = null;
      node._RBColor = _BLACK;
    }
    _RBFixTreeOnInsert(node) {
      let BLACK = _BLACK, RED = _RED, y2;
      while (node !== this._RBRoot && redblack_node_default._RBColorOrBlack(node._RBParent) === RED) {
        let par = node._RBParent;
        if (par === par._RBParent._RBLeft) {
          y2 = par._RBParent._RBRight;
          if (redblack_node_default._RBColorOrBlack(y2) === RED) {
            par._RBColor = BLACK;
            y2._RBColor = BLACK;
            par._RBParent._RBColor = RED;
            node = par._RBParent;
          } else {
            if (node === node._RBParent._RBRight) {
              node = par;
              node._RBLeftRotate(this);
            }
            par._RBColor = BLACK;
            par._RBParent._RBColor = RED;
            par._RBParent._RBRightRotate(this);
          }
        } else {
          y2 = par._RBParent._RBLeft;
          if (redblack_node_default._RBColorOrBlack(y2) === RED) {
            par._RBColor = BLACK;
            y2._RBColor = BLACK;
            par._RBParent._RBColor = RED;
            node = par._RBParent;
          } else {
            if (node === node._RBParent._RBLeft) {
              node = par;
              node._RBRightRotate(this);
            }
            par._RBColor = BLACK;
            par._RBParent._RBColor = RED;
            par._RBParent._RBLeftRotate(this);
          }
        }
      }
      this._RBRoot._RBColor = BLACK;
    }
    _RBFixTreeOnRemove(x3) {
      let BLACK = _BLACK, RED = _RED, w3;
      while (x3 !== this._RBRoot && redblack_node_default._RBColorOrBlack(x3) === BLACK) {
        if (x3._RBIsLeftChild()) {
          w3 = x3._RBParent._RBRight;
          if (redblack_node_default._RBColorOrBlack(w3) === RED) {
            w3._RBColor = BLACK;
            x3._RBParent._RBColor = RED;
            x3._RBParent._RBLeftRotate(this);
            w3 = x3._RBParent._RBRight;
          }
          if (w3 && redblack_node_default._RBColorOrBlack(w3._RBLeft) === BLACK && redblack_node_default._RBColorOrBlack(w3._RBRight) === BLACK) {
            w3._RBColor = RED;
            x3 = x3._RBParent;
          } else {
            if (w3 && redblack_node_default._RBColorOrBlack(w3._RBRight) === BLACK) {
              if (w3._RBLeft) {
                w3._RBLeft._RBColor = BLACK;
              }
              w3._RBColor = RED;
              w3._RBRightRotate(this);
              w3 = x3._RBParent._RBRight;
            }
            if (w3) {
              w3._RBColor = x3._RBParent._RBColor;
            }
            x3._RBParent._RBColor = BLACK;
            if (w3 && w3._RBRight) {
              w3._RBRight._RBColor = BLACK;
            }
            x3._RBParent._RBRightRotate(this);
            x3 = this._RBRoot;
          }
        } else {
          w3 = x3._RBParent._RBLeft;
          if (redblack_node_default._RBColorOrBlack(w3) === RED) {
            if (w3) {
              w3._RBColor = BLACK;
            }
            x3._RBParent._RBColor = RED;
            x3._RBParent._RBRightRotate(this);
            w3 = x3._RBParent._RBLeft;
          }
          if (w3 && redblack_node_default._RBColorOrBlack(w3._RBRight) === BLACK && redblack_node_default._RBColorOrBlack(w3._RBLeft) === BLACK) {
            w3._RBColor = RED;
            x3 = x3._RBParent;
          } else {
            if (w3 && redblack_node_default._RBColorOrBlack(w3._RBLeft) === BLACK) {
              if (w3._RBRight) {
                w3._RBRight._RBColor = BLACK;
              }
              w3._RBColor = RED;
              w3._RBLeftRotate(this);
              w3 = x3._RBParent._RBLeft;
            }
            if (w3) {
              w3._RBColor = x3._RBParent._RBColor;
            }
            x3._RBParent._RBColor = BLACK;
            if (w3 && w3._RBLeft) {
              w3._RBLeft._RBColor = BLACK;
            }
            x3._RBParent._RBLeftRotate(this);
            x3 = this._RBRoot;
          }
        }
      }
      x3._RBColor = BLACK;
    }
  };
  var redblack_tree_default = RedBlackTree;

  // src/model/treechangedevent.js
  var TreeChangedEvent = class {
    constructor(tree, deltas, previousParents) {
      this.tree = tree;
      this.deltas = deltas;
      this.previousParents = previousParents;
    }
    previousParent(node) {
      return this.previousParents[node.id];
    }
    movedNodes() {
      let deltas = this.deltas, length = deltas.length, results = [];
      if (length === 1) {
        return results;
      }
      let allRemovedNodes = [], tree = this.tree, each, i3;
      for (i3 = 1; i3 < length; i3++) {
        allRemovedNodes.concat(deltas[i3].removedNodes);
      }
      length = allRemovedNodes.length;
      for (i3 = 1; i3 < length; i3++) {
        each = allRemovedNodes[i3];
        if (each.tree === tree && each.isTracked) {
          results.push(each);
        }
      }
      return results;
    }
  };
  var _TreeChangedEvent = TreeChangedEvent;

  // src/model/tree.js
  var { ok: ok4 } = assert_default;
  var { debug: debug2 } = environment_default;
  var Tree = class extends redblack_tree_default {
    constructor(text = "", taxonomy3) {
      super(text);
      this.id = UUID();
      this._lastNodeID = 0;
      this._updateCount = 0;
      this._tagsCache = null;
      this._parsedTagsCache = null;
      this.classifier = null;
      this.root = null;
      if (!taxonomy3) {
        this.taxonomy = taxonomy();
      } else if (typeof taxonomy3 === "string") {
        this.taxonomy = taxonomy({}, taxonomy3);
      } else {
        this.taxonomy = taxonomy3;
      }
      let root = this.createNode("", true);
      root._type = "root";
      root._typeLevel = Taxonomy.ROOT_STRUCTURE_TYPE_LEVEL;
      root._typeIndentLevel = 0;
      root._structureLevel = root._typeLevel + root._typeIndentLevel;
      this.root = root;
      this._deltaRegistrationDisabled = 0;
      this._deltas = null;
      this.beginUpdates();
      this.disableDeltaRegistration();
      this._nodeWillBeInsertedBeforeNode(root, null);
      this._nodeWasInserted(root);
      this.setText(text);
      this.enableDeltaRegistration();
      this.endUpdates();
      this.classifier = new Classifier(this);
    }
    nodes() {
      let results = [];
      let each = this.root.firstChild;
      while (each) {
        results.push(each);
        each = each.nextLineNode();
      }
      return results;
    }
    nodeCount() {
      if (!this._RBRoot) {
        return 0;
      }
      return this._RBRoot.totalLineCount();
    }
    nodeForID(id) {
      let each = this.root.nextLineNode();
      while (each) {
        if (each.id === id) {
          return each;
        }
        each = each.nextLineNode();
      }
      return void 0;
    }
    nodesForIDs(ids) {
      let nodes = [];
      let length = ids.length;
      for (let i3 = 0; i3 < length; i3++) {
        let node = this.nodeForID(ids[i3]);
        if (node) {
          nodes.push(node);
        }
      }
      return nodes;
    }
    firstLineNode() {
      return this.root.firstChild;
    }
    lastLineNode() {
      return this.root.lastDescendant();
    }
    _nextNodeID() {
      return `${this._lastNodeID++}`;
    }
    createNode(line, dontPreclassifiy) {
      let node = new Node(line, this);
      if (!dontPreclassifiy) {
        let taxonomy3 = this.taxonomy, startState = taxonomy3.startState();
        _createNodeClassifierText._setNode(node, null);
        taxonomy3.classify(_createNodeClassifierText, startState, startState);
        node._updateFromTaxonomyState(startState);
        node._taxonomyState = null;
      }
      return node;
    }
    createNodesFromLines(lines) {
      if (!Array.isArray(lines)) {
        lines = lines.split(Tree.NEW_LINE_REGEX);
      }
      let tree = new Tree(null, this.taxonomy), length = lines.length, i3;
      tree.beginUpdates();
      for (i3 = 0; i3 < length; i3++) {
        tree.insertNodeBefore(tree.createNode(lines[i3], true), null);
      }
      tree.endUpdates();
      tree.ensureClassified();
      let nodes = tree.root.descendants(), children = tree.root.children();
      length = children.length;
      for (i3 = 0; i3 < length; i3++) {
        this.adoptNode(children[i3]);
      }
      tree.cleanupForCollection();
      return { roots: children, all: nodes };
    }
    adoptNode(node) {
      if (node.tree !== this) {
        node.removeFromParent();
        while (node) {
          node.tree = this;
          node.id = this._nextNodeID();
          node._taxonomyState = null;
          node = node.nextLineNode();
        }
      }
    }
    evaluateNodePath(nodePath2) {
      if (!nodePath2) {
        return this.root.descendants();
      }
      return this.root.evaluateNodePath(nodePath2);
    }
    nodeToLineNumber(node) {
      if (!node || !node.isTracked || node === this.root) {
        return -1;
      }
      return super.nodeToLineNumber(node);
    }
    lineAndCharForTextOffset(textOffset) {
      if (textOffset === 0) {
        return { line: 0, ch: 0 };
      }
      let nodeOffset = this.textOffsetToNodeOffset(textOffset), line = this.nodeToLineNumber(nodeOffset.node);
      return { line, ch: nodeOffset.offset };
    }
    textOffsetForLineChar(line, char) {
      return this.nodeOffsetToTextOffset(this.lineNumberToNode(line), char);
    }
    insertNodeBefore(node, referenceNode) {
      let isDeltaRegistrationEnabled = this.isDeltaRegistrationEnabled();
      this.beginUpdates();
      node.removeFromParent();
      this.disableDeltaRegistration();
      let insertedNodes, insertingAtEnd = !referenceNode;
      if (isDeltaRegistrationEnabled) {
        insertedNodes = node.descendants();
        insertedNodes.splice(0, 0, node);
      }
      while (node.lastChild) {
        let lastChild = node.lastChild;
        this.insertNodeBefore(lastChild, referenceNode);
        referenceNode = lastChild;
      }
      let nodeParent = referenceNode ? referenceNode.previousLineNodeOrRoot() : this.root.lastDescendantOrSelf(), nodeNextSibling = nodeParent.firstChild, nodeParentStructureLevel = nodeParent._structureLevel, nodeStructureLevel = node._structureLevel, nextBranch = referenceNode;
      while (nodeParentStructureLevel >= nodeStructureLevel) {
        nodeNextSibling = nodeParent.nextSibling;
        nodeParent = nodeParent.parent;
        nodeParentStructureLevel = nodeParent._structureLevel;
      }
      if (nextBranch) {
        while (nextBranch && nextBranch._structureLevel > nodeStructureLevel) {
          if (nextBranch === nodeNextSibling) {
            nodeNextSibling = nextBranch.nextSibling;
          }
          let nextNextBranch = nextBranch.nextBranch();
          node.appendChild(nextBranch, true);
          nextBranch = nextNextBranch;
        }
      }
      nodeParent.insertChildBefore(node, nodeNextSibling, true);
      this.enableDeltaRegistration();
      if (isDeltaRegistrationEnabled) {
        let previous = node.previousLineNodeOrRoot(), firstNode = this.root.firstChild, insertedText = Node.formatNodes("txt", null, insertedNodes, false, false), fromLineCh, toLineCh, location;
        if (this.nodeCount() === 1) {
          location = 0;
        } else if (node === firstNode) {
          location = 0;
          insertedText = `${insertedText}
`;
        } else if (insertingAtEnd) {
          location = this.nodeOffsetToTextOffset(previous, previous.line().length);
          insertedText = `
${insertedText}`;
        } else {
          location = this.nodeOffsetToTextOffset(previous, previous.line().length + 1);
          insertedText = `${insertedText}
`;
        }
        fromLineCh = this.lineAndCharForTextOffset(location);
        toLineCh = fromLineCh;
        this.recordDelta(new _Delta(location, "", insertedText, fromLineCh, toLineCh, null, null, insertedNodes));
      }
      this.validate();
      this.endUpdates();
    }
    appendNode(node) {
      this.insertNodeBefore(node, null);
    }
    appendNodes(nodes) {
      this.beginUpdates();
      let length = nodes.length;
      for (let i3 = 0; i3 < length; i3++) {
        this.appendNode(nodes[i3]);
      }
      this.endUpdates();
    }
    insertNodesBefore(nodes, referenceNode) {
      let length = nodes.length;
      this.beginUpdates();
      for (let i3 = 0; i3 < length; i3++) {
        this.insertNodeBefore(nodes[i3], referenceNode);
      }
      this.endUpdates();
    }
    removeNode(node) {
      let isDeltaRegistrationEnabled = this.isDeltaRegistrationEnabled(), previousLineNode = node.previousLineNode(), nextLineNode = node.nextLineNode(), nextBranch = node.nextBranch(), fromLineCh, toLineCh, location;
      if (isDeltaRegistrationEnabled) {
        location = this.nodeOffsetToTextOffset(node, 0);
        fromLineCh = this.lineAndCharForTextOffset(location);
        toLineCh = { line: fromLineCh.line + 1, ch: 0 };
      }
      this.beginUpdates();
      this.disableDeltaRegistration();
      node.removeFromParent();
      while (node.firstChild) {
        this.insertNodeBefore(node.firstChild, nextBranch);
      }
      this.enableDeltaRegistration();
      if (isDeltaRegistrationEnabled) {
        let line = node.line();
        if (nextLineNode) {
          this.recordDelta(new _Delta(location, `${line}
`, "", fromLineCh, toLineCh, null, [node], null));
        } else if (previousLineNode) {
          fromLineCh.line--;
          fromLineCh.ch = previousLineNode.line().length;
          toLineCh.line--;
          toLineCh.ch = node.line().length;
          this.recordDelta(new _Delta(location - 1, `
${line}`, "", fromLineCh, toLineCh, null, [node], null));
        } else {
          toLineCh.line--;
          toLineCh.ch = node.line().length;
          this.recordDelta(new _Delta(location, line, "", fromLineCh, toLineCh, null, [node], null));
        }
      }
      this.endUpdates();
      this.validate();
    }
    removeNodes(nodes) {
      let length = nodes.length;
      this.beginUpdates();
      for (let i3 = 0; i3 < length; i3++) {
        this.removeNode(nodes[i3]);
      }
      this.endUpdates();
    }
    text() {
      let textLength = this.textLength();
      if (textLength === 0) {
        return "";
      }
      return this.textInRange(this.createRangeFromLocation(0, textLength));
    }
    textLength() {
      if (!this._RBRoot) {
        return 0;
      }
      return this._RBRoot.totalLength() - 1;
    }
    textInRange(range2) {
      return this._nodesAndTextSegmentsInRange(range2).lines.join("\n");
    }
    setText(newText) {
      if (newText !== null) {
        return this.replaceTextInRange(this.createRangeFromLocation(0, this.textLength()), newText);
      }
      let isDeltaRegistrationEnabled = this.isDeltaRegistrationEnabled(), root = this.root, lastLineNode = this.lastLineNode(), removedNodes, fromLineCh, toLineCh, oldText;
      if (isDeltaRegistrationEnabled) {
        removedNodes = this.root.descendants();
        fromLineCh = { line: 0, ch: 0 };
        toLineCh = {
          line: this.nodeCount() - 1,
          ch: lastLineNode ? lastLineNode.line().length : 0
        };
        oldText = this.text();
      }
      this.beginUpdates();
      this.disableDeltaRegistration();
      while (root.firstChild) {
        root.firstChild.removeFromParent();
      }
      this.enableDeltaRegistration();
      if (isDeltaRegistrationEnabled) {
        this.recordDelta(new _Delta(0, oldText, "", fromLineCh, toLineCh, null, removedNodes, null));
      }
      this.endUpdates();
    }
    _nodesAndTextSegmentsInRange(range2) {
      if (!this.root.firstChild) {
        return { lines: [], nodes: [] };
      }
      let startNode = range2.startNode, endNode = range2.endNode, nodes = [startNode], lines = [];
      if (startNode === endNode) {
        let startLine = startNode.line();
        if (range2.length() === startLine.length + 1) {
          lines.push(`${startLine}
`);
        } else {
          lines.push(startLine.substr(range2.startOffset, range2.length()));
        }
      } else {
        let head = startNode.line().substr(range2.startOffset);
        let tail = endNode.lineInRange(0, range2.endOffset);
        let each = startNode.nextLineNode();
        lines.push(head);
        while (each !== endNode) {
          lines.push(each.line());
          nodes.push(each);
          each = each.nextLineNode();
        }
        lines.push(tail);
        nodes.push(endNode);
      }
      return { lines, nodes };
    }
    replaceTextInRange(range2, insertedText) {
      this.replaceTextInRanges([range2], insertedText);
    }
    replaceCharactersInRange(location, length, insertedText) {
      this.replaceTextInRange(insertedText, this.createRangeFromLocation(location, length));
    }
    replaceTextInRanges(ranges, insertedText) {
      this.beginUpdates();
      let length = ranges.length;
      for (let i3 = 0; i3 < length; i3++) {
        let eachRange = ranges[i3];
        if (i3 === 0) {
          this._replaceTextInRangeImplementation(eachRange, insertedText);
        } else {
          this._replaceTextInRangeImplementation(eachRange, "");
        }
      }
      this.endUpdates();
    }
    _replaceTextInRangeImplementation(range2, insertedText) {
      let isDeltaRegistrationEnabled = this.isDeltaRegistrationEnabled(), rangeLength = range2.length(), rangeLocation = range2.location(), fromLineCh = this.lineAndCharForTextOffset(rangeLocation), toLineCh = this.lineAndCharForTextOffset(rangeLocation + rangeLength), startNode = range2.startNode, startLine = startNode.line(), startOffset = range2.startOffset, effectedNodes = range2.nodesInRange(), effectedNodesLength = effectedNodes.length, nodeAfterEndNode = range2.nodeAfterEndNode(), oldLines = range2.linesInRange(), oldLinesText = oldLines.join("\n"), newLinesText = oldLinesText.slice(0, startOffset) + insertedText + oldLinesText.slice(startOffset + rangeLength), newLines = newLinesText.split(Tree.NEW_LINE_REGEX), newLinesLength = newLines.length, updatedNode = null, insertedNodes = [], each, j3;
      this.disableDeltaRegistration();
      updatedNode = startNode;
      if (newLines.length === 1 && effectedNodes.length === 1) {
        startNode.replaceLineInRange(insertedText, startOffset, range2.endOffset - startOffset);
      } else {
        startNode.replaceLineInRange(newLines[0].substr(startOffset), startOffset, startLine.length - startOffset);
      }
      for (j3 = effectedNodesLength - 1; j3 > 0; j3--) {
        this.removeNode(effectedNodes[j3]);
      }
      for (j3 = 1; j3 < newLinesLength; j3++) {
        each = this.createNode(newLines[j3], true);
        insertedNodes.push(each);
        this.insertNodeBefore(each, nodeAfterEndNode);
      }
      this.enableDeltaRegistration();
      if (isDeltaRegistrationEnabled) {
        effectedNodes.shift();
        this.recordDelta(new _Delta(rangeLocation, oldLinesText.substr(startOffset, rangeLength), insertedText, fromLineCh, toLineCh, updatedNode, effectedNodes, insertedNodes));
      }
    }
    appendText(text) {
      let range2 = this.createRangeFromLocation(this.textLength(), 0);
      this.replaceTextInRange(range2, text);
    }
    nodeOffsetToTextOffset(node, offset) {
      if (offset === -1) {
        offset = node.line().length + 1;
        if (node === this.lastLineNode()) {
          offset--;
        }
      }
      return this._RBTextOffsetOfNode(node) + offset;
    }
    textOffsetToNodeOffset(textOffset) {
      let _RBRoot = this._RBRoot;
      if (!_RBRoot || textOffset > _RBRoot.totalLength() || textOffset < 0) {
        return null;
      }
      let node = this._RBNodeAtTextOffset(textOffset);
      return {
        node,
        offset: textOffset - this._RBTextOffsetOfNode(node)
      };
    }
    isUpdating() {
      return this._updateCount !== 0;
    }
    beginUpdates() {
      if (this._updateCount === 0) {
        this._deltas = [];
        this._previousParents = {};
      }
      this._updateCount++;
    }
    endUpdates() {
      this._updateCount--;
      if (this._updateCount === 0) {
        let previousParents = this._previousParents, deltas = this._deltas, length = deltas.length;
        this._tagsCache = null;
        this._parsedTagsCache = null;
        this._deltas = void 0;
        this._previousParents = void 0;
        this.validate();
        if (length !== 0) {
          this._dispatchEvent("treeChanged", new _TreeChangedEvent(this, deltas, previousParents));
        }
      }
    }
    isDeltaRegistrationEnabled() {
      return this._deltaRegistrationDisabled === 0;
    }
    disableDeltaRegistration() {
      this._deltaRegistrationDisabled++;
    }
    enableDeltaRegistration() {
      this._deltaRegistrationDisabled--;
    }
    recordDelta(delta) {
      if (this.isDeltaRegistrationEnabled()) {
        this._deltas.push(delta);
        this.classifier._invalidateLinesForDelta(delta);
      }
    }
    _nodeWillBeInsertedBeforeNode(node, referenceNode) {
      let isDeltaRegistrationEnabled = this.isDeltaRegistrationEnabled(), insertedNodes = isDeltaRegistrationEnabled ? [] : null, each = node;
      while (each) {
        if (insertedNodes) {
          insertedNodes.push(each);
        }
        each.isTracked = true;
        each = each.nextLineNode();
      }
      if (isDeltaRegistrationEnabled) {
        let insertedText = Node.formatNodes("txt", null, insertedNodes, false, false), replacedText = "", fromLineCh, toLineCh, location;
        if (referenceNode) {
          location = this.nodeOffsetToTextOffset(referenceNode, 0);
          insertedText = `${insertedText}
`;
        } else {
          let insertAfter = this.root.lastDescendant();
          if (insertAfter) {
            location = this.nodeOffsetToTextOffset(insertAfter, -1);
            insertedText = `
${insertedText}`;
          } else {
            location = 0;
          }
        }
        fromLineCh = this.lineAndCharForTextOffset(location);
        toLineCh = fromLineCh;
        this.recordDelta(new _Delta(location, replacedText, insertedText, fromLineCh, toLineCh, null, null, insertedNodes));
      }
      if (this.root !== node) {
        each = node;
        while (each) {
          this._RBInsertLineBefore(each, referenceNode);
          each = each.nextLineNode();
        }
      }
    }
    _nodeWasInserted() {
    }
    _nodeWillBeRemoved(node) {
      let isDeltaRegistrationEnabled = this.isDeltaRegistrationEnabled(), removedNodes = isDeltaRegistrationEnabled ? [] : null, lastDescendantOrSelf = node.lastDescendantOrSelf(), each = node, fromLineCh, toLineCh, fromLocation, toLocation;
      if (isDeltaRegistrationEnabled) {
        fromLocation = this.nodeOffsetToTextOffset(node, 0);
        fromLineCh = this.lineAndCharForTextOffset(fromLocation);
        toLocation = this.nodeOffsetToTextOffset(lastDescendantOrSelf, lastDescendantOrSelf.line().length);
        toLineCh = this.lineAndCharForTextOffset(toLocation);
      }
      while (each) {
        if (removedNodes) {
          removedNodes.push(each);
        }
        this._RBRemoveLine(each);
        each.isTracked = false;
        if (each === lastDescendantOrSelf) {
          each = null;
        } else {
          each = each.nextLineNode();
        }
      }
      if (isDeltaRegistrationEnabled) {
        let lastNode = this.root.lastDescendantOrSelf(), lastRemovedNode = node.lastDescendantOrSelf(), replacedText = Node.formatNodes("txt", null, removedNodes, false, false), firstNodeRemoved = node === this.root.firstChild, lastNodeRemoved = lastNode === lastRemovedNode, insertedText = "";
        if (lastNodeRemoved) {
          if (!firstNodeRemoved) {
            replacedText = `
${replacedText}`;
            fromLineCh.line--;
            fromLineCh.ch = node.previousLineNode().line().length;
            fromLocation--;
          }
        } else {
          replacedText = `${replacedText}
`;
          toLineCh.line++;
          toLineCh.ch = 0;
          toLocation++;
        }
        this.recordDelta(new _Delta(fromLocation, replacedText, insertedText, fromLineCh, toLineCh, null, removedNodes, null));
      }
    }
    _nodeLineWasUpdated(node, location, replacedText, insertedText) {
      if (this.isDeltaRegistrationEnabled()) {
        location = location || 0;
        let textStart = node.lineTextStart() + location, length = replacedText === void 0 ? node.line().length : replacedText.length, fromLineCh = { line: node.lineNumber(), ch: location }, toLineCh = { line: fromLineCh.line, ch: location + length };
        this.recordDelta(new _Delta(textStart, replacedText, insertedText, fromLineCh, toLineCh, node, null, null));
      }
    }
    createRangeFromNodes(startNode, startOffset, endNode, endOffset, anchoredAtEnd) {
      if (startOffset === -1) {
        startOffset = startNode.line().length;
      }
      if (endOffset === -1) {
        endOffset = endNode.line().length;
      }
      return new Range(this, startNode, startOffset, endNode, endOffset, anchoredAtEnd);
    }
    createRangeFromString(rangeString, defaultLocation, defaultLength, anchoredAtEnd) {
      let rangeComponents = rangeString.split(",");
      if (defaultLocation === void 0) {
        defaultLocation = "0";
      }
      if (defaultLength === void 0) {
        defaultLength = "0";
      }
      return this.createRangeFromLocation(parseInt(rangeComponents[0] || defaultLocation, 10), parseInt(rangeComponents[1] || defaultLength, 10), anchoredAtEnd);
    }
    createRangeFromLineChs(startLineCh, endLineCh, anchoredAtEnd) {
      let startNode = this.lineNumberToNode(startLineCh.line), endNode;
      if (!endLineCh) {
        endLineCh = startLineCh;
      }
      if (startLineCh.line === endLineCh.line) {
        endNode = startNode;
      } else {
        endNode = this.lineNumberToNode(endLineCh.line);
        if (!endNode) {
          endNode = this.lastLineNode();
          endLineCh.ch = endNode.line().length;
        }
      }
      return this.createRangeFromNodes(startNode, startLineCh.ch, endNode, endLineCh.ch, anchoredAtEnd);
    }
    createRangeFromAnchoreAndHeadLineChs(anchor, head) {
      let headNode = this.lineNumberToNode(head.line), anchorNode;
      if (head.line === anchor.line) {
        anchorNode = headNode;
      } else {
        anchorNode = this.lineNumberToNode(anchor.line);
        if (!anchorNode) {
          anchorNode = this.lastLineNode();
          anchor.ch = anchorNode.line().length;
        }
      }
      if (anchor.line < head.line || anchor.line === head.line && anchor.ch < head.ch) {
        return this.createRangeFromNodes(anchorNode, anchor.ch, headNode, head.ch, false);
      }
      return this.createRangeFromNodes(headNode, head.ch, anchorNode, anchor.ch, true);
    }
    createRangeFromLocation(location, length, anchoredAtEnd) {
      if (!this.root.firstChild) {
        this.root.appendChild(this.createNode("", true));
      }
      if (location === void 0) {
        location = 0;
      }
      if (location === -1) {
        location = this.textLength();
      }
      if (length === void 0) {
        length = 0;
      }
      if (length === -1) {
        length = this.textLength() - location;
      }
      let startNodeOffset = this.textOffsetToNodeOffset(location), endNodeOffset = this.textOffsetToNodeOffset(location + length);
      if (startNodeOffset && endNodeOffset) {
        return new Range(this, startNodeOffset.node, startNodeOffset.offset, endNodeOffset.node, endNodeOffset.offset, anchoredAtEnd);
      }
      return null;
    }
    ensureClassified(fromNode, toNode) {
      this.classifier.ensureClassified(fromNode, toNode);
      this.validate();
    }
    reClassifyAll() {
      this.classifier.reClassifyAll();
      this.validate();
    }
    setReadOnly(value) {
      this.readOnly = value;
    }
    isReadOnly() {
      return this.readOnly;
    }
    tags(onlyIncludeParsedTags) {
      let tagsCache = onlyIncludeParsedTags ? this._parsedTagsCache : this._tagsCache;
      if (!tagsCache) {
        let each = this.root.firstChild, treeTags = {}, eachTags, eachKeys, eachKey, length, i3;
        while (each) {
          eachTags = each.tags();
          if (eachTags) {
            const attributeRuns = each.lineAttributedString().attributeRuns();
            const attributeRunsLength = attributeRuns.length;
            let j3;
            eachKeys = Object.keys(eachTags);
            length = eachKeys.length;
            for (i3 = 0; i3 < length; i3++) {
              eachKey = eachKeys[i3];
              if (onlyIncludeParsedTags) {
                for (j3 = 0; j3 < attributeRunsLength; j3++) {
                  if (attributeRuns[j3].attributes.tagname === eachKey) {
                    treeTags[eachKey] = eachKey;
                    break;
                  }
                }
              } else {
                treeTags[eachKey] = eachKey;
              }
            }
          }
          each = each.nextLineNode();
        }
        tagsCache = Object.keys(treeTags);
        if (onlyIncludeParsedTags) {
          this._parsedTagsCache = tagsCache;
        } else {
          this._tagsCache = tagsCache;
        }
      }
      return tagsCache;
    }
    links() {
      const node = this.root.firstChild;
      let allLinks = [];
      for (let eachNode = node; eachNode !== null; eachNode = eachNode.nextLineNode()) {
        const links = eachNode.links();
        if (links.length > 0)
          allLinks = allLinks.concat(links);
      }
      return allLinks.flat();
    }
    metadata() {
      let node = this.root.firstChild;
      let allMetadata = {};
      const metadataTypes = [
        "metadatatopboundary",
        "metadata",
        "metadatabottomboundary"
      ];
      while (node && metadataTypes.indexOf(node.type()) >= 0) {
        let metadata = node.metadata();
        allMetadata = Object.assign(allMetadata, metadata);
        node = node.nextLineNode();
      }
      return allMetadata;
    }
    addMetadata(name106, value) {
      let node = this.root.firstChild;
      const metadataLineContent = `${name106}: ${value}
`;
      const metadataTypes = [
        "metadatatopboundary",
        "metadata",
        "metadatabottomboundary"
      ];
      let metadataFound = false;
      while (node && metadataTypes.indexOf(node.type()) >= 0) {
        metadataFound = true;
        node = node.nextLineNode();
      }
      if (!node) {
        return this.appendText(`
${metadataLineContent}
`);
      }
      if (node.previousLineNode() && node.previousLineNode().type() === "metadatabottomboundary") {
        node = node.previousLineNode();
      }
      const range2 = this.createRangeFromNodes(node, 0, node, 0);
      let textToReplace = metadataLineContent;
      if (!metadataFound) {
        textToReplace = `${metadataLineContent}
`;
      }
      this.replaceTextInRange(range2, textToReplace);
    }
    cleanupForCollection() {
      this.removeAllListeners("treeChanged");
      if (this.classifier) {
        this.classifier.cleanupForCollection();
      }
    }
    suggestNameFromContent() {
      let each = this.root.firstChild;
      let backup = null;
      let headingSuggestion = null;
      const blessedTypes = ["heading", "body"];
      while (each) {
        let eachText = each.text();
        if (eachText.length > 0) {
          if (each.type() === "heading") {
            headingSuggestion = eachText;
            if (each.nextSibling)
              return headingSuggestion;
          } else if (!backup && blessedTypes.includes(each.type())) {
            if (headingSuggestion)
              return headingSuggestion;
            backup = eachText;
          }
        }
        each = each.nextSibling;
      }
      return headingSuggestion || backup;
    }
    getExcerpt() {
      for (let each = this.firstLineNode(); each !== null; each = each.nextLineNode()) {
        if (["body", "blockquote", "unordered", "ordered"].includes(each.type())) {
          return each.textWithoutSyntax();
        }
      }
      return "";
    }
    validate() {
      if (debug2) {
        let each = this.firstLineNode(), nodeCount = 0, textLength = 0;
        if (!each) {
          textLength++;
        }
        while (each) {
          nodeCount++;
          textLength += each.line().length + 1;
          ok4(each._RBNextLineNode() === each.nextLineNode(), "Next line traversal should be same in both node and RBTrees");
          ok4(each._RBPreviousLineNode() === each.previousLineNode(), "Previous line traversal should be same in both node and RBTrees");
          ok4(each._structureLevel > each.parent._structureLevel, "Structure level must be greater then parents structure level");
          each = each.nextLineNode();
        }
        textLength--;
        ok4(textLength === this.textLength(), "Actual text length must match RBTree text length");
        ok4(nodeCount === this.nodeCount(), "Actual lines length must match RBTree lines length");
      }
    }
    toJson() {
      return {
        metadata: this.metadata(),
        tags: this.tags(),
        links: this.links(),
        root: this.root.branchToJson()
      };
    }
    toString(rbTree) {
      let lines = [];
      if (rbTree) {
        let root = this._RBRoot;
        if (root) {
          lines.push(`Binary Search Tree [lineCount: ${root.totalLineCount()}]`);
          this._RBPreorderTraverse(root, (each) => {
            lines.push(each.toString(true));
          });
        }
      } else {
        lines.push("\n\u250C Tree");
        lines.push(this.root.branchToString(1));
        if (this._deltas && this._deltas.length > 0) {
          lines.push("Text Deltas [");
          let length = this._deltas.length, i3;
          for (i3 = 0; i3 < length; i3++) {
            lines.push(this._deltas[i3].toString());
          }
          lines.push("]");
        }
      }
      return lines.join("\n");
    }
    static stringByNormalizingLineEndings(string2) {
      if (string2 === null || string2 === void 0) {
        return string2;
      }
      return string2.split(Tree.NEW_LINE_REGEX).join("\n");
    }
  };
  implement(Tree.prototype, _EventEmitter);
  var _createNodeClassifierText = new _ClassifierText();
  Tree.NEW_LINE_REGEX = /\u000d(?:\u000a)?|\u000a|\u2029|\u000c|\u0085/;

  // src/ft/extensions/cutcopypaste.js
  function cut(clipboard) {
    this.copy(clipboard);
    this.replaceSelections("", "end", "cut");
  }
  function copy(clipboard) {
    let selectedRanges = this.selectedRanges(), selectedTextAndFolds = [], selectedText = [];
    for (let i3 = 0; i3 < selectedRanges.length; i3++) {
      let eachRange = selectedRanges[i3], eachText = eachRange.textInRange(), eachFolds = this.foldsInRange(eachRange), eachFoldsJSON = this.foldsToJSON(eachFolds);
      this.normalizeFoldsJSON(eachFoldsJSON, eachRange.startLineCh());
      selectedText.push(eachText);
      selectedTextAndFolds.push({
        text: eachText,
        folds: eachFoldsJSON
      });
    }
    clipboard.setData("text/plain", selectedText.join("\n"));
    clipboard.setData("com.foldingtext.FoldingText", JSON.stringify(selectedTextAndFolds));
  }
  function paste(clipboard) {
    let selectedRanges = this.selectedRanges(), pastedText = clipboard.getData("text/plain"), pastedTextAndFoldsJSON = clipboard.getData("com.foldingtext.FoldingText");
    if (pastedTextAndFoldsJSON) {
      let pastedTextAndFolds = JSON.parse(pastedTextAndFoldsJSON), pastedTextAndFoldsLength = pastedTextAndFolds.length, foldOffset = { line: 0, ch: 0 }, each, eachFolds, eachTextLines, i3;
      if (pastedTextAndFolds.length !== selectedRanges.length) {
        let consolidatedPastedText = [], consolidatedPastedFolds = [];
        for (i3 = 0; i3 < pastedTextAndFoldsLength; i3++) {
          each = pastedTextAndFolds[i3];
          eachTextLines = Tree.stringByNormalizingLineEndings(each.text).split("\n");
          eachFolds = each.folds;
          consolidatedPastedText = consolidatedPastedText.concat(eachTextLines);
          this.perpareNormalizedFoldsJSONForDestination(eachFolds, foldOffset);
          consolidatedPastedFolds = consolidatedPastedFolds.concat(eachFolds);
          foldOffset.line += eachTextLines.length;
        }
        pastedTextAndFolds = [];
        for (i3 = 0; i3 < selectedRanges.length; i3++) {
          pastedTextAndFolds.push({
            text: consolidatedPastedText.join("\n"),
            folds: JSON.parse(JSON.stringify(consolidatedPastedFolds))
          });
        }
      }
      foldOffset.line = 0;
      foldOffset.ch = 0;
      let pastedFolds = [], pastedTexts = [];
      for (i3 = 0; i3 < pastedTextAndFolds.length; i3++) {
        let destinationRange = selectedRanges[i3], destinationLineCh = destinationRange.startLineCh(), eachTextAndFolds = pastedTextAndFolds[i3], textLines = Tree.stringByNormalizingLineEndings(eachTextAndFolds.text).split("\n"), foldsJSON = eachTextAndFolds.folds;
        destinationLineCh.line += foldOffset.line;
        foldsJSON = this.perpareNormalizedFoldsJSONForDestination(foldsJSON, destinationLineCh);
        pastedTexts.push(eachTextAndFolds.text);
        pastedFolds = pastedFolds.concat(foldsJSON);
        foldOffset.line += textLines.length - 1;
      }
      this.replaceSelections(pastedTexts, "end", "paste");
      this.restoreJSONFolds(pastedFolds);
    } else if (pastedText !== null) {
      this.replaceSelections(Tree.stringByNormalizingLineEndings(pastedText).split("\n"), "end", "paste");
    }
  }
  Extensions.add("com.foldingtext.editor.methods", {
    cut,
    copy,
    paste
  });
  Extensions.addInit((editor2) => {
    let cm = editor2.cm();
    cm.on("cut", (cm2, e5) => {
      e5.preventDefault();
      editor2.cut(e5.clipboardData);
    });
    cm.on("copy", (cm2, e5) => {
      e5.preventDefault();
      editor2.copy(e5.clipboardData);
    });
    cm.on("paste", (cm2, e5) => {
      e5.preventDefault();
      editor2.paste(e5.clipboardData);
    });
  });

  // src/ft/extensions/dragdrop.js
  init_extensions();
  Extensions.addInit((editor2) => {
    let dropIndicatorDiv = document.createElement("div"), draggedTextMarkers, cm = editor2.cm();
    dropIndicatorDiv.className = "CodeMirror-dropIndicator";
    cm.on("dragstart", (cm2, e5) => {
      e5.dataTransfer.effectAllowed = "copyMove";
      draggedTextMarkers = [];
      cm2.operation(() => {
        cm2.listSelections().forEach((each) => {
          draggedTextMarkers.push(cm2.markText(each.anchor, each.head));
        });
      });
    });
    cm.on("dragend", (cm2, e5) => {
      cm2.operation(() => {
        draggedTextMarkers.forEach((each) => {
          if (e5.dataTransfer.dropEffect === "move") {
            let range2 = each.find();
            if (range2) {
              cm2.replaceRange("", range2.from, range2.to, "+paste");
            }
          }
          each.clear();
        });
        draggedTextMarkers = void 0;
      });
    });
    function showDragIndicator() {
      if (!dropIndicatorDiv.parentNode) {
        cm.display.lineSpace.appendChild(dropIndicatorDiv);
      }
    }
    function removeDragIndicator() {
      if (dropIndicatorDiv.parentNode) {
        dropIndicatorDiv.parentNode.removeChild(dropIndicatorDiv);
      }
    }
    cm.on("dragenter", (cm2, e5) => {
      showDragIndicator(e5);
    });
    cm.on("dragover", (cm2, e5) => {
      let lineCh = editor2.targetsAt(e5.clientX, e5.clientY).lineCh, coords = editor2.cursorCoords(lineCh, "div");
      if (cm2.state.draggingText && cm2.doc.sel.contains(lineCh) > -1) {
        e5.dataTransfer.dropEffect = "none";
        removeDragIndicator(e5);
      } else {
        dropIndicatorDiv.style.left = `${coords.left}px`;
        dropIndicatorDiv.style.top = `${coords.top}px`;
        dropIndicatorDiv.style.height = `${Math.max(0, coords.bottom - coords.top) * cm2.options.cursorHeight}px`;
        showDragIndicator(e5);
      }
    });
    cm.on("dragleave", (cm2, e5) => {
      removeDragIndicator(e5);
    });
    cm.on("drop", (cm2, e5) => {
      removeDragIndicator(e5);
    });
  });

  // src/ft/extensions/findreplace.js
  var import_searchcursor = __toModule(require_searchcursor());

  // src/codemirror.js
  var import_codemirror3 = __toModule(require_codemirror());
  if (typeof window === "undefined") {
    window = {};
  }
  Promise.resolve().then(() => __toModule(require_dialog()));
  Promise.resolve().then(() => __toModule(require_rulers()));
  Promise.resolve().then(() => __toModule(require_closebrackets()));
  Promise.resolve().then(() => __toModule(require_active_line()));
  Promise.resolve().then(() => __toModule(require_match_highlighter()));
  Promise.resolve().then(() => __toModule(require_search()));
  Promise.resolve().then(() => __toModule(require_searchcursor()));
  Promise.resolve().then(() => __toModule(require_emacs()));
  Promise.resolve().then(() => __toModule(require_sublime()));
  Promise.resolve().then(() => __toModule(require_meta()));

  // src/ft/extensions/panel.js
  init_extensions();
  var Panel = function(editor2) {
    let panelElement = document.querySelector(".panel");
    if (!panelElement) {
      panelElement = document.createElement("div");
      panelElement.className = "panel";
    }
    this._panelElement = panelElement;
    this._editor = editor2;
    this._panelEditor = this.createPanelEditor();
    this._ignorePanelEditorChanges = 0;
    this._fields = [];
    let outerThis = this;
    this._panelEditor.addKeyMap({
      Esc() {
        outerThis.hide();
        outerThis._editor.focus();
      },
      Enter() {
        outerThis.returnPressed(false);
      },
      "Shift-Enter"() {
        outerThis.returnPressed(true);
      },
      Tab() {
        outerThis.tabPressed(false);
      },
      "Shift-Tab"() {
        outerThis.tabPressed(true);
      },
      "Option-Tab"() {
        outerThis._panelEditor.execCommand("indent");
      }
    });
    this._panelEditor.on("change", this._panelEditorContentChanged.bind(this));
  };
  (function() {
    this.createPanelEditor = function createPanelEditor() {
      return new import_codemirror3.default(this._panelElement, {
        value: "",
        lineWrapping: true,
        indentWithTabs: true,
        viewportMargin: Infinity,
        undoDepth: Infinity,
        indentUnit: 4,
        autoIndent: false,
        fieldsController: this,
        isFieldEditor: true
      });
    };
    this.show = function show() {
      let panelElement = this._panelElement;
      if (!panelElement.parentElement) {
        document.body.appendChild(panelElement);
      }
    };
    this.hide = function hide() {
      let panelElement = this._panelElement;
      if (panelElement.parentElement) {
        panelElement.parentElement.removeChild(panelElement);
      }
      this._editor.focus();
    };
    this.remove = function remove() {
      this.hide();
      this._editor._panel = null;
    };
    this.hasField = function hasField(id) {
      for (let i3 = this._fields.length - 1; i3 >= 0; i3--) {
        if (this._fields[i3].id === id) {
          return true;
        }
      }
      return false;
    };
    this.addField = function addField(field) {
      let Pos = import_codemirror3.default.Pos, id = field.id, label = field.label, value = field.value, index2 = field.index !== void 0 ? field.index : -1, panelEditor = this._panelEditor, prevField = index2 > 0, posToInsertField = new Pos(panelEditor.firstLine(), 0), marker = null;
      if (prevField) {
        posToInsertField = this.posOfFieldValue(index2 - 1, false);
      }
      this._ignorePanelEditorChanges++;
      panelEditor.replaceRange(`${label} ${value}`, posToInsertField);
      let indexOfInsert = panelEditor.indexFromPos(posToInsertField), indexOfStart = indexOfInsert + 0, indexOfEnd = indexOfStart + label.length, posMarkStart = panelEditor.posFromIndex(indexOfStart), posMarkEnd = panelEditor.posFromIndex(indexOfEnd);
      marker = panelEditor.doc.markText(posMarkStart, posMarkEnd, {
        atomic: true,
        readOnly: true,
        inclusiveLeft: true,
        inclusiveRight: true,
        className: "field"
      });
      if (marker) {
        let newField = {
          id,
          marker,
          onChange: field.onChange
        };
        if (index2 < 0) {
          this._fields.push(newField);
        } else {
          this._fields.splice(index2, 0, newField);
        }
        newField.value = this._getFieldValueFromEditor(id);
      } else {
        console.error("Cannot add marker: ", field);
      }
      this._ignorePanelEditorChanges--;
    };
    this.removeField = function removeField(idOrIndex) {
      if (typeof idOrIndex === "string") {
        idOrIndex = this.indexFromID(idOrIndex);
      }
      if (idOrIndex === -1) {
        return;
      }
      this._ignorePanelEditorChanges++;
      let panelEditor = this._panelEditor, startRange = this.posOfFieldMarker(idOrIndex, true), endRange = this.posOfFieldValue(idOrIndex, false), endRangeLine = panelEditor.getLine(endRange.line), field = this._fields.splice(idOrIndex, 1);
      if (startRange.ch === 0 && startRange.line > 0) {
        startRange = panelEditor.posFromIndex(panelEditor.indexFromPos(startRange) - 1);
      }
      if (endRange.ch >= endRangeLine.length - 1) {
        endRange = panelEditor.posFromIndex(panelEditor.indexFromPos(endRange) + 1);
      }
      field[0].marker.clear();
      panelEditor.replaceRange("", startRange, endRange);
      this._ignorePanelEditorChanges--;
    };
    this.posOfFieldMarker = function posOfFieldMarker(index2, start2) {
      let field = this._fields[index2], marker = field.marker, pos = marker.find();
      if (start2) {
        return pos.from;
      }
      return pos.to;
    };
    this.posOfFieldValue = function posOfFieldValue(index2, start2) {
      let panelEditor = this._panelEditor;
      if (start2) {
        let markEnd = this.posOfFieldMarker(index2, false);
        markEnd = panelEditor.posFromIndex(panelEditor.indexFromPos(markEnd) + 1);
        return markEnd;
      }
      let lastLine = panelEditor.getLine(panelEditor.lastLine()), nextFieldStart = new import_codemirror3.default.Pos(panelEditor.lastLine(), lastLine.length), fields = this._fields, hasNextField = fields.length > index2 + 1;
      if (hasNextField) {
        nextFieldStart = this.posOfFieldMarker(index2 + 1, true);
        nextFieldStart = panelEditor.posFromIndex(panelEditor.indexFromPos(nextFieldStart) - 1);
      }
      return nextFieldStart;
    };
    this._getFieldValueFromEditor = function _getFieldValueFromEditor(idOrIndex) {
      if (typeof idOrIndex === "string") {
        idOrIndex = this.indexFromID(idOrIndex);
      }
      if (idOrIndex < 0) {
        return null;
      }
      let start2 = this.posOfFieldValue(idOrIndex, true), end = this.posOfFieldValue(idOrIndex, false);
      let value = this._panelEditor.getRange(start2, end);
      return value.replace(/[\n]+$/, "");
    };
    this.fieldValue = function fieldValue(idOrIndex) {
      if (typeof idOrIndex === "string") {
        idOrIndex = this.indexFromID(idOrIndex);
      }
      if (idOrIndex < 0) {
        return null;
      }
      let field = this._fields[idOrIndex];
      if (field.value) {
        return field.value;
      }
      field.value = this._getFieldValueFromEditor(idOrIndex);
      return field.value;
    };
    this.indexFromID = function indexFromID(id) {
      for (let i3 = this._fields.length - 1; i3 >= 0; i3--) {
        let field = this._fields[i3];
        if (field.id === id) {
          return i3;
        }
      }
      return -1;
    };
    this._panelEditorContentChanged = function _panelEditorContentChanged() {
      if (this._ignorePanelEditorChanges > 0) {
        return;
      }
      let fields = this._fields, fieldCount = fields.length;
      for (let i3 = 0; i3 < fieldCount; i3++) {
        let field = fields[i3], oldValue = field.value, newValue = this._getFieldValueFromEditor(i3);
        if (oldValue !== newValue) {
          field.value = newValue;
          if (field.onChange) {
            field.onChange(oldValue, newValue);
          }
          import_codemirror3.default.signal(this, "fieldvaluechanged", {
            from: oldValue,
            to: newValue,
            id: field.id
          });
        }
      }
    };
    this.focus = function focus(nthField, selectAll) {
      this._panelEditor.focus();
      if (nthField !== void 0 && nthField >= 0) {
        this._focusField(nthField, selectAll);
      }
    };
    this._focusField = function _focusField(index2, selectAll) {
      if (index2 < 0) {
        index2 = 0;
      }
      if (index2 >= this._fields.length) {
        index2 = this._fields.length - 1;
      }
      if (selectAll) {
        this._panelEditor.setSelection(this.posOfFieldValue(index2, true), this.posOfFieldValue(index2, false));
      } else {
        this._panelEditor.setCursor(this.posOfFieldValue(index2, true));
      }
    };
    this.currentlyActiveField = function currentlyActiveField() {
      let selStart = this._panelEditor.getCursor("start");
      for (let i3 = 0; i3 < this._fields.length; i3++) {
        let start2 = this.posOfFieldValue(i3, true), end = this.posOfFieldValue(i3, false);
        if (selStart.line >= start2.line && selStart.ch >= start2.ch && selStart.line <= end.line && selStart.ch <= end.ch) {
          return i3;
        }
      }
      return -1;
    };
    this.returnPressed = function returnPressed(withShiftKey) {
      let fieldIndex = this.currentlyActiveField();
      if (fieldIndex < 0) {
        return;
      }
      let field = this._fields[fieldIndex];
      import_codemirror3.default.signal(this, "returnpressed", {
        id: field.id,
        shiftKey: withShiftKey || false
      });
    };
    this.tabPressed = function tabPressed(withShiftKey) {
      let active = this.currentlyActiveField();
      if (withShiftKey) {
        if (active > 0) {
          this._focusField(active - 1);
        } else if (active === 0) {
          this._editor.focus();
        }
      } else {
        let lastFieldIndex = this._fields.length - 1;
        if (active < lastFieldIndex) {
          this._focusField(active + 1);
        } else if (active === lastFieldIndex) {
          this._editor.focus();
        }
      }
    };
  }).call(Panel.prototype);
  Extensions.add("com.foldingtext.editor.methods", {
    panel() {
      let panel = this._panel;
      if (!this._panel) {
        panel = new Panel(this);
        this._panel = panel;
      }
      return panel;
    }
  });

  // src/ft/extensions/findreplace.js
  init_extensions();
  var FindReplace = function FindReplace2(editor2) {
    this._editor = editor2;
    this._searchCursor = null;
  };
  (function() {
    this.searchCursor = function searchCursor() {
      return this._searchCursor;
    };
    this.findImplementation = function findImplementation(direction, cm) {
      let forward = direction !== "reverse", Pos = import_codemirror3.default.Pos, selectionStart = cm.doc.getCursor("start"), selectionEnd = cm.doc.getCursor("end"), currentPosition = forward ? selectionEnd : selectionStart, query = this._editor.panel().fieldValue("find"), caseSensitive = query.toLowerCase() !== query, searchCursor = cm.getSearchCursor(query, currentPosition, !caseSensitive);
      if (!searchCursor.find(!forward)) {
        searchCursor = cm.getSearchCursor(query, forward ? new Pos(cm.firstLine(), 0) : new Pos(cm.lastLine()), !caseSensitive);
        if (!searchCursor.find(!forward)) {
          return null;
        }
      }
      this._searchCursor = searchCursor;
      return searchCursor;
    };
  }).call(FindReplace.prototype);
  function getSearchState(editor2) {
    return editor2._searchState || (editor2._searchState = { query: "e", replaceString: "b" });
  }
  function getSearchCursor(editor2, query, pos) {
    return editor2.cm().getSearchCursor(query, pos, typeof query === "string" && query === query.toLowerCase());
  }
  function showFindInterface(editor2) {
    editor2.postMessage("show-finder");
    editor2.setIsFinding(true);
  }
  function hideFindInterface(editor2) {
    editor2.setIsFinding(false);
    clearMarks(editor2);
    editor2.postMessage("hide-finder");
    editor2.focus();
  }
  function setQuery(editor2, query) {
    getSearchState(editor2).query = query;
  }
  function clearMarks(editor2) {
    var _a;
    const state = getSearchState(editor2);
    (_a = state == null ? void 0 : state.marks) == null ? void 0 : _a.forEach((mark) => mark.clear());
    state.marks = [];
  }
  function findMatch(editor2, previous) {
    const cm = editor2.cm();
    const state = getSearchState(editor2);
    clearMarks(editor2);
    let cursor = getSearchCursor(editor2, state.query, previous ? state.posFrom : state.posTo);
    if (!cursor.find(previous)) {
      cursor = getSearchCursor(editor2, state.query, previous ? import_codemirror3.default.Pos(cm.lastLine()) : import_codemirror3.default.Pos(cm.firstLine(), 0));
      if (!cursor.find(previous)) {
        return false;
      }
    }
    cm.setSelection(cursor.from(), cursor.to());
    const mark = cm.markText(cursor.from(), cursor.to(), {
      startStyle: "search-highlight-start",
      className: "search-highlight",
      endStyle: "search-highlight-end",
      clearOnEnter: true
    });
    if (state.marks)
      state.marks.push(mark);
    else
      state.marks = [mark];
    state.posFrom = cursor.from();
    state.posTo = cursor.to();
    return true;
  }
  function nextMatch(editor2) {
    return findMatch(editor2, false);
  }
  function previousMatch(editor2) {
    return findMatch(editor2, true);
  }
  function showReplaceInterface() {
  }
  function hideReplaceInterface(_editor2) {
  }
  function replace2(editor2, all2) {
    let state = getSearchState(editor2), replaceString = state.replaceString, replaced = false;
    editor2.operation(() => {
      if (all2) {
        while (nextMatch(editor2)) {
          editor2.replaceSelection(replaceString, "end");
          replaced = true;
        }
      } else {
        editor2.replaceSelection(replaceString, "end");
        replaced = true;
      }
    });
    return replaced;
  }
  function replaceAndFind(editor2) {
    replace2(editor2, false);
    nextMatch(editor2);
  }
  function validateFind(editor2) {
    return getSearchState(editor2).query !== void 0;
  }
  function validateReplace(editor2) {
    let searchState = getSearchState(editor2);
    return searchState.query !== void 0 && searchState.replaceString !== void 0;
  }
  Extensions.addCommand({
    name: "showFindInterface",
    shortcut: "Cmd-F",
    performCommand: showFindInterface
  });
  Extensions.addCommand({
    name: "hideFindInterface",
    shortcut: "Esc",
    performCommand: hideFindInterface
  });
  Extensions.addCommand({
    name: "setQuery",
    performCommand: setQuery
  });
  Extensions.addCommand({
    name: "nextMatch",
    shortcut: "Cmd-G",
    validate(editor2) {
      return getSearchState(editor2).query !== void 0;
    },
    performCommand: nextMatch
  });
  Extensions.addCommand({
    name: "previousMatch",
    shortcut: "Shift-Cmd-G",
    validate: validateFind,
    performCommand: previousMatch
  });
  Extensions.addCommand({
    name: "showReplaceInterface",
    shortcut: "Cmd-Alt-F",
    performCommand: showReplaceInterface
  });
  Extensions.addCommand({
    name: "hideReplaceInterface",
    shortcut: "Esc",
    performCommand: hideReplaceInterface
  });
  Extensions.addCommand({
    name: "replace",
    validate: validateReplace,
    performCommand: replace2
  });
  Extensions.addCommand({
    name: "replaceAndFind",
    validate: validateReplace,
    performCommand: replaceAndFind
  });
  Extensions.addCommand({
    name: "replaceAll",
    validate: validateReplace,
    performCommand(editor2) {
      replace2(editor2, true);
    }
  });
  Extensions.add("com.foldingtext.editor.methods", {
    isFinding() {
      return this.isFinding || false;
    },
    setIsFinding(value) {
      if (value === this.isFinding)
        return;
      this.isFinding = value;
      if (!this.isFinding) {
        hideFindInterface(this);
      } else {
        showFindInterface(this);
      }
    }
  });

  // src/ft/extensions/folding.js
  init_extensions();
  var nextFoldID = 0;
  var Fold = class {
    constructor(editor2, textMarker, isManual, isBoundary) {
      this.id = `${nextFoldID++}`;
      this._valid = true;
      this._editor = editor2;
      this._isManual = isManual;
      this._isBoundary = isBoundary;
      this._textMarker = textMarker;
      textMarker.ftFold = this;
      let outerThis = this;
      import_codemirror3.default.on(textMarker, "clear", () => {
        outerThis._valid = false;
        outerThis._editor._invalidFolds = true;
      });
      import_codemirror3.default.on(textMarker, "hide", () => {
        outerThis._valid = false;
        outerThis._editor._invalidFolds = true;
      });
      import_codemirror3.default.on(textMarker, "unhide", () => {
        if (!outerThis._valid) {
          outerThis._valid = true;
          outerThis._editor._folds.push(outerThis);
        }
      });
    }
    valid() {
      return this._valid;
    }
    isManual() {
      return this._isManual;
    }
    setIsManual(isManual) {
      this._isManual = isManual;
    }
    isBoundary() {
      return this._isBoundary;
    }
    setIsBoundary(isBoundary) {
      this._isBoundary = isBoundary;
    }
    clear() {
      this._textMarker.clear();
      this._editor.invalidateRestorableState();
    }
    range() {
      let pos = this._textMarker.find();
      if (pos) {
        return this._editor.tree().createRangeFromLineChs(pos.from, pos.to);
      }
      return void 0;
    }
  };
  function folds() {
    let f3 = this._folds;
    if (!f3) {
      f3 = [];
      this._folds = f3;
    } else if (this._invalidFolds) {
      let length = f3.length, newFolds = [], each, i3;
      for (i3 = 0; i3 < length; i3++) {
        each = f3[i3];
        if (each._valid) {
          newFolds.push(each);
        }
      }
      f3 = newFolds;
      this._folds = f3;
      this._invalidFolds = false;
    }
    return f3;
  }
  function foldsInRange(range2) {
    let cm = this.cm(), from = range2.startLineCh(), to = range2.endLineCh(), marks = cm.findMarksInRange(from, to), length = marks.length, folds2 = [], each, i3;
    for (i3 = 0; i3 < length; i3++) {
      each = marks[i3].ftFold;
      if (each) {
        folds2.push(each);
      }
    }
    return folds2;
  }
  function foldsToJSON(folds2) {
    let length = folds2.length, jsonFolds = [], eachFold, each, i3;
    for (i3 = 0; i3 < length; i3++) {
      eachFold = folds2[i3];
      each = eachFold._textMarker.find();
      if (each) {
        if (eachFold.isManual()) {
          each.isManual = eachFold.isManual();
        }
        if (eachFold.isBoundary()) {
          each.isBoundary = eachFold.isBoundary();
        }
        jsonFolds.push(each);
      }
    }
    return jsonFolds;
  }
  function normalizeFoldsJSON(foldsJSON, originLineCh) {
    foldsJSON.forEach((each) => {
      each.from.line -= originLineCh.line;
      if (each.from.line === 0) {
        each.from.ch -= originLineCh.ch;
      }
      each.to.line -= originLineCh.line;
      if (each.to.line === 0) {
        each.to.ch -= originLineCh.ch;
      }
    });
    return foldsJSON;
  }
  function perpareNormalizedFoldsJSONForDestination(foldsJSON, destinationLineCh) {
    foldsJSON.forEach((each) => {
      if (each.from.line === 0) {
        each.from.ch += destinationLineCh.ch;
      }
      each.from.line += destinationLineCh.line;
      if (each.to.line === 0) {
        each.to.ch += destinationLineCh.ch;
      }
      each.to.line += destinationLineCh.line;
    });
    return foldsJSON;
  }
  function createFoldInRange(range2, isManual, isBoundary) {
    let editor2 = this, cm = editor2.cm(), tree = editor2.tree(), folds2 = editor2.foldsInRange(range2), rangeStart = range2.location(), rangeEnd = rangeStart + range2.length(), adjustedFoldRanges = [], length = folds2.length, usedExistingFold, eachRange, each, fold, i3;
    if (range2.length() < 1) {
      return void 0;
    }
    editor2.operation(() => {
      for (i3 = 0; i3 < length; i3++) {
        each = folds2[i3];
        eachRange = each.range();
        if (eachRange.isEqualToRange(range2)) {
          fold = each;
          usedExistingFold = true;
          return;
        }
        let eachStart = eachRange.location(), eachEnd = eachStart + eachRange.length(), containsEachStart = eachStart >= rangeStart && eachStart < rangeEnd, containsEachEnd = eachEnd > rangeStart && eachEnd <= rangeEnd, containedByEach = rangeStart > eachStart && rangeEnd < eachEnd;
        if (containsEachStart && !containsEachEnd) {
          each.clear();
          if (eachEnd - rangeEnd > 0) {
            adjustedFoldRanges.push(tree.createRangeFromLocation(rangeEnd, eachEnd - rangeEnd));
          }
        } else if (!containsEachStart && containsEachEnd) {
          each.clear();
          if (rangeStart - eachStart > 0) {
            adjustedFoldRanges.push(tree.createRangeFromLocation(eachStart, rangeStart - eachStart));
          }
        } else if (!containsEachStart && !containsEachEnd && containedByEach) {
          each.clear();
          if (eachEnd - rangeEnd > 0) {
            adjustedFoldRanges.push(tree.createRangeFromLocation(rangeEnd, eachEnd - rangeEnd));
          }
          if (rangeStart - eachStart > 0) {
            adjustedFoldRanges.push(tree.createRangeFromLocation(eachStart, rangeStart - eachStart));
          }
        } else if (containsEachStart && containsEachEnd) {
        }
      }
      let widget = document.createElement("span"), from = range2.startLineCh(), to = range2.endLineCh(), mark = cm.markText(from, to, {
        className: "collapsed",
        replacedWith: widget,
        clearOnEnter: false
      });
      fold = new Fold(editor2, mark, isManual, isBoundary);
      widget.className = "cm-fold";
      import_codemirror3.default.on(widget, "mousedown", (e5) => {
        fold.clear();
        e5.preventDefault();
      });
      length = adjustedFoldRanges.length;
      for (i3 = 0; i3 < length; i3++) {
        each = adjustedFoldRanges[i3];
        editor2.createFoldInRange(each);
      }
    });
    if (!usedExistingFold) {
      if (!this._folds) {
        this._folds = [];
      }
      this._folds.push(fold);
    }
    editor2.invalidateRestorableState();
    return fold;
  }
  function splitAndRemoveFoldsInRange(range2) {
    let folds2 = this.foldsInRange(range2), outerThis = this;
    if (folds2.length > 0) {
      outerThis.operation(() => {
        outerThis.createFoldInRange(range2).clear();
        folds2 = outerThis.foldsInRange(range2);
        for (let i3 = 0; i3 < folds2.length; i3++) {
          let each = folds2[i3], eachRange = each.range();
          if (range2.containsRange(eachRange)) {
            each.clear();
          }
        }
      });
    }
  }
  function restoreJSONFolds(jsonFolds) {
    if (!jsonFolds) {
      return;
    }
    let length = jsonFolds.length, each, i3;
    jsonFolds.sort((a3, b2) => {
      let compare2 = b2.from.line - a3.from.line;
      if (compare2 === 0) {
        compare2 = b2.from.ch - a3.from.ch;
        if (compare2 === 0) {
          compare2 = b2.to.line - a3.to.line;
          if (compare2 === 0) {
            compare2 = b2.to.ch - a3.to.ch;
          }
        }
      }
      return compare2;
    });
    let outerThis = this, tree = this.tree(), textLength = tree.textLength();
    this.operation(() => {
      for (i3 = 0; i3 < length; i3++) {
        each = jsonFolds[i3];
        if (tree.textOffsetForLineChar(each.to.line, each.to.ch) <= textLength) {
          outerThis.createFoldInRange(tree.createRangeFromLineChs(each.from, each.to), each.isManual, each.isBoundary);
        }
      }
    });
  }
  function removeFold(fold) {
    this.removeFolds([fold]);
  }
  function removeFolds(folds2) {
    let length = folds2.length, i3;
    this.operation(() => {
      for (i3 = 0; i3 < length; i3++) {
        folds2[i3].clear();
      }
    });
    this.invalidateRestorableState();
  }
  function nodeIsHiddenInFold(node, dontCountLineFolds) {
    return this.lineIsHiddenInFold(this.tree().nodeToLineNumber(node), dontCountLineFolds);
  }
  function lineIsHiddenInFold(line, dontCountLineFolds) {
    if (line < 0) {
      return false;
    }
    let cm = this.cm(), lineHandle = cm.getLineHandle(line);
    if (cm.lineHandleIsHidden(lineHandle)) {
      return true;
    }
    if (!dontCountLineFolds) {
      return lineHandleStartsLineFold(this, lineHandle);
    }
    return false;
  }
  function nodeStartsLineFold(node) {
    return this.lineStartsLineFold(this.tree().nodeToLineNumber(node));
  }
  function lineStartsLineFold(line) {
    if (line < 0) {
      return false;
    }
    let cm = this.cm(), lineHandle = cm.getLineHandle(line);
    return lineHandleStartsLineFold(this, lineHandle);
  }
  function lineHandleStartsLineFold(editor2, lineHandle) {
    let cm = editor2.cm(), markedSpans = lineHandle.markedSpans;
    if (markedSpans && markedSpans.length > 0) {
      for (let i3 = 0; i3 < markedSpans.length; i3++) {
        let mark = markedSpans[i3];
        if (mark.marker && mark.marker.className === "collapsed" && (mark.from === null || mark.from === 0) && (mark.to === null || mark.to === lineHandle.text.length)) {
          let to = mark.marker.find().to;
          if (cm.getLine(to.line).length === to.ch) {
            return mark.marker;
          }
        }
      }
    }
    return null;
  }
  function visibleNodesInRange(range2) {
    let nodes = range2.nodesInRange();
    return nodes;
  }
  function saveFolds(editor2, state) {
    state.jsonFolds = editor2.foldsToJSON(editor2.folds());
  }
  function loadFolds(editor2, state) {
    if (!state.fileChangedSinceLastStateSync) {
      editor2.operation(() => {
        editor2.removeFolds(editor2.folds());
        editor2.restoreJSONFolds(state.jsonFolds);
      });
    }
  }
  Extensions.addState({
    readState: loadFolds,
    writeState: saveFolds
  });
  Extensions.addRenderNodeElementStyles((editor2, node, elementRenderer) => {
    let marker = lineHandleStartsLineFold(editor2, elementRenderer._lineHandle);
    if (marker) {
      elementRenderer.addTextClass("cm-folded-line");
      elementRenderer.addWrapClass("cm-folded-line-wrapper");
      let lineChRange = marker.find();
      if (lineChRange.from.line === 0) {
        elementRenderer.addWrapClass("cm-foldedLineWrapper-at-start");
      } else if (lineChRange.to.line === editor2.tree().nodeCount() - 1) {
        elementRenderer.addWrapClass("cm-foldedLineWrapper-at-end");
      }
      elementRenderer.setStyle("marginLeft", "0");
      elementRenderer.setStyle("marginRight", "0");
      elementRenderer.setStyle("textIndent", "0");
    }
  });
  Extensions.add("com.foldingtext.editor.beforeUndoRedo", (editor2, changeObj) => {
    let range2 = editor2.tree().createRangeFromLineChs(changeObj.from, changeObj.to), folds2 = editor2.foldsInRange(range2);
    editor2.removeFolds(folds2);
  });
  Extensions.add("com.foldingtext.editor.methods", {
    folds,
    foldsInRange,
    foldsToJSON,
    normalizeFoldsJSON,
    perpareNormalizedFoldsJSONForDestination,
    restoreJSONFolds,
    createFoldInRange,
    splitAndRemoveFoldsInRange,
    removeFold,
    removeFolds,
    nodeIsHiddenInFold,
    lineIsHiddenInFold,
    nodeStartsLineFold,
    lineStartsLineFold,
    visibleNodesInRange
  });

  // src/ft/extensions/nodepath.js
  init_extensions();
  var { applicationName } = environment_default;
  function nodePath() {
    if (!this._nodePath) {
      this._nodePath = new NodePath(NodePath.SHOW_ALL_PATH, this.tree().taxonomy.types());
    }
    return this._nodePath;
  }
  function nodePathMatches() {
    if (!this._nodePathMatches) {
      this._nodePathMatches = this.tree().evaluateNodePath(this._nodePath);
    }
    return this._nodePathMatches;
  }
  function nodePathMatchesNodeSet() {
    if (!this._nodePathMatchesNodeSet) {
      this._nodePathMatchesNodeSet = NodeSet.setFromArray(this.nodePathMatches());
    }
    return this._nodePathMatchesNodeSet;
  }
  function nodePathEditedNodeSet() {
    if (!this._nodePathEditedNodeSet) {
      this._nodePathEditedNodeSet = new NodeSet();
    }
    return this._nodePathEditedNodeSet;
  }
  function addFoldsToShowMatchesAndAncestors(editor2) {
    let tree = editor2.tree(), firstLineNode = tree.firstLineNode(), lastLineNode = tree.lastLineNode(), matches = editor2.nodePathMatches().slice(0), eachMatch = matches.shift(), each = tree.firstLineNode(), foldStart, foldEnd, foldRange, folds2 = [];
    if (eachMatch && eachMatch.isRoot()) {
      eachMatch = matches.shift();
    }
    while (each) {
      if (each === eachMatch) {
        if (foldStart) {
          foldEnd = each.previousLineNode();
          foldRange = tree.createRangeFromNodes(foldStart, 0, foldEnd, foldEnd.line().length);
          folds2.push(editor2.createFoldInRange(foldRange, false));
          foldStart = null;
        }
        eachMatch = matches.shift();
      } else if (!foldStart) {
        foldStart = each;
      }
      each = each.nextLineNode();
    }
    if (foldStart) {
      foldEnd = tree.lastLineNode();
      foldRange = tree.createRangeFromNodes(foldStart, 0, foldEnd, foldEnd.line().length);
      folds2.push(editor2.createFoldInRange(foldRange, false));
    }
    folds2.forEach((eachFold) => {
      if (eachFold) {
        let eachRange = eachFold.range();
        if (!editor2._nodePathTopBoundaryFold) {
          if (eachRange.startNode === firstLineNode && eachRange.startOffset === 0) {
            editor2._nodePathTopBoundaryFold = eachFold;
            eachFold.setIsBoundary(true);
          }
        }
        if (!editor2._nodePathBottomBoundaryFold) {
          if (eachRange.endNode === lastLineNode && eachRange.endOffset === eachRange.endNode.line().length) {
            editor2._nodePathBottomBoundaryFold = eachFold;
            eachFold.setIsBoundary(true);
          }
        }
      }
    });
  }
  function setNodePath(nodePath2, restoringState) {
    let editor2 = this;
    let isString2 = typeof nodePath2 === "string" || nodePath2 instanceof String;
    if (isString2) {
      this._nodePath = new NodePath(nodePath2, editor2.tree().taxonomy.types());
    } else {
      this._nodePath = nodePath2;
    }
    this._nodePathMatches = null;
    this._nodePathMatchesNodeSet = null;
    this._nodePathEditedNodeSet = null;
    this._nodePathTopBoundaryFold = null;
    this._nodePathBottomBoundaryFold = null;
    if (restoringState) {
      editor2.folds().forEach((each) => {
        if (each.isBoundary()) {
          if (each.range().location() === 0) {
            editor2._nodePathTopBoundaryFold = each;
          } else {
            editor2._nodePathBottomBoundaryFold = each;
          }
        }
      });
    } else {
      editor2.operation(() => {
        let viewport = editor2.viewport();
        editor2.removeFolds(editor2.folds().filter((each) => {
          return !each.isManual();
        }));
        editor2.refresh();
        if (!editor2.nodePath().isShowAllPath()) {
          addFoldsToShowMatchesAndAncestors(editor2);
        }
        editor2.scrollToLine(viewport.firstVisibleLine, viewport.firstVisibleLineOffset);
      });
    }
    if (editor2._nodePathTopBoundaryFold || editor2._nodePathBottomBoundaryFold) {
      editor2.setSelectedRange(editor2.selectedRange());
    }
    let outerThis = this;
    Extensions.processExtensions("com.foldingtext.editor.nodePathDidChange", (each) => {
      each(outerThis);
    });
    editor2.invalidateRestorableState();
  }
  function nodePathLocation() {
    return this.nodePath().locationPathString();
  }
  function setNodePathLocation(location) {
    this.nodePath().setLocationPathString(location);
    this.setNodePath(this.nodePath());
  }
  function nodePathFilter() {
    return this.nodePath().filterStepString();
  }
  function setNodePathFilter(filter3) {
    this.nodePath().setFilterStepString(filter3);
    this.setNodePath(this.nodePath());
  }
  function treeChanged(editor2, e5) {
    if (!editor2.nodePath().isShowAllPath()) {
      let deltas = e5.deltas, nodePathEditedNodeSet2 = editor2.nodePathEditedNodeSet(), each, i3;
      for (i3 = 0; i3 < deltas.length; i3++) {
        each = deltas[i3];
        if (each.textChanged()) {
          nodePathEditedNodeSet2.addNodeIgnoringNull(each.updatedNode);
          nodePathEditedNodeSet2.addNodesFromArray(each.insertedNodes);
        }
      }
    }
  }
  Extensions.addState({
    readState(editor2, state) {
      if (state.nodePath && state.nodePath !== NodePath.SHOW_ALL_PATH) {
        editor2.tree().ensureClassified();
        editor2.setNodePath(new NodePath(state.nodePath, editor2.tree().taxonomy.types()), true);
      }
    },
    writeState(editor2, state) {
      state.nodePath = editor2.nodePath().nodePathString;
    }
  }, Extensions.PriorityLast);
  Extensions.add("com.foldingtext.editor.methods", {
    nodePath,
    nodePathMatches,
    nodePathMatchesNodeSet,
    nodePathEditedNodeSet,
    setNodePath,
    nodePathLocation,
    setNodePathLocation,
    nodePathFilter,
    setNodePathFilter
  });
  Extensions.addRenderNodeElementStyles((editor2, node, elementRenderer) => {
    if (!editor2.nodePath().isShowAllPath()) {
      if (editor2.nodePathMatchesNodeSet().containsNode(node)) {
        elementRenderer.addBackgroundClass("cm-match");
      } else if (editor2.nodePathEditedNodeSet().containsNode(node)) {
        elementRenderer.addBackgroundClass("cm-notMatchEdited");
      } else {
        elementRenderer.addBackgroundClass("cm-notMatch");
      }
    }
  });
  Extensions.addTreeChanged(treeChanged);
  Extensions.addCommand({
    name: "showAll",
    performCommand(editor2) {
      editor2.operation(() => {
        let viewport = editor2.viewport();
        editor2.removeFolds(editor2.folds());
        editor2.setNodePath(NodePath.SHOW_ALL_PATH);
        editor2.scrollToLine(viewport.firstVisibleLine, viewport.firstVisibleLineOffset);
      });
    }
  });
  Extensions.addCommand({
    name: "link node path",
    description: "Encode the selected node path text as clickable link.",
    performCommand(editor2) {
      let nodepath = editor2.selectedText(), encodedPath = encodeURIComponent(nodepath);
      editor2.replaceSelection(`[label](x-${applicationName.toLowerCase()}://documents/current?nodepath=${encodedPath})`, "start");
      editor2.setSelectedRange(editor2.selectedRange().rangeByOffsetting(1, 5));
    }
  });

  // src/ft/extensions/focus.js
  init_extensions();
  function focusRange(range2) {
    let editor2 = this, tree = editor2.tree(), start2 = range2.location(), end = start2 + range2.length(), preRange = tree.createRangeFromLocation(0, start2), postRange = tree.createRangeFromLocation(end, tree.textLength() - end);
    editor2.operation(() => {
      editor2.removeFolds(editor2.folds());
      editor2.createFoldInRange(preRange, false);
      editor2.createFoldInRange(postRange, false);
    });
  }
  function focusNode(node) {
    if (node.firstChild || node.type() === "heading") {
      this.setNodePath(NodePath.calculateMinNodePath(node, true));
      this.scrollToTop();
    } else {
      node = node.parent;
      if (node.isRoot()) {
        this.setNodePath(null);
      } else {
        this.setNodePath(NodePath.calculateMinNodePath(node, true));
      }
    }
  }
  function focusIn(editor2) {
    let range2 = editor2.selectedRange().rangeByAdjustingToEffectedNodesInEditor(editor2);
    if (range2.startNode === range2.endNode) {
      editor2.focusNode(range2.startNode);
    } else {
      range2 = range2.rangeByExtendingToParagraph();
      if (range2.location() > 0) {
        range2 = range2.rangeByOffsetting(-1, 1);
      }
      editor2.focusRange(range2);
    }
  }
  function focusOut(editor2) {
    let nodePath2 = editor2.nodePath();
    if (nodePath2.isShowAllPath()) {
      let viewport = editor2.viewport();
      editor2.removeFolds(editor2.folds());
      editor2.scrollToLine(viewport.firstVisibleLine, viewport.firstVisibleLineOffset);
    } else {
      nodePath2.updateNodePathByFocusingOutOneLevel();
      editor2.setNodePath(nodePath2);
    }
  }
  Extensions.addCommand({
    name: "focusIn",
    performCommand: focusIn
  });
  Extensions.addCommand({
    name: "focusOut",
    validate(editor2) {
      return !editor2.nodePath().isShowAllPath() || editor2.folds().length > 0;
    },
    performCommand: focusOut
  });
  Extensions.add("com.foldingtext.editor.willEndOperation", (editor2) => {
    window.setTimeout(() => {
      if (editor2._editorTopFold) {
        if (!editor2.nodePath().isShowAllPath() || editor2.folds().length > 0) {
          editor2._editorTopFold.style.display = "";
        } else {
          editor2._editorTopFold.style.display = "none";
        }
      }
    }, 0);
  });
  Extensions.addInit((editor2) => {
    let wrapperElement = editor2.wrapperElement(), topFoldWidget = document.createElement("div");
    topFoldWidget.className = "cm-editor-top-fold";
    topFoldWidget.style.display = "none";
    topFoldWidget.title = "Show All";
    editor2._editorTopFold = topFoldWidget;
    import_codemirror3.default.on(topFoldWidget, "mousedown", (e5) => {
      editor2.performCommand("showAll");
      e5.preventDefault();
    });
    wrapperElement.appendChild(topFoldWidget);
  });
  Extensions.add("com.foldingtext.editor.methods", {
    focusRange,
    focusNode
  });

  // src/ft/extensions/foldingnodes.js
  init_extensions();
  function _getEndFold(editor2, node) {
    let tree = editor2.tree(), lineLength = node.line().length, folds2 = editor2.foldsInRange(tree.createRangeFromNodes(node, lineLength)), length = folds2.length, i3;
    for (i3 = 0; i3 < length; i3++) {
      let each = folds2[i3], eachRange = each.range();
      if (eachRange.startNode === node && eachRange.startOffset === lineLength) {
        return each;
      }
    }
    return null;
  }
  function isExpanded(node, testChildren) {
    if (_getEndFold(this, node) !== null) {
      return false;
    }
    if (testChildren) {
      let eachChild = node.firstChild;
      while (eachChild) {
        if (this.nodeIsHiddenInFold(eachChild)) {
          return false;
        }
        eachChild = eachChild.nextSibling;
      }
    }
    return true;
  }
  function isCollapsed(node, testChildren) {
    return !this.isExpanded(node, testChildren);
  }
  function expandNode(node, all2) {
    this.expandNodes([node], all2);
  }
  function expandNodes(nodes, all2) {
    let outerThis = this;
    this.operation(() => {
      let allChildren = [], nodesLength = nodes.length, i3;
      for (i3 = 0; i3 < nodesLength; i3++) {
        let each = nodes[i3], endFold = _getEndFold(outerThis, each);
        if (endFold) {
          endFold.clear();
        }
        let eachChild = each.firstChild;
        while (eachChild) {
          if (outerThis.nodeIsHiddenInFold(eachChild)) {
            outerThis.expandToRevealNode(eachChild);
          }
          allChildren.push(eachChild);
          eachChild = eachChild.nextSibling;
        }
        if (all2) {
          outerThis.expandNodes(allChildren, true);
        }
      }
    });
  }
  function expandToRevealNode(node) {
    let startNode = node, startOffset = 0, endNode = node, endOffset = node.line().length;
    if (node.previousLineNode()) {
      startNode = node.previousLineNode();
      startOffset = startNode.line().length;
    }
    if (node.nextLineNode() && !node.firstChild) {
      endNode = node.nextLineNode();
      endOffset = 0;
    }
    this.splitAndRemoveFoldsInRange(this.tree().createRangeFromNodes(startNode, startOffset, endNode, endOffset));
  }
  function collapseNode(node, all2, folds2) {
    return this.collapseNodes([node], all2, folds2);
  }
  function collapseNodes(nodes, all2, folds2) {
    if (!folds2) {
      folds2 = [];
    }
    let tree = this.tree(), outerThis = this, length = nodes.length, eachNode, i3;
    this.operation(() => {
      for (i3 = 0; i3 < length; i3++) {
        eachNode = nodes[i3];
        if (eachNode.firstChild) {
          let last = eachNode.lastDescendantOrSelf(), foldRange = tree.createRangeFromNodes(eachNode, eachNode.line().length, last, last.line().length);
          if (all2) {
            let eachSibling = eachNode.firstChild;
            while (eachSibling) {
              outerThis.collapseNode(eachSibling, true, folds2);
              eachSibling = eachSibling.nextSibling;
            }
          }
          folds2.push(outerThis.createFoldInRange(foldRange, true));
        }
      }
    });
    return folds2;
  }
  function hideNodes(nodes, trimEmpties) {
    let editor2 = this, tree = editor2.tree(), length = nodes.length, hideStart, hideEnd, previous, each, i3;
    function addFold(from, to) {
      if (trimEmpties) {
        while (from.type() === "empty" && from !== to) {
          from = from.nextLineNode();
        }
        while (to.type() === "empty" && to !== from) {
          to = to.previousLineNode();
        }
      }
      if (from === to && from.type() === "empty") {
        return;
      }
      editor2.createFoldInRange(tree.createRangeFromNodes(from, 0, to, -1), false);
    }
    editor2.operation(() => {
      for (i3 = 0; i3 < length; i3++) {
        each = nodes[i3];
        if (!previous || each.previousLineNode() === previous) {
          if (!hideStart) {
            hideStart = each;
          }
          hideEnd = each;
        } else if (hideStart) {
          addFold(hideStart, hideEnd);
          hideStart = void 0;
          hideEnd = void 0;
        }
        previous = each;
      }
      if (hideStart) {
        addFold(hideStart, hideEnd);
      }
    });
  }
  function _biggestFold(folds2) {
    let length = folds2.length, biggest = folds2[0], biggestLength = biggest.range().length(), each, eachLength, i3;
    for (i3 = 1; i3 < length; i3++) {
      each = folds2[i3];
      eachLength = each.range().length();
      if (eachLength > biggestLength) {
        biggest = each;
        biggestLength = eachLength;
      }
    }
    return biggest;
  }
  function toggleNodeFold(editor2, all2) {
    let range2 = editor2.selectedRange().rangeByAdjustingToEffectedNodesInEditor(editor2), folds2 = editor2.foldsInRange(range2);
    if (folds2.length > 0) {
      if (range2.isCollapsed()) {
        editor2.removeFold(_biggestFold(folds2));
      } else {
        editor2.removeFolds(folds2);
      }
      return;
    }
    let branches = Node.commonAncestorsForNodes(range2.nodesInRange()), lineOrderedBranches = branches.nodesInLineOrder(), node = range2.startNode;
    if (editor2.isCollapsed(node)) {
      editor2.expandNodes(lineOrderedBranches, all2);
    } else if (editor2.nodeIsHiddenInFold(node)) {
      editor2.expandToRevealNode(node);
    } else {
      let anyChildren = false;
      lineOrderedBranches.forEach((each) => {
        if (each.firstChild) {
          anyChildren = true;
        }
      });
      if (anyChildren) {
        editor2.collapseNodes(lineOrderedBranches, all2);
      } else if (!node.parent.isRoot()) {
        editor2.collapseNode(node.parent, all2);
        editor2.setSelectedRange(editor2.tree().createRangeFromNodes(node.parent, node.parent.line().length));
      }
    }
  }
  function toggleAllFolds(editor2) {
    let folds2 = editor2.folds(), length = folds2.length;
    if (length) {
      editor2.removeFolds(folds2);
    } else {
      editor2.operation(() => {
        let each = editor2.tree().root.firstChild;
        while (each) {
          editor2.collapseNode(each, true);
          each = each.nextSibling;
        }
      });
    }
  }
  function sortedAndUniqueNodeStructureLevels(nodes) {
    let structureLevels = [];
    nodes.forEach((each) => {
      structureLevels.push(each.structureLevel());
    });
    structureLevels.sort();
    structureLevels.sortedUniquify();
    return structureLevels;
  }
  function foldingLevel(nodes) {
    let tree = this.tree(), editor2 = this;
    if (!nodes) {
      nodes = tree.root.descendants();
    }
    if (nodes instanceof Node) {
      let node = nodes;
      nodes = node.descendants();
      nodes.unshift(node);
    }
    tree.ensureClassified();
    let nodesStructureLevels = sortedAndUniqueNodeStructureLevels(nodes), firstHiddenStructureLevel = Number.MAX_VALUE;
    nodes.forEach((each) => {
      if (editor2.nodeIsHiddenInFold(each)) {
        if (each.structureLevel() < firstHiddenStructureLevel) {
          firstHiddenStructureLevel = each.structureLevel();
        }
      }
    });
    if (firstHiddenStructureLevel === Number.MAX_VALUE) {
      return nodesStructureLevels.length;
    }
    return nodesStructureLevels.indexOf(firstHiddenStructureLevel);
  }
  function setFoldingLevel(level, nodes) {
    let tree = this.tree(), editor2 = this;
    if (!nodes) {
      nodes = tree.root.descendants();
    }
    if (nodes instanceof Node) {
      let node = nodes;
      nodes = node.descendants();
      nodes.unshift(node);
    }
    editor2.operation(() => {
      let nodesRange = tree.createRangeFromNodes(nodes[0], 0, nodes.lastObject(), -1), nodesStructureLevels = sortedAndUniqueNodeStructureLevels(nodes), collapseStructureLevel = nodesStructureLevels[level - 1], hideStructureLevel = nodesStructureLevels[level];
      editor2.removeFolds(editor2.foldsInRange(nodesRange));
      if (level < 0) {
        return;
      }
      editor2.collapseNodes(nodes.filter((each) => {
        return each.structureLevel() === collapseStructureLevel;
      }), false);
      editor2.hideNodes(nodes.filter((each) => {
        return each.structureLevel() >= hideStructureLevel && !editor2.nodeIsHiddenInFold(each);
      }), true);
    });
  }
  Extensions.addCommand({
    name: "toggleNodeFold",
    performCommand(editor2) {
      toggleNodeFold(editor2, false);
    }
  });
  Extensions.addCommand({
    name: "toggleNodeFoldNodeAndDescendants",
    performCommand(editor2) {
      toggleNodeFold(editor2, true);
    }
  });
  Extensions.addCommand({
    name: "toggleAllFolds",
    performCommand: toggleAllFolds
  });
  Extensions.addCommand({
    name: "foldingLevel",
    performCommand(editor2, options) {
      let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByExtendingToBranch().rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = effectedRange.nodesInRange();
      editor2.setFoldingLevel(options.interfaceItemTag, nodes);
    }
  });
  Extensions.addCommand({
    name: "expandFoldingLevel",
    performCommand(editor2) {
      let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByExtendingToBranch().rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = effectedRange.nodesInRange(), foldingLevel2 = editor2.foldingLevel(nodes);
      editor2.setFoldingLevel(foldingLevel2 + 1, nodes);
    }
  });
  Extensions.addCommand({
    name: "contractFoldingLevel",
    performCommand(editor2) {
      let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByExtendingToBranch().rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = effectedRange.nodesInRange(), foldingLevel2 = editor2.foldingLevel(nodes);
      if (foldingLevel2 > 1) {
        editor2.setFoldingLevel(foldingLevel2 - 1, nodes);
      }
    }
  });
  Extensions.addCommand({
    name: "hideSelection",
    performCommand(editor2) {
      let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = effectedRange.nodesInRange();
      editor2.hideNodes(nodes, false);
    }
  });
  Extensions.add("com.foldingtext.editor.methods", {
    foldingLevel,
    setFoldingLevel,
    isExpanded,
    isCollapsed,
    collapseNode,
    collapseNodes,
    hideNodes,
    expandNode,
    expandNodes,
    expandToRevealNode
  });

  // src/ft/extensions/selection.js
  init_extensions();
  function performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, nodeOperation) {
    editor2.operation(() => {
      let lastMoved = effectedRange.endNode, folds2 = editor2.foldsInRange(effectedRange), foldRanges = [];
      selectedRange.beginTrackingOffsets();
      folds2.forEach((each) => {
        let foldRange = each.range();
        foldRange.isManualFoldRange = each.isManual();
        foldRanges.push(foldRange);
        foldRange.beginTrackingOffsets();
        each.clear();
      });
      nodeOperation();
      foldRanges.forEach((eachRange) => {
        eachRange.endTrackingOffsets();
        editor2.createFoldInRange(eachRange, eachRange.isManualFoldRange);
      });
      selectedRange.endTrackingOffsets();
      if (selectedRange.startNode !== selectedRange.endNode && selectedRange.endOffset === 0) {
        let afterLast = effectedRange.endNode.nextLineNode();
        if (afterLast) {
          selectedRange.endNode = afterLast;
        } else {
          selectedRange.endNode = lastMoved;
          selectedRange.endOffset = lastMoved.line().length;
        }
      }
      editor2.setSelectedRange(selectedRange);
    });
  }
  function expandSelection(editor2) {
    let expandSelectionStartRange = editor2._expandSelectionStartRange, extendSelectionLevel = editor2._extendSelectionLevel;
    if (!expandSelectionStartRange) {
      expandSelectionStartRange = editor2.selectedRange().copy();
      extendSelectionLevel = 0;
    }
    let previousExpandToRange = expandSelectionStartRange.rangeByExtendingToLevel(extendSelectionLevel), expandToRange = previousExpandToRange.copy();
    while (!expandToRange.isSelectingAll() && previousExpandToRange.isEqualToRange(expandToRange)) {
      expandToRange = expandSelectionStartRange.rangeByExtendingToLevel(++extendSelectionLevel);
    }
    editor2.setSelectedRange(expandToRange);
    editor2._expandSelectionStartRange = expandSelectionStartRange;
    editor2._extendSelectionLevel = extendSelectionLevel;
  }
  function contractSelection(editor2) {
    let expandSelectionStartRange = editor2._expandSelectionStartRange, extendSelectionLevel = editor2._extendSelectionLevel;
    if (!extendSelectionLevel) {
      return;
    }
    let previousContractToRange = expandSelectionStartRange.rangeByExtendingToLevel(extendSelectionLevel), contractToRange = previousContractToRange.copy();
    while (extendSelectionLevel > 0 && previousContractToRange.isEqualToRange(contractToRange)) {
      contractToRange = expandSelectionStartRange.rangeByExtendingToLevel(--extendSelectionLevel);
    }
    editor2.setSelectedRange(contractToRange);
    editor2._extendSelectionLevel = extendSelectionLevel;
    editor2._expandSelectionStartRange = expandSelectionStartRange;
  }
  Extensions.addCommand({
    name: "expandSelectionToWord",
    performCommand(editor2) {
      editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToWord());
    }
  });
  Extensions.addCommand({
    name: "expandSelectionToSentence",
    performCommand(editor2) {
      editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToSentence());
    }
  });
  Extensions.addCommand({
    name: "expandSelectionToLine",
    performCommand(editor2) {
      editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToLine());
    }
  });
  Extensions.addCommand({
    name: "expandSelectionToParagraph",
    performCommand(editor2) {
      editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToParagraph());
    }
  });
  Extensions.addCommand({
    name: "expandSelectionToBranch",
    performCommand(editor2) {
      editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToBranch());
    }
  });
  Extensions.addCommand({
    name: "expandSelection",
    performCommand: expandSelection
  });
  Extensions.addCommand({
    name: "contractSelection",
    performCommand: contractSelection
  });
  Extensions.add("com.foldingtext.editor.beforeSelectionChange", (editor2) => {
    editor2._expandSelectionStartRange = null;
    editor2._extendSelectionLevel = 0;
  });

  // src/ft/extensions/formatting.js
  init_extensions();
  function insertLink(editor2) {
    let selectedText = editor2.selectedText(), selectedRange;
    editor2.operation(() => {
      editor2.replaceSelection(`[${selectedText}]()`, "around");
      if (selectedText.length) {
        selectedRange = editor2.selectedRange().rangeByOffsetting(0, -1).rangeByCollapsing(false);
      } else {
        selectedRange = editor2.selectedRange().rangeByOffsetting(1, 0).rangeByCollapsing(true);
      }
      editor2.setSelectedRange(selectedRange);
    });
  }
  function toggleSelectionFormatting(editor2, before, after) {
    if (!after) {
      after = before;
    }
    let selectedRange = editor2.selectedRange(), selectedText = selectedRange.textInRange(), beforeLength = before.length, afterLength = after.length, addedFormatting = true;
    editor2.operation(() => {
      if (selectedRange.isCollapsed()) {
        editor2.replaceSelection(before + after, "around");
        selectedRange.startOffset += beforeLength;
        selectedRange.endOffset += afterLength;
        editor2.setSelectedRange(selectedRange);
      } else if (selectedText.startsWith(before) && selectedText.endsWith(after)) {
        editor2.replaceSelection(selectedText.substr(beforeLength, selectedText.length - (beforeLength + afterLength)), "around");
        addedFormatting = false;
      } else {
        let extendedRange = selectedRange.rangeByOffsetting(-beforeLength, beforeLength + afterLength), extendedText = extendedRange.textInRange();
        if (extendedText.startsWith(before) && extendedText.endsWith(after)) {
          editor2.setSelectedRange(extendedRange);
          editor2.replaceSelection(selectedText, "around");
          addedFormatting = false;
        } else {
          editor2.replaceSelection(before + selectedText + after, "around");
          editor2.setSelectedRange(editor2.selectedRange().rangeByOffsetting(beforeLength, -(beforeLength + afterLength)));
        }
      }
    });
    return addedFormatting;
  }
  Extensions.add("com.foldingtext.editor.methods", {
    toggleSelectionFormatting
  });
  Extensions.add("com.foldingtext.editor.options", {
    name: "boldFormattingChar",
    defaultValue: "*"
  });
  Extensions.addCommand({
    name: "toggleBold",
    performCommand(editor2) {
      let boldFormattingChar = editor2.option("boldFormattingChar");
      editor2.toggleSelectionFormatting(editor2, boldFormattingChar + boldFormattingChar);
    }
  });
  Extensions.addCommand({
    name: "setBoldFormattingChar",
    performCommand(editor2, formattingChar) {
      editor2.setOption("boldFormattingChar", formattingChar.interfaceItemTag);
    }
  });
  Extensions.add("com.foldingtext.editor.options", {
    name: "italicFormattingChar",
    defaultValue: "_"
  });
  Extensions.addCommand({
    name: "toggleItalic",
    performCommand(editor2) {
      editor2.toggleSelectionFormatting(editor2, editor2.option("italicFormattingChar"));
    }
  });
  Extensions.addCommand({
    name: "setItalicFormattingChar",
    performCommand(editor2, formattingChar) {
      editor2.setOption("italicFormattingChar", formattingChar.interfaceItemTag);
    }
  });
  Extensions.addCommand({
    name: "toggleCode",
    performCommand(editor2) {
      editor2.toggleSelectionFormatting(editor2, "`");
    }
  });
  Extensions.addCommand({
    name: "insertLink",
    performCommand(editor2) {
      insertLink(editor2);
    }
  });
  function formatSelectionType(editor2, type, typeIndentLevel, postProcess) {
    let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = effectedRange.nodesInRange(), tree = editor2.tree(), taxonomy3 = tree.taxonomy;
    tree.ensureClassified();
    performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
      tree.beginUpdates();
      nodes.forEach((each) => {
        let eachOldType = each.type(), eachOldMinLevel = taxonomy3.validatedTypeIndentLevel(each, 0);
        if (eachOldType !== "empty" || selectedRange.isCollapsed()) {
          let eachOldTypeIndentLevel = each.typeIndentLevel(), level = typeIndentLevel;
          each.setType(type);
          if (typeIndentLevel === void 0) {
            level = eachOldTypeIndentLevel;
            level -= eachOldMinLevel - taxonomy3.validatedTypeIndentLevel(each, 0);
          }
          each.setTypeIndentLevel(level);
        }
      });
      if (postProcess) {
        postProcess(nodes);
      }
      tree.endUpdates();
    });
  }
  Extensions.addCommand({
    name: "formatHeadingLarge",
    performCommand(editor2) {
      formatSelectionType(editor2, "heading", 0);
    }
  });
  Extensions.addCommand({
    name: "formatHeadingMedium",
    performCommand(editor2) {
      formatSelectionType(editor2, "heading", 2);
    }
  });
  Extensions.addCommand({
    name: "formatHeadingSmall",
    performCommand(editor2) {
      formatSelectionType(editor2, "heading", 3);
    }
  });
  Extensions.addCommand({
    name: "formatBody",
    performCommand(editor2) {
      formatSelectionType(editor2, "body", 0);
    }
  });
  Extensions.addCommand({
    name: "formatBlockquote",
    performCommand(editor2) {
      formatSelectionType(editor2, "blockquote");
    }
  });
  Extensions.addCommand({
    name: "formatCodeblock",
    performCommand(editor2) {
      formatSelectionType(editor2, "codeblock", 0);
    }
  });
  Extensions.addCommand({
    name: "formatHeading",
    performCommand(editor2, options) {
      formatSelectionType(editor2, "heading", options.interfaceItemTag ? options.interfaceItemTag : 1);
    }
  });
  Extensions.addCommand({
    name: "formatUnorderedList",
    performCommand(editor2) {
      formatSelectionType(editor2, "unordered", void 0);
    }
  });
  Extensions.addCommand({
    name: "formatOrderedList",
    performCommand(editor2) {
      formatSelectionType(editor2, "ordered", void 0, (nodes) => {
        let label = 1;
        nodes.forEach((each) => {
          let match = each.line().match(/^(\t*)([0-9]+\.\s+)/);
          if (match) {
            each.replaceLineInRange(`${label}`, match.index + match[1].length, 1);
            label++;
          }
        });
      });
    }
  });
  function adjustTypeLevel(editor2, delta) {
    let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = effectedRange.nodesInRange(), tree = editor2.tree();
    tree.ensureClassified();
    performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
      tree.beginUpdates();
      nodes.forEach((each) => {
        if (each.type() !== "empty" || selectedRange.isCollapsed()) {
          each.setTypeIndentLevel(each.typeIndentLevel() + delta);
        }
      });
      tree.endUpdates();
    });
  }
  Extensions.addCommand({
    name: "increaseTypeLevel",
    performCommand(editor2) {
      adjustTypeLevel(editor2, 1);
    }
  });
  Extensions.addCommand({
    name: "decreaseTypeLevel",
    performCommand(editor2) {
      adjustTypeLevel(editor2, -1);
    }
  });
  Extensions.addCommand({
    name: "clearFormatting",
    performCommand(editor2) {
      let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2), tree = editor2.tree(), clearedInline = false;
      tree.ensureClassified();
      let formattedText = {
        _format: null,
        _cleared: false,
        _node: null,
        _location: 0,
        _length: 0,
        format() {
          return this._format;
        },
        length() {
          return this._length;
        },
        string() {
          return this._node.lineInRange(this._location, this._length);
        },
        replaceInRange(inserted, location, length) {
          this._cleared = true;
          this._node.replaceLineInRange(inserted, this._location + location, length);
        }
      };
      function processExtension(eachExtension) {
        eachExtension(formattedText);
      }
      performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
        tree.beginUpdates();
        selectedRange.forEachNodeInRange((node, line, location, length) => {
          let end = location + length, attributesRange = {}, eachAttributeRange = {}, index2 = location, attributes;
          while (index2 <= end) {
            attributes = node.lineAttributesAtIndex(index2, attributesRange);
            if (attributes) {
              index2 = attributesRange.location + attributesRange.length;
              for (let eachAttribute in attributes) {
                node.lineAttributeAtIndex(eachAttribute, index2, null, eachAttributeRange);
                formattedText._cleared = false;
                formattedText._format = eachAttribute;
                formattedText._node = node;
                formattedText._location = eachAttributeRange.location;
                formattedText._length = eachAttributeRange.length;
                Extensions.processExtensions("com.foldingtext.editor.clearInlineFormatting", processExtension);
                if (formattedText._cleared) {
                  index2 = eachAttributeRange.location;
                  tree.ensureClassified();
                  clearedInline = true;
                  break;
                }
              }
            } else {
              index2++;
            }
          }
        });
        tree.endUpdates();
      });
      if (!clearedInline) {
        formatSelectionType(editor2, "body", 0);
      }
    }
  });

  // src/ft/extensions/headingfoldhelper.js
  init_extensions();
  function mouseDown(editor2, e5) {
    let target = editor2.targetsAt(e5.clientX, e5.clientY), attributes = target.attributes, node = target.node;
    if (node.type() === "heading" && attributes.lead) {
      return true;
    }
    return false;
  }
  function mouseUp(editor2, e5) {
    if (e5.button === 2 || e5.button === 0 && e5.ctrlKey) {
      return false;
    }
    let targets = editor2.targetsAt(e5.clientX, e5.clientY), attributes = targets.attributes, node = targets.node, cmdKey = e5.metaKey;
    if (node.type() === "heading" && attributes.lead) {
      if (!cmdKey) {
        if (editor2.isCollapsed(node)) {
          editor2.expandNode(node);
        } else {
          editor2.collapseNode(node);
        }
      } else {
        editor2.focusNode(node);
      }
      return true;
    }
    return false;
  }
  Extensions.add("com.foldingtext.editor.mouse", {
    mouseDown,
    mouseUp
  });

  // src/ft/extensions/moveparagraph.js
  init_extensions();
  function moveParagraphs(editor2, direction) {
    let selectedRange = editor2.selectedRange(), effectedRange = selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = effectedRange.nodesInRange(), length = nodes.length, tree = editor2.tree(), i3;
    if (direction === "right") {
      performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
        tree.beginUpdates();
        for (i3 = 0; i3 < length; i3++) {
          nodes[i3].replaceLineInRange("	", 0, 0);
        }
        tree.endUpdates();
      });
      return;
    }
    if (direction === "left") {
      performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
        tree.beginUpdates();
        for (i3 = 0; i3 < length; i3++) {
          let each = nodes[i3];
          if (each.line()[0] === "	") {
            nodes[i3].replaceLineInRange("", 0, 1);
          }
        }
        tree.endUpdates();
      });
      return;
    }
    let insertBefore;
    if (direction === "up") {
      insertBefore = nodes[0].previousLineNode();
      if (!insertBefore) {
        return;
      }
      if (editor2.nodeIsHiddenInFold(insertBefore)) {
        while (insertBefore && editor2.nodeIsHiddenInFold(insertBefore)) {
          insertBefore = insertBefore.previousLineNode();
        }
        if (insertBefore && !editor2.isCollapsed(insertBefore)) {
          insertBefore = insertBefore.nextLineNode();
        }
      }
      if (!insertBefore) {
        insertBefore = tree.firstLineNode();
      }
    }
    if (direction === "down") {
      let nextLineNode = nodes[nodes.length - 1].nextLineNode();
      if (!nextLineNode) {
        return;
      }
      insertBefore = nextLineNode.nextLineNode();
      if (editor2.isCollapsed(nextLineNode) || editor2.nodeIsHiddenInFold(nextLineNode)) {
        while (insertBefore && editor2.nodeIsHiddenInFold(insertBefore)) {
          insertBefore = insertBefore.nextLineNode();
        }
      }
    }
    performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
      tree.beginUpdates();
      tree.removeNodes(nodes);
      tree.insertNodesBefore(nodes, insertBefore);
      tree.endUpdates();
    });
  }
  function deleteParagraphs(editor2) {
    let tree = editor2.tree(), selectedRange = editor2.selectedRange(), range2 = selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2), nodes = range2.nodesInRange();
    if (!selectedRange.isCollapsed()) {
      editor2.replaceSelection("");
      return;
    }
    if (nodes.length === tree.nodeCount()) {
      tree.setText("");
    } else {
      tree.removeNodes(range2.nodesInRange());
    }
  }
  Extensions.addCommand({
    name: "moveParagraphsUp",
    performCommand(editor2) {
      moveParagraphs(editor2, "up");
    }
  });
  Extensions.addCommand({
    name: "moveParagraphsDown",
    performCommand(editor2) {
      moveParagraphs(editor2, "down");
    }
  });
  Extensions.addCommand({
    name: "moveParagraphsRight",
    performCommand(editor2) {
      moveParagraphs(editor2, "right");
    }
  });
  Extensions.addCommand({
    name: "moveParagraphsLeft",
    performCommand(editor2) {
      moveParagraphs(editor2, "left");
    }
  });
  Extensions.addCommand({
    name: "deleteParagraphs",
    performCommand: deleteParagraphs
  });

  // src/ft/extensions/indent.js
  init_extensions();
  function smartInsertTab(editor2) {
    let selectedRange = editor2.selectedRange(), selectionCollapsed = selectedRange.isCollapsed(), node = selectedRange.startNode, lead = node.tree.taxonomy.matchLeadForNode(node)[0];
    if (editor2.performCommand("replaceTextSnippet")) {
      return;
    }
    if (!selectionCollapsed || selectedRange.startOffset <= lead.length) {
      editor2.performCommand("moveParagraphsRight");
    } else {
      editor2.replaceSelection("	", "end", "+input");
    }
  }
  Extensions.addCommand({
    name: "smartInsertTab",
    performCommand: smartInsertTab
  });

  // src/ft/extensions/linkactivation.js
  init_extensions();
  function activateLink(editor2, node, ch, attributes, inBackground, addTagToNodePath) {
    attributes = attributes || node.lineAttributesAtIndex(ch);
    if (!attributes) {
      return false;
    }
    let target = node;
    function findLinkDefinitionFromTargetLabel(targetLabel) {
      let n3 = node;
      while (n3) {
        let type = n3.type();
        if (type === "linkdefinition" || type === "footnotelinkdefinition") {
          if (n3.lineAttributedString().findAttributeValue("linkid") === targetLabel) {
            return n3;
          }
        }
        n3 = n3.nextLineNode();
      }
      return null;
    }
    function findLinkFromTargetLabel(targetLabel) {
      let n3 = findLinkDefinitionFromTargetLabel(targetLabel);
      if (n3) {
        let t3 = n3.lineAttributedString().findAttributeValue("linktarget");
        if (t3) {
          return t3;
        }
        n3 = n3.nextLineNode();
        while (n3) {
          let type = n3.type();
          if (type === "linkdefinitionurl") {
            return n3.lineAttributedString().findAttributeValue("linktarget");
          } else if (type === "empty") {
            n3 = n3.nextLineNode();
            continue;
          } else {
            return null;
          }
        }
      }
      return null;
    }
    if (attributes.linktarget) {
      target = attributes.linktarget;
      attributes = node.lineAttributesAtIndex(ch);
      if (attributes.referencelink) {
        editor2.openLink(findLinkFromTargetLabel(target), inBackground);
      } else {
        editor2.openLink(target, inBackground);
      }
      return true;
    } else if (attributes.linklabel) {
      let linkLabel = attributes.linklabel;
      target = node.lineAttributedString().findAttributeValue("linktarget", ch);
      attributes = node.lineAttributesAtIndex(ch);
      if (attributes.referencelink) {
        if (!target || !target.trim()) {
          target = linkLabel;
        }
        editor2.openLink(findLinkFromTargetLabel(target), inBackground);
        return true;
      } else if (attributes.footnotelink) {
        target = linkLabel;
        let linkDefinition = findLinkDefinitionFromTargetLabel(target);
        if (linkDefinition) {
          editor2.scrollRangeToVisible(editor2.tree().createRangeFromNodes(linkDefinition, 0));
        }
        return true;
      } else if (attributes.inlinelink) {
        editor2.openLink(target, inBackground);
        return true;
      }
    } else if (attributes.tagname) {
      editor2.setNodePathFilter(`@${attributes.tagname}`);
      if (addTagToNodePath) {
        let path = editor2.nodePath().toString();
        editor2.setNodePath(`${path} union //@${attributes.tagname}//*`);
      }
      return true;
    } else if (attributes.tagvalue) {
      let tagvalue = attributes.tagvalue, location = ch, effectiveRange = {};
      while (location >= 0) {
        attributes = node.lineAttributesAtIndex(location, effectiveRange);
        if (attributes.tagname) {
          editor2.setNodePathFilter(`@${attributes.tagname} = "${tagvalue}"`);
          return true;
        }
        location = effectiveRange.location - 1;
      }
      return true;
    }
    return false;
  }
  function mouseDown2(editor2, e5) {
    let attributes = editor2.targetsAt(e5.clientX, e5.clientY).attributes;
    if (attributes.linklabel || attributes.linktarget || attributes.tagname || attributes.tagvalue) {
      return true;
    }
    return false;
  }
  function mouseUp2(editor2, e5) {
    if (e5.button === 2 || e5.button === 0 && e5.ctrlKey) {
      return false;
    }
    let targets = editor2.targetsAt(e5.clientX, e5.clientY), attributes = targets.attributes, lineCh = targets.lineCh, node = targets.node, addTagToNodePath, inBackground;
    if (import_codemirror3.default.mac) {
      inBackground = e5.metaKey;
    } else {
      inBackground = e5.ctrlKey;
    }
    addTagToNodePath = e5.metaKey;
    activateLink(editor2, node, lineCh.ch, attributes, inBackground, addTagToNodePath);
  }
  Extensions.add("com.foldingtext.editor.mouse", {
    mouseDown: mouseDown2,
    mouseUp: mouseUp2
  });
  Extensions.addCommand({
    name: "openLink",
    performCommand(editor2) {
      let range2 = editor2.selectedRange().rangeByAdjustingToEffectedNodesInEditor(editor2);
      activateLink(editor2, range2.startNode, range2.startOffset, null, false, false);
    }
  });

  // src/ft/extensions/movebranch.js
  init_extensions();
  function moveBranches(editor2, direction) {
    editor2.tree().ensureClassified();
    let selectedRange = editor2.selectedRange(), branches = Node.commonAncestorsForNodes(selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2).nodesInRange()).nodesInLineOrder(), firstBranch = branches[0], lastBranch = branches.lastObject(), lastEffected = lastBranch.lastDescendantOrSelf(), tree = editor2.tree(), newNextSibling = null, newParent = null;
    if (direction === "up") {
      newParent = firstBranch.parent;
      newNextSibling = firstBranch.previousSibling;
      if (!newNextSibling) {
        return;
      }
    } else if (direction === "down") {
      newParent = lastBranch.parent;
      newNextSibling = lastBranch.nextSibling;
      if (!newNextSibling) {
        let nextLineNode = lastEffected.nextLineNode();
        if (nextLineNode && nextLineNode.type() === "empty") {
          tree.beginUpdates();
          tree.insertNodeBefore(nextLineNode, firstBranch);
          tree.endUpdates();
        }
        return;
      }
      newNextSibling = newNextSibling.nextSibling;
    } else if (direction === "left") {
      newParent = firstBranch.parent.parent;
      newNextSibling = firstBranch.parent.nextSibling;
    } else if (direction === "right") {
      let each = firstBranch.previousLineNode();
      while (each && each.type() === "empty") {
        branches.unshift(each);
        each = each.previousLineNode();
      }
      firstBranch = branches[0];
      newParent = firstBranch.previousSibling;
    }
    if (!newParent) {
      return;
    }
    let validMove = true;
    branches.forEach((each) => {
      if (!newParent.validateInsertChildBefore(each, newNextSibling)) {
        validMove = false;
      }
    });
    if (!validMove) {
      return;
    }
    let effectedRange = tree.createRangeFromNodes(firstBranch, 0, lastEffected, lastEffected.line().length);
    performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
      newParent.insertChildrenBefore(branches, newNextSibling);
    });
  }
  function moveBranchesLeft(editor2) {
    moveBranches(editor2, "left");
  }
  function moveBranchesRight(editor2) {
    moveBranches(editor2, "right");
  }
  function moveBranchesUp(editor2) {
    moveBranches(editor2, "up");
  }
  function moveBranchesDown(editor2) {
    moveBranches(editor2, "down");
  }
  function promoteChildBranches(editor2) {
    let selectedRange = editor2.selectedRange(), node = selectedRange.startNode;
    if (node.firstChild) {
      let tree = editor2.tree(), children = node.children(), lastEffected = children.lastObject().lastDescendantOrSelf(), effectedRange = tree.createRangeFromNodes(children[0], 0, lastEffected, lastEffected.line().length);
      performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
        node.parent.insertChildrenBefore(children, node.nextSibling);
      });
    }
  }
  function demoteTrailingSiblingBranches(editor2) {
    let selectedRange = editor2.selectedRange(), node = selectedRange.startNode, each = node.nextSibling, trialingSiblings = [];
    while (each) {
      trialingSiblings.push(each);
      each = each.nextSibling;
    }
    if (trialingSiblings.length) {
      let tree = editor2.tree(), lastEffected = trialingSiblings.lastObject().lastDescendantOrSelf(), effectedRange = tree.createRangeFromNodes(trialingSiblings[0], 0, lastEffected, lastEffected.line().length);
      performNodeOperationWhileMaintainingEditorStateInRange(editor2, selectedRange, effectedRange, () => {
        node.insertChildrenBefore(trialingSiblings, null);
      });
    }
  }
  function deleteBranches(editor2) {
    let tree = editor2.tree(), selectedRange = editor2.selectedRange(), branches = Node.commonAncestorsForNodes(selectedRange.rangeByAdjustingToEffectedNodesInEditor(editor2).nodesInRange()).nodesInLineOrder();
    if (!selectedRange.isCollapsed()) {
      editor2.replaceSelection("");
      return;
    }
    if (tree.firstLineNode() === branches[0] && tree.lastLineNode() === branches[branches.length - 1].lastDescendantOrSelf()) {
      tree.setText("");
    } else {
      tree.beginUpdates();
      branches.forEach((each) => {
        each.removeFromParent();
      });
      tree.endUpdates();
    }
  }
  Extensions.addCommand({
    name: "moveBranchesUp",
    performCommand: moveBranchesUp
  });
  Extensions.addCommand({
    name: "moveBranchesDown",
    performCommand: moveBranchesDown
  });
  Extensions.addCommand({
    name: "moveBranchesLeft",
    performCommand: moveBranchesLeft
  });
  Extensions.addCommand({
    name: "moveBranchesRight",
    performCommand: moveBranchesRight
  });
  Extensions.addCommand({
    name: "promoteChildBranches",
    performCommand: promoteChildBranches
  });
  Extensions.addCommand({
    name: "demoteTrailingSiblingBranches",
    performCommand: demoteTrailingSiblingBranches
  });
  Extensions.addCommand({
    name: "deleteBranches",
    performCommand: deleteBranches
  });

  // src/ft/extensions/native/index.js
  init_extensions();

  // src/ft/extensions/native/communication.js
  init_extensions();
  var nativeTargets = {
    "editor-loaded": "isReady",
    "content-changed": "textContentDidChange",
    notification: "notification",
    "open-link": "openLink",
    "open-relative-path": "openRelativePath",
    "console-log": "consoleLog"
  };
  function registerListener() {
  }
  function packageSourceEvent(payload = {}) {
    return payload;
  }
  function postMessage(eventName, payload = {}) {
    var _a;
    const nativeViewController = (_a = window == null ? void 0 : window.webkit) == null ? void 0 : _a.messageHandlers[nativeTargets[eventName]];
    if (nativeViewController) {
      const event2 = packageSourceEvent(payload);
      nativeViewController.postMessage(event2);
    }
  }
  Extensions.add("com.foldingtext.editor.methods", {
    postMessage,
    registerListener
  });
  Extensions.add("com.foldingtext.editor.beforeChange", (editor2, change) => {
    const tree = editor2.tree();
    const { text, removed, from, to } = change;
    const fromOffset = tree.textOffsetForLineChar(from.line, from.ch);
    const toOffset = tree.textOffsetForLineChar(to.line, to.ch);
    const event2 = {
      from: fromOffset,
      to: toOffset,
      removed,
      text
    };
    postMessage("content-changed", event2);
  });

  // src/ft/extensions/native/debug.js
  init_extensions();
  Extensions.addInit((editor2) => {
    const oldConsoleLog = console.log;
    console.log = (...args) => {
      editor2.postMessage("console-log", args);
      oldConsoleLog(...args);
    };
  });

  // src/ft/extensions/native/index.js
  Extensions.add("com.foldingtext.editor.methods", {
    isNative: () => {
      var _a;
      return !!((_a = window == null ? void 0 : window.webkit) == null ? void 0 : _a.messageHandlers);
    }
  });

  // src/ft/extensions/outline-view/outline-view.js
  init_extensions();
  var outlineNodePath = "//heading union //@mode";
  var emptyMessage = "No Headings or Modes";
  var element;
  var isResizing = false;
  var lastMouseDownPosition;
  var initialWidth;
  var _editor;
  var sizer = null;
  function onSizerMouseDown(e5) {
    isResizing = true;
    lastMouseDownPosition = e5.clientX;
    let el = e5.target;
    initialWidth = parseFloat(window.getComputedStyle(el.parentElement, null).getPropertyValue("width"));
    document.addEventListener("mouseup", onSizerMouseUp, true);
    document.addEventListener("mousemove", onSizerMouseMove, true);
    if (el.setCapture)
      el.setCapture();
    el.parentElement.classList.add("sizing");
    e5.preventDefault();
    return false;
  }
  function onSizerMouseUp(e5) {
    isResizing = false;
    let el = sizer || e5.target;
    if (el.releaseCapture)
      el.releaseCapture();
    setTimeout(() => {
      el.parentElement.classList.remove("sizing");
      if (_editor) {
        _editor.setOption("outlineViewPanelWidth", parseFloat(el.parentElement.style.width));
      }
    });
    document.removeEventListener("mouseup", onSizerMouseUp, true);
    document.removeEventListener("mousemove", onSizerMouseMove, true);
  }
  function onSizerMouseMove(e5) {
    if (!isResizing)
      return;
    let parent = sizer.parentElement;
    let movement = e5.clientX - lastMouseDownPosition;
    parent.style.width = `${initialWidth + movement}px`;
    e5.preventDefault();
    return false;
  }
  function createUI() {
    let el = document.createElement("div");
    el.style.marginLeft = "-220px";
    el.className = "outlineView";
    sizer = document.createElement("div");
    sizer.className = "sizer";
    el.appendChild(sizer);
    sizer.addEventListener("mousedown", onSizerMouseDown);
    let treeContent = document.createElement("ul");
    treeContent.className = "outline-items";
    el.appendChild(treeContent);
    document.body.insertBefore(el, document.body.firstChild);
    return treeContent;
  }
  function updateDisplay(editor2) {
    if (editor2.option("showOutlineView")) {
      if (!_editor) {
        _editor = editor2;
      }
      if (!element) {
        element = createUI(editor2);
      }
      setTimeout(() => {
        let panelWidth = editor2.option("outlineViewPanelWidth");
        element.parentElement.style.marginLeft = 0;
        if (panelWidth && panelWidth > 0) {
          element.parentElement.style.width = `${panelWidth}px`;
        }
      });
      element.innerHTML = "";
      let outlineNodes = editor2.tree().evaluateNodePath(outlineNodePath);
      outlineNodes.forEach((node) => {
        let eachElement = document.createElement("li");
        let classes2 = ["outlineViewItem"];
        let mode2 = node.mode();
        let range2 = editor2.tree().createRangeFromNodes(node, 0);
        let text = node.textWithoutSyntax();
        classes2.push(`level-${node.typeIndentLevel()}`);
        if (mode2) {
          classes2.push("mode");
          classes2.push(`mode-${node.mode()}`);
          let modeSpecifier = document.createElement("span");
          modeSpecifier.className = "mode-name";
          modeSpecifier.textContent = node.mode();
          eachElement.appendChild(modeSpecifier);
        }
        eachElement.id = `outlineView-${node.id}`;
        eachElement.className = classes2.join(" ");
        eachElement.setAttribute("title", text);
        eachElement.appendChild(document.createTextNode(text));
        let isDouble = false;
        let delay = 200;
        eachElement.addEventListener("click", () => {
          setTimeout(() => {
            if (isDouble) {
              return;
            }
            if (!editor2.nodePath().isShowAllPath()) {
              editor2.performCommand("showAll");
            }
            editor2.setSelectedRange(range2);
            editor2.performCommand("centerSelectionInVisibleArea", 0.05);
            editor2.scrollRangeToVisible(range2);
            editor2.cm().focus();
          }, delay);
        });
        eachElement.addEventListener("dblclick", () => {
          isDouble = true;
          setTimeout(() => {
            if (NodePath.calculateMinNodePath(node, true) !== editor2.nodePath()) {
              editor2.focusNode(node);
              editor2.setSelectedRange(range2);
              editor2.scrollRangeToVisible(range2);
            }
            editor2.cm().focus();
          });
          setTimeout(() => {
            isDouble = false;
          }, delay);
          return false;
        });
        element.appendChild(eachElement);
      });
      if (outlineNodes.length === 0) {
        let emptyElement = document.createElement("li");
        emptyElement.className = "empty";
        emptyElement.textContent = emptyMessage;
        element.appendChild(emptyElement);
      }
    } else if (element) {
      element.parentElement.style.marginLeft = `-${element.parentElement.getBoundingClientRect().width}px`;
    }
  }
  Extensions.addInit((editor2) => {
    updateDisplay(editor2);
  });
  Extensions.addTreeChanged((editor2) => {
    updateDisplay(editor2);
  });
  Extensions.addCommand({
    name: "toggleOutlineView",
    validate(editor2, options) {
      options.interfaceItemState = editor2.option("showOutlineView");
      return true;
    },
    performCommand(editor2) {
      editor2.setOption("showOutlineView", !editor2.option("showOutlineView"));
      updateDisplay(editor2);
    }
  });
  Extensions.add("com.foldingtext.editor.options", {
    name: "outlineViewPanelWidth",
    defaultValue: 0,
    onChange(editor2, oldValue, newValue) {
      setTimeout(() => {
        if (newValue && newValue > 0 && element) {
          let curWidth = element.parentElement.style.width;
          if (!curWidth) {
            element.parentElement.style.width = `${newValue}px`;
          }
        }
      });
    }
  });
  Extensions.add("com.foldingtext.editor.options", {
    name: "showOutlineView",
    defaultValue: false,
    onChange(editor2) {
      updateDisplay(editor2);
    }
  });

  // src/ft/extensions/popup-menu.js
  init_extensions();
  var MenuItem = class {
    constructor(parent, label, { onClick }) {
      if (!label)
        throw new Error("Label should be supplied for Menu Item");
      this.label = label;
      this.isSeparator = label === "-";
      this.element = null;
      this.onClick = this.isSeparator ? null : onClick;
      this.parent = parent;
    }
    renderElement() {
      if (this.element)
        return this.element;
      this.element = document.createElement("li");
      this.element.className = "menu-item";
      if (this.isSeparator) {
        this.element.classList.add("separator");
      }
      this.element.addEventListener("mouseup", (e5) => {
        if (this.onClick)
          this.onClick(e5);
        if (!this.isSeparator)
          this.parent.menuItemClicked(this);
      });
      this.createMenuItemBody();
      return this.element;
    }
    createMenuItemBody() {
      const wrapper = document.createElement("div");
      wrapper.className = "wrapper";
      const text = document.createElement("span");
      if (!this.isSeparator)
        text.textContent = this.label;
      wrapper.appendChild(text);
      this.element.innerHTML = "";
      this.element.appendChild(wrapper);
    }
  };
  var PopupMenu = class {
    constructor(destroyOnClose) {
      this.menuElement = document.createElement("ul");
      this.menuElement.className = "popup-menu";
      this.isOpen = false;
      this._lastOpenOptions = [];
      this._menuItems = [];
      this._rendered = false;
      this.destroyOnClose = destroyOnClose;
      this.boundClose = this.close.bind(this);
    }
    setMenuItems(items) {
      this._menuItems = items.map((item) => {
        return new MenuItem(this, item.label, item);
      });
      this._rendered = false;
      this.renderUpdate();
    }
    addMenuItem(label, { onClick, index: index2 = -1 }) {
      const menuItem = new MenuItem(this, label, { onClick });
      if (index2 === -1)
        this._menuItems.push(menuItem);
      else
        this._menuItems.splice(index2, 0, menuItem);
      this._rendered = false;
      this.renderUpdate();
    }
    onClose(callback) {
      this.onCloseCallback = callback;
    }
    menuItemClicked(menuItem) {
      this.close(menuItem);
    }
    renderUpdate() {
      const fragment = document.createDocumentFragment();
      this._menuItems.map((item) => item.renderElement()).forEach((el) => fragment.appendChild(el));
      const wasOpen = this.isOpen;
      if (this.isOpen)
        this.close();
      this.menuElement.innerHTML = "";
      this.menuElement.appendChild(fragment);
      this._rendered = true;
      if (wasOpen)
        this.open(...this._lastOpenOptions);
    }
    open(anchorRect, parent) {
      if (!this.menuElement)
        throw new Error("Cannot reuse destoryed menu popup");
      if (this.isOpen)
        return;
      if (!this._rendered)
        this.renderUpdate();
      const { top, bottom, left } = anchorRect;
      const viewportHeight = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
      this._lastOpenOptions = [anchorRect, parent];
      this.menuElement.style.bottom = null;
      this.menuElement.style.top = null;
      if (bottom > viewportHeight / 2) {
        this.menuElement.style.bottom = `${viewportHeight - top}px`;
      } else
        this.menuElement.style.top = `${bottom}px`;
      this.menuElement.style.left = `${left}px`;
      this.menuElement.classList.add("open");
      this.isOpen = true;
      const actualParent = parent || document.body;
      actualParent.appendChild(this.menuElement);
    }
    close(menuItem) {
      if (!this.isOpen)
        return;
      this.menuElement.classList.remove("open");
      this.isOpen = false;
      if (this.destroyOnClose) {
        this.destroy();
      }
      this.onCloseCallback && this.onCloseCallback(menuItem);
    }
    destroy() {
      this._rendered = false;
      this.menuElement.innerHTML = "";
      if (this.menuElement.parentElement) {
        this.menuElement.parentElement.removeChild(this.menuElement);
      }
      this.menuElement = null;
    }
  };
  Extensions.add("com.foldingtext.editor.methods", {
    createPopupMenu: () => {
      return new PopupMenu();
    }
  });

  // src/ft/extensions/postmessage.js
  init_extensions();
  Extensions.addInit((editor2) => {
    window.addEventListener("message", (e5) => {
      if (e5.origin !== "http://localhost:3000")
        return;
      const { data } = e5;
      if (data.action === "setText") {
        editor2.setTextContent(data.text);
        return;
      }
      if (data.action === "focus") {
        editor2.focus();
        return;
      }
    });
  });

  // src/ft/extensions/showlistbullets.js
  init_extensions();
  var replaceLocationRE = /[-+*]/;
  var shouldRenderNode = function shouldRenderNode2(node) {
    return node.type() === "unordered";
  };
  Extensions.add("com.foldingtext.editor.options", {
    name: "showListBullets",
    defaultValue: true,
    onChange(editor2, oldValue, newValue) {
      if (oldValue === newValue) {
        return;
      }
      editor2.operation(() => {
        let each = editor2.tree().firstLineNode();
        while (each) {
          if (shouldRenderNode(each)) {
            editor2.setNeedsRender(each);
          }
          each = each.nextLineNode();
        }
        editor2.refresh();
      });
    }
  });
  Extensions.addCommand({
    name: "toggleShowListBullets",
    validate(editor2, options) {
      options.interfaceItemState = editor2.option("showListBullets");
      return true;
    },
    performCommand(editor2) {
      editor2.setOption("showListBullets", !editor2.option("showListBullets"));
    }
  });
  Extensions.addRenderNode((editor2, node, nodeRenderer) => {
    if (editor2.option("showListBullets") && shouldRenderNode(node)) {
      let match = replaceLocationRE.exec(node.line());
      if (match) {
        let widget = document.createElement("span");
        let textNode = document.createTextNode("\u2022");
        widget.className = "cm-list-bullet";
        widget.appendChild(textNode);
        nodeRenderer.renderInlineWidget(match.index, 1, widget);
      }
    }
  });
  function configure(shouldRenderNodeOverride, createArchiveNodeOverride) {
    if (shouldRenderNodeOverride) {
      shouldRenderNode = shouldRenderNodeOverride;
    }
    if (createArchiveNodeOverride) {
      createArchiveNode = createArchiveNodeOverride;
    }
  }

  // src/ft/editor/commands.js
  init_extensions();

  // src/ft/editor/diacritics.js
  var defaultDiacriticsRemovalap = [
    {
      base: "A",
      letters: "u0041\u24B6\uFF21\xC0\xC1\xC2\u1EA6\u1EA4\u1EAA\u1EA8\xC3\u0100\u0102\u1EB0\u1EAE\u1EB4\u1EB2\u0226\u01E0\xC4\u01DE\u1EA2\xC5\u01FA\u01CD\u0200\u0202\u1EA0\u1EAC\u1EB6\u1E00\u0104\u023A\u2C6F"
    },
    { base: "AA", letters: "uA732" },
    { base: "AE", letters: "u00C6\u01FC\u01E2" },
    { base: "AO", letters: "uA734" },
    { base: "AU", letters: "uA736" },
    { base: "AV", letters: "uA738\uA73A" },
    { base: "AY", letters: "uA73C" },
    {
      base: "B",
      letters: "u0042\u24B7\uFF22\u1E02\u1E04\u1E06\u0243\u0182\u0181"
    },
    {
      base: "C",
      letters: "u0043\u24B8\uFF23\u0106\u0108\u010A\u010C\xC7\u1E08\u0187\u023B\uA73E"
    },
    {
      base: "D",
      letters: "u0044\u24B9\uFF24\u1E0A\u010E\u1E0C\u1E10\u1E12\u1E0E\u0110\u018B\u018A\u0189\uA779"
    },
    { base: "DZ", letters: "u01F1\u01C4" },
    { base: "Dz", letters: "u01F2\u01C5" },
    {
      base: "E",
      letters: "u0045\u24BA\uFF25\xC8\xC9\xCA\u1EC0\u1EBE\u1EC4\u1EC2\u1EBC\u0112\u1E14\u1E16\u0114\u0116\xCB\u1EBA\u011A\u0204\u0206\u1EB8\u1EC6\u0228\u1E1C\u0118\u1E18\u1E1A\u0190\u018E"
    },
    { base: "F", letters: "u0046\u24BB\uFF26\u1E1E\u0191\uA77B" },
    {
      base: "G",
      letters: "u0047\u24BC\uFF27\u01F4\u011C\u1E20\u011E\u0120\u01E6\u0122\u01E4\u0193\uA7A0\uA77D\uA77E"
    },
    {
      base: "H",
      letters: "u0048\u24BD\uFF28\u0124\u1E22\u1E26\u021E\u1E24\u1E28\u1E2A\u0126\u2C67\u2C75\uA78D"
    },
    {
      base: "I",
      letters: "u0049\u24BE\uFF29\xCC\xCD\xCE\u0128\u012A\u012C\u0130\xCF\u1E2E\u1EC8\u01CF\u0208\u020A\u1ECA\u012E\u1E2C\u0197"
    },
    { base: "J", letters: "u004A\u24BF\uFF2A\u0134\u0248" },
    {
      base: "K",
      letters: "u004B\u24C0\uFF2B\u1E30\u01E8\u1E32\u0136\u1E34\u0198\u2C69\uA740\uA742\uA744\uA7A2"
    },
    {
      base: "L",
      letters: "u004C\u24C1\uFF2C\u013F\u0139\u013D\u1E36\u1E38\u013B\u1E3C\u1E3A\u0141\u023D\u2C62\u2C60\uA748\uA746\uA780"
    },
    { base: "LJ", letters: "u01C7" },
    { base: "Lj", letters: "u01C8" },
    { base: "M", letters: "u004D\u24C2\uFF2D\u1E3E\u1E40\u1E42\u2C6E\u019C" },
    {
      base: "N",
      letters: "u004E\u24C3\uFF2E\u01F8\u0143\xD1\u1E44\u0147\u1E46\u0145\u1E4A\u1E48\u0220\u019D\uA790\uA7A4"
    },
    { base: "NJ", letters: "u01CA" },
    { base: "Nj", letters: "u01CB" },
    {
      base: "O",
      letters: "u004F\u24C4\uFF2F\xD2\xD3\xD4\u1ED2\u1ED0\u1ED6\u1ED4\xD5\u1E4C\u022C\u1E4E\u014C\u1E50\u1E52\u014E\u022E\u0230\xD6\u022A\u1ECE\u0150\u01D1\u020C\u020E\u01A0\u1EDC\u1EDA\u1EE0\u1EDE\u1EE2\u1ECC\u1ED8\u01EA\u01EC\xD8\u01FE\u0186\u019F\uA74A\uA74C"
    },
    { base: "OI", letters: "u01A2" },
    { base: "OO", letters: "uA74E" },
    { base: "OU", letters: "u0222" },
    {
      base: "P",
      letters: "u0050\u24C5\uFF30\u1E54\u1E56\u01A4\u2C63\uA750\uA752\uA754"
    },
    { base: "Q", letters: "u0051\u24C6\uFF31\uA756\uA758\u024A" },
    {
      base: "R",
      letters: "u0052\u24C7\uFF32\u0154\u1E58\u0158\u0210\u0212\u1E5A\u1E5C\u0156\u1E5E\u024C\u2C64\uA75A\uA7A6\uA782"
    },
    {
      base: "S",
      letters: "u0053\u24C8\uFF33\u1E9E\u015A\u1E64\u015C\u1E60\u0160\u1E66\u1E62\u1E68\u0218\u015E\u2C7E\uA7A8\uA784"
    },
    {
      base: "T",
      letters: "u0054\u24C9\uFF34\u1E6A\u0164\u1E6C\u021A\u0162\u1E70\u1E6E\u0166\u01AC\u01AE\u023E\uA786"
    },
    { base: "TZ", letters: "uA728" },
    {
      base: "U",
      letters: "u0055\u24CA\uFF35\xD9\xDA\xDB\u0168\u1E78\u016A\u1E7A\u016C\xDC\u01DB\u01D7\u01D5\u01D9\u1EE6\u016E\u0170\u01D3\u0214\u0216\u01AF\u1EEA\u1EE8\u1EEE\u1EEC\u1EF0\u1EE4\u1E72\u0172\u1E76\u1E74\u0244"
    },
    { base: "V", letters: "u0056\u24CB\uFF36\u1E7C\u1E7E\u01B2\uA75E\u0245" },
    { base: "VY", letters: "uA760" },
    {
      base: "W",
      letters: "u0057\u24CC\uFF37\u1E80\u1E82\u0174\u1E86\u1E84\u1E88\u2C72"
    },
    { base: "X", letters: "u0058\u24CD\uFF38\u1E8A\u1E8C" },
    {
      base: "Y",
      letters: "u0059\u24CE\uFF39\u1EF2\xDD\u0176\u1EF8\u0232\u1E8E\u0178\u1EF6\u1EF4\u01B3\u024E\u1EFE"
    },
    {
      base: "Z",
      letters: "u005A\u24CF\uFF3A\u0179\u1E90\u017B\u017D\u1E92\u1E94\u01B5\u0224\u2C7F\u2C6B\uA762"
    },
    {
      base: "a",
      letters: "u0061\u24D0\uFF41\u1E9A\xE0\xE1\xE2\u1EA7\u1EA5\u1EAB\u1EA9\xE3\u0101\u0103\u1EB1\u1EAF\u1EB5\u1EB3\u0227\u01E1\xE4\u01DF\u1EA3\xE5\u01FB\u01CE\u0201\u0203\u1EA1\u1EAD\u1EB7\u1E01\u0105\u2C65\u0250"
    },
    { base: "aa", letters: "uA733" },
    { base: "ae", letters: "u00E6\u01FD\u01E3" },
    { base: "ao", letters: "uA735" },
    { base: "au", letters: "uA737" },
    { base: "av", letters: "uA739\uA73B" },
    { base: "ay", letters: "uA73D" },
    {
      base: "b",
      letters: "u0062\u24D1\uFF42\u1E03\u1E05\u1E07\u0180\u0183\u0253"
    },
    {
      base: "c",
      letters: "u0063\u24D2\uFF43\u0107\u0109\u010B\u010D\xE7\u1E09\u0188\u023C\uA73F\u2184"
    },
    {
      base: "d",
      letters: "u0064\u24D3\uFF44\u1E0B\u010F\u1E0D\u1E11\u1E13\u1E0F\u0111\u018C\u0256\u0257\uA77A"
    },
    { base: "dz", letters: "u01F3\u01C6" },
    {
      base: "e",
      letters: "u0065\u24D4\uFF45\xE8\xE9\xEA\u1EC1\u1EBF\u1EC5\u1EC3\u1EBD\u0113\u1E15\u1E17\u0115\u0117\xEB\u1EBB\u011B\u0205\u0207\u1EB9\u1EC7\u0229\u1E1D\u0119\u1E19\u1E1B\u0247\u025B\u01DD"
    },
    { base: "f", letters: "u0066\u24D5\uFF46\u1E1F\u0192\uA77C" },
    {
      base: "g",
      letters: "u0067\u24D6\uFF47\u01F5\u011D\u1E21\u011F\u0121\u01E7\u0123\u01E5\u0260\uA7A1\u1D79\uA77F"
    },
    {
      base: "h",
      letters: "u0068\u24D7\uFF48\u0125\u1E23\u1E27\u021F\u1E25\u1E29\u1E2B\u1E96\u0127\u2C68\u2C76\u0265"
    },
    { base: "hv", letters: "u0195" },
    {
      base: "i",
      letters: "u0069\u24D8\uFF49\xEC\xED\xEE\u0129\u012B\u012D\xEF\u1E2F\u1EC9\u01D0\u0209\u020B\u1ECB\u012F\u1E2D\u0268\u0131"
    },
    { base: "j", letters: "u006A\u24D9\uFF4A\u0135\u01F0\u0249" },
    {
      base: "k",
      letters: "u006B\u24DA\uFF4B\u1E31\u01E9\u1E33\u0137\u1E35\u0199\u2C6A\uA741\uA743\uA745\uA7A3"
    },
    {
      base: "l",
      letters: "u006C\u24DB\uFF4C\u0140\u013A\u013E\u1E37\u1E39\u013C\u1E3D\u1E3B\u017F\u0142\u019A\u026B\u2C61\uA749\uA781\uA747"
    },
    { base: "lj", letters: "u01C9" },
    { base: "m", letters: "u006D\u24DC\uFF4D\u1E3F\u1E41\u1E43\u0271\u026F" },
    {
      base: "n",
      letters: "u006E\u24DD\uFF4E\u01F9\u0144\xF1\u1E45\u0148\u1E47\u0146\u1E4B\u1E49\u019E\u0272\u0149\uA791\uA7A5"
    },
    { base: "nj", letters: "u01CC" },
    {
      base: "o",
      letters: "u006F\u24DE\uFF4F\xF2\xF3\xF4\u1ED3\u1ED1\u1ED7\u1ED5\xF5\u1E4D\u022D\u1E4F\u014D\u1E51\u1E53\u014F\u022F\u0231\xF6\u022B\u1ECF\u0151\u01D2\u020D\u020F\u01A1\u1EDD\u1EDB\u1EE1\u1EDF\u1EE3\u1ECD\u1ED9\u01EB\u01ED\xF8\u01FF\u0254\uA74B\uA74D\u0275"
    },
    { base: "oi", letters: "u01A3" },
    { base: "ou", letters: "u0223" },
    { base: "oo", letters: "uA74F" },
    {
      base: "p",
      letters: "u0070\u24DF\uFF50\u1E55\u1E57\u01A5\u1D7D\uA751\uA753\uA755"
    },
    { base: "q", letters: "u0071\u24E0\uFF51\u024B\uA757\uA759" },
    {
      base: "r",
      letters: "u0072\u24E1\uFF52\u0155\u1E59\u0159\u0211\u0213\u1E5B\u1E5D\u0157\u1E5F\u024D\u027D\uA75B\uA7A7\uA783"
    },
    {
      base: "s",
      letters: "u0073\u24E2\uFF53\xDF\u015B\u1E65\u015D\u1E61\u0161\u1E67\u1E63\u1E69\u0219\u015F\u023F\uA7A9\uA785\u1E9B"
    },
    {
      base: "t",
      letters: "u0074\u24E3\uFF54\u1E6B\u1E97\u0165\u1E6D\u021B\u0163\u1E71\u1E6F\u0167\u01AD\u0288\u2C66\uA787"
    },
    { base: "tz", letters: "uA729" },
    {
      base: "u",
      letters: "u0075\u24E4\uFF55\xF9\xFA\xFB\u0169\u1E79\u016B\u1E7B\u016D\xFC\u01DC\u01D8\u01D6\u01DA\u1EE7\u016F\u0171\u01D4\u0215\u0217\u01B0\u1EEB\u1EE9\u1EEF\u1EED\u1EF1\u1EE5\u1E73\u0173\u1E77\u1E75\u0289"
    },
    { base: "v", letters: "u0076\u24E5\uFF56\u1E7D\u1E7F\u028B\uA75F\u028C" },
    { base: "vy", letters: "uA761" },
    {
      base: "w",
      letters: "u0077\u24E6\uFF57\u1E81\u1E83\u0175\u1E87\u1E85\u1E98\u1E89\u2C73"
    },
    { base: "x", letters: "u0078\u24E7\uFF58\u1E8B\u1E8D" },
    {
      base: "y",
      letters: "u0079\u24E8\uFF59\u1EF3\xFD\u0177\u1EF9\u0233\u1E8F\xFF\u1EF7\u1E99\u1EF5\u01B4\u024F\u1EFF"
    },
    {
      base: "z",
      letters: "u007A\u24E9\uFF5A\u017A\u1E91\u017C\u017E\u1E93\u1E95\u01B6\u0225\u0240\u2C6C\uA763"
    }
  ];
  var diacriticsMap = {};
  for (let i3 = 0; i3 < defaultDiacriticsRemovalap.length; i3++) {
    let letters = defaultDiacriticsRemovalap[i3].letters.split("");
    for (let j3 = 0; j3 < letters.length; j3++) {
      diacriticsMap[letters[j3]] = defaultDiacriticsRemovalap[i3].base;
    }
  }
  function removeDiacritics(str) {
    let letters = str.split(""), newStr = "";
    for (let i3 = 0; i3 < letters.length; i3++) {
      newStr += letters[i3] in diacriticsMap ? diacriticsMap[letters[i3]] : letters[i3];
    }
    return newStr;
  }

  // src/ft/editor/commands.js
  var killLocation = 0;
  var killBuffer = "";
  Extensions.addCommand({
    name: "moveForward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goCharRight(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveRight",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goCharRight(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveBackward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goCharLeft(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveLeft",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goCharLeft(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveUp",
    performCommand(editor2) {
      let range2 = editor2.selectedRange();
      if (!range2.isCollapsed()) {
        editor2.setSelectedRange(range2.rangeByCollapsing(true));
      }
      return import_codemirror3.default.commands.goLineUp(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveDown",
    performCommand(editor2) {
      let range2 = editor2.selectedRange();
      if (!range2.isCollapsed()) {
        editor2.setSelectedRange(range2.rangeByCollapsing(false));
      }
      return import_codemirror3.default.commands.goLineDown(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveWordForward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goWordRight(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveWordBackward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goWordLeft(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToBeginningOfLine",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goLineLeft(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToEndOfLine",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goLineRight(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToBeginningOfParagraph",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goLineStart(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToEndOfParagraph",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goLineEnd(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToEndOfDocument",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goDocEnd(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToBeginningOfDocument",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goDocStart(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "pageDown",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goPageDown(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "pageUp",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goPageUp(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "centerSelectionInVisibleArea",
    performCommand(editor2, percent) {
      if (percent === void 0) {
        percent = 0.5;
      }
      let selectedRange = editor2.selectedRange(), startCoords = editor2.charCoords(selectedRange.startLineCh(), "local"), endCoords = selectedRange.isCollapsed() ? startCoords : editor2.charCoords(selectedRange.endLineCh(), "local"), halfWindowHeight = editor2.wrapperElement().offsetHeight * percent, top = startCoords.top, bottom = endCoords.bottom, halfSelectionHeight = (bottom - top) / 2, scrollTo = Math.round(top - halfWindowHeight + halfSelectionHeight);
      editor2.scrollTo(null, scrollTo);
    }
  });
  function extendSelectionWithMovement(editor2, movement) {
    let cm = editor2.cm();
    cm.setExtending(true);
    movement();
    cm.setExtending(false);
  }
  Extensions.addCommand({
    name: "moveBackwardAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goCharLeft(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveForwardAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goCharRight(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveWordForwardAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goWordRight(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveWordBackwardAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goWordLeft(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveUpAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineUp(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveDownAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineDown(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToBeginningOfLineAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineLeft(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToEndOfLineAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineRight(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToBeginningOfParagraphAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineStart(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToEndOfParagraphAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineEnd(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToEndOfDocumentAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goDocEnd(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToBeginningOfDocumentAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goDocStart(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "pageDownAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goPageDown(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "pageUpAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goPageUp(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveParagraphForwardAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        import_codemirror3.default.commands.goLineEnd(editor2.cm());
        editor2.performCommand("moveForward");
      });
    }
  });
  Extensions.addCommand({
    name: "moveParagraphBackwardAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        editor2.performCommand("moveBackward");
        import_codemirror3.default.commands.goLineStart(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveWordLeft",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goWordLeft(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveWordRight",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goWordRight(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveRightAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goCharRight(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveLeftAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goCharLeft(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveWordRightAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goWordRight(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveWordLeftAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goWordLeft(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToLeftEndOfLine",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goLineLeft(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToRightEndOfLine",
    performCommand(editor2) {
      return import_codemirror3.default.commands.goLineRight(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "moveToLeftEndOfLineAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineLeft(editor2.cm());
      });
    }
  });
  Extensions.addCommand({
    name: "moveToRightEndOfLineAndModifySelection",
    performCommand(editor2) {
      extendSelectionWithMovement(editor2, () => {
        return import_codemirror3.default.commands.goLineRight(editor2.cm());
      });
    }
  });
  function offsetScroll(editor2, offset) {
    let cm = editor2.cm(), scrollInfo = editor2.scrollInfo();
    scrollInfo.top += offset;
    cm.scrollIntoView({
      left: 0,
      top: scrollInfo.top,
      right: 0,
      bottom: scrollInfo.top + scrollInfo.clientHeight
    });
  }
  Extensions.addCommand({
    name: "scrollPageUp",
    performCommand(editor2) {
      offsetScroll(editor2, -editor2.scrollInfo().clientHeight);
    }
  });
  Extensions.addCommand({
    name: "scrollPageDown",
    performCommand(editor2) {
      offsetScroll(editor2, editor2.scrollInfo().clientHeight);
    }
  });
  Extensions.addCommand({
    name: "scrollLineUp",
    performCommand(editor2) {
      offsetScroll(editor2, editor2.cm().defaultTextHeight());
    }
  });
  Extensions.addCommand({
    name: "scrollLineDown",
    performCommand(editor2) {
      offsetScroll(editor2, editor2.cm().defaultTextHeight());
    }
  });
  Extensions.addCommand({
    name: "scrollToBeginningOfDocument",
    performCommand(editor2) {
      editor2.cm().scrollTo(0, 0);
    }
  });
  Extensions.addCommand({
    name: "scrollToEndOfDocument",
    performCommand(editor2) {
      editor2.cm().scrollTo(0, Number.MAX_VALUE);
    }
  });
  Extensions.addCommand({
    name: "transpose",
    performCommand(editor2) {
      return import_codemirror3.default.commands.transposeChars(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "transposeWords",
    performCommand() {
      return true;
    }
  });
  Extensions.addCommand({
    name: "selectAll",
    performCommand(editor2) {
      let cm = editor2.cm(), scrollInfo = editor2.scrollInfo();
      import_codemirror3.default.commands.selectAll(editor2.cm());
      cm.scrollTo(0, scrollInfo.top);
    }
  });
  Extensions.addCommand({
    name: "selectParagraph",
    performCommand(editor2) {
      return editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToParagraph());
    }
  });
  Extensions.addCommand({
    name: "selectLine",
    performCommand(editor2) {
      return editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToLine());
    }
  });
  Extensions.addCommand({
    name: "selectWord",
    performCommand(editor2) {
      return editor2.setSelectedRange(editor2.selectedRange().rangeByExtendingToWord());
    }
  });
  Extensions.addCommand({
    name: "indent",
    performCommand(editor2) {
      return import_codemirror3.default.commands.indentMore(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "insertSpace",
    performCommand(editor2) {
      return editor2.replaceSelection(" ");
    }
  });
  Extensions.addCommand({
    name: "insertTab",
    performCommand(editor2) {
      return import_codemirror3.default.commands.insertTab(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "insertBacktab",
    performCommand(editor2) {
      return import_codemirror3.default.commands.indentLess(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "insertNewline",
    performCommand(editor2) {
      editor2.replaceSelection("\n", "end", "+input");
    }
  });
  Extensions.addCommand({
    name: "insertNewlineBelow",
    performCommand(editor2) {
      editor2.performCommand("moveToEndOfParagraph");
      editor2.performCommand("insertNewline");
    }
  });
  Extensions.addCommand({
    name: "insertNewlineAbove",
    performCommand(editor2) {
      editor2.performCommand("moveToBeginningOfParagraph");
      editor2.performCommand("insertNewline");
      editor2.performCommand("moveLeft");
    }
  });
  Extensions.addCommand({
    name: "insertParagraphSeparator",
    performCommand(editor2) {
      editor2.replaceSelection("\n\n", "end", "+input");
    }
  });
  Extensions.addCommand({
    name: "insertNewlineIgnoringFieldEditor",
    performCommand(editor2) {
      editor2.replaceSelection("\n", "end", "+input");
    }
  });
  Extensions.addCommand({
    name: "insertTabIgnoringFieldEditor",
    performCommand(editor2) {
      return import_codemirror3.default.commands.insertTab(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "insertLineBreak",
    performCommand(editor2) {
      editor2.replaceSelection("\u2028", "end", "+input");
    }
  });
  Extensions.addCommand({
    name: "insertContainerBreak",
    performCommand() {
    }
  });
  Extensions.addCommand({
    name: "insertSingleQuoteIgnoringSubstitution",
    performCommand() {
    }
  });
  Extensions.addCommand({
    name: "insertDoubleQuoteIgnoringSubstitution",
    performCommand() {
    }
  });
  function transformWord(editor2, t3) {
    let selectedRange = editor2.selectedRange(), selectedText = selectedRange.textInRange(), transformedText = t3(selectedText);
    editor2.replaceSelection(transformedText, "around");
  }
  Extensions.addCommand({
    name: "changeCaseOfLetter",
    performCommand() {
    }
  });
  Extensions.addCommand({
    name: "uppercaseWord",
    performCommand(editor2) {
      editor2.performCommand("selectWord");
      transformWord(editor2, (text) => {
        return text.toUpperCase();
      });
    }
  });
  Extensions.addCommand({
    name: "lowercaseWord",
    performCommand(editor2) {
      editor2.performCommand("selectWord");
      transformWord(editor2, (text) => {
        return text.toLowerCase();
      });
    }
  });
  Extensions.addCommand({
    name: "capitalizeWord",
    performCommand(editor2) {
      editor2.performCommand("selectWord");
      transformWord(editor2, (text) => {
        return text.charAt(0).toUpperCase() + text.slice(1);
      });
    }
  });
  Extensions.addCommand({
    name: "deleteForward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.delCharAfter(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "deleteBackward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.delCharBefore(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "deleteBackwardByDecomposingPreviousCharacter",
    performCommand(editor2) {
      let range2 = editor2.selectedRange();
      if (range2.isCollapsed()) {
        let location = range2.location();
        if (location > 0) {
          range2 = range2.rangeByOffsetting(-1, 1);
          let text = range2.textInRange(), textWithoutDiacritics = removeDiacritics(text);
          if (text === textWithoutDiacritics) {
            editor2.performCommand("deleteBackward");
          } else {
            editor2.setSelectedRange(range2);
            editor2.replaceSelection(textWithoutDiacritics, "end", "+delete");
          }
        }
      } else {
        editor2.performCommand("deleteBackward");
      }
    }
  });
  Extensions.addCommand({
    name: "deleteWordForward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.delWordAfter(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "deleteWordBackward",
    performCommand(editor2) {
      return import_codemirror3.default.commands.delWordBefore(editor2.cm());
    }
  });
  Extensions.addCommand({
    name: "deleteToBeginningOfLine",
    performCommand(editor2) {
      let range2 = editor2.selectedRange();
      if (range2.isCollapsed()) {
        editor2.performCommand("moveToBeginningOfLineAndModifySelection");
      }
      editor2.replaceSelection("", "end", "+delete");
    }
  });
  Extensions.addCommand({
    name: "deleteToEndOfLine",
    performCommand(editor2) {
      let range2 = editor2.selectedRange();
      if (range2.isCollapsed()) {
        editor2.performCommand("moveToEndOfLineAndModifySelection");
      }
      editor2.replaceSelection("", "end", "+delete");
    }
  });
  Extensions.addCommand({
    name: "deleteToBeginningOfParagraph",
    performCommand(editor2) {
      let range2 = editor2.selectedRange();
      if (range2.isCollapsed()) {
        editor2.setSelectedRange(range2.rangeByExtendingToBeginningOfParagraph());
      }
      editor2.replaceSelection("", "end", "+delete");
    }
  });
  Extensions.addCommand({
    name: "deleteToEndOfParagraph",
    performCommand(editor2) {
      let range2 = editor2.selectedRange(), location = range2.location();
      if (range2.isCollapsed()) {
        range2 = range2.rangeByExtendingToEndOfLine();
        if (range2.isCollapsed()) {
          range2 = range2.rangeByExtendingToEndOfParagraph();
        }
      }
      let killText = range2.textInRange();
      if (killLocation === location) {
        killBuffer += killText;
      } else {
        killLocation = location;
        killBuffer = killText;
      }
      editor2.setSelectedRange(range2);
      editor2.replaceSelection("", "end", "+delete");
    }
  });
  Extensions.addCommand({
    name: "yank",
    performCommand(editor2) {
      editor2.replaceSelection(killBuffer, "end", "+input");
    }
  });
  Extensions.addCommand({
    name: "complete",
    performCommand(editor2) {
      if (editor2.complete) {
        editor2.complete();
      }
      return true;
    }
  });
  Extensions.addCommand({
    name: "setMark",
    performCommand() {
      return true;
    }
  });
  Extensions.addCommand({
    name: "deleteToMark",
    performCommand() {
      return true;
    }
  });
  Extensions.addCommand({
    name: "selectToMark",
    performCommand() {
      return true;
    }
  });
  Extensions.addCommand({
    name: "swapWithMark",
    performCommand() {
      return true;
    }
  });
  Extensions.addCommand({
    name: "cancelOperation",
    performCommand(editor2) {
      let selections = editor2.cm().getSelections();
      if (editor2.isFinding) {
        editor2.performCommand("hideFindInterface");
      }
      if (selections.length > 1) {
        editor2.performCommand("singleSelection");
        return true;
      }
      return true;
    }
  });

  // src/ft/extensions/smartnewline.js
  init_extensions();
  function smartInsertNewline(editor2) {
    let tree = editor2.tree(), selectedRange = editor2.selectedRange(), node = selectedRange.startNode, currentLeadMatch = node.tree.taxonomy.matchLeadForNode(node), currentLead = currentLeadMatch[0], nextLead = "", after = true;
    if (selectedRange.isCollapsed()) {
      if (currentLead.length !== 0 && selectedRange.startOffset === currentLead.length && currentLead === node.line()) {
        editor2.operation(() => {
          editor2.setSelectedRange(tree.createRangeFromNodes(node, 0, node, node.line().length));
          editor2.replaceSelection("", "end", "+input");
          editor2.scrollRangeToVisible(editor2.selectedRange());
        });
        return;
      }
      let lineNumber = editor2.tree().nodeToLineNumber(node), matchNode;
      if (editor2.lineIsHiddenInFold(lineNumber)) {
        while (lineNumber > 0 && editor2.lineIsHiddenInFold(lineNumber)) {
          lineNumber--;
        }
        matchNode = tree.lineNumberToNode(lineNumber);
      } else {
        if (selectedRange.startOffset <= currentLeadMatch[0].length) {
          selectedRange.startOffset = 0;
          selectedRange.endOffset = 0;
          editor2.operation(() => {
            editor2.replaceTextInRange(selectedRange, "\n", "+input");
            editor2.scrollRangeToVisible(editor2.selectedRange());
          });
          return;
        }
        editor2.operation(() => {
          editor2.expandToRevealNode(node);
          editor2.expandNode(node);
          editor2.setSelectedRange(selectedRange);
        });
        if (node.firstChild) {
          matchNode = node.firstChild;
          after = false;
        } else {
          matchNode = node;
        }
      }
      nextLead = matchNode.tree.taxonomy.nextLeadFromNode(matchNode, after);
    }
    editor2.operation(() => {
      editor2.replaceSelection(`
${nextLead}`, "end", "+input");
      editor2.scrollRangeToVisible(editor2.selectedRange());
    });
  }
  Extensions.addCommand({
    name: "smartInsertNewline",
    performCommand: smartInsertNewline
  });
  Extensions.addCommand({
    name: "smartInsertNewlineAbove",
    performCommand(editor2) {
      editor2.performCommand("moveToBeginningOfParagraph");
      editor2.performCommand("smartInsertNewline");
      editor2.performCommand("moveLeft");
    }
  });
  Extensions.addCommand({
    name: "smartInsertNewlineAfter",
    performCommand(editor2) {
      editor2.performCommand("moveToEndOfParagraph");
      editor2.performCommand("smartInsertNewline");
    }
  });

  // src/ft/extensions/smartspace.js
  init_extensions();
  function smartInsertSpace(editor2) {
    if (editor2.performCommand("replaceTextSnippet")) {
      return;
    }
    return import_codemirror3.default.Pass;
  }
  Extensions.addCommand({
    name: "smartInsertSpace",
    performCommand: smartInsertSpace
  });

  // src/ft/extensions/snippets.js
  init_extensions();
  string_default();
  var wordRegex = /\w/;
  function processSnippetDictionary(potentialSnippetText, snippetDictionary) {
    for (let each in snippetDictionary) {
      if (potentialSnippetText.endsWith(each)) {
        let beforeSnippetChar = potentialSnippetText[potentialSnippetText.length - (each.length + 1)], startSnippetChar = each[0];
        if (beforeSnippetChar && wordRegex.test(beforeSnippetChar) && wordRegex.test(startSnippetChar)) {
          return;
        }
        return {
          shortcut: each,
          expansion: snippetDictionary[each]
        };
      }
    }
  }
  Extensions.addCommand({
    name: "replaceTextSnippet",
    performCommand(editor2) {
      let selectedRange = editor2.selectedRange();
      if (selectedRange.isCollapsed()) {
        let node = selectedRange.startNode, line = node.line(), snippetEnd = selectedRange.startOffset, snippetStart = snippetEnd;
        while (snippetStart > 0 && line[snippetStart - 1] !== " ") {
          snippetStart--;
        }
        let tree = editor2.tree(), shortcutRange = tree.createRangeFromNodes(node, snippetStart, node, snippetEnd), potentialSnippetText = shortcutRange.textInRange();
        if (potentialSnippetText) {
          let snippet = Extensions.processExtensions("com.foldingtext.editor.snippets", (eachSnippetDictionary) => {
            return processSnippetDictionary(potentialSnippetText, eachSnippetDictionary);
          }, true);
          if (snippet) {
            let shortcut = snippet.shortcut, expansion = snippet.expansion;
            if (typeof expansion === "function") {
              expansion = expansion(shortcut);
            }
            editor2.replaceTextInRange(selectedRange.rangeByOffsetting(-shortcut.length, shortcut.length), expansion);
            return true;
          }
        }
      }
      return false;
    }
  });

  // src/ft/extensions/typewriter.js
  init_extensions();
  function onChanges(cm, changes) {
    if (cm.getSelection().length === 0) {
      let editor2 = cm.getOption("ftEditor"), percent = editor2.option("typewriterModePercent");
      for (let i3 = 0; i3 < changes.length; i3++) {
        let each = changes[i3];
        if (each.origin === "+input" || each.origin === "+delete") {
          editor2.performCommand("centerSelectionInVisibleArea", percent);
          return;
        }
      }
    }
  }
  Extensions.add("com.foldingtext.editor.options", {
    name: "typewriterMode",
    defaultValue: false,
    onChange(editor2, oldValue, newValue) {
      let cm = editor2.cm();
      if (!newValue) {
        cm.off("changes", onChanges);
      }
      if (newValue) {
        cm.on("changes", onChanges);
      }
      editor2.invalidateRestorableState();
    }
  });
  Extensions.add("com.foldingtext.editor.options", {
    name: "typewriterModePercent",
    defaultValue: 0.5,
    onChange() {
    }
  });
  Extensions.addCommand({
    name: "toggleTypewriterMode",
    validate(editor2, options) {
      options.interfaceItemState = editor2.option("typewriterMode");
      return true;
    },
    performCommand(editor2) {
      editor2.setOption("typewriterMode", !editor2.option("typewriterMode"));
    }
  });

  // src/ft/extensions/undo.js
  init_extensions();
  Extensions.addCommand({
    name: "undo",
    validate(editor2) {
      return editor2.cm().doc.getHistory().done.length > 0;
    },
    performCommand(editor2) {
      editor2.cm().undo();
    }
  });
  Extensions.addCommand({
    name: "undoSelection",
    validate(editor2) {
      return editor2.cm().doc.getHistory().done.length > 0;
    },
    performCommand(editor2) {
      editor2.cm().undoSelection();
    }
  });
  Extensions.addCommand({
    name: "redo",
    validate(editor2) {
      return editor2.cm().doc.getHistory().undone.length > 0;
    },
    performCommand(editor2) {
      editor2.cm().redo();
    }
  });
  Extensions.addCommand({
    name: "redoSelection",
    validate(editor2) {
      return editor2.cm().doc.getHistory().undone.length > 0;
    },
    performCommand(editor2) {
      editor2.cm().redoSelection();
    }
  });
  Extensions.addCommand({
    name: "clearUndoHistory",
    performCommand(editor2) {
      return editor2.cm().clearHistory();
    }
  });

  // src/ft/extensions/wordcount.js
  init_extensions();
  var import_paralleljs = __toModule(require_parallel());
  var textContentProcessQueue = [];
  var textContentWordCount = 0;
  var textContent = "";
  var element2;
  function formatNumber(number2) {
    return number2.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
  }
  function updateDisplay2(editor2) {
    if (editor2.option("wordCount")) {
      if (!element2) {
        element2 = document.createElement("div");
        document.body.insertBefore(element2, document.body.firstChild);
      }
      let selectedRange = editor2.selectedRange(), newInnerHTML;
      if (selectedRange.isCollapsed()) {
        element2.className = "word-count";
        newInnerHTML = `${formatNumber(textContentWordCount)} Words<br/>`;
      } else {
        let selectedText = selectedRange.textInRange(), selectedWordCount = calculateWordCountDelta({
          insertedText: selectedText,
          replacedText: ""
        });
        element2.className = "word-count word-count-selected";
        newInnerHTML = `${formatNumber(selectedWordCount)} Words<br/>`;
      }
      if (newInnerHTML !== element2.innerHTML) {
        element2.innerHTML = newInnerHTML;
      }
    } else if (element2) {
      element2.parentNode.removeChild(element2);
      element2 = null;
    }
  }
  function wordTextForRange(start2, length) {
    let end = start2 + length, lengthMinusOne = textContent.length - 1, ch;
    while (start2 > 0) {
      start2--;
      ch = textContent[start2];
      if (ch === " " || ch === "\n") {
        break;
      }
    }
    while (end < lengthMinusOne) {
      end++;
      ch = textContent[end];
      if (ch === " " || ch === "\n") {
        break;
      }
    }
    return textContent.substr(start2, end - start2);
  }
  function calculateWordCountDelta(data) {
    let wordRegex2 = new RegExp("[A-Za-z0-9_'\xC0-\u017F]+|[\u3040-\u309F]+|[\u30A0-\u30FF]+|[\u4E00-\u9FFF\uF900-\uFAFF\u3400-\u4DBF]", "g");
    function wordCount(text) {
      let match = text.match(wordRegex2);
      return match ? match.length : 0;
    }
    let replacedWordCount = wordCount(data.replacedText), insertedWordCount = wordCount(data.insertedText);
    return insertedWordCount - replacedWordCount;
  }
  function processNext(editor2) {
    textContentProcessQueue[0].spawn(calculateWordCountDelta).then((wordCountDelta) => {
      textContentProcessQueue.shift();
      textContentWordCount += wordCountDelta;
      if (textContentProcessQueue.length === 0) {
        updateDisplay2(editor2);
      } else {
        processNext(editor2);
      }
    });
  }
  function scheduleProcessing(editor2, location, replacedText, insertedText) {
    let replacedWordRangeText = wordTextForRange(location, replacedText.length);
    textContent = textContent.replaceRange(location, location + replacedText.length, insertedText);
    let insertedWordRangeText = wordTextForRange(location, insertedText.length);
    textContentProcessQueue.push(new import_paralleljs.default({
      replacedText: replacedWordRangeText,
      insertedText: insertedWordRangeText
    }));
    if (textContentProcessQueue.length === 1) {
      processNext(editor2);
    }
  }
  Extensions.addInit((editor2) => {
    scheduleProcessing(editor2, 0, 0, editor2.textContent());
  });
  Extensions.addTreeChanged((editor2, e5) => {
    let deltas = e5.deltas, deletasLength = deltas.length;
    for (let i3 = 0; i3 < deletasLength; i3++) {
      let eachDelta = deltas[i3];
      if (eachDelta.textChanged()) {
        scheduleProcessing(editor2, eachDelta.location, eachDelta.replacedText, eachDelta.insertedText);
      }
    }
  });
  Extensions.addSelectionDidChange((editor2) => {
    updateDisplay2(editor2);
  });
  Extensions.add("com.foldingtext.editor.options", {
    name: "wordCount",
    defaultValue: true,
    onChange(editor2) {
      updateDisplay2(editor2);
    }
  });
  Extensions.addCommand({
    name: "toggleWordCount",
    validate(editor2, options) {
      options.interfaceItemState = editor2.option("wordCount");
      return true;
    },
    performCommand(editor2) {
      editor2.setOption("wordCount", !editor2.option("wordCount"));
    }
  });

  // src/extensions.js
  configure((node) => node.type() === "unordered" && node.modeContext() !== "todo");

  // src/ft/editor/composition.js
  var PREFIX_LIST = ["webkit", "moz", "o"];
  var modInitialized = false;
  var TEXT_MARKER_OPTIONS = {
    inclusiveLeft: true,
    inclusiveRight: true,
    className: "text-in-composition"
  };
  function capitalizeString(string2) {
    return string2.charAt(0).toUpperCase() + string2.slice(1);
  }
  function getPrefixedPropertyName(propertyName) {
    let prefix, prefixedPropertyName, tempElem, _i, _len;
    tempElem = document.createElement("div");
    if (tempElem.style[propertyName] !== void 0) {
      return propertyName;
    }
    for (_i = 0, _len = PREFIX_LIST.length; _i < _len; _i++) {
      prefix = PREFIX_LIST[_i];
      prefixedPropertyName = prefix + capitalizeString(propertyName);
      if (tempElem.style[prefixedPropertyName] !== void 0) {
        return prefixedPropertyName;
      }
    }
    return false;
  }
  import_codemirror3.default.defineOption("enableCompositionMod", false, (cm, newVal) => {
    if (newVal && !modInitialized) {
      if (window.CompositionEvent) {
        return initCompositionMode(cm);
      }
      console.warn("Your browser doesn't support CompositionEvent.");
      return cm.setOption("enableCompositionMod", false);
    }
  });
  import_codemirror3.default.defineOption("debugCompositionMod", false, (cm, newVal) => {
    let inputField;
    inputField = cm.display.input;
    if (typeof jQuery === "undefined" || jQuery === null) {
      return;
    }
    if (newVal) {
      $(inputField).on("input.composition-debug keypress.composition-debug compositionupdate.composition-debug", (e5) => {
        return console.log(`[${e5.type}]`, e5.originalEvent.data, inputField.value, e5.timeStamp);
      });
      return $(inputField).on("compositionstart.composition-debug compositionend.composition-debug", (e5) => {
        return console.warn(`[${e5.type}]`, e5.originalEvent.data, inputField.value, cm.getCursor(), e5.timeStamp);
      });
    }
    return $(inputField).off(".composition-debug");
  });
  function setInputTranslate(cm, translateValue) {
    let transformProperty;
    transformProperty = getPrefixedPropertyName("transform");
    cm.display.input.style[transformProperty] = translateValue;
    return translateValue;
  }
  function clearCompositionTextMarkers(cm) {
    let textMarker, textMarkersArray, _i, _len;
    textMarkersArray = cm.getAllMarks();
    for (_i = 0, _len = textMarkersArray.length; _i < _len; _i++) {
      textMarker = textMarkersArray[_i];
      if (textMarker && textMarker.className === "text-in-composition") {
        textMarker.clear();
        if (cm.options.debugCompositionMod) {
          console.log("[TextMarker] Cleared");
        }
      }
    }
    return true;
  }
  function initCompositionMode(cm) {
    let inputField, inputWrapper, moveInputWithCursor;
    inputField = cm.display.input;
    inputWrapper = cm.display.inputDiv;
    moveInputWithCursor = cm.options.moveInputWithCursor;
    import_codemirror3.default.on(inputField, "compositionstart", () => {
      if (!cm.options.enableCompositionMod) {
        return;
      }
      cm.display.inCompositionMode = true;
      cm.setOption("readOnly", true);
      cm.setOption("moveInputWithCursor", true);
      if (cm.somethingSelected()) {
        cm.replaceSelection("");
      }
      cm.display.compositionHead = cm.getCursor();
      if (cm.options.debugCompositionMod) {
        console.log("[compositionstart] Update Composition Head", cm.display.compositionHead);
      }
      inputField.value = "";
      if (cm.options.debugCompositionMod) {
        console.log("[compositionstart] Clear cm.display.input", cm.display.compositionHead);
      }
      inputWrapper.classList.add("CodeMirror-input-wrapper");
      return inputWrapper.classList.add("in-composition");
    });
    import_codemirror3.default.on(inputField, "compositionupdate", (event2) => {
      let endPos, headPos, markerRange, pixelToTranslate;
      if (!cm.options.enableCompositionMod) {
        return;
      }
      headPos = cm.display.compositionHead;
      if (cm.display.textMarkerInComposition) {
        markerRange = cm.display.textMarkerInComposition.find();
        cm.replaceRange(event2.data, headPos, markerRange.to);
        cm.display.textMarkerInComposition.clear();
        cm.display.textMarkerInComposition = void 0;
      } else {
        cm.replaceRange(event2.data, headPos, headPos);
      }
      endPos = cm.getCursor();
      cm.display.textMarkerInComposition = cm.markText(headPos, endPos, TEXT_MARKER_OPTIONS);
      let headCoords = cm.charCoords(headPos, "local");
      let endCoords = cm.charCoords(endPos, "local");
      if (headCoords.top === endCoords.top) {
        pixelToTranslate = endCoords.left - headCoords.left;
      } else {
        let marginLeft = cm.getOption("ftEditor").defaultPREStyling().marginLeft;
        pixelToTranslate = endCoords.left - marginLeft;
      }
      return setInputTranslate(cm, `translateX(-${pixelToTranslate}px)`);
    });
    return import_codemirror3.default.on(inputField, "compositionend", (event2) => {
      let endPos, headPos, postCompositionEnd, textLeftComposition, _ref;
      if (!cm.options.enableCompositionMod) {
        return;
      }
      textLeftComposition = event2.data;
      headPos = cm.display.compositionHead;
      endPos = cm.getCursor();
      cm.replaceRange(textLeftComposition, headPos, endPos);
      cm.display.inCompositionMode = false;
      cm.display.compositionHead = void 0;
      if (_ref = cm.display.textMarkerInComposition) {
        _ref.clear();
      }
      cm.display.textMarkerInComposition = void 0;
      cm.setOption("readOnly", false);
      cm.setOption("moveInputWithCursor", moveInputWithCursor);
      inputWrapper.classList.remove("CodeMirror-input-wrapper");
      inputWrapper.classList.remove("in-composition");
      clearCompositionTextMarkers(cm);
      postCompositionEnd = function() {
        if (cm.display.inCompositionMode) {
          return false;
        }
        inputField.value = "";
        if (cm.options.debugCompositionMod) {
          console.warn("[postCompositionEnd] Input Cleared");
        }
        import_codemirror3.default.off(inputField, "input", postCompositionEnd);
        if (cm.options.debugCompositionMod) {
          return console.log("[postCompositionEnd] Handler unregistered for future input events");
        }
      };
      return import_codemirror3.default.on(inputField, "input", postCompositionEnd);
    });
  }

  // src/ft/editor/elementrenderer.js
  var ElementRenderer = function ElementRenderer2(editor2, cm) {
    this.editor = editor2;
    this.cm = cm;
    this._cmBuilder = null;
    this._cmMeasure = null;
    this._node = null;
    this._element = null;
    this._lineHandle = null;
    this._lineNumber = null;
  };
  ElementRenderer.prototype.setStyle = function setStyle(name106, value) {
    this._element.style[name106] = value;
  };
  ElementRenderer.prototype.setAttribute = function setAttribute(name106, value) {
    try {
      this._element.setAttribute(name106, value);
    } catch (e5) {
      console.error(`Invalid DOM Node attribute name: ${name106} or value: ${value}`);
    }
  };
  ElementRenderer.prototype.textClass = function textClass() {
    return this._cmBuilder.textClass;
  };
  ElementRenderer.prototype.addTextClass = function addTextClass(clss) {
    if (this._cmBuilder.textClass) {
      this._cmBuilder.textClass += ` ${clss}`;
    } else {
      this._cmBuilder.textClass = clss;
    }
  };
  ElementRenderer.prototype.backgroundClass = function backgroundClass() {
    return this._cmBuilder.bgClass;
  };
  ElementRenderer.prototype.addBackgroundClass = function addBackgroundClass(clss) {
    if (this._cmBuilder.bgClass) {
      this._cmBuilder.bgClass += ` ${clss}`;
    } else {
      this._cmBuilder.bgClass = clss;
    }
  };
  ElementRenderer.prototype.wrapClass = function wrapClass() {
    return this._cmBuilder.wrapClass;
  };
  ElementRenderer.prototype.addWrapClass = function addWrapClass(clss) {
    if (this._cmBuilder.wrapClass) {
      this._cmBuilder.wrapClass += ` ${clss}`;
    } else {
      this._cmBuilder.wrapClass = clss;
    }
  };
  ElementRenderer.prototype.measureTextRange = function measureTextRange(location, length) {
    if (this._cmBuilder.textClass !== this._element.className) {
      this._element.className = this._cmBuilder.textClass;
    }
    return this.editor.measureNodeText(this._node, location, length, this._cmBuilder, this._cmMeasure);
  };

  // src/ft/editor/keybindings.js
  init_extensions();
  Extensions.addInit((editor2) => {
    editor2.addKeyMap({
      name: "basic",
      Left: "goCharLeft",
      Right: "goCharRight",
      Up: "goLineUp",
      Down: "goLineDown",
      End: "goLineEnd",
      Home: "goLineStartSmart",
      PageUp: "goPageUp",
      PageDown: "goPageDown",
      Delete: "delCharAfter",
      Backspace: "delCharBefore",
      "Shift-Backspace": "delCharBefore",
      Tab: "defaultTab",
      "Shift-Tab": "indentAuto",
      Enter: "smartInsertNewline",
      Insert: "toggleOverwrite",
      Esc: "singleSelection"
    });
    editor2.addKeyMap({
      name: "smartNewLine",
      Space: "smartInsertSpace",
      Enter: "smartInsertNewline",
      Tab: "smartInsertTab",
      "Shift-Cmd-Enter": "smartInsertNewlineAbove",
      "Cmd-Enter": "smartInsertNewlineAfter"
    });
    editor2.addKeyMap({
      name: "webbindings",
      "Cmd-Z": "undo",
      "Shift-Cmd-Z": "redo",
      "Cmd-A": "selectAll",
      "Shift-Tab": "moveParagraphsLeft",
      Tab: "smartInsertTab",
      "Cmd-[": "moveParagraphsLeft",
      "Cmd-]": "moveParagraphsRight",
      "Cmd-Alt-[": "moveParagraphsUp",
      "Cmd-Alt-]": "moveParagraphsDown",
      "Ctrl-Alt-Left": "moveBranchesLeft",
      "Ctrl-Alt-Right": "moveBranchesRight",
      "Ctrl-Alt-Up": "moveBranchesUp",
      "Ctrl-Alt-Down": "moveBranchesDown",
      "Cmd-Alt-Up": "expandSelection",
      "Cmd-Alt-Down": "contractSelection",
      "Cmd-B": "toggleBold",
      "Cmd-I": "toggleItalic",
      "Cmd-L": "formatUnorderedList",
      "Shift-Cmd-L": "formatOrderedList",
      "Cmd-/": "toggleNodeFold",
      "Cmd-Alt-/": "toggleNodeFoldNodeAndDescendants",
      "Cmd-Alt-1"(editor3) {
        editor3.performCommand("foldingLevel", { interfaceItemTag: 1 });
      },
      "Cmd-Alt-2"(editor3) {
        editor3.performCommand("foldingLevel", { interfaceItemTag: 2 });
      },
      "Cmd-Alt-3"(editor3) {
        editor3.performCommand("foldingLevel", { interfaceItemTag: 3 });
      },
      "Cmd-Alt-4"(editor3) {
        editor3.performCommand("foldingLevel", { interfaceItemTag: 4 });
      },
      "Cmd-U": "focusIn",
      "Shift-Cmd-U": "focusOut",
      "Cmd-Alt-Right": "expandFoldingLevel",
      "Cmd-Alt-Left": "contractFoldingLevel",
      "Shift-Cmd-A": "showAll",
      fallback: ["basic"]
    });
    editor2.addKeyMap({
      name: "cocoa",
      Enter: "smartInsertNewline",
      "Cmd-Enter": "smartInsertNewlineAfter",
      "Shift-Cmd-Enter": "smartInsertNewlineAbove",
      "Alt-Enter": "insertNewlineIgnoringFieldEditor",
      "Ctrl-Enter": "insertLineBreak",
      Tab: "insertTab",
      "Alt-Tab": "insertTabIgnoringFieldEditor",
      "Shift-Tab": "insertBacktab",
      Backspace: "deleteBackward",
      "Shift-Backspace": "deleteBackward",
      "Ctrl-Backspace": "deleteBackwardByDecomposingPreviousCharacter",
      "Ctrl-Alt-Backspace": "deleteWordBackward",
      "Alt-Backspace": "deleteWordBackward",
      "Cmd-Backspace": "deleteToBeginningOfLine",
      Delete: "deleteForward",
      "Shift-Delete": "deleteForward",
      "Alt-Delete": "deleteWordForward",
      Esc: "cancelOperation",
      "Alt-Esc": "complete",
      Up: "moveUp",
      "Shift-Up": "moveUpAndModifySelection",
      "Ctrl-Up": "scrollPageUp",
      "Cmd-Up": "moveToBeginningOfDocument",
      "Shift-Cmd-Up": "moveToBeginningOfDocumentAndModifySelection",
      "Alt-Up"(editor3) {
        editor3.performCommand("moveBackward");
        editor3.performCommand("moveToBeginningOfParagraph");
      },
      "Shift-Alt-Up": "moveParagraphBackwardAndModifySelection",
      Down: "moveDown",
      "Shift-Down": "moveDownAndModifySelection",
      "Ctrl-Down": "scrollPageDown",
      "Cmd-Down": "moveToEndOfDocument",
      "Shift-Cmd-Down": "moveToEndOfDocumentAndModifySelection",
      "Alt-Down"(editor3) {
        editor3.performCommand("moveForward");
        editor3.performCommand("moveToEndOfParagraph");
      },
      "Shift-Alt-Down": "moveParagraphForwardAndModifySelection",
      Left: "moveLeft",
      "Shift-Left": "moveLeftAndModifySelection",
      "Ctrl-Left": "moveToBeginningOfLine",
      "Shift-Ctrl-Left": "moveToBeginningOfLineAndModifySelection",
      "Cmd-Left": "moveToBeginningOfLine",
      "Shift-Cmd-Left": "moveToBeginningOfLineAndModifySelection",
      "Alt-Left": "moveWordLeft",
      "Shift-Alt-Left": "moveWordLeftAndModifySelection",
      Right: "moveRight",
      "Shift-Right": "moveRightAndModifySelection",
      "Ctrl-Right": "moveToEndOfLine",
      "Shift-Ctrl-Right": "moveToEndOfLineAndModifySelection",
      "Cmd-Right": "moveToEndOfLine",
      "Shift-Cmd-Right": "moveToEndOfLineAndModifySelection",
      "Alt-Right": "moveWordRight",
      "Shift-Alt-Right": "moveWordRightAndModifySelection",
      Home: "scrollToBeginningOfDocument",
      "Shift-Home": "moveToBeginningOfDocumentAndModifySelection",
      End: "scrollToEndOfDocument",
      "Shift-End": "moveToEndOfDocumentAndModifySelection",
      PageUp: "scrollPageUp",
      "Shift-PageUp": "pageUpAndModifySelection",
      "Alt-PageUp": "pageUp",
      PageDown: "scrollPageDown",
      "Shift-PageDown": "pageDownAndModifySelection",
      "Alt-PageDown": "pageDown",
      "Cmd-Alt-T"(editor3) {
        editor3.performCommand("toggleOutlineView");
      },
      "Cmd-G": "nextMatch",
      "Shift-Cmd-G": "previousMatch",
      "Cmd-F": "showFindInterface"
    });
    editor2.addKeyMap({
      name: "emacsy",
      "Cmd-.": "cancelOperation",
      "Ctrl-A": "moveToBeginningOfParagraph",
      "Shift-Ctrl-A": "moveToBeginningOfParagraphAndModifySelection",
      "Ctrl-B": "moveBackward",
      "Ctrl-D": "deleteForward",
      "Ctrl-E": "moveToEndOfParagraph",
      "Shift-Ctrl-E": "moveToEndOfParagraphAndModifySelection",
      "Ctrl-F": "moveForward",
      "Ctrl-H": "deleteBackward",
      "Ctrl-K": "deleteToEndOfParagraph",
      "Ctrl-L": "centerSelectionInVisibleArea",
      "Ctrl-N": "moveDown",
      "Ctrl-O"(editor3) {
        editor3.performCommand("insertNewlineIgnoringFieldEditor");
        editor3.performCommand("moveBackward");
      },
      "Ctrl-P": "moveUp",
      "Ctrl-T": "transpose",
      "Ctrl-V": "pageDown",
      "Ctrl-Y": "yank",
      F5: "complete"
    });
  });

  // src/ft/editor/noderenderer.js
  init_extensions();
  var NodeRenderer = function NodeRenderer2(editor2, cm) {
    this.editor = editor2;
    this.cm = cm;
    this._node = null;
    this._cmLineNumber = null;
    this._cmLineHandle = null;
  };
  NodeRenderer.prototype._clearRenderMarks = function _clearRenderMarks(nodes) {
    let length = nodes.length, i3;
    for (i3 = 0; i3 < length; i3++) {
      const each = nodes[i3];
      const renderMarks = each._renderMarks;
      const markersLength = renderMarks ? renderMarks.length : 0;
      for (let j3 = 0; j3 < markersLength; j3++) {
        renderMarks[j3].clear();
      }
      each._renderMarks = [];
    }
  };
  NodeRenderer.prototype.renderDelta = function renderDelta(delta) {
    let removedNodes = delta.removedNodes, updatedNode = delta.updatedNode, insertedNodes = delta.insertedNodes, renderNodes = insertedNodes.slice(0), cmStartLine = delta.fromLineCh.line, outerThis = this, cm = this.cm, i3 = 0;
    this._clearRenderMarks(removedNodes);
    if (updatedNode) {
      renderNodes.unshift(updatedNode);
    }
    if (delta.textChanged()) {
      if (!updatedNode && delta.insertedText[0] === "\n") {
        cmStartLine++;
      }
    }
    cm.eachLine(cmStartLine, cmStartLine + renderNodes.length, (eachLineHandle) => {
      outerThis.renderNode(renderNodes[i3], cmStartLine + i3, eachLineHandle);
      i3++;
    });
  };
  NodeRenderer.prototype.renderNode = function renderNode(node, cmLineNumber, cmLineHandle) {
    this._node = node;
    this._cmLineNumber = cmLineNumber;
    this._cmLineHandle = cmLineHandle;
    let cm = this.cm, renderMarks = node._renderMarks, length = renderMarks.length, i3;
    if (length > 0) {
      for (i3 = 0; i3 < length; i3++) {
        renderMarks[i3].clear();
      }
      node._renderMarks = renderMarks = [];
    }
    cmLineHandle.styles = null;
    cm.regLineChange(cmLineNumber, "class");
    cm.regLineChange(cmLineNumber, "text");
    node.tree.taxonomy.renderNode(this.editor, node, this);
    let outerThis = this;
    Extensions.processExtensions("com.foldingtext.editor.renderNode", (each) => {
      each(outerThis.editor, node, outerThis);
    });
    this._node = null;
    this._cmLineNumber = null;
    this._cmLineHandle = null;
  };
  NodeRenderer.prototype.renderInlineWidget = function renderInlineWidget(location, length, widget) {
    let lineNumber = this._cmLineNumber;
    this._node._renderMarks.push(this.cm.markText({
      line: lineNumber,
      ch: location
    }, {
      line: lineNumber,
      ch: location + length
    }, {
      replacedWith: widget
    }));
  };
  NodeRenderer.prototype.renderLineWidget = function renderLineWidget(widget, options) {
    this._node._renderMarks.push(this.cm.addLineWidget(this._cmLineHandle, widget, options));
  };

  // src/ft/extensions/measuretext.js
  init_extensions();
  array_default();
  var cacheKeySegmentCache = {};
  var cacheKeySegmentCacheNext = 0;
  function cantorPairing(x3, y2) {
    return (x3 + y2) * (x3 + y2 + 1) / 2 + y2;
  }
  function shortenCacheKeySegment(cacheKeySegment) {
    let result = cacheKeySegmentCache[cacheKeySegment];
    if (!result) {
      result = cacheKeySegmentCacheNext++;
      cacheKeySegmentCache[cacheKeySegment] = result;
    }
    return result;
  }
  function cacheKeyForElement(element3, includeTextContent) {
    let attributes = element3.attributes, result = 0, attr;
    for (let j3 = 0; j3 < attributes.length; j3++) {
      attr = attributes[j3];
      result = cantorPairing(result, shortenCacheKeySegment(attr.name + attr.value));
    }
    if (includeTextContent) {
      result += element3.textContent;
    }
    return result;
  }
  var measureElement = document.createElement("pre");
  var measureSpan = document.createElement("span");
  measureSpan.style.whiteSpace = "pre-wrap";
  measureElement.appendChild(measureSpan);
  Extensions.add("com.foldingtext.editor.methods", {
    measureTextCache() {
      let cache = this._measureTextCache;
      if (!cache) {
        cache = {};
        this._measureTextCache = cache;
      }
      return cache;
    },
    defaultCharWidth() {
      return this.cm().defaultCharWidth();
    },
    defaultSpaceWidth() {
      return this.cm().defaultSpaceWidth();
    },
    defaultPREStyling() {
      let measureTextCache = this.measureTextCache(), defaultPREStyling = measureTextCache.defaultPREStyling;
      if (!defaultPREStyling) {
        let cm = this.cm(), measureDiv = cm.display.measure;
        defaultPREStyling = {};
        measureTextCache.defaultPREStyling = defaultPREStyling;
        measureDiv.appendChild(measureElement);
        let style = window.getComputedStyle(measureElement);
        defaultPREStyling.marginTop = style.marginTop ? parseFloat(style.marginTop) : 0;
        defaultPREStyling.marginBottom = style.marginBottom ? parseFloat(style.marginBottom) : 0;
        defaultPREStyling.marginLeft = style.marginLeft ? parseFloat(style.marginLeft) : 0;
        defaultPREStyling.marginRight = style.marginRight ? parseFloat(style.marginRight) : 0;
        measureDiv.removeChild(measureElement);
      }
      return defaultPREStyling;
    },
    tabWidth() {
      return this.cm().getOption("tabSize") * this.defaultSpaceWidth();
    },
    measureNodeText(node, location, length, cmBuilder, cmMeasure) {
      if (length === 0) {
        return { top: 0, bottom: 0, left: 0, right: 0, width: 0, height: 0 };
      }
      let cacheKey = shortenCacheKeySegment(cmBuilder.wrapClass), measureTextCache = this.measureTextCache(), startNode, startOffset, endNode, endOffset, end = location + length, map3 = cmMeasure.map, i3 = 0;
      cacheKey += cacheKeyForElement(cmBuilder.pre, false);
      while (i3 < map3.length && (startNode === void 0 || endNode === void 0)) {
        let s3 = map3[i3], e5 = map3[i3 + 1], n3 = map3[i3 + 2];
        if (!startNode && location <= e5) {
          startNode = n3;
          startOffset = location - s3;
        }
        if (!endNode && end <= e5) {
          endNode = n3;
          endOffset = end - s3;
        }
        if (startNode) {
          if (n3.nodeType === document.TEXT_NODE) {
            let spanParent = n3.parentNode;
            if (spanParent.className) {
              cacheKey += cacheKeyForElement(spanParent, true);
            } else {
              cacheKey += n3.textContent;
            }
          } else {
            cacheKey += shortenCacheKeySegment(n3.innerHTML);
          }
        }
        i3 += 3;
      }
      let rect = measureTextCache[cacheKey];
      if (!rect) {
        let cm = this.cm(), measureDiv = cm.display.measure, range2 = document.createRange();
        if (startNode.nodeType === document.TEXT_NODE) {
          range2.setStart(startNode, startOffset);
        } else {
          if (startOffset > 0) {
            startOffset = 1;
          }
          range2.setStart(startNode, startOffset);
        }
        if (endNode.nodeType === document.TEXT_NODE) {
          range2.setEnd(endNode, endOffset);
        } else {
          if (endOffset > 0) {
            endOffset = 1;
          }
          range2.setEnd(endNode, endOffset);
        }
        measureDiv.appendChild(cmBuilder.pre);
        rect = range2.getBoundingClientRect();
        measureDiv.removeChild(cmBuilder.pre);
        measureTextCache[cacheKey] = rect;
      }
      return rect;
    },
    clearMeasureTextCache() {
      this._measureTextCache = {};
    }
  });

  // src/ft/extensions/layout.js
  init_extensions();
  Extensions.add("com.foldingtext.editor.options", {
    name: "padBottomPercent",
    defaultValue: 0.5,
    onChange(editor2, oldValue, newValue) {
      if (oldValue === newValue) {
        return;
      }
      readjustBottomPadding(editor2);
      editor2.invalidateRestorableState();
    }
  });
  Extensions.add("com.foldingtext.editor.refresh", (editor2) => {
    readjustBottomPadding(editor2);
    readjustWrapAmount(editor2);
  });
  Extensions.add("com.foldingtext.editor.options", {
    name: "wrapToColumn",
    defaultValue: 66,
    onChange(editor2, oldValue, newValue) {
      if (oldValue === newValue) {
        return;
      }
      readjustWrapAmount(editor2);
      readjustBottomPadding(editor2);
      editor2.invalidateRestorableState();
    }
  });
  Extensions.addCommand({
    name: "wrapToColumn",
    validate(editor2, options) {
      options.interfaceItemState = editor2.option("wrapToColumn") === options.columnWidth;
      return true;
    },
    performCommand(editor2, options) {
      editor2.setOption("wrapToColumn", options.columnWidth);
    }
  });
  Extensions.add("com.foldingtext.editor.methods", {
    refresh() {
      this.clearMeasureTextCache();
      this.cm().refresh();
    },
    wrapperElement() {
      return this.cm().getWrapperElement();
    },
    scrollerElement() {
      return this.cm().getScrollerElement();
    },
    linesElement() {
      return this.cm().display.mover.firstElementChild;
    },
    textWrapWidth() {
      const wrapToColumn = this.option("wrapToColumn");
      if (wrapToColumn == void 0)
        return 0;
      return wrapToColumn * this.defaultCharWidth();
    }
  });
  function readjustWrapAmount(editor2) {
    let linesElement = editor2.linesElement(), textWrapWidth = editor2.textWrapWidth(), preStyling = editor2.defaultPREStyling(), pageMarginWidth = preStyling.marginLeft + preStyling.marginRight, maxWidth;
    if (textWrapWidth === 0) {
      maxWidth = "none";
    } else {
      maxWidth = `${Math.round(textWrapWidth + pageMarginWidth)}px`;
    }
    if (editor2._lastSetMaxWidth !== maxWidth) {
      editor2._lastSetMaxWidth = maxWidth;
      linesElement.style.maxWidth = maxWidth;
      editor2.refresh();
    }
  }
  function readjustBottomPadding(editor2) {
    let linesElement = editor2.linesElement();
    let padBottomPercent = editor2.option("padBottomPercent");
    let newBottomPadding = 0;
    let newMinHeight = 0;
    if (padBottomPercent > 0) {
      let viewHeight = editor2.wrapperElement().clientHeight, existingTopPadding = parseInt(window.getComputedStyle(linesElement).paddingTop, 10) || 0;
      newBottomPadding = Math.floor(viewHeight * padBottomPercent);
      newMinHeight = Math.floor(viewHeight * (1 - padBottomPercent));
      newMinHeight -= existingTopPadding;
      if (newMinHeight < 0) {
        newMinHeight = 0;
      }
    }
    if (editor2._lastSetPaddingBottom !== newBottomPadding || editor2._lastSetMinHeight !== newMinHeight) {
      editor2._lastSetMinHeight = newMinHeight;
      editor2._lastSetPaddingBottom = newBottomPadding;
      linesElement.style["min-height"] = `${newMinHeight}px`;
      linesElement.style.paddingBottom = `${newBottomPadding}px`;
      editor2.cm().setSize();
    }
  }

  // src/ft/editor/editor.js
  init_extensions();

  // src/util/dom.js
  function addClass(element3, classname) {
    if (element3.classList) {
      element3.classList.add(classname);
    }
    let cn = element3.className;
    if (cn.indexOf(classname) !== -1) {
      return;
    }
    if (cn !== "") {
      classname = ` ${classname}`;
    }
    element3.className = cn + classname;
  }
  function removeClass(element3, classname) {
    if (element3.classList) {
      element3.classList.remove(classname);
      return;
    }
    let cn = element3.className;
    let rxp = new RegExp(`\\s?\\b${classname}\\b`, "g");
    cn = cn.replace(rxp, "");
    element3.className = cn;
  }

  // src/ft/editor/editor.js
  string_default();
  var Editor = class {
    constructor(value, taxonomy3, options = {}) {
      this._setMethods();
      this._initializeCodeMirror(options);
      this._updateSyntaxHighlight();
      this._viewPortNodesChangedDelay = new delay_default();
      this._viewportNodes = [];
      this._viewportNodesSet = new NodeSet();
      this._needsRenderNodes = new NodeSet();
      this._nodeRenderer = new NodeRenderer(this, this._cm);
      this._elementRenderer = new ElementRenderer(this, this._cm);
      this._keyMaps = [];
      this._reverseKeyMapLookup = null;
      this._timer = null;
      this._commands = {};
      this._modes = {};
      this._optionHandlers = {};
      this.initialized = false;
      this._options = {};
      this._tree = new Tree("", taxonomy3);
      this._isDocumentLoaded = false;
      this._setupSync();
      this._initializeView(value, options);
      this._beginTimer();
      this._handleMouseEvents();
      this._handleFocusEvents();
      this._updateState();
      this._windowGlobals();
    }
    _initializeView(value, overrideOptions) {
      const cm = this.cm();
      let eachOverrideOption;
      this.operation(() => {
        Extensions.processExtensions("com.foldingtext.editor.options", (each) => {
          eachOverrideOption = overrideOptions[each.name];
          this._optionHandlers[each.name] = each.onChange;
          this.setOption(each.name, eachOverrideOption !== void 0 ? eachOverrideOption : each.defaultValue);
        });
        Extensions.processExtensions("com.foldingtext.editor.commands", (each) => {
          this._commands[each.name] = each;
        });
        Extensions.processExtensions("com.foldingtext.editor.init", (each) => each(this));
        if (value && this.tree().textLength() === 0) {
          this.tree().setText(value);
          cm.setCursor(new import_codemirror3.default.Pos(0, 0));
        }
        this.initialized = true;
        if (this.postMessage)
          this.postMessage("editor-loaded");
        Extensions.processExtensions("com.foldingtext.editor.selectionDidChange", (each) => each(this));
        this.refresh();
      });
    }
    _initializeCodeMirror(options) {
      import_codemirror3.default.keyMap.empty = {};
      options.keyMap = "basic";
      options.value = "";
      options.mode = null;
      options.AttributedString = _AttributedString;
      options.styleSelectedText = true;
      options.textForDropEvent = (e5) => this._textForCodemirrorDropEvent(e5);
      options.specialCharPlaceholder = (ch) => this._specialCharPlaceholder(ch);
      options.ftEditor = this;
      let place = document.querySelector(".editor");
      if (!place) {
        place = document.createElement("div");
        place.className = "editor";
        document.body.appendChild(place);
      }
      this._options = options;
      this._cm = new import_codemirror3.default(place, options);
    }
    _textForCodemirrorDropEvent(e5) {
      let text = this._droppedFilePaths;
      const dataTransfer = e5.dataTransfer;
      this._droppedFilePaths = null;
      if (!text) {
        text = dataTransfer.getData("public.url");
        const name106 = dataTransfer.getData("public.url-name");
        if (name106 && !text) {
          text = dataTransfer.getData("text/plain");
        }
        if (name106) {
          text = `[${name106}](${text})`;
        }
      }
      if (!text) {
        text = dataTransfer.getData("text/uri-list");
      }
      if (text) {
        return text;
      }
      return null;
    }
    _elt(tag, content, className, style) {
      const e5 = document.createElement(tag);
      if (className)
        e5.className = className;
      if (style)
        e5.style.cssText = style;
      if (typeof content == "string")
        e5.appendChild(document.createTextNode(content));
      else if (content)
        for (let i3 = 0; i3 < content.length; ++i3)
          e5.appendChild(content[i3]);
      return e5;
    }
    _specialCharPlaceholder(ch) {
      if (ch === "\u2028") {
        return document.createElement("br");
      }
      const token = this._elt("span", "\u2022", "cm-invalidchar");
      token.title = `\\u${ch.charCodeAt(0).toString(16)}`;
      return token;
    }
    _windowGlobals() {
      window.textContent = () => this.textContent();
      window.setTextContent = (textContent2) => this.setTextContent(textContent2);
      window.clearUndoHistory = () => this.cm().clearHistory();
      window.focusEditor = () => this.focus();
      window.replaceCharactersInRangeWithString = (rangeJSON, string2) => {
        const tree = this.tree();
        const parsedRange = JSON.parse(rangeJSON);
        const range2 = tree.createRangeFromLocation(parsedRange.location, parsedRange.length);
        this.replaceTextInRange(range2, string2);
      };
      window.scrollRangeToVisible = (rangeJSON) => {
        const tree = this.tree();
        const parsedRange = JSON.parse(rangeJSON);
        const range2 = tree.createRangeFromLocation(parsedRange.location, parsedRange.length);
        this.scrollRangeToVisible(range2);
      };
      window.visibleCharacterRange = () => {
        const viewPort = this.viewport();
        const from = { line: viewPort.from, ch: 0 };
        const to = { line: viewPort.to, ch: 0 };
        const tree = this.tree();
        const range2 = tree.createRangeFromLineChs(from, to);
        const rangeJSON = JSON.stringify({
          location: range2.location(),
          length: range2.length()
        });
        return rangeJSON;
      };
      window.rectsForCharacterRange = (rangeJSON) => {
        const tree = this.tree();
        const parsedRange = JSON.parse(rangeJSON);
        const range2 = tree.createRangeFromLocation(parsedRange.location, parsedRange.length);
        return JSON.stringify(this.rectsForCharacterRange(range2));
      };
      window.suggestedNameFromContent = () => {
        return this.suggestedNameFromContent();
      };
      window.restorableStateJSON = () => {
        return this.restorableStateJSON();
      };
      window.setRestorableStateJSON = (stateJSON, fileChanged) => {
        return this.setRestorableStateJSON(stateJSON, fileChanged);
      };
      window.getCmOption = (option) => {
        return this.getCmOption(option);
      };
      window.setCmOption = (name106, value) => {
        return this.setCmOption(name106, value);
      };
      window.refresh = () => this.refresh();
      window.performAction = (actionName, optionalTagValue) => this.performAction(actionName, optionalTagValue);
    }
    cm() {
      return this._cm;
    }
    openLink(url, inBackground = true) {
      let formattedUrl = url;
      if (!url.match(/[a-z][\w-]+:/)) {
        const c3 = url[0];
        if (c3 === "/") {
          formattedUrl = `file://${encodeURI(url)}`;
        } else if (c3 === "." || c3 === "~") {
          this.postMessage("open-relative-path", {
            url: encodeURI(formattedUrl),
            inBackground
          });
        } else {
          formattedUrl = `https://${url}`;
        }
      }
      this.postMessage("open-link", {
        url: formattedUrl,
        inBackground
      });
    }
    operation(callback) {
      this.cm().operation(callback);
    }
    setReadonly(value) {
      this.cm().setOption("readOnly", value);
      this.tree().setReadOnly(!!value);
    }
    isReadOnly() {
      const readonly = this.cm().getOption("readOnly");
      return !!readonly;
    }
    option(name106) {
      const value = this._options[name106];
      if (value === void 0) {
        return this.cm().getOption(name106);
      }
      return value;
    }
    setOption(name106, value) {
      const handler = this._optionHandlers[name106];
      const options = this._options;
      const old = options[name106];
      if (old !== value) {
        options[name106] = value;
        if (handler) {
          handler(this, old, value);
        }
      }
    }
    _updateState() {
      Extensions.addState({
        readState: (editor2, state) => {
          const options = state.options;
          if (options !== void 0) {
            for (let name106 in options) {
              editor2.setOption(name106, options[name106]);
            }
          }
        },
        writeState: (editor2, state) => {
          const options = {};
          Extensions.processExtensions("com.foldingtext.editor.options", (each) => {
            const name106 = each.name;
            const value = editor2.option(name106);
            if (value !== each.defaultValue) {
              options[name106] = value;
            }
          });
          state.options = options;
        }
      });
    }
    _updateSyntaxHighlight() {
      Extensions.add("com.foldingtext.editor.options", {
        name: "hideSyntax",
        defaultValue: true,
        onChange: (editor2, oldValue, newValue) => {
          const linesElement = editor2.linesElement();
          if (oldValue) {
            removeClass(linesElement, "cm-hide-syntax");
          }
          if (newValue) {
            addClass(linesElement, "cm-hide-syntax");
          }
          editor2.refresh();
        }
      });
      Extensions.addCommand({
        name: "toggleHideSyntax",
        validate: (editor2, options) => {
          options.interfaceItemState = editor2.option("hideSyntax");
          return true;
        },
        performCommand: (editor2) => {
          editor2.setOption("hideSyntax", !editor2.option("hideSyntax"));
        }
      });
    }
    setTextContent(textContent2) {
      this.cm().setValue(textContent2);
    }
    replaceTextInRange(range2, insertedText, origin) {
      this.cm().replaceRange(insertedText, range2.startLineCh(), range2.endLineCh(), origin);
    }
    hasSelection() {
      return this.cm().somethingSelected();
    }
    selectedText() {
      return this.selectedRange().textInRange();
    }
    selectedRange() {
      const cm = this.cm();
      const anchor = cm.getCursor("anchor");
      const head = cm.getCursor("head");
      return this.tree().createRangeFromAnchoreAndHeadLineChs(anchor, head);
    }
    replaceSelection(text, select, origin) {
      this.cm().replaceSelection(text, select, origin);
    }
    replaceSelections(texts, select, origin) {
      texts = [].concat(texts);
      const selectedRanges = this.selectedRanges();
      let replacements = [];
      const cm = this.cm();
      if (selectedRanges.length === texts.length) {
        replacements = texts;
      } else {
        selectedRanges.forEach(() => replacements.push(texts.join("\n")));
      }
      this.operation(() => cm.replaceSelections(replacements, select, origin));
    }
    setSelectedRange(range2, options) {
      this.cm().setSelection(range2.anchorLineCh(), range2.headLineCh(), options);
    }
    setSelectedLineCh(anchor, head, options) {
      this.cm().setSelection(anchor, head, options);
    }
    setSelectedRanges(ranges, options) {
      const length = ranges.length;
      const selections = [];
      for (let i3 = 0; i3 < length; i3++) {
        selections.push({
          anchor: ranges[i3].anchorLineCh(),
          head: ranges[i3].headLineCh()
        });
      }
      this.cm().setSelections(selections, options);
    }
    selectedRanges() {
      const tree = this.tree();
      const selections = this.cm().listSelections();
      const length = selections.length;
      const ranges = [];
      for (let i3 = 0; i3 < length; i3++) {
        const selection = selections[i3];
        const anchor = selection.anchor;
        const head = selection.head;
        ranges.push(tree.createRangeFromAnchoreAndHeadLineChs(anchor, head));
      }
      return ranges;
    }
    cursorRange(start2) {
      const cm = this.cm();
      const pos = cm.getCursor(start2 || "head");
      return this.tree().createRangeFromLineChs(pos, pos);
    }
    focus() {
      this.cm().focus();
      setTimeout(() => this.cm().focus());
    }
    commands() {
      const reverseKeyMapLookup = this.reverseKeyMapLookup();
      const commandsList = this._commands;
      let results = [];
      let each;
      for (each in commandsList) {
        if (Object.prototype.hasOwnProperty.call(commandsList, each)) {
          each = commandsList[each];
          results.push({
            name: each.name,
            description: each.description,
            shortcut: reverseKeyMapLookup[each.name]
          });
        }
      }
      return results;
    }
    performAction(actionName, optionalTagValue) {
      this.performCommand(actionName, { interfaceItemTag: optionalTagValue });
    }
    performCommand(commandName, options) {
      if (window._gaq) {
        window._gaq.push([
          "_trackEvent",
          "editor",
          "performCommand",
          commandName
        ]);
      }
      Extensions.processExtensions("com.foldingtext.editor.willPerformCommand", (each) => each(this, commandName));
      const command = this._commands[commandName];
      if (command) {
        return command.performCommand(this, options);
      } else if (import_codemirror3.default.commands[commandName]) {
        return import_codemirror3.default.commands[commandName](this.cm(), options);
      }
      console.log(`Command not found: ${commandName}`);
      return false;
    }
    validateCommand(commandName, options) {
      const command = this._commands[commandName];
      if (command) {
        if (command.validate) {
          return command.validate(this, options);
        }
      }
      return true;
    }
    charCoords(lineCh, mode2) {
      return this.cm().charCoords(lineCh, mode2);
    }
    cursorCoords(lineCh, mode2) {
      return this.cm().cursorCoords(lineCh, mode2);
    }
    coordsChar(left, top) {
      return this.cm().coordsChar({ left, top });
    }
    rectsForCharacterRange(range2) {
      const pos = { line: 0, ch: 0 };
      const rects = [];
      let lineEnd;
      range2.forEachNodeInRange((node, line, location, length) => {
        lineEnd = location + length;
        pos.line = line;
        for (let i3 = location; i3 < lineEnd; i3++) {
          pos.ch = i3;
          rects.push(this.charCoords(pos));
        }
      });
      return rects;
    }
    targetsAt(x3, y2) {
      const cm = this.cm();
      const pos = cm.coordsChar({ left: x3, top: y2 });
      const node = this.tree().lineNumberToNode(pos.line);
      let rect = cm.charCoords(pos);
      let attributes;
      if (rect.left > x3 && pos.ch > 0) {
        pos.ch--;
        rect = cm.charCoords(pos);
      }
      if (x3 >= rect.left && x3 <= rect.right && y2 >= rect.top && y2 <= rect.bottom) {
        attributes = node.lineAttributesAtIndex(pos.ch, null);
      }
      return {
        node,
        lineCh: pos,
        attributes: attributes || {}
      };
    }
    scrollRangeToVisible(range2, topMargin, bottomMargin) {
      this.cm().scrollIntoView({ from: range2.startLineCh(), to: range2.endLineCh() }, topMargin, bottomMargin);
    }
    scrollRectToVisible(rect) {
      this.cm().scrollIntoView(rect);
    }
    scrollTo(x3, y2) {
      this.cm().scrollTo(x3, y2);
    }
    scrollToTop() {
      this.cm().scrollTo(0, -Infinity);
    }
    scrollToLine(line, offset) {
      if (line < 0)
        line = 0;
      if (!offset)
        offset = 0;
      this.cm().scrollIntoView(line, offset, this.scrollInfo().clientHeight);
    }
    viewport() {
      const tree = this.tree();
      const vp = this._cm.getViewport();
      const numberOfLines = tree.nodeCount();
      const topLineChar = this.coordsChar(0, 0);
      while (topLineChar.line < numberOfLines - 1 && this.lineIsHiddenInFold(topLineChar.line)) {
        topLineChar.line++;
      }
      vp.firstVisibleLine = topLineChar.line;
      vp.firstVisibleLineOffset = this.charCoords(topLineChar).top;
      return vp;
    }
    viewportRange() {
      const viewport = this.viewport();
      const range2 = this.tree().createRangeFromLineChs({ line: viewport.from }, { line: viewport.to });
      return range2;
    }
    scrollInfo() {
      return this.cm().getScrollInfo();
    }
    setNeedsRender(node) {
      assert_default.ok(this.cm().curOp !== null, "Need to start operation before calling setNeedsRender");
      this._needsRenderNodes.addNode(node);
    }
    _mapToFunctionWithEditorParameter(func, _cm) {
      return func(this);
    }
    _mapToExecuteEditorCommand(command, _cm) {
      return this.performCommand(command);
    }
    addKeyMap(map3, bottom) {
      const isMac = import_codemirror3.default.mac;
      const cmMap = {};
      let each;
      if (!isMac) {
        let newMap = {};
        for (let key in map3) {
          if (Object.prototype.hasOwnProperty.call(map3, key)) {
            let remappedKey = key;
            if (remappedKey.indexOf("Cmd") !== -1) {
              if (remappedKey.indexOf("Ctrl") !== -1) {
                remappedKey = remappedKey.replace("Ctrl", "Shift");
              }
              remappedKey = remappedKey.replace("Cmd", "Ctrl");
              newMap[remappedKey] = map3[key];
            }
          }
        }
        map3 = newMap;
      }
      this._keyMaps[bottom ? "push" : "unshift"](map3);
      this._reverseKeyMapLookup = null;
      for (let key in map3) {
        if (Object.prototype.hasOwnProperty.call(map3, key)) {
          each = map3[key];
          if (key === "name" || key === "nofallthrough" || key === "disableInput" || key === "fallthrough") {
            cmMap[key] = each;
          } else if (typeof each === "function") {
            cmMap[key] = this._mapToFunctionWithEditorParameter.bind(this, each);
          } else if (typeof each === "string") {
            cmMap[key] = this._mapToExecuteEditorCommand.bind(this, each);
          }
        }
      }
      this.cm().addKeyMap(cmMap, bottom);
    }
    removeKeyMap(map3) {
      const keyMaps = this._keyMaps;
      for (let i3 = 0; i3 < keyMaps.length; ++i3) {
        if ((typeof map3 === "string" ? keyMaps[i3].name : keyMaps[i3]) === map3) {
          keyMaps.splice(i3, 1);
        }
      }
      this._reverseKeyMapLookup = null;
      this.cm().removeKeyMap(map3);
    }
    reverseKeyMapLookup() {
      const keySymbols = (shortcut) => {
        let components = shortcut.split("-"), result = components.lastObject() || "-";
        if (components.indexOf("Cmd") !== -1)
          result = `\u2318${result}`;
        if (components.indexOf("Shift") !== -1)
          result = `\u21E7${result}`;
        if (components.indexOf("Alt") !== -1)
          result = `\u2325${result}`;
        if (components.indexOf("Ctrl") !== -1)
          result = `^${result}`;
        return result;
      };
      const reverseMap = this._reverseKeyMapLookup;
      if (!reverseMap) {
        const commands = this._commands;
        const keyMaps = this._keyMaps;
        const length = keyMaps.length;
        const reverseMap2 = {};
        for (let i3 = 0; i3 < length; i3++) {
          const map3 = keyMaps[i3];
          for (let key in map3) {
            const command = map3[key];
            if (commands[command] && !reverseMap2[command]) {
              reverseMap2[command] = keySymbols(key);
            }
          }
        }
        this._reverseKeyMapLookup = reverseMap2;
      }
      return reverseMap;
    }
    invalidateRestorableState() {
      if (this.onStateChanged) {
        this.onStateChanged();
      }
    }
    restorableStateJSON() {
      const state = {};
      Extensions.processExtensions("com.foldingtext.editor.state", (each) => each.writeState(this, state));
      return JSON.stringify(state);
    }
    setRestorableStateJSON(stateJSON, fileChanged) {
      if (!stateJSON) {
        return;
      }
      try {
        const state = JSON.parse(stateJSON);
        state.fileChangedSinceLastStateSync = fileChanged;
        Extensions.processExtensions("com.foldingtext.editor.state", (each) => each.readState(this, state));
      } catch (e5) {
        console.error(e5);
      }
    }
    removeAndCleanupForCollection() {
      if (this._timer) {
        clearTimeout(this._timer);
      }
      this._viewPortNodesChangedDelay.clear();
      let cm = this.cm(), wrapperElement = this.wrapperElement();
      if (cm.getPanel !== void 0) {
        cm.getPanel().remove();
      }
      if (wrapperElement.parentNode) {
        wrapperElement.parentNode.removeChild(wrapperElement);
      }
      this.tree().cleanupForCollection();
    }
    _beginTimer() {
      const onTimeout = () => {
        if (Extensions.hasExtensions("com.foldingtext.editor.clockTick")) {
          const date2 = new Date();
          this.operation(() => {
            Extensions.processExtensions("com.foldingtext.editor.clockTick", (each) => {
              each(this, date2);
            });
          });
        }
        this._timer = setTimeout(onTimeout, 1e3);
      };
      this._timer = setTimeout(onTimeout, 1e3);
    }
    _handleMouseEvents() {
      const wrapper = this.wrapperElement();
      const cm = this.cm();
      import_codemirror3.default.on(wrapper, "mouseenter", (e5) => {
        Extensions.processExtensions("com.foldingtext.editor.mouseenter", (each) => each(this, e5));
      });
      import_codemirror3.default.on(wrapper, "mouseover", (e5) => {
        Extensions.processExtensions("com.foldingtext.editor.mouseover", (each) => each(this, e5));
      });
      import_codemirror3.default.on(wrapper, "mouseleave", (e5) => {
        Extensions.processExtensions("com.foldingtext.editor.mouseleave", (each) => each(this, e5));
      });
      cm.on("mousedown", (cm2, e5) => {
        if (e5.altKey) {
          return;
        }
        e5.codemirrorIgnore = !!Extensions.processExtensions("com.foldingtext.editor.mouse", (each) => {
          if (each.mouseDown(this, e5)) {
            if (each.mouseUp) {
              const mouseUpHandler = (e22) => {
                import_codemirror3.default.off(document, "mouseup", mouseUpHandler);
                if (each.mouseUp(this, e22)) {
                  e22.preventDefault();
                }
              };
              e5.preventDefault();
              import_codemirror3.default.on(document, "mouseup", mouseUpHandler);
            }
            return true;
          }
        }, true);
      });
      cm.on("contextmenu", () => {
      });
    }
    _handleFocusEvents() {
      const cm = this.cm();
      cm.on("focus", () => {
        Extensions.processExtensions("com.foldingtext.editor.focus", (each) => each(this));
      });
      cm.on("blur", () => {
        Extensions.processExtensions("com.foldingtext.editor.blur", (each) => {
          if (each)
            each(this);
        });
      });
    }
    _scheduleCheckForViewportNodesChange() {
      this._viewPortNodesChangedDelay.clear();
      this._viewPortNodesChangedDelay.set(100, () => {
        const oldViewportNodes = this._viewportNodes;
        const oldViewportNodesSet = this._viewportNodesSet;
        const newViewportNodes = this.visibleNodesInRange(this.viewportRange());
        if (!oldViewportNodes.shallowEquals(newViewportNodes)) {
          const newViewportNodesSet = NodeSet.setFromArray(newViewportNodes);
          const removedNodes = NodeSet.minusSets(oldViewportNodesSet, newViewportNodesSet);
          const addedNodes = NodeSet.minusSets(newViewportNodesSet, oldViewportNodesSet);
          Extensions.processExtensions("com.foldingtext.editor.viewportNodesChanged", (each) => each(this, newViewportNodes, removedNodes, addedNodes));
          this._viewportNodes = newViewportNodes;
          this._viewportNodesSet = newViewportNodesSet;
        }
      });
    }
    _handleViewportUpdates() {
      const cm = this.cm();
      const tree = this.tree();
      cm.on("refresh", () => Extensions.processExtensions("com.foldingtext.editor.refresh", (each) => each(this)));
      cm.on("viewportChange", () => {
        let viewport = this.viewport();
        tree.ensureClassified(tree.lineNumberToNode(viewport.from), tree.lineNumberToNode(viewport.to));
        this._scheduleCheckForViewportNodesChange();
      });
    }
    _setupSync() {
      const tree = this.tree();
      let changeIsCommingFromFoldingText = 0;
      let changeIsCommingFromCodeMirror = 0;
      const nodeRenderer = this._nodeRenderer;
      const elementRenderer = this._elementRenderer;
      const cm = this.cm();
      cm.on("beforeSelectionChange", (cm2, change) => {
        this.selectionChanged = !this.selectionChanged ? 1 : this.selectionChanged++;
        Extensions.processExtensions("com.foldingtext.editor.beforeSelectionChange", (each) => each(this, change));
      });
      cm.on("beforeChange", (doc, changeObj) => {
        Extensions.processExtensions("com.foldingtext.editor.beforeChange", (each) => each(this, changeObj));
        if (!changeObj.next && changeObj.origin === "+input") {
          Extensions.processExtensions("com.foldingtext.editor.insertText", (each) => each(this, changeObj), true);
        }
        if (!changeObj.update) {
          Extensions.processExtensions("com.foldingtext.editor.beforeUndoRedo", (each) => each(this, changeObj));
        }
        if (changeIsCommingFromFoldingText === 0 && cm.listSelections().length === 1) {
          const fromLineCh = changeObj.from;
          const toLineCh = changeObj.to;
          let lastChangeEnd = this._lastChangeEnd;
          if (lastChangeEnd && import_codemirror3.default.cmpPos(lastChangeEnd, fromLineCh) !== 0 && import_codemirror3.default.cmpPos(lastChangeEnd, toLineCh) !== 0) {
            doc.changeGeneration(true);
          }
          lastChangeEnd = import_codemirror3.default.Pos(fromLineCh.line, fromLineCh.ch);
          lastChangeEnd.line += changeObj.text.length - 1;
          lastChangeEnd.ch += changeObj.text[changeObj.text.length - 1].length;
          this._lastChangeEnd = lastChangeEnd;
        }
      });
      cm.on("update", () => {
      });
      cm.on("change", (_2, change) => {
        if (environment_default.debug) {
          assert_default.ok(tree.text() === cm.getValue(), "Tree and CM must stay in sync");
        }
        Extensions.processExtensions("com.foldingtext.editor.change", (each) => each(this, change));
      });
      const applyCodeMirrorJustChangedToTree = (changeObj) => {
        if (!changeIsCommingFromFoldingText) {
          changeIsCommingFromCodeMirror++;
          this.tree().beginUpdates();
          while (changeObj) {
            const from = changeObj.from;
            const fromNode = tree.lineNumberToNode(from.line);
            const to = changeObj.to;
            const toNode = tree.lineNumberToNode(to.line);
            const text = changeObj.text;
            const range2 = tree.createRangeFromNodes(fromNode, from.ch, toNode, to.ch);
            tree.replaceTextInRange(range2, text.join("\n"));
            changeObj = changeObj.next;
          }
          this.tree().endUpdates();
          changeIsCommingFromCodeMirror--;
        }
      };
      cm.on("justChanged", (doc, changeObj) => {
        applyCodeMirrorJustChangedToTree(changeObj);
      });
      cm.on("willEndOperation", (cm2) => {
        if (this.selectionChanged) {
          this.selectionChanged = 0;
          Extensions.processExtensions("com.foldingtext.editor.selectionDidChange", (each) => each(this));
        }
        const viewPort = this.viewport();
        tree.ensureClassified(tree.lineNumberToNode(viewPort.from), tree.lineNumberToNode(viewPort.to));
        this._scheduleCheckForViewportNodesChange();
        Extensions.processExtensions("com.foldingtext.editor.willEndOperation", (each) => {
          each(this);
        });
        this._needsRenderNodes.forEachNodeInSet((each) => {
          if (each.isTracked) {
            let lineNumber = each.lineNumber();
            nodeRenderer.renderNode(each, lineNumber, cm2.getLineHandle(lineNumber));
          }
        });
        this._needsRenderNodes.removeAllNodes();
      });
      tree.addEventListener("treeChanged", (e5) => {
        changeIsCommingFromFoldingText++;
        this.operation(() => {
          const deltas = e5.deltas;
          const length = deltas.length;
          let eachDelta;
          for (let i3 = 0; i3 < length; i3++) {
            eachDelta = deltas[i3];
            if (!changeIsCommingFromCodeMirror && eachDelta.textChanged()) {
              cm.replaceRange(eachDelta.insertedText, eachDelta.fromLineCh, eachDelta.toLineCh);
            }
            nodeRenderer.renderDelta(eachDelta);
          }
        });
        changeIsCommingFromFoldingText--;
        this.operation(() => {
          Extensions.processExtensions("com.foldingtext.editor.treeChange", (each) => each(this, e5));
        });
      });
      cm.setOption("externalMode", (cm2, line) => {
        const lineNumber = cm2.getLineNumber(line);
        const node = tree.lineNumberToNode(lineNumber);
        return node.lineAttributedString().toCodeMirrorStyleArray();
      });
      cm.on("renderLine", (cm2, line, element3, builder, measure) => {
        const lineNumber = cm2.getLineNumber(line);
        const node = tree.lineNumberToNode(lineNumber);
        elementRenderer._node = node;
        elementRenderer._element = element3;
        elementRenderer._lineHandle = line;
        elementRenderer._lineNumber = lineNumber;
        elementRenderer._cmBuilder = builder;
        elementRenderer._cmMeasure = measure;
        tree.taxonomy.renderNodeElementStyles(this, node, elementRenderer);
        Extensions.processExtensions("com.foldingtext.editor.renderNodeElementStyles", (each) => {
          each(this, node, elementRenderer);
        });
      });
    }
    _setMethods() {
      Extensions.processExtensions("com.foldingtext.editor.methods", (each) => {
        for (let methodName in each) {
          Editor.prototype[methodName] = each[methodName];
        }
      });
    }
    tree() {
      return this._tree;
    }
    isDocumentLoaded() {
      return this._isDocumentLoaded;
    }
    documentLoaded() {
      this._isDocumentLoaded = true;
      Extensions.processExtensions("com.foldingtext.editor.documentLoaded", (each) => each(this));
      setTimeout(() => {
        this.setSelectedRange(this.tree().createRangeFromLocation(0, 0));
      });
    }
    onDocumentLoaded(callback, priority = 0) {
      if (this._isDocumentLoaded)
        return callback(this);
      Extensions.add("com.foldingtext.editor.documentLoaded", callback, priority);
    }
    textContent() {
      return this.tree().text();
    }
    suggestedNameFromContent() {
      return this.tree().suggestNameFromContent();
    }
  };
  Extensions.addCommand({
    name: "focus",
    performCommand: (editor2) => {
      editor2.focus();
    }
  });

  // src/initEditor.js
  function initEditor(taxonomy3, _taxonomyStyles, _appstyles) {
    const urlParams = new URLSearchParams(window.location.search);
    const restorableState = JSON.parse(urlParams.get("state") || "{}");
    let text = "", tabSize = 4, options = {
      tabIndex: 0,
      autofocus: true,
      lineNumbers: false,
      lineWrapping: true,
      indentWithTabs: true,
      flattenSpans: true,
      tabSize,
      indentUnit: tabSize,
      enableCompositionMod: true,
      viewportMargin: 5,
      historyEventDelay: 1250,
      undoDepth: Infinity,
      moveInputWithCursor: false,
      mode: null,
      theme: "",
      value: ""
    }, overrideOptions = restorableState.options || {};
    for (let each in overrideOptions) {
      options[each] = overrideOptions[each];
    }
    return new Editor(text, taxonomy3, options);
  }

  // src/ft/modes/calc/calcmode.js
  init_extensions();
  var idsToCompiledExpressions = {};
  var idsToResults = {};
  var idsToErrors = {};
  var mathjs;
  var loadMathjs = async () => {
    if (mathjs)
      return Promise.resolve(mathjs);
    const { create: create3, all: all2 } = await Promise.resolve().then(() => (init_number6(), number_exports));
    mathjs = create3(all2);
    return mathjs;
  };
  function refreshCalc(editor2, node) {
    let each = node.firstChild, compiledExpression, scope = {}, newResult, line, id;
    while (each) {
      id = each.id;
      line = each.text().trim();
      compiledExpression = idsToCompiledExpressions[id];
      idsToErrors[id] = false;
      if (!line || line[0] === "#") {
        idsToCompiledExpressions[id] = void 0;
        newResult = void 0;
      } else {
        try {
          if (!compiledExpression) {
            compiledExpression = mathjs.compile(line);
            idsToCompiledExpressions[id] = compiledExpression;
          }
          if (compiledExpression) {
            newResult = compiledExpression.evaluate(scope);
          }
        } catch (e5) {
          newResult = e5.message;
          idsToErrors[id] = true;
        }
      }
      let oldResult = idsToResults[id], oldResultString = oldResult ? oldResult.toString() : "", newResultString = newResult ? newResult.toString() : "";
      if (oldResultString !== newResultString) {
        idsToResults[id] = newResult;
        editor2.setNeedsRender(each);
      }
      each = each.nextSibling;
    }
  }
  Extensions.addMode({
    name: "calc"
  });
  Extensions.addTreeChanged((editor2, e5) => {
    let deltas = e5.deltas, effectedCalcs = new NodeSet();
    for (let i3 = 0; i3 < deltas.length; i3++) {
      const delta = deltas[i3];
      const insertedNodes = delta.insertedNodes;
      const removedNodes = delta.removedNodes;
      const updatedNode = delta.updatedNode;
      for (let j3 = 0; j3 < removedNodes.length; j3++) {
        const each = removedNodes[j3];
        delete idsToCompiledExpressions[each.id];
        let previousParent = e5.previousParent(each);
        if (previousParent) {
          if (previousParent.mode() === "calc") {
            effectedCalcs.addNode(previousParent);
          }
        }
      }
      for (let j3 = 0; j3 < insertedNodes.length; j3++) {
        const each = insertedNodes[j3];
        if (each.mode() === "calc") {
          effectedCalcs.addNode(each);
        } else if (each.modeContext() === "calc" && each.parent.mode() === "calc") {
          effectedCalcs.addNode(each.parent);
        }
      }
      if (updatedNode) {
        delete idsToCompiledExpressions[updatedNode.id];
        if (updatedNode.modeContext() === "calc" && updatedNode.parent.mode() === "calc") {
          effectedCalcs.addNode(updatedNode.parent);
        }
      }
    }
    if (effectedCalcs.count > 0) {
      loadMathjs().then(() => {
        editor2.cm().operation(() => {
          effectedCalcs.forEachNodeInSet((each) => {
            if (each.mode() === "calc") {
              refreshCalc(editor2, each);
            }
          });
        });
      });
    }
  });
  function createWidget(className, textContent2) {
    let widget = document.createElement("span");
    widget.className = className;
    widget.textContent = textContent2;
    widget.addEventListener("mousedown", (e5) => {
      e5.preventDefault();
    });
    widget.addEventListener("mouseup", (e5) => {
      e5.preventDefault();
    });
    return widget;
  }
  Extensions.addRenderNode((editor2, node, nodeRenderer) => {
    if (node.modeContext() === "calc" && node.parent.mode() === "calc") {
      let result = idsToResults[node.id];
      if (result !== void 0) {
        let widget;
        if (idsToErrors[node.id]) {
          widget = createWidget("cm-calc-render-widget cm-error", result);
        } else {
          widget = createWidget("cm-calc-render-widget", mathjs && mathjs.format(result, {
            precision: 14
          }) || "Loading...");
        }
        nodeRenderer.renderLineWidget(widget, {
          showIfHidden: false,
          handleMouseEvents: true,
          positionWidget() {
            let line = node.lineNumber(), leadingSpace = node.line().match(/\s*/)[0], coords = editor2.charCoords({ line, ch: leadingSpace.length }, "div"), left = `${Math.round(coords.left + editor2.defaultSpaceWidth() * 4)}px`;
            return {
              marginLeft: left
            };
          }
        });
      }
    }
  });
  Extensions.addCommand({
    name: "calc",
    description: "Evaluate selected text and replace with result.",
    performCommand(editor2) {
      loadMathjs().then(() => {
        setTimeout(() => {
          let range2 = editor2.selectedRange(), text = range2.textInRange(), parser2 = mathjs.parser(), result;
          try {
            text.split("\n").forEach((each) => {
              result = parser2.evaluate(each);
            });
          } catch (e5) {
            result = e5;
          }
          editor2.replaceSelection(mathjs.format(result), "around");
        });
      });
    }
  });

  // src/ft/modes/clock/clockmode.js
  init_datetime();
  init_extensions();
  var viewportClocks = new NodeSet();
  var date = new Date();
  function formatDate(clockNode) {
    let formatProperty = clockNode.propertyNode("format"), format5;
    if (formatProperty) {
      format5 = formatProperty.tag("value");
    } else {
      format5 = "LT";
    }
    return _DateTime.moment(date).format(format5);
  }
  Extensions.addMode({
    name: "clock"
  });
  Extensions.addRenderNode((editor2, node, nodeRenderer) => {
    if (node.mode() === "clock") {
      let widget = document.createElement("span");
      widget.textContent = formatDate(node);
      nodeRenderer.renderLineWidget(widget, {
        overlay: true,
        positionWidget(widgetWidth) {
          let line = node.lineNumber(), leadingSpace = node.line().match(/\s*/)[0], coords = editor2.cursorCoords({ line, ch: leadingSpace.length }, "div");
          return {
            left: `${Math.round(coords.left - (widgetWidth + editor2.defaultSpaceWidth()))}px`
          };
        }
      });
    }
  });
  Extensions.add("com.foldingtext.editor.viewportNodesChanged", (editor2, nodes, removedNodes, addedNodes) => {
    viewportClocks.minusSet(removedNodes);
    addedNodes.forEachNodeInSet((node) => {
      if (node.mode() === "clock") {
        viewportClocks.addNode(node);
      }
    });
  });
  Extensions.addClockTick((editor2, clockDate) => {
    date = clockDate;
    viewportClocks.forEachNodeInSet((each) => {
      if (each.mode() !== "clock") {
        viewportClocks.removeNode(each);
      } else {
        editor2.setNeedsRender(each);
      }
    });
  });

  // src/ft/system/notificationcenter.js
  var NotificationCenter = function NotificationCenter2() {
  };
  NotificationCenter.deliverNotification = function deliverNotification(editor2, title, subtitle, informativeText) {
    if (editor2 == null ? void 0 : editor2.isNative()) {
      editor2.postMessage("notification", {
        title,
        subtitle,
        informativeText
      });
      return;
    }
    let Notification = window.Notification;
    if (Notification) {
      if (Notification.permission === "default") {
        Notification.requestPermission(() => {
        });
      } else if (Notification.permission === "granted") {
        subtitle = subtitle ? `${subtitle}
` : "";
        informativeText = informativeText ? informativeText : "";
        new Notification(title, {
          body: subtitle + informativeText
        });
      }
    }
  };

  // src/ft/modes/schedule/schedulemode.js
  init_datetime();
  init_extensions();

  // src/model/taxonomy/helpers/amounthelper.js
  var amountsRE = /\b(\d+(?:.?\d+)?)\s?((?:second|sec|minute|min|hour|day|week|year)s?)\b/g;
  function parseDuration(text) {
    let escapedText = text.escapedText(), duration = 0, match, i3 = 0;
    while (match = amountsRE.exec(escapedText)) {
      let amountString = match[0], quantityString = match[1], unitString = match[2], quantity = parseFloat(quantityString);
      text.addAttributeInRange("amount", amountString, i3 + match.index, amountString.length);
      text.addAttributeInRange("quantity", quantityString, i3 + match.index, quantityString.length);
      text.addAttributeInRange("unit", unitString, i3 + match.index + amountString.length - unitString.length, unitString.length);
      switch (unitString) {
        case "second":
        case "seconds":
        case "sec":
        case "secs":
          duration += quantity;
          break;
        case "minute":
        case "minutes":
        case "min":
        case "mins":
          duration += quantity * 60;
          break;
        case "hour":
        case "hours":
          duration += quantity * 60 * 60;
          break;
        case "day":
        case "days":
          duration += quantity * 60 * 60 * 24;
          break;
        case "week":
        case "weeks":
          duration += quantity * 60 * 60 * 24 * 7;
          break;
        case "year":
        case "years":
          duration += quantity * 60 * 60 * 24 * 360;
          break;
      }
    }
    return duration;
  }
  var attributesToClear12 = ["amount", "quantity", "unit"];

  // src/ft/modes/schedule/schedulemode.js
  var schedulesToLastValidStartMoments = {};
  var currentMoment = _DateTime.moment();
  var schedulesToStartMoments = {};
  var schedulesToCurrentSteps = {};
  var schedulesToFinishLines = {};
  var schedules = new NodeSet();
  function getStartMoment(node) {
    let startMoment;
    if (node.mode() === "schedule") {
      startMoment = schedulesToStartMoments[node.id];
      if (startMoment) {
        return startMoment;
      }
      let dateProperty = node.propertyNode("Start");
      if (dateProperty) {
        let parsedMoment = _DateTime.stringToMoment(dateProperty.tag("value"));
        if (parsedMoment) {
          startMoment = parsedMoment;
        }
      }
      if (!startMoment) {
        startMoment = schedulesToLastValidStartMoments[node.id];
        if (!startMoment) {
          startMoment = currentMoment;
        }
      }
      schedulesToStartMoments[node.id] = startMoment;
    } else if (node.modeContext() === "schedule") {
      if (node.parent.mode() === "schedule") {
        let totalDuration = 0, eachSibling = node.previousSibling;
        while (eachSibling) {
          let eachDuration = eachSibling.tag("duration");
          if (eachDuration) {
            totalDuration += eachDuration;
          }
          eachSibling = eachSibling.previousSibling;
        }
        startMoment = getStartMoment(node.parent);
        startMoment = _DateTime.moment(startMoment);
        startMoment.add("seconds", totalDuration);
      }
    }
    return startMoment;
  }
  function getFinishMoment(node) {
    let each = node, duration;
    while (each) {
      duration = each.tag("duration");
      if (duration) {
        let finishMoment = _DateTime.moment(getStartMoment(each));
        finishMoment.add("seconds", duration);
        return finishMoment;
      }
      each = each.previousSibling;
    }
    return getStartMoment(node);
  }
  function isMomentOverlappingStep(aMoment, stepNode) {
    let stepStartDate = getStartMoment(stepNode);
    if (stepStartDate) {
      let stepDuration = stepNode.tag("duration");
      if (stepDuration) {
        let dateTime = aMoment.unix(), stepStartTime = stepStartDate.unix();
        return dateTime >= stepStartTime && dateTime < stepStartTime + stepDuration;
      }
    }
    return false;
  }
  function refreshCurrentStepForSchedule(editor2, scheduleNode, postNotificationOnChangeCurrentAction) {
    let currentStep = schedulesToCurrentSteps[scheduleNode.id];
    if (currentStep && currentStep.parent) {
      if (isMomentOverlappingStep(currentMoment, currentStep)) {
        return;
      }
      editor2.setNeedsRender(currentStep);
    }
    let eachStep = scheduleNode.firstChild, newCurrentStep;
    while (eachStep) {
      if (isMomentOverlappingStep(currentMoment, eachStep)) {
        newCurrentStep = eachStep;
        if (newCurrentStep) {
          editor2.setNeedsRender(newCurrentStep);
        }
        break;
      }
      eachStep = eachStep.nextSibling;
    }
    if (postNotificationOnChangeCurrentAction && newCurrentStep !== currentStep) {
      if (newCurrentStep) {
        NotificationCenter.deliverNotification(editor2, newCurrentStep.text(), scheduleNode.line());
      } else {
        NotificationCenter.deliverNotification(editor2, `${scheduleNode.line()} ended`);
      }
    }
    schedulesToCurrentSteps[scheduleNode.id] = newCurrentStep;
  }
  function refreshEndStepForSchedule(editor2, scheduleNode) {
    let endStep = schedulesToFinishLines[scheduleNode.id], newEndStep = scheduleNode.lastChild;
    if (endStep !== newEndStep) {
      if (endStep) {
        editor2.setNeedsRender(endStep);
      }
      if (newEndStep) {
        editor2.setNeedsRender(newEndStep);
      }
      schedulesToFinishLines[scheduleNode.id] = newEndStep;
    }
  }
  function formatDifference(moment3, anchorMoment) {
    let shouldDisplayDate = true, shouldDisplayTimeMeridian = true, formatedDifference = "";
    if (anchorMoment) {
      if (moment3.month() === anchorMoment.month()) {
        if (moment3.date() === anchorMoment.date()) {
          shouldDisplayDate = false;
          if (moment3.hours() < 12 === anchorMoment.hours() < 12) {
            shouldDisplayTimeMeridian = false;
          }
        }
      }
    }
    let monthNames = [
      "Jan",
      "Feb",
      "Mar",
      "Apr",
      "May",
      "Jun",
      "Jul",
      "Aug",
      "Sep",
      "Oct",
      "Nov",
      "Dec"
    ];
    if (shouldDisplayDate) {
      formatedDifference += `${monthNames[moment3.month()]} ${moment3.date()}, `;
    }
    let hours = moment3.hours(), simple = hours > 12 ? hours - 12 : hours === 0 ? 12 : hours, minutes = moment3.minutes(), minuteString = minutes < 10 ? `0${minutes}` : `${minutes}`;
    formatedDifference += `${simple}:${minuteString}`;
    if (shouldDisplayTimeMeridian) {
      formatedDifference += hours >= 12 ? " PM" : " AM";
    }
    return formatedDifference;
  }
  Extensions.addMode({
    name: "schedule"
  });
  Extensions.addInit((editor2) => {
    schedules = NodeSet.setFromArray(editor2.tree().evaluateNodePath("//@mode = schedule"));
  });
  Extensions.add("com.foldingtext.taxonomy.classifier", {
    classify(text, state, previousState) {
      switch (state.type) {
        case "empty":
        case "codeblock":
        case "fencedcode":
          return;
      }
      let modeStack = state.modeStack;
      if (modeStack) {
        let modeRecord = modeStack.lastObject();
        if (!modeRecord || modeRecord.mode !== "schedule") {
          return;
        }
      } else {
        return;
      }
      let duration = parseDuration(text, state, previousState);
      if (duration) {
        state.tags.duration = duration;
      }
    },
    attributesToClear: [].concat(attributesToClear12)
  });
  Extensions.addClockTick((editor2, date2) => {
    currentMoment = _DateTime.moment(date2);
    schedules.forEachNodeInSet((each) => {
      if (each.mode() !== "schedule") {
        schedules.removeNode(each);
      } else {
        refreshCurrentStepForSchedule(editor2, each, true);
      }
    });
  });
  Extensions.addTreeChanged((editor2, e5) => {
    let deltas = e5.deltas, effectedSchedules = new NodeSet();
    for (let i3 = 0; i3 < deltas.length; i3++) {
      const insertedNodes = deltas[i3].insertedNodes;
      const removedNodes = deltas[i3].removedNodes;
      const updatedNode = deltas[i3].updatedNode;
      for (let j3 = 0; j3 < removedNodes.length; j3++) {
        const each = removedNodes[j3];
        if (schedules.containsNode(each)) {
          schedules.removeNode(each);
        } else {
          let previousParent = e5.previousParent(each);
          if (previousParent) {
            if (previousParent.mode() === "schedule") {
              let eachSibling = previousParent.firstChild;
              while (eachSibling) {
                editor2.setNeedsRender(eachSibling);
                eachSibling = eachSibling.nextSibling;
              }
              effectedSchedules.addNode(previousParent);
            }
          }
        }
      }
      for (let j3 = 0; j3 < insertedNodes.length; j3++) {
        const each = insertedNodes[j3];
        if (each.mode() === "schedule") {
          schedules.addNode(each);
        } else if (each.modeContext() === "schedule") {
          let eachSibling = each.nextSibling;
          while (eachSibling) {
            editor2.setNeedsRender(eachSibling);
            eachSibling = eachSibling.nextSibling;
          }
          effectedSchedules.addNode(each.parent);
        }
      }
      if (updatedNode) {
        if (updatedNode.mode() === "schedule") {
          schedules.addNode(updatedNode);
          let eachChild = updatedNode.firstChild;
          while (eachChild) {
            editor2.setNeedsRender(eachChild);
            eachChild = eachChild.nextSibling;
          }
        } else if (updatedNode.modeContext() === "schedule") {
          let eachSibling = updatedNode.nextSibling;
          while (eachSibling) {
            editor2.setNeedsRender(eachSibling);
            eachSibling = eachSibling.nextSibling;
          }
          effectedSchedules.addNode(updatedNode.parent);
        }
      }
    }
    if (effectedSchedules.count > 0) {
      effectedSchedules.forEachNodeInSet((each) => {
        if (each.mode() === "schedule") {
          schedulesToLastValidStartMoments[each.id] = schedulesToStartMoments[each.id];
          schedulesToStartMoments[each.id] = void 0;
          refreshCurrentStepForSchedule(editor2, each, false);
          refreshEndStepForSchedule(editor2, each, false);
        }
      });
    }
  });
  function createWidget2(identifier) {
    let widget = document.createElement("span");
    widget.className = `scheduler-render-widget ${identifier}`;
    widget.addEventListener("mousedown", (e5) => {
      e5.preventDefault();
    });
    widget.addEventListener("mouseup", (e5) => {
      e5.preventDefault();
      let node = widget.ftNode, scheduleNode = node.parent, scheduleStartMoment = getStartMoment(scheduleNode), stepStartMoment = getStartMoment(node), newScheduleStartDate = _DateTime.moment(currentMoment);
      newScheduleStartDate.subtract("milliseconds", stepStartMoment.diff(scheduleStartMoment));
      scheduleNode.setPropertyNodeValue("Start", _DateTime.momentToString(newScheduleStartDate));
    });
    return widget;
  }
  Extensions.addRenderNode((editor2, node, nodeRenderer) => {
    if (node.modeContext() === "schedule") {
      let duration = node.tag("duration"), widget;
      if (duration) {
        let startMoment = getStartMoment(node);
        if (startMoment) {
          let anchoreMoment = node.previousSibling ? getStartMoment(node.previousSibling) : getStartMoment(node.parent);
          widget = createWidget2("schedulestartdate");
          widget.textContent = formatDifference(startMoment, anchoreMoment);
          widget.ftNode = node;
          nodeRenderer.renderLineWidget(widget, {
            overlay: true,
            positionWidget(widgetWidth) {
              let line = node.lineNumber(), leadingSpace = node.line().match(/\s*/)[0], coords = editor2.cursorCoords({ line, ch: leadingSpace.length }, "div");
              return {
                left: `${Math.round(coords.left - (widgetWidth + editor2.defaultSpaceWidth()))}px`
              };
            }
          });
        }
      }
      if (schedulesToFinishLines[node.parent.id] === node) {
        let alignTo = node, alignToLeadingSpace;
        while (alignTo && !alignTo.tag("duration")) {
          alignTo = alignTo.previousSibling;
        }
        if (!alignTo) {
          alignTo = node.parent;
        }
        alignToLeadingSpace = alignTo.line().match(/\s*/)[0];
        let scheduleFinishDate = getFinishMoment(node), scheduleStartDate = getStartMoment(node.parent);
        if (currentMoment > scheduleFinishDate) {
          widget = createWidget2("scheduleendedfinishline");
          widget.textContent = `Ended: ${formatDifference(scheduleFinishDate, scheduleStartDate)}`;
        } else {
          widget = createWidget2("schedulefinishline");
          widget.textContent = `Ends: ${formatDifference(scheduleFinishDate, scheduleStartDate)}`;
        }
        nodeRenderer.renderLineWidget(widget, {
          showIfHidden: false,
          handleMouseEvents: true,
          positionWidget() {
            return {
              marginLeft: `${Math.round(editor2.charCoords({
                line: alignTo.lineNumber(),
                ch: alignToLeadingSpace.length
              }, "local").left)}px`
            };
          }
        });
      }
    }
  });
  Extensions.addRenderNodeElementStyles((editor2, node, elementRenderer) => {
    if (schedulesToCurrentSteps[node.parent.id] === node) {
      elementRenderer.addWrapClass("cm-schedule-current-step");
    }
  });

  // src/ft/modes/stopwatch/stopwatchmode.js
  init_datetime();
  init_extensions();
  var currentMoment2 = _DateTime.moment();
  var stopwatchs = new NodeSet();
  Extensions.addMode({
    name: "stopwatch"
  });
  function start(editor2, node) {
    node.setPropertyNodeValue("Start", _DateTime.momentToString(currentMoment2));
  }
  function stop(editor2, node) {
    let tree = editor2.tree(), startMoment = getStartMoment2(node), startPropertyNode = node.propertyNode("start"), duration = formatDuration(currentMoment2.diff(startMoment, "seconds"));
    tree.beginUpdates();
    node.insertChildBefore(tree.createNode(`- ${duration}`), startPropertyNode);
    startPropertyNode.removeFromParent();
    tree.endUpdates();
  }
  function getStartMoment2(node) {
    let startPropertyNode = node.propertyNode("start");
    if (startPropertyNode) {
      let value = startPropertyNode.tags().value;
      if (value) {
        return _DateTime.stringToMoment(value);
      }
    }
    return void 0;
  }
  function formatDuration(duration, shortFormat) {
    let hours = Math.floor(duration / 3600), minutes = Math.floor((duration - hours * 3600) / 60), seconds = Math.ceil(duration - hours * 3600 - minutes * 60), result = [];
    if (hours) {
      if (shortFormat) {
        result.push(`${hours}h`);
      } else {
        result.push(`${hours} hours`);
      }
    }
    if (minutes) {
      if (shortFormat) {
        result.push(`${minutes}m`);
      } else {
        result.push(`${minutes} minutes`);
      }
    }
    if (seconds) {
      if (shortFormat) {
        result.push(`${seconds}s`);
      } else {
        result.push(`${seconds} seconds`);
      }
    }
    return result.join(" ");
  }
  Extensions.addRenderNode((editor2, node, nodeRenderer) => {
    if (node.mode() === "stopwatch") {
      let widget = document.createElement("div"), button = document.createElement("span"), label = document.createElement("span"), startMoment = getStartMoment2(node), duration = 0;
      widget.className = "cm-stopwatch-render-widget";
      button.className = "cm-stopwatch-button";
      label.className = "label";
      widget.appendChild(label);
      widget.appendChild(button);
      if (startMoment) {
        widget.className += " running";
        duration = currentMoment2.diff(startMoment, "seconds");
      } else {
        node.children().forEach((each) => {
          if (each.tags().duration) {
            duration += each.tags().duration;
          }
        });
      }
      if (duration) {
        label.textContent = `${formatDuration(duration, true)}\xA0`;
      }
      button.addEventListener("mousedown", (e5) => {
        e5.preventDefault();
      });
      button.addEventListener("mouseup", (e5) => {
        e5.preventDefault();
        editor2.tree().ensureClassified();
        if (getStartMoment2(node)) {
          stop(editor2, node);
        } else {
          start(editor2, node);
        }
      });
      nodeRenderer.renderLineWidget(widget, {
        overlay: true,
        positionWidget(widgetWidth) {
          let line = node.lineNumber(), leadingSpace = node.line().match(/\s*/)[0], coords = editor2.cursorCoords({ line, ch: leadingSpace.length }, "div");
          return {
            left: `${Math.round(coords.left - (widgetWidth + editor2.defaultSpaceWidth()))}px`
          };
        }
      });
    }
  });
  Extensions.addTreeChanged((editor2, e5) => {
    let deltas = e5.deltas;
    for (let i3 = 0; i3 < deltas.length; i3++) {
      const insertedNodes = deltas[i3].insertedNodes;
      const removedNodes = deltas[i3].removedNodes;
      const updatedNode = deltas[i3].updatedNode;
      let parent;
      let each;
      for (let j3 = 0; j3 < removedNodes.length; j3++) {
        each = removedNodes[j3];
        let previousParent = e5.previousParent(each);
        if (previousParent && previousParent.mode() === "stopwatch") {
          editor2.setNeedsRender(previousParent);
        }
      }
      for (let j3 = 0; j3 < insertedNodes.length; j3++) {
        each = insertedNodes[j3];
        if (each.mode() === "stopwatch") {
          stopwatchs.addNode(each);
        } else {
          parent = each.parent;
          if (parent && parent.mode() === "stopwatch") {
            editor2.setNeedsRender(parent);
          }
        }
      }
      if (updatedNode) {
        if (updatedNode.mode() === "stopwatch") {
          stopwatchs.addNode(updatedNode);
        } else {
          parent = updatedNode.parent;
          if (parent && parent.mode() === "stopwatch") {
            editor2.setNeedsRender(parent);
          }
        }
      }
    }
  });
  Extensions.add("com.foldingtext.taxonomy.classifier", {
    classify(text, state, previousState) {
      if (state.type === "unordered") {
        let modeStack = state.modeStack;
        if (modeStack) {
          let modeRecord = modeStack.lastObject();
          if (!modeRecord || modeRecord.mode !== "stopwatch") {
            return;
          }
        } else {
          return;
        }
        let duration = parseDuration(text, state, previousState);
        if (duration) {
          state.tags.duration = duration;
        }
      }
    },
    attributesToClear: [].concat(attributesToClear12)
  });
  Extensions.add("com.foldingtext.editor.clockTick", (editor2, date2) => {
    currentMoment2 = _DateTime.moment(date2);
    stopwatchs.forEachNodeInSet((each) => {
      if (!each.isTracked || each.mode() !== "stopwatch") {
        stopwatchs.removeNode(each);
      } else {
        editor2.setNeedsRender(each);
      }
    });
  });

  // src/ft/modes/todo/todomode.js
  init_datetime();
  init_extensions();
  var import_moment2 = __toModule(require_moment());
  var replaceLocationRE2 = /[-+*]/;
  var shouldRenderNode3 = function shouldRenderNode4(node) {
    return node.modeContext() === "todo" && node.type() === "unordered";
  };
  var createArchiveNode2 = function createArchiveNode3(tree) {
    return tree.createNode("# Archive");
  };
  Extensions.addMode({
    name: "todo"
  });
  Extensions.addCommand({
    name: "done",
    description: "Toggle #done tag for selected lines.",
    performCommand(editor2, options) {
      let node = options ? options.node : null, range2 = node ? node.tree.createRangeFromNodes(node, 0) : null;
      editor2.toggleTag("done", _DateTime.momentToString((0, import_moment2.default)().startOf("day")), range2);
    }
  });
  Extensions.addCommand({
    name: "archive #done",
    description: "Move #done items to the archive section.",
    performCommand(editor2) {
      let tree = editor2.tree();
      tree.beginUpdates();
      tree.ensureClassified();
      let archiveNode = tree.evaluateNodePath("//@line:text = Archive")[0];
      if (!archiveNode) {
        archiveNode = createArchiveNode2(tree);
        tree.appendNode(archiveNode);
      }
      Node.commonAncestorsForNodes(tree.evaluateNodePath("//@done except //@line:text = Archive//@done")).forEachNodeInSet((node) => {
        archiveNode.insertChildBefore(node, archiveNode.firstChild);
      });
      tree.endUpdates();
    }
  });
  Extensions.addRenderNode((editor2, node, nodeRenderer) => {
    if (shouldRenderNode3(node)) {
      let match = replaceLocationRE2.exec(node.line());
      if (match) {
        let widget = document.createElement("span"), input = document.createElement("input"), label = document.createElement("label"), checkboxID = `${node.id}-todocheckbox`;
        input.id = checkboxID;
        input.setAttribute("type", "checkbox");
        input.checked = node.hasTag("done");
        label.setAttribute("for", checkboxID);
        import_codemirror3.default.on(input, "mousedown", (e5) => {
          editor2.performCommand("done", { node });
          e5.preventDefault();
        });
        widget.appendChild(input);
        widget.appendChild(label);
        widget.className = "cm-checkbox-render-widget";
        nodeRenderer.renderInlineWidget(match.index, 1, widget);
      }
    }
  });

  // src/app.js
  var pluginPaths = QueryParameter("pluginPaths", "").split(":");
  function loadCustomPlugins(_pluginPaths, callback, _onError) {
    callback();
  }
  var app = function app2(taxonomy3, taxonomyStyles, appstyles) {
    loadCustomPlugins(pluginPaths, () => {
      initEditor(taxonomy3, taxonomyStyles, appstyles);
    }, (err) => {
      console.log("Error requiring plugin paths", err);
      initEditor(taxonomy3, taxonomyStyles, appstyles);
    });
  };

  // src/index.js
  environment_default.applicationName = "FoldingText";
  var taxonomy2 = taxonomy({
    foldingtext: true,
    multimarkdown: true,
    gitmarkdown: true,
    criticMarkup: true,
    metadata: true
  }, "markdown");
  app(taxonomy2, {}, {});
})();
//! authors : Tim Wood, Iskren Chernev, Moment.js contributors
//! license : MIT
//! moment.js
//! momentjs.com
//! version : 2.29.1
//# sourceMappingURL=index.js.map
